/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/network","vs/base/node/pfs","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/errors","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/resources","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","fs","os","child_process","vs/base/common/process","vs/base/common/stream","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/performance","vs/base/common/iterator","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Z=function(_){for(var t=[],d=0,F=_.length;d<F;d++)t[d]=Q[_[d]];return t};define(Q[57],Z([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function d(F,b){if(!F)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}t.ok=d}),define(Q[44],Z([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function d(T){return(D,c,f)=>{let C=null,y=null;if(typeof f.value=="function"?(C="value",y=f.value):typeof f.get=="function"&&(C="get",y=f.get),!y)throw new Error("not supported");f[C]=T(y,c)}}t.createDecorator=d;function F(T,D,c){let f=null,C=null;if(typeof c.value=="function"?(f="value",C=c.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(f="get",C=c.get),!C)throw new Error("not supported");const y=`$memoize$${D}`;c[f]=function(...v){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,v)}),this[y]}}t.memoize=F;function b(T,D,c){return d((f,C)=>{const y=`$debounce$${C}`,v=`$debounce$result$${C}`;return function(...O){this[v]||(this[v]=c?c():void 0),clearTimeout(this[y]),D&&(this[v]=D(this[v],...O),O=[this[v]]),this[y]=setTimeout(()=>{f.apply(this,O),this[v]=c?c():void 0},T)}})}t.debounce=b;function L(T,D,c){return d((f,C)=>{const y=`$throttle$timer$${C}`,v=`$throttle$result$${C}`,O=`$throttle$lastRun$${C}`,u=`$throttle$pending$${C}`;return function(...h){if(this[v]||(this[v]=c?c():void 0),(this[O]===null||this[O]===void 0)&&(this[O]=-Number.MAX_VALUE),D&&(this[v]=D(this[v],...h)),this[u])return;const w=this[O]+T;w<=Date.now()?(this[O]=Date.now(),f.apply(this,[this[v]]),this[v]=c?c():void 0):(this[u]=!0,this[y]=setTimeout(()=>{this[u]=!1,this[O]=Date.now(),f.apply(this,[this[v]]),this[v]=c?c():void 0},w-Date.now()))}})}t.throttle=L}),define(Q[22],Z([0,1,13]),function(_,t,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function F(x,G=0){return x[x.length-(1+G)]}t.tail=F;function b(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}t.tail2=b;function L(x,G,k=(g,a)=>g===a){if(x===G)return!0;if(!x||!G||x.length!==G.length)return!1;for(let g=0,a=x.length;g<a;g++)if(!k(x[g],G[g]))return!1;return!0}t.equals=L;function T(x,G,k){let g=0,a=x.length-1;for(;g<=a;){const S=(g+a)/2|0,P=k(x[S],G);if(P<0)g=S+1;else if(P>0)a=S-1;else return S}return-(g+1)}t.binarySearch=T;function D(x,G){let k=0,g=x.length;if(g===0)return 0;for(;k<g;){const a=Math.floor((k+g)/2);G(x[a])?g=a:k=a+1}return k}t.findFirstInSorted=D;function c(x,G,k){if(x=x|0,x>=G.length)throw new TypeError("invalid index");let g=G[Math.floor(G.length*Math.random())],a=[],S=[],P=[];for(let N of G){const M=k(N,g);M<0?a.push(N):M>0?S.push(N):P.push(N)}return x<a.length?c(x,a,k):x<a.length+P.length?P[0]:c(x-(a.length+P.length),S,k)}t.quickSelect=c;function f(x,G){const k=[];let g;for(const a of x.slice(0).sort(G))!g||G(g[0],a)!==0?(g=[a],k.push(g)):g.push(a);return k}t.groupBy=f;function C(x,G,k){const g=[];function a(N,M,W){if(M===0&&W.length===0)return;const B=g[g.length-1];B&&B.start+B.deleteCount===N?(B.deleteCount+=M,B.toInsert.push(...W)):g.push({start:N,deleteCount:M,toInsert:W})}let S=0,P=0;for(;;){if(S===x.length){a(S,0,G.slice(P));break}if(P===G.length){a(S,x.length-S,[]);break}const N=x[S],M=G[P],W=k(N,M);W===0?(S+=1,P+=1):W<0?(a(S,1,[]),S+=1):W>0&&(a(S,0,[M]),P+=1)}return g}t.sortedDiff=C;function y(x,G,k){const g=C(x,G,k),a=[],S=[];for(const P of g)a.push(...x.slice(P.start,P.start+P.deleteCount)),S.push(...P.toInsert);return{removed:a,added:S}}t.delta=y;function v(x,G,k){if(k===0)return[];const g=x.slice(0,k).sort(G);return u(x,G,g,k,x.length),g}t.top=v;function O(x,G,k,g,a){return k===0?Promise.resolve([]):new Promise((S,P)=>{(async()=>{const N=x.length,M=x.slice(0,k).sort(G);for(let W=k,B=Math.min(k+g,N);W<N;W=B,B=Math.min(B+g,N)){if(W>k&&await new Promise($=>setTimeout($)),a&&a.isCancellationRequested)throw(0,d.canceled)();u(x,G,M,W,B)}return M})().then(S,P)})}t.topAsync=O;function u(x,G,k,g,a){for(const S=k.length;g<a;g++){const P=x[g];if(G(P,k[S-1])<0){k.pop();const N=D(k,M=>G(P,M)<0);k.splice(N,0,P)}}}function h(x){return x.filter(G=>!!G)}t.coalesce=h;function w(x){let G=0;for(let k=0;k<x.length;k++)x[k]&&(x[G]=x[k],G+=1);x.length=G}t.coalesceInPlace=w;function R(x,G,k){x.splice(k,0,x.splice(G,1)[0])}t.move=R;function I(x){return!Array.isArray(x)||x.length===0}t.isFalsyOrEmpty=I;function m(x){return Array.isArray(x)&&x.length>0}t.isNonEmptyArray=m;function o(x,G){if(!G)return x.filter((g,a)=>x.indexOf(g)===a);const k=Object.create(null);return x.filter(g=>{const a=G(g);return k[a]?!1:(k[a]=!0,!0)})}t.distinct=o;function r(x){const G=new Set;return x.filter(k=>G.has(k)?!1:(G.add(k),!0))}t.distinctES6=r;function e(x){const G=Object.create(null);return k=>{const g=x(k);return G[g]?!1:(G[g]=!0,!0)}}t.uniqueFilter=e;function i(x,G){for(let k=x.length-1;k>=0;k--){const g=x[k];if(G(g))return k}return-1}t.lastIndex=i;function n(x,G){return x.length>0?x[0]:G}t.firstOrDefault=n;function s(x,G,k=(g,a)=>g===a){let g=0;for(let a=0,S=Math.min(x.length,G.length);a<S&&k(x[a],G[a]);a++)g++;return g}t.commonPrefixLength=s;function l(x){return[].concat(...x)}t.flatten=l;function p(x,G){let k=typeof G=="number"?x:0;typeof G=="number"?k=x:(k=0,G=x);const g=[];if(k<=G)for(let a=k;a<G;a++)g.push(a);else for(let a=k;a>G;a--)g.push(a);return g}t.range=p;function E(x,G,k){return x.reduce((g,a)=>(g[G(a)]=k?k(a):a,g),Object.create(null))}t.index=E;function U(x,G){return x.push(G),()=>A(x,G)}t.insert=U;function A(x,G){const k=x.indexOf(G);if(k>-1)return x.splice(k,1),G}t.remove=A;function j(x,G,k){const g=x.slice(0,G),a=x.slice(G);return g.concat(k,a)}t.arrayInsert=j;function V(x,G){let k;if(typeof G=="number"){let g=G;k=()=>{const a=Math.sin(g++)*179426549;return a-Math.floor(a)}}else k=Math.random;for(let g=x.length-1;g>0;g-=1){const a=Math.floor(k()*(g+1)),S=x[g];x[g]=x[a],x[a]=S}}t.shuffle=V;function q(x,G){const k=x.indexOf(G);k>-1&&(x.splice(k,1),x.unshift(G))}t.pushToStart=q;function J(x,G){const k=x.indexOf(G);k>-1&&(x.splice(k,1),x.push(G))}t.pushToEnd=J;function ie(x,G){return Array.isArray(x)?x.map(G):G(x)}t.mapArrayOrNot=ie;function ne(x){return Array.isArray(x)?x:[x]}t.asArray=ne;function te(x){return x[Math.floor(Math.random()*x.length)]}t.getRandomElement=te;function ae(x,G){for(const k of x){const g=G(k);if(g!==void 0)return g}}t.mapFind=ae}),define(Q[58],Z([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var d;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(d=t.ScanError||(t.ScanError={}));var F;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(F=t.SyntaxKind||(t.SyntaxKind={}));var b;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(b=t.ParseErrorCode||(t.ParseErrorCode={}));var L;(function(e){e.DEFAULT={allowTrailingComma:!0}})(L=t.ParseOptions||(t.ParseOptions={}));function T(e,i=!1){let n=0,s=e.length,l="",p=0,E=16,U=0;function A(te){let ae=0,x=0;for(;ae<te;){const G=e.charCodeAt(n);if(G>=48&&G<=57)x=x*16+G-48;else if(G>=65&&G<=70)x=x*16+G-65+10;else if(G>=97&&G<=102)x=x*16+G-97+10;else break;n++,ae++}return ae<te&&(x=-1),x}function j(te){n=te,l="",p=0,E=16,U=0}function V(){const te=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&f(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&f(e.charCodeAt(n)))for(n++;n<e.length&&f(e.charCodeAt(n));)n++;else return U=3,e.substring(te,n);let ae=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&f(e.charCodeAt(n))){for(n++;n<e.length&&f(e.charCodeAt(n));)n++;ae=n}else U=3;return e.substring(te,ae)}function q(){let te="",ae=n;for(;;){if(n>=s){te+=e.substring(ae,n),U=2;break}const x=e.charCodeAt(n);if(x===34){te+=e.substring(ae,n),n++;break}if(x===92){if(te+=e.substring(ae,n),n++,n>=s){U=2;break}switch(e.charCodeAt(n++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:const k=A(4);k>=0?te+=String.fromCharCode(k):U=4;break;default:U=5}ae=n;continue}if(x>=0&&x<=31)if(c(x)){te+=e.substring(ae,n),U=2;break}else U=6;n++}return te}function J(){if(l="",U=0,p=n,n>=s)return p=s,E=17;let te=e.charCodeAt(n);if(D(te)){do n++,l+=String.fromCharCode(te),te=e.charCodeAt(n);while(D(te));return E=15}if(c(te))return n++,l+=String.fromCharCode(te),te===13&&e.charCodeAt(n)===10&&(n++,l+=`
`),E=14;switch(te){case 123:return n++,E=1;case 125:return n++,E=2;case 91:return n++,E=3;case 93:return n++,E=4;case 58:return n++,E=6;case 44:return n++,E=5;case 34:return n++,l=q(),E=10;case 47:const ae=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<s&&!c(e.charCodeAt(n));)n++;return l=e.substring(ae,n),E=12}if(e.charCodeAt(n+1)===42){n+=2;const x=s-1;let G=!1;for(;n<x;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,G=!0;break}n++}return G||(n++,U=1),l=e.substring(ae,n),E=13}return l+=String.fromCharCode(te),n++,E=16;case 45:if(l+=String.fromCharCode(te),n++,n===s||!f(e.charCodeAt(n)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=V(),E=11;default:for(;n<s&&ie(te);)n++,te=e.charCodeAt(n);if(p!==n){switch(l=e.substring(p,n),l){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return l+=String.fromCharCode(te),n++,E=16}}function ie(te){if(D(te)||c(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let te;do te=J();while(te>=12&&te<=15);return te}return{setPosition:j,getPosition:()=>n,scan:i?ne:J,getToken:()=>E,getTokenValue:()=>l,getTokenOffset:()=>p,getTokenLength:()=>n-p,getTokenError:()=>U}}t.createScanner=T;function D(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function c(e){return e===10||e===13||e===8232||e===8233}function f(e){return e>=48&&e<=57}var C;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(C||(C={}));function y(e,i){const n=[],s=new Object;let l;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function U(A,j,V,q){p.value=A,p.offset=j,p.length=V,p.type=q,p.colonOffset=void 0,l=p}try{m(e,{onObjectBegin:(A,j)=>{if(i<=A)throw s;l=void 0,E=i>A,n.push("")},onObjectProperty:(A,j,V)=>{if(i<j||(U(A,j,V,"property"),n[n.length-1]=A,i<=j+V))throw s},onObjectEnd:(A,j)=>{if(i<=A)throw s;l=void 0,n.pop()},onArrayBegin:(A,j)=>{if(i<=A)throw s;l=void 0,n.push(0)},onArrayEnd:(A,j)=>{if(i<=A)throw s;l=void 0,n.pop()},onLiteralValue:(A,j,V)=>{if(i<j||(U(A,j,V,r(A)),i<=j+V))throw s},onSeparator:(A,j,V)=>{if(i<=j)throw s;if(A===":"&&l&&l.type==="property")l.colonOffset=j,E=!1,l=void 0;else if(A===","){const q=n[n.length-1];typeof q=="number"?n[n.length-1]=q+1:(E=!0,n[n.length-1]=""),l=void 0}}})}catch(A){if(A!==s)throw A}return{path:n,previousNode:l,isAtPropertyKey:E,matches:A=>{let j=0;for(let V=0;j<A.length&&V<n.length;V++)if(A[j]===n[V]||A[j]==="*")j++;else if(A[j]!=="**")return!1;return j===A.length}}}t.getLocation=y;function v(e,i=[],n=L.DEFAULT){let s=null,l=[];const p=[];function E(A){Array.isArray(l)?l.push(A):s!==null&&(l[s]=A)}return m(e,{onObjectBegin:()=>{const A={};E(A),p.push(l),l=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{l=p.pop()},onArrayBegin:()=>{const A=[];E(A),p.push(l),l=A,s=null},onArrayEnd:()=>{l=p.pop()},onLiteralValue:E,onError:(A,j,V)=>{i.push({error:A,offset:j,length:V})}},n),l[0]}t.parse=v;function O(e,i=[],n=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(A){s.type==="property"&&(s.length=A-s.offset,s=s.parent)}function p(A){return s.children.push(A),A}m(e,{onObjectBegin:A=>{s=p({type:"object",offset:A,length:-1,parent:s,children:[]})},onObjectProperty:(A,j,V)=>{s=p({type:"property",offset:j,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:A,offset:j,length:V,parent:s})},onObjectEnd:(A,j)=>{s.length=A+j-s.offset,s=s.parent,l(A+j)},onArrayBegin:(A,j)=>{s=p({type:"array",offset:A,length:-1,parent:s,children:[]})},onArrayEnd:(A,j)=>{s.length=A+j-s.offset,s=s.parent,l(A+j)},onLiteralValue:(A,j,V)=>{p({type:r(A),offset:j,length:V,parent:s,value:A}),l(j+V)},onSeparator:(A,j,V)=>{s.type==="property"&&(A===":"?s.colonOffset=j:A===","&&l(j))},onError:(A,j,V)=>{i.push({error:A,offset:j,length:V})}},n);const U=s.children[0];return U&&delete U.parent,U}t.parseTree=O;function u(e,i){if(!e)return;let n=e;for(let s of i)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const p of n.children)if(Array.isArray(p.children)&&p.children[0].value===s){n=p.children[1],l=!0;break}if(!l)return}else{const l=s;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}t.findNodeAtLocation=u;function h(e){if(!e.parent||!e.parent.children)return[];const i=h(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=h;function w(e){switch(e.type){case"array":return e.children.map(w);case"object":const i=Object.create(null);for(let n of e.children){const s=n.children[1];s&&(i[n.children[0].value]=w(s))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=w;function R(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=R;function I(e,i,n=!1){if(R(e,i,n)){const s=e.children;if(Array.isArray(s))for(let l=0;l<s.length&&s[l].offset<=i;l++){const p=I(s[l],i,n);if(p)return p}return e}}t.findNodeAtOffset=I;function m(e,i,n=L.DEFAULT){const s=T(e,!1);function l(M){return M?()=>M(s.getTokenOffset(),s.getTokenLength()):()=>!0}function p(M){return M?W=>M(W,s.getTokenOffset(),s.getTokenLength()):()=>!0}const E=l(i.onObjectBegin),U=p(i.onObjectProperty),A=l(i.onObjectEnd),j=l(i.onArrayBegin),V=l(i.onArrayEnd),q=p(i.onLiteralValue),J=p(i.onSeparator),ie=l(i.onComment),ne=p(i.onError),te=n&&n.disallowComments,ae=n&&n.allowTrailingComma;function x(){for(;;){const M=s.scan();switch(s.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:te||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(M){case 12:case 13:te?G(10):ie();break;case 16:G(1);break;case 15:case 14:break;default:return M}}}function G(M,W=[],B=[]){if(ne(M),W.length+B.length>0){let $=s.getToken();for(;$!==17;){if(W.indexOf($)!==-1){x();break}else if(B.indexOf($)!==-1)break;$=x()}}}function k(M){const W=s.getTokenValue();return M?q(W):U(W),x(),!0}function g(){switch(s.getToken()){case 11:let M=0;try{M=JSON.parse(s.getTokenValue()),typeof M!="number"&&(G(2),M=0)}catch(W){G(2)}q(M);break;case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return x(),!0}function a(){return s.getToken()!==10?(G(3,[],[2,5]),!1):(k(!1),s.getToken()===6?(J(":"),x(),N()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function S(){E(),x();let M=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(M||G(4,[],[]),J(","),x(),s.getToken()===2&&ae)break}else M&&G(6,[],[]);a()||G(4,[],[2,5]),M=!0}return A(),s.getToken()!==2?G(7,[2],[]):x(),!0}function P(){j(),x();let M=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(M||G(4,[],[]),J(","),x(),s.getToken()===4&&ae)break}else M&&G(6,[],[]);N()||G(4,[],[4,5]),M=!0}return V(),s.getToken()!==4?G(8,[4],[]):x(),!0}function N(){switch(s.getToken()){case 3:return P();case 1:return S();case 10:return k(!0);default:return g()}}return x(),s.getToken()===17?n.allowEmptyContent?!0:(G(4,[],[]),!1):N()?(s.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}t.visit=m;function o(e,i){let n=T(e),s=[],l,p=0,E;do switch(E=n.getPosition(),l=n.scan(),l){case 12:case 13:case 17:p!==E&&s.push(e.substring(p,E)),i!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,i)),p=n.getPosition();break}while(l!==17);return s.join("")}t.stripComments=o;function r(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=r}),function(){function _(b){const L=[];typeof b=="number"&&L.push("code/timeOrigin",b);function T(c){L.push(c,Date.now())}function D(){const c=[];for(let f=0;f<L.length;f+=2)c.push({name:L[f],startTime:L[f+1]});return c}return{mark:T,getMarks:D}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const T of performance.getEntriesByType("mark"))L.push({name:T.name,startTime:Math.round(b+T.startTime)});return L}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function d(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=t()),b.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=d(F))}(),function(_,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var d=t();for(var F in d)(typeof exports=="object"?exports:_)[F]=d[F]}}(typeof self!="undefined"?self:this,function(){return function(_){var t={};function d(F){if(t[F])return t[F].exports;var b=t[F]={i:F,l:!1,exports:{}};return _[F].call(b.exports,b,b.exports,d),b.l=!0,b.exports}return d.m=_,d.c=t,d.d=function(F,b,L){d.o(F,b)||Object.defineProperty(F,b,{enumerable:!0,get:L})},d.r=function(F){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},d.t=function(F,b){if(1&b&&(F=d(F)),8&b||4&b&&typeof F=="object"&&F&&F.__esModule)return F;var L=Object.create(null);if(d.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:F}),2&b&&typeof F!="string")for(var T in F)d.d(L,T,function(D){return F[D]}.bind(null,T));return L},d.n=function(F){var b=F&&F.__esModule?function(){return F.default}:function(){return F};return d.d(b,"a",b),b},d.o=function(F,b){return Object.prototype.hasOwnProperty.call(F,b)},d.p="",d(d.s=0)}([function(_,t,d){(function(F){var b;t=_.exports=B,b=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var L=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,D=t.re=[],c=t.src=[],f=0,C=f++;c[C]="0|[1-9]\\d*";var y=f++;c[y]="[0-9]+";var v=f++;c[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var O=f++;c[O]="("+c[C]+")\\.("+c[C]+")\\.("+c[C]+")";var u=f++;c[u]="("+c[y]+")\\.("+c[y]+")\\.("+c[y]+")";var h=f++;c[h]="(?:"+c[C]+"|"+c[v]+")";var w=f++;c[w]="(?:"+c[y]+"|"+c[v]+")";var R=f++;c[R]="(?:-("+c[h]+"(?:\\."+c[h]+")*))";var I=f++;c[I]="(?:-?("+c[w]+"(?:\\."+c[w]+")*))";var m=f++;c[m]="[0-9A-Za-z-]+";var o=f++;c[o]="(?:\\+("+c[m]+"(?:\\."+c[m]+")*))";var r=f++,e="v?"+c[O]+c[R]+"?"+c[o]+"?";c[r]="^"+e+"$";var i="[v=\\s]*"+c[u]+c[I]+"?"+c[o]+"?",n=f++;c[n]="^"+i+"$";var s=f++;c[s]="((?:<|>)?=?)";var l=f++;c[l]=c[y]+"|x|X|\\*";var p=f++;c[p]=c[C]+"|x|X|\\*";var E=f++;c[E]="[v=\\s]*("+c[p]+")(?:\\.("+c[p]+")(?:\\.("+c[p]+")(?:"+c[R]+")?"+c[o]+"?)?)?";var U=f++;c[U]="[v=\\s]*("+c[l]+")(?:\\.("+c[l]+")(?:\\.("+c[l]+")(?:"+c[I]+")?"+c[o]+"?)?)?";var A=f++;c[A]="^"+c[s]+"\\s*"+c[E]+"$";var j=f++;c[j]="^"+c[s]+"\\s*"+c[U]+"$";var V=f++;c[V]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=f++;c[q]="(?:~>?)";var J=f++;c[J]="(\\s*)"+c[q]+"\\s+",D[J]=new RegExp(c[J],"g");var ie=f++;c[ie]="^"+c[q]+c[E]+"$";var ne=f++;c[ne]="^"+c[q]+c[U]+"$";var te=f++;c[te]="(?:\\^)";var ae=f++;c[ae]="(\\s*)"+c[te]+"\\s+",D[ae]=new RegExp(c[ae],"g");var x=f++;c[x]="^"+c[te]+c[E]+"$";var G=f++;c[G]="^"+c[te]+c[U]+"$";var k=f++;c[k]="^"+c[s]+"\\s*("+i+")$|^$";var g=f++;c[g]="^"+c[s]+"\\s*("+e+")$|^$";var a=f++;c[a]="(\\s*)"+c[s]+"\\s*("+i+"|"+c[E]+")",D[a]=new RegExp(c[a],"g");var S=f++;c[S]="^\\s*("+c[E]+")\\s+-\\s+("+c[E]+")\\s*$";var P=f++;c[P]="^\\s*("+c[U]+")\\s+-\\s+("+c[U]+")\\s*$";var N=f++;c[N]="(<|>)?=?\\s*\\*";for(var M=0;M<35;M++)b(M,c[M]),D[M]||(D[M]=new RegExp(c[M]));function W(z,H){if(z instanceof B)return z;if(typeof z!="string"||z.length>L||!(H?D[n]:D[r]).test(z))return null;try{return new B(z,H)}catch(K){return null}}function B(z,H){if(z instanceof B){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof B))return new B(z,H);b("SemVer",z,H),this.loose=H;var K=z.trim().match(H?D[n]:D[r]);if(!K)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var oe=+se;if(oe>=0&&oe<T)return oe}return se}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}t.parse=W,t.valid=function(z,H){var K=W(z,H);return K?K.version:null},t.clean=function(z,H){var K=W(z.trim().replace(/^[=v]+/,""),H);return K?K.version:null},t.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(z){return b("SemVer.compare",this.version,this.loose,z),z instanceof B||(z=new B(z,this.loose)),this.compareMain(z)||this.comparePre(z)},B.prototype.compareMain=function(z){return z instanceof B||(z=new B(z,this.loose)),X(this.major,z.major)||X(this.minor,z.minor)||X(this.patch,z.patch)},B.prototype.comparePre=function(z){if(z instanceof B||(z=new B(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var K=this.prerelease[H],se=z.prerelease[H];if(b("prerelease compare",H,K,se),K===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(K===void 0)return-1;if(K!==se)return X(K,se)}while(++H)},B.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},t.inc=function(z,H,K,se){typeof K=="string"&&(se=K,K=void 0);try{return new B(z,K).inc(H,se).version}catch(oe){return null}},t.diff=function(z,H){if(ce(z,H))return null;var K=W(z),se=W(H);if(K.prerelease.length||se.prerelease.length){for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return"pre"+oe;return"prerelease"}for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return oe},t.compareIdentifiers=X;var $=/^[0-9]+$/;function X(z,H){var K=$.test(z),se=$.test(H);return K&&se&&(z=+z,H=+H),K&&!se?-1:se&&!K?1:z<H?-1:z>H?1:0}function Y(z,H,K){return new B(z,K).compare(new B(H,K))}function ee(z,H,K){return Y(z,H,K)>0}function re(z,H,K){return Y(z,H,K)<0}function ce(z,H,K){return Y(z,H,K)===0}function ge(z,H,K){return Y(z,H,K)!==0}function Pe(z,H,K){return Y(z,H,K)>=0}function Fe(z,H,K){return Y(z,H,K)<=0}function Oe(z,H,K,se){var oe;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),oe=z===K;break;case"!==":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),oe=z!==K;break;case"":case"=":case"==":oe=ce(z,K,se);break;case"!=":oe=ge(z,K,se);break;case">":oe=ee(z,K,se);break;case">=":oe=Pe(z,K,se);break;case"<":oe=re(z,K,se);break;case"<=":oe=Fe(z,K,se);break;default:throw new TypeError("Invalid operator: "+H)}return oe}function Se(z,H){if(z instanceof Se){if(z.loose===H)return z;z=z.value}if(!(this instanceof Se))return new Se(z,H);b("comparator",z,H),this.loose=H,this.parse(z),this.semver===ke?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}t.rcompareIdentifiers=function(z,H){return X(H,z)},t.major=function(z,H){return new B(z,H).major},t.minor=function(z,H){return new B(z,H).minor},t.patch=function(z,H){return new B(z,H).patch},t.compare=Y,t.compareLoose=function(z,H){return Y(z,H,!0)},t.rcompare=function(z,H,K){return Y(H,z,K)},t.sort=function(z,H){return z.sort(function(K,se){return t.compare(K,se,H)})},t.rsort=function(z,H){return z.sort(function(K,se){return t.rcompare(K,se,H)})},t.gt=ee,t.lt=re,t.eq=ce,t.neq=ge,t.gte=Pe,t.lte=Fe,t.cmp=Oe,t.Comparator=Se;var ke={};function pe(z,H){if(z instanceof pe)return z.loose===H?z:new pe(z.raw,H);if(z instanceof Se)return new pe(z.value,H);if(!(this instanceof pe))return new pe(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Re(z){return!z||z.toLowerCase()==="x"||z==="*"}function xe(z,H,K,se,oe,be,de,Ce,Ee,Le,Me,we,Ie){return((H=Re(K)?"":Re(se)?">="+K+".0.0":Re(oe)?">="+K+"."+se+".0":">="+H)+" "+(Ce=Re(Ee)?"":Re(Le)?"<"+(+Ee+1)+".0.0":Re(Me)?"<"+Ee+"."+(+Le+1)+".0":we?"<="+Ee+"."+Le+"."+Me+"-"+we:"<="+Ce)).trim()}function _e(z,H){for(var K=0;K<z.length;K++)if(!z[K].test(H))return!1;if(H.prerelease.length){for(K=0;K<z.length;K++)if(b(z[K].semver),z[K].semver!==ke&&z[K].semver.prerelease.length>0){var se=z[K].semver;if(se.major===H.major&&se.minor===H.minor&&se.patch===H.patch)return!0}return!1}return!0}function Ue(z,H,K){try{H=new pe(H,K)}catch(se){return!1}return H.test(z)}function ze(z,H,K,se){var oe,be,de,Ce,Ee;switch(z=new B(z,se),H=new pe(H,se),K){case">":oe=ee,be=Fe,de=re,Ce=">",Ee=">=";break;case"<":oe=re,be=Pe,de=ee,Ce="<",Ee="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(z,H,se))return!1;for(var Le=0;Le<H.set.length;++Le){var Me=H.set[Le],we=null,Ie=null;if(Me.forEach(function(Te){Te.semver===ke&&(Te=new Se(">=0.0.0")),we=we||Te,Ie=Ie||Te,oe(Te.semver,we.semver,se)?we=Te:de(Te.semver,Ie.semver,se)&&(Ie=Te)}),we.operator===Ce||we.operator===Ee||(!Ie.operator||Ie.operator===Ce)&&be(z,Ie.semver)||Ie.operator===Ee&&de(z,Ie.semver))return!1}return!0}Se.prototype.parse=function(z){var H=this.loose?D[k]:D[g],K=z.match(H);if(!K)throw new TypeError("Invalid comparator: "+z);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new B(K[2],this.loose):this.semver=ke},Se.prototype.toString=function(){return this.value},Se.prototype.test=function(z){return b("Comparator.test",z,this.loose),this.semver===ke||(typeof z=="string"&&(z=new B(z,this.loose)),Oe(z,this.operator,this.semver,this.loose))},Se.prototype.intersects=function(z,H){if(!(z instanceof Se))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new pe(z.value,H),Ue(this.value,K,H);if(z.operator==="")return K=new pe(this.value,H),Ue(z.semver,K,H);var se=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),oe=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),be=this.semver.version===z.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ce=Oe(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Ee=Oe(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return se||oe||be&&de||Ce||Ee},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),b("range",z,H);var K=H?D[P]:D[S];z=z.replace(K,xe),b("hyphen replace",z),z=z.replace(D[a],"$1$2$3"),b("comparator trim",z,D[a]),z=(z=(z=z.replace(D[J],"$1~")).replace(D[ae],"$1^")).split(/\s+/).join(" ");var se=H?D[k]:D[g],oe=z.split(" ").map(function(be){return function(de,Ce){return b("comp",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(Me){return function(we,Ie){b("caret",we,Ie);var Te=Ie?D[G]:D[x];return we.replace(Te,function(Ae,le,he,me,ve){var De;return b("caret",we,Ae,le,he,me,ve),Re(le)?De="":Re(he)?De=">="+le+".0.0 <"+(+le+1)+".0.0":Re(me)?De=le==="0"?">="+le+"."+he+".0 <"+le+"."+(+he+1)+".0":">="+le+"."+he+".0 <"+(+le+1)+".0.0":ve?(b("replaceCaret pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),De=le==="0"?he==="0"?">="+le+"."+he+"."+me+ve+" <"+le+"."+he+"."+(+me+1):">="+le+"."+he+"."+me+ve+" <"+le+"."+(+he+1)+".0":">="+le+"."+he+"."+me+ve+" <"+(+le+1)+".0.0"):(b("no pr"),De=le==="0"?he==="0"?">="+le+"."+he+"."+me+" <"+le+"."+he+"."+(+me+1):">="+le+"."+he+"."+me+" <"+le+"."+(+he+1)+".0":">="+le+"."+he+"."+me+" <"+(+le+1)+".0.0"),b("caret return",De),De})}(Me,Le)}).join(" ")}(de,Ce),b("caret",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(Me){return function(we,Ie){var Te=Ie?D[ne]:D[ie];return we.replace(Te,function(Ae,le,he,me,ve){var De;return b("tilde",we,Ae,le,he,me,ve),Re(le)?De="":Re(he)?De=">="+le+".0.0 <"+(+le+1)+".0.0":Re(me)?De=">="+le+"."+he+".0 <"+le+"."+(+he+1)+".0":ve?(b("replaceTilde pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),De=">="+le+"."+he+"."+me+ve+" <"+le+"."+(+he+1)+".0"):De=">="+le+"."+he+"."+me+" <"+le+"."+(+he+1)+".0",b("tilde return",De),De})}(Me,Le)}).join(" ")}(de,Ce),b("tildes",de),de=function(Ee,Le){return b("replaceXRanges",Ee,Le),Ee.split(/\s+/).map(function(Me){return function(we,Ie){we=we.trim();var Te=Ie?D[j]:D[A];return we.replace(Te,function(Ae,le,he,me,ve,De){b("xRange",we,Ae,le,he,me,ve,De);var We=Re(he),Ne=We||Re(me),je=Ne||Re(ve);return le==="="&&je&&(le=""),We?Ae=le===">"||le==="<"?"<0.0.0":"*":le&&je?(Ne&&(me=0),je&&(ve=0),le===">"?(le=">=",Ne?(he=+he+1,me=0,ve=0):je&&(me=+me+1,ve=0)):le==="<="&&(le="<",Ne?he=+he+1:me=+me+1),Ae=le+he+"."+me+"."+ve):Ne?Ae=">="+he+".0.0 <"+(+he+1)+".0.0":je&&(Ae=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0"),b("xRange return",Ae),Ae})}(Me,Le)}).join(" ")}(de,Ce),b("xrange",de),de=function(Ee,Le){return b("replaceStars",Ee,Le),Ee.trim().replace(D[N],"")}(de,Ce),b("stars",de),de}(be,H)}).join(" ").split(/\s+/);return this.loose&&(oe=oe.filter(function(be){return!!be.match(se)})),oe=oe.map(function(be){return new Se(be,H)})},pe.prototype.intersects=function(z,H){if(!(z instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(se){return z.set.some(function(oe){return oe.every(function(be){return se.intersects(be,H)})})})})},t.toComparators=function(z,H){return new pe(z,H).set.map(function(K){return K.map(function(se){return se.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new B(z,this.loose));for(var H=0;H<this.set.length;H++)if(_e(this.set[H],z))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(z,H,K){var se=null,oe=null;try{var be=new pe(H,K)}catch(de){return null}return z.forEach(function(de){be.test(de)&&(se&&oe.compare(de)!==-1||(oe=new B(se=de,K)))}),se},t.minSatisfying=function(z,H,K){var se=null,oe=null;try{var be=new pe(H,K)}catch(de){return null}return z.forEach(function(de){be.test(de)&&(se&&oe.compare(de)!==1||(oe=new B(se=de,K)))}),se},t.validRange=function(z,H){try{return new pe(z,H).range||"*"}catch(K){return null}},t.ltr=function(z,H,K){return ze(z,H,"<",K)},t.gtr=function(z,H,K){return ze(z,H,">",K)},t.outside=ze,t.prerelease=function(z,H){var K=W(z,H);return K&&K.prerelease.length?K.prerelease:null},t.intersects=function(z,H,K){return z=new pe(z,K),H=new pe(H,K),z.intersects(H)},t.coerce=function(z){if(z instanceof B)return z;if(typeof z!="string")return null;var H=z.match(D[V]);return H==null?null:W((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,d(1))},function(_,t){var d,F,b=_.exports={};function L(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function D(w){if(d===setTimeout)return setTimeout(w,0);if((d===L||!d)&&setTimeout)return d=setTimeout,setTimeout(w,0);try{return d(w,0)}catch(R){try{return d.call(null,w,0)}catch(I){return d.call(this,w,0)}}}(function(){try{d=typeof setTimeout=="function"?setTimeout:L}catch(w){d=L}try{F=typeof clearTimeout=="function"?clearTimeout:T}catch(w){F=T}})();var c,f=[],C=!1,y=-1;function v(){C&&c&&(C=!1,c.length?f=c.concat(f):y=-1,f.length&&O())}function O(){if(!C){var w=D(v);C=!0;for(var R=f.length;R;){for(c=f,f=[];++y<R;)c&&c[y].run();y=-1,R=f.length}c=null,C=!1,function(I){if(F===clearTimeout)return clearTimeout(I);if((F===T||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(I);try{F(I)}catch(m){try{return F.call(null,I)}catch(o){return F.call(this,I)}}}(w)}}function u(w,R){this.fun=w,this.array=R}function h(){}b.nextTick=function(w){var R=new Array(arguments.length-1);if(arguments.length>1)for(var I=1;I<arguments.length;I++)R[I-1]=arguments[I];f.push(new u(w,R)),f.length!==1||C||D(O)},u.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=h,b.addListener=h,b.once=h,b.off=h,b.removeListener=h,b.removeAllListeners=h,b.emit=h,b.prependListener=h,b.prependOnceListener=h,b.listeners=function(w){return[]},b.binding=function(w){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(w){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(Q[35],Z([0,1,13,2]),function(_,t,d,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function b(m){const o=m;return o?[o.on,o.pause,o.resume,o.destroy].every(r=>typeof r=="function"):!1}t.isReadableStream=b;function L(m){const o=m;return o?b(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=L;function T(m,o){return new D(m,o)}t.newWriteableStream=T;class D{constructor(o,r){this.reducer=o,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){var r;if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof((r=this.options)===null||r===void 0?void 0:r.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(r=>r(o))}emitError(o){this.listeners.error.length===0?(0,d.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(r=>r(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,r){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(o,r){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(r);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(m,o){const r=[];let e;for(;(e=m.read())!==null;)r.push(e);return o(r)}t.consumeReadable=c;function f(m,o,r){const e=[];let i;for(;(i=m.read())!==null&&e.length<r;)e.push(i);return i===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return m.read()}}}t.peekReadable=f;function C(m,o){return new Promise((r,e)=>{const i=[];y(m,{onData:n=>{o&&i.push(n)},onError:n=>{o?e(n):r(void 0)},onEnd:()=>{r(o?o(i):void 0)}})})}t.consumeStream=C;function y(m,o){m.on("error",r=>o.onError(r)),m.on("end",()=>o.onEnd()),m.on("data",r=>o.onData(r))}t.listenStream=y;function v(m,o){return new Promise((r,e)=>{const i=new F.DisposableStore,n=[],s=E=>{if(n.push(E),n.length>o)return i.dispose(),m.pause(),r({stream:m,buffer:n,ended:!1})},l=E=>e(E),p=()=>r({stream:m,buffer:n,ended:!0});i.add((0,F.toDisposable)(()=>m.removeListener("error",l))),m.on("error",l),i.add((0,F.toDisposable)(()=>m.removeListener("end",p))),m.on("end",p),i.add((0,F.toDisposable)(()=>m.removeListener("data",s))),m.on("data",s)})}t.peekStream=v;function O(m,o){const r=T(o);return r.end(m),r}t.toStream=O;function u(){const m=T(()=>{throw new Error("not supported")});return m.end(),m}t.emptyStream=u;function h(m){let o=!1;return{read:()=>o?null:(o=!0,m)}}t.toReadable=h;function w(m,o,r){const e=T(r);return y(m,{onData:i=>e.write(o.data(i)),onError:i=>e.error(o.error?o.error(i):i),onEnd:()=>e.end()}),e}t.transform=w;function R(m,o,r){let e=!1;return{read:()=>{const i=o.read();return e?i:(e=!0,i!==null?r([m,i]):m)}}}t.prefixedReadable=R;function I(m,o,r){let e=!1;const i=T(r);return y(o,{onData:n=>e?i.write(n):(e=!0,i.write(r([m,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(m)),i.end()}}),i}t.prefixedStream=I}),define(Q[16],Z([0,1,19,35]),function(_,t,d,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const b=typeof Buffer!="undefined",L=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let D,c;class f{constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}static alloc(E){return b?new f(Buffer.allocUnsafe(E)):new f(new Uint8Array(E))}static wrap(E){return b&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new f(E)}static fromString(E,U){return!((U==null?void 0:U.dontUseNodeBuffer)||!1)&&b?new f(Buffer.from(E)):L?(D||(D=new TextEncoder),new f(D.encode(E))):new f(d.encodeUTF8(E))}static concat(E,U){if(typeof U=="undefined"){U=0;for(let V=0,q=E.length;V<q;V++)U+=E[V].byteLength}const A=f.alloc(U);let j=0;for(let V=0,q=E.length;V<q;V++){const J=E[V];A.set(J,j),j+=J.byteLength}return A}toString(){return b?this.buffer.toString():T?(c||(c=new TextDecoder),c.decode(this.buffer)):d.decodeUTF8(this.buffer)}slice(E,U){return new f(this.buffer.subarray(E,U))}set(E,U){E instanceof f?this.buffer.set(E.buffer,U):this.buffer.set(E,U)}readUInt32BE(E){return v(this.buffer,E)}writeUInt32BE(E,U){O(this.buffer,E,U)}readUInt32LE(E){return u(this.buffer,E)}writeUInt32LE(E,U){h(this.buffer,E,U)}readUInt8(E){return w(this.buffer,E)}writeUInt8(E,U){R(this.buffer,E,U)}}t.VSBuffer=f;function C(p,E){return p[E+0]<<0>>>0|p[E+1]<<8>>>0}t.readUInt16LE=C;function y(p,E,U){p[U+0]=E&255,E=E>>>8,p[U+1]=E&255}t.writeUInt16LE=y;function v(p,E){return p[E]*2**24+p[E+1]*2**16+p[E+2]*2**8+p[E+3]}t.readUInt32BE=v;function O(p,E,U){p[U+3]=E,E=E>>>8,p[U+2]=E,E=E>>>8,p[U+1]=E,E=E>>>8,p[U]=E}t.writeUInt32BE=O;function u(p,E){return p[E+0]<<0>>>0|p[E+1]<<8>>>0|p[E+2]<<16>>>0|p[E+3]<<24>>>0}t.readUInt32LE=u;function h(p,E,U){p[U+0]=E&255,E=E>>>8,p[U+1]=E&255,E=E>>>8,p[U+2]=E&255,E=E>>>8,p[U+3]=E&255}t.writeUInt32LE=h;function w(p,E){return p[E]}t.readUInt8=w;function R(p,E,U){p[U]=E}t.writeUInt8=R;function I(p){return F.consumeReadable(p,E=>f.concat(E))}t.readableToBuffer=I;function m(p){return F.toReadable(p)}t.bufferToReadable=m;function o(p){return F.consumeStream(p,E=>f.concat(E))}t.streamToBuffer=o;async function r(p){return p.ended?f.concat(p.buffer):f.concat([...p.buffer,await o(p.stream)])}t.bufferedStreamToBuffer=r;function e(p){return F.toStream(p,E=>f.concat(E))}t.bufferToStream=e;function i(p){return F.transform(p,{data:E=>typeof E=="string"?f.fromString(E):f.wrap(E)},E=>f.concat(E))}t.streamToBufferReadableStream=i;function n(p){return F.newWriteableStream(E=>f.concat(E),p)}t.newWriteableBufferStream=n;function s(p,E){return F.prefixedReadable(p,E,U=>f.concat(U))}t.prefixedBufferReadable=s;function l(p,E){return F.prefixedStream(p,E,U=>f.concat(U))}t.prefixedBufferStream=l}),define(Q[20],Z([0,1,12]),function(_,t,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function F(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const w=Array.isArray(h)?[]:{};return Object.keys(h).forEach(R=>{h[R]&&typeof h[R]=="object"?w[R]=F(h[R]):w[R]=h[R]}),w}t.deepClone=F;function b(h){if(!h||typeof h!="object")return h;const w=[h];for(;w.length>0;){const R=w.shift();Object.freeze(R);for(const I in R)if(L.call(R,I)){const m=R[I];typeof m=="object"&&!Object.isFrozen(m)&&w.push(m)}}return h}t.deepFreeze=b;const L=Object.prototype.hasOwnProperty;function T(h,w){return D(h,w,new Set)}t.cloneAndChange=T;function D(h,w,R){if((0,d.isUndefinedOrNull)(h))return h;const I=w(h);if(typeof I!="undefined")return I;if((0,d.isArray)(h)){const m=[];for(const o of h)m.push(D(o,w,R));return m}if((0,d.isObject)(h)){if(R.has(h))throw new Error("Cannot clone recursive data-structure");R.add(h);const m={};for(let o in h)L.call(h,o)&&(m[o]=D(h[o],w,R));return R.delete(h),m}return h}function c(h,w,R=!0){return(0,d.isObject)(h)?((0,d.isObject)(w)&&Object.keys(w).forEach(I=>{I in h?R&&((0,d.isObject)(h[I])&&(0,d.isObject)(w[I])?c(h[I],w[I],R):h[I]=w[I]):h[I]=w[I]}),h):w}t.mixin=c;function f(h,w){if(h===w)return!0;if(h==null||w===null||w===void 0||typeof h!=typeof w||typeof h!="object"||Array.isArray(h)!==Array.isArray(w))return!1;let R,I;if(Array.isArray(h)){if(h.length!==w.length)return!1;for(R=0;R<h.length;R++)if(!f(h[R],w[R]))return!1}else{const m=[];for(I in h)m.push(I);m.sort();const o=[];for(I in w)o.push(I);if(o.sort(),!f(m,o))return!1;for(R=0;R<m.length;R++)if(!f(h[m[R]],w[m[R]]))return!1}return!0}t.equals=f;function C(h){const w=new Set;return JSON.stringify(h,(R,I)=>{if((0,d.isObject)(I)||Array.isArray(I)){if(w.has(I))return"[Circular]";w.add(I)}return I})}t.safeStringify=C;function y(h,w,R){const I=w(h);return typeof I=="undefined"?R:I}t.getOrDefault=y;function v(h,w){const R=Object.create(null);return!h||!w||Object.keys(w).forEach(m=>{const o=h[m],r=w[m];f(o,r)||(R[m]=r)}),R}t.distinct=v;function O(h,w){const R=w.toLowerCase(),I=Object.keys(h).find(m=>m.toLowerCase()===R);return I?h[I]:h[w]}t.getCaseInsensitive=O;function u(h,w){const R=Object.create(null);for(const I of Object.keys(h))w(I,h[I])&&(R[I]=h[I]);return R}t.filter=u}),define(Q[59],Z([0,1,7]),function(_,t,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function F(f){const C=f;return C&&typeof C.type=="string"&&typeof C.severity=="string"}t.isRemoteConsoleLog=F;function b(f){const C=[];let y;try{const v=JSON.parse(f.arguments),O=v[v.length-1];O&&O.__$stack&&(v.pop(),y=O.__$stack),C.push(...v)}catch(v){C.push("Unable to log remote console arguments",f.arguments)}return{args:C,stack:y}}t.parse=b;function L(f){if(typeof f!="string")return L(b(f).stack);const C=f;if(C){const y=T(C),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(v&&v.length===4)return{uri:d.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}t.getFirstFrame=L;function T(f){if(!f)return f;const C=f.indexOf(`
`);return C===-1?f:f.substring(0,C)}function D(f,C){const{args:y,stack:v}=b(f),O=typeof y[0]=="string"&&y.length===1;let u=T(v);u&&(u=`(${u.trim()})`);let h=[];if(typeof y[0]=="string"?u&&O?h=[`%c[${C}] %c${y[0]} %c${u}`,c("blue"),c(""),c("grey")]:h=[`%c[${C}] %c${y[0]}`,c("blue"),c(""),...y.slice(1)]:h=[`%c[${C}]%`,c("blue"),...y],u&&!O&&h.push(u),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,h)}t.log=D;function c(f){return`color: ${f}`}}),define(Q[60],Z([0,1,16,19,7]),function(_,t,d,F,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function L(f){return JSON.stringify(f,D)}t.stringify=L;function T(f){let C=JSON.parse(f);return C=c(C),C}t.parse=T;function D(f,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,F.regExpFlags)(C)}:C}function c(f,C=0){if(!f||C>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return b.URI.revive(f);case 2:return new RegExp(f.source,f.flags)}if(f instanceof d.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let y=0;y<f.length;++y)f[y]=c(f[y],C+1);else for(const y in f)Object.hasOwnProperty.call(f,y)&&(f[y]=c(f[y],C+1))}return f}t.revive=c}),define(Q[61],Z([0,1,19,36,3,45,4]),function(_,t,d,F,b,L,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function D(){return Object.create(null)}t.getEmptyExpression=D;const c="**",f="/",C="[/\\\\]",y="[^/\\\\]",v=/\//g;function O(a){switch(a){case 0:return"";case 1:return`${y}*?`;default:return`(?:${C}|${y}+${C}|${C}${y}+)*?`}}function u(a,S){if(!a)return[];const P=[];let N=!1,M=!1,W="";for(const B of a){switch(B){case S:if(!N&&!M){P.push(W),W="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":M=!0;break;case"]":M=!1;break}W+=B}return W&&P.push(W),P}t.splitGlobAware=u;function h(a){if(!a)return"";let S="";const P=u(a,f);if(P.every(N=>N===c))S=".*";else{let N=!1;P.forEach((M,W)=>{if(M===c){N||(S+=O(2),N=!0);return}let B=!1,$="",X=!1,Y="";for(const ee of M){if(ee!=="}"&&B){$+=ee;continue}if(X&&(ee!=="]"||!Y)){let re;ee==="-"?re=ee:(ee==="^"||ee==="!")&&!Y?re="^":ee===f?re="":re=d.escapeRegExpCharacters(ee),Y+=re;continue}switch(ee){case"{":B=!0;continue;case"[":X=!0;continue;case"}":S+=`(?:${u($,",").map(ge=>h(ge)).join("|")})`,B=!1,$="";break;case"]":S+="["+Y+"]",X=!1,Y="";break;case"?":S+=y;continue;case"*":S+=O(1);continue;default:S+=d.escapeRegExpCharacters(ee)}}W<P.length-1&&(P[W+1]!==c||W+2<P.length)&&(S+=C),N=!1})}return S}const w=/^\*\*\/\*\.[\w\.-]+$/,R=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,m=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new L.LRUCache(1e4),i=function(){return!1},n=function(){return null};function s(a,S){if(!a)return n;let P;typeof a!="string"?P=a.pattern:P=a,P=P.trim();const N=`${P}_${!!S.trimForExclusions}`;let M=e.get(N);if(M)return l(M,a);let W;if(w.test(P)){const B=P.substr(4);M=function($,X){return typeof $=="string"&&$.endsWith(B)?P:null}}else(W=R.exec(p(P,S)))?M=E(W[1],P):(S.trimForExclusions?m:I).test(P)?M=U(P,S):(W=o.exec(p(P,S)))?M=A(W[1].substr(1),P,!0):(W=r.exec(p(P,S)))?M=A(W[1],P,!1):M=j(P);return e.set(N,M),l(M,a)}function l(a,S){return typeof S=="string"?a:function(P,N){return F.isEqualOrParent(P,S.base)?a(b.relative(S.base,P),N):null}}function p(a,S){return S.trimForExclusions&&a.endsWith("/**")?a.substr(0,a.length-2):a}function E(a,S){const P=`/${a}`,N=`\\${a}`,M=function(B,$){return typeof B!="string"?null:$?$===a?S:null:B===a||B.endsWith(P)||B.endsWith(N)?S:null},W=[a];return M.basenames=W,M.patterns=[S],M.allBasenames=W,M}function U(a,S){const P=g(a.slice(1,-1).split(",").map($=>s($,S)).filter($=>$!==n),a),N=P.length;if(!N)return n;if(N===1)return P[0];const M=function($,X){for(let Y=0,ee=P.length;Y<ee;Y++)if(P[Y]($,X))return a;return null},W=P.find($=>!!$.allBasenames);W&&(M.allBasenames=W.allBasenames);const B=P.reduce(($,X)=>X.allPaths?$.concat(X.allPaths):$,[]);return B.length&&(M.allPaths=B),M}function A(a,S,P){const N=b.sep===b.posix.sep,M=N?a:a.replace(v,b.sep),W=b.sep+M,B=b.posix.sep+a,$=P?function(X,Y){return typeof X=="string"&&(X===M||X.endsWith(W)||!N&&(X===a||X.endsWith(B)))?S:null}:function(X,Y){return typeof X=="string"&&(X===M||!N&&X===a)?S:null};return $.allPaths=[(P?"*/":"./")+a],$}function j(a){try{const S=new RegExp(`^${h(a)}$`);return function(P){return S.lastIndex=0,typeof P=="string"&&S.test(P)?a:null}}catch(S){return n}}function V(a,S,P){return!a||typeof S!="string"?!1:q(a)(S,void 0,P)}t.match=V;function q(a,S={}){if(!a)return i;if(typeof a=="string"||te(a)){const P=s(a,S);if(P===n)return i;const N=function(M,W){return!!P(M,W)};return P.allBasenames&&(N.allBasenames=P.allBasenames),P.allPaths&&(N.allPaths=P.allPaths),N}return G(a,S)}t.parse=q;function J(a){if(!a)return;let S;return P=>(S||(S=(a()||Promise.resolve([])).then(N=>N?ne(N):{})),S.then(N=>!!N[P]))}t.hasSiblingPromiseFn=J;function ie(a){if(!a)return;let S;return P=>{if(!S){const N=a();S=N?ne(N):{}}return!!S[P]}}t.hasSiblingFn=ie;function ne(a){const S={};for(const P of a)S[P]=!0;return S}function te(a){const S=a;return S&&typeof S.base=="string"&&typeof S.pattern=="string"}t.isRelativePattern=te;function ae(a){return a.allBasenames||[]}t.getBasenameTerms=ae;function x(a){return a.allPaths||[]}t.getPathTerms=x;function G(a,S){const P=g(Object.getOwnPropertyNames(a).map($=>k($,a[$],S)).filter($=>$!==n)),N=P.length;if(!N)return n;if(!P.some($=>!!$.requiresSiblings)){if(N===1)return P[0];const $=function(ee,re){for(let ce=0,ge=P.length;ce<ge;ce++){const Pe=P[ce](ee,re);if(Pe)return Pe}return null},X=P.find(ee=>!!ee.allBasenames);X&&($.allBasenames=X.allBasenames);const Y=P.reduce((ee,re)=>re.allPaths?ee.concat(re.allPaths):ee,[]);return Y.length&&($.allPaths=Y),$}const M=function($,X,Y){let ee;for(let re=0,ce=P.length;re<ce;re++){const ge=P[re];ge.requiresSiblings&&Y&&(X||(X=b.basename($)),ee||(ee=X.substr(0,X.length-b.extname($).length)));const Pe=ge($,X,ee,Y);if(Pe)return Pe}return null},W=P.find($=>!!$.allBasenames);W&&(M.allBasenames=W.allBasenames);const B=P.reduce(($,X)=>X.allPaths?$.concat(X.allPaths):$,[]);return B.length&&(M.allPaths=B),M}function k(a,S,P){if(S===!1)return n;const N=s(a,P);if(N===n)return n;if(typeof S=="boolean")return N;if(S){const M=S.when;if(typeof M=="string"){const W=(B,$,X,Y)=>{if(!Y||!N(B,$))return null;const ee=M.replace("$(basename)",X),re=Y(ee);return(0,T.isThenable)(re)?re.then(ce=>ce?a:null):re?a:null};return W.requiresSiblings=!0,W}}return N}function g(a,S){const P=a.filter($=>!!$.basenames);if(P.length<2)return a;const N=P.reduce(($,X)=>{const Y=X.basenames;return Y?$.concat(Y):$},[]);let M;if(S){M=[];for(let $=0,X=N.length;$<X;$++)M.push(S)}else M=P.reduce(($,X)=>{const Y=X.patterns;return Y?$.concat(Y):$},[]);const W=function($,X){if(typeof $!="string")return null;if(!X){let ee;for(ee=$.length;ee>0;ee--){const re=$.charCodeAt(ee-1);if(re===47||re===92)break}X=$.substr(ee)}const Y=N.indexOf(X);return Y!==-1?M[Y]:null};W.basenames=N,W.patterns=M,W.allBasenames=N;const B=a.filter($=>!$.basenames);return B.push(W),B}}),define(Q[62],Z([0,1,7,3,19,8,14,17,36]),function(_,t,d,F,b,L,T,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function f(s,l,p){if(typeof s=="string"&&(s=d.URI.file(s)),p){const U=p.getWorkspaceFolder(s);if(U){const A=p.getWorkspace().folders.length>1;let j;if((0,D.isEqual)(U.uri,s)?j="":j=(0,D.relativePath)(U.uri,s),A){const V=U.name?U.name:(0,D.basename)(U.uri);j=j?V+" \u2022 "+j:V}return j}}if(s.scheme!==L.Schemas.file&&s.scheme!==L.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,c.hasDriveLetter)(s.fsPath))return(0,F.normalize)(y(s.fsPath));let E=(0,F.normalize)(s.fsPath);return!T.isWindows&&(l==null?void 0:l.userHome)&&(E=O(E,l.userHome.fsPath)),E}t.getPathLabel=f;function C(s){if(!s)return;typeof s=="string"&&(s=d.URI.file(s));const l=(0,D.basename)(s)||(s.scheme===L.Schemas.file?s.fsPath:s.path);return T.isWindows&&(0,c.isRootOrDriveLetter)(l)?y(l):l}t.getBaseLabel=C;function y(s){return(0,c.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}t.normalizeDriveLetter=y;let v=Object.create(null);function O(s,l){if(T.isWindows||!s||!l)return s;let p=v.original===l?v.normalized:void 0;return p||(p=`${(0,b.rtrim)(l,F.posix.sep)}${F.posix.sep}`,v={original:l,normalized:p}),(T.isLinux?s.startsWith(p):(0,b.startsWithIgnoreCase)(s,p))&&(s=`~/${s.substr(p.length)}`),s}t.tildify=O;function u(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}t.untildify=u;const h="\u2026",w="\\\\",R="~";function I(s,l=F.sep){const p=new Array(s.length);let E=!1;for(let U=0;U<s.length;U++){let A=s[U];if(A===""){p[U]=`.${l}`;continue}if(!A){p[U]=A;continue}E=!0;let j="";A.indexOf(w)===0?(j=A.substr(0,A.indexOf(w)+w.length),A=A.substr(A.indexOf(w)+w.length)):A.indexOf(l)===0?(j=A.substr(0,A.indexOf(l)+l.length),A=A.substr(A.indexOf(l)+l.length)):A.indexOf(R)===0&&(j=A.substr(0,A.indexOf(R)+R.length),A=A.substr(A.indexOf(R)+R.length));const V=A.split(l);for(let q=1;E&&q<=V.length;q++)for(let J=V.length-q;E&&J>=0;J--){E=!1;let ie=V.slice(J,J+q).join(l);for(let ne=0;!E&&ne<s.length;ne++)if(ne!==U&&s[ne]&&s[ne].indexOf(ie)>-1){const te=J+q===V.length,ae=J>0&&s[ne].indexOf(l)>-1?l+ie:ie,x=s[ne].endsWith(ae);E=!te||x}if(!E){let ne="";(V[0].endsWith(":")||j!=="")&&(J===1&&(J=0,q++,ie=V[0]+l+ie),J>0&&(ne=V[0]+l),ne=j+ne),J>0&&(ne=ne+h+l),ne=ne+ie,J+q<V.length&&(ne=ne+l+h),p[U]=ne}}E&&(p[U]=A)}return p}t.shorten=I;var m;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function o(s,l=Object.create(null)){const p=[];let E=!1,U="";for(const A of s)if(A==="$"||E&&A==="{")U&&p.push({value:U,type:m.TEXT}),U="",E=!0;else if(A==="}"&&E){const j=l[U];if(typeof j=="string")j.length&&p.push({value:j,type:m.VARIABLE});else if(j){const V=p[p.length-1];(!V||V.type!==m.SEPARATOR)&&p.push({value:j.label,type:m.SEPARATOR})}U="",E=!1}else U+=A;return U&&!E&&p.push({value:U,type:m.TEXT}),p.filter((A,j)=>{if(A.type===m.SEPARATOR){const V=p[j-1],q=p[j+1];return[V,q].every(J=>J&&(J.type===m.VARIABLE||J.type===m.TEXT)&&J.value.length>0)}return!0}).map(A=>A.value).join("")}t.template=o;function r(s,l){return T.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):s.replace(/&&|&/g,p=>p==="&"?"&&":"&")}t.mnemonicMenuLabel=r;function e(s,l){return T.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,""):T.isWindows?s.replace(/&&|&/g,p=>p==="&"?"&&":"&"):s.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(s){return s.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(s){const l=s.indexOf("/")!==-1?F.posix:F.win32,p=l.basename(s),E=l.dirname(s);return p.length?{name:p,parentPath:E}:{name:E,parentPath:""}}t.splitName=n}),define(Q[46],Z([0,1,124]),function(_,t,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class F{constructor(L="utf8"){this.stringDecoder=new d.StringDecoder(L),this.remaining=null}write(L){const T=[],D=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(D.length<1)return T;let c=0,f,C=c;for(;C<D.length;)if(f=D.charCodeAt(C),f===13||f===10){if(T.push(D.substring(c,C)),C++,C<D.length){const y=f;f=D.charCodeAt(C),(y===13&&f===10||y===10&&f===13)&&C++}c=C}else C++;return this.remaining=c<D.length?D.substr(c):null,T}end(){return this.remaining}}t.LineDecoder=F}),define(Q[63],Z([0,1,31,19,3,9]),function(_,t,d,F,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function T(C){const y=(0,b.dirname)(C);if(C===y)return C;const v=((0,b.basename)(C)||C).toLowerCase();try{const u=(0,L.readdirSync)(y).filter(h=>h.toLowerCase()===v);if(u.length===1){const h=T(y);if(h)return(0,b.join)(h,u[0])}else if(u.length>1){const h=u.indexOf(v);if(h>=0){const w=T(y);if(w)return(0,b.join)(w,u[h])}}}catch(O){}return null}t.realcaseSync=T;async function D(C){try{return await L.Promises.realpath(C)}catch(y){const v=f(C);return await L.Promises.access(v,d.constants.R_OK),v}}t.realpath=D;function c(C){try{return d.realpathSync(C)}catch(y){const v=f(C);return d.accessSync(v,d.constants.R_OK),v}}t.realpathSync=c;function f(C){return(0,F.rtrim)((0,b.normalize)(C),b.sep)}});var ye=this&&this.__await||function(_){return this instanceof ye?(this.v=_,this):new ye(_)},Ve=this&&this.__asyncGenerator||function(_,t,d){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var F=d.apply(_,t||[]),b,L=[];return b={},T("next"),T("throw"),T("return"),b[Symbol.asyncIterator]=function(){return this},b;function T(v){F[v]&&(b[v]=function(O){return new Promise(function(u,h){L.push([v,O,u,h])>1||D(v,O)})})}function D(v,O){try{c(F[v](O))}catch(u){y(L[0][3],u)}}function c(v){v.value instanceof ye?Promise.resolve(v.value.v).then(f,C):y(L[0][2],v)}function f(v){D("next",v)}function C(v){D("throw",v)}function y(v,O){v(O),L.shift(),L.length&&D(L[0][0],L[0][1])}},Be=this&&this.__asyncValues||function(_){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t=_[Symbol.asyncIterator],d;return t?t.call(_):(_=typeof __values=="function"?__values(_):_[Symbol.iterator](),d={},F("next"),F("throw"),F("return"),d[Symbol.asyncIterator]=function(){return this},d);function F(L){d[L]=_[L]&&function(T){return new Promise(function(D,c){T=_[L](T),b(D,c,T.done,T.value)})}}function b(L,T,D,c){Promise.resolve(c).then(function(f){L({value:f,done:D})},T)}};define(Q[64],Z([0,1,9,32,3]),function(_,t,d,F,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,T=/^Microsoft.PowerShell_.*/,D=/^Microsoft.PowerShellPreview_.*/;var c;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(c||(c={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class y{constructor(r,e,i){this.exePath=r,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await d.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function v({useAlternateBitness:o=!1}={}){return o?f===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function O({useAlternateBitness:o=!1,findPreview:r=!1}={}){const e=v({useAlternateBitness:o});if(!e)return null;const i=b.join(e,"PowerShell");if(!await d.SymlinkSupport.existsDirectory(i))return null;let n=-1,s=null;for(const E of await d.readdir(i)){let U=-1;if(r){const j=E.indexOf("-");if(j<0)continue;const V=E.substring(0,j);if(!L.test(V)||E.substring(j+1)!=="preview")continue;U=parseInt(V,10)}else{if(!L.test(E))continue;U=parseInt(E,10)}if(U<=n)continue;const A=b.join(i,E,"pwsh.exe");!await d.SymlinkSupport.existsFile(A)||(s=A,n=U)}if(!s)return null;const l=e.includes("x86")?" (x86)":"",p=r?" Preview":"";return new y(s,`PowerShell${p}${l}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const r=b.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await d.SymlinkSupport.existsDirectory(r))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=o?{pwshMsixDirRegex:D,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const n of await d.readdir(r))if(e.test(n)){const s=b.join(r,n,"pwsh.exe");return new y(s,i)}return null}function h(){const o=b.join(F.homedir(),".dotnet","tools","pwsh.exe");return new y(o,".NET Core PowerShell Global Tool")}function w(){const o=b.join(process.env.windir,f===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(o,"Windows PowerShell",!0)}function R(){return Ve(this,arguments,function*(){let r=yield ye(O());r&&(yield yield ye(r)),r=yield ye(O({useAlternateBitness:!0})),r&&(yield yield ye(r)),r=yield ye(u()),r&&(yield yield ye(r)),r=h(),r&&(yield yield ye(r)),r=yield ye(O({findPreview:!0})),r&&(yield yield ye(r)),r=yield ye(u({findPreview:!0})),r&&(yield yield ye(r)),r=yield ye(O({useAlternateBitness:!0,findPreview:!0})),r&&(yield yield ye(r)),r=w(),r&&(yield yield ye(r))})}function I(){return Ve(this,arguments,function*(){var r,e;try{for(var i=Be(R()),n;n=yield ye(i.next()),!n.done;){const s=n.value;(yield ye(s.exists()))&&(yield yield ye(s))}}catch(s){r={error:s}}finally{try{n&&!n.done&&(e=i.return)&&(yield ye(e.call(i)))}finally{if(r)throw r.error}}})}t.enumeratePowerShellInstallations=I;async function m(){var o,r;try{for(var e=Be(I()),i;i=await e.next(),!i.done;)return i.value}catch(n){o={error:n}}finally{try{i&&!i.done&&(r=e.return)&&await r.call(e)}finally{if(o)throw o.error}}return null}t.getFirstAvailablePowerShellInstallation=m}),define(Q[65],Z([0,1,3,31,14,125,2,9]),function(_,t,d,F,b,L,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function c(y,v,O){return C({path:y,isDirectory:!1},v,O)}t.watchFile=c;function f(y,v,O){return C({path:y,isDirectory:!0},v,O)}t.watchFolder=f,t.CHANGE_BUFFER_DELAY=100;function C(y,v,O){const u=(0,d.basename)(y.path),h=new Map;let w=!1,R=[(0,T.toDisposable)(()=>{h.forEach(I=>(0,T.dispose)(I)),h.clear()})];try{const I=(0,F.watch)(y.path);R.push((0,T.toDisposable)(()=>{I.removeAllListeners(),I.close()}));const m=new Set;y.isDirectory&&(0,D.readdir)(y.path).then(o=>o.forEach(r=>m.add(r))),I.on("error",(o,r)=>{w||O(`Failed to watch ${y.path} for changes using fs.watch() (${o}, ${r})`)}),I.on("change",(o,r)=>{if(w)return;let e="";if(r&&(e=r.toString(),b.isMacintosh&&(e=(0,L.normalizeNFC)(e))),!e||o!=="change"&&o!=="rename")return;const i=y.isDirectory?(0,d.join)(y.path,e):y.path;if(y.isDirectory)if(o==="rename"){const n=h.get(i);n&&(0,T.dispose)(n);const s=setTimeout(async()=>{h.delete(i);const l=await(0,D.exists)(i);if(w)return;let p;l?m.has(e)?p="changed":(p="added",m.add(e)):(m.delete(e),p="deleted"),v(p,i)},t.CHANGE_BUFFER_DELAY);h.set(i,(0,T.toDisposable)(()=>clearTimeout(s)))}else{let n;m.has(e)?n="changed":(n="added",m.add(e)),v(n,i)}else if(o==="rename"||e!==u){const n=setTimeout(async()=>{const s=await(0,D.exists)(i);w||(s?(v("changed",i),R=[C(y,v,O)]):v("deleted",i))},t.CHANGE_BUFFER_DELAY);(0,T.dispose)(R),R=[(0,T.toDisposable)(()=>clearTimeout(n))]}else v("changed",i)})}catch(I){(0,D.exists)(y.path).then(m=>{m&&!w&&O(`Failed to watch ${y.path} for changes using fs.watch() (${I.toString()})`)})}return(0,T.toDisposable)(()=>{w=!0,R=(0,T.dispose)(R)})}});var ue=this&&this.__decorate||function(_,t,d,F){var b=arguments.length,L=b<3?t:F===null?F=Object.getOwnPropertyDescriptor(t,d):F,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(_,t,d,F);else for(var D=_.length-1;D>=0;D--)(T=_[D])&&(L=(b<3?T(L):b>3?T(t,d,L):T(t,d))||L);return b>3&&L&&Object.defineProperty(t,d,L),L};define(Q[37],Z([0,1,10,2,4,27,13,16,22,12,60,19,44]),function(_,t,d,F,b,L,T,D,c,f,C,y,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var O;(function(g){g[g.Promise=100]="Promise",g[g.PromiseCancel=101]="PromiseCancel",g[g.EventListen=102]="EventListen",g[g.EventDispose=103]="EventDispose"})(O=t.RequestType||(t.RequestType={}));function u(g){switch(g){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(g){g[g.Initialize=200]="Initialize",g[g.PromiseSuccess=201]="PromiseSuccess",g[g.PromiseError=202]="PromiseError",g[g.PromiseErrorObj=203]="PromiseErrorObj",g[g.EventFire=204]="EventFire"})(h=t.ResponseType||(t.ResponseType={}));function w(g){switch(g){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var R;(function(g){g[g.Uninitialized=0]="Uninitialized",g[g.Idle=1]="Idle"})(R||(R={}));class I{constructor(a){this.buffer=a,this.pos=0}read(a){const S=this.buffer.slice(this.pos,this.pos+a);return this.pos+=S.byteLength,S}}class m{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(a){this.buffers.push(a)}}var o;(function(g){g[g.Undefined=0]="Undefined",g[g.String=1]="String",g[g.Buffer=2]="Buffer",g[g.VSBuffer=3]="VSBuffer",g[g.Array=4]="Array",g[g.Object=5]="Object"})(o||(o={}));function r(g){const a=D.VSBuffer.alloc(4);return a.writeUInt32BE(g,0),a}function e(g){return g.read(4).readUInt32BE(0)}function i(g){const a=D.VSBuffer.alloc(1);return a.writeUInt8(g,0),a}const n={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object)},s=typeof Buffer!="undefined";function l(g,a){if(typeof a=="undefined")g.write(n.Undefined);else if(typeof a=="string"){const S=D.VSBuffer.fromString(a);g.write(n.String),g.write(r(S.byteLength)),g.write(S)}else if(s&&Buffer.isBuffer(a)){const S=D.VSBuffer.wrap(a);g.write(n.Buffer),g.write(r(S.byteLength)),g.write(S)}else if(a instanceof D.VSBuffer)g.write(n.VSBuffer),g.write(r(a.byteLength)),g.write(a);else if(Array.isArray(a)){g.write(n.Array),g.write(r(a.length));for(const S of a)l(g,S)}else{const S=D.VSBuffer.fromString(JSON.stringify(a));g.write(n.Object),g.write(r(S.byteLength)),g.write(S)}}function p(g){switch(g.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return g.read(e(g)).toString();case o.Buffer:return g.read(e(g)).buffer;case o.VSBuffer:return g.read(e(g));case o.Array:{const S=e(g),P=[];for(let N=0;N<S;N++)P.push(p(g));return P}case o.Object:return JSON.parse(g.read(e(g)).toString())}}class E{constructor(a,S,P=null,N=1e3){this.protocol=a,this.ctx=S,this.logger=P,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(M=>this.onRawMessage(M)),this.sendResponse({type:200})}registerChannel(a,S){this.channels.set(a,S),setTimeout(()=>this.flushPendingRequests(a),0)}sendResponse(a){switch(a.type){case 200:{const S=this.send([a.type]);this.logger&&this.logger.logOutgoing(S,0,1,w(a.type));return}case 201:case 202:case 204:case 203:{const S=this.send([a.type,a.id],a.data);this.logger&&this.logger.logOutgoing(S,a.id,1,w(a.type),a.data);return}}}send(a,S=void 0){const P=new m;return l(P,a),l(P,S),this.sendBuffer(P.buffer)}sendBuffer(a){try{return this.protocol.send(a),a.byteLength}catch(S){return 0}}onRawMessage(a){const S=new I(a),P=p(S),N=p(S),M=P[0];switch(M){case 100:return this.logger&&this.logger.logIncoming(a.byteLength,P[1],1,`${u(M)}: ${P[2]}.${P[3]}`,N),this.onPromise({type:M,id:P[1],channelName:P[2],name:P[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(a.byteLength,P[1],1,`${u(M)}: ${P[2]}.${P[3]}`,N),this.onEventListen({type:M,id:P[1],channelName:P[2],name:P[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(a.byteLength,P[1],1,`${u(M)}`),this.disposeActiveRequest({type:M,id:P[1]});case 103:return this.logger&&this.logger.logIncoming(a.byteLength,P[1],1,`${u(M)}`),this.disposeActiveRequest({type:M,id:P[1]})}}onPromise(a){const S=this.channels.get(a.channelName);if(!S){this.collectPendingRequest(a);return}const P=new L.CancellationTokenSource;let N;try{N=S.call(this.ctx,a.name,a.arg,P.token)}catch(B){N=Promise.reject(B)}const M=a.id;N.then(B=>{this.sendResponse({id:M,data:B,type:201}),this.activeRequests.delete(a.id)},B=>{B instanceof Error?this.sendResponse({id:M,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.sendResponse({id:M,data:B,type:203}),this.activeRequests.delete(a.id)});const W=(0,F.toDisposable)(()=>P.cancel());this.activeRequests.set(a.id,W)}onEventListen(a){const S=this.channels.get(a.channelName);if(!S){this.collectPendingRequest(a);return}const P=a.id,M=S.listen(this.ctx,a.name,a.arg)(W=>this.sendResponse({id:P,data:W,type:204}));this.activeRequests.set(a.id,M)}disposeActiveRequest(a){const S=this.activeRequests.get(a.id);S&&(S.dispose(),this.activeRequests.delete(a.id))}collectPendingRequest(a){let S=this.pendingRequests.get(a.channelName);S||(S=[],this.pendingRequests.set(a.channelName,S));const P=setTimeout(()=>{console.error(`Unknown channel: ${a.channelName}`),a.type===100&&this.sendResponse({id:a.id,data:{name:"Unknown channel",message:`Channel name '${a.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);S.push({request:a,timeoutTimer:P})}flushPendingRequests(a){const S=this.pendingRequests.get(a);if(S){for(const P of S)switch(clearTimeout(P.timeoutTimer),P.request.type){case 100:this.onPromise(P.request);break;case 102:this.onEventListen(P.request);break}this.pendingRequests.delete(a)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(a=>a.dispose()),this.activeRequests.clear()}}t.ChannelServer=E;var U;(function(g){g[g.LocalSide=0]="LocalSide",g[g.OtherSide=1]="OtherSide"})(U=t.RequestInitiator||(t.RequestInitiator={}));class A{constructor(a,S=null){this.protocol=a,this.isDisposed=!1,this.state=R.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(P=>this.onBuffer(P)),this.logger=S}getChannel(a){const S=this;return{call(P,N,M){return S.isDisposed?Promise.reject(T.canceled()):S.requestPromise(a,P,N,M)},listen(P,N){return S.isDisposed?Promise.reject(T.canceled()):S.requestEvent(a,P,N)}}}requestPromise(a,S,P,N=L.CancellationToken.None){const M=this.lastRequestId++,B={id:M,type:100,channelName:a,name:S,arg:P};if(N.isCancellationRequested)return Promise.reject(T.canceled());let $;return new Promise((Y,ee)=>{if(N.isCancellationRequested)return ee(T.canceled());const re=()=>{const Fe=Oe=>{switch(Oe.type){case 201:this.handlers.delete(M),Y(Oe.data);break;case 202:this.handlers.delete(M);const Se=new Error(Oe.data.message);Se.stack=Oe.data.stack,Se.name=Oe.data.name,ee(Se);break;case 203:this.handlers.delete(M),ee(Oe.data);break}};this.handlers.set(M,Fe),this.sendRequest(B)};let ce=null;this.state===R.Idle?re():(ce=(0,b.createCancelablePromise)(Fe=>this.whenInitialized()),ce.then(()=>{ce=null,re()}));const ge=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:M,type:101}),ee(T.canceled())},Pe=N.onCancellationRequested(ge);$=(0,F.combinedDisposable)((0,F.toDisposable)(ge),Pe),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(a,S,P){const N=this.lastRequestId++,W={id:N,type:102,channelName:a,name:S,arg:P};let B=null;const $=new d.Emitter({onFirstListenerAdd:()=>{B=(0,b.createCancelablePromise)(Y=>this.whenInitialized()),B.then(()=>{B=null,this.activeRequests.add($),this.sendRequest(W)})},onLastListenerRemove:()=>{B?(B.cancel(),B=null):(this.activeRequests.delete($),this.sendRequest({id:N,type:103}))}}),X=Y=>$.fire(Y.data);return this.handlers.set(N,X),$.event}sendRequest(a){switch(a.type){case 100:case 102:{const S=this.send([a.type,a.id,a.channelName,a.name],a.arg);this.logger&&this.logger.logOutgoing(S,a.id,0,`${u(a.type)}: ${a.channelName}.${a.name}`,a.arg);return}case 101:case 103:{const S=this.send([a.type,a.id]);this.logger&&this.logger.logOutgoing(S,a.id,0,u(a.type));return}}}send(a,S=void 0){const P=new m;return l(P,a),l(P,S),this.sendBuffer(P.buffer)}sendBuffer(a){try{return this.protocol.send(a),a.byteLength}catch(S){return 0}}onBuffer(a){const S=new I(a),P=p(S),N=p(S),M=P[0];switch(M){case 200:return this.logger&&this.logger.logIncoming(a.byteLength,0,0,w(M)),this.onResponse({type:P[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(a.byteLength,P[1],0,w(M),N),this.onResponse({type:P[0],id:P[1],data:N})}}onResponse(a){if(a.type===200){this.state=R.Idle,this._onDidInitialize.fire();return}const S=this.handlers.get(a.id);S&&S(a)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===R.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(a=>a.dispose()),this.activeRequests.clear()}}ue([v.memoize],A.prototype,"onDidInitializePromise",null),t.ChannelClient=A;class j{constructor(a){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,a(({protocol:S,onDidClientDisconnect:P})=>{d.Event.once(S.onMessage)(M=>{const W=new I(M),B=p(W),$=new E(S,B),X=new A(S);this.channels.forEach((ee,re)=>$.registerChannel(re,ee));const Y={channelServer:$,channelClient:X,ctx:B};this._connections.add(Y),this._onDidAddConnection.fire(Y),P(()=>{$.dispose(),X.dispose(),this._connections.delete(Y),this._onDidRemoveConnection.fire(Y)})})})}get connections(){const a=[];return this._connections.forEach(S=>a.push(S)),a}getChannel(a,S){const P=this;return{call(N,M,W){let B;if((0,f.isFunction)(S)){let X=(0,c.getRandomElement)(P.connections.filter(S));B=X?Promise.resolve(X):d.Event.toPromise(d.Event.filter(P.onDidAddConnection,S))}else B=S.routeCall(P,N,M);const $=B.then(X=>X.channelClient.getChannel(a));return q($).call(N,M,W)},listen(N,M){if((0,f.isFunction)(S))return P.getMulticastEvent(a,S,N,M);const W=S.routeEvent(P,N,M).then(B=>B.channelClient.getChannel(a));return q(W).listen(N,M)}}}getMulticastEvent(a,S,P,N){const M=this;let W=new F.DisposableStore;const B=new d.Emitter({onFirstListenerAdd:()=>{W=new F.DisposableStore;const $=new d.EventMultiplexer,X=new Map,Y=re=>{const ge=re.channelClient.getChannel(a).listen(P,N),Pe=$.add(ge);X.set(re,Pe)},ee=re=>{const ce=X.get(re);!ce||(ce.dispose(),X.delete(re))};M.connections.filter(S).forEach(Y),d.Event.filter(M.onDidAddConnection,S)(Y,void 0,W),M.onDidRemoveConnection(ee,void 0,W),$.event(B.fire,B,W),W.add($)},onLastListenerRemove:()=>{W.dispose()}});return B.event}registerChannel(a,S){this.channels.set(a,S),this._connections.forEach(P=>{P.channelServer.registerChannel(a,S)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=j;class V{constructor(a,S,P=null){const N=new m;l(N,S),a.send(N.buffer),this.channelClient=new A(a,P),this.channelServer=new E(a,S,P)}getChannel(a){return this.channelClient.getChannel(a)}registerChannel(a,S){this.channelServer.registerChannel(a,S)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=V;function q(g){return{call(a,S,P){return g.then(N=>N.call(a,S,P))},listen(a,S){const P=new d.Relay;return g.then(N=>P.input=N.listen(a,S)),P.event}}}t.getDelayedChannel=q;function J(g){let a=!1;return{call(S,P,N){return a?g.call(S,P,N):(0,b.timeout)(0).then(()=>a=!0).then(()=>g.call(S,P,N))},listen(S,P){if(a)return g.listen(S,P);const N=new d.Relay;return(0,b.timeout)(0).then(()=>a=!0).then(()=>N.input=g.listen(S,P)),N.event}}}t.getNextTickChannel=J;class ie{constructor(a){this.fn=a}routeCall(a){return this.route(a)}routeEvent(a){return this.route(a)}async route(a){for(const S of a.connections)if(await Promise.resolve(this.fn(S.ctx)))return Promise.resolve(S);return await d.Event.toPromise(a.onDidAddConnection),await this.route(a)}}t.StaticRouter=ie;var ne;(function(g){function a(N,M){const W=N,B=M&&M.disableMarshalling,$=new Map;for(const X in W)P(X)&&$.set(X,d.Event.buffer(W[X],!0));return new class{listen(X,Y){const ee=$.get(Y);if(ee)return ee;throw new Error(`Event not found: ${Y}`)}call(X,Y,ee){const re=W[Y];if(typeof re=="function"){if(!B&&Array.isArray(ee))for(let ce=0;ce<ee.length;ce++)ee[ce]=(0,C.revive)(ee[ce]);return re.apply(W,ee)}throw new Error(`Method not found: ${Y}`)}}}g.fromService=a;function S(N,M){const W=M&&M.disableMarshalling;return new Proxy({},{get(B,$){var X;if(typeof $=="string")return((X=M==null?void 0:M.properties)===null||X===void 0?void 0:X.has($))?M.properties.get($):P($)?N.listen($):async function(...Y){let ee;M&&!(0,f.isUndefinedOrNull)(M.context)?ee=[M.context,...Y]:ee=Y;const re=await N.call($,ee);return W?re:(0,C.revive)(re)};throw new Error(`Property not found: ${String($)}`)}})}g.toService=S;function P(N){return N[0]==="o"&&N[1]==="n"&&y.isUpperAsciiLetter(N.charCodeAt(2))}})(ne=t.ProxyChannel||(t.ProxyChannel={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ae(g){if(Array.isArray(g))return g;if(g&&typeof g=="object"&&typeof g.toString=="function"){let a=g.toString();if(a!=="[object Object]")return a}return g}function x(g){return Array.isArray(g)?g.map(ae):ae(g)}function G(g,a,S,P,N,M,W){W=x(W);const B=te[N],$=B[P%B.length];let X=[`%c[${g}]%c[${String(a).padStart(7," ")}]%c[len: ${String(S).padStart(5," ")}]%c${String(P).padStart(5," ")} - ${M}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(M)?(X=X.concat(W),X.push(")")):X.push(W),console.log.apply(console,X)}t.logWithColors=G;class k{constructor(a,S){this._outgoingPrefix=a,this._incomingPrefix=S,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(a,S,P,N,M){this._totalOutgoing+=a,G(this._outgoingPrefix,this._totalOutgoing,a,S,P,N,M)}logIncoming(a,S,P,N,M){this._totalIncoming+=a,G(this._incomingPrefix,this._totalIncoming,a,S,P,N,M)}}t.IPCLogger=k}),define(Q[66],Z([0,1,2,10,4,12]),function(_,t,d,F,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var T;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=t.StorageHint||(t.StorageHint={}));var D;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(D||(D={}));class c extends d.Disposable{constructor(y,v=Object.create(null)){super();this.database=y,this.options=v,this._onDidChangeStorage=this._register(new F.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=D.None,this.cache=new Map,this.flushDelayer=new b.ThrottledDelayer(c.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){var v,O;(v=y.changed)===null||v===void 0||v.forEach((u,h)=>this.accept(h,u)),(O=y.deleted)===null||O===void 0||O.forEach(u=>this.accept(u,void 0))}accept(y,v){if(this.state===D.Closed)return;let O=!1;(0,L.isUndefinedOrNull)(v)?O=this.cache.delete(y):this.cache.get(y)!==v&&(this.cache.set(y,v),O=!0),O&&this._onDidChangeStorage.fire(y)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===D.None&&(this.state=D.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,v){const O=this.cache.get(y);return(0,L.isUndefinedOrNull)(O)?v:O}getBoolean(y,v){const O=this.get(y);return(0,L.isUndefinedOrNull)(O)?v:O==="true"}getNumber(y,v){const O=this.get(y);return(0,L.isUndefinedOrNull)(O)?v:parseInt(O,10)}async set(y,v){if(this.state===D.Closed)return;if((0,L.isUndefinedOrNull)(v))return this.delete(y);const O=String(v);if(this.cache.get(y)!==O)return this.cache.set(y,O),this.pendingInserts.set(y,O),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async delete(y){if(!(this.state===D.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=D.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(y){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{var v;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(v=this.whenFlushedCallbacks.pop())===null||v===void 0||v()})}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}t.Storage=c,c.DEFAULT_FLUSH_DELAY=100;class f{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert&&y.insert.forEach((v,O)=>this.items.set(O,v)),y.delete&&y.delete.forEach(v=>this.items.delete(v))}async close(){}}t.InMemoryStorageDatabase=f}),define(Q[67],Z([5,6]),function(_,t){return _.create("vs/base/common/date",t)}),define(Q[68],Z([0,1,67]),function(_,t,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const F=60,b=F*60,L=b*24,T=L*7,D=L*30,c=L*365;function f(y,v){typeof y!="number"&&(y=y.getTime());const O=Math.round((new Date().getTime()-y)/1e3);if(O<-30)return(0,d.localize)(0,null,f(new Date().getTime()+O*1e3,!1));if(O<30)return(0,d.localize)(1,null);let u;return O<F?(u=O,v?u===1?(0,d.localize)(2,null,u):(0,d.localize)(3,null,u):u===1?(0,d.localize)(4,null,u):(0,d.localize)(5,null,u)):O<b?(u=Math.floor(O/F),v?u===1?(0,d.localize)(6,null,u):(0,d.localize)(7,null,u):u===1?(0,d.localize)(8,null,u):(0,d.localize)(9,null,u)):O<L?(u=Math.floor(O/b),v?u===1?(0,d.localize)(10,null,u):(0,d.localize)(11,null,u):u===1?(0,d.localize)(12,null,u):(0,d.localize)(13,null,u)):O<T?(u=Math.floor(O/L),v?u===1?(0,d.localize)(14,null,u):(0,d.localize)(15,null,u):u===1?(0,d.localize)(16,null,u):(0,d.localize)(17,null,u)):O<D?(u=Math.floor(O/T),v?u===1?(0,d.localize)(18,null,u):(0,d.localize)(19,null,u):u===1?(0,d.localize)(20,null,u):(0,d.localize)(21,null,u)):O<c?(u=Math.floor(O/D),v?u===1?(0,d.localize)(22,null,u):(0,d.localize)(23,null,u):u===1?(0,d.localize)(24,null,u):(0,d.localize)(25,null,u)):(u=Math.floor(O/c),v?u===1?(0,d.localize)(26,null,u):(0,d.localize)(27,null,u):u===1?(0,d.localize)(28,null,u):(0,d.localize)(29,null,u))}t.fromNow=f;function C(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=C}),define(Q[69],Z([5,6]),function(_,t){return _.create("vs/base/common/errorMessage",t)}),define(Q[28],Z([0,1,69,12,22]),function(_,t,d,F,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function L(f,C){return C&&(f.stack||f.stacktrace)?d.localize(0,null,D(f),T(f.stack)||T(f.stacktrace)):D(f)}function T(f){return Array.isArray(f)?f.join(`
`):f}function D(f){return typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?d.localize(1,null,f.message):f.message||d.localize(2,null)}function c(f=null,C=!1){if(!f)return d.localize(3,null);if(Array.isArray(f)){const y=b.coalesce(f),v=c(y[0],C);return y.length>1?d.localize(4,null,v,y.length):v}if(F.isString(f))return f;if(f.detail){const y=f.detail;if(y.error)return L(y.error,C);if(y.exception)return L(y.exception,C)}return f.stack?L(f,C):f.message?f.message:d.localize(5,null)}t.toErrorMessage=c}),define(Q[70],Z([5,6]),function(_,t){return _.create("vs/base/node/processes",t)}),define(Q[47],Z([0,1,3,9,33,70,34,12,20,36,14,46,8]),function(_,t,d,F,b,L,T,D,c,f,C,y,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function O(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(o,r){if(C.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};r&&(e.cwd=r);const i=b.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],e);return new Promise(n=>{i.once("error",s=>{n({success:!1,error:s})}),i.once("exit",(s,l)=>{n(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?O(e.status):1})}else if(C.isLinux||C.isMacintosh)try{const e=v.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",_).fsPath;return new Promise(i=>{b.execFile(e,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,s,l)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function h(o=T.env){return o.comspec||"cmd.exe"}t.getWindowsShell=h;class w{constructor(r,e,i,n){if(e!==void 0&&i!==void 0&&n!==void 0)this.cmd=r,this.args=e,this.shell=i,this.options=n;else{const s=r;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(T.env).forEach(l=>{s[l]=T.env[l]}),Object.keys(this.options.env).forEach(l=>{s[l]=this.options.env[l]}),this.options.env=s}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const e=r.lastIndexOf(d.sep);return e!==-1&&(r=r.substring(e+1)),w.WellKnowCommands[r]?r:"other"}start(r){return C.isWindows&&(this.options&&this.options.cwd&&f.isUNC(this.options.cwd)||!this.options&&f.isUNC(T.cwd()))?Promise.reject(new Error(L.localize(0,null))):this.useExec().then(e=>{let i,n;const s=new Promise((l,p)=>{i=l,n=p});if(e){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=b.exec(l,this.options,(p,E,U)=>{this.childProcess=null;const A=p;A&&A.killed?n({killed:this.terminateRequested,stdout:E.toString(),stderr:U.toString()}):this.handleExec(i,r,p,E,U)})}else{let l=null;const p=E=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(E,i,r,n);const U={terminated:this.terminateRequested};D.isNumber(E)&&(U.cmdCode=E),i(U)};if(this.shell&&C.isWindows){const E=c.deepClone(this.options);E.windowsVerbatimArguments=!0,E.detached=!1;let U=!1,A=!1;const j=[];let V=this.ensureQuotes(this.cmd);j.push(V.value),U=V.quoted,this.args&&this.args.forEach(J=>{V=this.ensureQuotes(J),j.push(V.value),A=A&&V.quoted});const q=["/s","/c"];U?A?q.push('"'+j.join(" ")+'"'):j.length>1?q.push('"'+j[0]+'" '+j.slice(1).join(" ")):q.push('"'+j[0]+'"'):q.push(j.join(" ")),l=b.spawn(h(),q,E)}else this.cmd&&(l=b.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(D.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",E=>{this.childProcess=null,n({terminated:this.terminateRequested,error:E})}),l.pid&&(this.childProcess.on("close",p),this.handleSpawn(l,i,r,n,!0)))}return s})}handleClose(r,e,i,n){}ensureQuotes(r){return w.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,u(r,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!C.isWindows)return r(!1);const e=b.spawn(h(),["/s","/c"]);e.on("error",i=>r(!0)),e.on("exit",i=>r(!1))})}}t.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class R extends w{constructor(r,e,i,n){super(r,e,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,e,i,n,s){[n,s].forEach((l,p)=>{const E=new y.LineDecoder;E.write(l).forEach(j=>{e({line:j,source:p===0?0:1})});const A=E.end();A&&e({line:A,source:p===0?0:1})}),r({terminated:this.terminateRequested,error:i})}handleSpawn(r,e,i,n,s){const l=new y.LineDecoder,p=new y.LineDecoder;r.stdout.on("data",E=>{l.write(E).forEach(A=>i({line:A,source:0}))}),r.stderr.on("data",E=>{p.write(E).forEach(A=>i({line:A,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=p}handleClose(r,e,i,n){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&i({line:s,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&i({line:l,source:1})}}t.LineProcess=R;function I(o){let r=[],e=!1;const i=function(n){if(e){r.push(n);return}(!o.send(n,l=>{if(l&&console.error(l),e=!1,r.length>0){const p=r.slice(0);r=[],p.forEach(E=>i(E))}})||C.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=I;var m;(function(o){async function r(e,i,n){if(d.isAbsolute(e))return e;if(i===void 0&&(i=T.cwd()),d.dirname(e)!=="."||(n===void 0&&D.isString(T.env.PATH)&&(n=T.env.PATH.split(d.delimiter)),n===void 0||n.length===0))return d.join(i,e);async function l(p){return await F.exists(p)?!(await F.Promises.stat(p)).isDirectory():!1}for(let p of n){let E;if(d.isAbsolute(p)?E=d.join(p,e):E=d.join(i,p,e),await l(E))return E;let U=E+".com";if(await l(U)||(U=E+".exe",await l(U)))return U}return d.join(i,e)}o.findExecutable=r})(m=t.win32||(t.win32={}))}),define(Q[71],Z([0,1,32,14,64,47]),function(_,t,d,F,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function T(O,u){return O===1?F.isWindows?y():L.getWindowsShell(u):f(O,u)}t.getSystemShell=T;function D(O,u){return O===1?F.isWindows?v(u):L.getWindowsShell(u):f(O,u)}t.getSystemShellSync=D;let c=null;function f(O,u){if(F.isLinux&&O===2||F.isMacintosh&&O===3)return"/bin/bash";if(!c){let h;if(F.isWindows)h="/bin/bash";else{if(h=u.SHELL,!h)try{h=(0,d.userInfo)().shell}catch(w){}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}c=h}return c}let C=null;async function y(){return C||(C=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),C}function v(O){if(C)return C;const u=F.isWindows&&parseFloat((0,d.release)())>=10,h=O.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${O.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?w:L.getWindowsShell(O)}}),define(Q[48],Z([0,1,33,2,4,20,10,47,37,59,27,13,16,14]),function(_,t,d,F,b,L,T,D,c,f,C,y,v,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class u extends c.ChannelServer{constructor(R){super({send:I=>{try{process.send&&process.send(I.buffer.toString("base64"))}catch(m){}},onMessage:T.Event.fromNodeEventEmitter(process,"message",I=>v.VSBuffer.wrap(Buffer.from(I,"base64")))},R);process.once("disconnect",()=>this.dispose())}}t.Server=u;class h{constructor(R,I){this.modulePath=R,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new T.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new b.Delayer(m),this.child=null,this._client=null}getChannel(R){const I=this;return{call(m,o,r){return I.requestPromise(R,m,o,r)},listen(m,o){return I.requestEvent(R,m,o)}}}requestPromise(R,I,m,o=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(R),e=(0,b.createCancelablePromise)(s=>r.call(I,m,s)),i=o.onCancellationRequested(()=>e.cancel()),n=(0,F.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(R,I,m){if(!this.disposeDelayer)return T.Event.None;this.disposeDelayer.cancel();let o;const r=new T.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(R).listen(I,m)(r.fire,r),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const R=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env=Object.assign(Object.assign({},(0,L.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(I.env=Object.assign(Object.assign({},I.env),this.options.env)),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),O.isMacintosh&&I.env&&delete I.env.DYLD_LIBRARY_PATH,this.child=(0,d.fork)(this.modulePath,R,I);const m=new T.Emitter;T.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,f.isRemoteConsoleLog)(l)){(0,f.log)(l,`IPC Library: ${this.options.serverName}`);return}m.fire(v.VSBuffer.wrap(Buffer.from(l,"base64")))});const r=this.options.useQueue?(0,D.createQueuedSender)(this.child):this.child,e=l=>this.child&&this.child.connected&&r.send(l.buffer.toString("base64")),i=m.event,n={send:e,onMessage:i};this._client=new c.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,p)=>{process.removeListener("exit",s),this.activeRequests.forEach(E=>(0,F.dispose)(E)),this.activeRequests.clear(),l!==0&&p!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+p),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:p})})}return this._client}getCachedChannel(R){let I=this.channels.get(R);return I||(I=this.client.getChannel(R),this.channels.set(R,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=h}),define(Q[72],Z([5,6]),function(_,t){return _.create("vs/base/node/zip",t)}),define(Q[73],Z([5,6]),function(_,t){return _.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[74],Z([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[75],Z([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Q[76],Z([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[77],Z([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[78],Z([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Q[79],Z([5,6]),function(_,t){return _.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[80],Z([5,6]),function(_,t){return _.create("vs/platform/files/common/fileService",t)}),define(Q[81],Z([5,6]),function(_,t){return _.create("vs/platform/files/common/io",t)}),define(Q[82],Z([5,6]),function(_,t){return _.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[83],Z([5,6]),function(_,t){return _.create("vs/platform/request/common/request",t)}),define(Q[84],Z([5,6]),function(_,t){return _.create("vs/platform/telemetry/common/telemetryService",t)}),define(Q[85],Z([0,1,3,17,44,68,8,7,34]),function(_,t,d,F,b,L,T,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class f{constructor(u,h,w){this._args=u,this.paths=h,this.productService=w}get appRoot(){return(0,d.dirname)(T.FileAccess.asFileUri("",_).fsPath)}get userHome(){return D.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return D.URI.file((0,d.join)(this.userDataPath,"User"))}get tmpDir(){return D.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,F.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,F.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const u=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,d.join)(this.userDataPath,"logs",u)}return this.args.logsPath}get userDataSyncLogResource(){return D.URI.file((0,d.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,F.joinPath)(D.URI.file((0,d.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return D.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return D.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,F.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,F.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=c.env.VSCODE_PORTABLE;return u?D.URI.file((0,d.join)(u,"argv.json")):(0,F.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,F.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return D.URI.file((0,d.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,d.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,d.resolve)(u):(0,d.normalize)((0,d.join)(T.FileAccess.asFileUri("",_).fsPath,"..","extensions"))}get extensionsDownloadPath(){const u=this.args["extensions-download-dir"];return u?(0,d.resolve)(u):(0,d.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,d.resolve)(u);const h=c.env.VSCODE_EXTENSIONS;if(h)return h;const w=c.env.VSCODE_PORTABLE;return w?(0,d.join)(w,"extensions"):(0,F.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(h=>/^[^:/?#]+?:\/\//.test(h)?D.URI.parse(h):D.URI.file((0,d.normalize)(h)))}get extensionDevelopmentKind(){var u;return(u=this.args.extensionDevelopmentKind)===null||u===void 0?void 0:u.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?D.URI.parse(u):D.URI.file((0,d.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!c.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,F.joinPath)(D.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return D.URI.file((0,d.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ue([b.memoize],f.prototype,"appRoot",null),ue([b.memoize],f.prototype,"userHome",null),ue([b.memoize],f.prototype,"userDataPath",null),ue([b.memoize],f.prototype,"appSettingsHome",null),ue([b.memoize],f.prototype,"tmpDir",null),ue([b.memoize],f.prototype,"userRoamingDataHome",null),ue([b.memoize],f.prototype,"settingsResource",null),ue([b.memoize],f.prototype,"userDataSyncHome",null),ue([b.memoize],f.prototype,"userDataSyncLogResource",null),ue([b.memoize],f.prototype,"sync",null),ue([b.memoize],f.prototype,"machineSettingsResource",null),ue([b.memoize],f.prototype,"globalStorageHome",null),ue([b.memoize],f.prototype,"workspaceStorageHome",null),ue([b.memoize],f.prototype,"keybindingsResource",null),ue([b.memoize],f.prototype,"keyboardLayoutResource",null),ue([b.memoize],f.prototype,"argvResource",null),ue([b.memoize],f.prototype,"snippetsHome",null),ue([b.memoize],f.prototype,"isExtensionDevelopment",null),ue([b.memoize],f.prototype,"untitledWorkspacesHome",null),ue([b.memoize],f.prototype,"installSourcePath",null),ue([b.memoize],f.prototype,"builtinExtensionsPath",null),ue([b.memoize],f.prototype,"extensionsPath",null),ue([b.memoize],f.prototype,"extensionDevelopmentLocationURI",null),ue([b.memoize],f.prototype,"extensionDevelopmentKind",null),ue([b.memoize],f.prototype,"extensionTestsLocationURI",null),ue([b.memoize],f.prototype,"debugExtensionHost",null),ue([b.memoize],f.prototype,"serviceMachineIdResource",null),ue([b.memoize],f.prototype,"telemetryLogResource",null),t.AbstractNativeEnvironmentService=f;function C(O,u){return v(O["inspect-extensions"],O["inspect-brk-extensions"],5870,u,O.debugId)}t.parseExtensionHostPort=C;function y(O,u){return v(O["inspect-search"],O["inspect-brk-search"],5876,u)}t.parseSearchPort=y;function v(O,u,h,w,R){const m=Number(u||O)||(w?null:h),o=m?Boolean(!!u):!1;return{port:m,break:o,debugId:R}}}),function(){"use strict";function _(t,d,F,b){function L(D){const c=T(D),f=[c];return t.isAbsolute(c)||f.unshift(b),t.resolve(...f)}function T(D){const c=process.env.VSCODE_PORTABLE;if(c)return t.join(c,"user-data");const f=D["user-data-dir"];if(f)return f;let C=process.env.VSCODE_APPDATA;if(!C)switch(process.platform){case"win32":if(C=process.env.APPDATA,!C){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");C=t.join(y,"AppData","Roaming")}break;case"darwin":C=t.join(d.homedir(),"Library","Application Support");break;case"linux":C=process.env.XDG_CONFIG_HOME||t.join(d.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(C,F)}return{getUserDataPath:L}}if(typeof define=="function")define(Q[86],Z([0,87,32,8,17,34]),function(t,d,F,b,L,T){const D=L.dirname(b.FileAccess.asFileUri("",t)),c=t.__$__nodeRequire(L.joinPath(D,"package.json").fsPath);return _(d,F,c.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),d=require("path"),F=require("os");module.exports=_(d,F,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[88],Z([0,1,32,86,85]),function(_,t,d,F,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class L extends b.AbstractNativeEnvironmentService{constructor(D,c){super(D,{homeDir:(0,d.homedir)(),tmpDir:(0,d.tmpdir)(),userDataDir:(0,F.getUserDataPath)(D)},c)}}t.NativeEnvironmentService=L}),define(Q[89],Z([0,1,20]),function(_,t,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const F=/^%([\w\d.-]+)%$/i;function b(L,T){const D=c=>{if(typeof c!="string")return;const f=F.exec(c);if(!!f)return T[f[1]]||c};return(0,d.cloneAndChange)(L,D)}t.localizeManifest=b}),define(Q[49],Z([0,1,79]),function(_,t,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function L(v){return v=v.trim(),v==="*"||F.test(v)}t.isValidVersionStr=L;function T(v){if(!L(v))return null;if(v=v.trim(),v==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let O=v.match(F);return O?{hasCaret:O[1]==="^",hasGreaterEquals:O[1]===">=",majorBase:O[2]==="x"?0:parseInt(O[2],10),majorMustEqual:O[2]!=="x",minorBase:O[4]==="x"?0:parseInt(O[4],10),minorMustEqual:O[4]!=="x",patchBase:O[6]==="x"?0:parseInt(O[6],10),patchMustEqual:O[6]!=="x",preRelease:O[8]||null}:null}t.parseVersion=T;function D(v){if(!v)return null;let O=v.majorBase,u=v.majorMustEqual,h=v.minorBase,w=v.minorMustEqual,R=v.patchBase,I=v.patchMustEqual;v.hasCaret&&(O===0||(w=!1),I=!1);let m=0;if(v.preRelease){const o=b.exec(v.preRelease);if(o){const[,r,e,i]=o;m=Date.UTC(Number(r),Number(e)-1,Number(i))}}return{majorBase:O,majorMustEqual:u,minorBase:h,minorMustEqual:w,patchBase:R,patchMustEqual:I,isMinimum:v.hasGreaterEquals,notBefore:m}}t.normalizeVersion=D;function c(v,O,u){let h;typeof v=="string"?h=D(T(v)):h=v;let w;O instanceof Date?w=O.getTime():typeof O=="string"&&(w=new Date(O).getTime());let R;if(typeof u=="string"?R=D(T(u)):R=u,!h||!R)return!1;let I=h.majorBase,m=h.minorBase,o=h.patchBase,r=R.majorBase,e=R.minorBase,i=R.patchBase,n=R.notBefore,s=R.majorMustEqual,l=R.minorMustEqual,p=R.patchMustEqual;return R.isMinimum?I>r?!0:I<r?!1:m>e?!0:m<e||w&&w<n?!1:o>=i:(I===1&&r===0&&(!s||!l||!p)&&(r=1,e=0,i=0,s=!0,l=!1,p=!1),I<r?!1:I>r?!s:m<e?!1:m>e?!l:o<i?!1:o>i?!p:!(w&&w<n))}t.isValidVersion=c;function f(v,O,u,h){return u.isBuiltin||typeof u.main=="undefined"?!0:y(v,O,u.engines.vscode,h)}t.isValidExtensionVersion=f;function C(v,O,u){return v==="*"||y(O,u,v)}t.isEngineValid=C;function y(v,O,u,h=[]){let w=D(T(u));if(!w)return h.push(d.localize(0,null,u)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return h.push(d.localize(1,null,u)),!1}else if(!w.majorMustEqual)return h.push(d.localize(2,null,u)),!1;return c(v,O,w)?!0:(h.push(d.localize(3,null,v,u)),!1)}}),define(Q[90],Z([0,1,37,48,2,8]),function(_,t,d,F,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends b.Disposable{constructor(c,f,C,y){super();this.folders=c,this.onDidFilesChange=f,this.onLogMessage=C,this.verboseLogging=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new F.Client(L.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=d.ProxyChannel.toService((0,d.getNextTickChannel)(c.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f))),this.setFolders(this.folders)}setVerboseLogging(c){this.verboseLogging=c,!this.isDisposed&&this.service&&this.service.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${c}`})}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(Q[91],Z([0,1,37,48,2,8]),function(_,t,d,F,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends b.Disposable{constructor(c,f,C,y,v={}){super();this.folders=c,this.onDidFilesChange=f,this.onLogMessage=C,this.verboseLogging=y,this.watcherOptions=v,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new F.Client(L.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=d.ProxyChannel.toService((0,d.getNextTickChannel)(c.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f))),this.service.setRoots(this.folders)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${c}`})}setVerboseLogging(c){this.verboseLogging=c,this.service&&this.service.setVerboseLogging(c)}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(Q[92],Z([0,1,33,46,61,8]),function(_,t,d,F,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class T{constructor(c,f,C,y,v){this.watchedFolder=c,this.eventCallback=C,this.logCallback=y,this.verboseLogging=v,this.restartCounter=0,Array.isArray(f)?this.ignored=f.map(O=>b.parse(O)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${c}`),this.startWatcher()}startWatcher(){const c=[this.watchedFolder];this.verboseLogging&&c.push("-verbose"),this.handle=d.spawn(L.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",_).fsPath,c);const f=new F.LineDecoder;this.handle.stdout.on("data",C=>{const y=[];f.write(C).forEach(v=>{const O=v.split("|");if(O.length===2){const u=Number(O[0]),h=O[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(w=>w(h))){this.verboseLogging&&this.log(h);return}y.push({type:T.changeTypeMap[u],path:h})}else this.log(O[1])}}),y.length>0&&this.eventCallback(y)}),this.handle.on("error",C=>this.onError(C)),this.handle.stderr.on("data",C=>this.onError(C)),this.handle.on("exit",(C,y)=>this.onExit(C,y))}onError(c){this.error("process error: "+c.toString())}onExit(c,f){this.handle&&(this.error(`terminated unexpectedly (code: ${c}, signal: ${f})`),this.restartCounter<=T.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(c){this.logCallback({type:"error",message:`[File Watcher (C#)] ${c}`})}log(c){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${c}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=T,T.MAX_RESTARTS=5,T.changeTypeMap=[0,1,2]}),define(Q[93],Z([0,1,92,3,19]),function(_,t,d,F,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class L{constructor(D,c,f,C){this.onDidFilesChange=c,this.onLogMessage=f,this.verboseLogging=C,this.service=void 0,this.folder=D[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(F.posix.sep)&&(this.folder.path=(0,b.rtrim)(this.folder.path,F.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new d.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,D=>this.onFileEvents(D),D=>this.onLogMessage(D),this.verboseLogging)}setVerboseLogging(D){this.verboseLogging=D,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(D){this.isDisposed||D.length>0&&this.onDidFilesChange(D)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=L}),define(Q[50],Z([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class d{constructor(L,T=[],D=!1){this.ctor=L,this.staticArguments=T,this.supportsDelayedInstantiation=D}}t.SyncDescriptor=d;const F=(b,...L)=>new d(b,L);t.createSyncDescriptor=F}),define(Q[94],Z([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class d{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}t.Node=d;class F{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let T of this._nodes.values())T.outgoing.size===0&&L.push(T);return L}insertEdge(L,T){const D=this.lookupOrInsertNode(L),c=this.lookupOrInsertNode(T);D.outgoing.set(this._hashFn(T),c),c.incoming.set(this._hashFn(L),D)}removeNode(L){const T=this._hashFn(L);this._nodes.delete(T);for(let D of this._nodes.values())D.outgoing.delete(T),D.incoming.delete(T)}lookupOrInsertNode(L){const T=this._hashFn(L);let D=this._nodes.get(T);return D||(D=new d(L),this._nodes.set(T,D)),D}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[T,D]of this._nodes)L.push(`${T}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,T]of this._nodes){const D=new Set([L]),c=this._findCycle(T,D);if(c)return c}}_findCycle(L,T){for(let[D,c]of L.outgoing){if(T.has(D))return[...T,D].join(" -> ");T.add(D);const f=this._findCycle(c,T);if(f)return f;T.delete(D)}}}t.Graph=F}),define(Q[95],Z([0,1,11]),function(_,t,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,d.createDecorator)("downloadService")}),define(Q[21],Z([0,1,11]),function(_,t,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,d.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,d.refineServiceDecorator)(t.IEnvironmentService)}),define(Q[23],Z([0,1,74,11,8]),function(_,t,d,F,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN);function L(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}t.isIExtensionIdentifier=L;var T;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=5]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(T=t.SortBy||(t.SortBy={}));var D;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(D=t.SortOrder||(t.SortOrder={}));var c;(function(y){y.Uninstall="uninstall"})(c=t.StatisticType||(t.StatisticType={}));var f;(function(y){y[y.None=0]="None",y[y.Install=1]="Install",y[y.Update=2]="Update"})(f=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,F.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class C extends Error{constructor(v,O){super(v);this.code=O}}t.ExtensionManagementError=C,t.IExtensionManagementService=(0,F.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,F.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,F.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=b.FileAccess.asBrowserUri("./media/defaultIcon.png",_).toString(!0),t.ExtensionsLabel=(0,d.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,d.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,F.createDecorator)("IExtensionManagementCLIService")}),define(Q[38],Z([0,1,19,11]),function(_,t,d,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkpaceSupportTypeMessage=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function b(C){if(typeof C=="object"&&C!==null&&C.supported!==!0)return C.description}t.getWorkpaceSupportTypeMessage=b;function L(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}t.isIExtensionIdentifier=L,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(C){C[C.System=0]="System",C[C.User=1]="User"})(T=t.ExtensionType||(t.ExtensionType={}));class D{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,v){if(typeof y=="undefined"||y===null)return typeof v=="undefined"||v===null;if(typeof v=="undefined"||v===null)return!1;if(typeof y=="string"||typeof v=="string"){let O=typeof y=="string"?y:y.value,u=typeof v=="string"?v:v.value;return d.equalsIgnoreCase(O,u)}return y._lower===v._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}t.ExtensionIdentifier=D;function c(C){return C.contributes&&C.contributes.localizations?C.contributes.localizations.length>0:!1}t.isLanguagePackExtension=c;function f(C){return C.contributes&&C.contributes.authentication?C.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=f,t.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[24],Z([0,1,19,38]),function(_,t,d,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function b(O,u){return O.uuid&&u.uuid?O.uuid===u.uuid:O.id===u.id?!0:(0,d.compareIgnoreCase)(O.id,u.id)===0}t.areSameExtensions=b;class L{constructor(u,h){this.version=h,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof L?b(this,u)&&this.version===u.version:!1}}t.ExtensionIdentifierWithVersion=L;function T(O,u){return`${O}.${u}`}t.getExtensionId=T;function D(O){return O.toLocaleLowerCase()}t.adoptToGalleryExtensionId=D;function c(O,u){return D(T(O,u))}t.getGalleryExtensionId=c;function f(O,u){const h=[],w=R=>{for(const I of h)if(I.some(m=>b(u(m),u(R))))return I;return null};for(const R of O){const I=w(R);I?I.push(R):h.push([R])}return h}t.groupByExtension=f;function C(O){return{id:O.identifier.id,name:O.manifest.name,galleryId:null,publisherId:O.publisherId,publisherName:O.manifest.publisher,publisherDisplayName:O.publisherDisplayName,dependencies:O.manifest.extensionDependencies&&O.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=C;function y(O){return Object.assign({id:O.identifier.id,name:O.name,galleryId:O.identifier.uuid,publisherId:O.publisherId,publisherName:O.publisher,publisherDisplayName:O.publisherDisplayName,dependencies:!!(O.properties.dependencies&&O.properties.dependencies.length>0)},O.telemetryData)}t.getGalleryExtensionTelemetryData=y,t.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function v(O){const u=new Set;for(const h of O)h.malicious&&u.add(h.id.id);return u}t.getMaliciousExtensionsSet=v});var fe=this&&this.__param||function(_,t){return function(d,F){t(d,F,_)}};define(Q[96],Z([0,1,75,13,7,39,23,24,38,62,27,8]),function(_,t,d,F,b,L,T,D,c,f,C,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const v=I=>(0,d.localize)(0,null,I),O=(0,d.localize)(1,null,"ms-dotnettools.csharp");function u(I,m){return m?`${I.publisher}.${I.name}@${I.version}`:`${I.publisher}.${I.name}`}const h=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function w(I){const m=h.exec(I);return m&&m[1]?[(0,D.adoptToGalleryExtensionId)(m[1]),m[2]]:[(0,D.adoptToGalleryExtensionId)(I),void 0]}t.getIdAndVersion=w;let R=class{constructor(m,o){this.extensionManagementService=m,this.extensionGalleryService=o}get location(){}async listExtensions(m,o,r=console){let e=await this.extensionManagementService.getInstalled(1);const i=c.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(o&&o!==""){if(i.indexOf(o.toLowerCase())<0){r.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(s=>s.manifest.categories?s.manifest.categories.map(p=>p.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){r.log("Possible Categories: "),i.forEach(s=>{r.log(s)});return}this.location&&r.log((0,d.localize)(2,null,this.location)),e=e.sort((s,l)=>s.identifier.id.localeCompare(l.identifier.id));let n;for(let s of e)n!==s.identifier.id&&(n=s.identifier.id,r.log(u(s.manifest,m)))}async installExtensions(m,o,r,e,i=console){const n=[],s=[];m.length&&i.log(this.location?(0,d.localize)(3,null,this.location):(0,d.localize)(4,null));const l=await this.extensionManagementService.getInstalled(1),p=(A,j)=>{const V=l.find(q=>(0,D.areSameExtensions)(q.identifier,{id:A}));if(V){if(!j&&!e)return i.log((0,d.localize)(5,null,A,V.manifest.version,A)),!1;if(j&&V.manifest.version===j)return i.log((0,d.localize)(6,null,`${A}@${j}`)),!1}return!0},E=[],U=[];for(const A of m)if(A instanceof b.URI)E.push(A);else{const[j,V]=w(A);p(j,V)&&U.push({id:j,version:V,installOptions:{isBuiltin:!1,isMachineScoped:r}})}for(const A of o){const[j,V]=w(A);p(j,V)&&U.push({id:j,version:V,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(E.length&&await Promise.all(E.map(async A=>{try{const j=await this.installVSIX(A,{isBuiltin:!1,isMachineScoped:r},e,i);j&&s.push(j)}catch(j){i.error(j.message||j.stack||j),n.push(A.toString())}})),U.length){const A=await this.getGalleryExtensions(U);await Promise.all(U.map(async j=>{const V=A.get(j.id.toLowerCase());if(V)try{const q=await this.installFromGallery(j,V,l,e,i);q&&s.push(q)}catch(q){i.error(q.message||q.stack||q),n.push(j.id)}else i.error(`${v(j.version?`${j.id}@${j.version}`:j.id)}
${O}`),n.push(j.id)}))}if(n.length)throw new Error((0,d.localize)(7,null,n.join(", ")))}async installVSIX(m,o,r,e){const i=await this.extensionManagementService.getManifest(m);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,r,e))try{return await this.extensionManagementService.install(m,o),e.log((0,d.localize)(8,null,(0,f.getBaseLabel)(m))),i}catch(s){if((0,F.isPromiseCanceledError)(s))return e.log((0,d.localize)(9,null,(0,f.getBaseLabel)(m))),null;throw s}return null}async getGalleryExtensions(m){const o=m.filter(({version:i})=>i===void 0).map(({id:i})=>i),r=m.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(o,C.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(r.map(async({id:i,version:n})=>{const s=await this.extensionGalleryService.getCompatibleExtension({id:i},n);s&&e.set(s.identifier.id.toLowerCase(),s)}))]),e}async installFromGallery({id:m,version:o,installOptions:r},e,i,n,s){const l=await this.extensionGalleryService.getManifest(e,C.CancellationToken.None);if(l&&!this.validateExtensionKind(l,s))return null;const p=i.find(E=>(0,D.areSameExtensions)(E.identifier,e.identifier));if(p){if(e.version===p.manifest.version)return s.log((0,d.localize)(10,null,o?`${m}@${o}`:m)),null;s.log((0,d.localize)(11,null,m,e.version))}try{return r.isBuiltin?s.log((0,d.localize)(12,null,m,e.version)):s.log((0,d.localize)(13,null,m,e.version)),await this.extensionManagementService.installFromGallery(e,r),s.log((0,d.localize)(14,null,m,e.version)),l}catch(E){if((0,F.isPromiseCanceledError)(E))return s.log((0,d.localize)(15,null,m)),null;throw E}}validateExtensionKind(m,o){return!0}async validateVSIX(m,o,r){const e={id:(0,D.getGalleryExtensionId)(m.publisher,m.name)},n=(await this.extensionManagementService.getInstalled(1)).find(s=>(0,D.areSameExtensions)(e,s.identifier)&&(0,L.gt)(s.manifest.version,m.version));return n&&!o?(r.log((0,d.localize)(16,null,n.identifier.id,n.manifest.version,m.version)),!1):this.validateExtensionKind(m,r)}async uninstallExtensions(m,o,r=console){const e=async n=>{if(n instanceof b.URI){const s=await this.extensionManagementService.getManifest(n);return u(s)}return n},i=[];for(const n of m){const s=await e(n),p=(await this.extensionManagementService.getInstalled()).filter(E=>(0,D.areSameExtensions)(E.identifier,{id:s}));if(!p.length)throw new Error(`${this.notInstalled(s)}
${O}`);if(p.some(E=>E.type===0)){r.log((0,d.localize)(17,null,s));return}if(!o&&p.some(E=>E.isBuiltin)){r.log((0,d.localize)(18,null,s));return}r.log((0,d.localize)(19,null,s));for(const E of p)await this.extensionManagementService.uninstall(E),i.push(E);this.location?r.log((0,d.localize)(20,null,s,this.location)):r.log((0,d.localize)(21,null,s))}}async locateExtension(m,o=console){const r=await this.extensionManagementService.getInstalled();m.forEach(e=>{r.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===y.Schemas.file){o.log(i.location.fsPath);return}})})}notInstalled(m){return this.location?(0,d.localize)(22,null,m,this.location):(0,d.localize)(23,null,m)}};R=ue([fe(0,T.IExtensionManagementService),fe(1,T.IExtensionGalleryService)],R),t.ExtensionManagementCLIService=R}),define(Q[97],Z([0,1,2,3,38,9]),function(_,t,d,F,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class T extends d.Disposable{constructor(c,f){super();this.environmentService=c,this.extensionsManifestCache=(0,F.join)(this.environmentService.userDataPath,b.MANIFEST_CACHE_FOLDER,b.USER_MANIFEST_CACHE_FILE),this._register(f.onDidInstallExtension(C=>this.onDidInstallExtension(C))),this._register(f.onDidUninstallExtension(C=>this.onDidUnInstallExtension(C)))}onDidInstallExtension(c){c.error||this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){L.rimraf(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=T}),define(Q[98],Z([0,1,87,33,29,14,126,28,71]),function(_,t,d,F,b,L,T,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function f(v,O,u){return O["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):L.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,T.isLaunchedFromCli)(u)&&!O["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,T.isLaunchedFromCli)(u)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),C||(C=y(v)),C)}t.resolveShellEnv=f;let C;async function y(v){const O=new Promise(async(u,h)=>{const w=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",w);const R=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",R);const I=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),m=new RegExp(I+"(.*)"+I),o=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});v.trace("getUnixShellEnvironment#env",o);const r=await(0,c.getSystemShell)(L.OS,o);v.trace("getUnixShellEnvironment#shell",r);const e=d.basename(r);let i,n;/^pwsh(-preview)?$/.test(e)?(i=`& '${process.execPath}' -p '''${I}'' + JSON.stringify(process.env) + ''${I}'''`,n=["-Login","-Command"]):(i=`'${process.execPath}' -p '"${I}" + JSON.stringify(process.env) + "${I}"'`,n=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(n),i);const s=(0,F.spawn)(r,[...n,i],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});s.on("error",E=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(E)),u({})});const l=[];s.stdout.on("data",E=>l.push(E));const p=[];s.stderr.on("data",E=>p.push(E)),s.on("close",(E,U)=>{const A=Buffer.concat(l).toString("utf8");v.trace("getUnixShellEnvironment#raw",A);const j=Buffer.concat(p).toString("utf8");if(j.trim()&&v.trace("getUnixShellEnvironment#stderr",j),E||U)return h(new Error(`Failed to get environment (code ${E}, signal ${U})`));const V=m.exec(A),q=V?V[1]:"{}";try{const J=JSON.parse(q);w?J.ELECTRON_RUN_AS_NODE=w:delete J.ELECTRON_RUN_AS_NODE,R?J.ELECTRON_NO_ATTACH_CONSOLE=R:delete J.ELECTRON_NO_ATTACH_CONSOLE,delete J.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",J),u(J)}catch(J){v.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(J)),h(J)}})});try{return await O}catch(u){return v.error("getUnixShellEnvironment#error",(0,D.toErrorMessage)(u)),{}}}}),define(Q[51],Z([0,1,7,18,14]),function(_,t,d,F,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function L(c){return c.map(f=>({type:f.type,resource:d.URI.file(f.path)}))}t.toFileChanges=L;function T(c){const f=new D;for(const C of c)f.processEvent(C);return f.normalize()}t.normalizeFileChanges=T;class D{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(f){const C=this.mapPathToChange.get(f.path);if(C){const y=C.type,v=f.type;y===1&&v===2?(this.mapPathToChange.delete(f.path),this.normalized.splice(this.normalized.indexOf(C),1)):y===2&&v===1?C.type=0:y===1&&v===0||(C.type=v)}else this.normalized.push(f),this.mapPathToChange.set(f.path,f)}normalize(){const f=[],C=[];return this.normalized.filter(y=>y.type!==2?(f.push(y),!1):!0).sort((y,v)=>y.path.length-v.path.length).filter(y=>C.some(v=>(0,F.isParent)(y.path,v,!b.isLinux))?!1:(C.push(y.path),!0)).concat(f)}}}),define(Q[99],Z([0,1,51,2,9,63,65,4,3]),function(_,t,d,F,b,L,T,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class f extends F.Disposable{constructor(y,v,O,u){super();this.path=y,this.onDidFilesChange=v,this.onLogMessage=O,this.verboseLogging=u,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(y){this.verboseLogging=y}async startWatching(){try{const{stat:y,symbolicLink:v}=await b.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let O=this.path;if(v)try{O=await(0,L.realpath)(O)}catch(u){if(this.onError(u),v.dangling)return}y.isDirectory()?this._register((0,T.watchFolder)(O,(u,h)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,c.join)(this.path,(0,c.basename)(h))})},u=>this.onError(u))):this._register((0,T.watchFile)(O,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(y){y.code!=="ENOENT"&&this.onError(y)}}onFileChange(y){this.fileChangesBuffer.push(y),this.verboseLogging&&this.onVerbose(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const O=(0,d.normalizeFileChanges)(v);this.verboseLogging&&O.forEach(u=>{this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`)}),O.length>0&&this.onDidFilesChange(O)})}onError(y){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${y}`})}onVerbose(y){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=f}),define(Q[52],Z([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class d{constructor(...b){this._entries=new Map;for(let[L,T]of b)this.set(L,T)}set(b,L){const T=this._entries.get(b);return this._entries.set(b,L),T}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}t.ServiceCollection=d}),define(Q[100],Z([0,1,13,94,50,11,52,4]),function(_,t,d,F,b,L,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class f extends Error{constructor(u){var h;super("cyclic dependency between services");this.message=(h=u.findCycleSlow())!==null&&h!==void 0?h:`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class C{constructor(u=new T.ServiceCollection,h=!1,w){this._activeInstantiations=new Set,this._services=u,this._strict=h,this._parent=w,this._services.set(L.IInstantiationService,this)}createChild(u){return new C(u,this._strict,this)}invokeFunction(u,...h){let w=v.traceInvocation(u),R=!1;try{return u({get:(m,o)=>{if(R)throw(0,d.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(m,w);if(!r&&o!==L.optional)throw new Error(`[invokeFunction] unknown service '${m}'`);return r}},...h)}finally{R=!0,w.stop()}}createInstance(u,...h){let w,R;return u instanceof b.SyncDescriptor?(w=v.traceCreation(u.ctor),R=this._createInstance(u.ctor,u.staticArguments.concat(h),w)):(w=v.traceCreation(u),R=this._createInstance(u,h,w)),w.stop(),R}_createInstance(u,h=[],w){let R=L._util.getServiceDependencies(u).sort((o,r)=>o.index-r.index),I=[];for(const o of R){let r=this._getOrCreateServiceInstance(o.id,w);if(!r&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);I.push(r)}let m=R.length>0?R[0].index:h.length;if(h.length!==m){console.warn(`[createInstance] First service dependency of ${u.name} at position ${m+1} conflicts with ${h.length} static arguments`);let o=m-h.length;o>0?h=h.concat(new Array(o)):h=h.slice(0,m)}return new u(...[...h,...I])}_setServiceInstance(u,h){if(this._services.get(u)instanceof b.SyncDescriptor)this._services.set(u,h);else if(this._parent)this._parent._setServiceInstance(u,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let h=this._services.get(u);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):h}_getOrCreateServiceInstance(u,h){let w=this._getServiceInstanceOrDescriptor(u);return w instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,w,h.branch(u,!0)):(h.branch(u,!1),w)}_safeCreateAndCacheServiceInstance(u,h,w){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,h,w)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,h,w){const R=new F.Graph(o=>o.id.toString());let I=0;const m=[{id:u,desc:h,_trace:w}];for(;m.length;){const o=m.pop();if(R.lookupOrInsertNode(o),I++>1e3)throw new f(R);for(let r of L._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(r.id);if(!e&&!r.optional&&console.warn(`[createInstance] ${u} depends on ${r.id} which is NOT registered.`),e instanceof b.SyncDescriptor){const i={id:r.id,desc:e,_trace:o._trace.branch(r.id,!0)};R.insertEdge(o,i),m.push(i)}}}for(;;){const o=R.roots();if(o.length===0){if(!R.isEmpty())throw new f(R);break}for(const{data:r}of o){if(this._getServiceInstanceOrDescriptor(r.id)instanceof b.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,i)}R.removeNode(r)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,h,w=[],R,I){if(this._services.get(u)instanceof b.SyncDescriptor)return this._createServiceInstance(h,w,R,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,h,w,R,I);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(u,h=[],w,R){if(w){const I=new D.IdleValue(()=>this._createInstance(u,h,R));return new Proxy(Object.create(null),{get(m,o){if(o in m)return m[o];let r=I.value,e=r[o];return typeof e!="function"||(e=e.bind(r),m[o]=e),e},set(m,o,r){return I.value[o]=r,!0}})}else return this._createInstance(u,h,R)}}t.InstantiationService=C;var y;(function(O){O[O.Creation=0]="Creation",O[O.Invocation=1]="Invocation",O[O.Branch=2]="Branch"})(y||(y={}));class v{constructor(u,h){this.type=u,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return c?new v(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(u){return c?new v(0,u.name):v._None}branch(u,h){let w=new v(2,u.toString());return this._dep.push([u,h,w]),w}stop(){let u=Date.now()-this._start;v._totals+=u;let h=!1;function w(I,m){let o=[],r=new Array(I+1).join("	");for(const[e,i,n]of m._dep)if(i&&n){h=!0,o.push(`${r}CREATES -> ${e}`);let s=w(I+1,n);s&&o.push(s)}else o.push(`${r}uses -> ${e}`);return o.join(`
`)}let R=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(u>2||h)&&console.log(R.join(`
`))}}v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(Q[53],Z([0,1,11]),function(_,t,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,d.createDecorator)("localizationsService");function F(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const L of b.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}t.isValidLocalization=F}),define(Q[15],Z([0,1,11,2,14,10,28]),function(_,t,d,F,b,L,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,d.createDecorator)("logService"),t.ILoggerService=(0,d.createDecorator)("loggerService");function D(){return new Date().toISOString()}var c;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;class f extends F.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=f;class C extends f{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(c.Trace)&&this.log(c.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(c.Debug)&&this.log(c.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(c.Info)&&this.log(c.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(c.Warning)&&this.log(c.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(c.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(c.Error,this.format(n))}else this.log(c.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(c.Critical)&&this.log(c.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let s=e[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(l){}i+=(n>0?" ":"")+s}return i}}t.AbstractMessageLogger=C;class y extends f{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!b.isWindows}trace(e,...i){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,e,...i):console.log(`[main ${D()}]`,e,...i))}debug(e,...i){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,e,...i):console.log(`[main ${D()}]`,e,...i))}info(e,...i){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,e,...i):console.log(`[main ${D()}]`,e,...i))}warn(e,...i){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,e,...i):console.warn(`[main ${D()}]`,e,...i))}error(e,...i){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,e,...i):console.error(`[main ${D()}]`,e,...i))}critical(e,...i){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,e,...i):console.error(`[main ${D()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=y;class v extends f{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=v;class O extends f{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.AdapterLogger=O;class u extends f{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=u;class h extends F.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=h;class w extends F.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(n))}))}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,(i==null?void 0:i.always)?c.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=w;class R{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=R;function I(r){if(r.verbose)return c.Trace;if(typeof r.logLevel=="string"){const e=m(r.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=I;function m(r){switch(r){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.parseLogLevel=m;function o(r){switch(r){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}t.LogLevelToString=o}),define(Q[101],Z([0,1,9,2,18,23,21,7,17,24,15,29,39,14,4,13]),function(_,t,d,F,b,L,T,D,c,f,C,y,v,O,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let R=class extends F.Disposable{constructor(m,o,r,e){super();this.fileService=o,this.extensionGalleryService=r,this.logService=e,this.extensionsDownloadDir=D.URI.file(m.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(m,o){await this.cleanUpPromise;const r=this.getName(m),e=(0,c.joinPath)(this.extensionsDownloadDir,r);if(!await this.fileService.exists(e)){const i=(0,c.joinPath)(this.extensionsDownloadDir,`.${(0,y.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(m,i,o);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(s){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",m.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,h.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(m){}async rename(m,o,r){try{await d.Promises.rename(m.fsPath,o.fsPath)}catch(e){if(O.isWindows&&e&&e.code==="EPERM"&&Date.now()<r)return this.logService.info(`Failed renaming ${m} to ${o} with 'EPERM' error. Trying again...`),this.rename(m,o,r);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const m=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const o=[],r=[];for(const n of m.children){const s=this.parse(n.name);s&&r.push([s,n])}const e=(0,f.groupByExtension)(r,([n])=>n),i=[];for(const n of e)n.sort((s,l)=>v.rcompare(s[0].version,l[0].version)),o.push(...n.slice(1).map(s=>s[1].resource)),i.push(n[0][1]);i.sort((n,s)=>n.mtime-s.mtime),o.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await u.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(m){this.logService.error(m)}}getName(m){return this.cache?new f.ExtensionIdentifierWithVersion(m.identifier,m.version).key().toLowerCase():(0,y.generateUuid)()}parse(m){const o=w.exec(m);return o&&o[1]&&o[2]?new f.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};R=ue([fe(0,T.INativeEnvironmentService),fe(1,b.IFileService),fe(2,L.IExtensionGalleryService),fe(3,C.ILogService)],R),t.ExtensionsDownloader=R}),define(Q[102],Z([0,1,2,15,33,28,3,4,10,8,9,21]),function(_,t,d,F,b,L,T,D,c,f,C,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let v=class extends d.Disposable{constructor(u,h){super();this.environmentService=u,this.logService=h,this.processesLimiter=new D.Limiter(5)}async postUninstall(u){const h=this.parseScript(u,"uninstall");return h&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(h.script,"uninstall",h.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),w=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${w}`)))),(0,C.rimraf)(this.getExtensionStoragePath(u)).then(void 0,w=>this.logService.error("Error while removing extension storage path",w))}parseScript(u,h){const w=`vscode:${h}`;if(u.location.scheme===f.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[w]=="string"){const R=u.manifest.scripts[w].split(" ");return R.length<2||R[0]!=="node"||!R[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${w} should be a node script`),null):{script:(0,T.join)(u.location.fsPath,R[1]),args:R.slice(2)||[]}}return null}runLifecycleHook(u,h,w,R,I){return new Promise((m,o)=>{const r=this.start(u,h,w,I);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?o(n):m(void 0)};r.on("error",n=>{i((0,L.toErrorMessage)(n)||"Unknown")}),r.on("exit",(n,s)=>{i(n?`post-${h} process exited with code ${n}`:void 0)}),R&&(e=setTimeout(()=>{e=null,r.kill(),o("timed out")},5e3))})}start(u,h,w,R){const I={silent:!0,execArgv:void 0},m=(0,b.fork)(u,[`--type=extension-post-${h}`,...w],I);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const o=c.Event.fromNodeEventEmitter(m.stdout,"data"),r=c.Event.fromNodeEventEmitter(m.stderr,"data");o(n=>this.logService.info(R.identifier.id,R.manifest.version,`post-${h}`,n)),r(n=>this.logService.error(R.identifier.id,R.manifest.version,`post-${h}`,n));const e=c.Event.any(c.Event.map(o,n=>({data:`%c${n}`,format:[""]})),c.Event.map(r,n=>({data:`%c${n}`,format:["color: red"]})));return c.Event.debounce(e,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(R.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),m}getExtensionStoragePath(u){return(0,T.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};v=ue([fe(0,y.IEnvironmentService),fe(1,F.ILogService)],v),t.ExtensionsLifecycle=v}),define(Q[103],Z([0,1,2,21,10,18,7,24,17,15]),function(_,t,d,F,b,L,T,D,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let C=class extends d.Disposable{constructor(v,O,u,h){super();this.extensionsManagementService=v,this.logService=h,this._onDidChangeExtensionsByAnotherSource=this._register(new b.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(I=>{this.installedExtensions=I.map(m=>m.identifier),this.startTimestamp=Date.now()}),this._register(v.onInstallExtension(I=>this.onInstallExtension(I))),this._register(v.onDidInstallExtension(I=>this.onDidInstallExtension(I))),this._register(v.onDidUninstallExtension(I=>this.onDidUninstallExtension(I)));const w=T.URI.file(u.extensionsPath),R=new c.ExtUri(I=>!O.hasCapability(I,1024));this._register(O.watch(w)),this._register(b.Event.filter(O.onDidFilesChange,I=>I.changes.some(m=>this.doesChangeAffects(m,w,R)))(()=>this.onDidChange()))}doesChangeAffects(v,O,u){return u.isEqual(u.dirname(v.resource),O)?u.isEqual(v.resource,u.joinPath(O,".obsolete"))?!0:!(v.type!==1&&v.type!==2||u.basename(v.resource).startsWith(".")):!1}onInstallExtension(v){this.addInstallingExtension(v.identifier)}onDidInstallExtension(v){this.removeInstallingExtension(v.identifier),v.error||this.addInstalledExtension(v.identifier)}onDidUninstallExtension(v){v.error||this.removeInstalledExtension(v.identifier)}addInstallingExtension(v){this.removeInstallingExtension(v),this.installingExtensions.push(v)}removeInstallingExtension(v){this.installingExtensions=this.installingExtensions.filter(O=>!(0,D.areSameExtensions)(O,v))}addInstalledExtension(v){this.installedExtensions&&(this.removeInstalledExtension(v),this.installedExtensions.push(v))}removeInstalledExtension(v){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(O=>!(0,D.areSameExtensions)(O,v)))}async onDidChange(){if(this.installedExtensions){const v=await this.extensionsManagementService.getInstalled(1),O=v.filter(h=>[...this.installingExtensions,...this.installedExtensions].some(w=>(0,D.areSameExtensions)(w,h.identifier))?!1:h.installedTimestamp&&h.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",h.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",h.identifier.id),!1)),u=this.installedExtensions.filter(h=>this.installingExtensions.some(w=>(0,D.areSameExtensions)(w,h))?!1:v.every(w=>!(0,D.areSameExtensions)(w.identifier,h))?(this.logService.info("Detected extension removed from another source",h.id),!0):!1);this.installedExtensions=v.map(h=>h.identifier),(O.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:O,removed:u})}}};C=ue([fe(1,L.IFileService),fe(2,F.INativeEnvironmentService),fe(3,f.ILogService)],C),t.ExtensionsWatcher=C}),define(Q[104],Z([0,1,9,127,23,2,21,4,24,15,53,22,10,8,3]),function(_,t,d,F,b,L,T,D,c,f,C,y,v,O,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let h=class extends L.Disposable{constructor(I,m,o){super();this.extensionManagementService=I,this.logService=o,this._onDidLanguagesChange=this._register(new v.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new w(m,o)),this._register(I.onDidInstallExtension(({local:r})=>this.onDidInstallExtension(r))),this._register(I.onDidUninstallExtension(({identifier:r})=>this.onDidUninstallExtension(r)))}getLanguageIds(){return this.cache.getLanguagePacks().then(I=>{const m=["en",...Object.keys(I)];return(0,y.distinct)(m)})}onDidInstallExtension(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",I.identifier.id),this.update().then(m=>{m&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(I){this.cache.getLanguagePacks().then(m=>{Object.keys(m).some(o=>m[o]&&m[o].extensions.some(r=>(0,c.areSameExtensions)(r.extensionIdentifier,I)))&&(this.logService.debug("Removing language packs from the extension",I.id),this.update().then(o=>{o&&this._onDidLanguagesChange.fire()}))})}async update(){const[I,m]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),o=await this.cache.update(m);return!(0,y.equals)(Object.keys(I),Object.keys(o))}};h=ue([fe(0,b.IExtensionManagementService),fe(1,T.INativeEnvironmentService),fe(2,f.ILogService)],h),t.LocalizationsService=h;let w=class extends L.Disposable{constructor(I,m){super();this.logService=m,this.languagePacks={},this.languagePacksFilePath=(0,u.join)(I.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(I){return this.withLanguagePacks(m=>{Object.keys(m).forEach(o=>delete m[o]),this.createLanguagePacksFromExtensions(m,...I)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(I,...m){for(const o of m)o&&o.manifest&&o.manifest.contributes&&o.manifest.contributes.localizations&&o.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(I,o);Object.keys(I).forEach(o=>this.updateHash(I[o]))}createLanguagePacksFromExtension(I,m){const o=m.identifier,r=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const e of r)if(m.location.scheme===O.Schemas.file&&(0,C.isValidLocalization)(e)){let i=I[e.languageId];i||(i={hash:"",extensions:[],translations:{}},I[e.languageId]=i);let n=i.extensions.filter(s=>(0,c.areSameExtensions)(s.extensionIdentifier,o))[0];n?n.version=m.manifest.version:i.extensions.push({extensionIdentifier:o,version:m.manifest.version});for(const s of e.translations)i.translations[s.id]=(0,u.join)(m.location.fsPath,s.path)}}updateHash(I){if(I){const m=(0,F.createHash)("md5");for(const o of I.extensions)m.update(o.extensionIdentifier.uuid||o.extensionIdentifier.id).update(o.version);I.hash=m.digest("hex")}}withLanguagePacks(I=()=>null){return this.languagePacksFileLimiter.queue(()=>{let m=null;return d.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,o=>o.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(o)).then(o=>{try{return JSON.parse(o)}catch(r){return{}}}).then(o=>(m=I(o),o)).then(o=>{for(const e of Object.keys(o))o[e]||delete o[e];this.languagePacks=o,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),(0,d.writeFile)(this.languagePacksFilePath,r)}).then(()=>m,o=>this.logService.error(o))})}};w=ue([fe(0,T.INativeEnvironmentService),fe(1,f.ILogService)],w)}),define(Q[105],Z([0,1,15,18]),function(_,t,d,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function b(c,f,C,y){try{const v=await new Promise((O,u)=>{_(["spdlog"],O,u)});return v.setFlushOn(d.LogLevel.Info),v.createAsyncRotatingLogger(c,f,C,y)}catch(v){console.error(v)}return null}function L(c,f,C,y){const v=_.__$__nodeRequire("spdlog");return v.setFlushOn(d.LogLevel.Info),v.createRotatingLogger(c,f,C,y)}t.createRotatingLogger=L;function T(c,f,C){switch(f){case d.LogLevel.Trace:c.trace(C);break;case d.LogLevel.Debug:c.debug(C);break;case d.LogLevel.Info:c.info(C);break;case d.LogLevel.Warning:c.warn(C);break;case d.LogLevel.Error:c.error(C);break;case d.LogLevel.Critical:c.critical(C);break;default:throw new Error("Invalid log level")}}class D extends d.AbstractMessageLogger{constructor(f,C,y,v){super();this.name=f,this.filepath=C,this.rotating=y,this.buffer=[],this.setLevel(v),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(O=>{this._logger&&this._logger.setLevel(O)}))}_createSpdLogLogger(){const f=this.rotating?6:1,C=30/f*F.ByteSize.MB;return b(this.name,this.filepath,C,f).then(y=>{if(y){this._logger=y,this._logger.setLevel(this.getLevel());for(const{level:v,message:O}of this.buffer)T(this._logger,v,O);this.buffer=[]}})}log(f,C){this._logger?T(this._logger,f,C):this.getLevel()<=f&&this.buffer.push({level:f,message:C})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=D}),define(Q[54],Z([0,1,81,16,18,13,40]),function(_,t,d,F,b,L,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function D(y,v,O,u,h,w){let R;try{await c(y,v,O,u,h,w)}catch(I){R=I}finally{R&&h.errorTransformer&&(R=h.errorTransformer(R)),typeof R!="undefined"&&O.error(R),O.end()}}t.readFileIntoStream=D;async function c(y,v,O,u,h,w){f(w);const R=await y.open(v,{create:!1});try{f(w);let I=0,m=0,o=h&&typeof h.length=="number"?h.length:void 0,r=F.VSBuffer.alloc(Math.min(h.bufferSize,typeof o=="number"?o:h.bufferSize)),e=h&&typeof h.position=="number"?h.position:0,i=0;do m=await y.read(R,e,r.buffer,i,r.byteLength-i),e+=m,i+=m,I+=m,typeof o=="number"&&(o-=m),i===r.byteLength&&(await O.write(u(r)),r=F.VSBuffer.alloc(Math.min(h.bufferSize,typeof o=="number"?o:h.bufferSize)),i=0);while(m>0&&(typeof o!="number"||o>0)&&f(w)&&C(I,h));if(i>0){let n=i;typeof o=="number"&&(n=Math.min(i,o)),O.write(u(r.slice(0,n)))}}catch(I){throw(0,b.ensureFileSystemProviderError)(I)}finally{await y.close(R)}}function f(y){if(y.isCancellationRequested)throw(0,L.canceled)();return!0}function C(y,v){if(v==null?void 0:v.limits){if(typeof v.limits.memory=="number"&&y>v.limits.memory)throw(0,b.createFileSystemProviderError)((0,d.localize)(0,null,T.default.nameShort),b.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&y>v.limits.size)throw(0,b.createFileSystemProviderError)((0,d.localize)(1,null),b.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[106],Z([0,1,80,128,2,18,10,17,45,22,15,16,35,4,27,8,54,129]),function(_,t,d,F,b,L,T,D,c,f,C,y,v,O,u,h,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let I=class extends b.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(o,r){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,F.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:r});const e=new b.DisposableStore;return e.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new L.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),e.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:o}))),typeof r.onDidErrorOccur=="function"&&e.add(r.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:r}),this.provider.delete(o),(0,b.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){r.push(e)}}),!this.provider.has(o)&&await O.Promises.settled(r)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,r){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&r)}listCapabilities(){return R.Iterable.map(this.provider,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async withProvider(o){if(!(0,D.isAbsolutePath)(o))throw new L.FileOperationError((0,d.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const r=this.provider.get(o.scheme);if(!r){const e=new Error;throw e.name="ENOPRO",e.message=(0,d.localize)(1,null,o.toString()),e}return r}async withReadProvider(o){const r=await this.withProvider(o);if((0,L.hasOpenReadWriteCloseCapability)(r)||(0,L.hasReadWriteCapability)(r)||(0,L.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const r=await this.withProvider(o);if((0,L.hasOpenReadWriteCloseCapability)(r)||(0,L.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.doResolveFile(o,r)}catch(e){throw(0,L.toFileSystemProviderErrorCode)(e)===L.FileSystemProviderErrorCode.FileNotFound?new L.FileOperationError((0,d.localize)(2,null,this.resourceForError(o)),1):(0,L.ensureFileSystemProviderError)(e)}}async doResolveFile(o,r){const e=await this.withProvider(o),i=this.isPathCaseSensitive(e),n=r==null?void 0:r.resolveTo,s=r==null?void 0:r.resolveSingleChildDescendants,l=r==null?void 0:r.resolveMetadata,p=await e.stat(o);let E;return this.toFileStat(e,o,p,void 0,!!l,(U,A)=>(E||(E=c.TernarySearchTree.forUris(()=>!i),E.set(o,!0),(0,f.isNonEmptyArray)(n)&&n.forEach(j=>E.set(j,!0))),Boolean(E.findSuperstr(U.resource)||E.get(U.resource))?!0:U.isDirectory&&s?A===1:!1))}async toFileStat(o,r,e,i,n,s){var l;const{providerExtUri:p}=this.getExtUri(o),E={resource:r,name:p.basename(r),isFile:(e.type&L.FileType.File)!=0,isDirectory:(e.type&L.FileType.Directory)!=0,isSymbolicLink:(e.type&L.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean(((l=e.permissions)!==null&&l!==void 0?l:0)&L.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,L.etag)({mtime:e.mtime,size:e.size})};if(E.isDirectory&&s(E,i)){try{const U=await o.readdir(r),A=await O.Promises.settled(U.map(async([j,V])=>{try{const q=p.joinPath(r,j),J=n?await o.stat(q):{type:V};return await this.toFileStat(o,q,J,U.length,n,s)}catch(q){return this.logService.trace(q),null}}));E.children=(0,f.coalesce)(A)}catch(U){this.logService.trace(U),E.children=[]}return E}return E}async resolveAll(o){return O.Promises.settled(o.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const r=await this.withProvider(o);try{return!!await r.stat(o)}catch(e){return!1}}async canCreateFile(o,r){try{await this.doValidateCreateFile(o,r)}catch(e){return e}return!0}async doValidateCreateFile(o,r){if(!(r==null?void 0:r.overwrite)&&await this.exists(o))throw new L.FileOperationError((0,d.localize)(3,null,this.resourceForError(o)),3,r)}async createFile(o,r=y.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const i=await this.writeFile(o,r);return this._onDidRunOperation.fire(new L.FileOperationEvent(o,0,i)),i}async writeFile(o,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,o,e)||await this.mkdirp(i,n.dirname(o));let l;if((0,L.hasReadWriteCapability)(i)&&!(r instanceof y.VSBuffer))if((0,v.isReadableStream)(r)){const p=await(0,v.peekStream)(r,3);p.ended?l=y.VSBuffer.concat(p.buffer):l=p}else l=(0,v.peekReadable)(r,p=>y.VSBuffer.concat(p),3);else l=r;!(0,L.hasOpenReadWriteCloseCapability)(i)||(0,L.hasReadWriteCapability)(i)&&l instanceof y.VSBuffer?await this.doWriteUnbuffered(i,o,e,l):await this.doWriteBuffered(i,o,e,l instanceof y.VSBuffer?(0,y.bufferToReadable)(l):l)}catch(s){throw new L.FileOperationError((0,d.localize)(4,null,this.resourceForError(o),(0,L.ensureFileSystemProviderError)(s).toString()),(0,L.toFileOperationResult)(s),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,r,e){if(!!(e==null?void 0:e.unlock)&&!(o.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(r)));let n;try{n=await o.stat(r)}catch(s){return}if((n.type&L.FileType.Directory)!=0)throw new L.FileOperationError((0,d.localize)(6,null,this.resourceForError(r)),0,e);if(this.throwIfFileIsReadonly(r,n),e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==L.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,L.etag)({mtime:e.mtime,size:n.size}))throw new L.FileOperationError((0,d.localize)(7,null),3,e);return n}async readFile(o,r){const e=await this.withReadProvider(o);return(r==null?void 0:r.atomic)?this.doReadFileAtomic(e,o,r):this.doReadFile(e,o,r)}async doReadFileAtomic(o,r,e){return new Promise((i,n)=>{this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(o,r,e);i(s)}catch(s){n(s)}})})}async doReadFile(o,r,e){const i=await this.doReadFileStream(o,r,Object.assign(Object.assign({},e),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,y.streamToBuffer)(i.value)})}async readFileStream(o,r){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,r)}async doReadFileStream(o,r,e){const i=new u.CancellationTokenSource,n=this.validateReadFile(r,e).then(l=>l,l=>{throw i.cancel(),l});let s;try{e&&typeof e.etag=="string"&&e.etag!==L.ETAG_DISABLED&&await n,!((0,L.hasOpenReadWriteCloseCapability)(o)||(0,L.hasFileReadStreamCapability)(o))||(0,L.hasReadWriteCapability)(o)&&(e==null?void 0:e.preferUnbuffered)?s=this.readFileUnbuffered(o,r,e):(0,L.hasFileReadStreamCapability)(o)?s=this.readFileStreamed(o,r,i.token,e):s=this.readFileBuffered(o,r,i.token,e);const l=await n;return Object.assign(Object.assign({},l),{value:s})}catch(l){throw s&&await(0,v.consumeStream)(s),new L.FileOperationError((0,d.localize)(8,null,this.resourceForError(r),(0,L.ensureFileSystemProviderError)(l).toString()),(0,L.toFileOperationResult)(l),e)}}readFileStreamed(o,r,e,i=Object.create(null)){const n=o.readFileStream(r,i,e);return(0,v.transform)(n,{data:s=>s instanceof y.VSBuffer?s:y.VSBuffer.wrap(s),error:s=>new L.FileOperationError((0,d.localize)(9,null,this.resourceForError(r),(0,L.ensureFileSystemProviderError)(s).toString()),(0,L.toFileOperationResult)(s),i)},s=>y.VSBuffer.concat(s))}readFileBuffered(o,r,e,i=Object.create(null)){const n=(0,y.newWriteableBufferStream)();return(0,w.readFileIntoStream)(o,r,n,s=>s,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new L.FileOperationError((0,d.localize)(10,null,this.resourceForError(r),(0,L.ensureFileSystemProviderError)(s).toString()),(0,L.toFileOperationResult)(s),i)}),e),n}readFileUnbuffered(o,r,e){const i=(0,v.newWriteableStream)(n=>y.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(r);e&&typeof e.position=="number"&&(n=n.slice(e.position)),e&&typeof e.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(r,n.byteLength,e),i.end(y.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(o,r){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new L.FileOperationError((0,d.localize)(11,null,this.resourceForError(o)),0,r);if(r&&typeof r.etag=="string"&&r.etag!==L.ETAG_DISABLED&&r.etag===e.etag)throw new L.FileOperationError((0,d.localize)(12,null),2,r);return this.validateReadFileLimits(o,e.size,r),e}validateReadFileLimits(o,r,e){if(e==null?void 0:e.limits){let i;if(typeof e.limits.memory=="number"&&r>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&r>e.limits.size&&(i=7),typeof i=="number")throw new L.FileOperationError((0,d.localize)(13,null,this.resourceForError(o)),i)}}async canMove(o,r,e){return this.doCanMoveCopy(o,r,"move",e)}async canCopy(o,r,e){return this.doCanMoveCopy(o,r,"copy",e)}async doCanMoveCopy(o,r,e,i){if(o.toString()!==r.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,o,s,r,e,i)}catch(n){return n}return!0}async move(o,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,o,n,r,"move",!!e),l=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(o,s==="move"?2:3,l)),l}async copy(o,r,e){const i=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,o,n,r,"copy",!!e),l=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(o,s==="copy"?3:2,l)),l}async doMoveCopy(o,r,e,i,n,s){if(r.toString()===i.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:p}=await this.doValidateMoveCopy(o,r,e,i,n,s);if(l&&!p&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(o===e&&(0,L.hasFileFolderCopyCapability)(o))await o.copy(r,i,{overwrite:s});else{const E=await this.resolve(r);E.isDirectory?await this.doCopyFolder(o,E,e,i):await this.doCopyFile(o,r,e,i)}return n}else return o===e?(await o.rename(r,i,{overwrite:s}),n):(await this.doMoveCopy(o,r,e,i,"copy",s),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(o,r,e,i){if((0,L.hasOpenReadWriteCloseCapability)(o)&&(0,L.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,r,e,i);if((0,L.hasOpenReadWriteCloseCapability)(o)&&(0,L.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,r,e,i);if((0,L.hasReadWriteCapability)(o)&&(0,L.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,r,e,i);if((0,L.hasReadWriteCapability)(o)&&(0,L.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,r,e,i)}async doCopyFolder(o,r,e,i){await e.mkdir(i),Array.isArray(r.children)&&await O.Promises.settled(r.children.map(async n=>{const s=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),e,s):this.doCopyFile(o,n.resource,e,s)}))}async doValidateMoveCopy(o,r,e,i,n,s){let l=!1;if(o===e){const{providerExtUri:E,isPathCaseSensitive:U}=this.getExtUri(o);if(U||(l=E.isEqual(r,i)),l&&n==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!l&&E.isEqualOrParent(i,r))throw new Error((0,d.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const p=await this.exists(i);if(p&&!l){if(!s)throw new L.FileOperationError((0,d.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(o===e){const{providerExtUri:E}=this.getExtUri(o);if(E.isEqualOrParent(r,i))throw new Error((0,d.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:p,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const r=this.isPathCaseSensitive(o);return{providerExtUri:r?D.extUri:D.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(r,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(o,0,e)),e}async mkdirp(o,r){const e=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(r,i.dirname(r));)try{if(((await o.stat(r)).type&L.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(r)));break}catch(n){if((0,L.toFileSystemProviderErrorCode)(n)!==L.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(r)),r=i.dirname(r)}for(let n=e.length-1;n>=0;n--){r=i.joinPath(r,e[n]);try{await o.mkdir(r)}catch(s){if((0,L.toFileSystemProviderErrorCode)(s)!==L.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,r){try{await this.doValidateDelete(o,r)}catch(e){return e}return!0}async doValidateDelete(o,r){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(r==null?void 0:r.useTrash)&&!(e.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(o)));let n;try{n=await e.stat(o)}catch(l){}if(n)this.throwIfFileIsReadonly(o,n);else throw new L.FileOperationError((0,d.localize)(20,null,this.resourceForError(o)),1);if(!!!(r==null?void 0:r.recursive)){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(o)))}return e}async del(o,r){const e=await this.doValidateDelete(o,r),i=!!(r==null?void 0:r.useTrash),n=!!(r==null?void 0:r.recursive);await e.delete(o,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new L.FileOperationEvent(o,1))}watch(o,r={recursive:!1,excludes:[]}){let e=!1,i=()=>{e=!0};return this.doWatch(o,r).then(n=>{e?(0,b.dispose)(n):i=()=>(0,b.dispose)(n)},n=>this.logService.error(n)),(0,b.toDisposable)(()=>i())}async doWatch(o,r){const e=await this.withProvider(o),i=this.toWatchKey(e,o,r),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(o,r)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,b.toDisposable)(()=>{n.count--,n.count===0&&((0,b.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(o,r,e){const{providerExtUri:i}=this.getExtUri(o);return[i.getComparisonKey(r),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>(0,b.dispose)(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(async()=>{var n;const s=await o.open(r,{create:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1});try{(0,v.isReadableStream)(i)||(0,v.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(o,s,i):await this.doWriteReadableBufferedQueued(o,s,i)}catch(l){throw(0,L.ensureFileSystemProviderError)(l)}finally{await o.close(s)}})}async doWriteStreamBufferedQueued(o,r,e){let i=0,n;if((0,v.isReadableBufferedStream)(e)){if(e.buffer.length>0){const s=y.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,r,s,s.byteLength,i,0),i+=s.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(s,l)=>{(0,v.listenStream)(n,{onData:async p=>{n.pause();try{await this.doWriteBuffer(o,r,p,p.byteLength,i,0)}catch(E){return l(E)}i+=p.byteLength,setTimeout(()=>n.resume())},onError:p=>l(p),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,r,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(o,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(o,r,e,i,n,s){let l=0;for(;l<i;)l+=await o.write(r,n+l,e.buffer,s+l,i-l)}async doWriteUnbuffered(o,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,r,e,i))}async doWriteUnbufferedQueued(o,r,e,i){var n;let s;i instanceof y.VSBuffer?s=i:(0,v.isReadableStream)(i)?s=await(0,y.streamToBuffer)(i):(0,v.isReadableBufferedStream)(i)?s=await(0,y.bufferedStreamToBuffer)(i):s=(0,y.readableToBuffer)(i),await o.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1})}async doPipeBuffered(o,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,r,e,i))}async doPipeBufferedQueued(o,r,e,i){let n,s;try{n=await o.open(r,{create:!1}),s=await e.open(i,{create:!0,unlock:!1});const l=y.VSBuffer.alloc(this.BUFFER_SIZE);let p=0,E=0,U=0;do U=await o.read(n,p,l.buffer,E,l.byteLength-E),await this.doWriteBuffer(e,s,l,U,p,E),p+=U,E+=U,E===l.byteLength&&(E=0);while(U>0)}catch(l){throw(0,L.ensureFileSystemProviderError)(l)}finally{await O.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof s=="number"?e.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,r,e,i))}async doPipeUnbufferedQueued(o,r,e,i){return e.writeFile(i,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,r,e,i))}async doPipeUnbufferedToBufferedQueued(o,r,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const s=await o.readFile(r);await this.doWriteBuffer(e,n,y.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,L.ensureFileSystemProviderError)(s)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(o,r,e,i){const n=await(0,y.streamToBuffer)(this.readFileBuffered(o,r,u.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(o,r){if(o.capabilities&2048)throw new L.FileOperationError((0,d.localize)(22,null,this.resourceForError(r)),6);return o}throwIfFileIsReadonly(o,r){var e;if(((e=r.permissions)!==null&&e!==void 0?e:0)&L.FilePermission.Readonly)throw new L.FileOperationError((0,d.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===h.Schemas.file?o.fsPath:o.toString(!0)}};I=ue([fe(0,C.ILogService)],I),t.FileService=I}),define(Q[107],Z([0,1,2,18,10,14,9,3,17,36,4,15,82,51,91,93,90,99,35,54,22,16]),function(_,t,d,F,b,L,T,D,c,f,C,y,v,O,u,h,w,R,I,m,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends d.Disposable{constructor(n,s){var l;super();this.logService=n,this.options=s,this.BUFFER_SIZE=((l=this.options)===null||l===void 0?void 0:l.bufferSize)||64*1024,this.onDidChangeCapabilities=b.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new b.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new b.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new C.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,L.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:l}=await T.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,l),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(n){try{const s=await(0,T.readdir)(this.toFilePath(n),{withFileTypes:!0}),l=[];return await Promise.all(s.map(async p=>{try{let E;p.isSymbolicLink()?E=(await this.stat((0,c.joinPath)(n,p.name))).type:E=this.toType(p),l.push([p.name,E])}catch(E){this.logService.trace(E)}})),l}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let l;return(s==null?void 0:s.dangling)?l=F.FileType.Unknown:n.isFile()?l=F.FileType.File:n.isDirectory()?l=F.FileType.Directory:l=F.FileType.Unknown,s&&(l|=F.FileType.SymbolicLink),l}async readFile(n){try{const s=this.toFilePath(n);return await T.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(n,s,l){const p=(0,I.newWriteableStream)(E=>r.VSBuffer.concat(E.map(U=>r.VSBuffer.wrap(U))).buffer);return(0,m.readFileIntoStream)(this,n,p,E=>E.buffer,Object.assign(Object.assign({},s),{bufferSize:this.BUFFER_SIZE}),l),p}async writeFile(n,s,l){let p;try{const E=this.toFilePath(n);if(!l.create||!l.overwrite){if(await(0,T.exists)(E)){if(!l.overwrite)throw(0,F.createFileSystemProviderError)((0,v.localize)(0,null),F.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,F.createFileSystemProviderError)((0,v.localize)(1,null),F.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(n,{create:!0,unlock:l.unlock}),await this.write(p,0,s,0,s.byteLength)}catch(E){throw await this.toFileSystemProviderWriteError(n,E)}finally{typeof p=="number"&&await this.close(p)}}async open(n,s){try{const l=this.toFilePath(n);if((0,F.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:U}=await T.SymlinkSupport.stat(l);U.mode&128||await T.Promises.chmod(l,U.mode|128)}catch(U){this.logService.trace(U)}let p;if((0,F.isFileOpenForWriteOptions)(s)){if(L.isWindows)try{await T.Promises.truncate(l,0),p="r+"}catch(U){U.code!=="ENOENT"&&this.logService.trace(U)}p||(p="w")}else p="r";const E=await T.Promises.open(l,p);return this.mapHandleToPos.set(E,0),(0,F.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(E,n),E}catch(l){throw(0,F.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(n,l):this.toFileSystemProviderError(l)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await T.Promises.fdatasync(n)}catch(s){this.canFlush=!1,this.logService.error(s)}return await T.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}}async read(n,s,l,p,E){const U=this.normalizePos(n,s);let A=null;try{const j=await T.Promises.read(n,l,p,E,U);return typeof j=="number"?A=j:A=j.bytesRead,A}catch(j){throw this.toFileSystemProviderError(j)}finally{this.updatePos(n,U,A)}}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,l){const p=this.mapHandleToPos.get(n);typeof p=="number"&&(typeof s=="number"||(typeof l=="number"?this.mapHandleToPos.set(n,p+l):this.mapHandleToPos.delete(n)))}async write(n,s,l,p,E){return(0,C.retry)(()=>this.doWrite(n,s,l,p,E),100,3)}async doWrite(n,s,l,p,E){const U=this.normalizePos(n,s);let A=null;try{const j=await T.Promises.write(n,l,p,E,U);return typeof j=="number"?A=j:A=j.bytesWritten,A}catch(j){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),j)}finally{this.updatePos(n,U,A)}}async mkdir(n){try{await T.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const l=this.toFilePath(n);await this.doDelete(l,s)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(n,s){s.recursive?await(0,T.rimraf)(n,T.RimRafMode.MOVE):await T.Promises.unlink(n)}async rename(n,s,l){const p=this.toFilePath(n),E=this.toFilePath(s);if(p!==E)try{await this.validateTargetDeleted(n,s,"move",l.overwrite),await(0,T.move)(p,E)}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,v.localize)(2,null,(0,D.basename)(p),(0,D.basename)((0,D.dirname)(E)),U.toString()))),this.toFileSystemProviderError(U)}}async copy(n,s,l){const p=this.toFilePath(n),E=this.toFilePath(s);if(p!==E)try{await this.validateTargetDeleted(n,s,"copy",l.overwrite),await(0,T.copy)(p,E,{preserveSymlinks:!0})}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,v.localize)(3,null,(0,D.basename)(p),(0,D.basename)((0,D.dirname)(E)),U.toString()))),this.toFileSystemProviderError(U)}}async validateTargetDeleted(n,s,l,p){const E=this.toFilePath(n),U=this.toFilePath(s);let A=!1;if(!!(this.capabilities&1024)||(A=(0,f.isEqual)(E,U,!0)),A&&l==="copy")throw(0,F.createFileSystemProviderError)((0,v.localize)(4,null),F.FileSystemProviderErrorCode.FileExists);if(!A&&await(0,T.exists)(U)){if(!p)throw(0,F.createFileSystemProviderError)((0,v.localize)(5,null),F.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(n,s){return s.recursive?this.watchRecursive(n,s.excludes):this.watchNonRecursive(n)}watchRecursive(n,s){const l={path:this.toFilePath(n),excludes:s},p=(0,o.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,d.toDisposable)(()=>{p(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var n,s,l;if(this.recursiveWatcher instanceof w.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,d.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let p,E;((s=(n=this.options)===null||n===void 0?void 0:n.watcher)===null||s===void 0?void 0:s.usePolling)?(p=u.FileWatcher,E=(l=this.options)===null||l===void 0?void 0:l.watcher):this.recursiveFoldersToWatch.length===1?L.isWindows?p=h.FileWatcher:p=u.FileWatcher:p=w.FileWatcher,this.recursiveWatcher=new p(this.recursiveFoldersToWatch,U=>this._onDidChangeFile.fire((0,O.toFileChanges)(U)),U=>{U.type==="error"&&this._onDidWatchErrorOccur.fire(U.message),this.logService[U.type](U.message)},this.logService.getLevel()===y.LogLevel.Trace,E),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)}))}}watchNonRecursive(n){const s=new R.FileWatcher(this.toFilePath(n),p=>this._onDidChangeFile.fire((0,O.toFileChanges)(p)),p=>{p.type==="error"&&this._onDidWatchErrorOccur.fire(p.message),this.logService[p.type](p.message)},this.logService.getLevel()===y.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)});return(0,d.combinedDisposable)(s,l)}toFilePath(n){return(0,D.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof F.FileSystemProviderError)return n;let s;switch(n.code){case"ENOENT":s=F.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=F.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=F.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=F.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=F.FileSystemProviderErrorCode.NoPermissions;break;default:s=F.FileSystemProviderErrorCode.Unknown}return(0,F.createFileSystemProviderError)(n,s)}async toFileSystemProviderWriteError(n,s){let l=this.toFileSystemProviderError(s);if(n&&l.code===F.FileSystemProviderErrorCode.NoPermissions)try{const{stat:p}=await T.SymlinkSupport.stat(this.toFilePath(n));p.mode&128||(l=(0,F.createFileSystemProviderError)(s,F.FileSystemProviderErrorCode.FileWriteLocked))}catch(p){this.logService.trace(p)}return l}dispose(){super.dispose(),(0,d.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,d.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(Q[41],Z([0,1,11]),function(_,t,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,d.createDecorator)("productService")}),define(Q[25],Z([0,1,12,57]),function(_,t,d,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class b{constructor(){this.data=new Map}add(T,D){F.ok(d.isString(T)),F.ok(d.isObject(D)),F.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,D)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}t.Registry=new b}),define(Q[108],Z([0,1,25,10]),function(_,t,d,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function b(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class L{constructor(){this._onDidChangeSchema=new F.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,f){this.schemasById[b(c)]=f,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new L;d.Registry.add(t.Extensions.JSONContribution,T)}),define(Q[30],Z([0,1,73,10,25,12,108]),function(_,t,d,F,b,L,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"};var D;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const c=b.Registry.as(T.Extensions.JSONContribution);class f{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:d.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},c.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(R,I=!0){this.registerConfigurations([R],I)}registerConfigurations(R,I=!0){const m=[];R.forEach(o=>{m.push(...this.validateAndRegisterProperties(o,I,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),c.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(R){const I=[],m=o=>{if(o.properties)for(const r in o.properties)I.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,o.properties[r]);o.allOf&&o.allOf.forEach(r=>m(r))};for(const o of R){m(o);const r=this.configurationContributors.indexOf(o);r!==-1&&this.configurationContributors.splice(r,1)}c.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}registerDefaultConfigurations(R){const I=[],m=[];for(const o of R)for(const r in o)if(I.push(r),t.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]=Object.assign(Object.assign({},this.defaultValues[r]||{}),o[r]);const e={type:"object",default:this.defaultValues[r],description:d.localize(1,null,r),$ref:t.resourceLanguageSettingsSchemaId};m.push(y(r)),this.configurationProperties[r]=e,this.defaultLanguageConfigurationOverridesNode.properties[r]=e}else{this.defaultValues[r]=o[r];const e=this.configurationProperties[r];e&&(this.updatePropertyDefaultValue(r,e),this.updateSchema(r,e))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}deregisterDefaultConfigurations(R){const I=[];for(const m of R)for(const o in m)if(I.push(o),delete this.defaultValues[o],t.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const r=this.configurationProperties[o];r&&(this.updatePropertyDefaultValue(o,r),this.updateSchema(o,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}notifyConfigurationSchemaUpdated(...R){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(R){for(const I of R)this.overrideIdentifiers.add(I);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(R,I=!0,m,o=3){var r;o=L.isUndefinedOrNull(R.scope)?o:R.scope;let e=[],i=R.properties;if(i)for(let s in i){if(I&&u(s)){delete i[s];continue}const l=i[s];if(this.updatePropertyDefaultValue(s,l),t.OVERRIDE_PROPERTY_PATTERN.test(s)?l.scope=void 0:(l.scope=L.isUndefinedOrNull(l.scope)?o:l.scope,l.restricted=L.isUndefinedOrNull(l.restricted)?!!((r=m==null?void 0:m.restrictedConfigurations)===null||r===void 0?void 0:r.includes(s)):l.restricted),i[s].hasOwnProperty("included")&&!i[s].included){this.excludedConfigurationProperties[s]=i[s],delete i[s];continue}else this.configurationProperties[s]=i[s];!i[s].deprecationMessage&&i[s].markdownDeprecationMessage&&(i[s].deprecationMessage=i[s].markdownDeprecationMessage),e.push(s)}let n=R.allOf;if(n)for(let s of n)e.push(...this.validateAndRegisterProperties(s,I,m,o));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(R){const I=m=>{let o=m.properties;if(o)for(const e in o)this.updateSchema(e,o[e]);let r=m.allOf;r&&r.forEach(I)};I(R)}updateSchema(R,I){switch(t.allSettings.properties[R]=I,I.scope){case 1:t.applicationSettings.properties[R]=I;break;case 2:t.machineSettings.properties[R]=I;break;case 6:t.machineOverridableSettings.properties[R]=I;break;case 3:t.windowSettings.properties[R]=I;break;case 4:t.resourceSettings.properties[R]=I;break;case 5:t.resourceSettings.properties[R]=I,this.resourceLanguageSettingsSchema.properties[R]=I;break}}removeFromSchema(R,I){switch(delete t.allSettings.properties[R],I.scope){case 1:delete t.applicationSettings.properties[R];break;case 2:delete t.machineSettings.properties[R];break;case 6:delete t.machineOverridableSettings.properties[R];break;case 3:delete t.windowSettings.properties[R];break;case 4:case 5:delete t.resourceSettings.properties[R];break}}updateOverridePropertyPatternKey(){for(const R of this.overrideIdentifiers.values()){const I=`[${R}]`,m={type:"object",description:d.localize(2,null),errorMessage:d.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(I,m),t.allSettings.properties[I]=m,t.applicationSettings.properties[I]=m,t.machineSettings.properties[I]=m,t.machineOverridableSettings.properties[I]=m,t.windowSettings.properties[I]=m,t.resourceSettings.properties[I]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(R,I){let m=this.defaultValues[R];L.isUndefined(m)&&(m=I.default),L.isUndefined(m)&&(m=v(I.type)),I.default=m}}const C="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(C);function y(w){return w.substring(1,w.length-1)}t.overrideIdentifierFromKey=y;function v(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=v;const O=new f;b.Registry.add(t.Extensions.Configuration,O);function u(w){return w.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(w)?d.localize(5,null,w):O.getConfigurationProperties()[w]!==void 0?d.localize(6,null,w):null:d.localize(4,null)}t.validateProperty=u;function h(){const w=[],R=O.getConfigurationProperties();for(const I of Object.keys(R))w.push([I,R[I].scope]);return w.push(["launch",4]),w.push(["task",4]),w}t.getScopes=h}),define(Q[26],Z([0,1,20,12,7,25,11,30]),function(_,t,d,F,b,L,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,T.createDecorator)("configurationService");function c(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof b.URI)}t.isConfigurationOverrides=c;var f;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(f=t.ConfigurationTarget||(t.ConfigurationTarget={}));function C(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=C;function y(i,n){const s=n?i?n.keys.filter(V=>i.keys.indexOf(V)===-1):[...n.keys]:[],l=i?n?i.keys.filter(V=>n.keys.indexOf(V)===-1):[...i.keys]:[],p=[];if(n&&i){for(const V of i.keys)if(n.keys.indexOf(V)!==-1){const q=R(i.contents,V),J=R(n.contents,V);d.equals(q,J)||p.push(V)}}const E=[],U=V=>{const q={};for(const J of V)for(const ie of J.identifiers)q[r(ie)]=J;return q},A=n?U(n.overrides):{},j=i?U(i.overrides):{};if(Object.keys(A).length)for(const V of s){const q=A[V];q&&E.push([(0,D.overrideIdentifierFromKey)(V),q.keys])}if(Object.keys(j).length)for(const V of l){const q=j[V];q&&E.push([(0,D.overrideIdentifierFromKey)(V),q.keys])}if(Object.keys(A).length&&Object.keys(j).length)for(const V of p){const q=j[V],J=A[V];if(q&&J){const ie=y({contents:q.contents,keys:q.keys,overrides:[]},{contents:J.contents,keys:J.keys,overrides:[]});E.push([(0,D.overrideIdentifierFromKey)(V),[...ie.added,...ie.removed,...ie.updated]])}}return{added:s,removed:l,updated:p,overrides:E}}t.compare=y;function v(i,n){const s=[];for(const l of Object.keys(i))if(D.OVERRIDE_PROPERTY_PATTERN.test(l)){const p={};for(const E in i[l])p[E]=i[l][E];s.push({identifiers:[(0,D.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(p),contents:O(p,n)})}return s}t.toOverrides=v;function O(i,n){const s=Object.create(null);for(let l in i)u(s,l,i[l],n);return s}t.toValuesTree=O;function u(i,n,s,l){const p=n.split("."),E=p.pop();let U=i;for(let A=0;A<p.length;A++){let j=p[A],V=U[j];switch(typeof V){case"undefined":V=U[j]=Object.create(null);break;case"object":break;default:l(`Ignoring ${n} as ${p.slice(0,A+1).join(".")} is ${JSON.stringify(V)}`);return}U=V}if(typeof U=="object"&&U!==null)try{U[E]=s}catch(A){l(`Ignoring ${n} as ${p.join(".")} is ${JSON.stringify(U)}`)}else l(`Ignoring ${n} as ${p.join(".")} is ${JSON.stringify(U)}`)}t.addToValueTree=u;function h(i,n){const s=n.split(".");w(i,s)}t.removeFromValueTree=h;function w(i,n){const s=n.shift();if(n.length===0){delete i[s];return}if(Object.keys(i).indexOf(s)!==-1){const l=i[s];typeof l=="object"&&!Array.isArray(l)&&(w(l,n),Object.keys(l).length===0&&delete i[s])}}function R(i,n,s){function l(U,A){let j=U;for(const V of A){if(typeof j!="object"||j===null)return;j=j[V]}return j}const p=n.split("."),E=l(i,p);return typeof E=="undefined"?s:E}t.getConfigurationValue=R;function I(i,n,s){Object.keys(n).forEach(l=>{l!=="__proto__"&&(l in i?F.isObject(i[l])&&F.isObject(n[l])?I(i[l],n[l],s):s&&(i[l]=n[l]):i[l]=n[l])})}t.merge=I;function m(){const i=L.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=m;function o(){const i=Object.create(null),n=L.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let s in n){let l=n[s].default;u(i,s,l,p=>console.error(`Conflict in default settings: ${p}`))}return i}t.getDefaultValues=o;function r(i){return`[${i}]`}t.keyFromOverrideIdentifier=r;function e(i,n,s){const l=i.inspect(n),p=i.inspect(s);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:l.defaultValue}t.getMigratedSettingValue=e}),define(Q[109],Z([0,1,58,45,22,12,20,7,30,26,25,2,10]),function(_,t,d,F,b,L,T,D,c,f,C,y,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class O{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,f.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,f.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const s of b.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[s],p=i[s];p&&(typeof l=="object"&&typeof p=="object"?(l=T.deepClone(l),this.mergeContents(l,p)):l=p),n[s]=l}return new O(n,this.keys,this.overrides)}merge(...e){const i=T.deepClone(this.contents),n=T.deepClone(this.overrides),s=[...this.keys];for(const l of e){this.mergeContents(i,l.contents);for(const p of l.overrides){const[E]=n.filter(U=>b.equals(U.identifiers,p.identifiers));E?this.mergeContents(E.contents,p.contents):n.push(T.deepClone(p))}for(const p of l.keys)s.indexOf(p)===-1&&s.push(p)}return new O(i,s,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&L.isObject(e[n])&&L.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=T.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?T.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,f.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,f.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=O;class u extends O{constructor(){const e=(0,f.getDefaultValues)(),i=(0,f.getConfigurationKeys)(),n=[];for(const s of Object.keys(e))c.OVERRIDE_PROPERTY_PATTERN.test(s)&&n.push({identifiers:[(0,c.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(e[s]),contents:(0,f.toValuesTree)(e[s],l=>console.error(`Conflict in default settings file: ${l}`))});super(e,i,n)}}t.DefaultConfigurationModel=u;class h{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new O}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!L.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:s,overrides:l,restricted:p}=this.doParseRaw(e,i);this._configurationModel=new O(n,s,l),this._restrictedConfigurations=p||[]}doParseContent(e){let i={},n=null,s=[],l=[],p=[];function E(A){Array.isArray(s)?s.push(A):n&&(s[n]=A)}let U={onObjectBegin:()=>{let A={};E(A),l.push(s),s=A,n=null},onObjectProperty:A=>{n=A},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{let A=[];E(A),l.push(s),s=A,n=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:E,onError:(A,j,V)=>{p.push({error:A,offset:j,length:V})}};if(e)try{d.visit(e,U),i=s[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return i}doParseRaw(e,i){const n=C.Registry.as(c.Extensions.Configuration).getConfigurationProperties(),s=this.filter(e,n,!0,i);e=s.raw;const l=(0,f.toValuesTree)(e,U=>console.error(`Conflict in settings file ${this._name}: ${U}`)),p=Object.keys(e),E=(0,f.toOverrides)(e,U=>console.error(`Conflict in settings file ${this._name}: ${U}`));return{contents:l,keys:p,overrides:E,restricted:s.restricted}}filter(e,i,n,s){if(!(s==null?void 0:s.scopes)&&!(s==null?void 0:s.skipRestricted))return{raw:e,restricted:[]};const l={},p=[];for(let E in e)if(c.OVERRIDE_PROPERTY_PATTERN.test(E)&&n){const U=this.filter(e[E],i,!1,s);l[E]=U.raw,p.push(...U.restricted)}else{const U=i[E],A=U?typeof U.scope!="undefined"?U.scope:3:void 0;(U==null?void 0:U.restricted)&&p.push(E),(A===void 0||s.scopes===void 0||s.scopes.includes(A))&&(s.skipRestricted&&(U==null?void 0:U.restricted)||(l[E]=e[E]))}return{raw:l,restricted:p}}}t.ConfigurationModelParser=h;class w extends y.Disposable{constructor(e,i,n,s){super();this.userSettingsResource=e,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(v.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new O}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=w;class R{constructor(e,i,n=new O,s=new O,l=new F.ResourceMap,p=new O,E=new F.ResourceMap,U=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=l,this._memoryConfiguration=p,this._memoryConfigurationByResource=E,this._freeze=U,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new O,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(e):s.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const s=this.getConsolidateConfigurationModel(i,n),l=this.getFolderConfigurationModelForResource(i.resource,n),p=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,E=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),U=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),A=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),j=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),V=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,q=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(e):l.freeze().getValue(e):void 0,J=i.overrideIdentifier?p.override(i.overrideIdentifier).getValue(e):p.getValue(e),ie=s.getValue(e),ne=b.distinct(b.flatten(s.overrides.map(te=>te.identifiers))).filter(te=>s.getOverrideValue(e,te)!==void 0);return{defaultValue:E,userValue:U,userLocalValue:A,userRemoteValue:j,workspaceValue:V,workspaceFolderValue:q,memoryValue:J,value:ie,default:E!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:U!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:j!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:V!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:q!==void 0?{value:l==null?void 0:l.freeze().getValue(e),override:i.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:J!==void 0?{value:p.getValue(e),override:i.overrideIdentifier?p.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ne.length?ne:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(s=>c.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const l=(0,c.overrideIdentifierFromKey)(s),p=this._defaultConfiguration.getKeysForOverrideIdentifier(l),E=e.getKeysForOverrideIdentifier(l),U=[...E.filter(A=>p.indexOf(A)===-1),...p.filter(A=>E.indexOf(A)===-1),...p.filter(A=>!T.equals(this._defaultConfiguration.override(l).getValue(A),e.override(l).getValue(A)))];return[l,U]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:l}=(0,f.compare)(this.localUserConfiguration,e),p=[...i,...n,...s];return p.length&&this.updateLocalUserConfiguration(e),{keys:p,overrides:l}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:l}=(0,f.compare)(this.remoteUserConfiguration,e);let p=[...i,...n,...s];return p.length&&this.updateRemoteUserConfiguration(e),{keys:p,overrides:l}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:s,overrides:l}=(0,f.compare)(this.workspaceConfiguration,e);let p=[...i,...n,...s];return p.length&&this.updateWorkspaceConfiguration(e),{keys:p,overrides:l}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:s,updated:l,removed:p,overrides:E}=(0,f.compare)(n,i);let U=[...s,...l,...p];return(U.length||!n)&&this.updateFolderConfiguration(e,i),{keys:U,overrides:E}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:s,removed:l,overrides:p}=(0,f.compare)(i,void 0);return{keys:[...n,...s,...l],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const s=i.getFolder(e);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const l=this._memoryConfigurationByResource.get(e);l&&(n=n.merge(l))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(e);s?(i=n.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:s,keys:l}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:s,keys:l}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),s=this.parseConfigurationModel(e.workspace),l=e.folders.reduce((p,E)=>(p.set(D.URI.revive(E[0]),this.parseConfigurationModel(E[1])),p),new F.ResourceMap);return new R(i,n,new O,s,l,new O,new F.ResourceMap,!1)}static parseConfigurationModel(e){return new O(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=R;function I(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,i=new Map;for(const s of r)s.keys.forEach(l=>e.add(l)),s.overrides.forEach(([l,p])=>{const E=(0,F.getOrSet)(i,l,new Set);p.forEach(U=>E.add(U))});const n=[];return i.forEach((s,l)=>n.push([l,[...s.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=I;class m{constructor(e,i,n,s){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=s,this._previousConfiguration=void 0;const l=new Set;e.keys.forEach(E=>l.add(E)),e.overrides.forEach(([,E])=>E.forEach(U=>l.add(U))),this.affectedKeys=[...l.values()];const p=new O;this.affectedKeys.forEach(E=>p.setValue(E,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=R.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(e,i,(n=this.previous)===null||n===void 0?void 0:n.workspace):void 0,l=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!T.equals(s,l)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,f.toValuesTree)({[i]:!0},()=>{}),s;for(;typeof n=="object"&&(s=Object.keys(n)[0]);){if(e=e[s],!e)return!1;n=n[s]}return!0}}t.ConfigurationChangeEvent=m;class o extends m{constructor(e,i,n,s){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=s}}t.AllKeysConfigurationChangeEvent=o}),define(Q[110],Z([0,1,25,30,2,26,109,10,4,17]),function(_,t,d,F,b,L,T,D,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class C extends b.Disposable{constructor(v,O){super();this.settingsResource=v,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,f.extUriBiasedIgnorePathCase,O)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new c.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(d.Registry.as(F.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const v=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,v)}getConfigurationData(){return this.configuration.toData()}getValue(v,O){const u=typeof v=="string"?v:void 0,h=(0,L.isConfigurationOverrides)(v)?v:(0,L.isConfigurationOverrides)(O)?O:{};return this.configuration.getValue(u,h,void 0)}updateValue(v,O,u,h){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const O=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(u,O,1)}onDidDefaultConfigurationChange(v){const O=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,v);this.trigger(u,O,6)}trigger(v,O,u){const h=new T.ConfigurationChangeEvent(v,{data:O},this.configuration);h.source=u,h.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(v){switch(v){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=C}),define(Q[55],Z([0,1,83,11,30,25,16]),function(_,t,d,F,b,L,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,F.createDecorator)("requestService");function D(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}t.isSuccess=D;function c(u){return u.res.statusCode===204}async function f(u){if(!D(u))throw new Error("Server returned "+u.res.statusCode);return c(u)?null:(await(0,T.streamToBuffer)(u.stream)).toString()}t.asText=f;async function C(u){if(!D(u))throw new Error("Server returned "+u.res.statusCode);if(c(u))return null;const w=(await(0,T.streamToBuffer)(u.stream)).toString();try{return JSON.parse(w)}catch(R){throw R.message+=`:
`+w,R}}t.asJson=C;function y(u){O(u)}t.updateProxyConfigurationsScope=y;let v;function O(u){const h=L.Registry.as(b.Extensions.Configuration);v&&h.deregisterConfigurations([v]),v={id:"http",order:15,title:(0,d.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,d.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,d.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,d.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,d.localize)(4,null),(0,d.localize)(5,null),(0,d.localize)(6,null),(0,d.localize)(7,null)],default:"override",description:(0,d.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,d.localize)(9,null),restricted:!0}}},h.registerConfiguration(v)}O(2)}),define(Q[111],Z([0,1,112,12]),function(_,t,d,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function b(T,D){return T.protocol==="http:"?D.HTTP_PROXY||D.http_proxy||null:T.protocol==="https:"&&(D.HTTPS_PROXY||D.https_proxy||D.HTTP_PROXY||D.http_proxy)||null}async function L(T,D,c={}){const f=(0,d.parse)(T),C=c.proxyUrl||b(f,D);if(!C)return null;const y=(0,d.parse)(C);if(!/^https?:$/.test(y.protocol||""))return null;const v={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,F.isBoolean)(c.strictSSL)?c.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((O,u)=>{_(["http-proxy-agent"],O,u)}))(v):new(await new Promise((O,u)=>{_(["https-proxy-agent"],O,u)}))(v)}t.getProxyAgent=L}),define(Q[113],Z([0,1,29,16]),function(_,t,d,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function b(L,T,D){let c=D&&D.get("storage.serviceMachineId",0)||null;if(c)return c;try{const C=(await T.readFile(L.serviceMachineIdResource)).value.toString();c=(0,d.isUUID)(C)?C:null}catch(f){c=null}if(!c){c=(0,d.generateUuid)();try{await T.writeFile(L.serviceMachineIdResource,F.VSBuffer.fromString(c))}catch(f){}}return D&&D.store("storage.serviceMachineId",c,0,1),c}t.getServiceMachineId=b}),define(Q[114],Z([0,1,11,10,2,12,66,4]),function(_,t,d,F,b,L,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const c="__$__targetStorageMarker";t.IStorageService=(0,d.createDecorator)("storageService");var f;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(f=t.WillSaveStateReason||(t.WillSaveStateReason={}));var C;(function(h){h[h.GLOBAL=0]="GLOBAL",h[h.WORKSPACE=1]="WORKSPACE"})(C=t.StorageScope||(t.StorageScope={}));var y;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(y=t.StorageTarget||(t.StorageTarget={}));class v extends b.Disposable{constructor(w={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super();this.options=w,this._onDidChangeValue=this._register(new F.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new F.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new F.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(w,R){R===c?(w===0?this._globalKeyTargets=void 0:w===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:w})):this._onDidChangeValue.fire({scope:w,key:R,target:this.getKeyTargets(w)[R]})}emitWillSaveState(w){this._onWillSaveState.fire({reason:w})}get(w,R,I){var m;return(m=this.getStorage(R))===null||m===void 0?void 0:m.get(w,I)}getBoolean(w,R,I){var m;return(m=this.getStorage(R))===null||m===void 0?void 0:m.getBoolean(w,I)}getNumber(w,R,I){var m;return(m=this.getStorage(R))===null||m===void 0?void 0:m.getNumber(w,I)}store(w,R,I,m){if((0,L.isUndefinedOrNull)(R)){this.remove(w,I);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(w,I,m),(o=this.getStorage(I))===null||o===void 0||o.set(w,R)})}remove(w,R){this.withPausedEmitters(()=>{var I;this.updateKeyTarget(w,R,void 0),(I=this.getStorage(R))===null||I===void 0||I.delete(w)})}withPausedEmitters(w){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{w()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(w,R){const I=[],m=this.getKeyTargets(w);for(const o of Object.keys(m))m[o]===R&&I.push(o);return I}updateKeyTarget(w,R,I){var m,o;const r=this.getKeyTargets(R);typeof I=="number"?r[w]!==I&&(r[w]=I,(m=this.getStorage(R))===null||m===void 0||m.set(c,JSON.stringify(r))):typeof r[w]=="number"&&(delete r[w],(o=this.getStorage(R))===null||o===void 0||o.set(c,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(w){return w===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(w){const R=this.get(c,w);if(R)try{return JSON.parse(R)}catch(I){}return Object.create(null)}isNew(w){return this.getBoolean(t.IS_NEW_KEY,w)===!0}async flush(){var w,R,I,m;this._onWillSaveState.fire({reason:f.NONE}),await D.Promises.settled([(R=(w=this.getStorage(0))===null||w===void 0?void 0:w.whenFlushed())!==null&&R!==void 0?R:Promise.resolve(),(m=(I=this.getStorage(1))===null||I===void 0?void 0:I.whenFlushed())!==null&&m!==void 0?m:Promise.resolve()])}async logStorage(){var w,R,I,m,o,r;const e=(R=(w=this.getStorage(0))===null||w===void 0?void 0:w.items)!==null&&R!==void 0?R:new Map,i=(m=(I=this.getStorage(1))===null||I===void 0?void 0:I.items)!==null&&m!==void 0?m:new Map;return u(e,i,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(r=this.getLogDetails(1))!==null&&r!==void 0?r:"")}}t.AbstractStorageService=v,v.DEFAULT_FLUSH_INTERVAL=60*1e3;class O extends v{constructor(){super();this.globalStorage=new T.Storage(new T.InMemoryStorageDatabase),this.workspaceStorage=new T.Storage(new T.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(w=>this.emitDidChangeValue(1,w))),this._register(this.globalStorage.onDidChangeStorage(w=>this.emitDidChangeValue(0,w)))}getStorage(w){return w===0?this.globalStorage:this.workspaceStorage}getLogDetails(w){return w===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(w){}}t.InMemoryStorageService=O;async function u(h,w,R,I){const m=l=>{try{return JSON.parse(l)}catch(p){return l}},o=new Map,r=new Map;h.forEach((l,p)=>{o.set(p,l),r.set(p,m(l))});const e=new Map,i=new Map;w.forEach((l,p)=>{e.set(p,l),i.set(p,m(l))}),console.group(`Storage: Global (path: ${R})`);let n=[];o.forEach((l,p)=>{n.push({key:p,value:l})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${I})`);let s=[];e.forEach((l,p)=>{s.push({key:p,value:l})}),console.table(s),console.groupEnd(),console.log(i)}t.logStorage=u}),define(Q[115],Z([0,1,14,34,29,7]),function(_,t,d,F,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function T(f){if(d.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}async function D(f,C,y,v,O,u,h,w,R,I){const m=Object.create(null);m["common.machineId"]=h,m.sessionID=(0,b.generateUuid)()+Date.now(),m.commitHash=O,m.version=u,m["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,d.PlatformToString)(d.platform),m["common.nodePlatform"]=F.platform,m["common.nodeArch"]=v,m["common.product"]=I||"desktop";const o=c(w||[]);o&&(m["common.msftInternal"]=o);let r=0;const e=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),d.isLinuxSnap&&(m["common.snap"]="true");const i=T(y);i&&(m["common.platformDetail"]=i);try{const n=await f.readFile(L.URI.file(R));m["common.source"]=n.value.toString().slice(0,30)}catch(n){}return m}t.resolveCommonProperties=D;function c(f){const C=F.env.USERDNSDOMAIN;if(!C)return!1;const y=C.toLowerCase();return f.some(v=>y===v)}t.verifyMicrosoftInternalDomain=c}),define(Q[42],Z([0,1,11]),function(_,t,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,d.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,d.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Q[116],Z([0,1,13,23,24,20,42,55,49,21,27,15,18,7,41,114,113,11,17]),function(_,t,d,F,b,L,T,D,c,f,C,y,v,O,u,h,w,R,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var m;(function(g){g[g.None=0]="None",g[g.IncludeVersions=1]="IncludeVersions",g[g.IncludeFiles=2]="IncludeFiles",g[g.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",g[g.IncludeSharedAccounts=8]="IncludeSharedAccounts",g[g.IncludeVersionProperties=16]="IncludeVersionProperties",g[g.ExcludeNonValidated=32]="ExcludeNonValidated",g[g.IncludeInstallationTargets=64]="IncludeInstallationTargets",g[g.IncludeAssetUri=128]="IncludeAssetUri",g[g.IncludeStatistics=256]="IncludeStatistics",g[g.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",g[g.Unpublished=4096]="Unpublished"})(m||(m={}));function o(...g){return String(g.reduce((a,S)=>a|S,0))}var r;(function(g){g[g.Tag=1]="Tag",g[g.ExtensionId=4]="ExtensionId",g[g.Category=5]="Category",g[g.ExtensionName=7]="ExtensionName",g[g.Target=8]="Target",g[g.Featured=9]="Featured",g[g.SearchText=10]="SearchText",g[g.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:m.None,criteria:[],assetTypes:[]};class l{constructor(a=s){this.state=a}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(a,S=this.state.pageSize){return new l(Object.assign(Object.assign({},this.state),{pageNumber:a,pageSize:S}))}withFilter(a,...S){const P=[...this.state.criteria,...S.length?S.map(N=>({filterType:a,value:N})):[{filterType:a}]];return new l(Object.assign(Object.assign({},this.state),{criteria:P}))}withSortBy(a){return new l(Object.assign(Object.assign({},this.state),{sortBy:a}))}withSortOrder(a){return new l(Object.assign(Object.assign({},this.state),{sortOrder:a}))}withFlags(...a){return new l(Object.assign(Object.assign({},this.state),{flags:a.reduce((S,P)=>S|P,0)}))}withAssetTypes(...a){return new l(Object.assign(Object.assign({},this.state),{assetTypes:a}))}get raw(){const{criteria:a,pageNumber:S,pageSize:P,sortBy:N,sortOrder:M,flags:W,assetTypes:B}=this.state;return{filters:[{criteria:a,pageNumber:S,pageSize:P,sortBy:N,sortOrder:M}],assetTypes:B,flags:W}}get searchText(){const a=this.state.criteria.filter(S=>S.filterType===r.SearchText)[0];return a&&a.value?a.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(a=>String(a.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function p(g,a){const S=(g||[]).filter(P=>P.statisticName===a)[0];return S?S.value:0}function E(g){const a="Microsoft.VisualStudio.Code.Translation.";return g.files.filter(P=>P.assetType.indexOf(a)===0).reduce((P,N)=>{const M=V(g,N.assetType);return M&&P.push([N.assetType.substring(a.length),M]),P},[])}function U(g){if(g.properties){const a=g.properties.filter(N=>N.key===e.Repository),S=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),P=a.filter(N=>S.test(N.value))[0];return P?{uri:P.value,fallbackUri:P.value}:null}return V(g,e.Repository)}function A(g){return{uri:`${g.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${g.fallbackAssetUri}/${e.VSIX}`}}function j(g){const a=V(g,e.Icon);if(a)return a;const S=F.DefaultIconPath;return{uri:S,fallbackUri:S}}function V(g,a){return g.files.filter(P=>P.assetType===a)[0]?{uri:`${g.assetUri}/${a}`,fallbackUri:`${g.fallbackAssetUri}/${a}`}:null}function q(g,a){const S=g.properties?g.properties.filter(N=>N.key===a):[],P=S.length>0&&S[0].value;return P?P.split(",").map(N=>(0,b.adoptToGalleryExtensionId)(N)):[]}function J(g){const a=g.properties?g.properties.filter(S=>S.key===i.Engine):[];return a.length>0&&a[0].value||""}function ie(g){const a=g.properties?g.properties.filter(P=>P.key===i.LocalizedLanguages):[],S=a.length>0&&a[0].value||"";return S?S.split(","):[]}function ne(g){return g.indexOf("preview")!==-1}function te(g){const a=g.properties?g.properties.find(S=>S.key===i.WebExtension):void 0;return!!a&&a.value==="true"}function ae(g){return g.files.some(a=>a.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,I.joinPath)(O.URI.parse(g.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function x(g,a,S,P,N){const M={manifest:V(a,e.Manifest),readme:V(a,e.Details),changelog:V(a,e.Changelog),license:V(a,e.License),repository:U(a),download:A(a),icon:j(a),coreTranslations:E(a)};return{identifier:{id:(0,b.getGalleryExtensionId)(g.publisher.publisherName,g.extensionName),uuid:g.extensionId},name:g.extensionName,version:a.version,date:a.lastUpdated,displayName:g.displayName,publisherId:g.publisher.publisherId,publisher:g.publisher.publisherName,publisherDisplayName:g.publisher.displayName,description:g.shortDescription||"",installCount:p(g.statistics,"install"),rating:p(g.statistics,"averagerating"),ratingCount:p(g.statistics,"ratingcount"),assetUri:O.URI.parse(a.assetUri),webResource:ae(a),assetTypes:a.files.map(({assetType:W})=>W),assets:M,properties:{dependencies:q(a,i.Dependency),extensionPack:q(a,i.ExtensionPack),engine:J(a),localizedLanguages:ie(a),webExtension:te(a)},telemetryData:{index:(P.pageNumber-1)*P.pageSize+S,querySource:N},preview:ne(g.flags)}}let G=class{constructor(a,S,P,N,M,W,B){this.requestService=a,this.logService=S,this.environmentService=P,this.telemetryService=N,this.fileService=M,this.productService=W;const $=W.extensionsGallery;this.extensionsGalleryUrl=$&&$.serviceUrl,this.extensionsControlUrl=$&&$.controlUrl,this.commonHeadersPromise=k(W.version,this.environmentService,this.fileService,B)}api(a=""){return`${this.extensionsGalleryUrl}${a}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(a,S){const P=[];let{total:N,firstPage:M,getPage:W}=await this.query({names:a,pageSize:a.length},S);P.push(...M);for(let B=1;P.length<N&&(M=await W(B,S),M.length);B++)P.push(...M);return P}async getCompatibleExtension(a,S){const P=await this.getCompatibleExtensionByEngine(a,S);return(P==null?void 0:P.properties.webExtension)?P.webResource?P:null:P}async getCompatibleExtensionByEngine(a,S){const P=(0,F.isIExtensionIdentifier)(a)?null:a;if(P&&P.properties.engine&&(0,c.isEngineValid)(P.properties.engine,this.productService.version,this.productService.date))return P;const{id:N,uuid:M}=P?P.identifier:a;let W=new l().withFlags(m.IncludeAssetUri,m.IncludeStatistics,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");M?W=W.withFilter(r.ExtensionId,M):W=W.withFilter(r.ExtensionName,N);const{galleryExtensions:B}=await this.queryGallery(W,C.CancellationToken.None),[$]=B;if(!$||!$.versions.length)return null;if(S){const Y=$.versions.filter(ee=>ee.version===S)[0];if(Y){const ee=x($,Y,0,W);if(ee.properties.engine&&(0,c.isEngineValid)(ee.properties.engine,this.productService.version,this.productService.date))return ee}return null}const X=await this.getLastValidExtensionVersion($,$.versions);return X?x($,X,0,W):null}async query(a,S){const P=C.CancellationToken.isCancellationToken(a)?{}:a,N=C.CancellationToken.isCancellationToken(a)?a:S;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let M=P.text||"";const W=(0,L.getOrDefault)(P,re=>re.pageSize,50);let B=new l().withFlags(m.IncludeLatestVersionOnly,m.IncludeAssetUri,m.IncludeStatistics,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,W).withFilter(r.Target,"Microsoft.VisualStudio.Code");M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,ce,ge)=>(B=B.withFilter(r.Category,ge||ce),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,ce,ge)=>(B=B.withFilter(r.Tag,ge||ce),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(r.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),B=B.withFilter(r.SearchText,M)),B=B.withSortBy(0)):P.ids?B=B.withFilter(r.ExtensionId,...P.ids):P.names?B=B.withFilter(r.ExtensionName,...P.names):B=B.withSortBy(4),typeof P.sortBy=="number"&&(B=B.withSortBy(P.sortBy)),typeof P.sortOrder=="number"&&(B=B.withSortOrder(P.sortOrder));const{galleryExtensions:$,total:X}=await this.queryGallery(B,N),Y=$.map((re,ce)=>x(re,re.versions[0],ce,B,P.source)),ee=async(re,ce)=>{if(ce.isCancellationRequested)throw(0,d.canceled)();const ge=B.withPage(re+1),{galleryExtensions:Pe}=await this.queryGallery(ge,ce);return Pe.map((Fe,Oe)=>x(Fe,Fe.versions[0],Oe,ge,P.source))};return{firstPage:Y,total:X,pageSize:B.pageSize,getPage:ee}}async queryGallery(a,S){if(!this.isEnabled())throw new Error("No extension gallery service configured.");a=a.withFlags(a.flags,m.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,o(m.Unpublished));const P=await this.commonHeadersPromise,N=JSON.stringify(a.raw),M=Object.assign(Object.assign({},P),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(N.length)}),W=new Date().getTime();let B,$,X=0;try{if(B=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:N,headers:M},S),B.res.statusCode&&B.res.statusCode>=400&&B.res.statusCode<500)return{galleryExtensions:[],total:X};const Y=await(0,D.asJson)(B);if(Y){const ee=Y.results[0],re=ee.extensions,ce=ee.resultMetadata&&ee.resultMetadata.filter(ge=>ge.metadataType==="ResultCount")[0];return X=ce&&ce.metadataItems.filter(ge=>ge.name==="TotalCount")[0].count||0,{galleryExtensions:re,total:X}}return{galleryExtensions:[],total:X}}catch(Y){throw $=Y,Y}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},a.telemetryData),{requestBodySize:String(N.length),duration:new Date().getTime()-W,success:!!B&&(0,D.isSuccess)(B),responseBodySize:B==null?void 0:B.res.headers["Content-Length"],statusCode:B?String(B.res.statusCode):void 0,errorCode:$?(0,d.isPromiseCanceledError)($)?"canceled":(0,d.getErrorMessage)($).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(X)}))}}async reportStatistic(a,S,P,N){if(!this.isEnabled())return;const M=await this.commonHeadersPromise,W=Object.assign(Object.assign({},M),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${a}/extensions/${S}/${P}/stats?statType=${N}`),headers:W},C.CancellationToken.None)}catch(B){}}async download(a,S,P){this.logService.trace("ExtensionGalleryService#download",a.identifier.id);const N=(0,b.getGalleryExtensionTelemetryData)(a),M=new Date().getTime(),W=Y=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},N),{duration:Y})),B=P===1?"install":P===2?"update":"",$=B?{uri:`${a.assets.download.uri}&${B}=true`,fallbackUri:`${a.assets.download.fallbackUri}?${B}=true`}:a.assets.download,X=await this.getAsset($);await this.fileService.writeFile(S,X.stream),W(new Date().getTime()-M)}async getReadme(a,S){if(a.assets.readme){const P=await this.getAsset(a.assets.readme,{},S);return await(0,D.asText)(P)||""}return""}async getManifest(a,S){if(a.assets.manifest){const P=await this.getAsset(a.assets.manifest,{},S),N=await(0,D.asText)(P);return N?JSON.parse(N):null}return null}async getCoreTranslation(a,S){const P=a.assets.coreTranslations.filter(N=>N[0]===S.toUpperCase())[0];if(P){const N=await this.getAsset(P[1]),M=await(0,D.asText)(N);return M?JSON.parse(M):null}return null}async getChangelog(a,S){if(a.assets.changelog){const P=await this.getAsset(a.assets.changelog,{},S);return await(0,D.asText)(P)||""}return""}async getAllVersions(a,S){let P=new l().withFlags(m.IncludeVersions,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");a.identifier.uuid?P=P.withFilter(r.ExtensionId,a.identifier.uuid):P=P.withFilter(r.ExtensionName,a.identifier.id);const N=[],{galleryExtensions:M}=await this.queryGallery(P,C.CancellationToken.None);return M.length&&(S?await Promise.all(M[0].versions.map(async W=>{let B;try{B=await this.getEngine(W)}catch($){}B&&(0,c.isEngineValid)(B,this.productService.version,this.productService.date)&&N.push({version:W.version,date:W.lastUpdated})})):N.push(...M[0].versions.map(W=>({version:W.version,date:W.lastUpdated})))),N}async getAsset(a,S={},P=C.CancellationToken.None){const N=await this.commonHeadersPromise,M={type:"GET"},W=Object.assign(Object.assign({},N),S.headers||{});S=Object.assign(Object.assign(Object.assign({},S),M),{headers:W});const B=a.uri,$=a.fallbackUri,X=Object.assign(Object.assign({},S),{url:B});try{const Y=await this.requestService.request(X,P);if(Y.res.statusCode===200)return Y;const ee=await(0,D.asText)(Y);throw new Error(`Expected 200, got back ${Y.res.statusCode} instead.

${ee}`)}catch(Y){if((0,d.isPromiseCanceledError)(Y))throw Y;const ee=(0,d.getErrorMessage)(Y);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:B,message:ee});const re=Object.assign(Object.assign({},S),{url:$});return this.requestService.request(re,P)}}async getLastValidExtensionVersion(a,S){const P=this.getLastValidExtensionVersionFromProperties(a,S);return P||this.getLastValidExtensionVersionRecursively(a,S)}getLastValidExtensionVersionFromProperties(a,S){for(const P of S){const N=J(P);if(!N)return null;if((0,c.isEngineValid)(N,this.productService.version,this.productService.date))return P}return null}async getEngine(a){const S=J(a);if(S)return S;const P=V(a,e.Manifest);if(!P)throw new Error("Manifest was not found");const N={"Accept-Encoding":"gzip"},M=await this.getAsset(P,{headers:N}),W=await(0,D.asJson)(M);if(W)return W.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(a,S){if(!S.length)return null;const P=S[0],N=await this.getEngine(P);return(0,c.isEngineValid)(N,this.productService.version,this.productService.date)?(P.properties=P.properties||[],P.properties.push({key:i.Engine,value:N}),P):this.getLastValidExtensionVersionRecursively(a,S.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const a=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},C.CancellationToken.None);if(a.res.statusCode!==200)throw new Error("Could not get extensions report.");const S=await(0,D.asJson)(a),P=new Map;if(S)for(const N of S.malicious){const M=P.get(N)||{id:{id:N},malicious:!0,slow:!1};M.malicious=!0,P.set(N,M)}return[...P.values()]}};G=ue([fe(0,D.IRequestService),fe(1,y.ILogService),fe(2,f.IEnvironmentService),fe(3,T.ITelemetryService),fe(4,v.IFileService),fe(5,u.IProductService),fe(6,(0,R.optional)(h.IStorageService))],G),t.ExtensionGalleryService=G;async function k(g,a,S,P){const N={"X-Market-Client-Id":`VSCode ${g}`,"User-Agent":`VSCode ${g}`},M=await(0,w.getServiceMachineId)(a,S,P);return N["X-Market-User-Id"]=M,N}t.resolveMarketplaceHeaders=k}),define(Q[117],Z([0,1,40,84,19,11,26,30,2,20,25]),function(_,t,d,F,b,L,T,D,c,f,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let y=class{constructor(u,h){this._configurationService=h,this._experimentProperties={},this._disposables=new c.DisposableStore,this._cleanupPatterns=[],this._appender=u.appender,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,b.escapeRegExpCharacters)(w),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(w=>{const R=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!R})}))}setExperimentProperty(u,h){this._experimentProperties[u]=h}setEnabled(u){this._enabled=u}_updateUserOptIn(){var u;const h=(u=this._configurationService)===null||u===void 0?void 0:u.getValue(v);this._userOptIn=h?h.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const u=await this._commonProperties;let h=u.sessionID,w=u["common.instanceId"],R=u["common.machineId"],I=u["common.firstSessionDate"],m=u["common.msftInternal"];return{sessionId:h,instanceId:w,machineId:R,firstSessionDate:I,msftInternal:m}}dispose(){this._disposables.dispose()}publicLog(u,h,w){return this.isOptedIn?this._commonProperties.then(R=>{h=(0,f.mixin)(h,R),h=(0,f.mixin)(h,this._experimentProperties),h=(0,f.cloneAndChange)(h,I=>{if(typeof I=="string")return this._cleanupInfo(I,w)}),this._appender.log(u,h)},R=>{console.error(R)}):Promise.resolve(void 0)}publicLog2(u,h,w){return this.publicLog(u,h,w)}publicLogError(u,h){return this.sendErrorTelemetry?this.publicLog(u,h,!0):Promise.resolve(void 0)}publicLogError2(u,h){return this.publicLogError(u,h)}_cleanupInfo(u,h){let w=u;if(h){const R=[];for(let r of this._cleanupPatterns)for(;;){const e=r.exec(u);if(!e)break;R.push([e.index,r.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(w="";;){const r=m.exec(u);if(!r)break;!I.test(r[0])&&R.every(([e,i])=>r.index<e||r.index>=i)&&(w+=u.substring(o,r.index)+"<REDACTED: user-file-path>",o=m.lastIndex)}o<u.length&&(w+=u.substr(o))}for(let R of this._cleanupPatterns)w=w.replace(R,"");return w}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=ue([fe(1,(0,L.optional)(T.IConfigurationService))],y),t.TelemetryService=y;const v="telemetry";C.Registry.as(D.Extensions.Configuration).registerConfiguration({id:v,order:110,type:"object",title:(0,F.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,F.localize)(2,null,d.default.privacyStatementUrl):(0,F.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Q[56],Z([0,1,26,20,12,4]),function(_,t,d,F,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(u,h){return Promise.resolve(void 0)}publicLog2(u,h){return this.publicLog(u,h)}publicLogError(u,h){return Promise.resolve(void 0)}publicLogError2(u,h){return this.publicLogError(u,h)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class T{async publicLog(h,w,R){}async publicLogError(h,w,R){}}t.NullEndpointTelemetryService=T;function D(...u){return{log:(h,w)=>u.forEach(R=>R.log(h,w)),flush:()=>L.Promises.settled(u.map(h=>h.flush()))}}t.combinedAppender=D,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(u,h){return h.onDidChangeConfiguration(w=>{w.source!==6&&u.publicLog2("updateConfiguration",{configurationSource:(0,d.ConfigurationTargetToString)(w.source),configurationKeys:v(w.sourceConfig)})})}t.configurationTelemetry=c;function f(u){const h=Object.create(null),w=Object.create(null),R=Object.create(null);y(u,R);for(let I in R){I=I.length>150?I.substr(I.length-149):I;const m=R[I];typeof m=="number"?w[I]=m:typeof m=="boolean"?w[I]=m?1:0:typeof m=="string"?h[I]=m.substring(0,1023):typeof m!="undefined"&&m!==null&&(h[I]=m)}return{properties:h,measurements:w}}t.validateTelemetryData=f;function C(u){if(!u)return"none";let h="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(R=>{u.indexOf(`${R}+`)===0&&(h=R)}),h}t.cleanRemoteAuthority=C;function y(u,h,w=0,R){if(!!u)for(let I of Object.getOwnPropertyNames(u)){const m=u[I],o=R?R+I:I;Array.isArray(m)?h[o]=(0,F.safeStringify)(m):m instanceof Date?h[o]=m.toISOString():(0,b.isObject)(m)?w<2?y(m,h,w+1,o+"."):h[o]=(0,F.safeStringify)(m):h[o]=m}}function v(u){if(!u)return[];const h=[];return O(h,"",u),h}function O(u,h,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(R=>O(u,h?`${h}.${R}`:R,w[R])):u.push(h)}}),define(Q[118],Z([0,1,13,20,56]),function(_,t,d,F,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function L(D){const c=await new Promise((C,y)=>{_(["applicationinsights"],C,y)});let f;return c.defaultClient?(f=new c.TelemetryClient(D),f.channel.setUseDiskRetryCaching(!0)):(c.setup(D).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),f=c.defaultClient),D.indexOf("AIF-")===0&&(f.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),f}class T{constructor(c,f,C){this._eventPrefix=c,this._defaultData=f,this._defaultData||(this._defaultData=Object.create(null)),typeof C=="function"?this._aiClient=C():this._aiClient=C,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(f=>{c(f)},f=>{(0,d.onUnexpectedError)(f),console.error(f)})}}log(c,f){!this._aiClient||(f=(0,F.mixin)(f,this._defaultData),f=(0,b.validateTelemetryData)(f),this._withAIClient(C=>C.trackEvent({name:this._eventPrefix+"/"+c,properties:f.properties,measurements:f.measurements})))}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(f=>{f.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=T}),define(Q[119],Z([0,1,9,31,3]),function(_,t,d,F,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;function L(T,D){const c=Object.create(null),f=(y,v)=>{const O=JSON.parse(y);c[v]=O};if(D){const y=(0,d.readdirSync)(D).filter(O=>{try{return(0,F.statSync)((0,b.join)(D,O)).isDirectory()}catch(u){return!1}}),v=[];y.forEach(O=>{(0,d.readdirSync)((0,b.join)(D,O)).filter(h=>h==="telemetry.json").length===1&&v.push(O)}),v.forEach(O=>{const u=(0,F.readFileSync)((0,b.join)(D,O,"telemetry.json")).toString();f(u,O)})}let C=(0,F.readFileSync)((0,b.join)(T,"telemetry-core.json")).toString();return f(C,"vscode-core"),C=(0,F.readFileSync)((0,b.join)(T,"telemetry-extensions.json")).toString(),f(C,"vscode-extensions"),JSON.stringify(c,null,4)}t.buildTelemetryMessage=L}),define(Q[43],Z([0,1,72,3,31,4,9,130,131,12]),function(_,t,d,F,b,L,T,D,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class C extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=C;function y(r){const e=r.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function v(r){if(r instanceof C)return r;let e;return/end of central directory record signature not found/.test(r.message)&&(e="CorruptZip"),new C(e,r)}function O(r,e,i,n,s,l){const p=F.dirname(e),E=F.join(n,p);if(!E.startsWith(n))return Promise.reject(new Error(d.localize(0,null,e)));const U=F.join(n,e);let A;return l.onCancellationRequested(()=>{A&&A.destroy()}),Promise.resolve(T.Promises.mkdir(E,{recursive:!0})).then(()=>new Promise((j,V)=>{if(!l.isCancellationRequested)try{A=(0,b.createWriteStream)(U,{mode:i}),A.once("close",()=>j()),A.once("error",V),r.once("error",V),r.pipe(A)}catch(q){V(q)}}))}function u(r,e,i,n){let s=(0,L.createCancelablePromise)(()=>Promise.resolve()),l=0;return n.onCancellationRequested(()=>{s.cancel(),r.close()}),new Promise((p,E)=>{const U=new L.Sequencer,A=j=>{j.isCancellationRequested||(l++,r.readEntry())};r.once("error",E),r.once("close",()=>s.then(()=>{n.isCancellationRequested||r.entryCount===l?p():E(new C("Incomplete",new Error(d.localize(1,null,l,r.entryCount))))},E)),r.readEntry(),r.on("entry",j=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(j.fileName)){A(n);return}const V=j.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(V)){const ie=F.join(e,V);s=(0,L.createCancelablePromise)(ne=>T.Promises.mkdir(ie,{recursive:!0}).then(()=>A(ne)).then(void 0,E));return}const q=w(r,j),J=y(j);s=(0,L.createCancelablePromise)(ie=>U.queue(()=>q.then(ne=>O(ne,V,J,e,i,ie).then(()=>A(ie)))).then(null,E))})})}function h(r,e=!1){return new Promise((i,n)=>{(0,D.open)(r,e?{lazyEntries:!0}:void 0,(s,l)=>{s?n(v(s)):i((0,f.assertIsDefined)(l))})})}function w(r,e){return new Promise((i,n)=>{r.openReadStream(e,(s,l)=>{s?n(v(s)):i((0,f.assertIsDefined)(l))})})}function R(r,e){return new Promise((i,n)=>{const s=new c.ZipFile;e.forEach(p=>{p.contents?s.addBuffer(typeof p.contents=="string"?Buffer.from(p.contents,"utf8"):p.contents,p.path):p.localPath&&s.addFile(p.localPath,p.path)}),s.end();const l=(0,b.createWriteStream)(r);s.outputStream.pipe(l),s.outputStream.once("error",n),l.once("error",n),l.once("finish",()=>i(r))})}t.zip=R;function I(r,e,i={},n){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let l=h(r,!0);return i.overwrite&&(l=l.then(p=>(0,T.rimraf)(e).then(()=>p))),l.then(p=>u(p,e,{sourcePathRegex:s},n))}t.extract=I;function m(r,e){return h(r).then(i=>new Promise((n,s)=>{i.on("entry",l=>{l.fileName===e&&w(i,l).then(p=>n(p),p=>s(p))}),i.once("close",()=>s(new Error(d.localize(2,null,e))))}))}function o(r,e){return m(r,e).then(i=>new Promise((n,s)=>{const l=[];i.once("error",s),i.on("data",p=>l.push(p)),i.on("end",()=>n(Buffer.concat(l)))}))}t.buffer=o}),define(Q[120],Z([0,1,43,77]),function(_,t,d,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function b(L){return(0,d.buffer)(L,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch(D){throw new Error((0,F.localize)(0,null))}})}t.getManifest=b}),define(Q[121],Z([0,1,39,2,9,3,15,23,24,4,7,21,89,78,41,43,14,22,8,18,17,29,13]),function(_,t,d,F,b,L,T,D,c,f,C,y,v,O,u,h,w,R,I,m,o,r,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",s="extracting",l="deleting",p="renaming";let E=class extends F.Disposable{constructor(A,j,V,q,J){super();this.beforeRemovingExtension=A,this.fileService=j,this.logService=V,this.environmentService=q,this.productService=J,this._devSystemExtensionsPath=null,this.systemExtensionsPath=q.builtinExtensionsPath,this.extensionsPath=q.extensionsPath,this.uninstalledPath=L.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new f.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(A){const j=[];(A===null||A===0)&&j.push(this.scanSystemExtensions().then(null,V=>Promise.reject(new D.ExtensionManagementError(this.joinErrors(V).message,i)))),(A===null||A===1)&&j.push(this.scanUserExtensions(!0).then(null,V=>Promise.reject(new D.ExtensionManagementError(this.joinErrors(V).message,n))));try{const V=await Promise.all(j);return(0,R.flatten)(V)}catch(V){throw this.joinErrors(V)}}async scanUserExtensions(A){this.logService.trace("Started scanning user extensions");let[j,V]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return V=V.filter(q=>!j[new c.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version).key()]),A&&(V=(0,c.groupByExtension)(V,J=>J.identifier).map(J=>J.sort((ie,ne)=>d.rcompare(ie.manifest.version,ne.manifest.version))[0])),this.logService.trace("Scanned user extensions:",V.length),V}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(A,j,V){const q=A.key(),J=L.join(this.extensionsPath,`.${(0,r.generateUuid)()}`),ie=L.join(this.extensionsPath,q);try{await b.rimraf(ie)}catch(te){try{await b.rimraf(ie)}catch(ae){}throw new D.ExtensionManagementError((0,O.localize)(0,null,ie,A.id),l)}await this.extractAtLocation(A,j,J,V);let ne=await this.scanExtension(C.URI.file(J),1);if(!ne)throw new Error((0,O.localize)(1,null,J));await this.storeMetadata(ne,{installedTimestamp:Date.now()});try{await this.rename(A,J,ie,Date.now()+2*60*1e3),this.logService.info("Renamed to",ie)}catch(te){try{await b.rimraf(J)}catch(ae){}if(te.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",A.id);else throw this.logService.info(`Rename failed because of ${(0,e.getErrorMessage)(te)}. Deleted from extracted location`,J),te}try{ne=await this.scanExtension(C.URI.file(ie),1)}catch(te){}if(ne)return ne;throw new Error((0,O.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(A,j){return this.setMetadata(A,j),await this.storeMetadata(A,Object.assign(Object.assign({},j),{installedTimestamp:A.installedTimestamp})),A}async storeMetadata(A,j){j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0;const V=L.join(A.location.fsPath,"package.json"),q=await b.Promises.readFile(V,"utf8"),{manifest:J}=await this.parseManifest(q);return J.__metadata=j,await b.writeFile(V,JSON.stringify(J,null,"	")),A}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...A){const j=A.map(V=>new c.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version));await this.withUninstalledExtensions(V=>{j.forEach(q=>V[q.key()]=!0)})}async setInstalled(A){await this.withUninstalledExtensions(q=>delete q[A.key()]);const V=(await this.scanExtensions(1)).find(q=>new c.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version).equals(A))||null;return V?(await this.storeMetadata(V,{installedTimestamp:Date.now()}),this.scanExtension(V.location,1)):null}async withUninstalledExtensions(A){return this.uninstalledFileLimiter.queue(async()=>{let j;try{j=await b.Promises.readFile(this.uninstalledPath,"utf8")}catch(q){if(q.code!=="ENOENT")throw q}let V={};if(j)try{V=JSON.parse(j)}catch(q){}return A&&(A(V),Object.keys(V).length?await b.writeFile(this.uninstalledPath,JSON.stringify(V)):await b.rimraf(this.uninstalledPath)),V})}async removeExtension(A,j){this.logService.trace(`Deleting ${j} extension from disk`,A.identifier.id,A.location.fsPath),await b.rimraf(A.location.fsPath),this.logService.info("Deleted from disk",A.identifier.id,A.location.fsPath)}async removeUninstalledExtension(A){await this.removeExtension(A,"uninstalled"),await this.withUninstalledExtensions(j=>delete j[new c.ExtensionIdentifierWithVersion(A.identifier,A.manifest.version).key()])}async extractAtLocation(A,j,V,q){this.logService.trace(`Started extracting the extension from ${j} to ${V}`);try{await b.rimraf(V)}catch(J){throw new D.ExtensionManagementError(this.joinErrors(J).message,l)}try{await(0,h.extract)(j,V,{sourcePath:"extension",overwrite:!0},q),this.logService.info(`Extracted extension to ${V}:`,A.id)}catch(J){try{await b.rimraf(V)}catch(ie){}throw new D.ExtensionManagementError(J.message,J instanceof h.ExtractError&&J.type?J.type:s)}}async rename(A,j,V,q){try{await b.Promises.rename(j,V)}catch(J){if(w.isWindows&&J&&J.code==="EPERM"&&Date.now()<q)return this.logService.info(`Failed renaming ${j} to ${V} with 'EPERM' error. Trying again...`,A.id),this.rename(A,j,V,q);throw new D.ExtensionManagementError(J.message||(0,O.localize)(3,null,j,V),J.code||p)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const A=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return A;const j=this.scanDevSystemExtensions(),[V,q]=await Promise.all([A,j]);return[...V,...q]}async scanExtensionsInDir(A,j){const V=new f.Limiter(10),q=await this.fileService.resolve(C.URI.file(A));return q.children?(await Promise.all(q.children.filter(ie=>ie.isDirectory).map(ie=>V.queue(async()=>j===1&&(0,o.basename)(ie.resource).indexOf(".")===0?null:this.scanExtension(ie.resource,j))))).filter(ie=>ie&&ie.identifier):[]}async scanExtension(A,j){var V,q;try{const J=await this.fileService.resolve(A);if(J.children){const{manifest:ie,metadata:ne}=await this.readManifest(A.fsPath),te=(V=J.children.find(({name:k})=>/^readme(\.txt|\.md|)$/i.test(k)))===null||V===void 0?void 0:V.resource,ae=(q=J.children.find(({name:k})=>/^changelog(\.txt|\.md|)$/i.test(k)))===null||q===void 0?void 0:q.resource,x={id:(0,c.getGalleryExtensionId)(ie.publisher,ie.name)},G={type:j,identifier:x,manifest:ie,location:A,readmeUrl:te,changelogUrl:ae,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:j===0};return ne&&(this.setMetadata(G,ne),G.installedTimestamp=ne.installedTimestamp),G}}catch(J){j!==0&&this.logService.trace(J)}return null}async scanDefaultSystemExtensions(){const A=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",A.length),A}async scanDevSystemExtensions(){const A=this.getDevSystemExtensionsList();if(A.length){const j=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",j.length),j.filter(V=>A.some(q=>(0,c.areSameExtensions)(V.identifier,{id:q})))}else return[]}setMetadata(A,j){A.publisherDisplayName=j.publisherDisplayName||null,A.publisherId=j.publisherId||null,A.identifier.uuid=j.id,A.isMachineScoped=!!j.isMachineScoped,A.isBuiltin=A.type===0||!!j.isBuiltin}async removeUninstalledExtensions(){const A=await this.getUninstalledExtensions(),j=await this.scanAllUserExtensions(),V=new Set;for(const ie of j)A[new c.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]||V.add(ie.identifier.id.toLowerCase());const q=(0,c.groupByExtension)(j,ie=>ie.identifier);await f.Promises.settled(q.map(async ie=>{const ne=ie.sort((te,ae)=>d.rcompare(te.manifest.version,ae.manifest.version))[0];V.has(ne.identifier.id.toLowerCase())||await this.beforeRemovingExtension(ne)}));const J=j.filter(ie=>A[new c.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]);await f.Promises.settled(J.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const A=await this.scanAllUserExtensions(),j=[],V=(0,c.groupByExtension)(A,q=>q.identifier);j.push(...(0,R.flatten)(V.map(q=>q.sort((J,ie)=>d.rcompare(J.manifest.version,ie.manifest.version)).slice(1)))),await f.Promises.settled(j.map(q=>this.removeExtension(q,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(A=>A.name)}joinErrors(A){const j=Array.isArray(A)?A:[A];return j.length===1?j[0]instanceof Error?j[0]:new Error(j[0]):j.reduce((V,q)=>new Error(`${V.message}${V.message?",":""}${q instanceof Error?q.message:q}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=L.normalize(L.join(I.FileAccess.asFileUri("",_).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(A){const j=[b.Promises.readFile(L.join(A,"package.json"),"utf8").then(ie=>this.parseManifest(ie)),b.Promises.readFile(L.join(A,"package.nls.json"),"utf8").then(void 0,ie=>ie.code!=="ENOENT"?Promise.reject(ie):"{}").then(ie=>JSON.parse(ie))],[{manifest:V,metadata:q},J]=await Promise.all(j);return{manifest:(0,v.localizeManifest)(V,J),metadata:q}}parseManifest(A){return new Promise((j,V)=>{try{const q=JSON.parse(A),J=q.__metadata||null;j({manifest:q,metadata:J})}catch(q){V(new Error((0,O.localize)(4,null)))}})}};E=ue([fe(1,m.IFileService),fe(2,T.ILogService),fe(3,y.INativeEnvironmentService),fe(4,u.IProductService)],E),t.ExtensionsScanner=E}),define(Q[122],Z([0,1,76,3,9,2,22,43,23,24,21,4,10,39,7,40,14,15,97,28,42,49,17,29,95,11,8,27,120,101,121,102,103,18]),function(_,t,d,F,b,L,T,D,c,f,C,y,v,O,u,h,w,R,I,m,o,r,e,i,n,s,l,p,E,U,A,j,V,q){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const J="unsetUninstalled",ie="downloading",ne="validating",te="local",ae="unknown";let x=class extends L.Disposable{constructor(k,g,a,S,P,N,M){super();this.environmentService=k,this.galleryService=g,this.logService=a,this.downloadService=S,this.telemetryService=P,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new v.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new v.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new v.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new v.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const W=this._register(N.createInstance(j.ExtensionsLifecycle));this.extensionsScanner=this._register(N.createInstance(A.ExtensionsScanner,$=>W.postUninstall($))),this.manifestCache=this._register(new I.ExtensionsManifestCache(k,this)),this.extensionsDownloader=this._register(N.createInstance(U.ExtensionsDownloader));const B=this._register(new V.ExtensionsWatcher(this,M,k,a));this._register(B.onDidChangeExtensionsByAnotherSource(({added:$,removed:X})=>{$.forEach(Y=>this._onDidInstallExtension.fire({identifier:Y.identifier,operation:0,local:Y})),X.forEach(Y=>this._onDidUninstallExtension.fire({identifier:Y}))})),this._register((0,L.toDisposable)(()=>{this.installingExtensions.forEach($=>$.cancel()),this.uninstallingExtensions.forEach($=>$.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(k){this.logService.trace("ExtensionManagementService#zip",k.identifier.id);const g=await this.collectFiles(k),a=await(0,D.zip)((0,e.joinPath)(this.environmentService.tmpDir,(0,i.generateUuid)()).fsPath,g);return u.URI.file(a)}async unzip(k){return this.logService.trace("ExtensionManagementService#unzip",k.toString()),(await this.install(k)).identifier}async getManifest(k){const g=await this.downloadVsix(k),a=F.resolve(g.fsPath);return(0,E.getManifest)(a)}async collectFiles(k){const g=async S=>{let P=await b.readdir(S);P=P.map(W=>F.join(S,W));const N=await Promise.all(P.map(W=>b.Promises.stat(W)));let M=Promise.resolve([]);return N.forEach((W,B)=>{const $=P[B];W.isFile()&&(M=M.then(X=>[...X,$])),W.isDirectory()&&(M=M.then(X=>g($).then(Y=>[...X,...Y])))}),M};return(await g(k.location.fsPath)).map(S=>({path:`extension/${F.relative(k.location.fsPath,S)}`,localPath:S}))}async install(k,g={}){return this.logService.trace("ExtensionManagementService#install",k.toString()),(0,y.createCancelablePromise)(async a=>{const S=await this.downloadVsix(k),P=F.resolve(S.fsPath),N=await(0,E.getManifest)(P),M={id:(0,f.getGalleryExtensionId)(N.publisher,N.name)};let W=1;if(N.engines&&N.engines.vscode&&!(0,r.isEngineValid)(N.engines.vscode,h.default.version,h.default.date))throw new Error(d.localize(0,null,M.id,h.default.version));const B=new f.ExtensionIdentifierWithVersion(M,N.version),X=(await this.getInstalled(1)).find(ee=>(0,f.areSameExtensions)(M,ee.identifier));if(X)if(g.isMachineScoped=g.isMachineScoped||X.isMachineScoped,g.isBuiltin=g.isBuiltin||X.isBuiltin,W=2,B.equals(new f.ExtensionIdentifierWithVersion(X.identifier,X.manifest.version)))try{await this.extensionsScanner.removeExtension(X,"existing")}catch(ee){throw new Error(d.localize(1,null,N.displayName||N.name))}else O.gt(X.manifest.version,N.version)&&await this.uninstallExtension(X);else{const ee=await this.unsetUninstalledAndGetLocal(B);if(ee)try{await this.extensionsScanner.removeExtension(ee,"existing")}catch(re){throw new Error(d.localize(2,null,N.displayName||N.name))}}this.logService.info("Installing the extension:",M.id),this._onInstallExtension.fire({identifier:M,zipPath:P});let Y;try{Y=await this.getGalleryMetadata((0,f.getGalleryExtensionId)(N.publisher,N.name))}catch(ee){}try{const ee=await this.installFromZipPath(B,P,Object.assign(Object.assign({},Y||{}),g),g,W,a);return this.logService.info("Successfully installed the extension:",M.id),ee}catch(ee){throw this.logService.error("Failed to install the extension:",M.id,ee.message),ee}})}async downloadVsix(k){if(k.scheme===l.Schemas.file)return k;if(!this.downloadService)throw new Error("Download service is not available");const g=(0,e.joinPath)(this.environmentService.tmpDir,(0,i.generateUuid)());return await this.downloadService.download(k,g),g}async installFromZipPath(k,g,a,S,P,N){try{const M=await this.installExtension({zipPath:g,identifierWithVersion:k,metadata:a},N);try{await this.installDependenciesAndPackExtensions(M,void 0,S)}catch(W){(0,T.isNonEmptyArray)(M.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",M.identifier.id,W.message),(0,T.isNonEmptyArray)(M.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",M.identifier.id,W.message)}return this._onDidInstallExtension.fire({identifier:k,zipPath:g,local:M,operation:P}),M}catch(M){throw this._onDidInstallExtension.fire({identifier:k,zipPath:g,operation:P,error:M}),M}}async canInstall(k){return!0}async installFromGallery(k,g={}){if(!this.galleryService.isEnabled())throw new Error(d.localize(3,null));try{k=await this.checkAndGetCompatibleVersion(k)}catch(P){const N=P&&P.code?P.code:ae;throw this.logService.error("Failed to install extension:",k.identifier.id,P?P.message:N),this.reportTelemetry(this.getTelemetryEvent(1),(0,f.getGalleryExtensionTelemetryData)(k),void 0,P),P instanceof Error&&(P.name=N),P}const a=new f.ExtensionIdentifierWithVersion(k.identifier,k.version).key();let S=this.installingExtensions.get(a);return S||(S=(0,y.createCancelablePromise)(P=>this.doInstallFromGallery(k,g,P)),this.installingExtensions.set(a,S),S.finally(()=>this.installingExtensions.delete(a))),S}async doInstallFromGallery(k,g,a){const S=new Date().getTime();let P=1;this.logService.info("Installing extension:",k.identifier.id),this._onInstallExtension.fire({identifier:k.identifier,gallery:k});try{const M=(await this.getInstalled(1)).find($=>(0,f.areSameExtensions)($.identifier,k.identifier));M&&(P=2);const W=await this.downloadInstallableExtension(k,P);W.metadata.isMachineScoped=g.isMachineScoped||(M==null?void 0:M.isMachineScoped),W.metadata.isBuiltin=g.isBuiltin||(M==null?void 0:M.isBuiltin);const B=await this.installExtension(W,a);try{await this.extensionsDownloader.delete(u.URI.file(W.zipPath))}catch($){}if(!g.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(B,M,g)}catch($){try{await this.uninstall(B)}catch(X){}throw $}return M&&O.neq(M.manifest.version,k.version)&&await this.extensionsScanner.setUninstalled(M),this.logService.info("Extensions installed successfully:",k.identifier.id),this._onDidInstallExtension.fire({identifier:k.identifier,gallery:k,local:B,operation:P}),this.reportTelemetry(this.getTelemetryEvent(P),(0,f.getGalleryExtensionTelemetryData)(k),new Date().getTime()-S,void 0),B}catch(N){const M=N&&N.code?N.code:ae;throw this.logService.error("Failed to install extension:",k.identifier.id,N?N.message:M),this._onDidInstallExtension.fire({identifier:k.identifier,gallery:k,operation:P,error:M}),this.reportTelemetry(this.getTelemetryEvent(P),(0,f.getGalleryExtensionTelemetryData)(k),new Date().getTime()-S,N),N instanceof Error&&(N.name=M),N}}async checkAndGetCompatibleVersion(k){if(await this.isMalicious(k))throw new c.ExtensionManagementError(d.localize(4,null),c.INSTALL_ERROR_MALICIOUS);const g=await this.galleryService.getCompatibleExtension(k);if(!g)throw new c.ExtensionManagementError(d.localize(5,null,k.identifier.id,h.default.version),c.INSTALL_ERROR_INCOMPATIBLE);return g}async reinstallFromGallery(k){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",k.identifier.id),!this.galleryService.isEnabled())throw new Error(d.localize(6,null));const g=await this.findGalleryExtension(k);if(!g)throw new Error(d.localize(7,null));await this.extensionsScanner.setUninstalled(k);try{await this.extensionsScanner.removeUninstalledExtension(k)}catch(a){throw new Error(d.localize(8,null,(0,m.toErrorMessage)(a)))}await this.installFromGallery(g)}getTelemetryEvent(k){return k===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(k){const g=await this.getExtensionsReport();return(0,f.getMaliciousExtensionsSet)(g).has(k.identifier.id)}async downloadInstallableExtension(k,g){const a={id:k.identifier.uuid,publisherId:k.publisherId,publisherDisplayName:k.publisherDisplayName};let S;try{this.logService.trace("Started downloading extension:",k.identifier.id),S=(await this.extensionsDownloader.downloadExtension(k,g)).fsPath,this.logService.info("Downloaded extension:",k.identifier.id,S)}catch(P){throw new c.ExtensionManagementError(this.joinErrors(P).message,ie)}try{const P=await(0,E.getManifest)(S);return{zipPath:S,identifierWithVersion:new f.ExtensionIdentifierWithVersion(k.identifier,P.version),metadata:a}}catch(P){throw new c.ExtensionManagementError(this.joinErrors(P).message,ne)}}async installExtension(k,g){try{const a=await this.unsetUninstalledAndGetLocal(k.identifierWithVersion);if(a)return k.metadata?this.extensionsScanner.saveMetadataForLocalExtension(a,k.metadata):a}catch(a){throw w.isMacintosh?new c.ExtensionManagementError(d.localize(9,null),J):new c.ExtensionManagementError(d.localize(10,null),J)}return this.extractAndInstall(k,g)}async unsetUninstalledAndGetLocal(k){if(!await this.isUninstalled(k))return null;this.logService.trace("Removing the extension from uninstalled list:",k.id);const a=await this.extensionsScanner.setInstalled(k);return this.logService.info("Removed the extension from uninstalled list:",k.id),a}async extractAndInstall({zipPath:k,identifierWithVersion:g,metadata:a},S){let P=await this.extensionsScanner.extractUserExtension(g,k,S);return this.logService.info("Installation completed.",g.id),a&&(P=await this.extensionsScanner.saveMetadataForLocalExtension(P,a)),P}async installDependenciesAndPackExtensions(k,g,a){if(!this.galleryService.isEnabled())return;const S=k.manifest.extensionDependencies||[];if(k.manifest.extensionPack)for(const P of k.manifest.extensionPack)g&&g.manifest.extensionPack&&g.manifest.extensionPack.some(N=>(0,f.areSameExtensions)({id:N},{id:P}))||S.every(N=>!(0,f.areSameExtensions)({id:N},{id:P}))&&S.push(P);if(S.length){const P=await this.getInstalled(),N=S.filter(M=>P.every(({identifier:W})=>!(0,f.areSameExtensions)(W,{id:M})));if(N.length){const W=(await this.galleryService.query({names:N,pageSize:S.length},p.CancellationToken.None)).firstPage;try{await y.Promises.settled(W.map(B=>this.installFromGallery(B,a)))}catch(B){try{await this.rollback(W)}catch($){}throw B}}}}async rollback(k){const a=(await this.getInstalled(1)).filter(S=>k.some(P=>new f.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).equals(new f.ExtensionIdentifierWithVersion(P.identifier,P.version))));await y.Promises.settled(a.map(S=>this.uninstall(S)))}async uninstall(k,g={}){this.logService.trace("ExtensionManagementService#uninstall",k.identifier.id);const a=await this.getInstalled(1),S=a.find(P=>(0,f.areSameExtensions)(P.identifier,k.identifier));if(!S)throw new Error(d.localize(11,null,k.manifest.displayName||k.manifest.name));try{await this.checkForDependenciesAndUninstall(S,a,g)}catch(P){throw this.joinErrors(P)}}async updateMetadata(k,g){return this.logService.trace("ExtensionManagementService#updateMetadata",k.identifier.id),k=await this.extensionsScanner.saveMetadataForLocalExtension(k,Object.assign(Object.assign({},k.manifest.__metadata||{}),g)),this.manifestCache.invalidate(),k}async updateExtensionScope(k,g){return this.logService.trace("ExtensionManagementService#updateExtensionScope",k.identifier.id),k=await this.extensionsScanner.saveMetadataForLocalExtension(k,Object.assign(Object.assign({},k.manifest.__metadata||{}),{isMachineScoped:g})),this.manifestCache.invalidate(),k}async getGalleryMetadata(k){const g=await this.findGalleryExtensionByName(k);return g?{id:g.identifier.uuid,publisherDisplayName:g.publisherDisplayName,publisherId:g.publisherId}:void 0}async findGalleryExtension(k){if(k.identifier.uuid){const g=await this.findGalleryExtensionById(k.identifier.uuid);return g||this.findGalleryExtensionByName(k.identifier.id)}return this.findGalleryExtensionByName(k.identifier.id)}async findGalleryExtensionById(k){return(await this.galleryService.query({ids:[k],pageSize:1},p.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(k){return(await this.galleryService.query({names:[k],pageSize:1},p.CancellationToken.None)).firstPage[0]}joinErrors(k){const g=Array.isArray(k)?k:[k];return g.length===1?g[0]instanceof Error?g[0]:new Error(g[0]):g.reduce((a,S)=>new Error(`${a.message}${a.message?",":""}${S instanceof Error?S.message:S}`),new Error(""))}async checkForDependenciesAndUninstall(k,g,a){try{await this.preUninstallExtension(k);const S=a.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(k,g);await this.uninstallExtensions(k,S,g,a)}catch(S){throw await this.postUninstallExtension(k,new c.ExtensionManagementError(S instanceof Error?S.message:S,te)),S}await this.postUninstallExtension(k)}async uninstallExtensions(k,g,a,S){const P=[k,...g];if(!S.donotCheckDependents)for(const N of P)this.checkForDependents(N,P,a,k);await y.Promises.settled([this.uninstallExtension(k),...g.map(N=>this.doUninstall(N))])}checkForDependents(k,g,a,S){const P=this.getDependents(k,a);if(P.length){const N=P.filter(M=>g.indexOf(M)===-1);if(N.length)throw new Error(this.getDependentsErrorMessage(k,N,S))}}getDependentsErrorMessage(k,g,a){return a===k?g.length===1?d.localize(12,null,a.manifest.displayName||a.manifest.name,g[0].manifest.displayName||g[0].manifest.name):g.length===2?d.localize(13,null,a.manifest.displayName||a.manifest.name,g[0].manifest.displayName||g[0].manifest.name,g[1].manifest.displayName||g[1].manifest.name):d.localize(14,null,a.manifest.displayName||a.manifest.name,g[0].manifest.displayName||g[0].manifest.name,g[1].manifest.displayName||g[1].manifest.name):g.length===1?d.localize(15,null,a.manifest.displayName||a.manifest.name,k.manifest.displayName||k.manifest.name,g[0].manifest.displayName||g[0].manifest.name):g.length===2?d.localize(16,null,a.manifest.displayName||a.manifest.name,k.manifest.displayName||k.manifest.name,g[0].manifest.displayName||g[0].manifest.name,g[1].manifest.displayName||g[1].manifest.name):d.localize(17,null,a.manifest.displayName||a.manifest.name,k.manifest.displayName||k.manifest.name,g[0].manifest.displayName||g[0].manifest.name,g[1].manifest.displayName||g[1].manifest.name)}getAllPackExtensionsToUninstall(k,g,a=[]){if(a.indexOf(k)!==-1)return[];a.push(k);const S=k.manifest.extensionPack?k.manifest.extensionPack:[];if(S.length){const P=g.filter(M=>!M.isBuiltin&&S.some(W=>(0,f.areSameExtensions)({id:W},M.identifier))),N=[];for(const M of P)N.push(...this.getAllPackExtensionsToUninstall(M,g,a));return[...P,...N]}return[]}getDependents(k,g){return g.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(S=>(0,f.areSameExtensions)({id:S},k.identifier)))}async doUninstall(k){try{await this.preUninstallExtension(k),await this.uninstallExtension(k)}catch(g){throw await this.postUninstallExtension(k,new c.ExtensionManagementError(g instanceof Error?g.message:g,te)),g}await this.postUninstallExtension(k)}async preUninstallExtension(k){if(!await b.exists(k.location.fsPath))throw new Error(d.localize(18,null));this.logService.info("Uninstalling extension:",k.identifier.id),this._onUninstallExtension.fire(k.identifier)}async uninstallExtension(k){let g=this.uninstallingExtensions.get(k.identifier.id);return g||(g=(0,y.createCancelablePromise)(async()=>{const a=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...a.filter(S=>(0,f.areSameExtensions)(S.identifier,k.identifier)))}),this.uninstallingExtensions.set(k.identifier.id,g),g.finally(()=>this.uninstallingExtensions.delete(k.identifier.id))),g}async postUninstallExtension(k,g){if(g)this.logService.error("Failed to uninstall extension:",k.identifier.id,g.message);else if(this.logService.info("Successfully uninstalled extension:",k.identifier.id),k.identifier.uuid)try{await this.galleryService.reportStatistic(k.manifest.publisher,k.manifest.name,k.manifest.version,"uninstall")}catch(S){}this.reportTelemetry("extensionGallery:uninstall",(0,f.getLocalExtensionTelemetryData)(k),void 0,g);const a=g?g instanceof c.ExtensionManagementError?g.code:ae:void 0;this._onDidUninstallExtension.fire({identifier:k.identifier,error:a})}getInstalled(k=null){return this.extensionsScanner.scanExtensions(k)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(k){return(await this.filterUninstalled(k)).length===1}async filterUninstalled(...k){const g=[],a=await this.extensionsScanner.getUninstalledExtensions();for(const S of k)a[S.key()]&&g.push(S.key());return g}getExtensionsReport(){const k=new Date().getTime();return(!this.reportedExtensions||k-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=k),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const k=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${k.length} reported extensions from service`),k}catch(k){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(k,g,a,S){const P=S?S instanceof c.ExtensionManagementError?S.code:ae:void 0;this.telemetryService.publicLogError(k,Object.assign(Object.assign({},g),{success:!S,duration:a,errorcode:P}))}};x=ue([fe(0,C.INativeEnvironmentService),fe(1,c.IExtensionGalleryService),fe(2,R.ILogService),fe(3,(0,s.optional)(n.IDownloadService)),fe(4,o.ITelemetryService),fe(5,s.IInstantiationService),fe(6,q.IFileService)],x),t.ExtensionManagementService=x}),define(Q[123],Z([0,1,132,112,2,12,13,111,26,15,16,21,98]),function(_,t,d,F,b,L,T,D,c,f,C,y,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let O=class extends b.Disposable{constructor(h,w,R){super();this.environmentService=w,this.logService=R,this.configure(h.getValue()),this._register(h.onDidChangeConfiguration(()=>this.configure(h.getValue()),this))}configure(h){this.proxyUrl=h.http&&h.http.proxy,this.strictSSL=!!(h.http&&h.http.proxyStrictSSL),this.authorization=h.http&&h.http.proxyAuthorization}async request(h,w){this.logService.trace("RequestService#request",h.url);const{proxyUrl:R,strictSSL:I}=this,m=Object.assign(Object.assign({},process.env),await(0,v.resolveShellEnv)(this.logService,this.environmentService.args,process.env)),o=h.agent?h.agent:await(0,D.getProxyAgent)(h.url||"",m,{proxyUrl:R,strictSSL:I});return h.agent=o,h.strictSSL=I,this.authorization&&(h.headers=Object.assign(Object.assign({},h.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(h,w)}async getNodeRequest(h){return((0,F.parse)(h.url).protocol==="https:"?await new Promise((I,m)=>{_(["https"],I,m)}):await new Promise((I,m)=>{_(["http"],I,m)})).request}_request(h,w){return new Promise(async(R,I)=>{let m;const o=(0,F.parse)(h.url),r=h.getRawRequest?h.getRawRequest(h):await this.getNodeRequest(h),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,L.isBoolean)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(e.auth=h.user+":"+h.password),m=r(e,i=>{const n=(0,L.isNumber)(h.followRedirects)?h.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request(Object.assign(Object.assign({},h),{url:i.headers.location,followRedirects:n-1}),w).then(R,I);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,d.createGunzip)())),R({res:i,stream:(0,C.streamToBufferReadableStream)(s)})}}),m.on("error",I),h.timeout&&m.setTimeout(h.timeout),h.data&&typeof h.data=="string"&&m.write(h.data),m.end(),w.onCancellationRequested(()=>{m.abort(),I((0,T.canceled)())})})}async resolveProxy(h){}};O=ue([fe(0,c.IConfigurationService),fe(1,y.INativeEnvironmentService),fe(2,f.ILogService)],O),t.RequestService=O}),define(Q[133],Z([0,1,32,31,134,9,3,4,40,52,50,100,21,88,23,122,116,42,56,117,115,55,123,26,110,118,15,8,105,119,106,18,107,2,41,96,7,104,53,13,28,16,34]),function(_,t,d,F,b,L,T,D,c,f,C,y,v,O,u,h,w,R,I,m,o,r,e,i,n,s,l,p,E,U,A,j,V,q,J,ie,ne,te,ae,x,G,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class a extends q.Disposable{constructor(N){super();this.argv=N,(0,b.gracefulify)(F),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[N,M]=await this.initServices();return N.invokeFunction(async W=>{const B=W.get(l.ILogService),$=W.get(j.IFileService),X=W.get(v.INativeEnvironmentService),Y=W.get(u.IExtensionManagementCLIService);return B.info("CLI main",this.argv),this.registerErrorHandler(B),await this.doRun(X,Y,$),(0,D.raceTimeout)((0,I.combinedAppender)(...M).flush(),1e3)})}async initServices(){const N=new f.ServiceCollection,M=Object.assign({_serviceBrand:void 0},c.default);N.set(J.IProductService,M);const W=new O.NativeEnvironmentService(this.argv,M);N.set(v.INativeEnvironmentService,W),await Promise.all([W.appSettingsHome.fsPath,W.extensionsPath].map(ge=>ge?L.Promises.mkdir(ge,{recursive:!0}):void 0));const B=(0,l.getLogLevel)(W),$=[];$.push(new E.SpdLogLogger("cli",(0,T.join)(W.logsPath,"cli.log"),!0,B)),B===l.LogLevel.Trace&&$.push(new l.ConsoleLogger(B));const X=this._register(new l.MultiplexLogService($));N.set(l.ILogService,X);const Y=this._register(new A.FileService(X));N.set(j.IFileService,Y);const ee=this._register(new V.DiskFileSystemProvider(X));Y.registerProvider(p.Schemas.file,ee);const re=this._register(new n.ConfigurationService(W.settingsResource,Y));N.set(i.IConfigurationService,re),await re.initialize(),N.set(r.IRequestService,new C.SyncDescriptor(e.RequestService)),N.set(u.IExtensionManagementService,new C.SyncDescriptor(h.ExtensionManagementService)),N.set(u.IExtensionGalleryService,new C.SyncDescriptor(w.ExtensionGalleryService)),N.set(u.IExtensionManagementCLIService,new C.SyncDescriptor(ie.ExtensionManagementCLIService)),N.set(ae.ILocalizationsService,new C.SyncDescriptor(te.LocalizationsService));const ce=[];if(W.isBuilt&&!W.isExtensionDevelopment&&!W.disableTelemetry&&M.enableTelemetry){M.aiConfig&&M.aiConfig.asimovKey&&ce.push(new s.AppInsightsAppender("monacoworkbench",null,M.aiConfig.asimovKey));const{appRoot:ge,extensionsPath:Pe,installSourcePath:Fe}=W,Oe={appender:(0,I.combinedAppender)(...ce),sendErrorTelemetry:!1,commonProperties:(async()=>{let Se;try{const ke=await L.Promises.readFile((0,T.join)(W.userDataPath,"storage.json"));Se=JSON.parse(ke.toString())[R.machineIdKey]}catch(ke){ke.code!=="ENOENT"&&X.error(ke)}return(0,o.resolveCommonProperties)(Y,(0,d.release)(),(0,d.hostname)(),process.arch,M.commit,M.version,Se,M.msftInternalDomains,Fe)})(),piiPaths:[ge,Pe]};N.set(R.ITelemetryService,new C.SyncDescriptor(m.TelemetryService,[Oe]))}else N.set(R.ITelemetryService,I.NullTelemetryService);return[new y.InstantiationService(N),ce]}registerErrorHandler(N){(0,x.setUnexpectedErrorHandler)(M=>{const W=(0,G.toErrorMessage)(M,!0);!W||N.error(`[uncaught exception in CLI]: ${W}`)})}async doRun(N,M,W){if(this.argv["install-source"])return this.setInstallSource(N,W,this.argv["install-source"]);if(this.argv["list-extensions"])return M.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return M.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return M.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return M.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log((0,U.buildTelemetryMessage)(N.appRoot,N.extensionsPath))}asExtensionIdOrVSIX(N){return N.map(M=>/\.vsix$/i.test(M)?ne.URI.file((0,T.isAbsolute)(M)?M:(0,T.join)((0,g.cwd)(),M)):M)}async setInstallSource(N,M,W){await M.writeFile(ne.URI.file(N.installSourcePath),k.VSBuffer.fromString(W.slice(0,30)))}}async function S(P){const N=new a(P);try{await N.run()}finally{N.dispose()}}t.main=S})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/286b643ecd231f66f3f2e67e1456f3c601838b46/core/vs/code/node/cliProcessMain.js.map
