/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/base/common/types","vs/base/common/async","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/base/common/stopwatch","vs/base/common/codicons","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","fs","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(K){for(var e=[],v=0,R=K.length;v<R;v++)e[v]=me[K[v]];return e};define(me[51],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(R,C){if(!R)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=v}),define(me[52],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function R(i){const A=[];for(let h in i)v.call(i,h)&&A.push(i[h]);return A}e.values=R;function C(i,A){for(let h in i)if(v.call(i,h)&&A({key:h,value:i[h]},function(){delete i[h]})===!1)return}e.forEach=C;function T(i,A){const h=Object.create(null);for(const p of i){const a=A(p);let w=h[a];w||(w=h[a]=[]),w.push(p)}return h}e.groupBy=T;function y(i){const A=Object.create(null);return i&&i.forEach((h,p)=>{A[p]=h}),A}e.fromMap=y;function P(i,A){const h=[],p=[];for(let a of i)A.has(a)||h.push(a);for(let a of A)i.has(a)||p.push(a);return{removed:h,added:p}}e.diffSets=P;function D(i,A){const h=[],p=[];for(let[a,w]of i)A.has(a)||h.push(w);for(let[a,w]of A)i.has(a)||p.push(w);return{removed:h,added:p}}e.diffMaps=D;class I{constructor(){this.map=new Map}add(A,h){let p=this.map.get(A);p||(p=new Set,this.map.set(A,p)),p.add(h)}delete(A,h){const p=this.map.get(A);!p||(p.delete(h),p.size===0&&this.map.delete(A))}forEach(A,h){const p=this.map.get(A);!p||p.forEach(h)}}e.SetMap=I}),define(me[53],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(y){return(P,D,I)=>{let i=null,A=null;if(typeof I.value=="function"?(i="value",A=I.value):typeof I.get=="function"&&(i="get",A=I.get),!A)throw new Error("not supported");I[i]=y(A,D)}}e.createDecorator=v;function R(y,P,D){let I=null,i=null;if(typeof D.value=="function"?(I="value",i=D.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(I="get",i=D.get),!i)throw new Error("not supported");const A=`$memoize$${P}`;D[I]=function(...h){return this.hasOwnProperty(A)||Object.defineProperty(this,A,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,h)}),this[A]}}e.memoize=R;function C(y,P,D){return v((I,i)=>{const A=`$debounce$${i}`,h=`$debounce$result$${i}`;return function(...p){this[h]||(this[h]=D?D():void 0),clearTimeout(this[A]),P&&(this[h]=P(this[h],...p),p=[this[h]]),this[A]=setTimeout(()=>{I.apply(this,p),this[h]=D?D():void 0},y)}})}e.debounce=C;function T(y,P,D){return v((I,i)=>{const A=`$throttle$timer$${i}`,h=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,a=`$throttle$pending$${i}`;return function(...w){if(this[h]||(this[h]=D?D():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),P&&(this[h]=P(this[h],...w)),this[a])return;const m=this[p]+y;m<=Date.now()?(this[p]=Date.now(),I.apply(this,[this[h]]),this[h]=D?D():void 0):(this[a]=!0,this[A]=setTimeout(()=>{this[a]=!1,this[p]=Date.now(),I.apply(this,[this[h]]),this[h]=D?D():void 0},m-Date.now()))}})}e.throttle=T}),define(me[17],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function R(d){e.errorHandler.setUnexpectedErrorHandler(d)}e.setUnexpectedErrorHandler=R;function C(d){D(d)||e.errorHandler.onUnexpectedError(d)}e.onUnexpectedError=C;function T(d){D(d)||e.errorHandler.onUnexpectedExternalError(d)}e.onUnexpectedExternalError=T;function y(d){if(d instanceof Error){let{name:t,message:n}=d;const s=d.stacktrace||d.stack;return{$isError:!0,name:t,message:n,stack:s}}return d}e.transformErrorForSerialization=y;const P="Canceled";function D(d){return d instanceof Error&&d.name===P&&d.message===P}e.isPromiseCanceledError=D;class I extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=I;function i(){const d=new Error(P);return d.name=d.message,d}e.canceled=i;function A(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}e.illegalArgument=A;function h(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}e.illegalState=h;function p(d){return d?new Error(`readonly property '${d} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function a(d){const t=new Error(`${d} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function w(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}e.getErrorMessage=w;class m extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=m;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;function u(d){const t=d;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function c(d,t=Object.create(null)){const n=new Error(d);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=c}),define(me[16],ge([0,1,17]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(x,k=0){return x[x.length-(1+k)]}e.tail=R;function C(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}e.tail2=C;function T(x,k,U=(F,M)=>F===M){if(x===k)return!0;if(!x||!k||x.length!==k.length)return!1;for(let F=0,M=x.length;F<M;F++)if(!U(x[F],k[F]))return!1;return!0}e.equals=T;function y(x,k,U){let F=0,M=x.length-1;for(;F<=M;){const $=(F+M)/2|0,H=U(x[$],k);if(H<0)F=$+1;else if(H>0)M=$-1;else return $}return-(F+1)}e.binarySearch=y;function P(x,k){let U=0,F=x.length;if(F===0)return 0;for(;U<F;){const M=Math.floor((U+F)/2);k(x[M])?F=M:U=M+1}return U}e.findFirstInSorted=P;function D(x,k,U){if(x=x|0,x>=k.length)throw new TypeError("invalid index");let F=k[Math.floor(k.length*Math.random())],M=[],$=[],H=[];for(let X of k){const ae=U(X,F);ae<0?M.push(X):ae>0?$.push(X):H.push(X)}return x<M.length?D(x,M,U):x<M.length+H.length?H[0]:D(x-(M.length+H.length),$,U)}e.quickSelect=D;function I(x,k){const U=[];let F;for(const M of x.slice(0).sort(k))!F||k(F[0],M)!==0?(F=[M],U.push(F)):F.push(M);return U}e.groupBy=I;function i(x,k,U){const F=[];function M(X,ae,we){if(ae===0&&we.length===0)return;const Le=F[F.length-1];Le&&Le.start+Le.deleteCount===X?(Le.deleteCount+=ae,Le.toInsert.push(...we)):F.push({start:X,deleteCount:ae,toInsert:we})}let $=0,H=0;for(;;){if($===x.length){M($,0,k.slice(H));break}if(H===k.length){M($,x.length-$,[]);break}const X=x[$],ae=k[H],we=U(X,ae);we===0?($+=1,H+=1):we<0?(M($,1,[]),$+=1):we>0&&(M($,0,[ae]),H+=1)}return F}e.sortedDiff=i;function A(x,k,U){const F=i(x,k,U),M=[],$=[];for(const H of F)M.push(...x.slice(H.start,H.start+H.deleteCount)),$.push(...H.toInsert);return{removed:M,added:$}}e.delta=A;function h(x,k,U){if(U===0)return[];const F=x.slice(0,U).sort(k);return a(x,k,F,U,x.length),F}e.top=h;function p(x,k,U,F,M){return U===0?Promise.resolve([]):new Promise(($,H)=>{(async()=>{const X=x.length,ae=x.slice(0,U).sort(k);for(let we=U,Le=Math.min(U+F,X);we<X;we=Le,Le=Math.min(Le+F,X)){if(we>U&&await new Promise(Ie=>setTimeout(Ie)),M&&M.isCancellationRequested)throw(0,v.canceled)();a(x,k,ae,we,Le)}return ae})().then($,H)})}e.topAsync=p;function a(x,k,U,F,M){for(const $=U.length;F<M;F++){const H=x[F];if(k(H,U[$-1])<0){U.pop();const X=P(U,ae=>k(H,ae)<0);U.splice(X,0,H)}}}function w(x){return x.filter(k=>!!k)}e.coalesce=w;function m(x){let k=0;for(let U=0;U<x.length;U++)x[U]&&(x[k]=x[U],k+=1);x.length=k}e.coalesceInPlace=m;function b(x,k,U){x.splice(U,0,x.splice(k,1)[0])}e.move=b;function _(x){return!Array.isArray(x)||x.length===0}e.isFalsyOrEmpty=_;function u(x){return Array.isArray(x)&&x.length>0}e.isNonEmptyArray=u;function c(x,k){if(!k)return x.filter((F,M)=>x.indexOf(F)===M);const U=Object.create(null);return x.filter(F=>{const M=k(F);return U[M]?!1:(U[M]=!0,!0)})}e.distinct=c;function d(x){const k=new Set;return x.filter(U=>k.has(U)?!1:(k.add(U),!0))}e.distinctES6=d;function t(x){const k=Object.create(null);return U=>{const F=x(U);return k[F]?!1:(k[F]=!0,!0)}}e.uniqueFilter=t;function n(x,k){for(let U=x.length-1;U>=0;U--){const F=x[U];if(k(F))return U}return-1}e.lastIndex=n;function s(x,k){return x.length>0?x[0]:k}e.firstOrDefault=s;function r(x,k,U=(F,M)=>F===M){let F=0;for(let M=0,$=Math.min(x.length,k.length);M<$&&U(x[M],k[M]);M++)F++;return F}e.commonPrefixLength=r;function o(x){return[].concat(...x)}e.flatten=o;function g(x,k){let U=typeof k=="number"?x:0;typeof k=="number"?U=x:(U=0,k=x);const F=[];if(U<=k)for(let M=U;M<k;M++)F.push(M);else for(let M=U;M>k;M--)F.push(M);return F}e.range=g;function f(x,k,U){return x.reduce((F,M)=>(F[k(M)]=U?U(M):M,F),Object.create(null))}e.index=f;function S(x,k){return x.push(k),()=>E(x,k)}e.insert=S;function E(x,k){const U=x.indexOf(k);if(U>-1)return x.splice(U,1),k}e.remove=E;function l(x,k,U){const F=x.slice(0,k),M=x.slice(k);return F.concat(U,M)}e.arrayInsert=l;function L(x,k){let U;if(typeof k=="number"){let F=k;U=()=>{const M=Math.sin(F++)*179426549;return M-Math.floor(M)}}else U=Math.random;for(let F=x.length-1;F>0;F-=1){const M=Math.floor(U()*(F+1)),$=x[F];x[F]=x[M],x[M]=$}}e.shuffle=L;function O(x,k){const U=x.indexOf(k);U>-1&&(x.splice(U,1),x.unshift(k))}e.pushToStart=O;function W(x,k){const U=x.indexOf(k);U>-1&&(x.splice(U,1),x.push(k))}e.pushToEnd=W;function te(x,k){return Array.isArray(x)?x.map(k):k(x)}e.mapArrayOrNot=te;function se(x){return Array.isArray(x)?x:[x]}e.asArray=se;function N(x){return x[Math.floor(Math.random()*x.length)]}e.getRandomElement=N;function V(x,k){for(const U of x){const F=k(U);if(F!==void 0)return F}}e.mapFind=V}),define(me[72],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(R){const C=this;let T=!1,y;return function(){return T||(T=!0,y=R.apply(C,arguments)),y}}e.once=v}),define(me[73],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class v{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=v,e.defaultGenerator=new v("id#")}),define(me[54],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(R){function C(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}R.is=C;const T=Object.freeze([]);function y(){return T}R.empty=y;function*P(d){yield d}R.single=P;function D(d){return d||T}R.from=D;function I(d){return!d||d[Symbol.iterator]().next().done===!0}R.isEmpty=I;function i(d){return d[Symbol.iterator]().next().value}R.first=i;function A(d,t){for(const n of d)if(t(n))return!0;return!1}R.some=A;function h(d,t){for(const n of d)if(t(n))return n}R.find=h;function*p(d,t){for(const n of d)t(n)&&(yield n)}R.filter=p;function*a(d,t){for(const n of d)yield t(n)}R.map=a;function*w(...d){for(const t of d)for(const n of t)yield n}R.concat=w;function*m(d){for(const t of d)for(const n of t)yield n}R.concatNested=m;function b(d,t,n){let s=n;for(const r of d)s=t(s,r);return s}R.reduce=b;function*_(d,t,n=d.length){for(t<0&&(t+=d.length),n<0?n+=d.length:n>d.length&&(n=d.length);t<n;t++)yield d[t]}R.slice=_;function u(d,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,d];const s=d[Symbol.iterator]();for(let r=0;r<t;r++){const o=s.next();if(o.done)return[n,R.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return s}}]}R.consume=u;function c(d,t,n=(s,r)=>s===r){const s=d[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const o=s.next(),g=r.next();if(o.done!==g.done)return!1;if(o.done)return!0;if(!n(o.value,g.value))return!1}}R.equals=c})(v=e.Iterable||(e.Iterable={}))}),define(me[55],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let s=0,r=t.length,o="",g=0,f=16,S=0;function E(N){let V=0,x=0;for(;V<N;){const k=t.charCodeAt(s);if(k>=48&&k<=57)x=x*16+k-48;else if(k>=65&&k<=70)x=x*16+k-65+10;else if(k>=97&&k<=102)x=x*16+k-97+10;else break;s++,V++}return V<N&&(x=-1),x}function l(N){s=N,o="",g=0,f=16,S=0}function L(){const N=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&I(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&I(t.charCodeAt(s)))for(s++;s<t.length&&I(t.charCodeAt(s));)s++;else return S=3,t.substring(N,s);let V=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&I(t.charCodeAt(s))){for(s++;s<t.length&&I(t.charCodeAt(s));)s++;V=s}else S=3;return t.substring(N,V)}function O(){let N="",V=s;for(;;){if(s>=r){N+=t.substring(V,s),S=2;break}const x=t.charCodeAt(s);if(x===34){N+=t.substring(V,s),s++;break}if(x===92){if(N+=t.substring(V,s),s++,s>=r){S=2;break}switch(t.charCodeAt(s++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:const U=E(4);U>=0?N+=String.fromCharCode(U):S=4;break;default:S=5}V=s;continue}if(x>=0&&x<=31)if(D(x)){N+=t.substring(V,s),S=2;break}else S=6;s++}return N}function W(){if(o="",S=0,g=s,s>=r)return g=r,f=17;let N=t.charCodeAt(s);if(P(N)){do s++,o+=String.fromCharCode(N),N=t.charCodeAt(s);while(P(N));return f=15}if(D(N))return s++,o+=String.fromCharCode(N),N===13&&t.charCodeAt(s)===10&&(s++,o+=`
`),f=14;switch(N){case 123:return s++,f=1;case 125:return s++,f=2;case 91:return s++,f=3;case 93:return s++,f=4;case 58:return s++,f=6;case 44:return s++,f=5;case 34:return s++,o=O(),f=10;case 47:const V=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<r&&!D(t.charCodeAt(s));)s++;return o=t.substring(V,s),f=12}if(t.charCodeAt(s+1)===42){s+=2;const x=r-1;let k=!1;for(;s<x;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,k=!0;break}s++}return k||(s++,S=1),o=t.substring(V,s),f=13}return o+=String.fromCharCode(N),s++,f=16;case 45:if(o+=String.fromCharCode(N),s++,s===r||!I(t.charCodeAt(s)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=L(),f=11;default:for(;s<r&&te(N);)s++,N=t.charCodeAt(s);if(g!==s){switch(o=t.substring(g,s),o){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return o+=String.fromCharCode(N),s++,f=16}}function te(N){if(P(N)||D(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let N;do N=W();while(N>=12&&N<=15);return N}return{setPosition:l,getPosition:()=>s,scan:n?se:W,getToken:()=>f,getTokenValue:()=>o,getTokenOffset:()=>g,getTokenLength:()=>s-g,getTokenError:()=>S}}e.createScanner=y;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function I(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function A(t,n){const s=[],r=new Object;let o;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function S(E,l,L,O){g.value=E,g.offset=l,g.length=L,g.type=O,g.colonOffset=void 0,o=g}try{u(t,{onObjectBegin:(E,l)=>{if(n<=E)throw r;o=void 0,f=n>E,s.push("")},onObjectProperty:(E,l,L)=>{if(n<l||(S(E,l,L,"property"),s[s.length-1]=E,n<=l+L))throw r},onObjectEnd:(E,l)=>{if(n<=E)throw r;o=void 0,s.pop()},onArrayBegin:(E,l)=>{if(n<=E)throw r;o=void 0,s.push(0)},onArrayEnd:(E,l)=>{if(n<=E)throw r;o=void 0,s.pop()},onLiteralValue:(E,l,L)=>{if(n<l||(S(E,l,L,d(E)),n<=l+L))throw r},onSeparator:(E,l,L)=>{if(n<=l)throw r;if(E===":"&&o&&o.type==="property")o.colonOffset=l,f=!1,o=void 0;else if(E===","){const O=s[s.length-1];typeof O=="number"?s[s.length-1]=O+1:(f=!0,s[s.length-1]=""),o=void 0}}})}catch(E){if(E!==r)throw E}return{path:s,previousNode:o,isAtPropertyKey:f,matches:E=>{let l=0;for(let L=0;l<E.length&&L<s.length;L++)if(E[l]===s[L]||E[l]==="*")l++;else if(E[l]!=="**")return!1;return l===E.length}}}e.getLocation=A;function h(t,n=[],s=T.DEFAULT){let r=null,o=[];const g=[];function f(E){Array.isArray(o)?o.push(E):r!==null&&(o[r]=E)}return u(t,{onObjectBegin:()=>{const E={};f(E),g.push(o),o=E,r=null},onObjectProperty:E=>{r=E},onObjectEnd:()=>{o=g.pop()},onArrayBegin:()=>{const E=[];f(E),g.push(o),o=E,r=null},onArrayEnd:()=>{o=g.pop()},onLiteralValue:f,onError:(E,l,L)=>{n.push({error:E,offset:l,length:L})}},s),o[0]}e.parse=h;function p(t,n=[],s=T.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(E){r.type==="property"&&(r.length=E-r.offset,r=r.parent)}function g(E){return r.children.push(E),E}u(t,{onObjectBegin:E=>{r=g({type:"object",offset:E,length:-1,parent:r,children:[]})},onObjectProperty:(E,l,L)=>{r=g({type:"property",offset:l,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:E,offset:l,length:L,parent:r})},onObjectEnd:(E,l)=>{r.length=E+l-r.offset,r=r.parent,o(E+l)},onArrayBegin:(E,l)=>{r=g({type:"array",offset:E,length:-1,parent:r,children:[]})},onArrayEnd:(E,l)=>{r.length=E+l-r.offset,r=r.parent,o(E+l)},onLiteralValue:(E,l,L)=>{g({type:d(E),offset:l,length:L,parent:r,value:E}),o(l+L)},onSeparator:(E,l,L)=>{r.type==="property"&&(E===":"?r.colonOffset=l:E===","&&o(l))},onError:(E,l,L)=>{n.push({error:E,offset:l,length:L})}},s);const S=r.children[0];return S&&delete S.parent,S}e.parseTree=p;function a(t,n){if(!t)return;let s=t;for(let r of n)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const g of s.children)if(Array.isArray(g.children)&&g.children[0].value===r){s=g.children[1],o=!0;break}if(!o)return}else{const o=r;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}e.findNodeAtLocation=a;function w(t){if(!t.parent||!t.parent.children)return[];const n=w(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=w;function m(t){switch(t.type){case"array":return t.children.map(m);case"object":const n=Object.create(null);for(let s of t.children){const r=s.children[1];r&&(n[s.children[0].value]=m(r))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=m;function b(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=b;function _(t,n,s=!1){if(b(t,n,s)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const g=_(r[o],n,s);if(g)return g}return t}}e.findNodeAtOffset=_;function u(t,n,s=T.DEFAULT){const r=y(t,!1);function o(ae){return ae?()=>ae(r.getTokenOffset(),r.getTokenLength()):()=>!0}function g(ae){return ae?we=>ae(we,r.getTokenOffset(),r.getTokenLength()):()=>!0}const f=o(n.onObjectBegin),S=g(n.onObjectProperty),E=o(n.onObjectEnd),l=o(n.onArrayBegin),L=o(n.onArrayEnd),O=g(n.onLiteralValue),W=g(n.onSeparator),te=o(n.onComment),se=g(n.onError),N=s&&s.disallowComments,V=s&&s.allowTrailingComma;function x(){for(;;){const ae=r.scan();switch(r.getTokenError()){case 4:k(14);break;case 5:k(15);break;case 3:k(13);break;case 1:N||k(11);break;case 2:k(12);break;case 6:k(16);break}switch(ae){case 12:case 13:N?k(10):te();break;case 16:k(1);break;case 15:case 14:break;default:return ae}}}function k(ae,we=[],Le=[]){if(se(ae),we.length+Le.length>0){let Ie=r.getToken();for(;Ie!==17;){if(we.indexOf(Ie)!==-1){x();break}else if(Le.indexOf(Ie)!==-1)break;Ie=x()}}}function U(ae){const we=r.getTokenValue();return ae?O(we):S(we),x(),!0}function F(){switch(r.getToken()){case 11:let ae=0;try{ae=JSON.parse(r.getTokenValue()),typeof ae!="number"&&(k(2),ae=0)}catch(we){k(2)}O(ae);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return x(),!0}function M(){return r.getToken()!==10?(k(3,[],[2,5]),!1):(U(!1),r.getToken()===6?(W(":"),x(),X()||k(4,[],[2,5])):k(5,[],[2,5]),!0)}function $(){f(),x();let ae=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(ae||k(4,[],[]),W(","),x(),r.getToken()===2&&V)break}else ae&&k(6,[],[]);M()||k(4,[],[2,5]),ae=!0}return E(),r.getToken()!==2?k(7,[2],[]):x(),!0}function H(){l(),x();let ae=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(ae||k(4,[],[]),W(","),x(),r.getToken()===4&&V)break}else ae&&k(6,[],[]);X()||k(4,[],[4,5]),ae=!0}return L(),r.getToken()!==4?k(8,[4],[]):x(),!0}function X(){switch(r.getToken()){case 3:return H();case 1:return $();case 10:return U(!0);default:return F()}}return x(),r.getToken()===17?s.allowEmptyContent?!0:(k(4,[],[]),!1):X()?(r.getToken()!==17&&k(9,[],[]),!0):(k(4,[],[]),!1)}e.visit=u;function c(t,n){let s=y(t),r=[],o,g=0,f;do switch(f=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:g!==f&&r.push(t.substring(g,f)),n!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,n)),g=s.getPosition();break}while(o!==17);return r.join("")}e.stripComments=c;function d(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=d}),define(me[133],ge([0,1,55]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(D,I,i){let A,h,p,a,w;if(I){for(a=I.offset,w=a+I.length,p=a;p>0&&!P(D,p-1);)p--;let g=w;for(;g<D.length&&!P(D,g);)g++;h=D.substring(p,g),A=T(h,i)}else h=D,A=0,p=0,a=0,w=D.length;const m=y(i,D);let b=!1,_=0,u;i.insertSpaces?u=C(" ",i.tabSize||4):u="	";const c=(0,v.createScanner)(h,!1);let d=!1;function t(){return m+C(u,A+_)}function n(){let g=c.scan();for(b=!1;g===15||g===14;)b=b||g===14,g=c.scan();return d=g===16||c.getTokenError()!==0,g}const s=[];function r(g,f,S){!d&&f<w&&S>a&&D.substring(f,S)!==g&&s.push({offset:f,length:S-f,content:g})}let o=n();if(o!==17){const g=c.getTokenOffset()+p,f=C(u,A);r(f,p,g)}for(;o!==17;){let g=c.getTokenOffset()+c.getTokenLength()+p,f=n(),S="";for(;!b&&(f===12||f===13);){const l=c.getTokenOffset()+p;r(" ",g,l),g=c.getTokenOffset()+c.getTokenLength()+p,S=f===12?t():"",f=n()}if(f===2)o!==1&&(_--,S=t());else if(f===4)o!==3&&(_--,S=t());else{switch(o){case 3:case 1:_++,S=t();break;case 5:case 12:S=t();break;case 13:b?S=t():S=" ";break;case 6:S=" ";break;case 10:if(f===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?S=" ":f!==5&&f!==17&&(d=!0);break;case 16:d=!0;break}b&&(f===12||f===13)&&(S=t())}const E=c.getTokenOffset()+p;r(S,g,E),o=f}return s}e.format=R;function C(D,I){let i="";for(let A=0;A<I;A++)i+=D;return i}function T(D,I){let i=0,A=0;const h=I.tabSize||4;for(;i<D.length;){const p=D.charAt(i);if(p===" ")A++;else if(p==="	")A+=h;else break;i++}return Math.floor(A/h)}function y(D,I){for(let i=0;i<I.length;i++){const A=I.charAt(i);if(A==="\r")return i+1<I.length&&I.charAt(i+1)===`
`?`\r
`:"\r";if(A===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=y;function P(D,I){return`\r
`.indexOf(D.charAt(I))!==-1}e.isEOL=P}),define(me[134],ge([0,1,55,133]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(I,i,A){return T(I,i,void 0,A)}e.removeProperty=C;function T(I,i,A,h,p){const a=i.slice(),w=[],m=(0,v.parseTree)(I,w);let b,_;for(;a.length>0&&(_=a.pop(),b=(0,v.findNodeAtLocation)(m,a),b===void 0&&A!==void 0);)typeof _=="string"?A={[_]:A}:A=[A];if(b)if(b.type==="object"&&typeof _=="string"&&Array.isArray(b.children)){const u=(0,v.findNodeAtLocation)(b,[_]);if(u!==void 0)if(A===void 0){if(!u.parent)throw new Error("Malformed AST");const c=b.children.indexOf(u.parent);let d,t=u.parent.offset+u.parent.length;if(c>0){const n=b.children[c-1];d=n.offset+n.length}else d=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return y(I,{offset:d,length:t-d,content:""},h)}else return y(I,{offset:u.offset,length:u.length,content:JSON.stringify(A)},h);else{if(A===void 0)return[];const c=`${JSON.stringify(_)}: ${JSON.stringify(A)}`,d=p?p(b.children.map(n=>n.children[0].value)):b.children.length;let t;if(d>0){const n=b.children[d-1];t={offset:n.offset+n.length,length:0,content:","+c}}else b.children.length===0?t={offset:b.offset+1,length:0,content:c}:t={offset:b.offset+1,length:0,content:c+","};return y(I,t,h)}}else if(b.type==="array"&&typeof _=="number"&&Array.isArray(b.children))if(A!==void 0){const u=`${JSON.stringify(A)}`;let c;if(b.children.length===0||_===0)c={offset:b.offset+1,length:0,content:b.children.length===0?u:u+","};else{const d=_===-1||_>b.children.length?b.children.length:_,t=b.children[d-1];c={offset:t.offset+t.length,length:0,content:","+u}}return y(I,c,h)}else{const u=_,c=b.children[u];let d;if(b.children.length===1)d={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===u){const t=b.children[u-1],n=t.offset+t.length,s=b.offset+b.length;d={offset:n,length:s-2-n,content:""}}else d={offset:c.offset,length:b.children[u+1].offset-c.offset,content:""};return y(I,d,h)}else throw new Error(`Can not add ${typeof _!="number"?"index":"property"} to parent of type ${b.type}`);else{if(A===void 0)throw new Error("Can not delete in empty document");return y(I,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(A)},h)}}e.setProperty=T;function y(I,i,A){let h=P(I,i),p=i.offset,a=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!(0,R.isEOL)(h,p-1);)p--;for(;a<h.length&&!(0,R.isEOL)(h,a);)a++}const w=(0,R.format)(h,{offset:p,length:a-p},A);for(let b=w.length-1;b>=0;b--){const _=w[b];h=P(h,_),p=Math.min(p,_.offset),a=Math.max(a,_.offset+_.length),a+=_.content.length-_.length}const m=I.length-(h.length-a)-p;return[{offset:p,length:m,content:h.substring(p,a)}]}e.withFormatting=y;function P(I,i){return I.substring(0,i.offset)+i.content+I.substring(i.offset+i.length)}e.applyEdit=P;function D(I,i){let A=i.slice(0).sort((p,a)=>{const w=p.offset-a.offset;return w===0?p.length-a.length:w}),h=I.length;for(let p=A.length-1;p>=0;p--){let a=A[p];if(a.offset+a.length<=h)I=P(I,a);else throw new Error("Overlapping edit");h=a.offset}return I}e.applyEdits=D}),define(me[135],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new v(()=>C(this.getValue()))}}e.Lazy=v}),define(me[6],ge([0,1,72,54]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const C=!1;let T=null;function y(u){T=u}if(e.setDisposableTracker=y,C){const u="__is_disposable_tracked__";T=new class{trackDisposable(c){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[u]||console.log(d)},3e3)}markTracked(c){if(c&&c!==w.None)try{c[u]=!0}catch(d){}}}}function P(u){!T||T.markTracked(u)}function D(u){return T&&T.trackDisposable(u),u}e.trackDisposable=D;class I extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=I;function i(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=i;function A(u){if(R.Iterable.is(u)){let c=[];for(const d of u)if(d){P(d);try{d.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new I(c);return Array.isArray(u)?[]:u}else if(u)return P(u),u.dispose(),u}e.dispose=A;function h(...u){return u.forEach(P),p(()=>A(u))}e.combinedDisposable=h;function p(u){const c=D({dispose:()=>{P(c),u()}});return c}e.toDisposable=p;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{A(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return P(c),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new a,D(this)}dispose(){P(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var d;this._isDisposed||c===this._value||((d=this._value)===null||d===void 0||d.dispose(),c&&P(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,P(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=m;class b{constructor(){this.references=new Map}acquire(c,...d){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...d)},this.references.set(c,t));const{object:n}=t,s=(0,v.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:n,dispose:s}}}e.ReferenceCollection=b;class _{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=_}),define(me[56],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(T){this.element=T,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class R{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let T=this._first;for(;T!==v.Undefined;){const y=T.next;T.prev=v.Undefined,T.next=v.Undefined,T=y}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,y){const P=new v(T);if(this._first===v.Undefined)this._first=P,this._last=P;else if(y){const I=this._last;this._last=P,P.prev=I,I.next=P}else{const I=this._first;this._first=P,P.next=I,I.prev=P}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(P))}}shift(){if(this._first!==v.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==v.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==v.Undefined&&T.next!==v.Undefined){const y=T.prev;y.next=T.next,T.next.prev=y}else T.prev===v.Undefined&&T.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):T.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):T.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==v.Undefined;)yield T.element,T=T.next}}e.LinkedList=R}),function(K,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(K=typeof globalThis!="undefined"?globalThis:K||self,K.marked=e())}(this,function(){"use strict";function K(ye,De){for(var ke=0;ke<De.length;ke++){var re=De[ke];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(ye,re.key,re)}}function e(ye,De,ke){return De&&K(ye.prototype,De),ke&&K(ye,ke),ye}function v(ye,De){if(!!ye){if(typeof ye=="string")return R(ye,De);var ke=Object.prototype.toString.call(ye).slice(8,-1);if(ke==="Object"&&ye.constructor&&(ke=ye.constructor.name),ke==="Map"||ke==="Set")return Array.from(ye);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return R(ye,De)}}function R(ye,De){(De==null||De>ye.length)&&(De=ye.length);for(var ke=0,re=new Array(De);ke<De;ke++)re[ke]=ye[ke];return re}function C(ye,De){var ke;if(typeof Symbol=="undefined"||ye[Symbol.iterator]==null){if(Array.isArray(ye)||(ke=v(ye))||De&&ye&&typeof ye.length=="number"){ke&&(ye=ke);var re=0;return function(){return re>=ye.length?{done:!0}:{done:!1,value:ye[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ke=ye[Symbol.iterator](),ke.next.bind(ke)}function T(ye){var De={exports:{}};return ye(De,De.exports),De.exports}var y=T(function(ye){function De(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ke(re){ye.exports.defaults=re}ye.exports={defaults:De(),getDefaults:De,changeDefaults:ke}}),P=/[&<>"']/,D=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,A={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(De){return A[De]};function p(ye,De){if(De){if(P.test(ye))return ye.replace(D,h)}else if(I.test(ye))return ye.replace(i,h);return ye}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function w(ye){return ye.replace(a,function(De,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var m=/(^|[^\[])\^/g;function b(ye,De){ye=ye.source||ye,De=De||"";var ke={replace:function(he,z){return z=z.source||z,z=z.replace(m,"$1"),ye=ye.replace(he,z),ke},getRegex:function(){return new RegExp(ye,De)}};return ke}var _=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(ye,De,ke){if(ye){var re;try{re=decodeURIComponent(w(ke)).replace(_,"").toLowerCase()}catch(he){return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}De&&!u.test(ke)&&(ke=r(De,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch(he){return null}return ke}var d={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(ye,De){d[" "+ye]||(t.test(ye)?d[" "+ye]=ye+"/":d[" "+ye]=S(ye,"/",!0)),ye=d[" "+ye];var ke=ye.indexOf(":")===-1;return De.substring(0,2)==="//"?ke?De:ye.replace(n,"$1")+De:De.charAt(0)==="/"?ke?De:ye.replace(s,"$1")+De:ye+De}var o={exec:function(){}};function g(ye){for(var De=1,ke,re;De<arguments.length;De++){ke=arguments[De];for(re in ke)Object.prototype.hasOwnProperty.call(ke,re)&&(ye[re]=ke[re])}return ye}function f(ye,De){var ke=ye.replace(/\|/g,function(z,J,ce){for(var Pe=!1,Ae=J;--Ae>=0&&ce[Ae]==="\\";)Pe=!Pe;return Pe?"|":" |"}),re=ke.split(/ \|/),he=0;if(re.length>De)re.splice(De);else for(;re.length<De;)re.push("");for(;he<re.length;he++)re[he]=re[he].trim().replace(/\\\|/g,"|");return re}function S(ye,De,ke){var re=ye.length;if(re===0)return"";for(var he=0;he<re;){var z=ye.charAt(re-he-1);if(z===De&&!ke)he++;else if(z!==De&&ke)he++;else break}return ye.substr(0,re-he)}function E(ye,De){if(ye.indexOf(De[1])===-1)return-1;for(var ke=ye.length,re=0,he=0;he<ke;he++)if(ye[he]==="\\")he++;else if(ye[he]===De[0])re++;else if(ye[he]===De[1]&&(re--,re<0))return he;return-1}function l(ye){ye&&ye.sanitize&&!ye.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(ye,De){if(De<1)return"";for(var ke="";De>1;)De&1&&(ke+=ye),De>>=1,ye+=ye;return ke+ye}var O={escape:p,unescape:w,edit:b,cleanUrl:c,resolveUrl:r,noopTest:o,merge:g,splitCells:f,rtrim:S,findClosingBracket:E,checkSanitizeDeprecation:l,repeatString:L},W=y.defaults,te=O.rtrim,se=O.splitCells,N=O.escape,V=O.findClosingBracket;function x(ye,De,ke){var re=De.href,he=De.title?N(De.title):null,z=ye[1].replace(/\\([\[\]])/g,"$1");return ye[0].charAt(0)!=="!"?{type:"link",raw:ke,href:re,title:he,text:z}:{type:"image",raw:ke,href:re,title:he,text:N(z)}}function k(ye,De){var ke=ye.match(/^(\s+)(?:```)/);if(ke===null)return De;var re=ke[1];return De.split(`
`).map(function(he){var z=he.match(/^\s+/);if(z===null)return he;var J=z[0];return J.length>=re.length?he.slice(re.length):he}).join(`
`)}var U=function(){function ye(ke){this.options=ke||W}var De=ye.prototype;return De.space=function(re){var he=this.rules.block.newline.exec(re);if(he)return he[0].length>1?{type:"space",raw:he[0]}:{raw:`
`}},De.code=function(re){var he=this.rules.block.code.exec(re);if(he){var z=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?z:te(z,`
`)}}},De.fences=function(re){var he=this.rules.block.fences.exec(re);if(he){var z=he[0],J=k(z,he[3]||"");return{type:"code",raw:z,lang:he[2]?he[2].trim():he[2],text:J}}},De.heading=function(re){var he=this.rules.block.heading.exec(re);if(he){var z=he[2].trim();if(/#$/.test(z)){var J=te(z,"#");(this.options.pedantic||!J||/ $/.test(J))&&(z=J.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:z}}},De.nptable=function(re){var he=this.rules.block.nptable.exec(re);if(he){var z={type:"table",header:se(he[1].replace(/^ *| *\| *$/g,"")),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:he[3]?he[3].replace(/\n$/,"").split(`
`):[],raw:he[0]};if(z.header.length===z.align.length){var J=z.align.length,ce;for(ce=0;ce<J;ce++)/^ *-+: *$/.test(z.align[ce])?z.align[ce]="right":/^ *:-+: *$/.test(z.align[ce])?z.align[ce]="center":/^ *:-+ *$/.test(z.align[ce])?z.align[ce]="left":z.align[ce]=null;for(J=z.cells.length,ce=0;ce<J;ce++)z.cells[ce]=se(z.cells[ce],z.header.length);return z}}},De.hr=function(re){var he=this.rules.block.hr.exec(re);if(he)return{type:"hr",raw:he[0]}},De.blockquote=function(re){var he=this.rules.block.blockquote.exec(re);if(he){var z=he[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:he[0],text:z}}},De.list=function(re){var he=this.rules.block.list.exec(re);if(he){var z=he[0],J=he[2],ce=J.length>1,Pe={type:"list",raw:z,ordered:ce,start:ce?+J.slice(0,-1):"",loose:!1,items:[]},Ae=he[0].match(this.rules.block.item),Ne=!1,Be,Qe,rt,et,Xe,ot,Et,bt,vt=Ae.length;rt=this.rules.block.listItemStart.exec(Ae[0]);for(var le=0;le<vt;le++){if(Be=Ae[le],z=Be,le!==vt-1){if(et=this.rules.block.listItemStart.exec(Ae[le+1]),this.options.pedantic?et[1].length>rt[1].length:et[1].length>rt[0].length||et[1].length>3){Ae.splice(le,2,Ae[le]+`
`+Ae[le+1]),le--,vt--;continue}else(!this.options.pedantic||this.options.smartLists?et[2][et[2].length-1]!==J[J.length-1]:ce===(et[2].length===1))&&(Xe=Ae.slice(le+1).join(`
`),Pe.raw=Pe.raw.substring(0,Pe.raw.length-Xe.length),le=vt-1);rt=et}Qe=Be.length,Be=Be.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Be.indexOf(`
 `)&&(Qe-=Be.length,Be=this.options.pedantic?Be.replace(/^ {1,4}/gm,""):Be.replace(new RegExp("^ {1,"+Qe+"}","gm"),"")),ot=Ne||/\n\n(?!\s*$)/.test(Be),le!==vt-1&&(Ne=Be.charAt(Be.length-1)===`
`,ot||(ot=Ne)),ot&&(Pe.loose=!0),this.options.gfm&&(Et=/^\[[ xX]\] /.test(Be),bt=void 0,Et&&(bt=Be[1]!==" ",Be=Be.replace(/^\[[ xX]\] +/,""))),Pe.items.push({type:"list_item",raw:z,task:Et,checked:bt,loose:ot,text:Be})}return Pe}},De.html=function(re){var he=this.rules.block.html.exec(re);if(he)return{type:this.options.sanitize?"paragraph":"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):N(he[0]):he[0]}},De.def=function(re){var he=this.rules.block.def.exec(re);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var z=he[1].toLowerCase().replace(/\s+/g," ");return{tag:z,raw:he[0],href:he[2],title:he[3]}}},De.table=function(re){var he=this.rules.block.table.exec(re);if(he){var z={type:"table",header:se(he[1].replace(/^ *| *\| *$/g,"")),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:he[3]?he[3].replace(/\n$/,"").split(`
`):[]};if(z.header.length===z.align.length){z.raw=he[0];var J=z.align.length,ce;for(ce=0;ce<J;ce++)/^ *-+: *$/.test(z.align[ce])?z.align[ce]="right":/^ *:-+: *$/.test(z.align[ce])?z.align[ce]="center":/^ *:-+ *$/.test(z.align[ce])?z.align[ce]="left":z.align[ce]=null;for(J=z.cells.length,ce=0;ce<J;ce++)z.cells[ce]=se(z.cells[ce].replace(/^ *\| *| *\| *$/g,""),z.header.length);return z}}},De.lheading=function(re){var he=this.rules.block.lheading.exec(re);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1]}},De.paragraph=function(re){var he=this.rules.block.paragraph.exec(re);if(he)return{type:"paragraph",raw:he[0],text:he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1]}},De.text=function(re){var he=this.rules.block.text.exec(re);if(he)return{type:"text",raw:he[0],text:he[0]}},De.escape=function(re){var he=this.rules.inline.escape.exec(re);if(he)return{type:"escape",raw:he[0],text:N(he[1])}},De.tag=function(re,he,z){var J=this.rules.inline.tag.exec(re);if(J)return!he&&/^<a /i.test(J[0])?he=!0:he&&/^<\/a>/i.test(J[0])&&(he=!1),!z&&/^<(pre|code|kbd|script)(\s|>)/i.test(J[0])?z=!0:z&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(J[0])&&(z=!1),{type:this.options.sanitize?"text":"html",raw:J[0],inLink:he,inRawBlock:z,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):N(J[0]):J[0]}},De.link=function(re){var he=this.rules.inline.link.exec(re);if(he){var z=he[2].trim();if(!this.options.pedantic&&/^</.test(z)){if(!/>$/.test(z))return;var J=te(z.slice(0,-1),"\\");if((z.length-J.length)%2==0)return}else{var ce=V(he[2],"()");if(ce>-1){var Pe=he[0].indexOf("!")===0?5:4,Ae=Pe+he[1].length+ce;he[2]=he[2].substring(0,ce),he[0]=he[0].substring(0,Ae).trim(),he[3]=""}}var Ne=he[2],Be="";if(this.options.pedantic){var Qe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ne);Qe&&(Ne=Qe[1],Be=Qe[3])}else Be=he[3]?he[3].slice(1,-1):"";return Ne=Ne.trim(),/^</.test(Ne)&&(this.options.pedantic&&!/>$/.test(z)?Ne=Ne.slice(1):Ne=Ne.slice(1,-1)),x(he,{href:Ne&&Ne.replace(this.rules.inline._escapes,"$1"),title:Be&&Be.replace(this.rules.inline._escapes,"$1")},he[0])}},De.reflink=function(re,he){var z;if((z=this.rules.inline.reflink.exec(re))||(z=this.rules.inline.nolink.exec(re))){var J=(z[2]||z[1]).replace(/\s+/g," ");if(J=he[J.toLowerCase()],!J||!J.href){var ce=z[0].charAt(0);return{type:"text",raw:ce,text:ce}}return x(z,J,z[0])}},De.emStrong=function(re,he,z){z===void 0&&(z="");var J=this.rules.inline.emStrong.lDelim.exec(re);if(!!J&&!(J[3]&&z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ce=J[1]||J[2]||"";if(!ce||ce&&(z===""||this.rules.inline.punctuation.exec(z))){var Pe=J[0].length-1,Ae,Ne,Be=Pe,Qe=0,rt=J[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,he=he.slice(-1*re.length+Pe);(J=rt.exec(he))!=null;)if(Ae=J[1]||J[2]||J[3]||J[4]||J[5]||J[6],!!Ae){if(Ne=Ae.length,J[3]||J[4]){Be+=Ne;continue}else if((J[5]||J[6])&&Pe%3&&!((Pe+Ne)%3)){Qe+=Ne;continue}if(Be-=Ne,!(Be>0)){if(Be+Qe-Ne<=0&&!he.slice(rt.lastIndex).match(rt)&&(Ne=Math.min(Ne,Ne+Be+Qe)),Math.min(Pe,Ne)%2)return{type:"em",raw:re.slice(0,Pe+J.index+Ne+1),text:re.slice(1,Pe+J.index+Ne)};if(Math.min(Pe,Ne)%2==0)return{type:"strong",raw:re.slice(0,Pe+J.index+Ne+1),text:re.slice(2,Pe+J.index+Ne-1)}}}}}},De.codespan=function(re){var he=this.rules.inline.code.exec(re);if(he){var z=he[2].replace(/\n/g," "),J=/[^ ]/.test(z),ce=/^ /.test(z)&&/ $/.test(z);return J&&ce&&(z=z.substring(1,z.length-1)),z=N(z,!0),{type:"codespan",raw:he[0],text:z}}},De.br=function(re){var he=this.rules.inline.br.exec(re);if(he)return{type:"br",raw:he[0]}},De.del=function(re){var he=this.rules.inline.del.exec(re);if(he)return{type:"del",raw:he[0],text:he[2]}},De.autolink=function(re,he){var z=this.rules.inline.autolink.exec(re);if(z){var J,ce;return z[2]==="@"?(J=N(this.options.mangle?he(z[1]):z[1]),ce="mailto:"+J):(J=N(z[1]),ce=J),{type:"link",raw:z[0],text:J,href:ce,tokens:[{type:"text",raw:J,text:J}]}}},De.url=function(re,he){var z;if(z=this.rules.inline.url.exec(re)){var J,ce;if(z[2]==="@")J=N(this.options.mangle?he(z[0]):z[0]),ce="mailto:"+J;else{var Pe;do Pe=z[0],z[0]=this.rules.inline._backpedal.exec(z[0])[0];while(Pe!==z[0]);J=N(z[0]),z[1]==="www."?ce="http://"+J:ce=J}return{type:"link",raw:z[0],text:J,href:ce,tokens:[{type:"text",raw:J,text:J}]}}},De.inlineText=function(re,he,z){var J=this.rules.inline.text.exec(re);if(J){var ce;return he?ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):N(J[0]):J[0]:ce=N(this.options.smartypants?z(J[0]):J[0]),{type:"text",raw:J[0],text:ce}}},ye}(),F=O.noopTest,M=O.edit,$=O.merge,H={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:F,table:F,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};H._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,H._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,H.def=M(H.def).replace("label",H._label).replace("title",H._title).getRegex(),H.bullet=/(?:[*+-]|\d{1,9}[.)])/,H.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,H.item=M(H.item,"gm").replace(/bull/g,H.bullet).getRegex(),H.listItemStart=M(/^( *)(bull)/).replace("bull",H.bullet).getRegex(),H.list=M(H.list).replace(/bull/g,H.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+H.def.source+")").getRegex(),H._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",H._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,H.html=M(H.html,"i").replace("comment",H._comment).replace("tag",H._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),H.paragraph=M(H._paragraph).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",H._tag).getRegex(),H.blockquote=M(H.blockquote).replace("paragraph",H.paragraph).getRegex(),H.normal=$({},H),H.gfm=$({},H.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),H.gfm.nptable=M(H.gfm.nptable).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",H._tag).getRegex(),H.gfm.table=M(H.gfm.table).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",H._tag).getRegex(),H.pedantic=$({},H.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",H._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:F,paragraph:M(H.normal._paragraph).replace("hr",H.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",H.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var X={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:F,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:F,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};X._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",X.punctuation=M(X.punctuation).replace(/punctuation/g,X._punctuation).getRegex(),X.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,X.escapedEmSt=/\\\*|\\_/g,X._comment=M(H._comment).replace("(?:-->|$)","-->").getRegex(),X.emStrong.lDelim=M(X.emStrong.lDelim).replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimAst=M(X.emStrong.rDelimAst,"g").replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimUnd=M(X.emStrong.rDelimUnd,"g").replace(/punct/g,X._punctuation).getRegex(),X._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,X._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,X._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,X.autolink=M(X.autolink).replace("scheme",X._scheme).replace("email",X._email).getRegex(),X._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,X.tag=M(X.tag).replace("comment",X._comment).replace("attribute",X._attribute).getRegex(),X._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,X._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,X._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,X.link=M(X.link).replace("label",X._label).replace("href",X._href).replace("title",X._title).getRegex(),X.reflink=M(X.reflink).replace("label",X._label).getRegex(),X.reflinkSearch=M(X.reflinkSearch,"g").replace("reflink",X.reflink).replace("nolink",X.nolink).getRegex(),X.normal=$({},X),X.pedantic=$({},X.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",X._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",X._label).getRegex()}),X.gfm=$({},X.normal,{escape:M(X.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),X.gfm.url=M(X.gfm.url,"i").replace("email",X.gfm._extended_email).getRegex(),X.breaks=$({},X.gfm,{br:M(X.br).replace("{2,}","*").getRegex(),text:M(X.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ae={block:H,inline:X},we=y.defaults,Le=ae.block,Ie=ae.inline,Me=O.repeatString;function We(ye){return ye.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(ye){var De="",ke,re,he=ye.length;for(ke=0;ke<he;ke++)re=ye.charCodeAt(ke),Math.random()>.5&&(re="x"+re.toString(16)),De+="&#"+re+";";return De}var Y=function(){function ye(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||we,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var re={block:Le.normal,inline:Ie.normal};this.options.pedantic?(re.block=Le.pedantic,re.inline=Ie.pedantic):this.options.gfm&&(re.block=Le.gfm,this.options.breaks?re.inline=Ie.breaks:re.inline=Ie.gfm),this.tokenizer.rules=re}ye.lex=function(re,he){var z=new ye(he);return z.lex(re)},ye.lexInline=function(re,he){var z=new ye(he);return z.inlineTokens(re)};var De=ye.prototype;return De.lex=function(re){return re=re.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(re,this.tokens,!0),this.inline(this.tokens),this.tokens},De.blockTokens=function(re,he,z){he===void 0&&(he=[]),z===void 0&&(z=!0),this.options.pedantic&&(re=re.replace(/^ +$/gm,""));for(var J,ce,Pe,Ae;re;){if(J=this.tokenizer.space(re)){re=re.substring(J.raw.length),J.type&&he.push(J);continue}if(J=this.tokenizer.code(re)){re=re.substring(J.raw.length),Ae=he[he.length-1],Ae&&Ae.type==="paragraph"?(Ae.raw+=`
`+J.raw,Ae.text+=`
`+J.text):he.push(J);continue}if(J=this.tokenizer.fences(re)){re=re.substring(J.raw.length),he.push(J);continue}if(J=this.tokenizer.heading(re)){re=re.substring(J.raw.length),he.push(J);continue}if(J=this.tokenizer.nptable(re)){re=re.substring(J.raw.length),he.push(J);continue}if(J=this.tokenizer.hr(re)){re=re.substring(J.raw.length),he.push(J);continue}if(J=this.tokenizer.blockquote(re)){re=re.substring(J.raw.length),J.tokens=this.blockTokens(J.text,[],z),he.push(J);continue}if(J=this.tokenizer.list(re)){for(re=re.substring(J.raw.length),Pe=J.items.length,ce=0;ce<Pe;ce++)J.items[ce].tokens=this.blockTokens(J.items[ce].text,[],!1);he.push(J);continue}if(J=this.tokenizer.html(re)){re=re.substring(J.raw.length),he.push(J);continue}if(z&&(J=this.tokenizer.def(re))){re=re.substring(J.raw.length),this.tokens.links[J.tag]||(this.tokens.links[J.tag]={href:J.href,title:J.title});continue}if(J=this.tokenizer.table(re)){re=re.substring(J.raw.length),he.push(J);continue}if(J=this.tokenizer.lheading(re)){re=re.substring(J.raw.length),he.push(J);continue}if(z&&(J=this.tokenizer.paragraph(re))){re=re.substring(J.raw.length),he.push(J);continue}if(J=this.tokenizer.text(re)){re=re.substring(J.raw.length),Ae=he[he.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+J.raw,Ae.text+=`
`+J.text):he.push(J);continue}if(re){var Ne="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(Ne);break}else throw new Error(Ne)}}return he},De.inline=function(re){var he,z,J,ce,Pe,Ae,Ne=re.length;for(he=0;he<Ne;he++)switch(Ae=re[he],Ae.type){case"paragraph":case"text":case"heading":{Ae.tokens=[],this.inlineTokens(Ae.text,Ae.tokens);break}case"table":{for(Ae.tokens={header:[],cells:[]},ce=Ae.header.length,z=0;z<ce;z++)Ae.tokens.header[z]=[],this.inlineTokens(Ae.header[z],Ae.tokens.header[z]);for(ce=Ae.cells.length,z=0;z<ce;z++)for(Pe=Ae.cells[z],Ae.tokens.cells[z]=[],J=0;J<Pe.length;J++)Ae.tokens.cells[z][J]=[],this.inlineTokens(Pe[J],Ae.tokens.cells[z][J]);break}case"blockquote":{this.inline(Ae.tokens);break}case"list":{for(ce=Ae.items.length,z=0;z<ce;z++)this.inline(Ae.items[z].tokens);break}}return re},De.inlineTokens=function(re,he,z,J){he===void 0&&(he=[]),z===void 0&&(z=!1),J===void 0&&(J=!1);var ce,Pe,Ae=re,Ne,Be,Qe;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Ne=this.tokenizer.rules.inline.reflinkSearch.exec(Ae))!=null;)rt.includes(Ne[0].slice(Ne[0].lastIndexOf("[")+1,-1))&&(Ae=Ae.slice(0,Ne.index)+"["+Me("a",Ne[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ne=this.tokenizer.rules.inline.blockSkip.exec(Ae))!=null;)Ae=Ae.slice(0,Ne.index)+"["+Me("a",Ne[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ne=this.tokenizer.rules.inline.escapedEmSt.exec(Ae))!=null;)Ae=Ae.slice(0,Ne.index)+"++"+Ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;){if(Be||(Qe=""),Be=!1,ce=this.tokenizer.escape(re)){re=re.substring(ce.raw.length),he.push(ce);continue}if(ce=this.tokenizer.tag(re,z,J)){re=re.substring(ce.raw.length),z=ce.inLink,J=ce.inRawBlock;var et=he[he.length-1];et&&ce.type==="text"&&et.type==="text"?(et.raw+=ce.raw,et.text+=ce.text):he.push(ce);continue}if(ce=this.tokenizer.link(re)){re=re.substring(ce.raw.length),ce.type==="link"&&(ce.tokens=this.inlineTokens(ce.text,[],!0,J)),he.push(ce);continue}if(ce=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(ce.raw.length);var Xe=he[he.length-1];ce.type==="link"?(ce.tokens=this.inlineTokens(ce.text,[],!0,J),he.push(ce)):Xe&&ce.type==="text"&&Xe.type==="text"?(Xe.raw+=ce.raw,Xe.text+=ce.text):he.push(ce);continue}if(ce=this.tokenizer.emStrong(re,Ae,Qe)){re=re.substring(ce.raw.length),ce.tokens=this.inlineTokens(ce.text,[],z,J),he.push(ce);continue}if(ce=this.tokenizer.codespan(re)){re=re.substring(ce.raw.length),he.push(ce);continue}if(ce=this.tokenizer.br(re)){re=re.substring(ce.raw.length),he.push(ce);continue}if(ce=this.tokenizer.del(re)){re=re.substring(ce.raw.length),ce.tokens=this.inlineTokens(ce.text,[],z,J),he.push(ce);continue}if(ce=this.tokenizer.autolink(re,j)){re=re.substring(ce.raw.length),he.push(ce);continue}if(!z&&(ce=this.tokenizer.url(re,j))){re=re.substring(ce.raw.length),he.push(ce);continue}if(ce=this.tokenizer.inlineText(re,J,We)){re=re.substring(ce.raw.length),ce.raw.slice(-1)!=="_"&&(Qe=ce.raw.slice(-1)),Be=!0,Pe=he[he.length-1],Pe&&Pe.type==="text"?(Pe.raw+=ce.raw,Pe.text+=ce.text):he.push(ce);continue}if(re){var ot="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(ot);break}else throw new Error(ot)}}return he},e(ye,null,[{key:"rules",get:function(){return{block:Le,inline:Ie}}}]),ye}(),ee=y.defaults,oe=O.cleanUrl,pe=O.escape,_e=function(){function ye(ke){this.options=ke||ee}var De=ye.prototype;return De.code=function(re,he,z){var J=(he||"").match(/\S*/)[0];if(this.options.highlight){var ce=this.options.highlight(re,J);ce!=null&&ce!==re&&(z=!0,re=ce)}return re=re.replace(/\n$/,"")+`
`,J?'<pre><code class="'+this.options.langPrefix+pe(J,!0)+'">'+(z?re:pe(re,!0))+`</code></pre>
`:"<pre><code>"+(z?re:pe(re,!0))+`</code></pre>
`},De.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},De.html=function(re){return re},De.heading=function(re,he,z,J){return this.options.headerIds?"<h"+he+' id="'+this.options.headerPrefix+J.slug(z)+'">'+re+"</h"+he+`>
`:"<h"+he+">"+re+"</h"+he+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(re,he,z){var J=he?"ol":"ul",ce=he&&z!==1?' start="'+z+'"':"";return"<"+J+ce+`>
`+re+"</"+J+`>
`},De.listitem=function(re){return"<li>"+re+`</li>
`},De.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(re){return"<p>"+re+`</p>
`},De.table=function(re,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+he+`</table>
`},De.tablerow=function(re){return`<tr>
`+re+`</tr>
`},De.tablecell=function(re,he){var z=he.header?"th":"td",J=he.align?"<"+z+' align="'+he.align+'">':"<"+z+">";return J+re+"</"+z+`>
`},De.strong=function(re){return"<strong>"+re+"</strong>"},De.em=function(re){return"<em>"+re+"</em>"},De.codespan=function(re){return"<code>"+re+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(re){return"<del>"+re+"</del>"},De.link=function(re,he,z){if(re=oe(this.options.sanitize,this.options.baseUrl,re),re===null)return z;var J='<a href="'+pe(re)+'"';return he&&(J+=' title="'+he+'"'),J+=">"+z+"</a>",J},De.image=function(re,he,z){if(re=oe(this.options.sanitize,this.options.baseUrl,re),re===null)return z;var J='<img src="'+re+'" alt="'+z+'"';return he&&(J+=' title="'+he+'"'),J+=this.options.xhtml?"/>":">",J},De.text=function(re){return re},ye}(),de=function(){function ye(){}var De=ye.prototype;return De.strong=function(re){return re},De.em=function(re){return re},De.codespan=function(re){return re},De.del=function(re){return re},De.html=function(re){return re},De.text=function(re){return re},De.link=function(re,he,z){return""+z},De.image=function(re,he,z){return""+z},De.br=function(){return""},ye}(),Ee=function(){function ye(){this.seen={}}var De=ye.prototype;return De.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(re,he){var z=re,J=0;if(this.seen.hasOwnProperty(z)){J=this.seen[re];do J++,z=re+"-"+J;while(this.seen.hasOwnProperty(z))}return he||(this.seen[re]=J,this.seen[z]=0),z},De.slug=function(re,he){he===void 0&&(he={});var z=this.serialize(re);return this.getNextSafeSlug(z,he.dryrun)},ye}(),Re=y.defaults,Ve=O.unescape,be=function(){function ye(ke){this.options=ke||Re,this.options.renderer=this.options.renderer||new _e,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new Ee}ye.parse=function(re,he){var z=new ye(he);return z.parse(re)},ye.parseInline=function(re,he){var z=new ye(he);return z.parseInline(re)};var De=ye.prototype;return De.parse=function(re,he){he===void 0&&(he=!0);var z="",J,ce,Pe,Ae,Ne,Be,Qe,rt,et,Xe,ot,Et,bt,vt,le,Se,ue,G,Ue=re.length;for(J=0;J<Ue;J++)switch(Xe=re[J],Xe.type){case"space":continue;case"hr":{z+=this.renderer.hr();continue}case"heading":{z+=this.renderer.heading(this.parseInline(Xe.tokens),Xe.depth,Ve(this.parseInline(Xe.tokens,this.textRenderer)),this.slugger);continue}case"code":{z+=this.renderer.code(Xe.text,Xe.lang,Xe.escaped);continue}case"table":{for(rt="",Qe="",Ae=Xe.header.length,ce=0;ce<Ae;ce++)Qe+=this.renderer.tablecell(this.parseInline(Xe.tokens.header[ce]),{header:!0,align:Xe.align[ce]});for(rt+=this.renderer.tablerow(Qe),et="",Ae=Xe.cells.length,ce=0;ce<Ae;ce++){for(Be=Xe.tokens.cells[ce],Qe="",Ne=Be.length,Pe=0;Pe<Ne;Pe++)Qe+=this.renderer.tablecell(this.parseInline(Be[Pe]),{header:!1,align:Xe.align[Pe]});et+=this.renderer.tablerow(Qe)}z+=this.renderer.table(rt,et);continue}case"blockquote":{et=this.parse(Xe.tokens),z+=this.renderer.blockquote(et);continue}case"list":{for(ot=Xe.ordered,Et=Xe.start,bt=Xe.loose,Ae=Xe.items.length,et="",ce=0;ce<Ae;ce++)le=Xe.items[ce],Se=le.checked,ue=le.task,vt="",le.task&&(G=this.renderer.checkbox(Se),bt?le.tokens.length>0&&le.tokens[0].type==="text"?(le.tokens[0].text=G+" "+le.tokens[0].text,le.tokens[0].tokens&&le.tokens[0].tokens.length>0&&le.tokens[0].tokens[0].type==="text"&&(le.tokens[0].tokens[0].text=G+" "+le.tokens[0].tokens[0].text)):le.tokens.unshift({type:"text",text:G}):vt+=G),vt+=this.parse(le.tokens,bt),et+=this.renderer.listitem(vt,ue,Se);z+=this.renderer.list(et,ot,Et);continue}case"html":{z+=this.renderer.html(Xe.text);continue}case"paragraph":{z+=this.renderer.paragraph(this.parseInline(Xe.tokens));continue}case"text":{for(et=Xe.tokens?this.parseInline(Xe.tokens):Xe.text;J+1<Ue&&re[J+1].type==="text";)Xe=re[++J],et+=`
`+(Xe.tokens?this.parseInline(Xe.tokens):Xe.text);z+=he?this.renderer.paragraph(et):et;continue}default:{var Fe='Token with "'+Xe.type+'" type was not found.';if(this.options.silent){console.error(Fe);return}else throw new Error(Fe)}}return z},De.parseInline=function(re,he){he=he||this.renderer;var z="",J,ce,Pe=re.length;for(J=0;J<Pe;J++)switch(ce=re[J],ce.type){case"escape":{z+=he.text(ce.text);break}case"html":{z+=he.html(ce.text);break}case"link":{z+=he.link(ce.href,ce.title,this.parseInline(ce.tokens,he));break}case"image":{z+=he.image(ce.href,ce.title,ce.text);break}case"strong":{z+=he.strong(this.parseInline(ce.tokens,he));break}case"em":{z+=he.em(this.parseInline(ce.tokens,he));break}case"codespan":{z+=he.codespan(ce.text);break}case"br":{z+=he.br();break}case"del":{z+=he.del(this.parseInline(ce.tokens,he));break}case"text":{z+=he.text(ce.text);break}default:{var Ae='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}return z},ye}(),Ke=O.merge,Q=O.checkSanitizeDeprecation,ne=O.escape,ve=y.getDefaults,xe=y.changeDefaults,je=y.defaults;function ze(ye,De,ke){if(typeof ye=="undefined"||ye===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");if(typeof De=="function"&&(ke=De,De=null),De=Ke({},ze.defaults,De||{}),Q(De),ke){var re=De.highlight,he;try{he=Y.lex(ye,De)}catch(Pe){return ke(Pe)}var z=function(Ae){var Ne;if(!Ae)try{Ne=be.parse(he,De)}catch(Be){Ae=Be}return De.highlight=re,Ae?ke(Ae):ke(null,Ne)};if(!re||re.length<3||(delete De.highlight,!he.length))return z();var J=0;ze.walkTokens(he,function(Pe){Pe.type==="code"&&(J++,setTimeout(function(){re(Pe.text,Pe.lang,function(Ae,Ne){if(Ae)return z(Ae);Ne!=null&&Ne!==Pe.text&&(Pe.text=Ne,Pe.escaped=!0),J--,J===0&&z()})},0))}),J===0&&z();return}try{var ce=Y.lex(ye,De);return De.walkTokens&&ze.walkTokens(ce,De.walkTokens),be.parse(ce,De)}catch(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+ne(Pe.message+"",!0)+"</pre>";throw Pe}}ze.options=ze.setOptions=function(ye){return Ke(ze.defaults,ye),xe(ze.defaults),ze},ze.getDefaults=ve,ze.defaults=je,ze.use=function(ye){var De=Ke({},ye);if(ye.renderer&&function(){var re=ze.defaults.renderer||new _e,he=function(ce){var Pe=re[ce];re[ce]=function(){for(var Ae=arguments.length,Ne=new Array(Ae),Be=0;Be<Ae;Be++)Ne[Be]=arguments[Be];var Qe=ye.renderer[ce].apply(re,Ne);return Qe===!1&&(Qe=Pe.apply(re,Ne)),Qe}};for(var z in ye.renderer)he(z);De.renderer=re}(),ye.tokenizer&&function(){var re=ze.defaults.tokenizer||new U,he=function(ce){var Pe=re[ce];re[ce]=function(){for(var Ae=arguments.length,Ne=new Array(Ae),Be=0;Be<Ae;Be++)Ne[Be]=arguments[Be];var Qe=ye.tokenizer[ce].apply(re,Ne);return Qe===!1&&(Qe=Pe.apply(re,Ne)),Qe}};for(var z in ye.tokenizer)he(z);De.tokenizer=re}(),ye.walkTokens){var ke=ze.defaults.walkTokens;De.walkTokens=function(re){ye.walkTokens(re),ke&&ke(re)}}ze.setOptions(De)},ze.walkTokens=function(ye,De){for(var ke=C(ye),re;!(re=ke()).done;){var he=re.value;switch(De(he),he.type){case"table":{for(var z=C(he.tokens.header),J;!(J=z()).done;){var ce=J.value;ze.walkTokens(ce,De)}for(var Pe=C(he.tokens.cells),Ae;!(Ae=Pe()).done;)for(var Ne=Ae.value,Be=C(Ne),Qe;!(Qe=Be()).done;){var rt=Qe.value;ze.walkTokens(rt,De)}break}case"list":{ze.walkTokens(he.items,De);break}default:he.tokens&&ze.walkTokens(he.tokens,De)}}},ze.parseInline=function(ye,De){if(typeof ye=="undefined"||ye===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");De=Ke({},ze.defaults,De||{}),Q(De);try{var ke=Y.lexInline(ye,De);return De.walkTokens&&ze.walkTokens(ke,De.walkTokens),be.parseInline(ke,De)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+ne(re.message+"",!0)+"</pre>";throw re}},ze.Parser=be,ze.parser=be.parse,ze.Renderer=_e,ze.TextRenderer=de,ze.Lexer=Y,ze.lexer=Y.lex,ze.Tokenizer=U,ze.Slugger=Ee,ze.parse=ze;var Je=ze;return Je}),define(me[74],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function v(y,P,D){return Math.min(Math.max(y,P),D)}e.clamp=v;function R(y,P){return(P+y%P)%P}e.rot=R;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class T{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function K(C){const T=[];typeof C=="number"&&T.push("code/timeOrigin",C);function y(D){T.push(D,Date.now())}function P(){const D=[];for(let I=0;I<T.length;I+=2)D.push({name:T[I],startTime:T[I+1]});return D}return{mark:y,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const y of performance.getEntriesByType("mark"))T.push({name:y.name,startTime:Math.round(C+y.startTime)});return T}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function v(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))}(),define(me[11],ge([0,1]),function(K,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let C=!1,T=!1,y=!1,P=!1,D=!1,I=!1,i=!1,A,h=R,p,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?w=e.globals.vscode.process:typeof process!="undefined"&&(w=process);const m=typeof((v=w==null?void 0:w.versions)===null||v===void 0?void 0:v.electron)=="string"&&w.type==="renderer";if(e.isElectronSandboxed=m&&(w==null?void 0:w.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=w==null?void 0:w.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!m)a=navigator.userAgent,C=a.indexOf("Windows")>=0,T=a.indexOf("Macintosh")>=0,i=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=a.indexOf("Linux")>=0,I=!0,A=navigator.language,h=A;else if(typeof w=="object"){C=w.platform==="win32",T=w.platform==="darwin",y=w.platform==="linux",P=y&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,A=R,h=R;const r=w.env.VSCODE_NLS_CONFIG;if(r)try{const o=JSON.parse(r),g=o.availableLanguages["*"];A=o.locale,h=g||R,p=o._translationsConfigFile}catch(o){}D=!0}else console.error("Unable to resolve platform.");var b;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function _(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=_;let u=0;T?u=1:C?u=3:y&&(u=2),e.isWindows=C,e.isMacintosh=T,e.isLinux=y,e.isLinuxSnap=P,e.isNative=D,e.isWeb=I,e.isIOS=i,e.platform=u,e.userAgent=a,e.language=h;var c;(function(r){function o(){return e.language}r.value=o;function g(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=g;function f(){return e.language==="en"}r.isDefault=f})(c=e.Language||(e.Language={})),e.locale=A,e.translationsConfigFile=p,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let g=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let E=0,l=g.length;E<l;E++){const L=g[E];if(L.id===S.data.vscodeSetImmediateId){g.splice(E,1),L.callback();return}}});let f=0;return S=>{const E=++f;g.push({id:E,callback:S}),e.globals.postMessage({vscodeSetImmediateId:E},"*")}}if(typeof(w==null?void 0:w.nextTick)=="function")return w.nextTick.bind(w);const o=Promise.resolve();return g=>o.then(g)}();var d;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(d=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||i?2:C?1:3;let t=!0,n=!1;function s(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(me[36],ge([0,1,11]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const C=v.globals.vscode.process;R={get platform(){return C.platform},get env(){return C.env},cwd(){return C.cwd()},nextTick(T){return(0,v.setImmediate)(T)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:R={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(C){return(0,v.setImmediate)(C)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(me[9],ge([0,1,36]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,C=97,T=90,y=122,P=46,D=47,I=92,i=58,A=63;class h extends Error{constructor(c,d,t){let n;typeof d=="string"&&d.indexOf("not ")===0?(n="must not be",d=d.replace(/^not /,"")):n="must be";const s=c.indexOf(".")!==-1?"property":"argument";let r=`The "${c}" ${s} ${n} of type ${d}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function p(u,c){if(typeof u!="string")throw new h(c,"string",u)}function a(u){return u===D||u===I}function w(u){return u===D}function m(u){return u>=R&&u<=T||u>=C&&u<=y}function b(u,c,d,t){let n="",s=0,r=-1,o=0,g=0;for(let f=0;f<=u.length;++f){if(f<u.length)g=u.charCodeAt(f);else{if(t(g))break;g=D}if(t(g)){if(!(r===f-1||o===1))if(o===2){if(n.length<2||s!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const S=n.lastIndexOf(d);S===-1?(n="",s=0):(n=n.slice(0,S),s=n.length-1-n.lastIndexOf(d)),r=f,o=0;continue}else if(n.length!==0){n="",s=0,r=f,o=0;continue}}c&&(n+=n.length>0?`${d}..`:"..",s=2)}else n.length>0?n+=`${d}${u.slice(r+1,f)}`:n=u.slice(r+1,f),s=f-r-1;r=f,o=0}else g===P&&o!==-1?++o:o=-1}return n}function _(u,c){if(c===null||typeof c!="object")throw new h("pathObject","Object",c);const d=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return d?d===c.root?`${d}${t}`:`${d}${u}${t}`:t}e.win32={resolve(...u){let c="",d="",t=!1;for(let n=u.length-1;n>=-1;n--){let s;if(n>=0){if(s=u[n],p(s,"path"),s.length===0)continue}else c.length===0?s=v.cwd():(s=v.env[`=${c}`]||v.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==c.toLowerCase()&&s.charCodeAt(2)===I)&&(s=`${c}\\`));const r=s.length;let o=0,g="",f=!1;const S=s.charCodeAt(0);if(r===1)a(S)&&(o=1,f=!0);else if(a(S))if(f=!0,a(s.charCodeAt(1))){let E=2,l=E;for(;E<r&&!a(s.charCodeAt(E));)E++;if(E<r&&E!==l){const L=s.slice(l,E);for(l=E;E<r&&a(s.charCodeAt(E));)E++;if(E<r&&E!==l){for(l=E;E<r&&!a(s.charCodeAt(E));)E++;(E===r||E!==l)&&(g=`\\\\${L}\\${s.slice(l,E)}`,o=E)}}}else o=1;else m(S)&&s.charCodeAt(1)===i&&(g=s.slice(0,2),o=2,r>2&&a(s.charCodeAt(2))&&(f=!0,o=3));if(g.length>0)if(c.length>0){if(g.toLowerCase()!==c.toLowerCase())continue}else c=g;if(t){if(c.length>0)break}else if(d=`${s.slice(o)}\\${d}`,t=f,f&&c.length>0)break}return d=b(d,!t,"\\",a),t?`${c}\\${d}`:`${c}${d}`||"."},normalize(u){p(u,"path");const c=u.length;if(c===0)return".";let d=0,t,n=!1;const s=u.charCodeAt(0);if(c===1)return w(s)?"\\":u;if(a(s))if(n=!0,a(u.charCodeAt(1))){let o=2,g=o;for(;o<c&&!a(u.charCodeAt(o));)o++;if(o<c&&o!==g){const f=u.slice(g,o);for(g=o;o<c&&a(u.charCodeAt(o));)o++;if(o<c&&o!==g){for(g=o;o<c&&!a(u.charCodeAt(o));)o++;if(o===c)return`\\\\${f}\\${u.slice(g)}\\`;o!==g&&(t=`\\\\${f}\\${u.slice(g,o)}`,d=o)}}}else d=1;else m(s)&&u.charCodeAt(1)===i&&(t=u.slice(0,2),d=2,c>2&&a(u.charCodeAt(2))&&(n=!0,d=3));let r=d<c?b(u.slice(d),!n,"\\",a):"";return r.length===0&&!n&&(r="."),r.length>0&&a(u.charCodeAt(c-1))&&(r+="\\"),t===void 0?n?`\\${r}`:r:n?`${t}\\${r}`:`${t}${r}`},isAbsolute(u){p(u,"path");const c=u.length;if(c===0)return!1;const d=u.charCodeAt(0);return a(d)||c>2&&m(d)&&u.charCodeAt(1)===i&&a(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let c,d;for(let s=0;s<u.length;++s){const r=u[s];p(r,"path"),r.length>0&&(c===void 0?c=d=r:c+=`\\${r}`)}if(c===void 0)return".";let t=!0,n=0;if(typeof d=="string"&&a(d.charCodeAt(0))){++n;const s=d.length;s>1&&a(d.charCodeAt(1))&&(++n,s>2&&(a(d.charCodeAt(2))?++n:t=!1))}if(t){for(;n<c.length&&a(c.charCodeAt(n));)n++;n>=2&&(c=`\\${c.slice(n)}`)}return e.win32.normalize(c)},relative(u,c){if(p(u,"from"),p(c,"to"),u===c)return"";const d=e.win32.resolve(u),t=e.win32.resolve(c);if(d===t||(u=d.toLowerCase(),c=t.toLowerCase(),u===c))return"";let n=0;for(;n<u.length&&u.charCodeAt(n)===I;)n++;let s=u.length;for(;s-1>n&&u.charCodeAt(s-1)===I;)s--;const r=s-n;let o=0;for(;o<c.length&&c.charCodeAt(o)===I;)o++;let g=c.length;for(;g-1>o&&c.charCodeAt(g-1)===I;)g--;const f=g-o,S=r<f?r:f;let E=-1,l=0;for(;l<S;l++){const O=u.charCodeAt(n+l);if(O!==c.charCodeAt(o+l))break;O===I&&(E=l)}if(l!==S){if(E===-1)return t}else{if(f>S){if(c.charCodeAt(o+l)===I)return t.slice(o+l+1);if(l===2)return t.slice(o+l)}r>S&&(u.charCodeAt(n+l)===I?E=l:l===2&&(E=3)),E===-1&&(E=0)}let L="";for(l=n+E+1;l<=s;++l)(l===s||u.charCodeAt(l)===I)&&(L+=L.length===0?"..":"\\..");return o+=E,L.length>0?`${L}${t.slice(o,g)}`:(t.charCodeAt(o)===I&&++o,t.slice(o,g))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const c=e.win32.resolve(u);if(c.length<=2)return u;if(c.charCodeAt(0)===I){if(c.charCodeAt(1)===I){const d=c.charCodeAt(2);if(d!==A&&d!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(m(c.charCodeAt(0))&&c.charCodeAt(1)===i&&c.charCodeAt(2)===I)return`\\\\?\\${c}`;return u},dirname(u){p(u,"path");const c=u.length;if(c===0)return".";let d=-1,t=0;const n=u.charCodeAt(0);if(c===1)return a(n)?u:".";if(a(n)){if(d=t=1,a(u.charCodeAt(1))){let o=2,g=o;for(;o<c&&!a(u.charCodeAt(o));)o++;if(o<c&&o!==g){for(g=o;o<c&&a(u.charCodeAt(o));)o++;if(o<c&&o!==g){for(g=o;o<c&&!a(u.charCodeAt(o));)o++;if(o===c)return u;o!==g&&(d=t=o+1)}}}}else m(n)&&u.charCodeAt(1)===i&&(d=c>2&&a(u.charCodeAt(2))?3:2,t=d);let s=-1,r=!0;for(let o=c-1;o>=t;--o)if(a(u.charCodeAt(o))){if(!r){s=o;break}}else r=!1;if(s===-1){if(d===-1)return".";s=d}return u.slice(0,s)},basename(u,c){c!==void 0&&p(c,"ext"),p(u,"path");let d=0,t=-1,n=!0,s;if(u.length>=2&&m(u.charCodeAt(0))&&u.charCodeAt(1)===i&&(d=2),c!==void 0&&c.length>0&&c.length<=u.length){if(c===u)return"";let r=c.length-1,o=-1;for(s=u.length-1;s>=d;--s){const g=u.charCodeAt(s);if(a(g)){if(!n){d=s+1;break}}else o===-1&&(n=!1,o=s+1),r>=0&&(g===c.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=o))}return d===t?t=o:t===-1&&(t=u.length),u.slice(d,t)}for(s=u.length-1;s>=d;--s)if(a(u.charCodeAt(s))){if(!n){d=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":u.slice(d,t)},extname(u){p(u,"path");let c=0,d=-1,t=0,n=-1,s=!0,r=0;u.length>=2&&u.charCodeAt(1)===i&&m(u.charCodeAt(0))&&(c=t=2);for(let o=u.length-1;o>=c;--o){const g=u.charCodeAt(o);if(a(g)){if(!s){t=o+1;break}continue}n===-1&&(s=!1,n=o+1),g===P?d===-1?d=o:r!==1&&(r=1):d!==-1&&(r=-1)}return d===-1||n===-1||r===0||r===1&&d===n-1&&d===t+1?"":u.slice(d,n)},format:_.bind(null,"\\"),parse(u){p(u,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return c;const d=u.length;let t=0,n=u.charCodeAt(0);if(d===1)return a(n)?(c.root=c.dir=u,c):(c.base=c.name=u,c);if(a(n)){if(t=1,a(u.charCodeAt(1))){let E=2,l=E;for(;E<d&&!a(u.charCodeAt(E));)E++;if(E<d&&E!==l){for(l=E;E<d&&a(u.charCodeAt(E));)E++;if(E<d&&E!==l){for(l=E;E<d&&!a(u.charCodeAt(E));)E++;E===d?t=E:E!==l&&(t=E+1)}}}}else if(m(n)&&u.charCodeAt(1)===i){if(d<=2)return c.root=c.dir=u,c;if(t=2,a(u.charCodeAt(2))){if(d===3)return c.root=c.dir=u,c;t=3}}t>0&&(c.root=u.slice(0,t));let s=-1,r=t,o=-1,g=!0,f=u.length-1,S=0;for(;f>=t;--f){if(n=u.charCodeAt(f),a(n)){if(!g){r=f+1;break}continue}o===-1&&(g=!1,o=f+1),n===P?s===-1?s=f:S!==1&&(S=1):s!==-1&&(S=-1)}return o!==-1&&(s===-1||S===0||S===1&&s===o-1&&s===r+1?c.base=c.name=u.slice(r,o):(c.name=u.slice(r,s),c.base=u.slice(r,o),c.ext=u.slice(s,o))),r>0&&r!==t?c.dir=u.slice(0,r-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let c="",d=!1;for(let t=u.length-1;t>=-1&&!d;t--){const n=t>=0?u[t]:v.cwd();p(n,"path"),n.length!==0&&(c=`${n}/${c}`,d=n.charCodeAt(0)===D)}return c=b(c,!d,"/",w),d?`/${c}`:c.length>0?c:"."},normalize(u){if(p(u,"path"),u.length===0)return".";const c=u.charCodeAt(0)===D,d=u.charCodeAt(u.length-1)===D;return u=b(u,!c,"/",w),u.length===0?c?"/":d?"./":".":(d&&(u+="/"),c?`/${u}`:u)},isAbsolute(u){return p(u,"path"),u.length>0&&u.charCodeAt(0)===D},join(...u){if(u.length===0)return".";let c;for(let d=0;d<u.length;++d){const t=u[d];p(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(u,c){if(p(u,"from"),p(c,"to"),u===c||(u=e.posix.resolve(u),c=e.posix.resolve(c),u===c))return"";const d=1,t=u.length,n=t-d,s=1,r=c.length-s,o=n<r?n:r;let g=-1,f=0;for(;f<o;f++){const E=u.charCodeAt(d+f);if(E!==c.charCodeAt(s+f))break;E===D&&(g=f)}if(f===o)if(r>o){if(c.charCodeAt(s+f)===D)return c.slice(s+f+1);if(f===0)return c.slice(s+f)}else n>o&&(u.charCodeAt(d+f)===D?g=f:f===0&&(g=0));let S="";for(f=d+g+1;f<=t;++f)(f===t||u.charCodeAt(f)===D)&&(S+=S.length===0?"..":"/..");return`${S}${c.slice(s+g)}`},toNamespacedPath(u){return u},dirname(u){if(p(u,"path"),u.length===0)return".";const c=u.charCodeAt(0)===D;let d=-1,t=!0;for(let n=u.length-1;n>=1;--n)if(u.charCodeAt(n)===D){if(!t){d=n;break}}else t=!1;return d===-1?c?"/":".":c&&d===1?"//":u.slice(0,d)},basename(u,c){c!==void 0&&p(c,"ext"),p(u,"path");let d=0,t=-1,n=!0,s;if(c!==void 0&&c.length>0&&c.length<=u.length){if(c===u)return"";let r=c.length-1,o=-1;for(s=u.length-1;s>=0;--s){const g=u.charCodeAt(s);if(g===D){if(!n){d=s+1;break}}else o===-1&&(n=!1,o=s+1),r>=0&&(g===c.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=o))}return d===t?t=o:t===-1&&(t=u.length),u.slice(d,t)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===D){if(!n){d=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":u.slice(d,t)},extname(u){p(u,"path");let c=-1,d=0,t=-1,n=!0,s=0;for(let r=u.length-1;r>=0;--r){const o=u.charCodeAt(r);if(o===D){if(!n){d=r+1;break}continue}t===-1&&(n=!1,t=r+1),o===P?c===-1?c=r:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||t===-1||s===0||s===1&&c===t-1&&c===d+1?"":u.slice(c,t)},format:_.bind(null,"/"),parse(u){p(u,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return c;const d=u.charCodeAt(0)===D;let t;d?(c.root="/",t=1):t=0;let n=-1,s=0,r=-1,o=!0,g=u.length-1,f=0;for(;g>=t;--g){const S=u.charCodeAt(g);if(S===D){if(!o){s=g+1;break}continue}r===-1&&(o=!1,r=g+1),S===P?n===-1?n=g:f!==1&&(f=1):n!==-1&&(f=-1)}if(r!==-1){const S=s===0&&d?1:s;n===-1||f===0||f===1&&n===r-1&&n===s+1?c.base=c.name=u.slice(S,r):(c.name=u.slice(S,n),c.base=u.slice(S,r),c.ext=u.slice(n,r))}return s>0?c.dir=u.slice(0,s-1):d&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[136],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var R;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(T,...y){const P=y.reduce((i,A)=>(i[A]=!0,i),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(i=>!P[i]).forEach(i=>{for(let A=0;A<D.length;A++)if(i.search(D[A])!==-1){delete T[i];break}})}e.sanitizeProcessEnvironment=C}),define(me[44],ge([0,1,11]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=v.globals.performance&&typeof v.globals.performance.now=="function";class C{constructor(y){this._highResolution=R&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new C(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=C}),define(me[3],ge([0,1,17,72,6,56,44]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(b){b.None=()=>C.Disposable.None;function _(N){return(V,x=null,k)=>{let U=!1,F;return F=N(M=>{if(!U)return F?F.dispose():U=!0,V.call(x,M)},null,k),U&&F.dispose(),F}}b.once=_;function u(N,V){return r((x,k=null,U)=>N(F=>x.call(k,V(F)),null,U))}b.map=u;function c(N,V){return r((x,k=null,U)=>N(F=>{V(F),x.call(k,F)},null,U))}b.forEach=c;function d(N,V){return r((x,k=null,U)=>N(F=>V(F)&&x.call(k,F),null,U))}b.filter=d;function t(N){return N}b.signal=t;function n(...N){return(V,x=null,k)=>(0,C.combinedDisposable)(...N.map(U=>U(F=>V.call(x,F),null,k)))}b.any=n;function s(N,V,x){let k=x;return u(N,U=>(k=V(k,U),k))}b.reduce=s;function r(N){let V;const x=new h({onFirstListenerAdd(){V=N(x.fire,x)},onLastListenerRemove(){V.dispose()}});return x.event}b.snapshot=r;function o(N,V,x=100,k=!1,U){let F,M,$,H=0;const X=new h({leakWarningThreshold:U,onFirstListenerAdd(){F=N(ae=>{H++,M=V(M,ae),k&&!$&&(X.fire(M),M=void 0),clearTimeout($),$=setTimeout(()=>{const we=M;M=void 0,$=void 0,(!k||H>1)&&X.fire(we),H=0},x)})},onLastListenerRemove(){F.dispose()}});return X.event}b.debounce=o;function g(N){const V=new Date().getTime();return u(_(N),x=>new Date().getTime()-V)}b.stopwatch=g;function f(N,V=(x,k)=>x===k){let x=!0,k;return d(N,U=>{const F=x||!V(U,k);return x=!1,k=U,F})}b.latch=f;function S(N,V){return[b.filter(N,V),b.filter(N,x=>!V(x))]}b.split=S;function E(N,V=!1,x=[]){let k=x.slice(),U=N($=>{k?k.push($):M.fire($)});const F=()=>{k&&k.forEach($=>M.fire($)),k=null},M=new h({onFirstListenerAdd(){U||(U=N($=>M.fire($)))},onFirstListenerDidAdd(){k&&(V?setTimeout(F):F())},onLastListenerRemove(){U&&U.dispose(),U=null}});return M.event}b.buffer=E;class l{constructor(V){this.event=V}map(V){return new l(u(this.event,V))}forEach(V){return new l(c(this.event,V))}filter(V){return new l(d(this.event,V))}reduce(V,x){return new l(s(this.event,V,x))}latch(){return new l(f(this.event))}debounce(V,x=100,k=!1,U){return new l(o(this.event,V,x,k,U))}on(V,x,k){return this.event(V,x,k)}once(V,x,k){return _(this.event)(V,x,k)}}function L(N){return new l(N)}b.chain=L;function O(N,V,x=k=>k){const k=(...$)=>M.fire(x(...$)),U=()=>N.on(V,k),F=()=>N.removeListener(V,k),M=new h({onFirstListenerAdd:U,onLastListenerRemove:F});return M.event}b.fromNodeEventEmitter=O;function W(N,V,x=k=>k){const k=(...$)=>M.fire(x(...$)),U=()=>N.addEventListener(V,k),F=()=>N.removeEventListener(V,k),M=new h({onFirstListenerAdd:U,onLastListenerRemove:F});return M.event}b.fromDOMEventEmitter=W;function te(N){const V=new h;let x=!1;return N.then(void 0,()=>null).then(()=>{x?V.fire(void 0):setTimeout(()=>V.fire(void 0),0)}),x=!0,V.event}b.fromPromise=te;function se(N){return new Promise(V=>_(N)(V))}b.toPromise=se})(P=e.Event||(e.Event={}));class D{constructor(_){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${_}_${D._idPool++}`}start(_){this._stopWatch=new y.StopWatch(!0),this._listenerCount=_}stop(){if(this._stopWatch){const _=this._stopWatch.elapsed();this._elapsedOverall+=_,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${_.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let I=-1;function i(b){const _=I;return I=b,{dispose(){I=_}}}e.setGlobalLeakWarningThreshold=i;class A{constructor(_,u=Math.random().toString(18).slice(2,5)){this.customThreshold=_,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(_){let u=I;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||_<u)return;this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),d=this._stacks.get(c)||0;if(this._stacks.set(c,d+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,n=0;for(const[s,r]of this._stacks)(!t||n<r)&&(t=s,n=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${_} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}class h{constructor(_){var u;this._disposed=!1,this._options=_,this._leakageMon=I>0?new A(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(_,u,c)=>{var d;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(u?[_,u]:_);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,_,u);const s=(d=this._leakageMon)===null||d===void 0?void 0:d.check(this._listeners.size);let r;return r={dispose:()=>{s&&s(),r.dispose=h._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof C.DisposableStore?c.add(r):Array.isArray(c)&&c.push(r),r}),this._event}fire(_){var u,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let d of this._listeners)this._deliveryQueue.push([d,_]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[d,t]=this._deliveryQueue.shift();try{typeof d=="function"?d.call(void 0,t):d[0].call(d[1],t)}catch(n){(0,v.onUnexpectedError)(n)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var _,u,c,d,t;this._disposed||(this._disposed=!0,(_=this._listeners)===null||_===void 0||_.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(d=(c=this._options)===null||c===void 0?void 0:c.onLastListenerRemove)===null||d===void 0||d.call(c),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=h,h._noop=function(){};class p extends h{constructor(_){super(_);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=_==null?void 0:_.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const _=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(_))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(_){this._listeners&&(this._isPaused!==0?this._eventQueue.push(_):super.fire(_))}}e.PauseableEmitter=p;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(_){const u={event:_,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const c=()=>{this.hasListeners&&this.unhook(u);const d=this.events.indexOf(u);this.events.splice(d,1)};return(0,C.toDisposable)((0,R.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(_=>this.hook(_))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(_=>this.unhook(_))}hook(_){_.listener=_.event(u=>this.emitter.fire(u))}unhook(_){_.listener&&_.listener.dispose(),_.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class w{constructor(){this.buffers=[]}wrapEvent(_){return(u,c,d)=>_(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>u.call(c,t)):u.call(c,t)},void 0,d)}bufferEvents(_){const u=[];this.buffers.push(u);const c=_();return this.buffers.pop(),u.forEach(d=>d()),c}}e.EventBufferer=w;class m{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=C.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(_){this.inputEvent=_,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=_(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=m}),define(me[21],ge([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(P,D){const I=setTimeout(P.bind(D),0);return{dispose(){clearTimeout(I)}}});var C;(function(P){function D(I){return I===P.None||I===P.Cancelled||I instanceof T?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}P.isCancellationToken=D,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(C=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=C.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=y}),define(me[45],ge([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(A){const h=this._icons.get(A.id);h?A.description?h.description=A.description:console.error(`Duplicate registration of codicon ${A.id}`):(this._icons.set(A.id,A),this._onDidRegister.fire(A))}get(A){return this._icons.get(A)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new R;e.iconRegistry=C;function T(i,A){return new P(i,A)}e.registerCodicon=T;function y(i){return i?i.replace(/\$\((.*?)\)/g,(A,h)=>` ${h} `).trim():""}e.getCodiconAriaLabel=y;class P{constructor(A,h,p){this.id=A,this.definition=h,this.description=p,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function D(i,A){const h=["codicon","codicon-"+i];return A&&h.push("codicon-modifier-"+A),h}e.getClassNamesArray=D;var I;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const A=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function h(w){if(w instanceof P)return["codicon","codicon-"+w.id];const m=A.exec(w.id);if(!m)return h(P.error);let[,b,_]=m;const u=["codicon","codicon-"+b];return _&&u.push("codicon-modifier-"+_.substr(1)),u}i.asClassNameArray=h;function p(w){return h(w).join(" ")}i.asClassName=p;function a(w){return"."+h(w).join(".")}i.asCSSSelector=a})(I=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(me[93],ge([0,1,17,6]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(u){const c=u;return c?[c.on,c.pause,c.resume,c.destroy].every(d=>typeof d=="function"):!1}e.isReadableStream=C;function T(u){const c=u;return c?C(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=T;function y(u,c){return new P(u,c)}e.newWriteableStream=y;class P{constructor(c,d){this.reducer=c,this.options=d,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){var d;if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof((d=this.options)===null||d===void 0?void 0:d.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(d=>d(c))}emitError(c){this.listeners.error.length===0?(0,v.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(d=>d(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,d){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(d),this.resume();break;case"end":this.listeners.end.push(d),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(d),this.state.flowing&&this.flowErrors();break}}removeListener(c,d){if(this.state.destroyed)return;let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(d);n>=0&&t.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const d=[...this.pendingWritePromises];this.pendingWritePromises.length=0,d.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(u,c){const d=[];let t;for(;(t=u.read())!==null;)d.push(t);return c(d)}e.consumeReadable=D;function I(u,c,d){const t=[];let n;for(;(n=u.read())!==null&&t.length<d;)t.push(n);return n===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const s=n;return n=void 0,s}return u.read()}}}e.peekReadable=I;function i(u,c){return new Promise((d,t)=>{const n=[];A(u,{onData:s=>{c&&n.push(s)},onError:s=>{c?t(s):d(void 0)},onEnd:()=>{d(c?c(n):void 0)}})})}e.consumeStream=i;function A(u,c){u.on("error",d=>c.onError(d)),u.on("end",()=>c.onEnd()),u.on("data",d=>c.onData(d))}e.listenStream=A;function h(u,c){return new Promise((d,t)=>{const n=new R.DisposableStore,s=[],r=f=>{if(s.push(f),s.length>c)return n.dispose(),u.pause(),d({stream:u,buffer:s,ended:!1})},o=f=>t(f),g=()=>d({stream:u,buffer:s,ended:!0});n.add((0,R.toDisposable)(()=>u.removeListener("error",o))),u.on("error",o),n.add((0,R.toDisposable)(()=>u.removeListener("end",g))),u.on("end",g),n.add((0,R.toDisposable)(()=>u.removeListener("data",r))),u.on("data",r)})}e.peekStream=h;function p(u,c){const d=y(c);return d.end(u),d}e.toStream=p;function a(){const u=y(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=a;function w(u){let c=!1;return{read:()=>c?null:(c=!0,u)}}e.toReadable=w;function m(u,c,d){const t=y(d);return A(u,{onData:n=>t.write(c.data(n)),onError:n=>t.error(c.error?c.error(n):n),onEnd:()=>t.end()}),t}e.transform=m;function b(u,c,d){let t=!1;return{read:()=>{const n=c.read();return t?n:(t=!0,n!==null?d([u,n]):u)}}}e.prefixedReadable=b;function _(u,c,d){let t=!1;const n=y(d);return A(c,{onData:s=>t?n.write(s):(t=!0,n.write(d([u,s]))),onError:s=>n.error(s),onEnd:()=>{t||(t=!0,n.write(u)),n.end()}}),n}e.prefixedStream=_}),define(me[8],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(z){return!z||typeof z!="string"?!0:z.trim().length===0}e.isFalsyOrWhitespace=v;const R=/{(\d+)}/g;function C(z,...J){return J.length===0?z:z.replace(R,function(ce,Pe){const Ae=parseInt(Pe,10);return isNaN(Ae)||Ae<0||Ae>=J.length?ce:J[Ae]})}e.format=C;function T(z){return z.replace(/[<>&]/g,function(J){switch(J){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return J}})}e.escape=T;function y(z){return z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function P(z,J){let ce=0;const Pe=J.charCodeAt(0);for(let Ae=z.length-1;Ae>=0;Ae--)z.charCodeAt(Ae)===Pe&&ce++;return ce}e.count=P;function D(z,J,ce="\u2026"){return z.length<=J?z:`${z.substr(0,J)}${ce}`}e.truncate=D;function I(z,J=" "){const ce=i(z,J);return A(ce,J)}e.trim=I;function i(z,J){if(!z||!J)return z;const ce=J.length;if(ce===0||z.length===0)return z;let Pe=0;for(;z.indexOf(J,Pe)===Pe;)Pe=Pe+ce;return z.substring(Pe)}e.ltrim=i;function A(z,J){if(!z||!J)return z;const ce=J.length,Pe=z.length;if(ce===0||Pe===0)return z;let Ae=Pe,Ne=-1;for(;Ne=z.lastIndexOf(J,Ae-1),!(Ne===-1||Ne+ce!==Ae);){if(Ne===0)return"";Ae=Ne}return z.substring(0,Ae)}e.rtrim=A;function h(z){return z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function p(z){return z.replace(/\*/g,"")}e.stripWildcards=p;function a(z,J,ce={}){if(!z)throw new Error("Cannot create regex from empty string");J||(z=y(z)),ce.wholeWord&&(/\B/.test(z.charAt(0))||(z="\\b"+z),/\B/.test(z.charAt(z.length-1))||(z=z+"\\b"));let Pe="";return ce.global&&(Pe+="g"),ce.matchCase||(Pe+="i"),ce.multiline&&(Pe+="m"),ce.unicode&&(Pe+="u"),new RegExp(z,Pe)}e.createRegExp=a;function w(z){return z.source==="^"||z.source==="^$"||z.source==="$"||z.source==="^\\s*$"?!1:!!(z.exec("")&&z.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function m(z){return!!z.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function b(z){return(z.global?"g":"")+(z.ignoreCase?"i":"")+(z.multiline?"m":"")+(z.unicode?"u":"")}e.regExpFlags=b;function _(z){return z.split(/\r\n|\r|\n/)}e.splitLines=_;function u(z){for(let J=0,ce=z.length;J<ce;J++){const Pe=z.charCodeAt(J);if(Pe!==32&&Pe!==9)return J}return-1}e.firstNonWhitespaceIndex=u;function c(z,J=0,ce=z.length){for(let Pe=J;Pe<ce;Pe++){const Ae=z.charCodeAt(Pe);if(Ae!==32&&Ae!==9)return z.substring(J,Pe)}return z.substring(J,ce)}e.getLeadingWhitespace=c;function d(z,J=z.length-1){for(let ce=J;ce>=0;ce--){const Pe=z.charCodeAt(ce);if(Pe!==32&&Pe!==9)return ce}return-1}e.lastNonWhitespaceIndex=d;function t(z,J){return z<J?-1:z>J?1:0}e.compare=t;function n(z,J,ce=0,Pe=z.length,Ae=0,Ne=J.length){for(;ce<Pe&&Ae<Ne;ce++,Ae++){let rt=z.charCodeAt(ce),et=J.charCodeAt(Ae);if(rt<et)return-1;if(rt>et)return 1}const Be=Pe-ce,Qe=Ne-Ae;return Be<Qe?-1:Be>Qe?1:0}e.compareSubstring=n;function s(z,J){return r(z,J,0,z.length,0,J.length)}e.compareIgnoreCase=s;function r(z,J,ce=0,Pe=z.length,Ae=0,Ne=J.length){for(;ce<Pe&&Ae<Ne;ce++,Ae++){let rt=z.charCodeAt(ce),et=J.charCodeAt(Ae);if(rt===et)continue;const Xe=rt-et;if(!(Xe===32&&g(et))&&!(Xe===-32&&g(rt)))return o(rt)&&o(et)?Xe:n(z.toLowerCase(),J.toLowerCase(),ce,Pe,Ae,Ne)}const Be=Pe-ce,Qe=Ne-Ae;return Be<Qe?-1:Be>Qe?1:0}e.compareSubstringIgnoreCase=r;function o(z){return z>=97&&z<=122}e.isLowerAsciiLetter=o;function g(z){return z>=65&&z<=90}e.isUpperAsciiLetter=g;function f(z){return o(z)||g(z)}function S(z,J){return z.length===J.length&&E(z,J)}e.equalsIgnoreCase=S;function E(z,J,ce=z.length){for(let Pe=0;Pe<ce;Pe++){const Ae=z.charCodeAt(Pe),Ne=J.charCodeAt(Pe);if(Ae!==Ne){if(f(Ae)&&f(Ne)){const Be=Math.abs(Ae-Ne);if(Be!==0&&Be!==32)return!1}else if(String.fromCharCode(Ae).toLowerCase()!==String.fromCharCode(Ne).toLowerCase())return!1}}return!0}function l(z,J){const ce=J.length;return J.length>z.length?!1:E(z,J,ce)}e.startsWithIgnoreCase=l;function L(z,J){let ce,Pe=Math.min(z.length,J.length);for(ce=0;ce<Pe;ce++)if(z.charCodeAt(ce)!==J.charCodeAt(ce))return ce;return Pe}e.commonPrefixLength=L;function O(z,J){let ce,Pe=Math.min(z.length,J.length);const Ae=z.length-1,Ne=J.length-1;for(ce=0;ce<Pe;ce++)if(z.charCodeAt(Ae-ce)!==J.charCodeAt(Ne-ce))return ce;return Pe}e.commonSuffixLength=O;function W(z){return 55296<=z&&z<=56319}e.isHighSurrogate=W;function te(z){return 56320<=z&&z<=57343}e.isLowSurrogate=te;function se(z,J){return(z-55296<<10)+(J-56320)+65536}e.computeCodePoint=se;function N(z,J,ce){const Pe=z.charCodeAt(ce);if(W(Pe)&&ce+1<J){const Ae=z.charCodeAt(ce+1);if(te(Ae))return se(Pe,Ae)}return Pe}e.getNextCodePoint=N;function V(z,J){const ce=z.charCodeAt(J-1);if(te(ce)&&J>1){const Pe=z.charCodeAt(J-2);if(W(Pe))return se(Pe,ce)}return ce}function x(z,J){const ce=ze.getInstance(),Pe=J,Ae=z.length,Ne=N(z,Ae,J);J+=Ne>=65536?2:1;let Be=ce.getGraphemeBreakType(Ne);for(;J<Ae;){const Qe=N(z,Ae,J),rt=ce.getGraphemeBreakType(Qe);if(xe(Be,rt))break;J+=Qe>=65536?2:1,Be=rt}return J-Pe}e.nextCharLength=x;function k(z,J){const ce=ze.getInstance(),Pe=J,Ae=V(z,J);J-=Ae>=65536?2:1;let Ne=ce.getGraphemeBreakType(Ae);for(;J>0;){const Be=V(z,J),Qe=ce.getGraphemeBreakType(Be);if(xe(Qe,Ne))break;J-=Be>=65536?2:1,Ne=Qe}return Pe-J}e.prevCharLength=k;function U(z,J){const ce=ze.getInstance(),Pe=z.length,Ae=J,Ne=N(z,Pe,J),Be=ce.getGraphemeBreakType(Ne);J+=Ne>=65536?2:1;let Qe=Be;for(;J<Pe;){const et=N(z,Pe,J),Xe=ce.getGraphemeBreakType(et);if(xe(Qe,Xe))break;J+=et>=65536?2:1,Qe=Xe}const rt=J;for(J=Ae,Qe=Be;J>0;){const et=V(z,J),Xe=ce.getGraphemeBreakType(et);if(xe(Xe,Qe))break;J-=et>=65536?2:1,Qe=Xe}return[J,rt]}function F(z,J){return J>0&&te(z.charCodeAt(J))?U(z,J-1):U(z,J)}e.getCharContainingOffset=F;function M(z){const J=z.length;let ce=0,Pe=0;for(;Pe<J;){const Be=N(z,J,Pe);Pe+=Be>=65536?2:1,Be<128?ce+=1:Be<2048?ce+=2:Be<65536?ce+=3:ce+=4}const Ae=new Uint8Array(ce);Pe=0;let Ne=0;for(;Pe<J;){const Be=N(z,J,Pe);Pe+=Be>=65536?2:1,Be<128?Ae[Ne++]=Be:Be<2048?(Ae[Ne++]=192|(Be&1984)>>>6,Ae[Ne++]=128|(Be&63)>>>0):Be<65536?(Ae[Ne++]=224|(Be&61440)>>>12,Ae[Ne++]=128|(Be&4032)>>>6,Ae[Ne++]=128|(Be&63)>>>0):(Ae[Ne++]=240|(Be&1835008)>>>18,Ae[Ne++]=128|(Be&258048)>>>12,Ae[Ne++]=128|(Be&4032)>>>6,Ae[Ne++]=128|(Be&63)>>>0)}return Ae}e.encodeUTF8=M;function $(z){const J=z.byteLength,ce=[];let Pe=0;for(;Pe<J;){const Ae=z[Pe];let Ne;if(Ae>=240&&Pe+3<J?Ne=(z[Pe++]&7)<<18>>>0|(z[Pe++]&63)<<12>>>0|(z[Pe++]&63)<<6>>>0|(z[Pe++]&63)<<0>>>0:Ae>=224&&Pe+2<J?Ne=(z[Pe++]&15)<<12>>>0|(z[Pe++]&63)<<6>>>0|(z[Pe++]&63)<<0>>>0:Ae>=192&&Pe+1<J?Ne=(z[Pe++]&31)<<6>>>0|(z[Pe++]&63)<<0>>>0:Ne=z[Pe++],Ne>=0&&Ne<=55295||Ne>=57344&&Ne<=65535)ce.push(String.fromCharCode(Ne));else if(Ne>=65536&&Ne<=1114111){const Be=Ne-65536,Qe=55296+((Be&1047552)>>>10),rt=56320+((Be&1023)>>>0);ce.push(String.fromCharCode(Qe)),ce.push(String.fromCharCode(rt))}else ce.push(String.fromCharCode(65533))}return ce.join("")}e.decodeUTF8=$;const H=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(z){return H.test(z)}e.containsRTL=X;const ae=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function we(z){return ae.test(z)}e.containsEmoji=we;const Le=/^[\t\n\r\x20-\x7E]*$/;function Ie(z){return Le.test(z)}e.isBasicASCII=Ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Me(z){return e.UNUSUAL_LINE_TERMINATORS.test(z)}e.containsUnusualLineTerminators=Me;function We(z){for(let J=0,ce=z.length;J<ce;J++)if(j(z.charCodeAt(J)))return!0;return!1}e.containsFullWidthCharacter=We;function j(z){return z=+z,z>=11904&&z<=55215||z>=63744&&z<=64255||z>=65281&&z<=65374}e.isFullWidthCharacter=j;function Y(z){return z>=127462&&z<=127487||z===8986||z===8987||z===9200||z===9203||z>=9728&&z<=10175||z===11088||z===11093||z>=127744&&z<=128591||z>=128640&&z<=128764||z>=128992&&z<=129003||z>=129280&&z<=129535||z>=129648&&z<=129750}e.isEmojiImprecise=Y;function ee(z,J){if(z.length<J)return z;const ce=/\b/g;let Pe=0;for(;ce.test(z)&&!(z.length-ce.lastIndex<J);)Pe=ce.lastIndex,ce.lastIndex+=1;return z.substring(Pe).replace(/^\s/,"")}e.lcut=ee;const oe=/\x1B\x5B[12]?K/g,pe=/\x1b\[\d+m/g,_e=/\x1b\[0?m/g;function de(z){return z&&(z=z.replace(oe,""),z=z.replace(pe,""),z=z.replace(_e,"")),z}e.removeAnsiEscapeCodes=de,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(z){return!!(z&&z.length>0&&z.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Re(z){return Ee(z)?z.substr(1):z}e.stripUTF8BOM=Re;function Ve(z,J){if(!z||!J||z.length<J.length)return!1;const ce=J.length,Pe=z.toLowerCase();let Ae=0,Ne=-1;for(;Ae<ce;){const Be=Pe.indexOf(J[Ae],Ne+1);if(Be<0)return!1;Ne=Be,Ae++}return!0}e.fuzzyContains=Ve;function be(z,J=!1){return z?(J&&(z=z.replace(/\\./g,"")),z.toLowerCase()!==z):!1}e.containsUppercaseCharacter=be;function Ke(z){return z.charAt(0).toUpperCase()+z.slice(1)}e.uppercaseFirstLetter=Ke;function Q(z,J=1){if(J===0)return"";let ce=-1;do ce=z.indexOf(`
`,ce+1),J--;while(J>0&&ce>=0);return ce===-1?z:(z[ce-1]==="\r"&&ce--,z.substr(0,ce))}e.getNLines=Q;function ne(z){const J=90-65+1;return z=z%(2*J),z<J?String.fromCharCode(97+z):String.fromCharCode(65+z-J)}e.singleLetterHash=ne;function ve(z){return ze.getInstance().getGraphemeBreakType(z)}e.getGraphemeBreakType=ve;function xe(z,J){return z===0?J!==5&&J!==7:z===2&&J===3?!1:z===4||z===2||z===3||J===4||J===2||J===3?!0:!(z===8&&(J===8||J===9||J===11||J===12)||(z===11||z===9)&&(J===9||J===10)||(z===12||z===10)&&J===10||J===5||J===13||J===7||z===1||z===13&&J===14||z===6&&J===6)}e.breakBetweenGraphemeBreakType=xe;var je;(function(z){z[z.Other=0]="Other",z[z.Prepend=1]="Prepend",z[z.CR=2]="CR",z[z.LF=3]="LF",z[z.Control=4]="Control",z[z.Extend=5]="Extend",z[z.Regional_Indicator=6]="Regional_Indicator",z[z.SpacingMark=7]="SpacingMark",z[z.L=8]="L",z[z.V=9]="V",z[z.T=10]="T",z[z.LV=11]="LV",z[z.LVT=12]="LVT",z[z.ZWJ=13]="ZWJ",z[z.Extended_Pictographic=14]="Extended_Pictographic"})(je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=Je()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(J){if(J<32)return J===10?3:J===13?2:4;if(J<127)return 0;const ce=this._data,Pe=ce.length/3;let Ae=1;for(;Ae<=Pe;)if(J<ce[3*Ae])Ae=2*Ae;else if(J>ce[3*Ae+1])Ae=2*Ae+1;else return ce[3*Ae+2];return 0}}ze._INSTANCE=null;function Je(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function ye(z,J){if(z===0)return 0;const ce=De(z,J);if(ce!==void 0)return ce;const Pe=V(J,z);return z-=ke(Pe),z}e.getLeftDeleteOffset=ye;function De(z,J){let ce=V(J,z);for(z-=ke(ce);re(ce)||ce===65039||ce===8419;){if(z===0)return;ce=V(J,z),z-=ke(ce)}if(!!Y(ce)){if(z>=0){const Pe=V(J,z);Pe===8205&&(z-=ke(Pe))}return z}}function ke(z){return z>=65536?2:1}function re(z){return 127995<=z&&z<=127999}var he;(function(z){z[z.zwj=8205]="zwj",z[z.emojiVariantSelector=65039]="emojiVariantSelector",z[z.enclosingKeyCap=8419]="enclosingKeyCap"})(he||(he={}))}),define(me[22],ge([0,1,8,93]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let P,D;class I{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return C?new I(Buffer.allocUnsafe(f)):new I(new Uint8Array(f))}static wrap(f){return C&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new I(f)}static fromString(f,S){return!((S==null?void 0:S.dontUseNodeBuffer)||!1)&&C?new I(Buffer.from(f)):T?(P||(P=new TextEncoder),new I(P.encode(f))):new I(v.encodeUTF8(f))}static concat(f,S){if(typeof S=="undefined"){S=0;for(let L=0,O=f.length;L<O;L++)S+=f[L].byteLength}const E=I.alloc(S);let l=0;for(let L=0,O=f.length;L<O;L++){const W=f[L];E.set(W,l),l+=W.byteLength}return E}toString(){return C?this.buffer.toString():y?(D||(D=new TextDecoder),D.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(f,S){return new I(this.buffer.subarray(f,S))}set(f,S){f instanceof I?this.buffer.set(f.buffer,S):this.buffer.set(f,S)}readUInt32BE(f){return h(this.buffer,f)}writeUInt32BE(f,S){p(this.buffer,f,S)}readUInt32LE(f){return a(this.buffer,f)}writeUInt32LE(f,S){w(this.buffer,f,S)}readUInt8(f){return m(this.buffer,f)}writeUInt8(f,S){b(this.buffer,f,S)}}e.VSBuffer=I;function i(g,f){return g[f+0]<<0>>>0|g[f+1]<<8>>>0}e.readUInt16LE=i;function A(g,f,S){g[S+0]=f&255,f=f>>>8,g[S+1]=f&255}e.writeUInt16LE=A;function h(g,f){return g[f]*2**24+g[f+1]*2**16+g[f+2]*2**8+g[f+3]}e.readUInt32BE=h;function p(g,f,S){g[S+3]=f,f=f>>>8,g[S+2]=f,f=f>>>8,g[S+1]=f,f=f>>>8,g[S]=f}e.writeUInt32BE=p;function a(g,f){return g[f+0]<<0>>>0|g[f+1]<<8>>>0|g[f+2]<<16>>>0|g[f+3]<<24>>>0}e.readUInt32LE=a;function w(g,f,S){g[S+0]=f&255,f=f>>>8,g[S+1]=f&255,f=f>>>8,g[S+2]=f&255,f=f>>>8,g[S+3]=f&255}e.writeUInt32LE=w;function m(g,f){return g[f]}e.readUInt8=m;function b(g,f,S){g[S]=f}e.writeUInt8=b;function _(g){return R.consumeReadable(g,f=>I.concat(f))}e.readableToBuffer=_;function u(g){return R.toReadable(g)}e.bufferToReadable=u;function c(g){return R.consumeStream(g,f=>I.concat(f))}e.streamToBuffer=c;async function d(g){return g.ended?I.concat(g.buffer):I.concat([...g.buffer,await c(g.stream)])}e.bufferedStreamToBuffer=d;function t(g){return R.toStream(g,f=>I.concat(f))}e.bufferToStream=t;function n(g){return R.transform(g,{data:f=>typeof f=="string"?I.fromString(f):I.wrap(f)},f=>I.concat(f))}e.streamToBufferReadableStream=n;function s(g){return R.newWriteableStream(f=>I.concat(f),g)}e.newWriteableBufferStream=s;function r(g,f){return R.prefixedReadable(g,f,S=>I.concat(S))}e.prefixedBufferReadable=r;function o(g,f){return R.prefixedStream(g,f,S=>I.concat(S))}e.prefixedBufferStream=o}),define(me[75],ge([0,1,8]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(b){return C(b,0)}e.hash=R;function C(b,_){switch(typeof b){case"object":return b===null?T(349,_):Array.isArray(b)?D(b,_):I(b,_);case"string":return P(b,_);case"boolean":return y(b,_);case"number":return T(b,_);case"undefined":return T(937,_);default:return T(617,_)}}e.doHash=C;function T(b,_){return(_<<5)-_+b|0}function y(b,_){return T(b?433:863,_)}function P(b,_){_=T(149417,_);for(let u=0,c=b.length;u<c;u++)_=T(b.charCodeAt(u),_);return _}e.stringHash=P;function D(b,_){return _=T(104579,_),b.reduce((u,c)=>C(c,u),_)}function I(b,_){return _=T(181387,_),Object.keys(b).sort().reduce((u,c)=>(u=P(c,u),C(b[c],u)),_)}class i{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=C(_,this._value),this._value}}e.Hasher=i;var A;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function h(b,_,u=32){const c=u-_,d=~((1<<c)-1);return(b<<_|(d&b)>>>c)>>>0}function p(b,_=0,u=b.byteLength,c=0){for(let d=0;d<u;d++)b[_+d]=c}function a(b,_,u="0"){for(;b.length<_;)b=u+b;return b}function w(b,_=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(u=>u.toString(16).padStart(2,"0")).join(""):a((b>>>0).toString(16),_/4)}e.toHexString=w;class m{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const u=_.length;if(u===0)return;const c=this._buff;let d=this._buffLen,t=this._leftoverHighSurrogate,n,s;for(t!==0?(n=t,s=-1,t=0):(n=_.charCodeAt(0),s=0);;){let r=n;if(v.isHighSurrogate(n))if(s+1<u){const o=_.charCodeAt(s+1);v.isLowSurrogate(o)?(s++,r=v.computeCodePoint(n,o)):r=65533}else{t=n;break}else v.isLowSurrogate(n)&&(r=65533);if(d=this._push(c,d,r),s++,s<u)n=_.charCodeAt(s);else break}this._buffLen=d,this._leftoverHighSurrogate=t}_push(_,u,c){return c<128?_[u++]=c:c<2048?(_[u++]=192|(c&1984)>>>6,_[u++]=128|(c&63)>>>0):c<65536?(_[u++]=224|(c&61440)>>>12,_[u++]=128|(c&4032)>>>6,_[u++]=128|(c&63)>>>0):(_[u++]=240|(c&1835008)>>>18,_[u++]=128|(c&258048)>>>12,_[u++]=128|(c&4032)>>>6,_[u++]=128|(c&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=m._bigBlock32,u=this._buffDV;for(let f=0;f<64;f+=4)_.setUint32(f,u.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)_.setUint32(f,h(_.getUint32(f-12,!1)^_.getUint32(f-32,!1)^_.getUint32(f-56,!1)^_.getUint32(f-64,!1),1),!1);let c=this._h0,d=this._h1,t=this._h2,n=this._h3,s=this._h4,r,o,g;for(let f=0;f<80;f++)f<20?(r=d&t|~d&n,o=1518500249):f<40?(r=d^t^n,o=1859775393):f<60?(r=d&t|d&n|t&n,o=2400959708):(r=d^t^n,o=3395469782),g=h(c,5)+r+s+o+_.getUint32(f*4,!1)&4294967295,s=n,n=t,t=h(d,30),d=c,c=g;this._h0=this._h0+c&4294967295,this._h1=this._h1+d&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=m,m._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[57],ge([0,1,8]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(R||(R={})),function(C){const T="error",y="warning",P="warn",D="info",I="ignore";function i(h){return h?v.equalsIgnoreCase(T,h)?C.Error:v.equalsIgnoreCase(y,h)||v.equalsIgnoreCase(P,h)?C.Warning:v.equalsIgnoreCase(D,h)?C.Info:C.Ignore:C.Ignore}C.fromValue=i;function A(h){switch(h){case C.Error:return T;case C.Warning:return y;case C.Info:return D;default:return I}}C.toString=A}(R||(R={})),e.default=R}),define(me[12],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(f){return Array.isArray(f)}e.isArray=v;function R(f){return typeof f=="string"}e.isString=R;function C(f){return Array.isArray(f)&&f.every(S=>R(S))}e.isStringArray=C;function T(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=T;function y(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=y;function P(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=P;function D(f){return f===!0||f===!1}e.isBoolean=D;function I(f){return typeof f=="undefined"}e.isUndefined=I;function i(f){return!A(f)}e.isDefined=i;function A(f){return I(f)||f===null}e.isUndefinedOrNull=A;function h(f,S){if(!f)throw new Error(S?`Unexpected type, expected '${S}'`:"Unexpected type")}e.assertType=h;function p(f){if(A(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=p;function a(...f){const S=[];for(let E=0;E<f.length;E++){const l=f[E];if(A(l))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);S.push(l)}return S}e.assertAllDefined=a;const w=Object.prototype.hasOwnProperty;function m(f){if(!T(f))return!1;for(let S in f)if(w.call(f,S))return!1;return!0}e.isEmptyObject=m;function b(f){return typeof f=="function"}e.isFunction=b;function _(...f){return f.length>0&&f.every(b)}e.areFunctions=_;function u(f,S){const E=Math.min(f.length,S.length);for(let l=0;l<E;l++)c(f[l],S[l])}e.validateConstraints=u;function c(f,S){if(R(S)){if(typeof f!==S)throw new Error(`argument does not match constraint: typeof ${S}`)}else if(b(S)){try{if(f instanceof S)return}catch(E){}if(!A(f)&&f.constructor===S||S.length===1&&S.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function d(f){let S=[],E=Object.getPrototypeOf(f);for(;Object.prototype!==E;)S=S.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return S}e.getAllPropertyNames=d;function t(f){const S=[];for(const E of d(f))typeof f[E]=="function"&&S.push(E);return S}e.getAllMethodNames=t;function n(f,S){const E=L=>function(){const O=Array.prototype.slice.call(arguments,0);return S(L,O)};let l={};for(const L of f)l[L]=E(L);return l}e.createProxyObject=n;function s(f){return f===null?void 0:f}e.withNullAsUndefined=s;function r(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=r;function o(f){return class{constructor(){return new Proxy({},{get(S,E){if(S[E])return S[E];throw new Error(`Not Implemented: ${f}->${String(E)}`)}})}}}e.NotImplementedProxy=o;function g(f){throw new Error("Unreachable")}e.assertNever=g}),define(me[29],ge([0,1,11,8,9,12]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(s){return s===47||s===92}e.isPathSeparator=y;function P(s){return s.replace(/[\\/]/g,C.posix.sep)}e.toSlashes=P;function D(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=D;function I(s,r=C.posix.sep){if(!s)return"";const o=s.length,g=s.charCodeAt(0);if(y(g)){if(y(s.charCodeAt(1))&&!y(s.charCodeAt(2))){let S=3;const E=S;for(;S<o&&!y(s.charCodeAt(S));S++);if(E!==S&&!y(s.charCodeAt(S+1))){for(S+=1;S<o;S++)if(y(s.charCodeAt(S)))return s.slice(0,S+1).replace(/[\\/]/g,r)}}return r}else if(b(g)&&s.charCodeAt(1)===58)return y(s.charCodeAt(2))?s.slice(0,2)+r:s.slice(0,2);let f=s.indexOf("://");if(f!==-1){for(f+=3;f<o;f++)if(y(s.charCodeAt(f)))return s.slice(0,f+1)}return""}e.getRoot=I;function i(s){if(!v.isWindows||!s||s.length<5)return!1;let r=s.charCodeAt(0);if(r!==92||(r=s.charCodeAt(1),r!==92))return!1;let o=2;const g=o;for(;o<s.length&&(r=s.charCodeAt(o),r!==92);o++);return!(g===o||(r=s.charCodeAt(o+1),isNaN(r)||r===92))}e.isUNC=i;const A=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(s,r=v.isWindows){const o=r?A:h;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||r&&p.test(s)||s==="."||s===".."||r&&s[s.length-1]==="."||r&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=a;function w(s,r,o){const g=s===r;return!o||g?g:!s||!r?!1:(0,R.equalsIgnoreCase)(s,r)}e.isEqual=w;function m(s,r,o,g=C.sep){if(s===r)return!0;if(!s||!r||r.length>s.length)return!1;if(o){if(!(0,R.startsWithIgnoreCase)(s,r))return!1;if(r.length===s.length)return!0;let S=r.length;return r.charAt(r.length-1)===g&&S--,s.charAt(S)===g}return r.charAt(r.length-1)!==g&&(r+=g),s.indexOf(r)===0}e.isEqualOrParent=m;function b(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=b;function _(s,r){return v.isWindows&&s.endsWith(":")&&(s+=C.sep),(0,C.isAbsolute)(s)||(s=(0,C.join)(r,s)),s=(0,C.normalize)(s),v.isWindows?(s=(0,R.rtrim)(s,C.sep),s.endsWith(":")&&(s+=C.sep)):(s=(0,R.rtrim)(s,C.sep),s||(s=C.sep)),s}e.sanitizeFilePath=_;function u(s){const r=(0,C.normalize)(s);return v.isWindows?s.length>3?!1:c(r)&&(s.length===2||r.charCodeAt(2)===92):r===C.posix.sep}e.isRootOrDriveLetter=u;function c(s){return v.isWindows?b(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function d(s){return c(s)?s[0]:void 0}e.getDriveLetter=d;function t(s,r,o){return r.length>s.length?-1:s===r?0:(o&&(s=s.toLowerCase(),r=r.toLowerCase()),s.indexOf(r))}e.indexOfPath=t;function n(s){const r=s.split(":");let o,g,f;if(r.forEach(S=>{const E=Number(S);(0,T.isNumber)(E)?g===void 0?g=E:f===void 0&&(f=E):o=o?[o,S].join(":"):S}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:g!==void 0?g:void 0,column:f!==void 0?f:g!==void 0?1:void 0}}e.parseLineAndColumnAware=n}),define(me[24],ge([0,1,12]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const m=Array.isArray(w)?[]:{};return Object.keys(w).forEach(b=>{w[b]&&typeof w[b]=="object"?m[b]=R(w[b]):m[b]=w[b]}),m}e.deepClone=R;function C(w){if(!w||typeof w!="object")return w;const m=[w];for(;m.length>0;){const b=m.shift();Object.freeze(b);for(const _ in b)if(T.call(b,_)){const u=b[_];typeof u=="object"&&!Object.isFrozen(u)&&m.push(u)}}return w}e.deepFreeze=C;const T=Object.prototype.hasOwnProperty;function y(w,m){return P(w,m,new Set)}e.cloneAndChange=y;function P(w,m,b){if((0,v.isUndefinedOrNull)(w))return w;const _=m(w);if(typeof _!="undefined")return _;if((0,v.isArray)(w)){const u=[];for(const c of w)u.push(P(c,m,b));return u}if((0,v.isObject)(w)){if(b.has(w))throw new Error("Cannot clone recursive data-structure");b.add(w);const u={};for(let c in w)T.call(w,c)&&(u[c]=P(w[c],m,b));return b.delete(w),u}return w}function D(w,m,b=!0){return(0,v.isObject)(w)?((0,v.isObject)(m)&&Object.keys(m).forEach(_=>{_ in w?b&&((0,v.isObject)(w[_])&&(0,v.isObject)(m[_])?D(w[_],m[_],b):w[_]=m[_]):w[_]=m[_]}),w):m}e.mixin=D;function I(w,m){if(w===m)return!0;if(w==null||m===null||m===void 0||typeof w!=typeof m||typeof w!="object"||Array.isArray(w)!==Array.isArray(m))return!1;let b,_;if(Array.isArray(w)){if(w.length!==m.length)return!1;for(b=0;b<w.length;b++)if(!I(w[b],m[b]))return!1}else{const u=[];for(_ in w)u.push(_);u.sort();const c=[];for(_ in m)c.push(_);if(c.sort(),!I(u,c))return!1;for(b=0;b<u.length;b++)if(!I(w[u[b]],m[u[b]]))return!1}return!0}e.equals=I;function i(w){const m=new Set;return JSON.stringify(w,(b,_)=>{if((0,v.isObject)(_)||Array.isArray(_)){if(m.has(_))return"[Circular]";m.add(_)}return _})}e.safeStringify=i;function A(w,m,b){const _=m(w);return typeof _=="undefined"?b:_}e.getOrDefault=A;function h(w,m){const b=Object.create(null);return!w||!m||Object.keys(m).forEach(u=>{const c=w[u],d=m[u];I(c,d)||(b[u]=d)}),b}e.distinct=h;function p(w,m){const b=m.toLowerCase(),_=Object.keys(w).find(u=>u.toLowerCase()===b);return _?w[_]:w[m]}e.getCaseInsensitive=p;function a(w,m){const b=Object.create(null);for(const _ of Object.keys(w))m(_,w[_])&&(b[_]=w[_]);return b}e.filter=a}),define(me[94],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var v;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(v=e.Constants||(e.Constants={}));function R(T){return T<0?0:T>255?255:T|0}e.toUint8=R;function C(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=C}),define(me[2],ge([0,1,11,9]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,T=/^\//,y=/^\/\//;function P(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!C.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!T.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(s,r){return!s&&!r?"file":s}function I(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==A&&(r=A+r):r=A;break}return r}const i="",A="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(r,o,g,f,S,E=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=D(r,E),this.authority=o||i,this.path=I(this.scheme,g||i),this.query=f||i,this.fragment=S||i,P(this,E))}static isUri(r){return r instanceof p?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return u(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:g,path:f,query:S,fragment:E}=r;return o===void 0?o=this.scheme:o===null&&(o=i),g===void 0?g=this.authority:g===null&&(g=i),f===void 0?f=this.path:f===null&&(f=i),S===void 0?S=this.query:S===null&&(S=i),E===void 0?E=this.fragment:E===null&&(E=i),o===this.scheme&&g===this.authority&&f===this.path&&S===this.query&&E===this.fragment?this:new w(o,g,f,S,E)}static parse(r,o=!1){const g=h.exec(r);return g?new w(g[2]||i,n(g[4]||i),n(g[5]||i),n(g[7]||i),n(g[9]||i),o):new w(i,i,i,i,i)}static file(r){let o=i;if(v.isWindows&&(r=r.replace(/\\/g,A)),r[0]===A&&r[1]===A){const g=r.indexOf(A,2);g===-1?(o=r.substring(2),r=A):(o=r.substring(2,g),r=r.substring(g)||A)}return new w("file",o,r,i,i)}static from(r){const o=new w(r.scheme,r.authority,r.path,r.query,r.fragment);return P(o,!0),o}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return v.isWindows&&r.scheme==="file"?g=p.file(R.win32.join(u(r,!0),...o)).path:g=R.posix.join(r.path,...o),r.with({path:g})}toString(r=!1){return c(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof p)return r;{const o=new w(r);return o._formatted=r.external,o._fsPath=r._sep===a?r.fsPath:null,o}}else return r}}e.URI=p;const a=v.isWindows?1:void 0;class w extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(r=!1){return r?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=a),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(s,r){let o,g=-1;for(let f=0;f<s.length;f++){const S=s.charCodeAt(f);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||r&&S===47)g!==-1&&(o+=encodeURIComponent(s.substring(g,f)),g=-1),o!==void 0&&(o+=s.charAt(f));else{o===void 0&&(o=s.substr(0,f));const E=m[S];E!==void 0?(g!==-1&&(o+=encodeURIComponent(s.substring(g,f)),g=-1),o+=E):g===-1&&(g=f)}}return g!==-1&&(o+=encodeURIComponent(s.substring(g))),o!==void 0?o:s}function _(s){let r;for(let o=0;o<s.length;o++){const g=s.charCodeAt(o);g===35||g===63?(r===void 0&&(r=s.substr(0,o)),r+=m[g]):r!==void 0&&(r+=s[o])}return r!==void 0?r:s}function u(s,r){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,v.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=u;function c(s,r){const o=r?_:b;let g="",{scheme:f,authority:S,path:E,query:l,fragment:L}=s;if(f&&(g+=f,g+=":"),(S||f==="file")&&(g+=A,g+=A),S){let O=S.indexOf("@");if(O!==-1){const W=S.substr(0,O);S=S.substr(O+1),O=W.indexOf(":"),O===-1?g+=o(W,!1):(g+=o(W.substr(0,O),!1),g+=":",g+=o(W.substr(O+1),!1)),g+="@"}S=S.toLowerCase(),O=S.indexOf(":"),O===-1?g+=o(S,!1):(g+=o(S.substr(0,O),!1),g+=S.substr(O))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const O=E.charCodeAt(1);O>=65&&O<=90&&(E=`/${String.fromCharCode(O+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const O=E.charCodeAt(0);O>=65&&O<=90&&(E=`${String.fromCharCode(O+32)}:${E.substr(2)}`)}g+=o(E,!0)}return l&&(g+="?",g+=o(l,!1)),L&&(g+="#",g+=r?L:b(L,!1)),g}function d(s){try{return decodeURIComponent(s)}catch(r){return s.length>3?s.substr(0,3)+d(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(t)?s.replace(t,r=>d(r)):s}});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)};define(me[23],ge([0,1,2,8]),function(K,e,v,R){"use strict";var C,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,n,s){let r=t.get(n);return r===void 0&&(r=s,t.set(n,r)),r}e.getOrSet=P;function D(t){const n=[];return t.forEach((s,r)=>{n.push(`${r} => ${s}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=D;function I(t){const n=[];return t.forEach(s=>{n.push(s)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=I;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),r=this._value.charCodeAt(this._pos);return s-r}value(){return this._value[this._pos]}}e.StringIterator=i;class A{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,R.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class h{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,R.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=h;var p;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(p||(p={}));class a{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new h(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,R.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class w{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class m{constructor(n){this._iter=n}static forUris(n=()=>!1){return new m(new a(n))}static forPaths(){return new m(new h)}static forStrings(){return new m(new i)}static forConfigKeys(){return new m(new A)}clear(){this._root=void 0}set(n,s){const r=this._iter.reset(n);let o;for(this._root||(this._root=new w,this._root.segment=r.value()),o=this._root;;){const f=r.cmp(o.segment);if(f>0)o.left||(o.left=new w,o.left.segment=r.value()),o=o.left;else if(f<0)o.right||(o.right=new w,o.right.segment=r.value()),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new w,o.mid.segment=r.value()),o=o.mid;else break}const g=o.value;return o.value=s,o.key=n,g}get(n){var s;return(s=this._getNode(n))===null||s===void 0?void 0:s.value}_getNode(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const o=s.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(n){const s=this._getNode(n);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const r=this._iter.reset(n),o=[];let g=this._root;for(;g;){const f=r.cmp(g.segment);if(f>0)o.push([1,g]),g=g.left;else if(f<0)o.push([-1,g]),g=g.right;else if(r.hasNext())r.next(),o.push([0,g]),g=g.mid;else{for(s?(g.left=void 0,g.mid=void 0,g.right=void 0):g.value=void 0;o.length>0&&g.isEmpty();){let[S,E]=o.pop();switch(S){case 1:E.left=void 0;break;case 0:E.mid=void 0;break;case-1:E.right=void 0;break}g=E}break}}}findSubstr(n){const s=this._iter.reset(n);let r=this._root,o;for(;r;){const g=s.cmp(r.segment);if(g>0)r=r.left;else if(g<0)r=r.right;else if(s.hasNext())s.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const o=s.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(n){for(const[s,r]of this)n(r,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=m;class b{constructor(n,s){this[C]="ResourceMap",n instanceof b?(this.map=new Map(n.map),this.toKey=s!=null?s:b.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:b.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[r,o]of this.map)n(o,v.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield v.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[v.URI.parse(n[0]),n[1]]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[v.URI.parse(n[0]),n[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var _;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(_=e.Touch||(e.Touch={}));class u{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,s=0){const r=this._map.get(n);if(!!r)return s!==0&&this.touch(r,s),r.value}set(n,s,r=0){let o=this._map.get(n);if(o)o.value=s,r!==0&&this.touch(o,r);else{switch(o={key:n,value:s,next:void 0,previous:void 0},r){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const r=this._state;let o=this._head;for(;o;){if(s?n.bind(s)(o.value,o.key,this):n(o.value,o.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const g={value:r.key,done:!1};return r=r.next,g}else return{value:void 0,done:!0}}};return o}values(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const g={value:r.value,done:!1};return r=r.next,g}else return{value:void 0,done:!0}}};return o}entries(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const g={value:[r.key,r.value],done:!1};return r=r.next,g}else return{value:void 0,done:!0}}};return o}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,r=this.size;for(;s&&r>n;)this._map.delete(s.key),s=s.next,r--;this._head=s,this._size=r,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,r=n.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const r=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(r.previous=o,o.next=r),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const r=n.next,o=n.previous;n===this._head?(r.previous=void 0,this._head=r):(r.previous=o,o.next=r),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,r)=>{n.push([r,s])}),n}fromJSON(n){this.clear();for(const[s,r]of n)this.set(s,r)}}e.LinkedMap=u;class c extends u{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class d{constructor(n){y.set(this,void 0),nt(this,y,n,"f")}get size(){return $e(this,y,"f").size}forEach(n,s){$e(this,y,"f").forEach(n,s)}get(n){return $e(this,y,"f").get(n)}has(n){return $e(this,y,"f").has(n)}entries(){return $e(this,y,"f").entries()}keys(){return $e(this,y,"f").keys()}values(){return $e(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return $e(this,y,"f").entries()}}e.ReadonlyMapView=d}),define(me[95],ge([0,1,23,8]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...de){return function(Ee,Re){for(let Ve=0,be=de.length;Ve<be;Ve++){const Ke=de[Ve](Ee,Re);if(Ke)return Ke}return null}}e.or=C,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(de,Ee,Re){if(!Re||Re.length<Ee.length)return null;let Ve;return de?Ve=R.startsWithIgnoreCase(Re,Ee):Ve=Re.indexOf(Ee)===0,Ve?Ee.length>0?[{start:0,end:Ee.length}]:[]:null}function y(de,Ee){const Re=Ee.toLowerCase().indexOf(de.toLowerCase());return Re===-1?null:[{start:Re,end:Re+de.length}]}e.matchesContiguousSubString=y;function P(de,Ee){return D(de.toLowerCase(),Ee.toLowerCase(),0,0)}e.matchesSubString=P;function D(de,Ee,Re,Ve){if(Re===de.length)return[];if(Ve===Ee.length)return null;if(de[Re]===Ee[Ve]){let be=null;return(be=D(de,Ee,Re+1,Ve+1))?b({start:Ve,end:Ve+1},be):null}return D(de,Ee,Re,Ve+1)}function I(de){return 97<=de&&de<=122}function i(de){return 65<=de&&de<=90}e.isUpper=i;function A(de){return 48<=de&&de<=57}function h(de){return de===32||de===9||de===10||de===13}const p=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(de=>p.add(de.charCodeAt(0)));function a(de){return h(de)||p.has(de)}function w(de,Ee){return de===Ee||a(de)&&a(Ee)}function m(de){return I(de)||i(de)||A(de)}function b(de,Ee){return Ee.length===0?Ee=[de]:de.end===Ee[0].start?Ee[0].start=de.start:Ee.unshift(de),Ee}function _(de,Ee){for(let Re=Ee;Re<de.length;Re++){const Ve=de.charCodeAt(Re);if(i(Ve)||A(Ve)||Re>0&&!m(de.charCodeAt(Re-1)))return Re}return de.length}function u(de,Ee,Re,Ve){if(Re===de.length)return[];if(Ve===Ee.length)return null;if(de[Re]!==Ee[Ve].toLowerCase())return null;{let be=null,Ke=Ve+1;for(be=u(de,Ee,Re+1,Ve+1);!be&&(Ke=_(Ee,Ke))<Ee.length;)be=u(de,Ee,Re+1,Ke),Ke++;return be===null?null:b({start:Ve,end:Ve+1},be)}}function c(de){let Ee=0,Re=0,Ve=0,be=0,Ke=0;for(let je=0;je<de.length;je++)Ke=de.charCodeAt(je),i(Ke)&&Ee++,I(Ke)&&Re++,m(Ke)&&Ve++,A(Ke)&&be++;const Q=Ee/de.length,ne=Re/de.length,ve=Ve/de.length,xe=be/de.length;return{upperPercent:Q,lowerPercent:ne,alphaPercent:ve,numericPercent:xe}}function d(de){const{upperPercent:Ee,lowerPercent:Re}=de;return Re===0&&Ee>.6}function t(de){const{upperPercent:Ee,lowerPercent:Re,alphaPercent:Ve,numericPercent:be}=de;return Re>.2&&Ee<.8&&Ve>.6&&be<.2}function n(de){let Ee=0,Re=0,Ve=0,be=0;for(let Ke=0;Ke<de.length;Ke++)Ve=de.charCodeAt(Ke),i(Ve)&&Ee++,I(Ve)&&Re++,h(Ve)&&be++;return(Ee===0||Re===0)&&be===0?de.length<=30:Ee<=5}function s(de,Ee){if(!Ee||(Ee=Ee.trim(),Ee.length===0)||!n(de)||Ee.length>60)return null;const Re=c(Ee);if(!t(Re)){if(!d(Re))return null;Ee=Ee.toLowerCase()}let Ve=null,be=0;for(de=de.toLowerCase();be<Ee.length&&(Ve=u(de,Ee,0,be))===null;)be=_(Ee,be+1);return Ve}e.matchesCamelCase=s;function r(de,Ee,Re=!1){if(!Ee||Ee.length===0)return null;let Ve=null,be=0;for(de=de.toLowerCase(),Ee=Ee.toLowerCase();be<Ee.length&&(Ve=o(de,Ee,0,be,Re))===null;)be=g(Ee,be+1);return Ve}e.matchesWords=r;function o(de,Ee,Re,Ve,be){if(Re===de.length)return[];if(Ve===Ee.length)return null;if(w(de.charCodeAt(Re),Ee.charCodeAt(Ve))){let Ke=null,Q=Ve+1;if(Ke=o(de,Ee,Re+1,Ve+1,be),!be)for(;!Ke&&(Q=g(Ee,Q))<Ee.length;)Ke=o(de,Ee,Re+1,Q,be),Q++;return Ke===null?null:b({start:Ve,end:Ve+1},Ke)}else return null}function g(de,Ee){for(let Re=Ee;Re<de.length;Re++)if(a(de.charCodeAt(Re))||Re>0&&a(de.charCodeAt(Re-1)))return Re;return de.length}const f=C(e.matchesPrefix,s,y),S=C(e.matchesPrefix,s,P),E=new v.LRUCache(1e4);function l(de,Ee,Re=!1){if(typeof de!="string"||typeof Ee!="string")return null;let Ve=E.get(de);Ve||(Ve=new RegExp(R.convertSimple2RegExpPattern(de),"i"),E.set(de,Ve));const be=Ve.exec(Ee);return be?[{start:be.index,end:be.index+be[0].length}]:Re?S(de,Ee):f(de,Ee)}e.matchesFuzzy=l;function L(de,Ee){const Re=We(de,de.toLowerCase(),0,Ee,Ee.toLowerCase(),0,!0);return Re?W(Re):null}e.matchesFuzzy2=L;function O(de,Ee,Re,Ve,be,Ke){const Q=Math.min(13,de.length);for(;Re<Q;Re++){const ne=We(de,Ee,Re,Ve,be,Ke,!1);if(ne)return ne}return[0,Ke]}e.anyScore=O;function W(de){if(typeof de=="undefined")return[];const Ee=[],Re=de[1];for(let Ve=de.length-1;Ve>1;Ve--){const be=de[Ve]+Re,Ke=Ee[Ee.length-1];Ke&&Ke.end===be?Ke.end=be+1:Ee.push({start:be,end:be+1})}return Ee}e.createMatches=W;const te=128;function se(){const de=[],Ee=[];for(let Re=0;Re<=te;Re++)Ee[Re]=0;for(let Re=0;Re<=te;Re++)de.push(Ee.slice(0));return de}function N(de){const Ee=[];for(let Re=0;Re<=de;Re++)Ee[Re]=0;return Ee}const V=N(2*te),x=N(2*te),k=se(),U=se(),F=se(),M=!1;function $(de,Ee,Re,Ve,be){function Ke(ne,ve,xe=" "){for(;ne.length<ve;)ne=xe+ne;return ne}let Q=` |   |${Ve.split("").map(ne=>Ke(ne,3)).join("|")}
`;for(let ne=0;ne<=Re;ne++)ne===0?Q+=" |":Q+=`${Ee[ne-1]}|`,Q+=de[ne].slice(0,be+1).map(ve=>Ke(ve.toString(),3)).join("|")+`
`;return Q}function H(de,Ee,Re,Ve){de=de.substr(Ee),Re=Re.substr(Ve),console.log($(U,de,de.length,Re,Re.length)),console.log($(F,de,de.length,Re,Re.length)),console.log($(k,de,de.length,Re,Re.length))}function X(de,Ee){if(Ee<0||Ee>=de.length)return!1;const Re=de.codePointAt(Ee);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(Re)}}function ae(de,Ee){if(Ee<0||Ee>=de.length)return!1;switch(de.charCodeAt(Ee)){case 32:case 9:return!0;default:return!1}}function we(de,Ee,Re){return Ee[de]!==Re[de]}function Le(de,Ee,Re,Ve,be,Ke,Q=!1){for(;Ee<Re&&be<Ke;)de[Ee]===Ve[be]&&(Q&&(V[Ee]=be),Ee+=1),be+=1;return Ee===Re}e.isPatternInWord=Le;var Ie;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Me;(function(de){de.Default=[-100,0];function Ee(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}de.isDefault=Ee})(Me=e.FuzzyScore||(e.FuzzyScore={}));function We(de,Ee,Re,Ve,be,Ke,Q){const ne=de.length>te?te:de.length,ve=Ve.length>te?te:Ve.length;if(Re>=ne||Ke>=ve||ne-Re>ve-Ke||!Le(Ee,Re,ne,be,Ke,ve,!0))return;j(ne,ve,Re,Ke,Ee,be);let xe=1,je=1,ze=Re,Je=Ke;const ye=[!1];for(xe=1,ze=Re;ze<ne;xe++,ze++){const z=V[ze],J=x[ze],ce=ze+1<ne?x[ze+1]:ve;for(je=z-Ke+1,Je=z;Je<ce;je++,Je++){let Pe=Number.MIN_SAFE_INTEGER,Ae=!1;Je<=J&&(Pe=Y(de,Ee,ze,Re,Ve,be,Je,ve,Ke,k[xe-1][je-1]===0,ye));let Ne=0;Pe!==Number.MAX_SAFE_INTEGER&&(Ae=!0,Ne=Pe+U[xe-1][je-1]);const Be=Je>z,Qe=Be?U[xe][je-1]+(k[xe][je-1]>0?-5:0):0,rt=Je>z+1&&k[xe][je-1]>0,et=rt?U[xe][je-2]+(k[xe][je-2]>0?-5:0):0;if(rt&&(!Be||et>=Qe)&&(!Ae||et>=Ne))U[xe][je]=et,F[xe][je]=3,k[xe][je]=0;else if(Be&&(!Ae||Qe>=Ne))U[xe][je]=Qe,F[xe][je]=2,k[xe][je]=0;else if(Ae)U[xe][je]=Ne,F[xe][je]=1,k[xe][je]=k[xe-1][je-1]+1;else throw new Error("not possible")}}if(M&&H(de,Re,Ve,Ke),!ye[0]&&!Q)return;xe--,je--;const De=[U[xe][je],Ke];let ke=0,re=0;for(;xe>=1;){let z=je;do{const J=F[xe][z];if(J===3)z=z-2;else if(J===2)z=z-1;else break}while(z>=1);ke>1&&Ee[Re+xe-1]===be[Ke+je-1]&&!we(z+Ke-1,Ve,be)&&ke+1>k[xe][z]&&(z=je),z===je?ke++:ke=1,re||(re=z),xe--,je=z-1,De.push(je)}ve===ne&&(De[0]+=2);const he=re-ne;return De[0]-=he,De}e.fuzzyScore=We;function j(de,Ee,Re,Ve,be,Ke){let Q=de-1,ne=Ee-1;for(;Q>=Re&&ne>=Ve;)be[Q]===Ke[ne]&&(x[Q]=ne,Q--),ne--}function Y(de,Ee,Re,Ve,be,Ke,Q,ne,ve,xe,je){if(Ee[Re]!==Ke[Q])return Number.MIN_SAFE_INTEGER;let ze=1,Je=!1;return Q===Re-Ve?ze=de[Re]===be[Q]?7:5:we(Q,be,Ke)&&(Q===0||!we(Q-1,be,Ke))?(ze=de[Re]===be[Q]?7:5,Je=!0):X(Ke,Q)&&(Q===0||!X(Ke,Q-1))?ze=5:(X(Ke,Q-1)||ae(Ke,Q-1))&&(ze=5,Je=!0),ze>1&&Re===Ve&&(je[0]=!0),Je||(Je=we(Q,be,Ke)||X(Ke,Q-1)||ae(Ke,Q-1)),Re===Ve?Q>ve&&(ze-=Je?3:5):xe?ze+=Je?2:0:ze+=Je?0:1,Q+1===ne&&(ze-=Je?3:5),ze}function ee(de,Ee,Re,Ve,be,Ke,Q){return pe(de,Ee,Re,Ve,be,Ke,!0,Q)}e.fuzzyScoreGracefulAggressive=ee;function oe(de,Ee,Re,Ve,be,Ke,Q){return pe(de,Ee,Re,Ve,be,Ke,!1,Q)}e.fuzzyScoreGraceful=oe;function pe(de,Ee,Re,Ve,be,Ke,Q,ne){let ve=We(de,Ee,Re,Ve,be,Ke,ne);if(ve&&!Q)return ve;if(de.length>=3){const xe=Math.min(7,de.length-1);for(let je=Re+1;je<xe;je++){const ze=_e(de,je);if(ze){const Je=We(ze,ze.toLowerCase(),Re,Ve,be,Ke,ne);Je&&(Je[0]-=3,(!ve||Je[0]>ve[0])&&(ve=Je))}}}return ve}function _e(de,Ee){if(Ee+1>=de.length)return;const Re=de[Ee],Ve=de[Ee+1];if(Re!==Ve)return de.slice(0,Ee)+Ve+Re+de.slice(Ee+2)}}),define(me[137],ge([0,1,45,95,8]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${T.source}`,"g");function P(w){return w.replace(y,(m,b)=>b?m:`\\${m}`)}e.escapeIcons=P;const D=new RegExp(`\\\\${T.source}`,"g");function I(w){return w.replace(D,m=>`\\${m}`)}e.markdownEscapeEscapedIcons=I;const i=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function A(w){return w.indexOf(e.iconStartMarker)===-1?w:w.replace(i,(m,b,_,u)=>_?m:b||u||"")}e.stripIcons=A;function h(w){const m=w.indexOf(e.iconStartMarker);return m===-1?{text:w}:p(w,m)}e.parseLabelWithIcons=h;function p(w,m){const b=[];let _="";function u(g){if(g){_+=g;for(const f of g)b.push(t)}}let c=-1,d="",t=0,n,s,r=m;const o=w.length;for(u(w.substr(0,m));r<o;)n=w[r],s=w[r+1],n===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(c=r,u(d),d=e.iconStartMarker,r++):n===")"&&c!==-1?(t+=r-c+1,c=-1,d=""):c!==-1?/^[a-z0-9\-]$/i.test(n)?d+=n:(u(d),c=-1,d=""):u(n),r++;return u(d),{text:_,iconOffsets:b}}function a(w,m,b=!1){const{text:_,iconOffsets:u}=m;if(!u||u.length===0)return(0,R.matchesFuzzy)(w,_,b);const c=(0,C.ltrim)(_," "),d=_.length-c.length,t=(0,R.matchesFuzzy)(w,c,b);if(t)for(const n of t){const s=u[n.start+d]+d;n.start+=s,n.end+=s}return t}e.matchesFuzzyIconAware=a}),define(me[96],ge([0,1,16,137,17]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(w="",m=!1){var b,_;if(this.value=w,typeof this.value!="string")throw(0,C.illegalArgument)("value");typeof m=="boolean"?(this.isTrusted=m,this.supportThemeIcons=!1):(this.isTrusted=(b=m.isTrusted)!==null&&b!==void 0?b:void 0,this.supportThemeIcons=(_=m.supportThemeIcons)!==null&&_!==void 0?_:!1)}appendText(w,m=0){return this.value+=A(this.supportThemeIcons?(0,R.escapeIcons)(w):w).replace(/([ \t]+)/g,(b,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,m===1?`\\
`:`

`),this}appendMarkdown(w){return this.value+=w,this}appendCodeblock(w,m){return this.value+="\n```",this.value+=w,this.value+=`
`,this.value+=m,this.value+="\n```\n",this}}e.MarkdownString=y;function P(a){return D(a)?!a.value:Array.isArray(a)?a.every(P):!0}e.isEmptyMarkdownString=P;function D(a){return a instanceof y?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function I(a,w){return!a&&!w?!0:!a||!w?!1:Array.isArray(a)&&Array.isArray(w)?(0,v.equals)(a,w,i):D(a)&&D(w)?i(a,w):!1}e.markedStringsEquals=I;function i(a,w){return a===w?!0:!a||!w?!1:a.value===w.value&&a.isTrusted===w.isTrusted&&a.supportThemeIcons===w.supportThemeIcons}function A(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=A;function h(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=h;function p(a){const w=[],m=a.split("|").map(_=>_.trim());a=m[0];const b=m[1];if(b){const _=/height=(\d+)/.exec(b),u=/width=(\d+)/.exec(b),c=_?_[1]:"",d=u?u[1]:"",t=isFinite(parseInt(d)),n=isFinite(parseInt(c));t&&w.push(`width="${d}"`),n&&w.push(`height="${c}"`)}return{href:a,dimensions:w}}e.parseHrefAndDimensions=p}),define(me[58],ge([0,1,22,8,2]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(I){return JSON.stringify(I,P)}e.stringify=T;function y(I){let i=JSON.parse(I);return i=D(i),i}e.parse=y;function P(I,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,R.regExpFlags)(i)}:i}function D(I,i=0){if(!I||i>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return C.URI.revive(I);case 2:return new RegExp(I.source,I.flags)}if(I instanceof v.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let A=0;A<I.length;++A)I[A]=D(I[A],i+1);else for(const A in I)Object.hasOwnProperty.call(I,A)&&(I[A]=D(I[A],i+1))}return I}e.revive=D}),define(me[10],ge([0,1,2,11]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(C=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,I,i){this._hosts[D]=I,this._ports[D]=i}setConnectionToken(D,I){this._connectionTokens[D]=I}rewrite(D){if(this._delegate)return this._delegate(D);const I=D.authority;let i=this._hosts[I];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const A=this._ports[I],h=this._connectionTokens[I];let p=`path=${encodeURIComponent(D.path)}`;return typeof h=="string"&&(p+=`&tkn=${encodeURIComponent(h)}`),v.URI.from({scheme:R.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${i}:${A}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new T;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,I,i){const A=this.toUri(D,I);return A.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(A):R.isNative&&(i||R.isPreferringBrowserCodeLoad)&&A.scheme===C.file?A.with({scheme:C.vscodeFileResource,authority:A.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):A}asFileUri(D,I){const i=this.toUri(D,I);return i.scheme===C.vscodeFileResource?i.with({scheme:C.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(D,I){return v.URI.isUri(D)?D:v.URI.parse(I.toUrl(D))}}e.FileAccess=new y}),define(me[76],ge([0,1,23]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new v.LRUCache(1e4);function C(I){return D(I,"NFC",R)}e.normalizeNFC=C;const T=new v.LRUCache(1e4);function y(I){return D(I,"NFD",T)}e.normalizeNFD=y;const P=/[^\u0000-\u0080]/;function D(I,i,A){if(!e.canNormalize||!I)return I;const h=A.get(I);if(h)return h;let p;return P.test(I)?p=I.normalize(i):p=I,A.set(I,p),p}e.removeAccents=function(){if(e.canNormalize){const I=/[\u0300-\u036f]/g;return function(i){return y(i).replace(I,"")}}else return function(I){return I}}()}),define(me[25],ge([0,1,29,9,2,8,10,11]),function(K,e,v,R,C,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(p){return(0,C.uriToFsPath)(p,!0)}e.originalFSPath=D;class I{constructor(a){this._ignorePathCasing=a}compare(a,w,m=!1){return a===w?0:(0,T.compare)(this.getComparisonKey(a,m),this.getComparisonKey(w,m))}isEqual(a,w,m=!1){return a===w?!0:!a||!w?!1:this.getComparisonKey(a,m)===this.getComparisonKey(w,m)}getComparisonKey(a,w=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,w,m=!1){if(a.scheme===w.scheme){if(a.scheme===y.Schemas.file)return v.isEqualOrParent(D(a),D(w),this._ignorePathCasing(a))&&a.query===w.query&&(m||a.fragment===w.fragment);if((0,e.isEqualAuthority)(a.authority,w.authority))return v.isEqualOrParent(a.path,w.path,this._ignorePathCasing(a),"/")&&a.query===w.query&&(m||a.fragment===w.fragment)}return!1}joinPath(a,...w){return C.URI.joinPath(a,...w)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return R.posix.basename(a.path)}extname(a){return R.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let w;return a.scheme===y.Schemas.file?w=C.URI.file(R.dirname(D(a))).path:(w=R.posix.dirname(a.path),a.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),w="/")),a.with({path:w})}normalizePath(a){if(!a.path.length)return a;let w;return a.scheme===y.Schemas.file?w=C.URI.file(R.normalize(D(a))).path:w=R.posix.normalize(a.path),a.with({path:w})}relativePath(a,w){if(a.scheme!==w.scheme||!(0,e.isEqualAuthority)(a.authority,w.authority))return;if(a.scheme===y.Schemas.file){const _=R.relative(D(a),D(w));return P.isWindows?v.toSlashes(_):_}let m=a.path||"/",b=w.path||"/";if(this._ignorePathCasing(a)){let _=0;for(const u=Math.min(m.length,b.length);_<u&&!(m.charCodeAt(_)!==b.charCodeAt(_)&&m.charAt(_).toLowerCase()!==b.charAt(_).toLowerCase());_++);m=b.substr(0,_)+m.substr(_)}return R.posix.relative(m,b)}resolvePath(a,w){if(a.scheme===y.Schemas.file){const m=C.URI.file(R.resolve(D(a),w));return a.with({authority:m.authority,path:m.path})}return w=v.toPosixPath(w),a.with({path:R.posix.resolve(a.path,w)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,w){return a===w||(0,T.equalsIgnoreCase)(a,w)}hasTrailingPathSeparator(a,w=R.sep){if(a.scheme===y.Schemas.file){const m=D(a);return m.length>v.getRoot(m).length&&m[m.length-1]===w}else{const m=a.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,w=R.sep){return(0,e.hasTrailingPathSeparator)(a,w)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,w=R.sep){let m=!1;if(a.scheme===y.Schemas.file){const b=D(a);m=b!==void 0&&b.length===v.getRoot(b).length&&b[b.length-1]===w}else{w="/";const b=a.path;m=b.length===1&&b.charCodeAt(b.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(a,w)?a.with({path:a.path+"/"}):a}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(p=>p.scheme===y.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new I(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,a){const w=[];for(let m=0;m<p.length;m++){const b=a(p[m]);p.some((_,u)=>u===m?!1:(0,e.isEqualOrParent)(b,a(_)))||w.push(p[m])}return w}e.distinctParents=i;var A;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function a(w){const m=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(u=>{const[c,d]=u.split(":");c&&d&&m.set(c,d)});const _=w.path.substring(0,w.path.indexOf(";"));return _&&m.set(p.META_DATA_MIME,_),m}p.parseMetaData=a})(A=e.DataUri||(e.DataUri={}));function h(p,a,w){if(a){let m=p.path;return m&&m[0]!==R.posix.sep&&(m=R.posix.sep+m),p.with({scheme:w,authority:a,path:m})}return p.with({scheme:w})}e.toLocalResource=h}),define(me[13],ge([0,1,21,17,3,6,56,25]),function(K,e,v,R,C,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(U){return!!U&&typeof U.then=="function"}e.isThenable=D;function I(U){const F=new v.CancellationTokenSource,M=U(F.token),$=new Promise((H,X)=>{F.token.onCancellationRequested(()=>{X((0,R.canceled)())}),Promise.resolve(M).then(ae=>{F.dispose(),H(ae)},ae=>{F.dispose(),X(ae)})});return new class{cancel(){F.cancel()}then(H,X){return $.then(H,X)}catch(H){return this.then(void 0,H)}finally(H){return $.finally(H)}}}e.createCancelablePromise=I;function i(U,F,M){return Promise.race([U,new Promise($=>F.onCancellationRequested(()=>$(M)))])}e.raceCancellation=i;async function A(U){let F=-1;const M=U.map((H,X)=>H.then(ae=>(F=X,ae))),$=await Promise.race(M);return U.forEach((H,X)=>{X!==F&&H.cancel()}),$}e.raceCancellablePromises=A;function h(U,F,M){let $;const H=setTimeout(()=>{$==null||$(void 0),M==null||M()},F);return Promise.race([U.finally(()=>clearTimeout(H)),new Promise(X=>$=X)])}e.raceTimeout=h;function p(U){return new Promise((F,M)=>{const $=U();D($)?$.then(F,M):F($)})}e.asPromise=p;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(M,M).then($)})}return new Promise((M,$)=>{this.queuedPromise.then(M,$)})}return this.activePromise=F(),new Promise((M,$)=>{this.activePromise.then(H=>{this.activePromise=null,M(H)},H=>{this.activePromise=null,$(H)})})}}e.Throttler=a;class w{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=w;class m{constructor(){this.promiseMap=new Map}queue(F,M){var $;const X=(($=this.promiseMap.get(F))!==null&&$!==void 0?$:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(F)===X&&this.promiseMap.delete(F)});return this.promiseMap.set(F,X),X}}e.SequencerByKey=m;class b{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,M=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(($,H)=>{this.doResolve=$,this.doReject=H}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const $=this.task;return this.task=null,$()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=b;class _{constructor(F){this.delayer=new b(F),this.throttler=new a}trigger(F,M){return this.delayer.trigger(()=>this.throttler.queue(F),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,M)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class c extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function d(U,F){return F?new Promise((M,$)=>{const H=setTimeout(M,U);F.onCancellationRequested(()=>{clearTimeout(H),$((0,R.canceled)())})}):I(M=>d(U,M))}e.timeout=d;function t(U,F=0){const M=setTimeout(U,F);return(0,T.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=t;function n(U){return U.then(void 0,F=>{})}e.ignoreErrors=n;function s(U){const F=[];let M=0;const $=U.length;function H(){return M<$?U[M++]():null}function X(ae){ae!=null&&F.push(ae);const we=H();return we?we.then(X):Promise.resolve(F)}return Promise.resolve(null).then(X)}e.sequence=s;function r(U,F=$=>!!$,M=null){let $=0;const H=U.length,X=()=>{if($>=H)return Promise.resolve(M);const ae=U[$++];return Promise.resolve(ae()).then(Le=>F(Le)?Promise.resolve(Le):X())};return X()}e.first=r;function o(U,F=$=>!!$,M=null){if(U.length===0)return Promise.resolve(M);let $=U.length;const H=()=>{var X,ae;$=-1;for(const we of U)(ae=(X=we).cancel)===null||ae===void 0||ae.call(X)};return new Promise((X,ae)=>{for(const we of U)we.then(Le=>{--$>=0&&F(Le)?(H(),X(Le)):$===0&&X(M)}).catch(Le=>{--$>=0&&(H(),ae(Le))})})}e.firstParallel=o;class g{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((M,$)=>{this.outstandingPromises.push({factory:F,c:M,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const M=F.factory();M.then(F.c,F.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=g;class f extends g{constructor(){super(1)}}e.Queue=f;class S{constructor(){this.queues=new Map}queueFor(F,M=P.extUri){const $=M.getComparisonKey(F);let H=this.queues.get($);return H||(H=new f,C.Event.once(H.onFinished)(()=>{H==null||H.dispose(),this.queues.delete($)}),this.queues.set($,H)),H}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=S;class E{constructor(F,M){this._token=-1,typeof F=="function"&&typeof M=="number"&&this.setIfNotSet(F,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},M)}setIfNotSet(F,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},M))}}e.TimeoutTimer=E;class l{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setInterval(()=>{F()},M)}}e.IntervalTimer=l;class L{constructor(F,M){this.timeoutToken=-1,this.runner=F,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class O extends L{constructor(F,M){super(F,M);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const U=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const M=setTimeout(()=>F(U));let $=!1;return{dispose(){$||($=!0,clearTimeout(M))}}}}else e.runWhenIdle=(U,F)=>{const M=requestIdleCallback(U,typeof F=="number"?{timeout:F}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(M))}}}}();class W{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=W;async function te(U,F,M){let $;for(let H=0;H<M;H++)try{return await U()}catch(X){$=X,await d(F)}throw $}e.retry=te;class se{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,M,$){return this._pending={taskId:F,cancel:()=>$==null?void 0:$(),promise:M},M.then(()=>this.donePending(F),()=>this.donePending(F)),M}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let M,$;const H=new Promise((X,ae)=>{M=X,$=ae});this._next={run:F,promise:H,promiseResolve:M,promiseReject:$}}return this._next.promise}}e.TaskSequentializer=se;class N{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,M)=>{this.completeCallback=F,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(M=>{this.completeCallback(F),this.resolved=!0,M()})}error(F){return new Promise(M=>{this.errorCallback(F),this.rejected=!0,M()})}cancel(){new Promise(F=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=V;class x extends C.Emitter{async fireAsync(F,M,$){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const H of this._listeners)this._asyncDeliveryQueue.push([H,F]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[H,X]=this._asyncDeliveryQueue.shift(),ae=[],we=Object.assign(Object.assign({},X),{waitUntil:Le=>{if(Object.isFrozen(ae))throw new Error("waitUntil can NOT be called asynchronous");$&&(Le=$(Le,typeof H=="function"?H:H[0])),ae.push(Le)}});try{typeof H=="function"?H.call(void 0,we):H[0].call(H[1],we)}catch(Le){(0,R.onUnexpectedError)(Le);continue}Object.freeze(ae),await k.settled(ae).catch(Le=>(0,R.onUnexpectedError)(Le))}}}}e.AsyncEmitter=x;var k;(function(U){async function F(X){return typeof Promise.allSettled=="function"?M(X):$(X)}U.allSettled=F;async function M(X){return Promise.allSettled(X)}async function $(X){return Promise.all(X.map(ae=>ae.then(we=>({status:"fulfilled",value:we}),we=>({status:"rejected",reason:we}))))}async function H(X){let ae;const we=await Promise.all(X.map(Le=>Le.then(Ie=>Ie,Ie=>{ae||(ae=Ie)})));if(typeof ae!="undefined")throw ae;return we}U.settled=H})(k=e.Promises||(e.Promises={}))}),define(me[97],ge([0,1,9,13]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new R.IdleValue(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),T=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(E,l,L=!1){const O=E||"",W=l||"",te=C.value.collator.compare(O,W);return C.value.collatorIsNumeric&&te===0&&O!==W?O<W?-1:1:te}e.compareFileNames=P;function D(E,l){const L=T.value.collator;return E=E||"",l=l||"",d(L,E,l)}e.compareFileNamesDefault=D;function I(E,l){const L=T.value.collator;return E=E||"",l=l||"",r(E,l)||d(L,E,l)}e.compareFileNamesUpper=I;function i(E,l){const L=T.value.collator;return E=E||"",l=l||"",s(E,l)||d(L,E,l)}e.compareFileNamesLower=i;function A(E,l){return E=E||"",l=l||"",E===l?0:E<l?-1:1}e.compareFileNamesUnicode=A;function h(E,l,L=!1){L||(E=E&&E.toLowerCase(),l=l&&l.toLowerCase());const[O,W]=u(E),[te,se]=u(l);return O!==te?O<te?-1:1:W===se?0:W<se?-1:1}e.noIntlCompareFileNames=h;function p(E,l){const[L,O]=u(E),[W,te]=u(l);let se=C.value.collator.compare(O,te);if(se===0){if(C.value.collatorIsNumeric&&O!==te)return O<te?-1:1;if(se=C.value.collator.compare(L,W),C.value.collatorIsNumeric&&se===0&&L!==W)return L<W?-1:1}return se}e.compareFileExtensions=p;function a(E,l){E=E||"",l=l||"";const L=c(E),O=c(l),W=T.value.collator,te=y.value.collator;return d(te,L,O)||d(W,E,l)}e.compareFileExtensionsDefault=a;function w(E,l){E=E||"",l=l||"";const L=c(E),O=c(l),W=T.value.collator,te=y.value.collator;return d(te,L,O)||r(E,l)||d(W,E,l)}e.compareFileExtensionsUpper=w;function m(E,l){E=E||"",l=l||"";const L=c(E),O=c(l),W=T.value.collator,te=y.value.collator;return d(te,L,O)||s(E,l)||d(W,E,l)}e.compareFileExtensionsLower=m;function b(E,l){E=E||"",l=l||"";const L=c(E).toLowerCase(),O=c(l).toLowerCase();return L!==O?L<O?-1:1:E!==l?E<l?-1:1:0}e.compareFileExtensionsUnicode=b;const _=/^(.*?)(\.([^.]*))?$/;function u(E,l=!1){const L=E?_.exec(E):[];let O=[L&&L[1]||"",L&&L[3]||""];return l&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function c(E){const l=E?_.exec(E):[];return l&&l[1]&&l[1].charAt(0)!=="."&&l[3]||""}function d(E,l,L){let O=E.compare(l,L);return O!==0?O:l.length!==L.length?l.length<L.length?-1:1:0}function t(E){const l=E.charAt(0);return l.toLocaleUpperCase()!==l}function n(E){const l=E.charAt(0);return l.toLocaleLowerCase()!==l}function s(E,l){return t(E)&&n(l)?-1:n(E)&&t(l)?1:0}function r(E,l){return n(E)&&t(l)?-1:t(E)&&n(l)?1:0}function o(E,l,L=!1){return L||(E=E&&E.toLowerCase(),l=l&&l.toLowerCase()),E===l?0:E<l?-1:1}function g(E,l,L=!1){const O=E.split(v.sep),W=l.split(v.sep),te=O.length-1,se=W.length-1;let N,V;for(let x=0;;x++){if(N=te===x,V=se===x,N&&V)return P(O[x],W[x],L);if(N)return-1;if(V)return 1;const k=o(O[x],W[x],L);if(k!==0)return k}}e.comparePaths=g;function f(E,l,L){const O=E.toLowerCase(),W=l.toLowerCase(),te=S(E,l,L);if(te)return te;const se=O.endsWith(L),N=W.endsWith(L);if(se!==N)return se?-1:1;const V=P(O,W);return V!==0?V:O.localeCompare(W)}e.compareAnything=f;function S(E,l,L){const O=E.toLowerCase(),W=l.toLowerCase(),te=O.startsWith(L),se=W.startsWith(L);if(te!==se)return te?-1:1;if(te&&se){if(O.length<W.length)return-1;if(O.length>W.length)return 1}return 0}e.compareByPrefix=S}),define(me[98],ge([0,1,97,95,9,11,8]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const P=0,D=[P,[]];function I(N,V,x,k){if(!N||!V)return D;const U=N.length,F=V.length;if(U<F)return D;const M=N.toLowerCase();return!k&&!M.includes(x)?D:i(V,x,F,N,M,U)}e.scoreFuzzy=I;function i(N,V,x,k,U,F){const M=[],$=[];for(let we=0;we<x;we++){const Le=we*F,Ie=Le-F,Me=we>0,We=N[we],j=V[we];for(let Y=0;Y<F;Y++){const ee=Y>0,oe=Le+Y,pe=oe-1,_e=Ie+Y-1,de=ee?M[pe]:0,Ee=Me&&ee?M[_e]:0,Re=Me&&ee?$[_e]:0;let Ve;!Ee&&Me?Ve=0:Ve=A(We,j,k,U,Y,Re),Ve&&Ee+Ve>=de?($[oe]=Re+1,M[oe]=Ee+Ve):($[oe]=P,M[oe]=de)}}const H=[];let X=x-1,ae=F-1;for(;X>=0&&ae>=0;){const we=X*F+ae;$[we]===P||(H.push(ae),X--),ae--}return[M[x*F-1],H.reverse()]}function A(N,V,x,k,U,F){let M=0;if(!h(V,k[U]))return M;if(M+=1,F>0&&(M+=F*5),N===x[U]&&(M+=1),U===0)M+=8;else{const $=p(x.charCodeAt(U-1));$?M+=$:(0,R.isUpper)(x.charCodeAt(U))&&(M+=2)}return M}function h(N,V){return N===V?!0:N==="/"||N==="\\"?V==="/"||V==="\\":!1}function p(N){switch(N){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function w(N,V,x=0,k=0){const U=V;return U.values&&U.values.length>1?m(N,U.values,x,k):b(N,V,x,k)}e.scoreFuzzy2=w;function m(N,V,x,k){let U=0;const F=[];for(const M of V){const[$,H]=b(N,M,x,k);if(typeof $!="number")return a;U+=$,F.push(...H)}return[U,g(F)]}function b(N,V,x,k){const U=(0,R.fuzzyScore)(V.original,V.originalLowercase,x,N,N.toLowerCase(),k,!0);return U?[U[0],(0,R.createMatches)(U)]:a}const _=Object.freeze({score:0}),u=1<<18,c=1<<17,d=1<<16;function t(N,V,x,k,U){if(!N||!V.normalized)return _;const F=k.getItemLabel(N);if(!F)return _;const M=k.getItemDescription(N);let $;M?$=`${F}${M}${V.normalized}${Array.isArray(V.values)?V.values.length:""}${x}`:$=`${F}${V.normalized}${Array.isArray(V.values)?V.values.length:""}${x}`;const H=U[$];if(H)return H;const X=n(F,M,k.getItemPath(N),V,x);return U[$]=X,X}e.scoreItemFuzzy=t;function n(N,V,x,k,U){const F=!x||!k.containsPathSeparator;return x&&(T.isLinux?k.pathNormalized===x:(0,y.equalsIgnoreCase)(k.pathNormalized,x))?{score:u,labelMatch:[{start:0,end:N.length}],descriptionMatch:V?[{start:0,end:V.length}]:void 0}:k.values&&k.values.length>1?s(N,V,x,k.values,F,U):r(N,V,x,k,F,U)}function s(N,V,x,k,U,F){let M=0;const $=[],H=[];for(const X of k){const{score:ae,labelMatch:we,descriptionMatch:Le}=r(N,V,x,X,U,F);if(ae===P)return _;M+=ae,we&&$.push(...we),Le&&H.push(...Le)}return{score:M,labelMatch:g($),descriptionMatch:g(H)}}function r(N,V,x,k,U,F){if(U||!V){const[M,$]=I(N,k.normalized,k.normalizedLowercase,F);if(M){const H=(0,R.matchesPrefix)(k.normalized,N);let X;return H?(X=c,X+=Math.round(k.normalized.length/N.length*100)):X=d,{score:X+M,labelMatch:H||o($)}}}if(V){let M=V;x&&(M=`${V}${C.sep}`);const $=M.length,H=`${M}${N}`,[X,ae]=I(H,k.normalized,k.normalizedLowercase,F);if(X){const we=o(ae),Le=[],Ie=[];return we.forEach(Me=>{Me.start<$&&Me.end>$?(Le.push({start:0,end:Me.end-$}),Ie.push({start:Me.start,end:$})):Me.start>=$?Le.push({start:Me.start-$,end:Me.end-$}):Ie.push(Me)}),{score:X,labelMatch:Le,descriptionMatch:Ie}}}return _}function o(N){const V=[];if(!N)return V;let x;for(const k of N)x&&x.end===k?x.end+=1:(x={start:k,end:k+1},V.push(x));return V}function g(N){const V=N.sort((U,F)=>U.start-F.start),x=[];let k;for(const U of V)!k||!f(k,U)?(k=U,x.push(U)):(k.start=Math.min(k.start,U.start),k.end=Math.max(k.end,U.end));return x}function f(N,V){return!(N.end<V.start||V.end<N.start)}function S(N,V,x,k,U,F){const M=t(N,x,k,U,F),$=t(V,x,k,U,F),H=M.score,X=$.score;if((H===u||X===u)&&H!==X)return H===u?-1:1;if(H>d||X>d){if(H!==X)return H>X?-1:1;if(H<c&&X<c){const j=l(M.labelMatch,$.labelMatch);if(j!==0)return j}const Me=U.getItemLabel(N)||"",We=U.getItemLabel(V)||"";if(Me.length!==We.length)return Me.length-We.length}if(H!==X)return H>X?-1:1;const ae=Array.isArray(M.labelMatch)&&M.labelMatch.length>0,we=Array.isArray($.labelMatch)&&$.labelMatch.length>0;if(ae&&!we)return-1;if(we&&!ae)return 1;const Le=E(N,M,U),Ie=E(V,$,U);return Le&&Ie&&Le!==Ie?Ie>Le?-1:1:L(N,V,x,U)}e.compareItemsByFuzzyScore=S;function E(N,V,x){let k=-1,U=-1;if(V.descriptionMatch&&V.descriptionMatch.length?k=V.descriptionMatch[0].start:V.labelMatch&&V.labelMatch.length&&(k=V.labelMatch[0].start),V.labelMatch&&V.labelMatch.length){if(U=V.labelMatch[V.labelMatch.length-1].end,V.descriptionMatch&&V.descriptionMatch.length){const F=x.getItemDescription(N);F&&(U+=F.length)}}else V.descriptionMatch&&V.descriptionMatch.length&&(U=V.descriptionMatch[V.descriptionMatch.length-1].end);return U-k}function l(N,V){if(!N&&!V||(!N||!N.length)&&(!V||!V.length))return 0;if(!V||!V.length)return-1;if(!N||!N.length)return 1;const x=N[0].start,U=N[N.length-1].end-x,F=V[0].start,$=V[V.length-1].end-F;return U===$?0:$<U?1:-1}function L(N,V,x,k){const U=k.getItemLabel(N)||"",F=k.getItemLabel(V)||"",M=k.getItemDescription(N),$=k.getItemDescription(V),H=U.length+(M?M.length:0),X=F.length+($?$.length:0);if(H!==X)return H-X;const ae=k.getItemPath(N),we=k.getItemPath(V);return ae&&we&&ae.length!==we.length?ae.length-we.length:U!==F?(0,v.compareAnything)(U,F,x.normalized):M&&$&&M!==$?(0,v.compareAnything)(M,$,x.normalized):ae&&we&&ae!==we?(0,v.compareAnything)(ae,we,x.normalized):0}const O=" ";function W(N){typeof N!="string"&&(N="");const V=N.toLowerCase(),{pathNormalized:x,normalized:k,normalizedLowercase:U}=te(N),F=x.indexOf(C.sep)>=0;let M;const $=N.split(O);if($.length>1)for(const H of $){const{pathNormalized:X,normalized:ae,normalizedLowercase:we}=te(H);ae&&(M||(M=[]),M.push({original:H,originalLowercase:H.toLowerCase(),pathNormalized:X,normalized:ae,normalizedLowercase:we}))}return{original:N,originalLowercase:V,pathNormalized:x,normalized:k,normalizedLowercase:U,values:M,containsPathSeparator:F}}e.prepareQuery=W;function te(N){let V;T.isWindows?V=N.replace(/\//g,C.sep):V=N.replace(/\\/g,C.sep);const x=(0,y.stripWildcards)(V).replace(/\s/g,"");return{pathNormalized:V,normalized:x,normalizedLowercase:x.toLowerCase()}}function se(N){return Array.isArray(N)?W(N.map(V=>V.original).join(O)):W(N.original)}e.pieceToQuery=se}),define(me[31],ge([0,1,8,29,9,23,13]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const D="**",I="/",i="[/\\\\]",A="[^/\\\\]",h=/\//g;function p(M){switch(M){case 0:return"";case 1:return`${A}*?`;default:return`(?:${i}|${A}+${i}|${i}${A}+)*?`}}function a(M,$){if(!M)return[];const H=[];let X=!1,ae=!1,we="";for(const Le of M){switch(Le){case $:if(!X&&!ae){H.push(we),we="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}we+=Le}return we&&H.push(we),H}e.splitGlobAware=a;function w(M){if(!M)return"";let $="";const H=a(M,I);if(H.every(X=>X===D))$=".*";else{let X=!1;H.forEach((ae,we)=>{if(ae===D){X||($+=p(2),X=!0);return}let Le=!1,Ie="",Me=!1,We="";for(const j of ae){if(j!=="}"&&Le){Ie+=j;continue}if(Me&&(j!=="]"||!We)){let Y;j==="-"?Y=j:(j==="^"||j==="!")&&!We?Y="^":j===I?Y="":Y=v.escapeRegExpCharacters(j),We+=Y;continue}switch(j){case"{":Le=!0;continue;case"[":Me=!0;continue;case"}":$+=`(?:${a(Ie,",").map(oe=>w(oe)).join("|")})`,Le=!1,Ie="";break;case"]":$+="["+We+"]",Me=!1,We="";break;case"?":$+=A;continue;case"*":$+=p(1);continue;default:$+=v.escapeRegExpCharacters(j)}}we<H.length-1&&(H[we+1]!==D||we+2<H.length)&&($+=i),X=!1})}return $}const m=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),n=function(){return!1},s=function(){return null};function r(M,$){if(!M)return s;let H;typeof M!="string"?H=M.pattern:H=M,H=H.trim();const X=`${H}_${!!$.trimForExclusions}`;let ae=t.get(X);if(ae)return o(ae,M);let we;if(m.test(H)){const Le=H.substr(4);ae=function(Ie,Me){return typeof Ie=="string"&&Ie.endsWith(Le)?H:null}}else(we=b.exec(g(H,$)))?ae=f(we[1],H):($.trimForExclusions?u:_).test(H)?ae=S(H,$):(we=c.exec(g(H,$)))?ae=E(we[1].substr(1),H,!0):(we=d.exec(g(H,$)))?ae=E(we[1],H,!1):ae=l(H);return t.set(X,ae),o(ae,M)}function o(M,$){return typeof $=="string"?M:function(H,X){return R.isEqualOrParent(H,$.base)?M(C.relative($.base,H),X):null}}function g(M,$){return $.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function f(M,$){const H=`/${M}`,X=`\\${M}`,ae=function(Le,Ie){return typeof Le!="string"?null:Ie?Ie===M?$:null:Le===M||Le.endsWith(H)||Le.endsWith(X)?$:null},we=[M];return ae.basenames=we,ae.patterns=[$],ae.allBasenames=we,ae}function S(M,$){const H=F(M.slice(1,-1).split(",").map(Ie=>r(Ie,$)).filter(Ie=>Ie!==s),M),X=H.length;if(!X)return s;if(X===1)return H[0];const ae=function(Ie,Me){for(let We=0,j=H.length;We<j;We++)if(H[We](Ie,Me))return M;return null},we=H.find(Ie=>!!Ie.allBasenames);we&&(ae.allBasenames=we.allBasenames);const Le=H.reduce((Ie,Me)=>Me.allPaths?Ie.concat(Me.allPaths):Ie,[]);return Le.length&&(ae.allPaths=Le),ae}function E(M,$,H){const X=C.sep===C.posix.sep,ae=X?M:M.replace(h,C.sep),we=C.sep+ae,Le=C.posix.sep+M,Ie=H?function(Me,We){return typeof Me=="string"&&(Me===ae||Me.endsWith(we)||!X&&(Me===M||Me.endsWith(Le)))?$:null}:function(Me,We){return typeof Me=="string"&&(Me===ae||!X&&Me===M)?$:null};return Ie.allPaths=[(H?"*/":"./")+M],Ie}function l(M){try{const $=new RegExp(`^${w(M)}$`);return function(H){return $.lastIndex=0,typeof H=="string"&&$.test(H)?M:null}}catch($){return s}}function L(M,$,H){return!M||typeof $!="string"?!1:O(M)($,void 0,H)}e.match=L;function O(M,$={}){if(!M)return n;if(typeof M=="string"||N(M)){const H=r(M,$);if(H===s)return n;const X=function(ae,we){return!!H(ae,we)};return H.allBasenames&&(X.allBasenames=H.allBasenames),H.allPaths&&(X.allPaths=H.allPaths),X}return k(M,$)}e.parse=O;function W(M){if(!M)return;let $;return H=>($||($=(M()||Promise.resolve([])).then(X=>X?se(X):{})),$.then(X=>!!X[H]))}e.hasSiblingPromiseFn=W;function te(M){if(!M)return;let $;return H=>{if(!$){const X=M();$=X?se(X):{}}return!!$[H]}}e.hasSiblingFn=te;function se(M){const $={};for(const H of M)$[H]=!0;return $}function N(M){const $=M;return $&&typeof $.base=="string"&&typeof $.pattern=="string"}e.isRelativePattern=N;function V(M){return M.allBasenames||[]}e.getBasenameTerms=V;function x(M){return M.allPaths||[]}e.getPathTerms=x;function k(M,$){const H=F(Object.getOwnPropertyNames(M).map(Ie=>U(Ie,M[Ie],$)).filter(Ie=>Ie!==s)),X=H.length;if(!X)return s;if(!H.some(Ie=>!!Ie.requiresSiblings)){if(X===1)return H[0];const Ie=function(j,Y){for(let ee=0,oe=H.length;ee<oe;ee++){const pe=H[ee](j,Y);if(pe)return pe}return null},Me=H.find(j=>!!j.allBasenames);Me&&(Ie.allBasenames=Me.allBasenames);const We=H.reduce((j,Y)=>Y.allPaths?j.concat(Y.allPaths):j,[]);return We.length&&(Ie.allPaths=We),Ie}const ae=function(Ie,Me,We){let j;for(let Y=0,ee=H.length;Y<ee;Y++){const oe=H[Y];oe.requiresSiblings&&We&&(Me||(Me=C.basename(Ie)),j||(j=Me.substr(0,Me.length-C.extname(Ie).length)));const pe=oe(Ie,Me,j,We);if(pe)return pe}return null},we=H.find(Ie=>!!Ie.allBasenames);we&&(ae.allBasenames=we.allBasenames);const Le=H.reduce((Ie,Me)=>Me.allPaths?Ie.concat(Me.allPaths):Ie,[]);return Le.length&&(ae.allPaths=Le),ae}function U(M,$,H){if($===!1)return s;const X=r(M,H);if(X===s)return s;if(typeof $=="boolean")return X;if($){const ae=$.when;if(typeof ae=="string"){const we=(Le,Ie,Me,We)=>{if(!We||!X(Le,Ie))return null;const j=ae.replace("$(basename)",Me),Y=We(j);return(0,y.isThenable)(Y)?Y.then(ee=>ee?M:null):Y?M:null};return we.requiresSiblings=!0,we}}return X}function F(M,$){const H=M.filter(Ie=>!!Ie.basenames);if(H.length<2)return M;const X=H.reduce((Ie,Me)=>{const We=Me.basenames;return We?Ie.concat(We):Ie},[]);let ae;if($){ae=[];for(let Ie=0,Me=X.length;Ie<Me;Ie++)ae.push($)}else ae=H.reduce((Ie,Me)=>{const We=Me.patterns;return We?Ie.concat(We):Ie},[]);const we=function(Ie,Me){if(typeof Ie!="string")return null;if(!Me){let j;for(j=Ie.length;j>0;j--){const Y=Ie.charCodeAt(j-1);if(Y===47||Y===92)break}Me=Ie.substr(j)}const We=X.indexOf(Me);return We!==-1?ae[We]:null};we.basenames=X,we.patterns=ae,we.allBasenames=X;const Le=M.filter(Ie=>!Ie.basenames);return Le.push(we),Le}}),define(me[77],ge([0,1,2,9,8,10,11,25,29]),function(K,e,v,R,C,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function I(r,o,g){if(typeof r=="string"&&(r=v.URI.file(r)),g){const S=g.getWorkspaceFolder(r);if(S){const E=g.getWorkspace().folders.length>1;let l;if((0,P.isEqual)(S.uri,r)?l="":l=(0,P.relativePath)(S.uri,r),E){const L=S.name?S.name:(0,P.basename)(S.uri);l=l?L+" \u2022 "+l:L}return l}}if(r.scheme!==T.Schemas.file&&r.scheme!==T.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(r.fsPath))return(0,R.normalize)(A(r.fsPath));let f=(0,R.normalize)(r.fsPath);return!y.isWindows&&(o==null?void 0:o.userHome)&&(f=p(f,o.userHome.fsPath)),f}e.getPathLabel=I;function i(r){if(!r)return;typeof r=="string"&&(r=v.URI.file(r));const o=(0,P.basename)(r)||(r.scheme===T.Schemas.file?r.fsPath:r.path);return y.isWindows&&(0,D.isRootOrDriveLetter)(o)?A(o):o}e.getBaseLabel=i;function A(r){return(0,D.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=A;let h=Object.create(null);function p(r,o){if(y.isWindows||!r||!o)return r;let g=h.original===o?h.normalized:void 0;return g||(g=`${(0,C.rtrim)(o,R.posix.sep)}${R.posix.sep}`,h={original:o,normalized:g}),(y.isLinux?r.startsWith(g):(0,C.startsWithIgnoreCase)(r,g))&&(r=`~/${r.substr(g.length)}`),r}e.tildify=p;function a(r,o){return r.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=a;const w="\u2026",m="\\\\",b="~";function _(r,o=R.sep){const g=new Array(r.length);let f=!1;for(let S=0;S<r.length;S++){let E=r[S];if(E===""){g[S]=`.${o}`;continue}if(!E){g[S]=E;continue}f=!0;let l="";E.indexOf(m)===0?(l=E.substr(0,E.indexOf(m)+m.length),E=E.substr(E.indexOf(m)+m.length)):E.indexOf(o)===0?(l=E.substr(0,E.indexOf(o)+o.length),E=E.substr(E.indexOf(o)+o.length)):E.indexOf(b)===0&&(l=E.substr(0,E.indexOf(b)+b.length),E=E.substr(E.indexOf(b)+b.length));const L=E.split(o);for(let O=1;f&&O<=L.length;O++)for(let W=L.length-O;f&&W>=0;W--){f=!1;let te=L.slice(W,W+O).join(o);for(let se=0;!f&&se<r.length;se++)if(se!==S&&r[se]&&r[se].indexOf(te)>-1){const N=W+O===L.length,V=W>0&&r[se].indexOf(o)>-1?o+te:te,x=r[se].endsWith(V);f=!N||x}if(!f){let se="";(L[0].endsWith(":")||l!=="")&&(W===1&&(W=0,O++,te=L[0]+o+te),W>0&&(se=L[0]+o),se=l+se),W>0&&(se=se+w+o),se=se+te,W+O<L.length&&(se=se+o+w),g[S]=se}}f&&(g[S]=E)}return g}e.shorten=_;var u;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function c(r,o=Object.create(null)){const g=[];let f=!1,S="";for(const E of r)if(E==="$"||f&&E==="{")S&&g.push({value:S,type:u.TEXT}),S="",f=!0;else if(E==="}"&&f){const l=o[S];if(typeof l=="string")l.length&&g.push({value:l,type:u.VARIABLE});else if(l){const L=g[g.length-1];(!L||L.type!==u.SEPARATOR)&&g.push({value:l.label,type:u.SEPARATOR})}S="",f=!1}else S+=E;return S&&!f&&g.push({value:S,type:u.TEXT}),g.filter((E,l)=>{if(E.type===u.SEPARATOR){const L=g[l-1],O=g[l+1];return[L,O].every(W=>W&&(W.type===u.VARIABLE||W.type===u.TEXT)&&W.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=c;function d(r,o){return y.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):r.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=d;function t(r,o){return y.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,""):y.isWindows?r.replace(/&&|&/g,g=>g==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(r){const o=r.indexOf("/")!==-1?R.posix:R.win32,g=o.basename(r),f=o.dirname(r);return g.length?{name:g,parentPath:f}:{name:f,parentPath:""}}e.splitName=s}),define(me[99],ge([0,1,2]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(i){return i.toJSON()}class C{constructor(A){this._uriTransformer=A}transformIncoming(A){const h=this._uriTransformer.transformIncoming(A);return h===A?A:R(v.URI.from(h))}transformOutgoing(A){const h=this._uriTransformer.transformOutgoing(A);return h===A?A:R(v.URI.from(h))}transformOutgoingURI(A){const h=this._uriTransformer.transformOutgoing(A);return h===A?A:v.URI.from(h)}transformOutgoingScheme(A){return this._uriTransformer.transformOutgoingScheme(A)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function T(i,A,h){if(!i||h>200)return null;if(typeof i=="object"){if(i instanceof v.URI)return A.transformOutgoing(i);for(let p in i)if(Object.hasOwnProperty.call(i,p)){const a=T(i[p],A,h+1);a!==null&&(i[p]=a)}}return null}function y(i,A){const h=T(i,A,0);return h===null?i:h}e.transformOutgoingURIs=y;function P(i,A,h,p){if(!i||p>200)return null;if(typeof i=="object"){if(i.$mid===1)return h?v.URI.revive(A.transformIncoming(i)):A.transformIncoming(i);for(let a in i)if(Object.hasOwnProperty.call(i,a)){const w=P(i[a],A,h,p+1);w!==null&&(i[a]=w)}}return null}function D(i,A){const h=P(i,A,!1,0);return h===null?i:h}e.transformIncomingURIs=D;function I(i,A){const h=P(i,A,!0,0);return h===null?i:h}e.transformAndReviveIncomingURIs=I}),define(me[32],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(D){return v.test(D)}e.isUUID=R;const C=new Uint8Array(16),T=[];for(let D=0;D<256;D++)T.push(D.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let I=0;I<D.length;I++)D[I]=Math.floor(Math.random()*256);return D};function P(){y(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let D=0,I="";return I+=T[C[D++]],I+=T[C[D++]],I+=T[C[D++]],I+=T[C[D++]],I+="-",I+=T[C[D++]],I+=T[C[D++]],I+="-",I+=T[C[D++]],I+=T[C[D++]],I+="-",I+=T[C[D++]],I+=T[C[D++]],I+="-",I+=T[C[D++]],I+=T[C[D++]],I+=T[C[D++]],I+=T[C[D++]],I+=T[C[D++]],I+=T[C[D++]],I}e.generateUuid=P}),define(me[138],ge([0,1,100]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(T="utf8"){this.stringDecoder=new v.StringDecoder(T),this.remaining=null}write(T){const y=[],P=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(P.length<1)return y;let D=0,I,i=D;for(;i<P.length;)if(I=P.charCodeAt(i),I===13||I===10){if(y.push(P.substring(D,i)),i++,i<P.length){const A=I;I=P.charCodeAt(i),(A===13&&I===10||A===10&&I===13)&&i++}D=i}else i++;return this.remaining=D<P.length?P.substr(D):null,y}end(){return this.remaining}}e.LineDecoder=R}),define(me[28],ge([0,1,59,101,280,9,13,11,29,32,76,25,2]),function(K,e,v,R,C,T,y,P,D,I,i,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var p;(function(k){k[k.UNLINK=0]="UNLINK",k[k.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function a(k,U=p.UNLINK){if((0,D.isRootOrDriveLetter)(k))throw new Error("rimraf - will refuse to recursively delete root");return U===p.UNLINK?m(k):w(k)}e.rimraf=a;async function w(k){try{const U=(0,T.join)((0,R.tmpdir)(),(0,I.generateUuid)());try{await x.rename(k,U)}catch(F){return m(k)}m(U).catch(F=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function m(k){return x.rmdir(k,{recursive:!0,maxRetries:3})}function b(k){if((0,D.isRootOrDriveLetter)(k))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(k,{recursive:!0})}e.rimrafSync=b;async function _(k,U){return d(await(U?u(k):x.readdir(k)))}e.readdir=_;async function u(k){try{return await x.readdir(k,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const U=[],F=await _(k);for(const M of F){let $=!1,H=!1,X=!1;try{const ae=await x.lstat((0,T.join)(k,M));$=ae.isFile(),H=ae.isDirectory(),X=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}U.push({name:M,isFile:()=>$,isDirectory:()=>H,isSymbolicLink:()=>X})}return U}function c(k){return d(v.readdirSync(k))}e.readdirSync=c;function d(k){return k.map(U=>typeof U=="string"?P.isMacintosh?(0,i.normalizeNFC)(U):U:(U.name=P.isMacintosh?(0,i.normalizeNFC)(U.name):U.name,U))}async function t(k){const U=await _(k),F=[];for(const M of U)await s.existsDirectory((0,T.join)(k,M))&&F.push(M);return F}e.readDirsInDir=t;function n(k,U=1e3){return new Promise(F=>{let M=!1;const $=setInterval(()=>{M||(M=!0,v.access(k,H=>{M=!1,H&&(clearInterval($),F(void 0))}))},U)})}e.whenDeleted=n;var s;(function(k){async function U($){let H;try{if(H=await x.lstat($),!H.isSymbolicLink())return{stat:H}}catch(X){}try{return{stat:await x.stat($),symbolicLink:(H==null?void 0:H.isSymbolicLink())?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(P.isWindows&&X.code==="EACCES")try{return{stat:await x.stat(await x.readlink($)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw ae}throw X}}k.stat=U;async function F($){try{const{stat:H,symbolicLink:X}=await k.stat($);return H.isFile()&&(X==null?void 0:X.dangling)!==!0}catch(H){}return!1}k.existsFile=F;async function M($){try{const{stat:H,symbolicLink:X}=await k.stat($);return H.isDirectory()&&(X==null?void 0:X.dangling)!==!0}catch(H){}return!1}k.existsDirectory=M})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new y.ResourceQueue;function o(k,U,F){return r.queueFor(h.URI.file(k),A.extUriBiasedIgnorePathCase).queue(()=>{const M=E(F);return new Promise(($,H)=>f(k,U,M,X=>X?H(X):$()))})}e.writeFile=o;let g=!0;function f(k,U,F,M){if(!g)return v.writeFile(k,U,{mode:F.mode,flag:F.flag},M);v.open(k,F.flag,F.mode,($,H)=>{if($)return M($);v.writeFile(H,U,X=>{if(X)return v.close(H,()=>M(X));v.fdatasync(H,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),g=!1),v.close(H,we=>M(we))))})})}function S(k,U,F){const M=E(F);if(!g)return v.writeFileSync(k,U,{mode:M.mode,flag:M.flag});const $=v.openSync(k,M.flag,M.mode);try{v.writeFileSync($,U);try{v.fdatasyncSync($)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),g=!1}}finally{v.closeSync($)}}e.writeFileSync=S;function E(k){return k?{mode:typeof k.mode=="number"?k.mode:438,flag:typeof k.flag=="string"?k.flag:"w"}:{mode:438,flag:"w"}}async function l(k,U){if(k===U)return;async function F(M){try{const $=await x.lstat(M);if($.isDirectory()||$.isSymbolicLink())return;await x.utimes(M,$.atime,new Date)}catch($){}}try{await x.rename(k,U),await F(U)}catch(M){if(k.toLowerCase()!==U.toLowerCase()&&M.code==="EXDEV"||k.endsWith("."))await L(k,U,{preserveSymlinks:!1}),await a(k,p.MOVE),await F(U);else throw M}}e.move=l;async function L(k,U,F){return W(k,U,{root:{source:k,target:U},options:F,handledSourcePaths:new Set})}e.copy=L;const O=511;async function W(k,U,F){if(F.handledSourcePaths.has(k))return;F.handledSourcePaths.add(k);const{stat:M,symbolicLink:$}=await s.stat(k);if($){if(F.options.preserveSymlinks)try{return await N(k,U,F)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if($.dangling)return}return M.isDirectory()?te(k,U,M.mode&O,F):se(k,U,M.mode&O)}async function te(k,U,F,M){await x.mkdir(U,{recursive:!0,mode:F});const $=await _(k);for(const H of $)await W((0,T.join)(k,H),(0,T.join)(U,H),M)}async function se(k,U,F){await x.copyFile(k,U),await x.chmod(U,F)}async function N(k,U,F){let M=await x.readlink(k);(0,D.isEqualOrParent)(M,F.root.source,!P.isLinux)&&(M=(0,T.join)(F.root.target,M.substr(F.root.source.length+1))),await x.symlink(M,U)}async function V(k){try{return await x.access(k),!0}catch(U){return!1}}e.exists=V;var x;(function(k){k.access=(0,C.promisify)(v.access),k.stat=(0,C.promisify)(v.stat),k.lstat=(0,C.promisify)(v.lstat),k.utimes=(0,C.promisify)(v.utimes),k.read=(0,C.promisify)(v.read),k.readFile=(0,C.promisify)(v.readFile),k.write=(0,C.promisify)(v.write),k.writeFile=(0,C.promisify)(v.writeFile),k.appendFile=(0,C.promisify)(v.appendFile),k.fdatasync=(0,C.promisify)(v.fdatasync),k.truncate=(0,C.promisify)(v.truncate),k.rename=(0,C.promisify)(v.rename),k.copyFile=(0,C.promisify)(v.copyFile),k.open=(0,C.promisify)(v.open),k.close=(0,C.promisify)(v.close),k.symlink=(0,C.promisify)(v.symlink),k.readlink=(0,C.promisify)(v.readlink),k.chmod=(0,C.promisify)(v.chmod),k.readdir=(0,C.promisify)(v.readdir),k.mkdir=(0,C.promisify)(v.mkdir),k.unlink=(0,C.promisify)(v.unlink),k.rmdir=(0,C.promisify)(v.rmdir),k.realpath=(0,C.promisify)(v.realpath)})(x=e.Promises||(e.Promises={}))}),define(me[102],ge([0,1,59,8,9,28]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function y(i){const A=(0,C.dirname)(i);if(i===A)return i;const h=((0,C.basename)(i)||i).toLowerCase();try{const a=(0,T.readdirSync)(A).filter(w=>w.toLowerCase()===h);if(a.length===1){const w=y(A);if(w)return(0,C.join)(w,a[0])}else if(a.length>1){const w=a.indexOf(h);if(w>=0){const m=y(A);if(m)return(0,C.join)(m,a[w])}}}catch(p){}return null}e.realcaseSync=y;async function P(i){try{return await T.Promises.realpath(i)}catch(A){const h=I(i);return await T.Promises.access(h,v.constants.R_OK),h}}e.realpath=P;function D(i){try{return v.realpathSync(i)}catch(A){const h=I(i);return v.accessSync(h,v.constants.R_OK),h}}e.realpathSync=D;function I(i){return(0,R.rtrim)((0,C.normalize)(i),C.sep)}});var qe=this&&this.__decorate||function(K,e,v,R){var C=arguments.length,T=C<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(K,e,v,R);else for(var P=K.length-1;P>=0;P--)(y=K[P])&&(T=(C<3?y(T):C>3?y(e,v,T):y(e,v))||T);return C>3&&T&&Object.defineProperty(e,v,T),T};define(me[103],ge([0,1,3,6,13,21,17,22,16,12,58,8,53]),function(K,e,v,R,C,T,y,P,D,I,i,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function a(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function m(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(b||(b={}));class _{constructor(M){this.buffer=M,this.pos=0}read(M){const $=this.buffer.slice(this.pos,this.pos+M);return this.pos+=$.byteLength,$}}class u{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var c;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(c||(c={}));function d(F){const M=P.VSBuffer.alloc(4);return M.writeUInt32BE(F,0),M}function t(F){return F.read(4).readUInt32BE(0)}function n(F){const M=P.VSBuffer.alloc(1);return M.writeUInt8(F,0),M}const s={Undefined:n(c.Undefined),String:n(c.String),Buffer:n(c.Buffer),VSBuffer:n(c.VSBuffer),Array:n(c.Array),Object:n(c.Object)},r=typeof Buffer!="undefined";function o(F,M){if(typeof M=="undefined")F.write(s.Undefined);else if(typeof M=="string"){const $=P.VSBuffer.fromString(M);F.write(s.String),F.write(d($.byteLength)),F.write($)}else if(r&&Buffer.isBuffer(M)){const $=P.VSBuffer.wrap(M);F.write(s.Buffer),F.write(d($.byteLength)),F.write($)}else if(M instanceof P.VSBuffer)F.write(s.VSBuffer),F.write(d(M.byteLength)),F.write(M);else if(Array.isArray(M)){F.write(s.Array),F.write(d(M.length));for(const $ of M)o(F,$)}else{const $=P.VSBuffer.fromString(JSON.stringify(M));F.write(s.Object),F.write(d($.byteLength)),F.write($)}}function g(F){switch(F.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return F.read(t(F)).toString();case c.Buffer:return F.read(t(F)).buffer;case c.VSBuffer:return F.read(t(F));case c.Array:{const $=t(F),H=[];for(let X=0;X<$;X++)H.push(g(F));return H}case c.Object:return JSON.parse(F.read(t(F)).toString())}}class f{constructor(M,$,H=null,X=1e3){this.protocol=M,this.ctx=$,this.logger=H,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ae=>this.onRawMessage(ae)),this.sendResponse({type:200})}registerChannel(M,$){this.channels.set(M,$),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const $=this.send([M.type]);this.logger&&this.logger.logOutgoing($,0,1,m(M.type));return}case 201:case 202:case 204:case 203:{const $=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing($,M.id,1,m(M.type),M.data);return}}}send(M,$=void 0){const H=new u;return o(H,M),o(H,$),this.sendBuffer(H.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch($){return 0}}onRawMessage(M){const $=new _(M),H=g($),X=g($),ae=H[0];switch(ae){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,H[1],1,`${a(ae)}: ${H[2]}.${H[3]}`,X),this.onPromise({type:ae,id:H[1],channelName:H[2],name:H[3],arg:X});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,H[1],1,`${a(ae)}: ${H[2]}.${H[3]}`,X),this.onEventListen({type:ae,id:H[1],channelName:H[2],name:H[3],arg:X});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,H[1],1,`${a(ae)}`),this.disposeActiveRequest({type:ae,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,H[1],1,`${a(ae)}`),this.disposeActiveRequest({type:ae,id:H[1]})}}onPromise(M){const $=this.channels.get(M.channelName);if(!$){this.collectPendingRequest(M);return}const H=new T.CancellationTokenSource;let X;try{X=$.call(this.ctx,M.name,M.arg,H.token)}catch(Le){X=Promise.reject(Le)}const ae=M.id;X.then(Le=>{this.sendResponse({id:ae,data:Le,type:201}),this.activeRequests.delete(M.id)},Le=>{Le instanceof Error?this.sendResponse({id:ae,data:{message:Le.message,name:Le.name,stack:Le.stack?Le.stack.split?Le.stack.split(`
`):Le.stack:void 0},type:202}):this.sendResponse({id:ae,data:Le,type:203}),this.activeRequests.delete(M.id)});const we=(0,R.toDisposable)(()=>H.cancel());this.activeRequests.set(M.id,we)}onEventListen(M){const $=this.channels.get(M.channelName);if(!$){this.collectPendingRequest(M);return}const H=M.id,ae=$.listen(this.ctx,M.name,M.arg)(we=>this.sendResponse({id:H,data:we,type:204}));this.activeRequests.set(M.id,ae)}disposeActiveRequest(M){const $=this.activeRequests.get(M.id);$&&($.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let $=this.pendingRequests.get(M.channelName);$||($=[],this.pendingRequests.set(M.channelName,$));const H=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);$.push({request:M,timeoutTimer:H})}flushPendingRequests(M){const $=this.pendingRequests.get(M);if($){for(const H of $)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var S;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(M,$=null){this.protocol=M,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=$}getChannel(M){const $=this;return{call(H,X,ae){return $.isDisposed?Promise.reject(y.canceled()):$.requestPromise(M,H,X,ae)},listen(H,X){return $.isDisposed?Promise.reject(y.canceled()):$.requestEvent(M,H,X)}}}requestPromise(M,$,H,X=T.CancellationToken.None){const ae=this.lastRequestId++,Le={id:ae,type:100,channelName:M,name:$,arg:H};if(X.isCancellationRequested)return Promise.reject(y.canceled());let Ie;return new Promise((We,j)=>{if(X.isCancellationRequested)return j(y.canceled());const Y=()=>{const _e=de=>{switch(de.type){case 201:this.handlers.delete(ae),We(de.data);break;case 202:this.handlers.delete(ae);const Ee=new Error(de.data.message);Ee.stack=de.data.stack,Ee.name=de.data.name,j(Ee);break;case 203:this.handlers.delete(ae),j(de.data);break}};this.handlers.set(ae,_e),this.sendRequest(Le)};let ee=null;this.state===b.Idle?Y():(ee=(0,C.createCancelablePromise)(_e=>this.whenInitialized()),ee.then(()=>{ee=null,Y()}));const oe=()=>{ee?(ee.cancel(),ee=null):this.sendRequest({id:ae,type:101}),j(y.canceled())},pe=X.onCancellationRequested(oe);Ie=(0,R.combinedDisposable)((0,R.toDisposable)(oe),pe),this.activeRequests.add(Ie)}).finally(()=>{this.activeRequests.delete(Ie)})}requestEvent(M,$,H){const X=this.lastRequestId++,we={id:X,type:102,channelName:M,name:$,arg:H};let Le=null;const Ie=new v.Emitter({onFirstListenerAdd:()=>{Le=(0,C.createCancelablePromise)(We=>this.whenInitialized()),Le.then(()=>{Le=null,this.activeRequests.add(Ie),this.sendRequest(we)})},onLastListenerRemove:()=>{Le?(Le.cancel(),Le=null):(this.activeRequests.delete(Ie),this.sendRequest({id:X,type:103}))}}),Me=We=>Ie.fire(We.data);return this.handlers.set(X,Me),Ie.event}sendRequest(M){switch(M.type){case 100:case 102:{const $=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing($,M.id,0,`${a(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const $=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing($,M.id,0,a(M.type));return}}}send(M,$=void 0){const H=new u;return o(H,M),o(H,$),this.sendBuffer(H.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch($){return 0}}onBuffer(M){const $=new _(M),H=g($),X=g($),ae=H[0];switch(ae){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,m(ae)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,H[1],0,m(ae),X),this.onResponse({type:H[0],id:H[1],data:X})}}onResponse(M){if(M.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const $=this.handlers.get(M.id);$&&$(M)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}qe([h.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class l{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:$,onDidClientDisconnect:H})=>{v.Event.once($.onMessage)(ae=>{const we=new _(ae),Le=g(we),Ie=new f($,Le),Me=new E($);this.channels.forEach((j,Y)=>Ie.registerChannel(Y,j));const We={channelServer:Ie,channelClient:Me,ctx:Le};this._connections.add(We),this._onDidAddConnection.fire(We),H(()=>{Ie.dispose(),Me.dispose(),this._connections.delete(We),this._onDidRemoveConnection.fire(We)})})})}get connections(){const M=[];return this._connections.forEach($=>M.push($)),M}getChannel(M,$){const H=this;return{call(X,ae,we){let Le;if((0,I.isFunction)($)){let Me=(0,D.getRandomElement)(H.connections.filter($));Le=Me?Promise.resolve(Me):v.Event.toPromise(v.Event.filter(H.onDidAddConnection,$))}else Le=$.routeCall(H,X,ae);const Ie=Le.then(Me=>Me.channelClient.getChannel(M));return O(Ie).call(X,ae,we)},listen(X,ae){if((0,I.isFunction)($))return H.getMulticastEvent(M,$,X,ae);const we=$.routeEvent(H,X,ae).then(Le=>Le.channelClient.getChannel(M));return O(we).listen(X,ae)}}}getMulticastEvent(M,$,H,X){const ae=this;let we=new R.DisposableStore;const Le=new v.Emitter({onFirstListenerAdd:()=>{we=new R.DisposableStore;const Ie=new v.EventMultiplexer,Me=new Map,We=Y=>{const oe=Y.channelClient.getChannel(M).listen(H,X),pe=Ie.add(oe);Me.set(Y,pe)},j=Y=>{const ee=Me.get(Y);!ee||(ee.dispose(),Me.delete(Y))};ae.connections.filter($).forEach(We),v.Event.filter(ae.onDidAddConnection,$)(We,void 0,we),ae.onDidRemoveConnection(j,void 0,we),Ie.event(Le.fire,Le,we),we.add(Ie)},onLastListenerRemove:()=>{we.dispose()}});return Le.event}registerChannel(M,$){this.channels.set(M,$),this._connections.forEach(H=>{H.channelServer.registerChannel(M,$)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=l;class L{constructor(M,$,H=null){const X=new u;o(X,$),M.send(X.buffer),this.channelClient=new E(M,H),this.channelServer=new f(M,$,H)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,$){this.channelServer.registerChannel(M,$)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function O(F){return{call(M,$,H){return F.then(X=>X.call(M,$,H))},listen(M,$){const H=new v.Relay;return F.then(X=>H.input=X.listen(M,$)),H.event}}}e.getDelayedChannel=O;function W(F){let M=!1;return{call($,H,X){return M?F.call($,H,X):(0,C.timeout)(0).then(()=>M=!0).then(()=>F.call($,H,X))},listen($,H){if(M)return F.listen($,H);const X=new v.Relay;return(0,C.timeout)(0).then(()=>M=!0).then(()=>X.input=F.listen($,H)),X.event}}}e.getNextTickChannel=W;class te{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const $ of M.connections)if(await Promise.resolve(this.fn($.ctx)))return Promise.resolve($);return await v.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=te;var se;(function(F){function M(X,ae){const we=X,Le=ae&&ae.disableMarshalling,Ie=new Map;for(const Me in we)H(Me)&&Ie.set(Me,v.Event.buffer(we[Me],!0));return new class{listen(Me,We){const j=Ie.get(We);if(j)return j;throw new Error(`Event not found: ${We}`)}call(Me,We,j){const Y=we[We];if(typeof Y=="function"){if(!Le&&Array.isArray(j))for(let ee=0;ee<j.length;ee++)j[ee]=(0,i.revive)(j[ee]);return Y.apply(we,j)}throw new Error(`Method not found: ${We}`)}}}F.fromService=M;function $(X,ae){const we=ae&&ae.disableMarshalling;return new Proxy({},{get(Le,Ie){var Me;if(typeof Ie=="string")return((Me=ae==null?void 0:ae.properties)===null||Me===void 0?void 0:Me.has(Ie))?ae.properties.get(Ie):H(Ie)?X.listen(Ie):async function(...We){let j;ae&&!(0,I.isUndefinedOrNull)(ae.context)?j=[ae.context,...We]:j=We;const Y=await X.call(Ie,j);return we?Y:(0,i.revive)(Y)};throw new Error(`Property not found: ${String(Ie)}`)}})}F.toService=$;function H(X){return X[0]==="o"&&X[1]==="n"&&A.isUpperAsciiLetter(X.charCodeAt(2))}})(se=e.ProxyChannel||(e.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let M=F.toString();if(M!=="[object Object]")return M}return F}function x(F){return Array.isArray(F)?F.map(V):V(F)}function k(F,M,$,H,X,ae,we){we=x(we);const Le=N[X],Ie=Le[H%Le.length];let Me=[`%c[${F}]%c[${String(M).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${Ie}`];/\($/.test(ae)?(Me=Me.concat(we),Me.push(")")):Me.push(we),console.log.apply(console,Me)}e.logWithColors=k;class U{constructor(M,$){this._outgoingPrefix=M,this._incomingPrefix=$,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,$,H,X,ae){this._totalOutgoing+=M,k(this._outgoingPrefix,this._totalOutgoing,M,$,H,X,ae)}logIncoming(M,$,H,X,ae){this._totalIncoming+=M,k(this._incomingPrefix,this._totalIncoming,M,$,H,X,ae)}}e.IPCLogger=U}),define(me[104],ge([0,1,3,103,6,22,11,36]),function(K,e,v,R,C,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function I(){return D||(D=T.VSBuffer.alloc(0)),D}class i{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,r){if(s===0)return I();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const S=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=s),S}if(this._chunks[0].byteLength>s){const S=this._chunks[0].slice(0,s);return r&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),S}let o=T.VSBuffer.alloc(s),g=0,f=0;for(;s>0;){const S=this._chunks[f];if(S.byteLength>s){const E=S.slice(0,s);o.set(E,g),g+=s,r&&(this._chunks[f]=S.slice(s),this._totalLength-=s),s-=s}else o.set(S,g),g+=S.byteLength,r?(this._chunks.shift(),this._totalLength-=S.byteLength):f++,s-=S.byteLength}return o}}e.ChunkStream=i;var A;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(A||(A={}));var h;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(s,r,o,g){this.type=s,this.id=r,this.ack=o,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class a extends C.Disposable{constructor(s){super();this._onMessage=this._register(new v.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new i,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const o=this._state.messageType,g=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new p(o,g,f,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class w{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=T.VSBuffer.alloc(13);r.writeUInt8(s.type,0),r.writeUInt32BE(s.id,1),r.writeUInt32BE(s.ack,5),r.writeUInt32BE(s.data.byteLength,9),this._writeSoon(r,s.data)}_bufferAdd(s,r){const o=this._totalLength===0;return this._data.push(s,r),this._totalLength+=s.byteLength+r.byteLength,o}_bufferTake(){const s=T.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,r){this._bufferAdd(s,r)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class m extends C.Disposable{constructor(s){super();this._onMessage=new v.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new v.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new w(this._socket)),this._socketReader=this._register(new a(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new p(1,0,0,s))}}e.Protocol=m;class b extends R.IPCClient{constructor(s,r,o=null){super(s,r,o);this.protocol=s}static fromSocket(s,r){return new b(new m(s),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=b;class _{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new v.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=_;class u{constructor(s){this.data=s,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],r=0,o=this._first;for(;o;)s[r++]=o.data,o=o.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const r=new u(s);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class d{constructor(){this.lastRuns=[];const s=Date.now();for(let r=0;r<d._HISTORY_LENGTH;r++)this.lastRuns[r]=s-1e3*r;setInterval(()=>{for(let r=d._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return d._INSTANCE||(d._INSTANCE=new d),d._INSTANCE}load(){const s=Date.now(),r=(1+d._HISTORY_LENGTH)*1e3;let o=0;for(let g=0;g<d._HISTORY_LENGTH;g++)s-this.lastRuns[g]<=r&&o++;return 1-o/d._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}d._HISTORY_LENGTH=10,d._INSTANCE=null;class t{constructor(s,r=null){this._loadEstimator=d.getInstance(),this._onControlMessage=new _,this.onControlMessage=this._onControlMessage.event,this._onMessage=new _,this.onMessage=this._onMessage.event,this._onDidDispose=new _,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new _,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new _,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new p(5,0,0,I());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const r=new p(4,0,0,I());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,r){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let r=0,o=s.length;r<o;r++)this._socketWriter.write(s[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new p(6,0,0,I())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const r=this._outgoingUnackMsg.toArray();for(let o=0,g=r.length;o<g;o++)this._socketWriter.write(r[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new p(1,r,this._incomingAckId,s);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(s){const r=new p(2,0,0,s);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const s=this._outgoingUnackMsg.peek(),r=Date.now()-s.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new p(3,0,this._incomingAckId,I());this._socketWriter.write(s)}}e.PersistentProtocol=t}),define(me[105],ge([0,1,94]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(P){let D=(0,v.toUint8)(P);this._defaultValue=D,this._asciiMap=R._createAsciiMap(D),this._map=new Map}static _createAsciiMap(P){let D=new Uint8Array(256);for(let I=0;I<256;I++)D[I]=P;return D}set(P,D){let I=(0,v.toUint8)(D);P>=0&&P<256?this._asciiMap[P]=I:this._map.set(P,I)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}}e.CharacterClassifier=R;var C;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(C||(C={}));class T{constructor(){this._actual=new R(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}}e.CharacterSet=T}),define(me[139],ge([0,1,105]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends v.CharacterClassifier{constructor(P){super(0);for(let D=0,I=P.length;D<I;D++)this.set(P.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function T(y){let P={};return D=>(P.hasOwnProperty(D)||(P[D]=y(D)),P[D])}e.getMapForWordSeparators=T(y=>new C(y))}),define(me[46],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class v{constructor(C,T){this.lineNumber=C,this.column=T}with(C=this.lineNumber,T=this.column){return C===this.lineNumber&&T===this.column?this:new v(C,T)}delta(C=0,T=0){return this.with(this.lineNumber+C,this.column+T)}equals(C){return v.equals(this,C)}static equals(C,T){return!C&&!T?!0:!!C&&!!T&&C.lineNumber===T.lineNumber&&C.column===T.column}isBefore(C){return v.isBefore(this,C)}static isBefore(C,T){return C.lineNumber<T.lineNumber?!0:T.lineNumber<C.lineNumber?!1:C.column<T.column}isBeforeOrEqual(C){return v.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,T){return C.lineNumber<T.lineNumber?!0:T.lineNumber<C.lineNumber?!1:C.column<=T.column}static compare(C,T){let y=C.lineNumber|0,P=T.lineNumber|0;if(y===P){let D=C.column|0,I=T.column|0;return D-I}return y-P}clone(){return new v(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new v(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=v}),define(me[42],ge([0,1,46]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(T,y,P,D){T>P||T===P&&y>D?(this.startLineNumber=P,this.startColumn=D,this.endLineNumber=T,this.endColumn=y):(this.startLineNumber=T,this.startColumn=y,this.endLineNumber=P,this.endColumn=D)}isEmpty(){return R.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return R.containsPosition(this,T)}static containsPosition(T,y){return!(y.lineNumber<T.startLineNumber||y.lineNumber>T.endLineNumber||y.lineNumber===T.startLineNumber&&y.column<T.startColumn||y.lineNumber===T.endLineNumber&&y.column>T.endColumn)}containsRange(T){return R.containsRange(this,T)}static containsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>T.endColumn)}strictContainsRange(T){return R.strictContainsRange(this,T)}static strictContainsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<=T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>=T.endColumn)}plusRange(T){return R.plusRange(this,T)}static plusRange(T,y){let P,D,I,i;return y.startLineNumber<T.startLineNumber?(P=y.startLineNumber,D=y.startColumn):y.startLineNumber===T.startLineNumber?(P=y.startLineNumber,D=Math.min(y.startColumn,T.startColumn)):(P=T.startLineNumber,D=T.startColumn),y.endLineNumber>T.endLineNumber?(I=y.endLineNumber,i=y.endColumn):y.endLineNumber===T.endLineNumber?(I=y.endLineNumber,i=Math.max(y.endColumn,T.endColumn)):(I=T.endLineNumber,i=T.endColumn),new R(P,D,I,i)}intersectRanges(T){return R.intersectRanges(this,T)}static intersectRanges(T,y){let P=T.startLineNumber,D=T.startColumn,I=T.endLineNumber,i=T.endColumn,A=y.startLineNumber,h=y.startColumn,p=y.endLineNumber,a=y.endColumn;return P<A?(P=A,D=h):P===A&&(D=Math.max(D,h)),I>p?(I=p,i=a):I===p&&(i=Math.min(i,a)),P>I||P===I&&D>i?null:new R(P,D,I,i)}equalsRange(T){return R.equalsRange(this,T)}static equalsRange(T,y){return!!T&&!!y&&T.startLineNumber===y.startLineNumber&&T.startColumn===y.startColumn&&T.endLineNumber===y.endLineNumber&&T.endColumn===y.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(T){return new v.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(T){return new v.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,y){return new R(this.startLineNumber,this.startColumn,T,y)}setStartPosition(T,y){return new R(T,y,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(T){return new R(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,y=T){return new R(T.lineNumber,T.column,y.lineNumber,y.column)}static lift(T){return T?new R(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<T.startColumn)}static areIntersecting(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<=y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,y){if(T&&y){const I=T.startLineNumber|0,i=y.startLineNumber|0;if(I===i){const A=T.startColumn|0,h=y.startColumn|0;if(A===h){const p=T.endLineNumber|0,a=y.endLineNumber|0;if(p===a){const w=T.endColumn|0,m=y.endColumn|0;return w-m}return p-a}return A-h}return I-i}return(T?1:0)-(y?1:0)}static compareRangesUsingEnds(T,y){return T.endLineNumber===y.endLineNumber?T.endColumn===y.endColumn?T.startLineNumber===y.startLineNumber?T.startColumn-y.startColumn:T.startLineNumber-y.startLineNumber:T.endColumn-y.endColumn:T.endLineNumber-y.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=R}),define(me[140],ge([0,1,46,42]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class T extends R.Range{constructor(P,D,I,i){super(P,D,I,i);this.selectionStartLineNumber=P,this.selectionStartColumn=D,this.positionLineNumber=I,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return T.selectionsEqual(this,P)}static selectionsEqual(P,D){return P.selectionStartLineNumber===D.selectionStartLineNumber&&P.selectionStartColumn===D.selectionStartColumn&&P.positionLineNumber===D.positionLineNumber&&P.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,D){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,P,D):new T(P,D,this.startLineNumber,this.startColumn)}getPosition(){return new v.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(P,D){return this.getDirection()===0?new T(P,D,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,P,D)}static fromPositions(P,D=P){return new T(P.lineNumber,P.column,D.lineNumber,D.column)}static liftSelection(P){return new T(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,D){if(P&&!D||!P&&D)return!1;if(!P&&!D)return!0;if(P.length!==D.length)return!1;for(let I=0,i=P.length;I<i;I++)if(!this.selectionsEqual(P[I],D[I]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,D,I,i,A){return A===0?new T(P,D,I,i):new T(I,i,P,D)}}e.Selection=T}),define(me[106],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var v;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(v=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(a){a[a.TextDefined=0]="TextDefined",a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(a){a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(a){a[a.LF=0]="LF",a[a.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(w){this.tabSize=Math.max(1,w.tabSize|0),this.indentSize=w.tabSize|0,this.insertSpaces=Boolean(w.insertSpaces),this.defaultEOL=w.defaultEOL|0,this.trimAutoWhitespace=Boolean(w.trimAutoWhitespace)}equals(w){return this.tabSize===w.tabSize&&this.indentSize===w.indentSize&&this.insertSpaces===w.insertSpaces&&this.defaultEOL===w.defaultEOL&&this.trimAutoWhitespace===w.trimAutoWhitespace}createChangeEvent(w){return{tabSize:this.tabSize!==w.tabSize,indentSize:this.indentSize!==w.indentSize,insertSpaces:this.insertSpaces!==w.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==w.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class D{constructor(w,m){this.range=w,this.matches=m}}e.FindMatch=D;var I;(function(a){a[a.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",a[a.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",a[a.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",a[a.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(I=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(a){a[a.Left=0]="Left",a[a.Right=1]="Right"})(i=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var A;(function(a){a[a.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(A=e.ModelConstants||(e.ModelConstants={}));class h{constructor(w,m,b,_,u,c){this.identifier=w,this.range=m,this.text=b,this.forceMoveMarkers=_,this.isAutoWhitespaceEdit=u,this._isTracked=c}}e.ValidAnnotatedEditOperation=h;class p{constructor(w,m,b){this.reverseEdits=w,this.changes=m,this.trimAutoWhitespaceLineNumbers=b}}e.ApplyEditsResult=p}),define(me[141],ge([0,1,8,139,46,42,106]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class D{constructor(u,c,d,t){this.searchString=u,this.isRegex=c,this.matchCase=d,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=I(this.searchString):u=this.searchString.indexOf(`
`)>=0;let c=null;try{c=v.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(t){return null}if(!c)return null;let d=!this.isRegex&&!u;return d&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(d=this.matchCase),new i(c,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,d?this.searchString:null)}}e.SearchParams=D;function I(_){if(!_||_.length===0)return!1;for(let u=0,c=_.length;u<c;u++)if(_.charCodeAt(u)===92){if(u++,u>=c)break;const t=_.charCodeAt(u);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=I;class i{constructor(u,c,d){this.regex=u,this.wordSeparators=c,this.simpleSearch=d}}e.SearchData=i;function A(_,u,c){if(!c)return new y.FindMatch(_,null);let d=[];for(let t=0,n=u.length;t<n;t++)d[t]=u[t];return new y.FindMatch(_,d)}e.createFindMatch=A;class h{constructor(u){let c=[],d=0;for(let t=0,n=u.length;t<n;t++)u.charCodeAt(t)===10&&(c[d++]=t);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(u){const c=this._lineFeedsOffsets;let d=0,t=c.length-1;if(t===-1||u<=c[0])return 0;for(;d<t;){const n=d+((t-d)/2>>0);c[n]>=u?t=n-1:c[n+1]>=u?(d=n,t=n):d=n+1}return d+1}}class p{static findMatches(u,c,d,t,n){const s=c.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(u,d,new b(s.wordSeparators,s.regex),t,n):this._doFindMatchesLineByLine(u,d,s,t,n):[]}static _getMultilineMatchRange(u,c,d,t,n,s){let r,o=0;t?(o=t.findLineFeedCountBeforeOffset(n),r=c+n+o):r=c+n;let g;if(t){let l=t.findLineFeedCountBeforeOffset(n+s.length)-o;g=r+s.length+l}else g=r+s.length;const f=u.getPositionAt(r),S=u.getPositionAt(g);return new T.Range(f.lineNumber,f.column,S.lineNumber,S.column)}static _doFindMatchesMultiline(u,c,d,t,n){const s=u.getOffsetAt(c.getStartPosition()),r=u.getValueInRange(c,1),o=u.getEOL()===`\r
`?new h(r):null,g=[];let f=0,S;for(d.reset(0);S=d.next(r);)if(g[f++]=A(this._getMultilineMatchRange(u,s,r,o,S.index,S[0]),S,t),f>=n)return g;return g}static _doFindMatchesLineByLine(u,c,d,t,n){const s=[];let r=0;if(c.startLineNumber===c.endLineNumber){const g=u.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return r=this._findMatchesInLine(d,g,c.startLineNumber,c.startColumn-1,r,s,t,n),s}const o=u.getLineContent(c.startLineNumber).substring(c.startColumn-1);r=this._findMatchesInLine(d,o,c.startLineNumber,c.startColumn-1,r,s,t,n);for(let g=c.startLineNumber+1;g<c.endLineNumber&&r<n;g++)r=this._findMatchesInLine(d,u.getLineContent(g),g,0,r,s,t,n);if(r<n){const g=u.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);r=this._findMatchesInLine(d,g,c.endLineNumber,0,r,s,t,n)}return s}static _findMatchesInLine(u,c,d,t,n,s,r,o){const g=u.wordSeparators;if(!r&&u.simpleSearch){const E=u.simpleSearch,l=E.length,L=c.length;let O=-l;for(;(O=c.indexOf(E,O+l))!==-1;)if((!g||m(g,c,L,O,l))&&(s[n++]=new y.FindMatch(new T.Range(d,O+1+t,d,O+1+l+t),null),n>=o))return n;return n}const f=new b(u.wordSeparators,u.regex);let S;f.reset(0);do if(S=f.next(c),S&&(s[n++]=A(new T.Range(d,S.index+1+t,d,S.index+1+S[0].length+t),S,r),n>=o))return n;while(S);return n}static findNextMatch(u,c,d,t){const n=c.parseSearchRequest();if(!n)return null;const s=new b(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(u,d,s,t):this._doFindNextMatchLineByLine(u,d,s,t)}static _doFindNextMatchMultiline(u,c,d,t){const n=new C.Position(c.lineNumber,1),s=u.getOffsetAt(n),r=u.getLineCount(),o=u.getValueInRange(new T.Range(n.lineNumber,n.column,r,u.getLineMaxColumn(r)),1),g=u.getEOL()===`\r
`?new h(o):null;d.reset(c.column-1);let f=d.next(o);return f?A(this._getMultilineMatchRange(u,s,o,g,f.index,f[0]),f,t):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(u,new C.Position(1,1),d,t):null}static _doFindNextMatchLineByLine(u,c,d,t){const n=u.getLineCount(),s=c.lineNumber,r=u.getLineContent(s),o=this._findFirstMatchInLine(d,r,s,c.column,t);if(o)return o;for(let g=1;g<=n;g++){const f=(s+g-1)%n,S=u.getLineContent(f+1),E=this._findFirstMatchInLine(d,S,f+1,1,t);if(E)return E}return null}static _findFirstMatchInLine(u,c,d,t,n){u.reset(t-1);const s=u.next(c);return s?A(new T.Range(d,s.index+1,d,s.index+1+s[0].length),s,n):null}static findPreviousMatch(u,c,d,t){const n=c.parseSearchRequest();if(!n)return null;const s=new b(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(u,d,s,t):this._doFindPreviousMatchLineByLine(u,d,s,t)}static _doFindPreviousMatchMultiline(u,c,d,t){const n=this._doFindMatchesMultiline(u,new T.Range(1,1,c.lineNumber,c.column),d,t,10*P);if(n.length>0)return n[n.length-1];const s=u.getLineCount();return c.lineNumber!==s||c.column!==u.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(u,new C.Position(s,u.getLineMaxColumn(s)),d,t):null}static _doFindPreviousMatchLineByLine(u,c,d,t){const n=u.getLineCount(),s=c.lineNumber,r=u.getLineContent(s).substring(0,c.column-1),o=this._findLastMatchInLine(d,r,s,t);if(o)return o;for(let g=1;g<=n;g++){const f=(n+s-g-1)%n,S=u.getLineContent(f+1),E=this._findLastMatchInLine(d,S,f+1,t);if(E)return E}return null}static _findLastMatchInLine(u,c,d,t){let n=null,s;for(u.reset(0);s=u.next(c);)n=A(new T.Range(d,s.index+1,d,s.index+1+s[0].length),s,t);return n}}e.TextModelSearch=p;function a(_,u,c,d,t){if(d===0)return!0;const n=u.charCodeAt(d-1);if(_.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=u.charCodeAt(d);if(_.get(s)!==0)return!0}return!1}function w(_,u,c,d,t){if(d+t===c)return!0;const n=u.charCodeAt(d+t);if(_.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=u.charCodeAt(d+t-1);if(_.get(s)!==0)return!0}return!1}function m(_,u,c,d,t){return a(_,u,c,d,t)&&w(_,u,c,d,t)}e.isValidMatch=m;class b{constructor(u,c){this._wordSeparators=u,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const c=u.length;let d;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(d=this._searchRegex.exec(u),!d))return null;const t=d.index,n=d[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){v.getNextCodePoint(u,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||m(this._wordSeparators,u,c,t,n))return d}while(d);return null}}e.Searcher=b}),define(me[107],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function v(P=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)P.indexOf(I)>=0||(D+="\\"+I);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=v();function R(P){let D=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)D=P;else{let I="g";P.ignoreCase&&(I+="i"),P.multiline&&(I+="m"),P.unicode&&(I+="u"),D=new RegExp(P.source,I)}return D.lastIndex=0,D}e.ensureValidWordDefinition=R;const C={maxLen:1e3,windowSize:15,timeBudget:150};function T(P,D,I,i,A=C){if(I.length>A.maxLen){let m=P-A.maxLen/2;return m<0?m=0:i+=m,I=I.substring(m,P+A.maxLen/2),T(P,D,I,i,A)}const h=Date.now(),p=P-1-i;let a=-1,w=null;for(let m=1;!(Date.now()-h>=A.timeBudget);m++){const b=p-A.windowSize*m;D.lastIndex=Math.max(0,b);const _=y(D,I,p,a);if(!_&&w||(w=_,b<=0))break;a=b}if(w){let m={word:w[0],startColumn:i+1+w.index,endColumn:i+1+w.index+w[0].length};return D.lastIndex=0,m}return null}e.getWordAtText=T;function y(P,D,I,i){let A;for(;A=P.exec(D);){const h=A.index||0;if(h<=I&&P.lastIndex>=I)return A;if(i>0&&h>i)return null}return null}}),define(me[142],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var v;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(v=e.IndentAction||(e.IndentAction={}));class R{constructor(P){if(this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let D=0,I=P.notIn.length;D<I;D++)switch(P.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=R;class C{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of P)T(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),T(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),T(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),T(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&T(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=C;function T(y,P,D){y.has(P)?y.get(P).push(D):y.set(P,[D])}}),define(me[78],ge([0,1,31,9]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(T,y,P,D){if(Array.isArray(T)){let I=0;for(const i of T){const A=C(i,y,P,D);if(A===10)return A;A>I&&(I=A)}return I}else{if(typeof T=="string")return D?T==="*"?5:T===P?10:0:0;if(T){const{language:I,pattern:i,scheme:A,hasAccessToAllModels:h}=T;if(!D&&!h)return 0;let p=0;if(A)if(A===y.scheme)p=10;else if(A==="*")p=5;else return 0;if(I)if(I===P)p=10;else if(I==="*")p=Math.max(p,5);else return 0;if(i){let a;if(typeof i=="string"?a=i:a=Object.assign(Object.assign({},i),{base:(0,R.normalize)(i.base)}),a===y.fsPath||(0,v.match)(a,y.fsPath))p=10;else return 0}return p}else return 0}}e.score=C}),define(me[143],ge([0,1,105]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class C{constructor(a,w,m){const b=new Uint8Array(a*w);for(let _=0,u=a*w;_<u;_++)b[_]=m;this._data=b,this.rows=a,this.cols=w}get(a,w){return this._data[a*this.cols+w]}set(a,w,m){this._data[a*this.cols+w]=m}}e.Uint8Matrix=C;class T{constructor(a){let w=0,m=0;for(let _=0,u=a.length;_<u;_++){let[c,d,t]=a[_];d>w&&(w=d),c>m&&(m=c),t>m&&(m=t)}w++,m++;let b=new C(m,w,0);for(let _=0,u=a.length;_<u;_++){let[c,d,t]=a[_];b.set(c,d,t)}this._states=b,this._maxCharCode=w}nextState(a,w){return w<0||w>=this._maxCharCode?0:this._states.get(a,w)}}e.StateMachine=T;let y=null;function P(){return y===null&&(y=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var D;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let I=null;function i(){if(I===null){I=new v.CharacterClassifier(0);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<p.length;w++)I.set(p.charCodeAt(w),1);const a=".,;";for(let w=0;w<a.length;w++)I.set(a.charCodeAt(w),2)}return I}class A{static _createLink(a,w,m,b,_){let u=_-1;do{const c=w.charCodeAt(u);if(a.get(c)!==2)break;u--}while(u>b);if(b>0){const c=w.charCodeAt(b-1),d=w.charCodeAt(u);(c===40&&d===41||c===91&&d===93||c===123&&d===125)&&u--}return{range:{startLineNumber:m,startColumn:b+1,endLineNumber:m,endColumn:u+2},url:w.substring(b,u+1)}}static computeLinks(a,w=P()){const m=i();let b=[];for(let _=1,u=a.getLineCount();_<=u;_++){const c=a.getLineContent(_),d=c.length;let t=0,n=0,s=0,r=1,o=!1,g=!1,f=!1,S=!1;for(;t<d;){let E=!1;const l=c.charCodeAt(t);if(r===13){let L;switch(l){case 40:o=!0,L=0;break;case 41:L=o?0:1;break;case 91:f=!0,g=!0,L=0;break;case 93:f=!1,L=g?0:1;break;case 123:S=!0,L=0;break;case 125:L=S?0:1;break;case 39:L=s===34||s===96?0:1;break;case 34:L=s===39||s===96?0:1;break;case 96:L=s===39||s===34?0:1;break;case 42:L=s===42?1:0;break;case 124:L=s===124?1:0;break;case 32:L=f?0:1;break;default:L=m.get(l)}L===1&&(b.push(A._createLink(m,c,_,n,t)),E=!0)}else if(r===12){let L;l===91?(g=!0,L=0):L=m.get(l),L===1?E=!0:r=13}else r=w.nextState(r,l),r===0&&(E=!0);E&&(r=1,o=!1,g=!1,S=!1,n=t+1,s=l),t++}r===13&&b.push(A._createLink(m,c,_,n,d))}return b}}e.LinkComputer=A;function h(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:A.computeLinks(p)}e.computeLinks=h}),define(me[144],ge([0,1,3,6]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class C{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,P){return this._map.set(y,P),this.fire([y]),(0,R.toDisposable)(()=>{this._map.get(y)===P&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,P){let D=null,I=!1;return this._promises.set(y,P.then(i=>{this._promises.delete(y),!(I||!i)&&(D=this.register(y,i))})),(0,R.toDisposable)(()=>{I=!0,D&&D.dispose()})}getPromise(y){const P=this.get(y);if(P)return Promise.resolve(P);const D=this._promises.get(y);return D?D.then(I=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=C}),define(me[108],ge([0,1,22,11]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(A){A[A.Full=1]="Full",A[A.Delta=2]="Delta"})(C||(C={}));function T(A){for(let h=0,p=A.length;h<p;h+=4){const a=A[h+0],w=A[h+1],m=A[h+2],b=A[h+3];A[h+0]=b,A[h+1]=m,A[h+2]=w,A[h+3]=a}}function y(A){const h=new Uint8Array(A.buffer,A.byteOffset,A.length*4);return R.isLittleEndian()||T(h),v.VSBuffer.wrap(h)}function P(A){const h=A.buffer;if(R.isLittleEndian()||T(h),h.byteOffset%4==0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const p=new Uint8Array(h.byteLength);return p.set(h),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function D(A){const h=new Uint32Array(I(A));let p=0;if(h[p++]=A.id,A.type==="full")h[p++]=1,h[p++]=A.data.length,h.set(A.data,p),p+=A.data.length;else{h[p++]=2,h[p++]=A.deltas.length;for(const a of A.deltas)h[p++]=a.start,h[p++]=a.deleteCount,a.data?(h[p++]=a.data.length,h.set(a.data,p),p+=a.data.length):h[p++]=0}return y(h)}e.encodeSemanticTokensDto=D;function I(A){let h=0;if(h+=1+1,A.type==="full")h+=1+A.data.length;else{h+=1,h+=(1+1+1)*A.deltas.length;for(const p of A.deltas)p.data&&(h+=p.data.length)}return h}function i(A){const h=P(A);let p=0;const a=h[p++];if(h[p++]===1){const _=h[p++],u=h.subarray(p,p+_);return p+=_,{id:a,type:"full",data:u}}const m=h[p++];let b=[];for(let _=0;_<m;_++){const u=h[p++],c=h[p++],d=h[p++];let t;d>0&&(t=h.subarray(p,p+d),p+=d),b[_]={start:u,deleteCount:c,data:t}}return{id:a,type:"delta",deltas:b}}e.decodeSemanticTokensDto=i}),define(me[109],ge([0,1,94]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(y,P){this.index=y,this.remainder=P}}e.PrefixSumIndexOfResult=R;class C{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,P){y=(0,v.toUint32)(y);const D=this.values,I=this.prefixSum,i=P.length;return i===0?!1:(this.values=new Uint32Array(D.length+i),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y),y+i),this.values.set(P,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,P){return y=(0,v.toUint32)(y),P=(0,v.toUint32)(P),this.values[y]===P?!1:(this.values[y]=P,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,P){y=(0,v.toUint32)(y),P=(0,v.toUint32)(P);const D=this.values,I=this.prefixSum;if(y>=D.length)return!1;let i=D.length-y;return P>=i&&(P=i),P===0?!1:(this.values=new Uint32Array(D.length-P),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y+P),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,v.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),y>=this.values.length&&(y=this.values.length-1);for(let D=P;D<=y;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let P=0,D=this.values.length-1,I=0,i=0,A=0;for(;P<=D;)if(I=P+(D-P)/2|0,i=this.prefixSum[I],A=i-this.values[I],y<A)D=I-1;else if(y>=i)P=I+1;else break;return new R(I,y-A)}}e.PrefixSumComputer=C}),define(me[145],ge([0,1,8,46,109]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(P,D,I,i){this._uri=P,this._lines=D,this._eol=I,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const D=P.changes;for(const I of D)this._acceptDeleteRange(I.range),this._acceptInsertText(new R.Position(I.range.startLineNumber,I.range.startColumn),I.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,D=this._lines.length,I=new Uint32Array(D);for(let i=0;i<D;i++)I[i]=this._lines[i].length+P;this._lineStarts=new C.PrefixSumComputer(I)}}_setLineText(P,D){this._lines[P]=D,this._lineStarts&&this._lineStarts.changeValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,D){if(D.length===0)return;let I=(0,v.splitLines)(D);if(I.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+I[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}I[I.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+I[0]);let i=new Uint32Array(I.length-1);for(let A=1;A<I.length;A++)this._lines.splice(P.lineNumber+A-1,0,I[A]),i[A-1]=I[A].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,i)}}e.MirrorTextModel=T}),define(me[146],ge([18,19]),function(K,e){return K.create("vs/base/common/date",e)}),define(me[147],ge([0,1,146]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,C=R*60,T=C*24,y=T*7,P=T*30,D=T*365;function I(A,h){typeof A!="number"&&(A=A.getTime());const p=Math.round((new Date().getTime()-A)/1e3);if(p<-30)return(0,v.localize)(0,null,I(new Date().getTime()+p*1e3,!1));if(p<30)return(0,v.localize)(1,null);let a;return p<R?(a=p,h?a===1?(0,v.localize)(2,null,a):(0,v.localize)(3,null,a):a===1?(0,v.localize)(4,null,a):(0,v.localize)(5,null,a)):p<C?(a=Math.floor(p/R),h?a===1?(0,v.localize)(6,null,a):(0,v.localize)(7,null,a):a===1?(0,v.localize)(8,null,a):(0,v.localize)(9,null,a)):p<T?(a=Math.floor(p/C),h?a===1?(0,v.localize)(10,null,a):(0,v.localize)(11,null,a):a===1?(0,v.localize)(12,null,a):(0,v.localize)(13,null,a)):p<y?(a=Math.floor(p/T),h?a===1?(0,v.localize)(14,null,a):(0,v.localize)(15,null,a):a===1?(0,v.localize)(16,null,a):(0,v.localize)(17,null,a)):p<P?(a=Math.floor(p/y),h?a===1?(0,v.localize)(18,null,a):(0,v.localize)(19,null,a):a===1?(0,v.localize)(20,null,a):(0,v.localize)(21,null,a)):p<D?(a=Math.floor(p/P),h?a===1?(0,v.localize)(22,null,a):(0,v.localize)(23,null,a):a===1?(0,v.localize)(24,null,a):(0,v.localize)(25,null,a)):(a=Math.floor(p/D),h?a===1?(0,v.localize)(26,null,a):(0,v.localize)(27,null,a):a===1?(0,v.localize)(28,null,a):(0,v.localize)(29,null,a))}e.fromNow=I;function i(A){return A.getFullYear()+"-"+String(A.getMonth()+1).padStart(2,"0")+"-"+String(A.getDate()).padStart(2,"0")+"T"+String(A.getHours()).padStart(2,"0")+":"+String(A.getMinutes()).padStart(2,"0")+":"+String(A.getSeconds()).padStart(2,"0")+"."+(A.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(me[148],ge([18,19]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(me[60],ge([0,1,148,12,16]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(I,i){return i&&(I.stack||I.stacktrace)?v.localize(0,null,P(I),y(I.stack)||y(I.stacktrace)):P(I)}function y(I){return Array.isArray(I)?I.join(`
`):I}function P(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?v.localize(1,null,I.message):I.message||v.localize(2,null)}function D(I=null,i=!1){if(!I)return v.localize(3,null);if(Array.isArray(I)){const A=C.coalesce(I),h=D(A[0],i);return A.length>1?v.localize(4,null,h,A.length):h}if(R.isString(I))return I;if(I.detail){const A=I.detail;if(A.error)return T(A.error,i);if(A.exception)return T(A.exception,i)}return I.stack?T(I,i):I.message?I.message:v.localize(5,null)}e.toErrorMessage=D}),define(me[149],ge([18,19]),function(K,e){return K.create("vs/base/node/processes",e)}),define(me[110],ge([0,1,9,28,37,149,36,12,24,29,11,138,10]),function(K,e,v,R,C,T,y,P,D,I,i,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function p(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function a(c,d){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};d&&(t.cwd=d);const n=C.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],t);return new Promise(s=>{n.once("error",r=>{s({success:!1,error:r})}),n.once("exit",(r,o)=>{s(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?p(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=h.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(n=>{C.execFile(t,[c.pid.toString()],{encoding:"utf8",shell:!0},(s,r,o)=>{n(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function w(c=y.env){return c.comspec||"cmd.exe"}e.getWindowsShell=w;class m{constructor(d,t,n,s){if(t!==void 0&&n!==void 0&&s!==void 0)this.cmd=d,this.args=t,this.shell=n,this.options=s;else{const r=d;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(y.env).forEach(o=>{r[o]=y.env[o]}),Object.keys(this.options.env).forEach(o=>{r[o]=this.options.env[o]}),this.options.env=r}}getSanitizedCommand(){let d=this.cmd.toLowerCase();const t=d.lastIndexOf(v.sep);return t!==-1&&(d=d.substring(t+1)),m.WellKnowCommands[d]?d:"other"}start(d){return i.isWindows&&(this.options&&this.options.cwd&&I.isUNC(this.options.cwd)||!this.options&&I.isUNC(y.cwd()))?Promise.reject(new Error(T.localize(0,null))):this.useExec().then(t=>{let n,s;const r=new Promise((o,g)=>{n=o,s=g});if(t){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=C.exec(o,this.options,(g,f,S)=>{this.childProcess=null;const E=g;E&&E.killed?s({killed:this.terminateRequested,stdout:f.toString(),stderr:S.toString()}):this.handleExec(n,d,g,f,S)})}else{let o=null;const g=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,n,d,s);const S={terminated:this.terminateRequested};P.isNumber(f)&&(S.cmdCode=f),n(S)};if(this.shell&&i.isWindows){const f=D.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let S=!1,E=!1;const l=[];let L=this.ensureQuotes(this.cmd);l.push(L.value),S=L.quoted,this.args&&this.args.forEach(W=>{L=this.ensureQuotes(W),l.push(L.value),E=E&&L.quoted});const O=["/s","/c"];S?E?O.push('"'+l.join(" ")+'"'):l.length>1?O.push('"'+l[0]+'" '+l.slice(1).join(" ")):O.push('"'+l[0]+'"'):O.push(l.join(" ")),o=C.spawn(w(),O,f)}else this.cmd&&(o=C.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(P.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",f=>{this.childProcess=null,s({terminated:this.terminateRequested,error:f})}),o.pid&&(this.childProcess.on("close",g),this.handleSpawn(o,n,d,s,!0)))}return r})}handleClose(d,t,n,s){}ensureQuotes(d){return m.regexp.test(d)?{value:'"'+d+'"',quoted:!0}:{value:d,quoted:d.length>0&&d[0]==='"'&&d[d.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(d=>d.pid,d=>-1):new Promise(d=>{this.pidResolve=d})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(d=>(this.terminateRequested=!0,a(d,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),d=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(d=>{if(!this.shell||!i.isWindows)return d(!1);const t=C.spawn(w(),["/s","/c"]);t.on("error",n=>d(!0)),t.on("exit",n=>d(!1))})}}e.AbstractProcess=m,m.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},m.regexp=/^[^"].* .*[^"]/;class b extends m{constructor(d,t,n,s){super(d,t,n,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(d,t,n,s,r){[s,r].forEach((o,g)=>{const f=new A.LineDecoder;f.write(o).forEach(l=>{t({line:l,source:g===0?0:1})});const E=f.end();E&&t({line:E,source:g===0?0:1})}),d({terminated:this.terminateRequested,error:n})}handleSpawn(d,t,n,s,r){const o=new A.LineDecoder,g=new A.LineDecoder;d.stdout.on("data",f=>{o.write(f).forEach(E=>n({line:E,source:0}))}),d.stderr.on("data",f=>{g.write(f).forEach(E=>n({line:E,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=g}handleClose(d,t,n,s){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&n({line:r,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&n({line:o,source:1})}}e.LineProcess=b;function _(c){let d=[],t=!1;const n=function(s){if(t){d.push(s);return}(!c.send(s,o=>{if(o&&console.error(o),t=!1,d.length>0){const g=d.slice(0);d=[],g.forEach(f=>n(f))}})||i.isWindows)&&(t=!0)};return{send:n}}e.createQueuedSender=_;var u;(function(c){async function d(t,n,s){if(v.isAbsolute(t))return t;if(n===void 0&&(n=y.cwd()),v.dirname(t)!=="."||(s===void 0&&P.isString(y.env.PATH)&&(s=y.env.PATH.split(v.delimiter)),s===void 0||s.length===0))return v.join(n,t);async function o(g){return await R.exists(g)?!(await R.Promises.stat(g)).isDirectory():!1}for(let g of s){let f;if(v.isAbsolute(g)?f=v.join(g,t):f=v.join(n,g,t),await o(f))return f;let S=f+".com";if(await o(S)||(S=f+".exe",await o(S)))return S}return v.join(n,t)}c.findExecutable=d})(u=e.win32||(e.win32={}))}),define(me[150],ge([18,19]),function(K,e){return K.create("vs/editor/common/config/editorOptions",e)}),define(me[151],ge([0,1,150,11,107]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ne){this._values=ne}hasChanged(ne){return this._values[ne]}}e.ConfigurationChangedEvent=y;class P{constructor(){this._values=[]}_read(ne){return this._values[ne]}get(ne){return this._values[ne]}_write(ne,ve){this._values[ne]=ve}}e.ValidatedEditorOptions=P;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class I{constructor(ne,ve,xe,je){this.id=ne,this.name=ve,this.defaultValue=xe,this.schema=je}compute(ne,ve,xe){return xe}}class i{constructor(ne,ve=null){this.schema=void 0,this.id=ne,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(ne){return this.defaultValue}}class A{constructor(ne,ve,xe,je){this.id=ne,this.name=ve,this.defaultValue=xe,this.schema=je}validate(ne){return typeof ne=="undefined"?this.defaultValue:ne}compute(ne,ve,xe){return xe}}function h(Q,ne){return typeof Q=="undefined"?ne:Q==="false"?!1:Boolean(Q)}e.boolean=h;class p extends A{constructor(ne,ve,xe,je=void 0){typeof je!="undefined"&&(je.type="boolean",je.default=xe),super(ne,ve,xe,je)}validate(ne){return h(ne,this.defaultValue)}}class a extends A{constructor(ne,ve,xe,je,ze,Je=void 0){typeof Je!="undefined"&&(Je.type="integer",Je.default=xe,Je.minimum=je,Je.maximum=ze),super(ne,ve,xe,Je),this.minimum=je,this.maximum=ze}static clampedInt(ne,ve,xe,je){if(typeof ne=="undefined")return ve;let ze=parseInt(ne,10);return isNaN(ze)?ve:(ze=Math.max(xe,ze),ze=Math.min(je,ze),ze|0)}validate(ne){return a.clampedInt(ne,this.defaultValue,this.minimum,this.maximum)}}class w extends A{constructor(ne,ve,xe,je,ze){typeof ze!="undefined"&&(ze.type="number",ze.default=xe),super(ne,ve,xe,ze),this.validationFn=je}static clamp(ne,ve,xe){return ne<ve?ve:ne>xe?xe:ne}static float(ne,ve){if(typeof ne=="number")return ne;if(typeof ne=="undefined")return ve;const xe=parseFloat(ne);return isNaN(xe)?ve:xe}validate(ne){return this.validationFn(w.float(ne,this.defaultValue))}}class m extends A{static string(ne,ve){return typeof ne!="string"?ve:ne}constructor(ne,ve,xe,je=void 0){typeof je!="undefined"&&(je.type="string",je.default=xe),super(ne,ve,xe,je)}validate(ne){return m.string(ne,this.defaultValue)}}function b(Q,ne,ve){return typeof Q!="string"||ve.indexOf(Q)===-1?ne:Q}e.stringSet=b;class _ extends A{constructor(ne,ve,xe,je,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.enum=je,ze.default=xe),super(ne,ve,xe,ze),this._allowedValues=je}validate(ne){return b(ne,this.defaultValue,this._allowedValues)}}class u extends I{constructor(ne,ve,xe,je,ze,Je,ye=void 0){typeof ye!="undefined"&&(ye.type="string",ye.enum=ze,ye.default=je),super(ne,ve,xe,ye),this._allowedValues=ze,this._convert=Je}validate(ne){return typeof ne!="string"?this.defaultValue:this._allowedValues.indexOf(ne)===-1?this.defaultValue:this._convert(ne)}}function c(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",description:v.localize(3,null)})}validate(ne){switch(ne){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ne,ve,xe){return xe===0?ne.accessibilitySupport:xe}}class t extends I{constructor(){const ne={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ne,{"editor.comments.insertSpace":{type:"boolean",default:ne.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ne.ignoreEmptyLines,description:v.localize(5,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{insertSpace:h(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(Q){switch(Q){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function g(Q){switch(Q){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class f extends i{constructor(){super(124,[62,31])}compute(ne,ve,xe){const je=["monaco-editor"];return ve.get(31)&&je.push(ve.get(31)),ne.extraEditorClassName&&je.push(ne.extraEditorClassName),ve.get(62)==="default"?je.push("mouse-default"):ve.get(62)==="copy"&&je.push("mouse-copy"),ve.get(97)&&je.push("showUnused"),ve.get(122)&&je.push("showDeprecated"),je.join(" ")}}class S extends p{constructor(){super(30,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(ne,ve,xe){return xe&&ne.emptySelectionClipboard}}class E extends I{constructor(){const ne={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ne,{"editor.find.cursorMoveOnType":{type:"boolean",default:ne.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ne.seedSearchStringFromSelection,description:v.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ne.autoFindInSelection,enumDescriptions:[v.localize(9,null),v.localize(10,null),v.localize(11,null)],description:v.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ne.globalFindClipboard,description:v.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ne.addExtraSpaceOnTop,description:v.localize(14,null)},"editor.find.loop":{type:"boolean",default:ne.loop,description:v.localize(15,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{cursorMoveOnType:h(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:h(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ne.autoFindInSelection=="boolean"?ne.autoFindInSelection?"always":"never":b(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(ve.loop,this.defaultValue.loop)}}}class l extends I{constructor(){super(41,"fontLigatures",l.OFF,{anyOf:[{type:"boolean",description:v.localize(16,null)},{type:"string",description:v.localize(17,null)}],description:v.localize(18,null),default:!1})}validate(ne){return typeof ne=="undefined"?this.defaultValue:typeof ne=="string"?ne==="false"?l.OFF:ne==="true"?l.ON:ne:Boolean(ne)?l.ON:l.OFF}}e.EditorFontLigatures=l,l.OFF='"liga" off, "calt" off',l.ON='"liga" on, "calt" on';class L extends i{constructor(){super(40)}compute(ne,ve,xe){return ne.fontInfo}}class O extends A{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(19,null)})}validate(ne){let ve=w.float(ne,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:w.clamp(ve,6,100)}compute(ne,ve,xe){return ne.fontInfo.fontSize}}class W extends I{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:v.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(21,null)})}validate(ne){return ne==="normal"||ne==="bold"?ne:String(a.clampedInt(ne,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class te extends I{constructor(){const ne={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:ne.multiple,enumDescriptions:[v.localize(22,null),v.localize(23,null),v.localize(24,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ne,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:v.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:v.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:v.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:v.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:v.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ne.alternativeDefinitionCommand,enum:xe,description:v.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ne.alternativeTypeDefinitionCommand,enum:xe,description:v.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ne.alternativeDeclarationCommand,enum:xe,description:v.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ne.alternativeImplementationCommand,enum:xe,description:v.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ne.alternativeReferenceCommand,enum:xe,description:v.localize(35,null)}})}validate(ne){var ve,xe,je,ze,Je;if(!ne||typeof ne!="object")return this.defaultValue;const ye=ne;return{multiple:b(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=ye.multipleDefinitions)!==null&&ve!==void 0?ve:b(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(xe=ye.multipleTypeDefinitions)!==null&&xe!==void 0?xe:b(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(je=ye.multipleDeclarations)!==null&&je!==void 0?je:b(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(ze=ye.multipleImplementations)!==null&&ze!==void 0?ze:b(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Je=ye.multipleReferences)!==null&&Je!==void 0?Je:b(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class se extends I{constructor(){const ne={enabled:!0,delay:300,sticky:!0};super(50,"hover",ne,{"editor.hover.enabled":{type:"boolean",default:ne.enabled,description:v.localize(36,null)},"editor.hover.delay":{type:"number",default:ne.delay,description:v.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ne.sticky,description:v.localize(38,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:h(ve.enabled,this.defaultValue.enabled),delay:a.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:h(ve.sticky,this.defaultValue.sticky)}}}var N;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class V extends i{constructor(){super(127,[46,54,35,61,89,56,57,91,114,117,118,119,2])}compute(ne,ve,xe){return V.computeLayout(ve,{memory:ne.memory,outerWidth:ne.outerWidth,outerHeight:ne.outerHeight,isDominatedByLongLines:ne.isDominatedByLongLines,lineHeight:ne.fontInfo.lineHeight,viewLineCount:ne.viewLineCount,lineNumbersDigitCount:ne.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ne.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ne.fontInfo.maxDigitWidth,pixelRatio:ne.pixelRatio})}static computeContainedMinimapLineCount(ne){const ve=ne.height/ne.lineHeight,xe=ne.scrollBeyondLastLine?ve-1:0,je=(ne.viewLineCount+xe)/(ne.pixelRatio*ne.height),ze=Math.floor(ne.viewLineCount/je);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:xe,desiredRatio:je,minimapLineCount:ze}}static _computeMinimapLayout(ne,ve){const xe=ne.outerWidth,je=ne.outerHeight,ze=ne.pixelRatio;if(!ne.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ze*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const Je=ve.stableMinimapLayoutInput,ye=Je&&ne.outerHeight===Je.outerHeight&&ne.lineHeight===Je.lineHeight&&ne.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&ne.pixelRatio===Je.pixelRatio&&ne.scrollBeyondLastLine===Je.scrollBeyondLastLine&&ne.minimap.enabled===Je.minimap.enabled&&ne.minimap.side===Je.minimap.side&&ne.minimap.size===Je.minimap.size&&ne.minimap.showSlider===Je.minimap.showSlider&&ne.minimap.renderCharacters===Je.minimap.renderCharacters&&ne.minimap.maxColumn===Je.minimap.maxColumn&&ne.minimap.scale===Je.minimap.scale&&ne.verticalScrollbarWidth===Je.verticalScrollbarWidth&&ne.isViewportWrapping===Je.isViewportWrapping,De=ne.lineHeight,ke=ne.typicalHalfwidthCharacterWidth,re=ne.scrollBeyondLastLine,he=ne.minimap.renderCharacters;let z=ze>=2?Math.round(ne.minimap.scale*2):ne.minimap.scale;const J=ne.minimap.maxColumn,ce=ne.minimap.size,Pe=ne.minimap.side,Ae=ne.verticalScrollbarWidth,Ne=ne.viewLineCount,Be=ne.remainingWidth,Qe=ne.isViewportWrapping,rt=he?2:3;let et=Math.floor(ze*je);const Xe=et/ze;let ot=!1,Et=!1,bt=rt*z,vt=z/ze,le=1;if(ce==="fill"||ce==="fit"){const{typicalViewportLineCount:it,extraLinesBeyondLastLine:ct,desiredRatio:gt,minimapLineCount:Ye}=V.computeContainedMinimapLineCount({viewLineCount:Ne,scrollBeyondLastLine:re,height:je,lineHeight:De,pixelRatio:ze});if(Ne/Ye>1)ot=!0,Et=!0,z=1,bt=1,vt=z/ze;else{let at=!1,lt=z+1;if(ce==="fit"){const Pt=Math.ceil((Ne+ct)*bt);Qe&&ye&&Be<=ve.stableFitRemainingWidth?(at=!0,lt=ve.stableFitMaxMinimapScale):(at=Pt>et,Qe&&at?(ve.stableMinimapLayoutInput=ne,ve.stableFitRemainingWidth=Be):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0))}if(ce==="fill"||at){ot=!0;const Pt=z;bt=Math.min(De*ze,Math.max(1,Math.floor(1/gt))),z=Math.min(lt,Math.max(1,Math.floor(bt/rt))),z>Pt&&(le=Math.min(2,z/Pt)),vt=z/ze/le,et=Math.ceil(Math.max(it,Ne+ct)*bt),Qe&&at&&(ve.stableFitMaxMinimapScale=z)}}}const Se=Math.floor(J*vt),ue=Math.min(Se,Math.max(0,Math.floor((Be-Ae-2)*vt/(ke+vt)))+e.MINIMAP_GUTTER_WIDTH);let G=Math.floor(ze*ue);const Ue=G/ze;G=Math.floor(G*le);const Fe=he?1:2,Ze=Pe==="left"?0:xe-ue-Ae;return{renderMinimap:Fe,minimapLeft:Ze,minimapWidth:ue,minimapHeightIsEditorHeight:ot,minimapIsSampling:Et,minimapScale:z,minimapLineHeight:bt,minimapCanvasInnerWidth:G,minimapCanvasInnerHeight:et,minimapCanvasOuterWidth:Ue,minimapCanvasOuterHeight:Xe}}static computeLayout(ne,ve){const xe=ve.outerWidth|0,je=ve.outerHeight|0,ze=ve.lineHeight|0,Je=ve.lineNumbersDigitCount|0,ye=ve.typicalHalfwidthCharacterWidth,De=ve.maxDigitWidth,ke=ve.pixelRatio,re=ve.viewLineCount,he=ne.get(119),z=he==="inherit"?ne.get(118):he,J=z==="inherit"?ne.get(114):z,ce=ne.get(117),Pe=ne.get(2),Ae=ve.isDominatedByLongLines,Ne=ne.get(46),Be=ne.get(56).renderType!==0,Qe=ne.get(57),rt=ne.get(91),et=ne.get(61),Xe=ne.get(89),ot=Xe.verticalScrollbarSize,Et=Xe.verticalHasArrows,bt=Xe.arrowSize,vt=Xe.horizontalScrollbarSize,le=ne.get(54),Se=ne.get(35);let ue;if(typeof le=="string"&&/^\d+(\.\d+)?ch$/.test(le)){const Rt=parseFloat(le.substr(0,le.length-2));ue=a.clampedInt(Rt*ye,0,0,1e3)}else ue=a.clampedInt(le,0,0,1e3);Se&&(ue+=16);let G=0;if(Be){const Rt=Math.max(Je,Qe);G=Math.round(Rt*De)}let Ue=0;Ne&&(Ue=ze);let Fe=0,Ze=Fe+Ue,it=Ze+G,ct=it+ue;const gt=xe-Ue-G-ue;let Ye=!1,dt=!1,at=-1;Pe!==2&&(z==="inherit"&&Ae?(Ye=!0,dt=!0):J==="on"||J==="bounded"?dt=!0:J==="wordWrapColumn"&&(at=ce));const lt=V._computeMinimapLayout({outerWidth:xe,outerHeight:je,lineHeight:ze,typicalHalfwidthCharacterWidth:ye,pixelRatio:ke,scrollBeyondLastLine:rt,minimap:et,verticalScrollbarWidth:ot,viewLineCount:re,remainingWidth:gt,isViewportWrapping:dt},ve.memory||new D);lt.renderMinimap!==0&&lt.minimapLeft===0&&(Fe+=lt.minimapWidth,Ze+=lt.minimapWidth,it+=lt.minimapWidth,ct+=lt.minimapWidth);const Pt=gt-lt.minimapWidth,Ct=Math.max(1,Math.floor((Pt-ot-2)/ye)),At=Et?bt:0;return dt&&(at=Math.max(1,Ct),J==="bounded"&&(at=Math.min(at,ce))),{width:xe,height:je,glyphMarginLeft:Fe,glyphMarginWidth:Ue,lineNumbersLeft:Ze,lineNumbersWidth:G,decorationsLeft:it,decorationsWidth:ue,contentLeft:ct,contentWidth:Pt,minimap:lt,viewportColumn:Ct,isWordWrapMinified:Ye,isViewportWrapping:dt,wrappingColumn:at,verticalScrollbarWidth:ot,horizontalScrollbarHeight:vt,overviewRuler:{top:At,width:ot,height:je-2*At,right:0}}}}e.EditorLayoutInfoComputer=V;class x extends I{constructor(){const ne={enabled:!0};super(53,"lightbulb",ne,{"editor.lightbulb.enabled":{type:"boolean",default:ne.enabled,description:v.localize(39,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:h(ne.enabled,this.defaultValue.enabled)}}}class k extends I{constructor(){const ne={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(123,"inlayHints",ne,{"editor.inlayHints.enabled":{type:"boolean",default:ne.enabled,description:v.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ne.fontSize,description:v.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ne.fontFamily,description:v.localize(42,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:h(ve.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class U extends a{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:v.localize(43,null)})}compute(ne,ve,xe){return ne.fontInfo.lineHeight}}class F extends I{constructor(){const ne={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ne,{"editor.minimap.enabled":{type:"boolean",default:ne.enabled,description:v.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(45,null),v.localize(46,null),v.localize(47,null)],default:ne.size,description:v.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ne.side,description:v.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ne.showSlider,description:v.localize(50,null)},"editor.minimap.scale":{type:"number",default:ne.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ne.renderCharacters,description:v.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ne.maxColumn,description:v.localize(53,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:h(ve.enabled,this.defaultValue.enabled),size:b(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(ve.side,this.defaultValue.side,["right","left"]),showSlider:b(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(ve.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(ve.scale,1,1,3),maxColumn:a.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(Q){return Q==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class $ extends I{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(55,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{top:a.clampedInt(ve.top,0,0,1e3),bottom:a.clampedInt(ve.bottom,0,0,1e3)}}}class H extends I{constructor(){const ne={enabled:!0,cycle:!1};super(72,"parameterHints",ne,{"editor.parameterHints.enabled":{type:"boolean",default:ne.enabled,description:v.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ne.cycle,description:v.localize(57,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:h(ve.enabled,this.defaultValue.enabled),cycle:h(ve.cycle,this.defaultValue.cycle)}}}class X extends i{constructor(){super(125)}compute(ne,ve,xe){return ne.pixelRatio}}class ae extends I{constructor(){const ne={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ne,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ne.strings,description:v.localize(58,null)},comments:{type:"boolean",default:ne.comments,description:v.localize(59,null)},other:{type:"boolean",default:ne.other,description:v.localize(60,null)}}}],default:ne,description:v.localize(61,null)});this.defaultValue=ne}validate(ne){if(typeof ne=="boolean")return ne;if(ne&&typeof ne=="object"){const ve=ne,xe={other:h(ve.other,this.defaultValue.other),comments:h(ve.comments,this.defaultValue.comments),strings:h(ve.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var we;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(we=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Le extends I{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(62,null),v.localize(63,null),v.localize(64,null),v.localize(65,null)],default:"on",description:v.localize(66,null)})}validate(ne){let ve=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof ne!="undefined"&&(typeof ne=="function"?(ve=4,xe=ne):ne==="interval"?ve=3:ne==="relative"?ve=2:ne==="on"?ve=1:ve=0),{renderType:ve,renderFn:xe}}}function Ie(Q){const ne=Q.get(84);return ne==="editable"?Q.get(77):ne!=="on"}e.filterValidationDecorations=Ie;class Me extends I{constructor(){const ne=[],ve={type:"number",description:v.localize(67,null)};super(88,"rulers",ne,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:v.localize(68,null),format:"color-hex"}}}]},default:ne,description:v.localize(69,null)})}validate(ne){if(Array.isArray(ne)){let ve=[];for(let xe of ne)if(typeof xe=="number")ve.push({column:a.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const je=xe;ve.push({column:a.clampedInt(je.column,0,0,1e4),color:je.color})}return ve.sort((xe,je)=>xe.column-je.column),ve}return this.defaultValue}}function We(Q,ne){if(typeof Q!="string")return ne;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class j extends I{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne,xe=a.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=a.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:We(ve.vertical,this.defaultValue.vertical),horizontal:We(ve.horizontal,this.defaultValue.horizontal),useShadows:h(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:a.clampedInt(ve.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:je,verticalSliderSize:a.clampedInt(ve.verticalSliderSize,je,0,1e3),scrollByPage:h(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class Y extends I{constructor(){const ne={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showSuggestionPreview:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ne,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(70,null),v.localize(71,null)],default:ne.insertMode,description:v.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ne.filterGraceful,description:v.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ne.localityBonus,description:v.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ne.shareSuggestSelections,markdownDescription:v.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ne.snippetsPreventQuickSuggestions,description:v.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ne.showIcons,description:v.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ne.showStatusBar,description:v.localize(78,null)},"editor.suggest.showSuggestionPreview":{type:"boolean",default:ne.showSuggestionPreview,description:v.localize(79,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ne.showInlineDetails,description:v.localize(80,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(81,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(82,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(83,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(84,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(85,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:v.localize(86,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(87,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(88,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(89,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(90,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(91,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(92,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(93,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(94,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(95,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(96,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(97,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(98,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(99,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(100,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(101,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(102,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(103,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(104,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(105,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(106,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(107,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(108,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(109,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(110,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(111,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{insertMode:b(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:h(ve.showIcons,this.defaultValue.showIcons),showStatusBar:h(ve.showStatusBar,this.defaultValue.showStatusBar),showSuggestionPreview:h(ve.showSuggestionPreview,this.defaultValue.showSuggestionPreview),showInlineDetails:h(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(ve.showMethods,this.defaultValue.showMethods),showFunctions:h(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:h(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(ve.showDeprecated,this.defaultValue.showDeprecated),showFields:h(ve.showFields,this.defaultValue.showFields),showVariables:h(ve.showVariables,this.defaultValue.showVariables),showClasses:h(ve.showClasses,this.defaultValue.showClasses),showStructs:h(ve.showStructs,this.defaultValue.showStructs),showInterfaces:h(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:h(ve.showModules,this.defaultValue.showModules),showProperties:h(ve.showProperties,this.defaultValue.showProperties),showEvents:h(ve.showEvents,this.defaultValue.showEvents),showOperators:h(ve.showOperators,this.defaultValue.showOperators),showUnits:h(ve.showUnits,this.defaultValue.showUnits),showValues:h(ve.showValues,this.defaultValue.showValues),showConstants:h(ve.showConstants,this.defaultValue.showConstants),showEnums:h(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:h(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(ve.showKeywords,this.defaultValue.showKeywords),showWords:h(ve.showWords,this.defaultValue.showWords),showColors:h(ve.showColors,this.defaultValue.showColors),showFiles:h(ve.showFiles,this.defaultValue.showFiles),showReferences:h(ve.showReferences,this.defaultValue.showReferences),showFolders:h(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:h(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(ve.showSnippets,this.defaultValue.showSnippets),showUsers:h(ve.showUsers,this.defaultValue.showUsers),showIssues:h(ve.showIssues,this.defaultValue.showIssues)}}}class ee extends I{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(112,null),default:!0,type:"boolean"}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(ne.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class oe extends i{constructor(){super(126,[77])}compute(ne,ve,xe){return ve.get(77)?!0:ne.tabFocusMode}}var pe;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(pe=e.WrappingIndent||(e.WrappingIndent={}));function _e(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class de extends i{constructor(){super(128,[127])}compute(ne,ve,xe){const je=ve.get(127);return{isDominatedByLongLines:ne.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}const Ee="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",Ve="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Re:R.isLinux?Ve:Ee,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var Ke;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.codeLens=12]="codeLens",Q[Q.codeLensFontFamily=13]="codeLensFontFamily",Q[Q.codeLensFontSize=14]="codeLensFontSize",Q[Q.colorDecorators=15]="colorDecorators",Q[Q.columnSelection=16]="columnSelection",Q[Q.comments=17]="comments",Q[Q.contextmenu=18]="contextmenu",Q[Q.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=20]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=22]="cursorStyle",Q[Q.cursorSurroundingLines=23]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=25]="cursorWidth",Q[Q.disableLayerHinting=26]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",Q[Q.domReadOnly=28]="domReadOnly",Q[Q.dragAndDrop=29]="dragAndDrop",Q[Q.emptySelectionClipboard=30]="emptySelectionClipboard",Q[Q.extraEditorClassName=31]="extraEditorClassName",Q[Q.fastScrollSensitivity=32]="fastScrollSensitivity",Q[Q.find=33]="find",Q[Q.fixedOverflowWidgets=34]="fixedOverflowWidgets",Q[Q.folding=35]="folding",Q[Q.foldingStrategy=36]="foldingStrategy",Q[Q.foldingHighlight=37]="foldingHighlight",Q[Q.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=39]="fontFamily",Q[Q.fontInfo=40]="fontInfo",Q[Q.fontLigatures=41]="fontLigatures",Q[Q.fontSize=42]="fontSize",Q[Q.fontWeight=43]="fontWeight",Q[Q.formatOnPaste=44]="formatOnPaste",Q[Q.formatOnType=45]="formatOnType",Q[Q.glyphMargin=46]="glyphMargin",Q[Q.gotoLocation=47]="gotoLocation",Q[Q.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",Q[Q.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",Q[Q.hover=50]="hover",Q[Q.inDiffEditor=51]="inDiffEditor",Q[Q.letterSpacing=52]="letterSpacing",Q[Q.lightbulb=53]="lightbulb",Q[Q.lineDecorationsWidth=54]="lineDecorationsWidth",Q[Q.lineHeight=55]="lineHeight",Q[Q.lineNumbers=56]="lineNumbers",Q[Q.lineNumbersMinChars=57]="lineNumbersMinChars",Q[Q.linkedEditing=58]="linkedEditing",Q[Q.links=59]="links",Q[Q.matchBrackets=60]="matchBrackets",Q[Q.minimap=61]="minimap",Q[Q.mouseStyle=62]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=64]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=66]="multiCursorModifier",Q[Q.multiCursorPaste=67]="multiCursorPaste",Q[Q.occurrencesHighlight=68]="occurrencesHighlight",Q[Q.overviewRulerBorder=69]="overviewRulerBorder",Q[Q.overviewRulerLanes=70]="overviewRulerLanes",Q[Q.padding=71]="padding",Q[Q.parameterHints=72]="parameterHints",Q[Q.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=75]="quickSuggestions",Q[Q.quickSuggestionsDelay=76]="quickSuggestionsDelay",Q[Q.readOnly=77]="readOnly",Q[Q.renameOnType=78]="renameOnType",Q[Q.renderControlCharacters=79]="renderControlCharacters",Q[Q.renderIndentGuides=80]="renderIndentGuides",Q[Q.renderFinalNewline=81]="renderFinalNewline",Q[Q.renderLineHighlight=82]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=84]="renderValidationDecorations",Q[Q.renderWhitespace=85]="renderWhitespace",Q[Q.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",Q[Q.roundedSelection=87]="roundedSelection",Q[Q.rulers=88]="rulers",Q[Q.scrollbar=89]="scrollbar",Q[Q.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=91]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=92]="scrollPredominantAxis",Q[Q.selectionClipboard=93]="selectionClipboard",Q[Q.selectionHighlight=94]="selectionHighlight",Q[Q.selectOnLineNumbers=95]="selectOnLineNumbers",Q[Q.showFoldingControls=96]="showFoldingControls",Q[Q.showUnused=97]="showUnused",Q[Q.snippetSuggestions=98]="snippetSuggestions",Q[Q.smartSelect=99]="smartSelect",Q[Q.smoothScrolling=100]="smoothScrolling",Q[Q.stickyTabStops=101]="stickyTabStops",Q[Q.stopRenderingLineAfter=102]="stopRenderingLineAfter",Q[Q.suggest=103]="suggest",Q[Q.suggestFontSize=104]="suggestFontSize",Q[Q.suggestLineHeight=105]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",Q[Q.suggestSelection=107]="suggestSelection",Q[Q.tabCompletion=108]="tabCompletion",Q[Q.tabIndex=109]="tabIndex",Q[Q.unusualLineTerminators=110]="unusualLineTerminators",Q[Q.useShadowDOM=111]="useShadowDOM",Q[Q.useTabStops=112]="useTabStops",Q[Q.wordSeparators=113]="wordSeparators",Q[Q.wordWrap=114]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=115]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=116]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=117]="wordWrapColumn",Q[Q.wordWrapOverride1=118]="wordWrapOverride1",Q[Q.wordWrapOverride2=119]="wordWrapOverride2",Q[Q.wrappingIndent=120]="wrappingIndent",Q[Q.wrappingStrategy=121]="wrappingStrategy",Q[Q.showDeprecated=122]="showDeprecated",Q[Q.inlayHints=123]="inlayHints",Q[Q.editorClassName=124]="editorClassName",Q[Q.pixelRatio=125]="pixelRatio",Q[Q.tabFocusMode=126]="tabFocusMode",Q[Q.layoutInfo=127]="layoutInfo",Q[Q.wrappingInfo=128]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new p(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(113,null)})),acceptSuggestionOnEnter:be(new _(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(114,null),""],markdownDescription:v.localize(115,null)})),accessibilitySupport:be(new d),accessibilityPageSize:be(new a(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(116,null)})),ariaLabel:be(new m(4,"ariaLabel",v.localize(117,null))),autoClosingBrackets:be(new _(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(118,null),v.localize(119,null),""],description:v.localize(120,null)})),autoClosingDelete:be(new _(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(121,null),""],description:v.localize(122,null)})),autoClosingOvertype:be(new _(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(123,null),""],description:v.localize(124,null)})),autoClosingQuotes:be(new _(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(125,null),v.localize(126,null),""],description:v.localize(127,null)})),autoIndent:be(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[v.localize(128,null),v.localize(129,null),v.localize(130,null),v.localize(131,null),v.localize(132,null)],description:v.localize(133,null)})),automaticLayout:be(new p(10,"automaticLayout",!1)),autoSurround:be(new _(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(134,null),v.localize(135,null),v.localize(136,null),""],description:v.localize(137,null)})),stickyTabStops:be(new p(101,"stickyTabStops",!1,{description:v.localize(138,null)})),codeLens:be(new p(12,"codeLens",!0,{description:v.localize(139,null)})),codeLensFontFamily:be(new m(13,"codeLensFontFamily","",{description:v.localize(140,null)})),codeLensFontSize:be(new a(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:v.localize(141,null)})),colorDecorators:be(new p(15,"colorDecorators",!0,{description:v.localize(142,null)})),columnSelection:be(new p(16,"columnSelection",!1,{description:v.localize(143,null)})),comments:be(new t),contextmenu:be(new p(18,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new p(19,"copyWithSyntaxHighlighting",!0,{description:v.localize(144,null)})),cursorBlinking:be(new u(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:v.localize(145,null)})),cursorSmoothCaretAnimation:be(new p(21,"cursorSmoothCaretAnimation",!1,{description:v.localize(146,null)})),cursorStyle:be(new u(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],g,{description:v.localize(147,null)})),cursorSurroundingLines:be(new a(23,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(148,null)})),cursorSurroundingLinesStyle:be(new _(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(149,null),v.localize(150,null)],description:v.localize(151,null)})),cursorWidth:be(new a(25,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(152,null)})),disableLayerHinting:be(new p(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new p(27,"disableMonospaceOptimizations",!1)),domReadOnly:be(new p(28,"domReadOnly",!1)),dragAndDrop:be(new p(29,"dragAndDrop",!0,{description:v.localize(153,null)})),emptySelectionClipboard:be(new S),extraEditorClassName:be(new m(31,"extraEditorClassName","")),fastScrollSensitivity:be(new w(32,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:v.localize(154,null)})),find:be(new E),fixedOverflowWidgets:be(new p(34,"fixedOverflowWidgets",!1)),folding:be(new p(35,"folding",!0,{description:v.localize(155,null)})),foldingStrategy:be(new _(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(156,null),v.localize(157,null)],description:v.localize(158,null)})),foldingHighlight:be(new p(37,"foldingHighlight",!0,{description:v.localize(159,null)})),unfoldOnClickAfterEndOfLine:be(new p(38,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(160,null)})),fontFamily:be(new m(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(161,null)})),fontInfo:be(new L),fontLigatures2:be(new l),fontSize:be(new O),fontWeight:be(new W),formatOnPaste:be(new p(44,"formatOnPaste",!1,{description:v.localize(162,null)})),formatOnType:be(new p(45,"formatOnType",!1,{description:v.localize(163,null)})),glyphMargin:be(new p(46,"glyphMargin",!0,{description:v.localize(164,null)})),gotoLocation:be(new te),hideCursorInOverviewRuler:be(new p(48,"hideCursorInOverviewRuler",!1,{description:v.localize(165,null)})),highlightActiveIndentGuide:be(new p(49,"highlightActiveIndentGuide",!0,{description:v.localize(166,null)})),hover:be(new se),inDiffEditor:be(new p(51,"inDiffEditor",!1)),letterSpacing:be(new w(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>w.clamp(Q,-5,20),{description:v.localize(167,null)})),lightbulb:be(new x),lineDecorationsWidth:be(new A(54,"lineDecorationsWidth",10)),lineHeight:be(new U),lineNumbers:be(new Le),lineNumbersMinChars:be(new a(57,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new p(58,"linkedEditing",!1,{description:v.localize(168,null)})),links:be(new p(59,"links",!0,{description:v.localize(169,null)})),matchBrackets:be(new _(60,"matchBrackets","always",["always","near","never"],{description:v.localize(170,null)})),minimap:be(new F),mouseStyle:be(new _(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new w(63,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:v.localize(171,null)})),mouseWheelZoom:be(new p(64,"mouseWheelZoom",!1,{markdownDescription:v.localize(172,null)})),multiCursorMergeOverlapping:be(new p(65,"multiCursorMergeOverlapping",!0,{description:v.localize(173,null)})),multiCursorModifier:be(new u(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[v.localize(174,null),v.localize(175,null)],markdownDescription:v.localize(176,null)})),multiCursorPaste:be(new _(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(177,null),v.localize(178,null)],markdownDescription:v.localize(179,null)})),occurrencesHighlight:be(new p(68,"occurrencesHighlight",!0,{description:v.localize(180,null)})),overviewRulerBorder:be(new p(69,"overviewRulerBorder",!0,{description:v.localize(181,null)})),overviewRulerLanes:be(new a(70,"overviewRulerLanes",3,0,3)),padding:be(new $),parameterHints:be(new H),peekWidgetDefaultFocus:be(new _(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(182,null),v.localize(183,null)],description:v.localize(184,null)})),definitionLinkOpensInPeek:be(new p(74,"definitionLinkOpensInPeek",!1,{description:v.localize(185,null)})),quickSuggestions:be(new ae),quickSuggestionsDelay:be(new a(76,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(186,null)})),readOnly:be(new p(77,"readOnly",!1)),renameOnType:be(new p(78,"renameOnType",!1,{description:v.localize(187,null),markdownDeprecationMessage:v.localize(188,null)})),renderControlCharacters:be(new p(79,"renderControlCharacters",!1,{description:v.localize(189,null)})),renderIndentGuides:be(new p(80,"renderIndentGuides",!0,{description:v.localize(190,null)})),renderFinalNewline:be(new p(81,"renderFinalNewline",!0,{description:v.localize(191,null)})),renderLineHighlight:be(new _(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(192,null)],description:v.localize(193,null)})),renderLineHighlightOnlyWhenFocus:be(new p(83,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(194,null)})),renderValidationDecorations:be(new _(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new _(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(195,null),v.localize(196,null),v.localize(197,null),""],description:v.localize(198,null)})),revealHorizontalRightPadding:be(new a(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new p(87,"roundedSelection",!0,{description:v.localize(199,null)})),rulers:be(new Me),scrollbar:be(new j),scrollBeyondLastColumn:be(new a(90,"scrollBeyondLastColumn",5,0,1073741824,{description:v.localize(200,null)})),scrollBeyondLastLine:be(new p(91,"scrollBeyondLastLine",!0,{description:v.localize(201,null)})),scrollPredominantAxis:be(new p(92,"scrollPredominantAxis",!0,{description:v.localize(202,null)})),selectionClipboard:be(new p(93,"selectionClipboard",!0,{description:v.localize(203,null),included:R.isLinux})),selectionHighlight:be(new p(94,"selectionHighlight",!0,{description:v.localize(204,null)})),selectOnLineNumbers:be(new p(95,"selectOnLineNumbers",!0)),showFoldingControls:be(new _(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[v.localize(205,null),v.localize(206,null)],description:v.localize(207,null)})),showUnused:be(new p(97,"showUnused",!0,{description:v.localize(208,null)})),showDeprecated:be(new p(122,"showDeprecated",!0,{description:v.localize(209,null)})),inlayHints:be(new k),snippetSuggestions:be(new _(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(210,null),v.localize(211,null),v.localize(212,null),v.localize(213,null)],description:v.localize(214,null)})),smartSelect:be(new ee),smoothScrolling:be(new p(100,"smoothScrolling",!1,{description:v.localize(215,null)})),stopRenderingLineAfter:be(new a(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new Y),suggestFontSize:be(new a(104,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(216,null)})),suggestLineHeight:be(new a(105,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(217,null)})),suggestOnTriggerCharacters:be(new p(106,"suggestOnTriggerCharacters",!0,{description:v.localize(218,null)})),suggestSelection:be(new _(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(219,null),v.localize(220,null),v.localize(221,null)],description:v.localize(222,null)})),tabCompletion:be(new _(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(223,null),v.localize(224,null),v.localize(225,null)],description:v.localize(226,null)})),tabIndex:be(new a(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new _(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(227,null),v.localize(228,null),v.localize(229,null)],description:v.localize(230,null)})),useShadowDOM:be(new p(111,"useShadowDOM",!0)),useTabStops:be(new p(112,"useTabStops",!0,{description:v.localize(231,null)})),wordSeparators:be(new m(113,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:v.localize(232,null)})),wordWrap:be(new _(114,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(233,null),v.localize(234,null),v.localize(235,null),v.localize(236,null)],description:v.localize(237,null)})),wordWrapBreakAfterCharacters:be(new m(115,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new m(116,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new a(117,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(238,null)})),wordWrapOverride1:be(new _(118,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new _(119,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new u(120,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],_e,{enumDescriptions:[v.localize(239,null),v.localize(240,null),v.localize(241,null),v.localize(242,null)],description:v.localize(243,null)})),wrappingStrategy:be(new _(121,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[v.localize(244,null),v.localize(245,null)],description:v.localize(246,null)})),editorClassName:be(new f),pixelRatio:be(new X),tabFocusMode:be(new oe),layoutInfo:be(new V),wrappingInfo:be(new de)}}),define(me[152],ge([18,19]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[153],ge([18,19]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[154],ge([18,19]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[155],ge([18,19]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[156],ge([18,19]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(me[157],ge([18,19]),function(K,e){return K.create("vs/platform/markers/common/markers",e)}),define(me[158],ge([18,19]),function(K,e){return K.create("vs/platform/theme/common/iconRegistry",e)}),define(me[159],ge([18,19]),function(K,e){return K.create("vs/platform/workspaces/common/workspaces",e)}),define(me[160],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[161],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[162],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostProgress",e)}),define(me[163],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[164],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[165],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[166],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[167],ge([18,19]),function(K,e){return K.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[168],ge([18,19]),function(K,e){return K.create("vs/workbench/common/views",e)}),define(me[169],ge([18,19]),function(K,e){return K.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[170],ge([18,19]),function(K,e){return K.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[171],ge([18,19]),function(K,e){return K.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[172],ge([18,19]),function(K,e){return K.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[173],ge([18,19]),function(K,e){return K.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[174],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var v;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(v=e.EditorActivation||(e.EditorActivation={}));var R;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(R=e.EditorOverride||(e.EditorOverride={}));var C;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(C=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[175],ge([0,1,154]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function T(h){return h=h.trim(),h==="*"||R.test(h)}e.isValidVersionStr=T;function y(h){if(!T(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=h.match(R);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=y;function P(h){if(!h)return null;let p=h.majorBase,a=h.majorMustEqual,w=h.minorBase,m=h.minorMustEqual,b=h.patchBase,_=h.patchMustEqual;h.hasCaret&&(p===0||(m=!1),_=!1);let u=0;if(h.preRelease){const c=C.exec(h.preRelease);if(c){const[,d,t,n]=c;u=Date.UTC(Number(d),Number(t)-1,Number(n))}}return{majorBase:p,majorMustEqual:a,minorBase:w,minorMustEqual:m,patchBase:b,patchMustEqual:_,isMinimum:h.hasGreaterEquals,notBefore:u}}e.normalizeVersion=P;function D(h,p,a){let w;typeof h=="string"?w=P(y(h)):w=h;let m;p instanceof Date?m=p.getTime():typeof p=="string"&&(m=new Date(p).getTime());let b;if(typeof a=="string"?b=P(y(a)):b=a,!w||!b)return!1;let _=w.majorBase,u=w.minorBase,c=w.patchBase,d=b.majorBase,t=b.minorBase,n=b.patchBase,s=b.notBefore,r=b.majorMustEqual,o=b.minorMustEqual,g=b.patchMustEqual;return b.isMinimum?_>d?!0:_<d?!1:u>t?!0:u<t||m&&m<s?!1:c>=n:(_===1&&d===0&&(!r||!o||!g)&&(d=1,t=0,n=0,r=!0,o=!1,g=!1),_<d?!1:_>d?!r:u<t?!1:u>t?!o:c<n?!1:c>n?!g:!(m&&m<s))}e.isValidVersion=D;function I(h,p,a,w){return a.isBuiltin||typeof a.main=="undefined"?!0:A(h,p,a.engines.vscode,w)}e.isValidExtensionVersion=I;function i(h,p,a){return h==="*"||A(p,a,h)}e.isEngineValid=i;function A(h,p,a,w=[]){let m=P(y(a));if(!m)return w.push(v.localize(0,null,a)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return w.push(v.localize(1,null,a)),!1}else if(!m.majorMustEqual)return w.push(v.localize(2,null,a)),!1;return D(h,p,m)?!0:(w.push(v.localize(3,null,h,a)),!1)}}),define(me[111],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(T,y=[],P=!1){this.ctor=T,this.staticArguments=y,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=v;const R=(C,...T)=>new v(C,T);e.createSyncDescriptor=R}),define(me[79],ge([0,1,111]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function C(y,P,D){P instanceof v.SyncDescriptor||(P=new v.SyncDescriptor(P,[],D)),R.push([y,P])}e.registerSingleton=C;function T(){return R}e.getSingletonServiceDescriptors=T}),define(me[176],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=v;class R{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let y of this._nodes.values())y.outgoing.size===0&&T.push(y);return T}insertEdge(T,y){const P=this.lookupOrInsertNode(T),D=this.lookupOrInsertNode(y);P.outgoing.set(this._hashFn(y),D),D.incoming.set(this._hashFn(T),P)}removeNode(T){const y=this._hashFn(T);this._nodes.delete(y);for(let P of this._nodes.values())P.outgoing.delete(y),P.incoming.delete(y)}lookupOrInsertNode(T){const y=this._hashFn(T);let P=this._nodes.get(y);return P||(P=new v(T),this._nodes.set(y,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[y,P]of this._nodes)T.push(`${y}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,y]of this._nodes){const P=new Set([T]),D=this._findCycle(y,P);if(D)return D}}_findCycle(T,y){for(let[P,D]of T.outgoing){if(y.has(P))return[...y,P].join(" -> ");y.add(P);const I=this._findCycle(D,y);if(I)return I;y.delete(P)}}}e.Graph=R}),define(me[4],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function D(I){return I[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=D})(v=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function R(P,D,I,i){D[v.DI_TARGET]===D?D[v.DI_DEPENDENCIES].push({id:P,index:I,optional:i}):(D[v.DI_DEPENDENCIES]=[{id:P,index:I,optional:i}],D[v.DI_TARGET]=D)}function C(P){if(v.serviceIds.has(P))return v.serviceIds.get(P);const D=function(I,i,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(D,I,A,!1)};return D.toString=()=>P,v.serviceIds.set(P,D),D}e.createDecorator=C;function T(P){return P}e.refineServiceDecorator=T;function y(P){return function(D,I,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(P,D,i,!0)}}e.optional=y}),define(me[177],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,v.createDecorator)("modelService");function R(C){return!C.isTooLargeForSyncing()&&!C.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(me[178],ge([0,1,3,75,6,23,74,78,177]),function(K,e,v,R,C,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function I(h){return typeof h=="string"?!1:Array.isArray(h)?h.every(I):!!h.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new v.Emitter}get onDidChange(){return this._onDidChange.event}register(p,a){let w={selector:p,provider:a,_score:-1,_time:this._clock++};return this._entries.push(w),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,C.toDisposable)(()=>{if(w){let m=this._entries.indexOf(w);m>=0&&(this._entries.splice(m,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),w=void 0)}})}has(p){return this.all(p).length>0}all(p){if(!p)return[];this._updateScores(p);const a=[];for(let w of this._entries)w._score>0&&a.push(w.provider);return a}ordered(p){const a=[];return this._orderedForEach(p,w=>a.push(w.provider)),a}orderedGroups(p){const a=[];let w,m;return this._orderedForEach(p,b=>{w&&m===b._score?w.push(b.provider):(m=b._score,w=[b.provider],a.push(w))}),a}_orderedForEach(p,a){if(!!p){this._updateScores(p);for(const w of this._entries)w._score>0&&a(w)}}_updateScores(p){let a={uri:p.uri.toString(),language:p.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let w of this._entries)if(w._score=(0,P.score)(w.selector,p.uri,p.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(p)),I(w.selector)&&w._score>0){for(let m of this._entries)m._score=0;w._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(p,a){return p._score<a._score?1:p._score>a._score?-1:p._time<a._time?1:p._time>a._time?-1:0}}e.LanguageFeatureRegistry=i;class A{constructor(p,a,w=Number.MAX_SAFE_INTEGER){this._registry=p,this.min=a,this.max=w,this._cache=new T.LRUCache(50,.7)}_key(p){return p.id+(0,R.hash)(this._registry.all(p))}_clamp(p){return p===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(p*1.3)))}get(p){const a=this._key(p),w=this._cache.get(a);return this._clamp(w==null?void 0:w.value)}update(p,a){const w=this._key(p);let m=this._cache.get(w);return m||(m=new y.MovingAverage,this._cache.set(w,m)),m.update(a),this.get(p)}}e.LanguageFeatureRequestDelays=A}),define(me[80],ge([0,1,2,42,178,144,45]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var P;(function(l){l[l.Null=0]="Null",l[l.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));class D{constructor(L,O){this.language=L,this.id=O}}e.LanguageIdentifier=D;var I;(function(l){l[l.NotSet=-1]="NotSet",l[l.None=0]="None",l[l.Italic=1]="Italic",l[l.Bold=2]="Bold",l[l.Underline=4]="Underline"})(I=e.FontStyle||(e.FontStyle={}));var i;(function(l){l[l.None=0]="None",l[l.DefaultForeground=1]="DefaultForeground",l[l.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var A;(function(l){l[l.Other=0]="Other",l[l.Comment=1]="Comment",l[l.String=2]="String",l[l.RegEx=4]="RegEx"})(A=e.StandardTokenType||(e.StandardTokenType={}));var h;(function(l){l[l.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",l[l.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",l[l.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",l[l.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",l[l.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",l[l.ITALIC_MASK=2048]="ITALIC_MASK",l[l.BOLD_MASK=4096]="BOLD_MASK",l[l.UNDERLINE_MASK=8192]="UNDERLINE_MASK",l[l.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",l[l.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",l[l.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",l[l.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",l[l.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",l[l.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",l[l.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",l[l.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",l[l.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",l[l.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(h=e.MetadataConsts||(e.MetadataConsts={}));class p{static getLanguageId(L){return(L&255)>>>0}static getTokenType(L){return(L&1792)>>>8}static getFontStyle(L){return(L&14336)>>>11}static getForeground(L){return(L&8372224)>>>14}static getBackground(L){return(L&4286578688)>>>23}static getClassNameFromMetadata(L){let O=this.getForeground(L),W="mtk"+O,te=this.getFontStyle(L);return te&1&&(W+=" mtki"),te&2&&(W+=" mtkb"),te&4&&(W+=" mtku"),W}static getInlineStyleFromMetadata(L,O){const W=this.getForeground(L),te=this.getFontStyle(L);let se=`color: ${O[W]};`;return te&1&&(se+="font-style: italic;"),te&2&&(se+="font-weight: bold;"),te&4&&(se+="text-decoration: underline;"),se}}e.TokenMetadata=p;var a;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let l=Object.create(null);return l[0]="symbol-method",l[1]="symbol-function",l[2]="symbol-constructor",l[3]="symbol-field",l[4]="symbol-variable",l[5]="symbol-class",l[6]="symbol-struct",l[7]="symbol-interface",l[8]="symbol-module",l[9]="symbol-property",l[10]="symbol-event",l[11]="symbol-operator",l[12]="symbol-unit",l[13]="symbol-value",l[14]="symbol-constant",l[15]="symbol-enum",l[16]="symbol-enum-member",l[17]="symbol-keyword",l[27]="symbol-snippet",l[18]="symbol-text",l[19]="symbol-color",l[20]="symbol-file",l[21]="symbol-reference",l[22]="symbol-customcolor",l[23]="symbol-folder",l[24]="symbol-type-parameter",l[25]="account",l[26]="issues",function(L){const O=l[L];let W=O&&y.iconRegistry.get(O);return W||(console.info("No codicon found for CompletionItemKind "+L),W=y.Codicon.symbolProperty),W.classNames}}(),e.completionKindFromString=function(){let l=Object.create(null);return l.method=0,l.function=1,l.constructor=2,l.field=3,l.variable=4,l.class=5,l.struct=6,l.interface=7,l.module=8,l.property=9,l.event=10,l.operator=11,l.unit=12,l.value=13,l.constant=14,l.enum=15,l["enum-member"]=16,l.enumMember=16,l.keyword=17,l.snippet=27,l.text=18,l.color=19,l.file=20,l.reference=21,l.customcolor=22,l.folder=23,l["type-parameter"]=24,l.typeParameter=24,l.account=25,l.issue=26,function(L,O){let W=l[L];return typeof W=="undefined"&&!O&&(W=9),W}}();var w;(function(l){l[l.Deprecated=1]="Deprecated"})(w=e.CompletionItemTag||(e.CompletionItemTag={}));var m;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(m=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var b;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(_=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var c;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(c=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(l){return l&&v.URI.isUri(l.uri)&&R.Range.isIRange(l.range)&&(R.Range.isIRange(l.originSelectionRange)||R.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=t;var n;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var s;(function(l){l[l.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var r;(function(l){const L=new Map;L.set("file",0),L.set("module",1),L.set("namespace",2),L.set("package",3),L.set("class",4),L.set("method",5),L.set("property",6),L.set("field",7),L.set("constructor",8),L.set("enum",9),L.set("interface",10),L.set("function",11),L.set("variable",12),L.set("constant",13),L.set("string",14),L.set("number",15),L.set("boolean",16),L.set("array",17),L.set("object",18),L.set("key",19),L.set("null",20),L.set("enum-member",21),L.set("struct",22),L.set("event",23),L.set("operator",24),L.set("type-parameter",25);const O=new Map;O.set(0,"file"),O.set(1,"module"),O.set(2,"namespace"),O.set(3,"package"),O.set(4,"class"),O.set(5,"method"),O.set(6,"property"),O.set(7,"field"),O.set(8,"constructor"),O.set(9,"enum"),O.set(10,"interface"),O.set(11,"function"),O.set(12,"variable"),O.set(13,"constant"),O.set(14,"string"),O.set(15,"number"),O.set(16,"boolean"),O.set(17,"array"),O.set(18,"object"),O.set(19,"key"),O.set(20,"null"),O.set(21,"enum-member"),O.set(22,"struct"),O.set(23,"event"),O.set(24,"operator"),O.set(25,"type-parameter");function W(N){return L.get(N)}l.fromString=W;function te(N){return O.get(N)}l.toString=te;function se(N,V){const x=O.get(N);let k=x&&y.iconRegistry.get("symbol-"+x);return k||(console.info("No codicon found for SymbolKind "+N),k=y.Codicon.symbolProperty),`${V?"inline":"block"} ${k.classNames}`}l.toCssClassName=se})(r=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(L){this.value=L}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var g;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(g=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var f;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(f=e.CommentMode||(e.CommentMode={}));var S;(function(l){l[l.Other=0]="Other",l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(S=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new C.LanguageFeatureRegistry,e.RenameProviderRegistry=new C.LanguageFeatureRegistry,e.CompletionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new C.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new C.LanguageFeatureRegistry,e.HoverProviderRegistry=new C.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new C.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new C.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new C.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new C.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new C.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.LinkProviderRegistry=new C.LanguageFeatureRegistry,e.ColorProviderRegistry=new C.LanguageFeatureRegistry,e.SelectionRangeRegistry=new C.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var E;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(E=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[179],ge([0,1,6,12,4,3,56,54]),function(K,e,v,R,C,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,C.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,I){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!I)throw new Error("invalid command");return this.registerCommand({id:D,handler:I})}if(D.description){const a=[];for(let m of D.description.args)a.push(m.constraint);const w=D.handler;D.handler=function(m,...b){return(0,R.validateConstraints)(b,a),w(m,...b)}}const{id:i}=D;let A=this._commands.get(i);A||(A=new y.LinkedList,this._commands.set(i,A));let h=A.unshift(D),p=(0,v.toDisposable)(()=>{h();const a=this._commands.get(i);(a==null?void 0:a.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),p}registerCommandAlias(D,I){return e.CommandsRegistry.registerCommand(D,(i,...A)=>i.get(e.ICommandService).executeCommand(I,...A))}getCommand(D){const I=this._commands.get(D);if(!(!I||I.isEmpty()))return P.Iterable.first(I)}getCommands(){const D=new Map;for(const I of this._commands.keys()){const i=this.getCommand(I);i&&D.set(I,i)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>v.Disposable.None,onDidExecuteCommand:()=>v.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(me[81],ge([0,1,8,4,11]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=C.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",C.isMacintosh),y.set("isLinux",C.isLinux),y.set("isWindows",C.isWindows),y.set("isWeb",C.isWeb),y.set("isMacNative",C.isMacintosh&&!C.isWeb),y.set("isEdge",T.indexOf("Edg/")>=0),y.set("isFirefox",T.indexOf("Firefox")>=0),y.set("isChrome",T.indexOf("Chrome")>=0),y.set("isSafari",T.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var D;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return A.INSTANCE}static true(){return h.INSTANCE}static has(l){return p.create(l)}static equals(l,L){return a.create(l,L)}static notEquals(l,L){return b.create(l,L)}static regex(l,L){return n.create(l,L)}static in(l,L){return w.create(l,L)}static not(l){return _.create(l)}static and(...l){return r.create(l)}static or(...l){return o.create(l)}static greater(l,L){return u.create(l,L)}static less(l,L){return d.create(l,L)}static deserialize(l,L=!1){if(!!l)return this._deserializeOrExpression(l,L)}static _deserializeOrExpression(l,L){let O=l.split("||");return o.create(O.map(W=>this._deserializeAndExpression(W,L)))}static _deserializeAndExpression(l,L){let O=l.split("&&");return r.create(O.map(W=>this._deserializeOne(W,L)))}static _deserializeOne(l,L){if(l=l.trim(),l.indexOf("!=")>=0){let O=l.split("!=");return b.create(O[0].trim(),this._deserializeValue(O[1],L))}if(l.indexOf("==")>=0){let O=l.split("==");return a.create(O[0].trim(),this._deserializeValue(O[1],L))}if(l.indexOf("=~")>=0){let O=l.split("=~");return n.create(O[0].trim(),this._deserializeRegexValue(O[1],L))}if(l.indexOf(" in ")>=0){let O=l.split(" in ");return w.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(l)){const O=l.split(">=");return c.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(l)){const O=l.split(">");return u.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(l)){const O=l.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(l)){const O=l.split("<");return d.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(l)?_.create(l.substr(1).trim()):p.create(l)}static _deserializeValue(l,L){if(l=l.trim(),l==="true")return!0;if(l==="false")return!1;let O=/^'([^']*)'$/.exec(l);return O?O[1].trim():l}static _deserializeRegexValue(l,L){if((0,v.isFalsyOrWhitespace)(l)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=l.indexOf("/"),W=l.lastIndexOf("/");if(O===W||O<0){if(L)throw new Error(`bad regexp-value '${l}', missing /-enclosure`);return console.warn(`bad regexp-value '${l}', missing /-enclosure`),null}let te=l.slice(O+1,W),se=l[W+1]==="i"?"i":"";try{return new RegExp(te,se)}catch(N){if(L)throw new Error(`bad regexp-value '${l}', parse error: ${N}`);return console.warn(`bad regexp-value '${l}', parse error: ${N}`),null}}}e.ContextKeyExpr=I;function i(E,l){return E.cmp(l)}class A{constructor(){this.type=0}cmp(l){return this.type-l.type}equals(l){return l.type===this.type}evaluate(l){return!1}serialize(){return"false"}keys(){return[]}map(l){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=A,A.INSTANCE=new A;class h{constructor(){this.type=1}cmp(l){return this.type-l.type}equals(l){return l.type===this.type}evaluate(l){return!0}serialize(){return"true"}keys(){return[]}map(l){return this}negate(){return A.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class p{constructor(l){this.key=l,this.type=2}static create(l){const L=y.get(l);return typeof L=="boolean"?L?h.INSTANCE:A.INSTANCE:new p(l)}cmp(l){return l.type!==this.type?this.type-l.type:f(this.key,l.key)}equals(l){return l.type===this.type?this.key===l.key:!1}evaluate(l){return!!l.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(l){return l.mapDefined(this.key)}negate(){return _.create(this.key)}}e.ContextKeyDefinedExpr=p;class a{constructor(l,L){this.key=l,this.value=L,this.type=4}static create(l,L){if(typeof L=="boolean")return L?p.create(l):_.create(l);const O=y.get(l);return typeof O=="boolean"?L===(O?"true":"false")?h.INSTANCE:A.INSTANCE:new a(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:S(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return l.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(l){return l.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class w{constructor(l,L){this.key=l,this.valueKey=L,this.type=10}static create(l,L){return new w(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:S(this.key,this.valueKey,l.key,l.valueKey)}equals(l){return l.type===this.type?this.key===l.key&&this.valueKey===l.valueKey:!1}evaluate(l){const L=l.getValue(this.valueKey),O=l.getValue(this.key);return Array.isArray(L)?L.indexOf(O)>=0:typeof O=="string"&&typeof L=="object"&&L!==null?P.call(L,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(l){return l.mapIn(this.key,this.valueKey)}negate(){return m.create(this)}}e.ContextKeyInExpr=w;class m{constructor(l){this._actual=l,this.type=11}static create(l){return new m(l)}cmp(l){return l.type!==this.type?this.type-l.type:this._actual.cmp(l._actual)}equals(l){return l.type===this.type?this._actual.equals(l._actual):!1}evaluate(l){return!this._actual.evaluate(l)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(l){return new m(this._actual.map(l))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class b{constructor(l,L){this.key=l,this.value=L,this.type=5}static create(l,L){if(typeof L=="boolean")return L?_.create(l):p.create(l);const O=y.get(l);return typeof O=="boolean"?L===(O?"true":"false")?A.INSTANCE:h.INSTANCE:new b(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:S(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return l.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(l){return l.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class _{constructor(l){this.key=l,this.type=3}static create(l){const L=y.get(l);return typeof L=="boolean"?L?A.INSTANCE:h.INSTANCE:new _(l)}cmp(l){return l.type!==this.type?this.type-l.type:f(this.key,l.key)}equals(l){return l.type===this.type?this.key===l.key:!1}evaluate(l){return!l.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(l){return l.mapNot(this.key)}negate(){return p.create(this.key)}}e.ContextKeyNotExpr=_;class u{constructor(l,L){this.key=l,this.value=L,this.type=12}static create(l,L){return new u(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:S(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(l){return l.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class c{constructor(l,L){this.key=l,this.value=L,this.type=13}static create(l,L){return new c(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:S(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(l){return l.mapGreaterEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class d{constructor(l,L){this.key=l,this.value=L,this.type=14}static create(l,L){return new d(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:S(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(l){return l.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=d;class t{constructor(l,L){this.key=l,this.value=L,this.type=15}static create(l,L){return new t(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:S(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(l){return l.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(l,L){this.key=l,this.regexp=L,this.type=7}static create(l,L){return new n(l,L)}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.key<l.key)return-1;if(this.key>l.key)return 1;const L=this.regexp?this.regexp.source:"",O=l.regexp?l.regexp.source:"";return L<O?-1:L>O?1:0}equals(l){if(l.type===this.type){const L=this.regexp?this.regexp.source:"",O=l.regexp?l.regexp.source:"";return this.key===l.key&&L===O}return!1}evaluate(l){let L=l.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const l=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${l}`}keys(){return[this.key]}map(l){return l.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=n;class s{constructor(l){this._actual=l,this.type=8}static create(l){return new s(l)}cmp(l){return l.type!==this.type?this.type-l.type:this._actual.cmp(l._actual)}equals(l){return l.type===this.type?this._actual.equals(l._actual):!1}evaluate(l){return!this._actual.evaluate(l)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(l){return new s(this._actual.map(l))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class r{constructor(l){this.expr=l,this.type=6}static create(l){return r._normalizeArr(l)}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.expr.length<l.expr.length)return-1;if(this.expr.length>l.expr.length)return 1;for(let L=0,O=this.expr.length;L<O;L++){const W=i(this.expr[L],l.expr[L]);if(W!==0)return W}return 0}equals(l){if(l.type===this.type){if(this.expr.length!==l.expr.length)return!1;for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].equals(l.expr[L]))return!1;return!0}return!1}evaluate(l){for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].evaluate(l))return!1;return!0}static _normalizeArr(l){const L=[];let O=!1;for(const W of l)if(!!W){if(W.type===1){O=!0;continue}if(W.type===0)return A.INSTANCE;if(W.type===6){L.push(...W.expr);continue}L.push(W)}if(L.length===0&&O)return h.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];for(L.sort(i);L.length>1;){const W=L[L.length-1];if(W.type!==9)break;L.pop();const te=L.pop(),se=o.create(W.expr.map(N=>r.create([N,te])));se&&(L.push(se),L.sort(i))}return L.length===1?L[0]:new r(L)}}serialize(){return this.expr.map(l=>l.serialize()).join(" && ")}keys(){const l=[];for(let L of this.expr)l.push(...L.keys());return l}map(l){return new r(this.expr.map(L=>L.map(l)))}negate(){let l=[];for(let L of this.expr)l.push(L.negate());return o.create(l)}}e.ContextKeyAndExpr=r;class o{constructor(l){this.expr=l,this.type=9}static create(l){const L=o._normalizeArr(l);if(L.length!==0)return L.length===1?L[0]:new o(L)}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.expr.length<l.expr.length)return-1;if(this.expr.length>l.expr.length)return 1;for(let L=0,O=this.expr.length;L<O;L++){const W=i(this.expr[L],l.expr[L]);if(W!==0)return W}return 0}equals(l){if(l.type===this.type){if(this.expr.length!==l.expr.length)return!1;for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].equals(l.expr[L]))return!1;return!0}return!1}evaluate(l){for(let L=0,O=this.expr.length;L<O;L++)if(this.expr[L].evaluate(l))return!0;return!1}static _normalizeArr(l){let L=[],O=!1;if(l){for(let W=0,te=l.length;W<te;W++){const se=l[W];if(!!se){if(se.type===0){O=!0;continue}if(se.type===1)return[h.INSTANCE];if(se.type===9){L=L.concat(se.expr);continue}L.push(se)}}if(L.length===0&&O)return[A.INSTANCE];L.sort(i)}return L}serialize(){return this.expr.map(l=>l.serialize()).join(" || ")}keys(){const l=[];for(let L of this.expr)l.push(...L.keys());return l}map(l){return new o(this.expr.map(L=>L.map(l)))}negate(){let l=[];for(let O of this.expr)l.push(O.negate());const L=O=>O.type===9?O.expr:[O];for(;l.length>1;){const O=l.shift(),W=l.shift(),te=[];for(const se of L(O))for(const N of L(W))te.push(I.and(se,N));l.unshift(I.or(...te))}return l[0]}}e.ContextKeyOrExpr=o;class g extends p{constructor(l,L,O){super(l);this._defaultValue=L,typeof O=="object"?g._info.push(Object.assign(Object.assign({},O),{key:l})):O!==!0&&g._info.push({key:l,description:O,type:L!=null?typeof L:void 0})}static all(){return g._info.values()}bindTo(l){return l.createKey(this.key,this._defaultValue)}getValue(l){return l.getContextKeyValue(this.key)}toNegated(){return I.not(this.key)}isEqualTo(l){return I.equals(this.key,l)}notEqualsTo(l){return I.notEquals(this.key,l)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(E,l){return E<l?-1:E>l?1:0}function S(E,l,L,O){return E<L?-1:E>L?1:l<O?-1:l>O?1:0}}),define(me[180],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(me[181],ge([0,1,153,4,10]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function T(A){return A&&typeof A=="object"&&typeof A.id=="string"&&(!A.uuid||typeof A.uuid=="string")}e.isIExtensionIdentifier=T;var y;(function(A){A[A.NoneOrRelevance=0]="NoneOrRelevance",A[A.LastUpdatedDate=1]="LastUpdatedDate",A[A.Title=2]="Title",A[A.PublisherName=3]="PublisherName",A[A.InstallCount=4]="InstallCount",A[A.PublishedDate=5]="PublishedDate",A[A.AverageRating=6]="AverageRating",A[A.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var P;(function(A){A[A.Default=0]="Default",A[A.Ascending=1]="Ascending",A[A.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var D;(function(A){A.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var I;(function(A){A[A.None=0]="None",A[A.Install=1]="Install",A[A.Update=2]="Update"})(I=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(h,p){super(h);this.code=p}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,8,4]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function C(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkpaceSupportTypeMessage=C;function T(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));class P{constructor(A){this.value=A,this._lower=A.toLowerCase()}static equals(A,h){if(typeof A=="undefined"||A===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof A=="string"||typeof h=="string"){let p=typeof A=="string"?A:A.value,a=typeof h=="string"?h:h.value;return v.equalsIgnoreCase(p,a)}return A._lower===h._lower}static toKey(A){return typeof A=="string"?A.toLowerCase():A._lower}}e.ExtensionIdentifier=P;function D(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function I(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=I,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[182],ge([0,1,8,26]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(p,a){return p.uuid&&a.uuid?p.uuid===a.uuid:p.id===a.id?!0:(0,v.compareIgnoreCase)(p.id,a.id)===0}e.areSameExtensions=C;class T{constructor(a,w){this.version=w,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof T?C(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=T;function y(p,a){return`${p}.${a}`}e.getExtensionId=y;function P(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function D(p,a){return P(y(p,a))}e.getGalleryExtensionId=D;function I(p,a){const w=[],m=b=>{for(const _ of w)if(_.some(u=>C(a(u),a(b))))return _;return null};for(const b of p){const _=m(b);_?_.push(b):w.push([b])}return w}e.groupByExtension=I;function i(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function A(p){return Object.assign({id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0)},p.telemetryData)}e.getGalleryExtensionTelemetryData=A,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function h(p){const a=new Set;for(const w of p)w.malicious&&a.add(w.id.id);return a}e.getMaliciousExtensionsSet=h}),define(me[183],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(me[43],ge([0,1,156,9,2,4,8,12,23]),function(K,e,v,R,C,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function I(N){return N.create===!0}e.isFileOpenForWriteOptions=I;var i;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var A;(function(N){N[N.Readonly=1]="Readonly"})(A=e.FilePermission||(e.FilePermission={}));var h;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(h=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=p;function a(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=a;function w(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function m(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=m;var b;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class _ extends Error{constructor(V,x){super(V);this.code=x}}e.FileSystemProviderError=_;function u(N,V){const x=new _(N.toString(),V);return d(x,V),x}e.createFileSystemProviderError=u;function c(N){return N||u((0,v.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=c;function d(N,V){return N.name=V?`${V} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=d;function t(N){if(!N)return b.Unknown;if(N instanceof _)return N.code;const V=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!V)return b.Unknown;switch(V[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function n(N){if(N instanceof S)return N.fileOperationResult;switch(t(N)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var s;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class r{constructor(V,x,k){this.resource=V,this.operation=x,this.target=k}isOperation(V){return this.operation===V}}e.FileOperationEvent=r;var o;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class g{constructor(V,x){this.ignorePathCasing=x,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=V;for(const k of V)switch(k.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(k.resource,k);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(k.resource,k);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(k.resource,k);break}}contains(V,...x){return this.doContains(V,{includeChildren:!1},...x)}affects(V,...x){return this.doContains(V,{includeChildren:!0},...x)}doContains(V,x,...k){var U,F,M,$,H,X;if(!V)return!1;const ae=k.length>0;return!!((!ae||k.includes(1))&&(((U=this.added)===null||U===void 0?void 0:U.get(V))||x.includeChildren&&((F=this.added)===null||F===void 0?void 0:F.findSuperstr(V)))||(!ae||k.includes(0))&&(((M=this.updated)===null||M===void 0?void 0:M.get(V))||x.includeChildren&&(($=this.updated)===null||$===void 0?void 0:$.findSuperstr(V)))||(!ae||k.includes(2))&&(((H=this.deleted)===null||H===void 0?void 0:H.findSubstr(V))||x.includeChildren&&((X=this.deleted)===null||X===void 0?void 0:X.findSuperstr(V))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(V){const x=[],k=V===1?this.added:V===0?this.updated:this.deleted;if(k)for(const[,U]of k)x.push(U);return x}filter(V){return new g(this.changes.filter(x=>V(x)),this.ignorePathCasing)}}e.FileChangesEvent=g;function f(N,V,x){return!N||!V||N===V||V.length>N.length?!1:(V.charAt(V.length-1)!==R.sep&&(V+=R.sep),x?(0,y.startsWithIgnoreCase)(N,V):N.indexOf(V)===0)}e.isParent=f;class S extends Error{constructor(V,x,k){super(V);this.fileOperationResult=x,this.options=k}static isFileOperationError(V){return V instanceof Error&&!(0,P.isUndefinedOrNull)(V.fileOperationResult)}}e.FileOperationError=S;var E;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(E=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var l;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(l=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=L;async function O(N,V){if(!V.canHandleResource(C.URI.from({scheme:N.scheme})))return new Promise(x=>{const k=V.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===N.scheme&&U.added&&(k.dispose(),x())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class W{static formatSize(V){return(0,P.isNumber)(V)||(V=0),V<W.KB?(0,v.localize)(1,null,V.toFixed(0)):V<W.MB?(0,v.localize)(2,null,(V/W.KB).toFixed(2)):V<W.GB?(0,v.localize)(3,null,(V/W.MB).toFixed(2)):V<W.TB?(0,v.localize)(4,null,(V/W.GB).toFixed(2)):(0,v.localize)(5,null,(V/W.TB).toFixed(2))}}e.ByteSize=W,W.KB=1024,W.MB=W.KB*W.KB,W.GB=W.MB*W.KB,W.TB=W.GB*W.KB;var te;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(te=e.Arch||(e.Arch={}));function se(N){return{maxFileSize:N===0?300*W.MB:16*W.GB,maxHeapSize:N===0?700*W.MB:2*700*W.MB}}e.getPlatformLimits=se}),define(me[82],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...C){this._entries=new Map;for(let[T,y]of C)this.set(T,y)}set(C,T){const y=this._entries.get(C);return this._entries.set(C,T),y}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=v}),define(me[184],ge([0,1,17,176,111,4,82,13]),function(K,e,v,R,C,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class I extends Error{constructor(a){var w;super("cyclic dependency between services");this.message=(w=a.findCycleSlow())!==null&&w!==void 0?w:`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class i{constructor(a=new y.ServiceCollection,w=!1,m){this._activeInstantiations=new Set,this._services=a,this._strict=w,this._parent=m,this._services.set(T.IInstantiationService,this)}createChild(a){return new i(a,this._strict,this)}invokeFunction(a,...w){let m=h.traceInvocation(a),b=!1;try{return a({get:(u,c)=>{if(b)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const d=this._getOrCreateServiceInstance(u,m);if(!d&&c!==T.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return d}},...w)}finally{b=!0,m.stop()}}createInstance(a,...w){let m,b;return a instanceof C.SyncDescriptor?(m=h.traceCreation(a.ctor),b=this._createInstance(a.ctor,a.staticArguments.concat(w),m)):(m=h.traceCreation(a),b=this._createInstance(a,w,m)),m.stop(),b}_createInstance(a,w=[],m){let b=T._util.getServiceDependencies(a).sort((c,d)=>c.index-d.index),_=[];for(const c of b){let d=this._getOrCreateServiceInstance(c.id,m);if(!d&&this._strict&&!c.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${c.id}.`);_.push(d)}let u=b.length>0?b[0].index:w.length;if(w.length!==u){console.warn(`[createInstance] First service dependency of ${a.name} at position ${u+1} conflicts with ${w.length} static arguments`);let c=u-w.length;c>0?w=w.concat(new Array(c)):w=w.slice(0,u)}return new a(...[...w,..._])}_setServiceInstance(a,w){if(this._services.get(a)instanceof C.SyncDescriptor)this._services.set(a,w);else if(this._parent)this._parent._setServiceInstance(a,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let w=this._services.get(a);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):w}_getOrCreateServiceInstance(a,w){let m=this._getServiceInstanceOrDescriptor(a);return m instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,m,w.branch(a,!0)):(w.branch(a,!1),m)}_safeCreateAndCacheServiceInstance(a,w,m){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,w,m)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,w,m){const b=new R.Graph(c=>c.id.toString());let _=0;const u=[{id:a,desc:w,_trace:m}];for(;u.length;){const c=u.pop();if(b.lookupOrInsertNode(c),_++>1e3)throw new I(b);for(let d of T._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(d.id);if(!t&&!d.optional&&console.warn(`[createInstance] ${a} depends on ${d.id} which is NOT registered.`),t instanceof C.SyncDescriptor){const n={id:d.id,desc:t,_trace:c._trace.branch(d.id,!0)};b.insertEdge(c,n),u.push(n)}}}for(;;){const c=b.roots();if(c.length===0){if(!b.isEmpty())throw new I(b);break}for(const{data:d}of c){if(this._getServiceInstanceOrDescriptor(d.id)instanceof C.SyncDescriptor){const n=this._createServiceInstanceWithOwner(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this._setServiceInstance(d.id,n)}b.removeNode(d)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,w,m=[],b,_){if(this._services.get(a)instanceof C.SyncDescriptor)return this._createServiceInstance(w,m,b,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,w,m,b,_);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(a,w=[],m,b){if(m){const _=new P.IdleValue(()=>this._createInstance(a,w,b));return new Proxy(Object.create(null),{get(u,c){if(c in u)return u[c];let d=_.value,t=d[c];return typeof t!="function"||(t=t.bind(d),u[c]=t),t},set(u,c,d){return _.value[c]=d,!0}})}else return this._createInstance(a,w,b)}}e.InstantiationService=i;var A;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(A||(A={}));class h{constructor(a,w){this.type=a,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return D?new h(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(a){return D?new h(0,a.name):h._None}branch(a,w){let m=new h(2,a.toString());return this._dep.push([a,w,m]),m}stop(){let a=Date.now()-this._start;h._totals+=a;let w=!1;function m(_,u){let c=[],d=new Array(_+1).join("	");for(const[t,n,s]of u._dep)if(n&&s){w=!0,c.push(`${d}CREATES -> ${t}`);let r=m(_+1,s);r&&c.push(r)}else c.push(`${d}uses -> ${t}`);return c.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(a>2||w)&&console.log(b.join(`
`))}}h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(me[14],ge([0,1,4,6,11,3,60]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function P(){return new Date().toISOString()}var D;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class I extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class i extends I{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(D.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(D.Error,this.format(s))}else this.log(D.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let s=0;s<t.length;s++){let r=t[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(o){}n+=(s>0?" ":"")+r}return n}}e.AbstractMessageLogger=i;class A extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}debug(t,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}info(t,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}warn(t,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...n):console.warn(`[main ${P()}]`,t,...n))}error(t,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}critical(t,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=A;class h extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=h;class p extends I{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class a extends I{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=a;class w extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=w;class m extends R.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(n==null?void 0:n.always)?D.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=m;class b{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=b;function _(d){if(d.verbose)return D.Trace;if(typeof d.logLevel=="string"){const t=u(d.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function u(d){switch(d){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=u;function c(d){switch(d){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=c}),define(me[112],ge([0,1,14,43]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function C(D,I,i,A){try{const h=await new Promise((p,a)=>{K(["spdlog"],p,a)});return h.setFlushOn(v.LogLevel.Info),h.createAsyncRotatingLogger(D,I,i,A)}catch(h){console.error(h)}return null}function T(D,I,i,A){const h=K.__$__nodeRequire("spdlog");return h.setFlushOn(v.LogLevel.Info),h.createRotatingLogger(D,I,i,A)}e.createRotatingLogger=T;function y(D,I,i){switch(I){case v.LogLevel.Trace:D.trace(i);break;case v.LogLevel.Debug:D.debug(i);break;case v.LogLevel.Info:D.info(i);break;case v.LogLevel.Warning:D.warn(i);break;case v.LogLevel.Error:D.error(i);break;case v.LogLevel.Critical:D.critical(i);break;default:throw new Error("Invalid log level")}}class P extends v.AbstractMessageLogger{constructor(I,i,A,h){super();this.name=I,this.filepath=i,this.rotating=A,this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const I=this.rotating?6:1,i=30/I*R.ByteSize.MB;return C(this.name,this.filepath,i,I).then(A=>{if(A){this._logger=A,this._logger.setLevel(this.getLevel());for(const{level:h,message:p}of this.buffer)y(this._logger,h,p);this.buffer=[]}})}log(I,i){this._logger?y(this._logger,I,i):this.getLevel()<=I&&this.buffer.push({level:I,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(me[113],ge([0,1,4,157,57]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var y;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function I(a,w){return w-a}D.compare=I;const i=Object.create(null);i[D.Error]=(0,R.localize)(0,null),i[D.Warning]=(0,R.localize)(1,null),i[D.Info]=(0,R.localize)(2,null);function A(a){return i[a]||""}D.toString=A;function h(a){switch(a){case C.default.Error:return D.Error;case C.default.Warning:return D.Warning;case C.default.Info:return D.Info;case C.default.Ignore:return D.Hint}}D.fromSeverity=h;function p(a){switch(a){case D.Error:return C.default.Error;case D.Warning:return C.default.Warning;case D.Info:return C.default.Info;case D.Hint:return C.default.Ignore}}D.toSeverity=p}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(D){const I="";function i(h){return A(h,!0)}D.makeKey=i;function A(h,p){let a=[I];return h.source?a.push(h.source.replace("\xA6","\\\xA6")):a.push(I),h.code?typeof h.code=="string"?a.push(h.code.replace("\xA6","\\\xA6")):a.push(h.code.value.replace("\xA6","\\\xA6")):a.push(I),h.severity!==void 0&&h.severity!==null?a.push(y.toString(h.severity)):a.push(I),h.message&&p?a.push(h.message.replace("\xA6","\\\xA6")):a.push(I),h.startLineNumber!==void 0&&h.startLineNumber!==null?a.push(h.startLineNumber.toString()):a.push(I),h.startColumn!==void 0&&h.startColumn!==null?a.push(h.startColumn.toString()):a.push(I),h.endLineNumber!==void 0&&h.endLineNumber!==null?a.push(h.endLineNumber.toString()):a.push(I),h.endColumn!==void 0&&h.endColumn!==null?a.push(h.endColumn.toString()):a.push(I),a.push(I),a.join("\xA6")}D.makeKeyOptionalMessage=A})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,v.createDecorator)("markerService")}),define(me[185],ge([0,1,57,4,3]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=v.default,e.INotificationService=(0,R.createDecorator)("notificationService");var T;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new D,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=P;class D{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=D}),define(me[186],ge([0,1,6,8,2,4]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return v.Disposable.None},registerValidator(){return v.Disposable.None},registerExternalUriResolver(){return v.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return v.Disposable.None},async open(){return!1},async resolveExternalUri(P){return{resolved:P,dispose(){}}}});function y(P,D){return C.URI.isUri(P)?(0,R.equalsIgnoreCase)(P.scheme,D):(0,R.startsWithIgnoreCase)(P,D+":")}e.matchesScheme=y}),define(me[187],ge([0,1,10,11,36,25]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const P=R.globals.vscode.context.configuration();if(P)y=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(K==null?void 0:K.__$__nodeRequire)=="function"){const P=(0,T.dirname)(v.FileAccess.asFileUri("",K));y=K.__$__nodeRequire((0,T.joinPath)(P,"product.json").fsPath);const D=K.__$__nodeRequire((0,T.joinPath)(P,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`}),Object.assign(y,{version:D.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.57.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=y});var He=this&&this.__param||function(K,e){return function(v,R){e(v,R,K)}};define(me[114],ge([0,1,4,21,6,13]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,v.createDecorator)("progressService");var y;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(A){this.callback=A}get value(){return this._value}report(A){this._value=A,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let D=class extends C.Disposable{constructor(A,h){super();this.deferred=new T.DeferredPromise,h.withProgress(A,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(A){this.reporter?this.reporter.report(A):this.lastStep=A}};D=qe([He(1,e.IProgressService)],D),e.UnmanagedProgress=D;class I extends C.Disposable{constructor(A){super();this.progressIndicator=A,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(A){this.stop();const h=++this.currentOperationId,p=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{h===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},A),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:h,token:p.token,stop:()=>this.doStop(h),isCurrent:()=>this.currentOperationId===h}}stop(){this.doStop(this.currentOperationId)}doStop(A){this.currentOperationId===A&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,v.createDecorator)("editorProgressService")}),define(me[38],ge([0,1,12,51]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(y,P){R.ok(v.isString(y)),R.ok(v.isObject(P)),R.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,P)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new C}),define(me[115],ge([0,1,38,3]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,I){this.schemasById[C(D)]=I,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new T;v.Registry.add(e.Extensions.JSONContribution,y)}),define(me[83],ge([0,1,152,3,38,12,115]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=C.Registry.as(y.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,_=!0){this.registerConfigurations([b],_)}registerConfigurations(b,_=!0){const u=[];b.forEach(c=>{u.push(...this.validateAndRegisterProperties(c,_,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(b){const _=[],u=c=>{if(c.properties)for(const d in c.properties)_.push(d),delete this.configurationProperties[d],this.removeFromSchema(d,c.properties[d]);c.allOf&&c.allOf.forEach(d=>u(d))};for(const c of b){u(c);const d=this.configurationContributors.indexOf(c);d!==-1&&this.configurationContributors.splice(d,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}registerDefaultConfigurations(b){const _=[],u=[];for(const c of b)for(const d in c)if(_.push(d),e.OVERRIDE_PROPERTY_PATTERN.test(d)){this.defaultValues[d]=Object.assign(Object.assign({},this.defaultValues[d]||{}),c[d]);const t={type:"object",default:this.defaultValues[d],description:v.localize(1,null,d),$ref:e.resourceLanguageSettingsSchemaId};u.push(A(d)),this.configurationProperties[d]=t,this.defaultLanguageConfigurationOverridesNode.properties[d]=t}else{this.defaultValues[d]=c[d];const t=this.configurationProperties[d];t&&(this.updatePropertyDefaultValue(d,t),this.updateSchema(d,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}deregisterDefaultConfigurations(b){const _=[];for(const u of b)for(const c in u)if(_.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const d=this.configurationProperties[c];d&&(this.updatePropertyDefaultValue(c,d),this.updateSchema(c,d))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const _ of b)this.overrideIdentifiers.add(_);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,_=!0,u,c=3){var d;c=T.isUndefinedOrNull(b.scope)?c:b.scope;let t=[],n=b.properties;if(n)for(let r in n){if(_&&a(r)){delete n[r];continue}const o=n[r];if(this.updatePropertyDefaultValue(r,o),e.OVERRIDE_PROPERTY_PATTERN.test(r)?o.scope=void 0:(o.scope=T.isUndefinedOrNull(o.scope)?c:o.scope,o.restricted=T.isUndefinedOrNull(o.restricted)?!!((d=u==null?void 0:u.restrictedConfigurations)===null||d===void 0?void 0:d.includes(r)):o.restricted),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),t.push(r)}let s=b.allOf;if(s)for(let r of s)t.push(...this.validateAndRegisterProperties(r,_,u,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const _=u=>{let c=u.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let d=u.allOf;d&&d.forEach(_)};_(b)}updateSchema(b,_){switch(e.allSettings.properties[b]=_,_.scope){case 1:e.applicationSettings.properties[b]=_;break;case 2:e.machineSettings.properties[b]=_;break;case 6:e.machineOverridableSettings.properties[b]=_;break;case 3:e.windowSettings.properties[b]=_;break;case 4:e.resourceSettings.properties[b]=_;break;case 5:e.resourceSettings.properties[b]=_,this.resourceLanguageSettingsSchema.properties[b]=_;break}}removeFromSchema(b,_){switch(delete e.allSettings.properties[b],_.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const _=`[${b}]`,u={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(_,u),e.allSettings.properties[_]=u,e.applicationSettings.properties[_]=u,e.machineSettings.properties[_]=u,e.machineOverridableSettings.properties[_]=u,e.windowSettings.properties[_]=u,e.resourceSettings.properties[_]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,_){let u=this.defaultValues[b];T.isUndefined(u)&&(u=_.default),T.isUndefined(u)&&(u=h(_.type)),_.default=u}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function A(m){return m.substring(1,m.length-1)}e.overrideIdentifierFromKey=A;function h(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const p=new I;C.Registry.add(e.Extensions.Configuration,p);function a(m){return m.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(m)?v.localize(5,null,m):p.getConfigurationProperties()[m]!==void 0?v.localize(6,null,m):null:v.localize(4,null)}e.validateProperty=a;function w(){const m=[],b=p.getConfigurationProperties();for(const _ of Object.keys(b))m.push([_,b[_].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=w}),define(me[84],ge([0,1,24,12,2,38,4,83]),function(K,e,v,R,C,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function D(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof C.URI)}e.isConfigurationOverrides=D;var I;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function A(n,s){const r=s?n?s.keys.filter(L=>n.keys.indexOf(L)===-1):[...s.keys]:[],o=n?s?n.keys.filter(L=>s.keys.indexOf(L)===-1):[...n.keys]:[],g=[];if(s&&n){for(const L of n.keys)if(s.keys.indexOf(L)!==-1){const O=b(n.contents,L),W=b(s.contents,L);v.equals(O,W)||g.push(L)}}const f=[],S=L=>{const O={};for(const W of L)for(const te of W.identifiers)O[d(te)]=W;return O},E=s?S(s.overrides):{},l=n?S(n.overrides):{};if(Object.keys(E).length)for(const L of r){const O=E[L];O&&f.push([(0,P.overrideIdentifierFromKey)(L),O.keys])}if(Object.keys(l).length)for(const L of o){const O=l[L];O&&f.push([(0,P.overrideIdentifierFromKey)(L),O.keys])}if(Object.keys(E).length&&Object.keys(l).length)for(const L of g){const O=l[L],W=E[L];if(O&&W){const te=A({contents:O.contents,keys:O.keys,overrides:[]},{contents:W.contents,keys:W.keys,overrides:[]});f.push([(0,P.overrideIdentifierFromKey)(L),[...te.added,...te.removed,...te.updated]])}}return{added:r,removed:o,updated:g,overrides:f}}e.compare=A;function h(n,s){const r=[];for(const o of Object.keys(n))if(P.OVERRIDE_PROPERTY_PATTERN.test(o)){const g={};for(const f in n[o])g[f]=n[o][f];r.push({identifiers:[(0,P.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(g),contents:p(g,s)})}return r}e.toOverrides=h;function p(n,s){const r=Object.create(null);for(let o in n)a(r,o,n[o],s);return r}e.toValuesTree=p;function a(n,s,r,o){const g=s.split("."),f=g.pop();let S=n;for(let E=0;E<g.length;E++){let l=g[E],L=S[l];switch(typeof L){case"undefined":L=S[l]=Object.create(null);break;case"object":break;default:o(`Ignoring ${s} as ${g.slice(0,E+1).join(".")} is ${JSON.stringify(L)}`);return}S=L}if(typeof S=="object"&&S!==null)try{S[f]=r}catch(E){o(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(S)}`)}else o(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(S)}`)}e.addToValueTree=a;function w(n,s){const r=s.split(".");m(n,r)}e.removeFromValueTree=w;function m(n,s){const r=s.shift();if(s.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const o=n[r];typeof o=="object"&&!Array.isArray(o)&&(m(o,s),Object.keys(o).length===0&&delete n[r])}}function b(n,s,r){function o(S,E){let l=S;for(const L of E){if(typeof l!="object"||l===null)return;l=l[L]}return l}const g=s.split("."),f=o(n,g);return typeof f=="undefined"?r:f}e.getConfigurationValue=b;function _(n,s,r){Object.keys(s).forEach(o=>{o!=="__proto__"&&(o in n?R.isObject(n[o])&&R.isObject(s[o])?_(n[o],s[o],r):r&&(n[o]=s[o]):n[o]=s[o])})}e.merge=_;function u(){const n=T.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=u;function c(){const n=Object.create(null),s=T.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let r in s){let o=s[r].default;a(n,r,o,g=>console.error(`Conflict in default settings: ${g}`))}return n}e.getDefaultValues=c;function d(n){return`[${n}]`}e.keyFromOverrideIdentifier=d;function t(n,s,r){const o=n.inspect(s),g=n.inspect(r);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:o.defaultValue}e.getMigratedSettingValue=t}),define(me[188],ge([0,1,55,23,16,12,24,2,83,84,38,6,3]),function(K,e,v,R,C,T,y,P,D,I,i,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},n=[],s=[]){this._contents=t,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,I.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const s=this.getContentsForOverrideIdentifer(n);return s?t?(0,I.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const r of C.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[r],g=n[r];g&&(typeof o=="object"&&typeof g=="object"?(o=y.deepClone(o),this.mergeContents(o,g)):o=g),s[r]=o}return new p(s,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),s=y.deepClone(this.overrides),r=[...this.keys];for(const o of t){this.mergeContents(n,o.contents);for(const g of o.overrides){const[f]=s.filter(S=>C.equals(S.identifiers,g.identifiers));f?this.mergeContents(f.contents,g.contents):s.push(y.deepClone(g))}for(const g of o.keys)r.indexOf(g)===-1&&r.push(g)}return new p(n,r,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const s of Object.keys(n)){if(s in t&&T.isObject(t[s])&&T.isObject(n[s])){this.mergeContents(t[s],n[s]);continue}t[s]=y.deepClone(n[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,I.addToValueTree)(this.contents,t,n,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,I.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let s=0;s<n;s++)t.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=p;class a extends p{constructor(){const t=(0,I.getDefaultValues)(),n=(0,I.getConfigurationKeys)(),s=[];for(const r of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[(0,D.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,I.toValuesTree)(t[r],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,n,s)}}e.DefaultConfigurationModel=a;class w{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!T.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:s,keys:r,overrides:o,restricted:g}=this.doParseRaw(t,n);this._configurationModel=new p(s,r,o),this._restrictedConfigurations=g||[]}doParseContent(t){let n={},s=null,r=[],o=[],g=[];function f(E){Array.isArray(r)?r.push(E):s&&(r[s]=E)}let S={onObjectBegin:()=>{let E={};f(E),o.push(r),r=E,s=null},onObjectProperty:E=>{s=E},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{let E=[];f(E),o.push(r),r=E,s=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:f,onError:(E,l,L)=>{g.push({error:E,offset:l,length:L})}};if(t)try{v.visit(t,S),n=r[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return n}doParseRaw(t,n){const s=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,s,!0,n);t=r.raw;const o=(0,I.toValuesTree)(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),g=Object.keys(t),f=(0,I.toOverrides)(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:o,keys:g,overrides:f,restricted:r.restricted}}filter(t,n,s,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.skipRestricted))return{raw:t,restricted:[]};const o={},g=[];for(let f in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(f)&&s){const S=this.filter(t[f],n,!1,r);o[f]=S.raw,g.push(...S.restricted)}else{const S=n[f],E=S?typeof S.scope!="undefined"?S.scope:3:void 0;(S==null?void 0:S.restricted)&&g.push(f),(E===void 0||r.scopes===void 0||r.scopes.includes(E))&&(r.skipRestricted&&(S==null?void 0:S.restricted)||(o[f]=t[f]))}return{raw:o,restricted:g}}}e.ConfigurationModelParser=w;class m extends A.Disposable{constructor(t,n,s,r){super();this.userSettingsResource=t,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new h.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(h.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class b{constructor(t,n,s=new p,r=new p,o=new R.ResourceMap,g=new p,f=new R.ResourceMap,S=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=o,this._memoryConfiguration=g,this._memoryConfigurationByResource=f,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(t)}updateValue(t,n,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new p,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(t):r.setValue(t,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,s){const r=this.getConsolidateConfigurationModel(n,s),o=this.getFolderConfigurationModelForResource(n.resource,s),g=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,f=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),S=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),l=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),L=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=o?n.overrideIdentifier?o.freeze().override(n.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,W=n.overrideIdentifier?g.override(n.overrideIdentifier).getValue(t):g.getValue(t),te=r.getValue(t),se=C.distinct(C.flatten(r.overrides.map(N=>N.identifiers))).filter(N=>r.getOverrideValue(t,N)!==void 0);return{defaultValue:f,userValue:S,userLocalValue:E,userRemoteValue:l,workspaceValue:L,workspaceFolderValue:O,memoryValue:W,value:te,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:l!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:o==null?void 0:o.freeze().getValue(t),override:n.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:W!==void 0?{value:g.getValue(t),override:n.overrideIdentifier?g.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=n.filter(r=>D.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const o=(0,D.overrideIdentifierFromKey)(r),g=this._defaultConfiguration.getKeysForOverrideIdentifier(o),f=t.getKeysForOverrideIdentifier(o),S=[...f.filter(E=>g.indexOf(E)===-1),...g.filter(E=>f.indexOf(E)===-1),...g.filter(E=>!y.equals(this._defaultConfiguration.override(o).getValue(E),t.override(o).getValue(E)))];return[o,S]});return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,I.compare)(this.localUserConfiguration,t),g=[...n,...s,...r];return g.length&&this.updateLocalUserConfiguration(t),{keys:g,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,I.compare)(this.remoteUserConfiguration,t);let g=[...n,...s,...r];return g.length&&this.updateRemoteUserConfiguration(t),{keys:g,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,I.compare)(this.workspaceConfiguration,t);let g=[...n,...s,...r];return g.length&&this.updateWorkspaceConfiguration(t),{keys:g,overrides:o}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:r,updated:o,removed:g,overrides:f}=(0,I.compare)(s,n);let S=[...r,...o,...g];return(S.length||!s)&&this.updateFolderConfiguration(t,n),{keys:S,overrides:f}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:r,removed:o,overrides:g}=(0,I.compare)(n,void 0);return{keys:[...s,...r,...o],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let s=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const r=n.getFolder(t);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const o=this._memoryConfigurationByResource.get(t);o&&(s=s.merge(o))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(n=s.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=s}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:s,overrides:r,keys:o}=this._folderConfigurations.get(n);return t.push([n,{contents:s,overrides:r,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((g,f)=>(g.set(P.URI.revive(f[0]),this.parseConfigurationModel(f[1])),g),new R.ResourceMap);return new b(n,s,new p,r,o,new p,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function _(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const t=new Set,n=new Map;for(const r of d)r.keys.forEach(o=>t.add(o)),r.overrides.forEach(([o,g])=>{const f=(0,R.getOrSet)(n,o,new Set);g.forEach(S=>f.add(S))});const s=[];return n.forEach((r,o)=>s.push([o,[...r.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=_;class u{constructor(t,n,s,r){this.change=t,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(f=>o.add(f)),t.overrides.forEach(([,f])=>f.forEach(S=>o.add(S))),this.affectedKeys=[...o.values()];const g=new p;this.affectedKeys.forEach(f=>g.setValue(f,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,o=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let s=(0,I.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(t=t[r],!t)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=u;class c extends u{constructor(t,n,s,r){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=c}),define(me[189],ge([0,1,37,9,110,155,28,11,183,84,4,10,136]),function(K,e,v,R,C,T,y,P,D,I,i,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const p=T.localize(0,null);class a{async getDefaultTerminalForPlatforms(){const t=await b.getDefaultTerminalLinuxReady();return{windows:w.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let w=class zt extends a{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(v,n,C.getWindowsShell(),t)}spawnTerminal(t,n,s,r){const o=n.terminal.external,g=(o==null?void 0:o.windowsExec)||zt.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const f=R.basename(g).toLowerCase();if(f==="cmder"||f==="cmder.exe")return t.spawn(g,r?[r]:void 0),Promise.resolve(void 0);const S=["/c","start","/wait"];return g.indexOf(" ")>=0&&S.push('""'),S.push(g),(f==="wt"||f==="wt.exe")&&S.push("-d ."),new Promise((E,l)=>{const L=_(process),O=t.spawn(s,S,{cwd:r,env:L});O.on("error",l),O.on("exit",()=>E())})}runInTerminal(t,n,s,r,o){const g="windowsExec"in o&&o.windowsExec?o.windowsExec:zt.getDefaultTerminalWindows();return new Promise((f,S)=>{const E=`"${n} - ${p}"`,l=`""${s.join('" "')}" & pause"`,L=["/c","start",E,"/wait",g,"/c",l],O=Object.assign({},_(process),r);Object.keys(O).filter(se=>O[se]===null).forEach(se=>delete O[se]);const W={cwd:n,env:O,windowsVerbatimArguments:!0};v.spawn(zt.CMD,L,W).on("error",se=>{S(u(se))}),f(void 0)})}static getDefaultTerminalWindows(){if(!zt._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");zt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return zt._DEFAULT_TERMINAL_WINDOWS}};w.CMD="cmd.exe",w=qe([He(0,(0,i.optional)(I.IConfigurationService))],w),e.WindowsExternalTerminalService=w;let m=class Nn extends a{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(v,n,t)}runInTerminal(t,n,s,r,o){const g=o.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((f,S)=>{if(g===D.DEFAULT_TERMINAL_OSX||g==="iTerm.app"){const E=g===D.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${E}.scpt`,K).fsPath,"-t",t||p,"-w",n];for(let te of s)L.push("-a"),L.push(te);if(r)for(let te in r){const se=r[te];se===null?(L.push("-u"),L.push(te)):(L.push("-e"),L.push(`${te}=${se}`))}let O="";const W=v.spawn(Nn.OSASCRIPT,L);W.on("error",te=>{S(u(te))}),W.stderr.on("data",te=>{O+=te.toString()}),W.on("exit",te=>{if(te===0)f(void 0);else if(O){const se=O.split(`
`,1);S(new Error(se[0]))}else S(new Error(T.localize(1,null,E,te)))})}else S(new Error(T.localize(2,null,g)))})}spawnTerminal(t,n,s){const r=n.terminal.external,o=(r==null?void 0:r.osxExec)||D.DEFAULT_TERMINAL_OSX;return new Promise((g,f)=>{const S=["-a",o];s&&S.push(s);const E=t.spawn("/usr/bin/open",S);E.on("error",f),E.on("exit",()=>g())})}};m.OSASCRIPT="/usr/bin/osascript",m=qe([He(0,(0,i.optional)(I.IConfigurationService))],m),e.MacExternalTerminalService=m;let b=class Vt extends a{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(v,n,t)}runInTerminal(t,n,s,r,o){const g=o.linuxExec?Promise.resolve(o.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((f,S)=>{let E=[];g.then(l=>{l.indexOf("gnome-terminal")>=0?E.push("-x"):E.push("-e"),E.push("bash"),E.push("-c");const L=`${c(s)}; echo; read -p "${Vt.WAIT_MESSAGE}" -n1;`;E.push(`''${L}''`);const O=Object.assign({},process.env,r);Object.keys(O).filter(N=>O[N]===null).forEach(N=>delete O[N]);const W={cwd:n,env:O};let te="";const se=v.spawn(l,E,W);se.on("error",N=>{S(u(N))}),se.stderr.on("data",N=>{te+=N.toString()}),se.on("exit",N=>{if(N===0)f(void 0);else if(te){const V=te.split(`
`,1);S(new Error(V[0]))}else S(new Error(T.localize(4,null,l,N)))})})})}static async getDefaultTerminalLinuxReady(){return Vt._DEFAULT_TERMINAL_LINUX_READY||(Vt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{P.isLinux?await y.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),Vt._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,n,s){const r=n.terminal.external,o=(r==null?void 0:r.linuxExec)?Promise.resolve(r.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((g,f)=>{o.then(S=>{const E=_(process),l=t.spawn(S,[],{cwd:s,env:E});l.on("error",f),l.on("exit",()=>g())})})}};b.WAIT_MESSAGE=T.localize(3,null),b=qe([He(0,(0,i.optional)(I.IConfigurationService))],b),e.LinuxExternalTerminalService=b;function _(d){const t=d.env;return(0,h.sanitizeProcessEnvironment)(t),t}function u(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(T.localize(5,null,d.path)):d}function c(d){let t="";for(let n of d)n.indexOf(" ")>=0?t+='"'+n+'"':t+=n,t+=" ";return t}}),define(me[116],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var R;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends Error{constructor(y,P=R.Unknown,D){super(y);this._message=y,this._code=P,this._detail=D,this.isHandled=P===R.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(y){return y instanceof C&&y._code===R.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof C&&y._code===R.NoResolverFound}static isHandled(y){return y instanceof C&&y.isHandled}}e.RemoteAuthorityResolverError=C}),define(me[117],ge([0,1,10]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function R(I){return I.scheme===v.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=R;function C(I){if(!I)return;const i=I.indexOf("+");return i<0?I:I.substr(0,i)}e.getRemoteName=C;function T(I){return I.scheme!==v.Schemas.file&&I.scheme!==v.Schemas.vscodeRemote}function y(I){if(I.folders.length)return I.folders.every(i=>T(i.uri))?I.folders[0].uri:void 0;if(I.configuration&&T(I.configuration))return I.configuration}e.getVirtualWorkspaceLocation=y;function P(I){var i;return(i=y(I))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=P;function D(I){return y(I)!==void 0}e.isVirtualWorkspace=D}),define(me[190],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((C,T)=>K(["vsda"],C,T))}async sign(C){try{const T=await this.vsda(),y=new T.signer;if(y)return y.sign(C)}catch(T){}return C}}e.SignService=v}),define(me[191],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class v{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,T,y=5){let P;return P=T(D=>{const I=typeof D=="string"?D:D.data;let i=this._terminalBufferMap.get(C);if(i){i.data.push(I);return}const A=setTimeout(()=>this.flushBuffer(C),y);i={data:[I],timeoutId:A,dispose:()=>{clearTimeout(A),this.flushBuffer(C),P.dispose()}},this._terminalBufferMap.set(C,i)}),P}stopBuffering(C){const T=this._terminalBufferMap.get(C);T&&T.dispose()}flushBuffer(C){const T=this._terminalBufferMap.get(C);T&&(this._terminalBufferMap.delete(C),this._callback(C,T.data.join("")))}}e.TerminalDataBufferer=v}),define(me[192],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(me[193],ge([0,1,4,6,38,3,192,45]),function(K,e,v,R,C,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,v.createDecorator)("themeService");var D;(function(m){function b(_){return _&&typeof _=="object"&&typeof _.id=="string"}m.isThemeColor=b})(D=e.ThemeColor||(e.ThemeColor={}));function I(m){return{id:m}}e.themeColorFromId=I;var i;(function(m){function b(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||D.isThemeColor(n.color))}m.isThemeIcon=b;const _=new RegExp(`^\\$\\((${P.CSSIcon.iconNameExpression}(?:${P.CSSIcon.iconModifierExpression})?)\\)$`);function u(n){const s=_.exec(n);if(!s)return;let[,r]=s;return{id:r}}m.fromString=u;function c(n,s){let r=n.id;const o=r.lastIndexOf("~");return o!==-1&&(r=r.substring(0,o)),s&&(r=`${r}~${s}`),{id:r}}m.modify=c;function d(n,s){var r,o;return n.id===s.id&&((r=n.color)===null||r===void 0?void 0:r.id)===((o=s.color)===null||o===void 0?void 0:o.id)}m.isEqual=d;function t(n){return{id:n.id}}m.asThemeIcon=t,m.asClassNameArray=P.CSSIcon.asClassNameArray,m.asClassName=P.CSSIcon.asClassName,m.asCSSSelector=P.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=P.Codicon.file,e.FolderThemeIcon=P.Codicon.folder;function A(m){switch(m){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=A,e.Extensions={ThemingContribution:"base.contributions.theming"};class h{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,R.toDisposable)(()=>{const _=this.themingParticipants.indexOf(b);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new h;C.Registry.add(e.Extensions.ThemingContribution,p);function a(m){return p.onColorThemeChange(m)}e.registerThemingParticipant=a;class w extends R.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,_){let u=this.theme.getColor(b);return u&&_&&(u=_(u,this.theme)),u?u.toString():null}}e.Themable=w}),define(me[194],ge([0,1,38,193,3,158,115,13,45]),function(K,e,v,R,C,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class I{constructor(){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(b,_,u,c){const d=this.iconsById[b];if(d){if(u&&!d.description){d.description=u,this.iconSchema.properties[b].markdownDescription=`${u} $(${b})`;const s=this.iconReferenceSchema.enum.indexOf(b);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=u),this._onDidChange.fire()}return d}let t={id:b,description:u,defaults:_,deprecationMessage:c};this.iconsById[b]=t;let n={$ref:"#/definitions/icons"};return c&&(n.deprecationMessage=c),u&&(n.markdownDescription=`${u}: $(${b})`),this.iconSchema.properties[b]=n,this.iconReferenceSchema.enum.push(b),this.iconReferenceSchema.enumDescriptions.push(u||""),this._onDidChange.fire(),{id:b}}deregisterIcon(b){delete this.iconsById[b],delete this.iconSchema.properties[b];const _=this.iconReferenceSchema.enum.indexOf(b);_!==-1&&(this.iconReferenceSchema.enum.splice(_,1),this.iconReferenceSchema.enumDescriptions.splice(_,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(b=>this.iconsById[b])}getIcon(b){return this.iconsById[b]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(b,_){const u=this.iconFontsById[b];if(u)return u;let c={id:b,definition:_};return this.iconFontsById[b]=c,this._onDidChange.fire(),c}deregisterIconFont(b){delete this.iconFontsById[b]}getIconFonts(){return Object.keys(this.iconFontsById).map(b=>this.iconFontsById[b])}getIconFont(b){return this.iconFontsById[b]}toString(){const b=(d,t)=>d.id.localeCompare(t.id),_=d=>{for(;R.ThemeIcon.isThemeIcon(d.defaults);)d=this.iconsById[d.defaults.id];return`codicon codicon-${d?d.id:""}`};let u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(d=>this.iconsById[d]);for(const d of c.filter(t=>!!t.description).sort(b))u.push(`|<i class="${_(d)}"></i>|${d.id}|${R.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const d of c.filter(t=>!R.ThemeIcon.isThemeIcon(t.defaults)).sort(b))u.push(`|<i class="${_(d)}"></i>|${d.id}|`);return u.join(`
`)}}const i=new I;v.Registry.add(e.Extensions.IconContribution,i);function A(m,b,_,u){return i.registerIcon(m,b,_,u)}e.registerIcon=A;function h(){return i}e.getIconRegistry=h;function p(){for(const m of D.iconRegistry.all)i.registerIcon(m.id,m.definition,m.description);D.iconRegistry.onDidRegister(m=>i.registerIcon(m.id,m.definition,m.description))}p(),e.iconsSchemaId="vscode://schemas/icons";let a=v.Registry.as(y.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,i.getIconSchema());const w=new P.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.widgetClose=A("widget-close",D.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=A("goto-previous-location",D.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=A("goto-next-location",D.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=R.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(me[61],ge([0,1,2,25,4,23]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var y;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function P(h){const p=h;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=P;function D(h){const p=h;return!!(p&&typeof p=="object"&&v.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=D;class I{constructor(p,a,w,m){this._id=p,this._configuration=w,this._ignorePathCasing=m,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(p){this._id=p.id,this._configuration=p.configuration,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=I;class i{constructor(p,a){this.raw=a,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,R.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function A(h){return new i({uri:h,index:0,name:(0,R.basenameOrAuthority)(h)},{uri:h.toString()})}e.toWorkspaceFolder=A}),define(me[118],ge([0,1,4,159,61,2,11,9,25,134,55,10,77,29,117]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(V){return(typeof V=="string"?(0,P.extname)(V):(0,D.extname)(V))===w}e.hasWorkspaceFileExtension=m,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function b(V){return V.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function _(V){return V.hasOwnProperty("folderUri")}e.isRecentFolder=_;function u(V){return V.hasOwnProperty("fileUri")}e.isRecentFile=u;function c(V){const x=V;return typeof(x==null?void 0:x.id)=="string"&&T.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=c;function d(V){if(V.configuration)return{id:V.id,configPath:V.configuration};if(V.folders.length===1)return{id:V.id,uri:V.folders[0].uri}}e.toWorkspaceIdentifier=d;function t(V){const x=V;return typeof(x==null?void 0:x.id)=="string"&&T.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=t;function n(V){const x=V;if(x==null?void 0:x.uri)return{id:x.id,uri:T.URI.revive(x.uri)};const k=V;if(k==null?void 0:k.configPath)return{id:k.id,configPath:T.URI.revive(k.configPath)};if(V==null?void 0:V.id)return{id:V.id}}e.reviveIdentifier=n;function s(V,x){return D.extUriBiasedIgnorePathCase.isEqualOrParent(V,x.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function r(V){return o(V)||g(V)}e.isStoredWorkspaceFolder=r;function o(V){const x=V;return typeof(x==null?void 0:x.path)=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=o;function g(V){const x=V;return typeof(x==null?void 0:x.uri)=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=g;function f(V,x,k,U,F=!y.isWindows,M){if(V.scheme!==U.scheme)return{name:k,uri:V.toString(!0)};let $=x?void 0:M.relativePath(U,V);if($!==void 0)$.length===0?$=".":y.isWindows&&V.scheme===A.Schemas.file&&!F&&($=$.replace(/\//g,"\\"));else if(V.scheme===A.Schemas.file)$=V.fsPath,y.isWindows&&($=(0,h.normalizeDriveLetter)($),F&&($=(0,p.toSlashes)($)));else{if(!M.isEqualAuthority(V.authority,U.authority))return{name:k,uri:V.toString(!0)};$=V.path}return{name:k,path:$}}e.getStoredWorkspaceFolder=f;function S(V,x,k){let U=[],F=new Set;const M=k.dirname(x);for(let $ of V){let H;if(o($))$.path&&(H=k.resolvePath(M,$.path));else if(g($))try{H=T.URI.parse($.uri),H.path[0]!=="/"&&(H=H.with({path:"/"+H.path}))}catch(X){console.warn(X)}if(H){let X=k.getComparisonKey(H);if(!F.has(X)){F.add(X);const ae=$.name||k.basenameOrAuthority(H);U.push(new C.WorkspaceFolder({uri:H,name:ae,index:U.length},$))}}}return U}e.toWorkspaceFolders=S;function E(V,x,k,U,F){let M=l(x,V);const $=F.dirname(x),H=F.dirname(U),X=[],ae=L(M.folders);for(const Me of M.folders){const We=o(Me)?F.resolvePath($,Me.path):T.URI.parse(Me.uri);let j;k?j=!1:j=!o(Me)||(0,P.isAbsolute)(Me.path),X.push(f(We,j,Me.name,H,ae,F))}const we={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Le=I.setProperty(V,["folders"],X,we);let Ie=I.applyEdits(V,Le);return M.remoteAuthority===(0,a.getRemoteAuthority)(U)&&(Ie=I.applyEdits(Ie,I.removeProperty(Ie,["remoteAuthority"],we))),Ie}e.rewriteWorkspaceFileForNewLocation=E;function l(V,x){let k=i.parse(x);if(k&&Array.isArray(k.folders))k.folders=k.folders.filter(U=>r(U));else throw new Error(`${V} looks like an invalid workspace file.`);return k}function L(V){return y.isWindows?V.some(x=>o(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=L;function O(V){return V.workspace&&typeof V.workspace=="object"&&typeof V.workspace.id=="string"&&typeof V.workspace.configPath=="string"}function W(V){return typeof V.folderUri=="string"}function te(V){return typeof V.fileUri=="string"}function se(V,x){const k={workspaces:[],files:[]};if(V){const U=function(M,$){for(let H=0;H<M.length;H++)try{$(M[H],H)}catch(X){x.warn(`Error restoring recent entry ${JSON.stringify(M[H])}: ${X.toString()}. Skip entry.`)}},F=V;if(Array.isArray(F.entries))U(F.entries,M=>{const $=M.label,H=M.remoteAuthority;O(M)?k.workspaces.push({label:$,remoteAuthority:H,workspace:{id:M.workspace.id,configPath:T.URI.parse(M.workspace.configPath)}}):W(M)?k.workspaces.push({label:$,remoteAuthority:H,folderUri:T.URI.parse(M.folderUri)}):te(M)&&k.files.push({label:$,remoteAuthority:H,fileUri:T.URI.parse(M.fileUri)})});else{const M=V;Array.isArray(M.workspaces3)&&U(M.workspaces3,($,H)=>{const X=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[H]||void 0;typeof $=="object"&&typeof $.id=="string"&&typeof $.configURIPath=="string"?k.workspaces.push({label:X,workspace:{id:$.id,configPath:T.URI.parse($.configURIPath)}}):typeof $=="string"&&k.workspaces.push({label:X,folderUri:T.URI.parse($)})}),Array.isArray(M.files2)&&U(M.files2,($,H)=>{const X=Array.isArray(M.fileLabels)&&M.fileLabels[H]||void 0;typeof $=="string"&&k.files.push({label:X,fileUri:T.URI.parse($)})})}}return k}e.restoreRecentlyOpened=se;function N(V){const x={entries:[]};for(const k of V.workspaces)_(k)?x.entries.push({folderUri:k.folderUri.toString(),label:k.label,remoteAuthority:k.remoteAuthority}):x.entries.push({workspace:{id:k.workspace.id,configPath:k.workspace.configPath.toString()},label:k.label,remoteAuthority:k.remoteAuthority});for(const k of V.files)x.entries.push({fileUri:k.fileUri.toString(),label:k.label,remoteAuthority:k.remoteAuthority});return x}e.toStoreData=N}),define(me[85],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class v{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const T=this._idPool++;return this._data.set(T,C),this.logDebugInfo(),T}get(C,T){return this._data.has(C)?this._data.get(C)[T]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!v.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=v,v.enableDebugLogging=!1}),define(me[47],ge([0,1,2,3,4]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class T{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(P){this._tabs=P.map(D=>({name:D.name,group:D.group,resource:v.URI.revive(D.resource),isActive:D.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(me[62],ge([0,1,10,4]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(v.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,P){P===null?this._providerInfo.delete(y):this._providerInfo.set(y,P)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,v.createDecorator)("IExtHostInitDataService")}),define(me[195],ge([0,1,13]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(y,P,D){this._deferredPromises=new Map,this._id=y,this._shared=P,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new v.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of I.values())i.complete()}catch(i){for(const A of I.values())A.error(i)}})()},0)}get keys(){var y;return Object.entries((y=this._value)!==null&&y!==void 0?y:{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this._init}get(y,P){let D=this._value[y];return typeof D=="undefined"&&(D=P),D}update(y,P){this._value[y]=P;let D=this._deferredPromises.get(y);if(D!==void 0)return D.p;const I=new v.DeferredPromise;return this._deferredPromises.set(y,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class C extends R{constructor(y,P){super(y.identifier.value,!0,P);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=C}),define(me[15],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,v.createDecorator)("IExtHostRpcService");class R{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=R});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)};define(me[196],ge([0,1,26,3]),function(K,e,v,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(P,D){C.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=v.ExtensionIdentifier.toKey(P.identifier),nt(this,C,D,"f"),$e(this,C,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(P){return $e(this,C,"f").get(this._id,P)}store(P,D){return $e(this,C,"f").store(this._id,P,D)}delete(P){return $e(this,C,"f").delete(this._id,P)}}e.ExtensionSecrets=T,C=new WeakMap}),define(me[119],ge([0,1,4,3]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=(0,v.createDecorator)("IExtHostTelemetry")}),define(me[86],ge([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const C=new WeakMap,T=y=>{let P=C.get(y);return P||(P={children:new Map,bus:new v.Emitter},C.set(y,P)),P};e.getPrivateApiFor=T}),define(me[48],ge([0,1,4,3,15]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(P){function D(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}P.fromApiTunnel=D;function I(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}P.fromServiceTunnel=I})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,v.createDecorator)("IExtHostTunnelService");let y=class{constructor(D){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,I){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,I){return{dispose:()=>{}}}async $providePortAttributes(D,I,i,A,h){return[]}async $forwardPort(D,I){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=qe([He(0,C.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)},Qt=this&&this.__rest||function(K,e){var v={};for(var R in K)Object.prototype.hasOwnProperty.call(K,R)&&e.indexOf(R)<0&&(v[R]=K[R]);if(K!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(K);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(K,R[C])&&(v[R[C]]=K[R[C]]);return v};define(me[7],ge([0,1,16,17,96,23,8,12,2,32,43,116,86]),function(K,e,v,R,C,T,y,P,D,I,i,A,h){"use strict";var p,a,w,m,b,_,u,c,d,t,n,s,r,o,g,f,S,E;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function l(q){function B(){return Reflect.construct(q,arguments,this.constructor)}return Object.defineProperty(B,"name",Object.getOwnPropertyDescriptor(q,"name")),Object.setPrototypeOf(B,q),Object.setPrototypeOf(B.prototype,q.prototype),B}let L=b=class{constructor(B){p.set(this,void 0),nt(this,p,B,"f")}static from(...B){let ie=B;return new b(function(){if(ie){for(const Ce of ie)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();ie=void 0}})}dispose(){typeof $e(this,p,"f")=="function"&&($e(this,p,"f").call(this),nt(this,p,void 0,"f"))}};p=new WeakMap,L=b=qe([l],L),e.Disposable=L;let O=_=class{constructor(B,ie){if(B<0)throw(0,R.illegalArgument)("line must be non-negative");if(ie<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=B,this._character=ie}static Min(...B){if(B.length===0)throw new TypeError;let ie=B[0];for(let Ce=1;Ce<B.length;Ce++){const Ge=B[Ce];Ge.isBefore(ie)&&(ie=Ge)}return ie}static Max(...B){if(B.length===0)throw new TypeError;let ie=B[0];for(let Ce=1;Ce<B.length;Ce++){const Ge=B[Ce];Ge.isAfter(ie)&&(ie=Ge)}return ie}static isPosition(B){if(!B)return!1;if(B instanceof _)return!0;let{line:ie,character:Ce}=B;return typeof ie=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<B._character}isBeforeOrEqual(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<=B._character}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this._line===B._line&&this._character===B._character}compareTo(B){return this._line<B._line?-1:this._line>B.line?1:this._character<B._character?-1:this._character>B._character?1:0}translate(B,ie=0){if(B===null||ie===null)throw(0,R.illegalArgument)();let Ce;return typeof B=="undefined"?Ce=0:typeof B=="number"?Ce=B:(Ce=typeof B.lineDelta=="number"?B.lineDelta:0,ie=typeof B.characterDelta=="number"?B.characterDelta:0),Ce===0&&ie===0?this:new _(this.line+Ce,this.character+ie)}with(B,ie=this.character){if(B===null||ie===null)throw(0,R.illegalArgument)();let Ce;return typeof B=="undefined"?Ce=this.line:typeof B=="number"?Ce=B:(Ce=typeof B.line=="number"?B.line:this.line,ie=typeof B.character=="number"?B.character:this.character),Ce===this.line&&ie===this.character?this:new _(Ce,ie)}toJSON(){return{line:this.line,character:this.character}}};O=_=qe([l],O),e.Position=O;let W=u=class{constructor(B,ie,Ce,Ge){let tt,ut;if(typeof B=="number"&&typeof ie=="number"&&typeof Ce=="number"&&typeof Ge=="number"?(tt=new O(B,ie),ut=new O(Ce,Ge)):B instanceof O&&ie instanceof O&&(tt=B,ut=ie),!tt||!ut)throw new Error("Invalid arguments");tt.isBefore(ut)?(this._start=tt,this._end=ut):(this._start=ut,this._end=tt)}static isRange(B){return B instanceof u?!0:B?O.isPosition(B.start)&&O.isPosition(B.end):!1}get start(){return this._start}get end(){return this._end}contains(B){return B instanceof u?this.contains(B._start)&&this.contains(B._end):B instanceof O?!(B.isBefore(this._start)||this._end.isBefore(B)):!1}isEqual(B){return this._start.isEqual(B._start)&&this._end.isEqual(B._end)}intersection(B){const ie=O.Max(B.start,this._start),Ce=O.Min(B.end,this._end);if(!ie.isAfter(Ce))return new u(ie,Ce)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const ie=O.Min(B.start,this._start),Ce=O.Max(B.end,this.end);return new u(ie,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(B,ie=this.end){if(B===null||ie===null)throw(0,R.illegalArgument)();let Ce;return B?O.isPosition(B)?Ce=B:(Ce=B.start||this.start,ie=B.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&ie.isEqual(this.end)?this:new u(Ce,ie)}toJSON(){return[this.start,this.end]}};W=u=qe([l],W),e.Range=W;let te=c=class extends W{constructor(B,ie,Ce,Ge){let tt,ut;if(typeof B=="number"&&typeof ie=="number"&&typeof Ce=="number"&&typeof Ge=="number"?(tt=new O(B,ie),ut=new O(Ce,Ge)):B instanceof O&&ie instanceof O&&(tt=B,ut=ie),!tt||!ut)throw new Error("Invalid arguments");super(tt,ut);this._anchor=tt,this._active=ut}static isSelection(B){return B instanceof c?!0:B?W.isRange(B)&&O.isPosition(B.anchor)&&O.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};te=c=qe([l],te),e.Selection=te;class se{constructor(B,ie,Ce){if(typeof B!="string"||B.length===0)throw(0,R.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,R.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,R.illegalArgument)("connectionToken");this.host=B,this.port=Math.round(ie),this.connectionToken=Ce}}e.ResolvedAuthority=se;class N extends Error{constructor(B,ie=A.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(B);this._message=B,this._code=ie,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}static NotAvailable(B,ie){return new N(B,A.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(B){return new N(B,A.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=N;var V;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var x;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let k=d=class{constructor(B,ie){this._range=B,this._newText=ie}static isTextEdit(B){return B instanceof d?!0:B?W.isRange(B)&&typeof B.newText=="string":!1}static replace(B,ie){return new d(B,ie)}static insert(B,ie){return d.replace(new W(B,B),ie)}static delete(B){return d.replace(B,"")}static setEndOfLine(B){const ie=new d(new W(new O(0,0),new O(0,0)),"");return ie.newEol=B,ie}get range(){return this._range}set range(B){if(B&&!W.isRange(B))throw(0,R.illegalArgument)("range");this._range=B}get newText(){return this._newText||""}set newText(B){if(B&&typeof B!="string")throw(0,R.illegalArgument)("newText");this._newText=B}get newEol(){return this._newEol}set newEol(B){if(B&&typeof B!="number")throw(0,R.illegalArgument)("newEol");this._newEol=B}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};k=d=qe([l],k),e.TextEdit=k;var U;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellOutput=4]="CellOutput",q[q.CellReplace=5]="CellReplace",q[q.CellOutputItem=6]="CellOutputItem"})(U=e.FileEditType||(e.FileEditType={}));let F=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(B,ie,Ce,Ge){this._edits.push({_type:1,from:B,to:ie,options:Ce,metadata:Ge})}createFile(B,ie,Ce){this._edits.push({_type:1,from:void 0,to:B,options:ie,metadata:Ce})}deleteFile(B,ie,Ce){this._edits.push({_type:1,from:B,to:void 0,options:ie,metadata:Ce})}replaceNotebookMetadata(B,ie,Ce){this._edits.push({_type:3,metadata:Ce,uri:B,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(B,ie,Ce,Ge,tt){let ut,ft,yt=[],kt;if($t.isNotebookRange(ie)&&Oe.isNotebookCellDataArray(Ce)&&!Oe.isNotebookCellDataArray(Ge)?(ut=ie.start,ft=ie.end,yt=Ce,kt=Ge):typeof ie=="number"&&typeof Ce=="number"&&Oe.isNotebookCellDataArray(Ge)&&(ut=ie,ft=Ce,yt=Ge,kt=tt),ut===void 0||ft===void 0)throw new Error("Invalid arguments");(ut!==ft||yt.length>0)&&this._edits.push({_type:5,uri:B,index:ut,count:ft-ut,cells:yt,metadata:kt})}replaceNotebookCellMetadata(B,ie,Ce,Ge){this._edits.push({_type:3,metadata:Ge,uri:B,edit:{editType:8,index:ie,metadata:Ce}})}replace(B,ie,Ce,Ge){this._edits.push({_type:2,uri:B,edit:new k(ie,Ce),metadata:Ge})}insert(B,ie,Ce,Ge){this.replace(B,new W(ie,ie),Ce,Ge)}delete(B,ie,Ce){this.replace(B,ie,"",Ce)}has(B){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===B.toString())}set(B,ie){if(ie)for(const Ce of ie)Ce&&this._edits.push({_type:2,uri:B,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const Ge=this._edits[Ce];Ge._type===2&&Ge.uri.toString()===B.toString()&&(this._edits[Ce]=void 0)}(0,v.coalesceInPlace)(this._edits)}}get(B){const ie=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===B.toString()&&ie.push(Ce.edit);return ie}entries(){const B=new T.ResourceMap;for(let ie of this._edits)if(ie._type===2){let Ce=B.get(ie.uri);Ce||(Ce=[ie.uri,[]],B.set(ie.uri,Ce)),Ce[1].push(ie.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};F=qe([l],F),e.WorkspaceEdit=F;let M=t=class{constructor(B){this._tabstop=1,this.value=B||""}static isSnippetString(B){return B instanceof t?!0:B?typeof B.value=="string":!1}static _escape(B){return B.replace(/\$|}|\\/g,"\\$&")}appendText(B){return this.value+=t._escape(B),this}appendTabstop(B=this._tabstop++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,ie=this._tabstop++){if(typeof B=="function"){const Ce=new t;Ce._tabstop=this._tabstop,B(Ce),this._tabstop=Ce._tabstop,B=Ce.value}else B=t._escape(B);return this.value+="${",this.value+=ie,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,ie=this._tabstop++){const Ce=B.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(B,ie){if(typeof ie=="function"){const Ce=new t;Ce._tabstop=this._tabstop,ie(Ce),this._tabstop=Ce._tabstop,ie=Ce.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};M=t=qe([l],M),e.SnippetString=M;var $;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})($=e.DiagnosticTag||(e.DiagnosticTag={}));var H;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(H=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let X=n=class{constructor(B,ie){if(this.uri=B,ie)if(ie instanceof W)this.range=ie;else if(ie instanceof O)this.range=new W(ie,ie);else throw new Error("Illegal argument")}static isLocation(B){return B instanceof n?!0:B?W.isRange(B.range)&&D.URI.isUri(B.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};X=n=qe([l],X),e.Location=X;let ae=class{constructor(B,ie){this.location=B,this.message=ie}static is(B){return B?typeof B.message=="string"&&B.location&&W.isRange(B.location.range)&&D.URI.isUri(B.location.uri):!1}static isEqual(B,ie){return B===ie?!0:!B||!ie?!1:B.message===ie.message&&B.location.range.isEqual(ie.location.range)&&B.location.uri.toString()===ie.location.uri.toString()}};ae=qe([l],ae),e.DiagnosticRelatedInformation=ae;let we=class{constructor(B,ie,Ce=H.Error){if(!W.isRange(B))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=B,this.message=ie,this.severity=Ce}toJSON(){return{severity:H[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,ie){return B===ie?!0:!B||!ie?!1:B.message===ie.message&&B.severity===ie.severity&&B.code===ie.code&&B.severity===ie.severity&&B.source===ie.source&&B.range.isEqual(ie.range)&&(0,v.equals)(B.tags,ie.tags)&&(0,v.equals)(B.relatedInformation,ie.relatedInformation,ae.isEqual)}};we=qe([l],we),e.Diagnostic=we;let Le=class{constructor(B,ie){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:(0,C.isMarkdownString)(B)?this.contents=[B]:this.contents=[B],this.range=ie}};Le=qe([l],Le),e.Hover=Le;var Ie;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(Ie=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Me=class{constructor(B,ie=Ie.Text){this.range=B,this.kind=ie}toJSON(){return{range:this.range,kind:Ie[this.kind]}}};Me=qe([l],Me),e.DocumentHighlight=Me;var We;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(We=e.SymbolKind||(e.SymbolKind={}));var j;(function(q){q[q.Deprecated=1]="Deprecated"})(j=e.SymbolTag||(e.SymbolTag={}));let Y=s=class{constructor(B,ie,Ce,Ge,tt){this.name=B,this.kind=ie,this.containerName=tt,typeof Ce=="string"&&(this.containerName=Ce),Ge instanceof X?this.location=Ge:Ce instanceof W&&(this.location=new X(Ge,Ce)),s.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:We[this.kind],location:this.location,containerName:this.containerName}}};Y=s=qe([l],Y),e.SymbolInformation=Y;let ee=r=class{constructor(B,ie,Ce,Ge,tt){this.name=B,this.detail=ie,this.kind=Ce,this.range=Ge,this.selectionRange=tt,this.children=[],r.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children&&B.children.forEach(r.validate)}};ee=r=qe([l],ee),e.DocumentSymbol=ee;var oe;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(oe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(B,ie){this.title=B,this.kind=ie}};pe=qe([l],pe),e.CodeAction=pe;let _e=o=class{constructor(B){this.value=B}append(B){return new o(this.value?this.value+o.sep+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+o.sep)}};_e.sep=".",_e=o=qe([l],_e),e.CodeActionKind=_e,_e.Empty=new _e(""),_e.QuickFix=_e.Empty.append("quickfix"),_e.Refactor=_e.Empty.append("refactor"),_e.RefactorExtract=_e.Refactor.append("extract"),_e.RefactorInline=_e.Refactor.append("inline"),_e.RefactorRewrite=_e.Refactor.append("rewrite"),_e.Source=_e.Empty.append("source"),_e.SourceOrganizeImports=_e.Source.append("organizeImports"),_e.SourceFixAll=_e.Source.append("fixAll");let de=class{constructor(B,ie){if(this.range=B,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};de=qe([l],de),e.SelectionRange=de;class Ee{constructor(B,ie,Ce,Ge,tt,ut){this.kind=B,this.name=ie,this.detail=Ce,this.uri=Ge,this.range=tt,this.selectionRange=ut}}e.CallHierarchyItem=Ee;class Re{constructor(B,ie){this.fromRanges=ie,this.from=B}}e.CallHierarchyIncomingCall=Re;class Ve{constructor(B,ie){this.fromRanges=ie,this.to=B}}e.CallHierarchyOutgoingCall=Ve;let be=class{constructor(B,ie){this.range=B,this.command=ie}get isResolved(){return!!this.command}};be=qe([l],be),e.CodeLens=be;let Ke=g=class{constructor(B,ie=!1){a.set(this,void 0),nt(this,a,new C.MarkdownString(B,{supportThemeIcons:ie}),"f")}static isMarkdownString(B){return B instanceof g?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}get value(){return $e(this,a,"f").value}set value(B){$e(this,a,"f").value=B}get isTrusted(){return $e(this,a,"f").isTrusted}set isTrusted(B){$e(this,a,"f").isTrusted=B}get supportThemeIcons(){return $e(this,a,"f").supportThemeIcons}appendText(B){return $e(this,a,"f").appendText(B),this}appendMarkdown(B){return $e(this,a,"f").appendMarkdown(B),this}appendCodeblock(B,ie){return $e(this,a,"f").appendCodeblock(ie!=null?ie:"",B),this}};a=new WeakMap,Ke=g=qe([l],Ke),e.MarkdownString=Ke;let Q=class{constructor(B,ie){this.label=B,this.documentation=ie}};Q=qe([l],Q),e.ParameterInformation=Q;let ne=class{constructor(B,ie){this.label=B,this.documentation=ie,this.parameters=[]}};ne=qe([l],ne),e.SignatureInformation=ne;let ve=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ve=qe([l],ve),e.SignatureHelp=ve;var xe;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(xe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var je;(function(q){q[q.Other=0]="Other",q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(je=e.InlayHintKind||(e.InlayHintKind={}));let ze=class{constructor(B,ie,Ce){this.text=B,this.position=ie,this.kind=Ce}};ze=qe([l],ze),e.InlayHint=ze;var Je;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ye;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(ye=e.CompletionItemKind||(e.CompletionItemKind={}));var De;(function(q){q[q.Deprecated=1]="Deprecated"})(De=e.CompletionItemTag||(e.CompletionItemTag={}));let ke=class{constructor(B,ie){this.label=B,this.kind=ie}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&ye[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ke=qe([l],ke),e.CompletionItem=ke;let re=class{constructor(B=[],ie=!1){this.items=B,this.isIncomplete=ie}};re=qe([l],re),e.CompletionList=re;let he=class{constructor(B){this.text=B}};he=qe([l],he),e.InlineSuggestion=he;let z=class{constructor(B){this.items=B}};z=qe([l],z),e.InlineSuggestions=z;var J;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(J=e.ViewColumn||(e.ViewColumn={}));var ce;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(ce=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Pe;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(Pe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ae;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(Ae=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ne;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Ne=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Be;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(Be=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function B(ie){switch(ie){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=B}(Be=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let rt=class{constructor(B,ie){if(ie&&!D.URI.isUri(ie))throw(0,R.illegalArgument)("target");if(!W.isRange(B)||B.isEmpty)throw(0,R.illegalArgument)("range");this.range=B,this.target=ie}};rt=qe([l],rt),e.DocumentLink=rt;let et=class{constructor(B,ie,Ce,Ge){this.red=B,this.green=ie,this.blue=Ce,this.alpha=Ge}};et=qe([l],et),e.Color=et;let Xe=class{constructor(B,ie){if(ie&&!(ie instanceof et))throw(0,R.illegalArgument)("color");if(!W.isRange(B)||B.isEmpty)throw(0,R.illegalArgument)("range");this.range=B,this.color=ie}};Xe=qe([l],Xe),e.ColorInformation=Xe;let ot=class{constructor(B){if(!B||typeof B!="string")throw(0,R.illegalArgument)("label");this.label=B}};ot=qe([l],ot),e.ColorPresentation=ot;var Et;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Et=e.ColorFormat||(e.ColorFormat={}));var bt;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(bt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var vt;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(vt=e.TaskRevealKind||(e.TaskRevealKind={}));var le;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(le=e.TaskPanelKind||(e.TaskPanelKind={}));let Se=f=class{constructor(B,ie){if(typeof B!="string"||typeof ie!="string")throw(0,R.illegalArgument)("name");this._id=B}static from(B){switch(B){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}get id(){return this._id}};Se.Clean=new f("clean","Clean"),Se.Build=new f("build","Build"),Se.Rebuild=new f("rebuild","Rebuild"),Se.Test=new f("test","Test"),Se=f=qe([l],Se),e.TaskGroup=Se;function ue(q){let B="";for(let ie=0;ie<q.length;ie++)B+=q[ie].replace(/,/g,",,")+",";return B}let G=class{constructor(B,ie,Ce){if(typeof B!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=B,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=Ce):this._options=ie)}get process(){return this._process}set process(B){if(typeof B!="string")throw(0,R.illegalArgument)("process");this._process=B}get args(){return this._args}set args(B){Array.isArray(B)||(B=[]),this._args=B}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("process"),this._process!==void 0&&B.push(this._process),this._args&&this._args.length>0)for(let ie of this._args)B.push(ie);return ue(B)}};G=qe([l],G),e.ProcessExecution=G;let Ue=class{constructor(B,ie,Ce){if(this._args=[],Array.isArray(ie)){if(!B)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,R.illegalArgument)("command");this._command=B,this._args=ie,this._options=Ce}else{if(typeof B!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=B,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(B){if(typeof B!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=B}get command(){return this._command?this._command:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,R.illegalArgument)("command");this._command=B}get args(){return this._args}set args(B){this._args=B||[]}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("shell"),this._commandLine!==void 0&&B.push(this._commandLine),this._command!==void 0&&B.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ie of this._args)B.push(typeof ie=="string"?ie:ie.value);return ue(B)}};Ue=qe([l],Ue),e.ShellExecution=Ue;var Fe;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(Fe=e.ShellQuoting||(e.ShellQuoting={}));var Ze;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(Ze=e.TaskScope||(e.TaskScope={}));class it{constructor(B){this._callback=B}computeId(){return"customExecution"+(0,I.generateUuid)()}set callback(B){this._callback=B}get callback(){return this._callback}}e.CustomExecution=it;let ct=S=class{constructor(B,ie,Ce,Ge,tt,ut){this.__deprecated=!1,this._definition=this.definition=B;let ft;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=Ce,this.execution=Ge,ft=tt,this.__deprecated=!0):ie===Ze.Global||ie===Ze.Workspace?(this.target=ie,this._name=this.name=Ce,this._source=this.source=Ge,this.execution=tt,ft=ut):(this.target=ie,this._name=this.name=Ce,this._source=this.source=Ge,this.execution=tt,ft=ut),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(B){this.__id=B}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof G?this._definition={type:S.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ue?this._definition={type:S.ShellType,id:this._execution.computeId()}:this._execution instanceof it?this._definition={type:S.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:S.EmptyType,id:(0,I.generateUuid)()}}get definition(){return this._definition}set definition(B){if(B==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=B}get scope(){return this._scope}set target(B){this.clear(),this._scope=B}get name(){return this._name}set name(B){if(typeof B!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=B}get execution(){return this._execution}set execution(B){B===null&&(B=void 0),this.clear(),this._execution=B;const ie=this._definition.type;(S.EmptyType===ie||S.ProcessType===ie||S.ShellType===ie||S.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(B){if(Array.isArray(B))this.clear(),this._problemMatchers=B,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.clear(),this._isBackground=B}get source(){return this._source}set source(B){if(typeof B!="string"||B.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=B}get group(){return this._group}set group(B){B===null&&(B=void 0),this.clear(),this._group=B}get detail(){return this._detail}set detail(B){B===null&&(B=void 0),this._detail=B}get presentationOptions(){return this._presentationOptions}set presentationOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._presentationOptions=B}get runOptions(){return this._runOptions}set runOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._runOptions=B}};ct.ExtensionCallbackType="customExecution",ct.ProcessType="process",ct.ShellType="shell",ct.EmptyType="$empty",ct=S=qe([l],ct),e.Task=ct;var gt;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let Ye=class{constructor(B,ie=dt.None){this.collapsibleState=ie,D.URI.isUri(B)?this.resourceUri=B:this.label=B}};Ye=qe([l],Ye),e.TreeItem=Ye;var dt;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(dt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let at=class{constructor(B,ie){this.id=B,this.color=ie}};at=qe([l],at),e.ThemeIcon=at,at.File=new at("file"),at.Folder=new at("folder");let lt=class{constructor(B){this.id=B}};lt=qe([l],lt),e.ThemeColor=lt;var Pt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(B,ie){if(typeof B!="string"&&(!B||!D.URI.isUri(B)&&!D.URI.isUri(B.uri)))throw(0,R.illegalArgument)("base");if(typeof ie!="string")throw(0,R.illegalArgument)("pattern");typeof B=="string"?(this.baseFolder=D.URI.file(B),this.base=B):D.URI.isUri(B)?(this.baseFolder=B,this.base=B.fsPath):(this.baseFolder=B.uri,this.base=B.uri.fsPath),this.pattern=ie}};Ct=qe([l],Ct),e.RelativePattern=Ct;let At=class{constructor(B,ie,Ce,Ge){this.enabled=typeof B=="boolean"?B:!0,typeof ie=="string"&&(this.condition=ie),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,I.generateUuid)()),this._id}};At=qe([l],At),e.Breakpoint=At;let Rt=class extends At{constructor(B,ie,Ce,Ge,tt){super(ie,Ce,Ge,tt);if(B===null)throw(0,R.illegalArgument)("location");this.location=B}};Rt=qe([l],Rt),e.SourceBreakpoint=Rt;let St=class extends At{constructor(B,ie,Ce,Ge,tt){super(ie,Ce,Ge,tt);this.functionName=B}};St=qe([l],St),e.FunctionBreakpoint=St;let Xt=class extends At{constructor(B,ie,Ce,Ge,tt,ut,ft){super(Ge,tt,ut,ft);if(!ie)throw(0,R.illegalArgument)("dataId");this.label=B,this.dataId=ie,this.canPersist=Ce}};Xt=qe([l],Xt),e.DataBreakpoint=Xt;let Yt=class{constructor(B,ie,Ce){this.command=B,this.args=ie||[],this.options=Ce}};Yt=qe([l],Yt),e.DebugAdapterExecutable=Yt;let mt=class{constructor(B,ie){this.port=B,this.host=ie}};mt=qe([l],mt),e.DebugAdapterServer=mt;let Jt=class{constructor(B){this.path=B}};Jt=qe([l],Jt),e.DebugAdapterNamedPipeServer=Jt;let Zt=class{constructor(B){this.implementation=B}};Zt=qe([l],Zt),e.DebugAdapterInlineImplementation=Zt;let Dt=class{constructor(B,ie){this.range=B,this.expression=ie}};Dt=qe([l],Dt),e.EvaluatableExpression=Dt;var dn;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(dn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let en=class{constructor(B,ie){this.range=B,this.text=ie}};en=qe([l],en),e.InlineValueText=en;let xt=class{constructor(B,ie,Ce=!0){this.range=B,this.variableName=ie,this.caseSensitiveLookup=Ce}};xt=qe([l],xt),e.InlineValueVariableLookup=xt;let ht=class{constructor(B,ie){this.range=B,this.expression=ie}};ht=qe([l],ht),e.InlineValueEvaluatableExpression=ht;let tn=class{constructor(B,ie){this.frameId=B,this.stoppedLocation=ie}};tn=qe([l],tn),e.InlineValueContext=tn;var Ft;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Ft=e.FileChangeType||(e.FileChangeType={}));let Mt=E=class extends Error{constructor(B,ie=i.FileSystemProviderErrorCode.Unknown,Ce){var Ge;super(D.URI.isUri(B)?B.toString(!0):B);this.code=(Ge=Ce==null?void 0:Ce.name)!==null&&Ge!==void 0?Ge:"Unknown",(0,i.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(B){return new E(B,i.FileSystemProviderErrorCode.FileExists,E.FileExists)}static FileNotFound(B){return new E(B,i.FileSystemProviderErrorCode.FileNotFound,E.FileNotFound)}static FileNotADirectory(B){return new E(B,i.FileSystemProviderErrorCode.FileNotADirectory,E.FileNotADirectory)}static FileIsADirectory(B){return new E(B,i.FileSystemProviderErrorCode.FileIsADirectory,E.FileIsADirectory)}static NoPermissions(B){return new E(B,i.FileSystemProviderErrorCode.NoPermissions,E.NoPermissions)}static Unavailable(B){return new E(B,i.FileSystemProviderErrorCode.Unavailable,E.Unavailable)}};Mt=E=qe([l],Mt),e.FileSystemError=Mt;let qt=class{constructor(B,ie,Ce){this.start=B,this.end=ie,this.kind=Ce}};qt=qe([l],qt),e.FoldingRange=qt;var wn;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(wn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var bn;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(bn=e.CommentMode||(e.CommentMode={}));class fn{constructor(B,ie=[]){this.tokenTypes=B,this.tokenModifiers=ie}}e.SemanticTokensLegend=fn;function Bt(q){return typeof q=="undefined"||(0,P.isStringArray)(q)}class nn{constructor(B){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,B){this._hasLegend=!0;for(let ie=0,Ce=B.tokenTypes.length;ie<Ce;ie++)this._tokenTypeStrToInt.set(B.tokenTypes[ie],ie);for(let ie=0,Ce=B.tokenModifiers.length;ie<Ce;ie++)this._tokenModifierStrToInt.set(B.tokenModifiers[ie],ie)}}push(B,ie,Ce,Ge,tt){if(typeof B=="number"&&typeof ie=="number"&&typeof Ce=="number"&&typeof Ge=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(B,ie,Ce,Ge,tt);if(W.isRange(B)&&typeof ie=="string"&&Bt(Ce))return this._push(B,ie,Ce);throw(0,R.illegalArgument)()}_push(B,ie,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ge=B.start.line,tt=B.start.character,ut=B.end.character-B.start.character,ft=this._tokenTypeStrToInt.get(ie);let yt=0;if(Ce)for(const kt of Ce){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const Tt=this._tokenModifierStrToInt.get(kt);yt|=1<<Tt>>>0}this._pushEncoded(Ge,tt,ut,ft,yt)}_pushEncoded(B,ie,Ce,Ge,tt){if(this._dataIsSortedAndDeltaEncoded&&(B<this._prevLine||B===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let kt=0,Tt=0;for(let Lt=0;Lt<yt;Lt++){let Nt=this._data[5*Lt],cn=this._data[5*Lt+1];Nt===0?(Nt=kt,cn+=Tt):Nt+=kt,this._data[5*Lt]=Nt,this._data[5*Lt+1]=cn,kt=Nt,Tt=cn}}let ut=B,ft=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=tt,this._prevLine=B,this._prevChar=ie}static _sortAndDeltaEncode(B){let ie=[];const Ce=B.length/5|0;for(let ft=0;ft<Ce;ft++)ie[ft]=ft;ie.sort((ft,yt)=>{const kt=B[5*ft],Tt=B[5*yt];if(kt===Tt){const Lt=B[5*ft+1],Nt=B[5*yt+1];return Lt-Nt}return kt-Tt});const Ge=new Uint32Array(B.length);let tt=0,ut=0;for(let ft=0;ft<Ce;ft++){const yt=5*ie[ft],kt=B[yt+0],Tt=B[yt+1],Lt=B[yt+2],Nt=B[yt+3],cn=B[yt+4],On=kt-tt,zn=On===0?Tt-ut:Tt,un=5*ft;Ge[un+0]=On,Ge[un+1]=zn,Ge[un+2]=Lt,Ge[un+3]=Nt,Ge[un+4]=cn,tt=kt,ut=Tt}return Ge}build(B){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),B):new Ht(nn._sortAndDeltaEncode(this._data),B)}}e.SemanticTokensBuilder=nn;class Ht{constructor(B,ie){this.resultId=ie,this.data=B}}e.SemanticTokens=Ht;class rn{constructor(B,ie,Ce){this.start=B,this.deleteCount=ie,this.data=Ce}}e.SemanticTokensEdit=rn;class En{constructor(B,ie){this.resultId=ie,this.edits=B}}e.SemanticTokensEdits=En;var _n;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(_n=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Ot;(function(q){q[q.Initial=1]="Initial",q[q.Dynamic=2]="Dynamic"})(Ot=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Kt=class{constructor(){}};Kt.Back={iconPath:new at("arrow-left")},Kt=qe([l],Kt),e.QuickInputButtons=Kt;var Sn;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(Sn=e.ExtensionKind||(e.ExtensionKind={}));class yn{constructor(B,ie,Ce){this.badge=B,this.tooltip=ie,this.color=Ce}static validate(B){if(B.badge&&B.badge.length!==1&&B.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=yn;let sn=class{constructor(B){this.kind=B}};sn=qe([l],sn),e.ColorTheme=sn;var on;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast"})(on=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(B,ie){if(B<0)throw(0,R.illegalArgument)("start must be positive");if(ie<0)throw(0,R.illegalArgument)("end must be positive");B<=ie?(this._start=B,this._end=ie):(this._start=ie,this._end=B)}static isNotebookRange(B){return B instanceof $t?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(B){let ie=this._start,Ce=this._end;return B.start!==void 0&&(ie=B.start),B.end!==void 0&&(Ce=B.end),ie===this._start&&Ce===this._end?this:new $t(ie,Ce)}}e.NotebookRange=$t;class Gt{constructor(B,ie){typeof B=="object"?Object.assign(this,B):(this.inputCollapsed=B,this.outputCollapsed=ie)}with(B){let{inputCollapsed:ie,outputCollapsed:Ce}=B,Ge=Qt(B,["inputCollapsed","outputCollapsed"]);return ie===void 0?ie=this.inputCollapsed:ie===null&&(ie=void 0),Ce===void 0?Ce=this.outputCollapsed:Ce===null&&(Ce=void 0),ie===this.inputCollapsed&&Ce===this.outputCollapsed&&Object.keys(Ge).length===0?this:new Gt(Object.assign({inputCollapsed:ie,outputCollapsed:Ce},Ge))}}e.NotebookCellMetadata=Gt;class Wt{constructor(B={}){Object.assign(this,B)}with(B){return new Wt(B)}}e.NotebookDocumentMetadata=Wt;class Oe{constructor(B,ie,Ce,Ge,tt,ut){this.kind=B,this.value=ie,this.languageId=Ce,this.outputs=Ge!=null?Ge:[],this.metadata=tt,this.executionSummary=ut,Oe.validate(this)}static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(ie=>Oe.isNotebookCellData(ie))}static isNotebookCellData(B){return!0}}e.NotebookCellData=Oe;class an{constructor(B,ie){this.cells=B,this.metadata=ie!=null?ie:new Wt}}e.NotebookData=an;class It{constructor(B,ie,Ce){if(this.mime=B,this.value=ie,this.metadata=Ce,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(B){return B instanceof It?!0:B?typeof B.mime=="string":!1}static error(B){const ie={name:B.name,message:B.message,stack:B.stack};return It.json(ie,"application/vnd.code.notebook.error")}static stdout(B){return It.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return It.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,ie="application/octet-stream"){return new It(ie,B)}static text(B,ie="text/plain"){const Ce=$e(It,w,"f",m).encode(String(B));return new It(ie,Ce)}static json(B,ie="application/json"){const Ce=JSON.stringify(B,void 0,"	");return It.text(Ce,ie)}}e.NotebookCellOutputItem=It,w=It,m={value:new TextEncoder};class pt{constructor(B,ie,Ce){this.outputs=B,typeof ie=="string"?(this.id=ie,this.metadata=Ce):(this.id=(0,I.generateUuid)(),this.metadata=ie!=null?ie:Ce)}}e.NotebookCellOutput=pt;var Dn;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(Dn=e.NotebookCellKind||(e.NotebookCellKind={}));var Cn;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(Cn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var mn;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(mn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gn;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(gn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class kn{constructor(B,ie,Ce,Ge,tt,ut){this.text=B,this.alignment=ie,this.command=Ce,this.tooltip=Ge,this.priority=tt,this.accessibilityInformation=ut}}e.NotebookCellStatusBarItem=kn;var In;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(In=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pn{constructor(B,ie=[]){this.uri=B,this.provides=typeof ie=="string"?[ie]:ie}}e.NotebookKernelPreload=Pn;let ln=class{constructor(B,ie){this.label=B,this.timestamp=ie}};ln=qe([l],ln),e.TimelineItem=ln;var pn;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(pn=e.ExtensionMode||(e.ExtensionMode={}));var An;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(An=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Tn;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=4]="RegEx"})(Tn=e.StandardTokenType||(e.StandardTokenType={}));class Rn{constructor(B,ie){this.ranges=B,this.wordPattern=ie}}e.LinkedEditingRanges=Rn;class Ln{constructor(B,ie){this._port=B,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ln;var Fn;(function(q){q[q.Unset=0]="Unset",q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(Fn=e.TestResultState||(e.TestResultState={}));var Z;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information",q[q.Hint=3]="Hint"})(Z=e.TestMessageSeverity||(e.TestMessageSeverity={}));var fe;(function(q){q[q.Pending=0]="Pending",q[q.Resolved=1]="Resolved"})(fe=e.TestItemStatus||(e.TestItemStatus={}));const Te=(q,B,ie,Ce)=>{let Ge=ie;return{enumerable:!0,configurable:!1,get(){return Ge},set(tt){Ce(Ge,tt)||(Ge=tt,q.bus.fire([3,B,tt]))}}},st=(q,B)=>q===B,wt=(q,B)=>q===B?!0:!q||!B?!1:q.isEqual(B);class _t{constructor(B,ie,Ce,Ge){this.label=ie,this.data=Ge;const tt=(0,h.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:B,enumerable:!0,writable:!1},uri:{value:Ce,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>tt.parent},children:{value:new T.ReadonlyMapView(tt.children),enumerable:!0,writable:!1},range:Te(tt,"range",void 0,wt),description:Te(tt,"description",void 0,st),runnable:Te(tt,"runnable",!0,st),debuggable:Te(tt,"debuggable",!1,st),status:Te(tt,"status",fe.Resolved,st),error:Te(tt,"error",void 0,st)})}invalidate(){(0,h.getPrivateApiFor)(this).bus.fire([2])}dispose(){const B=(0,h.getPrivateApiFor)(this);B.parent&&(0,h.getPrivateApiFor)(B.parent).children.delete(this.id),B.bus.fire([1])}addChild(B){if(!(B instanceof _t))throw new Error("Test child must be created through vscode.test.createTestItem()");const ie=(0,h.getPrivateApiFor)(this);if(ie.children.has(B.id))throw new Error(`Attempted to insert a duplicate test item ID ${B.id}`);ie.children.set(B.id,B),ie.bus.fire([0,B])}}e.TestItemImpl=_t;class Mn{constructor(B){this.message=B,this.severity=Z.Error}static diff(B,ie,Ce){const Ge=new Mn(B);return Ge.expectedOutput=ie,Ge.actualOutput=Ce,Ge}}e.TestMessage=Mn;var $n;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})($n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Wn;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(Wn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Hn;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore"})(Hn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(me[120],ge([0,1,51,10,8,145,107,7,16]),function(K,e,v,R,C,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function i(a,w){w?I.set(a,w):I.delete(a)}e.setWordDefinitionFor=i;function A(a){return I.get(a)}e.getWordDefinitionFor=A;class h extends T.MirrorTextModel{constructor(w,m,b,_,u,c,d,t){super(m,b,_,u);this._proxy=w,this._languageId=c,this._isDirty=d,this._notebook=t,this._isDisposed=!1}dispose(){(0,v.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,D.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===R.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},get notebook(){return w._notebook},save(){return w._save()},getText(m){return m?w._getTextInRange(m):w.getText()},get eol(){return w._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(m){return w._lineAt(m)},offsetAt(m){return w._offsetAt(m)},positionAt(m){return w._positionAt(m)},validateRange(m){return w._validateRange(m)},validatePosition(m){return w._validatePosition(m)},getWordRangeAtPosition(m,b){return w._getWordRangeAtPosition(m,b)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,v.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,v.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const m=this._validateRange(w);if(m.isEmpty)return"";if(m.isSingleLine)return this._lines[m.start.line].substring(m.start.character,m.end.character);const b=this._eol,_=m.start.line,u=m.end.line,c=[];c.push(this._lines[_].substring(m.start.character));for(let d=_+1;d<u;d++)c.push(this._lines[d]);return c.push(this._lines[u].substring(0,m.end.character)),c.join(b)}_lineAt(w){let m;if(w instanceof P.Position?m=w.line:typeof w=="number"&&(m=w),typeof m!="number"||m<0||m>=this._lines.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new p(m,this._lines[m],m===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const m=this._lineStarts.getIndexOf(w),b=this._lines[m.index].length;return new P.Position(m.index,Math.min(m.remainder,b))}_validateRange(w){if(!(w instanceof P.Range))throw new Error("Invalid argument");const m=this._validatePosition(w.start),b=this._validatePosition(w.end);return m===w.start&&b===w.end?w:new P.Range(m.line,m.character,b.line,b.character)}_validatePosition(w){if(!(w instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:m,character:b}=w,_=!1;if(m<0)m=0,b=0,_=!0;else if(m>=this._lines.length)m=this._lines.length-1,b=this._lines[m].length,_=!0;else{const u=this._lines[m].length;b<0?(b=0,_=!0):b>u&&(b=u,_=!0)}return _?new P.Position(m,b):w}_getWordRangeAtPosition(w,m){const b=this._validatePosition(w);if(!m)m=A(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const _=(0,y.getWordAtText)(b.character+1,(0,y.ensureValidWordDefinition)(m),this._lines[b.line],0);if(_)return new P.Range(b.line,_.startColumn-1,b.line,_.endColumn-1)}}e.ExtHostDocumentData=h;class p{constructor(w,m,b){this._line=w,this._text=m,this._isLastLine=b}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(me[197],ge([0,1,7,3,109,6,78,23,2,32]),function(K,e,v,R,C,T,y,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(h,p,a,w){this._notebook=a,this._selector=w,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,I.generateUuid)()}),this._init(),this._disposables.add(p.onDidChangeDocument(b=>{const _=this._cellUris.get(b.document.uri);_!==void 0&&(this._cellLengths.changeValue(_,this._cells[_].document.getText().length+1),this._cellLines.changeValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const m=b=>{b===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(h.onDidChangeNotebookCells(b=>m(b.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const h=[],p=[];for(const a of this._notebook.getCells())a.kind===v.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),h.push(a.document.getText().length+1),p.push(a.document.lineCount));this._cellLengths=new C.PrefixSumComputer(new Uint32Array(h)),this._cellLines=new C.PrefixSumComputer(new Uint32Array(p))}get version(){return this._versionId}getText(h){var p,a;if(!h){let u="";for(const c of this._cells)u+=c.document.getText()+`
`;return u=u.slice(0,-1),u}if(h.isEmpty)return"";const w=this.locationAt(h.start),m=this.locationAt(h.end),b=this._cells[(p=this._cellUris.get(w.uri))!==null&&p!==void 0?p:-1],_=this._cells[(a=this._cellUris.get(m.uri))!==null&&a!==void 0?a:-1];if(!b||!_)return"";if(b===_)return b.document.getText(new v.Range(w.range.start,m.range.end));{const u=b.document.getText(new v.Range(w.range.start,new v.Position(b.document.lineCount,0))),c=_.document.getText(new v.Range(new v.Position(0,0),m.range.end));return u+`
`+c}}offsetAt(h){const p=this._cellLines.getIndexOf(h.line),a=this._cellLengths.getAccumulatedValue(p.index-1),w=this._cells[p.index].document.offsetAt(h.with(p.remainder));return a+w}positionAt(h){if(typeof h=="number"){const a=this._cellLengths.getIndexOf(h),w=this._cellLines.getAccumulatedValue(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(w)}const p=this._cellUris.get(h.uri);if(p!==void 0){const a=this._cellLines.getAccumulatedValue(p-1);return new v.Position(a+h.range.start.line,h.range.start.character)}return new v.Position(0,0)}locationAt(h){v.Range.isRange(h)||(h=new v.Range(h,h));const p=this._cellLines.getIndexOf(h.start.line);let a=p;h.isEmpty||(a=this._cellLines.getIndexOf(h.end.line));const w=new v.Position(p.remainder,h.start.character),m=new v.Position(a.remainder,h.end.character),b=new v.Range(w,m),_=this._cells[p.index];return new v.Location(_.document.uri,_.document.validateRange(b))}contains(h){return this._cellUris.has(h)}validateRange(h){const p=this.validatePosition(h.start),a=this.validatePosition(h.end);return h.with(p,a)}validatePosition(h){const p=this._cellLines.getIndexOf(h.line),a=new v.Position(p.remainder,h.character),w=this._cells[p.index].document.validatePosition(a),m=this._cellLines.getAccumulatedValue(p.index-1);return new v.Position(m+w.line,w.character)}}e.ExtHostNotebookConcatDocument=i}),define(me[198],ge([0,1,7,15,3]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(P){this._actual=new v.ColorTheme(v.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let D=P==="light"?v.ColorThemeKind.Light:P==="dark"?v.ColorThemeKind.Dark:v.ColorThemeKind.HighContrast;this._actual=new v.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=qe([He(0,R.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(me[63],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,v.createDecorator)("IURITransformerService");class R{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=R}),define(me[199],ge([0,1,22]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(D){let I=this.buffers.indexOf(D);return I<0&&(I=this.buffers.length,this.buffers.push(D)),I}}function C(P,D){if(D.serializeBuffersForPostMessage){const I=new R,i=(p,a)=>{if(a instanceof ArrayBuffer){const w=I.add(a);return{$$vscode_array_buffer_reference$$:!0,index:w}}else if(ArrayBuffer.isView(a)){const w=T(a);if(w){const m=I.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:m,view:{type:w,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},A=JSON.stringify(P,i),h=I.buffers.map(p=>{const a=new Uint8Array(p);return v.VSBuffer.wrap(a)});return{message:A,buffers:h}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=C;function T(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(P,D){const I=D.map(h=>{const p=new ArrayBuffer(h.byteLength);return new Uint8Array(p).set(h.buffer),p}),i=D.length?(h,p)=>{if(typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const a=p,{index:w}=a,m=I[w];if(a.view)switch(a.view.type){case 1:return new Int8Array(m,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return p}:void 0;return{message:JSON.parse(P,i),arrayBuffers:I}}e.deserializeWebviewMessage=y}),define(me[87],ge([0,1,10,2]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function C(T,y){return T.scheme===v.Schemas.http||T.scheme===v.Schemas.https?T:(y&&y.authority&&y.isRemote&&T.scheme===v.Schemas.file&&(T=R.URI.from({scheme:v.Schemas.vscodeRemote,authority:y.authority,path:T.path})),R.URI.from({scheme:v.Schemas.https,authority:`${T.scheme}+${T.authority}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=C}),define(me[200],ge([0,1,3,6,87]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(P,D,I){this._proxy=P,this._editors=D,this._initData=I,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const i=D.getVisibleTextEditors();for(const A of this._insets.values())i.indexOf(A.editor)<0&&A.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,D,I,i,A){let h;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===P){h=u;break}if(!h)throw new Error("not a visible editor");const p=this,a=this._handlePool++,w=new v.Emitter,m=new v.Emitter,b=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,C.asWebviewUri)(u,p._initData.remote)}get cspSource(){return C.webviewGenericCspSource}set options(u){this._options=u,p._proxy.$setOptions(a,u)}get options(){return this._options}set html(u){this._html=u,p._proxy.$setHtml(a,u)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(u){return p._proxy.$postMessage(a,u)}},_=new class{constructor(){this.editor=P,this.line=D,this.height=I,this.webview=b,this.onDidDispose=m.event}dispose(){p._insets.has(a)&&(p._insets.delete(a),p._proxy.$disposeEditorInset(a),m.fire(),m.dispose(),w.dispose())}};return this._proxy.$createEditorInset(a,h.id,h.value.document.uri,D+1,I,i||{},A.identifier,A.extensionLocation),this._insets.set(a,{editor:P,inset:_,onDidReceiveMessage:w}),_}$onDidDispose(P){const D=this._insets.get(P);D&&D.inset.dispose()}$onDidReceiveMessage(P,D){const I=this._insets.get(P);I&&I.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=T}),define(me[201],ge([0,1,3,81,168,4,6,23,38,16,52,24,45,194]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,p.registerIcon)("default-view-icon",h.Codicon.window,(0,C.localize)(0,null));var a;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var w;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel"})(w=e.ViewContainerLocation||(e.ViewContainerLocation={}));function m(o){switch(o){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=m;function b(o){return`viewContainer.${o}.enabled`}e.getEnabledViewContainerContextKey=b;class _ extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new v.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new v.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,I.flatten)([...this.viewContainers.values()])}registerViewContainer(g,f,S){var E;const l=this.get(g.id);if(l)return l;const L=g;return L.openCommandActionDescriptor=(S==null?void 0:S.donotRegisterOpenCommand)?void 0:(E=L.openCommandActionDescriptor)!==null&&E!==void 0?E:{id:L.id},(0,P.getOrSet)(this.viewContainers,f,[]).push(L),(S==null?void 0:S.isDefault)&&this.defaultViewContainers.push(L),this._onDidRegister.fire({viewContainer:L,viewContainerLocation:f}),L}deregisterViewContainer(g){for(const f of this.viewContainers.keys()){const S=this.viewContainers.get(f),E=S==null?void 0:S.indexOf(g);if(E!==-1){S==null||S.splice(E,1),S.length===0&&this.viewContainers.delete(f),this._onDidDeregister.fire({viewContainer:g,viewContainerLocation:f});return}}}get(g){return this.all.filter(f=>f.id===g)[0]}getViewContainers(g){return[...this.viewContainers.get(g)||[]]}getViewContainerLocation(g){return[...this.viewContainers.keys()].filter(f=>this.getViewContainers(f).filter(S=>(S==null?void 0:S.id)===g.id).length>0)[0]}getDefaultViewContainer(g){return this.defaultViewContainers.find(f=>this.getViewContainerLocation(f)===g)}}D.Registry.add(a.ViewContainersRegistry,new _);var u;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(u=e.ViewContentGroups||(e.ViewContentGroups={}));function c(o,g){var f,S,E,l;const L=(f=o.group)!==null&&f!==void 0?f:u.More,O=(S=g.group)!==null&&S!==void 0?S:u.More;return L!==O?L.localeCompare(O):((E=o.order)!==null&&E!==void 0?E:5)-((l=g.order)!==null&&l!==void 0?l:5)}class d extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new v.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new v.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new v.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new v.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(g,f){this.registerViews2([{views:g,viewContainer:f}])}registerViews2(g){g.forEach(({views:f,viewContainer:S})=>this.addViews(f,S)),this._onViewsRegistered.fire(g)}deregisterViews(g,f){const S=this.removeViews(g,f);S.length&&this._onViewsDeregistered.fire({views:S,viewContainer:f})}moveViews(g,f){for(const S of this._views.keys())if(S!==f){const E=this.removeViews(g,S);E.length&&(this.addViews(E,f),this._onDidChangeContainer.fire({views:E,from:S,to:f}))}}getViews(g){return this._views.get(g)||[]}getView(g){for(const f of this._viewContainers){const S=(this._views.get(f)||[]).filter(E=>E.id===g)[0];if(S)return S}return null}getViewContainer(g){for(const f of this._viewContainers)if((this._views.get(f)||[]).filter(E=>E.id===g)[0])return f;return null}registerViewWelcomeContent(g,f){return this._viewWelcomeContents.add(g,f),this._onDidChangeViewWelcomeContent.fire(g),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(g,f),this._onDidChangeViewWelcomeContent.fire(g)})}registerViewWelcomeContent2(g,f){const S=new Map;for(const[E,l]of f)this._viewWelcomeContents.add(g,l),S.set(E,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(g,l),this._onDidChangeViewWelcomeContent.fire(g)}));return this._onDidChangeViewWelcomeContent.fire(g),S}getViewWelcomeContent(g){const f=[];return this._viewWelcomeContents.forEach(g,S=>f.push(S)),f.sort(c)}addViews(g,f){let S=this._views.get(f);S||(S=[],this._views.set(f,S),this._viewContainers.push(f));for(const E of g){if(this.getView(E.id)!==null)throw new Error((0,C.localize)(1,null,E.id));S.push(E)}}removeViews(g,f){const S=this._views.get(f);if(!S)return[];const E=[],l=[];for(const L of S)g.includes(L)?E.push(L):l.push(L);return E.length&&(l.length?this._views.set(f,l):(this._views.delete(f),this._viewContainers.splice(this._viewContainers.indexOf(f),1))),E}}D.Registry.add(a.ViewsRegistry,new d),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",(0,C.localize)(2,null));function t(o){return`view.${o}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var n;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(g,f){this.resolved=!1,this._hasResolve=!1,(0,A.mixin)(this,g),this._hasResolve=!!f,this.resolve=async S=>{var E,l;if(f&&!this.resolved){const L=await f(S);L&&(this.tooltip=(E=this.tooltip)!==null&&E!==void 0?E:L.tooltip,this.command=(l=this.command)!==null&&l!==void 0?l:L.command)}S.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(me[202],ge([0,1,2,179,118,14,180,201]),function(K,e,v,R,C,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(a){return(w,...m)=>a(w.get(R.ICommandService),...m)}class I{static execute(w,m){const b={forceReuseWindow:m&&m.reuseWindow,remoteAuthority:m&&m.remoteAuthority};return w.executeCommand("_files.newWindow",b)}}e.NewWindowAPICommand=I,I.ID="vscode.newWindow",R.CommandsRegistry.registerCommand({id:I.ID,handler:D(I.execute),description:{description:"Opens an new window",args:[]}}),R.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(a,w){return a.get(C.IWorkspacesService).removeRecentlyOpened([w])});class i{static execute(w,m){return typeof m=="string"?m=m.match(/^[^:/?#]+:\/\//)?v.URI.parse(m):v.URI.file(m):m=v.URI.revive(m),w.executeCommand("_workbench.removeFromRecentlyOpened",m)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",R.CommandsRegistry.registerCommand(i.ID,D(i.execute)),R.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(a,w){const m=a.get(C.IWorkspacesService);let b;const _=w.uri,u=w.label,c=w.remoteAuthority;return w.type==="workspace"?b={workspace:await m.getWorkspaceIdentifier(_),label:u,remoteAuthority:c}:w.type==="folder"?b={folderUri:_,label:u,remoteAuthority:c}:b={fileUri:_,label:u,remoteAuthority:c},m.addRecentlyOpened([b])}),R.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(a){return a.get(C.IWorkspacesService).getRecentlyOpened()}),R.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(a,w){const m=a.get(T.ILogService),b=a.get(y.IEnvironmentService);b.isExtensionDevelopment&&!!b.extensionTestsLocationURI&&m.setLevel(w)}),R.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(a){return a.get(T.ILogService).getLevel()}),R.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(a,w){const m=a.get(P.IViewDescriptorService),b=m.getViewContainerById(w.destinationId);if(!!b){for(const _ of w.viewIds){const u=m.getViewDescriptorById(_);(u==null?void 0:u.canMoveView)&&m.moveViewsToContainer([u],b,P.ViewVisibilityState.Default)}await a.get(P.IViewsService).openViewContainer(b.id,!0)}});class A{static execute(w,m){return!Array.isArray(m==null?void 0:m.viewIds)||typeof(m==null?void 0:m.destinationId)!="string"?Promise.reject("Invalid arguments"):w.executeCommand("_workbench.action.moveViews",m)}}e.MoveViewsAPICommand=A,A.ID="vscode.moveViews",R.CommandsRegistry.registerCommand({id:A.ID,handler:D(A.execute),description:{description:"Move Views",args:[]}});class h{static execute(w,m){return w.executeCommand("_workbench.open",m)}}h.ID="vscode.open",R.CommandsRegistry.registerCommand(h.ID,D(h.execute));class p{static execute(w,m,b,_,u){return w.executeCommand("_workbench.diff",[m,b,_])}}p.ID="vscode.diff",R.CommandsRegistry.registerCommand(p.ID,D(p.execute))}),define(me[121],ge([0,1,3,13,169]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new v.Emitter,this._onExit=new v.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,D,I,i){const A={command:P};if(D&&Object.keys(D).length>0&&(A.arguments=D),this.internalSend("request",A),typeof i=="number"){const h=setTimeout(()=>{clearTimeout(h);const p=this.pendingRequests.get(A.seq);if(p){this.pendingRequests.delete(A.seq);const a={type:"response",seq:0,request_seq:A.seq,success:!1,command:P,message:(0,C.localize)(0,null,i,P)};p(a)}},i)}return I&&this.pendingRequests.set(A.seq,I),A.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,D){return P.type!=="event"||D.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,R.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const D=P,I=this.pendingRequests.get(D.request_seq);I&&(this.pendingRequests.delete(D.request_seq),I(D));break}}}internalSend(P,D){D.type=P,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((D,I)=>P.set(I,D)),await(0,R.timeout)(500),P.forEach((D,I)=>{D({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(me[203],ge([0,1,8,2,9,24,10]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function D(n,s,r){return n.replace(P,function(o,g){return s&&g.length>0&&g[0]!=="_"?o:r&&r.hasOwnProperty(g)?r[g]:o})}e.formatPII=D;function I(n){const s={};for(const r of Object.keys(n))r.startsWith("!")||(s[r]=n[r]);return s}e.filterExceptionsFromTelemetry=I;function i(n){return n.configuration.request==="attach"&&!A(n)}e.isSessionAttach=i;function A(n){let s=n.configuration.type;if(!!s)return s==="vslsShare"&&(s=n.configuration.adapterProxy.configuration.type),(0,v.equalsIgnoreCase)(s,"extensionhost")||(0,v.equalsIgnoreCase)(s,"pwa-extensionhost")?n:n.parentSession?A(n.parentSession):void 0}e.getExtensionHostDebugSession=A;function h(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=h;function p(n,s,r){let o,g=0,f=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,S=null;for(;S=f.exec(n);){let E=S.index+1,l=E+S[0].length;if(E<=s&&l>=r){o=S[0],g=E;break}}if(o){let E=/\w+/g,l=null;for(;(l=E.exec(o))&&!(l.index+1+g+l[0].length>=r););l&&(o=o.substring(0,E.lastIndex))}return o?{start:g,end:g+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(n){return!!(n&&n.match(a))}e.isUri=w;function m(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(w(n.path))return R.URI.parse(n.path);if((0,C.isAbsolute)(n.path))return R.URI.file(n.path)}return n.path}function b(n){if(typeof n.path=="object"){const s=R.URI.revive(n.path);if(s)return s.scheme===y.Schemas.file?s.fsPath:s.toString()}return n.path}function _(n,s){const r=s?m:b,o=(0,T.deepClone)(n);return c(o,(g,f)=>{g&&f&&(f.path=r(f))}),o}e.convertToDAPaths=_;function u(n,s){const r=s?m:b,o=(0,T.deepClone)(n);return c(o,(g,f)=>{!g&&f&&(f.path=r(f))}),o}e.convertToVSCPaths=u;function c(n,s){switch(n.type){case"event":const r=n;switch(r.event){case"output":s(!1,r.body.source);break;case"loadedSource":s(!1,r.body.source);break;case"breakpoint":s(!1,r.body.breakpoint.source);break;default:break}break;case"request":const o=n;switch(o.command){case"setBreakpoints":s(!0,o.arguments.source);break;case"breakpointLocations":s(!0,o.arguments.source);break;case"source":s(!0,o.arguments.source);break;case"gotoTargets":s(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(f=>s(!1,f));break;default:break}break;case"response":const g=n;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(f=>s(!1,f.source));break;case"loadedSources":g.body.sources.forEach(f=>s(!1,f));break;case"scopes":g.body.scopes.forEach(f=>s(!1,f.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(f=>s(!1,f.source));break;case"setBreakpoints":g.body.breakpoints.forEach(f=>s(!1,f.source));break;default:break}break}}function d(n){return n.filter(s=>{var r;return!((r=s.presentation)===null||r===void 0?void 0:r.hidden)}).sort((s,r)=>s.presentation?r.presentation?s.presentation.group?r.presentation.group?s.presentation.group!==r.presentation.group?s.presentation.group.localeCompare(r.presentation.group):t(s.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(s.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=d;function t(n,s){return typeof n!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:n-s}}),define(me[204],ge([0,1,28,37,170,122,9,8,24,11,181,121]),function(K,e,v,R,C,T,y,P,D,I,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class h extends A.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(_,u){this.outputStream=u,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,_.on("data",c=>this.handleData(c))}sendMessage(_){if(this.outputStream){const u=JSON.stringify(_);this.outputStream.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${h.TWO_CRLF}${u}`,"utf8")}}handleData(_){for(this.rawData=Buffer.concat([this.rawData,_]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const u=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+u))}continue}}else{const u=this.rawData.indexOf(h.TWO_CRLF);if(u!==-1){const d=this.rawData.toString("utf8",0,u).split(h.HEADER_LINESEPARATOR);for(const t of d){const n=t.split(h.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(u+h.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=h,h.TWO_CRLF=`\r
\r
`,h.HEADER_LINESEPARATOR=/\r?\n/,h.HEADER_FIELDSEPARATOR=/: */;class p extends h{startSession(){return new Promise((_,u)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),_(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.socket.on("error",d=>{c?this._onError.fire(d):u(d)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=p;class a extends p{constructor(_){super();this.adapterServer=_}createConnection(_){return T.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",_)}}e.SocketDebugAdapter=a;class w extends p{constructor(_){super();this.adapterServer=_}createConnection(_){return T.createConnection(this.adapterServer.path,_)}}e.NamedPipeDebugAdapter=w;class m extends h{constructor(_,u,c){super();this.adapterExecutable=_,this.debugType=u,this.outputService=c}async startSession(){const _=this.adapterExecutable.command,u=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(_)if(y.isAbsolute(_)){if(!await(0,v.exists)(_))throw new Error(C.localize(0,null,_))}else _.indexOf("/")<0&&_.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let d=process.env;if(c.env&&Object.keys(c.env).length>0&&(d=D.mixin(D.deepClone(process.env),c.env)),_==="node")if(Array.isArray(u)&&u.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:d,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(s.cwd=c.cwd);const r=R.fork(u[0],u.slice(1),s);if(!r.pid)throw new Error(C.localize(2,null,u[0]));this.serverProcess=r}else throw new Error(C.localize(3,null));else{const n={env:d};c.cwd&&(n.cwd=c.cwd),this.serverProcess=R.spawn(_,u,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,s)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const r=t.getChannel(i.ExtensionsChannelId);r&&r.append(n(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(d){this._onError.fire(d)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),I.isWindows?new Promise((_,u)=>{const c=R.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(d,t,n){if(d)return u(d)});c.on("exit",_),c.on("error",u)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(_,u){if(!_)return;const c=Object.create(null);_.runtime&&(_.runtime.indexOf("./")===0?c.runtime=y.join(u,_.runtime):c.runtime=_.runtime),_.runtimeArgs&&(c.runtimeArgs=_.runtimeArgs),_.program&&(y.isAbsolute(_.program)?c.program=_.program:c.program=y.join(u,_.program)),_.args&&(c.args=_.args);const d=_;return d.win&&(c.win=m.extract(d.win,u)),d.winx86&&(c.winx86=m.extract(d.winx86,u)),d.windows&&(c.windows=m.extract(d.windows,u)),d.osx&&(c.osx=m.extract(d.osx,u)),d.linux&&(c.linux=m.extract(d.linux,u)),c}static platformAdapterExecutable(_,u){let c=Object.create(null);u=u.toLowerCase();for(const o of _)if(o.contributes){const g=o.contributes.debuggers;g&&g.length>0&&g.filter(f=>typeof f.type=="string"&&P.equalsIgnoreCase(f.type,u)).forEach(f=>{const S=m.extract(f,o.extensionLocation.fsPath);c=D.mixin(c,S,o.isBuiltin)})}let d;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?d=c.winx86||c.win||c.windows:I.isWindows?d=c.win||c.windows:I.isMacintosh?d=c.osx:I.isLinux&&(d=c.linux),d=d||c;let t=d.program||c.program;const n=d.args||c.args;let s=d.runtime||c.runtime;const r=d.runtimeArgs||c.runtimeArgs;if(s)return{type:"executable",command:s,args:(r||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=m}),define(me[205],ge([0,1,37,11,29,189]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function y(h,p){return new Promise((a,w)=>{let m="";const b=v.spawn(h,p);b.pid&&b.stdout.on("data",_=>{m+=_.toString()}),b.on("error",_=>{w(_)}),b.on("close",_=>{a(m)})})}let P;function D(h,p){if(!P)if(R.isWindows)P=new T.WindowsExternalTerminalService(void 0);else if(R.isMacintosh)P=new T.MacExternalTerminalService(void 0);else if(R.isLinux)P=new T.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const a=p.getConfiguration("terminal");return P.runInTerminal(h.title,h.cwd,h.args,h.env||{},a.external||{})}e.runInExternalTerminal=D;function I(h){return h?R.isWindows?new Promise(async p=>{(await new Promise((w,m)=>{K(["windows-process-tree"],w,m)})).getProcessTree(h,w=>{p(w.children.length>0)})}):y("/usr/bin/pgrep",["-lP",String(h)]).then(p=>{const a=p.trim();return!(a.length===0||a.indexOf(" tmux")>=0)},p=>!0):Promise.resolve(!0)}e.hasChildProcesses=I;var i;(function(h){h[h.cmd=0]="cmd",h[h.powershell=1]="powershell",h[h.bash=2]="bash"})(i||(i={}));function A(h,p,a,w){h=h.trim().toLowerCase();let m;h.indexOf("powershell")>=0||h.indexOf("pwsh")>=0?m=1:h.indexOf("cmd.exe")>=0?m=0:h.indexOf("bash")>=0?m=2:R.isWindows?m=0:m=2;let b,_=" ";switch(m){case 1:if(b=c=>(c=c.replace(/\'/g,"''"),c.length>0&&c.charAt(c.length-1)==="\\"?`'${c}\\'`:`'${c}'`),a){const c=(0,C.getDriveLetter)(a);c&&(_+=`${c}:; `),_+=`cd ${b(a)}; `}if(w)for(let c in w){const d=w[c];d===null?_+=`Remove-Item env:${c}; `:_+=`\${env:${c}}='${d}'; `}if(p.length>0){const c=b(p.shift());_+=c[0]==="'"?`& ${c} `:`${c} `;for(let d of p)_+=`${b(d)} `}break;case 0:if(b=c=>(c=c.replace(/\"/g,'""'),c.indexOf(" ")>=0||c.indexOf('"')>=0||c.length===0?`"${c}"`:c),a){const c=(0,C.getDriveLetter)(a);c&&(_+=`${c}: && `),_+=`cd ${b(a)} && `}if(w){_+='cmd /C "';for(let c in w){let d=w[c];d===null?_+=`set "${c}=" && `:(d=d.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),_+=`set "${c}=${d}" && `)}}for(let c of p)_+=`${b(c)} `;w&&(_+='"');break;case 2:b=c=>(c=c.replace(/(["'\\\$])/g,"\\$1"),c.indexOf(" ")>=0||c.indexOf(";")>=0||c.length===0?`"${c}"`:c);const u=c=>/[^\w@%\/+=,.:^-]/.test(c)?`'${c.replace(/'/g,"'\\''")}'`:c;if(a&&(_+=`cd ${b(a)} ; `),w){_+="/usr/bin/env";for(let c in w){const d=w[c];d===null?_+=` -u ${u(c)}`:_+=` ${u(`${c}=${d}`)}`}_+=" "}for(let c of p)_+=`${b(c)} `;break}return _}e.prepareCommand=A}),define(me[64],ge([0,1,31,10,9,11,81]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarPosition=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var P;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var I;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var A;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.CellClearOutput=3]="CellClearOutput",E[E.CellsClearOutput=4]="CellsClearOutput",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.Unknown=100]="Unknown"})(A=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));function a(E,l){if(l)return E.toString();const L=w.parse(E);return L?L.notebook.toString():E.toString()}e.getCellUndoRedoComparisonKey=a;var w;(function(E){E.scheme=R.Schemas.vscodeNotebookCell;const l=/^ch(\d{7,})/;function L(N,V){return N.with({scheme:E.scheme,fragment:`ch${V.toString().padStart(7,"0")}${N.scheme!==R.Schemas.file?N.scheme:""}`})}E.generate=L;function O(N){if(N.scheme!==E.scheme)return;const V=l.exec(N.fragment);return V?{handle:Number(V[1]),notebook:N.with({scheme:N.fragment.substr(V[0].length)||R.Schemas.file,fragment:null})}:void 0}E.parse=O;function W(N){if(N.scheme!==R.Schemas.vscodeNotebookCellMetadata)return;const V=l.exec(N.fragment);return V?{handle:Number(V[1]),notebook:N.with({scheme:N.fragment.substr(V[0].length)||R.Schemas.file,fragment:null})}:void 0}E.parseCellMetadataUri=W;function te(N,V,x){return N.with({scheme:x,fragment:`ch${V.toString().padStart(7,"0")}${N.scheme!==R.Schemas.file?N.scheme:""}`})}E.generateCellUri=te;function se(N,V){if(N.scheme!==V)return;const x=l.exec(N.fragment);return x?{handle:Number(x[1]),notebook:N.with({scheme:N.fragment.substr(x[0].length)||R.Schemas.file,fragment:null})}:void 0}E.parseCellUri=se})(w=e.CellUri||(e.CellUri={}));const m=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}]]);function b(E){var l,L;return(L=(l=m.get(E))===null||l===void 0?void 0:l.alwaysSecure)!==null&&L!==void 0?L:!1}e.mimeTypeIsAlwaysSecure=b;function _(E){var l,L;return(L=(l=m.get(E))===null||l===void 0?void 0:l.supportedByCore)!==null&&L!==void 0?L:!1}e.mimeTypeSupportedByCore=_;function u(E){var l,L;return(L=(l=m.get(E))===null||l===void 0?void 0:l.mergeable)!==null&&L!==void 0?L:!1}e.mimeTypeIsMergeable=u;function c(E,l){return T.isWindows&&(E=E.replace(/\//g,"\\"),l=l.replace(/\//g,"\\")),v.match(E,l)}function d(E,l,L){let O=0;for(let W=0;W<l.length;W++){if(c(l[W],E))return O;O++}for(let W=0;W<L.length;W++){if(c(L[W],E))return O;O++}return O}function t(E,l,L){return E.sort((O,W)=>d(O,l,L)-d(W,l,L))}e.sortMimeTypes=t;function n(E,l,L,O=(W,te)=>W===te){const W=[];function te(V,x,k){if(x===0&&k.length===0)return;const U=W[W.length-1];U&&U.start+U.deleteCount===V?(U.deleteCount+=x,U.toInsert.push(...k)):W.push({start:V,deleteCount:x,toInsert:k})}let se=0,N=0;for(;;){if(se===E.length){te(se,0,l.slice(N));break}if(N===l.length){te(se,E.length-se,[]);break}const V=E[se],x=l[N];if(O(V,x)){se+=1,N+=1;continue}L(x)?(te(se,1,[]),se+=1):(te(se,0,[x]),N+=1)}return W}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(E){E.default="default",E.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(E){const l=E;return!!((typeof l.include=="string"||v.isRelativePattern(l.include))&&(typeof l.exclude=="string"||v.isRelativePattern(l.exclude)))}e.isDocumentExcludePattern=r;function o(E,l,L){if(Array.isArray(E.viewType)&&E.viewType.indexOf(l)>=0||E.viewType===l)return!0;if(E.filenamePattern){let O=r(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,W=r(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(v.match(O,(0,C.basename)(L.fsPath).toLowerCase()))return!(W&&v.match(W,(0,C.basename)(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class g{constructor(l){this.textModel=l}getElements(){const l=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)l[L]=this.textModel.cells[L].getHashValue();return l}}e.CellSequence=g,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarPosition="notebook.insertToolbarPosition",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled";var f;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(f=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class S{static create(l){return`${S._prefix}${l}`}static parse(l){if(l.startsWith(S._prefix))return l.substr(S._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=S,S._prefix="notebook/"}),define(me[206],ge([0,1,172,4,81]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new C.RawContextKey("customExecutionSupported",!0,v.localize(0,null)),e.ShellExecutionSupportedContext=new C.RawContextKey("shellExecutionSupported",!1,v.localize(1,null)),e.ProcessExecutionSupportedContext=new C.RawContextKey("processExecutionSupported",!1,v.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[207],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function v(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=v;function R(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=R}),define(me[123],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var v;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(D,I)=>{I.expand!==void 0&&(D.expand=I.expand),I.item!==void 0&&(D.item=D.item?Object.assign(D.item,I.item):I.item)};e.applyTestItemUpdate=R;var C;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(D,I)=>`${D}:${I.toString()}`;e.getTestSubscriptionKey=T;class y{add(I){}update(I){}remove(I,i){}complete(){}}e.IncrementalChangeCollector=y;class P{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(I){const i=this.createChangeCollector();for(const A of I)switch(A[0]){case 0:{const h=A[1];if(h.parent){if(this.items.has(h.parent)){const p=this.items.get(h.parent);p.children.add(h.item.extId);const a=this.createItem(h,p);this.items.set(h.item.extId,a),i.add(a)}}else{this.roots.add(h.item.extId);const p=this.createItem(h);this.items.set(h.item.extId,p),i.add(p)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=A[1],p=this.items.get(h.extId);if(!p)break;h.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,h),i.update(p);break}case 2:{const h=this.items.get(A[1]);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h.item.extId);const p=[[A[1]]];for(;p.length;)for(const a of p.pop()){const w=this.items.get(a);w&&(p.push(w.children),this.items.delete(a),i.remove(w,w!==h),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(A[1]);break;case 3:this.updatePendingRoots(A[1]);break}i.complete()}retireTest(I){}updatePendingRoots(I){this.pendingRootCount+=I}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=P}),define(me[208],ge([0,1,9,36,12,24,11,77,173]),function(K,e,v,R,C,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(A,h,p){this._contributedVariables=new Map,this._context=A,this._labelService=h,p&&(this._envVariablesPromise=p.then(a=>this.prepareEnv(a)))}prepareEnv(A){if(y.isWindows){const h=Object.create(null);return Object.keys(A).forEach(p=>{h[p.toLowerCase()]=A[p]}),h}return A}resolveWithEnvironment(A,h,p){return this.recursiveResolve(this.prepareEnv(A),h?h.uri:void 0,p)}async resolveAsync(A,h){return this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,h)}async resolveAnyBase(A,h,p,a){const w=T.deepClone(h);return y.isWindows&&w.windows?Object.keys(w.windows).forEach(m=>w[m]=w.windows[m]):y.isMacintosh&&w.osx?Object.keys(w.osx).forEach(m=>w[m]=w.osx[m]):y.isLinux&&w.linux&&Object.keys(w.linux).forEach(m=>w[m]=w.linux[m]),delete w.windows,delete w.osx,delete w.linux,this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,w,p,a)}async resolveAnyAsync(A,h,p){return this.resolveAnyBase(A,h,p)}async resolveAnyMap(A,h,p){const a=new Map;return{newConfig:await this.resolveAnyBase(A,h,p,a),resolvedVariables:a}}resolveWithInteractionReplace(A,h,p,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(A,h,p,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(A,h){if(this._contributedVariables.has(A))throw new Error("Variable "+A+" is contributed twice.");this._contributedVariables.set(A,h)}recursiveResolve(A,h,p,a,w){if(C.isString(p))return this.resolveString(A,h,p,a,w);if(C.isArray(p))return p.map(m=>this.recursiveResolve(A,h,m,a,w));if(C.isObject(p)){let m=Object.create(null);return Object.keys(p).forEach(b=>{const _=this.resolveString(A,h,b,a,w);m[_]=this.recursiveResolve(A,h,p[b],a,w)}),m}return p}resolveString(A,h,p,a,w){return p.replace(I.VARIABLE_REGEXP,(b,_)=>{if(_.includes(I.VARIABLE_LHS))return b;let u=this.evaluateSingleVariable(A,b,_,h,a);return w&&w.set(_,u),u})}fsPath(A){return this._labelService?this._labelService.getUriLabel(A,{noPrefix:!0}):A.fsPath}evaluateSingleVariable(A,h,p,a,w){let m;const b=p.split(":");b.length>1&&(p=b[0],m=b[1]);const _=()=>{const d=this._context.getFilePath();if(d)return d;throw new Error((0,D.localize)(0,null,h))},u=()=>{const d=_();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,h,v.basename(d)))},c=()=>{if(m){const d=this._context.getFolderUri(m);if(d)return d;throw new Error((0,D.localize)(2,null,h,m))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,h)):new Error((0,D.localize)(4,null,h))};switch(p){case"env":if(m){if(A){const d=A[y.isWindows?m.toLowerCase():m];if(C.isString(d))return d}return""}throw new Error((0,D.localize)(5,null,h));case"config":if(m){const d=this._context.getConfigurationValue(a,m);if(C.isUndefinedOrNull(d))throw new Error((0,D.localize)(6,null,h,m));if(C.isObject(d))throw new Error((0,D.localize)(7,null,h,m));return d}throw new Error((0,D.localize)(8,null,h));case"command":return this.resolveFromMap(h,m,w,"command");case"input":return this.resolveFromMap(h,m,w,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return a||m?(0,P.normalizeDriveLetter)(this.fsPath(c())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return v.basename(this.fsPath(c()));case"lineNumber":const d=this._context.getLineNumber();if(d)return d;throw new Error((0,D.localize)(9,null,h));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,h));case"file":return _();case"fileWorkspaceFolder":return u();case"relativeFile":return a||m?v.relative(this.fsPath(c()),_()):_();case"relativeFileDirname":const n=v.dirname(_());if(a||m){const g=v.relative(this.fsPath(c()),n);return g.length===0?".":g}return n;case"fileDirname":return v.dirname(_());case"fileExtname":return v.extname(_());case"fileBasename":return v.basename(_());case"fileBasenameNoExtension":const s=v.basename(_());return s.slice(0,s.length-v.extname(s).length);case"fileDirnameBasename":return v.basename(v.dirname(_()));case"execPath":const r=this._context.getExecPath();return r||h;case"execInstallFolder":const o=this._context.getAppRoot();return o||h;case"pathSeparator":return v.sep;default:try{const g=m?`${p}:${m}`:p;return this.resolveFromMap(h,g,w,void 0)}catch(g){return h}}}}resolveFromMap(A,h,p,a){if(h&&p){const w=a===void 0?p[h]:p[a+":"+h];if(typeof w=="string")return w;throw new Error((0,D.localize)(11,null,A))}return A}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[209],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,v.createDecorator)("editorGroupsService");var R;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(R=e.GroupDirection||(e.GroupDirection={}));var C;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var y;(function(h){h[h.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var P;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(P=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(h){h[h.GROUP_ACTIVE=0]="GROUP_ACTIVE",h[h.GROUP_INDEX=1]="GROUP_INDEX",h[h.EDITOR_OPEN=2]="EDITOR_OPEN",h[h.EDITOR_CLOSE=3]="EDITOR_CLOSE",h[h.EDITOR_MOVE=4]="EDITOR_MOVE",h[h.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",h[h.EDITOR_LABEL=6]="EDITOR_LABEL",h[h.EDITOR_PIN=7]="EDITOR_PIN",h[h.EDITOR_STICKY=8]="EDITOR_STICKY",h[h.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function A(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=A}),define(me[210],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,v.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(me[20],ge([0,1,16,22,96,281,58,24,12,2,42,80,174,113,64,210,7]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var b;(function(le){function Se(G){const{selectionStartLineNumber:Ue,selectionStartColumn:Fe,positionLineNumber:Ze,positionColumn:it}=G,ct=new m.Position(Ue-1,Fe-1),gt=new m.Position(Ze-1,it-1);return new m.Selection(ct,gt)}le.to=Se;function ue(G){const{anchor:Ue,active:Fe}=G;return{selectionStartLineNumber:Ue.line+1,selectionStartColumn:Ue.character+1,positionLineNumber:Fe.line+1,positionColumn:Fe.character+1}}le.from=ue})(b=e.Selection||(e.Selection={}));var _;(function(le){function Se(G){if(!G)return;const{start:Ue,end:Fe}=G;return{startLineNumber:Ue.line+1,startColumn:Ue.character+1,endLineNumber:Fe.line+1,endColumn:Fe.character+1}}le.from=Se;function ue(G){if(!G)return;const{startLineNumber:Ue,startColumn:Fe,endLineNumber:Ze,endColumn:it}=G;return new m.Range(Ue-1,Fe-1,Ze-1,it-1)}le.to=ue})(_=e.Range||(e.Range={}));var u;(function(le){function Se(ue){switch(ue){case 1:return m.StandardTokenType.Comment;case 0:return m.StandardTokenType.Other;case 4:return m.StandardTokenType.RegEx;case 2:return m.StandardTokenType.String}}le.to=Se})(u=e.TokenType||(e.TokenType={}));var c;(function(le){function Se(G){return new m.Position(G.lineNumber-1,G.column-1)}le.to=Se;function ue(G){return{lineNumber:G.line+1,column:G.character+1}}le.from=ue})(c=e.Position||(e.Position={}));var d;(function(le){function Se(G){switch(G){case m.DiagnosticTag.Unnecessary:return 1;case m.DiagnosticTag.Deprecated:return 2}}le.from=Se;function ue(G){switch(G){case 1:return m.DiagnosticTag.Unnecessary;case 2:return m.DiagnosticTag.Deprecated;default:return}}le.to=ue})(d=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(le){function Se(G){let Ue;return G.code&&((0,D.isString)(G.code)||(0,D.isNumber)(G.code)?Ue=String(G.code):Ue={value:String(G.code.value),target:G.code.target}),Object.assign(Object.assign({},_.from(G.range)),{message:G.message,source:G.source,code:Ue,severity:s.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(n.from),tags:Array.isArray(G.tags)?(0,v.coalesce)(G.tags.map(d.from)):void 0})}le.from=Se;function ue(G){var Ue;const Fe=new m.Diagnostic(_.to(G),G.message,s.to(G.severity));return Fe.source=G.source,Fe.code=(0,D.isString)(G.code)?G.code:(Ue=G.code)===null||Ue===void 0?void 0:Ue.value,Fe.relatedInformation=G.relatedInformation&&G.relatedInformation.map(n.to),Fe.tags=G.tags&&(0,v.coalesce)(G.tags.map(d.to)),Fe}le.to=ue})(t=e.Diagnostic||(e.Diagnostic={}));var n;(function(le){function Se(G){return Object.assign(Object.assign({},_.from(G.location.range)),{message:G.message,resource:G.location.uri})}le.from=Se;function ue(G){return new m.DiagnosticRelatedInformation(new m.Location(G.resource,_.to(G)),G.message)}le.to=ue})(n=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var s;(function(le){function Se(G){switch(G){case m.DiagnosticSeverity.Error:return p.MarkerSeverity.Error;case m.DiagnosticSeverity.Warning:return p.MarkerSeverity.Warning;case m.DiagnosticSeverity.Information:return p.MarkerSeverity.Info;case m.DiagnosticSeverity.Hint:return p.MarkerSeverity.Hint}return p.MarkerSeverity.Error}le.from=Se;function ue(G){switch(G){case p.MarkerSeverity.Info:return m.DiagnosticSeverity.Information;case p.MarkerSeverity.Warning:return m.DiagnosticSeverity.Warning;case p.MarkerSeverity.Error:return m.DiagnosticSeverity.Error;case p.MarkerSeverity.Hint:return m.DiagnosticSeverity.Hint;default:return m.DiagnosticSeverity.Error}}le.to=ue})(s=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var r;(function(le){function Se(G){return typeof G=="number"&&G>=m.ViewColumn.One?G-1:G===m.ViewColumn.Beside?w.SIDE_GROUP:w.ACTIVE_GROUP}le.from=Se;function ue(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}le.to=ue})(r=e.ViewColumn||(e.ViewColumn={}));function o(le){return typeof le.range!="undefined"}function g(le){return le.length===0?!0:!!o(le[0])}e.isDecorationOptionsArr=g;var f;(function(le){function Se(it){return it.map(le.from)}le.fromMany=Se;function ue(it){return it&&typeof it=="object"&&typeof it.language=="string"&&typeof it.value=="string"}function G(it){let ct;if(ue(it)){const{language:at,value:lt}=it;ct={value:"```"+at+`
`+lt+"\n```\n"}}else m.MarkdownString.isMarkdownString(it)?ct={value:it.value,isTrusted:it.isTrusted,supportThemeIcons:it.supportThemeIcons}:typeof it=="string"?ct={value:it}:ct={value:""};const gt=Object.create(null);ct.uris=gt;const Ye=at=>{try{let lt=I.URI.parse(at,!0);lt=lt.with({query:Ue(lt.query,gt)}),gt[at]=lt}catch(lt){}return""},dt=new T.Renderer;return dt.link=Ye,dt.image=at=>Ye(C.parseHrefAndDimensions(at).href),T(ct.value,{renderer:dt}),ct}le.from=G;function Ue(it,ct){if(!it)return it;let gt;try{gt=(0,y.parse)(it)}catch(dt){}if(!gt)return it;let Ye=!1;return gt=(0,P.cloneAndChange)(gt,dt=>{if(I.URI.isUri(dt)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[at]=dt,Ye=!0,at}else return}),Ye?JSON.stringify(gt):it}function Fe(it){const ct=new m.MarkdownString(it.value,it.supportThemeIcons);return ct.isTrusted=it.isTrusted,ct}le.to=Fe;function Ze(it){if(!!it)return typeof it=="string"?it:le.from(it)}le.fromStrict=Ze})(f=e.MarkdownString||(e.MarkdownString={}));function S(le){return g(le)?le.map(Se=>({range:_.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?f.fromMany(Se.hoverMessage):Se.hoverMessage?f.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):le.map(Se=>({range:_.from(Se)}))}e.fromRangeOrRangeWithMessage=S;function E(le){return typeof le=="undefined"?le:typeof le=="string"?I.URI.file(le):le}e.pathOrURIToURI=E;var l;(function(le){function Se(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?E(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}le.from=Se})(l=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(le){function Se(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?E(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?l.from(ue.before):void 0,after:ue.after?l.from(ue.after):void 0}}le.from=Se})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var O;(function(le){function Se(ue){if(typeof ue=="undefined")return ue;switch(ue){case m.DecorationRangeBehavior.OpenOpen:return 0;case m.DecorationRangeBehavior.ClosedClosed:return 1;case m.DecorationRangeBehavior.OpenClosed:return 2;case m.DecorationRangeBehavior.ClosedOpen:return 3}}le.from=Se})(O=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var W;(function(le){function Se(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?O.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?L.from(ue.light):void 0,dark:ue.dark?L.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?E(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?l.from(ue.before):void 0,after:ue.after?l.from(ue.after):void 0}}le.from=Se})(W=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var te;(function(le){function Se(G){return{text:G.newText,eol:G.newEol&&ve.from(G.newEol),range:_.from(G.range)}}le.from=Se;function ue(G){const Ue=new m.TextEdit(_.to(G.range),G.text);return Ue.newEol=typeof G.eol=="undefined"?void 0:ve.to(G.eol),Ue}le.to=ue})(te=e.TextEdit||(e.TextEdit={}));var se;(function(le){function Se(G,Ue,Fe){var Ze,it,ct;const gt={edits:[]};if(G instanceof m.WorkspaceEdit)for(let Ye of G._allEntries())if(Ye._type===1)gt.edits.push({_type:1,oldUri:Ye.from,newUri:Ye.to,options:Ye.options,metadata:Ye.metadata});else if(Ye._type===2){const dt=Ue==null?void 0:Ue.getDocument(Ye.uri);gt.edits.push({_type:2,resource:Ye.uri,edit:te.from(Ye.edit),modelVersionId:dt==null?void 0:dt.version,metadata:Ye.metadata})}else Ye._type===3?gt.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:Ye.edit,notebookMetadata:Ye.notebookMetadata,notebookVersionId:(Ze=Fe==null?void 0:Fe.getNotebookDocument(Ye.uri,!0))===null||Ze===void 0?void 0:Ze.apiNotebook.version}):Ye._type===4?(Ye.newOutputs&&gt.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:2,index:Ye.index,append:Ye.append,outputs:Ye.newOutputs.map(Ne.from)}}),Ye.newMetadata&&gt.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:8,index:Ye.index,metadata:Ye.newMetadata}})):Ye._type===5?gt.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,notebookVersionId:(it=Fe==null?void 0:Fe.getNotebookDocument(Ye.uri,!0))===null||it===void 0?void 0:it.apiNotebook.version,edit:{editType:1,index:Ye.index,count:Ye.count,cells:Ye.cells.map(Pe.from)}}):Ye._type===6&&gt.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:7,outputId:Ye.outputId,items:((ct=Ye.newOutputItems)===null||ct===void 0?void 0:ct.map(Ae.from))||[],append:Ye.append}});return gt}le.from=Se;function ue(G){const Ue=new m.WorkspaceEdit;for(const Fe of G.edits)Fe.edit?Ue.replace(I.URI.revive(Fe.resource),_.to(Fe.edit.range),Fe.edit.text):Ue.renameFile(I.URI.revive(Fe.oldUri),I.URI.revive(Fe.newUri),Fe.options);return Ue}le.to=ue})(se=e.WorkspaceEdit||(e.WorkspaceEdit={}));var N;(function(le){const Se=Object.create(null);Se[m.SymbolKind.File]=0,Se[m.SymbolKind.Module]=1,Se[m.SymbolKind.Namespace]=2,Se[m.SymbolKind.Package]=3,Se[m.SymbolKind.Class]=4,Se[m.SymbolKind.Method]=5,Se[m.SymbolKind.Property]=6,Se[m.SymbolKind.Field]=7,Se[m.SymbolKind.Constructor]=8,Se[m.SymbolKind.Enum]=9,Se[m.SymbolKind.Interface]=10,Se[m.SymbolKind.Function]=11,Se[m.SymbolKind.Variable]=12,Se[m.SymbolKind.Constant]=13,Se[m.SymbolKind.String]=14,Se[m.SymbolKind.Number]=15,Se[m.SymbolKind.Boolean]=16,Se[m.SymbolKind.Array]=17,Se[m.SymbolKind.Object]=18,Se[m.SymbolKind.Key]=19,Se[m.SymbolKind.Null]=20,Se[m.SymbolKind.EnumMember]=21,Se[m.SymbolKind.Struct]=22,Se[m.SymbolKind.Event]=23,Se[m.SymbolKind.Operator]=24,Se[m.SymbolKind.TypeParameter]=25;function ue(Ue){return typeof Se[Ue]=="number"?Se[Ue]:6}le.from=ue;function G(Ue){for(const Fe in Se)if(Se[Fe]===Ue)return Number(Fe);return m.SymbolKind.Property}le.to=G})(N=e.SymbolKind||(e.SymbolKind={}));var V;(function(le){function Se(G){switch(G){case m.SymbolTag.Deprecated:return 1}}le.from=Se;function ue(G){switch(G){case 1:return m.SymbolTag.Deprecated}}le.to=ue})(V=e.SymbolTag||(e.SymbolTag={}));var x;(function(le){function Se(G){return{name:G.name,kind:N.from(G.kind),tags:G.tags&&G.tags.map(V.from),containerName:G.containerName,location:$.from(G.location)}}le.from=Se;function ue(G){const Ue=new m.SymbolInformation(G.name,N.to(G.kind),G.containerName,$.to(G.location));return Ue.tags=G.tags&&G.tags.map(V.to),Ue}le.to=ue})(x=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var k;(function(le){function Se(G){var Ue,Fe;const Ze={name:G.name||"!!MISSING: name!!",detail:G.detail,range:_.from(G.range),selectionRange:_.from(G.selectionRange),kind:N.from(G.kind),tags:(Fe=(Ue=G.tags)===null||Ue===void 0?void 0:Ue.map(V.from))!==null&&Fe!==void 0?Fe:[]};return G.children&&(Ze.children=G.children.map(Se)),Ze}le.from=Se;function ue(G){const Ue=new m.DocumentSymbol(G.name,G.detail,N.to(G.kind),_.to(G.range),_.to(G.selectionRange));return(0,v.isNonEmptyArray)(G.tags)&&(Ue.tags=G.tags.map(V.to)),G.children&&(Ue.children=G.children.map(ue)),Ue}le.to=ue})(k=e.DocumentSymbol||(e.DocumentSymbol={}));var U;(function(le){function Se(ue){const G=new m.CallHierarchyItem(N.to(ue.kind),ue.name,ue.detail||"",I.URI.revive(ue.uri),_.to(ue.range),_.to(ue.selectionRange));return G._sessionId=ue._sessionId,G._itemId=ue._itemId,G}le.to=Se})(U=e.CallHierarchyItem||(e.CallHierarchyItem={}));var F;(function(le){function Se(ue){return new m.CallHierarchyIncomingCall(U.to(ue.from),ue.fromRanges.map(G=>_.to(G)))}le.to=Se})(F=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(le){function Se(ue){return new m.CallHierarchyOutgoingCall(U.to(ue.to),ue.fromRanges.map(G=>_.to(G)))}le.to=Se})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var $;(function(le){function Se(G){return{range:G.range&&_.from(G.range),uri:G.uri}}le.from=Se;function ue(G){return new m.Location(I.URI.revive(G.uri),_.to(G.range))}le.to=ue})($=e.location||(e.location={}));var H;(function(le){function Se(G){const Ue=G,Fe=G;return{originSelectionRange:Ue.originSelectionRange?_.from(Ue.originSelectionRange):void 0,uri:Ue.targetUri?Ue.targetUri:Fe.uri,range:_.from(Ue.targetRange?Ue.targetRange:Fe.range),targetSelectionRange:Ue.targetSelectionRange?_.from(Ue.targetSelectionRange):void 0}}le.from=Se;function ue(G){return{targetUri:I.URI.revive(G.uri),targetRange:_.to(G.range),targetSelectionRange:G.targetSelectionRange?_.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?_.to(G.originSelectionRange):void 0}}le.to=ue})(H=e.DefinitionLink||(e.DefinitionLink={}));var X;(function(le){function Se(G){return{range:_.from(G.range),contents:f.fromMany(G.contents)}}le.from=Se;function ue(G){return new m.Hover(G.contents.map(f.to),_.to(G.range))}le.to=ue})(X=e.Hover||(e.Hover={}));var ae;(function(le){function Se(G){return{range:_.from(G.range),expression:G.expression}}le.from=Se;function ue(G){return new m.EvaluatableExpression(_.to(G.range),G.expression)}le.to=ue})(ae=e.EvaluatableExpression||(e.EvaluatableExpression={}));var we;(function(le){function Se(G){if(G instanceof m.InlineValueText)return{type:"text",range:_.from(G.range),text:G.text};if(G instanceof m.InlineValueVariableLookup)return{type:"variable",range:_.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof m.InlineValueEvaluatableExpression)return{type:"expression",range:_.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}le.from=Se;function ue(G){switch(G.type){case"text":return{range:_.to(G.range),text:G.text};case"variable":return{range:_.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:_.to(G.range),expression:G.expression}}}le.to=ue})(we=e.InlineValue||(e.InlineValue={}));var Le;(function(le){function Se(G){return{frameId:G.frameId,stoppedLocation:_.from(G.stoppedLocation)}}le.from=Se;function ue(G){return new m.InlineValueContext(G.frameId,_.to(G.stoppedLocation))}le.to=ue})(Le=e.InlineValueContext||(e.InlineValueContext={}));var Ie;(function(le){function Se(G){return{range:_.from(G.range),kind:G.kind}}le.from=Se;function ue(G){return new m.DocumentHighlight(_.to(G.range),G.kind)}le.to=ue})(Ie=e.DocumentHighlight||(e.DocumentHighlight={}));var Me;(function(le){function Se(ue){switch(ue){case 1:return m.CompletionTriggerKind.TriggerCharacter;case 2:return m.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return m.CompletionTriggerKind.Invoke}}le.to=Se})(Me=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var We;(function(le){function Se(ue){return{triggerKind:Me.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}le.to=Se})(We=e.CompletionContext||(e.CompletionContext={}));var j;(function(le){function Se(G){switch(G){case m.CompletionItemTag.Deprecated:return 1}}le.from=Se;function ue(G){switch(G){case 1:return m.CompletionItemTag.Deprecated}}le.to=ue})(j=e.CompletionItemTag||(e.CompletionItemTag={}));var Y;(function(le){const Se=new Map([[m.CompletionItemKind.Method,0],[m.CompletionItemKind.Function,1],[m.CompletionItemKind.Constructor,2],[m.CompletionItemKind.Field,3],[m.CompletionItemKind.Variable,4],[m.CompletionItemKind.Class,5],[m.CompletionItemKind.Interface,7],[m.CompletionItemKind.Struct,6],[m.CompletionItemKind.Module,8],[m.CompletionItemKind.Property,9],[m.CompletionItemKind.Unit,12],[m.CompletionItemKind.Value,13],[m.CompletionItemKind.Constant,14],[m.CompletionItemKind.Enum,15],[m.CompletionItemKind.EnumMember,16],[m.CompletionItemKind.Keyword,17],[m.CompletionItemKind.Snippet,27],[m.CompletionItemKind.Text,18],[m.CompletionItemKind.Color,19],[m.CompletionItemKind.File,20],[m.CompletionItemKind.Reference,21],[m.CompletionItemKind.Folder,23],[m.CompletionItemKind.Event,10],[m.CompletionItemKind.Operator,11],[m.CompletionItemKind.TypeParameter,24],[m.CompletionItemKind.Issue,26],[m.CompletionItemKind.User,25]]);function ue(Fe){var Ze;return(Ze=Se.get(Fe))!==null&&Ze!==void 0?Ze:9}le.from=ue;const G=new Map([[0,m.CompletionItemKind.Method],[1,m.CompletionItemKind.Function],[2,m.CompletionItemKind.Constructor],[3,m.CompletionItemKind.Field],[4,m.CompletionItemKind.Variable],[5,m.CompletionItemKind.Class],[7,m.CompletionItemKind.Interface],[6,m.CompletionItemKind.Struct],[8,m.CompletionItemKind.Module],[9,m.CompletionItemKind.Property],[12,m.CompletionItemKind.Unit],[13,m.CompletionItemKind.Value],[14,m.CompletionItemKind.Constant],[15,m.CompletionItemKind.Enum],[16,m.CompletionItemKind.EnumMember],[17,m.CompletionItemKind.Keyword],[27,m.CompletionItemKind.Snippet],[18,m.CompletionItemKind.Text],[19,m.CompletionItemKind.Color],[20,m.CompletionItemKind.File],[21,m.CompletionItemKind.Reference],[23,m.CompletionItemKind.Folder],[10,m.CompletionItemKind.Event],[11,m.CompletionItemKind.Operator],[24,m.CompletionItemKind.TypeParameter],[25,m.CompletionItemKind.User],[26,m.CompletionItemKind.Issue]]);function Ue(Fe){var Ze;return(Ze=G.get(Fe))!==null&&Ze!==void 0?Ze:m.CompletionItemKind.Property}le.to=Ue})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(le){function Se(ue,G){var Ue;const Fe=new m.CompletionItem(typeof ue.label=="string"?ue.label:ue.label.name);return typeof ue.label!="string"&&(Fe.label2=ue.label),Fe.insertText=ue.insertText,Fe.kind=Y.to(ue.kind),Fe.tags=(Ue=ue.tags)===null||Ue===void 0?void 0:Ue.map(j.to),Fe.detail=ue.detail,Fe.documentation=C.isMarkdownString(ue.documentation)?f.to(ue.documentation):ue.documentation,Fe.sortText=ue.sortText,Fe.filterText=ue.filterText,Fe.preselect=ue.preselect,Fe.commitCharacters=ue.commitCharacters,i.Range.isIRange(ue.range)?Fe.range=_.to(ue.range):typeof ue.range=="object"&&(Fe.range={inserting:_.to(ue.range.insert),replacing:_.to(ue.range.replace)}),Fe.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?Fe.insertText=new m.SnippetString(ue.insertText):(Fe.insertText=ue.insertText,Fe.textEdit=Fe.range instanceof m.Range?new m.TextEdit(Fe.range,Fe.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Fe.additionalTextEdits=ue.additionalTextEdits.map(Ze=>te.to(Ze))),Fe.command=G&&ue.command?G.fromInternal(ue.command):void 0,Fe}le.to=Se})(ee=e.CompletionItem||(e.CompletionItem={}));var oe;(function(le){function Se(G){return{label:G.label,documentation:G.documentation?f.fromStrict(G.documentation):void 0}}le.from=Se;function ue(G){return{label:G.label,documentation:C.isMarkdownString(G.documentation)?f.to(G.documentation):G.documentation}}le.to=ue})(oe=e.ParameterInformation||(e.ParameterInformation={}));var pe;(function(le){function Se(G){return{label:G.label,documentation:G.documentation?f.fromStrict(G.documentation):void 0,parameters:Array.isArray(G.parameters)?G.parameters.map(oe.from):[],activeParameter:G.activeParameter}}le.from=Se;function ue(G){return{label:G.label,documentation:C.isMarkdownString(G.documentation)?f.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(oe.to):[],activeParameter:G.activeParameter}}le.to=ue})(pe=e.SignatureInformation||(e.SignatureInformation={}));var _e;(function(le){function Se(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(pe.from):[]}}le.from=Se;function ue(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(pe.to):[]}}le.to=ue})(_e=e.SignatureHelp||(e.SignatureHelp={}));var de;(function(le){function Se(G){var Ue;return{text:G.text,position:c.from(G.position),kind:Ee.from((Ue=G.kind)!==null&&Ue!==void 0?Ue:m.InlayHintKind.Other),whitespaceBefore:G.whitespaceBefore,whitespaceAfter:G.whitespaceAfter}}le.from=Se;function ue(G){const Ue=new m.InlayHint(G.text,c.to(G.position),Ee.to(G.kind));return Ue.whitespaceAfter=G.whitespaceAfter,Ue.whitespaceBefore=G.whitespaceBefore,Ue}le.to=ue})(de=e.InlayHint||(e.InlayHint={}));var Ee;(function(le){function Se(G){return G}le.from=Se;function ue(G){return G}le.to=ue})(Ee=e.InlayHintKind||(e.InlayHintKind={}));var Re;(function(le){function Se(G){return{range:_.from(G.range),url:G.target,tooltip:G.tooltip}}le.from=Se;function ue(G){let Ue;if(G.url)try{Ue=typeof G.url=="string"?I.URI.parse(G.url,!0):I.URI.revive(G.url)}catch(Fe){}return new m.DocumentLink(_.to(G.range),Ue)}le.to=ue})(Re=e.DocumentLink||(e.DocumentLink={}));var Ve;(function(le){function Se(G){const Ue=new m.ColorPresentation(G.label);return G.textEdit&&(Ue.textEdit=te.to(G.textEdit)),G.additionalTextEdits&&(Ue.additionalTextEdits=G.additionalTextEdits.map(Fe=>te.to(Fe))),Ue}le.to=Se;function ue(G){return{label:G.label,textEdit:G.textEdit?te.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Ue=>te.from(Ue)):void 0}}le.from=ue})(Ve=e.ColorPresentation||(e.ColorPresentation={}));var be;(function(le){function Se(G){return new m.Color(G[0],G[1],G[2],G[3])}le.to=Se;function ue(G){return[G.red,G.green,G.blue,G.alpha]}le.from=ue})(be=e.Color||(e.Color={}));var Ke;(function(le){function Se(G){return{range:_.from(G.range)}}le.from=Se;function ue(G){return new m.SelectionRange(_.to(G.range))}le.to=ue})(Ke=e.SelectionRange||(e.SelectionRange={}));var Q;(function(le){function Se(ue){switch(ue){case 2:return m.TextDocumentSaveReason.AfterDelay;case 1:return m.TextDocumentSaveReason.Manual;case 3:case 4:return m.TextDocumentSaveReason.FocusOut}}le.to=Se})(Q=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ne;(function(le){function Se(G){switch(G){case m.TextEditorLineNumbersStyle.Off:return 0;case m.TextEditorLineNumbersStyle.Relative:return 2;case m.TextEditorLineNumbersStyle.On:default:return 1}}le.from=Se;function ue(G){switch(G){case 0:return m.TextEditorLineNumbersStyle.Off;case 2:return m.TextEditorLineNumbersStyle.Relative;case 1:default:return m.TextEditorLineNumbersStyle.On}}le.to=ue})(ne=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ve;(function(le){function Se(G){if(G===m.EndOfLine.CRLF)return 1;if(G===m.EndOfLine.LF)return 0}le.from=Se;function ue(G){if(G===1)return m.EndOfLine.CRLF;if(G===0)return m.EndOfLine.LF}le.to=ue})(ve=e.EndOfLine||(e.EndOfLine={}));var xe;(function(le){function Se(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case m.ProgressLocation.SourceControl:return 3;case m.ProgressLocation.Window:return 10;case m.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}le.from=Se})(xe=e.ProgressLocation||(e.ProgressLocation={}));var je;(function(le){function Se(ue){const G={start:ue.start+1,end:ue.end+1};return ue.kind&&(G.kind=ze.from(ue.kind)),G}le.from=Se})(je=e.FoldingRange||(e.FoldingRange={}));var ze;(function(le){function Se(ue){if(ue)switch(ue){case m.FoldingRangeKind.Comment:return A.FoldingRangeKind.Comment;case m.FoldingRangeKind.Imports:return A.FoldingRangeKind.Imports;case m.FoldingRangeKind.Region:return A.FoldingRangeKind.Region}}le.from=Se})(ze=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Je;(function(le){function Se(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?_.from(ue.selection):void 0,override:typeof ue.override=="boolean"?h.EditorOverride.DISABLED:void 0}}le.from=Se})(Je=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ye;(function(le){function Se(G){return G instanceof m.RelativePattern||typeof G=="string"?G:ue(G)?new m.RelativePattern(G.base,G.pattern):G}le.from=Se;function ue(G){const Ue=G;return Ue&&typeof Ue.base=="string"&&typeof Ue.pattern=="string"}})(ye=e.GlobPattern||(e.GlobPattern={}));var De;(function(le){function Se(ue){if(ue){if(Array.isArray(ue))return ue.map(Se);if(typeof ue=="string")return ue;{const G=ue;return{language:G.language,scheme:G.scheme,pattern:typeof G.pattern=="undefined"?void 0:ye.from(G.pattern),exclusive:G.exclusive}}}else return}le.from=Se})(De=e.LanguageSelector||(e.LanguageSelector={}));var ke;(function(le){function Se(G){return{start:G.start,end:G.end}}le.from=Se;function ue(G){return new m.NotebookRange(G.start,G.end)}le.to=ue})(ke=e.NotebookRange||(e.NotebookRange={}));var re;(function(le){function Se(ue){return new m.NotebookCellMetadata().with(Object.assign(Object.assign({},ue),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}le.to=Se})(re=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var he;(function(le){function Se(G){return G}le.from=Se;function ue(G){return new m.NotebookDocumentMetadata().with(G)}le.to=ue})(he=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var z;(function(le){function Se(G){return{startTime:G.runStartTime,endTime:G.runEndTime,executionOrder:G.executionOrder,success:G.lastRunSuccess}}le.to=Se;function ue(G){return{lastRunSuccess:G.success,runStartTime:G.startTime,runEndTime:G.endTime,executionOrder:G.executionOrder}}le.from=ue})(z=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var J;(function(le){function Se(G){switch(G){case m.NotebookCellKind.Markup:return a.CellKind.Markup;case m.NotebookCellKind.Code:default:return a.CellKind.Code}}le.from=Se;function ue(G){switch(G){case a.CellKind.Markup:return m.NotebookCellKind.Markup;case a.CellKind.Code:default:return m.NotebookCellKind.Code}}le.to=ue})(J=e.NotebookCellKind||(e.NotebookCellKind={}));var ce;(function(le){function Se(G){const Ue={metadata:he.from(G.metadata),cells:[]};for(let Fe of G.cells)m.NotebookCellData.validate(Fe),Ue.cells.push(Pe.from(Fe));return Ue}le.from=Se;function ue(G){return{metadata:he.to(G.metadata),cells:G.cells.map(Pe.to)}}le.to=ue})(ce=e.NotebookData||(e.NotebookData={}));var Pe;(function(le){function Se(G){var Ue;return{cellKind:J.from(G.kind),language:G.languageId,source:G.value,metadata:G.metadata,internalMetadata:z.from((Ue=G.executionSummary)!==null&&Ue!==void 0?Ue:{}),outputs:G.outputs?G.outputs.map(Ne.from):[]}}le.from=Se;function ue(G){return new m.NotebookCellData(J.to(G.cellKind),G.source,G.language,G.outputs?G.outputs.map(Ne.to):void 0,G.metadata?re.to(G.metadata):void 0)}le.to=ue})(Pe=e.NotebookCellData||(e.NotebookCellData={}));var Ae;(function(le){function Se(G){let Ue,Fe;return G.value instanceof Uint8Array?Fe=Array.from(G.value):Ue=G.value,{metadata:G.metadata,mime:G.mime,value:Ue,valueBytes:Fe}}le.from=Se;function ue(G){let Ue;return G.value instanceof R.VSBuffer?Ue=G.value.buffer:Ue=G.value,new m.NotebookCellOutputItem(G.mime,Ue,G.metadata)}le.to=ue})(Ae=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ne;(function(le){function Se(G){return{outputId:G.id,outputs:G.outputs.map(Ae.from),metadata:G.metadata}}le.from=Se;function ue(G){const Ue=G.outputs.map(Ae.to);return new m.NotebookCellOutput(Ue,G.outputId,G.metadata)}le.to=ue})(Ne=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Be;(function(le){function Se(Fe){if(Fe!=null){if(Fe instanceof m.RelativePattern||typeof Fe=="string")return Fe;if(Ue(Fe))return new m.RelativePattern(Fe.base,Fe.pattern);if(G(Fe))return{include:ye.from(Fe.include)||void 0,exclude:ye.from(Fe.exclude)||void 0}}}le.from=Se;function ue(Fe){return typeof Fe=="string"?Fe:Ue(Fe)?{base:Fe.base,pattern:Fe.pattern}:{include:Fe.include,exclude:Fe.exclude}}le.to=ue;function G(Fe){const Ze=Fe,it=ye.from(Ze.include);if(!(it&&it instanceof m.RelativePattern||typeof it=="string"))return!1;const ct=ye.from(Ze.exclude);return!!(ct&&ct instanceof m.RelativePattern||typeof ct=="string")}function Ue(Fe){const Ze=Fe;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Be=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Qe;(function(le){function Se(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?l.from(ue.top):void 0}}le.from=Se})(Qe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var rt;(function(le){function Se(ue,G,Ue){const Fe=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===m.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Fe,Ue),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}le.from=Se})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var et;(function(le){function Se(ue){var G,Ue,Fe;return{transientOutputs:(G=ue==null?void 0:ue.transientOutputs)!==null&&G!==void 0?G:!1,transientCellMetadata:(Ue=ue==null?void 0:ue.transientCellMetadata)!==null&&Ue!==void 0?Ue:{},transientDocumentMetadata:(Fe=ue==null?void 0:ue.transientDocumentMetadata)!==null&&Fe!==void 0?Fe:{}}}le.from=Se})(et=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Xe;(function(le){function Se(G){var Ue;return{uri:G.uri,provides:typeof G.provides=="string"?[G.provides]:(Ue=G.provides)!==null&&Ue!==void 0?Ue:[]}}le.from=Se;function ue(G){return new m.NotebookKernelPreload(I.URI.revive(G.uri),G.provides)}le.to=ue})(Xe=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var ot;(function(le){function Se(G){return{message:f.fromStrict(G.message)||"",severity:G.severity,expectedOutput:G.expectedOutput,actualOutput:G.actualOutput,location:G.location?$.from(G.location):void 0}}le.from=Se;function ue(G){const Ue=new m.TestMessage(typeof G.message=="string"?G.message:f.to(G.message));return Ue.severity=G.severity,Ue.actualOutput=G.actualOutput,Ue.expectedOutput=G.expectedOutput,Ue}le.to=ue})(ot=e.TestMessage||(e.TestMessage={}));var Et;(function(le){function Se(Fe){var Ze,it;return{extId:Fe.id,label:Fe.label,uri:Fe.uri,range:_.from(Fe.range)||null,debuggable:(Ze=Fe.debuggable)!==null&&Ze!==void 0?Ze:!1,description:Fe.description||null,runnable:(it=Fe.runnable)!==null&&it!==void 0?it:!0,error:Fe.error&&f.fromStrict(Fe.error)||null}}le.from=Se;function ue(Fe){return{extId:Fe.id,label:Fe.label,uri:Fe.uri,range:_.from(Fe.range)||null,debuggable:!1,description:Fe.description||null,error:null,runnable:!0}}le.fromResultSnapshot=ue;function G(Fe){return{id:Fe.extId,label:Fe.label,uri:I.URI.revive(Fe.uri),range:_.to(Fe.range||void 0),addChild:()=>{},dispose:()=>{},status:m.TestItemStatus.Pending,data:void 0,debuggable:Fe.debuggable,description:Fe.description||void 0,runnable:Fe.runnable}}le.toPlain=G;function Ue(Fe){const Ze=new m.TestItemImpl(Fe.extId,Fe.label,I.URI.revive(Fe.uri),void 0);return Ze.range=_.to(Fe.range||void 0),Ze.debuggable=Fe.debuggable,Ze.description=Fe.description||void 0,Ze.runnable=Fe.runnable,Ze}le.to=Ue})(Et=e.TestItem||(e.TestItem={}));var bt;(function(le){const Se=(G,Ue)=>Object.assign(Object.assign({},Et.toPlain(G.item)),{taskStates:G.tasks.map(Fe=>({state:Fe.state,duration:Fe.duration,messages:Fe.messages.map(ot.to)})),children:G.children.map(Fe=>Ue.get(Fe)).filter(D.isDefined).map(Fe=>Se(Fe,Ue))});function ue(G){const Ue=[],Fe=new Map;for(const Ze of G.items)Fe.set(Ze.item.extId,Ze),Ze.direct&&Ue.push(Ze);return{completedAt:G.completedAt,results:Ue.map(Ze=>Se(Ze,Fe))}}le.to=ue})(bt=e.TestResults||(e.TestResults={}));var vt;(function(le){function Se(ue){switch(ue){case 1:return m.CodeActionTriggerKind.Invoke;case 2:return m.CodeActionTriggerKind.Automatic}}le.to=Se})(vt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(me[211],ge([0,1,2,17,7,20,56]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(I,i,A,h={timeout:1500,errors:3}){this._logService=I,this._documents=i,this._mainThreadBulkEdits=A,this._thresholds=h,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(i,A,h)=>{const a={dispose:this._callbacks.push([i,A,I])};return Array.isArray(h)&&h.push(a),a}}async $participateInSave(I,i){const A=v.URI.revive(I);let h=!1;const p=setTimeout(()=>h=!0,this._thresholds.timeout),a=[];try{for(let w of[...this._callbacks]){if(h)break;const m=this._documents.getDocument(A),b=await this._deliverEventAsyncAndBlameBadListeners(w,{document:m,reason:T.TextDocumentSaveReason.to(i)});a.push(b)}}finally{clearTimeout(p)}return a}_deliverEventAsyncAndBlameBadListeners([I,i,A],h){const p=this._badListeners.get(I);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(A,I,i,h).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const w=this._badListeners.get(I);this._badListeners.set(I,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,i,A,h){const p=[],a=Date.now(),{document:w,reason:m}=h,{version:b}=w,_=Object.freeze({document:w,reason:m,waitUntil(u){if(Object.isFrozen(p))throw(0,R.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(u))}});try{i.apply(A,[_])}catch(u){return Promise.reject(u)}return Object.freeze(p),new Promise((u,c)=>{const d=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(d),u(t)}).catch(t=>{clearTimeout(d),c(t)})}).then(u=>{const c={edits:[]};for(const d of u)if(Array.isArray(d)&&d.every(t=>t instanceof C.TextEdit))for(const{newText:t,newEol:n,range:s}of d)c.edits.push({_type:2,resource:w.uri,edit:{range:s&&T.Range.from(s),text:t,eol:n&&T.EndOfLine.from(n)}});if(c.edits.length!==0)return b===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(me[212],ge([0,1,3,13,31,2,20,7]),function(K,e,v,R,C,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(A,h,p,a,w){this._onDidCreate=new v.Emitter,this._onDidChange=new v.Emitter,this._onDidDelete=new v.Emitter,this._config=0,p&&(this._config+=1),a&&(this._config+=2),w&&(this._config+=4);const m=(0,C.parse)(h),b=A(_=>{if(!p)for(let u of _.created){const c=T.URI.revive(u);m(c.fsPath)&&this._onDidCreate.fire(c)}if(!a)for(let u of _.changed){const c=T.URI.revive(u);m(c.fsPath)&&this._onDidChange.fire(c)}if(!w)for(let u of _.deleted){const c=T.URI.revive(u);m(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,b)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class I{constructor(A,h,p){this._logService=h,this._extHostDocumentsAndEditors=p,this._onFileSystemEvent=new v.Emitter,this._onDidRenameFile=new v.Emitter,this._onDidCreateFile=new v.Emitter,this._onDidDeleteFile=new v.Emitter,this._onWillRenameFile=new R.AsyncEmitter,this._onWillCreateFile=new R.AsyncEmitter,this._onWillDeleteFile=new R.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(A,h,p,a){return new D(this._onFileSystemEvent.event,A,h,p,a)}$onFileEvent(A){this._onFileSystemEvent.fire(A)}$onDidRunFileOperation(A,h){switch(A){case 2:this._onDidRenameFile.fire(Object.freeze({files:h.map(p=>({oldUri:T.URI.revive(p.source),newUri:T.URI.revive(p.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:h.map(p=>T.URI.revive(p.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:h.map(p=>T.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(A){return this._createWillExecuteEvent(A,this._onWillRenameFile)}getOnWillCreateFileEvent(A){return this._createWillExecuteEvent(A,this._onWillCreateFile)}getOnWillDeleteFileEvent(A){return this._createWillExecuteEvent(A,this._onWillDeleteFile)}_createWillExecuteEvent(A,h){return(p,a,w)=>{const m=function(_){p.call(a,_)};return m.extension=A,h.event(m,void 0,w)}}async $onWillRunFileOperation(A,h,p,a){switch(A){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:h.map(w=>({oldUri:T.URI.revive(w.source),newUri:T.URI.revive(w.target)}))},p,a);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:h.map(w=>T.URI.revive(w.target))},p,a);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:h.map(w=>T.URI.revive(w.target))},p,a)}}async _fireWillEvent(A,h,p,a){const w=new Set,m=[];if(await A.fireAsync(h,a,async(_,u)=>{var c;const d=Date.now(),t=await Promise.resolve(_);t instanceof P.WorkspaceEdit&&(m.push(t),w.add((c=u.extension.displayName)!==null&&c!==void 0?c:u.extension.identifier.value)),Date.now()-d>p&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),a.isCancellationRequested||m.length===0)return;const b={edits:[]};for(let _ of m){let{edits:u}=y.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);b.edits=b.edits.concat(u)}return{edit:b,extensionNames:Array.from(w)}}}e.ExtHostFileSystemEventService=I}),define(me[213],ge([0,1,10,24,2,20,7,64]),function(K,e,v,R,C,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(h,p,a,w){this.start=h,this.deletedCount=p,this.deletedItems=a,this.items=w}static asApiEvents(h){return h.map(p=>({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(a=>a.apiCell)}))}}class I{constructor(h,p,a){var w,m,b;this.notebook=h,this._extHostDocument=p,this._cellData=a,this.handle=a.handle,this.uri=C.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(w=a.internalMetadata)!==null&&w!==void 0?w:{},this._metadata=T.NotebookCellMetadata.to((m=a.metadata)!==null&&m!==void 0?m:{}),this._previousResult=T.NotebookCellExecutionSummary.to((b=a.internalMetadata)!==null&&b!==void 0?b:{})}static asModelAddData(h,p){return{EOL:p.eol,lines:p.source,modeId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:h}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const h=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return h.notebook.getCellIndex(h)},notebook:h.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get outputs(){return h._outputs.slice(0)},get metadata(){return h._metadata},get executionSummary(){return h._previousResult}})}return this._apiCell}setOutputs(h){this._outputs=h.map(T.NotebookCellOutput.to)}setOutputItems(h,p,a){const w=a.map(T.NotebookCellOutputItem.to),m=this._outputs.find(b=>b.id===h);m&&(p||(m.outputs.length=0),m.outputs.push(...w))}setMetadata(h){this._metadata=T.NotebookCellMetadata.to(h)}setInternalMetadata(h){this._internalMetadata=h,this._previousResult=T.NotebookCellExecutionSummary.to(h)}}e.ExtHostCell=I;class i{constructor(h,p,a,w,m,b,_){this._proxy=h,this._textDocumentsAndEditors=p,this._textDocuments=a,this._emitter=w,this._viewType=m,this._metadata=b,this.uri=_,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const h=this;this._notebook={get uri(){return h.uri},get version(){return h._versionId},get viewType(){return h._viewType},get isDirty(){return h._isDirty},get isUntitled(){return h.uri.scheme===v.Schemas.untitled},get isClosed(){return h._disposed},get metadata(){return h._metadata},get cellCount(){return h._cells.length},cellAt(p){return p=h._validateIndex(p),h._cells[p].apiCell},getCells(p){return(p?h._getCells(p):h._cells).map(w=>w.apiCell)},save(){return h._save()}}}return this._notebook}updateBackup(h){var p;(p=this._backup)===null||p===void 0||p.delete(),this._backup=h}disposeBackup(){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(h){h.metadata&&(this._metadata=this._metadata.with(h.metadata))}acceptModelChanged(h,p){this._versionId=h.versionId,this._isDirty=p;for(const a of h.rawEvents)a.kind===P.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(a.changes,!0),a.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===P.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===P.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(a.index,a.metadata):a.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(a.index,a.internalMetadata)}_validateIndex(h){return h=h|0,h<0?0:h>=this._cells.length?this._cells.length-1:h}_validateRange(h){let p=h.start|0,a=h.end|0;return p<0&&(p=0),a>this._cells.length&&(a=this._cells.length),h.with({start:p,end:a})}_getCells(h){h=this._validateRange(h);const p=[];for(let a=h.start;a<h.end;a++)p.push(this._cells[a]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(h,p){if(this._disposed)return;const a=[],w=[],m=[];h.reverse().forEach(b=>{const u=b[2].map(t=>{const n=new I(this,this._textDocumentsAndEditors,t);return p||w.push(I.asModelAddData(this.apiNotebook,t)),n}),c=new D(b[0],b[1],[],u),d=this._cells.splice(b[0],b[1],...u);for(const t of d)m.push(t.uri),c.deletedItems.push(t.apiCell);a.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:m}),p||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(a)}))}_moveCell(h,p){const a=this._cells.splice(h,1);this._cells.splice(p,0,...a);const w=[new D(h,1,a.map(m=>m.apiCell),[]),new D(p,0,[],a)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(w)}))}_setCellOutputs(h,p){const a=this._cells[h];a.setOutputs(p),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(h,p,a,w){const m=this._cells[h];m.setOutputItems(p,a,w),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[m.apiCell]}))}_changeCellLanguage(h,p){const a=this._cells[h];a.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelModeChanged(a.uri,p)}_changeCellMetadata(h,p){const a=this._cells[h],w=a.apiCell.metadata;a.setMetadata(p);const m=a.apiCell.metadata;(0,R.equals)(w,m)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:a.apiCell}))}_changeCellInternalMetadata(h,p){var a;const w=this._cells[h],m=w.internalMetadata;if(w.setInternalMetadata(p),m.runState!==p.runState){const b=(a=p.runState)!==null&&a!==void 0?a:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:w.apiCell,executionState:b}))}}getCellFromApiCell(h){return this._cells.find(p=>p.apiCell===h)}getCellFromIndex(h){return this._cells[h]}getCell(h){return this._cells.find(p=>p.handle===h)}getCellIndex(h){return this._cells.indexOf(h)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(me[124],ge([0,1,7,20]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(P){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=P}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(P){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:P})}replaceCellMetadata(P,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:P,metadata:D})}replaceCells(P,D,I){this._throwIfFinalized(),!(P===D&&I.length===0)&&this._collectedEdits.push({editType:1,index:P,count:D-P,cells:I.map(R.NotebookCellData.from)})}}class T{constructor(P,D,I,i,A,h){this.id=P,this._proxy=D,this.notebookData=I,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=A,this._visibleRanges=i,this._viewColumn=h}get apiEditor(){if(!this._editor){const P=this;this._editor={get document(){return P.notebookData.apiNotebook},get selections(){return P._selections},get visibleRanges(){return P._visibleRanges},revealRange(D,I){P._proxy.$tryRevealRange(P.id,R.NotebookRange.from(D),I!=null?I:v.NotebookEditorRevealType.Default)},get viewColumn(){return P._viewColumn},edit(D){const I=new C(this.document.version);return D(I),P._applyEdit(I.finalize())},setDecorations(D,I){return P.setDecorations(D,I)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(P){this._visible=P}_acceptVisibleRanges(P){this._visibleRanges=P}_acceptSelections(P){this._selections=P}_acceptViewColumn(P){this._viewColumn=P}_applyEdit(P){if(P.cellEdits.length===0)return Promise.resolve(!0);const D=[];let I=-1;for(let i=0;i<P.cellEdits.length;i++){if(I<0){D.push(P.cellEdits[i]),I++;continue}const h=D[I],p=P.cellEdits[i];if(h.editType===1&&p.editType===1&&h.index===p.index){h.cells.push(...P.cellEdits[i].cells),h.count+=P.cellEdits[i].count;continue}D.push(P.cellEdits[i]),I++}return this._proxy.$tryApplyEdits(this.id,P.documentVersionId,D)}setDecorations(P,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(P.key)))return D.isEmpty?this._hasDecorationsForKey.delete(P.key):this._hasDecorationsForKey.add(P.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(D),P.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(me[214],ge([0,1,20,114,162,21,53]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class P{constructor(A){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=A}withProgress(A,h,p){const a=this._handles++,{title:w,location:m,cancellable:b}=h,_={label:(0,C.localize)(0,null,A.displayName||A.name),id:A.identifier.value};return this._proxy.$startProgress(a,{location:v.ProgressLocation.from(m),title:w,source:_,cancellable:b},A),this._withProgress(a,p,!!b)}_withProgress(A,h,p){let a;p&&(a=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(A,a));const w=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),a&&a.dispose()};let m;try{m=h(new I(this._proxy,A),p&&a?a.token:T.CancellationToken.None)}catch(b){throw w(A),b}return m.then(b=>w(A),b=>w(A)),m}$acceptProgressCanceled(A){const h=this._mapHandleToCancellationSource.get(A);h&&(h.cancel(),this._mapHandleToCancellationSource.delete(A))}}e.ExtHostProgress=P;function D(i,A){return i.message=A.message,typeof A.increment=="number"&&(typeof i.increment=="number"?i.increment+=A.increment:i.increment=A.increment),i}class I extends R.Progress{constructor(A,h){super(p=>this.throttledReport(p));this._proxy=A,this._handle=h}throttledReport(A){this._proxy.$progressReport(this._handle,A)}}qe([(0,y.throttle)(100,(i,A)=>D(i,A),()=>Object.create(null))],I.prototype,"throttledReport",null)}),define(me[125],ge([0,1,51,17,73,20,7]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(h,p){const a=P._Keys.nextId();h.$registerTextEditorDecorationType(a,T.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:a,dispose(){h.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=P,P._Keys=new C.IdGenerator("TextEditorDecorationType");class D{constructor(h,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=h,this._documentVersionId=h.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(h,p){this._throwIfFinalized();let a=null;if(h instanceof y.Position)a=new y.Range(h,h);else if(h instanceof y.Range)a=h;else throw new Error("Unrecognized location");this._pushEdit(a,p,!1)}insert(h,p){this._throwIfFinalized(),this._pushEdit(new y.Range(h,h),p,!0)}delete(h){this._throwIfFinalized();let p=null;if(h instanceof y.Range)p=h;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(h,p,a){const w=this._document.validateRange(h);this._collectedEdits.push({range:w,text:p,forceMoveMarkers:a})}setEndOfLine(h){if(this._throwIfFinalized(),h!==y.EndOfLine.LF&&h!==y.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=h}}e.TextEditorEdit=D;class I{constructor(h,p,a,w){this._proxy=h,this._id=p,this._accept(a),this._logService=w;const m=this;this.value={get tabSize(){return m._tabSize},set tabSize(b){m._setTabSize(b)},get insertSpaces(){return m._insertSpaces},set insertSpaces(b){m._setInsertSpaces(b)},get cursorStyle(){return m._cursorStyle},set cursorStyle(b){m._setCursorStyle(b)},get lineNumbers(){return m._lineNumbers},set lineNumbers(b){m._setLineNumbers(b)}}}_accept(h){this._tabSize=h.tabSize,this._insertSpaces=h.insertSpaces,this._cursorStyle=h.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(h.lineNumbers)}_validateTabSize(h){if(h==="auto")return"auto";if(typeof h=="number"){const p=Math.floor(h);return p>0?p:null}if(typeof h=="string"){const p=parseInt(h,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(h){const p=this._validateTabSize(h);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateInsertSpaces(h){return h==="auto"?"auto":h==="false"?!1:Boolean(h)}_setInsertSpaces(h){const p=this._validateInsertSpaces(h);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(h){this._cursorStyle!==h&&(this._cursorStyle=h,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:h})))}_setLineNumbers(h){this._lineNumbers!==h&&(this._lineNumbers=h,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(h)})))}assign(h){const p={};let a=!1;if(typeof h.tabSize!="undefined"){const w=this._validateTabSize(h.tabSize);w==="auto"?(a=!0,p.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,a=!0,p.tabSize=w)}if(typeof h.insertSpaces!="undefined"){const w=this._validateInsertSpaces(h.insertSpaces);w==="auto"?(a=!0,p.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,a=!0,p.insertSpaces=w)}typeof h.cursorStyle!="undefined"&&this._cursorStyle!==h.cursorStyle&&(this._cursorStyle=h.cursorStyle,a=!0,p.cursorStyle=h.cursorStyle),typeof h.lineNumbers!="undefined"&&this._lineNumbers!==h.lineNumbers&&(this._lineNumbers=h.lineNumbers,a=!0,p.lineNumbers=T.TextEditorLineNumbersStyle.from(h.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,p))}_warnOnError(h){h.catch(p=>this._logService.warn(p))}}e.ExtHostTextEditorOptions=I;class i{constructor(h,p,a,w,m,b,_,u){this.id=h,this._proxy=p,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=m,this._options=new I(this._proxy,this.id,b,a),this._visibleRanges=_,this._viewColumn=u;const c=this;this.value=Object.freeze({get document(){return w.getValue()},set document(d){throw(0,R.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(d){if(!(d instanceof y.Selection))throw(0,R.illegalArgument)("selection");c._selections=[d],c._trySetSelection()},get selections(){return c._selections},set selections(d){if(!Array.isArray(d)||d.some(t=>!(t instanceof y.Selection)))throw(0,R.illegalArgument)("selections");c._selections=d,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(d){throw(0,R.readonly)("visibleRanges")},get options(){return c._options.value},set options(d){c._disposed||c._options.assign(d)},get viewColumn(){return c._viewColumn},set viewColumn(d){throw(0,R.readonly)("viewColumn")},edit(d,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new D(w.getValue(),t);return d(n),c._applyEdit(n)},insertSnippet(d,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=c._selections.map(r=>T.Range.from(r));else if(t instanceof y.Position){const{lineNumber:r,column:o}=T.Position.from(t);s=[{startLineNumber:r,startColumn:o,endLineNumber:r,endColumn:o}]}else if(t instanceof y.Range)s=[T.Range.from(t)];else{s=[];for(const r of t)if(r instanceof y.Range)s.push(T.Range.from(r));else{const{lineNumber:o,column:g}=T.Position.from(r);s.push({startLineNumber:o,startColumn:g,endLineNumber:o,endColumn:g})}}return p.$tryInsertSnippet(h,d.value,s,n)},setDecorations(d,t){const n=t.length===0;n&&!c._hasDecorationsForKey.has(d.key)||(n?c._hasDecorationsForKey.delete(d.key):c._hasDecorationsForKey.add(d.key),c._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return p.$trySetDecorations(h,d.key,T.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let r=0,o=t.length;r<o;r++){const g=t[r];s[4*r]=g.start.line+1,s[4*r+1]=g.start.character+1,s[4*r+2]=g.end.line+1,s[4*r+3]=g.end.character+1}return p.$trySetDecorationsFast(h,d.key,s)}}))},revealRange(d,t){c._runOnProxy(()=>p.$tryRevealRange(h,T.Range.from(d),t||y.TextEditorRevealType.Default))},show(d){p.$tryShowEditor(h,T.ViewColumn.from(d))},hide(){p.$tryHideEditor(h)}})}dispose(){(0,v.ok)(!this._disposed),this._disposed=!0}_acceptOptions(h){(0,v.ok)(!this._disposed),this._options._accept(h)}_acceptVisibleRanges(h){(0,v.ok)(!this._disposed),this._visibleRanges=h}_acceptViewColumn(h){(0,v.ok)(!this._disposed),this._viewColumn=h}_acceptSelections(h){(0,v.ok)(!this._disposed),this._selections=h}async _trySetSelection(){const h=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,h)),this.value}_applyEdit(h){const p=h.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const a=p.edits.map(m=>m.range);a.sort((m,b)=>m.end.line===b.end.line?m.end.character===b.end.character?m.start.line===b.start.line?m.start.character-b.start.character:m.start.line-b.start.line:m.end.character-b.end.character:m.end.line-b.end.line);for(let m=0,b=a.length-1;m<b;m++){const _=a[m].end;if(a[m+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=p.edits.map(m=>({range:T.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,w,{setEndOfLine:typeof p.setEndOfLine=="number"?T.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(h){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=i}),define(me[215],ge([0,1,165,25,2,3,6,13,7,12,16,20,21]),function(K,e,v,R,C,T,y,P,D,I,i,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function p(m,b){if((0,I.isString)(m))return{label:m};if(m&&typeof m=="object"&&typeof m.label=="string"){let _;return Array.isArray(m.highlights)&&(_=m.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),_=_.length?_:void 0),{label:m.label,highlights:_}}}class a{constructor(b,_,u){this._proxy=b,this.commands=_,this.logService=u,this.treeViews=new Map;function c(d){return d&&d.$treeViewId&&d.$treeItemHandle}_.registerArgumentProcessor({processArgument:d=>c(d)?this.convertArgument(d):Array.isArray(d)&&d.length>0?d.map(t=>c(t)?this.convertArgument(t):t):d})}registerTreeDataProvider(b,_,u){const c=this.createTreeView(b,{treeDataProvider:_},u);return{dispose:()=>c.dispose()}}createTreeView(b,_,u){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=_.dragAndDropController!==void 0,d=this._proxy.$registerTreeViewDataProvider(b,{showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany,canDragAndDrop:c}),t=this.createExtHostTreeView(b,_,u);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(n){t.message=n},get title(){return t.title},set title(n){t.title=n},get description(){return t.description},set description(n){t.description=n},reveal:(n,s)=>t.reveal(n,s),dispose:async()=>{await d,this.treeViews.delete(b),t.dispose()}}}$getChildren(b,_){const u=this.treeViews.get(b);return u?u.getChildren(_):Promise.reject(new Error((0,v.localize)(0,null,b)))}$onDrop(b,_,u){const c=this.treeViews.get(b);return c?c.onDrop(_,u):Promise.reject(new Error((0,v.localize)(1,null,b)))}async $hasResolve(b){const _=this.treeViews.get(b);if(!_)throw new Error((0,v.localize)(2,null,b));return _.hasResolve}$resolve(b,_,u){const c=this.treeViews.get(b);if(!c)throw new Error((0,v.localize)(3,null,b));return c.resolveTreeItem(_,u)}$setExpanded(b,_,u){const c=this.treeViews.get(b);if(!c)throw new Error((0,v.localize)(4,null,b));c.setExpanded(_,u)}$setSelection(b,_){const u=this.treeViews.get(b);if(!u)throw new Error((0,v.localize)(5,null,b));u.setSelection(_)}$setVisible(b,_){const u=this.treeViews.get(b);if(!u)throw new Error((0,v.localize)(6,null,b));u.setVisible(_)}createExtHostTreeView(b,_,u){const c=new w(b,_,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(b,c),c}convertArgument(b){const _=this.treeViews.get(b.$treeViewId);return _?_.getExtensionElement(b.$treeItemHandle):null}}e.ExtHostTreeViews=a;class w extends y.Disposable{constructor(b,_,u,c,d,t){super();if(this.viewId=b,this.proxy=u,this.commands=c,this.logService=d,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const o of t.contributes.views[r])o.id===b&&(this._title=o.name);this.dataProvider=_.treeDataProvider,this.dndController=_.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,s;this._register(T.Event.debounce(this._onDidChangeData.event,(r,o)=>(r||(r={message:!1,elements:[]}),o.element!==!1&&(n||(n=new Promise(g=>s=g),this.refreshPromise=this.refreshPromise.then(()=>n)),r.elements.push(o.element)),o.message&&(r.message=!0),r),200,!0)(({message:r,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const g=s;return n=null,this.refresh(o).then(()=>g())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(b=>this.getExtensionElement(b)).filter(b=>!(0,I.isUndefinedOrNull)(b))}getChildren(b){const _=b?this.getExtensionElement(b):void 0;if(b&&!_)return this.logService.error(`No tree item with id '${b}' found.`),Promise.resolve([]);const u=this.getChildrenNodes(b);return(u?Promise.resolve(u):this.fetchChildrenNodes(_)).then(c=>c.map(d=>d.item))}getExtensionElement(b){return this.elements.get(b)}reveal(b,_){_=_||{select:!0,focus:!1};const u=(0,I.isUndefinedOrNull)(_.select)?!0:_.select,c=(0,I.isUndefinedOrNull)(_.focus)?!1:_.focus,d=(0,I.isUndefinedOrNull)(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.refreshPromise.then(()=>this.resolveUnknownParentChain(b)).then(t=>this.resolveTreeNode(b,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(s=>s.item)},{select:u,focus:c,expand:d})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:c,expand:d})}get message(){return this._message}set message(b){this._message=b,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(b){this._title=b,this.proxy.$setTitle(this.viewId,b,this._description)}get description(){return this._description}set description(b){this._description=b,this.proxy.$setTitle(this.viewId,this._title,b)}setExpanded(b,_){const u=this.getExtensionElement(b);u&&(_?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(b){(0,i.equals)(this._selectedHandles,b)||(this._selectedHandles=b,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(b){b!==this._visible&&(this._visible=b,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(b,_){const u=b.map(d=>this.getExtensionElement(d)).filter(d=>!(0,I.isUndefinedOrNull)(d)),c=this.getExtensionElement(_);return u&&c?(0,P.asPromise)(()=>{var d;return(d=this.dndController)===null||d===void 0?void 0:d.onDrop(u,c)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(b,_){var u;if(!this.dataProvider.resolveTreeItem)return;const c=this.elements.get(b);if(c){const d=this.nodes.get(c);if(d){const t=(u=await this.dataProvider.resolveTreeItem(d.extensionItem,c,_))!==null&&u!==void 0?u:d.extensionItem;return d.item.tooltip=this.getTooltip(t.tooltip),d.item.command=this.getCommand(d.disposableStore,t.command),d.item}}}resolveUnknownParentChain(b){return this.resolveParent(b).then(_=>_?this.resolveUnknownParentChain(_).then(u=>this.resolveTreeNode(_,u[u.length-1]).then(c=>(u.push(c),u))):Promise.resolve([]))}resolveParent(b){const _=this.nodes.get(b);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(b))}resolveTreeNode(b,_){const u=this.nodes.get(b);return u?Promise.resolve(u):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(c=>this.createHandle(b,c,_,!0)).then(c=>this.getChildren(_?_.item.handle:void 0).then(()=>{const d=this.getExtensionElement(c);if(d){const t=this.nodes.get(d);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(b){if(b){let _;if(typeof b=="string"){const u=this.getExtensionElement(b);_=u?this.nodes.get(u):void 0}else _=b;return _&&_.children||null}return this.roots}async fetchChildrenNodes(b){this.clearChildren(b);const _=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=b?this.nodes.get(b):void 0,c=await this.dataProvider.getChildren(b);if(_.token.isCancellationRequested)return[];const d=await Promise.all((0,i.coalesce)(c||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,u):null}));return _.token.isCancellationRequested?[]:(0,i.coalesce)(d)}finally{_.dispose()}}refresh(b){if(b.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(b);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(b){const _=new Set,u=b.map(d=>this.nodes.get(d));for(const d of u)if(d&&!_.has(d.item.handle)){let t=d;for(;t&&t.parent&&u.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&_.add(d.item.handle)}const c=[];return _.forEach(d=>{const t=this.elements.get(d);if(t){const n=this.nodes.get(t);n&&(!n.parent||!_.has(n.parent.item.handle))&&c.push(d)}}),c}refreshHandles(b){const _={};return Promise.all(b.map(u=>this.refreshNode(u).then(c=>{c&&(_[u]=c.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(b){const _=this.getExtensionElement(b);if(_){const u=this.nodes.get(_);if(u)return this.clearChildren(_),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(c=>{if(c){const d=this.createTreeNode(_,c,u.parent);return this.updateNodeCache(_,d,u,u.parent),u.dispose(),d}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(b,_,u){const c=this.createTreeNode(b,_,u);if(_.id&&this.elements.has(c.item.handle))throw new Error((0,v.localize)(7,null,_.id));return this.addNodeToCache(b,c),this.addNodeToParentCache(c,u),c}getTooltip(b){return D.MarkdownString.isMarkdownString(b)?A.MarkdownString.from(b):b}getCommand(b,_){return _?this.commands.toInternal(_,b):void 0}createTreeNode(b,_,u){const c=new y.DisposableStore,d=this.createHandle(b,_,u),t=this.getLightIconPath(_);return{item:{handle:d,parentHandle:u?u.item.handle:void 0,label:p(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(c,_.command),contextValue:_.contextValue,icon:t,iconDark:this.getDarkIconPath(_)||t,themeIcon:this.getThemeIcon(_),collapsibleState:(0,I.isUndefinedOrNull)(_.collapsibleState)?D.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation},extensionItem:_,parent:u,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(b){return b.iconPath instanceof D.ThemeIcon?b.iconPath:void 0}createHandle(b,{id:_,label:u,resourceUri:c},d,t){if(_)return`${w.ID_HANDLE_PREFIX}/${_}`;const n=p(u,this.extension),s=d?d.item.handle:w.LABEL_HANDLE_PREFIX;let r=n?n.label:c?(0,R.basename)(c):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const o=this.nodes.has(b)?this.nodes.get(b).item.handle:void 0,g=this.getChildrenNodes(d)||[];let f,S=0;do{if(f=`${s}/${S}:${r}`,t||!this.elements.has(f)||o===f)break;S++}while(S<=g.length);return f}getLightIconPath(b){if(b.iconPath&&!(b.iconPath instanceof D.ThemeIcon))return typeof b.iconPath=="string"||C.URI.isUri(b.iconPath)?this.getIconPath(b.iconPath):this.getIconPath(b.iconPath.light)}getDarkIconPath(b){if(b.iconPath&&!(b.iconPath instanceof D.ThemeIcon)&&b.iconPath.dark)return this.getIconPath(b.iconPath.dark)}getIconPath(b){return C.URI.isUri(b)?b:C.URI.file(b)}addNodeToCache(b,_){this.elements.set(_.item.handle,b),this.nodes.set(b,_)}updateNodeCache(b,_,u,c){this.elements.delete(_.item.handle),this.nodes.delete(b),_.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(b,_);const d=this.getChildrenNodes(c)||[],t=d.filter(n=>n.item.handle===u.item.handle)[0];t&&d.splice(d.indexOf(t),1,_)}addNodeToParentCache(b,_){_?(_.children||(_.children=[]),_.children.push(b)):(this.roots||(this.roots=[]),this.roots.push(b))}clearChildren(b){if(b){const _=this.nodes.get(b);if(_){if(_.children)for(const u of _.children){const c=this.elements.get(u.item.handle);c&&this.clear(c)}_.children=void 0}}else this.clearAll()}clear(b){const _=this.nodes.get(b);if(_){if(_.children)for(const u of _.children){const c=this.elements.get(u.item.handle);c&&this.clear(c)}this.nodes.delete(b),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(b=>b.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}w.LABEL_HANDLE_PREFIX="0",w.ID_HANDLE_PREFIX="1"}),define(me[216],ge([0,1,16,13,21,12,86,20,7,123]),function(K,e,v,R,C,T,y,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(m,b){if(b!==void 0){const _=this.testIdsToInternal.get(b),u=_==null?void 0:_.get(m);if(u)return[_,u]}return(0,v.mapFind)(this.testIdsToInternal.values(),_=>{const u=_.get(m);return u&&[_,u]})}createForHierarchy(m=()=>{}){return new a(this.createIdMap(h++),m)}createIdMap(m){const b=new p(m);return this.testIdsToInternal.set(b.id,b),{object:b,dispose:()=>this.testIdsToInternal.delete(b.id)}}}e.OwnedTestCollection=i;var A;(function(w){w[w.Disconnected=0]="Disconnected",w[w.IsChild=1]="IsChild",w[w.IsParent=2]="IsParent",w[w.IsSame=3]="IsSame"})(A=e.TestPosition||(e.TestPosition={}));let h=0;class p{constructor(m){this.id=m,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(m){if(this.map.has(m.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${m.item.extId}`);this.map.set(m.item.extId,m),m.parent||this._roots.add(m)}has(m){return this.map.has(m)}delete(m){const b=this.map.get(m);return b?(this.map.delete(m),this._roots.delete(b),!0):!1}get(m){return this.map.get(m)}comparePositions(m,b){const _=typeof m=="string"?this.map.get(m):m,u=typeof b=="string"?this.map.get(b):b;if(!_||!u)return 0;if(_===u)return 3;for(let c=this.map.get(u.parent);c;c=this.map.get(c.parent))if(c===_)return 1;for(let c=this.map.get(_.parent);c;c=this.map.get(c.parent))if(c===u)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=p;class a{constructor(m,b){this.testIdToInternal=m,this.publishDiff=b,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new R.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(m,b){this.addItem(m,b,null)}getTestByReference(m){return this.testItemToInternal.get(m)}collectDiff(){const m=this.diff;return this.diff=[],m}pushDiff(m){const b=this.diff[this.diff.length-1];if(b&&m[0]===1){if(b[0]===1&&b[1].extId===m[1].extId){(0,I.applyTestItemUpdate)(b[1],m[1]);return}if(b[0]===0&&b[1].item.extId===m[1].extId){(0,I.applyTestItemUpdate)(b[1],m[1]);return}}this.diff.push(m),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(m,b){var _;const u=this.testIdToInternal.object.get(m);if(!!u){if((u.expandLevels===void 0||b>u.expandLevels)&&(u.expandLevels=b),u.expand===1){const c=this.refreshChildren(u);return c.isSettled?this.expandChildren(u,b-1):c.p.then(()=>this.expandChildren(u,b-1))}else if(u.expand===3)return((_=u.initialExpand)===null||_===void 0?void 0:_.isSettled)===!1?u.initialExpand.p.then(()=>this.expandChildren(u,b-1)):this.expandChildren(u,b-1)}}dispose(){var m;for(const b of this.testItemToInternal.values())(m=b.discoverCts)===null||m===void 0||m.dispose(!0),(0,y.getPrivateApiFor)(b.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(m,b){const _=m==null?void 0:m.actual.id;switch(b[0]){case 2:this.pushDiff([4,_]);break;case 1:this.removeItem(m);break;case 0:this.addItem(b[1],m.src.controller,m);break;case 3:const[u,c,d]=b;switch(c){case"status":this.updateExpandability(m);break;case"range":this.pushDiff([1,{extId:_,item:{range:P.Range.from(d)}}]);break;case"error":this.pushDiff([1,{extId:_,item:{error:P.MarkdownString.fromStrict(d)||null}}]);break;default:this.pushDiff([1,{extId:_,item:{[c]:d!=null?d:null}}]);break}break;default:(0,T.assertNever)(b[0])}}addItem(m,b,_){if(!(m instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${m.id} did not`);if(this.testItemToInternal.has(m))throw new Error(`Attempted to add a single TestItem ${m.id} multiple times to the tree`);if(this.testIdToInternal.object.has(m.id))throw new Error(`Attempted to insert a duplicate test item ID ${m.id}`);const u=_?_.item.extId:null,c=m.resolveHandler?1:0,d=_?_.expandLevels:1,t={controller:b,tree:this.testIdToInternal.object.id},n={actual:m,parent:u,item:P.TestItem.from(m),expandLevels:d?d-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(m,n),this.pushDiff([0,{parent:u,src:t,expand:c,item:n.item}]);const s=(0,y.getPrivateApiFor)(m);s.parent=_==null?void 0:_.actual,s.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const r of s.children.values())this.testItemToInternal.has(r)||this.addItem(r,b,n)}updateExpandability(m){var b;let _;m.actual.resolveHandler?m.actual.status===D.TestItemStatus.Pending?_=m.discoverCts?2:1:((b=m.initialExpand)===null||b===void 0||b.complete(),_=3):_=0,_!==m.expand&&(m.expand=_,this.pushDiff([1,{extId:m.actual.id,expand:_}]),_===1&&m.expandLevels!==void 0&&this.refreshChildren(m))}expandChildren(m,b){if(b<0)return;const _=[...m.actual.children.values()].map(u=>this.expand(u.id,b)).filter(R.isThenable);if(_.length)return Promise.all(_).then(()=>{})}refreshChildren(m){if(m.discoverCts&&m.discoverCts.dispose(!0),!m.actual.resolveHandler){const b=new R.DeferredPromise;return b.complete(),b}return m.expand=2,m.discoverCts=new C.CancellationTokenSource,this.pushExpandStateUpdate(m),m.initialExpand=new R.DeferredPromise,m.actual.resolveHandler(m.discoverCts.token),m.initialExpand}pushExpandStateUpdate(m){this.pushDiff([1,{extId:m.actual.id,expand:m.expand}])}removeItem(m){var b;this.pushDiff([2,m.actual.id]);const _=[m];for(;_.length;){const u=_.pop();if(!!u){(b=u.discoverCts)===null||b===void 0||b.dispose(!0),this.testIdToInternal.object.delete(u.item.extId),this.testItemToInternal.delete(u.actual);for(const c of u.actual.children.values())_.push(this.testIdToInternal.object.get(c.id))}}}flushDiff(){const m=this.collectDiff();m.length&&this.publishDiff(m)}}e.SingleUseTestCollection=a}),define(me[217],ge([0,1,26,3,9]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=T;class y{constructor(i){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(v.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(v.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let A of i.activationEvents)A==="onUri"&&(A=`onUri:${v.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(A)||this._activationMap.set(A,[]),this._activationMap.get(A).push(i)}}keepOnly(i){const A=new Set;i.forEach(h=>A.add(v.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>A.has(v.ExtensionIdentifier.toKey(h.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,A){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const h=y._findLoopingExtensions(this._extensionDescriptions);if(A=A.concat(h.map(p=>p.identifier)),A.length>0){const p=new Set;A.forEach(a=>p.add(v.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!p.has(v.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(h)}static _findLoopingExtensions(i){const A=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(m){this._nodesSet.has(m)||(this._nodesSet.add(m),this._nodesArr.push(m))}addArc(m,b){this.addNode(m),this.addNode(b),this._arcs.has(m)?this._arcs.get(m).push(b):this._arcs.set(m,[b])}getArcs(m){return this._arcs.has(m)?this._arcs.get(m):[]}hasOnlyGoodArcs(m,b){const _=A.getArcs(m);for(let u=0;u<_.length;u++)if(!b.has(_[u]))return!1;return!0}getNodes(){return this._nodesArr}};let h=new Map;for(let m of i){const b=v.ExtensionIdentifier.toKey(m.identifier);if(h.set(b,m),m.extensionDependencies)for(let _ of m.extensionDependencies){const u=v.ExtensionIdentifier.toKey(_);A.addArc(b,u)}}let p=new Set;A.getNodes().filter(m=>A.getArcs(m).length===0).forEach(m=>p.add(m));let a=A.getNodes().filter(m=>!p.has(m)),w;do{w=!1;for(let m=0;m<a.length;m++){const b=a[m];A.hasOnlyGoodArcs(b,p)&&(a.splice(m,1),m--,p.add(b),w=!0)}}while(w);return a.map(m=>h.get(m))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(v.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const A=this._activationMap.get(i);return A?A.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const A=this._extensionsMap.get(v.ExtensionIdentifier.toKey(i));return A||void 0}}e.ExtensionDescriptionRegistry=y;var P;(function(I){I[I.Builtin=0]="Builtin",I[I.User=1]="User",I[I.Dev=2]="Dev"})(P||(P={}));function D(I,i){const A=I.isBuiltin?0:I.isUnderDevelopment?2:1,h=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(A!==h)return A-h;const p=C.posix.basename(I.extensionLocation.path),a=C.posix.basename(i.extensionLocation.path);return p<a?-1:p>a?1:0}}),define(me[218],ge([0,1,22]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var C;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(C=e.MessageType||(e.MessageType={}));function T(P){const D=v.VSBuffer.alloc(1);switch(P){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=T;function y(P,D){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=y}),define(me[39],ge([0,1,3,2,4,26,182]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,C.createDecorator)("extensionService");class P{constructor(_){this.dependency=_}}e.MissingExtensionDependency=P;var D;(function(b){b[b.LocalProcess=0]="LocalProcess",b[b.LocalWebWorker=1]="LocalWebWorker",b[b.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class I{constructor(_,u,c,d){this.codeLoadingTime=_,this.activateCallTime=u,this.activateResolvedTime=c,this.activationReason=d}}e.ActivationTimes=I;class i{constructor(_,u){this.description=_,this.value=u}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var A;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(A=e.ActivationKind||(e.ActivationKind={}));function h(b){b.enableProposedApi||p(b)}e.checkProposedApiEnabled=h;function p(b){throw new Error(`[${b.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.throwProposedApiError=p;function a(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation}}e.toExtension=a;function w(b){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(b.identifier.id),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!1,extensionLocation:b.location},b.manifest),{uuid:b.identifier.uuid})}e.toExtensionDescription=w;class m{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None}activateByEvent(_){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(_){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(_){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(_){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(_,u){return Promise.resolve()}_onWillActivateExtension(_){}_onDidActivateExtension(_,u,c,d,t){}_onDidActivateExtensionError(_,u){}_onExtensionRuntimeError(_,u){}_onExtensionHostExit(_){}}e.NullExtensionService=m}),define(me[219],ge([0,1,26,39,14]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class y{constructor(a,w,m,b){this.startup=a,this.codeLoadingTime=w,this.activateCallTime=m,this.activateResolvedTime=b}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class P{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,w){return a===-1||w===-1?-1:w-a}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=P;class D{constructor(a,w,m,b,_,u){this.activationFailed=a,this.activationFailedError=w,this.activationTimes=m,this.module=b,this.exports=_,this.subscriptions=u}}e.ActivatedExtension=D;class I extends D{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class i extends D{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class A extends D{constructor(a){super(!0,a,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=A;let h=class{constructor(a,w,m,b,_){this._logService=_,this._registry=a,this._resolvedExtensionsSet=new Set,w.forEach(u=>this._resolvedExtensionsSet.add(v.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,m.forEach(u=>this._hostExtensionsMap.set(v.ExtensionIdentifier.toKey(u),u)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const w=v.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(w)}getActivatedExtension(a){const w=v.ExtensionIdentifier.toKey(a),m=this._activatedExtensions.get(w);if(!m)throw new Error("Extension `"+a.value+"` is not known or not activated");return m}activateByEvent(a,w){if(this._alreadyActivatedEvents[a])return T;const m=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(m.map(b=>({id:b.identifier,reason:{startup:w,extensionId:b.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,w){const m=this._registry.getExtensionDescription(a);if(!m)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:m.identifier,reason:w}])}_handleActivateRequest(a,w,m){if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(a.id))){w[v.ExtensionIdentifier.toKey(a.id)]=a;return}const b=this._registry.getExtensionDescription(a.id);if(!b){const c=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,c,new R.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(a.id),new A(c));return}const _=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let u=!0;for(let c=0,d=_.length;c<d;c++){const t=_[c];if(this._resolvedExtensionsSet.has(v.ExtensionIdentifier.toKey(t)))continue;const n=this._activatedExtensions.get(v.ExtensionIdentifier.toKey(t));if(n&&!n.activationFailed)continue;if(n&&n.activationFailed){const g=b.displayName||b.identifier.value,f=this._registry.getExtensionDescription(t),S=f&&f.displayName||t,E=new Error(`Cannot activate the '${g}' extension because its dependency '${S}' failed to activate`);E.detail=n.activationFailedError,this._host.onExtensionActivationError(b.identifier,E,null),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(b.identifier),new A(E));return}if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(t))){u=!1,w[v.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(v.ExtensionIdentifier.toKey(t)),reason:a.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){u=!1,w[v.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:a.reason};continue}const r=b.displayName||b.identifier.value,o=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(b.identifier,o,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(b.identifier),new A(o));return}u?w[v.ExtensionIdentifier.toKey(b.identifier)]=a:m.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(_=>!this._activatedExtensions.has(v.ExtensionIdentifier.toKey(_.id))),a.length===0))return Promise.resolve(void 0);const w=Object.create(null),m=[];for(let _=0,u=a.length;_<u;_++)this._handleActivateRequest(a[_],w,m);for(let _=0,u=m.length;_<u;_++){const c=v.ExtensionIdentifier.toKey(m[_].id);w[c]&&delete w[c]}const b=Object.keys(w).map(_=>w[_]);return m.length===0?Promise.all(b.map(_=>this._activateExtension(_.id,_.reason))).then(_=>{}):this._activateExtensions(b).then(_=>this._activateExtensions(m))}_activateExtension(a,w){const m=v.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(m))return Promise.resolve(void 0);const b=this._activatingExtensions.get(m);if(b)return b;const _=this._host.actualActivateExtension(a,w).then(void 0,u=>{const c=new Error;return u&&u.name&&(c.name=u.name),u&&u.message?c.message=`Activating extension '${a.value}' failed: ${u.message}.`:c.message=`Activating extension '${a.value}' failed: ${u}.`,u&&u.stack&&(c.stack=u.stack),this._host.onExtensionActivationError(a,c,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(u),new A(u)}).then(u=>{this._activatedExtensions.set(m,u),this._activatingExtensions.delete(m)});return this._activatingExtensions.set(m,_),_}};h=qe([He(4,C.ILogService)],h),e.ExtensionsActivator=h}),define(me[220],ge([0,1,14,39,27,10,112]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends v.LogService{constructor(I){if(I.logFile.scheme!==T.Schemas.file)throw new Error("Only file-logging supported");super(new y.SpdLogLogger(R.ExtensionHostLogFileName,I.logFile.fsPath,!0,I.logLevel))}$setLevel(I){this.setLevel(I)}};P=qe([He(0,C.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(me[221],ge([0,1,17]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,y)=>{this._actualOk=T,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,v.onUnexpectedError)(T))}then(T,y){return this._ensureActual().then(T,y)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=R}),define(me[126],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class v{constructor(D,I){this.isMain=D,this.sid=I,this.nid=++v.count}}e.ProxyIdentifier=v,v.count=0;const R=[];function C(P){const D=new v(!0,P);return R[D.nid]=D,D}e.createMainContextProxyIdentifier=C;function T(P){const D=new v(!1,P);return R[D.nid]=D,D}e.createExtHostContextProxyIdentifier=T;function y(P){return R[P].sid}e.getStringIdentifierForProxy=y}),define(me[5],ge([0,1,58,2,126]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var A;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(A=e.CandidatePortSource||(e.CandidatePortSource={}));var h;(function(u){u.name="$ident";function c(t,n){return Object.defineProperty(t,u.name,{value:n,enumerable:!0}),t}u.mixin=c;function d(t){return t[u.name]}u.of=d})(h=e.ObjectIdentifier||(e.ObjectIdentifier={}));class p{static mixin(c){return c._id=p._n++,c}}e.IdObject=p,p._n=0;var a;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(m=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(u){if(u&&u.edits)for(const c of u.edits)typeof c.resource=="object"?c.resource=R.URI.revive(c.resource):(c.newUri=R.URI.revive(c.newUri),c.oldUri=R.URI.revive(c.oldUri)),c.metadata&&c.metadata.iconPath&&(c.metadata=(0,v.revive)(c.metadata));return u}e.reviveWorkspaceEditDto=b;var _;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(_=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,C.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,C.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,C.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,C.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,C.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,C.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,C.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,C.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,C.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,C.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,C.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,C.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,C.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,C.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,C.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,C.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,C.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,C.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,C.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,C.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,C.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,C.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,C.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,C.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,C.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,C.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,C.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,C.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,C.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadTheming:(0,C.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,C.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,C.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,C.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,C.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,C.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,C.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,C.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,C.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,C.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,C.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,C.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,C.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,C.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,C.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,C.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,C.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,C.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,C.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,C.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,C.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,C.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,C.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,C.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostTheming:(0,C.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,C.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,C.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,C.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,C.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,C.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[88],ge([0,1,5,3,4]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(P){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(v.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,D){return this._proxy.$getPassword(P,D)}store(P,D,I){return this._proxy.$setPassword(P,D,I)}delete(P,D){return this._proxy.$deletePassword(P,D)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")}),define(me[65],ge([0,1,4,14,5,15]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,v.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(D,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(C.MainContext.MainThreadTelemetry)}report(D,I,i){const A=this.getUsageKey(D,I);this._reportedUsages.has(A)||(this._reportedUsages.add(A),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:D}))}getUsageKey(D,I){return`${D}-${I.identifier.value}`}};y=qe([He(0,T.IExtHostRpcService),He(1,R.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(P,D,I){}})}),define(me[222],ge([0,1,3,5,7,26]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new v.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new v.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,I,i,A={}){const h=T.ExtensionIdentifier.toKey(D.identifier),p=this._inFlightRequests.get(h)||[],a=i.sort().join(" ");let w=p.find(m=>m.scopes===a);if(w)return w.result;{const m=this._getSession(D,h,I,i,A);w={scopes:a,result:m},p.push(w),this._inFlightRequests.set(h,p);try{await m}finally{const b=p.findIndex(_=>_.scopes===a);b>-1&&(p.splice(b),this._inFlightRequests.set(h,p))}return m}}async _getSession(D,I,i,A,h={}){await this._proxy.$ensureProvider(i);const p=D.displayName||D.name;return this._proxy.$getSession(i,A,I,p,h)}async removeSession(D,I){const i=this._authenticationProviders.get(D);return i?i.provider.removeSession(I):this._proxy.$removeSession(D,I)}registerAuthenticationProvider(D,I,i,A){var h;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:I,provider:i,options:A!=null?A:{supportsMultipleAccounts:!1}}),this._providers.find(a=>a.id===D)||this._providers.push({id:D,label:I});const p=i.onDidChangeSessions(a=>{var w,m,b;this._proxy.$sendDidChangeSessions(D,{added:(w=a.added)!==null&&w!==void 0?w:[],changed:(m=a.changed)!==null&&m!==void 0?m:[],removed:(b=a.removed)!==null&&b!==void 0?b:[]})});return this._proxy.$registerAuthenticationProvider(D,I,(h=A==null?void 0:A.supportsMultipleAccounts)!==null&&h!==void 0?h:!1),new C.Disposable(()=>{p.dispose(),this._authenticationProviders.delete(D);const a=this._providers.findIndex(w=>w.id===D);a>-1&&this._providers.splice(a),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,I){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,I){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,I){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,I){return this._onDidChangeSessions.fire({provider:{id:D,label:I}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,I){return D.forEach(i=>{this._providers.some(A=>A.id===i.id)||this._providers.push(i)}),I.forEach(i=>{const A=this._providers.findIndex(h=>h.id===i.id);A>-1&&this._providers.splice(A)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:I}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(me[223],ge([0,1,5,15,20]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(P,D){this._extHostDocumentsAndEditors=D,this._proxy=P.getProxy(v.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const D=C.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};T=qe([He(0,R.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(me[224],ge([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(T){const y=T.getProxy(v.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(P){return y.$writeText(P)}})}}e.ExtHostClipboard=R}),define(me[49],ge([0,1,12,7,20,24,5,16,14,58,42,46,2,6,4,15]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let m=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new b(this,s=>{const r=this._apiCommands.get(s);return(r==null?void 0:r.result)===u.Void?r:void 0},n),this._argumentProcessors=[{processArgument(s){return(0,I.revive)(s)}},{processArgument(s){return(0,T.cloneAndChange)(s,function(r){if(i.Range.isIRange(r))return C.Range.to(r);if(A.Position.isIPosition(r))return C.Position.to(r);if(i.Range.isIRange(r.range)&&h.URI.isUri(r.uri))return C.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...s)=>{const r=t.args.map((g,f)=>{if(!g.validate(s[f]))throw new Error(`Invalid argument '${g.name}' when running '${t.id}', received: ${s[f]}`);return g.convert(s[f])}),o=await this.executeCommand(t.internalId,...r);return t.result.convert(o,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,s,r,o){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:s,thisArg:r,description:o}),t&&this._proxy.$registerCommand(n),new R.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,s){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const r=(0,T.cloneAndChange)(n,function(o){if(o instanceof R.Position)return C.Position.from(o);if(o instanceof R.Range)return C.Range.from(o);if(o instanceof R.Location)return C.location.from(o);if(R.NotebookRange.isNotebookRange(o))return C.NotebookRange.from(o);if(!Array.isArray(o))return o});try{const o=await this._proxy.$executeCommand(t,r,s);return(0,I.revive)(o)}catch(o){if(o instanceof Error&&o.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw o}}}async _executeContributedCommand(t,n){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:r,thisArg:o,description:g}=s;if(g)for(let f=0;f<g.args.length;f++)try{(0,v.validateConstraint)(n[f],g.args[f].constraint)}catch(S){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${g.args[f].name}' - ${g.args[f].description}`)}try{return await r.apply(o,n)}catch(f){if(t===this.converter.delegatingCommandId){const S=this.converter.getActualCommand(...n);S&&(t=S.command)}throw this._logService.error(f,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(s=>this._argumentProcessors.reduce((r,o)=>o.processArgument(r),s)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(s=>s[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,s]of this._commands){let{description:r}=s;r&&(t[n]=r)}return Promise.resolve(t)}};m=qe([He(0,w.IExtHostRpcService),He(1,D.ILogService)],m),e.ExtHostCommands=m,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class b{constructor(t,n,s){this._commands=t,this._lookupApiCommand=n,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const r=this._lookupApiCommand(t.command);if(r)s.id=r.internalId,s.arguments=r.args.map((o,g)=>o.convert(t.arguments&&t.arguments[g]));else if((0,P.isNonEmptyArray)(t.arguments)){const o=++this._cachIdPool;this._cache.set(o,t),n.add((0,p.toDisposable)(()=>{this._cache.delete(o),this._logService.trace("CommandsConverter#DISPOSE",o)})),s.$ident=o,s.id=this.delegatingCommandId,s.arguments=[o],this._logService.trace("CommandsConverter#CREATE",t.command,o)}return s}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=b;class _{constructor(t,n,s,r){this.name=t,this.description=n,this.validate=s,this.convert=r}optional(){return new _(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new _(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=_,_.Uri=new _("uri","Uri of a text document",d=>h.URI.isUri(d),d=>d),_.Position=new _("position","A position in a text document",d=>R.Position.isPosition(d),C.Position.from),_.Range=new _("range","A range in a text document",d=>R.Range.isRange(d),C.Range.from),_.Selection=new _("selection","A selection in a text document",d=>R.Selection.isSelection(d),C.Selection.from),_.Number=new _("number","",d=>typeof d=="number",d=>d),_.String=new _("string","",d=>typeof d=="string",d=>d),_.CallHierarchyItem=new _("item","A call hierarchy item",d=>d instanceof R.CallHierarchyItem,C.CallHierarchyItem.to);class u{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=u,u.Void=new u("no result",d=>d);class c{constructor(t,n,s,r,o){this.id=t,this.internalId=n,this.description=s,this.args=r,this.result=o}}e.ApiCommand=c}),define(me[225],ge([0,1,6,20,7,80,49,202,16,108]),function(K,e,v,R,C,T,y,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",h(R.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,w)=>{if((0,D.isFalsyOrEmpty)(a))return;class m extends C.SymbolInformation{static to(_){const u=new m(_.name,R.SymbolKind.to(_.kind),_.containerName||"",new C.Location(w[0],R.Range.to(_.range)));return u.detail=_.detail,u.range=u.location.range,u.selectionRange=R.Range.to(_.selectionRange),u.children=_.children?_.children.map(m.to):[],u}}return a.map(m.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",h(R.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",h(R.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",h(R.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",h(R.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",h(R.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(w=>C.Position.isPosition(w)),a=>a.map(R.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(w=>{let m;for(const b of w.reverse())m=new C.SelectionRange(R.Range.to(b),m);return m}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const w=[];if(Array.isArray(a))for(let m of a)w.push(...m[1].map(R.WorkspaceSymbol.to));return w})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(R.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(R.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(R.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return R.WorkspaceEdit.to(a)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(R.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new C.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const w=(0,I.decodeSemanticTokensDto)(a);if(w.type==="full")return new C.SemanticTokens(w.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new C.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const w=(0,I.decodeSemanticTokensDto)(a);if(w.type==="full")return new C.SemanticTokens(w.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,w,m)=>{if(!a)return new C.CompletionList([]);const b=a.suggestions.map(_=>R.CompletionItem.to(_,m));return new C.CompletionList(b,a.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return R.SignatureHelp.to(a)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,w,m)=>h(b=>new C.CodeLens(R.Range.to(b.range),b.command&&m.fromInternal(b.command)))(a))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>C.Range.isRange(a),a=>C.Selection.isSelection(a)?R.Selection.from(a):R.Range.from(a)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,w,m)=>h(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return m.fromInternal(b.command)}else{const _=new C.CodeAction(b.title,b.kind?new C.CodeActionKind(b.kind):void 0);return b.edit&&(_.edit=R.WorkspaceEdit.to(b.edit)),b.command&&(_.command=m.fromInternal(b.command)),_.isPreferred=b.isPreferred,_}})(a))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(w=>new C.ColorInformation(R.Range.to(w.range),R.Color.to(w.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",a=>a instanceof C.Color,R.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:R.Range.from(a.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(R.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",a=>a.map(R.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",h(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(w=>R.NotebookExclusiveDocumentPattern.to(w))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(R.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[R.ViewColumn.from(a.viewColumn),R.TextEditorOpenOptions.from(a)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[R.ViewColumn.from(a.viewColumn),R.TextEditorOpenOptions.from(a)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[R.ViewColumn.from(a.viewColumn),R.TextEditorOpenOptions.from(a)]).optional()],y.ApiCommandResult.Void)];class A{constructor(w){this._disposables=new v.DisposableStore,this._commands=w}static register(w){return i.forEach(w.registerApiCommand,w),new A(w).registerCommands()}registerCommands(){const w=m=>(...b)=>m(this._commands,...b);this._register(P.RemoveFromRecentlyOpenedAPICommand.ID,w(P.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:m=>typeof m=="string"}]})}_register(w,m,b){const _=this._commands.registerCommand(!1,w,m,this,b);this._disposables.add(_)}}e.ExtHostApiCommands=A;function h(a){return w=>{if(Array.isArray(w))return w.map(a)}}function p(a){if(!Array.isArray(a))return;const w=[];for(const m of a)T.isLocationLink(m)?w.push(R.DefinitionLink.to(m)):w.push(R.location.to(m));return w}}),define(me[226],ge([0,1,13,53,3,6,2,80,26,20,7,5]),function(K,e,v,R,C,T,y,P,D,I,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class h{constructor(c,d,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=c.getProxy(A.MainContext.MainThreadComments),d.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const s=this._commentControllers.get(n.handle);return s||n}else if(n&&n.$mid===7){const s=this._commentControllers.get(n.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.commentThreadHandle);return r||n}else if(n&&n.$mid===8){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);return r?{thread:r,text:n.text}:n}else if(n&&n.$mid===9){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let o=n.commentUniqueId,g=r.getCommentByUniqueId(o);return g||n}else if(n&&n.$mid===10){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let o=n.text,g=n.commentUniqueId,f=r.getCommentByUniqueId(g);return f?(f.body=o,f):n}return n}})}createCommentController(c,d,t){const n=h.handlePool++,s=new a(c,n,this._proxy,d,t);this._commentControllers.set(s.handle,s);const r=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(c.identifier))||[];return r.push(s),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(c.identifier),r),s}$createCommentThreadTemplate(c,d,t){const n=this._commentControllers.get(c);!n||n.$createCommentThreadTemplate(d,t)}async $updateCommentThreadTemplate(c,d,t){const n=this._commentControllers.get(c);!n||n.$updateCommentThreadTemplate(d,t)}$deleteCommentThread(c,d){const t=this._commentControllers.get(c);t&&t.$deleteCommentThread(d)}$provideCommentingRanges(c,d,t){const n=this._commentControllers.get(c);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(y.URI.revive(d));return(0,v.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(s,t)).then(r=>r?r.map(o=>I.Range.from(o)):void 0)}$toggleReaction(c,d,t,n,s){const r=this._commentControllers.get(c);return!r||!r.reactionHandler?Promise.resolve(void 0):(0,v.asPromise)(()=>{const o=r.getCommentThread(d);if(o){const g=o.getCommentByUniqueId(n.uniqueIdInThread);if(r!==void 0&&g&&r.reactionHandler)return r.reactionHandler(g,b(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=h,h.handlePool=0;class p{constructor(c,d,t,n,s,r,o){this._proxy=c,this._commentController=d,this._id=t,this._uri=n,this._range=s,this._comments=r,this.handle=p._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${d.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,I.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const c=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),d={};c("range")&&(d.range=I.Range.from(this._range)),c("label")&&(d.label=this.label),c("contextValue")&&(d.contextValue=this.contextValue),c("comments")&&(d.comments=this._comments.map(t=>w(this,this._commentController,t,this._commentsMap))),c("collapsibleState")&&(d.collapseState=_(this._collapseState)),c("canReply")&&(d.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,d)}getCommentByUniqueId(c){for(let d of this._commentsMap){let t=d[0],n=d[1];if(c===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}p._handlePool=0,qe([(0,R.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=p;class a{constructor(c,d,t,n,s){this._extension=c,this._handle=d,this._proxy=t,this._id=n,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,d,t,n){if(typeof c=="string"){const s=new p(this._proxy,this,c,d,t,n,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new p(this._proxy,this,void 0,c,d,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(c,d){const t=new p(this._proxy,this,void 0,y.URI.revive(c),I.Range.to(d),[],this._extension.identifier);return t.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(c,d){let t=this._threads.get(c);t&&(t.range=I.Range.to(d))}$deleteCommentThread(c){let d=this._threads.get(c);d&&d.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function w(u,c,d,t){let n=t.get(d);n||(n=++u.commentHandle,t.set(d,n));const s=d.author&&d.author.iconPath?d.author.iconPath.toString():void 0;return{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:n,body:I.MarkdownString.from(d.body),userName:d.author.name,userIconPath:s,label:d.label,commentReactions:d.reactions?d.reactions.map(r=>m(r)):void 0}}function m(u){return{label:u.label,iconPath:u.iconPath?I.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function b(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?y.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function _(u){if(u!==void 0)switch(u){case i.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}}),define(me[127],ge([0,1,2,5,7,4,15,14,16,8,9]),function(K,e,v,R,C,T,y,P,D,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let A=class vn{constructor(p,a){this._logService=a,this._provider=new Map,this._proxy=p.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,a){const w=vn._handlePool++;this._provider.set(w,{provider:p,extensionId:a}),this._proxy.$registerDecorationProvider(w,a.value);const m=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(b=>{if(!b){this._proxy.$onDidChange(w,null);return}let _=(0,D.asArray)(b);if(_.length<=vn._maxEventSize){this._proxy.$onDidChange(w,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,_.length);const u=_.map(t=>({uri:t,rank:(0,I.count)(t.path,"/")})),c=(0,D.groupBy)(u,(t,n)=>t.rank-n.rank||(0,I.compare)(t.uri.path,n.uri.path));let d=[];e:for(let t of c){let n;for(let s of t){let r=(0,i.dirname)(s.uri.path);if(n!==r&&(n=r,d.push(s.uri)>=vn._maxEventSize))break e}}this._proxy.$onDidChange(w,d)});return new C.Disposable(()=>{m==null||m.dispose(),this._proxy.$unregisterDecorationProvider(w),this._provider.delete(w)})}async $provideDecorations(p,a,w){if(!this._provider.has(p))return Object.create(null);const m=Object.create(null),{provider:b,extensionId:_}=this._provider.get(p);return await Promise.all(a.map(async u=>{try{const{uri:c,id:d}=u,t=await Promise.resolve(b.provideFileDecoration(v.URI.revive(c),w));if(!t)return;try{C.FileDecoration.validate(t),m[d]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${_.value}': ${n}`)}}catch(c){this._logService.error(c)}})),m}};A._handlePool=0,A._maxEventSize=250,A=qe([He(0,y.IExtHostRpcService),He(1,P.ILogService)],A),e.ExtHostDecorations=A,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(me[227],ge([0,1,160,113,2,5,7,20,3,14,23]),function(K,e,v,R,C,T,y,P,D,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class A{constructor(a,w,m,b,_){this._name=a,this._owner=w,this._maxDiagnosticsPerFile=m,this._proxy=b,this._onDidChangeDiagnostics=_,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,w){if(!a){this.clear();return}this._checkDisposed();let m=[];if(C.URI.isUri(a)){if(!w){this.delete(a);return}this._data.set(a,w.slice()),m=[a]}else if(Array.isArray(a)){m=[];let _;a=[...a].sort(A._compareIndexedTuplesByUri);for(const u of a){const[c,d]=u;if((!_||c.toString()!==_.toString())&&(_&&this._data.get(_).length===0&&this._data.delete(_),_=c,m.push(c),this._data.set(c,[])),d){const t=this._data.get(c);t&&t.push(...d)}else{const t=this._data.get(c);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(m),!this._proxy)return;const b=[];for(let _ of m){let u=[];const c=this._data.get(_);if(c)if(c.length>this._maxDiagnosticsPerFile){u=[];const d=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of c)if(n.severity===d[t]&&u.push(P.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;u.push({severity:R.MarkerSeverity.Info,message:(0,v.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=c.map(d=>P.Diagnostic.from(d));b.push([_,u])}this._proxy.$changeMany(this._owner,b)}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,w){this._checkDisposed();for(let m of this._data.keys())a.apply(w,[m,this.get(m),this])}get(a){this._checkDisposed();const w=this._data.get(a);return Array.isArray(w)?Object.freeze(w.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,w){return a[0].toString()<w[0].toString()?-1:a[0].toString()>w[0].toString()?1:0}}e.DiagnosticCollection=A;let h=class jt{constructor(a,w){this._logService=w,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,jt._debouncer,50),jt._mapper),this._proxy=a.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(a,w){return a?a.concat(w):w}static _mapper(a){const w=new i.ResourceMap;for(const m of a)w.set(m,m);return{uris:Object.freeze(Array.from(w.values()))}}createDiagnosticCollection(a,w){const{_collections:m,_proxy:b,_onDidChangeDiagnostics:_,_logService:u}=this,c=new class{$changeMany(n,s){b.$changeMany(n,s),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,n,s.length===0?"CLEARING":s)}$clear(n){b.$clear(n),u.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,n)}dispose(){b.dispose()}};let d;if(!w)w="_generated_diagnostic_collection_name_#"+jt._idPool++,d=w;else if(!m.has(w))d=w;else{this._logService.warn(`DiagnosticCollection with name '${w}' does already exist.`);do d=w+jt._idPool++;while(m.has(d))}return new class extends A{constructor(){super(w,d,jt._maxDiagnosticsPerFile,c,_);m.set(d,this)}dispose(){super.dispose(),m.delete(d)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const w=new Map,m=[];for(const b of this._collections.values())b.forEach((_,u)=>{let c=w.get(_.toString());typeof c=="undefined"&&(c=m.length,w.set(_.toString(),c),m.push([_,[]])),m[c][1]=m[c][1].concat(...u)});return m}}_getDiagnostics(a){let w=[];for(let m of this._collections.values())m.has(a)&&(w=w.concat(m.get(a)));return w}$acceptMarkersChange(a){if(!this._mirrorCollection){const w="_generated_mirror",m=new A(w,w,jt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(w,m),this._mirrorCollection=m}for(const[w,m]of a)this._mirrorCollection.set(C.URI.revive(w),m.map(P.Diagnostic.to))}};h._idPool=0,h._maxDiagnosticsPerFile=1e3,h=qe([He(1,I.ILogService)],h),e.ExtHostDiagnostics=h}),define(me[228],ge([0,1,2,5]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(y){this._proxy=y.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(P=>P?P.map(D=>v.URI.revive(D)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(P=>P?v.URI.revive(P):void 0)}}e.ExtHostDialogs=C}),define(me[229],ge([0,1,17,2,7,5,10,21,8]),function(K,e,v,R,C,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(A,h,p){this._documentsAndEditors=h,this._logService=p,this._documentContentProviders=new Map,this._proxy=A.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(A,h){if(Object.keys(y.Schemas).indexOf(A)>=0)throw new Error(`scheme '${A}' already registered`);const p=I._handlePool++;this._documentContentProviders.set(p,h),this._proxy.$registerTextContentProvider(p,A);let a;return typeof h.onDidChange=="function"&&(a=h.onDidChange(w=>{if(w.scheme!==A){this._logService.warn(`Provider for scheme '${A}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(p,w).then(m=>{if(!m&&typeof m!="string")return;const b=this._documentsAndEditors.getDocument(w);if(!b)return;const _=(0,D.splitLines)(m);if(!b.equalLines(_))return this._proxy.$onVirtualDocumentChange(w,m)},v.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(A,h){const p=this._documentContentProviders.get(A);return p?Promise.resolve(p.provideTextDocumentContent(R.URI.revive(h),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(me[230],ge([0,1,3,6,2,5,120,20,12,24]),function(K,e,v,R,C,T,y,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(h,p){this._onDidAddDocument=new v.Emitter,this._onDidRemoveDocument=new v.Emitter,this._onDidChangeDocument=new v.Emitter,this._onDidSaveDocument=new v.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const w of a)this._onDidRemoveDocument.fire(w.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const w of a)this._onDidAddDocument.fire(w.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!h)return;const p=this._documentsAndEditors.getDocument(h);if(p)return p}getDocument(h){const p=this.getDocumentData(h);if(!(p==null?void 0:p.document))throw new Error(`Unable to retrieve document from URI '${h}'`);return p.document}ensureDocumentData(h){const p=this._documentsAndEditors.getDocument(h);if(p)return Promise.resolve(p);let a=this._documentLoader.get(h.toString());return a||(a=this._proxy.$tryOpenDocument(h).then(w=>{this._documentLoader.delete(h.toString());const m=C.URI.revive(w);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(m))},w=>(this._documentLoader.delete(h.toString()),Promise.reject(w))),this._documentLoader.set(h.toString(),a)),a}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(p=>C.URI.revive(p))}$acceptModelModeChanged(h,p){const a=C.URI.revive(h),w=this._documentsAndEditors.getDocument(a);if(!w)throw new Error("unknown document");this._onDidRemoveDocument.fire(w.document),w._acceptLanguageId(p),this._onDidAddDocument.fire(w.document)}$acceptModelSaved(h){const p=C.URI.revive(h),a=this._documentsAndEditors.getDocument(p);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(h,p){const a=C.URI.revive(h),w=this._documentsAndEditors.getDocument(a);if(!w)throw new Error("unknown document");w._acceptIsDirty(p),this._onDidChangeDocument.fire({document:w.document,contentChanges:[]})}$acceptModelChanged(h,p,a){const w=C.URI.revive(h),m=this._documentsAndEditors.getDocument(w);if(!m)throw new Error("unknown document");m._acceptIsDirty(a),m.onEvents(p),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:m.document,contentChanges:p.changes.map(b=>({range:P.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text}))}))}setWordDefinitionFor(h,p){(0,y.setWordDefinitionFor)(h,p)}}e.ExtHostDocuments=i}),define(me[40],ge([0,1,51,3,6,2,4,5,120,15,125,20,14,23,10,54,135]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class b{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(c,d){this._extHostRpc=c,this._logService=d,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const d=[],t=[],n=[];if(c.removedDocuments)for(const s of c.removedDocuments){const r=T.URI.revive(s),o=this._documents.get(r);(o==null?void 0:o.unref())&&(this._documents.delete(r),d.push(o.value))}if(c.addedDocuments)for(const s of c.addedDocuments){const r=T.URI.revive(s.uri);let o=this._documents.get(r);if(o&&r.scheme!==a.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);o||(o=new b(new D.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),r,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(r,o),t.push(o.value)),o.ref()}if(c.removedEditors)for(const s of c.removedEditors){const r=this._editors.get(s);this._editors.delete(s),r&&n.push(r)}if(c.addedEditors)for(const s of c.addedEditors){const r=T.URI.revive(s.documentUri);v.ok(this._documents.has(r),`document '${r}' does not exist`),v.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const o=this._documents.get(r).value,g=new i.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new m.Lazy(()=>o.document),s.selections.map(A.Selection.to),s.options,s.visibleRanges.map(f=>A.Range.to(f)),typeof s.editorPosition=="number"?A.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,g)}c.newActiveEditor!==void 0&&(v.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,C.dispose)(d),(0,C.dispose)(n),c.removedDocuments&&this._onDidRemoveDocuments.fire(d),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){var d;return(d=this._documents.get(c))===null||d===void 0?void 0:d.value}allDocuments(){return w.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const d=this._editors.get(this._activeEditorId);return c?d:d==null?void 0:d.value}allEditors(){return[...this._editors.values()]}};_=qe([He(0,I.IExtHostRpcService),He(1,h.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[231],ge([0,1,2,5,6,7,20,143,8,22]),function(K,e,v,R,C,T,y,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const a=this._schemes.indexOf(p);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),a=[];let w,m,b=14,_=14;for(const u of p){let c=w?(0,D.commonPrefixLength)(w,u):0;for(c===0?m=1:m=_;c<u.length;c++)c+1===u.length?(b=_,_=9):_+=1,a.push([m,u.toUpperCase().charCodeAt(c),_]),a.push([m,u.toLowerCase().charCodeAt(c),_]),m=_;w=u,_=b}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new P.StateMachine(a)}}provideDocumentLinks(p){this._initStateMachine();const a=[],w=P.LinkComputer.computeLinks({getLineContent(m){return p.lineAt(m-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const m of w){const b=y.DocumentLink.to(m);b.target&&a.push(b)}return a}}class A{constructor(p,a){this._extHostLanguageFeatures=a,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=p.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){var p;(p=this._linkProviderRegistration)===null||p===void 0||p.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(p,a,w,m={},b){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const _=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(_,w),this._enableProposedApi.set(_,b!=null?b:!1);let u=2;m.isCaseSensitive&&(u+=1024),m.isReadonly&&(u+=2048),typeof w.copy=="function"&&(u+=8),typeof w.open=="function"&&typeof w.close=="function"&&typeof w.read=="function"&&typeof w.write=="function"&&(u+=4),this._proxy.$registerFileSystemProvider(_,a,u).catch(d=>{console.error(`FAILED to register filesystem provider of ${p.value}-extension for the scheme ${a}`),console.error(d)});const c=w.onDidChangeFile(d=>{const t=[];for(const n of d){let{uri:s,type:r}=n;if(s.scheme!==a)continue;let o;switch(r){case T.FileChangeType.Changed:o=0;break;case T.FileChangeType.Created:o=1;break;case T.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:o})}this._proxy.$onFileSystemChange(_,t)});return(0,C.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(_),this._enableProposedApi.delete(_),this._proxy.$unregisterProvider(_)})}static _asIStat(p,a){const{type:w,ctime:m,mtime:b,size:_,permissions:u}=p;return a?{type:w,ctime:m,mtime:b,size:_,permissions:u}:{type:w,ctime:m,mtime:b,size:_}}$stat(p,a){return Promise.resolve(this._getFsProvider(p).stat(v.URI.revive(a))).then(w=>{var m;return A._asIStat(w,(m=this._enableProposedApi.get(p))!==null&&m!==void 0?m:!1)})}$readdir(p,a){return Promise.resolve(this._getFsProvider(p).readDirectory(v.URI.revive(a)))}$readFile(p,a){return Promise.resolve(this._getFsProvider(p).readFile(v.URI.revive(a))).then(w=>I.VSBuffer.wrap(w))}$writeFile(p,a,w,m){return Promise.resolve(this._getFsProvider(p).writeFile(v.URI.revive(a),w.buffer,m))}$delete(p,a,w){return Promise.resolve(this._getFsProvider(p).delete(v.URI.revive(a),w))}$rename(p,a,w,m){return Promise.resolve(this._getFsProvider(p).rename(v.URI.revive(a),v.URI.revive(w),m))}$copy(p,a,w,m){const b=this._getFsProvider(p);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(v.URI.revive(a),v.URI.revive(w),m))}$mkdir(p,a){return Promise.resolve(this._getFsProvider(p).createDirectory(v.URI.revive(a)))}$watch(p,a,w,m){const b=this._getFsProvider(p).watch(v.URI.revive(w),m);this._watches.set(a,b)}$unwatch(p,a){const w=this._watches.get(a);w&&(w.dispose(),this._watches.delete(a))}$open(p,a,w){const m=this._getFsProvider(p);if(!m.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(m.open(v.URI.revive(a),w))}$close(p,a){const w=this._getFsProvider(p);if(!w.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(w.close(a))}$read(p,a,w,m){const b=this._getFsProvider(p);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const _=I.VSBuffer.alloc(m);return Promise.resolve(b.read(a,w,_.buffer,0,m)).then(u=>_.slice(0,u))}$write(p,a,w,m){const b=this._getFsProvider(p);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(a,w,m.buffer,0,m.byteLength))}_getFsProvider(p){const a=this._fsProvider.get(p);if(!a){const w=new Error;throw w.name="ENOPRO",w.message="no provider",w}return a}}e.ExtHostFileSystem=A}),define(me[89],ge([0,1,5,43,7,22,4,15,62]),function(K,e,v,R,C,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let I=class Ut{constructor(A,h){const p=A.getProxy(v.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return p.$stat(a).catch(Ut._handleError)},readDirectory(a){return p.$readdir(a).catch(Ut._handleError)},createDirectory(a){return p.$mkdir(a).catch(Ut._handleError)},async readFile(a){return p.$readFile(a).then(w=>w.buffer).catch(Ut._handleError)},writeFile(a,w){return p.$writeFile(a,T.VSBuffer.wrap(w)).catch(Ut._handleError)},delete(a,w){return p.$delete(a,Object.assign({recursive:!1,useTrash:!1},w)).catch(Ut._handleError)},rename(a,w,m){return p.$rename(a,w,Object.assign({overwrite:!1},m)).catch(Ut._handleError)},copy(a,w,m){return p.$copy(a,w,Object.assign({overwrite:!1},m)).catch(Ut._handleError)},isWritableFileSystem(a){const w=h.getCapabilities(a);if(typeof w=="number")return!(w&2048)}})}static _handleError(A){if(!(A instanceof Error))throw new C.FileSystemError(String(A));if(A.name==="ENOPRO")throw C.FileSystemError.Unavailable(A.message);switch(A.name){case R.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(A.message);case R.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(A.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(A.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(A.message);case R.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(A.message);case R.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(A.message);default:throw new C.FileSystemError(A.message,A.name)}}};I=qe([He(0,P.IExtHostRpcService),He(1,D.IExtHostFileSystemInfo)],I),e.ExtHostConsumerFileSystem=I,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(me[232],ge([0,1,6,5]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(y){this._handlePool=0,this._proxy=y.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,y),(0,v.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=C}),define(me[233],ge([0,1,2,24,20,7,13,5,8,42,16,12,140,6,108,73,85,44,17]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w,m,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class u{constructor(j,Y){this._documents=j,this._provider=Y}provideDocumentSymbols(j,Y){const ee=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(ee,Y)).then(oe=>{if(!(0,i.isFalsyOrEmpty)(oe))return oe[0]instanceof T.DocumentSymbol?oe.map(C.DocumentSymbol.from):u._asDocumentSymbolTree(oe)})}static _asDocumentSymbolTree(j){var Y;j=j.slice(0).sort((pe,_e)=>{let de=pe.location.range.start.compareTo(_e.location.range.start);return de===0&&(de=_e.location.range.end.compareTo(pe.location.range.end)),de});const ee=[],oe=[];for(const pe of j){const _e={name:pe.name||"!!MISSING: name!!",kind:C.SymbolKind.from(pe.kind),tags:((Y=pe.tags)===null||Y===void 0?void 0:Y.map(C.SymbolTag.from))||[],detail:"",containerName:pe.containerName,range:C.Range.from(pe.location.range),selectionRange:C.Range.from(pe.location.range),children:[]};for(;;){if(oe.length===0){oe.push(_e),ee.push(_e);break}const de=oe[oe.length-1];if(I.Range.containsRange(de.range,_e.range)&&!I.Range.equalsRange(de.range,_e.range)){de.children&&de.children.push(_e),oe.push(_e);break}oe.pop()}}return ee}}class c{constructor(j,Y,ee){this._documents=j,this._commands=Y,this._provider=ee,this._cache=new m.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(j,Y){const ee=this._documents.getDocument(j),oe=await this._provider.provideCodeLenses(ee,Y);if(!oe||Y.isCancellationRequested)return;const pe=this._cache.add(oe),_e=new p.DisposableStore;this._disposables.set(pe,_e);const de={cacheId:pe,lenses:[]};for(let Ee=0;Ee<oe.length;Ee++)de.lenses.push({cacheId:[pe,Ee],range:C.Range.from(oe[Ee].range),command:this._commands.toInternal(oe[Ee].command,_e)});return de}async resolveCodeLens(j,Y){var ee;const oe=j.cacheId&&this._cache.get(...j.cacheId);if(!oe)return;let pe;if(typeof this._provider.resolveCodeLens!="function"||oe.isResolved?pe=oe:pe=await this._provider.resolveCodeLens(oe,Y),pe||(pe=oe),Y.isCancellationRequested)return;const _e=j.cacheId&&this._disposables.get(j.cacheId[0]);if(!!_e)return j.command=this._commands.toInternal((ee=pe.command)!==null&&ee!==void 0?ee:c._badCmd,_e),j}releaseCodeLenses(j){var Y;(Y=this._disposables.get(j))===null||Y===void 0||Y.dispose(),this._disposables.delete(j),this._cache.delete(j)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function d(We){return Array.isArray(We)?We.map(C.DefinitionLink.from):We?[C.DefinitionLink.from(We)]:[]}class t{constructor(j,Y){this._documents=j,this._provider=Y}provideDefinition(j,Y,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDefinition(oe,pe,ee)).then(d)}}class n{constructor(j,Y){this._documents=j,this._provider=Y}provideDeclaration(j,Y,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDeclaration(oe,pe,ee)).then(d)}}class s{constructor(j,Y){this._documents=j,this._provider=Y}provideImplementation(j,Y,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideImplementation(oe,pe,ee)).then(d)}}class r{constructor(j,Y){this._documents=j,this._provider=Y}provideTypeDefinition(j,Y,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(oe,pe,ee)).then(d)}}class o{constructor(j,Y){this._documents=j,this._provider=Y}provideHover(j,Y,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideHover(oe,pe,ee)).then(_e=>{if(!(!_e||(0,i.isFalsyOrEmpty)(_e.contents)))return _e.range||(_e.range=oe.getWordRangeAtPosition(pe)),_e.range||(_e.range=new T.Range(pe,pe)),C.Hover.from(_e)})}}class g{constructor(j,Y){this._documents=j,this._provider=Y}provideEvaluatableExpression(j,Y,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(oe,pe,ee)).then(_e=>{if(_e)return C.EvaluatableExpression.from(_e)})}}class f{constructor(j,Y){this._documents=j,this._provider=Y}provideInlineValues(j,Y,ee,oe){const pe=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideInlineValues(pe,C.Range.to(Y),C.InlineValueContext.to(ee),oe)).then(_e=>{if(Array.isArray(_e))return _e.map(de=>C.InlineValue.from(de))})}}class S{constructor(j,Y){this._documents=j,this._provider=Y}provideDocumentHighlights(j,Y,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(oe,pe,ee)).then(_e=>{if(Array.isArray(_e))return _e.map(C.DocumentHighlight.from)})}}class E{constructor(j,Y){this._documents=j,this._provider=Y}provideLinkedEditingRanges(j,Y,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(oe,pe,ee)).then(_e=>{if(_e&&Array.isArray(_e.ranges))return{ranges:(0,i.coalesce)(_e.ranges.map(C.Range.from)),wordPattern:_e.wordPattern}})}}class l{constructor(j,Y){this._documents=j,this._provider=Y}provideReferences(j,Y,ee,oe){const pe=this._documents.getDocument(j),_e=C.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideReferences(pe,_e,ee,oe)).then(de=>{if(Array.isArray(de))return de.map(C.location.from)})}}class L{constructor(j,Y,ee,oe,pe,_e,de){this._documents=j,this._commands=Y,this._diagnostics=ee,this._provider=oe,this._logService=pe,this._extension=_e,this._apiDeprecation=de,this._cache=new m.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(j,Y,ee,oe){const pe=this._documents.getDocument(j),_e=h.Selection.isISelection(Y)?C.Selection.to(Y):C.Range.to(Y),de=[];for(const Re of this._diagnostics.getDiagnostics(j))if(_e.intersection(Re.range)&&de.push(Re)>L._maxCodeActionsPerFile)break;const Ee={diagnostics:de,only:ee.only?new T.CodeActionKind(ee.only):void 0,triggerKind:C.CodeActionTriggerKind.to(ee.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(pe,_e,Ee,oe)).then(Re=>{var Ve;if(!(0,i.isNonEmptyArray)(Re)||oe.isCancellationRequested)return;const be=this._cache.add(Re),Ke=new p.DisposableStore;this._disposables.set(be,Ke);const Q=[];for(let ne=0;ne<Re.length;ne++){const ve=Re[ne];!ve||(L._isCommand(ve)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Q.push({_isSynthetic:!0,title:ve.title,command:this._commands.toInternal(ve,Ke)})):(Ee.only&&(ve.kind?Ee.only.contains(ve.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ee.only.value} 'requested but returned code action is of kind '${ve.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ee.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Q.push({cacheId:[be,ne],title:ve.title,command:ve.command&&this._commands.toInternal(ve.command,Ke),diagnostics:ve.diagnostics&&ve.diagnostics.map(C.Diagnostic.from),edit:ve.edit&&C.WorkspaceEdit.from(ve.edit),kind:ve.kind&&ve.kind.value,isPreferred:ve.isPreferred,disabled:(Ve=ve.disabled)===null||Ve===void 0?void 0:Ve.reason})))}return{cacheId:be,actions:Q}})}async resolveCodeAction(j,Y){var ee;const[oe,pe]=j,_e=this._cache.get(oe,pe);if(!_e||L._isCommand(_e)||!this._provider.resolveCodeAction)return;const de=(ee=await this._provider.resolveCodeAction(_e,Y))!==null&&ee!==void 0?ee:_e;return(de==null?void 0:de.edit)?C.WorkspaceEdit.from(de.edit):void 0}releaseCodeActions(j){var Y;(Y=this._disposables.get(j))===null||Y===void 0||Y.dispose(),this._disposables.delete(j),this._cache.delete(j)}static _isCommand(j){return typeof j.command=="string"&&typeof j.title=="string"}}L._maxCodeActionsPerFile=1e3;class O{constructor(j,Y){this._documents=j,this._provider=Y}provideDocumentFormattingEdits(j,Y,ee){const oe=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(oe,Y,ee)).then(pe=>{if(Array.isArray(pe))return pe.map(C.TextEdit.from)})}}class W{constructor(j,Y){this._documents=j,this._provider=Y}provideDocumentRangeFormattingEdits(j,Y,ee,oe){const pe=this._documents.getDocument(j),_e=C.Range.to(Y);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(pe,_e,ee,oe)).then(de=>{if(Array.isArray(de))return de.map(C.TextEdit.from)})}}class te{constructor(j,Y){this._documents=j,this._provider=Y,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(j,Y,ee,oe,pe){const _e=this._documents.getDocument(j),de=C.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(_e,de,ee,oe,pe)).then(Ee=>{if(Array.isArray(Ee))return Ee.map(C.TextEdit.from)})}}class se{constructor(j,Y){this._provider=j,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(j,Y){const ee=P.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(j,Y)).then(oe=>{if((0,i.isNonEmptyArray)(oe))for(const pe of oe){if(!pe)continue;if(!pe.name){this._logService.warn("INVALID SymbolInformation, lacks name",pe);continue}const _e=P.IdObject.mixin(C.WorkspaceSymbol.from(pe));this._symbolCache.set(_e._id,pe),ee.symbols.push(_e)}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(j,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return j;const ee=this._symbolCache.get(j._id);if(ee){const oe=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ee,Y));return oe&&(0,R.mixin)(j,C.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(j){const Y=this._resultCache.get(j);if(Y){for(let[ee,oe]=Y;ee<=oe;ee++)this._symbolCache.delete(ee);this._resultCache.delete(j)}}}class N{constructor(j,Y,ee){this._documents=j,this._provider=Y,this._logService=ee}static supportsResolving(j){return typeof j.prepareRename=="function"}provideRenameEdits(j,Y,ee,oe){const pe=this._documents.getDocument(j),_e=C.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(pe,_e,ee,oe)).then(de=>{if(!!de)return C.WorkspaceEdit.from(de)},de=>{const Ee=N._asMessage(de);return Ee?{rejectReason:Ee,edits:void 0}:Promise.reject(de)})}resolveRenameLocation(j,Y,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(j),pe=C.Position.to(Y);return(0,y.asPromise)(()=>this._provider.prepareRename(oe,pe,ee)).then(_e=>{let de,Ee;if(T.Range.isRange(_e)?(de=_e,Ee=oe.getText(_e)):(0,A.isObject)(_e)&&(de=_e.range,Ee=_e.placeholder),!!de){if(de.start.line>pe.line||de.end.line<pe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(de),text:Ee}}},_e=>{const de=N._asMessage(_e);return de?{rejectReason:de,range:void 0,text:void 0}:Promise.reject(_e)})}static _asMessage(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class V{constructor(j,Y){this.resultId=j,this.tokens=Y}}class x{constructor(j,Y){this._documents=j,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(j,Y,ee){const oe=this._documents.getDocument(j),pe=Y!==0?this._previousResults.get(Y):null;return(0,y.asPromise)(()=>pe&&typeof pe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(oe,pe.resultId,ee):this._provider.provideDocumentSemanticTokens(oe,ee)).then(_e=>(pe&&this._previousResults.delete(Y),_e?(_e=x._fixProvidedSemanticTokens(_e),this._send(x._convertToEdits(pe,_e),_e)):null))}async releaseDocumentSemanticColoring(j){this._previousResults.delete(j)}static _fixProvidedSemanticTokens(j){return x._isSemanticTokens(j)?x._isCorrectSemanticTokens(j)?j:new T.SemanticTokens(new Uint32Array(j.data),j.resultId):x._isSemanticTokensEdits(j)?x._isCorrectSemanticTokensEdits(j)?j:new T.SemanticTokensEdits(j.edits.map(Y=>new T.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),j.resultId):j}static _isSemanticTokens(j){return j&&!!j.data}static _isCorrectSemanticTokens(j){return j.data instanceof Uint32Array}static _isSemanticTokensEdits(j){return j&&Array.isArray(j.edits)}static _isCorrectSemanticTokensEdits(j){for(const Y of j.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(j,Y){if(!x._isSemanticTokens(Y)||!j||!j.tokens)return Y;const ee=j.tokens,oe=ee.length,pe=Y.data,_e=pe.length;let de=0;const Ee=Math.min(oe,_e);for(;de<Ee&&ee[de]===pe[de];)de++;if(de===oe&&de===_e)return new T.SemanticTokensEdits([],Y.resultId);let Re=0;const Ve=Ee-de;for(;Re<Ve&&ee[oe-Re-1]===pe[_e-Re-1];)Re++;return new T.SemanticTokensEdits([{start:de,deleteCount:oe-de-Re,data:pe.subarray(de,_e-Re)}],Y.resultId)}_send(j,Y){if(x._isSemanticTokens(j)){const ee=this._nextResultId++;return this._previousResults.set(ee,new V(j.resultId,j.data)),(0,a.encodeSemanticTokensDto)({id:ee,type:"full",data:j.data})}if(x._isSemanticTokensEdits(j)){const ee=this._nextResultId++;return x._isSemanticTokens(Y)?this._previousResults.set(ee,new V(Y.resultId,Y.data)):this._previousResults.set(ee,new V(j.resultId)),(0,a.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(j.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class k{constructor(j,Y){this._documents=j,this._provider=Y}provideDocumentRangeSemanticTokens(j,Y,ee){const oe=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(oe,C.Range.to(Y),ee)).then(pe=>pe?this._send(pe):null)}_send(j){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:j.data})}}e.DocumentRangeSemanticTokensAdapter=k;class U{constructor(j,Y,ee,oe,pe){this._documents=j,this._commands=Y,this._provider=ee,this._apiDeprecation=oe,this._extension=pe,this._cache=new m.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}async provideCompletionItems(j,Y,ee,oe){const pe=this._documents.getDocument(j),_e=C.Position.to(Y),de=pe.getWordRangeAtPosition(_e)||new T.Range(_e,_e),Ee=de.with({end:_e}),Re=new b.StopWatch(!0),Ve=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(pe,_e,oe,C.CompletionContext.to(ee)));if(!Ve||oe.isCancellationRequested)return;const be=Array.isArray(Ve)?new T.CompletionList(Ve):Ve,Ke=U.supportsResolving(this._provider)?this._cache.add(be.items):this._cache.add([]),Q=new p.DisposableStore;this._disposables.set(Ke,Q);const ne=[],ve={x:Ke,b:ne,a:{replace:C.Range.from(de),insert:C.Range.from(Ee)},c:be.isIncomplete||void 0,d:Re.elapsed()};for(let xe=0;xe<be.items.length;xe++){const je=be.items[xe],ze=this._convertCompletionItem(je,[Ke,xe],Ee,de);ne.push(ze)}return ve}async resolveCompletionItem(j,Y){if(typeof this._provider.resolveCompletionItem!="function")return;const ee=this._cache.get(...j);if(!ee)return;const oe=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(ee,Y));if(!!oe)return this._convertCompletionItem(oe,j)}releaseCompletionItems(j){var Y;(Y=this._disposables.get(j))===null||Y===void 0||Y.dispose(),this._disposables.delete(j),this._cache.delete(j)}_convertCompletionItem(j,Y,ee,oe){var pe;const _e=this._disposables.get(Y[0]);if(!_e)throw Error("DisposableStore is missing...");const de={x:Y,a:(pe=j.label)!==null&&pe!==void 0?pe:"",o:j.label2,b:j.kind!==void 0?C.CompletionItemKind.from(j.kind):void 0,n:j.tags&&j.tags.map(C.CompletionItemTag.from),c:j.detail,d:typeof j.documentation=="undefined"?void 0:C.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters,l:j.additionalTextEdits&&j.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(j.command,_e)};j.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),de.h=j.textEdit.newText):typeof j.insertText=="string"?de.h=j.insertText:j.insertText instanceof T.SnippetString&&(de.h=j.insertText.value,de.i|=4);let Ee;return j.textEdit?Ee=j.textEdit.range:j.range&&(Ee=j.range),T.Range.isRange(Ee)?de.j=C.Range.from(Ee):Ee&&(!(ee==null?void 0:ee.isEqual(Ee.inserting))||!(oe==null?void 0:oe.isEqual(Ee.replacing)))&&(de.j={insert:C.Range.from(Ee.inserting),replace:C.Range.from(Ee.replacing)}),de}}class F{constructor(j,Y){this._documents=j,this._provider=Y}async provideInlineCompletions(j,Y,ee,oe){const pe=this._documents.getDocument(j),_e=C.Position.to(Y),de=await(0,y.asPromise)(()=>this._provider.provideInlineCompletionItems(pe,_e,ee,oe));if(!!de&&!oe.isCancellationRequested)return{items:de.items.map(Ee=>({text:Ee.text,range:Ee.range?C.Range.from(Ee.range):void 0}))}}}class M{constructor(j,Y){this._documents=j,this._provider=Y,this._cache=new m.Cache("SignatureHelp")}provideSignatureHelp(j,Y,ee,oe){const pe=this._documents.getDocument(j),_e=C.Position.to(Y),de=this.reviveContext(ee);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(pe,_e,oe,de)).then(Ee=>{if(Ee){const Re=this._cache.add([Ee]);return Object.assign(Object.assign({},C.SignatureHelp.from(Ee)),{id:Re})}})}reviveContext(j){let Y;if(j.activeSignatureHelp){const ee=C.SignatureHelp.to(j.activeSignatureHelp),oe=this._cache.get(j.activeSignatureHelp.id,0);oe?(Y=oe,Y.activeSignature=ee.activeSignature,Y.activeParameter=ee.activeParameter):Y=ee}return Object.assign(Object.assign({},j),{activeSignatureHelp:Y})}releaseSignatureHelp(j){this._cache.delete(j)}}class ${constructor(j,Y){this._documents=j,this._provider=Y}provideInlayHints(j,Y,ee){const oe=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideInlayHints(oe,C.Range.to(Y),ee)).then(pe=>pe?{hints:pe.map(C.InlayHint.from)}:void 0)}}class H{constructor(j,Y){this._documents=j,this._provider=Y,this._cache=new m.Cache("DocumentLink")}provideLinks(j,Y){const ee=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(ee,Y)).then(oe=>{if(!(!Array.isArray(oe)||oe.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.map(C.DocumentLink.from)};{const pe=this._cache.add(oe),_e={links:[],id:pe};for(let de=0;de<oe.length;de++){const Ee=C.DocumentLink.from(oe[de]);Ee.cacheId=[pe,de],_e.links.push(Ee)}return _e}}})}resolveLink(j,Y){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...j);return ee?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(ee,Y)).then(oe=>oe&&C.DocumentLink.from(oe)||void 0):Promise.resolve(void 0)}releaseLinks(j){this._cache.delete(j)}}class X{constructor(j,Y){this._documents=j,this._provider=Y}provideColors(j,Y){const ee=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(ee,Y)).then(oe=>Array.isArray(oe)?oe.map(_e=>({color:C.Color.from(_e.color),range:C.Range.from(_e.range)})):[])}provideColorPresentations(j,Y,ee){const oe=this._documents.getDocument(j),pe=C.Range.to(Y.range),_e=C.Color.to(Y.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(_e,{document:oe,range:pe},ee)).then(de=>{if(!!Array.isArray(de))return de.map(C.ColorPresentation.from)})}}class ae{constructor(j,Y){this._documents=j,this._provider=Y}provideFoldingRanges(j,Y,ee){const oe=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(oe,Y,ee)).then(pe=>{if(!!Array.isArray(pe))return pe.map(C.FoldingRange.from)})}}class we{constructor(j,Y,ee){this._documents=j,this._provider=Y,this._logService=ee}provideSelectionRanges(j,Y,ee){const oe=this._documents.getDocument(j),pe=Y.map(C.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(oe,pe,ee)).then(_e=>{if(!(0,i.isNonEmptyArray)(_e))return[];if(_e.length!==pe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const de=[];for(let Ee=0;Ee<pe.length;Ee++){const Re=[];de.push(Re);let Ve=pe[Ee],be=_e[Ee];for(;;){if(!be.range.contains(Ve))throw new Error("INVALID selection range, must contain the previous range");if(Re.push(C.SelectionRange.from(be)),!be.parent)break;Ve=be.range,be=be.parent}}return de})}}class Le{constructor(j,Y){this._documents=j,this._provider=Y,this._idPool=new w.IdGenerator(""),this._cache=new Map}async prepareSession(j,Y,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(Y),_e=await this._provider.prepareCallHierarchy(oe,pe,ee);if(!_e)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(_e)?_e.map(Ee=>this._cacheAndConvertItem(de,Ee)):[this._cacheAndConvertItem(de,_e)]}async provideCallsTo(j,Y,ee){const oe=this._itemFromCache(j,Y);if(!oe)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyIncomingCalls(oe,ee);if(!!pe)return pe.map(_e=>({from:this._cacheAndConvertItem(j,_e.from),fromRanges:_e.fromRanges.map(de=>C.Range.from(de))}))}async provideCallsFrom(j,Y,ee){const oe=this._itemFromCache(j,Y);if(!oe)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyOutgoingCalls(oe,ee);if(!!pe)return pe.map(_e=>({to:this._cacheAndConvertItem(j,_e.to),fromRanges:_e.fromRanges.map(de=>C.Range.from(de))}))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,Y){var ee;const oe=this._cache.get(j),pe={_sessionId:j,_itemId:oe.size.toString(36),name:Y.name,detail:Y.detail,kind:C.SymbolKind.from(Y.kind),uri:Y.uri,range:C.Range.from(Y.range),selectionRange:C.Range.from(Y.selectionRange),tags:(ee=Y.tags)===null||ee===void 0?void 0:ee.map(C.SymbolTag.from)};return oe.set(pe._itemId,Y),pe}_itemFromCache(j,Y){const ee=this._cache.get(j);return ee==null?void 0:ee.get(Y)}}class Ie{constructor(j,Y){this.adapter=j,this.extension=Y}}class Me{constructor(j,Y,ee,oe,pe,_e,de){this._adapter=new Map,this._uriTransformer=Y,this._proxy=j.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=oe,this._diagnostics=pe,this._logService=_e,this._apiDeprecation=de}_transformDocumentSelector(j){return(0,i.coalesce)((0,i.asArray)(j).map(Y=>this._doTransformDocumentSelector(Y)))}_doTransformDocumentSelector(j){if(typeof j=="string")return{$serialized:!0,language:j};if(j)return{$serialized:!0,language:j.language,scheme:this._transformScheme(j.scheme),pattern:typeof j.pattern=="undefined"?void 0:C.GlobPattern.from(j.pattern),exclusive:j.exclusive}}_transformScheme(j){return this._uriTransformer&&typeof j=="string"?this._uriTransformer.transformOutgoingScheme(j):j}_createDisposable(j){return new T.Disposable(()=>{this._adapter.delete(j),this._proxy.$unregister(j)})}_nextHandle(){return Me._handlePool++}_withAdapter(j,Y,ee,oe,pe=!1){const _e=this._adapter.get(j);if(!_e)return Promise.resolve(oe);if(_e.adapter instanceof Y){let de;_e.extension&&(de=Date.now(),this._logService.trace(`[${_e.extension.identifier.value}] INVOKE provider '${Y.name}'`));const Ee=ee(_e.adapter,_e.extension),Re=_e.extension;return Re&&Promise.resolve(Ee).then(()=>this._logService.trace(`[${Re.identifier.value}] provider DONE after ${Date.now()-de}ms`),Ve=>{pe&&Ve instanceof _.CancellationError||(this._logService.error(`[${Re.identifier.value}] provider FAILED`),this._logService.error(Ve))}),Ee}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(j,Y){const ee=this._nextHandle();return this._adapter.set(ee,new Ie(j,Y)),ee}static _extLabel(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,Y,ee,oe){const pe=this._addNewAdapter(new u(this._documents,ee),j),_e=oe&&oe.label||Me._extLabel(j);return this._proxy.$registerDocumentSymbolProvider(pe,this._transformDocumentSelector(Y),_e),this._createDisposable(pe)}$provideDocumentSymbols(j,Y,ee){return this._withAdapter(j,u,oe=>oe.provideDocumentSymbols(v.URI.revive(Y),ee),void 0)}registerCodeLensProvider(j,Y,ee){const oe=this._nextHandle(),pe=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Ie(new c(this._documents,this._commands.converter,ee),j)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(Y),pe);let _e=this._createDisposable(oe);if(pe!==void 0){const de=ee.onDidChangeCodeLenses(Ee=>this._proxy.$emitCodeLensEvent(pe));_e=T.Disposable.from(_e,de)}return _e}$provideCodeLenses(j,Y,ee){return this._withAdapter(j,c,oe=>oe.provideCodeLenses(v.URI.revive(Y),ee),void 0)}$resolveCodeLens(j,Y,ee){return this._withAdapter(j,c,oe=>oe.resolveCodeLens(Y,ee),void 0)}$releaseCodeLenses(j,Y){this._withAdapter(j,c,ee=>Promise.resolve(ee.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(j,Y,ee){const oe=this._addNewAdapter(new t(this._documents,ee),j);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(Y)),this._createDisposable(oe)}$provideDefinition(j,Y,ee,oe){return this._withAdapter(j,t,pe=>pe.provideDefinition(v.URI.revive(Y),ee,oe),[])}registerDeclarationProvider(j,Y,ee){const oe=this._addNewAdapter(new n(this._documents,ee),j);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(Y)),this._createDisposable(oe)}$provideDeclaration(j,Y,ee,oe){return this._withAdapter(j,n,pe=>pe.provideDeclaration(v.URI.revive(Y),ee,oe),[])}registerImplementationProvider(j,Y,ee){const oe=this._addNewAdapter(new s(this._documents,ee),j);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(Y)),this._createDisposable(oe)}$provideImplementation(j,Y,ee,oe){return this._withAdapter(j,s,pe=>pe.provideImplementation(v.URI.revive(Y),ee,oe),[])}registerTypeDefinitionProvider(j,Y,ee){const oe=this._addNewAdapter(new r(this._documents,ee),j);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(Y)),this._createDisposable(oe)}$provideTypeDefinition(j,Y,ee,oe){return this._withAdapter(j,r,pe=>pe.provideTypeDefinition(v.URI.revive(Y),ee,oe),[])}registerHoverProvider(j,Y,ee,oe){const pe=this._addNewAdapter(new o(this._documents,ee),j);return this._proxy.$registerHoverProvider(pe,this._transformDocumentSelector(Y)),this._createDisposable(pe)}$provideHover(j,Y,ee,oe){return this._withAdapter(j,o,pe=>pe.provideHover(v.URI.revive(Y),ee,oe),void 0)}registerEvaluatableExpressionProvider(j,Y,ee,oe){const pe=this._addNewAdapter(new g(this._documents,ee),j);return this._proxy.$registerEvaluatableExpressionProvider(pe,this._transformDocumentSelector(Y)),this._createDisposable(pe)}$provideEvaluatableExpression(j,Y,ee,oe){return this._withAdapter(j,g,pe=>pe.provideEvaluatableExpression(v.URI.revive(Y),ee,oe),void 0)}registerInlineValuesProvider(j,Y,ee,oe){const pe=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,_e=this._addNewAdapter(new f(this._documents,ee),j);this._proxy.$registerInlineValuesProvider(_e,this._transformDocumentSelector(Y),pe);let de=this._createDisposable(_e);if(pe!==void 0){const Ee=ee.onDidChangeInlineValues(Re=>this._proxy.$emitInlineValuesEvent(pe));de=T.Disposable.from(de,Ee)}return de}$provideInlineValues(j,Y,ee,oe,pe){return this._withAdapter(j,f,_e=>_e.provideInlineValues(v.URI.revive(Y),ee,oe,pe),void 0)}registerDocumentHighlightProvider(j,Y,ee){const oe=this._addNewAdapter(new S(this._documents,ee),j);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(Y)),this._createDisposable(oe)}$provideDocumentHighlights(j,Y,ee,oe){return this._withAdapter(j,S,pe=>pe.provideDocumentHighlights(v.URI.revive(Y),ee,oe),void 0)}registerLinkedEditingRangeProvider(j,Y,ee){const oe=this._addNewAdapter(new E(this._documents,ee),j);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(Y)),this._createDisposable(oe)}$provideLinkedEditingRanges(j,Y,ee,oe){return this._withAdapter(j,E,async pe=>{const _e=await pe.provideLinkedEditingRanges(v.URI.revive(Y),ee,oe);if(_e)return{ranges:_e.ranges,wordPattern:_e.wordPattern?Me._serializeRegExp(_e.wordPattern):void 0}},void 0)}registerReferenceProvider(j,Y,ee){const oe=this._addNewAdapter(new l(this._documents,ee),j);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(Y)),this._createDisposable(oe)}$provideReferences(j,Y,ee,oe,pe){return this._withAdapter(j,l,_e=>_e.provideReferences(v.URI.revive(Y),ee,oe,pe),void 0)}registerCodeActionProvider(j,Y,ee,oe){var pe,_e;const de=new p.DisposableStore,Ee=this._addNewAdapter(new L(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,j,this._apiDeprecation),j);return this._proxy.$registerQuickFixSupport(Ee,this._transformDocumentSelector(Y),{providedKinds:(pe=oe==null?void 0:oe.providedCodeActionKinds)===null||pe===void 0?void 0:pe.map(Re=>Re.value),documentation:(_e=oe==null?void 0:oe.documentation)===null||_e===void 0?void 0:_e.map(Re=>({kind:Re.kind.value,command:this._commands.converter.toInternal(Re.command,de)}))},Me._extLabel(j),Boolean(ee.resolveCodeAction)),de.add(this._createDisposable(Ee)),de}$provideCodeActions(j,Y,ee,oe,pe){return this._withAdapter(j,L,_e=>_e.provideCodeActions(v.URI.revive(Y),ee,oe,pe),void 0)}$resolveCodeAction(j,Y,ee){return this._withAdapter(j,L,oe=>oe.resolveCodeAction(Y,ee),void 0)}$releaseCodeActions(j,Y){this._withAdapter(j,L,ee=>Promise.resolve(ee.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(j,Y,ee){const oe=this._addNewAdapter(new O(this._documents,ee),j);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(Y),j.identifier,j.displayName||j.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(j,Y,ee,oe){return this._withAdapter(j,O,pe=>pe.provideDocumentFormattingEdits(v.URI.revive(Y),ee,oe),void 0)}registerDocumentRangeFormattingEditProvider(j,Y,ee){const oe=this._addNewAdapter(new W(this._documents,ee),j);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(Y),j.identifier,j.displayName||j.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(j,Y,ee,oe,pe){return this._withAdapter(j,W,_e=>_e.provideDocumentRangeFormattingEdits(v.URI.revive(Y),ee,oe,pe),void 0)}registerOnTypeFormattingEditProvider(j,Y,ee,oe){const pe=this._addNewAdapter(new te(this._documents,ee),j);return this._proxy.$registerOnTypeFormattingSupport(pe,this._transformDocumentSelector(Y),oe,j.identifier),this._createDisposable(pe)}$provideOnTypeFormattingEdits(j,Y,ee,oe,pe,_e){return this._withAdapter(j,te,de=>de.provideOnTypeFormattingEdits(v.URI.revive(Y),ee,oe,pe,_e),void 0)}registerWorkspaceSymbolProvider(j,Y){const ee=this._addNewAdapter(new se(Y,this._logService),j);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(j,Y,ee){return this._withAdapter(j,se,oe=>oe.provideWorkspaceSymbols(Y,ee),{symbols:[]})}$resolveWorkspaceSymbol(j,Y,ee){return this._withAdapter(j,se,oe=>oe.resolveWorkspaceSymbol(Y,ee),void 0)}$releaseWorkspaceSymbols(j,Y){this._withAdapter(j,se,ee=>ee.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(j,Y,ee){const oe=this._addNewAdapter(new N(this._documents,ee,this._logService),j);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(Y),N.supportsResolving(ee)),this._createDisposable(oe)}$provideRenameEdits(j,Y,ee,oe,pe){return this._withAdapter(j,N,_e=>_e.provideRenameEdits(v.URI.revive(Y),ee,oe,pe),void 0)}$resolveRenameLocation(j,Y,ee,oe){return this._withAdapter(j,N,pe=>pe.resolveRenameLocation(v.URI.revive(Y),ee,oe),void 0)}registerDocumentSemanticTokensProvider(j,Y,ee,oe){const pe=this._nextHandle(),_e=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(pe,new Ie(new x(this._documents,ee),j)),this._proxy.$registerDocumentSemanticTokensProvider(pe,this._transformDocumentSelector(Y),oe,_e);let de=this._createDisposable(pe);if(_e){const Ee=ee.onDidChangeSemanticTokens(Re=>this._proxy.$emitDocumentSemanticTokensEvent(_e));de=T.Disposable.from(de,Ee)}return de}$provideDocumentSemanticTokens(j,Y,ee,oe){return this._withAdapter(j,x,pe=>pe.provideDocumentSemanticTokens(v.URI.revive(Y),ee,oe),null,!0)}$releaseDocumentSemanticTokens(j,Y){this._withAdapter(j,x,ee=>ee.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(j,Y,ee,oe){const pe=this._addNewAdapter(new k(this._documents,ee),j);return this._proxy.$registerDocumentRangeSemanticTokensProvider(pe,this._transformDocumentSelector(Y),oe),this._createDisposable(pe)}$provideDocumentRangeSemanticTokens(j,Y,ee,oe){return this._withAdapter(j,k,pe=>pe.provideDocumentRangeSemanticTokens(v.URI.revive(Y),ee,oe),null,!0)}registerCompletionItemProvider(j,Y,ee,oe){const pe=this._addNewAdapter(new U(this._documents,this._commands.converter,ee,this._apiDeprecation,j),j);return this._proxy.$registerSuggestSupport(pe,this._transformDocumentSelector(Y),oe,U.supportsResolving(ee),`${j.identifier.value}(${oe.join("")})`),this._createDisposable(pe)}$provideCompletionItems(j,Y,ee,oe,pe){return this._withAdapter(j,U,_e=>_e.provideCompletionItems(v.URI.revive(Y),ee,oe,pe),void 0)}$resolveCompletionItem(j,Y,ee){return this._withAdapter(j,U,oe=>oe.resolveCompletionItem(Y,ee),void 0)}$releaseCompletionItems(j,Y){this._withAdapter(j,U,ee=>ee.releaseCompletionItems(Y),void 0)}registerInlineCompletionsProvider(j,Y,ee){const oe=this._addNewAdapter(new F(this._documents,ee),j);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(Y)),this._createDisposable(oe)}$provideInlineCompletions(j,Y,ee,oe,pe){return this._withAdapter(j,F,_e=>_e.provideInlineCompletions(v.URI.revive(Y),ee,oe,pe),void 0)}registerSignatureHelpProvider(j,Y,ee,oe){const pe=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,_e=this._addNewAdapter(new M(this._documents,ee),j);return this._proxy.$registerSignatureHelpProvider(_e,this._transformDocumentSelector(Y),pe),this._createDisposable(_e)}$provideSignatureHelp(j,Y,ee,oe,pe){return this._withAdapter(j,M,_e=>_e.provideSignatureHelp(v.URI.revive(Y),ee,oe,pe),void 0)}$releaseSignatureHelp(j,Y){this._withAdapter(j,M,ee=>ee.releaseSignatureHelp(Y),void 0)}registerInlayHintsProvider(j,Y,ee){const oe=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,pe=this._addNewAdapter(new $(this._documents,ee),j);this._proxy.$registerInlayHintsProvider(pe,this._transformDocumentSelector(Y),oe);let _e=this._createDisposable(pe);if(oe!==void 0){const de=ee.onDidChangeInlayHints(Ee=>this._proxy.$emitInlayHintsEvent(oe));_e=T.Disposable.from(_e,de)}return _e}$provideInlayHints(j,Y,ee,oe){return this._withAdapter(j,$,pe=>pe.provideInlayHints(v.URI.revive(Y),ee,oe),void 0)}registerDocumentLinkProvider(j,Y,ee){const oe=this._addNewAdapter(new H(this._documents,ee),j);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(Y),typeof ee.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(j,Y,ee){return this._withAdapter(j,H,oe=>oe.provideLinks(v.URI.revive(Y),ee),void 0)}$resolveDocumentLink(j,Y,ee){return this._withAdapter(j,H,oe=>oe.resolveLink(Y,ee),void 0)}$releaseDocumentLinks(j,Y){this._withAdapter(j,H,ee=>ee.releaseLinks(Y),void 0)}registerColorProvider(j,Y,ee){const oe=this._addNewAdapter(new X(this._documents,ee),j);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(Y)),this._createDisposable(oe)}$provideDocumentColors(j,Y,ee){return this._withAdapter(j,X,oe=>oe.provideColors(v.URI.revive(Y),ee),[])}$provideColorPresentations(j,Y,ee,oe){return this._withAdapter(j,X,pe=>pe.provideColorPresentations(v.URI.revive(Y),ee,oe),void 0)}registerFoldingRangeProvider(j,Y,ee){const oe=this._nextHandle(),pe=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Ie(new ae(this._documents,ee),j)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(Y),pe);let _e=this._createDisposable(oe);if(pe!==void 0){const de=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(pe));_e=T.Disposable.from(_e,de)}return _e}$provideFoldingRanges(j,Y,ee,oe){return this._withAdapter(j,ae,pe=>pe.provideFoldingRanges(v.URI.revive(Y),ee,oe),void 0)}registerSelectionRangeProvider(j,Y,ee){const oe=this._addNewAdapter(new we(this._documents,ee,this._logService),j);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(Y)),this._createDisposable(oe)}$provideSelectionRanges(j,Y,ee,oe){return this._withAdapter(j,we,pe=>pe.provideSelectionRanges(v.URI.revive(Y),ee,oe),[])}registerCallHierarchyProvider(j,Y,ee){const oe=this._addNewAdapter(new Le(this._documents,ee),j);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(Y)),this._createDisposable(oe)}$prepareCallHierarchy(j,Y,ee,oe){return this._withAdapter(j,Le,pe=>Promise.resolve(pe.prepareSession(v.URI.revive(Y),ee,oe)),void 0)}$provideCallHierarchyIncomingCalls(j,Y,ee,oe){return this._withAdapter(j,Le,pe=>pe.provideCallsTo(Y,ee,oe),void 0)}$provideCallHierarchyOutgoingCalls(j,Y,ee,oe){return this._withAdapter(j,Le,pe=>pe.provideCallsFrom(Y,ee,oe),void 0)}$releaseCallHierarchy(j,Y){this._withAdapter(j,Le,ee=>Promise.resolve(ee.releaseSession(Y)),void 0)}static _serializeRegExp(j){return{pattern:j.source,flags:(0,D.regExpFlags)(j)}}static _serializeIndentationRule(j){return{decreaseIndentPattern:Me._serializeRegExp(j.decreaseIndentPattern),increaseIndentPattern:Me._serializeRegExp(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Me._serializeRegExp(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Me._serializeRegExp(j.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(j){return{beforeText:Me._serializeRegExp(j.beforeText),afterText:j.afterText?Me._serializeRegExp(j.afterText):void 0,previousLineText:j.previousLineText?Me._serializeRegExp(j.previousLineText):void 0,action:j.action}}static _serializeOnEnterRules(j){return j.map(Me._serializeOnEnterRule)}setLanguageConfiguration(j,Y,ee){let{wordPattern:oe}=ee;if(oe&&(0,D.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(Y,oe):this._documents.setWordDefinitionFor(Y,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const pe=this._nextHandle(),_e={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?Me._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?Me._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?Me._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(pe,Y,_e),this._createDisposable(pe)}$setWordDefinitions(j){for(const Y of j)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=Me,Me._handlePool=0}),define(me[234],ge([0,1,5,20,7]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(P,D){this._proxy=P.getProxy(v.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,D){await this._proxy.$changeLanguage(P,D);const I=this._documents.getDocumentData(P);if(!I)throw new Error(`document '${P.toString}' NOT found`);return I.document}async tokenAtPosition(P,D){var I;const i=P.version,A=R.Position.from(D),h=await this._proxy.$tokensAtPosition(P.uri,A),p={type:C.StandardTokenType.Other,range:(I=P.getWordRangeAtPosition(D))!==null&&I!==void 0?I:new C.Range(D.line,D.character,D.line,D.character)};if(!h)return p;const a={range:R.Range.to(h.range),type:R.TokenType.to(h.type)};return!a.range.contains(D)||i!==P.version?p:a}}e.ExtHostLanguages=T}),define(me[235],ge([0,1,5,14,39]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(P){return P&&P.title}let y=class{constructor(D,I){this._logService=I,this._proxy=D.getProxy(v.MainContext.MainThreadMessageService)}showMessage(D,I,i,A,h){const p={extension:D};let a;typeof A=="string"||T(A)?a=[A,...h]:(p.modal=A&&A.modal,p.useCustom=A&&A.useCustom,a=h),p.useCustom&&(0,C.checkProposedApiEnabled)(D);const w=[];for(let m=0;m<a.length;m++){const b=a[m];if(typeof b=="string")w.push({title:b,handle:m,isCloseAffordance:!1});else if(typeof b=="object"){let{title:_,isCloseAffordance:u}=b;w.push({title:_,isCloseAffordance:!!u,handle:m})}else this._logService.warn("Invalid message item:",b)}return this._proxy.$showMessage(I,i,p,w).then(m=>{if(typeof m=="number")return a[m]})}};y=qe([He(1,R.ILogService)],y),e.ExtHostMessageService=y}),define(me[236],ge([0,1,22,3,75,73,6,23,8,12,2,85,5,20,7,64,213,124]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class _{constructor(d,t){const n=_._Keys.nextId();d.$registerNotebookEditorDecorationType(n,p.NotebookDecorationRenderOptions.from(t)),this.value={key:n,dispose(){d.$removeNotebookEditorDecorationType(n)}}}}e.NotebookEditorDecorationType=_,_._Keys=new T.IdGenerator("NotebookEditorDecorationType");class u{constructor(d,t,n,s,r,o){this._textDocumentsAndEditors=n,this._textDocuments=s,this.logService=r,this._extensionStoragePaths=o,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new R.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new R.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new R.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new R.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new A.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=d.getProxy(h.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=d.getProxy(h.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=d.getProxy(h.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:g=>{var f;if(g&&g.$mid===12){const S=(f=g.notebookEditor)===null||f===void 0?void 0:f.notebookUri,E=g.cell.handle,l=this._documents.get(S),L=l==null?void 0:l.getCell(E);if(L)return L.apiCell}return g}})}get activeNotebookEditor(){var d;return(d=this._activeNotebookEditor)===null||d===void 0?void 0:d.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(d=>d.apiEditor)}getEditorById(d){return this._editors.get(d)}getIdByEditor(d){for(const[t,n]of this._editors)if(n.apiEditor===d)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(d,t){const n=this._documents.get(d);if(!n&&!t)throw new Error(`NO notebook document for '${d}'`);return n}_getProviderData(d){const t=this._notebookContentProviders.get(d);if(!t)throw new Error(`NO provider for '${d}'`);return t}registerNotebookContentProvider(d,t,n,s,r){if((0,D.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:d,provider:n});let o;return n.onDidChangeNotebookContentOptions&&(o=n.onDidChangeNotebookContentOptions(()=>{const g=p.NotebookDocumentContentOptions.from(n.options);this._notebookProxy.$updateNotebookProviderOptions(t,g)})),this._notebookProxy.$registerNotebookProvider({id:d.identifier,location:d.extensionLocation},t,p.NotebookDocumentContentOptions.from(s),u._convertNotebookRegistrationData(d,r)),new a.Disposable(()=>{o==null||o.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(d,t){if(!t)return;const n=t.filenamePattern.map(s=>p.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(t.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:d.identifier,providerDisplayName:d.displayName||d.name,displayName:t.displayName,filenamePattern:n,exclusive:t.exclusive||!1}}registerNotebookCellStatusBarItemProvider(d,t,n){const s=u._notebookStatusBarItemProviderHandlePool++,r=typeof n.onDidChangeCellStatusBarItems=="function"?u._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,n),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,r,t);let o;return r!==void 0&&(o=n.onDidChangeCellStatusBarItems(g=>this._notebookProxy.$emitCellStatusBarEvent(r))),new a.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,r),o&&o.dispose()})}createNotebookEditorDecorationType(d){return new _(this._notebookEditorsProxy,d).value}async createNotebookDocument(d){const t=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:d.viewType,content:d.content&&p.NotebookData.from(d.content)});return i.URI.revive(t)}async openNotebookDocument(d){const t=this._documents.get(d);if(t)return t.apiNotebook;const n=await this._notebookDocumentsProxy.$tryOpenNotebook(d),s=this._documents.get(i.URI.revive(n));return(0,I.assertIsDefined)(s==null?void 0:s.apiNotebook)}async showNotebookDocument(d,t){var n;i.URI.isUri(d)&&(d=await this.openNotebookDocument(d));let s;typeof t=="object"?s={position:p.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(p.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:s={preserveFocus:!1};const r=await this._notebookEditorsProxy.$tryShowNotebookDocument(d.uri,d.viewType,s),o=r&&((n=this._editors.get(r))===null||n===void 0?void 0:n.apiEditor);if(o)return o;throw r?new Error(`Could NOT open editor for "${d.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${d.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(d,t,n,s){var r;const o=this._notebookStatusBarItemProviders.get(d),g=i.URI.revive(t),f=this._documents.get(g);if(!f||!o)return;const S=f.getCellFromIndex(n);if(!S)return;const E=await o.provideCellStatusBarItems(S.apiCell,s);if(!E)return;const l=new y.DisposableStore,L=this._statusBarCache.add([l]),O=(r=E&&E.map(W=>p.NotebookStatusBarItem.from(W,this._commandsConverter,l)))!==null&&r!==void 0?r:void 0;return{cacheId:L,items:O}}$releaseNotebookCellStatusBarItems(d){this._statusBarCache.delete(d)}registerNotebookSerializer(d,t,n,s,r){if((0,D.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,n),this._notebookProxy.$registerNotebookSerializer(o,{id:d.identifier,location:d.extensionLocation},t,p.NotebookDocumentContentOptions.from(s),u._convertNotebookRegistrationData(d,r)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(d,t,n){const s=this._notebookSerializer.get(d);if(!s)throw new Error("NO serializer found");const r=await s.deserializeNotebook(t.buffer,n);return p.NotebookData.from(r)}async $notebookToData(d,t,n){const s=this._notebookSerializer.get(d);if(!s)throw new Error("NO serializer found");const r=await s.serializeNotebook(p.NotebookData.to(t),n);return v.VSBuffer.wrap(r)}async $openNotebook(d,t,n,s,r){const{provider:o}=this._getProviderData(d),g=await o.openNotebook(i.URI.revive(t),{backupId:n,untitledDocumentData:s==null?void 0:s.buffer},r);return{metadata:p.NotebookDocumentMetadata.from(g.metadata),cells:g.cells.map(p.NotebookCellData.from)}}async $saveNotebook(d,t,n){const s=this.getNotebookDocument(i.URI.revive(t)),{provider:r}=this._getProviderData(d);return await r.saveNotebook(s.apiNotebook,n),!0}async $saveNotebookAs(d,t,n,s){const r=this.getNotebookDocument(i.URI.revive(t)),{provider:o}=this._getProviderData(d);return await o.saveNotebookAs(i.URI.revive(n),r.apiNotebook,s),!0}async $backupNotebook(d,t,n){var s;const r=this.getNotebookDocument(i.URI.revive(t)),o=this._getProviderData(d),g=(s=this._extensionStoragePaths.workspaceValue(o.extension))!==null&&s!==void 0?s:this._extensionStoragePaths.globalValue(o.extension),f=String((0,C.hash)([r.uri.toString(),this._backupIdPool++])),S=i.URI.joinPath(g,f),E=await o.provider.backupNotebook(r.apiNotebook,{destination:S},n);return r.updateBackup(E),E.id}$acceptModelChanged(d,t,n){this.getNotebookDocument(i.URI.revive(d)).acceptModelChanged(t,n)}$acceptDirtyStateChanged(d,t){const n=this.getNotebookDocument(i.URI.revive(d));n.acceptModelChanged({rawEvents:[],versionId:n.apiNotebook.version},t)}$acceptModelSaved(d){const t=this.getNotebookDocument(i.URI.revive(d));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(d,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",d,t);const n=this._editors.get(d);if(!n)throw new Error(`unknown text editor: ${d}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&n._acceptVisibleRanges(t.visibleRanges.ranges.map(p.NotebookRange.to)),t.selections&&n._acceptSelections(t.selections.selections.map(p.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:n.apiEditor,visibleRanges:n.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:n.apiEditor,selections:n.apiEditor.selections}))}$acceptEditorViewColumns(d){for(const t in d){const n=this._editors.get(t);if(!n)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);n._acceptViewColumn(p.ViewColumn.to(d[t]))}}$acceptDocumentPropertiesChanged(d,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",d.path,t);const n=this.getNotebookDocument(i.URI.revive(d));n.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:n.apiNotebook})}_createExtHostEditor(d,t,n){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const s=new b.ExtHostNotebookEditor(t,this._notebookEditorsProxy,d,n.visibleRanges.map(p.NotebookRange.to),n.selections.map(p.NotebookRange.to),typeof n.viewColumn=="number"?p.ViewColumn.to(n.viewColumn):void 0);this._editors.set(t,s)}$acceptDocumentAndEditorsDelta(d){var t,n,s;if(d.removedDocuments)for(const o of d.removedDocuments){const g=i.URI.revive(o),f=this._documents.get(g);f&&(f.dispose(),this._documents.delete(g),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(S=>S.document.uri)}),this._onDidCloseNotebookDocument.fire(f.apiNotebook));for(const S of this._editors.values())S.notebookData.uri.toString()===g.toString()&&this._editors.delete(S.id)}if(d.addedDocuments){const o=[];for(const g of d.addedDocuments){const f=i.URI.revive(g.uri),S=g.viewType;if(this._documents.has(f))throw new Error(`adding EXISTING notebook ${f} `);const E=this,l=new m.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(L){E._onDidChangeNotebookCells.fire(L)},emitCellOutputsChange(L){E._onDidChangeCellOutputs.fire(L)},emitCellMetadataChange(L){E._onDidChangeCellMetadata.fire(L)},emitCellExecutionStateChange(L){E._onDidChangeCellExecutionState.fire(L)}},S,g.metadata?p.NotebookDocumentMetadata.to(g.metadata):new a.NotebookDocumentMetadata,f);l.acceptModelChanged({versionId:g.versionId,rawEvents:[{kind:w.NotebookCellsChangeType.Initialize,changes:[[0,0,g.cells]]}]},!1),o.push(...g.cells.map(L=>m.ExtHostCell.asModelAddData(l.apiNotebook,L))),(t=this._documents.get(f))===null||t===void 0||t.dispose(),this._documents.set(f,l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:o}),this._onDidOpenNotebookDocument.fire(l.apiNotebook)}}if(d.addedEditors)for(const o of d.addedEditors){if(this._editors.has(o.id))return;const g=i.URI.revive(o.documentUri),f=this._documents.get(g);f&&this._createExtHostEditor(f,o.id,o)}const r=[];if(d.removedEditors)for(const o of d.removedEditors){const g=this._editors.get(o);g&&(this._editors.delete(o),((n=this._activeNotebookEditor)===null||n===void 0?void 0:n.id)===g.id&&(this._activeNotebookEditor=void 0),r.push(g))}if(d.visibleEditors){this._visibleNotebookEditors=d.visibleEditors.map(g=>this._editors.get(g)).filter(g=>!!g);const o=new Set;this._visibleNotebookEditors.forEach(g=>o.add(g.id));for(const g of this._editors.values()){const f=o.has(g.id);g._acceptVisibility(f)}this._visibleNotebookEditors=[...this._editors.values()].map(g=>g).filter(g=>g.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}d.newActiveEditor===null?this._activeNotebookEditor=void 0:d.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(d.newActiveEditor)),d.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor)}}e.ExtHostNotebookController=u,u._notebookStatusBarItemProviderHandlePool=0}),define(me[237],ge([0,1,3,6,5,26,2,20,87,23,13,64,21,16,14]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(c,d,t,n){this._mainContext=c,this._initData=d,this._extHostNotebook=t,this._logService=n,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=c.getProxy(C.MainContext.MainThreadNotebookKernels)}createNotebookController(c,d,t,n,s,r){for(let k of this._kernelData.values())if(k.controller.id===d&&T.ExtensionIdentifier.equals(c.identifier,k.extensionId))throw new Error(`notebook controller with id '${d}' ALREADY exist`);const o=this._handlePool++,g=this;this._logService.trace(`NotebookController[${o}], CREATED by ${c.identifier.value}, ${d}`);const f=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${c.identifier}'`);let S=!1;const E=new R.DisposableStore,l=new v.Emitter,L=new v.Emitter,O={id:`${c.identifier.value}/${d}`,viewType:t,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:n||c.identifier.value,preloads:r?r.map(P.NotebookKernelPreload.from):[]};let W=s!=null?s:f,te;this._proxy.$addKernel(o,O).catch(k=>{console.log(k),S=!0});let se=0;const N=()=>{if(S)return;const k=++se;Promise.resolve().then(()=>{k===se&&this._proxy.$updateKernel(o,O)})},V=new I.ResourceMap,x={get id(){return d},get viewType(){return O.viewType},onDidChangeNotebookAssociation:l.event,get label(){return O.label},set label(k){var U;O.label=(U=k!=null?k:c.displayName)!==null&&U!==void 0?U:c.name,N()},get detail(){var k;return(k=O.detail)!==null&&k!==void 0?k:""},set detail(k){O.detail=k,N()},get description(){var k;return(k=O.description)!==null&&k!==void 0?k:""},set description(k){O.description=k,N()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(k){O.supportedLanguages=k,N()},get hasExecutionOrder(){var k;return(k=O.hasExecutionOrder)!==null&&k!==void 0?k:!1},set hasExecutionOrder(k){O.hasExecutionOrder=k,N()},get preloads(){return O.preloads?O.preloads.map(P.NotebookKernelPreload.to):[]},get executeHandler(){return W},set executeHandler(k){W=k!=null?k:f},get interruptHandler(){return te},set interruptHandler(k){te=k,O.supportsInterrupt=Boolean(k),N()},createNotebookCellExecutionTask(k){if(S)throw new Error("notebook controller is DISPOSED");if(!V.has(k.notebook.uri))throw g._logService.trace(`NotebookController[${o}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(U=>U.toString())),new Error(`notebook controller is NOT associated to notebook: ${k.notebook.uri.toString()}`);return g._createNotebookCellExecution(k)},dispose:()=>{S||(this._logService.trace(`NotebookController[${o}], DISPOSED`),S=!0,this._kernelData.delete(o),E.dispose(),l.dispose(),L.dispose(),this._proxy.$removeKernel(o))},onDidReceiveMessage:L.event,postMessage(k,U){return g._proxy.$postMessage(o,U&&g._extHostNotebook.getIdByEditor(U),k)},asWebviewUri(k){return(0,D.asWebviewUri)(k,g._initData.remote)},updateNotebookAffinity(k,U){g._proxy.$updateNotebookPriority(o,k.uri,U)}};return this._kernelData.set(o,{extensionId:c.identifier,controller:x,onDidReceiveMessage:L,onDidChangeSelection:l,associatedNotebooks:V}),x}$acceptNotebookAssociation(c,d,t){const n=this._kernelData.get(c);if(n){const s=this._extHostNotebook.getNotebookDocument(y.URI.revive(d));t?n.associatedNotebooks.set(s.uri,!0):n.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${c}] ASSOCIATE notebook`,s.uri.toString(),t),n.onDidChangeSelection.fire({selected:t,notebook:s.apiNotebook})}}async $executeCells(c,d,t){const n=this._kernelData.get(c);if(!n)return;const s=this._extHostNotebook.getNotebookDocument(y.URI.revive(d)),r=[];for(let o of t){const g=s.getCell(o);g&&r.push(g.apiCell)}try{this._logService.trace(`NotebookController[${c}] EXECUTE cells`,s.uri.toString(),r.length),await n.controller.executeHandler.call(n.controller,r,s.apiNotebook,n.controller)}catch(o){this._logService.error(`NotebookController[${c}] execute cells FAILED`,o),console.error(o)}}async $cancelCells(c,d,t){var n;const s=this._kernelData.get(c);if(!s)return;const r=this._extHostNotebook.getNotebookDocument(y.URI.revive(d));s.controller.interruptHandler&&await s.controller.interruptHandler.call(s.controller,r.apiNotebook);for(let o of t){const g=r.getCell(o);g&&((n=this._activeExecutions.get(g.uri))===null||n===void 0||n.cancel())}}$acceptKernelMessageFromRenderer(c,d,t){const n=this._kernelData.get(c);if(!n)return;const s=this._extHostNotebook.getEditorById(d);if(!s)throw new Error(`send message for UNKNOWN editor: ${d}`);n.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:t}))}_createNotebookCellExecution(c){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this._extHostNotebook.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!t)throw new Error("invalid cell");if(this._activeExecutions.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const n=new b(t.notebook,t,this._mainContext.getProxy(C.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(t.uri,n);const s=n.onDidChangeState(()=>{n.state===m.Resolved&&(n.dispose(),s.dispose(),this._activeExecutions.delete(t.uri))});return n.asApiObject()}};w=qe([He(3,a.ILogService)],w),e.ExtHostNotebookKernels=w;var m;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(m||(m={}));class b extends R.Disposable{constructor(c,d,t){super();this._document=c,this._cell=d,this._proxy=t,this._onDidChangeState=new v.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=m.Init,this._tokenSource=this._register(new h.CancellationTokenSource),this._collector=new _(10,n=>this.applyEdits(n)),this._executionOrder=d.internalMetadata.executionOrder,this.mixinMetadata({runState:A.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(c){await this._collector.addItem(c)}async applyEdits(c){return this._proxy.$applyEdits(this._document.uri,c,!1)}verifyStateForOutput(){if(this._state===m.Init)throw new Error("Must call start before modifying cell output");if(this._state===m.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(c){const d={editType:9,handle:this._cell.handle,internalMetadata:c};this.applyEdits([d])}cellIndexToHandle(c){if(typeof c!="number")return this._cell.handle;const d=this._document.getCellFromIndex(c);if(!d)throw new Error("INVALID cell index");return d.handle}asApiObject(){const c=this;return Object.freeze({get document(){return c._document.apiNotebook},get cell(){return c._cell.apiCell},get executionOrder(){return c._executionOrder},set executionOrder(d){c._executionOrder=d,c.mixinMetadata({executionOrder:d})},start(d){var t;if(c._state===m.Resolved||c._state===m.Started)throw new Error("Cannot call start again");c._state=m.Started,c._onDidChangeState.fire(),c.mixinMetadata({runState:A.NotebookCellExecutionState.Executing,runStartTime:(t=d==null?void 0:d.startTime)!==null&&t!==void 0?t:null})},end(d){var t,n;if(c._state===m.Resolved)throw new Error("Cannot call resolve twice");c._state=m.Resolved,c._onDidChangeState.fire(),c.mixinMetadata({runState:null,lastRunSuccess:(t=d==null?void 0:d.success)!==null&&t!==void 0?t:null,runEndTime:(n=d==null?void 0:d.endTime)!==null&&n!==void 0?n:null})},clearOutput(d){return c.verifyStateForOutput(),this.replaceOutput([],d)},async appendOutput(d,t){c.verifyStateForOutput();const n=c.cellIndexToHandle(t);return d=(0,p.asArray)(d),c.applyEditSoon({editType:2,handle:n,append:!0,outputs:d.map(P.NotebookCellOutput.from)})},async replaceOutput(d,t){c.verifyStateForOutput();const n=c.cellIndexToHandle(t);return d=(0,p.asArray)(d),c.applyEditSoon({editType:2,handle:n,outputs:d.map(P.NotebookCellOutput.from)})},async appendOutputItems(d,t){return c.verifyStateForOutput(),d=(0,p.asArray)(d),c.applyEditSoon({editType:7,append:!0,items:d.map(P.NotebookCellOutputItem.from),outputId:t})},async replaceOutputItems(d,t){return c.verifyStateForOutput(),d=(0,p.asArray)(d),c.applyEditSoon({editType:7,items:d.map(P.NotebookCellOutputItem.from),outputId:t})},token:c._tokenSource.token})}}class _{constructor(c,d){this.delay=c,this.callback=d,this.batch=[]}addItem(c){return this.batch.push(c),this.waitPromise||(this.waitPromise=(0,i.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const d=this.batch;return this.batch=[],this.callback(d)})),this.waitPromise}}}),define(me[238],ge([0,1,3,5,124]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(P,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,D,I){var i;const A=this._extHostNotebook.getEditorById(P);!A||(i=this._rendererMessageEmitters.get(D))===null||i===void 0||i.fire({editor:A.apiEditor,message:I})}createRendererMessaging(P){return{onDidReceiveMessage:(...I)=>this.getOrCreateEmitterFor(P).event(...I),postMessage:(I,i)=>{const A=C.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);if(!A)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(A.id,P,i)}}}getOrCreateEmitterFor(P){let D=this._rendererMessageEmitters.get(P);return D||(D=new v.Emitter({onLastListenerRemove:()=>{D==null||D.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,D),D)}}e.ExtHostNotebookRenderers=T}),define(me[66],ge([0,1,5,3,6,22,4,15]),function(K,e,v,R,C,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends C.Disposable{constructor(a,w,m,b){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=b,this._id=b.$register(this.name,w,m),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?T.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(w=>this._proxy.$clear(w,a))}show(a,w){this.validate(),this._id.then(m=>this._proxy.$reveal(m,!!(typeof a=="boolean"?a:w)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class I extends D{constructor(a,w){super(a,!1,void 0,w)}append(a){super.append(a),this._id.then(w=>this._proxy.$append(w,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=I;class i extends D{constructor(a,w,m){super(a,!0,w,m)}append(a){throw new Error("Not supported")}}class A{constructor(a,w){this.name=a,this._channel=w}append(a){this._channel.then(w=>w.append(a))}appendLine(a){this._channel.then(w=>w.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,w){this._channel.then(m=>m.show(a,w))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=A;let h=class{constructor(a){this._proxy=a.getProxy(v.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new I(a,this._proxy)}createOutputChannelFromLogFile(a,w){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!w)throw new Error("illegal argument `file`. must not be falsy");return new i(a,w,this._proxy)}};h=qe([He(0,P.IExtHostRpcService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(me[239],ge([0,1,13,21,3,6,5,2,7,17,16,57]),function(K,e,v,R,C,T,y,P,D,I,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(p,a,w){const m=p.getProxy(y.MainContext.MainThreadQuickOpen);class b{constructor(r,o){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=o}showQuickPick(r,o,g,f=R.CancellationToken.None){this._onDidSelectItem=void 0;const S=Promise.resolve(r),E=++this._instances,l=m.$show(E,{title:g==null?void 0:g.title,placeHolder:g==null?void 0:g.placeHolder,matchOnDescription:g==null?void 0:g.matchOnDescription,matchOnDetail:g==null?void 0:g.matchOnDetail,ignoreFocusLost:g==null?void 0:g.ignoreFocusOut,canPickMany:g==null?void 0:g.canPickMany},f),L={},O=l.then(()=>L);return Promise.race([O,S]).then(W=>{if(W!==L)return S.then(te=>{const se=[];for(let N=0;N<te.length;N++){const V=te[N];let x,k,U,F,M;typeof V=="string"?x=V:(x=V.label,k=V.description,U=V.detail,F=V.picked,M=V.alwaysShow),se.push({label:x,description:k,handle:N,detail:U,picked:F,alwaysShow:M})}return g&&typeof g.onDidSelectItem=="function"&&(this._onDidSelectItem=N=>{g.onDidSelectItem(te[N])}),m.$setItems(E,se),l.then(N=>{if(typeof N=="number")return te[N];if(Array.isArray(N))return N.map(V=>te[V])})})}).then(void 0,W=>{if(!(0,I.isPromiseCanceledError)(W))return m.$setError(E,W),Promise.reject(W)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,o=R.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,m.$input(r,typeof this._validateInput=="function",o).then(void 0,g=>{if(!(0,I.isPromiseCanceledError)(g))return Promise.reject(g)})}$validateInput(r){return this._validateInput?(0,v.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,o=R.CancellationToken.None){const g=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!g)return;const f=await this._workspace.getWorkspaceFolders2();if(!!f)return f.find(S=>S.uri.toString()===g.uri.toString())}createQuickPick(r,o){const g=new t(r,o,()=>this._sessions.delete(g._id));return this._sessions.set(g._id,g),g}createInputBox(r){const o=new n(r,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(r,o){const g=this._sessions.get(r);g&&g._fireDidChangeValue(o)}$onDidAccept(r){const o=this._sessions.get(r);o&&o._fireDidAccept()}$onDidChangeActive(r,o){const g=this._sessions.get(r);g instanceof t&&g._fireDidChangeActive(o)}$onDidChangeSelection(r,o){const g=this._sessions.get(r);g instanceof t&&g._fireDidChangeSelection(o)}$onDidTriggerButton(r,o){const g=this._sessions.get(r);g&&g._fireDidTriggerButton(o)}$onDidHide(r){const o=this._sessions.get(r);o&&o._fireDidHide()}}class _{constructor(r,o){this._extensionId=r,this._onDidDispose=o,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((o,g)=>{const f=o===D.QuickInputButtons.Back?-1:g;this._handlesToButtons.set(f,o)}),this.update({buttons:r.map((o,g)=>({iconPath:u(o.iconPath),tooltip:o.tooltip,handle:o===D.QuickInputButtons.Back?-1:g}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const o=this._handlesToButtons.get(r);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),m.$dispose(this._id))}update(r){if(!this._disposed){for(const o of Object.keys(r)){const g=r[o];this._pendingUpdate[o]=g===void 0?null:g}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){m.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}_._nextId=1;function u(s){if(s instanceof D.ThemeIcon)return{id:s.id};const r=d(s),o=c(s);return{dark:typeof r=="string"?P.URI.file(r):r,light:typeof o=="string"?P.URI.file(o):o}}function c(s){return typeof s=="object"&&"light"in s?s.light:s}function d(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends _{constructor(r,o,g){super(r,g);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((o,g)=>{this._handlesToItems.set(g,o),this._itemsToHandles.set(o,g)}),this.update({items:r.map((o,g)=>({label:o.label,description:o.description,handle:g,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(r){const o=(0,i.coalesce)(r.map(g=>this._handlesToItems.get(g)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(r){const o=(0,i.coalesce)(r.map(g=>this._handlesToItems.get(g)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class n extends _{constructor(r,o){super(r,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?A.default.Error:A.default.Ignore})}}return new b(a,w)}e.createExtHostQuickOpen=h}),define(me[240],ge([0,1,2,3,53,6,13,5,16,97,14,26,39]),function(K,e,v,R,C,T,y,P,D,I,i,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function p(r){if(r)return typeof r.iconPath=="string"?v.URI.file(r.iconPath):r.iconPath}function a(r,o){if(!r.iconPath&&!o.iconPath)return 0;if(r.iconPath){if(!o.iconPath)return 1}else return-1;const g=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,f=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath;return(0,I.comparePaths)(g,f)}function w(r,o){let g=0;if(r.strikeThrough!==o.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==o.faded)return r.faded?1:-1;if(r.tooltip!==o.tooltip)return(r.tooltip||"").localeCompare(o.tooltip||"");if(g=a(r,o),g!==0)return g;if(r.light&&o.light)g=a(r.light,o.light);else{if(r.light)return 1;if(o.light)return-1}if(g!==0)return g;if(r.dark&&o.dark)g=a(r.dark,o.dark);else{if(r.dark)return 1;if(o.dark)return-1}return g}function m(r,o){if(r.command!==o.command)return r.command<o.command?-1:1;if(r.title!==o.title)return r.title<o.title?-1:1;if(r.tooltip!==o.tooltip){if(r.tooltip!==void 0&&o.tooltip!==void 0)return r.tooltip<o.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(r.arguments===o.arguments)return 0;if(r.arguments)if(o.arguments){if(r.arguments.length!==o.arguments.length)return r.arguments.length-o.arguments.length}else return 1;else return-1;for(let g=0;g<r.arguments.length;g++){const f=r.arguments[g],S=o.arguments[g];if(f!==S)return f<S?-1:1}return 0}function b(r,o){let g=(0,I.comparePaths)(r.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(g!==0)return g;if(r.command&&o.command)g=m(r.command,o.command);else{if(r.command)return 1;if(o.command)return-1}if(g!==0)return g;if(r.decorations&&o.decorations)g=w(r.decorations,o.decorations);else{if(r.decorations)return 1;if(o.decorations)return-1}return g}function _(r,o){for(let g=0;g<r.length;g++)if(r[g]!==o[g])return!1;return!0}function u(r,o){return r.command===o.command&&r.title===o.title&&r.tooltip===o.tooltip&&(r.arguments&&o.arguments?_(r.arguments,o.arguments):r.arguments===o.arguments)}function c(r,o){return(0,D.equals)(r,o,u)}class d{constructor(o,g,f){this._extension=o,this._proxy=g,this._sourceControlHandle=f,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return(0,h.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(o){if((0,h.checkProposedApiEnabled)(this._extension),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}focus(){(0,h.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(o,g){(0,h.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,o,g)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=d;class t{constructor(o,g,f,S,E){this._proxy=o,this._commands=g,this._sourceControlHandle=f,this._id=S,this._label=E,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,g){const f=this._resourceStatesCommandsMap.get(o);return f?(0,y.asPromise)(()=>this._commands.executeCommand(f.command,...f.arguments||[],g)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var o;const g=[...this._resourceStates].sort(b),S=(0,D.sortedDiff)(this._resourceSnapshot,g,b).map(L=>{const O=L.toInsert.map(W=>{const te=this._resourceHandlePool++;this._resourceStatesMap.set(te,W);const se=W.resourceUri,N=p(W.decorations),V=W.decorations&&p(W.decorations.light)||N,x=W.decorations&&p(W.decorations.dark)||N,k=[];let U;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"){const ae=new T.DisposableStore;U=this._commands.converter.toInternal(W.command,ae),this._resourceStatesDisposablesMap.set(te,ae)}else this._resourceStatesCommandsMap.set(te,W.command);V&&k.push(V),x&&x.toString()!==(V==null?void 0:V.toString())&&k.push(x);const F=W.decorations&&W.decorations.tooltip||"",M=W.decorations&&!!W.decorations.strikeThrough,$=W.decorations&&!!W.decorations.faded,H=W.contextValue||"";return{rawResource:[te,se,k,F,M,$,H,U],handle:te}});return{start:L.start,deleteCount:L.deleteCount,toInsert:O}}),E=S.map(({start:L,deleteCount:O,toInsert:W})=>[L,O,W.map(te=>te.rawResource)]),l=S.reverse();for(const{start:L,deleteCount:O,toInsert:W}of l){const te=W.map(N=>N.handle),se=this._handlesSnapshot.splice(L,O,...te);for(const N of se)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),(o=this._resourceStatesDisposablesMap.get(N))===null||o===void 0||o.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=g,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(o,g,f,S,E,l){this._proxy=g,this._commands=f,this._id=S,this._label=E,this._rootUri=l,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new d(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,S,E,l)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=o;const g=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:g})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&c(this._statusBarCommands,o))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=o;const g=(o||[]).map(f=>this._commands.converter.toInternal(f,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:g})}get selected(){return this._selected}createResourceGroup(o,g){const f=new t(this._proxy,this._commands,this.handle,o,g),S=R.Event.once(f.onDidDispose)(()=>this.createdResourceGroups.delete(f));return this.createdResourceGroups.set(f,S),this.eventuallyAddResourceGroups(),f}eventuallyAddResourceGroups(){const o=[],g=[];for(const[f,S]of this.createdResourceGroups){S.dispose();const E=f.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(f),this.eventuallyUpdateResourceStates()});R.Event.once(f.onDidDispose)(()=>{this.updatedResourceGroups.delete(f),E.dispose(),this._groups.delete(f.handle),this._proxy.$unregisterGroup(this.handle,f.handle)}),o.push([f.handle,f.id,f.label,f.features]);const l=f._takeResourceStateSnapshot();l.length>0&&g.push([f.handle,l]),this._groups.set(f.handle,f)}this._proxy.$registerGroups(this.handle,o,g),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(g=>{const f=g._takeResourceStateSnapshot();f.length!==0&&o.push([g.handle,f])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,qe([(0,C.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),qe([(0,C.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let s=class Un{constructor(o,g,f){this._commands=g,this.logService=f,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=o.getProxy(P.MainContext.MainThreadSCM),this._telemetry=o.getProxy(P.MainContext.MainThreadTelemetry),g.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===3){const E=this._sourceControls.get(S.sourceControlHandle);if(!E)return S;const l=E.getResourceGroup(S.groupHandle);return l?l.getResourceState(S.handle):S}else if(S&&S.$mid===4){const E=this._sourceControls.get(S.sourceControlHandle);return E?E.getResourceGroup(S.groupHandle):S}else if(S&&S.$mid===5){const E=this._sourceControls.get(S.handle);return E||S}return S}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,g,f,S){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,g,f,S),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const E=Un._handlePool++,l=new n(o,this._proxy,this._commands,g,f,S);this._sourceControls.set(E,l);const L=this._sourceControlsByExtension.get(A.ExtensionIdentifier.toKey(o.identifier))||[];return L.push(l),this._sourceControlsByExtension.set(A.ExtensionIdentifier.toKey(o.identifier),L),l}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const g=this._sourceControlsByExtension.get(A.ExtensionIdentifier.toKey(o.identifier)),f=g&&g[g.length-1];return f&&f.inputBox}$provideOriginalResource(o,g,f){const S=v.URI.revive(g);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,S.toString());const E=this._sourceControls.get(o);return!E||!E.quickDiffProvider||!E.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>E.quickDiffProvider.provideOriginalResource(S,f)).then(l=>l||null)}$onInputBoxValueChange(o,g){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const f=this._sourceControls.get(o);return f&&f.inputBox.$onInputBoxValueChange(g),Promise.resolve(void 0)}$executeResourceCommand(o,g,f,S){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,g,f);const E=this._sourceControls.get(o);if(!E)return Promise.resolve(void 0);const l=E.getResourceGroup(g);return l?l.$executeResourceCommand(f,S):Promise.resolve(void 0)}$validateInput(o,g,f){this.logService.trace("ExtHostSCM#$validateInput",o);const S=this._sourceControls.get(o);return!S||!S.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>S.inputBox.validateInput(g,f)).then(E=>E?Promise.resolve([E.message,E.type]):Promise.resolve(void 0))}$setSelectedSourceControl(o){var g,f;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&((g=this._sourceControls.get(o))===null||g===void 0||g.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((f=this._sourceControls.get(this._selectedSourceControlHandle))===null||f===void 0||f.setSelectionState(!1)),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};s._handlePool=0,s=qe([He(2,i.ILogService)],s),e.ExtHostSCM=s});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)};define(me[241],ge([0,1,7,5,163,6]),function(K,e,v,R,C,T){"use strict";var y,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(h,p,a,w,m=v.StatusBarAlignment.Left,b){y.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,nt(this,y,h,"f"),nt(this,P,p,"f"),this._entryId=D.ID_GEN++,this._extension=a,this._id=w,this._alignment=m,this._priority=b}get id(){var h;return(h=this._id)!==null&&h!==void 0?h:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var h;return(h=this._command)===null||h===void 0?void 0:h.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!D.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){var p;((p=this._command)===null||p===void 0?void 0:p.fromApi)!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:$e(this,P,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:$e(this,P,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,$e(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var h;this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let a;this._name?a=this._name:a=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let w=this._color;this._backgroundColor&&(w=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),$e(this,y,"f").$setEntry(this._entryId,p,a,this._text,this._tooltip,(h=this._command)===null||h===void 0?void 0:h.internal,w,this._backgroundColor,this._alignment===v.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,y=new WeakMap,P=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new v.ThemeColor("statusBarItem.errorForeground")]]);class I{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const p={message:h};return this._messages.unshift(p),this._update(),new v.Disposable(()=>{const a=this._messages.indexOf(p);a>=0&&(this._messages.splice(a,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(h,p){this._proxy=h.getProxy(R.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new I(this)}createStatusBarEntry(h,p,a,w){return new D(this._proxy,this._commands,h,p,a,w)}setStatusBarMessage(h,p){const a=this._statusMessage.setMessage(h);let w;return typeof p=="number"?w=setTimeout(()=>a.dispose(),p):typeof p!="undefined"&&p.then(()=>a.dispose(),()=>a.dispose()),new v.Disposable(()=>{a.dispose(),clearTimeout(w)})}}e.ExtHostStatusBar=i}),define(me[90],ge([0,1,5,3,4]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(P){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(v.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,D){this._proxy.$registerExtensionStorageKeysToSync(P,D)}getValue(P,D,I){return this._proxy.$getValue(P,D).then(i=>i||I)}setValue(P,D,I){return this._proxy.$setValue(P,D,I)}$acceptValue(P,D,I){this._onDidChangeStorage.fire({shared:P,key:D,value:I})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(me[91],ge([0,1,4,27,14,89,2]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,v.createDecorator)("IExtensionStoragePaths");let P=class{constructor(I,i,A){var h;this._logService=i,this._extHostFileSystem=A,this._workspace=(h=I.workspace)!==null&&h!==void 0?h:void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(p=>this._value=p)}async _getOrCreateWorkspaceStoragePath(){var I;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,A=y.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(A),this._logService.trace("[ExtHostStorage] storage dir already exists",A),A}catch(h){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",A),await this._extHostFileSystem.value.createDirectory(A),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(I=y.URI.revive(this._workspace.configuration))===null||I===void 0?void 0:I.toString(),name:this._workspace.name},void 0,2))),A}catch(h){this._logService.error("[ExtHostStorage]",h);return}}workspaceValue(I){if(this._value)return y.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return y.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}};P=qe([He(0,R.IExtHostInitDataService),He(1,C.ILogService),He(2,T.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(me[33],ge([0,1,3,5,4,2,15,6,7,164,17,207,21,32,191]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class w{constructor(t,n,s,r){this._proxy=t,this._id=n,this._creationOptions=s,this._name=r,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(g=>this._pidPromiseComplete=g);const o=this;this.value={get name(){return o._name||""},get processId(){return o._pidPromise},get creationOptions(){return o._creationOptions},get exitStatus(){return o._exitStatus},sendText(g,f=!0){o._checkDisposed(),o._proxy.$sendText(o._id,g,f)},show(g){o._checkDisposed(),o._proxy.$show(o._id,g)},hide(){o._checkDisposed(),o._proxy.$hide(o._id)},dispose(){o._disposed||(o._disposed=!0,o._proxy.$dispose(o._id))},get dimensions(){if(!(o._cols===void 0||o._rows===void 0))return{columns:o._cols,rows:o._rows}}}}async create(t,n,s,r,o,g,f,S,E,l,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:s,env:r,icon:o,initialText:g,waitOnExit:f,strictEnv:S,hideFromUser:E,isFeatureTerminal:l,isExtensionOwnedTerminal:L})}async createExtensionTerminal(t){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:t}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=w;class m{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new v.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new v.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new v.Emitter,this._onProcessTitleChanged=new v.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new v.Emitter,this._onProcessShellTypeChanged=new v.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=m;let b=1,_=class extends P.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new v.Emitter,this._onDidOpenTerminal=new v.Emitter,this._onDidChangeActiveTerminal=new v.Emitter,this._onDidChangeTerminalDimensions=new v.Emitter,this._proxy=n.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new v.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[s,r]of this._terminalProcesses)r.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(t){const n=t?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.path)||""}getDefaultShellArgs(t){const n=t?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.args)||[""]}createExtensionTerminal(t){const n=new w(this._proxy,(0,p.generateUuid)(),t,t.name),s=new m(t.pty);return n.createExtensionTerminal(t.iconPath).then(r=>{const o=this._setupExtHostProcessListeners(r,s);this._terminalProcessDisposables[r]=o}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const r=new m(n),o=this._setupExtHostProcessListeners(t,r);this._terminalProcessDisposables[t]=o}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(t);s&&(this._activeTerminal=s,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const s=this._getTerminalById(t);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:n})}async $acceptTerminalDimensions(t,n,s){const r=this._getTerminalById(t);r&&r.setDimensions(n,s)&&this._onDidChangeTerminalDimensions.fire({terminal:r.value,dimensions:r.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,s){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}async $acceptTerminalTitleChange(t,n){const s=this._getTerminalById(t);s&&(s.name=n)}async $acceptTerminalClosed(t,n){const s=this._getTerminalObjectIndexById(this._terminals,t);if(s!==null){const r=this._terminals.splice(s,1)[0];r.setExitCode(n),this._onDidCloseTerminal.fire(r.value)}}$acceptTerminalOpened(t,n,s,r){if(n){const f=this._getTerminalObjectIndexById(this._terminals,n);if(f!==null){this._terminals[f]._id=t,this._onDidOpenTerminal.fire(this.terminals[f]),this._terminals[f].isOpen=!0;return}}const o={name:r.name,shellPath:r.executable,shellArgs:r.args,cwd:typeof r.cwd=="string"?r.cwd:T.URI.revive(r.cwd),env:r.env,hideFromUser:r.hideFromUser},g=new w(this._proxy,t,o,s);this._terminals.push(g),this._onDidOpenTerminal.fire(g.value),g.isOpen=!0}async $acceptTerminalProcessId(t,n){const s=this._getTerminalById(t);s&&s._setProcessId(n)}async $startExtensionTerminal(t,n){const s=this._getTerminalById(t);if(!s)return{message:(0,I.localize)(0,null,t)};s.isOpen||await new Promise(o=>{const g=this.onDidOpenTerminal(async f=>{f===s.value&&(g.dispose(),o())})});const r=this._terminalProcesses.get(t);r?r.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const s=new P.DisposableStore;s.add(n.onProcessReady(o=>this._proxy.$sendProcessReady(t,o.pid,o.cwd))),s.add(n.onProcessTitleChanged(o=>this._proxy.$sendProcessTitle(t,o))),this._bufferer.startBuffering(t,n.onProcessData),s.add(n.onProcessExit(o=>this._onProcessExit(t,o))),n.onProcessOverrideDimensions&&s.add(n.onProcessOverrideDimensions(o=>this._proxy.$sendOverrideDimensions(t,o))),this._terminalProcesses.set(t,n);const r=this._extensionTerminalAwaitingStart[t];return r&&n instanceof m&&(n.startSendingEvents(r.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),s}$acceptProcessAckDataEvent(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.input(n)}$acceptProcessResize(t,n,s){var r;try{(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}catch(o){if(o.code!=="EPIPE"&&o.code!=="ERR_IPC_CHANNEL_CLOSED")throw o}}$acceptProcessShutdown(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(t,s))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(s=>this._proxy.$sendProcessCwd(t,s))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const s=this._getTerminalById(t);if(!s)return[];this._terminalLinkCache.delete(t);const r=this._terminalLinkCancellationSource.get(t);r&&r.dispose(!0);const o=new h.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,o);const g=[],f={terminal:s.value,line:n},S=[];for(const L of this._linkProviders)S.push(new Promise(async O=>{o.token.onCancellationRequested(()=>O({provider:L,links:[]}));const W=await L.provideTerminalLinks(f,o.token)||[];o.token.isCancellationRequested||O({provider:L,links:W})}));const E=await Promise.all(S);if(o.token.isCancellationRequested)return[];const l=new Map;for(const L of E)L&&L.links.length>0&&g.push(...L.links.map(O=>{const W={id:b++,startIndex:O.startIndex,length:O.length,label:O.tooltip};return l.set(W.id,{provider:L.provider,link:O}),W}));return this._terminalLinkCache.set(t,l),g}$activateLink(t,n){var s;const r=(s=this._terminalLinkCache.get(t))===null||s===void 0?void 0:s.get(n);!r||r.provider.handleTerminalLink(r.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const s=this._terminalProcessDisposables[t];s&&(s.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const s=this._getTerminalObjectIndexById(t,n);return s!==null?t[s]:null}_getTerminalObjectIndexById(t,n){let s=null;return t.some((r,o)=>r._id===n?(s=o,!0):!1),s}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new u,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const s=(0,A.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const s=n[0],r=new u(n[1]);this._setEnvironmentVariableCollection(s,r)})}$acceptDefaultProfile(t,n){this._defaultProfile=t,this._defaultAutomationProfile=n}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};_=qe([He(1,y.IExtHostRpcService)],_),e.BaseExtHostTerminalService=_;class u{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new v.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const s=this.map.get(t);(!s||s.value!==n.value||s.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((s,r)=>t.call(n,r,s,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=u;let c=class extends _{constructor(t){super(!1,t)}createTerminal(t,n,s){throw new i.NotSupportedError}createTerminalFromOptions(t){throw new i.NotSupportedError}};c=qe([He(0,y.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c}),define(me[242],ge([0,1,3,16,5,125,20,7]),function(K,e,v,R,C,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(i,A){this._extHostDocumentsAndEditors=A,this._onDidChangeTextEditorSelection=new v.Emitter,this._onDidChangeTextEditorOptions=new v.Emitter,this._onDidChangeTextEditorVisibleRanges=new v.Emitter,this._onDidChangeTextEditorViewColumn=new v.Emitter,this._onDidChangeActiveTextEditor=new v.Emitter,this._onDidChangeVisibleTextEditors=new v.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(h=>this._onDidChangeVisibleTextEditors.fire(h)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(h=>this._onDidChangeActiveTextEditor.fire(h))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const A=this._extHostDocumentsAndEditors.allEditors();return i?A:A.map(h=>h.value)}async showTextDocument(i,A,h){let p;typeof A=="number"?p={position:y.ViewColumn.from(A),preserveFocus:h}:typeof A=="object"?p={position:y.ViewColumn.from(A.viewColumn),preserveFocus:A.preserveFocus,selection:typeof A.selection=="object"?y.Range.from(A.selection):void 0,pinned:typeof A.preview=="boolean"?!A.preview:void 0}:p={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(i.uri,p),w=a&&this._extHostDocumentsAndEditors.getEditor(a);if(w)return w.value;throw a?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new T.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,A){const h=this._extHostDocumentsAndEditors.getEditor(i);if(!h)throw new Error("unknown text editor");if(A.options&&h._acceptOptions(A.options),A.selections){const p=A.selections.selections.map(y.Selection.to);h._acceptSelections(p)}if(A.visibleRanges){const p=R.coalesce(A.visibleRanges.map(y.Range.to));h._acceptVisibleRanges(p)}if(A.options&&this._onDidChangeTextEditorOptions.fire({textEditor:h.value,options:Object.assign(Object.assign({},A.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(A.options.lineNumbers)})}),A.selections){const p=P.TextEditorSelectionChangeKind.fromValue(A.selections.source),a=A.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:h.value,selections:a,kind:p})}if(A.visibleRanges){const p=R.coalesce(A.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:h.value,visibleRanges:p})}}$acceptEditorPositionData(i){for(const A in i){const h=this._extHostDocumentsAndEditors.getEditor(A);if(!h)throw new Error("Unknown text editor");const p=y.ViewColumn.to(i[A]);h.value.viewColumn!==p&&(h._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:h.value,viewColumn:p}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=D});var Qt=this&&this.__rest||function(K,e){var v={};for(var R in K)Object.prototype.hasOwnProperty.call(K,R)&&e.indexOf(R)<0&&(v[R]=K[R]);if(K!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(K);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(K,R[C])&&(v[R[C]]=K[R[C]]);return v};define(me[243],ge([0,1,2,4,5,6,7]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class P{constructor(i,A){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(C.MainContext.MainThreadTimeline),A.registerArgumentProcessor({processArgument:h=>{var p,a;if(h&&h.$mid===11){const w=h.uri===void 0?void 0:v.URI.revive(h.uri);return(a=(p=this._itemsBySourceAndUriMap.get(h.source))===null||p===void 0?void 0:p.get(D(w)))===null||a===void 0?void 0:a.get(h.handle)}return h}})}async $getTimeline(i,A,h,p,a){const w=this._providers.get(i);return w==null?void 0:w.provideTimeline(v.URI.revive(A),h,p,a)}registerTimelineProvider(i,A,h,p){const a=new T.DisposableStore,w=this.convertTimelineItem(A.id,p,a).bind(this);let m;A.onDidChange&&(m=A.onDidChange(_=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},_),{id:A.id})),this));const b=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},A),{scheme:i,onDidChange:void 0,async provideTimeline(_,u,c,d){var t;(d==null?void 0:d.resetCache)&&(a.clear(),(t=b.get(A.id))===null||t===void 0||t.clear());const n=await A.provideTimeline(_,u,c);if(n==null)return;const s=w(_,d);return Object.assign(Object.assign({},n),{source:A.id,items:n.items.map(s)})},dispose(){var _;for(const u of b.values())(_=u.get(A.id))===null||_===void 0||_.clear();m==null||m.dispose(),a.dispose()}}))}convertTimelineItem(i,A,h){return(p,a)=>{let w;if(a==null?void 0:a.cacheResults){let m=this._itemsBySourceAndUriMap.get(i);m===void 0&&(m=new Map,this._itemsBySourceAndUriMap.set(i,m));const b=D(p);w=m.get(b),w===void 0&&(w=new Map,m.set(b,w))}return m=>{var b,_;const{iconPath:u}=m,c=Qt(m,["iconPath"]),d=`${i}|${(b=m.id)!==null&&b!==void 0?b:m.timestamp}`;w==null||w.set(d,m);let t,n,s;return m.iconPath&&(u instanceof y.ThemeIcon?s={id:u.id}:v.URI.isUri(u)?(t=u,n=u):{light:t,dark:n}=u),Object.assign(Object.assign({},c),{id:(_=c.id)!==null&&_!==void 0?_:void 0,handle:d,source:i,command:m.command?A.toInternal(m.command,h):void 0,icon:t,iconDark:n,themeIcon:s,accessibilityInformation:m.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,T.toDisposable)(()=>{var h;for(const p of this._itemsBySourceAndUriMap.values())(h=p.get(i.id))===null||h===void 0||h.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=P;function D(I){return I==null?void 0:I.toString()}}),define(me[244],ge([0,1,6,10,2,5]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(D){this._openers=new Map,this._proxy=D.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,I,i,A){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const h=A.schemes.find(p=>!y.supportedSchemes.has(p));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,i),this._proxy.$registerUriOpener(I,A.schemes,D,A.label),(0,v.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(D,I,i){const A=this._openers.get(D);if(!A)throw new Error(`Unknown opener with id: ${D}`);const h=C.URI.revive(I);return A.canOpenExternalUri(h,i)}async $openUri(D,I,i){const A=this._openers.get(D);if(!A)throw new Error(`Unknown opener id: '${D}'`);return A.openExternalUri(C.URI.revive(I.resolvedUri),{sourceUri:C.URI.revive(I.sourceUri)},i)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(me[245],ge([0,1,5,2,6,17,26]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(v.MainContext.MainThreadUrls)}registerUriHandler(I,i){if(this.handles.has(y.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const A=P.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(I)),this.handlers.set(A,i),this._proxy.$registerUriHandler(A,I),(0,C.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(I)),this.handlers.delete(A),this._proxy.$unregisterUriHandler(A)})}$handleExternalUri(I,i){const A=this.handlers.get(I);if(!A)return Promise.resolve(void 0);try{A.handleUri(R.URI.revive(i))}catch(h){(0,T.onUnexpectedError)(h)}return Promise.resolve(void 0)}async createAppUri(I){return R.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=P,P.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)};define(me[67],ge([0,1,3,2,175,199,87,5]),function(K,e,v,R,C,T,y,P){"use strict";var D,I,i,A,h,p,a,w,m,b,_,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class c{constructor(f,S,E,l,L,O,W){D.set(this,void 0),I.set(this,void 0),i.set(this,void 0),A.set(this,void 0),h.set(this,void 0),p.set(this,void 0),a.set(this,""),w.set(this,void 0),m.set(this,!1),b.set(this,!1),_.set(this,!1),this._onMessageEmitter=new v.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new v.Emitter),this._onDidDispose=$e(this,u,"f").event,nt(this,D,f,"f"),nt(this,I,S,"f"),nt(this,w,E,"f"),nt(this,A,l,"f"),nt(this,h,L,"f"),nt(this,p,O,"f"),nt(this,_,d(O),"f"),nt(this,i,W,"f")}dispose(){nt(this,m,!0,"f"),$e(this,u,"f").fire(),$e(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return nt(this,b,!0,"f"),(0,y.asWebviewUri)(f,$e(this,A,"f").remote)}get cspSource(){return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),$e(this,a,"f")}set html(f){this.assertNotDisposed(),$e(this,a,"f")!==f&&(nt(this,a,f,"f"),!$e(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(nt(this,b,!0,"f"),$e(this,i,"f").report("Webview vscode-resource: uris",$e(this,p,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),$e(this,I,"f").$setHtml($e(this,D,"f"),f))}get options(){return this.assertNotDisposed(),$e(this,w,"f")}set options(f){this.assertNotDisposed(),$e(this,I,"f").$setOptions($e(this,D,"f"),s($e(this,p,"f"),$e(this,h,"f"),f)),nt(this,w,f,"f")}async postMessage(f){if($e(this,m,"f"))return!1;const S=(0,T.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:$e(this,_,"f")});return $e(this,I,"f").$postMessage($e(this,D,"f"),S.message,...S.buffers)}assertNotDisposed(){if($e(this,m,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=c,D=new WeakMap,I=new WeakMap,i=new WeakMap,A=new WeakMap,h=new WeakMap,p=new WeakMap,a=new WeakMap,w=new WeakMap,m=new WeakMap,b=new WeakMap,_=new WeakMap,u=new WeakMap;function d(g){try{const f=(0,C.normalizeVersion)((0,C.parseVersion)(g.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch(f){return!1}}e.shouldSerializeBuffersForPostMessage=d;class t{constructor(f,S,E,l,L){this.initData=S,this.workspace=E,this._logService=l,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=f.getProxy(P.MainContext.MainThreadWebviews)}$onMessage(f,S,...E){const l=this.getWebview(f);if(l){const{message:L}=(0,T.deserializeWebviewMessage)(S,E);l._onMessageEmitter.fire(L)}}$onMissingCsp(f,S){this._logService.warn(`${S} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,S,E){const l=new c(f,this._webviewProxy,r(S),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(f,l),l._onDidDispose(()=>{this._webviews.delete(f)}),l}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=t;function n(g){return{id:g.identifier,location:g.extensionLocation}}e.toExtensionData=n;function s(g,f,S){return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,portMapping:S.portMapping,localResourceRoots:S.localResourceRoots||o(g,f)}}e.serializeWebviewOptions=s;function r(g){var f;return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,portMapping:g.portMapping,localResourceRoots:(f=g.localResourceRoots)===null||f===void 0?void 0:f.map(S=>R.URI.from(S))}}e.reviveOptions=r;function o(g,f){return[...((f==null?void 0:f.getWorkspaceFolders())||[]).map(S=>S.uri),g.extensionLocation]}}),define(me[246],ge([0,1,21,75,6,10,25,2,20,67,85,5,7]),function(K,e,v,R,C,T,y,P,D,I,i,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class a{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,s){const r=this.key(t,n.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const o=new p(n,s);return this._documents.set(r,o),o}delete(t,n){const s=this.key(t,n.uri);this._documents.delete(s)}key(t,n){return`${t}@@@${n}`}}var w;(function(d){d[d.Text=0]="Text",d[d.Custom=1]="Custom"})(w||(w={}));class m{constructor(){this._providers=new Map}addTextProvider(t,n,s){return this.add(0,t,n,s)}addCustomProvider(t,n,s){return this.add(1,t,n,s)}get(t){return this._providers.get(t)}add(t,n,s,r){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:s,provider:r}),new h.Disposable(()=>this._providers.delete(n))}}class b{constructor(t,n,s,r,o){this._extHostDocuments=n,this._extensionStoragePaths=s,this._extHostWebview=r,this._extHostWebviewPanels=o,this._editorProviders=new m,this._documents=new a,this._proxy=t.getProxy(A.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,s,r){const o=new C.DisposableStore;return _(s)?(o.add(this._editorProviders.addTextProvider(n,t,s)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(t),n,r.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(t))):(o.add(this._editorProviders.addCustomProvider(n,t,s)),this.supportEditing(s)&&o.add(s.onDidChangeCustomDocument(g=>{const f=this.getCustomDocumentEntry(n,g.document.uri);if(u(g)){const S=f.addEdit(g);this._proxy.$onDidEdit(g.document.uri,n,S,g.label)}else this._proxy.$onContentChange(g.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(t),n,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(t))),h.Disposable.from(o,new h.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,s,r,o){var g;const f=this._editorProviders.get(n);if(!f)throw new Error(`No provider found for '${n}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${n}'`);const S=P.URI.revive(t),E=await f.provider.openCustomDocument(S,{backupId:s,untitledDocumentData:r==null?void 0:r.buffer},o);let l;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(l=(g=this._extensionStoragePaths.workspaceValue(f.extension))!==null&&g!==void 0?g:this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(n,E,l),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(t,n){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const r=P.URI.revive(t),{document:o}=this.getCustomDocumentEntry(n,r);this._documents.delete(n,o),o.dispose()}async $resolveWebviewEditor(t,n,s,r,o,g){const f=this._editorProviders.get(s);if(!f)throw new Error(`No provider found for '${s}'`);const S=D.ViewColumn.to(o),E=this._extHostWebview.createNewWebview(n,r.webviewOptions,f.extension),l=this._extHostWebviewPanels.createNewWebviewPanel(n,s,r.title,S,r.panelOptions,E),L=P.URI.revive(t);switch(f.type){case 1:{const{document:O}=this.getCustomDocumentEntry(s,L);return f.provider.resolveCustomEditor(O,l,g)}case 0:{const O=this._extHostDocuments.getDocument(L);return f.provider.resolveCustomTextEditor(O,l,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,s){this.getCustomDocumentEntry(n,t).disposeEdits(s)}async $onMoveCustomEditor(t,n,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const g=P.URI.revive(n),f=this._extHostDocuments.getDocument(g);await r.provider.moveCustomTextEditor(f,o,v.CancellationToken.None)}async $undo(t,n,s,r){return this.getCustomDocumentEntry(n,t).undo(s,r)}async $redo(t,n,s,r){return this.getCustomDocumentEntry(n,t).redo(s,r)}async $revert(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(r.document,s),r.disposeBackup()}async $onSave(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(r.document,s),r.disposeBackup()}async $onSaveAs(t,n,s,r){const o=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(o.document,P.URI.revive(s),r)}async $backup(t,n,s){const r=this.getCustomDocumentEntry(n,t),g=await this.getCustomEditorProvider(n).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},s);return r.updateBackup(g),g.id}getCustomDocumentEntry(t,n){const s=this._documents.get(t,P.URI.revive(n));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const n=this._editorProviders.get(t),s=n==null?void 0:n.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=b;function _(d){return typeof d.resolveCustomTextEditor=="function"}function u(d){return typeof d.undo=="function"&&typeof d.redo=="function"}function c(d){const t=d.scheme===T.Schemas.file||d.scheme===T.Schemas.untitled?d.fsPath:d.toString();return(0,R.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)};define(me[247],ge([0,1,3,6,2,32,20,67,5,7]),function(K,e,v,R,C,T,y,P,D,I){"use strict";var i,A,h,p,a,w,m,b,_,u,c,d,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends R.Disposable{constructor(g,f,S,E,l,L,O){super();i.set(this,void 0),A.set(this,void 0),h.set(this,void 0),p.set(this,void 0),a.set(this,void 0),w.set(this,void 0),m.set(this,void 0),b.set(this,void 0),_.set(this,!0),u.set(this,!0),c.set(this,!1),d.set(this,this._register(new v.Emitter)),this.onDidDispose=$e(this,d,"f").event,t.set(this,this._register(new v.Emitter)),this.onDidChangeViewState=$e(this,t,"f").event,nt(this,i,g,"f"),nt(this,A,f,"f"),nt(this,h,S,"f"),nt(this,a,L,"f"),nt(this,b,l,"f"),nt(this,w,E,"f"),nt(this,p,O,"f")}dispose(){$e(this,c,"f")||(nt(this,c,!0,"f"),$e(this,d,"f").fire(),$e(this,A,"f").$disposeWebview($e(this,i,"f")),$e(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),$e(this,p,"f")}get viewType(){return this.assertNotDisposed(),$e(this,h,"f")}get title(){return this.assertNotDisposed(),$e(this,w,"f")}set title(g){this.assertNotDisposed(),$e(this,w,"f")!==g&&(nt(this,w,g,"f"),$e(this,A,"f").$setTitle($e(this,i,"f"),g))}get iconPath(){return this.assertNotDisposed(),$e(this,m,"f")}set iconPath(g){this.assertNotDisposed(),$e(this,m,"f")!==g&&(nt(this,m,g,"f"),$e(this,A,"f").$setIconPath($e(this,i,"f"),C.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return $e(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof $e(this,b,"f")=="number"&&$e(this,b,"f")<0))return $e(this,b,"f")}get active(){return this.assertNotDisposed(),$e(this,u,"f")}get visible(){return this.assertNotDisposed(),$e(this,_,"f")}_updateViewState(g){$e(this,c,"f")||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(nt(this,u,g.active,"f"),nt(this,_,g.visible,"f"),nt(this,b,g.viewColumn,"f"),$e(this,t,"f").fire({webviewPanel:this}))}reveal(g,f){this.assertNotDisposed(),$e(this,A,"f").$reveal($e(this,i,"f"),{viewColumn:g?y.ViewColumn.from(g):void 0,preserveFocus:!!f})}assertNotDisposed(){if($e(this,c,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,A=new WeakMap,h=new WeakMap,p=new WeakMap,a=new WeakMap,w=new WeakMap,m=new WeakMap,b=new WeakMap,_=new WeakMap,u=new WeakMap,c=new WeakMap,d=new WeakMap,t=new WeakMap;class s{constructor(g,f,S){this.webviews=f,this.workspace=S,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=g.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(g,f,S,E,l={}){const L=typeof E=="object"?E.viewColumn:E,O={viewColumn:y.ViewColumn.from(L),preserveFocus:typeof E=="object"&&!!E.preserveFocus},W=(0,P.shouldSerializeBuffersForPostMessage)(g),te=s.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(g),te,f,{title:S,panelOptions:r(l),webviewOptions:(0,P.serializeWebviewOptions)(g,this.workspace,l),serializeBuffersForPostMessage:W},O);const se=this.webviews.createNewWebview(te,l,g);return this.createNewWebviewPanel(te,f,S,L,l,se)}$onDidChangeWebviewPanelViewStates(g){const f=Object.keys(g);f.sort((S,E)=>{const l=g[S],L=g[E];return l.active?1:L.active?-1:+l.visible-+L.visible});for(const S of f){const E=this.getWebviewPanel(S);if(!E)continue;const l=g[S];E._updateViewState({active:l.active,visible:l.visible,viewColumn:y.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel(g){const f=this.getWebviewPanel(g);f==null||f.dispose(),this._webviewPanels.delete(g),this.webviews.deleteWebview(g)}registerWebviewPanelSerializer(g,f,S){if(this._serializers.has(f))throw new Error(`Serializer for '${f}' already registered`);return this._serializers.set(f,{serializer:S,extension:g}),this._proxy.$registerSerializer(f,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(g)}),new I.Disposable(()=>{this._serializers.delete(f),this._proxy.$unregisterSerializer(f)})}async $deserializeWebviewPanel(g,f,S,E){const l=this._serializers.get(f);if(!l)throw new Error(`No serializer found for '${f}'`);const{serializer:L,extension:O}=l,W=this.webviews.createNewWebview(g,S.webviewOptions,O),te=this.createNewWebviewPanel(g,f,S.title,E,S.panelOptions,W);await L.deserializeWebviewPanel(te,S.state)}createNewWebviewPanel(g,f,S,E,l,L){const O=new n(g,this._proxy,f,S,E,l,L);return this._webviewPanels.set(g,O),O}getWebviewPanel(g){return this._webviewPanels.get(g)}}e.ExtHostWebviewPanels=s;function r(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)};define(me[248],ge([0,1,3,6,67,5,7]),function(K,e,v,R,C,T,y){"use strict";var P,D,I,i,A,h,p,a,w,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends R.Disposable{constructor(c,d,t,n,s,r){super();P.set(this,void 0),D.set(this,void 0),I.set(this,void 0),i.set(this,void 0),A.set(this,!1),h.set(this,void 0),p.set(this,void 0),a.set(this,void 0),w.set(this,this._register(new v.Emitter)),this.onDidChangeVisibility=$e(this,w,"f").event,m.set(this,this._register(new v.Emitter)),this.onDidDispose=$e(this,m,"f").event,nt(this,I,t,"f"),nt(this,p,n,"f"),nt(this,P,c,"f"),nt(this,D,d,"f"),nt(this,i,s,"f"),nt(this,h,r,"f")}dispose(){$e(this,A,"f")||(nt(this,A,!0,"f"),$e(this,m,"f").fire(),$e(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),$e(this,p,"f")}set title(c){this.assertNotDisposed(),$e(this,p,"f")!==c&&(nt(this,p,c,"f"),$e(this,D,"f").$setWebviewViewTitle($e(this,P,"f"),c))}get description(){return this.assertNotDisposed(),$e(this,a,"f")}set description(c){this.assertNotDisposed(),$e(this,a,"f")!==c&&(nt(this,a,c,"f"),$e(this,D,"f").$setWebviewViewDescription($e(this,P,"f"),c))}get visible(){return $e(this,h,"f")}get webview(){return $e(this,i,"f")}get viewType(){return $e(this,I,"f")}_setVisible(c){c===$e(this,h,"f")||$e(this,A,"f")||(nt(this,h,c,"f"),$e(this,w,"f").fire())}show(c){this.assertNotDisposed(),$e(this,D,"f").$show($e(this,P,"f"),!!c)}assertNotDisposed(){if($e(this,A,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,D=new WeakMap,I=new WeakMap,i=new WeakMap,A=new WeakMap,h=new WeakMap,p=new WeakMap,a=new WeakMap,w=new WeakMap,m=new WeakMap;class _{constructor(c,d){this._extHostWebview=d,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,d,t,n){if(this._viewProviders.has(d))throw new Error(`View provider for '${d}' already registered`);return this._viewProviders.set(d,{provider:t,extension:c}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(c),d,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(d),this._proxy.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(c,d,t,n,s){const r=this._viewProviders.get(d);if(!r)throw new Error(`No view provider found for '${d}'`);const{provider:o,extension:g}=r,f=this._extHostWebview.createNewWebview(c,{},g),S=new b(c,this._proxy,d,t,f,!0);this._webviewViews.set(c,S),await o.resolveWebviewView(S,{state:n},s)}async $onDidChangeWebviewViewVisibility(c,d){this.getWebviewView(c)._setVisible(d)}async $disposeWebviewView(c){const d=this.getWebviewView(c);this._webviewViews.delete(c),d.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const d=this._webviewViews.get(c);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=_}),define(me[128],ge([0,1,3,5,2,10,8,4,15]),function(K,e,v,R,C,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class xn{constructor(A){this._onDidChangeWindowState=new v.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=A.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(h=>this.$onDidChangeWindowFocus(h))}get state(){return this._state}$onDidChangeWindowFocus(A){A!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:A}),this._onDidChangeWindowState.fire(this._state))}openUri(A,h){let p;if(typeof A=="string"){p=A;try{A=C.URI.parse(A)}catch(a){return Promise.reject(`Invalid uri - '${A}'`)}}return(0,y.isFalsyOrWhitespace)(A.scheme)?Promise.reject("Invalid scheme - cannot be empty"):A.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${A.scheme}'`):this._proxy.$openUri(A,p,h)}async asExternalUri(A,h){if((0,y.isFalsyOrWhitespace)(A.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this._proxy.$asExternalUri(A,h);return C.URI.from(p)}};I.InitialState={focused:!0},I=qe([He(0,D.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(me[249],ge([0,1,9,101,32,49,6,5,2,15]),function(K,e,v,R,C,T,y,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends y.Disposable{constructor(h,p){super();const a=h.getProxy(P.MainContext.MainThreadDownloadService);p.registerCommand(!1,"_workbench.downloadResource",async w=>{const m=D.URI.file((0,v.join)((0,R.tmpdir)(),(0,C.generateUuid)()));return await a.$download(w,m),m})}};i=qe([He(0,I.IExtHostRpcService),He(1,T.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(me[250],ge([0,1,2,9,147,28,66,27,15,6,14,112,43]),function(K,e,v,R,C,T,y,P,D,I,i,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class p{constructor(b,_,u){this.name=b,this.file=_,this.appender=u}static async create(b,_){const u=await(0,A.createRotatingLogger)(b,_,30*h.ByteSize.MB,1);return u.clearFormatters(),new p(b,_,u)}append(b){this.appender.critical(b)}flush(){this.appender.flush()}}class a extends y.AbstractExtHostOutputChannel{constructor(b,_,u){super(b,!1,v.URI.file(_.file),u);this._appender=_}append(b){super.append(b),this._appender.append(b),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(b,_){this._appender.flush(),super.show(b,_)}clear(){this._appender.flush(),super.clear()}}let w=class extends y.ExtHostOutputService{constructor(b,_,u){super(b);this.logService=_,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new I.MutableDisposable,this._logsLocation=u.logsLocation}$setVisibleChannel(b){if(b){const _=this._channels.get(b);_&&(this._visibleChannelDisposable.value=_.onDidAppend(()=>_.update()))}}createOutputChannel(b){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const _=this._doCreateOutChannel(b);return _.then(u=>u._id.then(c=>this._channels.set(c,u))),new y.LazyOutputChannel(b,_)}async _doCreateOutChannel(b){try{const _=(0,R.join)(this._logsLocation.fsPath,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await T.SymlinkSupport.existsDirectory(_)||await T.Promises.mkdir(_,{recursive:!0});const c=`${this._namePool++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}`,d=v.URI.file((0,R.join)(_,`${c}.log`)),t=await p.create(c,d.fsPath);return new a(b,t,this._proxy)}catch(_){return this.logService.error(_),new y.ExtHostPushOutputChannel(b,this._proxy)}}};w=qe([He(0,D.IExtHostRpcService),He(1,i.ILogService),He(2,P.IExtHostInitDataService)],w),e.ExtHostOutputService2=w}),define(me[251],ge([0,1,12,32,15,33]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends T.BaseExtHostTerminalService{constructor(D){super(!0,D)}createTerminal(D,I,i){const A=new T.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),{name:D,shellPath:I,shellArgs:i},D);return this._terminals.push(A),A.create(I,i),A.value}createTerminalFromOptions(D,I){const i=new T.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),D,D.name);return this._terminals.push(i),i.create((0,v.withNullAsUndefined)(D.shellPath),(0,v.withNullAsUndefined)(D.shellArgs),(0,v.withNullAsUndefined)(D.cwd),(0,v.withNullAsUndefined)(D.env),(0,v.withNullAsUndefined)(D.iconPath),(0,v.withNullAsUndefined)(D.message),void 0,(0,v.withNullAsUndefined)(D.strictEnv),(0,v.withNullAsUndefined)(D.hideFromUser),(0,v.withNullAsUndefined)(I),!0),i.value}};y=qe([He(0,C.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(me[252],ge([0,1,5,15,6,27,2,37,25,28,7,11,48,3,74,14]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class m{constructor(g,f,S){this.remoteAddress=g,this.localAddress=f,this._dispose=S,this._onDispose=new p.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function b(o){const g=o.trim().split(`
`),f=[];return g.forEach(E=>{const l=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(E);l&&l.length>=3&&f.push({pid:parseInt(l[1],10),socket:parseInt(l[2],10)})}),f.reduce((E,l)=>(E[l.socket]=l,E),{})}e.getSockets=b;function _(...o){const g=[].concat(...o.map(c));return[...new Map(g.filter(f=>f.st==="0A").map(f=>{const S=f.local_address.split(":");return{socket:parseInt(f.inode,10),ip:u(S[0]),port:parseInt(S[1],16)}}).map(f=>[f.ip+":"+f.port,f])).values()]}e.loadListeningPorts=_;function u(o){let g="";if(o.length===8)for(let f=o.length-2;f>=0;f-=2)g+=parseInt(o.substr(f,2),16),f!==0&&(g+=".");else for(let f=o.length-4;f>=0;f-=4)g+=parseInt(o.substr(f,4),16).toString(16),f!==0&&(g+=":");return g}e.parseIpAddress=u;function c(o){const g=o.trim().split(`
`),f=g.shift().trim().split(/\s+/).filter(E=>E!=="rx_queue"&&E!=="tm->when");return g.map(E=>E.trim().split(/\s+/).reduce((l,L,O)=>(l[f[O]||O]=L,l),{}))}e.loadConnectionTable=c;function d(o){return!!o.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||o.indexOf("out/vs/server/main.js")!==-1||o.indexOf("_productName=VSCode")!==-1}function t(o){const g=o.trim().split(`
`),f=[];return g.forEach(S=>{const E=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(S);E&&E.length>=4&&f.push({pid:parseInt(E[1],10),ppid:parseInt(E[2]),cmd:E[3]})}),f}e.getRootProcesses=t;async function n(o,g,f){const S=f.reduce((l,L)=>(l[L.pid]=L,l),{}),E=[];return o.forEach(({socket:l,ip:L,port:O})=>{var W;const te=g[l]?g[l].pid:void 0,se=te?(W=S[te])===null||W===void 0?void 0:W.cmd:void 0;te&&se&&!d(se)&&E.push({host:L,port:O,detail:se,pid:te})}),E}e.findPorts=n;function s(o,g,f){const S=new Map,E=t(g);for(const l of o){const L=f.get(l.port);if(L){S.set(l.port,L);continue}const O=E.find(W=>W.cmd.includes(`${l.port}`));if(O){let W=O,te;do te=E.find(se=>se.ppid===W.pid),te&&(W=te);while(te);S.set(l.port,{host:l.ip,port:l.port,pid:W.pid,detail:W.cmd,ppid:W.ppid})}else S.set(l.port,{host:l.ip,port:l.port,ppid:Number.MAX_VALUE})}return S}e.tryFindRootPorts=s;let r=class extends C.Disposable{constructor(g,f,S){super();this.logService=S,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new p.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=g.getProxy(v.MainContext.MainThreadTunnelService),A.isLinux&&f.remote.isRemote&&f.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(g,f){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${g.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const S=await this._proxy.$openTunnel(f,g.displayName);if(S){const E=new m(S.remoteAddress,S.localAddress,()=>this._proxy.$closeTunnel(S.remoteAddress));return this._register(E),E}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(g){return Math.max(g*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(g,f){const S=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(S,{selector:g,provider:f}),this._proxy.$registerPortsAttributesProvider(g,S),new i.Disposable(()=>{this._portAttributesProviders.delete(S),this._proxy.$unregisterPortsAttributesProvider(S)})}async $providePortAttributes(g,f,S,E,l){const L=[];for(const W of g){const te=this._portAttributesProviders.get(W);if(!te)return[];L.push(...await Promise.all(f.map(async se=>te.provider.providePortAttributes(se,S,E,l))))}const O=L.filter(W=>!!W);return O.length>0?O.map(W=>({autoForwardAction:W.autoForwardAction,port:W.port})):[]}async $registerCandidateFinder(g){if(g&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=g;let f=new a.MovingAverage,S;for(;this._candidateFindingEnabled;){const E=new Date().getTime(),l=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${l.map(O=>O.port).join(", ")}`);const L=new Date().getTime()-E;f.update(L),(!S||JSON.stringify(S)!==JSON.stringify(l))&&(S=l,await this._proxy.$onFoundNewCandidates(S)),await new Promise(O=>setTimeout(()=>O(),this.calculateDelay(f.value)))}}async setTunnelExtensionFunctions(g){var f;return g?(g.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(g.candidatePortSource),g.showCandidatePort&&(this._showCandidatePort=g.showCandidatePort,this._proxy.$setCandidateFilter()),g.tunnelFactory&&(this._forwardPortProvider=g.tunnelFactory,this._proxy.$setTunnelProvider((f=g.tunnelFeatures)!==null&&f!==void 0?f:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(g,f){if(this._extensionTunnels.has(g.host)){const S=this._extensionTunnels.get(g.host);S.has(g.port)&&(f&&S.get(g.port).disposeListener.dispose(),await S.get(g.port).tunnel.dispose(),S.delete(g.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(g,f){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const S=this._forwardPortProvider(g,f);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),S!==void 0){const E=await S;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(g.remoteAddress.host)||this._extensionTunnels.set(g.remoteAddress.host,new Map);const l=this._register(E.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(E.remoteAddress))));return this._extensionTunnels.get(g.remoteAddress.host).set(g.remoteAddress.port,{tunnel:E,disposeListener:l}),h.TunnelDto.fromApiTunnel(E)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(S){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(g){const f=await Promise.all(g.map(E=>{var l;return this._showCandidatePort(E.host,E.port,(l=E.detail)!==null&&l!==void 0?l:"")})),S=g.filter((E,l)=>f[l]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${g.map(E=>E.port).join(", ")} to ${S.map(E=>E.port).join(", ")}`),S}async findCandidatePorts(){let g="",f="";try{g=await I.Promises.readFile("/proc/net/tcp","utf8"),f=await I.Promises.readFile("/proc/net/tcp6","utf8")}catch(V){}const S=_(g,f),E=await new Promise(V=>{(0,P.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(x,k,U)=>{V(k)})}),l=b(E),L=await I.readdir("/proc"),O=[];for(let V of L)try{const x=Number(V),k=D.joinPath(y.URI.file("/proc"),V);if((await I.Promises.stat(k.fsPath)).isDirectory()&&!isNaN(x)){const F=await I.Promises.readlink(D.joinPath(k,"cwd").fsPath),M=await I.Promises.readFile(D.joinPath(k,"cmdline").fsPath,"utf8");O.push({pid:x,cwd:F,cmd:M})}}catch(x){}const W=[],te=S.filter(V=>{const x=l[V.socket];return x||W.push(V),x}),se=n(te,l,O);let N;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${W.length}`),W.length>0){const V=await new Promise(x=>{(0,P.exec)("ps -F -A -l | grep root",(k,U,F)=>{x(U)})});this._foundRootPorts=s(W,V,this._foundRootPorts),N=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${N.join(", ")}`)}return se.then(V=>N?V.concat(N):V)}};r=qe([He(0,R.IExtHostRpcService),He(1,T.IExtHostInitDataService),He(2,w.ILogService)],r),e.ExtHostTunnelService=r}),define(me[253],ge([0,1,13,21,17,3,6,99,221,126,22]),function(K,e,v,R,C,T,y,P,D,I,i){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function h(r,o){try{return JSON.stringify(r,o)}catch(g){return"null"}}function p(r,o){return JSON.stringify(r,o)}function a(r){return r?(o,g)=>g&&g.$mid===1?r.transformOutgoing(g):g:null}var w;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const b=()=>{},_=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class c extends y.Disposable{constructor(o,g=null,f=null){super();this[A]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=o,this._logger=g,this._uriTransformer=f,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let S=0,E=I.ProxyIdentifier.count;S<E;S++)this._locals[S]=null,this._proxies[S]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new v.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(S=>this._receiveOneMessage(S))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(o=>{this._pendingRPCReplies[o].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(o){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(o){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(o){this._responsiveState!==o&&(this._responsiveState=o,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(o){return this._uriTransformer?(0,P.transformIncomingURIs)(o,this._uriTransformer):o}getProxy(o){const{nid:g,sid:f}=o;return this._proxies[g]||(this._proxies[g]=this._createProxy(g,f)),this._proxies[g]}_createProxy(o,g){let f={get:(S,E)=>(typeof E=="string"&&!S[E]&&E.charCodeAt(0)===36&&(S[E]=(...l)=>this._remoteCall(o,E,l)),E===u?g:S[E])};return new Proxy(Object.create(null),f)}set(o,g){return this._locals[o.nid]=g,g}assertRegistered(o){for(let g=0,f=o.length;g<f;g++){const S=o[g];if(!this._locals[S.nid])throw new Error(`Missing actor ${S.sid} (isMain: ${S.isMain})`)}}_receiveOneMessage(o){if(this._isDisposed)return;const g=o.byteLength,f=d.read(o,0),S=f.readUInt8(),E=f.readUInt32();switch(S){case 1:case 2:{let{rpcId:l,method:L,args:O}=t.deserializeRequestJSONArgs(f);this._uriTransformer&&(O=(0,P.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(g,E,l,L,O,S===2);break}case 3:case 4:{let{rpcId:l,method:L,args:O}=t.deserializeRequestMixedArgs(f);this._uriTransformer&&(O=(0,P.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(g,E,l,L,O,S===4);break}case 5:{this._logger&&this._logger.logIncoming(g,E,0,"ack"),this._onDidReceiveAcknowledge(E);break}case 6:{this._receiveCancel(g,E);break}case 7:{this._receiveReply(g,E,void 0);break}case 9:{let l=t.deserializeReplyOKJSON(f);this._uriTransformer&&(l=(0,P.transformIncomingURIs)(l,this._uriTransformer)),this._receiveReply(g,E,l);break}case 8:{let l=t.deserializeReplyOKVSBuffer(f);this._receiveReply(g,E,l);break}case 10:{let l=t.deserializeReplyErrError(f);this._uriTransformer&&(l=(0,P.transformIncomingURIs)(l,this._uriTransformer)),this._receiveReplyErr(g,E,l);break}case 11:{this._receiveReplyErr(g,E,void 0);break}default:console.error("received unexpected message"),console.error(o)}}_receiveRequest(o,g,f,S,E,l){this._logger&&this._logger.logIncoming(o,g,1,`receiveRequest ${(0,I.getStringIdentifierForProxy)(f)}.${S}(`,E);const L=String(g);let O,W;if(l){const se=new R.CancellationTokenSource;E.push(se.token),O=this._invokeHandler(f,S,E),W=()=>se.cancel()}else O=this._invokeHandler(f,S,E),W=b;this._cancelInvokedHandlers[L]=W;const te=t.serializeAcknowledged(g);this._logger&&this._logger.logOutgoing(te.byteLength,g,1,"ack"),this._protocol.send(te),O.then(se=>{delete this._cancelInvokedHandlers[L];const N=t.serializeReplyOK(g,se,this._uriReplacer);this._logger&&this._logger.logOutgoing(N.byteLength,g,1,"reply:",se),this._protocol.send(N)},se=>{delete this._cancelInvokedHandlers[L];const N=t.serializeReplyErr(g,se);this._logger&&this._logger.logOutgoing(N.byteLength,g,1,"replyErr:",se),this._protocol.send(N)})}_receiveCancel(o,g){this._logger&&this._logger.logIncoming(o,g,1,"receiveCancel");const f=String(g);this._cancelInvokedHandlers[f]&&this._cancelInvokedHandlers[f]()}_receiveReply(o,g,f){this._logger&&this._logger.logIncoming(o,g,0,"receiveReply:",f);const S=String(g);if(!this._pendingRPCReplies.hasOwnProperty(S))return;const E=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S],E.resolveOk(f)}_receiveReplyErr(o,g,f){this._logger&&this._logger.logIncoming(o,g,0,"receiveReplyErr:",f);const S=String(g);if(!this._pendingRPCReplies.hasOwnProperty(S))return;const E=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S];let l;f&&(f.$isError?(l=new Error,l.name=f.name,l.message=f.message,l.stack=f.stack):l=f),E.resolveErr(l)}_invokeHandler(o,g,f){try{return Promise.resolve(this._doInvokeHandler(o,g,f))}catch(S){return Promise.reject(S)}}_doInvokeHandler(o,g,f){const S=this._locals[o];if(!S)throw new Error("Unknown actor "+(0,I.getStringIdentifierForProxy)(o));let E=S[g];if(typeof E!="function")throw new Error("Unknown method "+g+" on actor "+(0,I.getStringIdentifierForProxy)(o));return E.apply(S,f)}_remoteCall(o,g,f){if(this._isDisposed)return Promise.reject(C.canceled());let S=null;if(f.length>0&&R.CancellationToken.isCancellationToken(f[f.length-1])&&(S=f.pop()),S&&S.isCancellationRequested)return Promise.reject(C.canceled());const E=t.serializeRequestArguments(f,this._uriReplacer),l=++this._lastMessageId,L=String(l),O=new D.LazyPromise;S&&S.onCancellationRequested(()=>{const te=t.serializeCancel(l);this._logger&&this._logger.logOutgoing(te.byteLength,l,0,"cancel"),this._protocol.send(t.serializeCancel(l))}),this._pendingRPCReplies[L]=O,this._onWillSendRequest(l);const W=t.serializeRequest(l,o,g,E,!!S);return this._logger&&this._logger.logOutgoing(W.byteLength,l,0,`request: ${(0,I.getStringIdentifierForProxy)(o)}.${g}(`,f),this._protocol.send(W),O}}e.RPCProtocol=c,A=_,c.UNRESPONSIVE_TIME=3*1e3;class d{constructor(o,g){this._buff=o,this._offset=g}static alloc(o,g,f){let S=new d(i.VSBuffer.alloc(f+1+4),0);return S.writeUInt8(o),S.writeUInt32(g),S}static read(o,g){return new d(o,g)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(o){this._buff.writeUInt8(o,this._offset),this._offset+=1}readUInt8(){const o=this._buff.readUInt8(this._offset);return this._offset+=1,o}writeUInt32(o){this._buff.writeUInt32BE(o,this._offset),this._offset+=4}readUInt32(){const o=this._buff.readUInt32BE(this._offset);return this._offset+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this._buff.writeUInt8(o.byteLength,this._offset),this._offset+=1,this._buff.set(o,this._offset),this._offset+=o.byteLength}readShortString(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const f=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,f}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readLongString(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,f}writeBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readVSBuffer(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const g=this._buff.slice(this._offset,this._offset+o);return this._offset+=o,g}static sizeMixedArray(o,g){let f=0;f+=1;for(let S=0,E=o.length;S<E;S++){const l=o[S],L=g[S];switch(f+=1,L){case 1:f+=this.sizeLongString(l);break;case 2:f+=this.sizeVSBuffer(l);break;case 3:break}}return f}writeMixedArray(o,g){this._buff.writeUInt8(o.length,this._offset),this._offset+=1;for(let f=0,S=o.length;f<S;f++){const E=o[f];switch(g[f]){case 1:this.writeUInt8(1),this.writeLongString(E);break;case 2:this.writeUInt8(2),this.writeVSBuffer(E);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const o=this._buff.readUInt8(this._offset);this._offset+=1;let g=new Array(o);for(let f=0;f<o;f++)switch(this.readUInt8()){case 1:g[f]=this.readLongString();break;case 2:g[f]=this.readVSBuffer();break;case 3:g[f]=void 0;break}return g}}class t{static _arrayContainsBufferOrUndefined(o){for(let g=0,f=o.length;g<f;g++)if(o[g]instanceof i.VSBuffer||typeof o[g]=="undefined")return!0;return!1}static serializeRequestArguments(o,g){if(this._arrayContainsBufferOrUndefined(o)){let f=[],S=[];for(let E=0,l=o.length;E<l;E++){const L=o[E];L instanceof i.VSBuffer?(f[E]=L,S[E]=2):typeof L=="undefined"?(f[E]=i.VSBuffer.alloc(0),S[E]=3):(f[E]=i.VSBuffer.fromString(p(L,g)),S[E]=1)}return{type:"mixed",args:f,argsType:S}}return{type:"simple",args:p(o,g)}}static serializeRequest(o,g,f,S,E){return S.type==="mixed"?this._requestMixedArgs(o,g,f,S.args,S.argsType,E):this._requestJSONArgs(o,g,f,S.args,E)}static _requestJSONArgs(o,g,f,S,E){const l=i.VSBuffer.fromString(f),L=i.VSBuffer.fromString(S);let O=0;O+=d.sizeUInt8(),O+=d.sizeShortString(l),O+=d.sizeLongString(L);let W=d.alloc(E?2:1,o,O);return W.writeUInt8(g),W.writeShortString(l),W.writeLongString(L),W.buffer}static deserializeRequestJSONArgs(o){const g=o.readUInt8(),f=o.readShortString(),S=o.readLongString();return{rpcId:g,method:f,args:JSON.parse(S)}}static _requestMixedArgs(o,g,f,S,E,l){const L=i.VSBuffer.fromString(f);let O=0;O+=d.sizeUInt8(),O+=d.sizeShortString(L),O+=d.sizeMixedArray(S,E);let W=d.alloc(l?4:3,o,O);return W.writeUInt8(g),W.writeShortString(L),W.writeMixedArray(S,E),W.buffer}static deserializeRequestMixedArgs(o){const g=o.readUInt8(),f=o.readShortString(),S=o.readMixedArray(),E=new Array(S.length);for(let l=0,L=S.length;l<L;l++){const O=S[l];typeof O=="string"?E[l]=JSON.parse(O):E[l]=O}return{rpcId:g,method:f,args:E}}static serializeAcknowledged(o){return d.alloc(5,o,0).buffer}static serializeCancel(o){return d.alloc(6,o,0).buffer}static serializeReplyOK(o,g,f){return typeof g=="undefined"?this._serializeReplyOKEmpty(o):g instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(o,g):this._serializeReplyOKJSON(o,h(g,f))}static _serializeReplyOKEmpty(o){return d.alloc(7,o,0).buffer}static _serializeReplyOKVSBuffer(o,g){let f=0;f+=d.sizeVSBuffer(g);let S=d.alloc(8,o,f);return S.writeVSBuffer(g),S.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static _serializeReplyOKJSON(o,g){const f=i.VSBuffer.fromString(g);let S=0;S+=d.sizeLongString(f);let E=d.alloc(9,o,S);return E.writeLongString(f),E.buffer}static deserializeReplyOKJSON(o){const g=o.readLongString();return JSON.parse(g)}static serializeReplyErr(o,g){return g?this._serializeReplyErrEror(o,g):this._serializeReplyErrEmpty(o)}static _serializeReplyErrEror(o,g){const f=i.VSBuffer.fromString(h(C.transformErrorForSerialization(g),null));let S=0;S+=d.sizeLongString(f);let E=d.alloc(10,o,S);return E.writeLongString(f),E.buffer}static deserializeReplyErrError(o){const g=o.readLongString();return JSON.parse(g)}static _serializeReplyErrEmpty(o){return d.alloc(11,o,0).buffer}}var n;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var s;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(s||(s={}))}),define(me[254],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,v.createDecorator)("remoteAgentService")}),define(me[255],ge([0,1,10,9,11,2,4,254]),function(K,e,v,R,C,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class{constructor(i,A){this.localUserHome=i,this.remoteAgentService=A,this.resolveOS=(async()=>{const h=await this.remoteAgentService.getEnvironment();return(h==null?void 0:h.os)||C.OS})(),this.resolveUserHome=(async()=>{const h=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(h==null?void 0:h.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?R.win32:R.posix)}async fileURI(i){let A="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const p=i.indexOf("/",2);p===-1?(A=i.substring(2),i="/"):(A=i.substring(2,p),i=i.substring(p)||"/")}return T.URI.from({scheme:v.Schemas.file,authority:A,path:i,query:"",fragment:""})}};D=qe([He(1,P.IRemoteAgentService)],D),e.AbstractPathService=D}),define(me[68],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class v{constructor(y,P){this.line=y,this.character=P}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,P){return new v(0,0)}with(y){return new v(0,0)}}e.Position=v;class R{constructor(y,P,D,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(y,P),this.end=new v(D,I)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new R(0,0,0,0)}with(y){return new R(0,0,0,0)}}e.Range=R;var C;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[30],ge([0,1,16,31,24,29,8,4,9,17,68]),function(K,e,v,R,C,T,y,P,D,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const A="\u27EA ",h=" characters skipped \u27EB",p=(A.length+h.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var a;(function(k){k[k.file=0]="file",k[k.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var w;(function(k){k[k.File=1]="File",k[k.Text=2]="Text"})(w=e.QueryType||(e.QueryType={}));function m(k){return!!k.preview}e.resultIsMatch=m;function b(k){return!!k.resource}e.isFileMatch=b;function _(k){return!!k.message}e.isProgressMessage=_;var u;(function(k){k[k.Normal=0]="Normal",k[k.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class c{constructor(U){this.resource=U,this.results=[]}}e.FileMatch=c;class d{constructor(U,F,M){this.ranges=F;const $=Array.isArray(F)?F:[F];if(M&&M.matchLines===1&&t($)){U=(0,y.getNLines)(U,M.matchLines);let H="",X=0,ae=0;const we=Math.floor(M.charsPerLine/5),Le=[];for(const Ie of $){const Me=Math.max(Ie.startColumn-we,0),We=Ie.startColumn+M.charsPerLine;if(Me>ae+we+p){const j=A+(Me-ae)+h;H+=j+U.slice(Me,We),X+=Me-(ae+j.length)}else H+=U.slice(ae,We);Le.push(new s(0,Ie.startColumn-X,Ie.endColumn-X)),ae=We}this.preview={text:H,matches:Array.isArray(this.ranges)?Le:Le[0]}}else{const H=Array.isArray(F)?F[0].startLineNumber:F.startLineNumber;this.preview={text:U,matches:(0,v.mapArrayOrNot)(F,X=>new n(X.startLineNumber-H,X.startColumn,X.endLineNumber-H,X.endColumn))}}}}e.TextSearchMatch=d;function t(k){const U=k[0].startLineNumber;for(const F of k)if(F.startLineNumber!==U||F.endLineNumber!==U)return!1;return!0}class n{constructor(U,F,M,$){this.startLineNumber=U,this.startColumn=F,this.endLineNumber=M,this.endColumn=$}}e.SearchRange=n;class s extends n{constructor(U,F,M){super(U,F,U,M)}}e.OneLineRange=s;var r;(function(k){k.Default="default",k.FileNames="fileNames",k.Type="type",k.Modified="modified",k.CountDescending="countDescending",k.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function o(k,U=!0){const F=k&&k.files&&k.files.exclude,M=U&&k&&k.search&&k.search.exclude;if(!F&&!M)return;if(!F||!M)return F||M;let $=Object.create(null);return $=C.mixin($,C.deepClone(F)),$=C.mixin($,C.deepClone(M),!0),$}e.getExcludes=o;function g(k,U){return k.excludePattern&&R.match(k.excludePattern,U)?!1:k.includePattern||k.usingSearchPaths?k.includePattern&&R.match(k.includePattern,U)?!0:k.usingSearchPaths?!!k.folderQueries&&k.folderQueries.some(F=>{const M=F.folder.fsPath;if(T.isEqualOrParent(U,M)){const $=D.relative(M,U);return!F.includePattern||!!R.match(F.includePattern,$)}else return!1}):!1:!0}e.pathIncludedInQuery=g;var f;(function(k){k[k.unknownEncoding=1]="unknownEncoding",k[k.regexParseError=2]="regexParseError",k[k.globParseError=3]="globParseError",k[k.invalidLiteral=4]="invalidLiteral",k[k.rgProcessError=5]="rgProcessError",k[k.other=6]="other",k[k.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class S extends Error{constructor(U,F){super(U);this.code=F}}e.SearchError=S;function E(k){const U=k.message;if((0,I.isPromiseCanceledError)(k))return new S(U,f.canceled);try{const F=JSON.parse(U);return new S(F.message,F.code)}catch(F){return new S(U,f.other)}}e.deserializeSearchError=E;function l(k){const U={message:k.message,code:k.code};return new Error(JSON.stringify(U))}e.serializeSearchError=l;function L(k){return k.type==="error"?!0:k.type==="success"}e.isSerializedSearchComplete=L;function O(k){return k.type==="success"}e.isSerializedSearchSuccess=O;function W(k){return!!k.path}e.isSerializedFileMatch=W;function te(k,U){const F=k.searchPath?k.searchPath:k.relativePath;return(0,y.fuzzyContains)(F,U)}e.isFilePatternMatch=te;class se{constructor(U){this.path=U,this.results=[]}addMatch(U){this.results.push(U)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=se;function N(k,U){const F=Object.assign(Object.assign({},k||{}),U||{});return Object.keys(F).filter(M=>{const $=F[M];return typeof $=="boolean"&&$})}e.resolvePatternsForProvider=N;class V{constructor(U,F){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},U.excludePattern||{}),F.excludePattern||{}),this._parsedExcludeExpression=R.parse(this._excludeExpression);let M=U.includePattern;F.includePattern&&(M?M=Object.assign(Object.assign({},M),F.includePattern):M=F.includePattern),M&&(this._parsedIncludeExpression=R.parse(M))}includedInQuerySync(U,F,M){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(U,F,M)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(U,F,M))}includedInQuery(U,F,M){return Promise.resolve(this._parsedExcludeExpression(U,F,M)).then(H=>!!H).then(H=>H?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(U,F,M)).then(X=>!!X):Promise.resolve(!0)).then(H=>H)}hasSiblingExcludeClauses(){return x(this._excludeExpression)}}e.QueryGlobTester=V;function x(k){for(const U in k)if(typeof k[U]!="boolean")return!0;return!1}}),define(me[34],ge([0,1,16,13,21,3,23,10,74,25,8,12,2,166,4,14,185,61,62,27,15,7,30,5]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w,m,b,_,u,c,d,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(L,O,W){return new I.ExtUri(te=>f(te,W)).isEqual(L,O)}function r(L,O,W){return s(L.uri,O.uri,W)?0:(0,i.compare)(L.uri.toString(),O.uri.toString())}function o(L,O,W){return L.index!==O.index?L.index<O.index?-1:1:s(L.uri,O.uri,W)?(0,i.compare)(L.name,O.name):(0,i.compare)(L.uri.toString(),O.uri.toString())}function g(L,O,W,te){const se=L.slice(0).sort((V,x)=>W(V,x,te)),N=O.slice(0).sort((V,x)=>W(V,x,te));return(0,v.delta)(se,N,(V,x)=>W(V,x,te))}function f(L,O){const W=O.getCapabilities(L.scheme);return!(W&&W&1024)}class S extends b.Workspace{constructor(O,W,te,se,N,V){super(O,te.map(x=>new b.WorkspaceFolder(x)),se,V);this._name=W,this._isUntitled=N,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(V),te.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}static toExtHostWorkspace(O,W,te,se){if(!O)return{workspace:null,added:[],removed:[]};const{id:N,name:V,folders:x,configuration:k,isUntitled:U}=O,F=[],M=W;W?x.forEach((ae,we)=>{const Le=h.URI.revive(ae.uri),Ie=S._findFolder(te||W,Le,se);Ie?(Ie.name=ae.name,Ie.index=ae.index,F.push(Ie)):F.push({uri:Le,name:ae.name,index:we})}):F.push(...x.map(({uri:ae,name:we,index:Le})=>({uri:h.URI.revive(ae),name:we,index:Le}))),F.sort((ae,we)=>ae.index<we.index?-1:1);const $=new S(N,V,F,k?h.URI.revive(k):null,!!U,ae=>f(ae,se)),{added:H,removed:X}=g(M?M.workspaceFolders:[],$.workspaceFolders,r,se);return{workspace:$,added:H,removed:X}}static _findFolder(O,W,te){for(let se=0;se<O.folders.length;se++){const N=O.workspaceFolders[se];if(s(N.uri,W,te))return N}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,W){return W&&this._structure.get(O)&&(O=(0,I.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let E=class{constructor(O,W,te,se){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=se,this._extHostFileSystemInfo=te,this._requestIdProvider=new D.Counter,this._barrier=new R.Barrier,this._proxy=O.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(n.MainContext.MainThreadMessageService);const N=W.workspace;this._confirmedWorkspace=N?new S(N.id,N.name,[],N.configuration?h.URI.revive(N.configuration):null,!!N.isUntitled,V=>f(V,te)):void 0}$initializeWorkspace(O,W){this._trusted=W,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?h.URI.from({scheme:P.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,W,te,...se){const N=[];if(Array.isArray(se)&&se.forEach(F=>{h.URI.isUri(F.uri)&&!N.some(M=>s(M.uri,F.uri,this._extHostFileSystemInfo))&&N.push({uri:F.uri,name:F.name||(0,I.basenameOrAuthority)(F.uri)})}),this._unconfirmedWorkspace||[W,te].some(F=>typeof F!="number"||F<0)||te===0&&N.length===0)return!1;const V=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(W+te>V.length)return!1;const x=V.slice(0);x.splice(W,te,...N.map(F=>({uri:F.uri,name:F.name||(0,I.basenameOrAuthority)(F.uri),index:void 0})));for(let F=0;F<x.length;F++){const M=x[F];if(x.some(($,H)=>H!==F&&s(M.uri,$.uri,this._extHostFileSystemInfo)))return!1}x.forEach((F,M)=>F.index=M);const{added:k,removed:U}=g(V,x,o,this._extHostFileSystemInfo);if(k.length===0&&U.length===0)return!1;if(this._proxy){const F=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(F,W,te,N).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(m.Severity.Error,(0,p.localize)(0,null,F,M.toString()),{extension:O},[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(O,W){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,W)}async getWorkspaceFolder2(O,W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,W)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,W){let te,se="";if(typeof O=="string"?(te=h.URI.file(O),se=O):typeof O!="undefined"&&(te=O,se=O.fsPath),!te)return se;const N=this.getWorkspaceFolder(te,!0);if(!N)return se;typeof W=="undefined"&&this._actualWorkspace&&(W=this._actualWorkspace.folders.length>1);let V=(0,I.relativePath)(N.uri,te);return W&&N.name&&(V=`${N.name}/${V}`),V}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=S.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:W,added:te,removed:se}=S.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=W||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:te,removed:se}))}findFiles(O,W,te,se,N=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${se.value}, entryPoint: findFiles`);let V;if(W===null?V=!1:W&&(typeof W=="string"?V=W:V=W.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:k}=l(O);return this._proxy.$startFileSearch((0,A.withUndefinedAsNull)(x),(0,A.withUndefinedAsNull)(k),(0,A.withUndefinedAsNull)(V),(0,A.withUndefinedAsNull)(te),N).then(U=>Array.isArray(U)?U.map(F=>h.URI.revive(F)):[])}async findTextInFiles(O,W,te,se,N=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${se.value}, entryPoint: findTextInFiles`);const V=this._requestIdProvider.getNext(),x=typeof W.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:k,folder:U}=l(W.include),F=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,M={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:x,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:k,excludePattern:F},$=!1;if(this._activeSearchCallbacks[V]=H=>{if($)return;const X=h.URI.revive(H.resource);H.results.forEach(ae=>{(0,t.resultIsMatch)(ae)?te({uri:X,preview:{text:ae.preview.text,matches:(0,v.mapArrayOrNot)(ae.preview.matches,we=>new d.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,v.mapArrayOrNot)(ae.ranges,we=>new d.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):te({uri:X,text:ae.text,lineNumber:ae.lineNumber})})},N.isCancellationRequested)return{};try{const H=await this._proxy.$startTextSearch(O,(0,A.withUndefinedAsNull)(U),M,V,N);return delete this._activeSearchCallbacks[V],H||{}}catch(H){throw delete this._activeSearchCallbacks[V],H}}$handleTextSearchResult(O,W){this._activeSearchCallbacks[W]&&this._activeSearchCallbacks[W](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};E=qe([He(0,c.IExtHostRpcService),He(1,u.IExtHostInitDataService),He(2,_.IExtHostFileSystemInfo),He(3,w.ILogService)],E),e.ExtHostWorkspace=E,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function l(L){let O,W;return L&&(typeof L=="string"?O=L:(O=L.pattern,W=L.baseFolder||h.URI.file(L.base))),{includePattern:O,folder:W}}}),define(me[35],ge([0,1,24,3,34,5,7,188,83,12,13,4,15,14,2]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(n,s){if(s){const r=s.split(".");let o=n;for(let g=0;o&&g<r.length;g++)o=o[r[g]];return o}}function m(n){return n instanceof a.URI}function b(n){return n&&n.uri instanceof a.URI&&n.languageId&&typeof n.languageId=="string"}function _(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function u(n){return n&&n.uri instanceof a.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function c(n){if(m(n))return{resource:n};if(b(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(_(n))return{overrideIdentifier:n.languageId};if(u(n))return{resource:n.uri};if(n===null)return{resource:null}}let d=class{constructor(s,r,o){this._proxy=s.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=o,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,r){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(s,r))}};d=qe([He(0,h.IExtHostRpcService),He(1,C.IExtHostWorkspace),He(2,p.ILogService)],d),e.ExtHostConfiguration=d;class t{constructor(s,r,o,g){this._onDidChangeConfiguration=new R.Emitter,this._proxy=s,this._logService=g,this._extHostWorkspace=r,this._configuration=P.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,r){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,o))}getConfiguration(s,r,o){const g=c(r)||{},f=this._toReadonlyValue(s?w(this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,g,o==null?void 0:o.identifier);function S(l){if(l==null)return null;if(typeof l=="boolean")return l?1:4;switch(l){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const E={has(l){return typeof w(f,l)!="undefined"},get:(l,L)=>{this._validateConfigurationAccess(s?`${s}.${l}`:l,g,o==null?void 0:o.identifier);let O=w(f,l);if(typeof O=="undefined")O=L;else{let W;const te=(se,N)=>{let V;const x=()=>{W=W||(0,v.deepClone)(f),V=V||w(W,N)};return(0,I.isObject)(se)?new Proxy(se,{get:(k,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return x(),()=>V;if(W)return V=V||w(W,N),V[U];const F=k[U];return typeof U=="string"?te(F,`${N}.${U}`):F},set:(k,U,F)=>(x(),V&&(V[U]=F),!0),deleteProperty:(k,U)=>(x(),V&&delete V[U],!0),defineProperty:(k,U,F)=>(x(),V&&Object.defineProperty(V,U,F),!0)}):se};O=te(O,l)}return O},update:(l,L,O,W)=>{l=s?`${s}.${l}`:l;const te=S(O);return L!==void 0?this._proxy.$updateConfigurationOption(te,l,L,g,W):this._proxy.$removeConfigurationOption(te,l,g,W)},inspect:l=>{var L,O,W,te,se,N,V,x;l=s?`${s}.${l}`:l;const k=(0,v.deepClone)(this._configuration.inspect(l,g,this._extHostWorkspace.workspace));if(k)return{key:l,defaultValue:(L=k.default)===null||L===void 0?void 0:L.value,globalValue:(O=k.user)===null||O===void 0?void 0:O.value,workspaceValue:(W=k.workspace)===null||W===void 0?void 0:W.value,workspaceFolderValue:(te=k.workspaceFolder)===null||te===void 0?void 0:te.value,defaultLanguageValue:(se=k.default)===null||se===void 0?void 0:se.override,globalLanguageValue:(N=k.user)===null||N===void 0?void 0:N.override,workspaceLanguageValue:(V=k.workspace)===null||V===void 0?void 0:V.override,workspaceFolderLanguageValue:(x=k.workspaceFolder)===null||x===void 0?void 0:x.override,languageIds:k.overrideIdentifiers}}};return typeof f=="object"&&(0,v.mixin)(E,f,!1),Object.freeze(E)}_toReadonlyValue(s){const r=o=>(0,I.isObject)(o)?new Proxy(o,{get:(g,f)=>r(g[f]),set:(g,f,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(f)}' of object`)},deleteProperty:(g,f)=>{throw new Error(`TypeError: Cannot delete read only property '${String(f)}' of object`)},defineProperty:(g,f)=>{throw new Error(`TypeError: Cannot define property '${String(f)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return r(s)}_validateConfigurationAccess(s,r,o){const g=D.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),f=o?`[${o.value}] `:"";if(g===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${f}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){(r==null?void 0:r.resource)&&this._logService.warn(`${f}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,r){const o=new P.ConfigurationChangeEvent(s,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(g,f)=>o.affectsConfiguration(g,c(f))})}_toMap(s){return s.reduce((r,o)=>(r.set(o[0],o[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,A.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)};define(me[69],ge([0,1,2,13,3,5,7,34,40,35,21,33,15,27,4,10,11,14,65,206,17]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w,m,b,_,u,c){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(se){function N(x){if(x!=null)return x}se.from=N;function V(x){if(x!=null)return x}se.to=V})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(se){function N(x){if(x!=null)return x}se.from=N;function V(x){if(x!=null)return x}se.to=V})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(se){function N(x){if(x!=null)return x}se.from=N;function V(x){if(x!=null)return x}se.to=V})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(se){function N(k){if(k){const U=k;return U&&!!U.process}else return!1}se.is=N;function V(k){if(k==null)return;const U={process:k.process,args:k.args};return k.options&&(U.options=s.from(k.options)),U}se.from=V;function x(k){if(k!=null)return new y.ProcessExecution(k.process,k.args,k.options)}se.to=x})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(se){function N(x){if(x!=null)return x}se.from=N;function V(x){if(x!=null)return x}se.to=V})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var g;(function(se){function N(k){if(k){const U=k;return U&&(!!U.commandLine||!!U.command)}else return!1}se.is=N;function V(k){if(k==null)return;const U={};return k.commandLine!==void 0?U.commandLine=k.commandLine:(U.command=k.command,U.args=k.args),k.options&&(U.options=o.from(k.options)),U}se.from=V;function x(k){if(!(k==null||k.command===void 0&&k.commandLine===void 0))return k.commandLine?new y.ShellExecution(k.commandLine,k.options):new y.ShellExecution(k.command,k.args?k.args:[],k.options)}se.to=x})(g=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var f;(function(se){function N(k){if(k){let U=k;return U&&U.customExecution==="customExecution"}else return!1}se.is=N;function V(k){return{customExecution:"customExecution"}}se.from=V;function x(k,U){return U.get(k)}se.to=x})(f=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var S;(function(se){function N(V,x){let k;return V.scope!==void 0&&typeof V.scope!="number"?k=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===y.TaskScope.Workspace&&x&&x.workspaceFile?k=x.workspaceFile:k=u.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:k}}se.from=N})(S=e.TaskHandleDTO||(e.TaskHandleDTO={}));var E;(function(se){function N(k,U){if(k==null)return[];const F=[];for(let M of k){const $=V(M,U);$&&F.push($)}return F}se.fromMany=N;function V(k,U){if(k==null)return;let F;k.execution instanceof y.ProcessExecution?F=r.from(k.execution):k.execution instanceof y.ShellExecution?F=g.from(k.execution):k.execution&&k.execution instanceof y.CustomExecution&&(F=f.from(k.execution));const M=t.from(k.definition);let $;if(k.scope?typeof k.scope=="number"?$=k.scope:$=k.scope.uri:$=y.TaskScope.Workspace,!M||!$)return;const H=k.group?k.group.id:void 0;return{_id:k._id,definition:M,name:k.name,source:{extensionId:U.identifier.value,label:k.source,scope:$},execution:F,isBackground:k.isBackground,group:H,presentationOptions:n.from(k.presentationOptions),problemMatchers:k.problemMatchers,hasDefinedMatchers:k.hasDefinedMatchers,runOptions:k.runOptions?k.runOptions:{reevaluateOnRerun:!0},detail:k.detail}}se.from=V;async function x(k,U,F){if(k==null)return;let M;r.is(k.execution)?M=r.to(k.execution):g.is(k.execution)?M=g.to(k.execution):f.is(k.execution)&&(M=f.to(k._id,F));const $=t.to(k.definition);let H;if(k.source&&(k.source.scope!==void 0?typeof k.source.scope=="number"?H=k.source.scope:H=await U.resolveWorkspaceFolder(v.URI.revive(k.source.scope)):H=y.TaskScope.Workspace),!$||!H)return;const X=new y.Task($,H,k.name,k.source.label,M,k.problemMatchers);return k.isBackground!==void 0&&(X.isBackground=k.isBackground),k.group!==void 0&&(X.group=y.TaskGroup.from(k.group)),k.presentationOptions&&(X.presentationOptions=n.to(k.presentationOptions)),k._id&&(X._id=k._id),k.detail&&(X.detail=k.detail),X}se.to=x})(E=e.TaskDTO||(e.TaskDTO={}));var l;(function(se){function N(x){return x}se.from=N;function V(x){if(!!x)return Object.assign(Object.create(null),x)}se.to=V})(l=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(N,V,x){this._id=V,this._task=x,d.set(this,void 0),nt(this,d,N,"f")}get task(){return this._task}terminate(){$e(this,d,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}d=new WeakMap;var O;(function(se){function N(V){return{id:V._id,task:void 0}}se.from=N})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let W=class{constructor(N,V,x,k,U,F,M,$){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=N.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=x,this._editorService=k,this._configurationService=U,this._terminalService=F,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=M,this._deprecationService=$,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,V,x){if(!x)return new y.Disposable(()=>{});const k=this.nextHandle();return this._handlers.set(k,{type:V,provider:x,extension:N}),this._proxy.$registerTaskProvider(k,V),new y.Disposable(()=>{this._handlers.delete(k),this._proxy.$unregisterTaskProvider(k)})}registerTaskSystem(N,V){this._proxy.$registerTaskSystem(N,V)}fetchTasks(N){return this._proxy.$fetchTasks(l.from(N)).then(async V=>{const x=[];for(let k of V){const U=await E.to(k,this._workspaceProvider,this._providedCustomExecutions2);U&&x.push(U)}return x})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(V=>N.push(V)),N}terminateTask(N){if(!(N instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,V,x){const k=this._providedCustomExecutions2.get(N.id);if(k){if(this._activeCustomExecutions2.get(N.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(N.id,k),this._terminalService.attachPtyToTerminal(V,await k.callback(x))}this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const V=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:V,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:N.exitCode})}$provideTasks(N,V){const x=this._handlers.get(N);if(!x)return Promise.reject(new Error("no handler found"));const k=[],U=(0,R.asPromise)(()=>x.provider.provideTasks(i.CancellationToken.None)).then(F=>this.provideTasksInternal(V,k,x,F));return new Promise(F=>{U.then(M=>{Promise.all(k).then(()=>{F(M)})})})}async $resolveTask(N,V){const x=this._handlers.get(N);if(!x)return Promise.reject(new Error("no handler found"));if(V.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${x.type}].`);const k=await E.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!k)throw new Error("Unexpected: Task cannot be resolved.");const U=await x.provider.resolveTask(k,i.CancellationToken.None);if(!U)return;this.checkDeprecation(U,x);const F=E.from(U,x.extension);if(!F)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==k.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(F.execution)&&await this.addCustomExecution(F,U,!0),await this.resolveTaskInternal(F)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,V,x){const k=await this._proxy.$createTaskId(N);!x&&!this._providedCustomExecutions2.has(k)&&this._notProvidedCustomExecutions.add(k),this._providedCustomExecutions2.set(k,V.execution)}async getTaskExecution(N,V){if(typeof N=="string"){const U=this._taskExecutionPromises.get(N);if(!U)throw new Error("Unexpected: The specified task is missing an execution");return U}let x=this._taskExecutionPromises.get(N.id);if(x)return x;const k=new Promise(async(U,F)=>{const M=V||await E.to(N.task,this._workspaceProvider,this._providedCustomExecutions2);M?U(new L(this,N.id,M)):F("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(N.id,k),k.then(U=>(this._taskExecutions.set(N.id,U),U),U=>Promise.reject(U))}checkDeprecation(N,V){N._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let x=this._notProvidedCustomExecutions.values(),k=x.next();for(;!k.done;)!this._activeCustomExecutions2.has(k.value)&&this._lastStartedTask!==k.value&&(this._providedCustomExecutions2.delete(k.value),this._notProvidedCustomExecutions.delete(k.value)),k=x.next()}};W=qe([He(0,h.IExtHostRpcService),He(1,p.IExtHostInitDataService),He(2,P.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,I.IExtHostConfiguration),He(5,A.IExtHostTerminalService),He(6,b.ILogService),He(7,_.IExtHostApiDeprecationService)],W),e.ExtHostTaskBase=W;let te=class extends W{constructor(N,V,x,k,U,F,M,$){super(N,V,x,k,U,F,M,$);this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:m.PlatformToString(0)})}async executeTask(N,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const x=E.from(V,N);if(x===void 0)throw new Error("Task is not valid");if(f.is(x.execution))await this.addCustomExecution(x,V,!1);else throw new c.NotSupportedError;const k=await this.getTaskExecution(await this._proxy.$getTaskExecution(x),V);return this._proxy.$executeTask(x).catch(U=>{throw new Error(U)}),k}provideTasksInternal(N,V,x,k){const U=[];if(k)for(let F of k){this.checkDeprecation(F,x),(!F.definition||!N[F.definition.type])&&this._logService.warn(`The task [${F.source}, ${F.name}] uses an undefined task type. The task will be ignored in the future.`);const M=E.from(F,x.extension);M&&f.is(M.execution)?(U.push(M),V.push(this.addCustomExecution(M,F,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:U,extension:x.extension}}async resolveTaskInternal(N){if(f.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,V,x){}};te=qe([He(0,h.IExtHostRpcService),He(1,p.IExtHostInitDataService),He(2,P.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,I.IExtHostConfiguration),He(5,A.IExtHostTerminalService),He(6,b.ILogService),He(7,_.IExtHostApiDeprecationService)],te),e.WorkerExtHostTask=te,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)},Qt=this&&this.__rest||function(K,e){var v={};for(var R in K)Object.prototype.hasOwnProperty.call(K,R)&&e.indexOf(R)<0&&(v[R]=K[R]);if(K!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(K);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(K,R[C])&&(v[R[C]]=K[R[C]]);return v};define(me[256],ge([0,1,16,13,22,21,3,72,54,6,24,12,2,32,5,40,15,86,20,7,34,216,123]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w,m,b,_,u,c,d,t){"use strict";var n,s,r,o;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const g=(x,k)=>`${x}:${k.toString()}`;let f=class{constructor(k,U,F){this.documents=U,this.workspace=F,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new d.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=k.getProxy(a.MainContext.MainThreadTesting),this.runQueue=new S(this.proxy),this.workspaceObservers=new N(this.proxy),this.textDocumentObservers=new V(this.proxy,U)}registerTestController(k,U){const F=(0,p.generateUuid)();this.controllers.set(F,{instance:U,extensionId:k}),this.proxy.$registerTestController(F);const M=[...this.testControllers.keys()];return setTimeout(()=>{var $;for(const H of M)($=this.testControllers.get(H))===null||$===void 0||$.subscribeFn(F,U)},0),new u.Disposable(()=>{this.controllers.delete(F),this.proxy.$unregisterTestController(F)})}createTextDocumentTestObserver(k){return this.textDocumentObservers.checkout(k.uri)}createWorkspaceTestObserver(k){return this.workspaceObservers.checkout(k.uri)}async runTests(k,U=T.CancellationToken.None){const F=M=>M.map(this.getInternalTestForReference,this).filter(A.isDefined).map($=>({src:$.src,testId:$.item.extId}));await this.proxy.$runTests({exclude:k.exclude?F(k.exclude).map(M=>M.testId):void 0,tests:F(k.tests),debug:k.debug},U)}createTestRun(k,U,F,M=!0){return this.runQueue.createTestRun(k,U,F,M)}$publishTestResults(k){this.results=Object.freeze(k.map(U=>(0,i.deepFreeze)(_.TestResults.to(U))).concat(this.results).sort((U,F)=>F.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(k,U){const F=h.URI.revive(U),M=g(k,F);if(this.testControllers.has(M))return;const $=new T.CancellationTokenSource;let H;if(k===1){let Ie=this.documents.getDocument(F);if(!Ie){const Me=new I.DisposableStore;Ie=await new Promise(We=>{Me.add((0,R.disposableTimeout)(()=>We(void 0),5e3)),Me.add(this.documents.onDidAddDocuments(j=>{const Y=j.find(ee=>ee.document.uri.toString()===F.toString());Y&&We(Y)}))}).finally(()=>Me.dispose())}if(Ie){const Me=await this.workspace.getWorkspaceFolder2(F,!1);H=We=>We.createDocumentTestRoot?We.createDocumentTestRoot(Ie.document,$.token):(0,e.createDefaultDocumentTestRoot)(We,Ie.document,Me,$.token)}}else{const Ie=await this.workspace.getWorkspaceFolder2(F,!1);Ie&&(H=Me=>Me.createWorkspaceTestRoot(Ie,$.token))}if(!H)return;const X=async(Ie,Me)=>{try{const We=await H(Me);We&&we.addRoot(We,Ie)}catch(We){console.error(We)}},ae=new I.DisposableStore,we=ae.add(this.ownedTests.createForHierarchy(Ie=>this.proxy.$publishDiff(k,U,Ie)));ae.add((0,I.toDisposable)(()=>$.dispose(!0)));const Le=[];for(const[Ie,Me]of this.controllers)Le.push(X(Ie,Me.instance));Promise.all(Le).then(()=>we.pushDiff([3,-1])),this.testControllers.set(M,{store:ae,collection:we,subscribeFn:X})}async $expandTest(k,U){const F=(0,v.mapFind)(this.testControllers.values(),M=>M.collection.treeId===k.src.tree?M:void 0);await(F==null?void 0:F.collection.expand(k.testId,U<0?Infinity:U)),this.flushCollectionDiffs()}$unsubscribeFromTests(k,U){var F;const M=h.URI.revive(U),$=g(k,M);(F=this.testControllers.get($))===null||F===void 0||F.store.dispose(),this.testControllers.delete($)}$acceptDiff(k,U,F){k===1?this.textDocumentObservers.acceptDiff(h.URI.revive(U),F):this.workspaceObservers.acceptDiff(h.URI.revive(U),F)}async $runTestsForProvider(k,U){const F=this.controllers.get(k.tests[0].src.controller);if(!F)return;const M=k.tests.map(({testId:X,src:ae})=>this.ownedTests.getTestById(X,ae==null?void 0:ae.tree)).filter(A.isDefined).map(([X,ae])=>ae),$=k.excludeExtIds.map(X=>this.ownedTests.getTestById(X)).filter(A.isDefined).filter(([X,ae])=>M.some(we=>X.comparePositions(we,ae)===1));if(!M.length)return;const H={tests:M.map(X=>O.unwrap(X.actual)),exclude:$.map(([,X])=>O.unwrap(X.actual)),debug:k.debug};await this.runQueue.enqueueRun({dto:E.fromInternal(k),token:U,extensionId:F.extensionId,req:H,doRun:()=>F.instance.runTests(H,U)})}$lookupTest(k){const U=this.ownedTests.getTestById(k.testId);if(!U)return Promise.resolve(void 0);const F=U[1],{actual:M,discoverCts:$,expandLevels:H}=F,X=Qt(F,["actual","discoverCts","expandLevels"]);return Promise.resolve(X)}flushCollectionDiffs(){for(const{collection:k}of this.testControllers.values())k.flushDiff()}getInternalTestForReference(k){var U,F;return(F=(U=this.workspaceObservers.getMirroredTestDataByReference(k))!==null&&U!==void 0?U:(0,v.mapFind)(this.testControllers.values(),M=>M.collection.getTestByReference(k)))!==null&&F!==void 0?F:this.textDocumentObservers.getMirroredTestDataByReference(k)}};f=qe([He(0,m.IExtHostRpcService),He(1,w.IExtHostDocumentsAndEditors),He(2,c.IExtHostWorkspace)],f),e.ExtHostTesting=f;class S{constructor(k){this.proxy=k,this.state=new Map}enqueueRun(k){let U=this.state.get(k.extensionId);U||(U={queue:[],current:void 0},this.state.set(k.extensionId,U));const F=new R.DeferredPromise,M=()=>{const $=[],H=new Set;U.current={publicReq:k.req,factory:X=>{const ae=new l(X,k.dto,H,this.proxy);return $.push(ae),k.token.onCancellationRequested(()=>ae.end()),ae}},this.invokeRunner(k.extensionId,k.dto.id,k.doRun,$).finally(()=>F.complete())};return U.queue.push(M),U.queue.length===1&&M(),F.p}createTestRun(k,U,F,M){var $,H;const X=this.state.get(k);if((X==null?void 0:X.current.publicReq)===U)return X.current.factory(F);const ae=E.fromPublic(U),we=new l(F,ae,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:U.debug,exclude:(H=($=U.exclude)===null||$===void 0?void 0:$.map(Le=>Le.id))!==null&&H!==void 0?H:[],id:ae.id,tests:U.tests.map(Le=>Le.id),persist:M}),we.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(ae.id)),we}invokeRunner(k,U,F,M){try{const $=F();return(0,R.isThenable)($)?$.then(()=>this.handleInvokeResult(k,U,M,void 0)).catch(H=>this.handleInvokeResult(k,U,M,H)):this.handleInvokeResult(k,U,M,void 0)}catch($){return this.handleInvokeResult(k,U,M,$)}}async handleInvokeResult(k,U,F,M){const $=this.state.get(k);!$||($.queue.shift(),$.queue.length>0?$.queue[0]():this.state.delete(k),await Promise.all(F.map(H=>H.onEnd.wait())))}}class E{constructor(k,U,F){this.id=k,this.include=U,this.exclude=F}static fromPublic(k){var U,F;return new E((0,p.generateUuid)(),new Set(k.tests.map(M=>M.id)),new Set((F=(U=k.exclude)===null||U===void 0?void 0:U.map(M=>M.id))!==null&&F!==void 0?F:D.Iterable.empty()))}static fromInternal(k){return new E(k.runId,new Set(k.tests.map(U=>U.testId)),new Set(k.excludeExtIds))}isIncluded(k){for(let U=k;U;U=U.parent){if(this.include.has(U.id))return!0;if(this.exclude.has(U.id))return!1}return!0}}class l{constructor(k,U,F,M){this.name=k,n.set(this,void 0),s.set(this,void 0),r.set(this,(0,p.generateUuid)()),o.set(this,void 0),this.onEnd=new R.Barrier,nt(this,n,M,"f"),nt(this,s,U,"f"),nt(this,o,F,"f"),M.$startedTestRunTask(U.id,{id:$e(this,r,"f"),name:k,running:!0})}setState(k,U,F){$e(this,s,"f").isIncluded(k)&&(this.ensureTestIsKnown(k),$e(this,n,"f").$updateTestStateInRun($e(this,s,"f").id,$e(this,r,"f"),k.id,U,F))}appendMessage(k,U){$e(this,s,"f").isIncluded(k)&&(this.ensureTestIsKnown(k),$e(this,n,"f").$appendTestMessageInRun($e(this,s,"f").id,$e(this,r,"f"),k.id,_.TestMessage.from(U)))}appendOutput(k){$e(this,n,"f").$appendOutputToRun($e(this,s,"f").id,$e(this,r,"f"),C.VSBuffer.fromString(k))}end(){$e(this,n,"f").$finishedTestRunTask($e(this,s,"f").id,$e(this,r,"f")),this.onEnd.open()}ensureTestIsKnown(k){const U=$e(this,o,"f");if(U.has(k.id))return;const F=[];for(;F.unshift(_.TestItem.from(k)),!(U.has(k.id)||(U.add(k.id),!k.parent));)k=k.parent;$e(this,n,"f").$addTestsToRun($e(this,s,"f").id,F)}}n=new WeakMap,s=new WeakMap,r=new WeakMap,o=new WeakMap;const L=async(x,k,U,F)=>{if(!U)return;const M=await x.createWorkspaceTestRoot(U,F);if(!M)return;F.onCancellationRequested(()=>{O.removeFilter(k)});const $=O.getWrapperForTestItem(M,k);return $.refreshMatch(),$};e.createDefaultDocumentTestRoot=L;class O extends u.TestItemImpl{constructor(k,U,F){super(k.id,k.label,k.uri,void 0);if(this.actual=k,this.filterDocument=U,this.actualParent=F,!(k instanceof u.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${k.id} did not`);this.debuggable=k.debuggable,this.runnable=k.runnable,this.description=k.description,this.error=k.error,this.status=k.status,this.range=k.range,this.resolveHandler=k.resolveHandler;const M=(0,b.getPrivateApiFor)(this);(0,b.getPrivateApiFor)(k).bus.event(H=>{switch(H[0]){case 3:this[H[1]]=H[2];break;case 0:const X=O.getWrapperForTestItem(H[1],this.filterDocument,this);(0,b.getPrivateApiFor)(X).parent=k,X.refreshMatch();break;default:M.bus.fire(H)}})}static removeFilter(k){this.wrapperMap.delete(k)}static getWrapperForTestItem(k,U,F){let M=this.wrapperMap.get(U);if(M==null?void 0:M.has(k))return M.get(k);M||(M=new WeakMap,this.wrapperMap.set(U,M));const $=new O(k,U,F);return M.set(k,$),$}static unwrap(k){return k instanceof O?k.actual:k}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var k,U;const F=this._cachedMatchesFilter;for(const $ of this.actual.children.values()){const H=O.getWrapperForTestItem($,this.filterDocument,this);H.hasNodeMatchingFilter?this.children.has(H.id)||this.addChild(H):H.dispose()}const M=this.children.size>0||((k=this.actual.uri)===null||k===void 0?void 0:k.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=M,M!==F&&((U=this.actualParent)===null||U===void 0||U.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,b.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,b.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=O,O.wrapperMap=new WeakMap;class W extends t.IncrementalChangeCollector{constructor(k){super();this.emitter=k,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(k){this.added.add(k)}update(k){Object.assign(k.revived,_.TestItem.toPlain(k.item)),this.added.has(k)||this.updated.add(k)}remove(k){if(this.added.has(k)){this.added.delete(k);return}if(this.updated.delete(k),k.parent&&this.alreadyRemoved.has(k.parent)){this.alreadyRemoved.add(k.item.extId);return}this.removed.add(k)}getChangeEvent(){const{added:k,updated:U,removed:F}=this;return{get added(){return[...k].map(M=>M.revived)},get updated(){return[...U].map(M=>M.revived)},get removed(){return[...F].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class te extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(k){let U=[];for(const F of k){const M=this.items.get(F);M&&U.push(M.revived)}return U}getMirroredTestDataById(k){return this.items.get(k)}getMirroredTestDataByReference(k){return this.items.get(k.id)}createItem(k,U){return Object.assign(Object.assign({},k),{revived:_.TestItem.toPlain(k.item),depth:U?U.depth+1:0,children:new Set})}createChangeCollector(){return new W(this.changeEmitter)}}e.MirroredTestCollection=te;class se{constructor(){this.resources=new Map}checkout(k){var U,F;const M=k.toString(),$=(U=this.resources.get(M))!==null&&U!==void 0?U:this.createObserverData(k);return(F=$.pendingDeletion)===null||F===void 0||F.dispose(),$.observers++,{onDidChangeTest:$.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return $.tests.rootTestItems},dispose:(0,P.once)(()=>{--$.observers||($.pendingDeletion=this.eventuallyDispose(k))})}}getMirroredTestDataByReference(k){for(const{tests:U}of this.resources.values()){const F=U.getMirroredTestDataByReference(k);if(F)return F}}eventuallyDispose(k){return(0,R.disposableTimeout)(()=>this.unlisten(k),10*1e3)}createObserverData(k){const U=new te,F=this.listen(k,$=>U.apply($)),M={observers:0,tests:U,listener:F};return this.resources.set(k.toString(),M),M}unlisten(k){var U;const F=k.toString(),M=this.resources.get(F);M&&(M.observers=-1,(U=M.pendingDeletion)===null||U===void 0||U.dispose(),M.listener.dispose(),this.resources.delete(F))}}class N extends se{constructor(k){super();this.proxy=k,this.diffListeners=new Map}acceptDiff(k,U){var F;(F=this.diffListeners.get(k.toString()))===null||F===void 0||F(U)}listen(k,U){this.proxy.$subscribeToDiffs(0,k);const F=k.toString();return this.diffListeners.set(F,U),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,k),this.diffListeners.delete(F)})}}class V extends se{constructor(k,U){super();this.proxy=k,this.documents=U,this.diffListeners=new Map}acceptDiff(k,U){var F;(F=this.diffListeners.get(k.toString()))===null||F===void 0||F(U)}listen(k,U){if(!this.documents.getDocument(k))return new u.Disposable(()=>{});const M=k.toString();return this.diffListeners.set(M,U),this.proxy.$subscribeToDiffs(1,k),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,k),this.diffListeners.delete(M)})}}}),define(me[257],ge([0,1,16,52,31,77,23,10,9,25,8,12,2,141,171,84,61,209,255,30]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w,m,b,_,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(S,E,l,L){this.configurationService=S,this.workspaceContextService=E,this.editorGroupsService=l,this.pathService=L}text(S,E,l={}){S=this.getContentPattern(S,l);const L=this.configurationService.getValue(),O=E&&E.some(te=>!this.configurationService.getValue({resource:te}).search.useRipgrep),W=this.commonQuery(E==null?void 0:E.map(m.toWorkspaceFolder),l);return Object.assign(Object.assign({},W),{type:2,contentPattern:S,previewOptions:l.previewOptions,maxFileSize:l.maxFileSize,usePCRE2:L.search.usePCRE2||O||!1,beforeContext:l.beforeContext,afterContext:l.afterContext,userDisabledExcludesAndIgnoreFiles:l.disregardExcludeSettings&&l.disregardIgnoreFiles})}getContentPattern(S,E){const l=this.configurationService.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const L=Object.assign(Object.assign({},S),{wordSeparators:l.editor.wordSeparators});return this.isCaseSensitive(S,E)&&(L.isCaseSensitive=!0),this.isMultiline(S)&&(L.isMultiline=!0),L}file(S,E={}){const l=this.commonQuery(S,E);return Object.assign(Object.assign({},l),{type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey})}handleIncludeExclude(S,E){return S?(S=Array.isArray(S)?S.map(r):r(S),E?this.parseSearchPaths(S):{pattern:t(...Array.isArray(S)?S:[S])}):{}}commonQuery(S=[],E={}){const l=this.handleIncludeExclude(E.includePattern,E.expandPatterns),L=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),O=S.length>1,W=(l.searchPaths&&l.searchPaths.length?l.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,E,L)):S.map(N=>this.getFolderQueryForRoot(N,E,L,O))).filter(N=>!!N),te={_reason:E._reason,folderQueries:W,usingSearchPaths:!!(l.searchPaths&&l.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:L.pattern,includePattern:l.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const V=v.coalesce(v.flatten(this.editorGroupsService.groups.map(k=>k.editors.map(U=>U.resource)))).filter(k=>(0,u.pathIncludedInQuery)(te,k.fsPath)),x=this.commonQueryFromFileList(V);return Object.assign(Object.assign({},te),x)}const se=E.extraFileResources&&E.extraFileResources.filter(N=>(0,u.pathIncludedInQuery)(te,N.fsPath));return te.extraFileResources=se&&se.length?se:void 0,te}commonQueryFromFileList(S){const E=[],l=new y.ResourceMap,L={};let O=!1;return S.forEach(W=>{var te,se;if(W.scheme===P.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(W)){const V=(se=(te=this.workspaceContextService.getWorkspaceFolder(W))===null||te===void 0?void 0:te.uri)!==null&&se!==void 0?se:W.with({path:D.dirname(W.fsPath)});let x=l.get(V);x||(O=!0,x={folder:V,includePattern:{}},E.push(x),l.set(V,x));const k=D.relative(V.fsPath,W.fsPath);(0,A.assertIsDefined)(x.includePattern)[k.replace(/\\/g,"/")]=!0}else W.fsPath&&(O=!0,L[W.fsPath]=!0)}),{folderQueries:E,includePattern:L,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(S,E){if(E.isSmartCase){if(S.isRegExp){if(i.containsUppercaseCharacter(S.pattern,!0))return!0}else if(i.containsUppercaseCharacter(S.pattern))return!0}return!!S.isCaseSensitive}isMultiline(S){return S.isMultiline||S.isRegExp&&(0,p.isMultilineRegexSource)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const E=x=>D.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),L=(Array.isArray(S)?S:n(S)).map(x=>{const k=this.pathService.resolvedUserHome;return k?(0,T.untildify)(x,k.scheme===P.Schemas.file?k.fsPath:k.path):x}),O=R.groupBy(L,x=>E(x)?"searchPaths":"exprSegments"),W=(O.exprSegments||[]).map(x=>i.rtrim(x,"/")).map(x=>i.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),s(x))),te={},se=this.expandSearchPathPatterns(O.searchPaths||[]);se&&se.length&&(te.searchPaths=se);const N=v.flatten(W),V=t(...N);return V&&(te.pattern=V),te}getExcludesForFolder(S,E){return E.disregardExcludeSettings?void 0:(0,u.getExcludes)(S,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(S){if(!S||!S.length)return[];const E=v.flatten(S.map(L=>{let{pathPortion:O,globPortion:W}=d(L);W&&(W=o(W));const te=this.expandOneSearchPath(O);return v.flatten(te.map(se=>this.resolveOneSearchPathPattern(se,W)))})),l=new Map;return E.forEach(L=>{const O=L.searchPath.toString(),W=l.get(O);W?L.pattern&&(W.pattern=W.pattern||{},W.pattern[L.pattern]=!0):l.set(O,{searchPath:L.searchPath,pattern:L.pattern?t(L.pattern):void 0})}),Array.from(l.values())}expandOneSearchPath(S){if(D.isAbsolute(S)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==P.Schemas.file?[{searchPath:E[0].uri.with({path:S})}]:[{searchPath:h.URI.file(D.normalize(S))}]}if(this.workspaceContextService.getWorkbenchState()===2){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(S=r(S),S.startsWith("../")||S===".."){const L=D.posix.resolve(E.path,S);return[{searchPath:E.with({path:L})}]}const l=o(S);return[{searchPath:E,pattern:l}]}else{if(S==="./"||S===".\\")return[];{const E=S.replace(/^\.[\/\\]/,""),L=this.workspaceContextService.getWorkspace().folders.map(O=>{const W=E.match(new RegExp(`^${O.name}(?:/(.*))?`));return W?{match:W,folder:O}:null}).filter(A.isDefined);if(L.length)return L.map(O=>{const W=O.match[1];return{searchPath:O.folder.uri,pattern:W&&o(W)}});{const O=S.match(/\.[\/\\](.+)[\/\\]?/),W=O?O[1]:S,te=a.localize(0,null,W);throw new Error(te)}}}}resolveOneSearchPathPattern(S,E){const l=S.pattern&&E?`${S.pattern}/${E}`:S.pattern||E,L=[{searchPath:S.searchPath,pattern:l}];return l&&!l.endsWith("**")&&L.push({searchPath:S.searchPath,pattern:l+"/**"}),L}getFolderQueryForSearchPath(S,E,l){const L=this.getFolderQueryForRoot((0,m.toWorkspaceFolder)(S.searchPath),E,l,!1);return L?Object.assign(Object.assign({},L),{includePattern:S.pattern}):null}getFolderQueryForRoot(S,E,l,L){let O;const W=h.URI.isUri(S)?S:S.uri;if(l.searchPaths){const x=l.searchPaths.filter(k=>(0,I.isEqual)(k.searchPath,W))[0];if(x&&!x.pattern)return null;x&&(O=x.pattern)}const te=this.configurationService.getValue({resource:W}),se=this.getExcludesForFolder(te,E),N=Object.assign(Object.assign({},se||{}),O||{}),V=h.URI.isUri(S)?(0,I.basename)(S):S.name;return{folder:W,folderName:L?V:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:te.files&&te.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!te.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!te.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!te.search.followSymlinks}}};c=qe([He(0,w.IConfigurationService),He(1,m.IWorkspaceContextService),He(2,b.IEditorGroupsService),He(3,_.IPathService)],c),e.QueryBuilder=c;function d(f){const S=f.match(/[\*\{\}\(\)\[\]\?]/);if(S){const E=S.index,l=f.substr(0,E).match(/[/|\\][^/\\]*$/);if(l){let L=f.substr(0,l.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:f.substr((l.index||0)+1)}}}return{pathPortion:f}}function t(...f){return f.length?f.reduce((S,E)=>(S[E]=!0,S),Object.create(null)):void 0}function n(f){return C.splitGlobAware(f,",").map(S=>S.trim()).filter(S=>!!S.length)}function s(f){return[`**/${f}/**`,`**/${f}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function r(f){return f.replace(/\\/g,"/")}function o(f){return r(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(f,S){f=v.distinct(f,L=>L.toString());const E=[],l=S.getWorkspace();return f&&f.forEach(L=>{let O;if(S.getWorkbenchState()===2)O=(0,I.relativePath)(l.folders[0].uri,L),O&&O!=="."&&(O="./"+O);else{const W=S.getWorkspaceFolder(L);if(W){const te=W.name;if(l.folders.filter(N=>N.name===te).length===1){const N=(0,I.relativePath)(W.uri,L);N===""?O=`./${W.name}`:O=`./${W.name}/${N}`}else O=L.fsPath}}O&&E.push(O)}),E}e.resolveResourcesForSearchIncludes=g}),define(me[258],ge([0,1,25,2,21,17,4,257,30,61]),function(K,e,v,R,C,T,y,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function A(w,m){const b=m.activationEvents;if(!b)return Promise.resolve(void 0);const _=[],u=[];for(const r of b)if(/^workspaceContains:/.test(r)){const o=r.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||w.forceUsingSearch?u.push(o):_.push(o)}if(_.length===0&&u.length===0)return Promise.resolve(void 0);let c;const d=new Promise((r,o)=>{c=r}),t=r=>c({activationEvent:r}),n=Promise.all(_.map(r=>h(w,r,t))).then(()=>{}),s=p(w,m.identifier,u,t);return Promise.all([n,s]).then(()=>{c(void 0)}),d}e.checkActivateWorkspaceContainsExtension=A;async function h(w,m,b){for(const _ of w.folders)if(await w.exists(v.joinPath(R.URI.revive(_),m))){b(`workspaceContains:${m}`);return}}async function p(w,m,b,_){if(b.length===0)return Promise.resolve(void 0);const u=new C.CancellationTokenSource,c=w.checkExists(w.folders,b,u.token),d=setTimeout(async()=>{u.cancel(),_(`workspaceContainsTimeout:${b.join(",")}`)},i);let t=!1;try{t=await c}catch(n){T.isPromiseCanceledError(n)||T.onUnexpectedError(n)}u.dispose(),clearTimeout(d),t&&_(`workspaceContains:${b.join(",")}`)}function a(w,m,b,_){const u=w.get(y.IInstantiationService),c=w.get(D.ISearchService),t=u.createInstance(P.QueryBuilder).file(m.map(n=>(0,I.toWorkspaceFolder)(R.URI.revive(n))),{_reason:"checkExists",includePattern:b,exists:!0});return c.fileSearch(t,_).then(n=>!!n.limitHit,n=>T.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=a});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)};define(me[41],ge([0,1,161,9,70,25,13,6,23,2,14,5,35,219,90,34,39,217,17,26,22,195,7,116,4,27,91,15,82,48,33,3,258,88,196]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w,m,b,_,u,c,d,t,n,s,r,o,g,f,S,E,l,L,O,W){"use strict";var te,se,N;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let V=class Bn extends P.Disposable{constructor(F,M,$,H,X,ae,we,Le,Ie,Me){super();this._onDidChangeRemoteConnectionData=this._register(new l.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=M,this._extHostContext=$,this._initData=we,this._extHostWorkspace=H,this._extHostConfiguration=X,this._logService=ae,this._extHostTunnelService=Ie,this._extHostTerminalService=Me,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(A.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(A.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(A.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new b.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=Le,this._instaService=F.createChild(new f.ServiceCollection([a.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const We=new Set;this._initData.hostExtensions.forEach(j=>We.add(u.ExtensionIdentifier.toKey(j))),this._activator=new p.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(j,Y,ee)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(j,_.transformErrorForSerialization(Y),ee)},actualActivateExtension:async(j,Y)=>{if(We.has(u.ExtensionIdentifier.toKey(j)))return await this._mainThreadExtensionsProxy.$activateExtension(j,Y),new p.HostExtension;const ee=this._registry.getExtensionDescription(j);return this._activateExtension(ee,Y)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(F){_.onUnexpectedError(F)}}async deactivateAll(){let F=[];try{F=this._registry.getAllExtensionDescriptions().map(X=>X.identifier).filter(X=>this.isActivated(X)).map(X=>this._deactivate(X))}catch(M){}await Promise.all(F)}isActivated(F){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(F):!1}_activateByEvent(F,M){return this._activator.activateByEvent(F,M)}_activateById(F,M){return this._activator.activateById(F,M)}activateByIdWithErrors(F,M){return this._activateById(F,M).then(()=>{const $=this._activator.getActivatedExtension(F);if($.activationFailed)return Promise.reject($.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(F=>this._registry)}getExtensionExports(F){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(F).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const F=D.TernarySearchTree.forPaths(),M=this._registry.getAllExtensionDescriptions().map($=>{if(!!this._getEntryPoint($))return this._hostUtils.realpath($.extensionLocation.fsPath).then(H=>F.set(I.URI.file(H).fsPath,$))});this._extensionPathIndex=Promise.all(M).then(()=>F)}return this._extensionPathIndex}_deactivate(F){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(F))return M;const $=this._activator.getActivatedExtension(F);if(!$)return M;try{typeof $.module.deactivate=="function"&&(M=Promise.resolve($.module.deactivate()).then(void 0,H=>(this._logService.error(H),Promise.resolve(void 0))))}catch(H){this._logService.error(H)}try{(0,P.dispose)($.subscriptions)}catch(H){this._logService.error(H)}return M}async _activateExtension(F,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier),this._doActivateExtension(F,M).then($=>{const H=$.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(F.identifier,H.codeLoadingTime,H.activateCallTime,H.activateResolvedTime,M),this._logExtensionActivationTimes(F,M,"success",H),$},$=>{throw this._logExtensionActivationTimes(F,M,"failure"),$})}_logExtensionActivationTimes(F,M,$,H){const X=x(F,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},X),H||{}),{outcome:$}))}_doActivateExtension(F,M){const $=x(F,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",$);const H=this._getEntryPoint(F);if(!H)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${F.identifier.value} ${JSON.stringify(M)}`),this._logService.flush();const X=new p.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(F.identifier,(0,T.joinPath)(F.extensionLocation,H),X),this._loadExtensionContext(F)]).then(ae=>(C.mark(`code/extHost/willActivateExtension/${F.identifier.value}`),Bn._callActivate(this._logService,F.identifier,ae[0],ae[1],X))).then(ae=>(C.mark(`code/extHost/didActivateExtension/${F.identifier.value}`),ae))}_loadExtensionContext(F){const M=new d.ExtensionGlobalMemento(F,this._storage),$=new d.ExtensionMemento(F.identifier.value,!1,this._storage),H=new W.ExtensionSecrets(F,this._secretState),X=F.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ae=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${F.identifier.value}`),Promise.all([M.whenReady,$.whenReady,this._storagePath.whenReady]).then(()=>{const we=this;let Le;return Object.freeze({globalState:M,workspaceState:$,secrets:H,subscriptions:[],get extensionUri(){return F.extensionLocation},get extensionPath(){return F.extensionLocation.fsPath},asAbsolutePath(Ie){return R.join(F.extensionLocation.fsPath,Ie)},get storagePath(){var Ie;return(Ie=we._storagePath.workspaceValue(F))===null||Ie===void 0?void 0:Ie.fsPath},get globalStoragePath(){return we._storagePath.globalValue(F).fsPath},get logPath(){return R.join(we._initData.logsLocation.fsPath,F.identifier.value)},get logUri(){return I.URI.joinPath(we._initData.logsLocation,F.identifier.value)},get storageUri(){return we._storagePath.workspaceValue(F)},get globalStorageUri(){return we._storagePath.globalValue(F)},get extensionMode(){return X},get extension(){return Le===void 0&&(Le=new k(we,F.identifier,F,ae)),Le},get extensionRuntime(){return(0,m.checkProposedApiEnabled)(F),we.extensionRuntime},get environmentVariableCollection(){return we._extHostTerminalService.getEnvironmentVariableCollection(F)}})})}static _callActivate(F,M,$,H,X){return $=$||{activate:void 0,deactivate:void 0},this._callActivateOptional(F,M,$,H,X).then(ae=>new p.ActivatedExtension(!1,null,X.build(),$,ae,H.subscriptions))}static _callActivateOptional(F,M,$,H,X){if(typeof $.activate=="function")try{X.activateCallStart(),F.trace(`ExtensionService#_callActivateOptional ${M.value}`);const ae=typeof global=="object"?global:self,we=$.activate.apply(ae,[H]);return X.activateCallStop(),X.activateResolveStart(),Promise.resolve(we).then(Le=>(X.activateResolveStop(),Le))}catch(ae){return Promise.reject(ae)}else return Promise.resolve($)}_activateOneStartupFinished(F,M){this._activateById(F.identifier,{startup:!1,extensionId:F.identifier,activationEvent:M}).then(void 0,$=>{this._logService.error($)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const F of this._registry.getAllExtensionDescriptions())if(F.activationEvents)for(const M of F.activationEvents)M==="onStartupFinished"&&this._activateOneStartupFinished(F,M)}_handleEagerExtensions(){const F=this._activateByEvent("*",!0).then(void 0,X=>{this._logService.error(X)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(X=>this._handleWorkspaceContainsEagerExtensions(X.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],$=this._handleWorkspaceContainsEagerExtensions(M),H=Promise.all([F,$]).then(()=>{});return Promise.race([H,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),H}_handleWorkspaceContainsEagerExtensions(F){return F.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(F,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(F,M){if(this.isActivated(M.identifier))return;const $=!this._initData.remote.isRemote&&!!this._initData.remote.authority,H={folders:F.map(ae=>ae.uri),forceUsingSearch:$,exists:ae=>this._hostUtils.exists(ae.fsPath),checkExists:(ae,we,Le)=>this._mainThreadWorkspaceProxy.$checkExists(ae,we,Le)},X=await(0,L.checkActivateWorkspaceContainsExtension)(H,M);if(!!X)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:X.activationEvent}).then(void 0,ae=>this._logService.error(ae))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(F){throw console.error(F),F}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:F,extensionTestsLocationURI:M}=this._initData.environment;if(!F||!M)throw new Error(v.localize(0,null));const $=await this._loadCommonJSModule(null,M,new p.ExtensionActivationTimesBuilder(!1));if(!$||typeof $.run!="function")throw new Error(v.localize(1,null,M.toString()));return new Promise((H,X)=>{const ae=(Ie,Me)=>{Ie?X(Ie):H(typeof Me=="number"&&Me>0?1:0)},we=(0,T.originalFSPath)(M),Le=$.run(we,ae);Le&&Le.then&&Le.then(()=>{H(0)}).catch(Ie=>{X(Ie.toString())})})}async $extensionTestsExit(F){this._logService.info(`extension host terminating: test runner requested exit with code ${F}`),this._logService.info(`exiting with code ${F}`),this._logService.flush(),this._hostUtils.exit(F)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(F,M){return this._resolvers[F]=M,(0,P.toDisposable)(()=>{delete this._resolvers[F]})}async _activateAndGetResolver(F){const M=F.indexOf("+");if(M===-1)throw new Error("Not an authority that can be resolved!");const $=F.substr(0,M);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${$}`,!1),{authorityPrefix:$,resolver:this._resolvers[$]}}async $resolveAuthority(F,M){const{authorityPrefix:$,resolver:H}=await this._activateAndGetResolver(F);if(!H)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${$}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(H)),C.mark(`code/extHost/willResolveAuthority/${$}`);const X=await H.resolve(F,{resolveAttempt:M});C.mark(`code/extHost/didResolveAuthorityOK/${$}`);const ae={authority:F,host:X.host,port:X.port,connectionToken:X.connectionToken},we={extensionHostEnv:X.extensionHostEnv,isTrusted:X.isTrusted};return{type:"ok",value:{authority:ae,options:we,tunnelInformation:{environmentTunnels:X.environmentTunnels}}}}catch(X){if(C.mark(`code/extHost/didResolveAuthorityError/${$}`),X instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:X._code,message:X._message,detail:X._detail}};throw X}}async $getCanonicalURI(F,M){const{authorityPrefix:$,resolver:H}=await this._activateAndGetResolver(F);if(!H)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${$}`);const X=I.URI.revive(M);if(typeof H.getCanonicalURI=="undefined")return X;const ae=await(0,y.asPromise)(()=>H.getCanonicalURI(X));return ae||X}$startExtensionHost(F){return this._registry.keepOnly(F),this._startExtensionHost()}$activateByEvent(F,M){return M===1?this._activateByEvent(F,!1):this._readyToRunExtensions.wait().then($=>this._activateByEvent(F,!1))}async $activate(F,M){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(F)?(await this._activateById(F,M),!0):!1}async $deltaExtensions(F,M){F.forEach(H=>H.extensionLocation=I.URI.revive(H.extensionLocation));const $=await this.getExtensionPathIndex();return await Promise.all(M.map(async H=>{const X=this._registry.getExtensionDescription(H);if(!X)return;const ae=await this._hostUtils.realpath(X.extensionLocation.fsPath);$.delete(I.URI.file(ae).fsPath)})),await Promise.all(F.map(async H=>{const X=await this._hostUtils.realpath(H.extensionLocation.fsPath);$.set(I.URI.file(X).fsPath,H)})),this._registry.deltaExtensions(F,M),Promise.resolve(void 0)}async $test_latency(F){return F}async $test_up(F){return F.byteLength}async $test_down(F){let M=c.VSBuffer.alloc(F),$=Math.random()%256;for(let H=0;H<F;H++)M.writeUInt8($,H);return M}async $updateRemoteConnectionData(F){this._remoteConnectionData=F,this._onDidChangeRemoteConnectionData.fire()}};V=qe([He(0,s.IInstantiationService),He(1,e.IHostUtils),He(2,g.IExtHostRpcService),He(3,w.IExtHostWorkspace),He(4,h.IExtHostConfiguration),He(5,i.ILogService),He(6,r.IExtHostInitDataService),He(7,o.IExtensionStoragePaths),He(8,S.IExtHostTunnelService),He(9,E.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function x(U,F){return{id:U.identifier.value,name:U.name,extensionVersion:U.version,publisherDisplayName:U.publisher,activationEvents:U.activationEvents?U.activationEvents.join(","):null,isBuiltin:U.isBuiltin,reason:F.activationEvent,reasonId:F.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class k{constructor(F,M,$,H){te.set(this,void 0),se.set(this,void 0),N.set(this,void 0),nt(this,te,F,"f"),nt(this,se,M,"f"),nt(this,N,$.identifier,"f"),this.id=$.identifier.value,this.extensionUri=$.extensionLocation,this.extensionPath=R.normalize((0,T.originalFSPath)($.extensionLocation)),this.packageJSON=$,this.extensionKind=H}get isActive(){return $e(this,te,"f").isActivated($e(this,N,"f"))}get exports(){if(this.packageJSON.api!=="none")return $e(this,te,"f").getExtensionExports($e(this,N,"f"))}activate(){return $e(this,te,"f").activateByIdWithErrors($e(this,N,"f"),{startup:!1,extensionId:$e(this,se,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=k,te=new WeakMap,se=new WeakMap,N=new WeakMap}),define(me[50],ge([0,1,9,2,3,13,5,7,121,34,41,40,208,35,203,15,4,12,36,47]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w,m,b,_,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,m.createDecorator)("IExtHostDebugService");let c=class{constructor(f,S,E,l,L,O){this._workspaceService=S,this._extensionService=E,this._editorsService=l,this._configurationService=L,this._editorTabs=O,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=f.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(W=>{W.onDidChange(te=>{this.registerAllDebugTypes(W)}),this.registerAllDebugTypes(W)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(f,S){const E=f;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let l=`debug:${encodeURIComponent(E.path||"")}`,L="?";return S&&(l+=`${L}session=${encodeURIComponent(S.id)}`,L="&"),l+=`${L}ref=${E.sourceReference}`,R.URI.parse(l)}else{if(E.path)return R.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(f){const S=[];for(const E of f.getAllExtensionDescriptions())if(E.contributes){const l=E.contributes.debuggers;if(l&&l.length>0)for(const L of l)(0,a.isDebuggerMainContribution)(L)&&S.push(L.type)}this._debugServiceProxy.$registerDebugTypes(S)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const f=[];return this._breakpoints.forEach(S=>f.push(S)),f}addBreakpoints(f){this.startBreakpoints();const S=f.filter(L=>{const O=L.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,L),!0)});this.fireBreakpointChanges(S,[],[]);const E=[],l=new Map;for(const L of S)if(L instanceof P.SourceBreakpoint){let O=l.get(L.location.uri.toString());O||(O={type:"sourceMulti",uri:L.location.uri,lines:[]},l.set(L.location.uri.toString(),O),E.push(O)),O.lines.push({id:L.id,enabled:L.enabled,condition:L.condition,hitCondition:L.hitCondition,logMessage:L.logMessage,line:L.location.range.start.line,character:L.location.range.start.character})}else L instanceof P.FunctionBreakpoint&&E.push({type:"function",id:L.id,enabled:L.enabled,hitCondition:L.hitCondition,logMessage:L.logMessage,condition:L.condition,functionName:L.functionName});return this._debugServiceProxy.$registerBreakpoints(E)}removeBreakpoints(f){this.startBreakpoints();const S=f.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],S,[]);const E=S.filter(O=>O instanceof P.SourceBreakpoint).map(O=>O.id),l=S.filter(O=>O instanceof P.FunctionBreakpoint).map(O=>O.id),L=S.filter(O=>O instanceof P.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(E,l,L)}startDebugging(f,S,E){return this._debugServiceProxy.$startDebugging(f?f.uri:void 0,S,{parentSessionID:E.parentSession?E.parentSession.id:void 0,repl:E.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact})}stopDebugging(f){return this._debugServiceProxy.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,S,E){if(!S)return new P.Disposable(()=>{});const l=this._configProviderHandleCounter++;return this._configProviders.push({type:f,handle:l,provider:S}),this._debugServiceProxy.$registerDebugConfigurationProvider(f,E,!!S.provideDebugConfigurations,!!S.resolveDebugConfiguration,!!S.resolveDebugConfigurationWithSubstitutedVariables,l),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(L=>L.provider!==S),this._debugServiceProxy.$unregisterDebugConfigurationProvider(l)})}registerDebugAdapterDescriptorFactory(f,S,E){if(!E)return new P.Disposable(()=>{});if(!this.definesDebugType(f,S))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${S}' debugger.`);if(this.getAdapterDescriptorFactoryByType(S))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const l=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:S,handle:l,factory:E}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(S,l),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(L=>L.factory!==E),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(l)})}registerDebugAdapterTrackerFactory(f,S){if(!S)return new P.Disposable(()=>{});const E=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:f,handle:E,factory:S}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(l=>l.factory!==S)})}async $runInTerminal(f,S){return Promise.resolve(void 0)}async $substituteVariables(f,S){if(!this._variableResolver){const[L,O]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(L||[],this._editorsService,O)}let E;const l=await this.getFolder(f);return l&&(E={uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(E,S)}createDebugAdapter(f,S){if(f.type==="implementation")return new r(f.implementation)}createSignService(){}async $startDASession(f,S){const E=this,l=await this.getSession(S);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(l.type),l).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}' (extension might have failed to activate)`);const O=this.convertToDto(L),W=this.createDebugAdapter(O,l);if(!W)throw new Error(`Couldn't create a debug adapter for type '${l.type}'.`);const te=W;return this._debugAdapters.set(f,te),this.getDebugAdapterTrackers(l).then(se=>(se&&this._debugAdaptersTrackers.set(f,se),te.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const V=N,x={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const k=await this._signService.sign(V.arguments.value);x.body={signature:k},te.sendResponse(x)}else throw new Error("no signer")}catch(k){x.success=!1,x.message=k.message,te.sendResponse(x)}}else se&&se.onDidSendMessage&&se.onDidSendMessage(N),N=(0,a.convertToVSCPaths)(N,!0),E._debugServiceProxy.$acceptDAMessage(f,N)}),te.onError(N=>{se&&se.onError&&se.onError(N),this._debugServiceProxy.$acceptDAError(f,N.name,N.message,N.stack)}),te.onExit(N=>{se&&se.onExit&&se.onExit((0,b.withNullAsUndefined)(N),void 0),this._debugServiceProxy.$acceptDAExit(f,(0,b.withNullAsUndefined)(N),void 0)}),se&&se.onWillStartSession&&se.onWillStartSession(),te.startSession()))})}$sendDAMessage(f,S){S=(0,a.convertToDAPaths)(S,!1);const E=this._debugAdaptersTrackers.get(f);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(S);const l=this._debugAdapters.get(f);l&&l.sendMessage(S)}$stopDASession(f){const S=this._debugAdaptersTrackers.get(f);this._debugAdaptersTrackers.delete(f),S&&S.onWillStopSession&&S.onWillStopSession();const E=this._debugAdapters.get(f);return this._debugAdapters.delete(f),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const S=[],E=[],l=[];if(f.added)for(const L of f.added){const O=L.id;if(O&&!this._breakpoints.has(O)){let W;if(L.type==="function")W=new P.FunctionBreakpoint(L.functionName,L.enabled,L.condition,L.hitCondition,L.logMessage);else if(L.type==="data")W=new P.DataBreakpoint(L.label,L.dataId,L.canPersist,L.enabled,L.hitCondition,L.condition,L.logMessage);else{const te=R.URI.revive(L.uri);W=new P.SourceBreakpoint(new P.Location(te,new P.Position(L.line,L.character)),L.enabled,L.condition,L.hitCondition,L.logMessage)}W._id=O,this._breakpoints.set(O,W),S.push(W)}}if(f.removed)for(const L of f.removed){const O=this._breakpoints.get(L);O&&(this._breakpoints.delete(L),E.push(O))}if(f.changed){for(const L of f.changed)if(L.id){const O=this._breakpoints.get(L.id);if(O){if(O instanceof P.FunctionBreakpoint&&L.type==="function"){const W=O;W.enabled=L.enabled,W.condition=L.condition,W.hitCondition=L.hitCondition,W.logMessage=L.logMessage,W.functionName=L.functionName}else if(O instanceof P.SourceBreakpoint&&L.type==="source"){const W=O;W.enabled=L.enabled,W.condition=L.condition,W.hitCondition=L.hitCondition,W.logMessage=L.logMessage,W.location=new P.Location(R.URI.revive(L.uri),new P.Position(L.line,L.character))}l.push(O)}}}this.fireBreakpointChanges(S,E,l)}$provideDebugConfigurations(f,S,E){return(0,T.asPromise)(async()=>{const l=this.getConfigProviderByHandle(f);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const L=await this.getFolder(S);return l.provideDebugConfigurations(L,E)}).then(l=>{if(!l)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return l})}$resolveDebugConfiguration(f,S,E,l){return(0,T.asPromise)(async()=>{const L=this.getConfigProviderByHandle(f);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(S);return L.resolveDebugConfiguration(O,E,l)})}$resolveDebugConfigurationWithSubstitutedVariables(f,S,E,l){return(0,T.asPromise)(async()=>{const L=this.getConfigProviderByHandle(f);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(S);return L.resolveDebugConfigurationWithSubstitutedVariables(O,E,l)})}async $provideDebugAdapter(f,S){const E=this.getAdapterDescriptorFactoryByHandle(f);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const l=await this.getSession(S);return this.getAdapterDescriptor(E,l).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}'`);return this.convertToDto(L)})}async $acceptDebugSessionStarted(f){const S=await this.getSession(f);this._onDidStartDebugSession.fire(S)}async $acceptDebugSessionTerminated(f){const S=await this.getSession(f);S&&(this._onDidTerminateDebugSession.fire(S),this._debugSessions.delete(S.id))}async $acceptDebugSessionActiveChanged(f){this._activeDebugSession=f?await this.getSession(f):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(f,S){const E=await this.getSession(f);E&&E._acceptNameChanged(S)}async $acceptDebugSessionCustomEvent(f,S){const l={session:await this.getSession(f),event:S.event,body:S.body};this._onDidReceiveDebugSessionCustomEvent.fire(l)}convertToDto(f){if(f instanceof P.DebugAdapterExecutable)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof P.DebugAdapterServer)return{type:"server",port:f.port,host:f.host};if(f instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:f.path};if(f instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(f){const S=this._adapterFactories.filter(E=>E.type===f);if(S.length>0)return S[0].factory}getAdapterDescriptorFactoryByHandle(f){const S=this._adapterFactories.filter(E=>E.handle===f);if(S.length>0)return S[0].factory}getConfigProviderByHandle(f){const S=this._configProviders.filter(E=>E.handle===f);if(S.length>0)return S[0].provider}definesDebugType(f,S){if(f.contributes){const E=f.contributes.debuggers;if(E&&E.length>0){for(const l of E)if(l.label&&l.type&&l.type===S)return!0}}return!1}getDebugAdapterTrackers(f){const E=f.configuration.type,l=this._trackerFactories.filter(L=>L.type===E||L.type==="*").map(L=>(0,T.asPromise)(()=>L.factory.createDebugAdapterTracker(f)).then(O=>O,O=>null));return Promise.race([Promise.all(l).then(L=>{const O=L.filter(W=>!!W);if(O.length>0)return new s(O)}),new Promise((L,O)=>{const W=setTimeout(()=>{clearTimeout(W),O(new Error("timeout"))},1e3)})]).catch(L=>{})}async getAdapterDescriptor(f,S){const E=S.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new P.DebugAdapterServer(E));if(f){const L=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>f.createDebugAdapterDescriptor(S,this.daExecutableFromPackage(S,L))).then(O=>{if(O)return O})}const l=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(S,l))}daExecutableFromPackage(f,S){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(f,S,E){(f.length>0||S.length>0||E.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:f,removed:S,changed:E}))}async getSession(f){if(f)if(typeof f=="string"){const S=this._debugSessions.get(f);if(S)return S}else{let S=this._debugSessions.get(f.id);if(!S){const E=await this.getFolder(f.folderUri),l=f.parent?this._debugSessions.get(f.parent):void 0;S=new d(this._debugServiceProxy,f.id,f.type,f.name,E,f.configuration,l),this._debugSessions.set(S.id,S),this._debugServiceProxy.$sessionCached(S.id)}return S}throw new Error("cannot find session")}getFolder(f){if(f){const S=R.URI.revive(f);return this._workspaceService.resolveWorkspaceFolder(S)}return Promise.resolve(void 0)}};c=qe([He(0,w.IExtHostRpcService),He(1,I.IExtHostWorkspace),He(2,i.IExtHostExtensionService),He(3,A.IExtHostDocumentsAndEditors),He(4,p.IExtHostConfiguration),He(5,u.IExtHostEditorTabs)],c),e.ExtHostDebugServiceBase=c;class d{constructor(f,S,E,l,L,O,W){this._debugServiceProxy=f,this._id=S,this._type=E,this._name=l,this._workspaceFolder=L,this._configuration=O,this._parentSession=W}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(f){this._name=f,this._debugServiceProxy.$setDebugSessionName(this._id,f)}get parentSession(){return this._parentSession}_acceptNameChanged(f){this._name=f}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(f,S){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,f,S)}getDebugProtocolBreakpoint(f){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,f.id)}}e.ExtHostDebugSession=d;class t{constructor(f){this.value=Object.freeze({append(S){f.$appendDebugConsole(S)},appendLine(S){this.append(S+`
`)}})}}e.ExtHostDebugConsole=t;class n extends h.AbstractVariableResolverService{constructor(f,S,E,l,L){function O(){if(S){const W=S.activeEditor();if(W)return W.document.uri;const te=l.tabs.filter(se=>se.isActive);if(te.length>0)return te[0].resource}}super({getFolderUri:W=>{const te=f.filter(se=>se.name===W);if(te&&te.length>0)return te[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(W,te)=>E.getConfiguration(void 0,W).get(te),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{const W=O();if(W)return v.normalize(W.fsPath)},getWorkspaceFolderPathForFile:()=>{if(L){const W=O();if(W){const te=L.getWorkspaceFolder(W);if(te)return v.normalize(te.uri.fsPath)}}},getSelectedText:()=>{if(S){const W=S.activeEditor();if(W&&!W.selection.isEmpty)return W.document.getText(W.selection)}},getLineNumber:()=>{if(S){const W=S.activeEditor();if(W)return String(W.selection.end.line+1)}}},void 0,Promise.resolve(_.env))}}e.ExtHostVariableResolverService=n;class s{constructor(f){this.trackers=f}onWillStartSession(){this.trackers.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.trackers.forEach(S=>S.onWillReceiveMessage?S.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.trackers.forEach(S=>S.onDidSendMessage?S.onDidSendMessage(f):void 0)}onWillStopSession(){this.trackers.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.trackers.forEach(S=>S.onError?S.onError(f):void 0)}onExit(f,S){this.trackers.forEach(E=>E.onExit?E.onExit(f,S):void 0)}}class r extends D.AbstractDebugAdapter{constructor(f){super();this.implementation=f,f.onDidSendMessage(S=>{this.acceptMessage(S)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.implementation.handleMessage(f)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends c{constructor(f,S,E,l,L,O){super(f,S,E,l,L,O)}createVariableResolver(f,S,E){return new n(f,S,E,this._editorTabs)}};o=qe([He(0,w.IExtHostRpcService),He(1,I.IExtHostWorkspace),He(2,i.IExtHostExtensionService),He(3,A.IExtHostDocumentsAndEditors),He(4,p.IExtHostConfiguration),He(5,u.IExtHostEditorTabs)],o),e.WorkerExtHostDebugService=o}),define(me[259],ge([0,1,70,2,5,35,39,26,15,27,4,41,36,14]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(u,c,d,t,n,s,r){this._apiFactory=u,this._extensionRegistry=c,this._instaService=d,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=s,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),v.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new w(this._apiFactory,c,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(m)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,c,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let c of u.nodeModuleName)this._factories.set(c,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(c=>u.alternativeModuleName(c))}};a=qe([He(2,i.IInstantiationService),He(3,T.IExtHostConfiguration),He(4,A.IExtHostExtensionService),He(5,I.IExtHostInitDataService),He(6,p.ILogService)],a),e.RequireInterceptor=a;class w{constructor(u,c,d,t,n){this._apiFactory=u,this._extensionPaths=c,this._extensionRegistry=d,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,c){const d=this._extensionPaths.findSubstr(c.fsPath);if(d){let t=this._extApiImpl.get(P.ExtensionIdentifier.toKey(d.identifier));return t||(t=this._apiFactory(d,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(d.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,s)=>t+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let m=class{constructor(u,c){this.nodeModuleName="keytar";const{environment:d}=c,t=u.getProxy(C.MainContext.MainThreadKeytar);if(d.appRoot){let n=d.appRoot.fsPath;h.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,s)=>t.$getPassword(n,s),setPassword:(n,s,r)=>t.$setPassword(n,s,r),deletePassword:(n,s)=>t.$deletePassword(n,s),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(u,c){return this._impl}alternativeModuleName(u){const c=u.length;if(c<=7||!this.alternativeNames)return;const d=c-7;if((u.charAt(d)==="/"||u.charAt(d)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};m=qe([He(0,D.IExtHostRpcService),He(1,I.IExtHostInitDataService)],m);let b=class{constructor(u,c,d){this._extensionPaths=u,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=d.getProxy(C.MainContext.MainThreadTelemetry);const t=d.getProxy(C.MainContext.MainThreadWindow);this._impl=(n,s)=>{const r=R.URI.parse(n);return s?this.callOriginal(n,s):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,n,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,n,{}):this.callOriginal(n,s)}}load(u,c,d){const t=this._extensionPaths.findSubstr(c.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=d(u),this._impl}callOriginal(u,c){return this.sendNoForwardTelemetry(),this._original(u,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=qe([He(2,D.IExtHostRpcService)],b)}),define(me[260],ge([0,1,167,11,7,204,34,41,40,35,33,15,50,190,13,205,47]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let b=class extends h.ExtHostDebugServiceBase{constructor(c,d,t,n,s,r,o){super(c,d,t,n,s,o);this._terminalService=r,this._integratedTerminalInstances=new _}createDebugAdapter(c,d){switch(c.type){case"server":return new T.SocketDebugAdapter(c);case"pipeServer":return new T.NamedPipeDebugAdapter(c);case"executable":return new T.ExecutableDebugAdapter(c,d.type)}return super.createDebugAdapter(c,d)}daExecutableFromPackage(c,d){const t=T.ExecutableDebugAdapter.platformAdapterExecutable(d.getAllExtensionDescriptions(),c.type);if(t)return new C.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new p.SignService}async $runInTerminal(c,d){if(c.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const t=await this._configurationService.getConfigProvider(),n=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),r=JSON.stringify({shell:n,shellArgs:s});let o=await this._integratedTerminalInstances.checkout(r),g,f=!1;if(o)g=c.cwd;else{const L={shellPath:n,shellArgs:s,cwd:c.cwd,name:c.title||v.localize(0,null)};f=!0,o=this._terminalService.createTerminalFromOptions(L,!0),this._integratedTerminalInstances.insert(o,r)}o.show(!0);const S=await o.processId;f?await new Promise(L=>setTimeout(L,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(n.indexOf("powershell")>=0||n.indexOf("pwsh")>=0||n.indexOf("cmd.exe")>=0?o.sendText("cls"):n.indexOf("bash")>=0?o.sendText("clear"):R.isWindows?o.sendText("cls"):o.sendText("clear"));const E=(0,w.prepareCommand)(n,c.args,g,c.env);o.sendText(E);const l=this.onDidTerminateDebugSession(L=>{L.id===d&&(this._integratedTerminalInstances.free(o),l.dispose())});return S}else if(c.kind==="external")return(0,w.runInExternalTerminal)(c,await this._configurationService.getConfigProvider());return super.$runInTerminal(c,d)}createVariableResolver(c,d,t){return new h.ExtHostVariableResolverService(c,d,t,this._editorTabs,this._workspaceService)}};b=qe([He(0,A.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,P.IExtHostExtensionService),He(3,D.IExtHostDocumentsAndEditors),He(4,I.IExtHostConfiguration),He(5,i.IExtHostTerminalService),He(6,m.IExtHostEditorTabs)],b),e.ExtHostDebugService=b;class _{constructor(){this._terminalInstances=new Map}async checkout(c){const t=[...this._terminalInstances.entries()].map(([n,s])=>(0,a.createCancelablePromise)(async r=>{if(s.lastUsedAt!==-1&&await(0,w.hasChildProcesses)(await n.processId))return null;const o=Date.now();return s.lastUsedAt+_.minUseDelay>o||r.isCancellationRequested||s.config!==c?null:(s.lastUsedAt=o,n)}));return await(0,a.firstParallel)(t,n=>!!n)}insert(c,d){this._terminalInstances.set(c,{lastUsedAt:Date.now(),config:d})}free(c){const d=this._terminalInstances.get(c);d&&(d.lastUsedAt=-1)}onTerminalClosed(c){this._terminalInstances.delete(c)}}_.minUseDelay=1e3}),define(me[261],ge([0,1,9,2,110,34,50,40,35,33,15,27,69,10,14,65,47]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let b=class extends h.ExtHostTaskBase{constructor(u,c,d,t,n,s,r,o,g){super(u,c,d,t,n,s,r,o);this.workspaceService=d,this.editorTabs=g,c.remote.isRemote&&c.remote.authority?this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:c.remote.authority,platform:process.platform}):this.registerTaskSystem(p.Schemas.file,{scheme:p.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(u,c){const d=c;if(!c.execution&&d._id===void 0)throw new Error("Tasks to execute must include an execution");if(d._id!==void 0){const t=h.TaskHandleDTO.from(d,this.workspaceService),n=await this._proxy.$getTaskExecution(t);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.getTaskExecution(n,c);return this._proxy.$executeTask(t).catch(()=>{}),s}else{const t=h.TaskDTO.from(c,u);if(t===void 0)return Promise.reject(new Error("Task is not valid"));h.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,c,!1);const n=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),c);return this._proxy.$executeTask(t).catch(()=>{}),n}}provideTasksInternal(u,c,d,t){const n=[];if(t)for(let s of t){this.checkDeprecation(s,d),(!s.definition||!u[s.definition.type])&&this._logService.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const r=h.TaskDTO.from(s,d.extension);r&&(n.push(r),h.CustomExecutionDTO.is(r.execution)&&c.push(this.addCustomExecution(r,s,!0)))}return{tasks:n,extension:d.extension}}async resolveTaskInternal(u){return u}async getVariableResolver(u){if(this._variableResolver===void 0){const c=await this._configurationService.getConfigProvider();this._variableResolver=new y.ExtHostVariableResolverService(u,this._editorService,c,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(u,c){const d=R.URI.revive(u),t={process:void 0,variables:Object.create(null)},n=await this._workspaceProvider.resolveWorkspaceFolder(d),s=await this._workspaceProvider.getWorkspaceFolders2();if(!s||!n)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const r=await this.getVariableResolver(s),o={uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}};for(let g of c.variables)t.variables[g]=await r.resolveAsync(o,g);if(c.process!==void 0){let g;if(c.process.path!==void 0){g=c.process.path.split(v.delimiter);for(let f=0;f<g.length;f++)g[f]=await r.resolveAsync(o,g[f])}t.process=await C.win32.findExecutable(await r.resolveAsync(o,c.process.name),c.process.cwd!==void 0?await r.resolveAsync(o,c.process.cwd):void 0,g)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(u,c,d){return C.win32.findExecutable(u,c,d)}};b=qe([He(0,i.IExtHostRpcService),He(1,A.IExtHostInitDataService),He(2,T.IExtHostWorkspace),He(3,P.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,I.IExtHostTerminalService),He(6,a.ILogService),He(7,w.IExtHostApiDeprecationService),He(8,m.IExtHostEditorTabs)],b),e.ExtHostTask=b}),define(me[262],ge([0,1,13,17,70,6,2,5,253,14,79,82,27,184,15,63,41,33]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(c,d,t,n){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new D.RPCProtocol(c,null,n),d=_._transform(d,this._rpcProtocol);const s=new A.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());s.set(h.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},d)),s.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),s.set(w.IURITransformerService,new w.URITransformerService(n)),s.set(m.IHostUtils,t);const r=new p.InstantiationService(s,!0),o=r.invokeFunction(E=>E.get(b.IExtHostTerminalService));this._disposables.add(o),this._logService=r.invokeFunction(E=>E.get(I.ILogService)),C.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",d),this._extensionService=r.invokeFunction(E=>E.get(m.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const g=new WeakMap;this._extensionService.getExtensionPathIndex().then(E=>{Error.prepareStackTrace=(l,L)=>{let O="",W,te;for(const se of L)O+=`
	at ${se.toString()}`,te=se.getFileName(),!W&&te&&(W=E.findSubstr(te));return g.set(l,W),`${l.name||"Error"}: ${l.message||""}${O}`}});const f=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),S=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(E=>{const l=R.transformErrorForSerialization(E),L=g.get(E);L?f.$onExtensionRuntimeError(L.identifier,l):S.$onUnexpectedError(l)})}terminate(c){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const d=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,v.timeout)(4e3),d]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(c,d){c.extensions.forEach(n=>n.extensionLocation=y.URI.revive(d.transformIncomingURIs(n.extensionLocation))),c.environment.appRoot=y.URI.revive(d.transformIncomingURIs(c.environment.appRoot));const t=c.environment.extensionDevelopmentLocationURI;return t&&(c.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(d.transformIncomingURIs(n)))),c.environment.extensionTestsLocationURI=y.URI.revive(d.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=y.URI.revive(d.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=y.URI.revive(d.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=y.URI.revive(d.transformIncomingURIs(c.logsLocation)),c.logFile=y.URI.revive(d.transformIncomingURIs(c.logFile)),c.workspace=d.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=_}),define(me[263],ge([0,1,9,21,60,31,25,44,30]),function(K,e,v,R,C,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(h,p,a){this.config=h,this.provider=p,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=h.filePattern,this.includePattern=h.includePattern&&T.parse(h.includePattern),this.maxResults=h.maxResults||void 0,this.exists=h.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=h.excludePattern&&T.parse(h.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(h=>h.cancel()),this.activeCancellationTokens=new Set}search(h){const p=this.config.folderQueries||[];return new Promise((a,w)=>{const m=b=>{this.resultCount++,h(b)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(b=>{const _=b.toString(),u=v.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,u)||this.matchFile(m,{base:b,basename:u})}),Promise.all(p.map(b=>this.searchInFolder(b,m))).then(b=>{a({limitHit:this.isLimitHit,stats:b[0]||void 0})},b=>{w(new Error((0,C.toErrorMessage)(b)))})})}async searchInFolder(h,p){const a=new R.CancellationTokenSource,w=this.getSearchOptionsForFolder(h),m=this.initDirectoryTree(),b=new D.QueryGlobTester(this.config,h),_=!b.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(a),u=P.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,a.token),d=u.elapsed(),t=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(n=>{const s=v.posix.relative(h.folder.path,n.path);if(_){const r=v.basename(n.path);this.matchFile(p,{base:h.folder,relativePath:s,basename:r});return}this.addDirectoryEntries(m,h.folder,s,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(m,b,p),{providerTime:d,postProcessTime:t.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(h){const p=(0,D.resolvePatternsForProvider)(this.config.includePattern,h.includePattern),a=(0,D.resolvePatternsForProvider)(this.config.excludePattern,h.excludePattern);return{folder:h.folder,excludes:a,includes:p,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}addDirectoryEntries({pathToEntries:h},p,a,w){if(a===this.filePattern){const b=v.basename(this.filePattern);this.matchFile(w,{base:p,relativePath:this.filePattern,basename:b})}function m(b){const _=v.basename(b),u=v.dirname(b);let c=h[u];c||(c=h[u]=[],m(u)),c.push({base:p,relativePath:b,basename:_})}m(a)}matchDirectoryTree({rootEntries:h,pathToEntries:p},a,w){const m=this,b=this.filePattern;function _(u){const c=T.hasSiblingFn(()=>u.map(d=>d.basename));for(let d=0,t=u.length;d<t;d++){const n=u[d],{relativePath:s,basename:r}=n;if(!a.includedInQuerySync(s,r,b!==r?c:void 0))continue;const o=p[s];if(o)_(o);else{if(s===b)continue;m.matchFile(w,n)}if(m.isLimitHit)break}}_(h)}matchFile(h,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||h(p))}}class i{constructor(){this.sessions=new Map}fileSearch(h,p,a,w){const m=this.getSessionTokenSource(h.cacheKey),b=new I(h,p,m&&m.token);let _=0;const u=c=>{_+=c.length,a(c.map(d=>this.rawMatchToSearchItem(d)))};return this.doSearch(b,i.BATCH_SIZE,u,w).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:c.stats}}))}clearCache(h){const p=this.getSessionTokenSource(h);p&&p.cancel()}getSessionTokenSource(h){if(!!h)return this.sessions.has(h)||this.sessions.set(h,new R.CancellationTokenSource),this.sessions.get(h)}rawMatchToSearchItem(h){return h.relativePath?{resource:y.joinPath(h.base,h.relativePath)}:{resource:h.base}}doSearch(h,p,a,w){w.onCancellationRequested(()=>{h.cancel()});const m=_=>{_&&(b.push(_),p>0&&b.length>=p&&(a(b),b=[]))};let b=[];return h.search(m).then(_=>(b.length&&a(b),_),_=>(b.length&&a(b),Promise.reject(_)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(me[129],ge([0,1,9,16,21,60,25,31,2,30,10,12]),function(K,e,v,R,C,T,y,P,D,I,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class h{constructor(u,c,d){this.query=u,this.provider=c,this.fileUtils=d,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,c){const d=this.query.folderQueries||[],t=new C.CancellationTokenSource;return c.onCancellationRequested(()=>t.cancel()),new Promise((n,s)=>{this.collector=new a(u);let r=!1;const o=(g,f)=>{if(!r&&!this.isLimitHit){const S=this.resultSize(g);m(g)&&typeof this.query.maxResults=="number"&&this.resultCount+S>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),g=this.trimResultToSize(g,this.query.maxResults-this.resultCount));const E=this.resultSize(g);this.resultCount+=E,(E>0||!m(g))&&this.collector.add(g,f)}};Promise.all(d.map((g,f)=>this.searchInFolder(g,S=>o(S,f),t.token))).then(g=>{t.dispose(),this.collector.flush();const f=g.some(S=>!!S&&!!S.limitHit);n({limitHit:this.isLimitHit||f,messages:(0,R.flatten)(g.map(S=>(S==null?void 0:S.message)?(0,A.isArray)(S.message)?S.message:[S.message]:[])),stats:{type:"textSearchProvider"}})},g=>{t.dispose();const f=(0,T.toErrorMessage)(g);s(new Error(f))})})}resultSize(u){return m(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,c){const d=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:d.slice(0,c),preview:{matches:t.slice(0,c),text:u.preview.text},uri:u.uri}}async searchInFolder(u,c,d){const t=new I.QueryGlobTester(this.query,u),n=[],s={report:g=>{if(!this.validateProviderResult(g))return;const f=u.folder.scheme===i.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(g.uri))):void 0,S=y.relativePath(u.folder,g.uri);S&&n.push(t.includedInQuery(S,v.basename(S),f).then(E=>{E&&c(g)}))}},r=this.getSearchOptionsForFolder(u),o=await this.provider.provideTextSearchResults(p(this.query.contentPattern),r,s,d);return await Promise.all(n),o}validateProviderResult(u){if(m(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const c=(0,I.resolvePatternsForProvider)(this.query.includePattern,u.includePattern),d=(0,I.resolvePatternsForProvider)(this.query.excludePattern,u.excludePattern),t={folder:D.URI.from(u.folder),excludes:d,includes:c,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=h;function p(_){return{isCaseSensitive:_.isCaseSensitive||!1,isRegExp:_.isRegExp||!1,isWordMatch:_.isWordMatch||!1,isMultiline:_.isMultiline||!1,pattern:_.pattern}}class a{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,c=>this.sendItems(c))}add(u,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!y.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(w(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=a;function w(_){return m(_)?{preview:{matches:(0,R.mapArrayOrNot)(_.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:_.preview.text},ranges:(0,R.mapArrayOrNot)(_.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:_.text,lineNumber:_.lineNumber}}function m(_){return!!_.preview}e.extensionResultIsMatch=m;class b{constructor(u,c){this.maxBatchSize=u,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,c){!u||this.addItemToBatch(u,c)}addItems(u,c){!u||this.addItemsToBatch(u,c)}addItemToBatch(u,c){this.batch.push(u),this.batchSize+=c,this.onUpdate()}addItemsToBatch(u,c){this.batch=this.batch.concat(u),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(me[71],ge([0,1,6,5,4,263,15,63,14,2,129]),function(K,e,v,R,C,T,y,P,D,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let A=class{constructor(w,m,b){this.extHostRpc=w,this._uriTransformer=m,this._logService=b,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,m){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const b=this._handlePool++;return this._textSearchProvider.set(b,m),this._proxy.$registerTextSearchProvider(b,this._transformScheme(w)),(0,v.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}registerFileSearchProvider(w,m){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const b=this._handlePool++;return this._fileSearchProvider.set(b,m),this._proxy.$registerFileSearchProvider(b,this._transformScheme(w)),(0,v.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}$provideFileSearchResults(w,m,b,_){const u=h(b),c=this._fileSearchProvider.get(w);if(c)return this._fileSearchManager.fileSearch(u,c,d=>{this._proxy.$handleFileMatch(w,m,d.map(t=>t.resource))},_);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,m,b,_){const u=this._textSearchProvider.get(w);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const c=h(b);return this.createTextSearchManager(c,u).search(t=>this._proxy.$handleTextMatch(w,m,t),_)}createTextSearchManager(w,m){return new i.TextSearchManager(w,m,{readdir:b=>Promise.resolve([]),toCanonicalName:b=>b})}};A=qe([He(0,y.IExtHostRpcService),He(1,P.IURITransformerService),He(2,D.ILogService)],A),e.ExtHostSearch=A;function h(a){return Object.assign(Object.assign({},a),{folderQueries:a.folderQueries&&a.folderQueries.map(p),extraFileResources:a.extraFileResources&&a.extraFileResources.map(w=>I.URI.revive(w))})}e.reviveQuery=h;function p(a){return Object.assign(Object.assign({},a),{folder:I.URI.revive(a.folder)})}}),define(me[264],ge([0,1,21,17,3,57,2,151,106,142,78,43,5,225,224,49,226,35,227,228,229,211,230,40,41,231,212,233,234,235,66,214,239,240,241,90,33,242,215,20,7,245,67,128,34,39,52,200,232,117,127,69,50,71,14,63,15,27,236,198,48,65,222,243,197,91,89,248,246,247,223,62,256,244,88,47,119,237,68,238,10,186]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w,m,b,_,u,c,d,t,n,s,r,o,g,f,S,E,l,L,O,W,te,se,N,V,x,k,U,F,M,$,H,X,ae,we,Le,Ie,Me,We,j,Y,ee,oe,pe,_e,de,Ee,Re,Ve,be,Ke,Q,ne,ve,xe,je,ze,Je,ye,De,ke,re,he,z,J,ce,Pe,Ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ne(Be){const Qe=Be.get(pe.IExtHostInitDataService),rt=Be.get(Je.IExtHostFileSystemInfo),et=Be.get(ne.IExtHostConsumerFileSystem),Xe=Be.get(s.IExtHostExtensionService),ot=Be.get($.IExtHostWorkspace),Et=Be.get(he.IExtHostTelemetry),bt=Be.get(b.IExtHostConfiguration),vt=Be.get(ee.IURITransformerService),le=Be.get(oe.IExtHostRpcService),Se=Be.get(te.IExtHostStorage),ue=Be.get(Q.IExtensionStoragePaths),G=Be.get(Y.ILogService),Ue=Be.get(Ee.IExtHostTunnelService),Fe=Be.get(Re.IExtHostApiDeprecationService),Ze=Be.get(M.IExtHostWindow),it=Be.get(ke.IExtHostSecretState),ct=Be.get(re.IExtHostEditorTabs);le.set(h.ExtHostContext.ExtHostFileSystemInfo,rt),le.set(h.ExtHostContext.ExtHostLogService,G),le.set(h.ExtHostContext.ExtHostWorkspace,ot),le.set(h.ExtHostContext.ExtHostConfiguration,bt),le.set(h.ExtHostContext.ExtHostExtensionService,Xe),le.set(h.ExtHostContext.ExtHostStorage,Se),le.set(h.ExtHostContext.ExtHostTunnelService,Ue),le.set(h.ExtHostContext.ExtHostWindow,Ze),le.set(h.ExtHostContext.ExtHostSecretState,it),le.set(h.ExtHostContext.ExtHostTelemetry,Et),le.set(h.ExtHostContext.ExtHostEditorTabs,ct);const gt=le.set(h.ExtHostContext.ExtHostDecorations,Be.get(Ie.IExtHostDecorations)),Ye=le.set(h.ExtHostContext.ExtHostDocumentsAndEditors,Be.get(n.IExtHostDocumentsAndEditors)),dt=le.set(h.ExtHostContext.ExtHostCommands,Be.get(w.IExtHostCommands)),at=le.set(h.ExtHostContext.ExtHostTerminalService,Be.get(se.IExtHostTerminalService)),lt=le.set(h.ExtHostContext.ExtHostDebugService,Be.get(We.IExtHostDebugService)),Pt=le.set(h.ExtHostContext.ExtHostSearch,Be.get(j.IExtHostSearch)),Ct=le.set(h.ExtHostContext.ExtHostTask,Be.get(Me.IExtHostTask)),At=le.set(h.ExtHostContext.ExtHostOutputService,Be.get(E.IExtHostOutputService)),Rt=le.set(h.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(le)),St=le.set(h.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(le,Ye)),Xt=le.set(h.ExtHostContext.ExtHostDocumentContentProviders,new c.ExtHostDocumentContentProvider(le,Ye,G)),Yt=le.set(h.ExtHostContext.ExtHostDocumentSaveParticipant,new d.ExtHostDocumentSaveParticipant(G,St,le.getProxy(h.MainContext.MainThreadBulkEdits))),mt=le.set(h.ExtHostContext.ExtHostNotebook,new _e.ExtHostNotebookController(le,dt,Ye,St,G,ue)),Jt=le.set(h.ExtHostContext.ExtHostNotebookKernels,new z.ExtHostNotebookKernels(le,Qe,mt,G)),Zt=le.set(h.ExtHostContext.ExtHostNotebookRenderers,new ce.ExtHostNotebookRenderers(le,mt)),Dt=le.set(h.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(le,Ye)),dn=le.set(h.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(le.getProxy(h.MainContext.MainThreadTreeViews),dt,G)),en=le.set(h.ExtHostContext.ExtHostEditorInsets,new ae.ExtHostEditorInsets(le.getProxy(h.MainContext.MainThreadEditorInsets),Dt,Qe)),xt=le.set(h.ExtHostContext.ExtHostDiagnostics,new _.ExtHostDiagnostics(le,G)),ht=le.set(h.ExtHostContext.ExtHostLanguageFeatures,new g.ExtHostLanguageFeatures(le,vt,St,dt,xt,G,Fe)),tn=le.set(h.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(le,ht)),Ft=le.set(h.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(le,G,Ye)),Mt=le.set(h.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(le,ot,dt)),qt=le.set(h.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(le,dt,G)),wn=le.set(h.ExtHostContext.ExtHostComments,new m.ExtHostComments(le,dt,St)),hn=le.set(h.ExtHostContext.ExtHostProgress,new l.ExtHostProgress(le.getProxy(h.MainContext.MainThreadProgress))),bn=le.set(h.ExtHostContext.ExtHosLabelService,new we.ExtHostLabelService(le)),fn=le.set(h.ExtHostContext.ExtHostTheming,new de.ExtHostTheming(le)),Bt=le.set(h.ExtHostContext.ExtHostAuthentication,new Ve.ExtHostAuthentication(le)),nn=le.set(h.ExtHostContext.ExtHostTimeline,new be.ExtHostTimeline(le,dt)),Ht=le.set(h.ExtHostContext.ExtHostWebviews,new F.ExtHostWebviews(le,{remote:Qe.remote},ot,G,Fe)),rn=le.set(h.ExtHostContext.ExtHostWebviewPanels,new je.ExtHostWebviewPanels(le,Ht,ot)),En=le.set(h.ExtHostContext.ExtHostCustomEditors,new xe.ExtHostCustomEditors(le,St,ue,Ht,rn)),_n=le.set(h.ExtHostContext.ExtHostWebviewViews,new ve.ExtHostWebviewViews(le,Ht)),Ot=le.set(h.ExtHostContext.ExtHostTesting,new ye.ExtHostTesting(le,Ye,ot)),Kt=le.set(h.ExtHostContext.ExtHostUriOpeners,new De.ExtHostUriOpeners(le)),Sn=(0,X.values)(h.ExtHostContext);le.assertRegistered(Sn);const yn=new ze.ExtHostBulkEdits(le,Ye),sn=new a.ExtHostClipboard(le),on=new S.ExtHostMessageService(le,G),$t=new u.ExtHostDialogs(le),Gt=new W.ExtHostStatusBar(le,dt.converter),Wt=new f.ExtHostLanguages(le,St);return p.ExtHostApiCommands.register(dt),function(Oe,an,It){const pt=function(){let Z=!Oe.isUnderDevelopment;function fe(Te){Z||(G.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function Te(st){if(Array.isArray(st))st.forEach(Te);else if(typeof st=="string")fe(st);else{const wt=st;typeof wt.scheme=="undefined"&&fe(st),!Oe.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,H.throwProposedApiError)(Oe)}return st}}(),Dn={getSession(Z,fe,Te){return Bt.getSession(Oe,Z,fe,Te)},get onDidChangeSessions(){return Bt.onDidChangeSessions},registerAuthenticationProvider(Z,fe,Te,st){return Bt.registerAuthenticationProvider(Z,fe,Te,st)},get onDidChangeAuthenticationProviders(){return(0,H.checkProposedApiEnabled)(Oe),Bt.onDidChangeAuthenticationProviders},get providers(){return(0,H.checkProposedApiEnabled)(Oe),Bt.providers},logout(Z,fe){return(0,H.checkProposedApiEnabled)(Oe),Bt.removeSession(Z,fe)}},Cn={registerCommand(Z,fe,Te){return dt.registerCommand(!0,Z,fe,Te)},registerTextEditorCommand(Z,fe,Te){return dt.registerCommand(!0,Z,(...st)=>{const wt=Dt.getActiveTextEditor();if(!wt){G.warn("Cannot execute "+Z+" because there is no active text editor.");return}return wt.edit(_t=>{fe.apply(Te,[wt,_t,...st])}).then(_t=>{_t||G.warn("Edits from command "+Z+" were not applied.")},_t=>{G.warn("An error occurred while running command "+Z,_t)})})},registerDiffInformationCommand:(Z,fe,Te)=>((0,H.checkProposedApiEnabled)(Oe),dt.registerCommand(!0,Z,async(...st)=>{const wt=Ye.activeEditor(!0);if(!wt){G.warn("Cannot execute "+Z+" because there is no active text editor.");return}const _t=await Dt.getDiffInformation(wt.id);fe.apply(Te,[_t,...st])})),executeCommand(Z,...fe){return dt.executeCommand(Z,...fe)},getCommands(Z=!1){return dt.getCommands(Z)}},mn={get machineId(){return Qe.telemetryInfo.machineId},get sessionId(){return Qe.telemetryInfo.sessionId},get language(){return Qe.environment.appLanguage},get appName(){return Qe.environment.appName},get appRoot(){var Z,fe;return(fe=(Z=Qe.environment.appRoot)===null||Z===void 0?void 0:Z.fsPath)!==null&&fe!==void 0?fe:""},get uriScheme(){return Qe.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return at.getDefaultShell(!1)},get isTelemetryEnabled(){return Et.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Et.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Z=Date.now()-new Date(Qe.telemetryInfo.firstSessionDate).getTime();return isNaN(Z)?!1:Z<1e3*60*60*24},openExternal(Z,fe){return Ze.openUri(Z,{allowTunneling:!!Qe.remote.authority,allowContributedOpeners:fe==null?void 0:fe.allowContributedOpeners})},asExternalUri(Z){return Z.scheme===Qe.environment.appUriScheme?Rt.createAppUri(Z):(!(0,Ae.matchesScheme)(Z.scheme,Pe.Schemas.http)&&!(0,Ae.matchesScheme)(Z.scheme,Pe.Schemas.https)&&(0,H.checkProposedApiEnabled)(Oe),Ze.asExternalUri(Z,{allowTunneling:!!Qe.remote.authority}))},get remoteName(){return(0,Le.getRemoteName)(Qe.remote.authority)},get uiKind(){return Qe.uiKind}};Qe.environment.extensionTestsLocationURI||Object.freeze(mn);const gn=Qe.remote.isRemote?k.ExtensionKind.Workspace:k.ExtensionKind.UI,kn={registerTestController(Z){return Ot.registerTestController(Oe.identifier.value,Z)},createDocumentTestObserver(Z){return(0,H.checkProposedApiEnabled)(Oe),Ot.createTextDocumentTestObserver(Z)},createWorkspaceTestObserver(Z){return(0,H.checkProposedApiEnabled)(Oe),Ot.createWorkspaceTestObserver(Z)},runTests(Z){return Ot.runTests(Z)},createTestItem(Z,fe){return new k.TestItemImpl(Z.id,Z.label,Z.uri,fe)},createTestRun(Z,fe,Te){return Ot.createTestRun(Oe.identifier.value,Z,fe,Te)},get onDidChangeTestResults(){return(0,H.checkProposedApiEnabled)(Oe),Ot.onResultsChanged},get testResults(){return(0,H.checkProposedApiEnabled)(Oe),Ot.results}},In={getExtension(Z){const fe=an.getExtensionDescription(Z);if(fe)return new s.Extension(Xe,Oe.identifier,fe,gn)},get all(){return an.getAllExtensionDescriptions().map(Z=>new s.Extension(Xe,Oe.identifier,Z,gn))},get onDidChange(){return an.onDidChange}},Pn={createDiagnosticCollection(Z){return xt.createDiagnosticCollection(Oe.identifier,Z)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:Z=>xt.getDiagnostics(Z),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(Z,fe){return Wt.changeLanguage(Z.uri,fe)},match(Z,fe){return(0,i.score)(x.LanguageSelector.from(Z),fe.uri,fe.languageId,!0)},registerCodeActionsProvider(Z,fe,Te){return ht.registerCodeActionProvider(Oe,pt(Z),fe,Te)},registerCodeLensProvider(Z,fe){return ht.registerCodeLensProvider(Oe,pt(Z),fe)},registerDefinitionProvider(Z,fe){return ht.registerDefinitionProvider(Oe,pt(Z),fe)},registerDeclarationProvider(Z,fe){return ht.registerDeclarationProvider(Oe,pt(Z),fe)},registerImplementationProvider(Z,fe){return ht.registerImplementationProvider(Oe,pt(Z),fe)},registerTypeDefinitionProvider(Z,fe){return ht.registerTypeDefinitionProvider(Oe,pt(Z),fe)},registerHoverProvider(Z,fe){return ht.registerHoverProvider(Oe,pt(Z),fe,Oe.identifier)},registerEvaluatableExpressionProvider(Z,fe){return ht.registerEvaluatableExpressionProvider(Oe,pt(Z),fe,Oe.identifier)},registerInlineValuesProvider(Z,fe){return ht.registerInlineValuesProvider(Oe,pt(Z),fe,Oe.identifier)},registerDocumentHighlightProvider(Z,fe){return ht.registerDocumentHighlightProvider(Oe,pt(Z),fe)},registerLinkedEditingRangeProvider(Z,fe){return ht.registerLinkedEditingRangeProvider(Oe,pt(Z),fe)},registerReferenceProvider(Z,fe){return ht.registerReferenceProvider(Oe,pt(Z),fe)},registerRenameProvider(Z,fe){return ht.registerRenameProvider(Oe,pt(Z),fe)},registerDocumentSymbolProvider(Z,fe,Te){return ht.registerDocumentSymbolProvider(Oe,pt(Z),fe,Te)},registerWorkspaceSymbolProvider(Z){return ht.registerWorkspaceSymbolProvider(Oe,Z)},registerDocumentFormattingEditProvider(Z,fe){return ht.registerDocumentFormattingEditProvider(Oe,pt(Z),fe)},registerDocumentRangeFormattingEditProvider(Z,fe){return ht.registerDocumentRangeFormattingEditProvider(Oe,pt(Z),fe)},registerOnTypeFormattingEditProvider(Z,fe,Te,...st){return ht.registerOnTypeFormattingEditProvider(Oe,pt(Z),fe,[Te].concat(st))},registerDocumentSemanticTokensProvider(Z,fe,Te){return ht.registerDocumentSemanticTokensProvider(Oe,pt(Z),fe,Te)},registerDocumentRangeSemanticTokensProvider(Z,fe,Te){return ht.registerDocumentRangeSemanticTokensProvider(Oe,pt(Z),fe,Te)},registerSignatureHelpProvider(Z,fe,Te,...st){return typeof Te=="object"?ht.registerSignatureHelpProvider(Oe,pt(Z),fe,Te):ht.registerSignatureHelpProvider(Oe,pt(Z),fe,typeof Te=="undefined"?[]:[Te,...st])},registerCompletionItemProvider(Z,fe,...Te){return ht.registerCompletionItemProvider(Oe,pt(Z),fe,Te)},registerInlineCompletionItemProvider(Z,fe){return(0,H.checkProposedApiEnabled)(Oe),ht.registerInlineCompletionsProvider(Oe,pt(Z),fe)},registerDocumentLinkProvider(Z,fe){return ht.registerDocumentLinkProvider(Oe,pt(Z),fe)},registerColorProvider(Z,fe){return ht.registerColorProvider(Oe,pt(Z),fe)},registerFoldingRangeProvider(Z,fe){return ht.registerFoldingRangeProvider(Oe,pt(Z),fe)},registerSelectionRangeProvider(Z,fe){return ht.registerSelectionRangeProvider(Oe,Z,fe)},registerCallHierarchyProvider(Z,fe){return ht.registerCallHierarchyProvider(Oe,Z,fe)},setLanguageConfiguration:(Z,fe)=>ht.setLanguageConfiguration(Oe,Z,fe),getTokenInformationAtPosition(Z,fe){return(0,H.checkProposedApiEnabled)(Oe),Wt.tokenAtPosition(Z,fe)},registerInlayHintsProvider(Z,fe){return(0,H.checkProposedApiEnabled)(Oe),ht.registerInlayHintsProvider(Oe,Z,fe)}},ln={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return at.activeTerminal},get terminals(){return at.terminals},async showTextDocument(Z,fe,Te){const st=await(y.URI.isUri(Z)?Promise.resolve(pn.openTextDocument(Z)):Promise.resolve(Z));return Dt.showTextDocument(st,fe,Te)},createTextEditorDecorationType(Z){return Dt.createTextEditorDecorationType(Z)},onDidChangeActiveTextEditor(Z,fe,Te){return Dt.onDidChangeActiveTextEditor(Z,fe,Te)},onDidChangeVisibleTextEditors(Z,fe,Te){return Dt.onDidChangeVisibleTextEditors(Z,fe,Te)},onDidChangeTextEditorSelection(Z,fe,Te){return Dt.onDidChangeTextEditorSelection(Z,fe,Te)},onDidChangeTextEditorOptions(Z,fe,Te){return Dt.onDidChangeTextEditorOptions(Z,fe,Te)},onDidChangeTextEditorVisibleRanges(Z,fe,Te){return Dt.onDidChangeTextEditorVisibleRanges(Z,fe,Te)},onDidChangeTextEditorViewColumn(Z,fe,Te){return Dt.onDidChangeTextEditorViewColumn(Z,fe,Te)},onDidCloseTerminal(Z,fe,Te){return at.onDidCloseTerminal(Z,fe,Te)},onDidOpenTerminal(Z,fe,Te){return at.onDidOpenTerminal(Z,fe,Te)},onDidChangeActiveTerminal(Z,fe,Te){return at.onDidChangeActiveTerminal(Z,fe,Te)},onDidChangeTerminalDimensions(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Oe),at.onDidChangeTerminalDimensions(Z,fe,Te)},onDidWriteTerminalData(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Oe),at.onDidWriteTerminalData(Z,fe,Te)},get state(){return Ze.state},onDidChangeWindowState(Z,fe,Te){return Ze.onDidChangeWindowState(Z,fe,Te)},showInformationMessage(Z,...fe){return on.showMessage(Oe,T.default.Info,Z,fe[0],fe.slice(1))},showWarningMessage(Z,...fe){return on.showMessage(Oe,T.default.Warning,Z,fe[0],fe.slice(1))},showErrorMessage(Z,...fe){return on.showMessage(Oe,T.default.Error,Z,fe[0],fe.slice(1))},showQuickPick(Z,fe,Te){return Mt.showQuickPick(Z,!!Oe.enableProposedApi,fe,Te)},showWorkspaceFolderPick(Z){return Mt.showWorkspaceFolderPick(Z)},showInputBox(Z,fe){return Mt.showInput(Z,fe)},showOpenDialog(Z){return $t.showOpenDialog(Z)},showSaveDialog(Z){return $t.showSaveDialog(Z)},createStatusBarItem(Z,fe,Te){let st,wt,_t;return typeof Z=="string"?(st=Z,wt=fe,_t=Te):(wt=Z,_t=fe),Gt.createStatusBarEntry(Oe,st,wt,_t)},setStatusBarMessage(Z,fe){return Gt.setStatusBarMessage(Z,fe)},withScmProgress(Z){return Fe.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),hn.withProgress(Oe,{location:k.ProgressLocation.SourceControl},(fe,Te)=>Z({report(st){}}))},withProgress(Z,fe){return hn.withProgress(Oe,Z,fe)},createOutputChannel(Z){return At.createOutputChannel(Z)},createWebviewPanel(Z,fe,Te,st){return rn.createWebviewPanel(Oe,Z,fe,Te,st)},createWebviewTextEditorInset(Z,fe,Te,st){return(0,H.checkProposedApiEnabled)(Oe),en.createWebviewEditorInset(Z,fe,Te,st,Oe)},createTerminal(Z,fe,Te){return typeof Z=="object"?"pty"in Z?at.createExtensionTerminal(Z):(Z.iconPath&&(0,H.checkProposedApiEnabled)(Oe),at.createTerminalFromOptions(Z)):at.createTerminal(Z,fe,Te)},registerTerminalLinkProvider(Z){return at.registerLinkProvider(Z)},registerTreeDataProvider(Z,fe){return dn.registerTreeDataProvider(Z,fe,Oe)},createTreeView(Z,fe){return dn.createTreeView(Z,fe,Oe)},registerWebviewPanelSerializer:(Z,fe)=>rn.registerWebviewPanelSerializer(Oe,Z,fe),registerCustomEditorProvider:(Z,fe,Te={})=>En.registerCustomEditorProvider(Oe,Z,fe,Te),registerFileDecorationProvider(Z){return gt.registerFileDecorationProvider(Z,Oe.identifier)},registerUriHandler(Z){return Rt.registerUriHandler(Oe.identifier,Z)},createQuickPick(){return Mt.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return Mt.createInputBox(Oe.identifier)},get activeColorTheme(){return fn.activeColorTheme},onDidChangeActiveColorTheme(Z,fe,Te){return fn.onDidChangeActiveColorTheme(Z,fe,Te)},registerWebviewViewProvider(Z,fe,Te){return _n.registerWebviewViewProvider(Oe,Z,fe,Te==null?void 0:Te.webviewOptions)},get activeNotebookEditor(){return(0,H.checkProposedApiEnabled)(Oe),mt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Oe),mt.onDidChangeActiveNotebookEditor(Z,fe,Te)},get visibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Oe),mt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Oe),mt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Oe),mt.onDidChangeNotebookEditorSelection(Z,fe,Te)},onDidChangeNotebookEditorVisibleRanges(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Oe),mt.onDidChangeNotebookEditorVisibleRanges(Z,fe,Te)},showNotebookDocument(Z,fe){return(0,H.checkProposedApiEnabled)(Oe),mt.showNotebookDocument(Z,fe)},registerExternalUriOpener(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Oe),Kt.registerExternalUriOpener(Oe.identifier,Z,fe,Te)},get openEditors(){return(0,H.checkProposedApiEnabled)(Oe),ct.tabs},get onDidChangeOpenEditors(){return(0,H.checkProposedApiEnabled)(Oe),ct.onDidChangeTabs}},pn={get rootPath(){return Fe.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(Z){throw R.readonly()},getWorkspaceFolder(Z){return ot.getWorkspaceFolder(Z)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(Z){throw R.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(Z){throw R.readonly()},updateWorkspaceFolders:(Z,fe,...Te)=>ot.updateWorkspaceFolders(Oe,Z,fe||0,...Te),onDidChangeWorkspaceFolders:function(Z,fe,Te){return ot.onDidChangeWorkspace(Z,fe,Te)},asRelativePath:(Z,fe)=>ot.getRelativePath(Z,fe),findFiles:(Z,fe,Te,st)=>ot.findFiles(x.GlobPattern.from(Z),x.GlobPattern.from(fe),Te,Oe.identifier,st),findTextInFiles:(Z,fe,Te,st)=>{let wt,_t;return typeof fe=="object"?(wt=fe,_t=Te):(wt={},_t=fe,st=Te),ot.findTextInFiles(Z,wt||{},_t,Oe.identifier,st)},saveAll:Z=>ot.saveAll(Z),applyEdit(Z){return yn.applyWorkspaceEdit(Z)},createFileSystemWatcher:(Z,fe,Te,st)=>Ft.createFileSystemWatcher(x.GlobPattern.from(Z),fe,Te,st),get textDocuments(){return St.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw R.readonly()},openTextDocument(Z){let fe;const Te=Z;if(typeof Z=="string")fe=Promise.resolve(y.URI.file(Z));else if(y.URI.isUri(Z))fe=Promise.resolve(Z);else if(!Te||typeof Te=="object")fe=St.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(st=>St.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(Z,fe,Te)=>St.onDidAddDocument(Z,fe,Te),onDidCloseTextDocument:(Z,fe,Te)=>St.onDidRemoveDocument(Z,fe,Te),onDidChangeTextDocument:(Z,fe,Te)=>St.onDidChangeDocument(Z,fe,Te),onDidSaveTextDocument:(Z,fe,Te)=>St.onDidSaveDocument(Z,fe,Te),onWillSaveTextDocument:(Z,fe,Te)=>Yt.getOnWillSaveTextDocumentEvent(Oe)(Z,fe,Te),onDidChangeConfiguration:(Z,fe,Te)=>It.onDidChangeConfiguration(Z,fe,Te),getConfiguration(Z,fe){return fe=arguments.length===1?void 0:fe,It.getConfiguration(Z,fe,Oe)},registerTextDocumentContentProvider(Z,fe){return Xt.registerTextDocumentContentProvider(Z,fe)},registerTaskProvider:(Z,fe)=>(Fe.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(Oe,Z,fe)),registerFileSystemProvider(Z,fe,Te){return tn.registerFileSystemProvider(Oe.identifier,Z,fe,Te,Oe.enableProposedApi)},get fs(){return et.value},registerFileSearchProvider:(Z,fe)=>((0,H.checkProposedApiEnabled)(Oe),Pt.registerFileSearchProvider(Z,fe)),registerTextSearchProvider:(Z,fe)=>((0,H.checkProposedApiEnabled)(Oe),Pt.registerTextSearchProvider(Z,fe)),registerRemoteAuthorityResolver:(Z,fe)=>((0,H.checkProposedApiEnabled)(Oe),Xe.registerRemoteAuthorityResolver(Z,fe)),registerResourceLabelFormatter:Z=>((0,H.checkProposedApiEnabled)(Oe),bn.$registerResourceLabelFormatter(Z)),onDidCreateFiles:(Z,fe,Te)=>Ft.onDidCreateFile(Z,fe,Te),onDidDeleteFiles:(Z,fe,Te)=>Ft.onDidDeleteFile(Z,fe,Te),onDidRenameFiles:(Z,fe,Te)=>Ft.onDidRenameFile(Z,fe,Te),onWillCreateFiles:(Z,fe,Te)=>Ft.getOnWillCreateFileEvent(Oe)(Z,fe,Te),onWillDeleteFiles:(Z,fe,Te)=>Ft.getOnWillDeleteFileEvent(Oe)(Z,fe,Te),onWillRenameFiles:(Z,fe,Te)=>Ft.getOnWillRenameFileEvent(Oe)(Z,fe,Te),openTunnel:Z=>((0,H.checkProposedApiEnabled)(Oe),Ue.openTunnel(Oe,Z).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,H.checkProposedApiEnabled)(Oe),Ue.getTunnels()},onDidChangeTunnels:(Z,fe,Te)=>((0,H.checkProposedApiEnabled)(Oe),Ue.onDidChangeTunnels(Z,fe,Te)),registerPortAttributesProvider:(Z,fe)=>((0,H.checkProposedApiEnabled)(Oe),Ue.registerPortsAttributesProvider(Z,fe)),registerTimelineProvider:(Z,fe)=>((0,H.checkProposedApiEnabled)(Oe),nn.registerTimelineProvider(Z,fe,Oe.identifier,dt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:Z=>((0,H.checkProposedApiEnabled)(Oe),ot.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,fe,Te)=>ot.onDidGrantWorkspaceTrust(Z,fe,Te)},An={get inputBox(){return Fe.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),qt.getLastInputBox(Oe)},createSourceControl(Z,fe,Te){return qt.createSourceControl(Oe,Z,fe,Te)}},Tn={createCommentController(Z,fe){return wn.createCommentController(Oe,Z,fe)}},Rn={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(Z,fe,Te){return lt.onDidStartDebugSession(Z,fe,Te)},onDidTerminateDebugSession(Z,fe,Te){return lt.onDidTerminateDebugSession(Z,fe,Te)},onDidChangeActiveDebugSession(Z,fe,Te){return lt.onDidChangeActiveDebugSession(Z,fe,Te)},onDidReceiveDebugSessionCustomEvent(Z,fe,Te){return lt.onDidReceiveDebugSessionCustomEvent(Z,fe,Te)},onDidChangeBreakpoints(Z,fe,Te){return lt.onDidChangeBreakpoints(Z,fe,Te)},registerDebugConfigurationProvider(Z,fe,Te){return lt.registerDebugConfigurationProvider(Z,fe,Te||k.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,fe){return lt.registerDebugAdapterDescriptorFactory(Oe,Z,fe)},registerDebugAdapterTrackerFactory(Z,fe){return lt.registerDebugAdapterTrackerFactory(Z,fe)},startDebugging(Z,fe,Te){return!Te||typeof Te=="object"&&"configuration"in Te?lt.startDebugging(Z,fe,{parentSession:Te}):lt.startDebugging(Z,fe,Te||{})},stopDebugging(Z){return lt.stopDebugging(Z)},addBreakpoints(Z){return lt.addBreakpoints(Z)},removeBreakpoints(Z){return lt.removeBreakpoints(Z)},asDebugSourceUri(Z,fe){return lt.asDebugSourceUri(Z,fe)}},Ln={registerTaskProvider:(Z,fe)=>Ct.registerTaskProvider(Oe,Z,fe),fetchTasks:Z=>Ct.fetchTasks(Z),executeTask:Z=>Ct.executeTask(Oe,Z),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(Z,fe,Te)=>Ct.onDidStartTask(Z,fe,Te),onDidEndTask:(Z,fe,Te)=>Ct.onDidEndTask(Z,fe,Te),onDidStartTaskProcess:(Z,fe,Te)=>Ct.onDidStartTaskProcess(Z,fe,Te),onDidEndTaskProcess:(Z,fe,Te)=>Ct.onDidEndTaskProcess(Z,fe,Te)},Fn={async openNotebookDocument(Z,fe){(0,H.checkProposedApiEnabled)(Oe);let Te;if(y.URI.isUri(Z))Te=Z,await mt.openNotebookDocument(Z);else if(typeof Z=="string")Te=y.URI.revive(await mt.createNotebookDocument({viewType:Z,content:fe}));else throw new Error("Invalid arguments");return mt.getNotebookDocument(Te).apiNotebook},get onDidOpenNotebookDocument(){return(0,H.checkProposedApiEnabled)(Oe),mt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,H.checkProposedApiEnabled)(Oe),mt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,H.checkProposedApiEnabled)(Oe),mt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,H.checkProposedApiEnabled)(Oe),mt.notebookDocuments.map(Z=>Z.apiNotebook)},registerNotebookSerializer(Z,fe,Te,st){return(0,H.checkProposedApiEnabled)(Oe),mt.registerNotebookSerializer(Oe,Z,fe,Te,Oe.enableProposedApi?st:void 0)},registerNotebookContentProvider:(Z,fe,Te,st)=>((0,H.checkProposedApiEnabled)(Oe),mt.registerNotebookContentProvider(Oe,Z,fe,Te,Oe.enableProposedApi?st:void 0)),registerNotebookCellStatusBarItemProvider:(Z,fe)=>((0,H.checkProposedApiEnabled)(Oe),mt.registerNotebookCellStatusBarItemProvider(Oe,Z,fe)),createNotebookEditorDecorationType(Z){return(0,H.checkProposedApiEnabled)(Oe),mt.createNotebookEditorDecorationType(Z)},createRendererMessaging(Z){return(0,H.checkProposedApiEnabled)(Oe),Zt.createRendererMessaging(Z)},onDidChangeNotebookDocumentMetadata(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Oe),mt.onDidChangeNotebookDocumentMetadata(Z,fe,Te)},onDidChangeNotebookCells(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Oe),mt.onDidChangeNotebookCells(Z,fe,Te)},onDidChangeNotebookCellExecutionState(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Oe),mt.onDidChangeNotebookCellExecutionState(Z,fe,Te)},onDidChangeCellOutputs(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Oe),mt.onDidChangeCellOutputs(Z,fe,Te)},onDidChangeCellMetadata(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Oe),mt.onDidChangeCellMetadata(Z,fe,Te)},createConcatTextDocument(Z,fe){return(0,H.checkProposedApiEnabled)(Oe),new Ke.ExtHostNotebookConcatDocument(mt,St,Z,fe)},createNotebookController(Z,fe,Te,st,wt){return(0,H.checkProposedApiEnabled)(Oe),Jt.createNotebookController(Oe,Z,fe,Te,st,wt)}};return{version:Qe.version,authentication:Dn,commands:Cn,comments:Tn,debug:Rn,env:mn,extensions:In,languages:Pn,notebook:Fn,scm:An,tasks:Ln,test:kn,window:ln,workspace:pn,Breakpoint:k.Breakpoint,CallHierarchyIncomingCall:k.CallHierarchyIncomingCall,CallHierarchyItem:k.CallHierarchyItem,CallHierarchyOutgoingCall:k.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:v.CancellationTokenSource,CandidatePortSource:h.CandidatePortSource,CodeAction:k.CodeAction,CodeActionKind:k.CodeActionKind,CodeActionTriggerKind:k.CodeActionTriggerKind,CodeLens:k.CodeLens,Color:k.Color,ColorInformation:k.ColorInformation,ColorPresentation:k.ColorPresentation,ColorThemeKind:k.ColorThemeKind,CommentMode:k.CommentMode,CommentThreadCollapsibleState:k.CommentThreadCollapsibleState,CompletionItem:k.CompletionItem,CompletionItemKind:k.CompletionItemKind,CompletionItemTag:k.CompletionItemTag,CompletionList:k.CompletionList,CompletionTriggerKind:k.CompletionTriggerKind,ConfigurationTarget:k.ConfigurationTarget,CustomExecution:k.CustomExecution,DebugAdapterExecutable:k.DebugAdapterExecutable,DebugAdapterInlineImplementation:k.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:k.DebugAdapterNamedPipeServer,DebugAdapterServer:k.DebugAdapterServer,DebugConfigurationProviderTriggerKind:k.DebugConfigurationProviderTriggerKind,DebugConsoleMode:k.DebugConsoleMode,DecorationRangeBehavior:k.DecorationRangeBehavior,Diagnostic:k.Diagnostic,DiagnosticRelatedInformation:k.DiagnosticRelatedInformation,DiagnosticSeverity:k.DiagnosticSeverity,DiagnosticTag:k.DiagnosticTag,Disposable:k.Disposable,DocumentHighlight:k.DocumentHighlight,DocumentHighlightKind:k.DocumentHighlightKind,DocumentLink:k.DocumentLink,DocumentSymbol:k.DocumentSymbol,EndOfLine:k.EndOfLine,EnvironmentVariableMutatorType:k.EnvironmentVariableMutatorType,EvaluatableExpression:k.EvaluatableExpression,InlineValueText:k.InlineValueText,InlineValueVariableLookup:k.InlineValueVariableLookup,InlineValueEvaluatableExpression:k.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:k.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:k.ExtensionKind,ExtensionMode:k.ExtensionMode,ExternalUriOpenerPriority:k.ExternalUriOpenerPriority,FileChangeType:k.FileChangeType,FileDecoration:k.FileDecoration,FileSystemError:k.FileSystemError,FileType:A.FileType,FilePermission:A.FilePermission,FoldingRange:k.FoldingRange,FoldingRangeKind:k.FoldingRangeKind,FunctionBreakpoint:k.FunctionBreakpoint,InlineCompletionItem:k.InlineSuggestion,InlineCompletionList:k.InlineSuggestions,Hover:k.Hover,IndentAction:I.IndentAction,Location:k.Location,MarkdownString:k.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:k.ParameterInformation,PortAutoForwardAction:k.PortAutoForwardAction,Position:k.Position,ProcessExecution:k.ProcessExecution,ProgressLocation:k.ProgressLocation,QuickInputButtons:k.QuickInputButtons,Range:k.Range,RelativePattern:k.RelativePattern,Selection:k.Selection,SelectionRange:k.SelectionRange,SemanticTokens:k.SemanticTokens,SemanticTokensBuilder:k.SemanticTokensBuilder,SemanticTokensEdit:k.SemanticTokensEdit,SemanticTokensEdits:k.SemanticTokensEdits,SemanticTokensLegend:k.SemanticTokensLegend,ShellExecution:k.ShellExecution,ShellQuoting:k.ShellQuoting,SignatureHelp:k.SignatureHelp,SignatureHelpTriggerKind:k.SignatureHelpTriggerKind,SignatureInformation:k.SignatureInformation,SnippetString:k.SnippetString,SourceBreakpoint:k.SourceBreakpoint,StandardTokenType:k.StandardTokenType,StatusBarAlignment:k.StatusBarAlignment,SymbolInformation:k.SymbolInformation,SymbolKind:k.SymbolKind,SymbolTag:k.SymbolTag,Task:k.Task,TaskGroup:k.TaskGroup,TaskPanelKind:k.TaskPanelKind,TaskRevealKind:k.TaskRevealKind,TaskScope:k.TaskScope,TextDocumentSaveReason:k.TextDocumentSaveReason,TextEdit:k.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:k.TextEditorLineNumbersStyle,TextEditorRevealType:k.TextEditorRevealType,TextEditorSelectionChangeKind:k.TextEditorSelectionChangeKind,ThemeColor:k.ThemeColor,ThemeIcon:k.ThemeIcon,TreeItem:k.TreeItem,TreeItemCollapsibleState:k.TreeItemCollapsibleState,UIKind:h.UIKind,Uri:y.URI,ViewColumn:k.ViewColumn,WorkspaceEdit:k.WorkspaceEdit,InlayHint:k.InlayHint,InlayHintKind:k.InlayHintKind,RemoteAuthorityResolverError:k.RemoteAuthorityResolverError,ResolvedAuthority:k.ResolvedAuthority,SourceControlInputBoxValidationType:k.SourceControlInputBoxValidationType,ExtensionRuntime:k.ExtensionRuntime,TimelineItem:k.TimelineItem,NotebookRange:k.NotebookRange,NotebookCellKind:k.NotebookCellKind,NotebookCellExecutionState:k.NotebookCellExecutionState,NotebookDocumentMetadata:k.NotebookDocumentMetadata,NotebookCellMetadata:k.NotebookCellMetadata,NotebookCellData:k.NotebookCellData,NotebookData:k.NotebookData,NotebookKernelPreload:k.NotebookKernelPreload,NotebookCellStatusBarAlignment:k.NotebookCellStatusBarAlignment,NotebookEditorRevealType:k.NotebookEditorRevealType,NotebookCellOutput:k.NotebookCellOutput,NotebookCellOutputItem:k.NotebookCellOutputItem,NotebookCellStatusBarItem:k.NotebookCellStatusBarItem,NotebookControllerAffinity:k.NotebookControllerAffinity,PortAttributes:k.PortAttributes,LinkedEditingRanges:k.LinkedEditingRanges,TestItemStatus:k.TestItemStatus,TestResultState:k.TestResultState,TestMessage:k.TestMessage,TextSearchCompleteMessageType:J.TextSearchCompleteMessageType,TestMessageSeverity:k.TestMessageSeverity,WorkspaceTrustState:k.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ne}),define(me[265],ge([0,1,79,66,34,127,35,49,40,33,69,50,71,91,90,48,65,128,89,62,88,119,47]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w,m,b,_,u,c,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.registerSingleton)(p.IExtensionStoragePaths,p.ExtensionStoragePaths),(0,v.registerSingleton)(m.IExtHostApiDeprecationService,m.ExtHostApiDeprecationService),(0,v.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,v.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,v.registerSingleton)(_.IExtHostConsumerFileSystem,_.ExtHostConsumerFileSystem),(0,v.registerSingleton)(A.IExtHostDebugService,A.WorkerExtHostDebugService),(0,v.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,v.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,v.registerSingleton)(u.IExtHostFileSystemInfo,u.ExtHostFileSystemInfo),(0,v.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,v.registerSingleton)(h.IExtHostSearch,h.ExtHostSearch),(0,v.registerSingleton)(a.IExtHostStorage,a.ExtHostStorage),(0,v.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,v.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService),(0,v.registerSingleton)(w.IExtHostTunnelService,w.ExtHostTunnelService),(0,v.registerSingleton)(b.IExtHostWindow,b.ExtHostWindow),(0,v.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace),(0,v.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,v.registerSingleton)(d.IExtHostTelemetry,d.ExtHostTelemetry),(0,v.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(me[92],ge([0,1,16,14,30,68]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(A){return A.startsWith("**")||A.startsWith("/")?A:`/${A}`}e.anchorGlob=y;function P(A,h,p,a){const w=(0,v.mapArrayOrNot)(p,D),m=new C.TextSearchMatch(h,w,a),b=m.preview.matches;return{ranges:(0,v.mapArrayOrNot)(w,I),uri:A,preview:{text:m.preview.text,matches:(0,v.mapArrayOrNot)(b,I)}}}e.createTextSearchResult=P;function D(A){return new C.SearchRange(A.start.line,A.start.character,A.end.line,A.end.character)}function I(A){return new T.Range(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn)}let i=class{constructor(h,p){this.prefix=h,this.logService=p}appendLine(h){this.logService.debug(`${this.prefix}#search`,h)}};i=qe([He(1,R.ILogService)],i),e.OutputChannel=i}),define(me[266],ge([0,1,93,22]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const T=512,y=512,P=512*8,D=512*128;class I{constructor(n){this.iconvLiteDecoder=n}static async create(n){let s;if(n!==e.UTF8)s=(await new Promise((o,g)=>{K(["iconv-lite-umd"],o,g)})).getDecoder(p(n));else{const r=new TextDecoder;s={write(o){return r.decode(o,{stream:!0})},end(){return r.decode()}}}return new I(s)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function i(t,n){var s;const r=((s=n.minBytesRequiredForDetection)!==null&&s!==void 0?s:n.guessEncoding)?P:y;return new Promise((o,g)=>{const f=(0,v.newWriteableStream)(O=>O.join("")),S=[];let E=0,l;const L=async()=>{try{const O=await d({buffer:R.VSBuffer.concat(S),bytesRead:E},n.guessEncoding);O.encoding=await n.overwriteEncoding(O.encoding),l=await I.create(O.encoding);const W=l.write(R.VSBuffer.concat(S).buffer);f.write(W),S.length=0,E=0,o({stream:f,detected:O})}catch(O){g(O)}};(0,v.listenStream)(t,{onData:async O=>{l?f.write(l.write(O.buffer)):(S.push(O),E+=O.byteLength,E>=r&&(t.pause(),await L(),setTimeout(()=>t.resume())))},onError:O=>f.error(O),onEnd:async()=>{l||await L(),f.end(l==null?void 0:l.end())}})})}e.toDecodeStream=i;async function A(t,n,s){const o=(await new Promise((S,E)=>{K(["iconv-lite-umd"],S,E)})).getEncoder(p(n),s);let g=!1,f=!1;return{read(){if(f)return null;const S=t.read();if(typeof S!="string"){if(f=!0,!g&&(s==null?void 0:s.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const E=o.end();return E&&E.length>0?(g=!0,R.VSBuffer.wrap(E)):null}return g=!0,R.VSBuffer.wrap(o.write(S))}}}e.toEncodeReadable=A;async function h(t){return(await new Promise((s,r)=>{K(["iconv-lite-umd"],s,r)})).encodingExists(p(t))}e.encodingExists=h;function p(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=p;function a(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),r=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const o=t.readUInt8(2);return s===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=a;const w=["ascii","utf-16","utf-32"];async function m(t){const n=await new Promise((f,S)=>{K(["jschardet"],f,S)}),s=t.slice(0,D),r=u(s.buffer),o=n.detect(r);if(!o||!o.encoding)return null;const g=o.encoding.toLowerCase();return 0<=w.indexOf(g)?null:_(o.encoding)}const b={ibm866:"cp866",big5:"cp950"};function _(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[n]||n}function u(t){let n="";for(let s=0;s<t.length;s++)n+=String.fromCharCode(t[s]);return n}function c(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=c;function d({buffer:t,bytesRead:n},s){let r=a(t,n),o=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&t){let g=!0,f=!0,S=!1;for(let E=0;E<n&&E<T;E++){const l=E%2==1,L=t.readUInt8(E)===0;if(L&&(S=!0),g&&(l&&!L||!l&&L)&&(g=!1),f&&(l&&L||!l&&!L)&&(f=!1),L&&!g&&!f)break}S&&(g?r=e.UTF16le:f?r=e.UTF16be:o=!0)}return s&&!o&&!r&&t?m(t.slice(0,n)).then(g=>({seemsBinary:!1,encoding:g})):{seemsBinary:o,encoding:r}}e.detectEncodingFromBuffer=d,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[130],ge([0,1,266,28,129]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class T extends C.TextSearchManager{constructor(P,D,I=R){super(P,D,{readdir:i=>I.readdir(i.fsPath),toCanonicalName:i=>(0,v.toCanonicalName)(i)})}}e.NativeTextSearchManager=T}),define(me[267],ge([0,1,268,282,283,2,284]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(A,h,p,a,w,m){const b=m.environment.useHostProxy,_=typeof b=="boolean"?b:!m.remote.isRemote,u=(0,y.createProxyResolver)({resolveProxy:d=>A.resolveProxy(d),getHttpProxySetting:()=>h.getConfiguration("http").get("proxy"),log:(d,t,...n)=>{switch(d){case y.LogLevel.Trace:a.trace(t,...n);break;case y.LogLevel.Debug:a.debug(t,...n);break;case y.LogLevel.Info:a.info(t,...n);break;case y.LogLevel.Warning:a.warn(t,...n);break;case y.LogLevel.Error:a.error(t,...n);break;case y.LogLevel.Critical:a.critical(t,...n);break;case y.LogLevel.Off:break;default:s(d,t,n);break}function s(r,o,...g){a.error("Unknown log level",r),a.error(o,...g)}},getLogLevel:()=>a.getLevel(),proxyResolveTelemetry:d=>{w.$publicLog2("resolveProxy",d)},useHostProxy:_,env:process.env}),c=D(h,u);return i(p,c)}e.connectProxyResolver=P;function D(A,h){const p={config:A.getConfiguration("http").get("proxySupport")||"off"};A.onDidChangeConfiguration(w=>{p.config=A.getConfiguration("http").get("proxySupport")||"off"});const a={config:!!A.getConfiguration("http").get("systemCertificates")};return A.onDidChangeConfiguration(w=>{a.config=!!A.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},v,(0,y.createHttpPatch)(v,h,{config:"off"},a,!0)),on:Object.assign({},v,(0,y.createHttpPatch)(v,h,{config:"on"},a,!0)),override:Object.assign({},v,(0,y.createHttpPatch)(v,h,{config:"override"},a,!0)),onRequest:Object.assign({},v,(0,y.createHttpPatch)(v,h,p,a,!0)),default:Object.assign(v,(0,y.createHttpPatch)(v,h,p,a,!1))},https:{off:Object.assign({},R,(0,y.createHttpPatch)(R,h,{config:"off"},a,!0)),on:Object.assign({},R,(0,y.createHttpPatch)(R,h,{config:"on"},a,!0)),override:Object.assign({},R,(0,y.createHttpPatch)(R,h,{config:"override"},a,!0)),onRequest:Object.assign({},R,(0,y.createHttpPatch)(R,h,p,a,!0)),default:Object.assign(R,(0,y.createHttpPatch)(R,h,p,a,!1))},tls:Object.assign(C,(0,y.createTlsPatch)(C))}}const I=new Map;function i(A,h){return A.getExtensionPathIndex().then(p=>{const a=K.__$__nodeRequire("module"),w=a._load;a._load=function(b,_,u){if(b==="tls")return h.tls;if(b!=="http"&&b!=="https")return w.apply(this,arguments);const c=h[b],d=p.findSubstr(T.URI.file(_.filename).fsPath);let t=I.get(d);if(t||I.set(d,t={}),!t[b]){let n=c.default;d&&d.enableProposedApi&&(n=c[d.proxySupport]||c.onRequest),t[b]=Object.assign({},n)}return t[b]}})}}),define(me[269],ge([0,1,37,9,76,29,11,8,92,270]),function(K,e,v,R,C,T,y,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function A(u,c,d,t){const n=h(u,c,d,t),s=c.folder.fsPath;return{cmd:v.spawn(i,n.args,{cwd:s}),rgDiskPath:i,siblingClauses:n.siblingClauses,rgArgs:n,cwd:s}}e.spawnRipgrepCmd=A;function h(u,c,d,t){const n=["--files","--hidden","--case-sensitive"];a([c],d,!1).forEach(r=>{const o=(0,D.anchorGlob)(r);if(n.push("-g",o),y.isMacintosh){const g=(0,C.normalizeNFD)(o);g!==o&&n.push("-g",g)}});const s=p([c],t,void 0,!1);return s.globArgs.forEach(r=>{const o=`!${(0,D.anchorGlob)(r)}`;if(n.push("-g",o),y.isMacintosh){const g=(0,C.normalizeNFD)(o);g!==o&&n.push("-g",g)}}),c.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),c.ignoreSymlinks||n.push("--follow"),u.exists&&n.push("--quiet"),n.push("--no-config"),c.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:s.siblingClauses}}function p(u,c,d,t=!0){const n=[];let s={};return u.forEach(r=>{const o=Object.assign({},r.excludePattern||{},c||{}),g=w(o,t?r.folder.fsPath:void 0,d);n.push(...g.globArgs),g.siblingClauses&&(s=Object.assign(s,g.siblingClauses))}),{globArgs:n,siblingClauses:s}}e.foldersToRgExcludeGlobs=p;function a(u,c,d=!0){const t=[];return u.forEach(n=>{const s=Object.assign({},c||{},n.includePattern||{}),r=w(s,d?n.folder.fsPath:void 0);t.push(...r.globArgs)}),t}e.foldersToIncludeGlobs=a;function w(u,c,d){const t=[],n={};return Object.keys(u).forEach(s=>{if(d&&d.has(s)||!s)return;const r=u[s];s=b(c?m(c,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof r=="boolean"&&r?(s.startsWith("\\\\")&&(s+="**"),t.push(_(s))):r&&r.when&&(n[s]=r)}),{globArgs:t,siblingClauses:n}}function m(u,c){return R.isAbsolute(c)?c:R.join(u,c)}e.getAbsoluteGlob=m;function b(u){return u=P.rtrim(u,"\\"),P.rtrim(u,"/")}function _(u){return T.getRoot(u).toLowerCase()==="c:/"?u.replace(/^c:[/\\]/i,"/"):u}e.fixDriveC=_}),define(me[271],ge([0,1,37,59,9,100,16,60,31,76,29,11,44,8,12,28,30,269,98]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w,m,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const u=new Set;process.on("exit",()=>{u.forEach(s=>s())});class c{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&D.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,_.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&D.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(o=>{const g=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),f=o.folder.fsPath;r.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==f).forEach(S=>{(0,i.isEqualOrParent)(S,f)&&(g[C.relative(f,S)]=!0)}),this.folderExcludePatterns.set(f,new t(g,f))})}cancel(){this.isCanceled=!0}walk(r,o,g,f,S){if(this.fileWalkSW=h.StopWatch.create(!1),this.isCanceled)return S(null,this.isLimitHit);o.forEach(E=>{const l=C.basename(E.fsPath);this.globalExcludePattern&&this.globalExcludePattern(E.fsPath,l)||this.matchFile(g,{relativePath:E.fsPath,searchPath:void 0})}),this.cmdSW=h.StopWatch.create(!1),this.parallel(r,(E,l)=>{this.call(this.cmdTraversal,this,E,g,f,L=>{if(L){const O=(0,P.toErrorMessage)(L);console.error(O),this.errors.push(O),l(L,void 0)}else l(null,void 0)})},(E,l)=>{this.fileWalkSW.stop();const L=E?y.coalesce(E)[0]:null;S(L,this.isLimitHit)})}parallel(r,o,g){const f=new Array(r.length),S=new Array(r.length);let E=!1,l=0;if(r.length===0)return g(null,[]);r.forEach((L,O)=>{o(L,(W,te)=>{if(W?(E=!0,f[O]=null,S[O]=W):(f[O]=te,S[O]=null),++l===r.length)return g(E?S:null,f)})})}call(r,o,...g){try{r.apply(o,g)}catch(f){g[g.length-1](f)}}cmdTraversal(r,o,g,f){const S=r.folder.fsPath,E=A.isMacintosh;let l;const L=()=>l&&l.kill();u.add(L);let O=k=>{u.delete(L),O=()=>{},f(k)},W="";const te=this.initDirectoryTree();let se;const N=(0,b.spawnRipgrepCmd)(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression);l=N.cmd,se=!Object.keys(N.siblingClauses).length;const V=N.rgArgs.args.map(k=>k.match(/^-/)?k:`'${k}'`).join(" ");let x=`${N.rgDiskPath} ${V}
 - cwd: ${N.cwd}`;N.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(N.rgArgs.siblingClauses)}`),g({message:x}),this.cmdResultCount=0,this.collectStdout(l,"utf8",g,(k,U,F)=>{if(k){O(k);return}if(this.isLimitHit){O();return}const $=(W+(E?I.normalizeNFC(U||""):U)).split(`
`);if(F){const H=$.length;$[H-1]=$[H-1].trim(),$[H-1]||$.pop()}else W=$.pop()||"";if($.length&&$[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=$.length,se){for(const H of $)if(this.matchFile(o,{base:S,relativePath:H,searchPath:this.getSearchPath(r,H)}),this.isLimitHit){L();break}(F||this.isLimitHit)&&O();return}this.addDirectoryEntries(r,te,S,$,o),F&&(this.matchDirectoryTree(te,S,o),O())})}spawnFindCmd(r){const o=this.folderExcludePatterns.get(r.folder.fsPath),g=o.getBasenameTerms(),f=o.getPathTerms(),S=["-L","."];if(g.length||f.length){S.push("-not","(","(");for(const E of g)S.push("-name",E),S.push("-o");for(const E of f)S.push("-path",E),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),v.spawn("find",S,{cwd:r.folder.fsPath})}readStdout(r,o,g){let f="";this.collectStdout(r,o,()=>{},(S,E,l)=>{if(S){g(S);return}f+=E,l&&g(null,f)})}collectStdout(r,o,g,f){let S=(L,O,W)=>{(L||W)&&(S=()=>{},this.cmdSW&&this.cmdSW.stop()),f(L,O,W)},E=!1;r.stdout?(this.forwardData(r.stdout,o,S),r.stdout.once("data",()=>E=!0)):g({message:"stdout is null"});let l;r.stderr?l=this.collectData(r.stderr):g({message:"stderr is null"}),r.on("error",L=>{S(L)}),r.on("close",L=>{let O;!E&&(O=this.decodeData(l,o))&&n(O)?S(new Error(`command failed with error code ${L}: ${this.decodeData(l,o)}`)):(this.exists&&L===0&&(this.isLimitHit=!0),S(null,"",!0))})}forwardData(r,o,g){const f=new T.StringDecoder(o);return r.on("data",S=>{g(null,f.write(S))}),f}collectData(r){const o=[];return r.on("data",g=>{o.push(g)}),o}decodeData(r,o){const g=new T.StringDecoder(o);return r.map(f=>g.write(f)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:o},g,f,S){f.indexOf(this.filePattern)!==-1&&this.matchFile(S,{base:g,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const E=l=>{const L=C.basename(l),O=C.dirname(l);let W=o[O];W||(W=o[O]=[],E(O)),W.push({base:g,relativePath:l,basename:L,searchPath:this.getSearchPath(r,l)})};f.forEach(E)}matchDirectoryTree({rootEntries:r,pathToEntries:o},g,f){const S=this,E=this.folderExcludePatterns.get(g),l=this.filePattern;function L(O){S.directoriesWalked++;const W=D.hasSiblingFn(()=>O.map(te=>te.basename));for(let te=0,se=O.length;te<se;te++){const N=O[te],{relativePath:V,basename:x}=N;if(E.test(V,x,l!==x?W:void 0))continue;const k=o[V];if(k)L(k);else{if(S.filesWalked++,V===l)continue;S.matchFile(f,N)}if(S.isLimitHit)break}}L(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,o,g,f,S){const E=r.folder,l=D.hasSiblingFn(()=>g);this.parallel(g,(L,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const W=o?[o,L].join(C.sep):L;if(this.folderExcludePatterns.get(r.folder.fsPath).test(W,L,this.config.filePattern!==L?l:void 0))return O(null);const te=[E.fsPath,W].join(C.sep);R.lstat(te,(se,N)=>{if(se||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(te,N,(V,x)=>V||this.isCanceled||this.isLimitHit?O(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(te,N,(k,U)=>k||this.isCanceled||this.isLimitHit||(U=U||"",this.walkedPaths[U])?O(null):(this.walkedPaths[U]=!0,(0,w.readdir)(te).then(F=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(r,W,F,f,M=>O(M||null))},F=>{O(null)})))):(this.filesWalked++,W===this.filePattern||this.maxFilesize&&a.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(f,{base:E.fsPath,relativePath:W,searchPath:this.getSearchPath(r,W)}),O(null,void 0)))})},L=>{const O=L&&y.coalesce(L);return S(O&&O.length>0?O[0]:void 0)})}matchFile(r,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,C.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(o))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,m.isFilePatternMatch)(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,o,g){return o.isSymbolicLink()?R.stat(r,g):g(null,o)}realPathIfNeeded(r,o,g){return o.isSymbolicLink()?R.realpath(r,(f,S)=>f?g(f):g(null,S)):g(null,r)}getSearchPath(r,o){return r.folderName?C.join(r.folderName,o):o}}e.FileWalker=c;class d{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new c(r)}search(r,o,g){this.walker.walk(this.folderQueries,this.extraFiles,r,o,(f,S)=>{g(f,{limitHit:S,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=d;class t{constructor(r,o){this.expression=r,this.root=o,this.init(r)}init(r){let o,g;Object.keys(r).filter(f=>r[f]).forEach(f=>{C.isAbsolute(f)?(o=o||D.getEmptyExpression(),o[f]=r[f]):(g=g||D.getEmptyExpression(),g[f]=r[f])}),this.absoluteParsedExpr=o&&D.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=g&&D.parse(g,{trimForExclusions:!0})}test(r,o,g){return this.relativeParsedExpr&&this.relativeParsedExpr(r,o,g)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,r),o,g)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getPathTerms(this.relativeParsedExpr)),r}}function n(s){const r=s.trim().split(`
`),o=r[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return p.uppercaseFirstLetter(r[r.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=n}),define(me[131],ge([0,1,37,285,100,16,52,31,9,8,2,30,68,286,270,92]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const m=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class b{constructor(E){this.outputChannel=E}provideTextSearchResults(E,l,L,O){return this.outputChannel.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify(Object.assign(Object.assign({},l),{folder:l.folder.toString()}))}`),new Promise((W,te)=>{O.onCancellationRequested(()=>M());const se=n(E,l),N=l.folder.fsPath,V=se.map(we=>we.match(/^-/)?we:`'${we}'`).join(" ");this.outputChannel.appendLine(`${m} ${V}
 - cwd: ${N}`);let x=v.spawn(m,se,{cwd:N});x.on("error",we=>{console.error(we),this.outputChannel.appendLine("Error: "+(we&&we.message)),te((0,A.serializeSearchError)(new A.SearchError(we&&we.message,A.SearchErrorCode.rgProcessError)))});let k=!1;const U=new c(l.maxResults,N,l.previewOptions);U.on("result",we=>{k=!0,H="",L.report(we)});let F=!1;const M=()=>{F=!0,x&&x.kill(),U&&U.cancel()};let $=!1;U.on("hitLimit",()=>{$=!0,M()});let H="";x.stdout.on("data",we=>{U.handleData(we),k||(H+=we)});let X=!1;x.stdout.once("data",()=>X=!0);let ae="";x.stderr.on("data",we=>{const Le=we.toString();this.outputChannel.appendLine(Le),ae+=Le}),x.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(k?"Got result from parser":"No result from parser"),H&&this.outputChannel.appendLine(`Got data without result: ${H}`),this.outputChannel.appendLine(""),F)W({limitHit:$});else{U.flush(),x=null;let we;ae&&!X&&(we=_(ae))?te((0,A.serializeSearchError)(new A.SearchError(we.message,we.code))):W({limitHit:$})}})})}}e.RipgrepTextSearchEngine=b;function _(S){const E=S.split(`
`),l=E[0].trim();if(E.some(O=>O.startsWith("regex parse error")))return new A.SearchError(u(E),A.SearchErrorCode.regexParseError);const L=l.match(/grep config error: unknown encoding: (.*)/);if(L)return new A.SearchError(`Unknown encoding: ${L[1]}`,A.SearchErrorCode.unknownEncoding);if(l.startsWith("error parsing glob"))return new A.SearchError(l.charAt(0).toUpperCase()+l.substr(1),A.SearchErrorCode.globParseError);if(l.startsWith("the literal"))return new A.SearchError(l.charAt(0).toUpperCase()+l.substr(1),A.SearchErrorCode.invalidLiteral);if(l.startsWith("PCRE2: error compiling pattern"))return new A.SearchError(l,A.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=_;function u(S){const E=["Regex parse error"],l=S.filter(L=>L.startsWith("PCRE2:"));if(l.length>=1){const L=l[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const O=L.split(":")[1];E.push(":"+O)}}return E.join("")}e.buildRegexParseError=u;class c extends R.EventEmitter{constructor(E,l,L){super();this.maxResults=E,this.rootFolder=l,this.previewOptions=L,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(E,l){return super.on(E,l),this}handleData(E){if(this.isDone)return;const l=typeof E=="string"?E:this.stringDecoder.write(E);this.handleDecodedData(l)}handleDecodedData(E){let l=E.indexOf(`
`);const L=this.remainder+E;if(l>=0)l+=this.remainder.length;else{this.remainder=L;return}let O=0;for(;l>=0;)this.handleLine(L.substring(O,l).trim()),O=l+1,l=L.indexOf(`
`,O);this.remainder=L.substring(O)}handleLine(E){if(this.isDone||!E)return;let l;try{l=JSON.parse(E)}catch(L){throw new Error(`malformed line from rg: ${E}`)}if(l.type==="match"){const L=d(l.data.path),O=i.URI.file(D.join(this.rootFolder,L)),W=this.createTextSearchMatch(l.data,O);this.onResult(W),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(l.type==="context"){const L=d(l.data.path),O=i.URI.file(D.join(this.rootFolder,L));this.createTextSearchContext(l.data,O).forEach(te=>this.onResult(te))}}createTextSearchMatch(E,l){const L=E.line_number-1;let O=!1,W=d(E.lines);L===0&&(0,I.startsWithUTF8BOM)(W)&&(O=!0,W=(0,I.stripUTF8BOM)(W));const te=Buffer.from(W);let se=0,N=0,V=L;E.submatches.length===0&&E.submatches.push(W.length?{start:0,end:1,match:{text:W[0]}}:{start:0,end:0,match:{text:""}});const x=(0,T.coalesce)(E.submatches.map((k,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let F=d(k.match);L===0&&U===0&&O&&(F=(0,I.stripUTF8BOM)(F),k.start=k.start<=3?0:k.start-3,k.end=k.end<=3?0:k.end-3);const M=te.slice(se,k.start).toString().length,$=N+M,H=t(F),X=V,ae=H.numLines+X,we=H.numLines>0?H.lastLineLength:H.lastLineLength+$;return se=k.end,N=we,V=ae,new h.Range(X,$,ae,we)}));return(0,w.createTextSearchResult)(l,W,x,this.previewOptions)}createTextSearchContext(E,l){const L=d(E.lines),O=E.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((W,te)=>({text:W,uri:l,lineNumber:O+te}))}onResult(E){this.emit("result",E)}}e.RipgrepParser=c;function d(S){return S.bytes?Buffer.from(S.bytes,"base64").toString():S.text}function t(S){const E=/\n/g;let l=0,L=-1,O;for(;O=E.exec(S);)l++,L=O.index;const W=L>=0?S.length-L-1:S.length;return{numLines:l,lastLineLength:W}}function n(S,E){const l=["--hidden"];l.push(S.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:O}=(0,y.groupBy)(E.includes,te=>te.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const te=new Set;O.forEach(se=>{te.add(se)}),l.push("-g","!*"),te.forEach(se=>{s(se).map(w.anchorGlob).forEach(N=>{l.push("-g",N)})})}L&&L.length&&L.forEach(te=>{l.push("-g",te)}),E.excludes.map(w.anchorGlob).forEach(te=>l.push("-g",`!${te}`)),E.maxFileSize&&l.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?l.push("--no-ignore-parent"):l.push("--no-ignore"),E.followSymlinks&&l.push("--follow"),E.encoding&&E.encoding!=="utf8"&&l.push("--encoding",E.encoding),S.pattern==="--"&&(S.isRegExp=!0,S.pattern="\\-\\-"),S.isMultiline&&!S.isRegExp&&(S.pattern=(0,I.escapeRegExpCharacters)(S.pattern),S.isRegExp=!0),E.usePCRE2&&l.push("--pcre2"),l.push("--crlf"),S.isRegExp&&(S.pattern=r(S.pattern),l.push("--auto-hybrid-regex"));let W;if(S.isWordMatch){const se=(0,I.createRegExp)(S.pattern,!!S.isRegExp,{wholeWord:S.isWordMatch}).source.replace(/\\\//g,"/");l.push("--regexp",se)}else if(S.isRegExp){let te=g(S.pattern);te=f(te),l.push("--regexp",te)}else W=S.pattern,l.push("--fixed-strings");return l.push("--no-config"),E.useGlobalIgnoreFiles||l.push("--no-ignore-global"),l.push("--json"),S.isMultiline&&l.push("--multiline"),E.beforeContext&&l.push("--before-context",E.beforeContext+""),E.afterContext&&l.push("--after-context",E.afterContext+""),l.push("--"),W&&l.push(W),l.push("."),l}function s(S){const E=(0,P.splitGlobAware)(S,"/");return E.map((l,L)=>E.slice(0,L+1).join("/"))}e.spreadGlobComponents=s;function r(S){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;S.match(E);)S=S.replace(E,"$1\\x{$2}");const l=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;S.match(l);)S=S.replace(l,"$1\\x{$2}");return S}e.unicodeEscapesToPCRE2=r;const o=S=>S.type==="Assertion"&&S.kind==="lookbehind";function g(S){let E;try{E=new p.RegExpParser().parsePattern(S)}catch(se){return S}let l="",L=0;const O=(se,N,V)=>{l+=S.slice(L,se)+V,L=N},W=[];return new p.RegExpVisitor({onCharacterEnter(se){if(se.raw!=="\\n")return;const N=W[0];if(!N)O(se.start,se.end,"\\r?\\n");else if(!W.some(o))if(N.type==="CharacterClass")if(N.negate){const V=S.slice(N.start+2,se.start)+S.slice(se.end,N.end-1);O(N.start,N.end,"(?!\\r?\\n"+(V?`|[${V}]`:"")+")")}else{const V=S.slice(N.start+1,se.start)+S.slice(se.end,N.end-1);O(N.start,N.end,V===""?"\\r?\\n":`(?:[${V}]|\\r?\\n)`)}else N.type==="Quantifier"&&O(se.start,se.end,"(?:\\r?\\n)")},onQuantifierEnter(se){W.unshift(se)},onQuantifierLeave(){W.shift()},onCharacterClassRangeEnter(se){W.unshift(se)},onCharacterClassRangeLeave(){W.shift()},onCharacterClassEnter(se){W.unshift(se)},onCharacterClassLeave(){W.shift()},onAssertionEnter(se){o(se)&&W.push(se)},onAssertionLeave(se){W[0]===se&&W.shift()}}).visit(E),l+=S.slice(L),l}e.fixRegexNewline=g;function f(S){return S.replace(/\n/g,"\\r?\\n")}e.fixNewline=f}),define(me[272],ge([0,1,21,131,114,10]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(I){this.outputChannel=I,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(I,i,A,h){const p=new R.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===T.Schemas.userData){const a=Object.assign(Object.assign({},i),{folder:i.folder.with({scheme:T.Schemas.file})}),w=new C.Progress(m=>A.report(Object.assign(Object.assign({},m),{uri:m.uri.with({scheme:i.folder.scheme})})));return this.withToken(h,m=>p.provideTextSearchResults(I,a,w,m))}else return this.withToken(h,a=>p.provideTextSearchResults(I,i,A,a))}async withToken(I,i){const A=P(I);this.inProgress.add(A);const h=await i(A.token);return this.inProgress.delete(A),h}dispose(){this.inProgress.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=y;function P(D){const I=new v.CancellationTokenSource;return D.onCancellationRequested(()=>I.cancel()),I}}),define(me[273],ge([0,1,28,131,130]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class T{constructor(D){this.query=D}search(D,I,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const A={appendLine(p){i({message:p})}},h=new C.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(A),v);return new Promise((p,a)=>h.search(w=>{I(w.map(y))},D).then(w=>p({limitHit:w.limitHit,type:"success"}),a))}}e.TextSearchEngineAdapter=T;function y(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((D,I)=>{if(I.ranges){const i=I;return D+(Array.isArray(i.ranges)?i.ranges.length:1)}else return D+1},0)}}}),define(me[274],ge([0,1,59,287,16,13,17,3,98,9,44,2,43,30,271,273]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,R.gracefulify(v);class m{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const s=u(t),r=new P.Emitter({onFirstListenerDidAdd:()=>{n=(0,T.createCancelablePromise)(o=>this.doFileSearchWithEngine(a.Engine,s,g=>r.fire(g),o)),n.then(o=>r.fire(o),o=>r.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}textSearch(t){let n;const s=u(t),r=new P.Emitter({onFirstListenerDidAdd:()=>{n=(0,T.createCancelablePromise)(o=>this.ripgrepTextSearch(s,g=>r.fire(g),o)),n.then(o=>r.fire(o),o=>r.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}ripgrepTextSearch(t,n,s){return t.maxFileSize=(0,h.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new w.TextSearchEngineAdapter(t).search(s,n,n)}doFileSearch(t,n,s){return this.doFileSearchWithEngine(a.Engine,t,n,s)}doFileSearchWithEngine(t,n,s,r,o=m.BATCH_SIZE){let g=0;const f=E=>{Array.isArray(E)?(g+=E.length,s(E.map(l=>this.rawMatchToSearchItem(l)))):E.relativePath?(g++,s(this.rawMatchToSearchItem(E))):s(E)};if(n.sortByScore){let E=this.trySortedSearchFromCache(n,f,r);if(!E){const l=n.maxResults?Object.assign({},n,{maxResults:null}):n,L=new t(l);E=this.doSortedSearch(L,n,s,f,r)}return new Promise((l,L)=>{E.then(([O,W])=>{const te=W.map(se=>this.rawMatchToSearchItem(se));this.sendProgress(te,s,o),l(O)},L)})}const S=new t(n);return this.doSearch(S,f,o,r).then(E=>({limitHit:E.limitHit,type:"success",stats:{detailStats:E.stats,type:"searchProcess",fromCache:!1,resultCount:g,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,I.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,s,r,o){const g=new P.Emitter;let f=(0,T.createCancelablePromise)(E=>{let l=[];const L=O=>{Array.isArray(O)?l=O:(r(O),g.fire(O))};return this.doSearch(t,L,-1,E).then(O=>[O,l])}),S;if(n.cacheKey){S=this.getOrCreateCache(n.cacheKey);const E={promise:f,event:g.event,resolved:!1};S.resultsToSearchCache[n.filePattern||""]=E,f.then(()=>{E.resolved=!0},l=>{delete S.resultsToSearchCache[n.filePattern||""]}),f=this.preventCancellation(f)}return f.then(([E,l])=>{const L=S?S.scorerCache:Object.create(null),O=(typeof n.maxResults!="number"||n.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(n,l,L,o).then(W=>{const te=O?O.elapsed():-1;return[{type:"success",stats:{detailStats:E.stats,sortingTime:te,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:W.length},messages:E.messages,limitHit:E.limitHit||typeof n.maxResults=="number"&&l.length>n.maxResults},W]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new b)}trySortedSearchFromCache(t,n,s){const r=t.cacheKey&&this.caches[t.cacheKey];if(!r)return;const o=this.getResultsFromCache(r,t.filePattern||"",n,s);if(o)return o.then(([g,f,S])=>{const E=i.StopWatch.create(!1);return this.sortResults(t,f,r.scorerCache,s).then(l=>{const L=E.elapsed(),O={fromCache:!0,detailStats:S,type:"searchProcess",resultCount:f.length,sortingTime:L};return[{type:"success",limitHit:g.limitHit||typeof t.maxResults=="number"&&f.length>t.maxResults,stats:O},l]})})}sortResults(t,n,s,r){const o=(0,D.prepareQuery)(t.filePattern||""),g=(S,E)=>(0,D.compareItemsByFuzzyScore)(S,E,o,!0,_,s),f=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return C.topAsync(n,g,f,1e4,r)}sendProgress(t,n,s){if(s&&s>0)for(let r=0;r<t.length;r+=s)n(t.slice(r,r+s));else n(t)}getResultsFromCache(t,n,s,r){const o=i.StopWatch.create(!1),g=n.indexOf(I.sep)>=0;let f;for(const L in t.resultsToSearchCache)if(n.startsWith(L)){if(g&&L.indexOf(I.sep)<0&&L!=="")continue;const O=t.resultsToSearchCache[L];f={promise:this.preventCancellation(O.promise),event:O.event,resolved:O.resolved};break}if(!f)return null;const S=o.elapsed(),E=i.StopWatch.create(!1),l=f.event(s);return r&&r.onCancellationRequested(()=>{l.dispose()}),f.promise.then(([L,O])=>{if(r&&r.isCancellationRequested)throw(0,y.canceled)();const W=[],te=(0,D.prepareQuery)(n).normalizedLowercase;for(const se of O)!(0,p.isFilePatternMatch)(se,te)||W.push(se);return[L,W,{cacheWasResolved:f.resolved,cacheLookupTime:S,cacheFilterTime:E.elapsed(),cacheEntryCount:O.length}]})}doSearch(t,n,s,r){return new Promise((o,g)=>{let f=[];r&&r.onCancellationRequested(()=>t.cancel()),t.search(S=>{S&&(s?(f.push(S),s>0&&f.length>=s&&(n(f),f=[])):n(S))},S=>{n(S)},(S,E)=>{f.length&&n(f),S?g(S):o(E)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,s){return t.then(n,s)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=m,m.BATCH_SIZE=512;class b{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const _=new class{getItemLabel(d){return(0,I.basename)(d.relativePath)}getItemDescription(d){return(0,I.dirname)(d.relativePath)}getItemPath(d){return d.relativePath}};function u(d){return Object.assign(Object.assign({},d),{folderQueries:d.folderQueries&&d.folderQueries.map(c),extraFileResources:d.extraFileResources&&d.extraFileResources.map(t=>A.URI.revive(t))})}function c(d){return Object.assign(Object.assign({},d),{folder:A.URI.revive(d.folder)})}}),define(me[275],ge([0,1,6,2,28,14,30,274,272,92,15,63,27,71,10,130]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let m=class extends p.ExtHostSearch{constructor(_,u,c,d){super(_,c,d);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new I.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(a.Schemas.userData,new D.RipgrepSearchProvider(t)),u.remote.isRemote&&u.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const _=new I.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(a.Schemas.file,new D.RipgrepSearchProvider(_)),this.registerInternalFileSearchProvider(a.Schemas.file,new P.SearchService)}registerInternalFileSearchProvider(_,u){const c=this._handlePool++;return this._internalFileSearchProvider=u,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(_)),(0,v.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(_,u,c,d){const t=(0,p.reviveQuery)(c);return _===this._internalFileSearchHandle?this.doInternalFileSearch(_,u,t,d):super.$provideFileSearchResults(_,u,c,d)}doInternalFileSearch(_,u,c,d){const t=n=>{if((0,y.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(_,u,n.map(s=>R.URI.file(s.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,t,d)}$clearCache(_){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(_),super.$clearCache(_)}createTextSearchManager(_,u){return new w.NativeTextSearchManager(_,u)}};m=qe([He(0,i.IExtHostRpcService),He(1,h.IExtHostInitDataService),He(2,A.IURITransformerService),He(3,T.ILogService)],m),e.NativeExtHostSearch=m}),define(me[132],ge([0,1,288,122,289,3,103,9,101,32,6,22,104,17,11]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(f){this.socket=f,this._errorListener=S=>{if(S){if(S.code==="EPIPE")return;(0,p.onUnexpectedError)(S)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(f){const S=E=>f(A.VSBuffer.wrap(E));return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(f){return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(f){return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(f){if(!this.socket.destroyed)try{this.socket.write(f.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,p.onUnexpectedError)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,p.onUnexpectedError)(S)}}end(){this.socket.end()}drain(){return new Promise((f,S)=>{if(this.socket.bufferSize===0){f();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),f()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.NodeSocket=w;var m;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(m||(m={}));var b;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(b||(b={}));class _ extends i.Disposable{constructor(f,S,E,l){super();this._onDidZlibFlush=this._register(new T.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new T.Emitter),this._onClose=this._register(new T.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=f,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=S,this._recordInflateBytes=l,S?(this._zlibInflate=C.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",L=>{console.error(L),(0,p.onUnexpectedError)(L),this._onClose.fire()}),this._zlibInflate.on("data",L=>{this._pendingInflateData.push(L)}),E&&(this._zlibInflate.write(E.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=C.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",L=>{console.error(L),(0,p.onUnexpectedError)(L),this._onClose.fire()}),this._zlibDeflate.on("data",L=>{this._pendingDeflateData.push(L)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new h.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):A.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this._onData.event(f)}onClose(f){return this._onClose.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){this._totalOutgoingDataBytes+=f.byteLength,this._zlibDeflate?(this._zlibDeflate.write(f.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let S=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,S=S.slice(0,S.length-4),this._isEnded||this._write(A.VSBuffer.wrap(S),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(f,!1)}_write(f,S){let E=2;f.byteLength<126?E+=0:f.byteLength<2**16?E+=2:E+=8;const l=A.VSBuffer.alloc(E);if(S?l.writeUInt8(194,0):l.writeUInt8(130,0),f.byteLength<126)l.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){l.writeUInt8(126,1);let L=1;l.writeUInt8(f.byteLength>>>8&255,++L),l.writeUInt8(f.byteLength>>>0&255,++L)}else{l.writeUInt8(127,1);let L=1;l.writeUInt8(0,++L),l.writeUInt8(0,++L),l.writeUInt8(0,++L),l.writeUInt8(0,++L),l.writeUInt8(f.byteLength>>>24&255,++L),l.writeUInt8(f.byteLength>>>16&255,++L),l.writeUInt8(f.byteLength>>>8&255,++L),l.writeUInt8(f.byteLength>>>0&255,++L)}this._totalOutgoingWireBytes+=l.byteLength+f.byteLength,this.socket.write(A.VSBuffer.concat([l,f]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(f){if(f.byteLength!==0){for(this._totalIncomingWireBytes+=f.byteLength,this._incomingData.acceptChunk(f);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const S=this._incomingData.peek(this._state.readLen),l=(S.readUInt8(0)&128)>>>7,L=S.readUInt8(1),O=(L&128)>>>7,W=L&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=l,this._state.mask=0}else if(this._state.state===2){const S=this._incomingData.read(this._state.readLen),E=S.readUInt8(1),l=(E&128)>>>7;let L=E&127,O=1;L===126?L=S.readUInt8(++O)*2**8+S.readUInt8(++O):L===127&&(L=S.readUInt8(++O)*0+S.readUInt8(++O)*0+S.readUInt8(++O)*0+S.readUInt8(++O)*0+S.readUInt8(++O)*2**24+S.readUInt8(++O)*2**16+S.readUInt8(++O)*2**8+S.readUInt8(++O));let W=0;l&&(W=S.readUInt8(++O)*2**24+S.readUInt8(++O)*2**16+S.readUInt8(++O)*2**8+S.readUInt8(++O)),this._state.state=3,this._state.readLen=L,this._state.mask=W}else if(this._state.state===3){const S=this._incomingData.read(this._state.readLen);u(S,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(S.buffer)),this._zlibInflate.write(S.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const E=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=E.length,this._onData.fire(A.VSBuffer.wrap(E))})):(this._totalIncomingDataBytes+=S.byteLength,this._onData.fire(S))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await T.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=_;function u(g,f){if(f===0)return;let S=g.byteLength>>>2;for(let te=0;te<S;te++){const se=g.readUInt32BE(te*4);g.writeUInt32BE(se^f,te*4)}let E=S*4,l=g.byteLength-E;const L=f>>>24&255,O=f>>>16&255,W=f>>>8&255;l>=1&&g.writeUInt8(g.readUInt8(E)^L,E),l>=2&&g.writeUInt8(g.readUInt8(E+1)^O,E+1),l>=3&&g.writeUInt8(g.readUInt8(E+2)^W,E+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function d(){const g=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let f;return e.XDG_RUNTIME_DIR?f=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):f=(0,P.join)((0,D.tmpdir)(),`vscode-ipc-${g}.sock`),n(f),f}e.createRandomIPCHandle=d;function t(g,f,S){const E=(0,v.createHash)("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${S}-${f}-sock`;let l;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?l=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${E.substr(0,8)}-${S}-${f}.sock`):l=(0,P.join)(g,`${S}-${f}.sock`),n(l),l}e.createStaticIPCHandle=t;function n(g){const f=c[a.platform];typeof f=="number"&&g.length>=f&&console.warn(`WARNING: IPC handle "${g}" is longer than ${f} chars, try a shorter --user-data-dir`)}class s extends y.IPCServer{constructor(f){super(s.toClientConnectionEvent(f));this.server=f}static toClientConnectionEvent(f){const S=T.Event.fromNodeEventEmitter(f,"connection");return T.Event.map(S,E=>({protocol:new h.Protocol(new w(E)),onDidClientDisconnect:T.Event.once(T.Event.fromNodeEventEmitter(E,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function r(g){return new Promise((f,S)=>{const E=(0,R.createServer)();E.on("error",S),E.listen(g,()=>{E.removeListener("error",S),f(new s(E))})})}e.serve=r;function o(g,f){return new Promise((S,E)=>{const l=(0,R.createConnection)(g,()=>{l.removeListener("error",E),S(h.Client.fromSocket(new w(l),f))});l.once("error",E)})}e.connect=o}),define(me[276],ge([0,1,132,268,59,49,2,118,14]),function(K,e,v,R,C,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(h,p,a){this._commands=h,this.logService=p,this._ipcHandlePath=a,this._server=R.createServer((w,m)=>this.onRequest(w,m)),this.setup().catch(w=>(p.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",h=>this.logService.error(h))}catch(h){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(h,p){const a=[];h.setEncoding("utf8"),h.on("data",w=>a.push(w)),h.on("end",()=>{const w=JSON.parse(a.join(""));switch(w.type){case"open":this.open(w,p);break;case"openExternal":this.openExternal(w,p);break;case"status":this.getStatus(w,p);break;case"extensionManagement":this.manageExtensions(w,p).catch(this.logService.error);break;default:p.writeHead(404),p.write(`Unknown message type: ${w.type}`,m=>{m&&this.logService.error(m)}),p.end();break}})}open(h,p){let{fileURIs:a,folderURIs:w,forceNewWindow:m,diffMode:b,addMode:_,forceReuseWindow:u,gotoLineMode:c,waitMarkerFilePath:d}=h;const t=[];if(Array.isArray(w))for(const n of w)try{t.push({folderUri:y.URI.parse(n)})}catch(s){}if(Array.isArray(a))for(const n of a)try{(0,P.hasWorkspaceFileExtension)(n)?t.push({workspaceUri:y.URI.parse(n)}):t.push({fileUri:y.URI.parse(n)})}catch(s){}if(t.length){const n=d?y.URI.file(d):void 0,r={forceNewWindow:m,diffMode:b,addMode:_,gotoLineMode:c,forceReuseWindow:u,preferNewWindow:!u&&!n&&!_,waitMarkerFileURI:n};this._commands.executeCommand("_remoteCLI.windowOpen",t,r)}p.writeHead(200),p.end()}async openExternal(h,p){for(const a of h.uris){const w=y.URI.parse(a),m=w.scheme==="file"?w:a;await this._commands.executeCommand("_remoteCLI.openExternal",m)}p.writeHead(200),p.end()}async manageExtensions(h,p){try{const a=b=>b==null?void 0:b.map(_=>/\.vsix$/i.test(_)?y.URI.parse(_):_),w={list:h.list,install:a(h.install),uninstall:a(h.uninstall),force:h.force},m=await this._commands.executeCommand("_remoteCLI.manageExtensions",w);p.writeHead(200),p.write(m)}catch(a){p.writeHead(500),p.write(String(a),w=>{w&&this.logService.error(w)})}p.end()}async getStatus(h,p){try{const a=await this._commands.executeCommand("_remoteCLI.getSystemStatus");p.writeHead(200),p.write(a),p.end()}catch(a){p.writeHead(500),p.write(String(a),w=>{w&&this.logService.error(w)}),p.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=I;let i=class extends I{constructor(h,p){super(h,p,(0,v.createRandomIPCHandle)())}};i=qe([He(0,T.IExtHostCommands),He(1,D.ILogService)],i),e.CLIServer=i}),define(me[277],ge([0,1,70,264,259,5,267,41,249,2,10,7,276,102]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends C.RequireInterceptor{_installInterceptor(){const b=this,_=K.__$__nodeRequire("module"),u=_._load;_._load=function(d,t,n){for(let s of b._alternatives){let r=s(d);if(r){d=r;break}}return b._factories.has(d)?b._factories.get(d).load(d,I.URI.file((0,p.realpathSync)(t.filename)),s=>u.apply(this,[s,t,n])):u.apply(this,arguments)}}}class w extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const b=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(h.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(a,b,this._registry).install(),v.mark("code/extHost/didInitAPI");const u=await this._extHostConfiguration.getConfigProvider();await(0,y.connectProxyResolver)(this._extHostWorkspace,u,this,this._logService,this._mainThreadTelemetryProxy,this._initData),v.mark("code/extHost/didInitProxyResolver");const c=process.send,d=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?c.apply(process,t):(d.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(b){return b.main}_loadCommonJSModule(b,_,u){if(_.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${_}', must be of file-scheme`);let c=null;u.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${_.toString(!0)}`),this._logService.flush();try{b&&v.mark(`code/extHost/willLoadExtensionCode/${b.value}`),c=K.__$__nodeRequire(_.fsPath)}catch(d){return Promise.reject(d)}finally{b&&v.mark(`code/extHost/didLoadExtensionCode/${b.value}`),u.codeLoadingStop()}return Promise.resolve(c)}async $setRemoteEnvironment(b){if(!!this._initData.remote.isRemote)for(const _ in b){const u=b[_];u===null?delete process.env[_]:process.env[_]=u}}}e.ExtHostExtensionService=w}),define(me[278],ge([0,1,79,250,251,261,260,275,277,220,252,50,41,66,71,69,33,48,14]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w,m,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.registerSingleton)(h.IExtHostExtensionService,D.ExtHostExtensionService),(0,v.registerSingleton)(_.ILogService,I.ExtHostLogService),(0,v.registerSingleton)(A.IExtHostDebugService,y.ExtHostDebugService),(0,v.registerSingleton)(p.IExtHostOutputService,R.ExtHostOutputService2),(0,v.registerSingleton)(a.IExtHostSearch,P.NativeExtHostSearch),(0,v.registerSingleton)(w.IExtHostTask,T.ExtHostTask),(0,v.registerSingleton)(m.IExtHostTerminalService,C.ExtHostTerminalService),(0,v.registerSingleton)(b.IExtHostTunnelService,i.ExtHostTunnelService)}),define(me[279],ge([0,1,122,290,70,17,104,132,187,218,262,22,99,28,102,13,265,278]),function(K,e,v,R,C,T,y,P,D,I,i,A,h,p,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const m=R(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const s=K.__$__nodeRequire("module"),r=s._load;s._load=function(o){if(o==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const b=process.exit.bind(process);function _(s){process.exit=function(r){if(s)b(r);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let u=function(s){b()};function c(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,r)=>{let o=null,g=setTimeout(()=>{u("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const f=108e5,S=3e5,E=new w.RunOnceScheduler(()=>u("renderer disconnected for too long (1)"),f),l=new w.RunOnceScheduler(()=>u("renderer disconnected for too long (2)"),S);process.on("message",(O,W)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){const te=A.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let se;if(O.skipWebSocketFrames)se=new P.NodeSocket(W);else{const N=A.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));se=new P.WebSocketNodeSocket(new P.NodeSocket(W),O.permessageDeflate,N,!1)}o?(E.cancel(),l.cancel(),o.beginAcceptReconnection(se,te),o.endAcceptReconnection()):(clearTimeout(g),o=new y.PersistentProtocol(se,te),o.onDidDispose(()=>u("renderer disconnected")),s(o),o.onSocketClose(()=>{E.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(l.isScheduled())return;E.isScheduled()&&l.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,o)=>{const g=v.createConnection(s,()=>{g.removeListener("error",o),r(new y.PersistentProtocol(new P.NodeSocket(g)))});g.once("error",o),g.on("close",()=>{u("renderer closed the socket")})})}}async function d(){const s=await c();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(r=>{(0,I.isMessageOfType)(r,2)?(this._terminating=!0,u("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||s.send(r)}drain(){return s.drain()}}}function t(s){return new Promise(r=>{const o=s.onMessage(g=>{o.dispose();const f=JSON.parse(g.toString()),S=f.commit,E=D.default.commit;S&&E&&S!==E&&b(55);const l=[];process.on("unhandledRejection",(W,te)=>{l.push(te),setTimeout(()=>{const se=l.indexOf(te);se>=0&&te.catch(N=>{l.splice(se,1),console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),(0,T.onUnexpectedError)(W)})},1e3)}),process.on("rejectionHandled",W=>{const te=l.indexOf(W);te>=0&&l.splice(te,1)}),process.on("uncaughtException",function(W){(0,T.onUnexpectedError)(W)});let L=0;setInterval(function(){try{process.kill(f.parentPid,0),L=0}catch(W){W&&W.code==="EPERM"?(L++,L>=3&&u(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${W.message} (code: ${W.code}) (errno: ${W.errno})`)):u(`parent process ${f.parentPid} does not exist anymore: ${W.message} (code: ${W.code}) (errno: ${W.errno})`)}},1e3);let O;try{O=K.__$__nodeRequire("native-watchdog"),O.start(f.parentPid)}catch(W){(0,T.onUnexpectedError)(W)}s.send((0,I.createMessageOfType)(0)),r({protocol:s,initData:f})});s.send((0,I.createMessageOfType)(1))})}async function n(){C.mark("code/extHost/willConnectToRenderer");const s=await d();C.mark("code/extHost/didConnectToRenderer");const r=await t(s);C.mark("code/extHost/didWaitForInitData");const{initData:o}=r;_(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=m.useHostProxy!==void 0?m.useHostProxy!=="false":void 0;const g=new class{exit(l){b(l)}exists(l){return(0,p.exists)(l)}realpath(l){return(0,a.realpath)(l)}};let f=null;if(o.remote.authority&&m.uriTransformerPath)try{const l=K.__$__nodeRequire(m.uriTransformerPath)(o.remote.authority);f=new h.URITransformer(l)}catch(E){console.error(E)}const S=new i.ExtensionHostMain(r.protocol,o,g,f);u=E=>S.terminate(E)}e.startExtensionHostProcess=n}),define(me[291],ge([0,1,279]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.startExtensionHostProcess)().catch(R=>console.log(R))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/286b643ecd231f66f3f2e67e1456f3c601838b46/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
