/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/workbench/api/common/extHostRpcService","vs/base/common/network","vs/platform/log/common/log","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],be=function(J){for(var e=[],v=0,R=J.length;v<R;v++)e[v]=ve[J[v]];return e};define(ve[42],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(R,S){if(!R)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=v}),define(ve[52],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function R(n){const P=[];for(let d in n)v.call(n,d)&&P.push(n[d]);return P}e.values=R;function S(n,P){for(let d in n)if(v.call(n,d)&&P({key:d,value:n[d]},function(){delete n[d]})===!1)return}e.forEach=S;function T(n,P){const d=Object.create(null);for(const g of n){const r=P(g);let m=d[r];m||(m=d[r]=[]),m.push(g)}return d}e.groupBy=T;function E(n){const P=Object.create(null);return n&&n.forEach((d,g)=>{P[g]=d}),P}e.fromMap=E;function D(n,P){const d=[],g=[];for(let r of n)P.has(r)||d.push(r);for(let r of P)n.has(r)||g.push(r);return{removed:d,added:g}}e.diffSets=D;function y(n,P){const d=[],g=[];for(let[r,m]of n)P.has(r)||d.push(m);for(let[r,m]of P)n.has(r)||g.push(m);return{removed:d,added:g}}e.diffMaps=y;class k{constructor(){this.map=new Map}add(P,d){let g=this.map.get(P);g||(g=new Set,this.map.set(P,g)),g.add(d)}delete(P,d){const g=this.map.get(P);!g||(g.delete(d),g.size===0&&this.map.delete(P))}forEach(P,d){const g=this.map.get(P);!g||g.forEach(d)}}e.SetMap=k}),define(ve[53],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(E){return(D,y,k)=>{let n=null,P=null;if(typeof k.value=="function"?(n="value",P=k.value):typeof k.get=="function"&&(n="get",P=k.get),!P)throw new Error("not supported");k[n]=E(P,y)}}e.createDecorator=v;function R(E,D,y){let k=null,n=null;if(typeof y.value=="function"?(k="value",n=y.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(k="get",n=y.get),!n)throw new Error("not supported");const P=`$memoize$${D}`;y[k]=function(...d){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,d)}),this[P]}}e.memoize=R;function S(E,D,y){return v((k,n)=>{const P=`$debounce$${n}`,d=`$debounce$result$${n}`;return function(...g){this[d]||(this[d]=y?y():void 0),clearTimeout(this[P]),D&&(this[d]=D(this[d],...g),g=[this[d]]),this[P]=setTimeout(()=>{k.apply(this,g),this[d]=y?y():void 0},E)}})}e.debounce=S;function T(E,D,y){return v((k,n)=>{const P=`$throttle$timer$${n}`,d=`$throttle$result$${n}`,g=`$throttle$lastRun$${n}`,r=`$throttle$pending$${n}`;return function(...m){if(this[d]||(this[d]=y?y():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),D&&(this[d]=D(this[d],...m)),this[r])return;const c=this[g]+E;c<=Date.now()?(this[g]=Date.now(),k.apply(this,[this[d]]),this[d]=y?y():void 0):(this[r]=!0,this[P]=setTimeout(()=>{this[r]=!1,this[g]=Date.now(),k.apply(this,[this[d]]),this[d]=y?y():void 0},c-Date.now()))}})}e.throttle=T}),define(ve[12],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function R(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=R;function S(f){y(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=S;function T(f){y(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=T;function E(f){if(f instanceof Error){let{name:t,message:i}=f;const s=f.stacktrace||f.stack;return{$isError:!0,name:t,message:i,stack:s}}return f}e.transformErrorForSerialization=E;const D="Canceled";function y(f){return f instanceof Error&&f.name===D&&f.message===D}e.isPromiseCanceledError=y;class k extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=k;function n(){const f=new Error(D);return f.name=f.message,f}e.canceled=n;function P(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=P;function d(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=d;function g(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function r(f){const t=new Error(`${f} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function m(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=m;class c extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=c;class p extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=p;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function a(f){const t=f;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=a;function h(f,t=Object.create(null)){const i=new Error(f);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=h}),define(ve[13],be([0,1,12]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(x,I=0){return x[x.length-(1+I)]}e.tail=R;function S(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}e.tail2=S;function T(x,I,H=(M,B)=>M===B){if(x===I)return!0;if(!x||!I||x.length!==I.length)return!1;for(let M=0,B=x.length;M<B;M++)if(!H(x[M],I[M]))return!1;return!0}e.equals=T;function E(x,I,H){let M=0,B=x.length-1;for(;M<=B;){const G=(M+B)/2|0,K=H(x[G],I);if(K<0)M=G+1;else if(K>0)B=G-1;else return G}return-(M+1)}e.binarySearch=E;function D(x,I){let H=0,M=x.length;if(M===0)return 0;for(;H<M;){const B=Math.floor((H+M)/2);I(x[B])?M=B:H=B+1}return H}e.findFirstInSorted=D;function y(x,I,H){if(x=x|0,x>=I.length)throw new TypeError("invalid index");let M=I[Math.floor(I.length*Math.random())],B=[],G=[],K=[];for(let se of I){const pe=H(se,M);pe<0?B.push(se):pe>0?G.push(se):K.push(se)}return x<B.length?y(x,B,H):x<B.length+K.length?K[0]:y(x-(B.length+K.length),G,H)}e.quickSelect=y;function k(x,I){const H=[];let M;for(const B of x.slice(0).sort(I))!M||I(M[0],B)!==0?(M=[B],H.push(M)):M.push(B);return H}e.groupBy=k;function n(x,I,H){const M=[];function B(se,pe,Fe){if(pe===0&&Fe.length===0)return;const We=M[M.length-1];We&&We.start+We.deleteCount===se?(We.deleteCount+=pe,We.toInsert.push(...Fe)):M.push({start:se,deleteCount:pe,toInsert:Fe})}let G=0,K=0;for(;;){if(G===x.length){B(G,0,I.slice(K));break}if(K===I.length){B(G,x.length-G,[]);break}const se=x[G],pe=I[K],Fe=H(se,pe);Fe===0?(G+=1,K+=1):Fe<0?(B(G,1,[]),G+=1):Fe>0&&(B(G,0,[pe]),K+=1)}return M}e.sortedDiff=n;function P(x,I,H){const M=n(x,I,H),B=[],G=[];for(const K of M)B.push(...x.slice(K.start,K.start+K.deleteCount)),G.push(...K.toInsert);return{removed:B,added:G}}e.delta=P;function d(x,I,H){if(H===0)return[];const M=x.slice(0,H).sort(I);return r(x,I,M,H,x.length),M}e.top=d;function g(x,I,H,M,B){return H===0?Promise.resolve([]):new Promise((G,K)=>{(async()=>{const se=x.length,pe=x.slice(0,H).sort(I);for(let Fe=H,We=Math.min(H+M,se);Fe<se;Fe=We,We=Math.min(We+M,se)){if(Fe>H&&await new Promise(Ne=>setTimeout(Ne)),B&&B.isCancellationRequested)throw(0,v.canceled)();r(x,I,pe,Fe,We)}return pe})().then(G,K)})}e.topAsync=g;function r(x,I,H,M,B){for(const G=H.length;M<B;M++){const K=x[M];if(I(K,H[G-1])<0){H.pop();const se=D(H,pe=>I(K,pe)<0);H.splice(se,0,K)}}}function m(x){return x.filter(I=>!!I)}e.coalesce=m;function c(x){let I=0;for(let H=0;H<x.length;H++)x[H]&&(x[I]=x[H],I+=1);x.length=I}e.coalesceInPlace=c;function p(x,I,H){x.splice(H,0,x.splice(I,1)[0])}e.move=p;function w(x){return!Array.isArray(x)||x.length===0}e.isFalsyOrEmpty=w;function a(x){return Array.isArray(x)&&x.length>0}e.isNonEmptyArray=a;function h(x,I){if(!I)return x.filter((M,B)=>x.indexOf(M)===B);const H=Object.create(null);return x.filter(M=>{const B=I(M);return H[B]?!1:(H[B]=!0,!0)})}e.distinct=h;function f(x){const I=new Set;return x.filter(H=>I.has(H)?!1:(I.add(H),!0))}e.distinctES6=f;function t(x){const I=Object.create(null);return H=>{const M=x(H);return I[M]?!1:(I[M]=!0,!0)}}e.uniqueFilter=t;function i(x,I){for(let H=x.length-1;H>=0;H--){const M=x[H];if(I(M))return H}return-1}e.lastIndex=i;function s(x,I){return x.length>0?x[0]:I}e.firstOrDefault=s;function o(x,I,H=(M,B)=>M===B){let M=0;for(let B=0,G=Math.min(x.length,I.length);B<G&&H(x[B],I[B]);B++)M++;return M}e.commonPrefixLength=o;function u(x){return[].concat(...x)}e.flatten=u;function _(x,I){let H=typeof I=="number"?x:0;typeof I=="number"?H=x:(H=0,I=x);const M=[];if(H<=I)for(let B=H;B<I;B++)M.push(B);else for(let B=H;B>I;B--)M.push(B);return M}e.range=_;function b(x,I,H){return x.reduce((M,B)=>(M[I(B)]=H?H(B):B,M),Object.create(null))}e.index=b;function A(x,I){return x.push(I),()=>C(x,I)}e.insert=A;function C(x,I){const H=x.indexOf(I);if(H>-1)return x.splice(H,1),I}e.remove=C;function l(x,I,H){const M=x.slice(0,I),B=x.slice(I);return M.concat(H,B)}e.arrayInsert=l;function F(x,I){let H;if(typeof I=="number"){let M=I;H=()=>{const B=Math.sin(M++)*179426549;return B-Math.floor(B)}}else H=Math.random;for(let M=x.length-1;M>0;M-=1){const B=Math.floor(H()*(M+1)),G=x[M];x[M]=x[B],x[B]=G}}e.shuffle=F;function N(x,I){const H=x.indexOf(I);H>-1&&(x.splice(H,1),x.unshift(I))}e.pushToStart=N;function z(x,I){const H=x.indexOf(I);H>-1&&(x.splice(H,1),x.push(I))}e.pushToEnd=z;function de(x,I){return Array.isArray(x)?x.map(I):I(x)}e.mapArrayOrNot=de;function he(x){return Array.isArray(x)?x:[x]}e.asArray=he;function $(x){return x[Math.floor(Math.random()*x.length)]}e.getRandomElement=$;function q(x,I){for(const H of x){const M=I(H);if(M!==void 0)return M}}e.mapFind=q}),define(ve[54],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(R){const S=this;let T=!1,E;return function(){return T||(T=!0,E=R.apply(S,arguments)),E}}e.once=v}),define(ve[55],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class v{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=v,e.defaultGenerator=new v("id#")}),define(ve[43],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(R){function S(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}R.is=S;const T=Object.freeze([]);function E(){return T}R.empty=E;function*D(f){yield f}R.single=D;function y(f){return f||T}R.from=y;function k(f){return!f||f[Symbol.iterator]().next().done===!0}R.isEmpty=k;function n(f){return f[Symbol.iterator]().next().value}R.first=n;function P(f,t){for(const i of f)if(t(i))return!0;return!1}R.some=P;function d(f,t){for(const i of f)if(t(i))return i}R.find=d;function*g(f,t){for(const i of f)t(i)&&(yield i)}R.filter=g;function*r(f,t){for(const i of f)yield t(i)}R.map=r;function*m(...f){for(const t of f)for(const i of t)yield i}R.concat=m;function*c(f){for(const t of f)for(const i of t)yield i}R.concatNested=c;function p(f,t,i){let s=i;for(const o of f)s=t(s,o);return s}R.reduce=p;function*w(f,t,i=f.length){for(t<0&&(t+=f.length),i<0?i+=f.length:i>f.length&&(i=f.length);t<i;t++)yield f[t]}R.slice=w;function a(f,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,f];const s=f[Symbol.iterator]();for(let o=0;o<t;o++){const u=s.next();if(u.done)return[i,R.empty()];i.push(u.value)}return[i,{[Symbol.iterator](){return s}}]}R.consume=a;function h(f,t,i=(s,o)=>s===o){const s=f[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const u=s.next(),_=o.next();if(u.done!==_.done)return!1;if(u.done)return!0;if(!i(u.value,_.value))return!1}}R.equals=h})(v=e.Iterable||(e.Iterable={}))}),define(ve[44],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function E(t,i=!1){let s=0,o=t.length,u="",_=0,b=16,A=0;function C($){let q=0,x=0;for(;q<$;){const I=t.charCodeAt(s);if(I>=48&&I<=57)x=x*16+I-48;else if(I>=65&&I<=70)x=x*16+I-65+10;else if(I>=97&&I<=102)x=x*16+I-97+10;else break;s++,q++}return q<$&&(x=-1),x}function l($){s=$,u="",_=0,b=16,A=0}function F(){const $=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&k(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&k(t.charCodeAt(s)))for(s++;s<t.length&&k(t.charCodeAt(s));)s++;else return A=3,t.substring($,s);let q=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&k(t.charCodeAt(s))){for(s++;s<t.length&&k(t.charCodeAt(s));)s++;q=s}else A=3;return t.substring($,q)}function N(){let $="",q=s;for(;;){if(s>=o){$+=t.substring(q,s),A=2;break}const x=t.charCodeAt(s);if(x===34){$+=t.substring(q,s),s++;break}if(x===92){if($+=t.substring(q,s),s++,s>=o){A=2;break}switch(t.charCodeAt(s++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const H=C(4);H>=0?$+=String.fromCharCode(H):A=4;break;default:A=5}q=s;continue}if(x>=0&&x<=31)if(y(x)){$+=t.substring(q,s),A=2;break}else A=6;s++}return $}function z(){if(u="",A=0,_=s,s>=o)return _=o,b=17;let $=t.charCodeAt(s);if(D($)){do s++,u+=String.fromCharCode($),$=t.charCodeAt(s);while(D($));return b=15}if(y($))return s++,u+=String.fromCharCode($),$===13&&t.charCodeAt(s)===10&&(s++,u+=`
`),b=14;switch($){case 123:return s++,b=1;case 125:return s++,b=2;case 91:return s++,b=3;case 93:return s++,b=4;case 58:return s++,b=6;case 44:return s++,b=5;case 34:return s++,u=N(),b=10;case 47:const q=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<o&&!y(t.charCodeAt(s));)s++;return u=t.substring(q,s),b=12}if(t.charCodeAt(s+1)===42){s+=2;const x=o-1;let I=!1;for(;s<x;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,I=!0;break}s++}return I||(s++,A=1),u=t.substring(q,s),b=13}return u+=String.fromCharCode($),s++,b=16;case 45:if(u+=String.fromCharCode($),s++,s===o||!k(t.charCodeAt(s)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=F(),b=11;default:for(;s<o&&de($);)s++,$=t.charCodeAt(s);if(_!==s){switch(u=t.substring(_,s),u){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return u+=String.fromCharCode($),s++,b=16}}function de($){if(D($)||y($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function he(){let $;do $=z();while($>=12&&$<=15);return $}return{setPosition:l,getPosition:()=>s,scan:i?he:z,getToken:()=>b,getTokenValue:()=>u,getTokenOffset:()=>_,getTokenLength:()=>s-_,getTokenError:()=>A}}e.createScanner=E;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function P(t,i){const s=[],o=new Object;let u;const _={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function A(C,l,F,N){_.value=C,_.offset=l,_.length=F,_.type=N,_.colonOffset=void 0,u=_}try{a(t,{onObjectBegin:(C,l)=>{if(i<=C)throw o;u=void 0,b=i>C,s.push("")},onObjectProperty:(C,l,F)=>{if(i<l||(A(C,l,F,"property"),s[s.length-1]=C,i<=l+F))throw o},onObjectEnd:(C,l)=>{if(i<=C)throw o;u=void 0,s.pop()},onArrayBegin:(C,l)=>{if(i<=C)throw o;u=void 0,s.push(0)},onArrayEnd:(C,l)=>{if(i<=C)throw o;u=void 0,s.pop()},onLiteralValue:(C,l,F)=>{if(i<l||(A(C,l,F,f(C)),i<=l+F))throw o},onSeparator:(C,l,F)=>{if(i<=l)throw o;if(C===":"&&u&&u.type==="property")u.colonOffset=l,b=!1,u=void 0;else if(C===","){const N=s[s.length-1];typeof N=="number"?s[s.length-1]=N+1:(b=!0,s[s.length-1]=""),u=void 0}}})}catch(C){if(C!==o)throw C}return{path:s,previousNode:u,isAtPropertyKey:b,matches:C=>{let l=0;for(let F=0;l<C.length&&F<s.length;F++)if(C[l]===s[F]||C[l]==="*")l++;else if(C[l]!=="**")return!1;return l===C.length}}}e.getLocation=P;function d(t,i=[],s=T.DEFAULT){let o=null,u=[];const _=[];function b(C){Array.isArray(u)?u.push(C):o!==null&&(u[o]=C)}return a(t,{onObjectBegin:()=>{const C={};b(C),_.push(u),u=C,o=null},onObjectProperty:C=>{o=C},onObjectEnd:()=>{u=_.pop()},onArrayBegin:()=>{const C=[];b(C),_.push(u),u=C,o=null},onArrayEnd:()=>{u=_.pop()},onLiteralValue:b,onError:(C,l,F)=>{i.push({error:C,offset:l,length:F})}},s),u[0]}e.parse=d;function g(t,i=[],s=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(C){o.type==="property"&&(o.length=C-o.offset,o=o.parent)}function _(C){return o.children.push(C),C}a(t,{onObjectBegin:C=>{o=_({type:"object",offset:C,length:-1,parent:o,children:[]})},onObjectProperty:(C,l,F)=>{o=_({type:"property",offset:l,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:C,offset:l,length:F,parent:o})},onObjectEnd:(C,l)=>{o.length=C+l-o.offset,o=o.parent,u(C+l)},onArrayBegin:(C,l)=>{o=_({type:"array",offset:C,length:-1,parent:o,children:[]})},onArrayEnd:(C,l)=>{o.length=C+l-o.offset,o=o.parent,u(C+l)},onLiteralValue:(C,l,F)=>{_({type:f(C),offset:l,length:F,parent:o,value:C}),u(l+F)},onSeparator:(C,l,F)=>{o.type==="property"&&(C===":"?o.colonOffset=l:C===","&&u(l))},onError:(C,l,F)=>{i.push({error:C,offset:l,length:F})}},s);const A=o.children[0];return A&&delete A.parent,A}e.parseTree=g;function r(t,i){if(!t)return;let s=t;for(let o of i)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let u=!1;for(const _ of s.children)if(Array.isArray(_.children)&&_.children[0].value===o){s=_.children[1],u=!0;break}if(!u)return}else{const u=o;if(s.type!=="array"||u<0||!Array.isArray(s.children)||u>=s.children.length)return;s=s.children[u]}return s}e.findNodeAtLocation=r;function m(t){if(!t.parent||!t.parent.children)return[];const i=m(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}e.getNodePath=m;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":const i=Object.create(null);for(let s of t.children){const o=s.children[1];o&&(i[s.children[0].value]=c(o))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=c;function p(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}e.contains=p;function w(t,i,s=!1){if(p(t,i,s)){const o=t.children;if(Array.isArray(o))for(let u=0;u<o.length&&o[u].offset<=i;u++){const _=w(o[u],i,s);if(_)return _}return t}}e.findNodeAtOffset=w;function a(t,i,s=T.DEFAULT){const o=E(t,!1);function u(pe){return pe?()=>pe(o.getTokenOffset(),o.getTokenLength()):()=>!0}function _(pe){return pe?Fe=>pe(Fe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const b=u(i.onObjectBegin),A=_(i.onObjectProperty),C=u(i.onObjectEnd),l=u(i.onArrayBegin),F=u(i.onArrayEnd),N=_(i.onLiteralValue),z=_(i.onSeparator),de=u(i.onComment),he=_(i.onError),$=s&&s.disallowComments,q=s&&s.allowTrailingComma;function x(){for(;;){const pe=o.scan();switch(o.getTokenError()){case 4:I(14);break;case 5:I(15);break;case 3:I(13);break;case 1:$||I(11);break;case 2:I(12);break;case 6:I(16);break}switch(pe){case 12:case 13:$?I(10):de();break;case 16:I(1);break;case 15:case 14:break;default:return pe}}}function I(pe,Fe=[],We=[]){if(he(pe),Fe.length+We.length>0){let Ne=o.getToken();for(;Ne!==17;){if(Fe.indexOf(Ne)!==-1){x();break}else if(We.indexOf(Ne)!==-1)break;Ne=x()}}}function H(pe){const Fe=o.getTokenValue();return pe?N(Fe):A(Fe),x(),!0}function M(){switch(o.getToken()){case 11:let pe=0;try{pe=JSON.parse(o.getTokenValue()),typeof pe!="number"&&(I(2),pe=0)}catch(Fe){I(2)}N(pe);break;case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return x(),!0}function B(){return o.getToken()!==10?(I(3,[],[2,5]),!1):(H(!1),o.getToken()===6?(z(":"),x(),se()||I(4,[],[2,5])):I(5,[],[2,5]),!0)}function G(){b(),x();let pe=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(pe||I(4,[],[]),z(","),x(),o.getToken()===2&&q)break}else pe&&I(6,[],[]);B()||I(4,[],[2,5]),pe=!0}return C(),o.getToken()!==2?I(7,[2],[]):x(),!0}function K(){l(),x();let pe=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(pe||I(4,[],[]),z(","),x(),o.getToken()===4&&q)break}else pe&&I(6,[],[]);se()||I(4,[],[4,5]),pe=!0}return F(),o.getToken()!==4?I(8,[4],[]):x(),!0}function se(){switch(o.getToken()){case 3:return K();case 1:return G();case 10:return H(!0);default:return M()}}return x(),o.getToken()===17?s.allowEmptyContent?!0:(I(4,[],[]),!1):se()?(o.getToken()!==17&&I(9,[],[]),!0):(I(4,[],[]),!1)}e.visit=a;function h(t,i){let s=E(t),o=[],u,_=0,b;do switch(b=s.getPosition(),u=s.scan(),u){case 12:case 13:case 17:_!==b&&o.push(t.substring(_,b)),i!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,i)),_=s.getPosition();break}while(u!==17);return o.join("")}e.stripComments=h;function f(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(ve[108],be([0,1,44]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(y,k,n){let P,d,g,r,m;if(k){for(r=k.offset,m=r+k.length,g=r;g>0&&!D(y,g-1);)g--;let _=m;for(;_<y.length&&!D(y,_);)_++;d=y.substring(g,_),P=T(d,n)}else d=y,P=0,g=0,r=0,m=y.length;const c=E(n,y);let p=!1,w=0,a;n.insertSpaces?a=S(" ",n.tabSize||4):a="	";const h=(0,v.createScanner)(d,!1);let f=!1;function t(){return c+S(a,P+w)}function i(){let _=h.scan();for(p=!1;_===15||_===14;)p=p||_===14,_=h.scan();return f=_===16||h.getTokenError()!==0,_}const s=[];function o(_,b,A){!f&&b<m&&A>r&&y.substring(b,A)!==_&&s.push({offset:b,length:A-b,content:_})}let u=i();if(u!==17){const _=h.getTokenOffset()+g,b=S(a,P);o(b,g,_)}for(;u!==17;){let _=h.getTokenOffset()+h.getTokenLength()+g,b=i(),A="";for(;!p&&(b===12||b===13);){const l=h.getTokenOffset()+g;o(" ",_,l),_=h.getTokenOffset()+h.getTokenLength()+g,A=b===12?t():"",b=i()}if(b===2)u!==1&&(w--,A=t());else if(b===4)u!==3&&(w--,A=t());else{switch(u){case 3:case 1:w++,A=t();break;case 5:case 12:A=t();break;case 13:p?A=t():A=" ";break;case 6:A=" ";break;case 10:if(b===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?A=" ":b!==5&&b!==17&&(f=!0);break;case 16:f=!0;break}p&&(b===12||b===13)&&(A=t())}const C=h.getTokenOffset()+g;o(A,_,C),u=b}return s}e.format=R;function S(y,k){let n="";for(let P=0;P<k;P++)n+=y;return n}function T(y,k){let n=0,P=0;const d=k.tabSize||4;for(;n<y.length;){const g=y.charAt(n);if(g===" ")P++;else if(g==="	")P+=d;else break;n++}return Math.floor(P/d)}function E(y,k){for(let n=0;n<k.length;n++){const P=k.charAt(n);if(P==="\r")return n+1<k.length&&k.charAt(n+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=E;function D(y,k){return`\r
`.indexOf(y.charAt(k))!==-1}e.isEOL=D}),define(ve[109],be([0,1,44,108]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function S(k,n,P){return T(k,n,void 0,P)}e.removeProperty=S;function T(k,n,P,d,g){const r=n.slice(),m=[],c=(0,v.parseTree)(k,m);let p,w;for(;r.length>0&&(w=r.pop(),p=(0,v.findNodeAtLocation)(c,r),p===void 0&&P!==void 0);)typeof w=="string"?P={[w]:P}:P=[P];if(p)if(p.type==="object"&&typeof w=="string"&&Array.isArray(p.children)){const a=(0,v.findNodeAtLocation)(p,[w]);if(a!==void 0)if(P===void 0){if(!a.parent)throw new Error("Malformed AST");const h=p.children.indexOf(a.parent);let f,t=a.parent.offset+a.parent.length;if(h>0){const i=p.children[h-1];f=i.offset+i.length}else f=p.offset+1,p.children.length>1&&(t=p.children[1].offset);return E(k,{offset:f,length:t-f,content:""},d)}else return E(k,{offset:a.offset,length:a.length,content:JSON.stringify(P)},d);else{if(P===void 0)return[];const h=`${JSON.stringify(w)}: ${JSON.stringify(P)}`,f=g?g(p.children.map(i=>i.children[0].value)):p.children.length;let t;if(f>0){const i=p.children[f-1];t={offset:i.offset+i.length,length:0,content:","+h}}else p.children.length===0?t={offset:p.offset+1,length:0,content:h}:t={offset:p.offset+1,length:0,content:h+","};return E(k,t,d)}}else if(p.type==="array"&&typeof w=="number"&&Array.isArray(p.children))if(P!==void 0){const a=`${JSON.stringify(P)}`;let h;if(p.children.length===0||w===0)h={offset:p.offset+1,length:0,content:p.children.length===0?a:a+","};else{const f=w===-1||w>p.children.length?p.children.length:w,t=p.children[f-1];h={offset:t.offset+t.length,length:0,content:","+a}}return E(k,h,d)}else{const a=w,h=p.children[a];let f;if(p.children.length===1)f={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===a){const t=p.children[a-1],i=t.offset+t.length,s=p.offset+p.length;f={offset:i,length:s-2-i,content:""}}else f={offset:h.offset,length:p.children[a+1].offset-h.offset,content:""};return E(k,f,d)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${p.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return E(k,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(P)},d)}}e.setProperty=T;function E(k,n,P){let d=D(k,n),g=n.offset,r=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;g>0&&!(0,R.isEOL)(d,g-1);)g--;for(;r<d.length&&!(0,R.isEOL)(d,r);)r++}const m=(0,R.format)(d,{offset:g,length:r-g},P);for(let p=m.length-1;p>=0;p--){const w=m[p];d=D(d,w),g=Math.min(g,w.offset),r=Math.max(r,w.offset+w.length),r+=w.content.length-w.length}const c=k.length-(d.length-r)-g;return[{offset:g,length:c,content:d.substring(g,r)}]}e.withFormatting=E;function D(k,n){return k.substring(0,n.offset)+n.content+k.substring(n.offset+n.length)}e.applyEdit=D;function y(k,n){let P=n.slice(0).sort((g,r)=>{const m=g.offset-r.offset;return m===0?g.length-r.length:m}),d=k.length;for(let g=P.length-1;g>=0;g--){let r=P[g];if(r.offset+r.length<=d)k=D(k,r);else throw new Error("Overlapping edit");d=r.offset}return k}e.applyEdits=y}),define(ve[110],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(S){this.executor=S,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(S){this._error=S}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(S){return new v(()=>S(this.getValue()))}}e.Lazy=v}),define(ve[6],be([0,1,54,43]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const S=!1;let T=null;function E(a){T=a}if(e.setDisposableTracker=E,S){const a="__is_disposable_tracked__";T=new class{trackDisposable(h){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{h[a]||console.log(f)},3e3)}markTracked(h){if(h&&h!==m.None)try{h[a]=!0}catch(f){}}}}function D(a){!T||T.markTracked(a)}function y(a){return T&&T.trackDisposable(a),a}e.trackDisposable=y;class k extends Error{constructor(h){super(`Encountered errors while disposing of store. Errors: [${h.join(", ")}]`);this.errors=h}}e.MultiDisposeError=k;function n(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=n;function P(a){if(R.Iterable.is(a)){let h=[];for(const f of a)if(f){D(f);try{f.dispose()}catch(t){h.push(t)}}if(h.length===1)throw h[0];if(h.length>1)throw new k(h);return Array.isArray(a)?[]:a}else if(a)return D(a),a.dispose(),a}e.dispose=P;function d(...a){return a.forEach(D),g(()=>P(a))}e.combinedDisposable=d;function g(a){const h=y({dispose:()=>{D(h),a()}});return h}e.toDisposable=g;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{P(this._toDispose.values())}finally{this._toDispose.clear()}}add(h){if(!h)return h;if(h===this)throw new Error("Cannot register a disposable on itself!");return D(h),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(h),h}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new r,y(this)}dispose(){D(this),this._store.dispose()}_register(h){if(h===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(h)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(h){var f;this._isDisposed||h===this._value||((f=this._value)===null||f===void 0||f.dispose(),h&&D(h),this._value=h)}clear(){this.value=void 0}dispose(){var h;this._isDisposed=!0,D(this),(h=this._value)===null||h===void 0||h.dispose(),this._value=void 0}}e.MutableDisposable=c;class p{constructor(){this.references=new Map}acquire(h,...f){let t=this.references.get(h);t||(t={counter:0,object:this.createReferencedObject(h,...f)},this.references.set(h,t));const{object:i}=t,s=(0,v.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(h,t.object),this.references.delete(h))});return t.counter++,{object:i,dispose:s}}}e.ReferenceCollection=p;class w{constructor(h){this.object=h}dispose(){}}e.ImmortalReference=w}),define(ve[45],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(T){this.element=T,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class R{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let T=this._first;for(;T!==v.Undefined;){const E=T.next;T.prev=v.Undefined,T.next=v.Undefined,T=E}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,E){const D=new v(T);if(this._first===v.Undefined)this._first=D,this._last=D;else if(E){const k=this._last;this._last=D,D.prev=k,k.next=D}else{const k=this._first;this._first=D,D.next=k,k.prev=D}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(D))}}shift(){if(this._first!==v.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==v.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==v.Undefined&&T.next!==v.Undefined){const E=T.prev;E.next=T.next,T.next.prev=E}else T.prev===v.Undefined&&T.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):T.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):T.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==v.Undefined;)yield T.element,T=T.next}}e.LinkedList=R}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(ye,Se){for(var Ce=0;Ce<Se.length;Ce++){var ne=Se[Ce];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(ye,ne.key,ne)}}function e(ye,Se,Ce){return Se&&J(ye.prototype,Se),Ce&&J(ye,Ce),ye}function v(ye,Se){if(!!ye){if(typeof ye=="string")return R(ye,Se);var Ce=Object.prototype.toString.call(ye).slice(8,-1);if(Ce==="Object"&&ye.constructor&&(Ce=ye.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(ye);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return R(ye,Se)}}function R(ye,Se){(Se==null||Se>ye.length)&&(Se=ye.length);for(var Ce=0,ne=new Array(Se);Ce<Se;Ce++)ne[Ce]=ye[Ce];return ne}function S(ye,Se){var Ce;if(typeof Symbol=="undefined"||ye[Symbol.iterator]==null){if(Array.isArray(ye)||(Ce=v(ye))||Se&&ye&&typeof ye.length=="number"){Ce&&(ye=Ce);var ne=0;return function(){return ne>=ye.length?{done:!0}:{done:!1,value:ye[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ce=ye[Symbol.iterator](),Ce.next.bind(Ce)}function T(ye){var Se={exports:{}};return ye(Se,Se.exports),Se.exports}var E=T(function(ye){function Se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ce(ne){ye.exports.defaults=ne}ye.exports={defaults:Se(),getDefaults:Se,changeDefaults:Ce}}),D=/[&<>"']/,y=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(Se){return P[Se]};function g(ye,Se){if(Se){if(D.test(ye))return ye.replace(y,d)}else if(k.test(ye))return ye.replace(n,d);return ye}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(ye){return ye.replace(r,function(Se,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var c=/(^|[^\[])\^/g;function p(ye,Se){ye=ye.source||ye,Se=Se||"";var Ce={replace:function(le,O){return O=O.source||O,O=O.replace(c,"$1"),ye=ye.replace(le,O),Ce},getRegex:function(){return new RegExp(ye,Se)}};return Ce}var w=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(ye,Se,Ce){if(ye){var ne;try{ne=decodeURIComponent(m(Ce)).replace(w,"").toLowerCase()}catch(le){return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}Se&&!a.test(Ce)&&(Ce=o(Se,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(le){return null}return Ce}var f={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(ye,Se){f[" "+ye]||(t.test(ye)?f[" "+ye]=ye+"/":f[" "+ye]=A(ye,"/",!0)),ye=f[" "+ye];var Ce=ye.indexOf(":")===-1;return Se.substring(0,2)==="//"?Ce?Se:ye.replace(i,"$1")+Se:Se.charAt(0)==="/"?Ce?Se:ye.replace(s,"$1")+Se:ye+Se}var u={exec:function(){}};function _(ye){for(var Se=1,Ce,ne;Se<arguments.length;Se++){Ce=arguments[Se];for(ne in Ce)Object.prototype.hasOwnProperty.call(Ce,ne)&&(ye[ne]=Ce[ne])}return ye}function b(ye,Se){var Ce=ye.replace(/\|/g,function(O,Y,oe){for(var ke=!1,Ie=Y;--Ie>=0&&oe[Ie]==="\\";)ke=!ke;return ke?"|":" |"}),ne=Ce.split(/ \|/),le=0;if(ne.length>Se)ne.splice(Se);else for(;ne.length<Se;)ne.push("");for(;le<ne.length;le++)ne[le]=ne[le].trim().replace(/\\\|/g,"|");return ne}function A(ye,Se,Ce){var ne=ye.length;if(ne===0)return"";for(var le=0;le<ne;){var O=ye.charAt(ne-le-1);if(O===Se&&!Ce)le++;else if(O!==Se&&Ce)le++;else break}return ye.substr(0,ne-le)}function C(ye,Se){if(ye.indexOf(Se[1])===-1)return-1;for(var Ce=ye.length,ne=0,le=0;le<Ce;le++)if(ye[le]==="\\")le++;else if(ye[le]===Se[0])ne++;else if(ye[le]===Se[1]&&(ne--,ne<0))return le;return-1}function l(ye){ye&&ye.sanitize&&!ye.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(ye,Se){if(Se<1)return"";for(var Ce="";Se>1;)Se&1&&(Ce+=ye),Se>>=1,ye+=ye;return Ce+ye}var N={escape:g,unescape:m,edit:p,cleanUrl:h,resolveUrl:o,noopTest:u,merge:_,splitCells:b,rtrim:A,findClosingBracket:C,checkSanitizeDeprecation:l,repeatString:F},z=E.defaults,de=N.rtrim,he=N.splitCells,$=N.escape,q=N.findClosingBracket;function x(ye,Se,Ce){var ne=Se.href,le=Se.title?$(Se.title):null,O=ye[1].replace(/\\([\[\]])/g,"$1");return ye[0].charAt(0)!=="!"?{type:"link",raw:Ce,href:ne,title:le,text:O}:{type:"image",raw:Ce,href:ne,title:le,text:$(O)}}function I(ye,Se){var Ce=ye.match(/^(\s+)(?:```)/);if(Ce===null)return Se;var ne=Ce[1];return Se.split(`
`).map(function(le){var O=le.match(/^\s+/);if(O===null)return le;var Y=O[0];return Y.length>=ne.length?le.slice(ne.length):le}).join(`
`)}var H=function(){function ye(Ce){this.options=Ce||z}var Se=ye.prototype;return Se.space=function(ne){var le=this.rules.block.newline.exec(ne);if(le)return le[0].length>1?{type:"space",raw:le[0]}:{raw:`
`}},Se.code=function(ne){var le=this.rules.block.code.exec(ne);if(le){var O=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?O:de(O,`
`)}}},Se.fences=function(ne){var le=this.rules.block.fences.exec(ne);if(le){var O=le[0],Y=I(O,le[3]||"");return{type:"code",raw:O,lang:le[2]?le[2].trim():le[2],text:Y}}},Se.heading=function(ne){var le=this.rules.block.heading.exec(ne);if(le){var O=le[2].trim();if(/#$/.test(O)){var Y=de(O,"#");(this.options.pedantic||!Y||/ $/.test(Y))&&(O=Y.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:O}}},Se.nptable=function(ne){var le=this.rules.block.nptable.exec(ne);if(le){var O={type:"table",header:he(le[1].replace(/^ *| *\| *$/g,"")),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:le[3]?le[3].replace(/\n$/,"").split(`
`):[],raw:le[0]};if(O.header.length===O.align.length){var Y=O.align.length,oe;for(oe=0;oe<Y;oe++)/^ *-+: *$/.test(O.align[oe])?O.align[oe]="right":/^ *:-+: *$/.test(O.align[oe])?O.align[oe]="center":/^ *:-+ *$/.test(O.align[oe])?O.align[oe]="left":O.align[oe]=null;for(Y=O.cells.length,oe=0;oe<Y;oe++)O.cells[oe]=he(O.cells[oe],O.header.length);return O}}},Se.hr=function(ne){var le=this.rules.block.hr.exec(ne);if(le)return{type:"hr",raw:le[0]}},Se.blockquote=function(ne){var le=this.rules.block.blockquote.exec(ne);if(le){var O=le[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:le[0],text:O}}},Se.list=function(ne){var le=this.rules.block.list.exec(ne);if(le){var O=le[0],Y=le[2],oe=Y.length>1,ke={type:"list",raw:O,ordered:oe,start:oe?+Y.slice(0,-1):"",loose:!1,items:[]},Ie=le[0].match(this.rules.block.item),Le=!1,Ue,Qe,rt,et,Ye,ot,_t,wt,vt=Ie.length;rt=this.rules.block.listItemStart.exec(Ie[0]);for(var ie=0;ie<vt;ie++){if(Ue=Ie[ie],O=Ue,ie!==vt-1){if(et=this.rules.block.listItemStart.exec(Ie[ie+1]),this.options.pedantic?et[1].length>rt[1].length:et[1].length>rt[0].length||et[1].length>3){Ie.splice(ie,2,Ie[ie]+`
`+Ie[ie+1]),ie--,vt--;continue}else(!this.options.pedantic||this.options.smartLists?et[2][et[2].length-1]!==Y[Y.length-1]:oe===(et[2].length===1))&&(Ye=Ie.slice(ie+1).join(`
`),ke.raw=ke.raw.substring(0,ke.raw.length-Ye.length),ie=vt-1);rt=et}Qe=Ue.length,Ue=Ue.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ue.indexOf(`
 `)&&(Qe-=Ue.length,Ue=this.options.pedantic?Ue.replace(/^ {1,4}/gm,""):Ue.replace(new RegExp("^ {1,"+Qe+"}","gm"),"")),ot=Le||/\n\n(?!\s*$)/.test(Ue),ie!==vt-1&&(Le=Ue.charAt(Ue.length-1)===`
`,ot||(ot=Le)),ot&&(ke.loose=!0),this.options.gfm&&(_t=/^\[[ xX]\] /.test(Ue),wt=void 0,_t&&(wt=Ue[1]!==" ",Ue=Ue.replace(/^\[[ xX]\] +/,""))),ke.items.push({type:"list_item",raw:O,task:_t,checked:wt,loose:ot,text:Ue})}return ke}},Se.html=function(ne){var le=this.rules.block.html.exec(ne);if(le)return{type:this.options.sanitize?"paragraph":"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]):le[0]}},Se.def=function(ne){var le=this.rules.block.def.exec(ne);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var O=le[1].toLowerCase().replace(/\s+/g," ");return{tag:O,raw:le[0],href:le[2],title:le[3]}}},Se.table=function(ne){var le=this.rules.block.table.exec(ne);if(le){var O={type:"table",header:he(le[1].replace(/^ *| *\| *$/g,"")),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:le[3]?le[3].replace(/\n$/,"").split(`
`):[]};if(O.header.length===O.align.length){O.raw=le[0];var Y=O.align.length,oe;for(oe=0;oe<Y;oe++)/^ *-+: *$/.test(O.align[oe])?O.align[oe]="right":/^ *:-+: *$/.test(O.align[oe])?O.align[oe]="center":/^ *:-+ *$/.test(O.align[oe])?O.align[oe]="left":O.align[oe]=null;for(Y=O.cells.length,oe=0;oe<Y;oe++)O.cells[oe]=he(O.cells[oe].replace(/^ *\| *| *\| *$/g,""),O.header.length);return O}}},Se.lheading=function(ne){var le=this.rules.block.lheading.exec(ne);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1]}},Se.paragraph=function(ne){var le=this.rules.block.paragraph.exec(ne);if(le)return{type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1]}},Se.text=function(ne){var le=this.rules.block.text.exec(ne);if(le)return{type:"text",raw:le[0],text:le[0]}},Se.escape=function(ne){var le=this.rules.inline.escape.exec(ne);if(le)return{type:"escape",raw:le[0],text:$(le[1])}},Se.tag=function(ne,le,O){var Y=this.rules.inline.tag.exec(ne);if(Y)return!le&&/^<a /i.test(Y[0])?le=!0:le&&/^<\/a>/i.test(Y[0])&&(le=!1),!O&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?O=!0:O&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(O=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:le,inRawBlock:O,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):$(Y[0]):Y[0]}},Se.link=function(ne){var le=this.rules.inline.link.exec(ne);if(le){var O=le[2].trim();if(!this.options.pedantic&&/^</.test(O)){if(!/>$/.test(O))return;var Y=de(O.slice(0,-1),"\\");if((O.length-Y.length)%2==0)return}else{var oe=q(le[2],"()");if(oe>-1){var ke=le[0].indexOf("!")===0?5:4,Ie=ke+le[1].length+oe;le[2]=le[2].substring(0,oe),le[0]=le[0].substring(0,Ie).trim(),le[3]=""}}var Le=le[2],Ue="";if(this.options.pedantic){var Qe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Le);Qe&&(Le=Qe[1],Ue=Qe[3])}else Ue=le[3]?le[3].slice(1,-1):"";return Le=Le.trim(),/^</.test(Le)&&(this.options.pedantic&&!/>$/.test(O)?Le=Le.slice(1):Le=Le.slice(1,-1)),x(le,{href:Le&&Le.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},le[0])}},Se.reflink=function(ne,le){var O;if((O=this.rules.inline.reflink.exec(ne))||(O=this.rules.inline.nolink.exec(ne))){var Y=(O[2]||O[1]).replace(/\s+/g," ");if(Y=le[Y.toLowerCase()],!Y||!Y.href){var oe=O[0].charAt(0);return{type:"text",raw:oe,text:oe}}return x(O,Y,O[0])}},Se.emStrong=function(ne,le,O){O===void 0&&(O="");var Y=this.rules.inline.emStrong.lDelim.exec(ne);if(!!Y&&!(Y[3]&&O.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var oe=Y[1]||Y[2]||"";if(!oe||oe&&(O===""||this.rules.inline.punctuation.exec(O))){var ke=Y[0].length-1,Ie,Le,Ue=ke,Qe=0,rt=Y[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,le=le.slice(-1*ne.length+ke);(Y=rt.exec(le))!=null;)if(Ie=Y[1]||Y[2]||Y[3]||Y[4]||Y[5]||Y[6],!!Ie){if(Le=Ie.length,Y[3]||Y[4]){Ue+=Le;continue}else if((Y[5]||Y[6])&&ke%3&&!((ke+Le)%3)){Qe+=Le;continue}if(Ue-=Le,!(Ue>0)){if(Ue+Qe-Le<=0&&!le.slice(rt.lastIndex).match(rt)&&(Le=Math.min(Le,Le+Ue+Qe)),Math.min(ke,Le)%2)return{type:"em",raw:ne.slice(0,ke+Y.index+Le+1),text:ne.slice(1,ke+Y.index+Le)};if(Math.min(ke,Le)%2==0)return{type:"strong",raw:ne.slice(0,ke+Y.index+Le+1),text:ne.slice(2,ke+Y.index+Le-1)}}}}}},Se.codespan=function(ne){var le=this.rules.inline.code.exec(ne);if(le){var O=le[2].replace(/\n/g," "),Y=/[^ ]/.test(O),oe=/^ /.test(O)&&/ $/.test(O);return Y&&oe&&(O=O.substring(1,O.length-1)),O=$(O,!0),{type:"codespan",raw:le[0],text:O}}},Se.br=function(ne){var le=this.rules.inline.br.exec(ne);if(le)return{type:"br",raw:le[0]}},Se.del=function(ne){var le=this.rules.inline.del.exec(ne);if(le)return{type:"del",raw:le[0],text:le[2]}},Se.autolink=function(ne,le){var O=this.rules.inline.autolink.exec(ne);if(O){var Y,oe;return O[2]==="@"?(Y=$(this.options.mangle?le(O[1]):O[1]),oe="mailto:"+Y):(Y=$(O[1]),oe=Y),{type:"link",raw:O[0],text:Y,href:oe,tokens:[{type:"text",raw:Y,text:Y}]}}},Se.url=function(ne,le){var O;if(O=this.rules.inline.url.exec(ne)){var Y,oe;if(O[2]==="@")Y=$(this.options.mangle?le(O[0]):O[0]),oe="mailto:"+Y;else{var ke;do ke=O[0],O[0]=this.rules.inline._backpedal.exec(O[0])[0];while(ke!==O[0]);Y=$(O[0]),O[1]==="www."?oe="http://"+Y:oe=Y}return{type:"link",raw:O[0],text:Y,href:oe,tokens:[{type:"text",raw:Y,text:Y}]}}},Se.inlineText=function(ne,le,O){var Y=this.rules.inline.text.exec(ne);if(Y){var oe;return le?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):$(Y[0]):Y[0]:oe=$(this.options.smartypants?O(Y[0]):Y[0]),{type:"text",raw:Y[0],text:oe}}},ye}(),M=N.noopTest,B=N.edit,G=N.merge,K={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};K._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,K._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,K.def=B(K.def).replace("label",K._label).replace("title",K._title).getRegex(),K.bullet=/(?:[*+-]|\d{1,9}[.)])/,K.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,K.item=B(K.item,"gm").replace(/bull/g,K.bullet).getRegex(),K.listItemStart=B(/^( *)(bull)/).replace("bull",K.bullet).getRegex(),K.list=B(K.list).replace(/bull/g,K.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+K.def.source+")").getRegex(),K._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",K._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,K.html=B(K.html,"i").replace("comment",K._comment).replace("tag",K._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),K.paragraph=B(K._paragraph).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",K._tag).getRegex(),K.blockquote=B(K.blockquote).replace("paragraph",K.paragraph).getRegex(),K.normal=G({},K),K.gfm=G({},K.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),K.gfm.nptable=B(K.gfm.nptable).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",K._tag).getRegex(),K.gfm.table=B(K.gfm.table).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",K._tag).getRegex(),K.pedantic=G({},K.normal,{html:B(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",K._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:B(K.normal._paragraph).replace("hr",K.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",K.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=B(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=B(K._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=B(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=B(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=B(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=B(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=B(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=B(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=B(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=B(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=G({},se),se.pedantic=G({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:B(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:B(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=G({},se.normal,{escape:B(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),se.gfm.url=B(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=G({},se.gfm,{br:B(se.br).replace("{2,}","*").getRegex(),text:B(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var pe={block:K,inline:se},Fe=E.defaults,We=pe.block,Ne=pe.inline,ze=N.repeatString;function Ve(ye){return ye.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(ye){var Se="",Ce,ne,le=ye.length;for(Ce=0;Ce<le;Ce++)ne=ye.charCodeAt(Ce),Math.random()>.5&&(ne="x"+ne.toString(16)),Se+="&#"+ne+";";return Se}var Q=function(){function ye(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Fe,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ne={block:We.normal,inline:Ne.normal};this.options.pedantic?(ne.block=We.pedantic,ne.inline=Ne.pedantic):this.options.gfm&&(ne.block=We.gfm,this.options.breaks?ne.inline=Ne.breaks:ne.inline=Ne.gfm),this.tokenizer.rules=ne}ye.lex=function(ne,le){var O=new ye(le);return O.lex(ne)},ye.lexInline=function(ne,le){var O=new ye(le);return O.inlineTokens(ne)};var Se=ye.prototype;return Se.lex=function(ne){return ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens,!0),this.inline(this.tokens),this.tokens},Se.blockTokens=function(ne,le,O){le===void 0&&(le=[]),O===void 0&&(O=!0),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var Y,oe,ke,Ie;ne;){if(Y=this.tokenizer.space(ne)){ne=ne.substring(Y.raw.length),Y.type&&le.push(Y);continue}if(Y=this.tokenizer.code(ne)){ne=ne.substring(Y.raw.length),Ie=le[le.length-1],Ie&&Ie.type==="paragraph"?(Ie.raw+=`
`+Y.raw,Ie.text+=`
`+Y.text):le.push(Y);continue}if(Y=this.tokenizer.fences(ne)){ne=ne.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.heading(ne)){ne=ne.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.nptable(ne)){ne=ne.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.hr(ne)){ne=ne.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.blockquote(ne)){ne=ne.substring(Y.raw.length),Y.tokens=this.blockTokens(Y.text,[],O),le.push(Y);continue}if(Y=this.tokenizer.list(ne)){for(ne=ne.substring(Y.raw.length),ke=Y.items.length,oe=0;oe<ke;oe++)Y.items[oe].tokens=this.blockTokens(Y.items[oe].text,[],!1);le.push(Y);continue}if(Y=this.tokenizer.html(ne)){ne=ne.substring(Y.raw.length),le.push(Y);continue}if(O&&(Y=this.tokenizer.def(ne))){ne=ne.substring(Y.raw.length),this.tokens.links[Y.tag]||(this.tokens.links[Y.tag]={href:Y.href,title:Y.title});continue}if(Y=this.tokenizer.table(ne)){ne=ne.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.lheading(ne)){ne=ne.substring(Y.raw.length),le.push(Y);continue}if(O&&(Y=this.tokenizer.paragraph(ne))){ne=ne.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.text(ne)){ne=ne.substring(Y.raw.length),Ie=le[le.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+Y.raw,Ie.text+=`
`+Y.text):le.push(Y);continue}if(ne){var Le="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Le);break}else throw new Error(Le)}}return le},Se.inline=function(ne){var le,O,Y,oe,ke,Ie,Le=ne.length;for(le=0;le<Le;le++)switch(Ie=ne[le],Ie.type){case"paragraph":case"text":case"heading":{Ie.tokens=[],this.inlineTokens(Ie.text,Ie.tokens);break}case"table":{for(Ie.tokens={header:[],cells:[]},oe=Ie.header.length,O=0;O<oe;O++)Ie.tokens.header[O]=[],this.inlineTokens(Ie.header[O],Ie.tokens.header[O]);for(oe=Ie.cells.length,O=0;O<oe;O++)for(ke=Ie.cells[O],Ie.tokens.cells[O]=[],Y=0;Y<ke.length;Y++)Ie.tokens.cells[O][Y]=[],this.inlineTokens(ke[Y],Ie.tokens.cells[O][Y]);break}case"blockquote":{this.inline(Ie.tokens);break}case"list":{for(oe=Ie.items.length,O=0;O<oe;O++)this.inline(Ie.items[O].tokens);break}}return ne},Se.inlineTokens=function(ne,le,O,Y){le===void 0&&(le=[]),O===void 0&&(O=!1),Y===void 0&&(Y=!1);var oe,ke,Ie=ne,Le,Ue,Qe;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Le=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)rt.includes(Le[0].slice(Le[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Le.index)+"["+ze("a",Le[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Le=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Le.index)+"["+ze("a",Le[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Le=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Le.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;){if(Ue||(Qe=""),Ue=!1,oe=this.tokenizer.escape(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.tag(ne,O,Y)){ne=ne.substring(oe.raw.length),O=oe.inLink,Y=oe.inRawBlock;var et=le[le.length-1];et&&oe.type==="text"&&et.type==="text"?(et.raw+=oe.raw,et.text+=oe.text):le.push(oe);continue}if(oe=this.tokenizer.link(ne)){ne=ne.substring(oe.raw.length),oe.type==="link"&&(oe.tokens=this.inlineTokens(oe.text,[],!0,Y)),le.push(oe);continue}if(oe=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(oe.raw.length);var Ye=le[le.length-1];oe.type==="link"?(oe.tokens=this.inlineTokens(oe.text,[],!0,Y),le.push(oe)):Ye&&oe.type==="text"&&Ye.type==="text"?(Ye.raw+=oe.raw,Ye.text+=oe.text):le.push(oe);continue}if(oe=this.tokenizer.emStrong(ne,Ie,Qe)){ne=ne.substring(oe.raw.length),oe.tokens=this.inlineTokens(oe.text,[],O,Y),le.push(oe);continue}if(oe=this.tokenizer.codespan(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.br(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.del(ne)){ne=ne.substring(oe.raw.length),oe.tokens=this.inlineTokens(oe.text,[],O,Y),le.push(oe);continue}if(oe=this.tokenizer.autolink(ne,W)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(!O&&(oe=this.tokenizer.url(ne,W))){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.inlineText(ne,Y,Ve)){ne=ne.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(Qe=oe.raw.slice(-1)),Ue=!0,ke=le[le.length-1],ke&&ke.type==="text"?(ke.raw+=oe.raw,ke.text+=oe.text):le.push(oe);continue}if(ne){var ot="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(ot);break}else throw new Error(ot)}}return le},e(ye,null,[{key:"rules",get:function(){return{block:We,inline:Ne}}}]),ye}(),te=E.defaults,re=N.cleanUrl,fe=N.escape,_e=function(){function ye(Ce){this.options=Ce||te}var Se=ye.prototype;return Se.code=function(ne,le,O){var Y=(le||"").match(/\S*/)[0];if(this.options.highlight){var oe=this.options.highlight(ne,Y);oe!=null&&oe!==ne&&(O=!0,ne=oe)}return ne=ne.replace(/\n$/,"")+`
`,Y?'<pre><code class="'+this.options.langPrefix+fe(Y,!0)+'">'+(O?ne:fe(ne,!0))+`</code></pre>
`:"<pre><code>"+(O?ne:fe(ne,!0))+`</code></pre>
`},Se.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},Se.html=function(ne){return ne},Se.heading=function(ne,le,O,Y){return this.options.headerIds?"<h"+le+' id="'+this.options.headerPrefix+Y.slug(O)+'">'+ne+"</h"+le+`>
`:"<h"+le+">"+ne+"</h"+le+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(ne,le,O){var Y=le?"ol":"ul",oe=le&&O!==1?' start="'+O+'"':"";return"<"+Y+oe+`>
`+ne+"</"+Y+`>
`},Se.listitem=function(ne){return"<li>"+ne+`</li>
`},Se.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(ne){return"<p>"+ne+`</p>
`},Se.table=function(ne,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+le+`</table>
`},Se.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},Se.tablecell=function(ne,le){var O=le.header?"th":"td",Y=le.align?"<"+O+' align="'+le.align+'">':"<"+O+">";return Y+ne+"</"+O+`>
`},Se.strong=function(ne){return"<strong>"+ne+"</strong>"},Se.em=function(ne){return"<em>"+ne+"</em>"},Se.codespan=function(ne){return"<code>"+ne+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(ne){return"<del>"+ne+"</del>"},Se.link=function(ne,le,O){if(ne=re(this.options.sanitize,this.options.baseUrl,ne),ne===null)return O;var Y='<a href="'+fe(ne)+'"';return le&&(Y+=' title="'+le+'"'),Y+=">"+O+"</a>",Y},Se.image=function(ne,le,O){if(ne=re(this.options.sanitize,this.options.baseUrl,ne),ne===null)return O;var Y='<img src="'+ne+'" alt="'+O+'"';return le&&(Y+=' title="'+le+'"'),Y+=this.options.xhtml?"/>":">",Y},Se.text=function(ne){return ne},ye}(),ue=function(){function ye(){}var Se=ye.prototype;return Se.strong=function(ne){return ne},Se.em=function(ne){return ne},Se.codespan=function(ne){return ne},Se.del=function(ne){return ne},Se.html=function(ne){return ne},Se.text=function(ne){return ne},Se.link=function(ne,le,O){return""+O},Se.image=function(ne,le,O){return""+O},Se.br=function(){return""},ye}(),we=function(){function ye(){this.seen={}}var Se=ye.prototype;return Se.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(ne,le){var O=ne,Y=0;if(this.seen.hasOwnProperty(O)){Y=this.seen[ne];do Y++,O=ne+"-"+Y;while(this.seen.hasOwnProperty(O))}return le||(this.seen[ne]=Y,this.seen[O]=0),O},Se.slug=function(ne,le){le===void 0&&(le={});var O=this.serialize(ne);return this.getNextSafeSlug(O,le.dryrun)},ye}(),Ae=E.defaults,xe=N.unescape,ge=function(){function ye(Ce){this.options=Ce||Ae,this.options.renderer=this.options.renderer||new _e,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ue,this.slugger=new we}ye.parse=function(ne,le){var O=new ye(le);return O.parse(ne)},ye.parseInline=function(ne,le){var O=new ye(le);return O.parseInline(ne)};var Se=ye.prototype;return Se.parse=function(ne,le){le===void 0&&(le=!0);var O="",Y,oe,ke,Ie,Le,Ue,Qe,rt,et,Ye,ot,_t,wt,vt,ie,Ee,ae,V,Me=ne.length;for(Y=0;Y<Me;Y++)switch(Ye=ne[Y],Ye.type){case"space":continue;case"hr":{O+=this.renderer.hr();continue}case"heading":{O+=this.renderer.heading(this.parseInline(Ye.tokens),Ye.depth,xe(this.parseInline(Ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{O+=this.renderer.code(Ye.text,Ye.lang,Ye.escaped);continue}case"table":{for(rt="",Qe="",Ie=Ye.header.length,oe=0;oe<Ie;oe++)Qe+=this.renderer.tablecell(this.parseInline(Ye.tokens.header[oe]),{header:!0,align:Ye.align[oe]});for(rt+=this.renderer.tablerow(Qe),et="",Ie=Ye.cells.length,oe=0;oe<Ie;oe++){for(Ue=Ye.tokens.cells[oe],Qe="",Le=Ue.length,ke=0;ke<Le;ke++)Qe+=this.renderer.tablecell(this.parseInline(Ue[ke]),{header:!1,align:Ye.align[ke]});et+=this.renderer.tablerow(Qe)}O+=this.renderer.table(rt,et);continue}case"blockquote":{et=this.parse(Ye.tokens),O+=this.renderer.blockquote(et);continue}case"list":{for(ot=Ye.ordered,_t=Ye.start,wt=Ye.loose,Ie=Ye.items.length,et="",oe=0;oe<Ie;oe++)ie=Ye.items[oe],Ee=ie.checked,ae=ie.task,vt="",ie.task&&(V=this.renderer.checkbox(Ee),wt?ie.tokens.length>0&&ie.tokens[0].type==="text"?(ie.tokens[0].text=V+" "+ie.tokens[0].text,ie.tokens[0].tokens&&ie.tokens[0].tokens.length>0&&ie.tokens[0].tokens[0].type==="text"&&(ie.tokens[0].tokens[0].text=V+" "+ie.tokens[0].tokens[0].text)):ie.tokens.unshift({type:"text",text:V}):vt+=V),vt+=this.parse(ie.tokens,wt),et+=this.renderer.listitem(vt,ae,Ee);O+=this.renderer.list(et,ot,_t);continue}case"html":{O+=this.renderer.html(Ye.text);continue}case"paragraph":{O+=this.renderer.paragraph(this.parseInline(Ye.tokens));continue}case"text":{for(et=Ye.tokens?this.parseInline(Ye.tokens):Ye.text;Y+1<Me&&ne[Y+1].type==="text";)Ye=ne[++Y],et+=`
`+(Ye.tokens?this.parseInline(Ye.tokens):Ye.text);O+=le?this.renderer.paragraph(et):et;continue}default:{var Te='Token with "'+Ye.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}return O},Se.parseInline=function(ne,le){le=le||this.renderer;var O="",Y,oe,ke=ne.length;for(Y=0;Y<ke;Y++)switch(oe=ne[Y],oe.type){case"escape":{O+=le.text(oe.text);break}case"html":{O+=le.html(oe.text);break}case"link":{O+=le.link(oe.href,oe.title,this.parseInline(oe.tokens,le));break}case"image":{O+=le.image(oe.href,oe.title,oe.text);break}case"strong":{O+=le.strong(this.parseInline(oe.tokens,le));break}case"em":{O+=le.em(this.parseInline(oe.tokens,le));break}case"codespan":{O+=le.codespan(oe.text);break}case"br":{O+=le.br();break}case"del":{O+=le.del(this.parseInline(oe.tokens,le));break}case"text":{O+=le.text(oe.text);break}default:{var Ie='Token with "'+oe.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}return O},ye}(),Ke=N.merge,j=N.checkSanitizeDeprecation,Z=N.escape,me=E.getDefaults,Oe=E.changeDefaults,He=E.defaults;function $e(ye,Se,Ce){if(typeof ye=="undefined"||ye===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");if(typeof Se=="function"&&(Ce=Se,Se=null),Se=Ke({},$e.defaults,Se||{}),j(Se),Ce){var ne=Se.highlight,le;try{le=Q.lex(ye,Se)}catch(ke){return Ce(ke)}var O=function(Ie){var Le;if(!Ie)try{Le=ge.parse(le,Se)}catch(Ue){Ie=Ue}return Se.highlight=ne,Ie?Ce(Ie):Ce(null,Le)};if(!ne||ne.length<3||(delete Se.highlight,!le.length))return O();var Y=0;$e.walkTokens(le,function(ke){ke.type==="code"&&(Y++,setTimeout(function(){ne(ke.text,ke.lang,function(Ie,Le){if(Ie)return O(Ie);Le!=null&&Le!==ke.text&&(ke.text=Le,ke.escaped=!0),Y--,Y===0&&O()})},0))}),Y===0&&O();return}try{var oe=Q.lex(ye,Se);return Se.walkTokens&&$e.walkTokens(oe,Se.walkTokens),ge.parse(oe,Se)}catch(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+Z(ke.message+"",!0)+"</pre>";throw ke}}$e.options=$e.setOptions=function(ye){return Ke($e.defaults,ye),Oe($e.defaults),$e},$e.getDefaults=me,$e.defaults=He,$e.use=function(ye){var Se=Ke({},ye);if(ye.renderer&&function(){var ne=$e.defaults.renderer||new _e,le=function(oe){var ke=ne[oe];ne[oe]=function(){for(var Ie=arguments.length,Le=new Array(Ie),Ue=0;Ue<Ie;Ue++)Le[Ue]=arguments[Ue];var Qe=ye.renderer[oe].apply(ne,Le);return Qe===!1&&(Qe=ke.apply(ne,Le)),Qe}};for(var O in ye.renderer)le(O);Se.renderer=ne}(),ye.tokenizer&&function(){var ne=$e.defaults.tokenizer||new H,le=function(oe){var ke=ne[oe];ne[oe]=function(){for(var Ie=arguments.length,Le=new Array(Ie),Ue=0;Ue<Ie;Ue++)Le[Ue]=arguments[Ue];var Qe=ye.tokenizer[oe].apply(ne,Le);return Qe===!1&&(Qe=ke.apply(ne,Le)),Qe}};for(var O in ye.tokenizer)le(O);Se.tokenizer=ne}(),ye.walkTokens){var Ce=$e.defaults.walkTokens;Se.walkTokens=function(ne){ye.walkTokens(ne),Ce&&Ce(ne)}}$e.setOptions(Se)},$e.walkTokens=function(ye,Se){for(var Ce=S(ye),ne;!(ne=Ce()).done;){var le=ne.value;switch(Se(le),le.type){case"table":{for(var O=S(le.tokens.header),Y;!(Y=O()).done;){var oe=Y.value;$e.walkTokens(oe,Se)}for(var ke=S(le.tokens.cells),Ie;!(Ie=ke()).done;)for(var Le=Ie.value,Ue=S(Le),Qe;!(Qe=Ue()).done;){var rt=Qe.value;$e.walkTokens(rt,Se)}break}case"list":{$e.walkTokens(le.items,Se);break}default:le.tokens&&$e.walkTokens(le.tokens,Se)}}},$e.parseInline=function(ye,Se){if(typeof ye=="undefined"||ye===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");Se=Ke({},$e.defaults,Se||{}),j(Se);try{var Ce=Q.lexInline(ye,Se);return Se.walkTokens&&$e.walkTokens(Ce,Se.walkTokens),ge.parseInline(Ce,Se)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+Z(ne.message+"",!0)+"</pre>";throw ne}},$e.Parser=ge,$e.parser=ge.parse,$e.Renderer=_e,$e.TextRenderer=ue,$e.Lexer=Q,$e.lexer=Q.lex,$e.Tokenizer=H,$e.Slugger=we,$e.parse=$e;var Xe=$e;return Xe}),define(ve[81],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function v(E,D,y){return Math.min(Math.max(E,D),y)}e.clamp=v;function R(E,D){return(D+E%D)%D}e.rot=R;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class T{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function J(S){const T=[];typeof S=="number"&&T.push("code/timeOrigin",S);function E(y){T.push(y,Date.now())}function D(){const y=[];for(let k=0;k<T.length;k+=2)y.push({name:T[k],startTime:T[k+1]});return y}return{mark:E,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const E of performance.getEntriesByType("mark"))T.push({name:E.name,startTime:Math.round(S+E.startTime)});return T}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function v(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))}(),define(ve[21],be([0,1]),function(J,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let S=!1,T=!1,E=!1,D=!1,y=!1,k=!1,n=!1,P,d=R,g,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?m=e.globals.vscode.process:typeof process!="undefined"&&(m=process);const c=typeof((v=m==null?void 0:m.versions)===null||v===void 0?void 0:v.electron)=="string"&&m.type==="renderer";if(e.isElectronSandboxed=c&&(m==null?void 0:m.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const o=m==null?void 0:m.env.VSCODE_BROWSER_CODE_LOADING;if(typeof o=="string")return o==="none"||o==="code"||o==="bypassHeatCheck"||o==="bypassHeatCheckAndEagerCompile"?o:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!c)r=navigator.userAgent,S=r.indexOf("Windows")>=0,T=r.indexOf("Macintosh")>=0,n=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=r.indexOf("Linux")>=0,k=!0,P=navigator.language,d=P;else if(typeof m=="object"){S=m.platform==="win32",T=m.platform==="darwin",E=m.platform==="linux",D=E&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,P=R,d=R;const o=m.env.VSCODE_NLS_CONFIG;if(o)try{const u=JSON.parse(o),_=u.availableLanguages["*"];P=u.locale,d=_||R,g=u._translationsConfigFile}catch(u){}y=!0}else console.error("Unable to resolve platform.");var p;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function w(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let a=0;T?a=1:S?a=3:E&&(a=2),e.isWindows=S,e.isMacintosh=T,e.isLinux=E,e.isLinuxSnap=D,e.isNative=y,e.isWeb=k,e.isIOS=n,e.platform=a,e.userAgent=r,e.language=d;var h;(function(o){function u(){return e.language}o.value=u;function _(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=_;function b(){return e.language==="en"}o.isDefault=b})(h=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let _=[];e.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeSetImmediateId)for(let C=0,l=_.length;C<l;C++){const F=_[C];if(F.id===A.data.vscodeSetImmediateId){_.splice(C,1),F.callback();return}}});let b=0;return A=>{const C=++b;_.push({id:C,callback:A}),e.globals.postMessage({vscodeSetImmediateId:C},"*")}}if(typeof(m==null?void 0:m.nextTick)=="function")return m.nextTick.bind(m);const u=Promise.resolve();return _=>u.then(_)}();var f;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||n?2:S?1:3;let t=!0,i=!1;function s(){if(!i){i=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,t=new Uint16Array(o.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(ve[46],be([0,1,21]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const S=v.globals.vscode.process;R={get platform(){return S.platform},get env(){return S.env},cwd(){return S.cwd()},nextTick(T){return(0,v.setImmediate)(T)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(S){return process.nextTick(S)}}:R={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(S){return(0,v.setImmediate)(S)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(ve[14],be([0,1,46]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,S=97,T=90,E=122,D=46,y=47,k=92,n=58,P=63;class d extends Error{constructor(h,f,t){let i;typeof f=="string"&&f.indexOf("not ")===0?(i="must not be",f=f.replace(/^not /,"")):i="must be";const s=h.indexOf(".")!==-1?"property":"argument";let o=`The "${h}" ${s} ${i} of type ${f}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function g(a,h){if(typeof a!="string")throw new d(h,"string",a)}function r(a){return a===y||a===k}function m(a){return a===y}function c(a){return a>=R&&a<=T||a>=S&&a<=E}function p(a,h,f,t){let i="",s=0,o=-1,u=0,_=0;for(let b=0;b<=a.length;++b){if(b<a.length)_=a.charCodeAt(b);else{if(t(_))break;_=y}if(t(_)){if(!(o===b-1||u===1))if(u===2){if(i.length<2||s!==2||i.charCodeAt(i.length-1)!==D||i.charCodeAt(i.length-2)!==D){if(i.length>2){const A=i.lastIndexOf(f);A===-1?(i="",s=0):(i=i.slice(0,A),s=i.length-1-i.lastIndexOf(f)),o=b,u=0;continue}else if(i.length!==0){i="",s=0,o=b,u=0;continue}}h&&(i+=i.length>0?`${f}..`:"..",s=2)}else i.length>0?i+=`${f}${a.slice(o+1,b)}`:i=a.slice(o+1,b),s=b-o-1;o=b,u=0}else _===D&&u!==-1?++u:u=-1}return i}function w(a,h){if(h===null||typeof h!="object")throw new d("pathObject","Object",h);const f=h.dir||h.root,t=h.base||`${h.name||""}${h.ext||""}`;return f?f===h.root?`${f}${t}`:`${f}${a}${t}`:t}e.win32={resolve(...a){let h="",f="",t=!1;for(let i=a.length-1;i>=-1;i--){let s;if(i>=0){if(s=a[i],g(s,"path"),s.length===0)continue}else h.length===0?s=v.cwd():(s=v.env[`=${h}`]||v.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==h.toLowerCase()&&s.charCodeAt(2)===k)&&(s=`${h}\\`));const o=s.length;let u=0,_="",b=!1;const A=s.charCodeAt(0);if(o===1)r(A)&&(u=1,b=!0);else if(r(A))if(b=!0,r(s.charCodeAt(1))){let C=2,l=C;for(;C<o&&!r(s.charCodeAt(C));)C++;if(C<o&&C!==l){const F=s.slice(l,C);for(l=C;C<o&&r(s.charCodeAt(C));)C++;if(C<o&&C!==l){for(l=C;C<o&&!r(s.charCodeAt(C));)C++;(C===o||C!==l)&&(_=`\\\\${F}\\${s.slice(l,C)}`,u=C)}}}else u=1;else c(A)&&s.charCodeAt(1)===n&&(_=s.slice(0,2),u=2,o>2&&r(s.charCodeAt(2))&&(b=!0,u=3));if(_.length>0)if(h.length>0){if(_.toLowerCase()!==h.toLowerCase())continue}else h=_;if(t){if(h.length>0)break}else if(f=`${s.slice(u)}\\${f}`,t=b,b&&h.length>0)break}return f=p(f,!t,"\\",r),t?`${h}\\${f}`:`${h}${f}`||"."},normalize(a){g(a,"path");const h=a.length;if(h===0)return".";let f=0,t,i=!1;const s=a.charCodeAt(0);if(h===1)return m(s)?"\\":a;if(r(s))if(i=!0,r(a.charCodeAt(1))){let u=2,_=u;for(;u<h&&!r(a.charCodeAt(u));)u++;if(u<h&&u!==_){const b=a.slice(_,u);for(_=u;u<h&&r(a.charCodeAt(u));)u++;if(u<h&&u!==_){for(_=u;u<h&&!r(a.charCodeAt(u));)u++;if(u===h)return`\\\\${b}\\${a.slice(_)}\\`;u!==_&&(t=`\\\\${b}\\${a.slice(_,u)}`,f=u)}}}else f=1;else c(s)&&a.charCodeAt(1)===n&&(t=a.slice(0,2),f=2,h>2&&r(a.charCodeAt(2))&&(i=!0,f=3));let o=f<h?p(a.slice(f),!i,"\\",r):"";return o.length===0&&!i&&(o="."),o.length>0&&r(a.charCodeAt(h-1))&&(o+="\\"),t===void 0?i?`\\${o}`:o:i?`${t}\\${o}`:`${t}${o}`},isAbsolute(a){g(a,"path");const h=a.length;if(h===0)return!1;const f=a.charCodeAt(0);return r(f)||h>2&&c(f)&&a.charCodeAt(1)===n&&r(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let h,f;for(let s=0;s<a.length;++s){const o=a[s];g(o,"path"),o.length>0&&(h===void 0?h=f=o:h+=`\\${o}`)}if(h===void 0)return".";let t=!0,i=0;if(typeof f=="string"&&r(f.charCodeAt(0))){++i;const s=f.length;s>1&&r(f.charCodeAt(1))&&(++i,s>2&&(r(f.charCodeAt(2))?++i:t=!1))}if(t){for(;i<h.length&&r(h.charCodeAt(i));)i++;i>=2&&(h=`\\${h.slice(i)}`)}return e.win32.normalize(h)},relative(a,h){if(g(a,"from"),g(h,"to"),a===h)return"";const f=e.win32.resolve(a),t=e.win32.resolve(h);if(f===t||(a=f.toLowerCase(),h=t.toLowerCase(),a===h))return"";let i=0;for(;i<a.length&&a.charCodeAt(i)===k;)i++;let s=a.length;for(;s-1>i&&a.charCodeAt(s-1)===k;)s--;const o=s-i;let u=0;for(;u<h.length&&h.charCodeAt(u)===k;)u++;let _=h.length;for(;_-1>u&&h.charCodeAt(_-1)===k;)_--;const b=_-u,A=o<b?o:b;let C=-1,l=0;for(;l<A;l++){const N=a.charCodeAt(i+l);if(N!==h.charCodeAt(u+l))break;N===k&&(C=l)}if(l!==A){if(C===-1)return t}else{if(b>A){if(h.charCodeAt(u+l)===k)return t.slice(u+l+1);if(l===2)return t.slice(u+l)}o>A&&(a.charCodeAt(i+l)===k?C=l:l===2&&(C=3)),C===-1&&(C=0)}let F="";for(l=i+C+1;l<=s;++l)(l===s||a.charCodeAt(l)===k)&&(F+=F.length===0?"..":"\\..");return u+=C,F.length>0?`${F}${t.slice(u,_)}`:(t.charCodeAt(u)===k&&++u,t.slice(u,_))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const h=e.win32.resolve(a);if(h.length<=2)return a;if(h.charCodeAt(0)===k){if(h.charCodeAt(1)===k){const f=h.charCodeAt(2);if(f!==P&&f!==D)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(c(h.charCodeAt(0))&&h.charCodeAt(1)===n&&h.charCodeAt(2)===k)return`\\\\?\\${h}`;return a},dirname(a){g(a,"path");const h=a.length;if(h===0)return".";let f=-1,t=0;const i=a.charCodeAt(0);if(h===1)return r(i)?a:".";if(r(i)){if(f=t=1,r(a.charCodeAt(1))){let u=2,_=u;for(;u<h&&!r(a.charCodeAt(u));)u++;if(u<h&&u!==_){for(_=u;u<h&&r(a.charCodeAt(u));)u++;if(u<h&&u!==_){for(_=u;u<h&&!r(a.charCodeAt(u));)u++;if(u===h)return a;u!==_&&(f=t=u+1)}}}}else c(i)&&a.charCodeAt(1)===n&&(f=h>2&&r(a.charCodeAt(2))?3:2,t=f);let s=-1,o=!0;for(let u=h-1;u>=t;--u)if(r(a.charCodeAt(u))){if(!o){s=u;break}}else o=!1;if(s===-1){if(f===-1)return".";s=f}return a.slice(0,s)},basename(a,h){h!==void 0&&g(h,"ext"),g(a,"path");let f=0,t=-1,i=!0,s;if(a.length>=2&&c(a.charCodeAt(0))&&a.charCodeAt(1)===n&&(f=2),h!==void 0&&h.length>0&&h.length<=a.length){if(h===a)return"";let o=h.length-1,u=-1;for(s=a.length-1;s>=f;--s){const _=a.charCodeAt(s);if(r(_)){if(!i){f=s+1;break}}else u===-1&&(i=!1,u=s+1),o>=0&&(_===h.charCodeAt(o)?--o==-1&&(t=s):(o=-1,t=u))}return f===t?t=u:t===-1&&(t=a.length),a.slice(f,t)}for(s=a.length-1;s>=f;--s)if(r(a.charCodeAt(s))){if(!i){f=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":a.slice(f,t)},extname(a){g(a,"path");let h=0,f=-1,t=0,i=-1,s=!0,o=0;a.length>=2&&a.charCodeAt(1)===n&&c(a.charCodeAt(0))&&(h=t=2);for(let u=a.length-1;u>=h;--u){const _=a.charCodeAt(u);if(r(_)){if(!s){t=u+1;break}continue}i===-1&&(s=!1,i=u+1),_===D?f===-1?f=u:o!==1&&(o=1):f!==-1&&(o=-1)}return f===-1||i===-1||o===0||o===1&&f===i-1&&f===t+1?"":a.slice(f,i)},format:w.bind(null,"\\"),parse(a){g(a,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return h;const f=a.length;let t=0,i=a.charCodeAt(0);if(f===1)return r(i)?(h.root=h.dir=a,h):(h.base=h.name=a,h);if(r(i)){if(t=1,r(a.charCodeAt(1))){let C=2,l=C;for(;C<f&&!r(a.charCodeAt(C));)C++;if(C<f&&C!==l){for(l=C;C<f&&r(a.charCodeAt(C));)C++;if(C<f&&C!==l){for(l=C;C<f&&!r(a.charCodeAt(C));)C++;C===f?t=C:C!==l&&(t=C+1)}}}}else if(c(i)&&a.charCodeAt(1)===n){if(f<=2)return h.root=h.dir=a,h;if(t=2,r(a.charCodeAt(2))){if(f===3)return h.root=h.dir=a,h;t=3}}t>0&&(h.root=a.slice(0,t));let s=-1,o=t,u=-1,_=!0,b=a.length-1,A=0;for(;b>=t;--b){if(i=a.charCodeAt(b),r(i)){if(!_){o=b+1;break}continue}u===-1&&(_=!1,u=b+1),i===D?s===-1?s=b:A!==1&&(A=1):s!==-1&&(A=-1)}return u!==-1&&(s===-1||A===0||A===1&&s===u-1&&s===o+1?h.base=h.name=a.slice(o,u):(h.name=a.slice(o,s),h.base=a.slice(o,u),h.ext=a.slice(s,u))),o>0&&o!==t?h.dir=a.slice(0,o-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let h="",f=!1;for(let t=a.length-1;t>=-1&&!f;t--){const i=t>=0?a[t]:v.cwd();g(i,"path"),i.length!==0&&(h=`${i}/${h}`,f=i.charCodeAt(0)===y)}return h=p(h,!f,"/",m),f?`/${h}`:h.length>0?h:"."},normalize(a){if(g(a,"path"),a.length===0)return".";const h=a.charCodeAt(0)===y,f=a.charCodeAt(a.length-1)===y;return a=p(a,!h,"/",m),a.length===0?h?"/":f?"./":".":(f&&(a+="/"),h?`/${a}`:a)},isAbsolute(a){return g(a,"path"),a.length>0&&a.charCodeAt(0)===y},join(...a){if(a.length===0)return".";let h;for(let f=0;f<a.length;++f){const t=a[f];g(t,"path"),t.length>0&&(h===void 0?h=t:h+=`/${t}`)}return h===void 0?".":e.posix.normalize(h)},relative(a,h){if(g(a,"from"),g(h,"to"),a===h||(a=e.posix.resolve(a),h=e.posix.resolve(h),a===h))return"";const f=1,t=a.length,i=t-f,s=1,o=h.length-s,u=i<o?i:o;let _=-1,b=0;for(;b<u;b++){const C=a.charCodeAt(f+b);if(C!==h.charCodeAt(s+b))break;C===y&&(_=b)}if(b===u)if(o>u){if(h.charCodeAt(s+b)===y)return h.slice(s+b+1);if(b===0)return h.slice(s+b)}else i>u&&(a.charCodeAt(f+b)===y?_=b:b===0&&(_=0));let A="";for(b=f+_+1;b<=t;++b)(b===t||a.charCodeAt(b)===y)&&(A+=A.length===0?"..":"/..");return`${A}${h.slice(s+_)}`},toNamespacedPath(a){return a},dirname(a){if(g(a,"path"),a.length===0)return".";const h=a.charCodeAt(0)===y;let f=-1,t=!0;for(let i=a.length-1;i>=1;--i)if(a.charCodeAt(i)===y){if(!t){f=i;break}}else t=!1;return f===-1?h?"/":".":h&&f===1?"//":a.slice(0,f)},basename(a,h){h!==void 0&&g(h,"ext"),g(a,"path");let f=0,t=-1,i=!0,s;if(h!==void 0&&h.length>0&&h.length<=a.length){if(h===a)return"";let o=h.length-1,u=-1;for(s=a.length-1;s>=0;--s){const _=a.charCodeAt(s);if(_===y){if(!i){f=s+1;break}}else u===-1&&(i=!1,u=s+1),o>=0&&(_===h.charCodeAt(o)?--o==-1&&(t=s):(o=-1,t=u))}return f===t?t=u:t===-1&&(t=a.length),a.slice(f,t)}for(s=a.length-1;s>=0;--s)if(a.charCodeAt(s)===y){if(!i){f=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":a.slice(f,t)},extname(a){g(a,"path");let h=-1,f=0,t=-1,i=!0,s=0;for(let o=a.length-1;o>=0;--o){const u=a.charCodeAt(o);if(u===y){if(!i){f=o+1;break}continue}t===-1&&(i=!1,t=o+1),u===D?h===-1?h=o:s!==1&&(s=1):h!==-1&&(s=-1)}return h===-1||t===-1||s===0||s===1&&h===t-1&&h===f+1?"":a.slice(h,t)},format:w.bind(null,"/"),parse(a){g(a,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return h;const f=a.charCodeAt(0)===y;let t;f?(h.root="/",t=1):t=0;let i=-1,s=0,o=-1,u=!0,_=a.length-1,b=0;for(;_>=t;--_){const A=a.charCodeAt(_);if(A===y){if(!u){s=_+1;break}continue}o===-1&&(u=!1,o=_+1),A===D?i===-1?i=_:b!==1&&(b=1):i!==-1&&(b=-1)}if(o!==-1){const A=s===0&&f?1:s;i===-1||b===0||b===1&&i===o-1&&i===s+1?h.base=h.name=a.slice(A,o):(h.name=a.slice(A,i),h.base=a.slice(A,o),h.ext=a.slice(i,o))}return s>0?h.dir=a.slice(0,s-1):f&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[56],be([0,1,21]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=v.globals.performance&&typeof v.globals.performance.now=="function";class S{constructor(E){this._highResolution=R&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new S(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=S}),define(ve[3],be([0,1,12,54,6,45,56]),function(J,e,v,R,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(p){p.None=()=>S.Disposable.None;function w($){return(q,x=null,I)=>{let H=!1,M;return M=$(B=>{if(!H)return M?M.dispose():H=!0,q.call(x,B)},null,I),H&&M.dispose(),M}}p.once=w;function a($,q){return o((x,I=null,H)=>$(M=>x.call(I,q(M)),null,H))}p.map=a;function h($,q){return o((x,I=null,H)=>$(M=>{q(M),x.call(I,M)},null,H))}p.forEach=h;function f($,q){return o((x,I=null,H)=>$(M=>q(M)&&x.call(I,M),null,H))}p.filter=f;function t($){return $}p.signal=t;function i(...$){return(q,x=null,I)=>(0,S.combinedDisposable)(...$.map(H=>H(M=>q.call(x,M),null,I)))}p.any=i;function s($,q,x){let I=x;return a($,H=>(I=q(I,H),I))}p.reduce=s;function o($){let q;const x=new d({onFirstListenerAdd(){q=$(x.fire,x)},onLastListenerRemove(){q.dispose()}});return x.event}p.snapshot=o;function u($,q,x=100,I=!1,H){let M,B,G,K=0;const se=new d({leakWarningThreshold:H,onFirstListenerAdd(){M=$(pe=>{K++,B=q(B,pe),I&&!G&&(se.fire(B),B=void 0),clearTimeout(G),G=setTimeout(()=>{const Fe=B;B=void 0,G=void 0,(!I||K>1)&&se.fire(Fe),K=0},x)})},onLastListenerRemove(){M.dispose()}});return se.event}p.debounce=u;function _($){const q=new Date().getTime();return a(w($),x=>new Date().getTime()-q)}p.stopwatch=_;function b($,q=(x,I)=>x===I){let x=!0,I;return f($,H=>{const M=x||!q(H,I);return x=!1,I=H,M})}p.latch=b;function A($,q){return[p.filter($,q),p.filter($,x=>!q(x))]}p.split=A;function C($,q=!1,x=[]){let I=x.slice(),H=$(G=>{I?I.push(G):B.fire(G)});const M=()=>{I&&I.forEach(G=>B.fire(G)),I=null},B=new d({onFirstListenerAdd(){H||(H=$(G=>B.fire(G)))},onFirstListenerDidAdd(){I&&(q?setTimeout(M):M())},onLastListenerRemove(){H&&H.dispose(),H=null}});return B.event}p.buffer=C;class l{constructor(q){this.event=q}map(q){return new l(a(this.event,q))}forEach(q){return new l(h(this.event,q))}filter(q){return new l(f(this.event,q))}reduce(q,x){return new l(s(this.event,q,x))}latch(){return new l(b(this.event))}debounce(q,x=100,I=!1,H){return new l(u(this.event,q,x,I,H))}on(q,x,I){return this.event(q,x,I)}once(q,x,I){return w(this.event)(q,x,I)}}function F($){return new l($)}p.chain=F;function N($,q,x=I=>I){const I=(...G)=>B.fire(x(...G)),H=()=>$.on(q,I),M=()=>$.removeListener(q,I),B=new d({onFirstListenerAdd:H,onLastListenerRemove:M});return B.event}p.fromNodeEventEmitter=N;function z($,q,x=I=>I){const I=(...G)=>B.fire(x(...G)),H=()=>$.addEventListener(q,I),M=()=>$.removeEventListener(q,I),B=new d({onFirstListenerAdd:H,onLastListenerRemove:M});return B.event}p.fromDOMEventEmitter=z;function de($){const q=new d;let x=!1;return $.then(void 0,()=>null).then(()=>{x?q.fire(void 0):setTimeout(()=>q.fire(void 0),0)}),x=!0,q.event}p.fromPromise=de;function he($){return new Promise(q=>w($)(q))}p.toPromise=he})(D=e.Event||(e.Event={}));class y{constructor(w){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${w}_${y._idPool++}`}start(w){this._stopWatch=new E.StopWatch(!0),this._listenerCount=w}stop(){if(this._stopWatch){const w=this._stopWatch.elapsed();this._elapsedOverall+=w,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${w.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let k=-1;function n(p){const w=k;return k=p,{dispose(){k=w}}}e.setGlobalLeakWarningThreshold=n;class P{constructor(w,a=Math.random().toString(18).slice(2,5)){this.customThreshold=w,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(w){let a=k;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||w<a)return;this._stacks||(this._stacks=new Map);const h=new Error().stack.split(`
`).slice(3).join(`
`),f=this._stacks.get(h)||0;if(this._stacks.set(h,f+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let t,i=0;for(const[s,o]of this._stacks)(!t||i<o)&&(t=s,i=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(h)||0;this._stacks.set(h,t-1)}}}class d{constructor(w){var a;this._disposed=!1,this._options=w,this._leakageMon=k>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((a=this._options)===null||a===void 0?void 0:a._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(w,a,h)=>{var f;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(a?[w,a]:w);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,w,a);const s=(f=this._leakageMon)===null||f===void 0?void 0:f.check(this._listeners.size);let o;return o={dispose:()=>{s&&s(),o.dispose=d._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},h instanceof S.DisposableStore?h.add(o):Array.isArray(h)&&h.push(o),o}),this._event}fire(w){var a,h;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let f of this._listeners)this._deliveryQueue.push([f,w]);for((a=this._perfMon)===null||a===void 0||a.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[f,t]=this._deliveryQueue.shift();try{typeof f=="function"?f.call(void 0,t):f[0].call(f[1],t)}catch(i){(0,v.onUnexpectedError)(i)}}(h=this._perfMon)===null||h===void 0||h.stop()}}dispose(){var w,a,h,f,t;this._disposed||(this._disposed=!0,(w=this._listeners)===null||w===void 0||w.clear(),(a=this._deliveryQueue)===null||a===void 0||a.clear(),(f=(h=this._options)===null||h===void 0?void 0:h.onLastListenerRemove)===null||f===void 0||f.call(h),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=d,d._noop=function(){};class g extends d{constructor(w){super(w);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=w==null?void 0:w.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const w=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(w))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(w){this._listeners&&(this._isPaused!==0?this._eventQueue.push(w):super.fire(w))}}e.PauseableEmitter=g;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(w){const a={event:w,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const h=()=>{this.hasListeners&&this.unhook(a);const f=this.events.indexOf(a);this.events.splice(f,1)};return(0,S.toDisposable)((0,R.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(w=>this.hook(w))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(w=>this.unhook(w))}hook(w){w.listener=w.event(a=>this.emitter.fire(a))}unhook(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class m{constructor(){this.buffers=[]}wrapEvent(w){return(a,h,f)=>w(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>a.call(h,t)):a.call(h,t)},void 0,f)}bufferEvents(w){const a=[];this.buffers.push(a);const h=w();return this.buffers.pop(),a.forEach(f=>f()),h}}e.EventBufferer=m;class c{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=S.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(w){this.inputEvent=w,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=w(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(ve[20],be([0,1,3]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(D,y){const k=setTimeout(D.bind(y),0);return{dispose(){clearTimeout(k)}}});var S;(function(D){function y(k){return k===D.None||k===D.Cancelled||k instanceof T?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}D.isCancellationToken=y,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(S=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=S.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=S.None}}e.CancellationTokenSource=E}),define(ve[35],be([0,1,3]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(P){const d=this._icons.get(P.id);d?P.description?d.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const S=new R;e.iconRegistry=S;function T(n,P){return new D(n,P)}e.registerCodicon=T;function E(n){return n?n.replace(/\$\((.*?)\)/g,(P,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=E;class D{constructor(P,d,g){this.id=P,this.definition=d,this.description=g,S.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function y(n,P){const d=["codicon","codicon-"+n];return P&&d.push("codicon-modifier-"+P),d}e.getClassNamesArray=y;var k;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function d(m){if(m instanceof D)return["codicon","codicon-"+m.id];const c=P.exec(m.id);if(!c)return d(D.error);let[,p,w]=c;const a=["codicon","codicon-"+p];return w&&a.push("codicon-modifier-"+w.substr(1)),a}n.asClassNameArray=d;function g(m){return d(m).join(" ")}n.asClassName=g;function r(m){return"."+d(m).join(".")}n.asCSSSelector=r})(k=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(ve[111],be([0,1,12,6]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function S(a){const h=a;return h?[h.on,h.pause,h.resume,h.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=S;function T(a){const h=a;return h?S(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=T;function E(a,h){return new D(a,h)}e.newWriteableStream=E;class D{constructor(h,f){this.reducer=h,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){var f;if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof((f=this.options)===null||f===void 0?void 0:f.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(f=>f(h))}emitError(h){this.listeners.error.length===0?(0,v.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(f=>f(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,f){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(h,f){if(this.state.destroyed)return;let t;switch(h){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(f);i>=0&&t.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(a,h){const f=[];let t;for(;(t=a.read())!==null;)f.push(t);return h(f)}e.consumeReadable=y;function k(a,h,f){const t=[];let i;for(;(i=a.read())!==null&&t.length<f;)t.push(i);return i===null&&t.length>0?h(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return a.read()}}}e.peekReadable=k;function n(a,h){return new Promise((f,t)=>{const i=[];P(a,{onData:s=>{h&&i.push(s)},onError:s=>{h?t(s):f(void 0)},onEnd:()=>{f(h?h(i):void 0)}})})}e.consumeStream=n;function P(a,h){a.on("error",f=>h.onError(f)),a.on("end",()=>h.onEnd()),a.on("data",f=>h.onData(f))}e.listenStream=P;function d(a,h){return new Promise((f,t)=>{const i=new R.DisposableStore,s=[],o=b=>{if(s.push(b),s.length>h)return i.dispose(),a.pause(),f({stream:a,buffer:s,ended:!1})},u=b=>t(b),_=()=>f({stream:a,buffer:s,ended:!0});i.add((0,R.toDisposable)(()=>a.removeListener("error",u))),a.on("error",u),i.add((0,R.toDisposable)(()=>a.removeListener("end",_))),a.on("end",_),i.add((0,R.toDisposable)(()=>a.removeListener("data",o))),a.on("data",o)})}e.peekStream=d;function g(a,h){const f=E(h);return f.end(a),f}e.toStream=g;function r(){const a=E(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=r;function m(a){let h=!1;return{read:()=>h?null:(h=!0,a)}}e.toReadable=m;function c(a,h,f){const t=E(f);return P(a,{onData:i=>t.write(h.data(i)),onError:i=>t.error(h.error?h.error(i):i),onEnd:()=>t.end()}),t}e.transform=c;function p(a,h,f){let t=!1;return{read:()=>{const i=h.read();return t?i:(t=!0,i!==null?f([a,i]):a)}}}e.prefixedReadable=p;function w(a,h,f){let t=!1;const i=E(f);return P(h,{onData:s=>t?i.write(s):(t=!0,i.write(f([a,s]))),onError:s=>i.error(s),onEnd:()=>{t||(t=!0,i.write(a)),i.end()}}),i}e.prefixedStream=w}),define(ve[8],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(O){return!O||typeof O!="string"?!0:O.trim().length===0}e.isFalsyOrWhitespace=v;const R=/{(\d+)}/g;function S(O,...Y){return Y.length===0?O:O.replace(R,function(oe,ke){const Ie=parseInt(ke,10);return isNaN(Ie)||Ie<0||Ie>=Y.length?oe:Y[Ie]})}e.format=S;function T(O){return O.replace(/[<>&]/g,function(Y){switch(Y){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Y}})}e.escape=T;function E(O){return O.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function D(O,Y){let oe=0;const ke=Y.charCodeAt(0);for(let Ie=O.length-1;Ie>=0;Ie--)O.charCodeAt(Ie)===ke&&oe++;return oe}e.count=D;function y(O,Y,oe="\u2026"){return O.length<=Y?O:`${O.substr(0,Y)}${oe}`}e.truncate=y;function k(O,Y=" "){const oe=n(O,Y);return P(oe,Y)}e.trim=k;function n(O,Y){if(!O||!Y)return O;const oe=Y.length;if(oe===0||O.length===0)return O;let ke=0;for(;O.indexOf(Y,ke)===ke;)ke=ke+oe;return O.substring(ke)}e.ltrim=n;function P(O,Y){if(!O||!Y)return O;const oe=Y.length,ke=O.length;if(oe===0||ke===0)return O;let Ie=ke,Le=-1;for(;Le=O.lastIndexOf(Y,Ie-1),!(Le===-1||Le+oe!==Ie);){if(Le===0)return"";Ie=Le}return O.substring(0,Ie)}e.rtrim=P;function d(O){return O.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function g(O){return O.replace(/\*/g,"")}e.stripWildcards=g;function r(O,Y,oe={}){if(!O)throw new Error("Cannot create regex from empty string");Y||(O=E(O)),oe.wholeWord&&(/\B/.test(O.charAt(0))||(O="\\b"+O),/\B/.test(O.charAt(O.length-1))||(O=O+"\\b"));let ke="";return oe.global&&(ke+="g"),oe.matchCase||(ke+="i"),oe.multiline&&(ke+="m"),oe.unicode&&(ke+="u"),new RegExp(O,ke)}e.createRegExp=r;function m(O){return O.source==="^"||O.source==="^$"||O.source==="$"||O.source==="^\\s*$"?!1:!!(O.exec("")&&O.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function c(O){return!!O.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function p(O){return(O.global?"g":"")+(O.ignoreCase?"i":"")+(O.multiline?"m":"")+(O.unicode?"u":"")}e.regExpFlags=p;function w(O){return O.split(/\r\n|\r|\n/)}e.splitLines=w;function a(O){for(let Y=0,oe=O.length;Y<oe;Y++){const ke=O.charCodeAt(Y);if(ke!==32&&ke!==9)return Y}return-1}e.firstNonWhitespaceIndex=a;function h(O,Y=0,oe=O.length){for(let ke=Y;ke<oe;ke++){const Ie=O.charCodeAt(ke);if(Ie!==32&&Ie!==9)return O.substring(Y,ke)}return O.substring(Y,oe)}e.getLeadingWhitespace=h;function f(O,Y=O.length-1){for(let oe=Y;oe>=0;oe--){const ke=O.charCodeAt(oe);if(ke!==32&&ke!==9)return oe}return-1}e.lastNonWhitespaceIndex=f;function t(O,Y){return O<Y?-1:O>Y?1:0}e.compare=t;function i(O,Y,oe=0,ke=O.length,Ie=0,Le=Y.length){for(;oe<ke&&Ie<Le;oe++,Ie++){let rt=O.charCodeAt(oe),et=Y.charCodeAt(Ie);if(rt<et)return-1;if(rt>et)return 1}const Ue=ke-oe,Qe=Le-Ie;return Ue<Qe?-1:Ue>Qe?1:0}e.compareSubstring=i;function s(O,Y){return o(O,Y,0,O.length,0,Y.length)}e.compareIgnoreCase=s;function o(O,Y,oe=0,ke=O.length,Ie=0,Le=Y.length){for(;oe<ke&&Ie<Le;oe++,Ie++){let rt=O.charCodeAt(oe),et=Y.charCodeAt(Ie);if(rt===et)continue;const Ye=rt-et;if(!(Ye===32&&_(et))&&!(Ye===-32&&_(rt)))return u(rt)&&u(et)?Ye:i(O.toLowerCase(),Y.toLowerCase(),oe,ke,Ie,Le)}const Ue=ke-oe,Qe=Le-Ie;return Ue<Qe?-1:Ue>Qe?1:0}e.compareSubstringIgnoreCase=o;function u(O){return O>=97&&O<=122}e.isLowerAsciiLetter=u;function _(O){return O>=65&&O<=90}e.isUpperAsciiLetter=_;function b(O){return u(O)||_(O)}function A(O,Y){return O.length===Y.length&&C(O,Y)}e.equalsIgnoreCase=A;function C(O,Y,oe=O.length){for(let ke=0;ke<oe;ke++){const Ie=O.charCodeAt(ke),Le=Y.charCodeAt(ke);if(Ie!==Le){if(b(Ie)&&b(Le)){const Ue=Math.abs(Ie-Le);if(Ue!==0&&Ue!==32)return!1}else if(String.fromCharCode(Ie).toLowerCase()!==String.fromCharCode(Le).toLowerCase())return!1}}return!0}function l(O,Y){const oe=Y.length;return Y.length>O.length?!1:C(O,Y,oe)}e.startsWithIgnoreCase=l;function F(O,Y){let oe,ke=Math.min(O.length,Y.length);for(oe=0;oe<ke;oe++)if(O.charCodeAt(oe)!==Y.charCodeAt(oe))return oe;return ke}e.commonPrefixLength=F;function N(O,Y){let oe,ke=Math.min(O.length,Y.length);const Ie=O.length-1,Le=Y.length-1;for(oe=0;oe<ke;oe++)if(O.charCodeAt(Ie-oe)!==Y.charCodeAt(Le-oe))return oe;return ke}e.commonSuffixLength=N;function z(O){return 55296<=O&&O<=56319}e.isHighSurrogate=z;function de(O){return 56320<=O&&O<=57343}e.isLowSurrogate=de;function he(O,Y){return(O-55296<<10)+(Y-56320)+65536}e.computeCodePoint=he;function $(O,Y,oe){const ke=O.charCodeAt(oe);if(z(ke)&&oe+1<Y){const Ie=O.charCodeAt(oe+1);if(de(Ie))return he(ke,Ie)}return ke}e.getNextCodePoint=$;function q(O,Y){const oe=O.charCodeAt(Y-1);if(de(oe)&&Y>1){const ke=O.charCodeAt(Y-2);if(z(ke))return he(ke,oe)}return oe}function x(O,Y){const oe=$e.getInstance(),ke=Y,Ie=O.length,Le=$(O,Ie,Y);Y+=Le>=65536?2:1;let Ue=oe.getGraphemeBreakType(Le);for(;Y<Ie;){const Qe=$(O,Ie,Y),rt=oe.getGraphemeBreakType(Qe);if(Oe(Ue,rt))break;Y+=Qe>=65536?2:1,Ue=rt}return Y-ke}e.nextCharLength=x;function I(O,Y){const oe=$e.getInstance(),ke=Y,Ie=q(O,Y);Y-=Ie>=65536?2:1;let Le=oe.getGraphemeBreakType(Ie);for(;Y>0;){const Ue=q(O,Y),Qe=oe.getGraphemeBreakType(Ue);if(Oe(Qe,Le))break;Y-=Ue>=65536?2:1,Le=Qe}return ke-Y}e.prevCharLength=I;function H(O,Y){const oe=$e.getInstance(),ke=O.length,Ie=Y,Le=$(O,ke,Y),Ue=oe.getGraphemeBreakType(Le);Y+=Le>=65536?2:1;let Qe=Ue;for(;Y<ke;){const et=$(O,ke,Y),Ye=oe.getGraphemeBreakType(et);if(Oe(Qe,Ye))break;Y+=et>=65536?2:1,Qe=Ye}const rt=Y;for(Y=Ie,Qe=Ue;Y>0;){const et=q(O,Y),Ye=oe.getGraphemeBreakType(et);if(Oe(Ye,Qe))break;Y-=et>=65536?2:1,Qe=Ye}return[Y,rt]}function M(O,Y){return Y>0&&de(O.charCodeAt(Y))?H(O,Y-1):H(O,Y)}e.getCharContainingOffset=M;function B(O){const Y=O.length;let oe=0,ke=0;for(;ke<Y;){const Ue=$(O,Y,ke);ke+=Ue>=65536?2:1,Ue<128?oe+=1:Ue<2048?oe+=2:Ue<65536?oe+=3:oe+=4}const Ie=new Uint8Array(oe);ke=0;let Le=0;for(;ke<Y;){const Ue=$(O,Y,ke);ke+=Ue>=65536?2:1,Ue<128?Ie[Le++]=Ue:Ue<2048?(Ie[Le++]=192|(Ue&1984)>>>6,Ie[Le++]=128|(Ue&63)>>>0):Ue<65536?(Ie[Le++]=224|(Ue&61440)>>>12,Ie[Le++]=128|(Ue&4032)>>>6,Ie[Le++]=128|(Ue&63)>>>0):(Ie[Le++]=240|(Ue&1835008)>>>18,Ie[Le++]=128|(Ue&258048)>>>12,Ie[Le++]=128|(Ue&4032)>>>6,Ie[Le++]=128|(Ue&63)>>>0)}return Ie}e.encodeUTF8=B;function G(O){const Y=O.byteLength,oe=[];let ke=0;for(;ke<Y;){const Ie=O[ke];let Le;if(Ie>=240&&ke+3<Y?Le=(O[ke++]&7)<<18>>>0|(O[ke++]&63)<<12>>>0|(O[ke++]&63)<<6>>>0|(O[ke++]&63)<<0>>>0:Ie>=224&&ke+2<Y?Le=(O[ke++]&15)<<12>>>0|(O[ke++]&63)<<6>>>0|(O[ke++]&63)<<0>>>0:Ie>=192&&ke+1<Y?Le=(O[ke++]&31)<<6>>>0|(O[ke++]&63)<<0>>>0:Le=O[ke++],Le>=0&&Le<=55295||Le>=57344&&Le<=65535)oe.push(String.fromCharCode(Le));else if(Le>=65536&&Le<=1114111){const Ue=Le-65536,Qe=55296+((Ue&1047552)>>>10),rt=56320+((Ue&1023)>>>0);oe.push(String.fromCharCode(Qe)),oe.push(String.fromCharCode(rt))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=G;const K=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function se(O){return K.test(O)}e.containsRTL=se;const pe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Fe(O){return pe.test(O)}e.containsEmoji=Fe;const We=/^[\t\n\r\x20-\x7E]*$/;function Ne(O){return We.test(O)}e.isBasicASCII=Ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ze(O){return e.UNUSUAL_LINE_TERMINATORS.test(O)}e.containsUnusualLineTerminators=ze;function Ve(O){for(let Y=0,oe=O.length;Y<oe;Y++)if(W(O.charCodeAt(Y)))return!0;return!1}e.containsFullWidthCharacter=Ve;function W(O){return O=+O,O>=11904&&O<=55215||O>=63744&&O<=64255||O>=65281&&O<=65374}e.isFullWidthCharacter=W;function Q(O){return O>=127462&&O<=127487||O===8986||O===8987||O===9200||O===9203||O>=9728&&O<=10175||O===11088||O===11093||O>=127744&&O<=128591||O>=128640&&O<=128764||O>=128992&&O<=129003||O>=129280&&O<=129535||O>=129648&&O<=129750}e.isEmojiImprecise=Q;function te(O,Y){if(O.length<Y)return O;const oe=/\b/g;let ke=0;for(;oe.test(O)&&!(O.length-oe.lastIndex<Y);)ke=oe.lastIndex,oe.lastIndex+=1;return O.substring(ke).replace(/^\s/,"")}e.lcut=te;const re=/\x1B\x5B[12]?K/g,fe=/\x1b\[\d+m/g,_e=/\x1b\[0?m/g;function ue(O){return O&&(O=O.replace(re,""),O=O.replace(fe,""),O=O.replace(_e,"")),O}e.removeAnsiEscapeCodes=ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(O){return!!(O&&O.length>0&&O.charCodeAt(0)===65279)}e.startsWithUTF8BOM=we;function Ae(O){return we(O)?O.substr(1):O}e.stripUTF8BOM=Ae;function xe(O,Y){if(!O||!Y||O.length<Y.length)return!1;const oe=Y.length,ke=O.toLowerCase();let Ie=0,Le=-1;for(;Ie<oe;){const Ue=ke.indexOf(Y[Ie],Le+1);if(Ue<0)return!1;Le=Ue,Ie++}return!0}e.fuzzyContains=xe;function ge(O,Y=!1){return O?(Y&&(O=O.replace(/\\./g,"")),O.toLowerCase()!==O):!1}e.containsUppercaseCharacter=ge;function Ke(O){return O.charAt(0).toUpperCase()+O.slice(1)}e.uppercaseFirstLetter=Ke;function j(O,Y=1){if(Y===0)return"";let oe=-1;do oe=O.indexOf(`
`,oe+1),Y--;while(Y>0&&oe>=0);return oe===-1?O:(O[oe-1]==="\r"&&oe--,O.substr(0,oe))}e.getNLines=j;function Z(O){const Y=90-65+1;return O=O%(2*Y),O<Y?String.fromCharCode(97+O):String.fromCharCode(65+O-Y)}e.singleLetterHash=Z;function me(O){return $e.getInstance().getGraphemeBreakType(O)}e.getGraphemeBreakType=me;function Oe(O,Y){return O===0?Y!==5&&Y!==7:O===2&&Y===3?!1:O===4||O===2||O===3||Y===4||Y===2||Y===3?!0:!(O===8&&(Y===8||Y===9||Y===11||Y===12)||(O===11||O===9)&&(Y===9||Y===10)||(O===12||O===10)&&Y===10||Y===5||Y===13||Y===7||O===1||O===13&&Y===14||O===6&&Y===6)}e.breakBetweenGraphemeBreakType=Oe;var He;(function(O){O[O.Other=0]="Other",O[O.Prepend=1]="Prepend",O[O.CR=2]="CR",O[O.LF=3]="LF",O[O.Control=4]="Control",O[O.Extend=5]="Extend",O[O.Regional_Indicator=6]="Regional_Indicator",O[O.SpacingMark=7]="SpacingMark",O[O.L=8]="L",O[O.V=9]="V",O[O.T=10]="T",O[O.LV=11]="LV",O[O.LVT=12]="LVT",O[O.ZWJ=13]="ZWJ",O[O.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Xe()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(Y){if(Y<32)return Y===10?3:Y===13?2:4;if(Y<127)return 0;const oe=this._data,ke=oe.length/3;let Ie=1;for(;Ie<=ke;)if(Y<oe[3*Ie])Ie=2*Ie;else if(Y>oe[3*Ie+1])Ie=2*Ie+1;else return oe[3*Ie+2];return 0}}$e._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function ye(O,Y){if(O===0)return 0;const oe=Se(O,Y);if(oe!==void 0)return oe;const ke=q(Y,O);return O-=Ce(ke),O}e.getLeftDeleteOffset=ye;function Se(O,Y){let oe=q(Y,O);for(O-=Ce(oe);ne(oe)||oe===65039||oe===8419;){if(O===0)return;oe=q(Y,O),O-=Ce(oe)}if(!!Q(oe)){if(O>=0){const ke=q(Y,O);ke===8205&&(O-=Ce(ke))}return O}}function Ce(O){return O>=65536?2:1}function ne(O){return 127995<=O&&O<=127999}var le;(function(O){O[O.zwj=8205]="zwj",O[O.emojiVariantSelector=65039]="emojiVariantSelector",O[O.enclosingKeyCap=8419]="enclosingKeyCap"})(le||(le={}))}),define(ve[23],be([0,1,8,111]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const S=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",E=typeof TextDecoder!="undefined";let D,y;class k{constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}static alloc(b){return S?new k(Buffer.allocUnsafe(b)):new k(new Uint8Array(b))}static wrap(b){return S&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new k(b)}static fromString(b,A){return!((A==null?void 0:A.dontUseNodeBuffer)||!1)&&S?new k(Buffer.from(b)):T?(D||(D=new TextEncoder),new k(D.encode(b))):new k(v.encodeUTF8(b))}static concat(b,A){if(typeof A=="undefined"){A=0;for(let F=0,N=b.length;F<N;F++)A+=b[F].byteLength}const C=k.alloc(A);let l=0;for(let F=0,N=b.length;F<N;F++){const z=b[F];C.set(z,l),l+=z.byteLength}return C}toString(){return S?this.buffer.toString():E?(y||(y=new TextDecoder),y.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(b,A){return new k(this.buffer.subarray(b,A))}set(b,A){b instanceof k?this.buffer.set(b.buffer,A):this.buffer.set(b,A)}readUInt32BE(b){return d(this.buffer,b)}writeUInt32BE(b,A){g(this.buffer,b,A)}readUInt32LE(b){return r(this.buffer,b)}writeUInt32LE(b,A){m(this.buffer,b,A)}readUInt8(b){return c(this.buffer,b)}writeUInt8(b,A){p(this.buffer,b,A)}}e.VSBuffer=k;function n(_,b){return _[b+0]<<0>>>0|_[b+1]<<8>>>0}e.readUInt16LE=n;function P(_,b,A){_[A+0]=b&255,b=b>>>8,_[A+1]=b&255}e.writeUInt16LE=P;function d(_,b){return _[b]*2**24+_[b+1]*2**16+_[b+2]*2**8+_[b+3]}e.readUInt32BE=d;function g(_,b,A){_[A+3]=b,b=b>>>8,_[A+2]=b,b=b>>>8,_[A+1]=b,b=b>>>8,_[A]=b}e.writeUInt32BE=g;function r(_,b){return _[b+0]<<0>>>0|_[b+1]<<8>>>0|_[b+2]<<16>>>0|_[b+3]<<24>>>0}e.readUInt32LE=r;function m(_,b,A){_[A+0]=b&255,b=b>>>8,_[A+1]=b&255,b=b>>>8,_[A+2]=b&255,b=b>>>8,_[A+3]=b&255}e.writeUInt32LE=m;function c(_,b){return _[b]}e.readUInt8=c;function p(_,b,A){_[A]=b}e.writeUInt8=p;function w(_){return R.consumeReadable(_,b=>k.concat(b))}e.readableToBuffer=w;function a(_){return R.toReadable(_)}e.bufferToReadable=a;function h(_){return R.consumeStream(_,b=>k.concat(b))}e.streamToBuffer=h;async function f(_){return _.ended?k.concat(_.buffer):k.concat([..._.buffer,await h(_.stream)])}e.bufferedStreamToBuffer=f;function t(_){return R.toStream(_,b=>k.concat(b))}e.bufferToStream=t;function i(_){return R.transform(_,{data:b=>typeof b=="string"?k.fromString(b):k.wrap(b)},b=>k.concat(b))}e.streamToBufferReadableStream=i;function s(_){return R.newWriteableStream(b=>k.concat(b),_)}e.newWriteableBufferStream=s;function o(_,b){return R.prefixedReadable(_,b,A=>k.concat(A))}e.prefixedBufferReadable=o;function u(_,b){return R.prefixedStream(_,b,A=>k.concat(A))}e.prefixedBufferStream=u}),define(ve[57],be([0,1,8]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(p){return S(p,0)}e.hash=R;function S(p,w){switch(typeof p){case"object":return p===null?T(349,w):Array.isArray(p)?y(p,w):k(p,w);case"string":return D(p,w);case"boolean":return E(p,w);case"number":return T(p,w);case"undefined":return T(937,w);default:return T(617,w)}}e.doHash=S;function T(p,w){return(w<<5)-w+p|0}function E(p,w){return T(p?433:863,w)}function D(p,w){w=T(149417,w);for(let a=0,h=p.length;a<h;a++)w=T(p.charCodeAt(a),w);return w}e.stringHash=D;function y(p,w){return w=T(104579,w),p.reduce((a,h)=>S(h,a),w)}function k(p,w){return w=T(181387,w),Object.keys(p).sort().reduce((a,h)=>(a=D(h,a),S(p[h],a)),w)}class n{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=S(w,this._value),this._value}}e.Hasher=n;var P;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function d(p,w,a=32){const h=a-w,f=~((1<<h)-1);return(p<<w|(f&p)>>>h)>>>0}function g(p,w=0,a=p.byteLength,h=0){for(let f=0;f<a;f++)p[w+f]=h}function r(p,w,a="0"){for(;p.length<w;)p=a+p;return p}function m(p,w=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(a=>a.toString(16).padStart(2,"0")).join(""):r((p>>>0).toString(16),w/4)}e.toHexString=m;class c{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const a=w.length;if(a===0)return;const h=this._buff;let f=this._buffLen,t=this._leftoverHighSurrogate,i,s;for(t!==0?(i=t,s=-1,t=0):(i=w.charCodeAt(0),s=0);;){let o=i;if(v.isHighSurrogate(i))if(s+1<a){const u=w.charCodeAt(s+1);v.isLowSurrogate(u)?(s++,o=v.computeCodePoint(i,u)):o=65533}else{t=i;break}else v.isLowSurrogate(i)&&(o=65533);if(f=this._push(h,f,o),s++,s<a)i=w.charCodeAt(s);else break}this._buffLen=f,this._leftoverHighSurrogate=t}_push(w,a,h){return h<128?w[a++]=h:h<2048?(w[a++]=192|(h&1984)>>>6,w[a++]=128|(h&63)>>>0):h<65536?(w[a++]=224|(h&61440)>>>12,w[a++]=128|(h&4032)>>>6,w[a++]=128|(h&63)>>>0):(w[a++]=240|(h&1835008)>>>18,w[a++]=128|(h&258048)>>>12,w[a++]=128|(h&4032)>>>6,w[a++]=128|(h&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=c._bigBlock32,a=this._buffDV;for(let b=0;b<64;b+=4)w.setUint32(b,a.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)w.setUint32(b,d(w.getUint32(b-12,!1)^w.getUint32(b-32,!1)^w.getUint32(b-56,!1)^w.getUint32(b-64,!1),1),!1);let h=this._h0,f=this._h1,t=this._h2,i=this._h3,s=this._h4,o,u,_;for(let b=0;b<80;b++)b<20?(o=f&t|~f&i,u=1518500249):b<40?(o=f^t^i,u=1859775393):b<60?(o=f&t|f&i|t&i,u=2400959708):(o=f^t^i,u=3395469782),_=d(h,5)+o+s+u+w.getUint32(b*4,!1)&4294967295,s=i,i=t,t=d(f,30),f=h,h=_;this._h0=this._h0+h&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=c,c._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ve[47],be([0,1,8]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(R||(R={})),function(S){const T="error",E="warning",D="warn",y="info",k="ignore";function n(d){return d?v.equalsIgnoreCase(T,d)?S.Error:v.equalsIgnoreCase(E,d)||v.equalsIgnoreCase(D,d)?S.Warning:v.equalsIgnoreCase(y,d)?S.Info:S.Ignore:S.Ignore}S.fromValue=n;function P(d){switch(d){case S.Error:return T;case S.Warning:return E;case S.Info:return y;default:return k}}S.toString=P}(R||(R={})),e.default=R}),define(ve[10],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(b){return Array.isArray(b)}e.isArray=v;function R(b){return typeof b=="string"}e.isString=R;function S(b){return Array.isArray(b)&&b.every(A=>R(A))}e.isStringArray=S;function T(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.isObject=T;function E(b){return typeof b=="number"&&!isNaN(b)}e.isNumber=E;function D(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.isIterable=D;function y(b){return b===!0||b===!1}e.isBoolean=y;function k(b){return typeof b=="undefined"}e.isUndefined=k;function n(b){return!P(b)}e.isDefined=n;function P(b){return k(b)||b===null}e.isUndefinedOrNull=P;function d(b,A){if(!b)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}e.assertType=d;function g(b){if(P(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.assertIsDefined=g;function r(...b){const A=[];for(let C=0;C<b.length;C++){const l=b[C];if(P(l))throw new Error(`Assertion Failed: argument at index ${C} is undefined or null`);A.push(l)}return A}e.assertAllDefined=r;const m=Object.prototype.hasOwnProperty;function c(b){if(!T(b))return!1;for(let A in b)if(m.call(b,A))return!1;return!0}e.isEmptyObject=c;function p(b){return typeof b=="function"}e.isFunction=p;function w(...b){return b.length>0&&b.every(p)}e.areFunctions=w;function a(b,A){const C=Math.min(b.length,A.length);for(let l=0;l<C;l++)h(b[l],A[l])}e.validateConstraints=a;function h(b,A){if(R(A)){if(typeof b!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(p(A)){try{if(b instanceof A)return}catch(C){}if(!P(b)&&b.constructor===A||A.length===1&&A.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function f(b){let A=[],C=Object.getPrototypeOf(b);for(;Object.prototype!==C;)A=A.concat(Object.getOwnPropertyNames(C)),C=Object.getPrototypeOf(C);return A}e.getAllPropertyNames=f;function t(b){const A=[];for(const C of f(b))typeof b[C]=="function"&&A.push(C);return A}e.getAllMethodNames=t;function i(b,A){const C=F=>function(){const N=Array.prototype.slice.call(arguments,0);return A(F,N)};let l={};for(const F of b)l[F]=C(F);return l}e.createProxyObject=i;function s(b){return b===null?void 0:b}e.withNullAsUndefined=s;function o(b){return typeof b=="undefined"?null:b}e.withUndefinedAsNull=o;function u(b){return class{constructor(){return new Proxy({},{get(A,C){if(A[C])return A[C];throw new Error(`Not Implemented: ${b}->${String(C)}`)}})}}}e.NotImplementedProxy=u;function _(b){throw new Error("Unreachable")}e.assertNever=_}),define(ve[36],be([0,1,21,8,14,10]),function(J,e,v,R,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(s){return s===47||s===92}e.isPathSeparator=E;function D(s){return s.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=D;function y(s){return s.indexOf("/")===-1&&(s=D(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=y;function k(s,o=S.posix.sep){if(!s)return"";const u=s.length,_=s.charCodeAt(0);if(E(_)){if(E(s.charCodeAt(1))&&!E(s.charCodeAt(2))){let A=3;const C=A;for(;A<u&&!E(s.charCodeAt(A));A++);if(C!==A&&!E(s.charCodeAt(A+1))){for(A+=1;A<u;A++)if(E(s.charCodeAt(A)))return s.slice(0,A+1).replace(/[\\/]/g,o)}}return o}else if(p(_)&&s.charCodeAt(1)===58)return E(s.charCodeAt(2))?s.slice(0,2)+o:s.slice(0,2);let b=s.indexOf("://");if(b!==-1){for(b+=3;b<u;b++)if(E(s.charCodeAt(b)))return s.slice(0,b+1)}return""}e.getRoot=k;function n(s){if(!v.isWindows||!s||s.length<5)return!1;let o=s.charCodeAt(0);if(o!==92||(o=s.charCodeAt(1),o!==92))return!1;let u=2;const _=u;for(;u<s.length&&(o=s.charCodeAt(u),o!==92);u++);return!(_===u||(o=s.charCodeAt(u+1),isNaN(o)||o===92))}e.isUNC=n;const P=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(s,o=v.isWindows){const u=o?P:d;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||o&&g.test(s)||s==="."||s===".."||o&&s[s.length-1]==="."||o&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=r;function m(s,o,u){const _=s===o;return!u||_?_:!s||!o?!1:(0,R.equalsIgnoreCase)(s,o)}e.isEqual=m;function c(s,o,u,_=S.sep){if(s===o)return!0;if(!s||!o||o.length>s.length)return!1;if(u){if(!(0,R.startsWithIgnoreCase)(s,o))return!1;if(o.length===s.length)return!0;let A=o.length;return o.charAt(o.length-1)===_&&A--,s.charAt(A)===_}return o.charAt(o.length-1)!==_&&(o+=_),s.indexOf(o)===0}e.isEqualOrParent=c;function p(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=p;function w(s,o){return v.isWindows&&s.endsWith(":")&&(s+=S.sep),(0,S.isAbsolute)(s)||(s=(0,S.join)(o,s)),s=(0,S.normalize)(s),v.isWindows?(s=(0,R.rtrim)(s,S.sep),s.endsWith(":")&&(s+=S.sep)):(s=(0,R.rtrim)(s,S.sep),s||(s=S.sep)),s}e.sanitizeFilePath=w;function a(s){const o=(0,S.normalize)(s);return v.isWindows?s.length>3?!1:h(o)&&(s.length===2||o.charCodeAt(2)===92):o===S.posix.sep}e.isRootOrDriveLetter=a;function h(s){return v.isWindows?p(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function f(s){return h(s)?s[0]:void 0}e.getDriveLetter=f;function t(s,o,u){return o.length>s.length?-1:s===o?0:(u&&(s=s.toLowerCase(),o=o.toLowerCase()),s.indexOf(o))}e.indexOfPath=t;function i(s){const o=s.split(":");let u,_,b;if(o.forEach(A=>{const C=Number(A);(0,T.isNumber)(C)?_===void 0?_=C:b===void 0&&(b=C):u=u?[u,A].join(":"):A}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:_!==void 0?_:void 0,column:b!==void 0?b:_!==void 0?1:void 0}}e.parseLineAndColumnAware=i}),define(ve[24],be([0,1,10]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const c=Array.isArray(m)?[]:{};return Object.keys(m).forEach(p=>{m[p]&&typeof m[p]=="object"?c[p]=R(m[p]):c[p]=m[p]}),c}e.deepClone=R;function S(m){if(!m||typeof m!="object")return m;const c=[m];for(;c.length>0;){const p=c.shift();Object.freeze(p);for(const w in p)if(T.call(p,w)){const a=p[w];typeof a=="object"&&!Object.isFrozen(a)&&c.push(a)}}return m}e.deepFreeze=S;const T=Object.prototype.hasOwnProperty;function E(m,c){return D(m,c,new Set)}e.cloneAndChange=E;function D(m,c,p){if((0,v.isUndefinedOrNull)(m))return m;const w=c(m);if(typeof w!="undefined")return w;if((0,v.isArray)(m)){const a=[];for(const h of m)a.push(D(h,c,p));return a}if((0,v.isObject)(m)){if(p.has(m))throw new Error("Cannot clone recursive data-structure");p.add(m);const a={};for(let h in m)T.call(m,h)&&(a[h]=D(m[h],c,p));return p.delete(m),a}return m}function y(m,c,p=!0){return(0,v.isObject)(m)?((0,v.isObject)(c)&&Object.keys(c).forEach(w=>{w in m?p&&((0,v.isObject)(m[w])&&(0,v.isObject)(c[w])?y(m[w],c[w],p):m[w]=c[w]):m[w]=c[w]}),m):c}e.mixin=y;function k(m,c){if(m===c)return!0;if(m==null||c===null||c===void 0||typeof m!=typeof c||typeof m!="object"||Array.isArray(m)!==Array.isArray(c))return!1;let p,w;if(Array.isArray(m)){if(m.length!==c.length)return!1;for(p=0;p<m.length;p++)if(!k(m[p],c[p]))return!1}else{const a=[];for(w in m)a.push(w);a.sort();const h=[];for(w in c)h.push(w);if(h.sort(),!k(a,h))return!1;for(p=0;p<a.length;p++)if(!k(m[a[p]],c[a[p]]))return!1}return!0}e.equals=k;function n(m){const c=new Set;return JSON.stringify(m,(p,w)=>{if((0,v.isObject)(w)||Array.isArray(w)){if(c.has(w))return"[Circular]";c.add(w)}return w})}e.safeStringify=n;function P(m,c,p){const w=c(m);return typeof w=="undefined"?p:w}e.getOrDefault=P;function d(m,c){const p=Object.create(null);return!m||!c||Object.keys(c).forEach(a=>{const h=m[a],f=c[a];k(h,f)||(p[a]=f)}),p}e.distinct=d;function g(m,c){const p=c.toLowerCase(),w=Object.keys(m).find(a=>a.toLowerCase()===p);return w?m[w]:m[c]}e.getCaseInsensitive=g;function r(m,c){const p=Object.create(null);for(const w of Object.keys(m))c(w,m[w])&&(p[w]=m[w]);return p}e.filter=r}),define(ve[82],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var v;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(v=e.Constants||(e.Constants={}));function R(T){return T<0?0:T>255?255:T|0}e.toUint8=R;function S(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=S}),define(ve[2],be([0,1,21,14]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const S=/^\w[\w\d+.-]*$/,T=/^\//,E=/^\/\//;function D(s,o){if(!s.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!S.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!T.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(s,o){return!s&&!o?"file":s}function k(s,o){switch(s){case"https":case"http":case"file":o?o[0]!==P&&(o=P+o):o=P;break}return o}const n="",P="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(o,u,_,b,A,C=!1){typeof o=="object"?(this.scheme=o.scheme||n,this.authority=o.authority||n,this.path=o.path||n,this.query=o.query||n,this.fragment=o.fragment||n):(this.scheme=y(o,C),this.authority=u||n,this.path=k(this.scheme,_||n),this.query=b||n,this.fragment=A||n,D(this,C))}static isUri(o){return o instanceof g?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return a(this,!1)}with(o){if(!o)return this;let{scheme:u,authority:_,path:b,query:A,fragment:C}=o;return u===void 0?u=this.scheme:u===null&&(u=n),_===void 0?_=this.authority:_===null&&(_=n),b===void 0?b=this.path:b===null&&(b=n),A===void 0?A=this.query:A===null&&(A=n),C===void 0?C=this.fragment:C===null&&(C=n),u===this.scheme&&_===this.authority&&b===this.path&&A===this.query&&C===this.fragment?this:new m(u,_,b,A,C)}static parse(o,u=!1){const _=d.exec(o);return _?new m(_[2]||n,i(_[4]||n),i(_[5]||n),i(_[7]||n),i(_[9]||n),u):new m(n,n,n,n,n)}static file(o){let u=n;if(v.isWindows&&(o=o.replace(/\\/g,P)),o[0]===P&&o[1]===P){const _=o.indexOf(P,2);_===-1?(u=o.substring(2),o=P):(u=o.substring(2,_),o=o.substring(_)||P)}return new m("file",u,o,n,n)}static from(o){const u=new m(o.scheme,o.authority,o.path,o.query,o.fragment);return D(u,!0),u}static joinPath(o,...u){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let _;return v.isWindows&&o.scheme==="file"?_=g.file(R.win32.join(a(o,!0),...u)).path:_=R.posix.join(o.path,...u),o.with({path:_})}toString(o=!1){return h(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof g)return o;{const u=new m(o);return u._formatted=o.external,u._fsPath=o._sep===r?o.fsPath:null,u}}else return o}}e.URI=g;const r=v.isWindows?1:void 0;class m extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(o=!1){return o?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=r),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(s,o){let u,_=-1;for(let b=0;b<s.length;b++){const A=s.charCodeAt(b);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||o&&A===47)_!==-1&&(u+=encodeURIComponent(s.substring(_,b)),_=-1),u!==void 0&&(u+=s.charAt(b));else{u===void 0&&(u=s.substr(0,b));const C=c[A];C!==void 0?(_!==-1&&(u+=encodeURIComponent(s.substring(_,b)),_=-1),u+=C):_===-1&&(_=b)}}return _!==-1&&(u+=encodeURIComponent(s.substring(_))),u!==void 0?u:s}function w(s){let o;for(let u=0;u<s.length;u++){const _=s.charCodeAt(u);_===35||_===63?(o===void 0&&(o=s.substr(0,u)),o+=c[_]):o!==void 0&&(o+=s[u])}return o!==void 0?o:s}function a(s,o){let u;return s.authority&&s.path.length>1&&s.scheme==="file"?u=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?o?u=s.path.substr(1):u=s.path[1].toLowerCase()+s.path.substr(2):u=s.path,v.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=a;function h(s,o){const u=o?w:p;let _="",{scheme:b,authority:A,path:C,query:l,fragment:F}=s;if(b&&(_+=b,_+=":"),(A||b==="file")&&(_+=P,_+=P),A){let N=A.indexOf("@");if(N!==-1){const z=A.substr(0,N);A=A.substr(N+1),N=z.indexOf(":"),N===-1?_+=u(z,!1):(_+=u(z.substr(0,N),!1),_+=":",_+=u(z.substr(N+1),!1)),_+="@"}A=A.toLowerCase(),N=A.indexOf(":"),N===-1?_+=u(A,!1):(_+=u(A.substr(0,N),!1),_+=A.substr(N))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const N=C.charCodeAt(1);N>=65&&N<=90&&(C=`/${String.fromCharCode(N+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const N=C.charCodeAt(0);N>=65&&N<=90&&(C=`${String.fromCharCode(N+32)}:${C.substr(2)}`)}_+=u(C,!0)}return l&&(_+="?",_+=u(l,!1)),F&&(_+="#",_+=o?F:p(F,!1)),_}function f(s){try{return decodeURIComponent(s)}catch(o){return s.length>3?s.substr(0,3)+f(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(s){return s.match(t)?s.replace(t,o=>f(o)):s}});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!S:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(J,v):S?S.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(ve[22],be([0,1,2,8]),function(J,e,v,R){"use strict";var S,T,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,i,s){let o=t.get(i);return o===void 0&&(o=s,t.set(i,o)),o}e.getOrSet=D;function y(t){const i=[];return t.forEach((s,o)=>{i.push(`${o} => ${s}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=y;function k(t){const i=[];return t.forEach(s=>{i.push(s)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=k;class n{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=n;class P{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,R.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class d{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,R.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var g;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(g||(g={}));class r{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,R.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=r;class m{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class c{constructor(i){this._iter=i}static forUris(i=()=>!1){return new c(new r(i))}static forPaths(){return new c(new d)}static forStrings(){return new c(new n)}static forConfigKeys(){return new c(new P)}clear(){this._root=void 0}set(i,s){const o=this._iter.reset(i);let u;for(this._root||(this._root=new m,this._root.segment=o.value()),u=this._root;;){const b=o.cmp(u.segment);if(b>0)u.left||(u.left=new m,u.left.segment=o.value()),u=u.left;else if(b<0)u.right||(u.right=new m,u.right.segment=o.value()),u=u.right;else if(o.hasNext())o.next(),u.mid||(u.mid=new m,u.mid.segment=o.value()),u=u.mid;else break}const _=u.value;return u.value=s,u.key=i,_}get(i){var s;return(s=this._getNode(i))===null||s===void 0?void 0:s.value}_getNode(i){const s=this._iter.reset(i);let o=this._root;for(;o;){const u=s.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(i){const s=this._getNode(i);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const o=this._iter.reset(i),u=[];let _=this._root;for(;_;){const b=o.cmp(_.segment);if(b>0)u.push([1,_]),_=_.left;else if(b<0)u.push([-1,_]),_=_.right;else if(o.hasNext())o.next(),u.push([0,_]),_=_.mid;else{for(s?(_.left=void 0,_.mid=void 0,_.right=void 0):_.value=void 0;u.length>0&&_.isEmpty();){let[A,C]=u.pop();switch(A){case 1:C.left=void 0;break;case 0:C.mid=void 0;break;case-1:C.right=void 0;break}_=C}break}}}findSubstr(i){const s=this._iter.reset(i);let o=this._root,u;for(;o;){const _=s.cmp(o.segment);if(_>0)o=o.left;else if(_<0)o=o.right;else if(s.hasNext())s.next(),u=o.value||u,o=o.mid;else break}return o&&o.value||u}findSuperstr(i){const s=this._iter.reset(i);let o=this._root;for(;o;){const u=s.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(i){for(const[s,o]of this)i(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=c;class p{constructor(i,s){this[S]="ResourceMap",i instanceof p?(this.map=new Map(i.map),this.toKey=s!=null?s:p.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:p.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),s),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[o,u]of this.map)i(u,v.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield v.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[v.URI.parse(i[0]),i[1]]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[v.URI.parse(i[0]),i[1]]}}e.ResourceMap=p,p.defaultToKey=t=>t.toString();var w;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class a{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,s=0){const o=this._map.get(i);if(!!o)return s!==0&&this.touch(o,s),o.value}set(i,s,o=0){let u=this._map.get(i);if(u)u.value=s,o!==0&&this.touch(u,o);else{switch(u={key:i,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(i,u),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const o=this._state;let u=this._head;for(;u;){if(s?i.bind(s)(u.value,u.key,this):i(u.value,u.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const i=this,s=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const _={value:o.key,done:!1};return o=o.next,_}else return{value:void 0,done:!0}}};return u}values(){const i=this,s=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const _={value:o.value,done:!1};return o=o.next,_}else return{value:void 0,done:!0}}};return u}entries(){const i=this,s=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const _={value:[o.key,o.value],done:!1};return o=o.next,_}else return{value:void 0,done:!0}}};return u}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>i;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,o=i.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const o=i.next,u=i.previous;i===this._tail?(u.next=void 0,this._tail=u):(o.previous=u,u.next=o),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const o=i.next,u=i.previous;i===this._head?(o.previous=void 0,this._head=o):(o.previous=u,u.next=o),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,o)=>{i.push([o,s])}),i}fromJSON(i){this.clear();for(const[s,o]of i)this.set(s,o)}}e.LinkedMap=a;class h extends a{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=h;class f{constructor(i){E.set(this,void 0),nt(this,E,i,"f")}get size(){return Be(this,E,"f").size}forEach(i,s){Be(this,E,"f").forEach(i,s)}get(i){return Be(this,E,"f").get(i)}has(i){return Be(this,E,"f").has(i)}entries(){return Be(this,E,"f").entries()}keys(){return Be(this,E,"f").keys()}values(){return Be(this,E,"f").values()}[(E=new WeakMap,Symbol.iterator)](){return Be(this,E,"f").entries()}}e.ReadonlyMapView=f}),define(ve[112],be([0,1,22,8]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...ue){return function(we,Ae){for(let xe=0,ge=ue.length;xe<ge;xe++){const Ke=ue[xe](we,Ae);if(Ke)return Ke}return null}}e.or=S,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(ue,we,Ae){if(!Ae||Ae.length<we.length)return null;let xe;return ue?xe=R.startsWithIgnoreCase(Ae,we):xe=Ae.indexOf(we)===0,xe?we.length>0?[{start:0,end:we.length}]:[]:null}function E(ue,we){const Ae=we.toLowerCase().indexOf(ue.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+ue.length}]}e.matchesContiguousSubString=E;function D(ue,we){return y(ue.toLowerCase(),we.toLowerCase(),0,0)}e.matchesSubString=D;function y(ue,we,Ae,xe){if(Ae===ue.length)return[];if(xe===we.length)return null;if(ue[Ae]===we[xe]){let ge=null;return(ge=y(ue,we,Ae+1,xe+1))?p({start:xe,end:xe+1},ge):null}return y(ue,we,Ae,xe+1)}function k(ue){return 97<=ue&&ue<=122}function n(ue){return 65<=ue&&ue<=90}e.isUpper=n;function P(ue){return 48<=ue&&ue<=57}function d(ue){return ue===32||ue===9||ue===10||ue===13}const g=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ue=>g.add(ue.charCodeAt(0)));function r(ue){return d(ue)||g.has(ue)}function m(ue,we){return ue===we||r(ue)&&r(we)}function c(ue){return k(ue)||n(ue)||P(ue)}function p(ue,we){return we.length===0?we=[ue]:ue.end===we[0].start?we[0].start=ue.start:we.unshift(ue),we}function w(ue,we){for(let Ae=we;Ae<ue.length;Ae++){const xe=ue.charCodeAt(Ae);if(n(xe)||P(xe)||Ae>0&&!c(ue.charCodeAt(Ae-1)))return Ae}return ue.length}function a(ue,we,Ae,xe){if(Ae===ue.length)return[];if(xe===we.length)return null;if(ue[Ae]!==we[xe].toLowerCase())return null;{let ge=null,Ke=xe+1;for(ge=a(ue,we,Ae+1,xe+1);!ge&&(Ke=w(we,Ke))<we.length;)ge=a(ue,we,Ae+1,Ke),Ke++;return ge===null?null:p({start:xe,end:xe+1},ge)}}function h(ue){let we=0,Ae=0,xe=0,ge=0,Ke=0;for(let He=0;He<ue.length;He++)Ke=ue.charCodeAt(He),n(Ke)&&we++,k(Ke)&&Ae++,c(Ke)&&xe++,P(Ke)&&ge++;const j=we/ue.length,Z=Ae/ue.length,me=xe/ue.length,Oe=ge/ue.length;return{upperPercent:j,lowerPercent:Z,alphaPercent:me,numericPercent:Oe}}function f(ue){const{upperPercent:we,lowerPercent:Ae}=ue;return Ae===0&&we>.6}function t(ue){const{upperPercent:we,lowerPercent:Ae,alphaPercent:xe,numericPercent:ge}=ue;return Ae>.2&&we<.8&&xe>.6&&ge<.2}function i(ue){let we=0,Ae=0,xe=0,ge=0;for(let Ke=0;Ke<ue.length;Ke++)xe=ue.charCodeAt(Ke),n(xe)&&we++,k(xe)&&Ae++,d(xe)&&ge++;return(we===0||Ae===0)&&ge===0?ue.length<=30:we<=5}function s(ue,we){if(!we||(we=we.trim(),we.length===0)||!i(ue)||we.length>60)return null;const Ae=h(we);if(!t(Ae)){if(!f(Ae))return null;we=we.toLowerCase()}let xe=null,ge=0;for(ue=ue.toLowerCase();ge<we.length&&(xe=a(ue,we,0,ge))===null;)ge=w(we,ge+1);return xe}e.matchesCamelCase=s;function o(ue,we,Ae=!1){if(!we||we.length===0)return null;let xe=null,ge=0;for(ue=ue.toLowerCase(),we=we.toLowerCase();ge<we.length&&(xe=u(ue,we,0,ge,Ae))===null;)ge=_(we,ge+1);return xe}e.matchesWords=o;function u(ue,we,Ae,xe,ge){if(Ae===ue.length)return[];if(xe===we.length)return null;if(m(ue.charCodeAt(Ae),we.charCodeAt(xe))){let Ke=null,j=xe+1;if(Ke=u(ue,we,Ae+1,xe+1,ge),!ge)for(;!Ke&&(j=_(we,j))<we.length;)Ke=u(ue,we,Ae+1,j,ge),j++;return Ke===null?null:p({start:xe,end:xe+1},Ke)}else return null}function _(ue,we){for(let Ae=we;Ae<ue.length;Ae++)if(r(ue.charCodeAt(Ae))||Ae>0&&r(ue.charCodeAt(Ae-1)))return Ae;return ue.length}const b=S(e.matchesPrefix,s,E),A=S(e.matchesPrefix,s,D),C=new v.LRUCache(1e4);function l(ue,we,Ae=!1){if(typeof ue!="string"||typeof we!="string")return null;let xe=C.get(ue);xe||(xe=new RegExp(R.convertSimple2RegExpPattern(ue),"i"),C.set(ue,xe));const ge=xe.exec(we);return ge?[{start:ge.index,end:ge.index+ge[0].length}]:Ae?A(ue,we):b(ue,we)}e.matchesFuzzy=l;function F(ue,we){const Ae=Ve(ue,ue.toLowerCase(),0,we,we.toLowerCase(),0,!0);return Ae?z(Ae):null}e.matchesFuzzy2=F;function N(ue,we,Ae,xe,ge,Ke){const j=Math.min(13,ue.length);for(;Ae<j;Ae++){const Z=Ve(ue,we,Ae,xe,ge,Ke,!1);if(Z)return Z}return[0,Ke]}e.anyScore=N;function z(ue){if(typeof ue=="undefined")return[];const we=[],Ae=ue[1];for(let xe=ue.length-1;xe>1;xe--){const ge=ue[xe]+Ae,Ke=we[we.length-1];Ke&&Ke.end===ge?Ke.end=ge+1:we.push({start:ge,end:ge+1})}return we}e.createMatches=z;const de=128;function he(){const ue=[],we=[];for(let Ae=0;Ae<=de;Ae++)we[Ae]=0;for(let Ae=0;Ae<=de;Ae++)ue.push(we.slice(0));return ue}function $(ue){const we=[];for(let Ae=0;Ae<=ue;Ae++)we[Ae]=0;return we}const q=$(2*de),x=$(2*de),I=he(),H=he(),M=he(),B=!1;function G(ue,we,Ae,xe,ge){function Ke(Z,me,Oe=" "){for(;Z.length<me;)Z=Oe+Z;return Z}let j=` |   |${xe.split("").map(Z=>Ke(Z,3)).join("|")}
`;for(let Z=0;Z<=Ae;Z++)Z===0?j+=" |":j+=`${we[Z-1]}|`,j+=ue[Z].slice(0,ge+1).map(me=>Ke(me.toString(),3)).join("|")+`
`;return j}function K(ue,we,Ae,xe){ue=ue.substr(we),Ae=Ae.substr(xe),console.log(G(H,ue,ue.length,Ae,Ae.length)),console.log(G(M,ue,ue.length,Ae,Ae.length)),console.log(G(I,ue,ue.length,Ae,Ae.length))}function se(ue,we){if(we<0||we>=ue.length)return!1;const Ae=ue.codePointAt(we);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(Ae)}}function pe(ue,we){if(we<0||we>=ue.length)return!1;switch(ue.charCodeAt(we)){case 32:case 9:return!0;default:return!1}}function Fe(ue,we,Ae){return we[ue]!==Ae[ue]}function We(ue,we,Ae,xe,ge,Ke,j=!1){for(;we<Ae&&ge<Ke;)ue[we]===xe[ge]&&(j&&(q[we]=ge),we+=1),ge+=1;return we===Ae}e.isPatternInWord=We;var Ne;(function(ue){ue[ue.Diag=1]="Diag",ue[ue.Left=2]="Left",ue[ue.LeftLeft=3]="LeftLeft"})(Ne||(Ne={}));var ze;(function(ue){ue.Default=[-100,0];function we(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}ue.isDefault=we})(ze=e.FuzzyScore||(e.FuzzyScore={}));function Ve(ue,we,Ae,xe,ge,Ke,j){const Z=ue.length>de?de:ue.length,me=xe.length>de?de:xe.length;if(Ae>=Z||Ke>=me||Z-Ae>me-Ke||!We(we,Ae,Z,ge,Ke,me,!0))return;W(Z,me,Ae,Ke,we,ge);let Oe=1,He=1,$e=Ae,Xe=Ke;const ye=[!1];for(Oe=1,$e=Ae;$e<Z;Oe++,$e++){const O=q[$e],Y=x[$e],oe=$e+1<Z?x[$e+1]:me;for(He=O-Ke+1,Xe=O;Xe<oe;He++,Xe++){let ke=Number.MIN_SAFE_INTEGER,Ie=!1;Xe<=Y&&(ke=Q(ue,we,$e,Ae,xe,ge,Xe,me,Ke,I[Oe-1][He-1]===0,ye));let Le=0;ke!==Number.MAX_SAFE_INTEGER&&(Ie=!0,Le=ke+H[Oe-1][He-1]);const Ue=Xe>O,Qe=Ue?H[Oe][He-1]+(I[Oe][He-1]>0?-5:0):0,rt=Xe>O+1&&I[Oe][He-1]>0,et=rt?H[Oe][He-2]+(I[Oe][He-2]>0?-5:0):0;if(rt&&(!Ue||et>=Qe)&&(!Ie||et>=Le))H[Oe][He]=et,M[Oe][He]=3,I[Oe][He]=0;else if(Ue&&(!Ie||Qe>=Le))H[Oe][He]=Qe,M[Oe][He]=2,I[Oe][He]=0;else if(Ie)H[Oe][He]=Le,M[Oe][He]=1,I[Oe][He]=I[Oe-1][He-1]+1;else throw new Error("not possible")}}if(B&&K(ue,Ae,xe,Ke),!ye[0]&&!j)return;Oe--,He--;const Se=[H[Oe][He],Ke];let Ce=0,ne=0;for(;Oe>=1;){let O=He;do{const Y=M[Oe][O];if(Y===3)O=O-2;else if(Y===2)O=O-1;else break}while(O>=1);Ce>1&&we[Ae+Oe-1]===ge[Ke+He-1]&&!Fe(O+Ke-1,xe,ge)&&Ce+1>I[Oe][O]&&(O=He),O===He?Ce++:Ce=1,ne||(ne=O),Oe--,He=O-1,Se.push(He)}me===Z&&(Se[0]+=2);const le=ne-Z;return Se[0]-=le,Se}e.fuzzyScore=Ve;function W(ue,we,Ae,xe,ge,Ke){let j=ue-1,Z=we-1;for(;j>=Ae&&Z>=xe;)ge[j]===Ke[Z]&&(x[j]=Z,j--),Z--}function Q(ue,we,Ae,xe,ge,Ke,j,Z,me,Oe,He){if(we[Ae]!==Ke[j])return Number.MIN_SAFE_INTEGER;let $e=1,Xe=!1;return j===Ae-xe?$e=ue[Ae]===ge[j]?7:5:Fe(j,ge,Ke)&&(j===0||!Fe(j-1,ge,Ke))?($e=ue[Ae]===ge[j]?7:5,Xe=!0):se(Ke,j)&&(j===0||!se(Ke,j-1))?$e=5:(se(Ke,j-1)||pe(Ke,j-1))&&($e=5,Xe=!0),$e>1&&Ae===xe&&(He[0]=!0),Xe||(Xe=Fe(j,ge,Ke)||se(Ke,j-1)||pe(Ke,j-1)),Ae===xe?j>me&&($e-=Xe?3:5):Oe?$e+=Xe?2:0:$e+=Xe?0:1,j+1===Z&&($e-=Xe?3:5),$e}function te(ue,we,Ae,xe,ge,Ke,j){return fe(ue,we,Ae,xe,ge,Ke,!0,j)}e.fuzzyScoreGracefulAggressive=te;function re(ue,we,Ae,xe,ge,Ke,j){return fe(ue,we,Ae,xe,ge,Ke,!1,j)}e.fuzzyScoreGraceful=re;function fe(ue,we,Ae,xe,ge,Ke,j,Z){let me=Ve(ue,we,Ae,xe,ge,Ke,Z);if(me&&!j)return me;if(ue.length>=3){const Oe=Math.min(7,ue.length-1);for(let He=Ae+1;He<Oe;He++){const $e=_e(ue,He);if($e){const Xe=Ve($e,$e.toLowerCase(),Ae,xe,ge,Ke,Z);Xe&&(Xe[0]-=3,(!me||Xe[0]>me[0])&&(me=Xe))}}}return me}function _e(ue,we){if(we+1>=ue.length)return;const Ae=ue[we],xe=ue[we+1];if(Ae!==xe)return ue.slice(0,we)+xe+Ae+ue.slice(we+2)}}),define(ve[113],be([0,1,35,112,8]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),E=new RegExp(`(\\\\)?${T.source}`,"g");function D(m){return m.replace(E,(c,p)=>p?c:`\\${c}`)}e.escapeIcons=D;const y=new RegExp(`\\\\${T.source}`,"g");function k(m){return m.replace(y,c=>`\\${c}`)}e.markdownEscapeEscapedIcons=k;const n=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function P(m){return m.indexOf(e.iconStartMarker)===-1?m:m.replace(n,(c,p,w,a)=>w?c:p||a||"")}e.stripIcons=P;function d(m){const c=m.indexOf(e.iconStartMarker);return c===-1?{text:m}:g(m,c)}e.parseLabelWithIcons=d;function g(m,c){const p=[];let w="";function a(_){if(_){w+=_;for(const b of _)p.push(t)}}let h=-1,f="",t=0,i,s,o=c;const u=m.length;for(a(m.substr(0,c));o<u;)i=m[o],s=m[o+1],i===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(h=o,a(f),f=e.iconStartMarker,o++):i===")"&&h!==-1?(t+=o-h+1,h=-1,f=""):h!==-1?/^[a-z0-9\-]$/i.test(i)?f+=i:(a(f),h=-1,f=""):a(i),o++;return a(f),{text:w,iconOffsets:p}}function r(m,c,p=!1){const{text:w,iconOffsets:a}=c;if(!a||a.length===0)return(0,R.matchesFuzzy)(m,w,p);const h=(0,S.ltrim)(w," "),f=w.length-h.length,t=(0,R.matchesFuzzy)(m,h,p);if(t)for(const i of t){const s=a[i.start+f]+f;i.start+=s,i.end+=s}return t}e.matchesFuzzyIconAware=r}),define(ve[83],be([0,1,13,113,12]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(m="",c=!1){var p,w;if(this.value=m,typeof this.value!="string")throw(0,S.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1):(this.isTrusted=(p=c.isTrusted)!==null&&p!==void 0?p:void 0,this.supportThemeIcons=(w=c.supportThemeIcons)!==null&&w!==void 0?w:!1)}appendText(m,c=0){return this.value+=P(this.supportThemeIcons?(0,R.escapeIcons)(m):m).replace(/([ \t]+)/g,(p,w)=>"&nbsp;".repeat(w.length)).replace(/^>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,c){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=E;function D(r){return y(r)?!r.value:Array.isArray(r)?r.every(D):!0}e.isEmptyMarkdownString=D;function y(r){return r instanceof E?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function k(r,m){return!r&&!m?!0:!r||!m?!1:Array.isArray(r)&&Array.isArray(m)?(0,v.equals)(r,m,n):y(r)&&y(m)?n(r,m):!1}e.markedStringsEquals=k;function n(r,m){return r===m?!0:!r||!m?!1:r.value===m.value&&r.isTrusted===m.isTrusted&&r.supportThemeIcons===m.supportThemeIcons}function P(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function d(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=d;function g(r){const m=[],c=r.split("|").map(w=>w.trim());r=c[0];const p=c[1];if(p){const w=/height=(\d+)/.exec(p),a=/width=(\d+)/.exec(p),h=w?w[1]:"",f=a?a[1]:"",t=isFinite(parseInt(f)),i=isFinite(parseInt(h));t&&m.push(`width="${f}"`),i&&m.push(`height="${h}"`)}return{href:r,dimensions:m}}e.parseHrefAndDimensions=g}),define(ve[58],be([0,1,23,8,2]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(k){return JSON.stringify(k,D)}e.stringify=T;function E(k){let n=JSON.parse(k);return n=y(n),n}e.parse=E;function D(k,n){return n instanceof RegExp?{$mid:2,source:n.source,flags:(0,R.regExpFlags)(n)}:n}function y(k,n=0){if(!k||n>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return S.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof v.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let P=0;P<k.length;++P)k[P]=y(k[P],n+1);else for(const P in k)Object.hasOwnProperty.call(k,P)&&(k[P]=y(k[P],n+1))}return k}e.revive=y}),define(ve[16],be([0,1,2,21]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var S;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp"})(S=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,k,n){this._hosts[y]=k,this._ports[y]=n}setConnectionToken(y,k){this._connectionTokens[y]=k}rewrite(y){if(this._delegate)return this._delegate(y);const k=y.authority;let n=this._hosts[k];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const P=this._ports[k],d=this._connectionTokens[k];let g=`path=${encodeURIComponent(y.path)}`;return typeof d=="string"&&(g+=`&tkn=${encodeURIComponent(d)}`),v.URI.from({scheme:R.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${n}:${P}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new T;class E{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,k,n){const P=this.toUri(y,k);return P.scheme===S.vscodeRemote?e.RemoteAuthorities.rewrite(P):R.isNative&&(n||R.isPreferringBrowserCodeLoad)&&P.scheme===S.file?P.with({scheme:S.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(y,k){const n=this.toUri(y,k);return n.scheme===S.vscodeFileResource?n.with({scheme:S.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(y,k){return v.URI.isUri(y)?y:v.URI.parse(k.toUrl(y))}}e.FileAccess=new E}),define(ve[25],be([0,1,36,14,2,8,16,21]),function(J,e,v,R,S,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(g){return(0,S.uriToFsPath)(g,!0)}e.originalFSPath=y;class k{constructor(r){this._ignorePathCasing=r}compare(r,m,c=!1){return r===m?0:(0,T.compare)(this.getComparisonKey(r,c),this.getComparisonKey(m,c))}isEqual(r,m,c=!1){return r===m?!0:!r||!m?!1:this.getComparisonKey(r,c)===this.getComparisonKey(m,c)}getComparisonKey(r,m=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,m,c=!1){if(r.scheme===m.scheme){if(r.scheme===E.Schemas.file)return v.isEqualOrParent(y(r),y(m),this._ignorePathCasing(r))&&r.query===m.query&&(c||r.fragment===m.fragment);if((0,e.isEqualAuthority)(r.authority,m.authority))return v.isEqualOrParent(r.path,m.path,this._ignorePathCasing(r),"/")&&r.query===m.query&&(c||r.fragment===m.fragment)}return!1}joinPath(r,...m){return S.URI.joinPath(r,...m)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return R.posix.basename(r.path)}extname(r){return R.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let m;return r.scheme===E.Schemas.file?m=S.URI.file(R.dirname(y(r))).path:(m=R.posix.dirname(r.path),r.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),m="/")),r.with({path:m})}normalizePath(r){if(!r.path.length)return r;let m;return r.scheme===E.Schemas.file?m=S.URI.file(R.normalize(y(r))).path:m=R.posix.normalize(r.path),r.with({path:m})}relativePath(r,m){if(r.scheme!==m.scheme||!(0,e.isEqualAuthority)(r.authority,m.authority))return;if(r.scheme===E.Schemas.file){const w=R.relative(y(r),y(m));return D.isWindows?v.toSlashes(w):w}let c=r.path||"/",p=m.path||"/";if(this._ignorePathCasing(r)){let w=0;for(const a=Math.min(c.length,p.length);w<a&&!(c.charCodeAt(w)!==p.charCodeAt(w)&&c.charAt(w).toLowerCase()!==p.charAt(w).toLowerCase());w++);c=p.substr(0,w)+c.substr(w)}return R.posix.relative(c,p)}resolvePath(r,m){if(r.scheme===E.Schemas.file){const c=S.URI.file(R.resolve(y(r),m));return r.with({authority:c.authority,path:c.path})}return m=v.toPosixPath(m),r.with({path:R.posix.resolve(r.path,m)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,m){return r===m||(0,T.equalsIgnoreCase)(r,m)}hasTrailingPathSeparator(r,m=R.sep){if(r.scheme===E.Schemas.file){const c=y(r);return c.length>v.getRoot(c).length&&c[c.length-1]===m}else{const c=r.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,m=R.sep){return(0,e.hasTrailingPathSeparator)(r,m)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,m=R.sep){let c=!1;if(r.scheme===E.Schemas.file){const p=y(r);c=p!==void 0&&p.length===v.getRoot(p).length&&p[p.length-1]===m}else{m="/";const p=r.path;c=p.length===1&&p.charCodeAt(p.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(r,m)?r.with({path:r.path+"/"}):r}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(g=>g.scheme===E.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new k(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(g,r){const m=[];for(let c=0;c<g.length;c++){const p=r(g[c]);g.some((w,a)=>a===c?!1:(0,e.isEqualOrParent)(p,r(w)))||m.push(g[c])}return m}e.distinctParents=n;var P;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function r(m){const c=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(a=>{const[h,f]=a.split(":");h&&f&&c.set(h,f)});const w=m.path.substring(0,m.path.indexOf(";"));return w&&c.set(g.META_DATA_MIME,w),c}g.parseMetaData=r})(P=e.DataUri||(e.DataUri={}));function d(g,r,m){if(r){let c=g.path;return c&&c[0]!==R.posix.sep&&(c=R.posix.sep+c),g.with({scheme:m,authority:r,path:c})}return g.with({scheme:m})}e.toLocalResource=d}),define(ve[11],be([0,1,20,12,3,6,45,25]),function(J,e,v,R,S,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(H){return!!H&&typeof H.then=="function"}e.isThenable=y;function k(H){const M=new v.CancellationTokenSource,B=H(M.token),G=new Promise((K,se)=>{M.token.onCancellationRequested(()=>{se((0,R.canceled)())}),Promise.resolve(B).then(pe=>{M.dispose(),K(pe)},pe=>{M.dispose(),se(pe)})});return new class{cancel(){M.cancel()}then(K,se){return G.then(K,se)}catch(K){return this.then(void 0,K)}finally(K){return G.finally(K)}}}e.createCancelablePromise=k;function n(H,M,B){return Promise.race([H,new Promise(G=>M.onCancellationRequested(()=>G(B)))])}e.raceCancellation=n;async function P(H){let M=-1;const B=H.map((K,se)=>K.then(pe=>(M=se,pe))),G=await Promise.race(B);return H.forEach((K,se)=>{se!==M&&K.cancel()}),G}e.raceCancellablePromises=P;function d(H,M,B){let G;const K=setTimeout(()=>{G==null||G(void 0),B==null||B()},M);return Promise.race([H.finally(()=>clearTimeout(K)),new Promise(se=>G=se)])}e.raceTimeout=d;function g(H){return new Promise((M,B)=>{const G=H();y(G)?G.then(M,B):M(G)})}e.asPromise=g;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const B=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(B,B).then(G)})}return new Promise((B,G)=>{this.queuedPromise.then(B,G)})}return this.activePromise=M(),new Promise((B,G)=>{this.activePromise.then(K=>{this.activePromise=null,B(K)},K=>{this.activePromise=null,G(K)})})}}e.Throttler=r;class m{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=m;class c{constructor(){this.promiseMap=new Map}queue(M,B){var G;const se=((G=this.promiseMap.get(M))!==null&&G!==void 0?G:Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.promiseMap.get(M)===se&&this.promiseMap.delete(M)});return this.promiseMap.set(M,se),se}}e.SequencerByKey=c;class p{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,B=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,K)=>{this.doResolve=G,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},B),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=p;class w{constructor(M){this.delayer=new p(M),this.throttler=new r}trigger(M,B){return this.delayer.trigger(()=>this.throttler.queue(M),B)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class a{constructor(){this._isOpen=!1,this._promise=new Promise((M,B)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class h extends a{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function f(H,M){return M?new Promise((B,G)=>{const K=setTimeout(B,H);M.onCancellationRequested(()=>{clearTimeout(K),G((0,R.canceled)())})}):k(B=>f(H,B))}e.timeout=f;function t(H,M=0){const B=setTimeout(H,M);return(0,T.toDisposable)(()=>clearTimeout(B))}e.disposableTimeout=t;function i(H){return H.then(void 0,M=>{})}e.ignoreErrors=i;function s(H){const M=[];let B=0;const G=H.length;function K(){return B<G?H[B++]():null}function se(pe){pe!=null&&M.push(pe);const Fe=K();return Fe?Fe.then(se):Promise.resolve(M)}return Promise.resolve(null).then(se)}e.sequence=s;function o(H,M=G=>!!G,B=null){let G=0;const K=H.length,se=()=>{if(G>=K)return Promise.resolve(B);const pe=H[G++];return Promise.resolve(pe()).then(We=>M(We)?Promise.resolve(We):se())};return se()}e.first=o;function u(H,M=G=>!!G,B=null){if(H.length===0)return Promise.resolve(B);let G=H.length;const K=()=>{var se,pe;G=-1;for(const Fe of H)(pe=(se=Fe).cancel)===null||pe===void 0||pe.call(se)};return new Promise((se,pe)=>{for(const Fe of H)Fe.then(We=>{--G>=0&&M(We)?(K(),se(We)):G===0&&se(B)}).catch(We=>{--G>=0&&(K(),pe(We))})})}e.firstParallel=u;class _{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new S.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((B,G)=>{this.outstandingPromises.push({factory:M,c:B,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const B=M.factory();B.then(M.c,M.e),B.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=_;class b extends _{constructor(){super(1)}}e.Queue=b;class A{constructor(){this.queues=new Map}queueFor(M,B=D.extUri){const G=B.getComparisonKey(M);let K=this.queues.get(G);return K||(K=new b,S.Event.once(K.onFinished)(()=>{K==null||K.dispose(),this.queues.delete(G)}),this.queues.set(G,K)),K}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=A;class C{constructor(M,B){this._token=-1,typeof M=="function"&&typeof B=="number"&&this.setIfNotSet(M,B)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,B){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},B)}setIfNotSet(M,B){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},B))}}e.TimeoutTimer=C;class l{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,B){this.cancel(),this._token=setInterval(()=>{M()},B)}}e.IntervalTimer=l;class F{constructor(M,B){this.timeoutToken=-1,this.runner=M,this.timeout=B,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class N extends F{constructor(M,B){super(M,B);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const H=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const B=setTimeout(()=>M(H));let G=!1;return{dispose(){G||(G=!0,clearTimeout(B))}}}}else e.runWhenIdle=(H,M)=>{const B=requestIdleCallback(H,typeof M=="number"?{timeout:M}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(B))}}}}();class z{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(B){this._error=B}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function de(H,M,B){let G;for(let K=0;K<B;K++)try{return await H()}catch(se){G=se,await f(M)}throw G}e.retry=de;class he{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,B,G){return this._pending={taskId:M,cancel:()=>G==null?void 0:G(),promise:B},B.then(()=>this.donePending(M),()=>this.donePending(M)),B}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let B,G;const K=new Promise((se,pe)=>{B=se,G=pe});this._next={run:M,promise:K,promiseResolve:B,promiseReject:G}}return this._next.promise}}e.TaskSequentializer=he;class ${constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,B)=>{this.completeCallback=M,this.errorCallback=B})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(B=>{this.completeCallback(M),this.resolved=!0,B()})}error(M){return new Promise(B=>{this.errorCallback(M),this.rejected=!0,B()})}cancel(){new Promise(M=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=q;class x extends S.Emitter{async fireAsync(M,B,G){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new E.LinkedList);for(const K of this._listeners)this._asyncDeliveryQueue.push([K,M]);for(;this._asyncDeliveryQueue.size>0&&!B.isCancellationRequested;){const[K,se]=this._asyncDeliveryQueue.shift(),pe=[],Fe=Object.assign(Object.assign({},se),{waitUntil:We=>{if(Object.isFrozen(pe))throw new Error("waitUntil can NOT be called asynchronous");G&&(We=G(We,typeof K=="function"?K:K[0])),pe.push(We)}});try{typeof K=="function"?K.call(void 0,Fe):K[0].call(K[1],Fe)}catch(We){(0,R.onUnexpectedError)(We);continue}Object.freeze(pe),await I.settled(pe).catch(We=>(0,R.onUnexpectedError)(We))}}}}e.AsyncEmitter=x;var I;(function(H){async function M(se){return typeof Promise.allSettled=="function"?B(se):G(se)}H.allSettled=M;async function B(se){return Promise.allSettled(se)}async function G(se){return Promise.all(se.map(pe=>pe.then(Fe=>({status:"fulfilled",value:Fe}),Fe=>({status:"rejected",reason:Fe}))))}async function K(se){let pe;const Fe=await Promise.all(se.map(We=>We.then(Ne=>Ne,Ne=>{pe||(pe=Ne)})));if(typeof pe!="undefined")throw pe;return Fe}H.settled=K})(I=e.Promises||(e.Promises={}))}),define(ve[114],be([0,1,14,11]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new R.IdleValue(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),T=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),E=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(C,l,F=!1){const N=C||"",z=l||"",de=S.value.collator.compare(N,z);return S.value.collatorIsNumeric&&de===0&&N!==z?N<z?-1:1:de}e.compareFileNames=D;function y(C,l){const F=T.value.collator;return C=C||"",l=l||"",f(F,C,l)}e.compareFileNamesDefault=y;function k(C,l){const F=T.value.collator;return C=C||"",l=l||"",o(C,l)||f(F,C,l)}e.compareFileNamesUpper=k;function n(C,l){const F=T.value.collator;return C=C||"",l=l||"",s(C,l)||f(F,C,l)}e.compareFileNamesLower=n;function P(C,l){return C=C||"",l=l||"",C===l?0:C<l?-1:1}e.compareFileNamesUnicode=P;function d(C,l,F=!1){F||(C=C&&C.toLowerCase(),l=l&&l.toLowerCase());const[N,z]=a(C),[de,he]=a(l);return N!==de?N<de?-1:1:z===he?0:z<he?-1:1}e.noIntlCompareFileNames=d;function g(C,l){const[F,N]=a(C),[z,de]=a(l);let he=S.value.collator.compare(N,de);if(he===0){if(S.value.collatorIsNumeric&&N!==de)return N<de?-1:1;if(he=S.value.collator.compare(F,z),S.value.collatorIsNumeric&&he===0&&F!==z)return F<z?-1:1}return he}e.compareFileExtensions=g;function r(C,l){C=C||"",l=l||"";const F=h(C),N=h(l),z=T.value.collator,de=E.value.collator;return f(de,F,N)||f(z,C,l)}e.compareFileExtensionsDefault=r;function m(C,l){C=C||"",l=l||"";const F=h(C),N=h(l),z=T.value.collator,de=E.value.collator;return f(de,F,N)||o(C,l)||f(z,C,l)}e.compareFileExtensionsUpper=m;function c(C,l){C=C||"",l=l||"";const F=h(C),N=h(l),z=T.value.collator,de=E.value.collator;return f(de,F,N)||s(C,l)||f(z,C,l)}e.compareFileExtensionsLower=c;function p(C,l){C=C||"",l=l||"";const F=h(C).toLowerCase(),N=h(l).toLowerCase();return F!==N?F<N?-1:1:C!==l?C<l?-1:1:0}e.compareFileExtensionsUnicode=p;const w=/^(.*?)(\.([^.]*))?$/;function a(C,l=!1){const F=C?w.exec(C):[];let N=[F&&F[1]||"",F&&F[3]||""];return l&&(!N[0]&&N[1]||N[0]&&N[0].charAt(0)===".")&&(N=[N[0]+"."+N[1],""]),N}function h(C){const l=C?w.exec(C):[];return l&&l[1]&&l[1].charAt(0)!=="."&&l[3]||""}function f(C,l,F){let N=C.compare(l,F);return N!==0?N:l.length!==F.length?l.length<F.length?-1:1:0}function t(C){const l=C.charAt(0);return l.toLocaleUpperCase()!==l}function i(C){const l=C.charAt(0);return l.toLocaleLowerCase()!==l}function s(C,l){return t(C)&&i(l)?-1:i(C)&&t(l)?1:0}function o(C,l){return i(C)&&t(l)?-1:t(C)&&i(l)?1:0}function u(C,l,F=!1){return F||(C=C&&C.toLowerCase(),l=l&&l.toLowerCase()),C===l?0:C<l?-1:1}function _(C,l,F=!1){const N=C.split(v.sep),z=l.split(v.sep),de=N.length-1,he=z.length-1;let $,q;for(let x=0;;x++){if($=de===x,q=he===x,$&&q)return D(N[x],z[x],F);if($)return-1;if(q)return 1;const I=u(N[x],z[x],F);if(I!==0)return I}}e.comparePaths=_;function b(C,l,F){const N=C.toLowerCase(),z=l.toLowerCase(),de=A(C,l,F);if(de)return de;const he=N.endsWith(F),$=z.endsWith(F);if(he!==$)return he?-1:1;const q=D(N,z);return q!==0?q:N.localeCompare(z)}e.compareAnything=b;function A(C,l,F){const N=C.toLowerCase(),z=l.toLowerCase(),de=N.startsWith(F),he=z.startsWith(F);if(de!==he)return de?-1:1;if(de&&he){if(N.length<z.length)return-1;if(N.length>z.length)return 1}return 0}e.compareByPrefix=A}),define(ve[28],be([0,1,8,36,14,22,11]),function(J,e,v,R,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const y="**",k="/",n="[/\\\\]",P="[^/\\\\]",d=/\//g;function g(B){switch(B){case 0:return"";case 1:return`${P}*?`;default:return`(?:${n}|${P}+${n}|${n}${P}+)*?`}}function r(B,G){if(!B)return[];const K=[];let se=!1,pe=!1,Fe="";for(const We of B){switch(We){case G:if(!se&&!pe){K.push(Fe),Fe="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}Fe+=We}return Fe&&K.push(Fe),K}e.splitGlobAware=r;function m(B){if(!B)return"";let G="";const K=r(B,k);if(K.every(se=>se===y))G=".*";else{let se=!1;K.forEach((pe,Fe)=>{if(pe===y){se||(G+=g(2),se=!0);return}let We=!1,Ne="",ze=!1,Ve="";for(const W of pe){if(W!=="}"&&We){Ne+=W;continue}if(ze&&(W!=="]"||!Ve)){let Q;W==="-"?Q=W:(W==="^"||W==="!")&&!Ve?Q="^":W===k?Q="":Q=v.escapeRegExpCharacters(W),Ve+=Q;continue}switch(W){case"{":We=!0;continue;case"[":ze=!0;continue;case"}":G+=`(?:${r(Ne,",").map(re=>m(re)).join("|")})`,We=!1,Ne="";break;case"]":G+="["+Ve+"]",ze=!1,Ve="";break;case"?":G+=P;continue;case"*":G+=g(1);continue;default:G+=v.escapeRegExpCharacters(W)}}Fe<K.length-1&&(K[Fe+1]!==y||Fe+2<K.length)&&(G+=n),se=!1})}return G}const c=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),i=function(){return!1},s=function(){return null};function o(B,G){if(!B)return s;let K;typeof B!="string"?K=B.pattern:K=B,K=K.trim();const se=`${K}_${!!G.trimForExclusions}`;let pe=t.get(se);if(pe)return u(pe,B);let Fe;if(c.test(K)){const We=K.substr(4);pe=function(Ne,ze){return typeof Ne=="string"&&Ne.endsWith(We)?K:null}}else(Fe=p.exec(_(K,G)))?pe=b(Fe[1],K):(G.trimForExclusions?a:w).test(K)?pe=A(K,G):(Fe=h.exec(_(K,G)))?pe=C(Fe[1].substr(1),K,!0):(Fe=f.exec(_(K,G)))?pe=C(Fe[1],K,!1):pe=l(K);return t.set(se,pe),u(pe,B)}function u(B,G){return typeof G=="string"?B:function(K,se){return R.isEqualOrParent(K,G.base)?B(S.relative(G.base,K),se):null}}function _(B,G){return G.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function b(B,G){const K=`/${B}`,se=`\\${B}`,pe=function(We,Ne){return typeof We!="string"?null:Ne?Ne===B?G:null:We===B||We.endsWith(K)||We.endsWith(se)?G:null},Fe=[B];return pe.basenames=Fe,pe.patterns=[G],pe.allBasenames=Fe,pe}function A(B,G){const K=M(B.slice(1,-1).split(",").map(Ne=>o(Ne,G)).filter(Ne=>Ne!==s),B),se=K.length;if(!se)return s;if(se===1)return K[0];const pe=function(Ne,ze){for(let Ve=0,W=K.length;Ve<W;Ve++)if(K[Ve](Ne,ze))return B;return null},Fe=K.find(Ne=>!!Ne.allBasenames);Fe&&(pe.allBasenames=Fe.allBasenames);const We=K.reduce((Ne,ze)=>ze.allPaths?Ne.concat(ze.allPaths):Ne,[]);return We.length&&(pe.allPaths=We),pe}function C(B,G,K){const se=S.sep===S.posix.sep,pe=se?B:B.replace(d,S.sep),Fe=S.sep+pe,We=S.posix.sep+B,Ne=K?function(ze,Ve){return typeof ze=="string"&&(ze===pe||ze.endsWith(Fe)||!se&&(ze===B||ze.endsWith(We)))?G:null}:function(ze,Ve){return typeof ze=="string"&&(ze===pe||!se&&ze===B)?G:null};return Ne.allPaths=[(K?"*/":"./")+B],Ne}function l(B){try{const G=new RegExp(`^${m(B)}$`);return function(K){return G.lastIndex=0,typeof K=="string"&&G.test(K)?B:null}}catch(G){return s}}function F(B,G,K){return!B||typeof G!="string"?!1:N(B)(G,void 0,K)}e.match=F;function N(B,G={}){if(!B)return i;if(typeof B=="string"||$(B)){const K=o(B,G);if(K===s)return i;const se=function(pe,Fe){return!!K(pe,Fe)};return K.allBasenames&&(se.allBasenames=K.allBasenames),K.allPaths&&(se.allPaths=K.allPaths),se}return I(B,G)}e.parse=N;function z(B){if(!B)return;let G;return K=>(G||(G=(B()||Promise.resolve([])).then(se=>se?he(se):{})),G.then(se=>!!se[K]))}e.hasSiblingPromiseFn=z;function de(B){if(!B)return;let G;return K=>{if(!G){const se=B();G=se?he(se):{}}return!!G[K]}}e.hasSiblingFn=de;function he(B){const G={};for(const K of B)G[K]=!0;return G}function $(B){const G=B;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=$;function q(B){return B.allBasenames||[]}e.getBasenameTerms=q;function x(B){return B.allPaths||[]}e.getPathTerms=x;function I(B,G){const K=M(Object.getOwnPropertyNames(B).map(Ne=>H(Ne,B[Ne],G)).filter(Ne=>Ne!==s)),se=K.length;if(!se)return s;if(!K.some(Ne=>!!Ne.requiresSiblings)){if(se===1)return K[0];const Ne=function(W,Q){for(let te=0,re=K.length;te<re;te++){const fe=K[te](W,Q);if(fe)return fe}return null},ze=K.find(W=>!!W.allBasenames);ze&&(Ne.allBasenames=ze.allBasenames);const Ve=K.reduce((W,Q)=>Q.allPaths?W.concat(Q.allPaths):W,[]);return Ve.length&&(Ne.allPaths=Ve),Ne}const pe=function(Ne,ze,Ve){let W;for(let Q=0,te=K.length;Q<te;Q++){const re=K[Q];re.requiresSiblings&&Ve&&(ze||(ze=S.basename(Ne)),W||(W=ze.substr(0,ze.length-S.extname(Ne).length)));const fe=re(Ne,ze,W,Ve);if(fe)return fe}return null},Fe=K.find(Ne=>!!Ne.allBasenames);Fe&&(pe.allBasenames=Fe.allBasenames);const We=K.reduce((Ne,ze)=>ze.allPaths?Ne.concat(ze.allPaths):Ne,[]);return We.length&&(pe.allPaths=We),pe}function H(B,G,K){if(G===!1)return s;const se=o(B,K);if(se===s)return s;if(typeof G=="boolean")return se;if(G){const pe=G.when;if(typeof pe=="string"){const Fe=(We,Ne,ze,Ve)=>{if(!Ve||!se(We,Ne))return null;const W=pe.replace("$(basename)",ze),Q=Ve(W);return(0,E.isThenable)(Q)?Q.then(te=>te?B:null):Q?B:null};return Fe.requiresSiblings=!0,Fe}}return se}function M(B,G){const K=B.filter(Ne=>!!Ne.basenames);if(K.length<2)return B;const se=K.reduce((Ne,ze)=>{const Ve=ze.basenames;return Ve?Ne.concat(Ve):Ne},[]);let pe;if(G){pe=[];for(let Ne=0,ze=se.length;Ne<ze;Ne++)pe.push(G)}else pe=K.reduce((Ne,ze)=>{const Ve=ze.patterns;return Ve?Ne.concat(Ve):Ne},[]);const Fe=function(Ne,ze){if(typeof Ne!="string")return null;if(!ze){let W;for(W=Ne.length;W>0;W--){const Q=Ne.charCodeAt(W-1);if(Q===47||Q===92)break}ze=Ne.substr(W)}const Ve=se.indexOf(ze);return Ve!==-1?pe[Ve]:null};Fe.basenames=se,Fe.patterns=pe,Fe.allBasenames=se;const We=B.filter(Ne=>!Ne.basenames);return We.push(Fe),We}}),define(ve[59],be([0,1,2,14,8,16,21,25,36]),function(J,e,v,R,S,T,E,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(o,u,_){if(typeof o=="string"&&(o=v.URI.file(o)),_){const A=_.getWorkspaceFolder(o);if(A){const C=_.getWorkspace().folders.length>1;let l;if((0,D.isEqual)(A.uri,o)?l="":l=(0,D.relativePath)(A.uri,o),C){const F=A.name?A.name:(0,D.basename)(A.uri);l=l?F+" \u2022 "+l:F}return l}}if(o.scheme!==T.Schemas.file&&o.scheme!==T.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(o.fsPath))return(0,R.normalize)(P(o.fsPath));let b=(0,R.normalize)(o.fsPath);return!E.isWindows&&(u==null?void 0:u.userHome)&&(b=g(b,u.userHome.fsPath)),b}e.getPathLabel=k;function n(o){if(!o)return;typeof o=="string"&&(o=v.URI.file(o));const u=(0,D.basename)(o)||(o.scheme===T.Schemas.file?o.fsPath:o.path);return E.isWindows&&(0,y.isRootOrDriveLetter)(u)?P(u):u}e.getBaseLabel=n;function P(o){return(0,y.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=P;let d=Object.create(null);function g(o,u){if(E.isWindows||!o||!u)return o;let _=d.original===u?d.normalized:void 0;return _||(_=`${(0,S.rtrim)(u,R.posix.sep)}${R.posix.sep}`,d={original:u,normalized:_}),(E.isLinux?o.startsWith(_):(0,S.startsWithIgnoreCase)(o,_))&&(o=`~/${o.substr(_.length)}`),o}e.tildify=g;function r(o,u){return o.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=r;const m="\u2026",c="\\\\",p="~";function w(o,u=R.sep){const _=new Array(o.length);let b=!1;for(let A=0;A<o.length;A++){let C=o[A];if(C===""){_[A]=`.${u}`;continue}if(!C){_[A]=C;continue}b=!0;let l="";C.indexOf(c)===0?(l=C.substr(0,C.indexOf(c)+c.length),C=C.substr(C.indexOf(c)+c.length)):C.indexOf(u)===0?(l=C.substr(0,C.indexOf(u)+u.length),C=C.substr(C.indexOf(u)+u.length)):C.indexOf(p)===0&&(l=C.substr(0,C.indexOf(p)+p.length),C=C.substr(C.indexOf(p)+p.length));const F=C.split(u);for(let N=1;b&&N<=F.length;N++)for(let z=F.length-N;b&&z>=0;z--){b=!1;let de=F.slice(z,z+N).join(u);for(let he=0;!b&&he<o.length;he++)if(he!==A&&o[he]&&o[he].indexOf(de)>-1){const $=z+N===F.length,q=z>0&&o[he].indexOf(u)>-1?u+de:de,x=o[he].endsWith(q);b=!$||x}if(!b){let he="";(F[0].endsWith(":")||l!=="")&&(z===1&&(z=0,N++,de=F[0]+u+de),z>0&&(he=F[0]+u),he=l+he),z>0&&(he=he+m+u),he=he+de,z+N<F.length&&(he=he+u+m),_[A]=he}}b&&(_[A]=C)}return _}e.shorten=w;var a;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function h(o,u=Object.create(null)){const _=[];let b=!1,A="";for(const C of o)if(C==="$"||b&&C==="{")A&&_.push({value:A,type:a.TEXT}),A="",b=!0;else if(C==="}"&&b){const l=u[A];if(typeof l=="string")l.length&&_.push({value:l,type:a.VARIABLE});else if(l){const F=_[_.length-1];(!F||F.type!==a.SEPARATOR)&&_.push({value:l.label,type:a.SEPARATOR})}A="",b=!1}else A+=C;return A&&!b&&_.push({value:A,type:a.TEXT}),_.filter((C,l)=>{if(C.type===a.SEPARATOR){const F=_[l-1],N=_[l+1];return[F,N].every(z=>z&&(z.type===a.VARIABLE||z.type===a.TEXT)&&z.value.length>0)}return!0}).map(C=>C.value).join("")}e.template=h;function f(o,u){return E.isMacintosh||u?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,E.isMacintosh?"&":"&&"):o.replace(/&&|&/g,_=>_==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function t(o,u){return E.isMacintosh||u?o.replace(/\(&&\w\)|&&/g,""):E.isWindows?o.replace(/&&|&/g,_=>_==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(o){const u=o.indexOf("/")!==-1?R.posix:R.win32,_=u.basename(o),b=u.dirname(o);return _.length?{name:_,parentPath:b}:{name:b,parentPath:""}}e.splitName=s}),define(ve[115],be([0,1,2]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(n){return n.toJSON()}class S{constructor(P){this._uriTransformer=P}transformIncoming(P){const d=this._uriTransformer.transformIncoming(P);return d===P?P:R(v.URI.from(d))}transformOutgoing(P){const d=this._uriTransformer.transformOutgoing(P);return d===P?P:R(v.URI.from(d))}transformOutgoingURI(P){const d=this._uriTransformer.transformOutgoing(P);return d===P?P:v.URI.from(d)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function T(n,P,d){if(!n||d>200)return null;if(typeof n=="object"){if(n instanceof v.URI)return P.transformOutgoing(n);for(let g in n)if(Object.hasOwnProperty.call(n,g)){const r=T(n[g],P,d+1);r!==null&&(n[g]=r)}}return null}function E(n,P){const d=T(n,P,0);return d===null?n:d}e.transformOutgoingURIs=E;function D(n,P,d,g){if(!n||g>200)return null;if(typeof n=="object"){if(n.$mid===1)return d?v.URI.revive(P.transformIncoming(n)):P.transformIncoming(n);for(let r in n)if(Object.hasOwnProperty.call(n,r)){const m=D(n[r],P,d,g+1);m!==null&&(n[r]=m)}}return null}function y(n,P){const d=D(n,P,!1,0);return d===null?n:d}e.transformIncomingURIs=y;function k(n,P){const d=D(n,P,!0,0);return d===null?n:d}e.transformAndReviveIncomingURIs=k}),define(ve[37],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(y){return v.test(y)}e.isUUID=R;const S=new Uint8Array(16),T=[];for(let y=0;y<256;y++)T.push(y.toString(16).padStart(2,"0"));let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(y){for(let k=0;k<y.length;k++)y[k]=Math.floor(Math.random()*256);return y};function D(){E(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let y=0,k="";return k+=T[S[y++]],k+=T[S[y++]],k+=T[S[y++]],k+=T[S[y++]],k+="-",k+=T[S[y++]],k+=T[S[y++]],k+="-",k+=T[S[y++]],k+=T[S[y++]],k+="-",k+=T[S[y++]],k+=T[S[y++]],k+="-",k+=T[S[y++]],k+=T[S[y++]],k+=T[S[y++]],k+=T[S[y++]],k+=T[S[y++]],k+=T[S[y++]],k}e.generateUuid=D}),define(ve[84],be([0,1,82]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(D){let y=(0,v.toUint8)(D);this._defaultValue=y,this._asciiMap=R._createAsciiMap(y),this._map=new Map}static _createAsciiMap(D){let y=new Uint8Array(256);for(let k=0;k<256;k++)y[k]=D;return y}set(D,y){let k=(0,v.toUint8)(y);D>=0&&D<256?this._asciiMap[D]=k:this._map.set(D,k)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=R;var S;(function(E){E[E.False=0]="False",E[E.True=1]="True"})(S||(S={}));class T{constructor(){this._actual=new R(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=T}),define(ve[116],be([0,1,84]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(E){E[E.Regular=0]="Regular",E[E.Whitespace=1]="Whitespace",E[E.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class S extends v.CharacterClassifier{constructor(D){super(0);for(let y=0,k=D.length;y<k;y++)this.set(D.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=S;function T(E){let D={};return y=>(D.hasOwnProperty(y)||(D[y]=E(y)),D[y])}e.getMapForWordSeparators=T(E=>new S(E))}),define(ve[38],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class v{constructor(S,T){this.lineNumber=S,this.column=T}with(S=this.lineNumber,T=this.column){return S===this.lineNumber&&T===this.column?this:new v(S,T)}delta(S=0,T=0){return this.with(this.lineNumber+S,this.column+T)}equals(S){return v.equals(this,S)}static equals(S,T){return!S&&!T?!0:!!S&&!!T&&S.lineNumber===T.lineNumber&&S.column===T.column}isBefore(S){return v.isBefore(this,S)}static isBefore(S,T){return S.lineNumber<T.lineNumber?!0:T.lineNumber<S.lineNumber?!1:S.column<T.column}isBeforeOrEqual(S){return v.isBeforeOrEqual(this,S)}static isBeforeOrEqual(S,T){return S.lineNumber<T.lineNumber?!0:T.lineNumber<S.lineNumber?!1:S.column<=T.column}static compare(S,T){let E=S.lineNumber|0,D=T.lineNumber|0;if(E===D){let y=S.column|0,k=T.column|0;return y-k}return E-D}clone(){return new v(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(S){return new v(S.lineNumber,S.column)}static isIPosition(S){return S&&typeof S.lineNumber=="number"&&typeof S.column=="number"}}e.Position=v}),define(ve[31],be([0,1,38]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(T,E,D,y){T>D||T===D&&E>y?(this.startLineNumber=D,this.startColumn=y,this.endLineNumber=T,this.endColumn=E):(this.startLineNumber=T,this.startColumn=E,this.endLineNumber=D,this.endColumn=y)}isEmpty(){return R.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return R.containsPosition(this,T)}static containsPosition(T,E){return!(E.lineNumber<T.startLineNumber||E.lineNumber>T.endLineNumber||E.lineNumber===T.startLineNumber&&E.column<T.startColumn||E.lineNumber===T.endLineNumber&&E.column>T.endColumn)}containsRange(T){return R.containsRange(this,T)}static containsRange(T,E){return!(E.startLineNumber<T.startLineNumber||E.endLineNumber<T.startLineNumber||E.startLineNumber>T.endLineNumber||E.endLineNumber>T.endLineNumber||E.startLineNumber===T.startLineNumber&&E.startColumn<T.startColumn||E.endLineNumber===T.endLineNumber&&E.endColumn>T.endColumn)}strictContainsRange(T){return R.strictContainsRange(this,T)}static strictContainsRange(T,E){return!(E.startLineNumber<T.startLineNumber||E.endLineNumber<T.startLineNumber||E.startLineNumber>T.endLineNumber||E.endLineNumber>T.endLineNumber||E.startLineNumber===T.startLineNumber&&E.startColumn<=T.startColumn||E.endLineNumber===T.endLineNumber&&E.endColumn>=T.endColumn)}plusRange(T){return R.plusRange(this,T)}static plusRange(T,E){let D,y,k,n;return E.startLineNumber<T.startLineNumber?(D=E.startLineNumber,y=E.startColumn):E.startLineNumber===T.startLineNumber?(D=E.startLineNumber,y=Math.min(E.startColumn,T.startColumn)):(D=T.startLineNumber,y=T.startColumn),E.endLineNumber>T.endLineNumber?(k=E.endLineNumber,n=E.endColumn):E.endLineNumber===T.endLineNumber?(k=E.endLineNumber,n=Math.max(E.endColumn,T.endColumn)):(k=T.endLineNumber,n=T.endColumn),new R(D,y,k,n)}intersectRanges(T){return R.intersectRanges(this,T)}static intersectRanges(T,E){let D=T.startLineNumber,y=T.startColumn,k=T.endLineNumber,n=T.endColumn,P=E.startLineNumber,d=E.startColumn,g=E.endLineNumber,r=E.endColumn;return D<P?(D=P,y=d):D===P&&(y=Math.max(y,d)),k>g?(k=g,n=r):k===g&&(n=Math.min(n,r)),D>k||D===k&&y>n?null:new R(D,y,k,n)}equalsRange(T){return R.equalsRange(this,T)}static equalsRange(T,E){return!!T&&!!E&&T.startLineNumber===E.startLineNumber&&T.startColumn===E.startColumn&&T.endLineNumber===E.endLineNumber&&T.endColumn===E.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(T){return new v.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(T){return new v.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,E){return new R(this.startLineNumber,this.startColumn,T,E)}setStartPosition(T,E){return new R(T,E,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(T){return new R(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,E=T){return new R(T.lineNumber,T.column,E.lineNumber,E.column)}static lift(T){return T?new R(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,E){return!(T.endLineNumber<E.startLineNumber||T.endLineNumber===E.startLineNumber&&T.endColumn<E.startColumn||E.endLineNumber<T.startLineNumber||E.endLineNumber===T.startLineNumber&&E.endColumn<T.startColumn)}static areIntersecting(T,E){return!(T.endLineNumber<E.startLineNumber||T.endLineNumber===E.startLineNumber&&T.endColumn<=E.startColumn||E.endLineNumber<T.startLineNumber||E.endLineNumber===T.startLineNumber&&E.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,E){if(T&&E){const k=T.startLineNumber|0,n=E.startLineNumber|0;if(k===n){const P=T.startColumn|0,d=E.startColumn|0;if(P===d){const g=T.endLineNumber|0,r=E.endLineNumber|0;if(g===r){const m=T.endColumn|0,c=E.endColumn|0;return m-c}return g-r}return P-d}return k-n}return(T?1:0)-(E?1:0)}static compareRangesUsingEnds(T,E){return T.endLineNumber===E.endLineNumber?T.endColumn===E.endColumn?T.startLineNumber===E.startLineNumber?T.startColumn-E.startColumn:T.startLineNumber-E.startLineNumber:T.endColumn-E.endColumn:T.endLineNumber-E.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=R}),define(ve[117],be([0,1,38,31]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var S;(function(E){E[E.LTR=0]="LTR",E[E.RTL=1]="RTL"})(S=e.SelectionDirection||(e.SelectionDirection={}));class T extends R.Range{constructor(D,y,k,n){super(D,y,k,n);this.selectionStartLineNumber=D,this.selectionStartColumn=y,this.positionLineNumber=k,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return T.selectionsEqual(this,D)}static selectionsEqual(D,y){return D.selectionStartLineNumber===y.selectionStartLineNumber&&D.selectionStartColumn===y.selectionStartColumn&&D.positionLineNumber===y.positionLineNumber&&D.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,y){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,D,y):new T(D,y,this.startLineNumber,this.startColumn)}getPosition(){return new v.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,y){return this.getDirection()===0?new T(D,y,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,D,y)}static fromPositions(D,y=D){return new T(D.lineNumber,D.column,y.lineNumber,y.column)}static liftSelection(D){return new T(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,y){if(D&&!y||!D&&y)return!1;if(!D&&!y)return!0;if(D.length!==y.length)return!1;for(let k=0,n=D.length;k<n;k++)if(!this.selectionsEqual(D[k],y[k]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,y,k,n,P){return P===0?new T(D,y,k,n):new T(k,n,D,y)}}e.Selection=T}),define(ve[85],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var v;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(v=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var S;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var E;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(E=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(m){this.tabSize=Math.max(1,m.tabSize|0),this.indentSize=m.tabSize|0,this.insertSpaces=Boolean(m.insertSpaces),this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=Boolean(m.trimAutoWhitespace)}equals(m){return this.tabSize===m.tabSize&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class y{constructor(m,c){this.range=m,this.matches=c}}e.FindMatch=y;var k;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right"})(n=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var P;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(P=e.ModelConstants||(e.ModelConstants={}));class d{constructor(m,c,p,w,a,h){this.identifier=m,this.range=c,this.text=p,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=a,this._isTracked=h}}e.ValidAnnotatedEditOperation=d;class g{constructor(m,c,p){this.reverseEdits=m,this.changes=c,this.trimAutoWhitespaceLineNumbers=p}}e.ApplyEditsResult=g}),define(ve[118],be([0,1,8,116,38,31,85]),function(J,e,v,R,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class y{constructor(a,h,f,t){this.searchString=a,this.isRegex=h,this.matchCase=f,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=k(this.searchString):a=this.searchString.indexOf(`
`)>=0;let h=null;try{h=v.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch(t){return null}if(!h)return null;let f=!this.isRegex&&!a;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new n(h,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,f?this.searchString:null)}}e.SearchParams=y;function k(w){if(!w||w.length===0)return!1;for(let a=0,h=w.length;a<h;a++)if(w.charCodeAt(a)===92){if(a++,a>=h)break;const t=w.charCodeAt(a);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class n{constructor(a,h,f){this.regex=a,this.wordSeparators=h,this.simpleSearch=f}}e.SearchData=n;function P(w,a,h){if(!h)return new E.FindMatch(w,null);let f=[];for(let t=0,i=a.length;t<i;t++)f[t]=a[t];return new E.FindMatch(w,f)}e.createFindMatch=P;class d{constructor(a){let h=[],f=0;for(let t=0,i=a.length;t<i;t++)a.charCodeAt(t)===10&&(h[f++]=t);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(a){const h=this._lineFeedsOffsets;let f=0,t=h.length-1;if(t===-1||a<=h[0])return 0;for(;f<t;){const i=f+((t-f)/2>>0);h[i]>=a?t=i-1:h[i+1]>=a?(f=i,t=i):f=i+1}return f+1}}class g{static findMatches(a,h,f,t,i){const s=h.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(a,f,new p(s.wordSeparators,s.regex),t,i):this._doFindMatchesLineByLine(a,f,s,t,i):[]}static _getMultilineMatchRange(a,h,f,t,i,s){let o,u=0;t?(u=t.findLineFeedCountBeforeOffset(i),o=h+i+u):o=h+i;let _;if(t){let l=t.findLineFeedCountBeforeOffset(i+s.length)-u;_=o+s.length+l}else _=o+s.length;const b=a.getPositionAt(o),A=a.getPositionAt(_);return new T.Range(b.lineNumber,b.column,A.lineNumber,A.column)}static _doFindMatchesMultiline(a,h,f,t,i){const s=a.getOffsetAt(h.getStartPosition()),o=a.getValueInRange(h,1),u=a.getEOL()===`\r
`?new d(o):null,_=[];let b=0,A;for(f.reset(0);A=f.next(o);)if(_[b++]=P(this._getMultilineMatchRange(a,s,o,u,A.index,A[0]),A,t),b>=i)return _;return _}static _doFindMatchesLineByLine(a,h,f,t,i){const s=[];let o=0;if(h.startLineNumber===h.endLineNumber){const _=a.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return o=this._findMatchesInLine(f,_,h.startLineNumber,h.startColumn-1,o,s,t,i),s}const u=a.getLineContent(h.startLineNumber).substring(h.startColumn-1);o=this._findMatchesInLine(f,u,h.startLineNumber,h.startColumn-1,o,s,t,i);for(let _=h.startLineNumber+1;_<h.endLineNumber&&o<i;_++)o=this._findMatchesInLine(f,a.getLineContent(_),_,0,o,s,t,i);if(o<i){const _=a.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);o=this._findMatchesInLine(f,_,h.endLineNumber,0,o,s,t,i)}return s}static _findMatchesInLine(a,h,f,t,i,s,o,u){const _=a.wordSeparators;if(!o&&a.simpleSearch){const C=a.simpleSearch,l=C.length,F=h.length;let N=-l;for(;(N=h.indexOf(C,N+l))!==-1;)if((!_||c(_,h,F,N,l))&&(s[i++]=new E.FindMatch(new T.Range(f,N+1+t,f,N+1+l+t),null),i>=u))return i;return i}const b=new p(a.wordSeparators,a.regex);let A;b.reset(0);do if(A=b.next(h),A&&(s[i++]=P(new T.Range(f,A.index+1+t,f,A.index+1+A[0].length+t),A,o),i>=u))return i;while(A);return i}static findNextMatch(a,h,f,t){const i=h.parseSearchRequest();if(!i)return null;const s=new p(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(a,f,s,t):this._doFindNextMatchLineByLine(a,f,s,t)}static _doFindNextMatchMultiline(a,h,f,t){const i=new S.Position(h.lineNumber,1),s=a.getOffsetAt(i),o=a.getLineCount(),u=a.getValueInRange(new T.Range(i.lineNumber,i.column,o,a.getLineMaxColumn(o)),1),_=a.getEOL()===`\r
`?new d(u):null;f.reset(h.column-1);let b=f.next(u);return b?P(this._getMultilineMatchRange(a,s,u,_,b.index,b[0]),b,t):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(a,new S.Position(1,1),f,t):null}static _doFindNextMatchLineByLine(a,h,f,t){const i=a.getLineCount(),s=h.lineNumber,o=a.getLineContent(s),u=this._findFirstMatchInLine(f,o,s,h.column,t);if(u)return u;for(let _=1;_<=i;_++){const b=(s+_-1)%i,A=a.getLineContent(b+1),C=this._findFirstMatchInLine(f,A,b+1,1,t);if(C)return C}return null}static _findFirstMatchInLine(a,h,f,t,i){a.reset(t-1);const s=a.next(h);return s?P(new T.Range(f,s.index+1,f,s.index+1+s[0].length),s,i):null}static findPreviousMatch(a,h,f,t){const i=h.parseSearchRequest();if(!i)return null;const s=new p(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(a,f,s,t):this._doFindPreviousMatchLineByLine(a,f,s,t)}static _doFindPreviousMatchMultiline(a,h,f,t){const i=this._doFindMatchesMultiline(a,new T.Range(1,1,h.lineNumber,h.column),f,t,10*D);if(i.length>0)return i[i.length-1];const s=a.getLineCount();return h.lineNumber!==s||h.column!==a.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(a,new S.Position(s,a.getLineMaxColumn(s)),f,t):null}static _doFindPreviousMatchLineByLine(a,h,f,t){const i=a.getLineCount(),s=h.lineNumber,o=a.getLineContent(s).substring(0,h.column-1),u=this._findLastMatchInLine(f,o,s,t);if(u)return u;for(let _=1;_<=i;_++){const b=(i+s-_-1)%i,A=a.getLineContent(b+1),C=this._findLastMatchInLine(f,A,b+1,t);if(C)return C}return null}static _findLastMatchInLine(a,h,f,t){let i=null,s;for(a.reset(0);s=a.next(h);)i=P(new T.Range(f,s.index+1,f,s.index+1+s[0].length),s,t);return i}}e.TextModelSearch=g;function r(w,a,h,f,t){if(f===0)return!0;const i=a.charCodeAt(f-1);if(w.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=a.charCodeAt(f);if(w.get(s)!==0)return!0}return!1}function m(w,a,h,f,t){if(f+t===h)return!0;const i=a.charCodeAt(f+t);if(w.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=a.charCodeAt(f+t-1);if(w.get(s)!==0)return!0}return!1}function c(w,a,h,f,t){return r(w,a,h,f,t)&&m(w,a,h,f,t)}e.isValidMatch=c;class p{constructor(a,h){this._wordSeparators=a,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const h=a.length;let f;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(f=this._searchRegex.exec(a),!f))return null;const t=f.index,i=f[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){v.getNextCodePoint(a,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||c(this._wordSeparators,a,h,t,i))return f}while(f);return null}}e.Searcher=p}),define(ve[86],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function v(D=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)D.indexOf(k)>=0||(y+="\\"+k);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=v();function R(D){let y=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)y=D;else{let k="g";D.ignoreCase&&(k+="i"),D.multiline&&(k+="m"),D.unicode&&(k+="u"),y=new RegExp(D.source,k)}return y.lastIndex=0,y}e.ensureValidWordDefinition=R;const S={maxLen:1e3,windowSize:15,timeBudget:150};function T(D,y,k,n,P=S){if(k.length>P.maxLen){let c=D-P.maxLen/2;return c<0?c=0:n+=c,k=k.substring(c,D+P.maxLen/2),T(D,y,k,n,P)}const d=Date.now(),g=D-1-n;let r=-1,m=null;for(let c=1;!(Date.now()-d>=P.timeBudget);c++){const p=g-P.windowSize*c;y.lastIndex=Math.max(0,p);const w=E(y,k,g,r);if(!w&&m||(m=w,p<=0))break;r=p}if(m){let c={word:m[0],startColumn:n+1+m.index,endColumn:n+1+m.index+m[0].length};return y.lastIndex=0,c}return null}e.getWordAtText=T;function E(D,y,k,n){let P;for(;P=D.exec(y);){const d=P.index||0;if(d<=k&&D.lastIndex>=k)return P;if(n>0&&d>n)return null}return null}}),define(ve[119],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var v;(function(E){E[E.None=0]="None",E[E.Indent=1]="Indent",E[E.IndentOutdent=2]="IndentOutdent",E[E.Outdent=3]="Outdent"})(v=e.IndentAction||(e.IndentAction={}));class R{constructor(D){if(this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let y=0,k=D.notIn.length;y<k;y++)switch(D.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=R;class S{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of D)T(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),T(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),T(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),T(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&T(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=S;function T(E,D,y){E.has(D)?E.get(D).push(y):E.set(D,[y])}}),define(ve[60],be([0,1,28,14]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(T,E,D,y){if(Array.isArray(T)){let k=0;for(const n of T){const P=S(n,E,D,y);if(P===10)return P;P>k&&(k=P)}return k}else{if(typeof T=="string")return y?T==="*"?5:T===D?10:0:0;if(T){const{language:k,pattern:n,scheme:P,hasAccessToAllModels:d}=T;if(!y&&!d)return 0;let g=0;if(P)if(P===E.scheme)g=10;else if(P==="*")g=5;else return 0;if(k)if(k===D)g=10;else if(k==="*")g=Math.max(g,5);else return 0;if(n){let r;if(typeof n=="string"?r=n:r=Object.assign(Object.assign({},n),{base:(0,R.normalize)(n.base)}),r===E.fsPath||(0,v.match)(r,E.fsPath))g=10;else return 0}return g}else return 0}}e.score=S}),define(ve[120],be([0,1,84]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class S{constructor(r,m,c){const p=new Uint8Array(r*m);for(let w=0,a=r*m;w<a;w++)p[w]=c;this._data=p,this.rows=r,this.cols=m}get(r,m){return this._data[r*this.cols+m]}set(r,m,c){this._data[r*this.cols+m]=c}}e.Uint8Matrix=S;class T{constructor(r){let m=0,c=0;for(let w=0,a=r.length;w<a;w++){let[h,f,t]=r[w];f>m&&(m=f),h>c&&(c=h),t>c&&(c=t)}m++,c++;let p=new S(c,m,0);for(let w=0,a=r.length;w<a;w++){let[h,f,t]=r[w];p.set(h,f,t)}this._states=p,this._maxCharCode=m}nextState(r,m){return m<0||m>=this._maxCharCode?0:this._states.get(r,m)}}e.StateMachine=T;let E=null;function D(){return E===null&&(E=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),E}var y;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let k=null;function n(){if(k===null){k=new v.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<g.length;m++)k.set(g.charCodeAt(m),1);const r=".,;";for(let m=0;m<r.length;m++)k.set(r.charCodeAt(m),2)}return k}class P{static _createLink(r,m,c,p,w){let a=w-1;do{const h=m.charCodeAt(a);if(r.get(h)!==2)break;a--}while(a>p);if(p>0){const h=m.charCodeAt(p-1),f=m.charCodeAt(a);(h===40&&f===41||h===91&&f===93||h===123&&f===125)&&a--}return{range:{startLineNumber:c,startColumn:p+1,endLineNumber:c,endColumn:a+2},url:m.substring(p,a+1)}}static computeLinks(r,m=D()){const c=n();let p=[];for(let w=1,a=r.getLineCount();w<=a;w++){const h=r.getLineContent(w),f=h.length;let t=0,i=0,s=0,o=1,u=!1,_=!1,b=!1,A=!1;for(;t<f;){let C=!1;const l=h.charCodeAt(t);if(o===13){let F;switch(l){case 40:u=!0,F=0;break;case 41:F=u?0:1;break;case 91:b=!0,_=!0,F=0;break;case 93:b=!1,F=_?0:1;break;case 123:A=!0,F=0;break;case 125:F=A?0:1;break;case 39:F=s===34||s===96?0:1;break;case 34:F=s===39||s===96?0:1;break;case 96:F=s===39||s===34?0:1;break;case 42:F=s===42?1:0;break;case 124:F=s===124?1:0;break;case 32:F=b?0:1;break;default:F=c.get(l)}F===1&&(p.push(P._createLink(c,h,w,i,t)),C=!0)}else if(o===12){let F;l===91?(_=!0,F=0):F=c.get(l),F===1?C=!0:o=13}else o=m.nextState(o,l),o===0&&(C=!0);C&&(o=1,u=!1,_=!1,A=!1,i=t+1,s=l),t++}o===13&&p.push(P._createLink(c,h,w,i,f))}return p}}e.LinkComputer=P;function d(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:P.computeLinks(g)}e.computeLinks=d}),define(ve[121],be([0,1,3,6]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class S{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(E){this._onDidChange.fire({changedLanguages:E,changedColorMap:!1})}register(E,D){return this._map.set(E,D),this.fire([E]),(0,R.toDisposable)(()=>{this._map.get(E)===D&&(this._map.delete(E),this.fire([E]))})}registerPromise(E,D){let y=null,k=!1;return this._promises.set(E,D.then(n=>{this._promises.delete(E),!(k||!n)&&(y=this.register(E,n))})),(0,R.toDisposable)(()=>{k=!0,y&&y.dispose()})}getPromise(E){const D=this.get(E);if(D)return Promise.resolve(D);const y=this._promises.get(E);return y?y.then(k=>this.get(E)):null}get(E){return this._map.get(E)||null}setColorMap(E){this._colorMap=E,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=S}),define(ve[87],be([0,1,23,21]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(S||(S={}));function T(P){for(let d=0,g=P.length;d<g;d+=4){const r=P[d+0],m=P[d+1],c=P[d+2],p=P[d+3];P[d+0]=p,P[d+1]=c,P[d+2]=m,P[d+3]=r}}function E(P){const d=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return R.isLittleEndian()||T(d),v.VSBuffer.wrap(d)}function D(P){const d=P.buffer;if(R.isLittleEndian()||T(d),d.byteOffset%4==0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const g=new Uint8Array(d.byteLength);return g.set(d),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function y(P){const d=new Uint32Array(k(P));let g=0;if(d[g++]=P.id,P.type==="full")d[g++]=1,d[g++]=P.data.length,d.set(P.data,g),g+=P.data.length;else{d[g++]=2,d[g++]=P.deltas.length;for(const r of P.deltas)d[g++]=r.start,d[g++]=r.deleteCount,r.data?(d[g++]=r.data.length,d.set(r.data,g),g+=r.data.length):d[g++]=0}return E(d)}e.encodeSemanticTokensDto=y;function k(P){let d=0;if(d+=1+1,P.type==="full")d+=1+P.data.length;else{d+=1,d+=(1+1+1)*P.deltas.length;for(const g of P.deltas)g.data&&(d+=g.data.length)}return d}function n(P){const d=D(P);let g=0;const r=d[g++];if(d[g++]===1){const w=d[g++],a=d.subarray(g,g+w);return g+=w,{id:r,type:"full",data:a}}const c=d[g++];let p=[];for(let w=0;w<c;w++){const a=d[g++],h=d[g++],f=d[g++];let t;f>0&&(t=d.subarray(g,g+f),g+=f),p[w]={start:a,deleteCount:h,data:t}}return{id:r,type:"delta",deltas:p}}e.decodeSemanticTokensDto=n}),define(ve[88],be([0,1,82]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(E,D){this.index=E,this.remainder=D}}e.PrefixSumIndexOfResult=R;class S{constructor(E){this.values=E,this.prefixSum=new Uint32Array(E.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(E,D){E=(0,v.toUint32)(E);const y=this.values,k=this.prefixSum,n=D.length;return n===0?!1:(this.values=new Uint32Array(y.length+n),this.values.set(y.subarray(0,E),0),this.values.set(y.subarray(E),E+n),this.values.set(D,E),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(E,D){return E=(0,v.toUint32)(E),D=(0,v.toUint32)(D),this.values[E]===D?!1:(this.values[E]=D,E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),!0)}removeValues(E,D){E=(0,v.toUint32)(E),D=(0,v.toUint32)(D);const y=this.values,k=this.prefixSum;if(E>=y.length)return!1;let n=y.length-E;return D>=n&&(D=n),D===0?!1:(this.values=new Uint32Array(y.length-D),this.values.set(y.subarray(0,E),0),this.values.set(y.subarray(E+D),E),this.prefixSum=new Uint32Array(this.values.length),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(E){return E<0?0:(E=(0,v.toUint32)(E),this._getAccumulatedValue(E))}_getAccumulatedValue(E){if(E<=this.prefixSumValidIndex[0])return this.prefixSum[E];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),E>=this.values.length&&(E=this.values.length-1);for(let y=D;y<=E;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],E),this.prefixSum[E]}getIndexOf(E){E=Math.floor(E),this.getTotalValue();let D=0,y=this.values.length-1,k=0,n=0,P=0;for(;D<=y;)if(k=D+(y-D)/2|0,n=this.prefixSum[k],P=n-this.values[k],E<P)y=k-1;else if(E>=n)D=k+1;else break;return new R(k,E-P)}}e.PrefixSumComputer=S}),define(ve[122],be([0,1,8,38,88]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(D,y,k,n){this._uri=D,this._lines=y,this._eol=k,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const y=D.changes;for(const k of y)this._acceptDeleteRange(k.range),this._acceptInsertText(new R.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,y=this._lines.length,k=new Uint32Array(y);for(let n=0;n<y;n++)k[n]=this._lines[n].length+D;this._lineStarts=new S.PrefixSumComputer(k)}}_setLineText(D,y){this._lines[D]=y,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,y){if(y.length===0)return;let k=(0,v.splitLines)(y);if(k.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+k[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}k[k.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+k[0]);let n=new Uint32Array(k.length-1);for(let P=1;P<k.length;P++)this._lines.splice(D.lineNumber+P-1,0,k[P]),n[P-1]=k[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,n)}}e.MirrorTextModel=T}),define(ve[123],be([18,19]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ve[61],be([0,1,123,10,13]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(k,n){return n&&(k.stack||k.stacktrace)?v.localize(0,null,D(k),E(k.stack)||E(k.stacktrace)):D(k)}function E(k){return Array.isArray(k)?k.join(`
`):k}function D(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?v.localize(1,null,k.message):k.message||v.localize(2,null)}function y(k=null,n=!1){if(!k)return v.localize(3,null);if(Array.isArray(k)){const P=S.coalesce(k),d=y(P[0],n);return P.length>1?v.localize(4,null,d,P.length):d}if(R.isString(k))return k;if(k.detail){const P=k.detail;if(P.error)return T(P.error,n);if(P.exception)return T(P.exception,n)}return k.stack?T(k,n):k.message?k.message:v.localize(5,null)}e.toErrorMessage=y}),define(ve[124],be([18,19]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(ve[125],be([0,1,124,21,86]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(j){j[j.None=0]="None",j[j.Keep=1]="Keep",j[j.Brackets=2]="Brackets",j[j.Advanced=3]="Advanced",j[j.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(Z){this._values=Z}hasChanged(Z){return this._values[Z]}}e.ConfigurationChangedEvent=E;class D{constructor(){this._values=[]}_read(Z){return this._values[Z]}get(Z){return this._values[Z]}_write(Z,me){this._values[Z]=me}}e.ValidatedEditorOptions=D;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class k{constructor(Z,me,Oe,He){this.id=Z,this.name=me,this.defaultValue=Oe,this.schema=He}compute(Z,me,Oe){return Oe}}class n{constructor(Z,me=null){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0,this.deps=me}validate(Z){return this.defaultValue}}class P{constructor(Z,me,Oe,He){this.id=Z,this.name=me,this.defaultValue=Oe,this.schema=He}validate(Z){return typeof Z=="undefined"?this.defaultValue:Z}compute(Z,me,Oe){return Oe}}function d(j,Z){return typeof j=="undefined"?Z:j==="false"?!1:Boolean(j)}e.boolean=d;class g extends P{constructor(Z,me,Oe,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Oe),super(Z,me,Oe,He)}validate(Z){return d(Z,this.defaultValue)}}class r extends P{constructor(Z,me,Oe,He,$e,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="integer",Xe.default=Oe,Xe.minimum=He,Xe.maximum=$e),super(Z,me,Oe,Xe),this.minimum=He,this.maximum=$e}static clampedInt(Z,me,Oe,He){if(typeof Z=="undefined")return me;let $e=parseInt(Z,10);return isNaN($e)?me:($e=Math.max(Oe,$e),$e=Math.min(He,$e),$e|0)}validate(Z){return r.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}class m extends P{constructor(Z,me,Oe,He,$e){typeof $e!="undefined"&&($e.type="number",$e.default=Oe),super(Z,me,Oe,$e),this.validationFn=He}static clamp(Z,me,Oe){return Z<me?me:Z>Oe?Oe:Z}static float(Z,me){if(typeof Z=="number")return Z;if(typeof Z=="undefined")return me;const Oe=parseFloat(Z);return isNaN(Oe)?me:Oe}validate(Z){return this.validationFn(m.float(Z,this.defaultValue))}}class c extends P{static string(Z,me){return typeof Z!="string"?me:Z}constructor(Z,me,Oe,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Oe),super(Z,me,Oe,He)}validate(Z){return c.string(Z,this.defaultValue)}}function p(j,Z,me){return typeof j!="string"||me.indexOf(j)===-1?Z:j}e.stringSet=p;class w extends P{constructor(Z,me,Oe,He,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=He,$e.default=Oe),super(Z,me,Oe,$e),this._allowedValues=He}validate(Z){return p(Z,this.defaultValue,this._allowedValues)}}class a extends k{constructor(Z,me,Oe,He,$e,Xe,ye=void 0){typeof ye!="undefined"&&(ye.type="string",ye.enum=$e,ye.default=He),super(Z,me,Oe,ye),this._allowedValues=$e,this._convert=Xe}validate(Z){return typeof Z!="string"?this.defaultValue:this._allowedValues.indexOf(Z)===-1?this.defaultValue:this._convert(Z)}}function h(j){switch(j){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",description:v.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,me,Oe){return Oe===0?Z.accessibilitySupport:Oe}}class t extends k{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:v.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertSpace:d(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(j){j[j.Hidden=0]="Hidden",j[j.Blink=1]="Blink",j[j.Smooth=2]="Smooth",j[j.Phase=3]="Phase",j[j.Expand=4]="Expand",j[j.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(j){switch(j){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var o;(function(j){j[j.Line=1]="Line",j[j.Block=2]="Block",j[j.Underline=3]="Underline",j[j.LineThin=4]="LineThin",j[j.BlockOutline=5]="BlockOutline",j[j.UnderlineThin=6]="UnderlineThin"})(o=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function u(j){switch(j){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=u;function _(j){switch(j){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}class b extends n{constructor(){super(124,[62,31])}compute(Z,me,Oe){const He=["monaco-editor"];return me.get(31)&&He.push(me.get(31)),Z.extraEditorClassName&&He.push(Z.extraEditorClassName),me.get(62)==="default"?He.push("mouse-default"):me.get(62)==="copy"&&He.push("mouse-copy"),me.get(97)&&He.push("showUnused"),me.get(122)&&He.push("showDeprecated"),He.join(" ")}}class A extends g{constructor(){super(30,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(Z,me,Oe){return Oe&&Z.emptySelectionClipboard}}class C extends k{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:Z.seedSearchStringFromSelection,description:v.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[v.localize(9,null),v.localize(10,null),v.localize(11,null)],description:v.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:v.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:v.localize(14,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:v.localize(15,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{cursorMoveOnType:d(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:d(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":p(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(me.loop,this.defaultValue.loop)}}}class l extends k{constructor(){super(41,"fontLigatures",l.OFF,{anyOf:[{type:"boolean",description:v.localize(16,null)},{type:"string",description:v.localize(17,null)}],description:v.localize(18,null),default:!1})}validate(Z){return typeof Z=="undefined"?this.defaultValue:typeof Z=="string"?Z==="false"?l.OFF:Z==="true"?l.ON:Z:Boolean(Z)?l.ON:l.OFF}}e.EditorFontLigatures=l,l.OFF='"liga" off, "calt" off',l.ON='"liga" on, "calt" on';class F extends n{constructor(){super(40)}compute(Z,me,Oe){return Z.fontInfo}}class N extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(19,null)})}validate(Z){let me=m.float(Z,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(me,6,100)}compute(Z,me,Oe){return Z.fontInfo.fontSize}}class z extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:v.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(21,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(r.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class de extends k{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[v.localize(22,null),v.localize(23,null),v.localize(24,null)]},Oe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:v.localize(26,null)},me),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:v.localize(27,null)},me),"editor.gotoLocation.multipleDeclarations":Object.assign({description:v.localize(28,null)},me),"editor.gotoLocation.multipleImplementations":Object.assign({description:v.localize(29,null)},me),"editor.gotoLocation.multipleReferences":Object.assign({description:v.localize(30,null)},me),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Oe,description:v.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Oe,description:v.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Oe,description:v.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Oe,description:v.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Oe,description:v.localize(35,null)}})}validate(Z){var me,Oe,He,$e,Xe;if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{multiple:p(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(me=ye.multipleDefinitions)!==null&&me!==void 0?me:p(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Oe=ye.multipleTypeDefinitions)!==null&&Oe!==void 0?Oe:p(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=ye.multipleDeclarations)!==null&&He!==void 0?He:p(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:($e=ye.multipleImplementations)!==null&&$e!==void 0?$e:p(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Xe=ye.multipleReferences)!==null&&Xe!==void 0?Xe:p(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:c.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:c.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:c.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:c.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:c.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class he extends k{constructor(){const Z={enabled:!0,delay:300,sticky:!0};super(50,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:v.localize(36,null)},"editor.hover.delay":{type:"number",default:Z.delay,description:v.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:v.localize(38,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:d(me.enabled,this.defaultValue.enabled),delay:r.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:d(me.sticky,this.defaultValue.sticky)}}}var $;(function(j){j[j.None=0]="None",j[j.Text=1]="Text",j[j.Blocks=2]="Blocks"})($=e.RenderMinimap||(e.RenderMinimap={}));class q extends n{constructor(){super(127,[46,54,35,61,89,56,57,91,114,117,118,119,2])}compute(Z,me,Oe){return q.computeLayout(me,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio})}static computeContainedMinimapLineCount(Z){const me=Z.height/Z.lineHeight,Oe=Z.scrollBeyondLastLine?me-1:0,He=(Z.viewLineCount+Oe)/(Z.pixelRatio*Z.height),$e=Math.floor(Z.viewLineCount/He);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Oe,desiredRatio:He,minimapLineCount:$e}}static _computeMinimapLayout(Z,me){const Oe=Z.outerWidth,He=Z.outerHeight,$e=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Xe=me.stableMinimapLayoutInput,ye=Xe&&Z.outerHeight===Xe.outerHeight&&Z.lineHeight===Xe.lineHeight&&Z.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&Z.pixelRatio===Xe.pixelRatio&&Z.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&Z.minimap.enabled===Xe.minimap.enabled&&Z.minimap.side===Xe.minimap.side&&Z.minimap.size===Xe.minimap.size&&Z.minimap.showSlider===Xe.minimap.showSlider&&Z.minimap.renderCharacters===Xe.minimap.renderCharacters&&Z.minimap.maxColumn===Xe.minimap.maxColumn&&Z.minimap.scale===Xe.minimap.scale&&Z.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&Z.isViewportWrapping===Xe.isViewportWrapping,Se=Z.lineHeight,Ce=Z.typicalHalfwidthCharacterWidth,ne=Z.scrollBeyondLastLine,le=Z.minimap.renderCharacters;let O=$e>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Y=Z.minimap.maxColumn,oe=Z.minimap.size,ke=Z.minimap.side,Ie=Z.verticalScrollbarWidth,Le=Z.viewLineCount,Ue=Z.remainingWidth,Qe=Z.isViewportWrapping,rt=le?2:3;let et=Math.floor($e*He);const Ye=et/$e;let ot=!1,_t=!1,wt=rt*O,vt=O/$e,ie=1;if(oe==="fill"||oe==="fit"){const{typicalViewportLineCount:it,extraLinesBeyondLastLine:ut,desiredRatio:gt,minimapLineCount:Je}=q.computeContainedMinimapLineCount({viewLineCount:Le,scrollBeyondLastLine:ne,height:He,lineHeight:Se,pixelRatio:$e});if(Le/Je>1)ot=!0,_t=!0,O=1,wt=1,vt=O/$e;else{let at=!1,lt=O+1;if(oe==="fit"){const Pt=Math.ceil((Le+ut)*wt);Qe&&ye&&Ue<=me.stableFitRemainingWidth?(at=!0,lt=me.stableFitMaxMinimapScale):(at=Pt>et,Qe&&at?(me.stableMinimapLayoutInput=Z,me.stableFitRemainingWidth=Ue):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0))}if(oe==="fill"||at){ot=!0;const Pt=O;wt=Math.min(Se*$e,Math.max(1,Math.floor(1/gt))),O=Math.min(lt,Math.max(1,Math.floor(wt/rt))),O>Pt&&(ie=Math.min(2,O/Pt)),vt=O/$e/ie,et=Math.ceil(Math.max(it,Le+ut)*wt),Qe&&at&&(me.stableFitMaxMinimapScale=O)}}}const Ee=Math.floor(Y*vt),ae=Math.min(Ee,Math.max(0,Math.floor((Ue-Ie-2)*vt/(Ce+vt)))+e.MINIMAP_GUTTER_WIDTH);let V=Math.floor($e*ae);const Me=V/$e;V=Math.floor(V*ie);const Te=le?1:2,Ze=ke==="left"?0:Oe-ae-Ie;return{renderMinimap:Te,minimapLeft:Ze,minimapWidth:ae,minimapHeightIsEditorHeight:ot,minimapIsSampling:_t,minimapScale:O,minimapLineHeight:wt,minimapCanvasInnerWidth:V,minimapCanvasInnerHeight:et,minimapCanvasOuterWidth:Me,minimapCanvasOuterHeight:Ye}}static computeLayout(Z,me){const Oe=me.outerWidth|0,He=me.outerHeight|0,$e=me.lineHeight|0,Xe=me.lineNumbersDigitCount|0,ye=me.typicalHalfwidthCharacterWidth,Se=me.maxDigitWidth,Ce=me.pixelRatio,ne=me.viewLineCount,le=Z.get(119),O=le==="inherit"?Z.get(118):le,Y=O==="inherit"?Z.get(114):O,oe=Z.get(117),ke=Z.get(2),Ie=me.isDominatedByLongLines,Le=Z.get(46),Ue=Z.get(56).renderType!==0,Qe=Z.get(57),rt=Z.get(91),et=Z.get(61),Ye=Z.get(89),ot=Ye.verticalScrollbarSize,_t=Ye.verticalHasArrows,wt=Ye.arrowSize,vt=Ye.horizontalScrollbarSize,ie=Z.get(54),Ee=Z.get(35);let ae;if(typeof ie=="string"&&/^\d+(\.\d+)?ch$/.test(ie)){const Rt=parseFloat(ie.substr(0,ie.length-2));ae=r.clampedInt(Rt*ye,0,0,1e3)}else ae=r.clampedInt(ie,0,0,1e3);Ee&&(ae+=16);let V=0;if(Ue){const Rt=Math.max(Xe,Qe);V=Math.round(Rt*Se)}let Me=0;Le&&(Me=$e);let Te=0,Ze=Te+Me,it=Ze+V,ut=it+ae;const gt=Oe-Me-V-ae;let Je=!1,dt=!1,at=-1;ke!==2&&(O==="inherit"&&Ie?(Je=!0,dt=!0):Y==="on"||Y==="bounded"?dt=!0:Y==="wordWrapColumn"&&(at=oe));const lt=q._computeMinimapLayout({outerWidth:Oe,outerHeight:He,lineHeight:$e,typicalHalfwidthCharacterWidth:ye,pixelRatio:Ce,scrollBeyondLastLine:rt,minimap:et,verticalScrollbarWidth:ot,viewLineCount:ne,remainingWidth:gt,isViewportWrapping:dt},me.memory||new y);lt.renderMinimap!==0&&lt.minimapLeft===0&&(Te+=lt.minimapWidth,Ze+=lt.minimapWidth,it+=lt.minimapWidth,ut+=lt.minimapWidth);const Pt=gt-lt.minimapWidth,Ct=Math.max(1,Math.floor((Pt-ot-2)/ye)),At=_t?wt:0;return dt&&(at=Math.max(1,Ct),Y==="bounded"&&(at=Math.min(at,oe))),{width:Oe,height:He,glyphMarginLeft:Te,glyphMarginWidth:Me,lineNumbersLeft:Ze,lineNumbersWidth:V,decorationsLeft:it,decorationsWidth:ae,contentLeft:ut,contentWidth:Pt,minimap:lt,viewportColumn:Ct,isWordWrapMinified:Je,isViewportWrapping:dt,wrappingColumn:at,verticalScrollbarWidth:ot,horizontalScrollbarHeight:vt,overviewRuler:{top:At,width:ot,height:He-2*At,right:0}}}}e.EditorLayoutInfoComputer=q;class x extends k{constructor(){const Z={enabled:!0};super(53,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:v.localize(39,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:d(Z.enabled,this.defaultValue.enabled)}}}class I extends k{constructor(){const Z={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(123,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"boolean",default:Z.enabled,description:v.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,description:v.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,description:v.localize(42,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:d(me.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:c.string(me.fontFamily,this.defaultValue.fontFamily)}}}class H extends r{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:v.localize(43,null)})}compute(Z,me,Oe){return Z.fontInfo.lineHeight}}class M extends k{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:v.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(45,null),v.localize(46,null),v.localize(47,null)],default:Z.size,description:v.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:v.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:v.localize(50,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:v.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:v.localize(53,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:d(me.enabled,this.defaultValue.enabled),size:p(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(me.side,this.defaultValue.side,["right","left"]),showSlider:p(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(me.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(me.scale,1,1,3),maxColumn:r.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function B(j){return j==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class G extends k{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(55,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{top:r.clampedInt(me.top,0,0,1e3),bottom:r.clampedInt(me.bottom,0,0,1e3)}}}class K extends k{constructor(){const Z={enabled:!0,cycle:!1};super(72,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:v.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:v.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:d(me.enabled,this.defaultValue.enabled),cycle:d(me.cycle,this.defaultValue.cycle)}}}class se extends n{constructor(){super(125)}compute(Z,me,Oe){return Z.pixelRatio}}class pe extends k{constructor(){const Z={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",Z,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Z.strings,description:v.localize(58,null)},comments:{type:"boolean",default:Z.comments,description:v.localize(59,null)},other:{type:"boolean",default:Z.other,description:v.localize(60,null)}}}],default:Z,description:v.localize(61,null)});this.defaultValue=Z}validate(Z){if(typeof Z=="boolean")return Z;if(Z&&typeof Z=="object"){const me=Z,Oe={other:d(me.other,this.defaultValue.other),comments:d(me.comments,this.defaultValue.comments),strings:d(me.strings,this.defaultValue.strings)};return Oe.other&&Oe.comments&&Oe.strings?!0:!Oe.other&&!Oe.comments&&!Oe.strings?!1:Oe}return this.defaultValue}}var Fe;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval",j[j.Custom=4]="Custom"})(Fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class We extends k{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(62,null),v.localize(63,null),v.localize(64,null),v.localize(65,null)],default:"on",description:v.localize(66,null)})}validate(Z){let me=this.defaultValue.renderType,Oe=this.defaultValue.renderFn;return typeof Z!="undefined"&&(typeof Z=="function"?(me=4,Oe=Z):Z==="interval"?me=3:Z==="relative"?me=2:Z==="on"?me=1:me=0),{renderType:me,renderFn:Oe}}}function Ne(j){const Z=j.get(84);return Z==="editable"?j.get(77):Z!=="on"}e.filterValidationDecorations=Ne;class ze extends k{constructor(){const Z=[],me={type:"number",description:v.localize(67,null)};super(88,"rulers",Z,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:v.localize(68,null),format:"color-hex"}}}]},default:Z,description:v.localize(69,null)})}validate(Z){if(Array.isArray(Z)){let me=[];for(let Oe of Z)if(typeof Oe=="number")me.push({column:r.clampedInt(Oe,0,0,1e4),color:null});else if(Oe&&typeof Oe=="object"){const He=Oe;me.push({column:r.clampedInt(He.column,0,0,1e4),color:He.color})}return me.sort((Oe,He)=>Oe.column-He.column),me}return this.defaultValue}}function Ve(j,Z){if(typeof j!="string")return Z;switch(j){case"hidden":return 2;case"visible":return 3;default:return 1}}class W extends k{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z,Oe=r.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=r.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ve(me.vertical,this.defaultValue.vertical),horizontal:Ve(me.horizontal,this.defaultValue.horizontal),useShadows:d(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Oe,horizontalSliderSize:r.clampedInt(me.horizontalSliderSize,Oe,0,1e3),verticalScrollbarSize:He,verticalSliderSize:r.clampedInt(me.verticalSliderSize,He,0,1e3),scrollByPage:d(me.scrollByPage,this.defaultValue.scrollByPage)}}}class Q extends k{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showSuggestionPreview:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(70,null),v.localize(71,null)],default:Z.insertMode,description:v.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:v.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:v.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:v.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:v.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:v.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:v.localize(78,null)},"editor.suggest.showSuggestionPreview":{type:"boolean",default:Z.showSuggestionPreview,description:v.localize(79,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:v.localize(80,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(81,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(82,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(83,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(84,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(85,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:v.localize(86,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(87,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(88,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(89,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(90,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(91,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(92,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(93,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(94,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(95,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(96,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(97,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(98,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(99,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(100,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(101,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(102,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(103,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(104,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(105,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(106,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(107,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(108,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(109,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(110,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(111,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertMode:p(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(me.showIcons,this.defaultValue.showIcons),showStatusBar:d(me.showStatusBar,this.defaultValue.showStatusBar),showSuggestionPreview:d(me.showSuggestionPreview,this.defaultValue.showSuggestionPreview),showInlineDetails:d(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(me.showMethods,this.defaultValue.showMethods),showFunctions:d(me.showFunctions,this.defaultValue.showFunctions),showConstructors:d(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(me.showDeprecated,this.defaultValue.showDeprecated),showFields:d(me.showFields,this.defaultValue.showFields),showVariables:d(me.showVariables,this.defaultValue.showVariables),showClasses:d(me.showClasses,this.defaultValue.showClasses),showStructs:d(me.showStructs,this.defaultValue.showStructs),showInterfaces:d(me.showInterfaces,this.defaultValue.showInterfaces),showModules:d(me.showModules,this.defaultValue.showModules),showProperties:d(me.showProperties,this.defaultValue.showProperties),showEvents:d(me.showEvents,this.defaultValue.showEvents),showOperators:d(me.showOperators,this.defaultValue.showOperators),showUnits:d(me.showUnits,this.defaultValue.showUnits),showValues:d(me.showValues,this.defaultValue.showValues),showConstants:d(me.showConstants,this.defaultValue.showConstants),showEnums:d(me.showEnums,this.defaultValue.showEnums),showEnumMembers:d(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(me.showKeywords,this.defaultValue.showKeywords),showWords:d(me.showWords,this.defaultValue.showWords),showColors:d(me.showColors,this.defaultValue.showColors),showFiles:d(me.showFiles,this.defaultValue.showFiles),showReferences:d(me.showReferences,this.defaultValue.showReferences),showFolders:d(me.showFolders,this.defaultValue.showFolders),showTypeParameters:d(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(me.showSnippets,this.defaultValue.showSnippets),showUsers:d(me.showUsers,this.defaultValue.showUsers),showIssues:d(me.showIssues,this.defaultValue.showIssues)}}}class te extends k{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(112,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class re extends n{constructor(){super(126,[77])}compute(Z,me,Oe){return me.get(77)?!0:Z.tabFocusMode}}var fe;(function(j){j[j.None=0]="None",j[j.Same=1]="Same",j[j.Indent=2]="Indent",j[j.DeepIndent=3]="DeepIndent"})(fe=e.WrappingIndent||(e.WrappingIndent={}));function _e(j){switch(j){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ue extends n{constructor(){super(128,[127])}compute(Z,me,Oe){const He=me.get(127);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const we="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",xe="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Ae:R.isLinux?xe:we,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function ge(j){return e.editorOptionsRegistry[j.id]=j,j}var Ke;(function(j){j[j.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",j[j.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",j[j.accessibilitySupport=2]="accessibilitySupport",j[j.accessibilityPageSize=3]="accessibilityPageSize",j[j.ariaLabel=4]="ariaLabel",j[j.autoClosingBrackets=5]="autoClosingBrackets",j[j.autoClosingDelete=6]="autoClosingDelete",j[j.autoClosingOvertype=7]="autoClosingOvertype",j[j.autoClosingQuotes=8]="autoClosingQuotes",j[j.autoIndent=9]="autoIndent",j[j.automaticLayout=10]="automaticLayout",j[j.autoSurround=11]="autoSurround",j[j.codeLens=12]="codeLens",j[j.codeLensFontFamily=13]="codeLensFontFamily",j[j.codeLensFontSize=14]="codeLensFontSize",j[j.colorDecorators=15]="colorDecorators",j[j.columnSelection=16]="columnSelection",j[j.comments=17]="comments",j[j.contextmenu=18]="contextmenu",j[j.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",j[j.cursorBlinking=20]="cursorBlinking",j[j.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",j[j.cursorStyle=22]="cursorStyle",j[j.cursorSurroundingLines=23]="cursorSurroundingLines",j[j.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",j[j.cursorWidth=25]="cursorWidth",j[j.disableLayerHinting=26]="disableLayerHinting",j[j.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",j[j.domReadOnly=28]="domReadOnly",j[j.dragAndDrop=29]="dragAndDrop",j[j.emptySelectionClipboard=30]="emptySelectionClipboard",j[j.extraEditorClassName=31]="extraEditorClassName",j[j.fastScrollSensitivity=32]="fastScrollSensitivity",j[j.find=33]="find",j[j.fixedOverflowWidgets=34]="fixedOverflowWidgets",j[j.folding=35]="folding",j[j.foldingStrategy=36]="foldingStrategy",j[j.foldingHighlight=37]="foldingHighlight",j[j.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",j[j.fontFamily=39]="fontFamily",j[j.fontInfo=40]="fontInfo",j[j.fontLigatures=41]="fontLigatures",j[j.fontSize=42]="fontSize",j[j.fontWeight=43]="fontWeight",j[j.formatOnPaste=44]="formatOnPaste",j[j.formatOnType=45]="formatOnType",j[j.glyphMargin=46]="glyphMargin",j[j.gotoLocation=47]="gotoLocation",j[j.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",j[j.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",j[j.hover=50]="hover",j[j.inDiffEditor=51]="inDiffEditor",j[j.letterSpacing=52]="letterSpacing",j[j.lightbulb=53]="lightbulb",j[j.lineDecorationsWidth=54]="lineDecorationsWidth",j[j.lineHeight=55]="lineHeight",j[j.lineNumbers=56]="lineNumbers",j[j.lineNumbersMinChars=57]="lineNumbersMinChars",j[j.linkedEditing=58]="linkedEditing",j[j.links=59]="links",j[j.matchBrackets=60]="matchBrackets",j[j.minimap=61]="minimap",j[j.mouseStyle=62]="mouseStyle",j[j.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",j[j.mouseWheelZoom=64]="mouseWheelZoom",j[j.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",j[j.multiCursorModifier=66]="multiCursorModifier",j[j.multiCursorPaste=67]="multiCursorPaste",j[j.occurrencesHighlight=68]="occurrencesHighlight",j[j.overviewRulerBorder=69]="overviewRulerBorder",j[j.overviewRulerLanes=70]="overviewRulerLanes",j[j.padding=71]="padding",j[j.parameterHints=72]="parameterHints",j[j.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",j[j.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",j[j.quickSuggestions=75]="quickSuggestions",j[j.quickSuggestionsDelay=76]="quickSuggestionsDelay",j[j.readOnly=77]="readOnly",j[j.renameOnType=78]="renameOnType",j[j.renderControlCharacters=79]="renderControlCharacters",j[j.renderIndentGuides=80]="renderIndentGuides",j[j.renderFinalNewline=81]="renderFinalNewline",j[j.renderLineHighlight=82]="renderLineHighlight",j[j.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",j[j.renderValidationDecorations=84]="renderValidationDecorations",j[j.renderWhitespace=85]="renderWhitespace",j[j.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",j[j.roundedSelection=87]="roundedSelection",j[j.rulers=88]="rulers",j[j.scrollbar=89]="scrollbar",j[j.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",j[j.scrollBeyondLastLine=91]="scrollBeyondLastLine",j[j.scrollPredominantAxis=92]="scrollPredominantAxis",j[j.selectionClipboard=93]="selectionClipboard",j[j.selectionHighlight=94]="selectionHighlight",j[j.selectOnLineNumbers=95]="selectOnLineNumbers",j[j.showFoldingControls=96]="showFoldingControls",j[j.showUnused=97]="showUnused",j[j.snippetSuggestions=98]="snippetSuggestions",j[j.smartSelect=99]="smartSelect",j[j.smoothScrolling=100]="smoothScrolling",j[j.stickyTabStops=101]="stickyTabStops",j[j.stopRenderingLineAfter=102]="stopRenderingLineAfter",j[j.suggest=103]="suggest",j[j.suggestFontSize=104]="suggestFontSize",j[j.suggestLineHeight=105]="suggestLineHeight",j[j.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",j[j.suggestSelection=107]="suggestSelection",j[j.tabCompletion=108]="tabCompletion",j[j.tabIndex=109]="tabIndex",j[j.unusualLineTerminators=110]="unusualLineTerminators",j[j.useShadowDOM=111]="useShadowDOM",j[j.useTabStops=112]="useTabStops",j[j.wordSeparators=113]="wordSeparators",j[j.wordWrap=114]="wordWrap",j[j.wordWrapBreakAfterCharacters=115]="wordWrapBreakAfterCharacters",j[j.wordWrapBreakBeforeCharacters=116]="wordWrapBreakBeforeCharacters",j[j.wordWrapColumn=117]="wordWrapColumn",j[j.wordWrapOverride1=118]="wordWrapOverride1",j[j.wordWrapOverride2=119]="wordWrapOverride2",j[j.wrappingIndent=120]="wrappingIndent",j[j.wrappingStrategy=121]="wrappingStrategy",j[j.showDeprecated=122]="showDeprecated",j[j.inlayHints=123]="inlayHints",j[j.editorClassName=124]="editorClassName",j[j.pixelRatio=125]="pixelRatio",j[j.tabFocusMode=126]="tabFocusMode",j[j.layoutInfo=127]="layoutInfo",j[j.wrappingInfo=128]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ge(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(113,null)})),acceptSuggestionOnEnter:ge(new w(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(114,null),""],markdownDescription:v.localize(115,null)})),accessibilitySupport:ge(new f),accessibilityPageSize:ge(new r(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(116,null)})),ariaLabel:ge(new c(4,"ariaLabel",v.localize(117,null))),autoClosingBrackets:ge(new w(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(118,null),v.localize(119,null),""],description:v.localize(120,null)})),autoClosingDelete:ge(new w(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(121,null),""],description:v.localize(122,null)})),autoClosingOvertype:ge(new w(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(123,null),""],description:v.localize(124,null)})),autoClosingQuotes:ge(new w(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(125,null),v.localize(126,null),""],description:v.localize(127,null)})),autoIndent:ge(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[v.localize(128,null),v.localize(129,null),v.localize(130,null),v.localize(131,null),v.localize(132,null)],description:v.localize(133,null)})),automaticLayout:ge(new g(10,"automaticLayout",!1)),autoSurround:ge(new w(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(134,null),v.localize(135,null),v.localize(136,null),""],description:v.localize(137,null)})),stickyTabStops:ge(new g(101,"stickyTabStops",!1,{description:v.localize(138,null)})),codeLens:ge(new g(12,"codeLens",!0,{description:v.localize(139,null)})),codeLensFontFamily:ge(new c(13,"codeLensFontFamily","",{description:v.localize(140,null)})),codeLensFontSize:ge(new r(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:v.localize(141,null)})),colorDecorators:ge(new g(15,"colorDecorators",!0,{description:v.localize(142,null)})),columnSelection:ge(new g(16,"columnSelection",!1,{description:v.localize(143,null)})),comments:ge(new t),contextmenu:ge(new g(18,"contextmenu",!0)),copyWithSyntaxHighlighting:ge(new g(19,"copyWithSyntaxHighlighting",!0,{description:v.localize(144,null)})),cursorBlinking:ge(new a(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:v.localize(145,null)})),cursorSmoothCaretAnimation:ge(new g(21,"cursorSmoothCaretAnimation",!1,{description:v.localize(146,null)})),cursorStyle:ge(new a(22,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],_,{description:v.localize(147,null)})),cursorSurroundingLines:ge(new r(23,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(148,null)})),cursorSurroundingLinesStyle:ge(new w(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(149,null),v.localize(150,null)],description:v.localize(151,null)})),cursorWidth:ge(new r(25,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(152,null)})),disableLayerHinting:ge(new g(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:ge(new g(27,"disableMonospaceOptimizations",!1)),domReadOnly:ge(new g(28,"domReadOnly",!1)),dragAndDrop:ge(new g(29,"dragAndDrop",!0,{description:v.localize(153,null)})),emptySelectionClipboard:ge(new A),extraEditorClassName:ge(new c(31,"extraEditorClassName","")),fastScrollSensitivity:ge(new m(32,"fastScrollSensitivity",5,j=>j<=0?5:j,{markdownDescription:v.localize(154,null)})),find:ge(new C),fixedOverflowWidgets:ge(new g(34,"fixedOverflowWidgets",!1)),folding:ge(new g(35,"folding",!0,{description:v.localize(155,null)})),foldingStrategy:ge(new w(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(156,null),v.localize(157,null)],description:v.localize(158,null)})),foldingHighlight:ge(new g(37,"foldingHighlight",!0,{description:v.localize(159,null)})),unfoldOnClickAfterEndOfLine:ge(new g(38,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(160,null)})),fontFamily:ge(new c(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(161,null)})),fontInfo:ge(new F),fontLigatures2:ge(new l),fontSize:ge(new N),fontWeight:ge(new z),formatOnPaste:ge(new g(44,"formatOnPaste",!1,{description:v.localize(162,null)})),formatOnType:ge(new g(45,"formatOnType",!1,{description:v.localize(163,null)})),glyphMargin:ge(new g(46,"glyphMargin",!0,{description:v.localize(164,null)})),gotoLocation:ge(new de),hideCursorInOverviewRuler:ge(new g(48,"hideCursorInOverviewRuler",!1,{description:v.localize(165,null)})),highlightActiveIndentGuide:ge(new g(49,"highlightActiveIndentGuide",!0,{description:v.localize(166,null)})),hover:ge(new he),inDiffEditor:ge(new g(51,"inDiffEditor",!1)),letterSpacing:ge(new m(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,j=>m.clamp(j,-5,20),{description:v.localize(167,null)})),lightbulb:ge(new x),lineDecorationsWidth:ge(new P(54,"lineDecorationsWidth",10)),lineHeight:ge(new H),lineNumbers:ge(new We),lineNumbersMinChars:ge(new r(57,"lineNumbersMinChars",5,1,300)),linkedEditing:ge(new g(58,"linkedEditing",!1,{description:v.localize(168,null)})),links:ge(new g(59,"links",!0,{description:v.localize(169,null)})),matchBrackets:ge(new w(60,"matchBrackets","always",["always","near","never"],{description:v.localize(170,null)})),minimap:ge(new M),mouseStyle:ge(new w(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ge(new m(63,"mouseWheelScrollSensitivity",1,j=>j===0?1:j,{markdownDescription:v.localize(171,null)})),mouseWheelZoom:ge(new g(64,"mouseWheelZoom",!1,{markdownDescription:v.localize(172,null)})),multiCursorMergeOverlapping:ge(new g(65,"multiCursorMergeOverlapping",!0,{description:v.localize(173,null)})),multiCursorModifier:ge(new a(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],B,{markdownEnumDescriptions:[v.localize(174,null),v.localize(175,null)],markdownDescription:v.localize(176,null)})),multiCursorPaste:ge(new w(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(177,null),v.localize(178,null)],markdownDescription:v.localize(179,null)})),occurrencesHighlight:ge(new g(68,"occurrencesHighlight",!0,{description:v.localize(180,null)})),overviewRulerBorder:ge(new g(69,"overviewRulerBorder",!0,{description:v.localize(181,null)})),overviewRulerLanes:ge(new r(70,"overviewRulerLanes",3,0,3)),padding:ge(new G),parameterHints:ge(new K),peekWidgetDefaultFocus:ge(new w(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(182,null),v.localize(183,null)],description:v.localize(184,null)})),definitionLinkOpensInPeek:ge(new g(74,"definitionLinkOpensInPeek",!1,{description:v.localize(185,null)})),quickSuggestions:ge(new pe),quickSuggestionsDelay:ge(new r(76,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(186,null)})),readOnly:ge(new g(77,"readOnly",!1)),renameOnType:ge(new g(78,"renameOnType",!1,{description:v.localize(187,null),markdownDeprecationMessage:v.localize(188,null)})),renderControlCharacters:ge(new g(79,"renderControlCharacters",!1,{description:v.localize(189,null)})),renderIndentGuides:ge(new g(80,"renderIndentGuides",!0,{description:v.localize(190,null)})),renderFinalNewline:ge(new g(81,"renderFinalNewline",!0,{description:v.localize(191,null)})),renderLineHighlight:ge(new w(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(192,null)],description:v.localize(193,null)})),renderLineHighlightOnlyWhenFocus:ge(new g(83,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(194,null)})),renderValidationDecorations:ge(new w(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ge(new w(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(195,null),v.localize(196,null),v.localize(197,null),""],description:v.localize(198,null)})),revealHorizontalRightPadding:ge(new r(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ge(new g(87,"roundedSelection",!0,{description:v.localize(199,null)})),rulers:ge(new ze),scrollbar:ge(new W),scrollBeyondLastColumn:ge(new r(90,"scrollBeyondLastColumn",5,0,1073741824,{description:v.localize(200,null)})),scrollBeyondLastLine:ge(new g(91,"scrollBeyondLastLine",!0,{description:v.localize(201,null)})),scrollPredominantAxis:ge(new g(92,"scrollPredominantAxis",!0,{description:v.localize(202,null)})),selectionClipboard:ge(new g(93,"selectionClipboard",!0,{description:v.localize(203,null),included:R.isLinux})),selectionHighlight:ge(new g(94,"selectionHighlight",!0,{description:v.localize(204,null)})),selectOnLineNumbers:ge(new g(95,"selectOnLineNumbers",!0)),showFoldingControls:ge(new w(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[v.localize(205,null),v.localize(206,null)],description:v.localize(207,null)})),showUnused:ge(new g(97,"showUnused",!0,{description:v.localize(208,null)})),showDeprecated:ge(new g(122,"showDeprecated",!0,{description:v.localize(209,null)})),inlayHints:ge(new I),snippetSuggestions:ge(new w(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(210,null),v.localize(211,null),v.localize(212,null),v.localize(213,null)],description:v.localize(214,null)})),smartSelect:ge(new te),smoothScrolling:ge(new g(100,"smoothScrolling",!1,{description:v.localize(215,null)})),stopRenderingLineAfter:ge(new r(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ge(new Q),suggestFontSize:ge(new r(104,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(216,null)})),suggestLineHeight:ge(new r(105,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(217,null)})),suggestOnTriggerCharacters:ge(new g(106,"suggestOnTriggerCharacters",!0,{description:v.localize(218,null)})),suggestSelection:ge(new w(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(219,null),v.localize(220,null),v.localize(221,null)],description:v.localize(222,null)})),tabCompletion:ge(new w(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(223,null),v.localize(224,null),v.localize(225,null)],description:v.localize(226,null)})),tabIndex:ge(new r(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ge(new w(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(227,null),v.localize(228,null),v.localize(229,null)],description:v.localize(230,null)})),useShadowDOM:ge(new g(111,"useShadowDOM",!0)),useTabStops:ge(new g(112,"useTabStops",!0,{description:v.localize(231,null)})),wordSeparators:ge(new c(113,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:v.localize(232,null)})),wordWrap:ge(new w(114,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(233,null),v.localize(234,null),v.localize(235,null),v.localize(236,null)],description:v.localize(237,null)})),wordWrapBreakAfterCharacters:ge(new c(115,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ge(new c(116,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ge(new r(117,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(238,null)})),wordWrapOverride1:ge(new w(118,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ge(new w(119,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ge(new a(120,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],_e,{enumDescriptions:[v.localize(239,null),v.localize(240,null),v.localize(241,null),v.localize(242,null)],description:v.localize(243,null)})),wrappingStrategy:ge(new w(121,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[v.localize(244,null),v.localize(245,null)],description:v.localize(246,null)})),editorClassName:ge(new b),pixelRatio:ge(new se),tabFocusMode:ge(new re),layoutInfo:ge(new q),wrappingInfo:ge(new ue)}}),define(ve[126],be([18,19]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[127],be([18,19]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[128],be([18,19]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ve[129],be([18,19]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(ve[130],be([18,19]),function(J,e){return J.create("vs/platform/theme/common/iconRegistry",e)}),define(ve[131],be([18,19]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[132],be([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[133],be([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[134],be([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[135],be([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[136],be([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[137],be([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[138],be([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[139],be([18,19]),function(J,e){return J.create("vs/workbench/common/views",e)}),define(ve[140],be([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[141],be([18,19]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ve[142],be([18,19]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[143],be([18,19]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[144],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var v;(function(E){E[E.ACTIVATE=0]="ACTIVATE",E[E.RESTORE=1]="RESTORE",E[E.PRESERVE=2]="PRESERVE"})(v=e.EditorActivation||(e.EditorActivation={}));var R;(function(E){E[E.PICK=1]="PICK",E[E.DISABLED=2]="DISABLED"})(R=e.EditorOverride||(e.EditorOverride={}));var S;(function(E){E[E.API=0]="API",E[E.USER=1]="USER"})(S=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(E){E[E.Center=0]="Center",E[E.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",E[E.NearTop=2]="NearTop",E[E.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[145],be([0,1,127]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function T(d){return d=d.trim(),d==="*"||R.test(d)}e.isValidVersionStr=T;function E(d){if(!T(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=d.match(R);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=E;function D(d){if(!d)return null;let g=d.majorBase,r=d.majorMustEqual,m=d.minorBase,c=d.minorMustEqual,p=d.patchBase,w=d.patchMustEqual;d.hasCaret&&(g===0||(c=!1),w=!1);let a=0;if(d.preRelease){const h=S.exec(d.preRelease);if(h){const[,f,t,i]=h;a=Date.UTC(Number(f),Number(t)-1,Number(i))}}return{majorBase:g,majorMustEqual:r,minorBase:m,minorMustEqual:c,patchBase:p,patchMustEqual:w,isMinimum:d.hasGreaterEquals,notBefore:a}}e.normalizeVersion=D;function y(d,g,r){let m;typeof d=="string"?m=D(E(d)):m=d;let c;g instanceof Date?c=g.getTime():typeof g=="string"&&(c=new Date(g).getTime());let p;if(typeof r=="string"?p=D(E(r)):p=r,!m||!p)return!1;let w=m.majorBase,a=m.minorBase,h=m.patchBase,f=p.majorBase,t=p.minorBase,i=p.patchBase,s=p.notBefore,o=p.majorMustEqual,u=p.minorMustEqual,_=p.patchMustEqual;return p.isMinimum?w>f?!0:w<f?!1:a>t?!0:a<t||c&&c<s?!1:h>=i:(w===1&&f===0&&(!o||!u||!_)&&(f=1,t=0,i=0,o=!0,u=!1,_=!1),w<f?!1:w>f?!o:a<t?!1:a>t?!u:h<i?!1:h>i?!_:!(c&&c<s))}e.isValidVersion=y;function k(d,g,r,m){return r.isBuiltin||typeof r.main=="undefined"?!0:P(d,g,r.engines.vscode,m)}e.isValidExtensionVersion=k;function n(d,g,r){return d==="*"||P(g,r,d)}e.isEngineValid=n;function P(d,g,r,m=[]){let c=D(E(r));if(!c)return m.push(v.localize(0,null,r)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return m.push(v.localize(1,null,r)),!1}else if(!c.majorMustEqual)return m.push(v.localize(2,null,r)),!1;return y(d,g,c)?!0:(m.push(v.localize(3,null,d,r)),!1)}}),define(ve[89],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(T,E=[],D=!1){this.ctor=T,this.staticArguments=E,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=v;const R=(S,...T)=>new v(S,T);e.createSyncDescriptor=R}),define(ve[62],be([0,1,89]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function S(E,D,y){D instanceof v.SyncDescriptor||(D=new v.SyncDescriptor(D,[],y)),R.push([E,D])}e.registerSingleton=S;function T(){return R}e.getSingletonServiceDescriptors=T}),define(ve[146],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=v;class R{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let E of this._nodes.values())E.outgoing.size===0&&T.push(E);return T}insertEdge(T,E){const D=this.lookupOrInsertNode(T),y=this.lookupOrInsertNode(E);D.outgoing.set(this._hashFn(E),y),y.incoming.set(this._hashFn(T),D)}removeNode(T){const E=this._hashFn(T);this._nodes.delete(E);for(let D of this._nodes.values())D.outgoing.delete(E),D.incoming.delete(E)}lookupOrInsertNode(T){const E=this._hashFn(T);let D=this._nodes.get(E);return D||(D=new v(T),this._nodes.set(E,D)),D}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[E,D]of this._nodes)T.push(`${E}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,E]of this._nodes){const D=new Set([T]),y=this._findCycle(E,D);if(y)return y}}_findCycle(T,E){for(let[D,y]of T.outgoing){if(E.has(D))return[...E,D].join(" -> ");E.add(D);const k=this._findCycle(y,E);if(k)return k;E.delete(D)}}}e.Graph=R}),define(ve[4],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function y(k){return k[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=y})(v=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function R(D,y,k,n){y[v.DI_TARGET]===y?y[v.DI_DEPENDENCIES].push({id:D,index:k,optional:n}):(y[v.DI_DEPENDENCIES]=[{id:D,index:k,optional:n}],y[v.DI_TARGET]=y)}function S(D){if(v.serviceIds.has(D))return v.serviceIds.get(D);const y=function(k,n,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(y,k,P,!1)};return y.toString=()=>D,v.serviceIds.set(D,y),y}e.createDecorator=S;function T(D){return D}e.refineServiceDecorator=T;function E(D){return function(y,k,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(D,y,n,!0)}}e.optional=E}),define(ve[147],be([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,v.createDecorator)("modelService");function R(S){return!S.isTooLargeForSyncing()&&!S.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(ve[148],be([0,1,3,57,6,22,81,60,147]),function(J,e,v,R,S,T,E,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(k):!!d.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new v.Emitter}get onDidChange(){return this._onDidChange.event}register(g,r){let m={selector:g,provider:r,_score:-1,_time:this._clock++};return this._entries.push(m),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,S.toDisposable)(()=>{if(m){let c=this._entries.indexOf(m);c>=0&&(this._entries.splice(c,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),m=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const r=[];for(let m of this._entries)m._score>0&&r.push(m.provider);return r}ordered(g){const r=[];return this._orderedForEach(g,m=>r.push(m.provider)),r}orderedGroups(g){const r=[];let m,c;return this._orderedForEach(g,p=>{m&&c===p._score?m.push(p.provider):(c=p._score,m=[p.provider],r.push(m))}),r}_orderedForEach(g,r){if(!!g){this._updateScores(g);for(const m of this._entries)m._score>0&&r(m)}}_updateScores(g){let r={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let m of this._entries)if(m._score=(0,D.score)(m.selector,g.uri,g.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(g)),k(m.selector)&&m._score>0){for(let c of this._entries)c._score=0;m._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(g,r){return g._score<r._score?1:g._score>r._score?-1:g._time<r._time?1:g._time>r._time?-1:0}}e.LanguageFeatureRegistry=n;class P{constructor(g,r,m=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=r,this.max=m,this._cache=new T.LRUCache(50,.7)}_key(g){return g.id+(0,R.hash)(this._registry.all(g))}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const r=this._key(g),m=this._cache.get(r);return this._clamp(m==null?void 0:m.value)}update(g,r){const m=this._key(g);let c=this._cache.get(m);return c||(c=new E.MovingAverage,this._cache.set(m,c)),c.update(r),this.get(g)}}e.LanguageFeatureRequestDelays=P}),define(ve[63],be([0,1,2,31,148,121,35]),function(J,e,v,R,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(l){l[l.Null=0]="Null",l[l.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class y{constructor(F,N){this.language=F,this.id=N}}e.LanguageIdentifier=y;var k;(function(l){l[l.NotSet=-1]="NotSet",l[l.None=0]="None",l[l.Italic=1]="Italic",l[l.Bold=2]="Bold",l[l.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var n;(function(l){l[l.None=0]="None",l[l.DefaultForeground=1]="DefaultForeground",l[l.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var P;(function(l){l[l.Other=0]="Other",l[l.Comment=1]="Comment",l[l.String=2]="String",l[l.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var d;(function(l){l[l.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",l[l.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",l[l.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",l[l.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",l[l.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",l[l.ITALIC_MASK=2048]="ITALIC_MASK",l[l.BOLD_MASK=4096]="BOLD_MASK",l[l.UNDERLINE_MASK=8192]="UNDERLINE_MASK",l[l.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",l[l.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",l[l.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",l[l.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",l[l.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",l[l.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",l[l.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",l[l.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",l[l.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",l[l.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(d=e.MetadataConsts||(e.MetadataConsts={}));class g{static getLanguageId(F){return(F&255)>>>0}static getTokenType(F){return(F&1792)>>>8}static getFontStyle(F){return(F&14336)>>>11}static getForeground(F){return(F&8372224)>>>14}static getBackground(F){return(F&4286578688)>>>23}static getClassNameFromMetadata(F){let N=this.getForeground(F),z="mtk"+N,de=this.getFontStyle(F);return de&1&&(z+=" mtki"),de&2&&(z+=" mtkb"),de&4&&(z+=" mtku"),z}static getInlineStyleFromMetadata(F,N){const z=this.getForeground(F),de=this.getFontStyle(F);let he=`color: ${N[z]};`;return de&1&&(he+="font-style: italic;"),de&2&&(he+="font-weight: bold;"),de&4&&(he+="text-decoration: underline;"),he}}e.TokenMetadata=g;var r;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let l=Object.create(null);return l[0]="symbol-method",l[1]="symbol-function",l[2]="symbol-constructor",l[3]="symbol-field",l[4]="symbol-variable",l[5]="symbol-class",l[6]="symbol-struct",l[7]="symbol-interface",l[8]="symbol-module",l[9]="symbol-property",l[10]="symbol-event",l[11]="symbol-operator",l[12]="symbol-unit",l[13]="symbol-value",l[14]="symbol-constant",l[15]="symbol-enum",l[16]="symbol-enum-member",l[17]="symbol-keyword",l[27]="symbol-snippet",l[18]="symbol-text",l[19]="symbol-color",l[20]="symbol-file",l[21]="symbol-reference",l[22]="symbol-customcolor",l[23]="symbol-folder",l[24]="symbol-type-parameter",l[25]="account",l[26]="issues",function(F){const N=l[F];let z=N&&E.iconRegistry.get(N);return z||(console.info("No codicon found for CompletionItemKind "+F),z=E.Codicon.symbolProperty),z.classNames}}(),e.completionKindFromString=function(){let l=Object.create(null);return l.method=0,l.function=1,l.constructor=2,l.field=3,l.variable=4,l.class=5,l.struct=6,l.interface=7,l.module=8,l.property=9,l.event=10,l.operator=11,l.unit=12,l.value=13,l.constant=14,l.enum=15,l["enum-member"]=16,l.enumMember=16,l.keyword=17,l.snippet=27,l.text=18,l.color=19,l.file=20,l.reference=21,l.customcolor=22,l.folder=23,l["type-parameter"]=24,l.typeParameter=24,l.account=25,l.issue=26,function(F,N){let z=l[F];return typeof z=="undefined"&&!N&&(z=9),z}}();var m;(function(l){l[l.Deprecated=1]="Deprecated"})(m=e.CompletionItemTag||(e.CompletionItemTag={}));var c;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(c=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var p;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var a;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(a=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(l){return l&&v.URI.isUri(l.uri)&&R.Range.isIRange(l.range)&&(R.Range.isIRange(l.originSelectionRange)||R.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=t;var i;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var s;(function(l){l[l.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var o;(function(l){const F=new Map;F.set("file",0),F.set("module",1),F.set("namespace",2),F.set("package",3),F.set("class",4),F.set("method",5),F.set("property",6),F.set("field",7),F.set("constructor",8),F.set("enum",9),F.set("interface",10),F.set("function",11),F.set("variable",12),F.set("constant",13),F.set("string",14),F.set("number",15),F.set("boolean",16),F.set("array",17),F.set("object",18),F.set("key",19),F.set("null",20),F.set("enum-member",21),F.set("struct",22),F.set("event",23),F.set("operator",24),F.set("type-parameter",25);const N=new Map;N.set(0,"file"),N.set(1,"module"),N.set(2,"namespace"),N.set(3,"package"),N.set(4,"class"),N.set(5,"method"),N.set(6,"property"),N.set(7,"field"),N.set(8,"constructor"),N.set(9,"enum"),N.set(10,"interface"),N.set(11,"function"),N.set(12,"variable"),N.set(13,"constant"),N.set(14,"string"),N.set(15,"number"),N.set(16,"boolean"),N.set(17,"array"),N.set(18,"object"),N.set(19,"key"),N.set(20,"null"),N.set(21,"enum-member"),N.set(22,"struct"),N.set(23,"event"),N.set(24,"operator"),N.set(25,"type-parameter");function z($){return F.get($)}l.fromString=z;function de($){return N.get($)}l.toString=de;function he($,q){const x=N.get($);let I=x&&E.iconRegistry.get("symbol-"+x);return I||(console.info("No codicon found for SymbolKind "+$),I=E.Codicon.symbolProperty),`${q?"inline":"block"} ${I.classNames}`}l.toCssClassName=he})(o=e.SymbolKinds||(e.SymbolKinds={}));class u{constructor(F){this.value=F}}e.FoldingRangeKind=u,u.Comment=new u("comment"),u.Imports=new u("imports"),u.Region=new u("region");var _;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(_=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var b;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(b=e.CommentMode||(e.CommentMode={}));var A;(function(l){l[l.Other=0]="Other",l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(A=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new S.LanguageFeatureRegistry,e.RenameProviderRegistry=new S.LanguageFeatureRegistry,e.CompletionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new S.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new S.LanguageFeatureRegistry,e.HoverProviderRegistry=new S.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new S.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new S.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new S.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new S.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new S.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.LinkProviderRegistry=new S.LanguageFeatureRegistry,e.ColorProviderRegistry=new S.LanguageFeatureRegistry,e.SelectionRangeRegistry=new S.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var C;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(C=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[149],be([0,1,6,10,4,3,45,43]),function(J,e,v,R,S,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,S.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,k){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!k)throw new Error("invalid command");return this.registerCommand({id:y,handler:k})}if(y.description){const r=[];for(let c of y.description.args)r.push(c.constraint);const m=y.handler;y.handler=function(c,...p){return(0,R.validateConstraints)(p,r),m(c,...p)}}const{id:n}=y;let P=this._commands.get(n);P||(P=new E.LinkedList,this._commands.set(n,P));let d=P.unshift(y),g=(0,v.toDisposable)(()=>{d();const r=this._commands.get(n);(r==null?void 0:r.isEmpty())&&this._commands.delete(n)});return this._onDidRegisterCommand.fire(n),g}registerCommandAlias(y,k){return e.CommandsRegistry.registerCommand(y,(n,...P)=>n.get(e.ICommandService).executeCommand(k,...P))}getCommand(y){const k=this._commands.get(y);if(!(!k||k.isEmpty()))return D.Iterable.first(k)}getCommands(){const y=new Map;for(const k of this._commands.keys()){const n=this.getCommand(k);n&&y.set(k,n)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>v.Disposable.None,onDidExecuteCommand:()=>v.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(ve[64],be([0,1,8,4,21]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=S.userAgent||"";const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",S.isMacintosh),E.set("isLinux",S.isLinux),E.set("isWindows",S.isWindows),E.set("isWeb",S.isWeb),E.set("isMacNative",S.isMacintosh&&!S.isWeb),E.set("isEdge",T.indexOf("Edg/")>=0),E.set("isFirefox",T.indexOf("Firefox")>=0),E.set("isChrome",T.indexOf("Chrome")>=0),E.set("isSafari",T.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var y;(function(C){C[C.False=0]="False",C[C.True=1]="True",C[C.Defined=2]="Defined",C[C.Not=3]="Not",C[C.Equals=4]="Equals",C[C.NotEquals=5]="NotEquals",C[C.And=6]="And",C[C.Regex=7]="Regex",C[C.NotRegex=8]="NotRegex",C[C.Or=9]="Or",C[C.In=10]="In",C[C.NotIn=11]="NotIn",C[C.Greater=12]="Greater",C[C.GreaterEquals=13]="GreaterEquals",C[C.Smaller=14]="Smaller",C[C.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return P.INSTANCE}static true(){return d.INSTANCE}static has(l){return g.create(l)}static equals(l,F){return r.create(l,F)}static notEquals(l,F){return p.create(l,F)}static regex(l,F){return i.create(l,F)}static in(l,F){return m.create(l,F)}static not(l){return w.create(l)}static and(...l){return o.create(l)}static or(...l){return u.create(l)}static greater(l,F){return a.create(l,F)}static less(l,F){return f.create(l,F)}static deserialize(l,F=!1){if(!!l)return this._deserializeOrExpression(l,F)}static _deserializeOrExpression(l,F){let N=l.split("||");return u.create(N.map(z=>this._deserializeAndExpression(z,F)))}static _deserializeAndExpression(l,F){let N=l.split("&&");return o.create(N.map(z=>this._deserializeOne(z,F)))}static _deserializeOne(l,F){if(l=l.trim(),l.indexOf("!=")>=0){let N=l.split("!=");return p.create(N[0].trim(),this._deserializeValue(N[1],F))}if(l.indexOf("==")>=0){let N=l.split("==");return r.create(N[0].trim(),this._deserializeValue(N[1],F))}if(l.indexOf("=~")>=0){let N=l.split("=~");return i.create(N[0].trim(),this._deserializeRegexValue(N[1],F))}if(l.indexOf(" in ")>=0){let N=l.split(" in ");return m.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(l)){const N=l.split(">=");return h.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(l)){const N=l.split(">");return a.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(l)){const N=l.split("<=");return t.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(l)){const N=l.split("<");return f.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(l)?w.create(l.substr(1).trim()):g.create(l)}static _deserializeValue(l,F){if(l=l.trim(),l==="true")return!0;if(l==="false")return!1;let N=/^'([^']*)'$/.exec(l);return N?N[1].trim():l}static _deserializeRegexValue(l,F){if((0,v.isFalsyOrWhitespace)(l)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=l.indexOf("/"),z=l.lastIndexOf("/");if(N===z||N<0){if(F)throw new Error(`bad regexp-value '${l}', missing /-enclosure`);return console.warn(`bad regexp-value '${l}', missing /-enclosure`),null}let de=l.slice(N+1,z),he=l[z+1]==="i"?"i":"";try{return new RegExp(de,he)}catch($){if(F)throw new Error(`bad regexp-value '${l}', parse error: ${$}`);return console.warn(`bad regexp-value '${l}', parse error: ${$}`),null}}}e.ContextKeyExpr=k;function n(C,l){return C.cmp(l)}class P{constructor(){this.type=0}cmp(l){return this.type-l.type}equals(l){return l.type===this.type}evaluate(l){return!1}serialize(){return"false"}keys(){return[]}map(l){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class d{constructor(){this.type=1}cmp(l){return this.type-l.type}equals(l){return l.type===this.type}evaluate(l){return!0}serialize(){return"true"}keys(){return[]}map(l){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class g{constructor(l){this.key=l,this.type=2}static create(l){const F=E.get(l);return typeof F=="boolean"?F?d.INSTANCE:P.INSTANCE:new g(l)}cmp(l){return l.type!==this.type?this.type-l.type:b(this.key,l.key)}equals(l){return l.type===this.type?this.key===l.key:!1}evaluate(l){return!!l.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(l){return l.mapDefined(this.key)}negate(){return w.create(this.key)}}e.ContextKeyDefinedExpr=g;class r{constructor(l,F){this.key=l,this.value=F,this.type=4}static create(l,F){if(typeof F=="boolean")return F?g.create(l):w.create(l);const N=E.get(l);return typeof N=="boolean"?F===(N?"true":"false")?d.INSTANCE:P.INSTANCE:new r(l,F)}cmp(l){return l.type!==this.type?this.type-l.type:A(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return l.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(l){return l.mapEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class m{constructor(l,F){this.key=l,this.valueKey=F,this.type=10}static create(l,F){return new m(l,F)}cmp(l){return l.type!==this.type?this.type-l.type:A(this.key,this.valueKey,l.key,l.valueKey)}equals(l){return l.type===this.type?this.key===l.key&&this.valueKey===l.valueKey:!1}evaluate(l){const F=l.getValue(this.valueKey),N=l.getValue(this.key);return Array.isArray(F)?F.indexOf(N)>=0:typeof N=="string"&&typeof F=="object"&&F!==null?D.call(F,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(l){return l.mapIn(this.key,this.valueKey)}negate(){return c.create(this)}}e.ContextKeyInExpr=m;class c{constructor(l){this._actual=l,this.type=11}static create(l){return new c(l)}cmp(l){return l.type!==this.type?this.type-l.type:this._actual.cmp(l._actual)}equals(l){return l.type===this.type?this._actual.equals(l._actual):!1}evaluate(l){return!this._actual.evaluate(l)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(l){return new c(this._actual.map(l))}negate(){return this._actual}}e.ContextKeyNotInExpr=c;class p{constructor(l,F){this.key=l,this.value=F,this.type=5}static create(l,F){if(typeof F=="boolean")return F?w.create(l):g.create(l);const N=E.get(l);return typeof N=="boolean"?F===(N?"true":"false")?P.INSTANCE:d.INSTANCE:new p(l,F)}cmp(l){return l.type!==this.type?this.type-l.type:A(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return l.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(l){return l.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=p;class w{constructor(l){this.key=l,this.type=3}static create(l){const F=E.get(l);return typeof F=="boolean"?F?P.INSTANCE:d.INSTANCE:new w(l)}cmp(l){return l.type!==this.type?this.type-l.type:b(this.key,l.key)}equals(l){return l.type===this.type?this.key===l.key:!1}evaluate(l){return!l.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(l){return l.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=w;class a{constructor(l,F){this.key=l,this.value=F,this.type=12}static create(l,F){return new a(l,F)}cmp(l){return l.type!==this.type?this.type-l.type:A(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(l){return l.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=a;class h{constructor(l,F){this.key=l,this.value=F,this.type=13}static create(l,F){return new h(l,F)}cmp(l){return l.type!==this.type?this.type-l.type:A(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(l){return l.mapGreaterEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=h;class f{constructor(l,F){this.key=l,this.value=F,this.type=14}static create(l,F){return new f(l,F)}cmp(l){return l.type!==this.type?this.type-l.type:A(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(l){return l.mapSmaller(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeySmallerExpr=f;class t{constructor(l,F){this.key=l,this.value=F,this.type=15}static create(l,F){return new t(l,F)}cmp(l){return l.type!==this.type?this.type-l.type:A(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(l){return l.mapSmallerEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(l,F){this.key=l,this.regexp=F,this.type=7}static create(l,F){return new i(l,F)}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.key<l.key)return-1;if(this.key>l.key)return 1;const F=this.regexp?this.regexp.source:"",N=l.regexp?l.regexp.source:"";return F<N?-1:F>N?1:0}equals(l){if(l.type===this.type){const F=this.regexp?this.regexp.source:"",N=l.regexp?l.regexp.source:"";return this.key===l.key&&F===N}return!1}evaluate(l){let F=l.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const l=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${l}`}keys(){return[this.key]}map(l){return l.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=i;class s{constructor(l){this._actual=l,this.type=8}static create(l){return new s(l)}cmp(l){return l.type!==this.type?this.type-l.type:this._actual.cmp(l._actual)}equals(l){return l.type===this.type?this._actual.equals(l._actual):!1}evaluate(l){return!this._actual.evaluate(l)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(l){return new s(this._actual.map(l))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class o{constructor(l){this.expr=l,this.type=6}static create(l){return o._normalizeArr(l)}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.expr.length<l.expr.length)return-1;if(this.expr.length>l.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const z=n(this.expr[F],l.expr[F]);if(z!==0)return z}return 0}equals(l){if(l.type===this.type){if(this.expr.length!==l.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(l.expr[F]))return!1;return!0}return!1}evaluate(l){for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].evaluate(l))return!1;return!0}static _normalizeArr(l){const F=[];let N=!1;for(const z of l)if(!!z){if(z.type===1){N=!0;continue}if(z.type===0)return P.INSTANCE;if(z.type===6){F.push(...z.expr);continue}F.push(z)}if(F.length===0&&N)return d.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];for(F.sort(n);F.length>1;){const z=F[F.length-1];if(z.type!==9)break;F.pop();const de=F.pop(),he=u.create(z.expr.map($=>o.create([$,de])));he&&(F.push(he),F.sort(n))}return F.length===1?F[0]:new o(F)}}serialize(){return this.expr.map(l=>l.serialize()).join(" && ")}keys(){const l=[];for(let F of this.expr)l.push(...F.keys());return l}map(l){return new o(this.expr.map(F=>F.map(l)))}negate(){let l=[];for(let F of this.expr)l.push(F.negate());return u.create(l)}}e.ContextKeyAndExpr=o;class u{constructor(l){this.expr=l,this.type=9}static create(l){const F=u._normalizeArr(l);if(F.length!==0)return F.length===1?F[0]:new u(F)}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.expr.length<l.expr.length)return-1;if(this.expr.length>l.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const z=n(this.expr[F],l.expr[F]);if(z!==0)return z}return 0}equals(l){if(l.type===this.type){if(this.expr.length!==l.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(l.expr[F]))return!1;return!0}return!1}evaluate(l){for(let F=0,N=this.expr.length;F<N;F++)if(this.expr[F].evaluate(l))return!0;return!1}static _normalizeArr(l){let F=[],N=!1;if(l){for(let z=0,de=l.length;z<de;z++){const he=l[z];if(!!he){if(he.type===0){N=!0;continue}if(he.type===1)return[d.INSTANCE];if(he.type===9){F=F.concat(he.expr);continue}F.push(he)}}if(F.length===0&&N)return[P.INSTANCE];F.sort(n)}return F}serialize(){return this.expr.map(l=>l.serialize()).join(" || ")}keys(){const l=[];for(let F of this.expr)l.push(...F.keys());return l}map(l){return new u(this.expr.map(F=>F.map(l)))}negate(){let l=[];for(let N of this.expr)l.push(N.negate());const F=N=>N.type===9?N.expr:[N];for(;l.length>1;){const N=l.shift(),z=l.shift(),de=[];for(const he of F(N))for(const $ of F(z))de.push(k.and(he,$));l.unshift(k.or(...de))}return l[0]}}e.ContextKeyOrExpr=u;class _ extends g{constructor(l,F,N){super(l);this._defaultValue=F,typeof N=="object"?_._info.push(Object.assign(Object.assign({},N),{key:l})):N!==!0&&_._info.push({key:l,description:N,type:F!=null?typeof F:void 0})}static all(){return _._info.values()}bindTo(l){return l.createKey(this.key,this._defaultValue)}getValue(l){return l.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(l){return k.equals(this.key,l)}notEqualsTo(l){return k.notEquals(this.key,l)}}e.RawContextKey=_,_._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function b(C,l){return C<l?-1:C>l?1:0}function A(C,l,F,N){return C<F?-1:C>F?1:l<N?-1:l>N?1:0}}),define(ve[150],be([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[26],be([0,1,8,4]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function S(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkpaceSupportTypeMessage=S;function T(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class D{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,d){if(typeof P=="undefined"||P===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof P=="string"||typeof d=="string"){let g=typeof P=="string"?P:P.value,r=typeof d=="string"?d:d.value;return v.equalsIgnoreCase(g,r)}return P._lower===d._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=D;function y(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function k(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=k,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[151],be([0,1,8,26]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function S(g,r){return g.uuid&&r.uuid?g.uuid===r.uuid:g.id===r.id?!0:(0,v.compareIgnoreCase)(g.id,r.id)===0}e.areSameExtensions=S;class T{constructor(r,m){this.version=m,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof T?S(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=T;function E(g,r){return`${g}.${r}`}e.getExtensionId=E;function D(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function y(g,r){return D(E(g,r))}e.getGalleryExtensionId=y;function k(g,r){const m=[],c=p=>{for(const w of m)if(w.some(a=>S(r(a),r(p))))return w;return null};for(const p of g){const w=c(p);w?w.push(p):m.push([p])}return m}e.groupByExtension=k;function n(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function P(g){return Object.assign({id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0)},g.telemetryData)}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function d(g){const r=new Set;for(const m of g)m.malicious&&r.add(m.id.id);return r}e.getMaliciousExtensionsSet=d}),define(ve[65],be([0,1,128,14,2,4,8,10,22]),function(J,e,v,R,S,T,E,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function k($){return $.create===!0}e.isFileOpenForWriteOptions=k;var n;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var P;(function($){$[$.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var d;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g($){return!!($.capabilities&2)}e.hasReadWriteCapability=g;function r($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=r;function m($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function c($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=c;var p;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(q,x){super(q);this.code=x}}e.FileSystemProviderError=w;function a($,q){const x=new w($.toString(),q);return f(x,q),x}e.createFileSystemProviderError=a;function h($){return $||a((0,v.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=h;function f($,q){return $.name=q?`${q} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=f;function t($){if(!$)return p.Unknown;if($ instanceof w)return $.code;const q=/^(.+) \(FileSystemError\)$/.exec($.name);if(!q)return p.Unknown;switch(q[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=t;function i($){if($ instanceof A)return $.fileOperationResult;switch(t($)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class o{constructor(q,x,I){this.resource=q,this.operation=x,this.target=I}isOperation(q){return this.operation===q}}e.FileOperationEvent=o;var u;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class _{constructor(q,x){this.ignorePathCasing=x,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=q;for(const I of q)switch(I.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(I.resource,I);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(I.resource,I);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(I.resource,I);break}}contains(q,...x){return this.doContains(q,{includeChildren:!1},...x)}affects(q,...x){return this.doContains(q,{includeChildren:!0},...x)}doContains(q,x,...I){var H,M,B,G,K,se;if(!q)return!1;const pe=I.length>0;return!!((!pe||I.includes(1))&&(((H=this.added)===null||H===void 0?void 0:H.get(q))||x.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(q)))||(!pe||I.includes(0))&&(((B=this.updated)===null||B===void 0?void 0:B.get(q))||x.includeChildren&&((G=this.updated)===null||G===void 0?void 0:G.findSuperstr(q)))||(!pe||I.includes(2))&&(((K=this.deleted)===null||K===void 0?void 0:K.findSubstr(q))||x.includeChildren&&((se=this.deleted)===null||se===void 0?void 0:se.findSuperstr(q))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(q){const x=[],I=q===1?this.added:q===0?this.updated:this.deleted;if(I)for(const[,H]of I)x.push(H);return x}filter(q){return new _(this.changes.filter(x=>q(x)),this.ignorePathCasing)}}e.FileChangesEvent=_;function b($,q,x){return!$||!q||$===q||q.length>$.length?!1:(q.charAt(q.length-1)!==R.sep&&(q+=R.sep),x?(0,E.startsWithIgnoreCase)($,q):$.indexOf(q)===0)}e.isParent=b;class A extends Error{constructor(q,x,I){super(q);this.fileOperationResult=x,this.options=I}static isFileOperationError(q){return q instanceof Error&&!(0,D.isUndefinedOrNull)(q.fileOperationResult)}}e.FileOperationError=A;var C;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(C=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var l;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(l=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=F;async function N($,q){if(!q.canHandleResource(S.URI.from({scheme:$.scheme})))return new Promise(x=>{const I=q.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===$.scheme&&H.added&&(I.dispose(),x())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(q){return(0,D.isNumber)(q)||(q=0),q<z.KB?(0,v.localize)(1,null,q.toFixed(0)):q<z.MB?(0,v.localize)(2,null,(q/z.KB).toFixed(2)):q<z.GB?(0,v.localize)(3,null,(q/z.MB).toFixed(2)):q<z.TB?(0,v.localize)(4,null,(q/z.GB).toFixed(2)):(0,v.localize)(5,null,(q/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var de;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(de=e.Arch||(e.Arch={}));function he($){return{maxFileSize:$===0?300*z.MB:16*z.GB,maxHeapSize:$===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=he}),define(ve[66],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...S){this._entries=new Map;for(let[T,E]of S)this.set(T,E)}set(S,T){const E=this._entries.get(S);return this._entries.set(S,T),E}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=v}),define(ve[152],be([0,1,12,146,89,4,66,11]),function(J,e,v,R,S,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class k extends Error{constructor(r){var m;super("cyclic dependency between services");this.message=(m=r.findCycleSlow())!==null&&m!==void 0?m:`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class n{constructor(r=new E.ServiceCollection,m=!1,c){this._activeInstantiations=new Set,this._services=r,this._strict=m,this._parent=c,this._services.set(T.IInstantiationService,this)}createChild(r){return new n(r,this._strict,this)}invokeFunction(r,...m){let c=d.traceInvocation(r),p=!1;try{return r({get:(a,h)=>{if(p)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(a,c);if(!f&&h!==T.optional)throw new Error(`[invokeFunction] unknown service '${a}'`);return f}},...m)}finally{p=!0,c.stop()}}createInstance(r,...m){let c,p;return r instanceof S.SyncDescriptor?(c=d.traceCreation(r.ctor),p=this._createInstance(r.ctor,r.staticArguments.concat(m),c)):(c=d.traceCreation(r),p=this._createInstance(r,m,c)),c.stop(),p}_createInstance(r,m=[],c){let p=T._util.getServiceDependencies(r).sort((h,f)=>h.index-f.index),w=[];for(const h of p){let f=this._getOrCreateServiceInstance(h.id,c);if(!f&&this._strict&&!h.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${h.id}.`);w.push(f)}let a=p.length>0?p[0].index:m.length;if(m.length!==a){console.warn(`[createInstance] First service dependency of ${r.name} at position ${a+1} conflicts with ${m.length} static arguments`);let h=a-m.length;h>0?m=m.concat(new Array(h)):m=m.slice(0,a)}return new r(...[...m,...w])}_setServiceInstance(r,m){if(this._services.get(r)instanceof S.SyncDescriptor)this._services.set(r,m);else if(this._parent)this._parent._setServiceInstance(r,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let m=this._services.get(r);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):m}_getOrCreateServiceInstance(r,m){let c=this._getServiceInstanceOrDescriptor(r);return c instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,c,m.branch(r,!0)):(m.branch(r,!1),c)}_safeCreateAndCacheServiceInstance(r,m,c){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,m,c)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,m,c){const p=new R.Graph(h=>h.id.toString());let w=0;const a=[{id:r,desc:m,_trace:c}];for(;a.length;){const h=a.pop();if(p.lookupOrInsertNode(h),w++>1e3)throw new k(p);for(let f of T._util.getServiceDependencies(h.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(f.id);if(!t&&!f.optional&&console.warn(`[createInstance] ${r} depends on ${f.id} which is NOT registered.`),t instanceof S.SyncDescriptor){const i={id:f.id,desc:t,_trace:h._trace.branch(f.id,!0)};p.insertEdge(h,i),a.push(i)}}}for(;;){const h=p.roots();if(h.length===0){if(!p.isEmpty())throw new k(p);break}for(const{data:f}of h){if(this._getServiceInstanceOrDescriptor(f.id)instanceof S.SyncDescriptor){const i=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,i)}p.removeNode(f)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,m,c=[],p,w){if(this._services.get(r)instanceof S.SyncDescriptor)return this._createServiceInstance(m,c,p,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,m,c,p,w);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(r,m=[],c,p){if(c){const w=new D.IdleValue(()=>this._createInstance(r,m,p));return new Proxy(Object.create(null),{get(a,h){if(h in a)return a[h];let f=w.value,t=f[h];return typeof t!="function"||(t=t.bind(f),a[h]=t),t},set(a,h,f){return w.value[h]=f,!0}})}else return this._createInstance(r,m,p)}}e.InstantiationService=n;var P;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(P||(P={}));class d{constructor(r,m){this.type=r,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return y?new d(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(r){return y?new d(0,r.name):d._None}branch(r,m){let c=new d(2,r.toString());return this._dep.push([r,m,c]),c}stop(){let r=Date.now()-this._start;d._totals+=r;let m=!1;function c(w,a){let h=[],f=new Array(w+1).join("	");for(const[t,i,s]of a._dep)if(i&&s){m=!0,h.push(`${f}CREATES -> ${t}`);let o=c(w+1,s);o&&h.push(o)}else h.push(`${f}uses -> ${t}`);return h.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(r>2||m)&&console.log(p.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(ve[17],be([0,1,4,6,21,3,61]),function(J,e,v,R,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function D(){return new Date().toISOString()}var y;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class k extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class n extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(y.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(y.Error,this.format(s))}else this.log(y.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let s=0;s<t.length;s++){let o=t[s];if(typeof o=="object")try{o=JSON.stringify(o)}catch(u){}i+=(s>0?" ":"")+o}return i}}e.AbstractMessageLogger=n;class P extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!S.isWindows}trace(t,...i){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}debug(t,...i){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}info(t,...i){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}warn(t,...i){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...i):console.warn(`[main ${D()}]`,t,...i))}error(t,...i){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...i):console.error(`[main ${D()}]`,t,...i))}critical(t,...i){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...i):console.error(`[main ${D()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class d extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=d;class g extends k{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,E.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class r extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const s of this.logServices)s.trace(t,...i)}debug(t,...i){for(const s of this.logServices)s.debug(t,...i)}info(t,...i){for(const s of this.logServices)s.info(t,...i)}warn(t,...i){for(const s of this.logServices)s.warn(t,...i)}error(t,...i){for(const s of this.logServices)s.error(t,...i)}critical(t,...i){for(const s of this.logServices)s.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=r;class m extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=m;class c extends R.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}createLogger(t,i){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(i==null?void 0:i.always)?y.Trace:this.logLevel,i),this.loggers.set(t.toString(),s),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=c;class p{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=p;function w(f){if(f.verbose)return y.Trace;if(typeof f.logLevel=="string"){const t=a(f.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function a(f){switch(f){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=a;function h(f){switch(f){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=h}),define(ve[90],be([0,1,4,129,47]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var E;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(E=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function k(r,m){return m-r}y.compare=k;const n=Object.create(null);n[y.Error]=(0,R.localize)(0,null),n[y.Warning]=(0,R.localize)(1,null),n[y.Info]=(0,R.localize)(2,null);function P(r){return n[r]||""}y.toString=P;function d(r){switch(r){case S.default.Error:return y.Error;case S.default.Warning:return y.Warning;case S.default.Info:return y.Info;case S.default.Ignore:return y.Hint}}y.fromSeverity=d;function g(r){switch(r){case y.Error:return S.default.Error;case y.Warning:return S.default.Warning;case y.Info:return S.default.Info;case y.Hint:return S.default.Ignore}}y.toSeverity=g}(E=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(y){const k="";function n(d){return P(d,!0)}y.makeKey=n;function P(d,g){let r=[k];return d.source?r.push(d.source.replace("\xA6","\\\xA6")):r.push(k),d.code?typeof d.code=="string"?r.push(d.code.replace("\xA6","\\\xA6")):r.push(d.code.value.replace("\xA6","\\\xA6")):r.push(k),d.severity!==void 0&&d.severity!==null?r.push(E.toString(d.severity)):r.push(k),d.message&&g?r.push(d.message.replace("\xA6","\\\xA6")):r.push(k),d.startLineNumber!==void 0&&d.startLineNumber!==null?r.push(d.startLineNumber.toString()):r.push(k),d.startColumn!==void 0&&d.startColumn!==null?r.push(d.startColumn.toString()):r.push(k),d.endLineNumber!==void 0&&d.endLineNumber!==null?r.push(d.endLineNumber.toString()):r.push(k),d.endColumn!==void 0&&d.endColumn!==null?r.push(d.endColumn.toString()):r.push(k),r.push(k),r.join("\xA6")}y.makeKeyOptionalMessage=P})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,v.createDecorator)("markerService")}),define(ve[153],be([0,1,47,4,3]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=v.default,e.INotificationService=(0,R.createDecorator)("notificationService");var T;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var E;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(E=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new y,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=D;class y{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=y}),define(ve[154],be([0,1,6,8,2,4]),function(J,e,v,R,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return v.Disposable.None},registerValidator(){return v.Disposable.None},registerExternalUriResolver(){return v.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return v.Disposable.None},async open(){return!1},async resolveExternalUri(D){return{resolved:D,dispose(){}}}});function E(D,y){return S.URI.isUri(D)?(0,R.equalsIgnoreCase)(D.scheme,y):(0,R.startsWithIgnoreCase)(D,y+":")}e.matchesScheme=E});var je=this&&this.__decorate||function(J,e,v,R){var S=arguments.length,T=S<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(J,e,v,R);else for(var D=J.length-1;D>=0;D--)(E=J[D])&&(T=(S<3?E(T):S>3?E(e,v,T):E(e,v))||T);return S>3&&T&&Object.defineProperty(e,v,T),T},qe=this&&this.__param||function(J,e){return function(v,R){e(v,R,J)}};define(ve[155],be([0,1,4,20,6,11]),function(J,e,v,R,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,v.createDecorator)("progressService");var E;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(E=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let y=class extends S.Disposable{constructor(P,d){super();this.deferred=new T.DeferredPromise,d.withProgress(P,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,S.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};y=je([qe(1,e.IProgressService)],y),e.UnmanagedProgress=y;class k extends S.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(P){this.stop();const d=++this.currentOperationId,g=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,S.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,S.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,S.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:g.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,v.createDecorator)("editorProgressService")}),define(ve[29],be([0,1,10,42]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(E,D){R.ok(v.isString(E)),R.ok(v.isObject(D)),R.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,D)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new S}),define(ve[91],be([0,1,29,3]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class T{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,k){this.schemasById[S(y)]=k,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new T;v.Registry.add(e.Extensions.JSONContribution,E)}),define(ve[67],be([0,1,126,3,29,10,91]),function(J,e,v,R,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=S.Registry.as(E.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(p,w=!0){this.registerConfigurations([p],w)}registerConfigurations(p,w=!0){const a=[];p.forEach(h=>{a.push(...this.validateAndRegisterProperties(h,w,h.extensionInfo)),this.configurationContributors.push(h),this.registerJSONConfiguration(h)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(p){const w=[],a=h=>{if(h.properties)for(const f in h.properties)w.push(f),delete this.configurationProperties[f],this.removeFromSchema(f,h.properties[f]);h.allOf&&h.allOf.forEach(f=>a(f))};for(const h of p){a(h);const f=this.configurationContributors.indexOf(h);f!==-1&&this.configurationContributors.splice(f,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}registerDefaultConfigurations(p){const w=[],a=[];for(const h of p)for(const f in h)if(w.push(f),e.OVERRIDE_PROPERTY_PATTERN.test(f)){this.defaultValues[f]=Object.assign(Object.assign({},this.defaultValues[f]||{}),h[f]);const t={type:"object",default:this.defaultValues[f],description:v.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId};a.push(P(f)),this.configurationProperties[f]=t,this.defaultLanguageConfigurationOverridesNode.properties[f]=t}else{this.defaultValues[f]=h[f];const t=this.configurationProperties[f];t&&(this.updatePropertyDefaultValue(f,t),this.updateSchema(f,t))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}deregisterDefaultConfigurations(p){const w=[];for(const a of p)for(const h in a)if(w.push(h),delete this.defaultValues[h],e.OVERRIDE_PROPERTY_PATTERN.test(h))delete this.configurationProperties[h],delete this.defaultLanguageConfigurationOverridesNode.properties[h];else{const f=this.configurationProperties[h];f&&(this.updatePropertyDefaultValue(h,f),this.updateSchema(h,f))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}notifyConfigurationSchemaUpdated(...p){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(p){for(const w of p)this.overrideIdentifiers.add(w);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(p,w=!0,a,h=3){var f;h=T.isUndefinedOrNull(p.scope)?h:p.scope;let t=[],i=p.properties;if(i)for(let o in i){if(w&&r(o)){delete i[o];continue}const u=i[o];if(this.updatePropertyDefaultValue(o,u),e.OVERRIDE_PROPERTY_PATTERN.test(o)?u.scope=void 0:(u.scope=T.isUndefinedOrNull(u.scope)?h:u.scope,u.restricted=T.isUndefinedOrNull(u.restricted)?!!((f=a==null?void 0:a.restrictedConfigurations)===null||f===void 0?void 0:f.includes(o)):u.restricted),i[o].hasOwnProperty("included")&&!i[o].included){this.excludedConfigurationProperties[o]=i[o],delete i[o];continue}else this.configurationProperties[o]=i[o];!i[o].deprecationMessage&&i[o].markdownDeprecationMessage&&(i[o].deprecationMessage=i[o].markdownDeprecationMessage),t.push(o)}let s=p.allOf;if(s)for(let o of s)t.push(...this.validateAndRegisterProperties(o,w,a,h));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(p){const w=a=>{let h=a.properties;if(h)for(const t in h)this.updateSchema(t,h[t]);let f=a.allOf;f&&f.forEach(w)};w(p)}updateSchema(p,w){switch(e.allSettings.properties[p]=w,w.scope){case 1:e.applicationSettings.properties[p]=w;break;case 2:e.machineSettings.properties[p]=w;break;case 6:e.machineOverridableSettings.properties[p]=w;break;case 3:e.windowSettings.properties[p]=w;break;case 4:e.resourceSettings.properties[p]=w;break;case 5:e.resourceSettings.properties[p]=w,this.resourceLanguageSettingsSchema.properties[p]=w;break}}removeFromSchema(p,w){switch(delete e.allSettings.properties[p],w.scope){case 1:delete e.applicationSettings.properties[p];break;case 2:delete e.machineSettings.properties[p];break;case 6:delete e.machineOverridableSettings.properties[p];break;case 3:delete e.windowSettings.properties[p];break;case 4:case 5:delete e.resourceSettings.properties[p];break}}updateOverridePropertyPatternKey(){for(const p of this.overrideIdentifiers.values()){const w=`[${p}]`,a={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(w,a),e.allSettings.properties[w]=a,e.applicationSettings.properties[w]=a,e.machineSettings.properties[w]=a,e.machineOverridableSettings.properties[w]=a,e.windowSettings.properties[w]=a,e.resourceSettings.properties[w]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(p,w){let a=this.defaultValues[p];T.isUndefined(a)&&(a=w.default),T.isUndefined(a)&&(a=d(w.type)),w.default=a}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function P(c){return c.substring(1,c.length-1)}e.overrideIdentifierFromKey=P;function d(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new k;S.Registry.add(e.Extensions.Configuration,g);function r(c){return c.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(c)?v.localize(5,null,c):g.getConfigurationProperties()[c]!==void 0?v.localize(6,null,c):null:v.localize(4,null)}e.validateProperty=r;function m(){const c=[],p=g.getConfigurationProperties();for(const w of Object.keys(p))c.push([w,p[w].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=m}),define(ve[92],be([0,1,24,10,2,29,4,67]),function(J,e,v,R,S,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,E.createDecorator)("configurationService");function y(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof S.URI)}e.isConfigurationOverrides=y;var k;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function P(i,s){const o=s?i?s.keys.filter(F=>i.keys.indexOf(F)===-1):[...s.keys]:[],u=i?s?i.keys.filter(F=>s.keys.indexOf(F)===-1):[...i.keys]:[],_=[];if(s&&i){for(const F of i.keys)if(s.keys.indexOf(F)!==-1){const N=p(i.contents,F),z=p(s.contents,F);v.equals(N,z)||_.push(F)}}const b=[],A=F=>{const N={};for(const z of F)for(const de of z.identifiers)N[f(de)]=z;return N},C=s?A(s.overrides):{},l=i?A(i.overrides):{};if(Object.keys(C).length)for(const F of o){const N=C[F];N&&b.push([(0,D.overrideIdentifierFromKey)(F),N.keys])}if(Object.keys(l).length)for(const F of u){const N=l[F];N&&b.push([(0,D.overrideIdentifierFromKey)(F),N.keys])}if(Object.keys(C).length&&Object.keys(l).length)for(const F of _){const N=l[F],z=C[F];if(N&&z){const de=P({contents:N.contents,keys:N.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});b.push([(0,D.overrideIdentifierFromKey)(F),[...de.added,...de.removed,...de.updated]])}}return{added:o,removed:u,updated:_,overrides:b}}e.compare=P;function d(i,s){const o=[];for(const u of Object.keys(i))if(D.OVERRIDE_PROPERTY_PATTERN.test(u)){const _={};for(const b in i[u])_[b]=i[u][b];o.push({identifiers:[(0,D.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(_),contents:g(_,s)})}return o}e.toOverrides=d;function g(i,s){const o=Object.create(null);for(let u in i)r(o,u,i[u],s);return o}e.toValuesTree=g;function r(i,s,o,u){const _=s.split("."),b=_.pop();let A=i;for(let C=0;C<_.length;C++){let l=_[C],F=A[l];switch(typeof F){case"undefined":F=A[l]=Object.create(null);break;case"object":break;default:u(`Ignoring ${s} as ${_.slice(0,C+1).join(".")} is ${JSON.stringify(F)}`);return}A=F}if(typeof A=="object"&&A!==null)try{A[b]=o}catch(C){u(`Ignoring ${s} as ${_.join(".")} is ${JSON.stringify(A)}`)}else u(`Ignoring ${s} as ${_.join(".")} is ${JSON.stringify(A)}`)}e.addToValueTree=r;function m(i,s){const o=s.split(".");c(i,o)}e.removeFromValueTree=m;function c(i,s){const o=s.shift();if(s.length===0){delete i[o];return}if(Object.keys(i).indexOf(o)!==-1){const u=i[o];typeof u=="object"&&!Array.isArray(u)&&(c(u,s),Object.keys(u).length===0&&delete i[o])}}function p(i,s,o){function u(A,C){let l=A;for(const F of C){if(typeof l!="object"||l===null)return;l=l[F]}return l}const _=s.split("."),b=u(i,_);return typeof b=="undefined"?o:b}e.getConfigurationValue=p;function w(i,s,o){Object.keys(s).forEach(u=>{u!=="__proto__"&&(u in i?R.isObject(i[u])&&R.isObject(s[u])?w(i[u],s[u],o):o&&(i[u]=s[u]):i[u]=s[u])})}e.merge=w;function a(){const i=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=a;function h(){const i=Object.create(null),s=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let o in s){let u=s[o].default;r(i,o,u,_=>console.error(`Conflict in default settings: ${_}`))}return i}e.getDefaultValues=h;function f(i){return`[${i}]`}e.keyFromOverrideIdentifier=f;function t(i,s,o){const u=i.inspect(s),_=i.inspect(o);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof _.userValue!="undefined"||typeof _.workspaceValue!="undefined"||typeof _.workspaceFolderValue!="undefined"?_.value:u.defaultValue}e.getMigratedSettingValue=t}),define(ve[156],be([0,1,44,22,13,10,24,2,67,92,29,6,3]),function(J,e,v,R,S,T,E,D,y,k,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},i=[],s=[]){this._contents=t,this._keys=i,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const s=this.getContentsForOverrideIdentifer(i);return s?t?(0,k.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const o of S.distinct([...Object.keys(this.contents),...Object.keys(i)])){let u=this.contents[o],_=i[o];_&&(typeof u=="object"&&typeof _=="object"?(u=E.deepClone(u),this.mergeContents(u,_)):u=_),s[o]=u}return new g(s,this.keys,this.overrides)}merge(...t){const i=E.deepClone(this.contents),s=E.deepClone(this.overrides),o=[...this.keys];for(const u of t){this.mergeContents(i,u.contents);for(const _ of u.overrides){const[b]=s.filter(A=>S.equals(A.identifiers,_.identifiers));b?this.mergeContents(b.contents,_.contents):s.push(E.deepClone(_))}for(const _ of u.keys)o.indexOf(_)===-1&&o.push(_)}return new g(i,o,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const s of Object.keys(i)){if(s in t&&T.isObject(t[s])&&T.isObject(i[s])){this.mergeContents(t[s],i[s]);continue}t[s]=E.deepClone(i[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?E.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,k.addToValueTree)(this.contents,t,i,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let s=0;s<i;s++)t.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=g;class r extends g{constructor(){const t=(0,k.getDefaultValues)(),i=(0,k.getConfigurationKeys)(),s=[];for(const o of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(o)&&s.push({identifiers:[(0,y.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,k.toValuesTree)(t[o],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,i,s)}}e.DefaultConfigurationModel=r;class m{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!T.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:s,keys:o,overrides:u,restricted:_}=this.doParseRaw(t,i);this._configurationModel=new g(s,o,u),this._restrictedConfigurations=_||[]}doParseContent(t){let i={},s=null,o=[],u=[],_=[];function b(C){Array.isArray(o)?o.push(C):s&&(o[s]=C)}let A={onObjectBegin:()=>{let C={};b(C),u.push(o),o=C,s=null},onObjectProperty:C=>{s=C},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{let C=[];b(C),u.push(o),o=C,s=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:b,onError:(C,l,F)=>{_.push({error:C,offset:l,length:F})}};if(t)try{v.visit(t,A),i=o[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return i}doParseRaw(t,i){const s=n.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,s,!0,i);t=o.raw;const u=(0,k.toValuesTree)(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),_=Object.keys(t),b=(0,k.toOverrides)(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:u,keys:_,overrides:b,restricted:o.restricted}}filter(t,i,s,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.skipRestricted))return{raw:t,restricted:[]};const u={},_=[];for(let b in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(b)&&s){const A=this.filter(t[b],i,!1,o);u[b]=A.raw,_.push(...A.restricted)}else{const A=i[b],C=A?typeof A.scope!="undefined"?A.scope:3:void 0;(A==null?void 0:A.restricted)&&_.push(b),(C===void 0||o.scopes===void 0||o.scopes.includes(C))&&(o.skipRestricted&&(A==null?void 0:A.restricted)||(u[b]=t[b]))}return{raw:u,restricted:_}}}e.ConfigurationModelParser=m;class c extends P.Disposable{constructor(t,i,s,o){super();this.userSettingsResource=t,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=c;class p{constructor(t,i,s=new g,o=new g,u=new R.ResourceMap,_=new g,b=new R.ResourceMap,A=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=u,this._memoryConfiguration=_,this._memoryConfigurationByResource=b,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(t)}updateValue(t,i,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new g,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(t):o.setValue(t,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,s){const o=this.getConsolidateConfigurationModel(i,s),u=this.getFolderConfigurationModelForResource(i.resource,s),_=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,b=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),A=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),C=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),l=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),F=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,N=u?i.overrideIdentifier?u.freeze().override(i.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,z=i.overrideIdentifier?_.override(i.overrideIdentifier).getValue(t):_.getValue(t),de=o.getValue(t),he=S.distinct(S.flatten(o.overrides.map($=>$.identifiers))).filter($=>o.getOverrideValue(t,$)!==void 0);return{defaultValue:b,userValue:A,userLocalValue:C,userRemoteValue:l,workspaceValue:F,workspaceFolderValue:N,memoryValue:z,value:de,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:C!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:l!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:u==null?void 0:u.freeze().getValue(t),override:i.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:_.getValue(t),override:i.overrideIdentifier?_.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:he.length?he:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=i.filter(o=>y.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const u=(0,y.overrideIdentifierFromKey)(o),_=this._defaultConfiguration.getKeysForOverrideIdentifier(u),b=t.getKeysForOverrideIdentifier(u),A=[...b.filter(C=>_.indexOf(C)===-1),..._.filter(C=>b.indexOf(C)===-1),..._.filter(C=>!E.equals(this._defaultConfiguration.override(u).getValue(C),t.override(u).getValue(C)))];return[u,A]});return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:u}=(0,k.compare)(this.localUserConfiguration,t),_=[...i,...s,...o];return _.length&&this.updateLocalUserConfiguration(t),{keys:_,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:u}=(0,k.compare)(this.remoteUserConfiguration,t);let _=[...i,...s,...o];return _.length&&this.updateRemoteUserConfiguration(t),{keys:_,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:o,overrides:u}=(0,k.compare)(this.workspaceConfiguration,t);let _=[...i,...s,...o];return _.length&&this.updateWorkspaceConfiguration(t),{keys:_,overrides:u}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:o,updated:u,removed:_,overrides:b}=(0,k.compare)(s,i);let A=[...o,...u,..._];return(A.length||!s)&&this.updateFolderConfiguration(t,i),{keys:A,overrides:b}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:u,overrides:_}=(0,k.compare)(i,void 0);return{keys:[...s,...o,...u],overrides:_}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let s=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const o=i.getFolder(t);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const u=this._memoryConfigurationByResource.get(t);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(i=s.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=s}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:s,overrides:o,keys:u}=this._folderConfigurations.get(i);return t.push([i,{contents:s,overrides:o,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((_,b)=>(_.set(D.URI.revive(b[0]),this.parseConfigurationModel(b[1])),_),new R.ResourceMap);return new p(i,s,new g,o,u,new g,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=p;function w(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const t=new Set,i=new Map;for(const o of f)o.keys.forEach(u=>t.add(u)),o.overrides.forEach(([u,_])=>{const b=(0,R.getOrSet)(i,u,new Set);_.forEach(A=>b.add(A))});const s=[];return i.forEach((o,u)=>s.push([u,[...o.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=w;class a{constructor(t,i,s,o){this.change=t,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(b=>u.add(b)),t.overrides.forEach(([,b])=>b.forEach(A=>u.add(A))),this.affectedKeys=[...u.values()];const _=new g;this.affectedKeys.forEach(b=>_.setValue(b,{})),this.affectedKeysTree=_.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,u=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!E.equals(o,u)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let s=(0,k.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(t=t[o],!t)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=a;class h extends a{constructor(t,i,s,o){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=h}),define(ve[93],be([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var R;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends Error{constructor(E,D=R.Unknown,y){super(E);this._message=E,this._code=D,this._detail=y,this.isHandled=D===R.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(E){return E instanceof S&&E._code===R.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof S&&E._code===R.NoResolverFound}static isHandled(E){return E instanceof S&&E.isHandled}}e.RemoteAuthorityResolverError=S}),define(ve[94],be([0,1,16]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function R(k){return k.scheme===v.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=R;function S(k){if(!k)return;const n=k.indexOf("+");return n<0?k:k.substr(0,n)}e.getRemoteName=S;function T(k){return k.scheme!==v.Schemas.file&&k.scheme!==v.Schemas.vscodeRemote}function E(k){if(k.folders.length)return k.folders.every(n=>T(n.uri))?k.folders[0].uri:void 0;if(k.configuration&&T(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=E;function D(k){var n;return(n=E(k))===null||n===void 0?void 0:n.scheme}e.getVirtualWorkspaceScheme=D;function y(k){return E(k)!==void 0}e.isVirtualWorkspace=y}),define(ve[157],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class v{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,T,E=5){let D;return D=T(y=>{const k=typeof y=="string"?y:y.data;let n=this._terminalBufferMap.get(S);if(n){n.data.push(k);return}const P=setTimeout(()=>this.flushBuffer(S),E);n={data:[k],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(S),D.dispose()}},this._terminalBufferMap.set(S,n)}),D}stopBuffering(S){const T=this._terminalBufferMap.get(S);T&&T.dispose()}flushBuffer(S){const T=this._terminalBufferMap.get(S);T&&(this._terminalBufferMap.delete(S),this._callback(S,T.data.join("")))}}e.TerminalDataBufferer=v}),define(ve[158],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(ve[159],be([0,1,4,6,29,3,158,35]),function(J,e,v,R,S,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,v.createDecorator)("themeService");var y;(function(c){function p(w){return w&&typeof w=="object"&&typeof w.id=="string"}c.isThemeColor=p})(y=e.ThemeColor||(e.ThemeColor={}));function k(c){return{id:c}}e.themeColorFromId=k;var n;(function(c){function p(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||y.isThemeColor(i.color))}c.isThemeIcon=p;const w=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function a(i){const s=w.exec(i);if(!s)return;let[,o]=s;return{id:o}}c.fromString=a;function h(i,s){let o=i.id;const u=o.lastIndexOf("~");return u!==-1&&(o=o.substring(0,u)),s&&(o=`${o}~${s}`),{id:o}}c.modify=h;function f(i,s){var o,u;return i.id===s.id&&((o=i.color)===null||o===void 0?void 0:o.id)===((u=s.color)===null||u===void 0?void 0:u.id)}c.isEqual=f;function t(i){return{id:i.id}}c.asThemeIcon=t,c.asClassNameArray=D.CSSIcon.asClassNameArray,c.asClassName=D.CSSIcon.asClassName,c.asCSSSelector=D.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function P(c){switch(c){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,R.toDisposable)(()=>{const w=this.themingParticipants.indexOf(p);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new d;S.Registry.add(e.Extensions.ThemingContribution,g);function r(c){return g.onColorThemeChange(c)}e.registerThemingParticipant=r;class m extends R.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,w){let a=this.theme.getColor(p);return a&&w&&(a=w(a,this.theme)),a?a.toString():null}}e.Themable=m}),define(ve[160],be([0,1,29,159,3,130,91,11,35]),function(J,e,v,R,S,T,E,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(p,w,a,h){const f=this.iconsById[p];if(f){if(a&&!f.description){f.description=a,this.iconSchema.properties[p].markdownDescription=`${a} $(${p})`;const s=this.iconReferenceSchema.enum.indexOf(p);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=a),this._onDidChange.fire()}return f}let t={id:p,description:a,defaults:w,deprecationMessage:h};this.iconsById[p]=t;let i={$ref:"#/definitions/icons"};return h&&(i.deprecationMessage=h),a&&(i.markdownDescription=`${a}: $(${p})`),this.iconSchema.properties[p]=i,this.iconReferenceSchema.enum.push(p),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:p}}deregisterIcon(p){delete this.iconsById[p],delete this.iconSchema.properties[p];const w=this.iconReferenceSchema.enum.indexOf(p);w!==-1&&(this.iconReferenceSchema.enum.splice(w,1),this.iconReferenceSchema.enumDescriptions.splice(w,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(p=>this.iconsById[p])}getIcon(p){return this.iconsById[p]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(p,w){const a=this.iconFontsById[p];if(a)return a;let h={id:p,definition:w};return this.iconFontsById[p]=h,this._onDidChange.fire(),h}deregisterIconFont(p){delete this.iconFontsById[p]}getIconFonts(){return Object.keys(this.iconFontsById).map(p=>this.iconFontsById[p])}getIconFont(p){return this.iconFontsById[p]}toString(){const p=(f,t)=>f.id.localeCompare(t.id),w=f=>{for(;R.ThemeIcon.isThemeIcon(f.defaults);)f=this.iconsById[f.defaults.id];return`codicon codicon-${f?f.id:""}`};let a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const h=Object.keys(this.iconsById).map(f=>this.iconsById[f]);for(const f of h.filter(t=>!!t.description).sort(p))a.push(`|<i class="${w(f)}"></i>|${f.id}|${R.ThemeIcon.isThemeIcon(f.defaults)?f.defaults.id:f.id}|${f.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const f of h.filter(t=>!R.ThemeIcon.isThemeIcon(t.defaults)).sort(p))a.push(`|<i class="${w(f)}"></i>|${f.id}|`);return a.join(`
`)}}const n=new k;v.Registry.add(e.Extensions.IconContribution,n);function P(c,p,w,a){return n.registerIcon(c,p,w,a)}e.registerIcon=P;function d(){return n}e.getIconRegistry=d;function g(){for(const c of y.iconRegistry.all)n.registerIcon(c.id,c.definition,c.description);y.iconRegistry.onDidRegister(c=>n.registerIcon(c.id,c.definition,c.description))}g(),e.iconsSchemaId="vscode://schemas/icons";let r=v.Registry.as(E.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,n.getIconSchema());const m=new D.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{m.isScheduled()||m.schedule()}),e.widgetClose=P("widget-close",y.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=P("goto-previous-location",y.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=P("goto-next-location",y.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=R.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(ve[48],be([0,1,2,25,4,22]),function(J,e,v,R,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");var E;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function D(d){const g=d;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=D;function y(d){const g=d;return!!(g&&typeof g=="object"&&v.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=y;class k{constructor(g,r,m,c){this._id=g,this._configuration=m,this._ignorePathCasing=c,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(g){this._id=g.id,this._configuration=g.configuration,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class n{constructor(g,r){this.raw=r,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,R.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function P(d){return new n({uri:d,index:0,name:(0,R.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=P}),define(ve[161],be([0,1,4,131,48,2,21,14,25,109,44,16,59,36,94]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(q){return(typeof q=="string"?(0,D.extname)(q):(0,y.extname)(q))===m}e.hasWorkspaceFileExtension=c,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function p(q){return q.hasOwnProperty("workspace")}e.isRecentWorkspace=p;function w(q){return q.hasOwnProperty("folderUri")}e.isRecentFolder=w;function a(q){return q.hasOwnProperty("fileUri")}e.isRecentFile=a;function h(q){const x=q;return typeof(x==null?void 0:x.id)=="string"&&T.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=h;function f(q){if(q.configuration)return{id:q.id,configPath:q.configuration};if(q.folders.length===1)return{id:q.id,uri:q.folders[0].uri}}e.toWorkspaceIdentifier=f;function t(q){const x=q;return typeof(x==null?void 0:x.id)=="string"&&T.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=t;function i(q){const x=q;if(x==null?void 0:x.uri)return{id:x.id,uri:T.URI.revive(x.uri)};const I=q;if(I==null?void 0:I.configPath)return{id:I.id,configPath:T.URI.revive(I.configPath)};if(q==null?void 0:q.id)return{id:q.id}}e.reviveIdentifier=i;function s(q,x){return y.extUriBiasedIgnorePathCase.isEqualOrParent(q,x.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function o(q){return u(q)||_(q)}e.isStoredWorkspaceFolder=o;function u(q){const x=q;return typeof(x==null?void 0:x.path)=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=u;function _(q){const x=q;return typeof(x==null?void 0:x.uri)=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=_;function b(q,x,I,H,M=!E.isWindows,B){if(q.scheme!==H.scheme)return{name:I,uri:q.toString(!0)};let G=x?void 0:B.relativePath(H,q);if(G!==void 0)G.length===0?G=".":E.isWindows&&q.scheme===P.Schemas.file&&!M&&(G=G.replace(/\//g,"\\"));else if(q.scheme===P.Schemas.file)G=q.fsPath,E.isWindows&&(G=(0,d.normalizeDriveLetter)(G),M&&(G=(0,g.toSlashes)(G)));else{if(!B.isEqualAuthority(q.authority,H.authority))return{name:I,uri:q.toString(!0)};G=q.path}return{name:I,path:G}}e.getStoredWorkspaceFolder=b;function A(q,x,I){let H=[],M=new Set;const B=I.dirname(x);for(let G of q){let K;if(u(G))G.path&&(K=I.resolvePath(B,G.path));else if(_(G))try{K=T.URI.parse(G.uri),K.path[0]!=="/"&&(K=K.with({path:"/"+K.path}))}catch(se){console.warn(se)}if(K){let se=I.getComparisonKey(K);if(!M.has(se)){M.add(se);const pe=G.name||I.basenameOrAuthority(K);H.push(new S.WorkspaceFolder({uri:K,name:pe,index:H.length},G))}}}return H}e.toWorkspaceFolders=A;function C(q,x,I,H,M){let B=l(x,q);const G=M.dirname(x),K=M.dirname(H),se=[],pe=F(B.folders);for(const ze of B.folders){const Ve=u(ze)?M.resolvePath(G,ze.path):T.URI.parse(ze.uri);let W;I?W=!1:W=!u(ze)||(0,D.isAbsolute)(ze.path),se.push(b(Ve,W,ze.name,K,pe,M))}const Fe={insertSpaces:!1,tabSize:4,eol:E.isLinux||E.isMacintosh?`
`:`\r
`},We=k.setProperty(q,["folders"],se,Fe);let Ne=k.applyEdits(q,We);return B.remoteAuthority===(0,r.getRemoteAuthority)(H)&&(Ne=k.applyEdits(Ne,k.removeProperty(Ne,["remoteAuthority"],Fe))),Ne}e.rewriteWorkspaceFileForNewLocation=C;function l(q,x){let I=n.parse(x);if(I&&Array.isArray(I.folders))I.folders=I.folders.filter(H=>o(H));else throw new Error(`${q} looks like an invalid workspace file.`);return I}function F(q){return E.isWindows?q.some(x=>u(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=F;function N(q){return q.workspace&&typeof q.workspace=="object"&&typeof q.workspace.id=="string"&&typeof q.workspace.configPath=="string"}function z(q){return typeof q.folderUri=="string"}function de(q){return typeof q.fileUri=="string"}function he(q,x){const I={workspaces:[],files:[]};if(q){const H=function(B,G){for(let K=0;K<B.length;K++)try{G(B[K],K)}catch(se){x.warn(`Error restoring recent entry ${JSON.stringify(B[K])}: ${se.toString()}. Skip entry.`)}},M=q;if(Array.isArray(M.entries))H(M.entries,B=>{const G=B.label,K=B.remoteAuthority;N(B)?I.workspaces.push({label:G,remoteAuthority:K,workspace:{id:B.workspace.id,configPath:T.URI.parse(B.workspace.configPath)}}):z(B)?I.workspaces.push({label:G,remoteAuthority:K,folderUri:T.URI.parse(B.folderUri)}):de(B)&&I.files.push({label:G,remoteAuthority:K,fileUri:T.URI.parse(B.fileUri)})});else{const B=q;Array.isArray(B.workspaces3)&&H(B.workspaces3,(G,K)=>{const se=Array.isArray(B.workspaceLabels)&&B.workspaceLabels[K]||void 0;typeof G=="object"&&typeof G.id=="string"&&typeof G.configURIPath=="string"?I.workspaces.push({label:se,workspace:{id:G.id,configPath:T.URI.parse(G.configURIPath)}}):typeof G=="string"&&I.workspaces.push({label:se,folderUri:T.URI.parse(G)})}),Array.isArray(B.files2)&&H(B.files2,(G,K)=>{const se=Array.isArray(B.fileLabels)&&B.fileLabels[K]||void 0;typeof G=="string"&&I.files.push({label:se,fileUri:T.URI.parse(G)})})}}return I}e.restoreRecentlyOpened=he;function $(q){const x={entries:[]};for(const I of q.workspaces)w(I)?x.entries.push({folderUri:I.folderUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority}):x.entries.push({workspace:{id:I.workspace.id,configPath:I.workspace.configPath.toString()},label:I.label,remoteAuthority:I.remoteAuthority});for(const I of q.files)x.entries.push({fileUri:I.fileUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority});return x}e.toStoreData=$}),define(ve[68],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class v{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const T=this._idPool++;return this._data.set(T,S),this.logDebugInfo(),T}get(S,T){return this._data.has(S)?this._data.get(S)[T]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!v.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=v,v.enableDebugLogging=!1}),define(ve[69],be([0,1,2,3,4]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,S.createDecorator)("IExtHostEditorTabs");class T{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(D){this._tabs=D.map(y=>({name:y.name,group:y.group,resource:v.URI.revive(y.resource),isActive:y.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(ve[49],be([0,1,16,4]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class S{constructor(){this._systemSchemes=new Set(Object.keys(v.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(E,D){D===null?this._providerInfo.delete(E):this._providerInfo.set(E,D)}isFreeScheme(E){return!this._providerInfo.has(E)&&!this._systemSchemes.has(E)}getCapabilities(E){return this._providerInfo.get(E)}}e.ExtHostFileSystemInfo=S,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(ve[27],be([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,v.createDecorator)("IExtHostInitDataService")}),define(ve[162],be([0,1,11]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(E,D,y){this._deferredPromises=new Map,this._id=E,this._shared=D,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new v.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of k.values())n.complete()}catch(n){for(const P of k.values())P.error(n)}})()},0)}get keys(){var E;return Object.entries((E=this._value)!==null&&E!==void 0?E:{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this._init}get(E,D){let y=this._value[E];return typeof y=="undefined"&&(y=D),y}update(E,D){this._value[E]=D;let y=this._deferredPromises.get(E);if(y!==void 0)return y.p;const k=new v.DeferredPromise;return this._deferredPromises.set(E,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class S extends R{constructor(E,D){super(E.identifier.value,!0,D);this._extension=E}setKeysForSync(E){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},E)}}e.ExtensionGlobalMemento=S}),define(ve[15],be([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,v.createDecorator)("IExtHostRpcService");class R{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=R});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!S:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(J,v):S?S.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(ve[163],be([0,1,26,3]),function(J,e,v,R){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(D,y){S.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=v.ExtensionIdentifier.toKey(D.identifier),nt(this,S,y,"f"),Be(this,S,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(D){return Be(this,S,"f").get(this._id,D)}store(D,y){return Be(this,S,"f").store(this._id,D,y)}delete(D){return Be(this,S,"f").delete(this._id,D)}}e.ExtensionSecrets=T,S=new WeakMap}),define(ve[95],be([0,1,4,3]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(E){this._enabled=E}$onDidChangeTelemetryEnabled(E){this._enabled=E,this._onDidChangeTelemetryEnabled.fire(E)}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=(0,v.createDecorator)("IExtHostTelemetry")}),define(ve[70],be([0,1,3]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(E){E[E.NewChild=0]="NewChild",E[E.Disposed=1]="Disposed",E[E.Invalidated=2]="Invalidated",E[E.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const S=new WeakMap,T=E=>{let D=S.get(E);return D||(D={children:new Map,bus:new v.Emitter},S.set(E,D)),D};e.getPrivateApiFor=T}),define(ve[71],be([0,1,4,3,15]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(D){function y(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public}}D.fromApiTunnel=y;function k(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public}}D.fromServiceTunnel=k})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,v.createDecorator)("IExtHostTunnelService");let E=class{constructor(y){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,k){return{dispose:()=>{}}}async $providePortAttributes(y,k,n,P,d){return[]}async $forwardPort(y,k){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};E=je([qe(0,S.IExtHostRpcService)],E),e.ExtHostTunnelService=E});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!S:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(J,v):S?S.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)},Kt=this&&this.__rest||function(J,e){var v={};for(var R in J)Object.prototype.hasOwnProperty.call(J,R)&&e.indexOf(R)<0&&(v[R]=J[R]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var S=0,R=Object.getOwnPropertySymbols(J);S<R.length;S++)e.indexOf(R[S])<0&&Object.prototype.propertyIsEnumerable.call(J,R[S])&&(v[R[S]]=J[R[S]]);return v};define(ve[7],be([0,1,13,12,83,22,8,10,2,37,65,93,70]),function(J,e,v,R,S,T,E,D,y,k,n,P,d){"use strict";var g,r,m,c,p,w,a,h,f,t,i,s,o,u,_,b,A,C;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function l(U){function L(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(L,U),Object.setPrototypeOf(L.prototype,U.prototype),L}let F=p=class{constructor(L){g.set(this,void 0),nt(this,g,L,"f")}static from(...L){let ee=L;return new p(function(){if(ee){for(const De of ee)De&&typeof De.dispose=="function"&&De.dispose();ee=void 0}})}dispose(){typeof Be(this,g,"f")=="function"&&(Be(this,g,"f").call(this),nt(this,g,void 0,"f"))}};g=new WeakMap,F=p=je([l],F),e.Disposable=F;let N=w=class{constructor(L,ee){if(L<0)throw(0,R.illegalArgument)("line must be non-negative");if(ee<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=L,this._character=ee}static Min(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let De=1;De<L.length;De++){const Ge=L[De];Ge.isBefore(ee)&&(ee=Ge)}return ee}static Max(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let De=1;De<L.length;De++){const Ge=L[De];Ge.isAfter(ee)&&(ee=Ge)}return ee}static isPosition(L){if(!L)return!1;if(L instanceof w)return!0;let{line:ee,character:De}=L;return typeof ee=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ee=0){if(L===null||ee===null)throw(0,R.illegalArgument)();let De;return typeof L=="undefined"?De=0:typeof L=="number"?De=L:(De=typeof L.lineDelta=="number"?L.lineDelta:0,ee=typeof L.characterDelta=="number"?L.characterDelta:0),De===0&&ee===0?this:new w(this.line+De,this.character+ee)}with(L,ee=this.character){if(L===null||ee===null)throw(0,R.illegalArgument)();let De;return typeof L=="undefined"?De=this.line:typeof L=="number"?De=L:(De=typeof L.line=="number"?L.line:this.line,ee=typeof L.character=="number"?L.character:this.character),De===this.line&&ee===this.character?this:new w(De,ee)}toJSON(){return{line:this.line,character:this.character}}};N=w=je([l],N),e.Position=N;let z=a=class{constructor(L,ee,De,Ge){let tt,ct;if(typeof L=="number"&&typeof ee=="number"&&typeof De=="number"&&typeof Ge=="number"?(tt=new N(L,ee),ct=new N(De,Ge)):L instanceof N&&ee instanceof N&&(tt=L,ct=ee),!tt||!ct)throw new Error("Invalid arguments");tt.isBefore(ct)?(this._start=tt,this._end=ct):(this._start=ct,this._end=tt)}static isRange(L){return L instanceof a?!0:L?N.isPosition(L.start)&&N.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof a?this.contains(L._start)&&this.contains(L._end):L instanceof N?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ee=N.Max(L.start,this._start),De=N.Min(L.end,this._end);if(!ee.isAfter(De))return new a(ee,De)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ee=N.Min(L.start,this._start),De=N.Max(L.end,this.end);return new a(ee,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ee=this.end){if(L===null||ee===null)throw(0,R.illegalArgument)();let De;return L?N.isPosition(L)?De=L:(De=L.start||this.start,ee=L.end||this.end):De=this.start,De.isEqual(this._start)&&ee.isEqual(this.end)?this:new a(De,ee)}toJSON(){return[this.start,this.end]}};z=a=je([l],z),e.Range=z;let de=h=class extends z{constructor(L,ee,De,Ge){let tt,ct;if(typeof L=="number"&&typeof ee=="number"&&typeof De=="number"&&typeof Ge=="number"?(tt=new N(L,ee),ct=new N(De,Ge)):L instanceof N&&ee instanceof N&&(tt=L,ct=ee),!tt||!ct)throw new Error("Invalid arguments");super(tt,ct);this._anchor=tt,this._active=ct}static isSelection(L){return L instanceof h?!0:L?z.isRange(L)&&N.isPosition(L.anchor)&&N.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};de=h=je([l],de),e.Selection=de;class he{constructor(L,ee,De){if(typeof L!="string"||L.length===0)throw(0,R.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,R.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,R.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(ee),this.connectionToken=De}}e.ResolvedAuthority=he;class $ extends Error{constructor(L,ee=P.RemoteAuthorityResolverErrorCode.Unknown,De){super(L);this._message=L,this._code=ee,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,$.prototype)}static NotAvailable(L,ee){return new $(L,P.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(L){return new $(L,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=$;var q;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(q=e.EndOfLine||(e.EndOfLine={}));var x;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let I=f=class{constructor(L,ee){this._range=L,this._newText=ee}static isTextEdit(L){return L instanceof f?!0:L?z.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ee){return new f(L,ee)}static insert(L,ee){return f.replace(new z(L,L),ee)}static delete(L){return f.replace(L,"")}static setEndOfLine(L){const ee=new f(new z(new N(0,0),new N(0,0)),"");return ee.newEol=L,ee}get range(){return this._range}set range(L){if(L&&!z.isRange(L))throw(0,R.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,R.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,R.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};I=f=je([l],I),e.TextEdit=I;var H;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellOutput=4]="CellOutput",U[U.CellReplace=5]="CellReplace",U[U.CellOutputItem=6]="CellOutputItem"})(H=e.FileEditType||(e.FileEditType={}));let M=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ee,De,Ge){this._edits.push({_type:1,from:L,to:ee,options:De,metadata:Ge})}createFile(L,ee,De){this._edits.push({_type:1,from:void 0,to:L,options:ee,metadata:De})}deleteFile(L,ee,De){this._edits.push({_type:1,from:L,to:void 0,options:ee,metadata:De})}replaceNotebookMetadata(L,ee,De){this._edits.push({_type:3,metadata:De,uri:L,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(L,ee,De,Ge,tt){let ct,ft,St=[],kt;if(Wt.isNotebookRange(ee)&&Re.isNotebookCellDataArray(De)&&!Re.isNotebookCellDataArray(Ge)?(ct=ee.start,ft=ee.end,St=De,kt=Ge):typeof ee=="number"&&typeof De=="number"&&Re.isNotebookCellDataArray(Ge)&&(ct=ee,ft=De,St=Ge,kt=tt),ct===void 0||ft===void 0)throw new Error("Invalid arguments");(ct!==ft||St.length>0)&&this._edits.push({_type:5,uri:L,index:ct,count:ft-ct,cells:St,metadata:kt})}replaceNotebookCellMetadata(L,ee,De,Ge){this._edits.push({_type:3,metadata:Ge,uri:L,edit:{editType:8,index:ee,metadata:De}})}replace(L,ee,De,Ge){this._edits.push({_type:2,uri:L,edit:new I(ee,De),metadata:Ge})}insert(L,ee,De,Ge){this.replace(L,new z(ee,ee),De,Ge)}delete(L,ee,De){this.replace(L,ee,"",De)}has(L){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===L.toString())}set(L,ee){if(ee)for(const De of ee)De&&this._edits.push({_type:2,uri:L,edit:De});else{for(let De=0;De<this._edits.length;De++){const Ge=this._edits[De];Ge._type===2&&Ge.uri.toString()===L.toString()&&(this._edits[De]=void 0)}(0,v.coalesceInPlace)(this._edits)}}get(L){const ee=[];for(let De of this._edits)De._type===2&&De.uri.toString()===L.toString()&&ee.push(De.edit);return ee}entries(){const L=new T.ResourceMap;for(let ee of this._edits)if(ee._type===2){let De=L.get(ee.uri);De||(De=[ee.uri,[]],L.set(ee.uri,De)),De[1].push(ee.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};M=je([l],M),e.WorkspaceEdit=M;let B=t=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof t?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=t._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ee=this._tabstop++){if(typeof L=="function"){const De=new t;De._tabstop=this._tabstop,L(De),this._tabstop=De._tabstop,L=De.value}else L=t._escape(L);return this.value+="${",this.value+=ee,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ee=this._tabstop++){const De=L.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(L,ee){if(typeof ee=="function"){const De=new t;De._tabstop=this._tabstop,ee(De),this._tabstop=De._tabstop,ee=De.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};B=t=je([l],B),e.SnippetString=B;var G;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(G=e.DiagnosticTag||(e.DiagnosticTag={}));var K;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(K=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let se=i=class{constructor(L,ee){if(this.uri=L,ee)if(ee instanceof z)this.range=ee;else if(ee instanceof N)this.range=new z(ee,ee);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof i?!0:L?z.isRange(L.range)&&y.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};se=i=je([l],se),e.Location=se;let pe=class{constructor(L,ee){this.location=L,this.message=ee}static is(L){return L?typeof L.message=="string"&&L.location&&z.isRange(L.location.range)&&y.URI.isUri(L.location.uri):!1}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.location.range.isEqual(ee.location.range)&&L.location.uri.toString()===ee.location.uri.toString()}};pe=je([l],pe),e.DiagnosticRelatedInformation=pe;let Fe=class{constructor(L,ee,De=K.Error){if(!z.isRange(L))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=L,this.message=ee,this.severity=De}toJSON(){return{severity:K[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.severity===ee.severity&&L.code===ee.code&&L.severity===ee.severity&&L.source===ee.source&&L.range.isEqual(ee.range)&&(0,v.equals)(L.tags,ee.tags)&&(0,v.equals)(L.relatedInformation,ee.relatedInformation,pe.isEqual)}};Fe=je([l],Fe),e.Diagnostic=Fe;let We=class{constructor(L,ee){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:(0,S.isMarkdownString)(L)?this.contents=[L]:this.contents=[L],this.range=ee}};We=je([l],We),e.Hover=We;var Ne;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Ne=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ze=class{constructor(L,ee=Ne.Text){this.range=L,this.kind=ee}toJSON(){return{range:this.range,kind:Ne[this.kind]}}};ze=je([l],ze),e.DocumentHighlight=ze;var Ve;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Ve=e.SymbolKind||(e.SymbolKind={}));var W;(function(U){U[U.Deprecated=1]="Deprecated"})(W=e.SymbolTag||(e.SymbolTag={}));let Q=s=class{constructor(L,ee,De,Ge,tt){this.name=L,this.kind=ee,this.containerName=tt,typeof De=="string"&&(this.containerName=De),Ge instanceof se?this.location=Ge:De instanceof z&&(this.location=new se(Ge,De)),s.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ve[this.kind],location:this.location,containerName:this.containerName}}};Q=s=je([l],Q),e.SymbolInformation=Q;let te=o=class{constructor(L,ee,De,Ge,tt){this.name=L,this.detail=ee,this.kind=De,this.range=Ge,this.selectionRange=tt,this.children=[],o.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(o.validate)}};te=o=je([l],te),e.DocumentSymbol=te;var re;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(re=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let fe=class{constructor(L,ee){this.title=L,this.kind=ee}};fe=je([l],fe),e.CodeAction=fe;let _e=u=class{constructor(L){this.value=L}append(L){return new u(this.value?this.value+u.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+u.sep)}};_e.sep=".",_e=u=je([l],_e),e.CodeActionKind=_e,_e.Empty=new _e(""),_e.QuickFix=_e.Empty.append("quickfix"),_e.Refactor=_e.Empty.append("refactor"),_e.RefactorExtract=_e.Refactor.append("extract"),_e.RefactorInline=_e.Refactor.append("inline"),_e.RefactorRewrite=_e.Refactor.append("rewrite"),_e.Source=_e.Empty.append("source"),_e.SourceOrganizeImports=_e.Source.append("organizeImports"),_e.SourceFixAll=_e.Source.append("fixAll");let ue=class{constructor(L,ee){if(this.range=L,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ue=je([l],ue),e.SelectionRange=ue;class we{constructor(L,ee,De,Ge,tt,ct){this.kind=L,this.name=ee,this.detail=De,this.uri=Ge,this.range=tt,this.selectionRange=ct}}e.CallHierarchyItem=we;class Ae{constructor(L,ee){this.fromRanges=ee,this.from=L}}e.CallHierarchyIncomingCall=Ae;class xe{constructor(L,ee){this.fromRanges=ee,this.to=L}}e.CallHierarchyOutgoingCall=xe;let ge=class{constructor(L,ee){this.range=L,this.command=ee}get isResolved(){return!!this.command}};ge=je([l],ge),e.CodeLens=ge;let Ke=_=class{constructor(L,ee=!1){r.set(this,void 0),nt(this,r,new S.MarkdownString(L,{supportThemeIcons:ee}),"f")}static isMarkdownString(L){return L instanceof _?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Be(this,r,"f").value}set value(L){Be(this,r,"f").value=L}get isTrusted(){return Be(this,r,"f").isTrusted}set isTrusted(L){Be(this,r,"f").isTrusted=L}get supportThemeIcons(){return Be(this,r,"f").supportThemeIcons}appendText(L){return Be(this,r,"f").appendText(L),this}appendMarkdown(L){return Be(this,r,"f").appendMarkdown(L),this}appendCodeblock(L,ee){return Be(this,r,"f").appendCodeblock(ee!=null?ee:"",L),this}};r=new WeakMap,Ke=_=je([l],Ke),e.MarkdownString=Ke;let j=class{constructor(L,ee){this.label=L,this.documentation=ee}};j=je([l],j),e.ParameterInformation=j;let Z=class{constructor(L,ee){this.label=L,this.documentation=ee,this.parameters=[]}};Z=je([l],Z),e.SignatureInformation=Z;let me=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};me=je([l],me),e.SignatureHelp=me;var Oe;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(Oe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var He;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(He=e.InlayHintKind||(e.InlayHintKind={}));let $e=class{constructor(L,ee,De){this.text=L,this.position=ee,this.kind=De}};$e=je([l],$e),e.InlayHint=$e;var Xe;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ye;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(ye=e.CompletionItemKind||(e.CompletionItemKind={}));var Se;(function(U){U[U.Deprecated=1]="Deprecated"})(Se=e.CompletionItemTag||(e.CompletionItemTag={}));let Ce=class{constructor(L,ee){this.label=L,this.kind=ee}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&ye[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ce=je([l],Ce),e.CompletionItem=Ce;let ne=class{constructor(L=[],ee=!1){this.items=L,this.isIncomplete=ee}};ne=je([l],ne),e.CompletionList=ne;let le=class{constructor(L){this.text=L}};le=je([l],le),e.InlineSuggestion=le;let O=class{constructor(L){this.items=L}};O=je([l],O),e.InlineSuggestions=O;var Y;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Y=e.ViewColumn||(e.ViewColumn={}));var oe;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(oe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ke;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ie;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Ie=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Le;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Le=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ue;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Ue=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function L(ee){switch(ee){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=L}(Ue=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let rt=class{constructor(L,ee){if(ee&&!y.URI.isUri(ee))throw(0,R.illegalArgument)("target");if(!z.isRange(L)||L.isEmpty)throw(0,R.illegalArgument)("range");this.range=L,this.target=ee}};rt=je([l],rt),e.DocumentLink=rt;let et=class{constructor(L,ee,De,Ge){this.red=L,this.green=ee,this.blue=De,this.alpha=Ge}};et=je([l],et),e.Color=et;let Ye=class{constructor(L,ee){if(ee&&!(ee instanceof et))throw(0,R.illegalArgument)("color");if(!z.isRange(L)||L.isEmpty)throw(0,R.illegalArgument)("range");this.range=L,this.color=ee}};Ye=je([l],Ye),e.ColorInformation=Ye;let ot=class{constructor(L){if(!L||typeof L!="string")throw(0,R.illegalArgument)("label");this.label=L}};ot=je([l],ot),e.ColorPresentation=ot;var _t;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(_t=e.ColorFormat||(e.ColorFormat={}));var wt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(wt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var vt;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(vt=e.TaskRevealKind||(e.TaskRevealKind={}));var ie;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(ie=e.TaskPanelKind||(e.TaskPanelKind={}));let Ee=b=class{constructor(L,ee){if(typeof L!="string"||typeof ee!="string")throw(0,R.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return b.Clean;case"build":return b.Build;case"rebuild":return b.Rebuild;case"test":return b.Test;default:return}}get id(){return this._id}};Ee.Clean=new b("clean","Clean"),Ee.Build=new b("build","Build"),Ee.Rebuild=new b("rebuild","Rebuild"),Ee.Test=new b("test","Test"),Ee=b=je([l],Ee),e.TaskGroup=Ee;function ae(U){let L="";for(let ee=0;ee<U.length;ee++)L+=U[ee].replace(/,/g,",,")+",";return L}let V=class{constructor(L,ee,De){if(typeof L!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=L,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=De):this._options=ee)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,R.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)L.push(ee);return ae(L)}};V=je([l],V),e.ProcessExecution=V;let Me=class{constructor(L,ee,De){if(this._args=[],Array.isArray(ee)){if(!L)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,R.illegalArgument)("command");this._command=L,this._args=ee,this._options=De}else{if(typeof L!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=L,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,R.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)L.push(typeof ee=="string"?ee:ee.value);return ae(L)}};Me=je([l],Me),e.ShellExecution=Me;var Te;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(Te=e.ShellQuoting||(e.ShellQuoting={}));var Ze;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Ze=e.TaskScope||(e.TaskScope={}));class it{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=it;let ut=A=class{constructor(L,ee,De,Ge,tt,ct){this.__deprecated=!1,this._definition=this.definition=L;let ft;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=De,this.execution=Ge,ft=tt,this.__deprecated=!0):ee===Ze.Global||ee===Ze.Workspace?(this.target=ee,this._name=this.name=De,this._source=this.source=Ge,this.execution=tt,ft=ct):(this.target=ee,this._name=this.name=De,this._source=this.source=Ge,this.execution=tt,ft=ct),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof V?this._definition={type:A.ProcessType,id:this._execution.computeId()}:this._execution instanceof Me?this._definition={type:A.ShellType,id:this._execution.computeId()}:this._execution instanceof it?this._definition={type:A.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:A.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ee=this._definition.type;(A.EmptyType===ee||A.ProcessType===ee||A.ShellType===ee||A.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};ut.ExtensionCallbackType="customExecution",ut.ProcessType="process",ut.ShellType="shell",ut.EmptyType="$empty",ut=A=je([l],ut),e.Task=ut;var gt;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let Je=class{constructor(L,ee=dt.None){this.collapsibleState=ee,y.URI.isUri(L)?this.resourceUri=L:this.label=L}};Je=je([l],Je),e.TreeItem=Je;var dt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(dt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let at=class{constructor(L,ee){this.id=L,this.color=ee}};at=je([l],at),e.ThemeIcon=at,at.File=new at("file"),at.Folder=new at("folder");let lt=class{constructor(L){this.id=L}};lt=je([l],lt),e.ThemeColor=lt;var Pt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(L,ee){if(typeof L!="string"&&(!L||!y.URI.isUri(L)&&!y.URI.isUri(L.uri)))throw(0,R.illegalArgument)("base");if(typeof ee!="string")throw(0,R.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=y.URI.file(L),this.base=L):y.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=ee}};Ct=je([l],Ct),e.RelativePattern=Ct;let At=class{constructor(L,ee,De,Ge){this.enabled=typeof L=="boolean"?L:!0,typeof ee=="string"&&(this.condition=ee),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};At=je([l],At),e.Breakpoint=At;let Rt=class extends At{constructor(L,ee,De,Ge,tt){super(ee,De,Ge,tt);if(L===null)throw(0,R.illegalArgument)("location");this.location=L}};Rt=je([l],Rt),e.SourceBreakpoint=Rt;let yt=class extends At{constructor(L,ee,De,Ge,tt){super(ee,De,Ge,tt);this.functionName=L}};yt=je([l],yt),e.FunctionBreakpoint=yt;let Gt=class extends At{constructor(L,ee,De,Ge,tt,ct,ft){super(Ge,tt,ct,ft);if(!ee)throw(0,R.illegalArgument)("dataId");this.label=L,this.dataId=ee,this.canPersist=De}};Gt=je([l],Gt),e.DataBreakpoint=Gt;let Qt=class{constructor(L,ee,De){this.command=L,this.args=ee||[],this.options=De}};Qt=je([l],Qt),e.DebugAdapterExecutable=Qt;let mt=class{constructor(L,ee){this.port=L,this.host=ee}};mt=je([l],mt),e.DebugAdapterServer=mt;let Yt=class{constructor(L){this.path=L}};Yt=je([l],Yt),e.DebugAdapterNamedPipeServer=Yt;let Jt=class{constructor(L){this.implementation=L}};Jt=je([l],Jt),e.DebugAdapterInlineImplementation=Jt;let Dt=class{constructor(L,ee){this.range=L,this.expression=ee}};Dt=je([l],Dt),e.EvaluatableExpression=Dt;var un;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(un=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Xt=class{constructor(L,ee){this.range=L,this.text=ee}};Xt=je([l],Xt),e.InlineValueText=Xt;let Bt=class{constructor(L,ee,De=!0){this.range=L,this.variableName=ee,this.caseSensitiveLookup=De}};Bt=je([l],Bt),e.InlineValueVariableLookup=Bt;let ht=class{constructor(L,ee){this.range=L,this.expression=ee}};ht=je([l],ht),e.InlineValueEvaluatableExpression=ht;let Zt=class{constructor(L,ee){this.frameId=L,this.stoppedLocation=ee}};Zt=je([l],Zt),e.InlineValueContext=Zt;var Lt;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Lt=e.FileChangeType||(e.FileChangeType={}));let Mt=C=class extends Error{constructor(L,ee=n.FileSystemProviderErrorCode.Unknown,De){var Ge;super(y.URI.isUri(L)?L.toString(!0):L);this.code=(Ge=De==null?void 0:De.name)!==null&&Ge!==void 0?Ge:"Unknown",(0,n.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(L){return new C(L,n.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(L){return new C(L,n.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(L){return new C(L,n.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(L){return new C(L,n.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(L){return new C(L,n.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(L){return new C(L,n.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}};Mt=C=je([l],Mt),e.FileSystemError=Mt;let Vt=class{constructor(L,ee,De){this.start=L,this.end=ee,this.kind=De}};Vt=je([l],Vt),e.FoldingRange=Vt;var pn;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(pn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var cn;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(cn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var vn;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(vn=e.CommentMode||(e.CommentMode={}));class dn{constructor(L,ee=[]){this.tokenTypes=L,this.tokenModifiers=ee}}e.SemanticTokensLegend=dn;function $t(U){return typeof U=="undefined"||(0,D.isStringArray)(U)}class en{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ee=0,De=L.tokenTypes.length;ee<De;ee++)this._tokenTypeStrToInt.set(L.tokenTypes[ee],ee);for(let ee=0,De=L.tokenModifiers.length;ee<De;ee++)this._tokenModifierStrToInt.set(L.tokenModifiers[ee],ee)}}push(L,ee,De,Ge,tt){if(typeof L=="number"&&typeof ee=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(L,ee,De,Ge,tt);if(z.isRange(L)&&typeof ee=="string"&&$t(De))return this._push(L,ee,De);throw(0,R.illegalArgument)()}_push(L,ee,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const Ge=L.start.line,tt=L.start.character,ct=L.end.character-L.start.character,ft=this._tokenTypeStrToInt.get(ee);let St=0;if(De)for(const kt of De){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const Tt=this._tokenModifierStrToInt.get(kt);St|=1<<Tt>>>0}this._pushEncoded(Ge,tt,ct,ft,St)}_pushEncoded(L,ee,De,Ge,tt){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let kt=0,Tt=0;for(let Ft=0;Ft<St;Ft++){let Ot=this._data[5*Ft],an=this._data[5*Ft+1];Ot===0?(Ot=kt,an+=Tt):Ot+=kt,this._data[5*Ft]=Ot,this._data[5*Ft+1]=an,kt=Ot,Tt=an}}let ct=L,ft=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=tt,this._prevLine=L,this._prevChar=ee}static _sortAndDeltaEncode(L){let ee=[];const De=L.length/5|0;for(let ft=0;ft<De;ft++)ee[ft]=ft;ee.sort((ft,St)=>{const kt=L[5*ft],Tt=L[5*St];if(kt===Tt){const Ft=L[5*ft+1],Ot=L[5*St+1];return Ft-Ot}return kt-Tt});const Ge=new Uint32Array(L.length);let tt=0,ct=0;for(let ft=0;ft<De;ft++){const St=5*ee[ft],kt=L[St+0],Tt=L[St+1],Ft=L[St+2],Ot=L[St+3],an=L[St+4],Ln=kt-tt,Wn=Ln===0?Tt-ct:Tt,ln=5*ft;Ge[ln+0]=Ln,Ge[ln+1]=Wn,Ge[ln+2]=Ft,Ge[ln+3]=Ot,Ge[ln+4]=an,tt=kt,ct=Tt}return Ge}build(L){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),L):new Ht(en._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=en;class Ht{constructor(L,ee){this.resultId=ee,this.data=L}}e.SemanticTokens=Ht;class tn{constructor(L,ee,De){this.start=L,this.deleteCount=ee,this.data=De}}e.SemanticTokensEdit=tn;class bn{constructor(L,ee){this.resultId=ee,this.edits=L}}e.SemanticTokensEdits=bn;var wn;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(wn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Nt;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(Nt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let jt=class{constructor(){}};jt.Back={iconPath:new at("arrow-left")},jt=je([l],jt),e.QuickInputButtons=jt;var _n;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(_n=e.ExtensionKind||(e.ExtensionKind={}));class En{constructor(L,ee,De){this.badge=L,this.tooltip=ee,this.color=De}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=En;let nn=class{constructor(L){this.kind=L}};nn=je([l],nn),e.ColorTheme=nn;var rn;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(rn=e.ColorThemeKind||(e.ColorThemeKind={}));class Wt{constructor(L,ee){if(L<0)throw(0,R.illegalArgument)("start must be positive");if(ee<0)throw(0,R.illegalArgument)("end must be positive");L<=ee?(this._start=L,this._end=ee):(this._start=ee,this._end=L)}static isNotebookRange(L){return L instanceof Wt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let ee=this._start,De=this._end;return L.start!==void 0&&(ee=L.start),L.end!==void 0&&(De=L.end),ee===this._start&&De===this._end?this:new Wt(ee,De)}}e.NotebookRange=Wt;class qt{constructor(L,ee){typeof L=="object"?Object.assign(this,L):(this.inputCollapsed=L,this.outputCollapsed=ee)}with(L){let{inputCollapsed:ee,outputCollapsed:De}=L,Ge=Kt(L,["inputCollapsed","outputCollapsed"]);return ee===void 0?ee=this.inputCollapsed:ee===null&&(ee=void 0),De===void 0?De=this.outputCollapsed:De===null&&(De=void 0),ee===this.inputCollapsed&&De===this.outputCollapsed&&Object.keys(Ge).length===0?this:new qt(Object.assign({inputCollapsed:ee,outputCollapsed:De},Ge))}}e.NotebookCellMetadata=qt;class xt{constructor(L={}){Object.assign(this,L)}with(L){return new xt(L)}}e.NotebookDocumentMetadata=xt;class Re{constructor(L,ee,De,Ge,tt,ct){this.kind=L,this.value=ee,this.languageId=De,this.outputs=Ge!=null?Ge:[],this.metadata=tt,this.executionSummary=ct,Re.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ee=>Re.isNotebookCellData(ee))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Re;class sn{constructor(L,ee){this.cells=L,this.metadata=ee!=null?ee:new xt}}e.NotebookData=sn;class It{constructor(L,ee,De){if(this.mime=L,this.value=ee,this.metadata=De,(0,E.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(L){return L instanceof It?!0:L?typeof L.mime=="string":!1}static error(L){const ee={name:L.name,message:L.message,stack:L.stack};return It.json(ee,"application/vnd.code.notebook.error")}static stdout(L){return It.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return It.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ee="application/octet-stream"){return new It(ee,L)}static text(L,ee="text/plain"){const De=Be(It,m,"f",c).encode(String(L));return new It(ee,De)}static json(L,ee="application/json"){const De=JSON.stringify(L,void 0,"	");return It.text(De,ee)}}e.NotebookCellOutputItem=It,m=It,c={value:new TextEncoder};class pt{constructor(L,ee,De){this.outputs=L,typeof ee=="string"?(this.id=ee,this.metadata=De):(this.id=(0,k.generateUuid)(),this.metadata=ee!=null?ee:De)}}e.NotebookCellOutput=pt;var yn;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(yn=e.NotebookCellKind||(e.NotebookCellKind={}));var Sn;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(Sn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var hn;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(hn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var fn;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(fn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Dn{constructor(L,ee,De,Ge,tt,ct){this.text=L,this.alignment=ee,this.command=De,this.tooltip=Ge,this.priority=tt,this.accessibilityInformation=ct}}e.NotebookCellStatusBarItem=Dn;var Cn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Cn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class kn{constructor(L,ee=[]){this.uri=L,this.provides=typeof ee=="string"?[ee]:ee}}e.NotebookKernelPreload=kn;let on=class{constructor(L,ee){this.label=L,this.timestamp=ee}};on=je([l],on),e.TimelineItem=on;var mn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(mn=e.ExtensionMode||(e.ExtensionMode={}));var In;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(In=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Pn;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=4]="RegEx"})(Pn=e.StandardTokenType||(e.StandardTokenType={}));class An{constructor(L,ee){this.ranges=L,this.wordPattern=ee}}e.LinkedEditingRanges=An;class Tn{constructor(L,ee){this._port=L,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Tn;var Rn;(function(U){U[U.Unset=0]="Unset",U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Rn=e.TestResultState||(e.TestResultState={}));var X;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information",U[U.Hint=3]="Hint"})(X=e.TestMessageSeverity||(e.TestMessageSeverity={}));var ce;(function(U){U[U.Pending=0]="Pending",U[U.Resolved=1]="Resolved"})(ce=e.TestItemStatus||(e.TestItemStatus={}));const Pe=(U,L,ee,De)=>{let Ge=ee;return{enumerable:!0,configurable:!1,get(){return Ge},set(tt){De(Ge,tt)||(Ge=tt,U.bus.fire([3,L,tt]))}}},st=(U,L)=>U===L,bt=(U,L)=>U===L?!0:!U||!L?!1:U.isEqual(L);class Et{constructor(L,ee,De,Ge){this.label=ee,this.data=Ge;const tt=(0,d.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:L,enumerable:!0,writable:!1},uri:{value:De,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>tt.parent},children:{value:new T.ReadonlyMapView(tt.children),enumerable:!0,writable:!1},range:Pe(tt,"range",void 0,bt),description:Pe(tt,"description",void 0,st),runnable:Pe(tt,"runnable",!0,st),debuggable:Pe(tt,"debuggable",!1,st),status:Pe(tt,"status",ce.Resolved,st),error:Pe(tt,"error",void 0,st)})}invalidate(){(0,d.getPrivateApiFor)(this).bus.fire([2])}dispose(){const L=(0,d.getPrivateApiFor)(this);L.parent&&(0,d.getPrivateApiFor)(L.parent).children.delete(this.id),L.bus.fire([1])}addChild(L){if(!(L instanceof Et))throw new Error("Test child must be created through vscode.test.createTestItem()");const ee=(0,d.getPrivateApiFor)(this);if(ee.children.has(L.id))throw new Error(`Attempted to insert a duplicate test item ID ${L.id}`);ee.children.set(L.id,L),ee.bus.fire([0,L])}}e.TestItemImpl=Et;class Fn{constructor(L){this.message=L,this.severity=X.Error}static diff(L,ee,De){const Ge=new Fn(L);return Ge.expectedOutput=ee,Ge.actualOutput=De,Ge}}e.TestMessage=Fn;var Un;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Un=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Bn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var $n;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore"})($n=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ve[96],be([0,1,42,16,8,122,86,7,13]),function(J,e,v,R,S,T,E,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function n(r,m){m?k.set(r,m):k.delete(r)}e.setWordDefinitionFor=n;function P(r){return k.get(r)}e.getWordDefinitionFor=P;class d extends T.MirrorTextModel{constructor(m,c,p,w,a,h,f,t){super(c,p,w,a);this._proxy=m,this._languageId=h,this._isDirty=f,this._notebook=t,this._isDisposed=!1}dispose(){(0,v.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(m){return(0,y.equals)(this._lines,m)}get document(){if(!this._document){const m=this;this._document={get uri(){return m._uri},get fileName(){return m._uri.fsPath},get isUntitled(){return m._uri.scheme===R.Schemas.untitled},get languageId(){return m._languageId},get version(){return m._versionId},get isClosed(){return m._isDisposed},get isDirty(){return m._isDirty},get notebook(){return m._notebook},save(){return m._save()},getText(c){return c?m._getTextInRange(c):m.getText()},get eol(){return m._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return m._lines.length},lineAt(c){return m._lineAt(c)},offsetAt(c){return m._offsetAt(c)},positionAt(c){return m._positionAt(c)},validateRange(c){return m._validateRange(c)},validatePosition(c){return m._validatePosition(c)},getWordRangeAtPosition(c,p){return m._getWordRangeAtPosition(c,p)}}}return Object.freeze(this._document)}_acceptLanguageId(m){(0,v.ok)(!this._isDisposed),this._languageId=m}_acceptIsDirty(m){(0,v.ok)(!this._isDisposed),this._isDirty=m}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(m){const c=this._validateRange(m);if(c.isEmpty)return"";if(c.isSingleLine)return this._lines[c.start.line].substring(c.start.character,c.end.character);const p=this._eol,w=c.start.line,a=c.end.line,h=[];h.push(this._lines[w].substring(c.start.character));for(let f=w+1;f<a;f++)h.push(this._lines[f]);return h.push(this._lines[a].substring(0,c.end.character)),h.join(p)}_lineAt(m){let c;if(m instanceof D.Position?c=m.line:typeof m=="number"&&(c=m),typeof c!="number"||c<0||c>=this._lines.length||Math.floor(c)!==c)throw new Error("Illegal value for `line`");return new g(c,this._lines[c],c===this._lines.length-1)}_offsetAt(m){return m=this._validatePosition(m),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(m.line-1)+m.character}_positionAt(m){m=Math.floor(m),m=Math.max(0,m),this._ensureLineStarts();const c=this._lineStarts.getIndexOf(m),p=this._lines[c.index].length;return new D.Position(c.index,Math.min(c.remainder,p))}_validateRange(m){if(!(m instanceof D.Range))throw new Error("Invalid argument");const c=this._validatePosition(m.start),p=this._validatePosition(m.end);return c===m.start&&p===m.end?m:new D.Range(c.line,c.character,p.line,p.character)}_validatePosition(m){if(!(m instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return m.with(0,0);let{line:c,character:p}=m,w=!1;if(c<0)c=0,p=0,w=!0;else if(c>=this._lines.length)c=this._lines.length-1,p=this._lines[c].length,w=!0;else{const a=this._lines[c].length;p<0?(p=0,w=!0):p>a&&(p=a,w=!0)}return w?new D.Position(c,p):m}_getWordRangeAtPosition(m,c){const p=this._validatePosition(m);if(!c)c=P(this._languageId);else if((0,S.regExpLeadsToEndlessLoop)(c))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${c.source}' because it matches the empty string.`);const w=(0,E.getWordAtText)(p.character+1,(0,E.ensureValidWordDefinition)(c),this._lines[p.line],0);if(w)return new D.Range(p.line,w.startColumn-1,p.line,w.endColumn-1)}}e.ExtHostDocumentData=d;class g{constructor(m,c,p){this._line=m,this._text=c,this._isLastLine=p}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(ve[164],be([0,1,7,3,88,6,60,22,2,37]),function(J,e,v,R,S,T,E,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(d,g,r,m){this._notebook=r,this._selector=m,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(p=>{const w=this._cellUris.get(p.document.uri);w!==void 0&&(this._cellLengths.changeValue(w,this._cells[w].document.getText().length+1),this._cellLines.changeValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const c=p=>{p===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeNotebookCells(p=>c(p.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const d=[],g=[];for(const r of this._notebook.getCells())r.kind===v.NotebookCellKind.Code&&(!this._selector||(0,E.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),d.push(r.document.getText().length+1),g.push(r.document.lineCount));this._cellLengths=new S.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new S.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(d){var g,r;if(!d){let a="";for(const h of this._cells)a+=h.document.getText()+`
`;return a=a.slice(0,-1),a}if(d.isEmpty)return"";const m=this.locationAt(d.start),c=this.locationAt(d.end),p=this._cells[(g=this._cellUris.get(m.uri))!==null&&g!==void 0?g:-1],w=this._cells[(r=this._cellUris.get(c.uri))!==null&&r!==void 0?r:-1];if(!p||!w)return"";if(p===w)return p.document.getText(new v.Range(m.range.start,c.range.end));{const a=p.document.getText(new v.Range(m.range.start,new v.Position(p.document.lineCount,0))),h=w.document.getText(new v.Range(new v.Position(0,0),c.range.end));return a+`
`+h}}offsetAt(d){const g=this._cellLines.getIndexOf(d.line),r=this._cellLengths.getAccumulatedValue(g.index-1),m=this._cells[g.index].document.offsetAt(d.with(g.remainder));return r+m}positionAt(d){if(typeof d=="number"){const r=this._cellLengths.getIndexOf(d),m=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(m)}const g=this._cellUris.get(d.uri);if(g!==void 0){const r=this._cellLines.getAccumulatedValue(g-1);return new v.Position(r+d.range.start.line,d.range.start.character)}return new v.Position(0,0)}locationAt(d){v.Range.isRange(d)||(d=new v.Range(d,d));const g=this._cellLines.getIndexOf(d.start.line);let r=g;d.isEmpty||(r=this._cellLines.getIndexOf(d.end.line));const m=new v.Position(g.remainder,d.start.character),c=new v.Position(r.remainder,d.end.character),p=new v.Range(m,c),w=this._cells[g.index];return new v.Location(w.document.uri,w.document.validateRange(p))}contains(d){return this._cellUris.has(d)}validateRange(d){const g=this.validatePosition(d.start),r=this.validatePosition(d.end);return d.with(g,r)}validatePosition(d){const g=this._cellLines.getIndexOf(d.line),r=new v.Position(g.remainder,d.character),m=this._cells[g.index].document.validatePosition(r),c=this._cellLines.getAccumulatedValue(g.index-1);return new v.Position(c+m.line,m.character)}}e.ExtHostNotebookConcatDocument=n}),define(ve[165],be([0,1,7,15,3]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(D){this._actual=new v.ColorTheme(v.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let y=D==="light"?v.ColorThemeKind.Light:D==="dark"?v.ColorThemeKind.Dark:v.ColorThemeKind.HighContrast;this._actual=new v.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=je([qe(0,R.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(ve[72],be([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,v.createDecorator)("IURITransformerService");class R{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=E=>E,this.transformOutgoing=E=>E,this.transformOutgoingURI=E=>E,this.transformOutgoingScheme=E=>E)}}e.URITransformerService=R}),define(ve[166],be([0,1,23]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(y){let k=this.buffers.indexOf(y);return k<0&&(k=this.buffers.length,this.buffers.push(y)),k}}function S(D,y){if(y.serializeBuffersForPostMessage){const k=new R,n=(g,r)=>{if(r instanceof ArrayBuffer){const m=k.add(r);return{$$vscode_array_buffer_reference$$:!0,index:m}}else if(ArrayBuffer.isView(r)){const m=T(r);if(m){const c=k.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:c,view:{type:m,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},P=JSON.stringify(D,n),d=k.buffers.map(g=>{const r=new Uint8Array(g);return v.VSBuffer.wrap(r)});return{message:P,buffers:d}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=S;function T(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function E(D,y){const k=y.map(d=>{const g=new ArrayBuffer(d.byteLength);return new Uint8Array(g).set(d.buffer),g}),n=y.length?(d,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const r=g,{index:m}=r,c=k[m];if(r.view)switch(r.view.type){case 1:return new Int8Array(c,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(c,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(c,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(c,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(c,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(c,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(c,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(c,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(c,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(c,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(c,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return g}:void 0;return{message:JSON.parse(D,n),arrayBuffers:k}}e.deserializeWebviewMessage=E}),define(ve[73],be([0,1,16,2]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function S(T,E){return T.scheme===v.Schemas.http||T.scheme===v.Schemas.https?T:(E&&E.authority&&E.isRemote&&T.scheme===v.Schemas.file&&(T=R.URI.from({scheme:v.Schemas.vscodeRemote,authority:E.authority,path:T.path})),R.URI.from({scheme:v.Schemas.https,authority:`${T.scheme}+${T.authority}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=S}),define(ve[167],be([0,1,3,6,73]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(D,y,k){this._proxy=D,this._editors=y,this._initData=k,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const n=y.getVisibleTextEditors();for(const P of this._insets.values())n.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,y,k,n,P){let d;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===D){d=a;break}if(!d)throw new Error("not a visible editor");const g=this,r=this._handlePool++,m=new v.Emitter,c=new v.Emitter,p=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,S.asWebviewUri)(a,g._initData.remote)}get cspSource(){return S.webviewGenericCspSource}set options(a){this._options=a,g._proxy.$setOptions(r,a)}get options(){return this._options}set html(a){this._html=a,g._proxy.$setHtml(r,a)}get html(){return this._html}get onDidReceiveMessage(){return m.event}postMessage(a){return g._proxy.$postMessage(r,a)}},w=new class{constructor(){this.editor=D,this.line=y,this.height=k,this.webview=p,this.onDidDispose=c.event}dispose(){g._insets.has(r)&&(g._insets.delete(r),g._proxy.$disposeEditorInset(r),c.fire(),c.dispose(),m.dispose())}};return this._proxy.$createEditorInset(r,d.id,d.value.document.uri,y+1,k,n||{},P.identifier,P.extensionLocation),this._insets.set(r,{editor:D,inset:w,onDidReceiveMessage:m}),w}$onDidDispose(D){const y=this._insets.get(D);y&&y.inset.dispose()}$onDidReceiveMessage(D,y){const k=this._insets.get(D);k&&k.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=T}),define(ve[168],be([0,1,3,64,139,4,6,22,29,13,52,24,35,160]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,g.registerIcon)("default-view-icon",d.Codicon.window,(0,S.localize)(0,null));var r;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var m;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel"})(m=e.ViewContainerLocation||(e.ViewContainerLocation={}));function c(u){switch(u){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=c;function p(u){return`viewContainer.${u}.enabled`}e.getEnabledViewContainerContextKey=p;class w extends E.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new v.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new v.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(_,b,A){var C;const l=this.get(_.id);if(l)return l;const F=_;return F.openCommandActionDescriptor=(A==null?void 0:A.donotRegisterOpenCommand)?void 0:(C=F.openCommandActionDescriptor)!==null&&C!==void 0?C:{id:F.id},(0,D.getOrSet)(this.viewContainers,b,[]).push(F),(A==null?void 0:A.isDefault)&&this.defaultViewContainers.push(F),this._onDidRegister.fire({viewContainer:F,viewContainerLocation:b}),F}deregisterViewContainer(_){for(const b of this.viewContainers.keys()){const A=this.viewContainers.get(b),C=A==null?void 0:A.indexOf(_);if(C!==-1){A==null||A.splice(C,1),A.length===0&&this.viewContainers.delete(b),this._onDidDeregister.fire({viewContainer:_,viewContainerLocation:b});return}}}get(_){return this.all.filter(b=>b.id===_)[0]}getViewContainers(_){return[...this.viewContainers.get(_)||[]]}getViewContainerLocation(_){return[...this.viewContainers.keys()].filter(b=>this.getViewContainers(b).filter(A=>(A==null?void 0:A.id)===_.id).length>0)[0]}getDefaultViewContainer(_){return this.defaultViewContainers.find(b=>this.getViewContainerLocation(b)===_)}}y.Registry.add(r.ViewContainersRegistry,new w);var a;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function h(u,_){var b,A,C,l;const F=(b=u.group)!==null&&b!==void 0?b:a.More,N=(A=_.group)!==null&&A!==void 0?A:a.More;return F!==N?F.localeCompare(N):((C=u.order)!==null&&C!==void 0?C:5)-((l=_.order)!==null&&l!==void 0?l:5)}class f extends E.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new v.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new v.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new v.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new v.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(_,b){this.registerViews2([{views:_,viewContainer:b}])}registerViews2(_){_.forEach(({views:b,viewContainer:A})=>this.addViews(b,A)),this._onViewsRegistered.fire(_)}deregisterViews(_,b){const A=this.removeViews(_,b);A.length&&this._onViewsDeregistered.fire({views:A,viewContainer:b})}moveViews(_,b){for(const A of this._views.keys())if(A!==b){const C=this.removeViews(_,A);C.length&&(this.addViews(C,b),this._onDidChangeContainer.fire({views:C,from:A,to:b}))}}getViews(_){return this._views.get(_)||[]}getView(_){for(const b of this._viewContainers){const A=(this._views.get(b)||[]).filter(C=>C.id===_)[0];if(A)return A}return null}getViewContainer(_){for(const b of this._viewContainers)if((this._views.get(b)||[]).filter(C=>C.id===_)[0])return b;return null}registerViewWelcomeContent(_,b){return this._viewWelcomeContents.add(_,b),this._onDidChangeViewWelcomeContent.fire(_),(0,E.toDisposable)(()=>{this._viewWelcomeContents.delete(_,b),this._onDidChangeViewWelcomeContent.fire(_)})}registerViewWelcomeContent2(_,b){const A=new Map;for(const[C,l]of b)this._viewWelcomeContents.add(_,l),A.set(C,(0,E.toDisposable)(()=>{this._viewWelcomeContents.delete(_,l),this._onDidChangeViewWelcomeContent.fire(_)}));return this._onDidChangeViewWelcomeContent.fire(_),A}getViewWelcomeContent(_){const b=[];return this._viewWelcomeContents.forEach(_,A=>b.push(A)),b.sort(h)}addViews(_,b){let A=this._views.get(b);A||(A=[],this._views.set(b,A),this._viewContainers.push(b));for(const C of _){if(this.getView(C.id)!==null)throw new Error((0,S.localize)(1,null,C.id));A.push(C)}}removeViews(_,b){const A=this._views.get(b);if(!A)return[];const C=[],l=[];for(const F of A)_.includes(F)?C.push(F):l.push(F);return C.length&&(l.length?this._views.set(b,l):(this._views.delete(b),this._viewContainers.splice(this._viewContainers.indexOf(b),1))),C}}y.Registry.add(r.ViewsRegistry,new f),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",(0,S.localize)(2,null));function t(u){return`view.${u}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var i;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(i=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class o{constructor(_,b){this.resolved=!1,this._hasResolve=!1,(0,P.mixin)(this,_),this._hasResolve=!!b,this.resolve=async A=>{var C,l;if(b&&!this.resolved){const F=await b(A);F&&(this.tooltip=(C=this.tooltip)!==null&&C!==void 0?C:F.tooltip,this.command=(l=this.command)!==null&&l!==void 0?l:F.command)}A.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o}),define(ve[169],be([0,1,2,149,161,17,150,168]),function(J,e,v,R,S,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(r){return(m,...c)=>r(m.get(R.ICommandService),...c)}class k{static execute(m,c){const p={forceReuseWindow:c&&c.reuseWindow,remoteAuthority:c&&c.remoteAuthority};return m.executeCommand("_files.newWindow",p)}}e.NewWindowAPICommand=k,k.ID="vscode.newWindow",R.CommandsRegistry.registerCommand({id:k.ID,handler:y(k.execute),description:{description:"Opens an new window",args:[]}}),R.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(r,m){return r.get(S.IWorkspacesService).removeRecentlyOpened([m])});class n{static execute(m,c){return typeof c=="string"?c=c.match(/^[^:/?#]+:\/\//)?v.URI.parse(c):v.URI.file(c):c=v.URI.revive(c),m.executeCommand("_workbench.removeFromRecentlyOpened",c)}}e.RemoveFromRecentlyOpenedAPICommand=n,n.ID="vscode.removeFromRecentlyOpened",R.CommandsRegistry.registerCommand(n.ID,y(n.execute)),R.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(r,m){const c=r.get(S.IWorkspacesService);let p;const w=m.uri,a=m.label,h=m.remoteAuthority;return m.type==="workspace"?p={workspace:await c.getWorkspaceIdentifier(w),label:a,remoteAuthority:h}:m.type==="folder"?p={folderUri:w,label:a,remoteAuthority:h}:p={fileUri:w,label:a,remoteAuthority:h},c.addRecentlyOpened([p])}),R.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(r){return r.get(S.IWorkspacesService).getRecentlyOpened()}),R.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(r,m){const c=r.get(T.ILogService),p=r.get(E.IEnvironmentService);p.isExtensionDevelopment&&!!p.extensionTestsLocationURI&&c.setLevel(m)}),R.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(r){return r.get(T.ILogService).getLevel()}),R.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(r,m){const c=r.get(D.IViewDescriptorService),p=c.getViewContainerById(m.destinationId);if(!!p){for(const w of m.viewIds){const a=c.getViewDescriptorById(w);(a==null?void 0:a.canMoveView)&&c.moveViewsToContainer([a],p,D.ViewVisibilityState.Default)}await r.get(D.IViewsService).openViewContainer(p.id,!0)}});class P{static execute(m,c){return!Array.isArray(c==null?void 0:c.viewIds)||typeof(c==null?void 0:c.destinationId)!="string"?Promise.reject("Invalid arguments"):m.executeCommand("_workbench.action.moveViews",c)}}e.MoveViewsAPICommand=P,P.ID="vscode.moveViews",R.CommandsRegistry.registerCommand({id:P.ID,handler:y(P.execute),description:{description:"Move Views",args:[]}});class d{static execute(m,c){return m.executeCommand("_workbench.open",c)}}d.ID="vscode.open",R.CommandsRegistry.registerCommand(d.ID,y(d.execute));class g{static execute(m,c,p,w,a){return m.executeCommand("_workbench.diff",[c,p,w])}}g.ID="vscode.diff",R.CommandsRegistry.registerCommand(g.ID,y(g.execute))}),define(ve[170],be([0,1,3,11,140]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new v.Emitter,this._onExit=new v.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,y,k,n){const P={command:D};if(y&&Object.keys(y).length>0&&(P.arguments=y),this.internalSend("request",P),typeof n=="number"){const d=setTimeout(()=>{clearTimeout(d);const g=this.pendingRequests.get(P.seq);if(g){this.pendingRequests.delete(P.seq);const r={type:"response",seq:0,request_seq:P.seq,success:!1,command:D,message:(0,S.localize)(0,null,n,D)};g(r)}},n)}return k&&this.pendingRequests.set(P.seq,k),P.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,y){return D.type!=="event"||y.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,R.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const y=D,k=this.pendingRequests.get(y.request_seq);k&&(this.pendingRequests.delete(y.request_seq),k(y));break}}}internalSend(D,y){y.type=D,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((y,k)=>D.set(k,y)),await(0,R.timeout)(500),D.forEach((y,k)=>{y({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(ve[171],be([0,1,8,2,14,24,16]),function(J,e,v,R,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function y(i,s,o){return i.replace(D,function(u,_){return s&&_.length>0&&_[0]!=="_"?u:o&&o.hasOwnProperty(_)?o[_]:u})}e.formatPII=y;function k(i){const s={};for(const o of Object.keys(i))o.startsWith("!")||(s[o]=i[o]);return s}e.filterExceptionsFromTelemetry=k;function n(i){return i.configuration.request==="attach"&&!P(i)}e.isSessionAttach=n;function P(i){let s=i.configuration.type;if(!!s)return s==="vslsShare"&&(s=i.configuration.adapterProxy.configuration.type),(0,v.equalsIgnoreCase)(s,"extensionhost")||(0,v.equalsIgnoreCase)(s,"pwa-extensionhost")?i:i.parentSession?P(i.parentSession):void 0}e.getExtensionHostDebugSession=P;function d(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=d;function g(i,s,o){let u,_=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,A=null;for(;A=b.exec(i);){let C=A.index+1,l=C+A[0].length;if(C<=s&&l>=o){u=A[0],_=C;break}}if(u){let C=/\w+/g,l=null;for(;(l=C.exec(u))&&!(l.index+1+_+l[0].length>=o););l&&(u=u.substring(0,C.lastIndex))}return u?{start:_,end:_+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(i){return!!(i&&i.match(r))}e.isUri=m;function c(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(m(i.path))return R.URI.parse(i.path);if((0,S.isAbsolute)(i.path))return R.URI.file(i.path)}return i.path}function p(i){if(typeof i.path=="object"){const s=R.URI.revive(i.path);if(s)return s.scheme===E.Schemas.file?s.fsPath:s.toString()}return i.path}function w(i,s){const o=s?c:p,u=(0,T.deepClone)(i);return h(u,(_,b)=>{_&&b&&(b.path=o(b))}),u}e.convertToDAPaths=w;function a(i,s){const o=s?c:p,u=(0,T.deepClone)(i);return h(u,(_,b)=>{!_&&b&&(b.path=o(b))}),u}e.convertToVSCPaths=a;function h(i,s){switch(i.type){case"event":const o=i;switch(o.event){case"output":s(!1,o.body.source);break;case"loadedSource":s(!1,o.body.source);break;case"breakpoint":s(!1,o.body.breakpoint.source);break;default:break}break;case"request":const u=i;switch(u.command){case"setBreakpoints":s(!0,u.arguments.source);break;case"breakpointLocations":s(!0,u.arguments.source);break;case"source":s(!0,u.arguments.source);break;case"gotoTargets":s(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(b=>s(!1,b));break;default:break}break;case"response":const _=i;if(_.success&&_.body)switch(_.command){case"stackTrace":_.body.stackFrames.forEach(b=>s(!1,b.source));break;case"loadedSources":_.body.sources.forEach(b=>s(!1,b));break;case"scopes":_.body.scopes.forEach(b=>s(!1,b.source));break;case"setFunctionBreakpoints":_.body.breakpoints.forEach(b=>s(!1,b.source));break;case"setBreakpoints":_.body.breakpoints.forEach(b=>s(!1,b.source));break;default:break}break}}function f(i){return i.filter(s=>{var o;return!((o=s.presentation)===null||o===void 0?void 0:o.hidden)}).sort((s,o)=>s.presentation?o.presentation?s.presentation.group?o.presentation.group?s.presentation.group!==o.presentation.group?s.presentation.group.localeCompare(o.presentation.group):t(s.presentation.order,o.presentation.order):-1:o.presentation.group?1:t(s.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=f;function t(i,s){return typeof i!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:i-s}}),define(ve[50],be([0,1,28,16,14,21,64]),function(J,e,v,R,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarPosition=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(C){C[C.Markup=1]="Markup",C[C.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(C){C[C.Running=1]="Running",C[C.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var k;(function(C){C[C.Pending=2]="Pending",C[C.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var n;(function(C){C[C.WithHardKernelDependency=0]="WithHardKernelDependency",C[C.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",C[C.Pure=2]="Pure",C[C.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var P;(function(C){C[C.ModelChange=1]="ModelChange",C[C.Move=2]="Move",C[C.CellClearOutput=3]="CellClearOutput",C[C.CellsClearOutput=4]="CellsClearOutput",C[C.ChangeLanguage=5]="ChangeLanguage",C[C.Initialize=6]="Initialize",C[C.ChangeCellMetadata=7]="ChangeCellMetadata",C[C.Output=8]="Output",C[C.OutputItem=9]="OutputItem",C[C.ChangeCellContent=10]="ChangeCellContent",C[C.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",C[C.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",C[C.Unknown=100]="Unknown"})(P=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(C){C[C.Handle=0]="Handle",C[C.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(C){C[C.Replace=1]="Replace",C[C.Output=2]="Output",C[C.Metadata=3]="Metadata",C[C.CellLanguage=4]="CellLanguage",C[C.DocumentMetadata=5]="DocumentMetadata",C[C.Move=6]="Move",C[C.OutputItems=7]="OutputItems",C[C.PartialMetadata=8]="PartialMetadata",C[C.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));function r(C,l){if(l)return C.toString();const F=m.parse(C);return F?F.notebook.toString():C.toString()}e.getCellUndoRedoComparisonKey=r;var m;(function(C){C.scheme=R.Schemas.vscodeNotebookCell;const l=/^ch(\d{7,})/;function F($,q){return $.with({scheme:C.scheme,fragment:`ch${q.toString().padStart(7,"0")}${$.scheme!==R.Schemas.file?$.scheme:""}`})}C.generate=F;function N($){if($.scheme!==C.scheme)return;const q=l.exec($.fragment);return q?{handle:Number(q[1]),notebook:$.with({scheme:$.fragment.substr(q[0].length)||R.Schemas.file,fragment:null})}:void 0}C.parse=N;function z($){if($.scheme!==R.Schemas.vscodeNotebookCellMetadata)return;const q=l.exec($.fragment);return q?{handle:Number(q[1]),notebook:$.with({scheme:$.fragment.substr(q[0].length)||R.Schemas.file,fragment:null})}:void 0}C.parseCellMetadataUri=z;function de($,q,x){return $.with({scheme:x,fragment:`ch${q.toString().padStart(7,"0")}${$.scheme!==R.Schemas.file?$.scheme:""}`})}C.generateCellUri=de;function he($,q){if($.scheme!==q)return;const x=l.exec($.fragment);return x?{handle:Number(x[1]),notebook:$.with({scheme:$.fragment.substr(x[0].length)||R.Schemas.file,fragment:null})}:void 0}C.parseCellUri=he})(m=e.CellUri||(e.CellUri={}));const c=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}]]);function p(C){var l,F;return(F=(l=c.get(C))===null||l===void 0?void 0:l.alwaysSecure)!==null&&F!==void 0?F:!1}e.mimeTypeIsAlwaysSecure=p;function w(C){var l,F;return(F=(l=c.get(C))===null||l===void 0?void 0:l.supportedByCore)!==null&&F!==void 0?F:!1}e.mimeTypeSupportedByCore=w;function a(C){var l,F;return(F=(l=c.get(C))===null||l===void 0?void 0:l.mergeable)!==null&&F!==void 0?F:!1}e.mimeTypeIsMergeable=a;function h(C,l){return T.isWindows&&(C=C.replace(/\//g,"\\"),l=l.replace(/\//g,"\\")),v.match(C,l)}function f(C,l,F){let N=0;for(let z=0;z<l.length;z++){if(h(l[z],C))return N;N++}for(let z=0;z<F.length;z++){if(h(F[z],C))return N;N++}return N}function t(C,l,F){return C.sort((N,z)=>f(N,l,F)-f(z,l,F))}e.sortMimeTypes=t;function i(C,l,F,N=(z,de)=>z===de){const z=[];function de(q,x,I){if(x===0&&I.length===0)return;const H=z[z.length-1];H&&H.start+H.deleteCount===q?(H.deleteCount+=x,H.toInsert.push(...I)):z.push({start:q,deleteCount:x,toInsert:I})}let he=0,$=0;for(;;){if(he===C.length){de(he,0,l.slice($));break}if($===l.length){de(he,C.length-he,[]);break}const q=C[he],x=l[$];if(N(q,x)){he+=1,$+=1;continue}F(x)?(de(he,1,[]),he+=1):(de(he,0,[x]),$+=1)}return z}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new E.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(C){C.default="default",C.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(C){const l=C;return!!((typeof l.include=="string"||v.isRelativePattern(l.include))&&(typeof l.exclude=="string"||v.isRelativePattern(l.exclude)))}e.isDocumentExcludePattern=o;function u(C,l,F){if(Array.isArray(C.viewType)&&C.viewType.indexOf(l)>=0||C.viewType===l)return!0;if(C.filenamePattern){let N=o(C.filenamePattern)?C.filenamePattern.include:C.filenamePattern,z=o(C.filenamePattern)?C.filenamePattern.exclude:void 0;if(v.match(N,(0,S.basename)(F.fsPath).toLowerCase()))return!(z&&v.match(z,(0,S.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u;class _{constructor(l){this.textModel=l}getElements(){const l=new Int32Array(this.textModel.cells.length);for(let F=0;F<this.textModel.cells.length;F++)l[F]=this.textModel.cells[F].getHashValue();return l}}e.CellSequence=_,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarPosition="notebook.insertToolbarPosition",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled";var b;(function(C){C[C.Left=1]="Left",C[C.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class A{static create(l){return`${A._prefix}${l}`}static parse(l){if(l.startsWith(A._prefix))return l.substr(A._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=A,A._prefix="notebook/"}),define(ve[172],be([0,1,142,4,64]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new S.RawContextKey("customExecutionSupported",!0,v.localize(0,null)),e.ShellExecutionSupportedContext=new S.RawContextKey("shellExecutionSupported",!1,v.localize(1,null)),e.ProcessExecutionSupportedContext=new S.RawContextKey("processExecutionSupported",!1,v.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[173],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function v(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=v;function R(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=R}),define(ve[97],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var v;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(y,k)=>{k.expand!==void 0&&(y.expand=k.expand),k.item!==void 0&&(y.item=y.item?Object.assign(y.item,k.item):k.item)};e.applyTestItemUpdate=R;var S;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",y[y.Retire=4]="Retire"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(y,k)=>`${y}:${k.toString()}`;e.getTestSubscriptionKey=T;class E{add(k){}update(k){}remove(k,n){}complete(){}}e.IncrementalChangeCollector=E;class D{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const n=this.createChangeCollector();for(const P of k)switch(P[0]){case 0:{const d=P[1];if(d.parent){if(this.items.has(d.parent)){const g=this.items.get(d.parent);g.children.add(d.item.extId);const r=this.createItem(d,g);this.items.set(d.item.extId,r),n.add(r)}}else{this.roots.add(d.item.extId);const g=this.createItem(d);this.items.set(d.item.extId,g),n.add(g)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=P[1],g=this.items.get(d.extId);if(!g)break;d.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(g,d),n.update(g);break}case 2:{const d=this.items.get(P[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d.item.extId);const g=[[P[1]]];for(;g.length;)for(const r of g.pop()){const m=this.items.get(r);m&&(g.push(m.children),this.items.delete(r),n.remove(m,m!==d),m.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(P[1]);break;case 3:this.updatePendingRoots(P[1]);break}n.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new E}}e.AbstractIncrementalTestCollection=D}),define(ve[174],be([0,1,14,46,10,24,21,59,143]),function(J,e,v,R,S,T,E,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(P,d,g){this._contributedVariables=new Map,this._context=P,this._labelService=d,g&&(this._envVariablesPromise=g.then(r=>this.prepareEnv(r)))}prepareEnv(P){if(E.isWindows){const d=Object.create(null);return Object.keys(P).forEach(g=>{d[g.toLowerCase()]=P[g]}),d}return P}resolveWithEnvironment(P,d,g){return this.recursiveResolve(this.prepareEnv(P),d?d.uri:void 0,g)}async resolveAsync(P,d){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,d)}async resolveAnyBase(P,d,g,r){const m=T.deepClone(d);return E.isWindows&&m.windows?Object.keys(m.windows).forEach(c=>m[c]=m.windows[c]):E.isMacintosh&&m.osx?Object.keys(m.osx).forEach(c=>m[c]=m.osx[c]):E.isLinux&&m.linux&&Object.keys(m.linux).forEach(c=>m[c]=m.linux[c]),delete m.windows,delete m.osx,delete m.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,m,g,r)}async resolveAnyAsync(P,d,g){return this.resolveAnyBase(P,d,g)}async resolveAnyMap(P,d,g){const r=new Map;return{newConfig:await this.resolveAnyBase(P,d,g,r),resolvedVariables:r}}resolveWithInteractionReplace(P,d,g,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,d,g,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,d){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,d)}recursiveResolve(P,d,g,r,m){if(S.isString(g))return this.resolveString(P,d,g,r,m);if(S.isArray(g))return g.map(c=>this.recursiveResolve(P,d,c,r,m));if(S.isObject(g)){let c=Object.create(null);return Object.keys(g).forEach(p=>{const w=this.resolveString(P,d,p,r,m);c[w]=this.recursiveResolve(P,d,g[p],r,m)}),c}return g}resolveString(P,d,g,r,m){return g.replace(k.VARIABLE_REGEXP,(p,w)=>{if(w.includes(k.VARIABLE_LHS))return p;let a=this.evaluateSingleVariable(P,p,w,d,r);return m&&m.set(w,a),a})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,d,g,r,m){let c;const p=g.split(":");p.length>1&&(g=p[0],c=p[1]);const w=()=>{const f=this._context.getFilePath();if(f)return f;throw new Error((0,y.localize)(0,null,d))},a=()=>{const f=w();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,d,v.basename(f)))},h=()=>{if(c){const f=this._context.getFolderUri(c);if(f)return f;throw new Error((0,y.localize)(2,null,d,c))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,d)):new Error((0,y.localize)(4,null,d))};switch(g){case"env":if(c){if(P){const f=P[E.isWindows?c.toLowerCase():c];if(S.isString(f))return f}return""}throw new Error((0,y.localize)(5,null,d));case"config":if(c){const f=this._context.getConfigurationValue(r,c);if(S.isUndefinedOrNull(f))throw new Error((0,y.localize)(6,null,d,c));if(S.isObject(f))throw new Error((0,y.localize)(7,null,d,c));return f}throw new Error((0,y.localize)(8,null,d));case"command":return this.resolveFromMap(d,c,m,"command");case"input":return this.resolveFromMap(d,c,m,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(h()));case"cwd":return r||c?(0,D.normalizeDriveLetter)(this.fsPath(h())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return v.basename(this.fsPath(h()));case"lineNumber":const f=this._context.getLineNumber();if(f)return f;throw new Error((0,y.localize)(9,null,d));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,d));case"file":return w();case"fileWorkspaceFolder":return a();case"relativeFile":return r||c?v.relative(this.fsPath(h()),w()):w();case"relativeFileDirname":const i=v.dirname(w());if(r||c){const _=v.relative(this.fsPath(h()),i);return _.length===0?".":_}return i;case"fileDirname":return v.dirname(w());case"fileExtname":return v.extname(w());case"fileBasename":return v.basename(w());case"fileBasenameNoExtension":const s=v.basename(w());return s.slice(0,s.length-v.extname(s).length);case"fileDirnameBasename":return v.basename(v.dirname(w()));case"execPath":const o=this._context.getExecPath();return o||d;case"execInstallFolder":const u=this._context.getAppRoot();return u||d;case"pathSeparator":return v.sep;default:try{const _=c?`${g}:${c}`:g;return this.resolveFromMap(d,_,m,void 0)}catch(_){return d}}}}resolveFromMap(P,d,g,r){if(d&&g){const m=r===void 0?g[d]:g[r+":"+d];if(typeof m=="string")return m;throw new Error((0,y.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[175],be([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,v.createDecorator)("editorGroupsService");var R;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(R=e.GroupDirection||(e.GroupDirection={}));var S;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(S=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var E;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(E=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.EDITOR_OPEN=2]="EDITOR_OPEN",d[d.EDITOR_CLOSE=3]="EDITOR_CLOSE",d[d.EDITOR_MOVE=4]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=6]="EDITOR_LABEL",d[d.EDITOR_PIN=7]="EDITOR_PIN",d[d.EDITOR_STICKY=8]="EDITOR_STICKY",d[d.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function P(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=P}),define(ve[176],be([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,v.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ve[9],be([0,1,13,23,83,230,58,24,10,2,31,63,144,90,50,176,7]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var p;(function(ie){function Ee(V){const{selectionStartLineNumber:Me,selectionStartColumn:Te,positionLineNumber:Ze,positionColumn:it}=V,ut=new c.Position(Me-1,Te-1),gt=new c.Position(Ze-1,it-1);return new c.Selection(ut,gt)}ie.to=Ee;function ae(V){const{anchor:Me,active:Te}=V;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}ie.from=ae})(p=e.Selection||(e.Selection={}));var w;(function(ie){function Ee(V){if(!V)return;const{start:Me,end:Te}=V;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}ie.from=Ee;function ae(V){if(!V)return;const{startLineNumber:Me,startColumn:Te,endLineNumber:Ze,endColumn:it}=V;return new c.Range(Me-1,Te-1,Ze-1,it-1)}ie.to=ae})(w=e.Range||(e.Range={}));var a;(function(ie){function Ee(ae){switch(ae){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 4:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}ie.to=Ee})(a=e.TokenType||(e.TokenType={}));var h;(function(ie){function Ee(V){return new c.Position(V.lineNumber-1,V.column-1)}ie.to=Ee;function ae(V){return{lineNumber:V.line+1,column:V.character+1}}ie.from=ae})(h=e.Position||(e.Position={}));var f;(function(ie){function Ee(V){switch(V){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}ie.from=Ee;function ae(V){switch(V){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}ie.to=ae})(f=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(ie){function Ee(V){let Me;return V.code&&((0,y.isString)(V.code)||(0,y.isNumber)(V.code)?Me=String(V.code):Me={value:String(V.code.value),target:V.code.target}),Object.assign(Object.assign({},w.from(V.range)),{message:V.message,source:V.source,code:Me,severity:s.from(V.severity),relatedInformation:V.relatedInformation&&V.relatedInformation.map(i.from),tags:Array.isArray(V.tags)?(0,v.coalesce)(V.tags.map(f.from)):void 0})}ie.from=Ee;function ae(V){var Me;const Te=new c.Diagnostic(w.to(V),V.message,s.to(V.severity));return Te.source=V.source,Te.code=(0,y.isString)(V.code)?V.code:(Me=V.code)===null||Me===void 0?void 0:Me.value,Te.relatedInformation=V.relatedInformation&&V.relatedInformation.map(i.to),Te.tags=V.tags&&(0,v.coalesce)(V.tags.map(f.to)),Te}ie.to=ae})(t=e.Diagnostic||(e.Diagnostic={}));var i;(function(ie){function Ee(V){return Object.assign(Object.assign({},w.from(V.location.range)),{message:V.message,resource:V.location.uri})}ie.from=Ee;function ae(V){return new c.DiagnosticRelatedInformation(new c.Location(V.resource,w.to(V)),V.message)}ie.to=ae})(i=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var s;(function(ie){function Ee(V){switch(V){case c.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}ie.from=Ee;function ae(V){switch(V){case g.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}ie.to=ae})(s=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(ie){function Ee(V){return typeof V=="number"&&V>=c.ViewColumn.One?V-1:V===c.ViewColumn.Beside?m.SIDE_GROUP:m.ACTIVE_GROUP}ie.from=Ee;function ae(V){if(typeof V=="number"&&V>=0)return V+1;throw new Error("invalid 'EditorGroupColumn'")}ie.to=ae})(o=e.ViewColumn||(e.ViewColumn={}));function u(ie){return typeof ie.range!="undefined"}function _(ie){return ie.length===0?!0:!!u(ie[0])}e.isDecorationOptionsArr=_;var b;(function(ie){function Ee(it){return it.map(ie.from)}ie.fromMany=Ee;function ae(it){return it&&typeof it=="object"&&typeof it.language=="string"&&typeof it.value=="string"}function V(it){let ut;if(ae(it)){const{language:at,value:lt}=it;ut={value:"```"+at+`
`+lt+"\n```\n"}}else c.MarkdownString.isMarkdownString(it)?ut={value:it.value,isTrusted:it.isTrusted,supportThemeIcons:it.supportThemeIcons}:typeof it=="string"?ut={value:it}:ut={value:""};const gt=Object.create(null);ut.uris=gt;const Je=at=>{try{let lt=k.URI.parse(at,!0);lt=lt.with({query:Me(lt.query,gt)}),gt[at]=lt}catch(lt){}return""},dt=new T.Renderer;return dt.link=Je,dt.image=at=>Je(S.parseHrefAndDimensions(at).href),T(ut.value,{renderer:dt}),ut}ie.from=V;function Me(it,ut){if(!it)return it;let gt;try{gt=(0,E.parse)(it)}catch(dt){}if(!gt)return it;let Je=!1;return gt=(0,D.cloneAndChange)(gt,dt=>{if(k.URI.isUri(dt)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[at]=dt,Je=!0,at}else return}),Je?JSON.stringify(gt):it}function Te(it){const ut=new c.MarkdownString(it.value,it.supportThemeIcons);return ut.isTrusted=it.isTrusted,ut}ie.to=Te;function Ze(it){if(!!it)return typeof it=="string"?it:ie.from(it)}ie.fromStrict=Ze})(b=e.MarkdownString||(e.MarkdownString={}));function A(ie){return _(ie)?ie.map(Ee=>({range:w.from(Ee.range),hoverMessage:Array.isArray(Ee.hoverMessage)?b.fromMany(Ee.hoverMessage):Ee.hoverMessage?b.from(Ee.hoverMessage):void 0,renderOptions:Ee.renderOptions})):ie.map(Ee=>({range:w.from(Ee)}))}e.fromRangeOrRangeWithMessage=A;function C(ie){return typeof ie=="undefined"?ie:typeof ie=="string"?k.URI.file(ie):ie}e.pathOrURIToURI=C;var l;(function(ie){function Ee(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?C(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}ie.from=Ee})(l=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(ie){function Ee(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?C(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?l.from(ae.before):void 0,after:ae.after?l.from(ae.after):void 0}}ie.from=Ee})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var N;(function(ie){function Ee(ae){if(typeof ae=="undefined")return ae;switch(ae){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}ie.from=Ee})(N=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var z;(function(ie){function Ee(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?N.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?F.from(ae.light):void 0,dark:ae.dark?F.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?C(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?l.from(ae.before):void 0,after:ae.after?l.from(ae.after):void 0}}ie.from=Ee})(z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var de;(function(ie){function Ee(V){return{text:V.newText,eol:V.newEol&&me.from(V.newEol),range:w.from(V.range)}}ie.from=Ee;function ae(V){const Me=new c.TextEdit(w.to(V.range),V.text);return Me.newEol=typeof V.eol=="undefined"?void 0:me.to(V.eol),Me}ie.to=ae})(de=e.TextEdit||(e.TextEdit={}));var he;(function(ie){function Ee(V,Me,Te){var Ze,it,ut;const gt={edits:[]};if(V instanceof c.WorkspaceEdit)for(let Je of V._allEntries())if(Je._type===1)gt.edits.push({_type:1,oldUri:Je.from,newUri:Je.to,options:Je.options,metadata:Je.metadata});else if(Je._type===2){const dt=Me==null?void 0:Me.getDocument(Je.uri);gt.edits.push({_type:2,resource:Je.uri,edit:de.from(Je.edit),modelVersionId:dt==null?void 0:dt.version,metadata:Je.metadata})}else Je._type===3?gt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:(Ze=Te==null?void 0:Te.getNotebookDocument(Je.uri,!0))===null||Ze===void 0?void 0:Ze.apiNotebook.version}):Je._type===4?(Je.newOutputs&&gt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:2,index:Je.index,append:Je.append,outputs:Je.newOutputs.map(Le.from)}}),Je.newMetadata&&gt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:8,index:Je.index,metadata:Je.newMetadata}})):Je._type===5?gt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,notebookVersionId:(it=Te==null?void 0:Te.getNotebookDocument(Je.uri,!0))===null||it===void 0?void 0:it.apiNotebook.version,edit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(ke.from)}}):Je._type===6&&gt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:7,outputId:Je.outputId,items:((ut=Je.newOutputItems)===null||ut===void 0?void 0:ut.map(Ie.from))||[],append:Je.append}});return gt}ie.from=Ee;function ae(V){const Me=new c.WorkspaceEdit;for(const Te of V.edits)Te.edit?Me.replace(k.URI.revive(Te.resource),w.to(Te.edit.range),Te.edit.text):Me.renameFile(k.URI.revive(Te.oldUri),k.URI.revive(Te.newUri),Te.options);return Me}ie.to=ae})(he=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(ie){const Ee=Object.create(null);Ee[c.SymbolKind.File]=0,Ee[c.SymbolKind.Module]=1,Ee[c.SymbolKind.Namespace]=2,Ee[c.SymbolKind.Package]=3,Ee[c.SymbolKind.Class]=4,Ee[c.SymbolKind.Method]=5,Ee[c.SymbolKind.Property]=6,Ee[c.SymbolKind.Field]=7,Ee[c.SymbolKind.Constructor]=8,Ee[c.SymbolKind.Enum]=9,Ee[c.SymbolKind.Interface]=10,Ee[c.SymbolKind.Function]=11,Ee[c.SymbolKind.Variable]=12,Ee[c.SymbolKind.Constant]=13,Ee[c.SymbolKind.String]=14,Ee[c.SymbolKind.Number]=15,Ee[c.SymbolKind.Boolean]=16,Ee[c.SymbolKind.Array]=17,Ee[c.SymbolKind.Object]=18,Ee[c.SymbolKind.Key]=19,Ee[c.SymbolKind.Null]=20,Ee[c.SymbolKind.EnumMember]=21,Ee[c.SymbolKind.Struct]=22,Ee[c.SymbolKind.Event]=23,Ee[c.SymbolKind.Operator]=24,Ee[c.SymbolKind.TypeParameter]=25;function ae(Me){return typeof Ee[Me]=="number"?Ee[Me]:6}ie.from=ae;function V(Me){for(const Te in Ee)if(Ee[Te]===Me)return Number(Te);return c.SymbolKind.Property}ie.to=V})($=e.SymbolKind||(e.SymbolKind={}));var q;(function(ie){function Ee(V){switch(V){case c.SymbolTag.Deprecated:return 1}}ie.from=Ee;function ae(V){switch(V){case 1:return c.SymbolTag.Deprecated}}ie.to=ae})(q=e.SymbolTag||(e.SymbolTag={}));var x;(function(ie){function Ee(V){return{name:V.name,kind:$.from(V.kind),tags:V.tags&&V.tags.map(q.from),containerName:V.containerName,location:G.from(V.location)}}ie.from=Ee;function ae(V){const Me=new c.SymbolInformation(V.name,$.to(V.kind),V.containerName,G.to(V.location));return Me.tags=V.tags&&V.tags.map(q.to),Me}ie.to=ae})(x=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var I;(function(ie){function Ee(V){var Me,Te;const Ze={name:V.name||"!!MISSING: name!!",detail:V.detail,range:w.from(V.range),selectionRange:w.from(V.selectionRange),kind:$.from(V.kind),tags:(Te=(Me=V.tags)===null||Me===void 0?void 0:Me.map(q.from))!==null&&Te!==void 0?Te:[]};return V.children&&(Ze.children=V.children.map(Ee)),Ze}ie.from=Ee;function ae(V){const Me=new c.DocumentSymbol(V.name,V.detail,$.to(V.kind),w.to(V.range),w.to(V.selectionRange));return(0,v.isNonEmptyArray)(V.tags)&&(Me.tags=V.tags.map(q.to)),V.children&&(Me.children=V.children.map(ae)),Me}ie.to=ae})(I=e.DocumentSymbol||(e.DocumentSymbol={}));var H;(function(ie){function Ee(ae){const V=new c.CallHierarchyItem($.to(ae.kind),ae.name,ae.detail||"",k.URI.revive(ae.uri),w.to(ae.range),w.to(ae.selectionRange));return V._sessionId=ae._sessionId,V._itemId=ae._itemId,V}ie.to=Ee})(H=e.CallHierarchyItem||(e.CallHierarchyItem={}));var M;(function(ie){function Ee(ae){return new c.CallHierarchyIncomingCall(H.to(ae.from),ae.fromRanges.map(V=>w.to(V)))}ie.to=Ee})(M=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var B;(function(ie){function Ee(ae){return new c.CallHierarchyOutgoingCall(H.to(ae.to),ae.fromRanges.map(V=>w.to(V)))}ie.to=Ee})(B=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var G;(function(ie){function Ee(V){return{range:V.range&&w.from(V.range),uri:V.uri}}ie.from=Ee;function ae(V){return new c.Location(k.URI.revive(V.uri),w.to(V.range))}ie.to=ae})(G=e.location||(e.location={}));var K;(function(ie){function Ee(V){const Me=V,Te=V;return{originSelectionRange:Me.originSelectionRange?w.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Te.uri,range:w.from(Me.targetRange?Me.targetRange:Te.range),targetSelectionRange:Me.targetSelectionRange?w.from(Me.targetSelectionRange):void 0}}ie.from=Ee;function ae(V){return{targetUri:k.URI.revive(V.uri),targetRange:w.to(V.range),targetSelectionRange:V.targetSelectionRange?w.to(V.targetSelectionRange):void 0,originSelectionRange:V.originSelectionRange?w.to(V.originSelectionRange):void 0}}ie.to=ae})(K=e.DefinitionLink||(e.DefinitionLink={}));var se;(function(ie){function Ee(V){return{range:w.from(V.range),contents:b.fromMany(V.contents)}}ie.from=Ee;function ae(V){return new c.Hover(V.contents.map(b.to),w.to(V.range))}ie.to=ae})(se=e.Hover||(e.Hover={}));var pe;(function(ie){function Ee(V){return{range:w.from(V.range),expression:V.expression}}ie.from=Ee;function ae(V){return new c.EvaluatableExpression(w.to(V.range),V.expression)}ie.to=ae})(pe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Fe;(function(ie){function Ee(V){if(V instanceof c.InlineValueText)return{type:"text",range:w.from(V.range),text:V.text};if(V instanceof c.InlineValueVariableLookup)return{type:"variable",range:w.from(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};if(V instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(V.range),expression:V.expression};throw new Error("Unknown 'InlineValue' type")}ie.from=Ee;function ae(V){switch(V.type){case"text":return{range:w.to(V.range),text:V.text};case"variable":return{range:w.to(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};case"expression":return{range:w.to(V.range),expression:V.expression}}}ie.to=ae})(Fe=e.InlineValue||(e.InlineValue={}));var We;(function(ie){function Ee(V){return{frameId:V.frameId,stoppedLocation:w.from(V.stoppedLocation)}}ie.from=Ee;function ae(V){return new c.InlineValueContext(V.frameId,w.to(V.stoppedLocation))}ie.to=ae})(We=e.InlineValueContext||(e.InlineValueContext={}));var Ne;(function(ie){function Ee(V){return{range:w.from(V.range),kind:V.kind}}ie.from=Ee;function ae(V){return new c.DocumentHighlight(w.to(V.range),V.kind)}ie.to=ae})(Ne=e.DocumentHighlight||(e.DocumentHighlight={}));var ze;(function(ie){function Ee(ae){switch(ae){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}ie.to=Ee})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ve;(function(ie){function Ee(ae){return{triggerKind:ze.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}ie.to=Ee})(Ve=e.CompletionContext||(e.CompletionContext={}));var W;(function(ie){function Ee(V){switch(V){case c.CompletionItemTag.Deprecated:return 1}}ie.from=Ee;function ae(V){switch(V){case 1:return c.CompletionItemTag.Deprecated}}ie.to=ae})(W=e.CompletionItemTag||(e.CompletionItemTag={}));var Q;(function(ie){const Ee=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function ae(Te){var Ze;return(Ze=Ee.get(Te))!==null&&Ze!==void 0?Ze:9}ie.from=ae;const V=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Me(Te){var Ze;return(Ze=V.get(Te))!==null&&Ze!==void 0?Ze:c.CompletionItemKind.Property}ie.to=Me})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(ie){function Ee(ae,V){var Me;const Te=new c.CompletionItem(typeof ae.label=="string"?ae.label:ae.label.name);return typeof ae.label!="string"&&(Te.label2=ae.label),Te.insertText=ae.insertText,Te.kind=Q.to(ae.kind),Te.tags=(Me=ae.tags)===null||Me===void 0?void 0:Me.map(W.to),Te.detail=ae.detail,Te.documentation=S.isMarkdownString(ae.documentation)?b.to(ae.documentation):ae.documentation,Te.sortText=ae.sortText,Te.filterText=ae.filterText,Te.preselect=ae.preselect,Te.commitCharacters=ae.commitCharacters,n.Range.isIRange(ae.range)?Te.range=w.to(ae.range):typeof ae.range=="object"&&(Te.range={inserting:w.to(ae.range.insert),replacing:w.to(ae.range.replace)}),Te.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Te.insertText=new c.SnippetString(ae.insertText):(Te.insertText=ae.insertText,Te.textEdit=Te.range instanceof c.Range?new c.TextEdit(Te.range,Te.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Te.additionalTextEdits=ae.additionalTextEdits.map(Ze=>de.to(Ze))),Te.command=V&&ae.command?V.fromInternal(ae.command):void 0,Te}ie.to=Ee})(te=e.CompletionItem||(e.CompletionItem={}));var re;(function(ie){function Ee(V){return{label:V.label,documentation:V.documentation?b.fromStrict(V.documentation):void 0}}ie.from=Ee;function ae(V){return{label:V.label,documentation:S.isMarkdownString(V.documentation)?b.to(V.documentation):V.documentation}}ie.to=ae})(re=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(ie){function Ee(V){return{label:V.label,documentation:V.documentation?b.fromStrict(V.documentation):void 0,parameters:Array.isArray(V.parameters)?V.parameters.map(re.from):[],activeParameter:V.activeParameter}}ie.from=Ee;function ae(V){return{label:V.label,documentation:S.isMarkdownString(V.documentation)?b.to(V.documentation):V.documentation,parameters:Array.isArray(V.parameters)?V.parameters.map(re.to):[],activeParameter:V.activeParameter}}ie.to=ae})(fe=e.SignatureInformation||(e.SignatureInformation={}));var _e;(function(ie){function Ee(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(fe.from):[]}}ie.from=Ee;function ae(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(fe.to):[]}}ie.to=ae})(_e=e.SignatureHelp||(e.SignatureHelp={}));var ue;(function(ie){function Ee(V){var Me;return{text:V.text,position:h.from(V.position),kind:we.from((Me=V.kind)!==null&&Me!==void 0?Me:c.InlayHintKind.Other),whitespaceBefore:V.whitespaceBefore,whitespaceAfter:V.whitespaceAfter}}ie.from=Ee;function ae(V){const Me=new c.InlayHint(V.text,h.to(V.position),we.to(V.kind));return Me.whitespaceAfter=V.whitespaceAfter,Me.whitespaceBefore=V.whitespaceBefore,Me}ie.to=ae})(ue=e.InlayHint||(e.InlayHint={}));var we;(function(ie){function Ee(V){return V}ie.from=Ee;function ae(V){return V}ie.to=ae})(we=e.InlayHintKind||(e.InlayHintKind={}));var Ae;(function(ie){function Ee(V){return{range:w.from(V.range),url:V.target,tooltip:V.tooltip}}ie.from=Ee;function ae(V){let Me;if(V.url)try{Me=typeof V.url=="string"?k.URI.parse(V.url,!0):k.URI.revive(V.url)}catch(Te){}return new c.DocumentLink(w.to(V.range),Me)}ie.to=ae})(Ae=e.DocumentLink||(e.DocumentLink={}));var xe;(function(ie){function Ee(V){const Me=new c.ColorPresentation(V.label);return V.textEdit&&(Me.textEdit=de.to(V.textEdit)),V.additionalTextEdits&&(Me.additionalTextEdits=V.additionalTextEdits.map(Te=>de.to(Te))),Me}ie.to=Ee;function ae(V){return{label:V.label,textEdit:V.textEdit?de.from(V.textEdit):void 0,additionalTextEdits:V.additionalTextEdits?V.additionalTextEdits.map(Me=>de.from(Me)):void 0}}ie.from=ae})(xe=e.ColorPresentation||(e.ColorPresentation={}));var ge;(function(ie){function Ee(V){return new c.Color(V[0],V[1],V[2],V[3])}ie.to=Ee;function ae(V){return[V.red,V.green,V.blue,V.alpha]}ie.from=ae})(ge=e.Color||(e.Color={}));var Ke;(function(ie){function Ee(V){return{range:w.from(V.range)}}ie.from=Ee;function ae(V){return new c.SelectionRange(w.to(V.range))}ie.to=ae})(Ke=e.SelectionRange||(e.SelectionRange={}));var j;(function(ie){function Ee(ae){switch(ae){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}ie.to=Ee})(j=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Z;(function(ie){function Ee(V){switch(V){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}ie.from=Ee;function ae(V){switch(V){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}ie.to=ae})(Z=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var me;(function(ie){function Ee(V){if(V===c.EndOfLine.CRLF)return 1;if(V===c.EndOfLine.LF)return 0}ie.from=Ee;function ae(V){if(V===1)return c.EndOfLine.CRLF;if(V===0)return c.EndOfLine.LF}ie.to=ae})(me=e.EndOfLine||(e.EndOfLine={}));var Oe;(function(ie){function Ee(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ie.from=Ee})(Oe=e.ProgressLocation||(e.ProgressLocation={}));var He;(function(ie){function Ee(ae){const V={start:ae.start+1,end:ae.end+1};return ae.kind&&(V.kind=$e.from(ae.kind)),V}ie.from=Ee})(He=e.FoldingRange||(e.FoldingRange={}));var $e;(function(ie){function Ee(ae){if(ae)switch(ae){case c.FoldingRangeKind.Comment:return P.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return P.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return P.FoldingRangeKind.Region}}ie.from=Ee})($e=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Xe;(function(ie){function Ee(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?w.from(ae.selection):void 0,override:typeof ae.override=="boolean"?d.EditorOverride.DISABLED:void 0}}ie.from=Ee})(Xe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ye;(function(ie){function Ee(V){return V instanceof c.RelativePattern||typeof V=="string"?V:ae(V)?new c.RelativePattern(V.base,V.pattern):V}ie.from=Ee;function ae(V){const Me=V;return Me&&typeof Me.base=="string"&&typeof Me.pattern=="string"}})(ye=e.GlobPattern||(e.GlobPattern={}));var Se;(function(ie){function Ee(ae){if(ae){if(Array.isArray(ae))return ae.map(Ee);if(typeof ae=="string")return ae;{const V=ae;return{language:V.language,scheme:V.scheme,pattern:typeof V.pattern=="undefined"?void 0:ye.from(V.pattern),exclusive:V.exclusive}}}else return}ie.from=Ee})(Se=e.LanguageSelector||(e.LanguageSelector={}));var Ce;(function(ie){function Ee(V){return{start:V.start,end:V.end}}ie.from=Ee;function ae(V){return new c.NotebookRange(V.start,V.end)}ie.to=ae})(Ce=e.NotebookRange||(e.NotebookRange={}));var ne;(function(ie){function Ee(ae){return new c.NotebookCellMetadata().with(Object.assign(Object.assign({},ae),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}ie.to=Ee})(ne=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var le;(function(ie){function Ee(V){return V}ie.from=Ee;function ae(V){return new c.NotebookDocumentMetadata().with(V)}ie.to=ae})(le=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var O;(function(ie){function Ee(V){return{startTime:V.runStartTime,endTime:V.runEndTime,executionOrder:V.executionOrder,success:V.lastRunSuccess}}ie.to=Ee;function ae(V){return{lastRunSuccess:V.success,runStartTime:V.startTime,runEndTime:V.endTime,executionOrder:V.executionOrder}}ie.from=ae})(O=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Y;(function(ie){function Ee(V){switch(V){case c.NotebookCellKind.Markup:return r.CellKind.Markup;case c.NotebookCellKind.Code:default:return r.CellKind.Code}}ie.from=Ee;function ae(V){switch(V){case r.CellKind.Markup:return c.NotebookCellKind.Markup;case r.CellKind.Code:default:return c.NotebookCellKind.Code}}ie.to=ae})(Y=e.NotebookCellKind||(e.NotebookCellKind={}));var oe;(function(ie){function Ee(V){const Me={metadata:le.from(V.metadata),cells:[]};for(let Te of V.cells)c.NotebookCellData.validate(Te),Me.cells.push(ke.from(Te));return Me}ie.from=Ee;function ae(V){return{metadata:le.to(V.metadata),cells:V.cells.map(ke.to)}}ie.to=ae})(oe=e.NotebookData||(e.NotebookData={}));var ke;(function(ie){function Ee(V){var Me;return{cellKind:Y.from(V.kind),language:V.languageId,source:V.value,metadata:V.metadata,internalMetadata:O.from((Me=V.executionSummary)!==null&&Me!==void 0?Me:{}),outputs:V.outputs?V.outputs.map(Le.from):[]}}ie.from=Ee;function ae(V){return new c.NotebookCellData(Y.to(V.cellKind),V.source,V.language,V.outputs?V.outputs.map(Le.to):void 0,V.metadata?ne.to(V.metadata):void 0)}ie.to=ae})(ke=e.NotebookCellData||(e.NotebookCellData={}));var Ie;(function(ie){function Ee(V){let Me,Te;return V.value instanceof Uint8Array?Te=Array.from(V.value):Me=V.value,{metadata:V.metadata,mime:V.mime,value:Me,valueBytes:Te}}ie.from=Ee;function ae(V){let Me;return V.value instanceof R.VSBuffer?Me=V.value.buffer:Me=V.value,new c.NotebookCellOutputItem(V.mime,Me,V.metadata)}ie.to=ae})(Ie=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Le;(function(ie){function Ee(V){return{outputId:V.id,outputs:V.outputs.map(Ie.from),metadata:V.metadata}}ie.from=Ee;function ae(V){const Me=V.outputs.map(Ie.to);return new c.NotebookCellOutput(Me,V.outputId,V.metadata)}ie.to=ae})(Le=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ue;(function(ie){function Ee(Te){if(Te!=null){if(Te instanceof c.RelativePattern||typeof Te=="string")return Te;if(Me(Te))return new c.RelativePattern(Te.base,Te.pattern);if(V(Te))return{include:ye.from(Te.include)||void 0,exclude:ye.from(Te.exclude)||void 0}}}ie.from=Ee;function ae(Te){return typeof Te=="string"?Te:Me(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}ie.to=ae;function V(Te){const Ze=Te,it=ye.from(Ze.include);if(!(it&&it instanceof c.RelativePattern||typeof it=="string"))return!1;const ut=ye.from(Ze.exclude);return!!(ut&&ut instanceof c.RelativePattern||typeof ut=="string")}function Me(Te){const Ze=Te;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Ue=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Qe;(function(ie){function Ee(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?l.from(ae.top):void 0}}ie.from=Ee})(Qe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var rt;(function(ie){function Ee(ae,V,Me){const Te=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:V.toInternal(Te,Me),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}ie.from=Ee})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var et;(function(ie){function Ee(ae){var V,Me,Te;return{transientOutputs:(V=ae==null?void 0:ae.transientOutputs)!==null&&V!==void 0?V:!1,transientCellMetadata:(Me=ae==null?void 0:ae.transientCellMetadata)!==null&&Me!==void 0?Me:{},transientDocumentMetadata:(Te=ae==null?void 0:ae.transientDocumentMetadata)!==null&&Te!==void 0?Te:{}}}ie.from=Ee})(et=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ye;(function(ie){function Ee(V){var Me;return{uri:V.uri,provides:typeof V.provides=="string"?[V.provides]:(Me=V.provides)!==null&&Me!==void 0?Me:[]}}ie.from=Ee;function ae(V){return new c.NotebookKernelPreload(k.URI.revive(V.uri),V.provides)}ie.to=ae})(Ye=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var ot;(function(ie){function Ee(V){return{message:b.fromStrict(V.message)||"",severity:V.severity,expectedOutput:V.expectedOutput,actualOutput:V.actualOutput,location:V.location?G.from(V.location):void 0}}ie.from=Ee;function ae(V){const Me=new c.TestMessage(typeof V.message=="string"?V.message:b.to(V.message));return Me.severity=V.severity,Me.actualOutput=V.actualOutput,Me.expectedOutput=V.expectedOutput,Me}ie.to=ae})(ot=e.TestMessage||(e.TestMessage={}));var _t;(function(ie){function Ee(Te){var Ze,it;return{extId:Te.id,label:Te.label,uri:Te.uri,range:w.from(Te.range)||null,debuggable:(Ze=Te.debuggable)!==null&&Ze!==void 0?Ze:!1,description:Te.description||null,runnable:(it=Te.runnable)!==null&&it!==void 0?it:!0,error:Te.error&&b.fromStrict(Te.error)||null}}ie.from=Ee;function ae(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:w.from(Te.range)||null,debuggable:!1,description:Te.description||null,error:null,runnable:!0}}ie.fromResultSnapshot=ae;function V(Te){return{id:Te.extId,label:Te.label,uri:k.URI.revive(Te.uri),range:w.to(Te.range||void 0),addChild:()=>{},dispose:()=>{},status:c.TestItemStatus.Pending,data:void 0,debuggable:Te.debuggable,description:Te.description||void 0,runnable:Te.runnable}}ie.toPlain=V;function Me(Te){const Ze=new c.TestItemImpl(Te.extId,Te.label,k.URI.revive(Te.uri),void 0);return Ze.range=w.to(Te.range||void 0),Ze.debuggable=Te.debuggable,Ze.description=Te.description||void 0,Ze.runnable=Te.runnable,Ze}ie.to=Me})(_t=e.TestItem||(e.TestItem={}));var wt;(function(ie){const Ee=(V,Me)=>Object.assign(Object.assign({},_t.toPlain(V.item)),{taskStates:V.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.map(ot.to)})),children:V.children.map(Te=>Me.get(Te)).filter(y.isDefined).map(Te=>Ee(Te,Me))});function ae(V){const Me=[],Te=new Map;for(const Ze of V.items)Te.set(Ze.item.extId,Ze),Ze.direct&&Me.push(Ze);return{completedAt:V.completedAt,results:Me.map(Ze=>Ee(Ze,Te))}}ie.to=ae})(wt=e.TestResults||(e.TestResults={}));var vt;(function(ie){function Ee(ae){switch(ae){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}ie.to=Ee})(vt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ve[177],be([0,1,2,12,7,9,45]),function(J,e,v,R,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(k,n,P,d={timeout:1500,errors:3}){this._logService=k,this._documents=n,this._mainThreadBulkEdits=P,this._thresholds=d,this._callbacks=new E.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(n,P,d)=>{const r={dispose:this._callbacks.push([n,P,k])};return Array.isArray(d)&&d.push(r),r}}async $participateInSave(k,n){const P=v.URI.revive(k);let d=!1;const g=setTimeout(()=>d=!0,this._thresholds.timeout),r=[];try{for(let m of[...this._callbacks]){if(d)break;const c=this._documents.getDocument(P),p=await this._deliverEventAsyncAndBlameBadListeners(m,{document:c,reason:T.TextDocumentSaveReason.to(n)});r.push(p)}}finally{clearTimeout(g)}return r}_deliverEventAsyncAndBlameBadListeners([k,n,P],d){const g=this._badListeners.get(k);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,k,n,d).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const m=this._badListeners.get(k);this._badListeners.set(k,m?m+1:1),typeof m=="number"&&m>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,n,P,d){const g=[],r=Date.now(),{document:m,reason:c}=d,{version:p}=m,w=Object.freeze({document:m,reason:c,waitUntil(a){if(Object.isFrozen(g))throw(0,R.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(a))}});try{n.apply(P,[w])}catch(a){return Promise.reject(a)}return Object.freeze(g),new Promise((a,h)=>{const f=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(f),a(t)}).catch(t=>{clearTimeout(f),h(t)})}).then(a=>{const h={edits:[]};for(const f of a)if(Array.isArray(f)&&f.every(t=>t instanceof S.TextEdit))for(const{newText:t,newEol:i,range:s}of f)h.edits.push({_type:2,resource:m.uri,edit:{range:s&&T.Range.from(s),text:t,eol:i&&T.EndOfLine.from(i)}});if(h.edits.length!==0)return p===m.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(ve[178],be([0,1,3,11,28,2,9,7]),function(J,e,v,R,S,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(P,d,g,r,m){this._onDidCreate=new v.Emitter,this._onDidChange=new v.Emitter,this._onDidDelete=new v.Emitter,this._config=0,g&&(this._config+=1),r&&(this._config+=2),m&&(this._config+=4);const c=(0,S.parse)(d),p=P(w=>{if(!g)for(let a of w.created){const h=T.URI.revive(a);c(h.fsPath)&&this._onDidCreate.fire(h)}if(!r)for(let a of w.changed){const h=T.URI.revive(a);c(h.fsPath)&&this._onDidChange.fire(h)}if(!m)for(let a of w.deleted){const h=T.URI.revive(a);c(h.fsPath)&&this._onDidDelete.fire(h)}});this._disposable=D.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,p)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(P,d,g){this._logService=d,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new v.Emitter,this._onDidRenameFile=new v.Emitter,this._onDidCreateFile=new v.Emitter,this._onDidDeleteFile=new v.Emitter,this._onWillRenameFile=new R.AsyncEmitter,this._onWillCreateFile=new R.AsyncEmitter,this._onWillDeleteFile=new R.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(P,d,g,r){return new y(this._onFileSystemEvent.event,P,d,g,r)}$onFileEvent(P){this._onFileSystemEvent.fire(P)}$onDidRunFileOperation(P,d){switch(P){case 2:this._onDidRenameFile.fire(Object.freeze({files:d.map(g=>({oldUri:T.URI.revive(g.source),newUri:T.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:d.map(g=>T.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:d.map(g=>T.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(P){return this._createWillExecuteEvent(P,this._onWillRenameFile)}getOnWillCreateFileEvent(P){return this._createWillExecuteEvent(P,this._onWillCreateFile)}getOnWillDeleteFileEvent(P){return this._createWillExecuteEvent(P,this._onWillDeleteFile)}_createWillExecuteEvent(P,d){return(g,r,m)=>{const c=function(w){g.call(r,w)};return c.extension=P,d.event(c,void 0,m)}}async $onWillRunFileOperation(P,d,g,r){switch(P){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:d.map(m=>({oldUri:T.URI.revive(m.source),newUri:T.URI.revive(m.target)}))},g,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:d.map(m=>T.URI.revive(m.target))},g,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:d.map(m=>T.URI.revive(m.target))},g,r)}}async _fireWillEvent(P,d,g,r){const m=new Set,c=[];if(await P.fireAsync(d,r,async(w,a)=>{var h;const f=Date.now(),t=await Promise.resolve(w);t instanceof D.WorkspaceEdit&&(c.push(t),m.add((h=a.extension.displayName)!==null&&h!==void 0?h:a.extension.identifier.value)),Date.now()-f>g&&this._logService.warn("SLOW file-participant",a.extension.identifier)}),r.isCancellationRequested||c.length===0)return;const p={edits:[]};for(let w of c){let{edits:a}=E.WorkspaceEdit.from(w,this._extHostDocumentsAndEditors);p.edits=p.edits.concat(a)}return{edit:p,extensionNames:Array.from(m)}}}e.ExtHostFileSystemEventService=k}),define(ve[179],be([0,1,16,24,2,9,7,50]),function(J,e,v,R,S,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(d,g,r,m){this.start=d,this.deletedCount=g,this.deletedItems=r,this.items=m}static asApiEvents(d){return d.map(g=>({start:g.start,deletedCount:g.deletedCount,deletedItems:g.deletedItems,items:g.items.map(r=>r.apiCell)}))}}class k{constructor(d,g,r){var m,c,p;this.notebook=d,this._extHostDocument=g,this._cellData=r,this.handle=r.handle,this.uri=S.URI.revive(r.uri),this.cellKind=r.cellKind,this._outputs=r.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(m=r.internalMetadata)!==null&&m!==void 0?m:{},this._metadata=T.NotebookCellMetadata.to((c=r.metadata)!==null&&c!==void 0?c:{}),this._previousResult=T.NotebookCellExecutionSummary.to((p=r.internalMetadata)!==null&&p!==void 0?p:{})}static asModelAddData(d,g){return{EOL:g.eol,lines:g.source,modeId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:d}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const d=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return d.notebook.getCellIndex(d)},notebook:d.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get outputs(){return d._outputs.slice(0)},get metadata(){return d._metadata},get executionSummary(){return d._previousResult}})}return this._apiCell}setOutputs(d){this._outputs=d.map(T.NotebookCellOutput.to)}setOutputItems(d,g,r){const m=r.map(T.NotebookCellOutputItem.to),c=this._outputs.find(p=>p.id===d);c&&(g||(c.outputs.length=0),c.outputs.push(...m))}setMetadata(d){this._metadata=T.NotebookCellMetadata.to(d)}setInternalMetadata(d){this._internalMetadata=d,this._previousResult=T.NotebookCellExecutionSummary.to(d)}}e.ExtHostCell=k;class n{constructor(d,g,r,m,c,p,w){this._proxy=d,this._textDocumentsAndEditors=g,this._textDocuments=r,this._emitter=m,this._viewType=c,this._metadata=p,this.uri=w,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const d=this;this._notebook={get uri(){return d.uri},get version(){return d._versionId},get viewType(){return d._viewType},get isDirty(){return d._isDirty},get isUntitled(){return d.uri.scheme===v.Schemas.untitled},get isClosed(){return d._disposed},get metadata(){return d._metadata},get cellCount(){return d._cells.length},cellAt(g){return g=d._validateIndex(g),d._cells[g].apiCell},getCells(g){return(g?d._getCells(g):d._cells).map(m=>m.apiCell)},save(){return d._save()}}}return this._notebook}updateBackup(d){var g;(g=this._backup)===null||g===void 0||g.delete(),this._backup=d}disposeBackup(){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(d){d.metadata&&(this._metadata=this._metadata.with(d.metadata))}acceptModelChanged(d,g){this._versionId=d.versionId,this._isDirty=g;for(const r of d.rawEvents)r.kind===D.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(r.changes,!0),r.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1):r.kind===D.NotebookCellsChangeType.Move?this._moveCell(r.index,r.newIdx):r.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(r.index,r.outputs):r.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems):r.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(r.index,r.language):r.kind===D.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(r.index,r.metadata):r.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(r.index,r.internalMetadata)}_validateIndex(d){return d=d|0,d<0?0:d>=this._cells.length?this._cells.length-1:d}_validateRange(d){let g=d.start|0,r=d.end|0;return g<0&&(g=0),r>this._cells.length&&(r=this._cells.length),d.with({start:g,end:r})}_getCells(d){d=this._validateRange(d);const g=[];for(let r=d.start;r<d.end;r++)g.push(this._cells[r]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(d,g){if(this._disposed)return;const r=[],m=[],c=[];d.reverse().forEach(p=>{const a=p[2].map(t=>{const i=new k(this,this._textDocumentsAndEditors,t);return g||m.push(k.asModelAddData(this.apiNotebook,t)),i}),h=new y(p[0],p[1],[],a),f=this._cells.splice(p[0],p[1],...a);for(const t of f)c.push(t.uri),h.deletedItems.push(t.apiCell);r.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:m,removedDocuments:c}),g||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(r)}))}_moveCell(d,g){const r=this._cells.splice(d,1);this._cells.splice(g,0,...r);const m=[new y(d,1,r.map(c=>c.apiCell),[]),new y(g,0,[],r)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(m)}))}_setCellOutputs(d,g){const r=this._cells[d];r.setOutputs(g),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[r.apiCell]}))}_setCellOutputItems(d,g,r,m){const c=this._cells[d];c.setOutputItems(g,r,m),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[c.apiCell]}))}_changeCellLanguage(d,g){const r=this._cells[d];r.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelModeChanged(r.uri,g)}_changeCellMetadata(d,g){const r=this._cells[d],m=r.apiCell.metadata;r.setMetadata(g);const c=r.apiCell.metadata;(0,R.equals)(m,c)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:r.apiCell}))}_changeCellInternalMetadata(d,g){var r;const m=this._cells[d],c=m.internalMetadata;if(m.setInternalMetadata(g),c.runState!==g.runState){const p=(r=g.runState)!==null&&r!==void 0?r:E.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:m.apiCell,executionState:p}))}}getCellFromApiCell(d){return this._cells.find(g=>g.apiCell===d)}getCellFromIndex(d){return this._cells[d]}getCell(d){return this._cells.find(g=>g.handle===d)}getCellIndex(d){return this._cells.indexOf(d)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(ve[98],be([0,1,7,9]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class S{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,y){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:D,metadata:y})}replaceCells(D,y,k){this._throwIfFinalized(),!(D===y&&k.length===0)&&this._collectedEdits.push({editType:1,index:D,count:y-D,cells:k.map(R.NotebookCellData.from)})}}class T{constructor(D,y,k,n,P,d){this.id=D,this._proxy=y,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=P,this._visibleRanges=n,this._viewColumn=d}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},get visibleRanges(){return D._visibleRanges},revealRange(y,k){D._proxy.$tryRevealRange(D.id,R.NotebookRange.from(y),k!=null?k:v.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(y){const k=new S(this.document.version);return y(k),D._applyEdit(k.finalize())},setDecorations(y,k){return D.setDecorations(y,k)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const y=[];let k=-1;for(let n=0;n<D.cellEdits.length;n++){if(k<0){y.push(D.cellEdits[n]),k++;continue}const d=y[k],g=D.cellEdits[n];if(d.editType===1&&g.editType===1&&d.index===g.index){d.cells.push(...D.cellEdits[n].cells),d.count+=D.cellEdits[n].count;continue}y.push(D.cellEdits[n]),k++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,y)}setDecorations(D,y){if(!(y.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return y.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(y),D.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(ve[180],be([0,1,9,155,134,20,53]),function(J,e,v,R,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,d,g){const r=this._handles++,{title:m,location:c,cancellable:p}=d,w={label:(0,S.localize)(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(r,{location:v.ProgressLocation.from(c),title:m,source:w,cancellable:p},P),this._withProgress(r,g,!!p)}_withProgress(P,d,g){let r;g&&(r=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,r));const m=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),r&&r.dispose()};let c;try{c=d(new k(this._proxy,P),g&&r?r.token:T.CancellationToken.None)}catch(p){throw m(P),p}return c.then(p=>m(P),p=>m(P)),c}$acceptProgressCanceled(P){const d=this._mapHandleToCancellationSource.get(P);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=D;function y(n,P){return n.message=P.message,typeof P.increment=="number"&&(typeof n.increment=="number"?n.increment+=P.increment:n.increment=P.increment),n}class k extends R.Progress{constructor(P,d){super(g=>this.throttledReport(g));this._proxy=P,this._handle=d}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}je([(0,E.throttle)(100,(n,P)=>y(n,P),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(ve[99],be([0,1,42,12,55,9,7]),function(J,e,v,R,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(d,g){const r=D._Keys.nextId();d.$registerTextEditorDecorationType(r,T.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:r,dispose(){d.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=D,D._Keys=new S.IdGenerator("TextEditorDecorationType");class y{constructor(d,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,g){this._throwIfFinalized();let r=null;if(d instanceof E.Position)r=new E.Range(d,d);else if(d instanceof E.Range)r=d;else throw new Error("Unrecognized location");this._pushEdit(r,g,!1)}insert(d,g){this._throwIfFinalized(),this._pushEdit(new E.Range(d,d),g,!0)}delete(d){this._throwIfFinalized();let g=null;if(d instanceof E.Range)g=d;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(d,g,r){const m=this._document.validateRange(d);this._collectedEdits.push({range:m,text:g,forceMoveMarkers:r})}setEndOfLine(d){if(this._throwIfFinalized(),d!==E.EndOfLine.LF&&d!==E.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=d}}e.TextEditorEdit=y;class k{constructor(d,g,r,m){this._proxy=d,this._id=g,this._accept(r),this._logService=m;const c=this;this.value={get tabSize(){return c._tabSize},set tabSize(p){c._setTabSize(p)},get insertSpaces(){return c._insertSpaces},set insertSpaces(p){c._setInsertSpaces(p)},get cursorStyle(){return c._cursorStyle},set cursorStyle(p){c._setCursorStyle(p)},get lineNumbers(){return c._lineNumbers},set lineNumbers(p){c._setLineNumbers(p)}}}_accept(d){this._tabSize=d.tabSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const g=Math.floor(d);return g>0?g:null}if(typeof d=="string"){const g=parseInt(d,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(d){const g=this._validateTabSize(d);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:Boolean(d)}_setInsertSpaces(d){const g=this._validateInsertSpaces(d);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(d)})))}assign(d){const g={};let r=!1;if(typeof d.tabSize!="undefined"){const m=this._validateTabSize(d.tabSize);m==="auto"?(r=!0,g.tabSize=m):typeof m=="number"&&this._tabSize!==m&&(this._tabSize=m,r=!0,g.tabSize=m)}if(typeof d.insertSpaces!="undefined"){const m=this._validateInsertSpaces(d.insertSpaces);m==="auto"?(r=!0,g.insertSpaces=m):this._insertSpaces!==m&&(this._insertSpaces=m,r=!0,g.insertSpaces=m)}typeof d.cursorStyle!="undefined"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,r=!0,g.cursorStyle=d.cursorStyle),typeof d.lineNumbers!="undefined"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,r=!0,g.lineNumbers=T.TextEditorLineNumbersStyle.from(d.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,g))}_warnOnError(d){d.catch(g=>this._logService.warn(g))}}e.ExtHostTextEditorOptions=k;class n{constructor(d,g,r,m,c,p,w,a){this.id=d,this._proxy=g,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._options=new k(this._proxy,this.id,p,r),this._visibleRanges=w,this._viewColumn=a;const h=this;this.value=Object.freeze({get document(){return m.getValue()},set document(f){throw(0,R.readonly)("document")},get selection(){return h._selections&&h._selections[0]},set selection(f){if(!(f instanceof E.Selection))throw(0,R.illegalArgument)("selection");h._selections=[f],h._trySetSelection()},get selections(){return h._selections},set selections(f){if(!Array.isArray(f)||f.some(t=>!(t instanceof E.Selection)))throw(0,R.illegalArgument)("selections");h._selections=f,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(f){throw(0,R.readonly)("visibleRanges")},get options(){return h._options.value},set options(f){h._disposed||h._options.assign(f)},get viewColumn(){return h._viewColumn},set viewColumn(f){throw(0,R.readonly)("viewColumn")},edit(f,t={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new y(m.getValue(),t);return f(i),h._applyEdit(i)},insertSnippet(f,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=h._selections.map(o=>T.Range.from(o));else if(t instanceof E.Position){const{lineNumber:o,column:u}=T.Position.from(t);s=[{startLineNumber:o,startColumn:u,endLineNumber:o,endColumn:u}]}else if(t instanceof E.Range)s=[T.Range.from(t)];else{s=[];for(const o of t)if(o instanceof E.Range)s.push(T.Range.from(o));else{const{lineNumber:u,column:_}=T.Position.from(o);s.push({startLineNumber:u,startColumn:_,endLineNumber:u,endColumn:_})}}return g.$tryInsertSnippet(d,f.value,s,i)},setDecorations(f,t){const i=t.length===0;i&&!h._hasDecorationsForKey.has(f.key)||(i?h._hasDecorationsForKey.delete(f.key):h._hasDecorationsForKey.add(f.key),h._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return g.$trySetDecorations(d,f.key,T.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let o=0,u=t.length;o<u;o++){const _=t[o];s[4*o]=_.start.line+1,s[4*o+1]=_.start.character+1,s[4*o+2]=_.end.line+1,s[4*o+3]=_.end.character+1}return g.$trySetDecorationsFast(d,f.key,s)}}))},revealRange(f,t){h._runOnProxy(()=>g.$tryRevealRange(d,T.Range.from(f),t||E.TextEditorRevealType.Default))},show(f){g.$tryShowEditor(d,T.ViewColumn.from(f))},hide(){g.$tryHideEditor(d)}})}dispose(){(0,v.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,v.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,v.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,v.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,v.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const g=d.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const r=g.edits.map(c=>c.range);r.sort((c,p)=>c.end.line===p.end.line?c.end.character===p.end.character?c.start.line===p.start.line?c.start.character-p.start.character:c.start.line-p.start.line:c.end.character-p.end.character:c.end.line-p.end.line);for(let c=0,p=r.length-1;c<p;c++){const w=r[c].end;if(r[c+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=g.edits.map(c=>({range:T.Range.from(c.range),text:c.text,forceMoveMarkers:c.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,m,{setEndOfLine:typeof g.setEndOfLine=="number"?T.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=n}),define(ve[181],be([0,1,137,25,2,3,6,11,7,10,13,9,20]),function(J,e,v,R,S,T,E,D,y,k,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(c,p){if((0,k.isString)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let w;return Array.isArray(c.highlights)&&(w=c.highlights.filter(a=>a.length===2&&typeof a[0]=="number"&&typeof a[1]=="number"),w=w.length?w:void 0),{label:c.label,highlights:w}}}class r{constructor(p,w,a){this._proxy=p,this.commands=w,this.logService=a,this.treeViews=new Map;function h(f){return f&&f.$treeViewId&&f.$treeItemHandle}w.registerArgumentProcessor({processArgument:f=>h(f)?this.convertArgument(f):Array.isArray(f)&&f.length>0?f.map(t=>h(t)?this.convertArgument(t):t):f})}registerTreeDataProvider(p,w,a){const h=this.createTreeView(p,{treeDataProvider:w},a);return{dispose:()=>h.dispose()}}createTreeView(p,w,a){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=w.dragAndDropController!==void 0,f=this._proxy.$registerTreeViewDataProvider(p,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,canDragAndDrop:h}),t=this.createExtHostTreeView(p,w,a);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(i){t.message=i},get title(){return t.title},set title(i){t.title=i},get description(){return t.description},set description(i){t.description=i},reveal:(i,s)=>t.reveal(i,s),dispose:async()=>{await f,this.treeViews.delete(p),t.dispose()}}}$getChildren(p,w){const a=this.treeViews.get(p);return a?a.getChildren(w):Promise.reject(new Error((0,v.localize)(0,null,p)))}$onDrop(p,w,a){const h=this.treeViews.get(p);return h?h.onDrop(w,a):Promise.reject(new Error((0,v.localize)(1,null,p)))}async $hasResolve(p){const w=this.treeViews.get(p);if(!w)throw new Error((0,v.localize)(2,null,p));return w.hasResolve}$resolve(p,w,a){const h=this.treeViews.get(p);if(!h)throw new Error((0,v.localize)(3,null,p));return h.resolveTreeItem(w,a)}$setExpanded(p,w,a){const h=this.treeViews.get(p);if(!h)throw new Error((0,v.localize)(4,null,p));h.setExpanded(w,a)}$setSelection(p,w){const a=this.treeViews.get(p);if(!a)throw new Error((0,v.localize)(5,null,p));a.setSelection(w)}$setVisible(p,w){const a=this.treeViews.get(p);if(!a)throw new Error((0,v.localize)(6,null,p));a.setVisible(w)}createExtHostTreeView(p,w,a){const h=new m(p,w,this._proxy,this.commands.converter,this.logService,a);return this.treeViews.set(p,h),h}convertArgument(p){const w=this.treeViews.get(p.$treeViewId);return w?w.getExtensionElement(p.$treeItemHandle):null}}e.ExtHostTreeViews=r;class m extends E.Disposable{constructor(p,w,a,h,f,t){super();if(this.viewId=p,this.proxy=a,this.commands=h,this.logService=f,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,t.contributes&&t.contributes.views)for(const o in t.contributes.views)for(const u of t.contributes.views[o])u.id===p&&(this._title=u.name);this.dataProvider=w.treeDataProvider,this.dndController=w.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let i,s;this._register(T.Event.debounce(this._onDidChangeData.event,(o,u)=>(o||(o={message:!1,elements:[]}),u.element!==!1&&(i||(i=new Promise(_=>s=_),this.refreshPromise=this.refreshPromise.then(()=>i)),o.elements.push(u.element)),u.message&&(o.message=!0),o),200,!0)(({message:o,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const _=s;return i=null,this.refresh(u).then(()=>_())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!(0,k.isUndefinedOrNull)(p))}getChildren(p){const w=p?this.getExtensionElement(p):void 0;if(p&&!w)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);const a=this.getChildrenNodes(p);return(a?Promise.resolve(a):this.fetchChildrenNodes(w)).then(h=>h.map(f=>f.item))}getExtensionElement(p){return this.elements.get(p)}reveal(p,w){w=w||{select:!0,focus:!1};const a=(0,k.isUndefinedOrNull)(w.select)?!0:w.select,h=(0,k.isUndefinedOrNull)(w.focus)?!1:w.focus,f=(0,k.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(t=>this.resolveTreeNode(p,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(s=>s.item)},{select:a,focus:h,expand:f})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:a,focus:h,expand:f})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}setExpanded(p,w){const a=this.getExtensionElement(p);a&&(w?this._onDidExpandElement.fire(Object.freeze({element:a})):this._onDidCollapseElement.fire(Object.freeze({element:a})))}setSelection(p){(0,n.equals)(this._selectedHandles,p)||(this._selectedHandles=p,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(p,w){const a=p.map(f=>this.getExtensionElement(f)).filter(f=>!(0,k.isUndefinedOrNull)(f)),h=this.getExtensionElement(w);return a&&h?(0,D.asPromise)(()=>{var f;return(f=this.dndController)===null||f===void 0?void 0:f.onDrop(a,h)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,w){var a;if(!this.dataProvider.resolveTreeItem)return;const h=this.elements.get(p);if(h){const f=this.nodes.get(h);if(f){const t=(a=await this.dataProvider.resolveTreeItem(f.extensionItem,h,w))!==null&&a!==void 0?a:f.extensionItem;return f.item.tooltip=this.getTooltip(t.tooltip),f.item.command=this.getCommand(f.disposableStore,t.command),f.item}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(w=>w?this.resolveUnknownParentChain(w).then(a=>this.resolveTreeNode(w,a[a.length-1]).then(h=>(a.push(h),a))):Promise.resolve([]))}resolveParent(p){const w=this.nodes.get(p);return w?Promise.resolve(w.parent?this.elements.get(w.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,w){const a=this.nodes.get(p);return a?Promise.resolve(a):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(h=>this.createHandle(p,h,w,!0)).then(h=>this.getChildren(w?w.item.handle:void 0).then(()=>{const f=this.getExtensionElement(h);if(f){const t=this.nodes.get(f);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${h}`)}))}getChildrenNodes(p){if(p){let w;if(typeof p=="string"){const a=this.getExtensionElement(p);w=a?this.nodes.get(a):void 0}else w=p;return w&&w.children||null}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const w=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const a=p?this.nodes.get(p):void 0,h=await this.dataProvider.getChildren(p);if(w.token.isCancellationRequested)return[];const f=await Promise.all((0,n.coalesce)(h||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!w.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,a):null}));return w.token.isCancellationRequested?[]:(0,n.coalesce)(f)}finally{w.dispose()}}refresh(p){if(p.some(a=>!a))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const a=this.getHandlesToRefresh(p);if(a.length)return this.refreshHandles(a)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const w=new Set,a=p.map(f=>this.nodes.get(f));for(const f of a)if(f&&!w.has(f.item.handle)){let t=f;for(;t&&t.parent&&a.findIndex(i=>t&&t.parent&&i&&i.item.handle===t.parent.item.handle)===-1;){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&w.add(f.item.handle)}const h=[];return w.forEach(f=>{const t=this.elements.get(f);if(t){const i=this.nodes.get(t);i&&(!i.parent||!w.has(i.parent.item.handle))&&h.push(f)}}),h}refreshHandles(p){const w={};return Promise.all(p.map(a=>this.refreshNode(a).then(h=>{h&&(w[a]=h.item)}))).then(()=>Object.keys(w).length?this.proxy.$refresh(this.viewId,w):void 0)}refreshNode(p){const w=this.getExtensionElement(p);if(w){const a=this.nodes.get(w);if(a)return this.clearChildren(w),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(h=>{if(h){const f=this.createTreeNode(w,h,a.parent);return this.updateNodeCache(w,f,a,a.parent),a.dispose(),f}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,w,a){const h=this.createTreeNode(p,w,a);if(w.id&&this.elements.has(h.item.handle))throw new Error((0,v.localize)(7,null,w.id));return this.addNodeToCache(p,h),this.addNodeToParentCache(h,a),h}getTooltip(p){return y.MarkdownString.isMarkdownString(p)?P.MarkdownString.from(p):p}getCommand(p,w){return w?this.commands.toInternal(w,p):void 0}createTreeNode(p,w,a){const h=new E.DisposableStore,f=this.createHandle(p,w,a),t=this.getLightIconPath(w);return{item:{handle:f,parentHandle:a?a.item.handle:void 0,label:g(w.label,this.extension),description:w.description,resourceUri:w.resourceUri,tooltip:this.getTooltip(w.tooltip),command:this.getCommand(h,w.command),contextValue:w.contextValue,icon:t,iconDark:this.getDarkIconPath(w)||t,themeIcon:this.getThemeIcon(w),collapsibleState:(0,k.isUndefinedOrNull)(w.collapsibleState)?y.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation},extensionItem:w,parent:a,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(p){return p.iconPath instanceof y.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:w,label:a,resourceUri:h},f,t){if(w)return`${m.ID_HANDLE_PREFIX}/${w}`;const i=g(a,this.extension),s=f?f.item.handle:m.LABEL_HANDLE_PREFIX;let o=i?i.label:h?(0,R.basename)(h):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const u=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,_=this.getChildrenNodes(f)||[];let b,A=0;do{if(b=`${s}/${A}:${o}`,t||!this.elements.has(b)||u===b)break;A++}while(A<=_.length);return b}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof y.ThemeIcon))return typeof p.iconPath=="string"||S.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof y.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return S.URI.isUri(p)?p:S.URI.file(p)}addNodeToCache(p,w){this.elements.set(w.item.handle,p),this.nodes.set(p,w)}updateNodeCache(p,w,a,h){this.elements.delete(w.item.handle),this.nodes.delete(p),w.item.handle!==a.item.handle&&this.elements.delete(a.item.handle),this.addNodeToCache(p,w);const f=this.getChildrenNodes(h)||[],t=f.filter(i=>i.item.handle===a.item.handle)[0];t&&f.splice(f.indexOf(t),1,w)}addNodeToParentCache(p,w){w?(w.children||(w.children=[]),w.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const w=this.nodes.get(p);if(w){if(w.children)for(const a of w.children){const h=this.elements.get(a.item.handle);h&&this.clear(h)}w.children=void 0}}else this.clearAll()}clear(p){const w=this.nodes.get(p);if(w){if(w.children)for(const a of w.children){const h=this.elements.get(a.item.handle);h&&this.clear(h)}this.nodes.delete(p),this.elements.delete(w.item.handle),w.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}m.LABEL_HANDLE_PREFIX="0",m.ID_HANDLE_PREFIX="1"}),define(ve[182],be([0,1,13,11,20,10,70,9,7,97]),function(J,e,v,R,S,T,E,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class n{constructor(){this.testIdsToInternal=new Map}getTestById(c,p){if(p!==void 0){const w=this.testIdsToInternal.get(p),a=w==null?void 0:w.get(c);if(a)return[w,a]}return(0,v.mapFind)(this.testIdsToInternal.values(),w=>{const a=w.get(c);return a&&[w,a]})}createForHierarchy(c=()=>{}){return new r(this.createIdMap(d++),c)}createIdMap(c){const p=new g(c);return this.testIdsToInternal.set(p.id,p),{object:p,dispose:()=>this.testIdsToInternal.delete(p.id)}}}e.OwnedTestCollection=n;var P;(function(m){m[m.Disconnected=0]="Disconnected",m[m.IsChild=1]="IsChild",m[m.IsParent=2]="IsParent",m[m.IsSame=3]="IsSame"})(P=e.TestPosition||(e.TestPosition={}));let d=0;class g{constructor(c){this.id=c,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(c){if(this.map.has(c.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${c.item.extId}`);this.map.set(c.item.extId,c),c.parent||this._roots.add(c)}has(c){return this.map.has(c)}delete(c){const p=this.map.get(c);return p?(this.map.delete(c),this._roots.delete(p),!0):!1}get(c){return this.map.get(c)}comparePositions(c,p){const w=typeof c=="string"?this.map.get(c):c,a=typeof p=="string"?this.map.get(p):p;if(!w||!a)return 0;if(w===a)return 3;for(let h=this.map.get(a.parent);h;h=this.map.get(h.parent))if(h===w)return 1;for(let h=this.map.get(w.parent);h;h=this.map.get(h.parent))if(h===a)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=g;class r{constructor(c,p){this.testIdToInternal=c,this.publishDiff=p,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new R.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(c,p){this.addItem(c,p,null)}getTestByReference(c){return this.testItemToInternal.get(c)}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){const p=this.diff[this.diff.length-1];if(p&&c[0]===1){if(p[0]===1&&p[1].extId===c[1].extId){(0,k.applyTestItemUpdate)(p[1],c[1]);return}if(p[0]===0&&p[1].item.extId===c[1].extId){(0,k.applyTestItemUpdate)(p[1],c[1]);return}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,p){var w;const a=this.testIdToInternal.object.get(c);if(!!a){if((a.expandLevels===void 0||p>a.expandLevels)&&(a.expandLevels=p),a.expand===1){const h=this.refreshChildren(a);return h.isSettled?this.expandChildren(a,p-1):h.p.then(()=>this.expandChildren(a,p-1))}else if(a.expand===3)return((w=a.initialExpand)===null||w===void 0?void 0:w.isSettled)===!1?a.initialExpand.p.then(()=>this.expandChildren(a,p-1)):this.expandChildren(a,p-1)}}dispose(){var c;for(const p of this.testItemToInternal.values())(c=p.discoverCts)===null||c===void 0||c.dispose(!0),(0,E.getPrivateApiFor)(p.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(c,p){const w=c==null?void 0:c.actual.id;switch(p[0]){case 2:this.pushDiff([4,w]);break;case 1:this.removeItem(c);break;case 0:this.addItem(p[1],c.src.controller,c);break;case 3:const[a,h,f]=p;switch(h){case"status":this.updateExpandability(c);break;case"range":this.pushDiff([1,{extId:w,item:{range:D.Range.from(f)}}]);break;case"error":this.pushDiff([1,{extId:w,item:{error:D.MarkdownString.fromStrict(f)||null}}]);break;default:this.pushDiff([1,{extId:w,item:{[h]:f!=null?f:null}}]);break}break;default:(0,T.assertNever)(p[0])}}addItem(c,p,w){if(!(c instanceof y.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);if(this.testItemToInternal.has(c))throw new Error(`Attempted to add a single TestItem ${c.id} multiple times to the tree`);if(this.testIdToInternal.object.has(c.id))throw new Error(`Attempted to insert a duplicate test item ID ${c.id}`);const a=w?w.item.extId:null,h=c.resolveHandler?1:0,f=w?w.expandLevels:1,t={controller:p,tree:this.testIdToInternal.object.id},i={actual:c,parent:a,item:D.TestItem.from(c),expandLevels:f?f-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(i),this.testItemToInternal.set(c,i),this.pushDiff([0,{parent:a,src:t,expand:h,item:i.item}]);const s=(0,E.getPrivateApiFor)(c);s.parent=w==null?void 0:w.actual,s.bus.event(this.onTestItemEvent.bind(this,i)),this.updateExpandability(i);for(const o of s.children.values())this.testItemToInternal.has(o)||this.addItem(o,p,i)}updateExpandability(c){var p;let w;c.actual.resolveHandler?c.actual.status===y.TestItemStatus.Pending?w=c.discoverCts?2:1:((p=c.initialExpand)===null||p===void 0||p.complete(),w=3):w=0,w!==c.expand&&(c.expand=w,this.pushDiff([1,{extId:c.actual.id,expand:w}]),w===1&&c.expandLevels!==void 0&&this.refreshChildren(c))}expandChildren(c,p){if(p<0)return;const w=[...c.actual.children.values()].map(a=>this.expand(a.id,p)).filter(R.isThenable);if(w.length)return Promise.all(w).then(()=>{})}refreshChildren(c){if(c.discoverCts&&c.discoverCts.dispose(!0),!c.actual.resolveHandler){const p=new R.DeferredPromise;return p.complete(),p}return c.expand=2,c.discoverCts=new S.CancellationTokenSource,this.pushExpandStateUpdate(c),c.initialExpand=new R.DeferredPromise,c.actual.resolveHandler(c.discoverCts.token),c.initialExpand}pushExpandStateUpdate(c){this.pushDiff([1,{extId:c.actual.id,expand:c.expand}])}removeItem(c){var p;this.pushDiff([2,c.actual.id]);const w=[c];for(;w.length;){const a=w.pop();if(!!a){(p=a.discoverCts)===null||p===void 0||p.dispose(!0),this.testIdToInternal.object.delete(a.item.extId),this.testItemToInternal.delete(a.actual);for(const h of a.actual.children.values())w.push(this.testIdToInternal.object.get(h.id))}}}flushDiff(){const c=this.collectDiff();c.length&&this.publishDiff(c)}}e.SingleUseTestCollection=r}),define(ve[183],be([0,1,26,3,14]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=T;class E{constructor(n){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(v.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(v.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let P of n.activationEvents)P==="onUri"&&(P=`onUri:${v.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(n)}}keepOnly(n){const P=new Set;n.forEach(d=>P.add(v.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>P.has(v.ExtensionIdentifier.toKey(d.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,P){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const d=E._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(d.map(g=>g.identifier)),P.length>0){const g=new Set;P.forEach(r=>g.add(v.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!g.has(v.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(d)}static _findLoopingExtensions(n){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(c){this._nodesSet.has(c)||(this._nodesSet.add(c),this._nodesArr.push(c))}addArc(c,p){this.addNode(c),this.addNode(p),this._arcs.has(c)?this._arcs.get(c).push(p):this._arcs.set(c,[p])}getArcs(c){return this._arcs.has(c)?this._arcs.get(c):[]}hasOnlyGoodArcs(c,p){const w=P.getArcs(c);for(let a=0;a<w.length;a++)if(!p.has(w[a]))return!1;return!0}getNodes(){return this._nodesArr}};let d=new Map;for(let c of n){const p=v.ExtensionIdentifier.toKey(c.identifier);if(d.set(p,c),c.extensionDependencies)for(let w of c.extensionDependencies){const a=v.ExtensionIdentifier.toKey(w);P.addArc(p,a)}}let g=new Set;P.getNodes().filter(c=>P.getArcs(c).length===0).forEach(c=>g.add(c));let r=P.getNodes().filter(c=>!g.has(c)),m;do{m=!1;for(let c=0;c<r.length;c++){const p=r[c];P.hasOnlyGoodArcs(p,g)&&(r.splice(c,1),c--,g.add(p),m=!0)}}while(m);return r.map(c=>d.get(c))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(v.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const P=this._activationMap.get(n);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const P=this._extensionsMap.get(v.ExtensionIdentifier.toKey(n));return P||void 0}}e.ExtensionDescriptionRegistry=E;var D;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(D||(D={}));function y(k,n){const P=k.isBuiltin?0:k.isUnderDevelopment?2:1,d=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(P!==d)return P-d;const g=S.posix.basename(k.extensionLocation.path),r=S.posix.basename(n.extensionLocation.path);return g<r?-1:g>r?1:0}}),define(ve[184],be([0,1,23]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var S;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(S=e.MessageType||(e.MessageType={}));function T(D){const y=v.VSBuffer.alloc(1);switch(D){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=T;function E(D,y){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=E}),define(ve[32],be([0,1,3,2,4,26,151]),function(J,e,v,R,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");class D{constructor(w){this.dependency=w}}e.MissingExtensionDependency=D;var y;(function(p){p[p.LocalProcess=0]="LocalProcess",p[p.LocalWebWorker=1]="LocalWebWorker",p[p.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(w,a,h,f){this.codeLoadingTime=w,this.activateCallTime=a,this.activateResolvedTime=h,this.activationReason=f}}e.ActivationTimes=k;class n{constructor(w,a){this.description=w,this.value=a}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var P;(function(p){p[p.Normal=0]="Normal",p[p.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function d(p){p.enableProposedApi||g(p)}e.checkProposedApiEnabled=d;function g(p){throw new Error(`[${p.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${p.identifier.value}`)}e.throwProposedApiError=g;function r(p){return{type:p.isBuiltin?0:1,isBuiltin:p.isBuiltin||p.isUserBuiltin,identifier:{id:(0,E.getGalleryExtensionId)(p.publisher,p.name),uuid:p.uuid},manifest:p,location:p.extensionLocation}}e.toExtension=r;function m(p){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(p.identifier.id),isBuiltin:p.type===0,isUserBuiltin:p.type===1&&p.isBuiltin,isUnderDevelopment:!1,extensionLocation:p.location},p.manifest),{uuid:p.identifier.uuid})}e.toExtensionDescription=m;class c{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None}activateByEvent(w){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(w){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(w){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(w){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(w,a){return Promise.resolve()}_onWillActivateExtension(w){}_onDidActivateExtension(w,a,h,f,t){}_onDidActivateExtensionError(w,a){}_onExtensionRuntimeError(w,a){}_onExtensionHostExit(w){}}e.NullExtensionService=c}),define(ve[185],be([0,1,26,32,17]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class E{constructor(r,m,c,p){this.startup=r,this.codeLoadingTime=m,this.activateCallTime=c,this.activateResolvedTime=p}}e.ExtensionActivationTimes=E,E.NONE=new E(!1,-1,-1,-1);class D{constructor(r){this._startup=r,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(r,m){return r===-1||m===-1?-1:m-r}build(){return new E(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class y{constructor(r,m,c,p,w,a){this.activationFailed=r,this.activationFailedError=m,this.activationTimes=c,this.module=p,this.exports=w,this.subscriptions=a}}e.ActivatedExtension=y;class k extends y{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class n extends y{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class P extends y{constructor(r){super(!0,r,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=P;let d=class{constructor(r,m,c,p,w){this._logService=w,this._registry=r,this._resolvedExtensionsSet=new Set,m.forEach(a=>this._resolvedExtensionsSet.add(v.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,c.forEach(a=>this._hostExtensionsMap.set(v.ExtensionIdentifier.toKey(a),a)),this._host=p,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(r){const m=v.ExtensionIdentifier.toKey(r);return this._activatedExtensions.has(m)}getActivatedExtension(r){const m=v.ExtensionIdentifier.toKey(r),c=this._activatedExtensions.get(m);if(!c)throw new Error("Extension `"+r.value+"` is not known or not activated");return c}activateByEvent(r,m){if(this._alreadyActivatedEvents[r])return T;const c=this._registry.getExtensionDescriptionsForActivationEvent(r);return this._activateExtensions(c.map(p=>({id:p.identifier,reason:{startup:m,extensionId:p.identifier,activationEvent:r}}))).then(()=>{this._alreadyActivatedEvents[r]=!0})}activateById(r,m){const c=this._registry.getExtensionDescription(r);if(!c)throw new Error("Extension `"+r+"` is not known");return this._activateExtensions([{id:c.identifier,reason:m}])}_handleActivateRequest(r,m,c){if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(r.id))){m[v.ExtensionIdentifier.toKey(r.id)]=r;return}const p=this._registry.getExtensionDescription(r.id);if(!p){const h=new Error(`Cannot activate unknown extension '${r.id.value}'`);this._host.onExtensionActivationError(r.id,h,new R.MissingExtensionDependency(r.id.value)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(r.id),new P(h));return}const w=typeof p.extensionDependencies=="undefined"?[]:p.extensionDependencies;let a=!0;for(let h=0,f=w.length;h<f;h++){const t=w[h];if(this._resolvedExtensionsSet.has(v.ExtensionIdentifier.toKey(t)))continue;const i=this._activatedExtensions.get(v.ExtensionIdentifier.toKey(t));if(i&&!i.activationFailed)continue;if(i&&i.activationFailed){const _=p.displayName||p.identifier.value,b=this._registry.getExtensionDescription(t),A=b&&b.displayName||t,C=new Error(`Cannot activate the '${_}' extension because its dependency '${A}' failed to activate`);C.detail=i.activationFailedError,this._host.onExtensionActivationError(p.identifier,C,null),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(p.identifier),new P(C));return}if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(t))){a=!1,m[v.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(v.ExtensionIdentifier.toKey(t)),reason:r.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){a=!1,m[v.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:r.reason};continue}const o=p.displayName||p.identifier.value,u=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(p.identifier,u,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(p.identifier),new P(u));return}a?m[v.ExtensionIdentifier.toKey(p.identifier)]=r:c.push(r)}_activateExtensions(r){if(r.length===0||(r=r.filter(w=>!this._activatedExtensions.has(v.ExtensionIdentifier.toKey(w.id))),r.length===0))return Promise.resolve(void 0);const m=Object.create(null),c=[];for(let w=0,a=r.length;w<a;w++)this._handleActivateRequest(r[w],m,c);for(let w=0,a=c.length;w<a;w++){const h=v.ExtensionIdentifier.toKey(c[w].id);m[h]&&delete m[h]}const p=Object.keys(m).map(w=>m[w]);return c.length===0?Promise.all(p.map(w=>this._activateExtension(w.id,w.reason))).then(w=>{}):this._activateExtensions(p).then(w=>this._activateExtensions(c))}_activateExtension(r,m){const c=v.ExtensionIdentifier.toKey(r);if(this._activatedExtensions.has(c))return Promise.resolve(void 0);const p=this._activatingExtensions.get(c);if(p)return p;const w=this._host.actualActivateExtension(r,m).then(void 0,a=>{const h=new Error;return a&&a.name&&(h.name=a.name),a&&a.message?h.message=`Activating extension '${r.value}' failed: ${a.message}.`:h.message=`Activating extension '${r.value}' failed: ${a}.`,a&&a.stack&&(h.stack=a.stack),this._host.onExtensionActivationError(r,h,null),this._logService.error(`Activating extension ${r.value} failed due to an error:`),this._logService.error(a),new P(a)}).then(a=>{this._activatedExtensions.set(c,a),this._activatingExtensions.delete(c)});return this._activatingExtensions.set(c,w),w}};d=je([qe(4,S.ILogService)],d),e.ExtensionsActivator=d}),define(ve[186],be([0,1,12]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,E)=>{this._actualOk=T,this._actualErr=E,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,v.onUnexpectedError)(T))}then(T,E){return this._ensureActual().then(T,E)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=R}),define(ve[100],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class v{constructor(y,k){this.isMain=y,this.sid=k,this.nid=++v.count}}e.ProxyIdentifier=v,v.count=0;const R=[];function S(D){const y=new v(!0,D);return R[y.nid]=y,y}e.createMainContextProxyIdentifier=S;function T(D){const y=new v(!1,D);return R[y.nid]=y,y}e.createExtHostContextProxyIdentifier=T;function E(D){return R[D].sid}e.getStringIdentifierForProxy=E}),define(ve[5],be([0,1,58,2,100]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var E;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(E=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var d;(function(a){a.name="$ident";function h(t,i){return Object.defineProperty(t,a.name,{value:i,enumerable:!0}),t}a.mixin=h;function f(t){return t[a.name]}a.of=f})(d=e.ObjectIdentifier||(e.ObjectIdentifier={}));class g{static mixin(h){return h._id=g._n++,h}}e.IdObject=g,g._n=0;var r;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n",a.label2="o"})(r=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var m;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(m=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var c;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(c=e.WorkspaceEditType||(e.WorkspaceEditType={}));function p(a){if(a&&a.edits)for(const h of a.edits)typeof h.resource=="object"?h.resource=R.URI.revive(h.resource):(h.newUri=R.URI.revive(h.newUri),h.oldUri=R.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,v.revive)(h.metadata));return a}e.reviveWorkspaceEditDto=p;var w;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,S.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,S.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,S.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,S.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,S.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,S.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,S.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,S.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,S.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,S.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,S.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadTheming:(0,S.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,S.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,S.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,S.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,S.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,S.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,S.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,S.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,S.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,S.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostTheming:(0,S.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,S.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ve[74],be([0,1,5,3,4]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(D){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(v.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,y){return this._proxy.$getPassword(D,y)}store(D,y,k){return this._proxy.$setPassword(D,y,k)}delete(D,y){return this._proxy.$deletePassword(D,y)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")}),define(ve[75],be([0,1,4,17,5,15]),function(J,e,v,R,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,v.createDecorator)("IExtHostApiDeprecationService");let E=class{constructor(y,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(S.MainContext.MainThreadTelemetry)}report(y,k,n){const P=this.getUsageKey(y,k);this._reportedUsages.has(P)||(this._reportedUsages.add(P),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:y}))}getUsageKey(y,k){return`${y}-${k.identifier.value}`}};E=je([qe(0,T.IExtHostRpcService),qe(1,R.ILogService)],E),e.ExtHostApiDeprecationService=E,e.NullApiDeprecationService=Object.freeze(new class{report(D,y,k){}})}),define(ve[187],be([0,1,3,5,7,26]),function(J,e,v,R,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class E{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new v.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new v.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,k,n,P={}){const d=T.ExtensionIdentifier.toKey(y.identifier),g=this._inFlightRequests.get(d)||[],r=n.sort().join(" ");let m=g.find(c=>c.scopes===r);if(m)return m.result;{const c=this._getSession(y,d,k,n,P);m={scopes:r,result:c},g.push(m),this._inFlightRequests.set(d,g);try{await c}finally{const p=g.findIndex(w=>w.scopes===r);p>-1&&(g.splice(p),this._inFlightRequests.set(d,g))}return c}}async _getSession(y,k,n,P,d={}){await this._proxy.$ensureProvider(n);const g=y.displayName||y.name;return this._proxy.$getSession(n,P,k,g,d)}async removeSession(y,k){const n=this._authenticationProviders.get(y);return n?n.provider.removeSession(k):this._proxy.$removeSession(y,k)}registerAuthenticationProvider(y,k,n,P){var d;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:k,provider:n,options:P!=null?P:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===y)||this._providers.push({id:y,label:k});const g=n.onDidChangeSessions(r=>{var m,c,p;this._proxy.$sendDidChangeSessions(y,{added:(m=r.added)!==null&&m!==void 0?m:[],changed:(c=r.changed)!==null&&c!==void 0?c:[],removed:(p=r.removed)!==null&&p!==void 0?p:[]})});return this._proxy.$registerAuthenticationProvider(y,k,(d=P==null?void 0:P.supportsMultipleAccounts)!==null&&d!==void 0?d:!1),new S.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(y);const r=this._providers.findIndex(m=>m.id===y);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,k){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,k){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,k){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,k){return this._onDidChangeSessions.fire({provider:{id:y,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,k){return y.forEach(n=>{this._providers.some(P=>P.id===n.id)||this._providers.push(n)}),k.forEach(n=>{const P=this._providers.findIndex(d=>d.id===n.id);P>-1&&this._providers.splice(P)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=E}),define(ve[188],be([0,1,5,15,9]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(D,y){this._extHostDocumentsAndEditors=y,this._proxy=D.getProxy(v.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const y=S.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};T=je([qe(0,R.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(ve[189],be([0,1,5]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(T){const E=T.getProxy(v.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return E.$readText()},writeText(D){return E.$writeText(D)}})}}e.ExtHostClipboard=R}),define(ve[76],be([0,1,10,7,9,24,5,13,17,58,31,38,2,6,4,15]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let c=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadCommands),this._logService=i,this.converter=new p(this,s=>{const o=this._apiCommands.get(s);return(o==null?void 0:o.result)===a.Void?o:void 0},i),this._argumentProcessors=[{processArgument(s){return(0,k.revive)(s)}},{processArgument(s){return(0,T.cloneAndChange)(s,function(o){if(n.Range.isIRange(o))return S.Range.to(o);if(P.Position.isIPosition(o))return S.Position.to(o);if(n.Range.isIRange(o.range)&&d.URI.isUri(o.uri))return S.location.to(o);if(!Array.isArray(o))return o})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...s)=>{const o=t.args.map((_,b)=>{if(!_.validate(s[b]))throw new Error(`Invalid argument '${_.name}' when running '${t.id}', received: ${s[b]}`);return _.convert(s[b])}),u=await this.executeCommand(t.internalId,...o);return t.result.convert(u,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,s,o,u){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:s,thisArg:o,description:u}),t&&this._proxy.$registerCommand(i),new R.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,s){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const o=(0,T.cloneAndChange)(i,function(u){if(u instanceof R.Position)return S.Position.from(u);if(u instanceof R.Range)return S.Range.from(u);if(u instanceof R.Location)return S.location.from(u);if(R.NotebookRange.isNotebookRange(u))return S.NotebookRange.from(u);if(!Array.isArray(u))return u});try{const u=await this._proxy.$executeCommand(t,o,s);return(0,k.revive)(u)}catch(u){if(u instanceof Error&&u.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw u}}}async _executeContributedCommand(t,i){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:o,thisArg:u,description:_}=s;if(_)for(let b=0;b<_.args.length;b++)try{(0,v.validateConstraint)(i[b],_.args[b].constraint)}catch(A){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${_.args[b].name}' - ${_.args[b].description}`)}try{return await o.apply(u,i)}catch(b){if(t===this.converter.delegatingCommandId){const A=this.converter.getActualCommand(...i);A&&(t=A.command)}throw this._logService.error(b,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(s=>this._argumentProcessors.reduce((o,u)=>u.processArgument(o),s)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(s=>s[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,s]of this._commands){let{description:o}=s;o&&(t[i]=o)}return Promise.resolve(t)}};c=je([qe(0,m.IExtHostRpcService),qe(1,y.ILogService)],c),e.ExtHostCommands=c,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class p{constructor(t,i,s){this._commands=t,this._lookupApiCommand=i,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const o=this._lookupApiCommand(t.command);if(o)s.id=o.internalId,s.arguments=o.args.map((u,_)=>u.convert(t.arguments&&t.arguments[_]));else if((0,D.isNonEmptyArray)(t.arguments)){const u=++this._cachIdPool;this._cache.set(u,t),i.add((0,g.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),s.$ident=u,s.id=this.delegatingCommandId,s.arguments=[u],this._logService.trace("CommandsConverter#CREATE",t.command,u)}return s}fromInternal(t){const i=E.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=p;class w{constructor(t,i,s,o){this.name=t,this.description=i,this.validate=s,this.convert=o}optional(){return new w(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new w(t!=null?t:this.name,i!=null?i:this.description,this.validate,this.convert)}}e.ApiCommandArgument=w,w.Uri=new w("uri","Uri of a text document",f=>d.URI.isUri(f),f=>f),w.Position=new w("position","A position in a text document",f=>R.Position.isPosition(f),S.Position.from),w.Range=new w("range","A range in a text document",f=>R.Range.isRange(f),S.Range.from),w.Selection=new w("selection","A selection in a text document",f=>R.Selection.isSelection(f),S.Selection.from),w.Number=new w("number","",f=>typeof f=="number",f=>f),w.String=new w("string","",f=>typeof f=="string",f=>f),w.CallHierarchyItem=new w("item","A call hierarchy item",f=>f instanceof R.CallHierarchyItem,S.CallHierarchyItem.to);class a{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=a,a.Void=new a("no result",f=>f);class h{constructor(t,i,s,o,u){this.id=t,this.internalId=i,this.description=s,this.args=o,this.result=u}}e.ApiCommand=h}),define(ve[190],be([0,1,6,9,7,63,76,169,13,87]),function(J,e,v,R,S,T,E,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const n=[new E.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",d(R.DocumentHighlight.to))),new E.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,m)=>{if((0,y.isFalsyOrEmpty)(r))return;class c extends S.SymbolInformation{static to(w){const a=new c(w.name,R.SymbolKind.to(w.kind),w.containerName||"",new S.Location(m[0],R.Range.to(w.range)));return a.detail=w.detail,a.range=a.location.range,a.selectionRange=R.Range.to(w.selectionRange),a.children=w.children?w.children.map(c.to):[],a}}return r.map(c.to)})),new E.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(R.TextEdit.to))),new E.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(R.TextEdit.to))),new E.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,new E.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new E.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(R.TextEdit.to))),new E.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new E.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new E.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new E.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new E.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location-instances.",d(R.location.to))),new E.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Hover-instances.",d(R.Hover.to))),new E.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(m=>S.Position.isPosition(m)),r=>r.map(R.Position.from))],new E.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(m=>{let c;for(const p of m.reverse())c=new S.SelectionRange(R.Range.to(p),c);return c}))),new E.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[E.ApiCommandArgument.String.with("query","Search string")],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const m=[];if(Array.isArray(r))for(let c of r)m.push(...c[1].map(R.WorkspaceSymbol.to));return m})),new E.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(R.CallHierarchyItem.to))),new E.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(R.CallHierarchyIncomingCall.to))),new E.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(R.CallHierarchyOutgoingCall.to))),new E.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("newName","The new symbol name")],new E.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return R.WorkspaceEdit.to(r)}})),new E.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new E.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(R.DocumentLink.to))),new E.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new S.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const m=(0,k.decodeSemanticTokensDto)(r);if(m.type==="full")return new S.SemanticTokens(m.data,void 0)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new S.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const m=(0,k.decodeSemanticTokensDto)(r);if(m.type==="full")return new S.SemanticTokens(m.data,void 0)})),new E.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new E.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,m,c)=>{if(!r)return new S.CompletionList([]);const p=r.suggestions.map(w=>R.CompletionItem.to(w,c));return new S.CompletionList(p,r.incomplete)})),new E.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new E.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return R.SignatureHelp.to(r)})),new E.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new E.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,m,c)=>d(p=>new S.CodeLens(R.Range.to(p.range),p.command&&c.fromInternal(p.command)))(r))),new E.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>S.Range.isRange(r),r=>S.Selection.isSelection(r)?R.Selection.from(r):R.Range.from(r)),E.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new E.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,m,c)=>d(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(p.command)}else{const w=new S.CodeAction(p.title,p.kind?new S.CodeActionKind(p.kind):void 0);return p.edit&&(w.edit=R.WorkspaceEdit.to(p.edit)),p.command&&(w.command=c.fromInternal(p.command)),w.isPreferred=p.isPreferred,w}})(r))),new E.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(m=>new S.ColorInformation(R.Range.to(m.range),R.Color.to(m.color))):[])),new E.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new E.ApiCommandArgument("color","The color to show and insert",r=>r instanceof S.Color,R.Color.from),new E.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:R.Range.from(r.range)}))],new E.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(R.ColorPresentation.to):[])),new E.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of Inlay objects",r=>r.map(R.InlayHint.to))),new E.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new E.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",d(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(m=>R.NotebookExclusiveDocumentPattern.to(m))})))),new E.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(R.InlineValue.to))),new E.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)])).optional(),E.ApiCommandArgument.String.with("label","").optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[E.ApiCommandArgument.Uri.with("resource","Resource to open"),E.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)])).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[E.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),E.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),E.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)]).optional()],E.ApiCommandResult.Void)];class P{constructor(m){this._disposables=new v.DisposableStore,this._commands=m}static register(m){return n.forEach(m.registerApiCommand,m),new P(m).registerCommands()}registerCommands(){const m=c=>(...p)=>c(this._commands,...p);this._register(D.RemoveFromRecentlyOpenedAPICommand.ID,m(D.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:c=>typeof c=="string"}]})}_register(m,c,p){const w=this._commands.registerCommand(!1,m,c,this,p);this._disposables.add(w)}}e.ExtHostApiCommands=P;function d(r){return m=>{if(Array.isArray(m))return m.map(r)}}function g(r){if(!Array.isArray(r))return;const m=[];for(const c of r)T.isLocationLink(c)?m.push(R.DefinitionLink.to(c)):m.push(R.location.to(c));return m}}),define(ve[191],be([0,1,11,53,3,6,2,63,26,9,7,5]),function(J,e,v,R,S,T,E,D,y,k,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class d{constructor(h,f,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=h.getProxy(P.MainContext.MainThreadComments),f.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const s=this._commentControllers.get(i.handle);return s||i}else if(i&&i.$mid===7){const s=this._commentControllers.get(i.commentControlHandle);if(!s)return i;const o=s.getCommentThread(i.commentThreadHandle);return o||i}else if(i&&i.$mid===8){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const o=s.getCommentThread(i.thread.commentThreadHandle);return o?{thread:o,text:i.text}:i}else if(i&&i.$mid===9){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const o=s.getCommentThread(i.thread.commentThreadHandle);if(!o)return i;let u=i.commentUniqueId,_=o.getCommentByUniqueId(u);return _||i}else if(i&&i.$mid===10){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const o=s.getCommentThread(i.thread.commentThreadHandle);if(!o)return i;let u=i.text,_=i.commentUniqueId,b=o.getCommentByUniqueId(_);return b?(b.body=u,b):i}return i}})}createCommentController(h,f,t){const i=d.handlePool++,s=new r(h,i,this._proxy,f,t);this._commentControllers.set(s.handle,s);const o=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(h.identifier))||[];return o.push(s),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(h.identifier),o),s}$createCommentThreadTemplate(h,f,t){const i=this._commentControllers.get(h);!i||i.$createCommentThreadTemplate(f,t)}async $updateCommentThreadTemplate(h,f,t){const i=this._commentControllers.get(h);!i||i.$updateCommentThreadTemplate(f,t)}$deleteCommentThread(h,f){const t=this._commentControllers.get(h);t&&t.$deleteCommentThread(f)}$provideCommentingRanges(h,f,t){const i=this._commentControllers.get(h);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(E.URI.revive(f));return(0,v.asPromise)(()=>i.commentingRangeProvider.provideCommentingRanges(s,t)).then(o=>o?o.map(u=>k.Range.from(u)):void 0)}$toggleReaction(h,f,t,i,s){const o=this._commentControllers.get(h);return!o||!o.reactionHandler?Promise.resolve(void 0):(0,v.asPromise)(()=>{const u=o.getCommentThread(f);if(u){const _=u.getCommentByUniqueId(i.uniqueIdInThread);if(o!==void 0&&_&&o.reactionHandler)return o.reactionHandler(_,p(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=d,d.handlePool=0;class g{constructor(h,f,t,i,s,o,u){this._proxy=h,this._commentController=f,this._id=t,this._uri=i,this._range=s,this._comments=o,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${f.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),u),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=o}set threadId(h){this._id=h}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(h){h.isEqual(this._range)||(this._range=h,this.modifications.range=h,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(h){this._canReply!==h&&(this._canReply=h,this.modifications.canReply=h,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(h){this._label=h,this.modifications.label=h,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(h){this._contextValue=h,this.modifications.contextValue=h,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(h){this._comments=h,this.modifications.comments=h,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(h){this._collapseState=h,this.modifications.collapsibleState=h,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const h=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),f={};h("range")&&(f.range=k.Range.from(this._range)),h("label")&&(f.label=this.label),h("contextValue")&&(f.contextValue=this.contextValue),h("comments")&&(f.comments=this._comments.map(t=>m(this,this._commentController,t,this._commentsMap))),h("collapsibleState")&&(f.collapseState=w(this._collapseState)),h("canReply")&&(f.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,f)}getCommentByUniqueId(h){for(let f of this._commentsMap){let t=f[0],i=f[1];if(h===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(h=>h.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}g._handlePool=0,je([(0,R.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=g;class r{constructor(h,f,t,i,s){this._extension=h,this._handle=f,this._proxy=t,this._id=i,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(h){this._reactionHandler=h,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this._options}set options(h){this._options=h,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(h,f,t,i){if(typeof h=="string"){const s=new g(this._proxy,this,h,f,t,i,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new g(this._proxy,this,void 0,h,f,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(h,f){const t=new g(this._proxy,this,void 0,E.URI.revive(h),k.Range.to(f),[],this._extension.identifier);return t.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(h,f){let t=this._threads.get(h);t&&(t.range=k.Range.to(f))}$deleteCommentThread(h){let f=this._threads.get(h);f&&f.dispose(),this._threads.delete(h)}getCommentThread(h){return this._threads.get(h)}dispose(){this._threads.forEach(h=>{h.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function m(a,h,f,t){let i=t.get(f);i||(i=++a.commentHandle,t.set(f,i));const s=f.author&&f.author.iconPath?f.author.iconPath.toString():void 0;return{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:i,body:k.MarkdownString.from(f.body),userName:f.author.name,userIconPath:s,label:f.label,commentReactions:f.reactions?f.reactions.map(o=>c(o)):void 0}}function c(a){return{label:a.label,iconPath:a.iconPath?k.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function p(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?E.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function w(a){if(a!==void 0)switch(a){case n.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}}),define(ve[101],be([0,1,2,5,7,4,15,17,13,8,14]),function(J,e,v,R,S,T,E,D,y,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class gn{constructor(g,r){this._logService=r,this._provider=new Map,this._proxy=g.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,r){const m=gn._handlePool++;this._provider.set(m,{provider:g,extensionId:r}),this._proxy.$registerDecorationProvider(m,r.value);const c=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(p=>{if(!p){this._proxy.$onDidChange(m,null);return}let w=(0,y.asArray)(p);if(w.length<=gn._maxEventSize){this._proxy.$onDidChange(m,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,w.length);const a=w.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),h=(0,y.groupBy)(a,(t,i)=>t.rank-i.rank||(0,k.compare)(t.uri.path,i.uri.path));let f=[];e:for(let t of h){let i;for(let s of t){let o=(0,n.dirname)(s.uri.path);if(i!==o&&(i=o,f.push(s.uri)>=gn._maxEventSize))break e}}this._proxy.$onDidChange(m,f)});return new S.Disposable(()=>{c==null||c.dispose(),this._proxy.$unregisterDecorationProvider(m),this._provider.delete(m)})}async $provideDecorations(g,r,m){if(!this._provider.has(g))return Object.create(null);const c=Object.create(null),{provider:p,extensionId:w}=this._provider.get(g);return await Promise.all(r.map(async a=>{try{const{uri:h,id:f}=a,t=await Promise.resolve(p.provideFileDecoration(v.URI.revive(h),m));if(!t)return;try{S.FileDecoration.validate(t),c[f]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${w.value}': ${i}`)}}catch(h){this._logService.error(h)}})),c}};P._handlePool=0,P._maxEventSize=250,P=je([qe(0,E.IExtHostRpcService),qe(1,D.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(ve[192],be([0,1,132,90,2,5,7,9,3,17,22]),function(J,e,v,R,S,T,E,D,y,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(r,m,c,p,w){this._name=r,this._owner=m,this._maxDiagnosticsPerFile=c,this._proxy=p,this._onDidChangeDiagnostics=w,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,m){if(!r){this.clear();return}this._checkDisposed();let c=[];if(S.URI.isUri(r)){if(!m){this.delete(r);return}this._data.set(r,m.slice()),c=[r]}else if(Array.isArray(r)){c=[];let w;r=[...r].sort(P._compareIndexedTuplesByUri);for(const a of r){const[h,f]=a;if((!w||h.toString()!==w.toString())&&(w&&this._data.get(w).length===0&&this._data.delete(w),w=h,c.push(h),this._data.set(h,[])),f){const t=this._data.get(h);t&&t.push(...f)}else{const t=this._data.get(h);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(c),!this._proxy)return;const p=[];for(let w of c){let a=[];const h=this._data.get(w);if(h)if(h.length>this._maxDiagnosticsPerFile){a=[];const f=[E.DiagnosticSeverity.Error,E.DiagnosticSeverity.Warning,E.DiagnosticSeverity.Information,E.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of h)if(i.severity===f[t]&&a.push(D.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;a.push({severity:R.MarkerSeverity.Info,message:(0,v.localize)(0,null,h.length-this._maxDiagnosticsPerFile),startLineNumber:a[a.length-1].startLineNumber,startColumn:a[a.length-1].startColumn,endLineNumber:a[a.length-1].endLineNumber,endColumn:a[a.length-1].endColumn})}else a=h.map(f=>D.Diagnostic.from(f));p.push([w,a])}this._proxy.$changeMany(this._owner,p)}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,m){this._checkDisposed();for(let c of this._data.keys())r.apply(m,[c,this.get(c),this])}get(r){this._checkDisposed();const m=this._data.get(r);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,m){return r[0].toString()<m[0].toString()?-1:r[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=P;let d=class zt{constructor(r,m){this._logService=m,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,zt._debouncer,50),zt._mapper),this._proxy=r.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(r,m){return r?r.concat(m):m}static _mapper(r){const m=new n.ResourceMap;for(const c of r)m.set(c,c);return{uris:Object.freeze(Array.from(m.values()))}}createDiagnosticCollection(r,m){const{_collections:c,_proxy:p,_onDidChangeDiagnostics:w,_logService:a}=this,h=new class{$changeMany(i,s){p.$changeMany(i,s),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,i,s.length===0?"CLEARING":s)}$clear(i){p.$clear(i),a.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,i)}dispose(){p.dispose()}};let f;if(!m)m="_generated_diagnostic_collection_name_#"+zt._idPool++,f=m;else if(!c.has(m))f=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do f=m+zt._idPool++;while(c.has(f))}return new class extends P{constructor(){super(m,f,zt._maxDiagnosticsPerFile,h,w);c.set(f,this)}dispose(){super.dispose(),c.delete(f)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const m=new Map,c=[];for(const p of this._collections.values())p.forEach((w,a)=>{let h=m.get(w.toString());typeof h=="undefined"&&(h=c.length,m.set(w.toString(),h),c.push([w,[]])),c[h][1]=c[h][1].concat(...a)});return c}}_getDiagnostics(r){let m=[];for(let c of this._collections.values())c.has(r)&&(m=m.concat(c.get(r)));return m}$acceptMarkersChange(r){if(!this._mirrorCollection){const m="_generated_mirror",c=new P(m,m,zt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(m,c),this._mirrorCollection=c}for(const[m,c]of r)this._mirrorCollection.set(S.URI.revive(m),c.map(D.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=je([qe(1,k.ILogService)],d),e.ExtHostDiagnostics=d}),define(ve[193],be([0,1,2,5]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(E){this._proxy=E.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(E){return this._proxy.$showOpenDialog(E).then(D=>D?D.map(y=>v.URI.revive(y)):void 0)}showSaveDialog(E){return this._proxy.$showSaveDialog(E).then(D=>D?v.URI.revive(D):void 0)}}e.ExtHostDialogs=S}),define(ve[194],be([0,1,12,2,7,5,16,20,8]),function(J,e,v,R,S,T,E,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(P,d,g){this._documentsAndEditors=d,this._logService=g,this._documentContentProviders=new Map,this._proxy=P.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,d){if(Object.keys(E.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const g=k._handlePool++;this._documentContentProviders.set(g,d),this._proxy.$registerTextContentProvider(g,P);let r;return typeof d.onDidChange=="function"&&(r=d.onDidChange(m=>{if(m.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(m)&&this.$provideTextDocumentContent(g,m).then(c=>{if(!c&&typeof c!="string")return;const p=this._documentsAndEditors.getDocument(m);if(!p)return;const w=(0,y.splitLines)(c);if(!p.equalLines(w))return this._proxy.$onVirtualDocumentChange(m,c)},v.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(P,d){const g=this._documentContentProviders.get(P);return g?Promise.resolve(g.provideTextDocumentContent(R.URI.revive(d),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(ve[195],be([0,1,3,6,2,5,96,9,10,24]),function(J,e,v,R,S,T,E,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class n{constructor(d,g){this._onDidAddDocument=new v.Emitter,this._onDidRemoveDocument=new v.Emitter,this._onDidChangeDocument=new v.Emitter,this._onDidSaveDocument=new v.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const m of r)this._onDidRemoveDocument.fire(m.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const m of r)this._onDidAddDocument.fire(m.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const g=this._documentsAndEditors.getDocument(d);if(g)return g}getDocument(d){const g=this.getDocumentData(d);if(!(g==null?void 0:g.document))throw new Error(`Unable to retrieve document from URI '${d}'`);return g.document}ensureDocumentData(d){const g=this._documentsAndEditors.getDocument(d);if(g)return Promise.resolve(g);let r=this._documentLoader.get(d.toString());return r||(r=this._proxy.$tryOpenDocument(d).then(m=>{this._documentLoader.delete(d.toString());const c=S.URI.revive(m);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(c))},m=>(this._documentLoader.delete(d.toString()),Promise.reject(m))),this._documentLoader.set(d.toString(),r)),r}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(g=>S.URI.revive(g))}$acceptModelModeChanged(d,g){const r=S.URI.revive(d),m=this._documentsAndEditors.getDocument(r);if(!m)throw new Error("unknown document");this._onDidRemoveDocument.fire(m.document),m._acceptLanguageId(g),this._onDidAddDocument.fire(m.document)}$acceptModelSaved(d){const g=S.URI.revive(d),r=this._documentsAndEditors.getDocument(g);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(d,g){const r=S.URI.revive(d),m=this._documentsAndEditors.getDocument(r);if(!m)throw new Error("unknown document");m._acceptIsDirty(g),this._onDidChangeDocument.fire({document:m.document,contentChanges:[]})}$acceptModelChanged(d,g,r){const m=S.URI.revive(d),c=this._documentsAndEditors.getDocument(m);if(!c)throw new Error("unknown document");c._acceptIsDirty(r),c.onEvents(g),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:c.document,contentChanges:g.changes.map(p=>({range:D.Range.to(p.range),rangeOffset:p.rangeOffset,rangeLength:p.rangeLength,text:p.text}))}))}setWordDefinitionFor(d,g){(0,E.setWordDefinitionFor)(d,g)}}e.ExtHostDocuments=n}),define(ve[39],be([0,1,42,3,6,2,4,5,96,15,99,9,17,22,16,43,110]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class p{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(h,f){this._extHostRpc=h,this._logService=f,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const f=[],t=[],i=[];if(h.removedDocuments)for(const s of h.removedDocuments){const o=T.URI.revive(s),u=this._documents.get(o);(u==null?void 0:u.unref())&&(this._documents.delete(o),f.push(u.value))}if(h.addedDocuments)for(const s of h.addedDocuments){const o=T.URI.revive(s.uri);let u=this._documents.get(o);if(u&&o.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${o} already exists!'`);u||(u=new p(new y.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),o,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(o,u),t.push(u.value)),u.ref()}if(h.removedEditors)for(const s of h.removedEditors){const o=this._editors.get(s);this._editors.delete(s),o&&i.push(o)}if(h.addedEditors)for(const s of h.addedEditors){const o=T.URI.revive(s.documentUri);v.ok(this._documents.has(o),`document '${o}' does not exist`),v.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const u=this._documents.get(o).value,_=new n.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new c.Lazy(()=>u.document),s.selections.map(P.Selection.to),s.options,s.visibleRanges.map(b=>P.Range.to(b)),typeof s.editorPosition=="number"?P.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,_)}h.newActiveEditor!==void 0&&(v.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,S.dispose)(f),(0,S.dispose)(i),h.removedDocuments&&this._onDidRemoveDocuments.fire(f),h.addedDocuments&&this._onDidAddDocuments.fire(t),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){var f;return(f=this._documents.get(h))===null||f===void 0?void 0:f.value}allDocuments(){return m.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const f=this._editors.get(this._activeEditorId);return h?f:f==null?void 0:f.value}allEditors(){return[...this._editors.values()]}};w=je([qe(0,k.IExtHostRpcService),qe(1,d.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,E.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[196],be([0,1,2,5,6,7,9,120,8,23]),function(J,e,v,R,S,T,E,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const r=this._schemes.indexOf(g);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),r=[];let m,c,p=14,w=14;for(const a of g){let h=m?(0,y.commonPrefixLength)(m,a):0;for(h===0?c=1:c=w;h<a.length;h++)h+1===a.length?(p=w,w=9):w+=1,r.push([c,a.toUpperCase().charCodeAt(h),w]),r.push([c,a.toLowerCase().charCodeAt(h),w]),c=w;m=a,w=p}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new D.StateMachine(r)}}provideDocumentLinks(g){this._initStateMachine();const r=[],m=D.LinkComputer.computeLinks({getLineContent(c){return g.lineAt(c-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const c of m){const p=E.DocumentLink.to(c);p.target&&r.push(p)}return r}}class P{constructor(g,r){this._extHostLanguageFeatures=r,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=g.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){var g;(g=this._linkProviderRegistration)===null||g===void 0||g.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(g,r,m,c={},p){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(w,m),this._enableProposedApi.set(w,p!=null?p:!1);let a=2;c.isCaseSensitive&&(a+=1024),c.isReadonly&&(a+=2048),typeof m.copy=="function"&&(a+=8),typeof m.open=="function"&&typeof m.close=="function"&&typeof m.read=="function"&&typeof m.write=="function"&&(a+=4),this._proxy.$registerFileSystemProvider(w,r,a).catch(f=>{console.error(`FAILED to register filesystem provider of ${g.value}-extension for the scheme ${r}`),console.error(f)});const h=m.onDidChangeFile(f=>{const t=[];for(const i of f){let{uri:s,type:o}=i;if(s.scheme!==r)continue;let u;switch(o){case T.FileChangeType.Changed:u=0;break;case T.FileChangeType.Created:u=1;break;case T.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:u})}this._proxy.$onFileSystemChange(w,t)});return(0,S.toDisposable)(()=>{h.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(w),this._enableProposedApi.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(g,r){const{type:m,ctime:c,mtime:p,size:w,permissions:a}=g;return r?{type:m,ctime:c,mtime:p,size:w,permissions:a}:{type:m,ctime:c,mtime:p,size:w}}$stat(g,r){return Promise.resolve(this._getFsProvider(g).stat(v.URI.revive(r))).then(m=>{var c;return P._asIStat(m,(c=this._enableProposedApi.get(g))!==null&&c!==void 0?c:!1)})}$readdir(g,r){return Promise.resolve(this._getFsProvider(g).readDirectory(v.URI.revive(r)))}$readFile(g,r){return Promise.resolve(this._getFsProvider(g).readFile(v.URI.revive(r))).then(m=>k.VSBuffer.wrap(m))}$writeFile(g,r,m,c){return Promise.resolve(this._getFsProvider(g).writeFile(v.URI.revive(r),m.buffer,c))}$delete(g,r,m){return Promise.resolve(this._getFsProvider(g).delete(v.URI.revive(r),m))}$rename(g,r,m,c){return Promise.resolve(this._getFsProvider(g).rename(v.URI.revive(r),v.URI.revive(m),c))}$copy(g,r,m,c){const p=this._getFsProvider(g);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(v.URI.revive(r),v.URI.revive(m),c))}$mkdir(g,r){return Promise.resolve(this._getFsProvider(g).createDirectory(v.URI.revive(r)))}$watch(g,r,m,c){const p=this._getFsProvider(g).watch(v.URI.revive(m),c);this._watches.set(r,p)}$unwatch(g,r){const m=this._watches.get(r);m&&(m.dispose(),this._watches.delete(r))}$open(g,r,m){const c=this._getFsProvider(g);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(v.URI.revive(r),m))}$close(g,r){const m=this._getFsProvider(g);if(!m.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(m.close(r))}$read(g,r,m,c){const p=this._getFsProvider(g);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const w=k.VSBuffer.alloc(c);return Promise.resolve(p.read(r,m,w.buffer,0,c)).then(a=>w.slice(0,a))}$write(g,r,m,c){const p=this._getFsProvider(g);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(r,m,c.buffer,0,c.byteLength))}_getFsProvider(g){const r=this._fsProvider.get(g);if(!r){const m=new Error;throw m.name="ENOPRO",m.message="no provider",m}return r}}e.ExtHostFileSystem=P}),define(ve[77],be([0,1,5,65,7,23,4,15,49]),function(J,e,v,R,S,T,E,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Ut{constructor(P,d){const g=P.getProxy(v.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return g.$stat(r).catch(Ut._handleError)},readDirectory(r){return g.$readdir(r).catch(Ut._handleError)},createDirectory(r){return g.$mkdir(r).catch(Ut._handleError)},async readFile(r){return g.$readFile(r).then(m=>m.buffer).catch(Ut._handleError)},writeFile(r,m){return g.$writeFile(r,T.VSBuffer.wrap(m)).catch(Ut._handleError)},delete(r,m){return g.$delete(r,Object.assign({recursive:!1,useTrash:!1},m)).catch(Ut._handleError)},rename(r,m,c){return g.$rename(r,m,Object.assign({overwrite:!1},c)).catch(Ut._handleError)},copy(r,m,c){return g.$copy(r,m,Object.assign({overwrite:!1},c)).catch(Ut._handleError)},isWritableFileSystem(r){const m=d.getCapabilities(r);if(typeof m=="number")return!(m&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new S.FileSystemError(String(P));if(P.name==="ENOPRO")throw S.FileSystemError.Unavailable(P.message);switch(P.name){case R.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(P.message);case R.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(P.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(P.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(P.message);case R.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(P.message);case R.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(P.message);default:throw new S.FileSystemError(P.message,P.name)}}};k=je([qe(0,D.IExtHostRpcService),qe(1,y.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,E.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[197],be([0,1,6,5]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(E){this._handlePool=0,this._proxy=E.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(E){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,E),(0,v.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=S}),define(ve[198],be([0,1,2,24,9,7,11,5,8,31,13,10,117,6,87,55,68,56,12]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r,m,c,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(W,Q){this._documents=W,this._provider=Q}provideDocumentSymbols(W,Q){const te=this._documents.getDocument(W);return(0,E.asPromise)(()=>this._provider.provideDocumentSymbols(te,Q)).then(re=>{if(!(0,n.isFalsyOrEmpty)(re))return re[0]instanceof T.DocumentSymbol?re.map(S.DocumentSymbol.from):a._asDocumentSymbolTree(re)})}static _asDocumentSymbolTree(W){var Q;W=W.slice(0).sort((fe,_e)=>{let ue=fe.location.range.start.compareTo(_e.location.range.start);return ue===0&&(ue=_e.location.range.end.compareTo(fe.location.range.end)),ue});const te=[],re=[];for(const fe of W){const _e={name:fe.name||"!!MISSING: name!!",kind:S.SymbolKind.from(fe.kind),tags:((Q=fe.tags)===null||Q===void 0?void 0:Q.map(S.SymbolTag.from))||[],detail:"",containerName:fe.containerName,range:S.Range.from(fe.location.range),selectionRange:S.Range.from(fe.location.range),children:[]};for(;;){if(re.length===0){re.push(_e),te.push(_e);break}const ue=re[re.length-1];if(k.Range.containsRange(ue.range,_e.range)&&!k.Range.equalsRange(ue.range,_e.range)){ue.children&&ue.children.push(_e),re.push(_e);break}re.pop()}}return te}}class h{constructor(W,Q,te){this._documents=W,this._commands=Q,this._provider=te,this._cache=new c.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(W,Q){const te=this._documents.getDocument(W),re=await this._provider.provideCodeLenses(te,Q);if(!re||Q.isCancellationRequested)return;const fe=this._cache.add(re),_e=new g.DisposableStore;this._disposables.set(fe,_e);const ue={cacheId:fe,lenses:[]};for(let we=0;we<re.length;we++)ue.lenses.push({cacheId:[fe,we],range:S.Range.from(re[we].range),command:this._commands.toInternal(re[we].command,_e)});return ue}async resolveCodeLens(W,Q){var te;const re=W.cacheId&&this._cache.get(...W.cacheId);if(!re)return;let fe;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?fe=re:fe=await this._provider.resolveCodeLens(re,Q),fe||(fe=re),Q.isCancellationRequested)return;const _e=W.cacheId&&this._disposables.get(W.cacheId[0]);if(!!_e)return W.command=this._commands.toInternal((te=fe.command)!==null&&te!==void 0?te:h._badCmd,_e),W}releaseCodeLenses(W){var Q;(Q=this._disposables.get(W))===null||Q===void 0||Q.dispose(),this._disposables.delete(W),this._cache.delete(W)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function f(Ve){return Array.isArray(Ve)?Ve.map(S.DefinitionLink.from):Ve?[S.DefinitionLink.from(Ve)]:[]}class t{constructor(W,Q){this._documents=W,this._provider=Q}provideDefinition(W,Q,te){const re=this._documents.getDocument(W),fe=S.Position.to(Q);return(0,E.asPromise)(()=>this._provider.provideDefinition(re,fe,te)).then(f)}}class i{constructor(W,Q){this._documents=W,this._provider=Q}provideDeclaration(W,Q,te){const re=this._documents.getDocument(W),fe=S.Position.to(Q);return(0,E.asPromise)(()=>this._provider.provideDeclaration(re,fe,te)).then(f)}}class s{constructor(W,Q){this._documents=W,this._provider=Q}provideImplementation(W,Q,te){const re=this._documents.getDocument(W),fe=S.Position.to(Q);return(0,E.asPromise)(()=>this._provider.provideImplementation(re,fe,te)).then(f)}}class o{constructor(W,Q){this._documents=W,this._provider=Q}provideTypeDefinition(W,Q,te){const re=this._documents.getDocument(W),fe=S.Position.to(Q);return(0,E.asPromise)(()=>this._provider.provideTypeDefinition(re,fe,te)).then(f)}}class u{constructor(W,Q){this._documents=W,this._provider=Q}provideHover(W,Q,te){const re=this._documents.getDocument(W),fe=S.Position.to(Q);return(0,E.asPromise)(()=>this._provider.provideHover(re,fe,te)).then(_e=>{if(!(!_e||(0,n.isFalsyOrEmpty)(_e.contents)))return _e.range||(_e.range=re.getWordRangeAtPosition(fe)),_e.range||(_e.range=new T.Range(fe,fe)),S.Hover.from(_e)})}}class _{constructor(W,Q){this._documents=W,this._provider=Q}provideEvaluatableExpression(W,Q,te){const re=this._documents.getDocument(W),fe=S.Position.to(Q);return(0,E.asPromise)(()=>this._provider.provideEvaluatableExpression(re,fe,te)).then(_e=>{if(_e)return S.EvaluatableExpression.from(_e)})}}class b{constructor(W,Q){this._documents=W,this._provider=Q}provideInlineValues(W,Q,te,re){const fe=this._documents.getDocument(W);return(0,E.asPromise)(()=>this._provider.provideInlineValues(fe,S.Range.to(Q),S.InlineValueContext.to(te),re)).then(_e=>{if(Array.isArray(_e))return _e.map(ue=>S.InlineValue.from(ue))})}}class A{constructor(W,Q){this._documents=W,this._provider=Q}provideDocumentHighlights(W,Q,te){const re=this._documents.getDocument(W),fe=S.Position.to(Q);return(0,E.asPromise)(()=>this._provider.provideDocumentHighlights(re,fe,te)).then(_e=>{if(Array.isArray(_e))return _e.map(S.DocumentHighlight.from)})}}class C{constructor(W,Q){this._documents=W,this._provider=Q}provideLinkedEditingRanges(W,Q,te){const re=this._documents.getDocument(W),fe=S.Position.to(Q);return(0,E.asPromise)(()=>this._provider.provideLinkedEditingRanges(re,fe,te)).then(_e=>{if(_e&&Array.isArray(_e.ranges))return{ranges:(0,n.coalesce)(_e.ranges.map(S.Range.from)),wordPattern:_e.wordPattern}})}}class l{constructor(W,Q){this._documents=W,this._provider=Q}provideReferences(W,Q,te,re){const fe=this._documents.getDocument(W),_e=S.Position.to(Q);return(0,E.asPromise)(()=>this._provider.provideReferences(fe,_e,te,re)).then(ue=>{if(Array.isArray(ue))return ue.map(S.location.from)})}}class F{constructor(W,Q,te,re,fe,_e,ue){this._documents=W,this._commands=Q,this._diagnostics=te,this._provider=re,this._logService=fe,this._extension=_e,this._apiDeprecation=ue,this._cache=new c.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(W,Q,te,re){const fe=this._documents.getDocument(W),_e=d.Selection.isISelection(Q)?S.Selection.to(Q):S.Range.to(Q),ue=[];for(const Ae of this._diagnostics.getDiagnostics(W))if(_e.intersection(Ae.range)&&ue.push(Ae)>F._maxCodeActionsPerFile)break;const we={diagnostics:ue,only:te.only?new T.CodeActionKind(te.only):void 0,triggerKind:S.CodeActionTriggerKind.to(te.trigger)};return(0,E.asPromise)(()=>this._provider.provideCodeActions(fe,_e,we,re)).then(Ae=>{var xe;if(!(0,n.isNonEmptyArray)(Ae)||re.isCancellationRequested)return;const ge=this._cache.add(Ae),Ke=new g.DisposableStore;this._disposables.set(ge,Ke);const j=[];for(let Z=0;Z<Ae.length;Z++){const me=Ae[Z];!me||(F._isCommand(me)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),j.push({_isSynthetic:!0,title:me.title,command:this._commands.toInternal(me,Ke)})):(we.only&&(me.kind?we.only.contains(me.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action is of kind '${me.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),j.push({cacheId:[ge,Z],title:me.title,command:me.command&&this._commands.toInternal(me.command,Ke),diagnostics:me.diagnostics&&me.diagnostics.map(S.Diagnostic.from),edit:me.edit&&S.WorkspaceEdit.from(me.edit),kind:me.kind&&me.kind.value,isPreferred:me.isPreferred,disabled:(xe=me.disabled)===null||xe===void 0?void 0:xe.reason})))}return{cacheId:ge,actions:j}})}async resolveCodeAction(W,Q){var te;const[re,fe]=W,_e=this._cache.get(re,fe);if(!_e||F._isCommand(_e)||!this._provider.resolveCodeAction)return;const ue=(te=await this._provider.resolveCodeAction(_e,Q))!==null&&te!==void 0?te:_e;return(ue==null?void 0:ue.edit)?S.WorkspaceEdit.from(ue.edit):void 0}releaseCodeActions(W){var Q;(Q=this._disposables.get(W))===null||Q===void 0||Q.dispose(),this._disposables.delete(W),this._cache.delete(W)}static _isCommand(W){return typeof W.command=="string"&&typeof W.title=="string"}}F._maxCodeActionsPerFile=1e3;class N{constructor(W,Q){this._documents=W,this._provider=Q}provideDocumentFormattingEdits(W,Q,te){const re=this._documents.getDocument(W);return(0,E.asPromise)(()=>this._provider.provideDocumentFormattingEdits(re,Q,te)).then(fe=>{if(Array.isArray(fe))return fe.map(S.TextEdit.from)})}}class z{constructor(W,Q){this._documents=W,this._provider=Q}provideDocumentRangeFormattingEdits(W,Q,te,re){const fe=this._documents.getDocument(W),_e=S.Range.to(Q);return(0,E.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(fe,_e,te,re)).then(ue=>{if(Array.isArray(ue))return ue.map(S.TextEdit.from)})}}class de{constructor(W,Q){this._documents=W,this._provider=Q,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(W,Q,te,re,fe){const _e=this._documents.getDocument(W),ue=S.Position.to(Q);return(0,E.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(_e,ue,te,re,fe)).then(we=>{if(Array.isArray(we))return we.map(S.TextEdit.from)})}}class he{constructor(W,Q){this._provider=W,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(W,Q){const te=D.IdObject.mixin({symbols:[]});return(0,E.asPromise)(()=>this._provider.provideWorkspaceSymbols(W,Q)).then(re=>{if((0,n.isNonEmptyArray)(re))for(const fe of re){if(!fe)continue;if(!fe.name){this._logService.warn("INVALID SymbolInformation, lacks name",fe);continue}const _e=D.IdObject.mixin(S.WorkspaceSymbol.from(fe));this._symbolCache.set(_e._id,fe),te.symbols.push(_e)}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol(W,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return W;const te=this._symbolCache.get(W._id);if(te){const re=await(0,E.asPromise)(()=>this._provider.resolveWorkspaceSymbol(te,Q));return re&&(0,R.mixin)(W,S.WorkspaceSymbol.from(re),!0)}}releaseWorkspaceSymbols(W){const Q=this._resultCache.get(W);if(Q){for(let[te,re]=Q;te<=re;te++)this._symbolCache.delete(te);this._resultCache.delete(W)}}}class ${constructor(W,Q,te){this._documents=W,this._provider=Q,this._logService=te}static supportsResolving(W){return typeof W.prepareRename=="function"}provideRenameEdits(W,Q,te,re){const fe=this._documents.getDocument(W),_e=S.Position.to(Q);return(0,E.asPromise)(()=>this._provider.provideRenameEdits(fe,_e,te,re)).then(ue=>{if(!!ue)return S.WorkspaceEdit.from(ue)},ue=>{const we=$._asMessage(ue);return we?{rejectReason:we,edits:void 0}:Promise.reject(ue)})}resolveRenameLocation(W,Q,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const re=this._documents.getDocument(W),fe=S.Position.to(Q);return(0,E.asPromise)(()=>this._provider.prepareRename(re,fe,te)).then(_e=>{let ue,we;if(T.Range.isRange(_e)?(ue=_e,we=re.getText(_e)):(0,P.isObject)(_e)&&(ue=_e.range,we=_e.placeholder),!!ue){if(ue.start.line>fe.line||ue.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(ue),text:we}}},_e=>{const ue=$._asMessage(_e);return ue?{rejectReason:ue,range:void 0,text:void 0}:Promise.reject(_e)})}static _asMessage(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class q{constructor(W,Q){this.resultId=W,this.tokens=Q}}class x{constructor(W,Q){this._documents=W,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(W,Q,te){const re=this._documents.getDocument(W),fe=Q!==0?this._previousResults.get(Q):null;return(0,E.asPromise)(()=>fe&&typeof fe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(re,fe.resultId,te):this._provider.provideDocumentSemanticTokens(re,te)).then(_e=>(fe&&this._previousResults.delete(Q),_e?(_e=x._fixProvidedSemanticTokens(_e),this._send(x._convertToEdits(fe,_e),_e)):null))}async releaseDocumentSemanticColoring(W){this._previousResults.delete(W)}static _fixProvidedSemanticTokens(W){return x._isSemanticTokens(W)?x._isCorrectSemanticTokens(W)?W:new T.SemanticTokens(new Uint32Array(W.data),W.resultId):x._isSemanticTokensEdits(W)?x._isCorrectSemanticTokensEdits(W)?W:new T.SemanticTokensEdits(W.edits.map(Q=>new T.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),W.resultId):W}static _isSemanticTokens(W){return W&&!!W.data}static _isCorrectSemanticTokens(W){return W.data instanceof Uint32Array}static _isSemanticTokensEdits(W){return W&&Array.isArray(W.edits)}static _isCorrectSemanticTokensEdits(W){for(const Q of W.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(W,Q){if(!x._isSemanticTokens(Q)||!W||!W.tokens)return Q;const te=W.tokens,re=te.length,fe=Q.data,_e=fe.length;let ue=0;const we=Math.min(re,_e);for(;ue<we&&te[ue]===fe[ue];)ue++;if(ue===re&&ue===_e)return new T.SemanticTokensEdits([],Q.resultId);let Ae=0;const xe=we-ue;for(;Ae<xe&&te[re-Ae-1]===fe[_e-Ae-1];)Ae++;return new T.SemanticTokensEdits([{start:ue,deleteCount:re-ue-Ae,data:fe.subarray(ue,_e-Ae)}],Q.resultId)}_send(W,Q){if(x._isSemanticTokens(W)){const te=this._nextResultId++;return this._previousResults.set(te,new q(W.resultId,W.data)),(0,r.encodeSemanticTokensDto)({id:te,type:"full",data:W.data})}if(x._isSemanticTokensEdits(W)){const te=this._nextResultId++;return x._isSemanticTokens(Q)?this._previousResults.set(te,new q(Q.resultId,Q.data)):this._previousResults.set(te,new q(W.resultId)),(0,r.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(W.edits||[]).map(re=>({start:re.start,deleteCount:re.deleteCount,data:re.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class I{constructor(W,Q){this._documents=W,this._provider=Q}provideDocumentRangeSemanticTokens(W,Q,te){const re=this._documents.getDocument(W);return(0,E.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(re,S.Range.to(Q),te)).then(fe=>fe?this._send(fe):null)}_send(W){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:W.data})}}e.DocumentRangeSemanticTokensAdapter=I;class H{constructor(W,Q,te,re,fe){this._documents=W,this._commands=Q,this._provider=te,this._apiDeprecation=re,this._extension=fe,this._cache=new c.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}async provideCompletionItems(W,Q,te,re){const fe=this._documents.getDocument(W),_e=S.Position.to(Q),ue=fe.getWordRangeAtPosition(_e)||new T.Range(_e,_e),we=ue.with({end:_e}),Ae=new p.StopWatch(!0),xe=await(0,E.asPromise)(()=>this._provider.provideCompletionItems(fe,_e,re,S.CompletionContext.to(te)));if(!xe||re.isCancellationRequested)return;const ge=Array.isArray(xe)?new T.CompletionList(xe):xe,Ke=H.supportsResolving(this._provider)?this._cache.add(ge.items):this._cache.add([]),j=new g.DisposableStore;this._disposables.set(Ke,j);const Z=[],me={x:Ke,b:Z,a:{replace:S.Range.from(ue),insert:S.Range.from(we)},c:ge.isIncomplete||void 0,d:Ae.elapsed()};for(let Oe=0;Oe<ge.items.length;Oe++){const He=ge.items[Oe],$e=this._convertCompletionItem(He,[Ke,Oe],we,ue);Z.push($e)}return me}async resolveCompletionItem(W,Q){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...W);if(!te)return;const re=await(0,E.asPromise)(()=>this._provider.resolveCompletionItem(te,Q));if(!!re)return this._convertCompletionItem(re,W)}releaseCompletionItems(W){var Q;(Q=this._disposables.get(W))===null||Q===void 0||Q.dispose(),this._disposables.delete(W),this._cache.delete(W)}_convertCompletionItem(W,Q,te,re){var fe;const _e=this._disposables.get(Q[0]);if(!_e)throw Error("DisposableStore is missing...");const ue={x:Q,a:(fe=W.label)!==null&&fe!==void 0?fe:"",o:W.label2,b:W.kind!==void 0?S.CompletionItemKind.from(W.kind):void 0,n:W.tags&&W.tags.map(S.CompletionItemTag.from),c:W.detail,d:typeof W.documentation=="undefined"?void 0:S.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters,l:W.additionalTextEdits&&W.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal(W.command,_e)};W.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ue.h=W.textEdit.newText):typeof W.insertText=="string"?ue.h=W.insertText:W.insertText instanceof T.SnippetString&&(ue.h=W.insertText.value,ue.i|=4);let we;return W.textEdit?we=W.textEdit.range:W.range&&(we=W.range),T.Range.isRange(we)?ue.j=S.Range.from(we):we&&(!(te==null?void 0:te.isEqual(we.inserting))||!(re==null?void 0:re.isEqual(we.replacing)))&&(ue.j={insert:S.Range.from(we.inserting),replace:S.Range.from(we.replacing)}),ue}}class M{constructor(W,Q){this._documents=W,this._provider=Q}async provideInlineCompletions(W,Q,te,re){const fe=this._documents.getDocument(W),_e=S.Position.to(Q),ue=await(0,E.asPromise)(()=>this._provider.provideInlineCompletionItems(fe,_e,te,re));if(!!ue&&!re.isCancellationRequested)return{items:ue.items.map(we=>({text:we.text,range:we.range?S.Range.from(we.range):void 0}))}}}class B{constructor(W,Q){this._documents=W,this._provider=Q,this._cache=new c.Cache("SignatureHelp")}provideSignatureHelp(W,Q,te,re){const fe=this._documents.getDocument(W),_e=S.Position.to(Q),ue=this.reviveContext(te);return(0,E.asPromise)(()=>this._provider.provideSignatureHelp(fe,_e,re,ue)).then(we=>{if(we){const Ae=this._cache.add([we]);return Object.assign(Object.assign({},S.SignatureHelp.from(we)),{id:Ae})}})}reviveContext(W){let Q;if(W.activeSignatureHelp){const te=S.SignatureHelp.to(W.activeSignatureHelp),re=this._cache.get(W.activeSignatureHelp.id,0);re?(Q=re,Q.activeSignature=te.activeSignature,Q.activeParameter=te.activeParameter):Q=te}return Object.assign(Object.assign({},W),{activeSignatureHelp:Q})}releaseSignatureHelp(W){this._cache.delete(W)}}class G{constructor(W,Q){this._documents=W,this._provider=Q}provideInlayHints(W,Q,te){const re=this._documents.getDocument(W);return(0,E.asPromise)(()=>this._provider.provideInlayHints(re,S.Range.to(Q),te)).then(fe=>fe?{hints:fe.map(S.InlayHint.from)}:void 0)}}class K{constructor(W,Q){this._documents=W,this._provider=Q,this._cache=new c.Cache("DocumentLink")}provideLinks(W,Q){const te=this._documents.getDocument(W);return(0,E.asPromise)(()=>this._provider.provideDocumentLinks(te,Q)).then(re=>{if(!(!Array.isArray(re)||re.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:re.map(S.DocumentLink.from)};{const fe=this._cache.add(re),_e={links:[],id:fe};for(let ue=0;ue<re.length;ue++){const we=S.DocumentLink.from(re[ue]);we.cacheId=[fe,ue],_e.links.push(we)}return _e}}})}resolveLink(W,Q){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...W);return te?(0,E.asPromise)(()=>this._provider.resolveDocumentLink(te,Q)).then(re=>re&&S.DocumentLink.from(re)||void 0):Promise.resolve(void 0)}releaseLinks(W){this._cache.delete(W)}}class se{constructor(W,Q){this._documents=W,this._provider=Q}provideColors(W,Q){const te=this._documents.getDocument(W);return(0,E.asPromise)(()=>this._provider.provideDocumentColors(te,Q)).then(re=>Array.isArray(re)?re.map(_e=>({color:S.Color.from(_e.color),range:S.Range.from(_e.range)})):[])}provideColorPresentations(W,Q,te){const re=this._documents.getDocument(W),fe=S.Range.to(Q.range),_e=S.Color.to(Q.color);return(0,E.asPromise)(()=>this._provider.provideColorPresentations(_e,{document:re,range:fe},te)).then(ue=>{if(!!Array.isArray(ue))return ue.map(S.ColorPresentation.from)})}}class pe{constructor(W,Q){this._documents=W,this._provider=Q}provideFoldingRanges(W,Q,te){const re=this._documents.getDocument(W);return(0,E.asPromise)(()=>this._provider.provideFoldingRanges(re,Q,te)).then(fe=>{if(!!Array.isArray(fe))return fe.map(S.FoldingRange.from)})}}class Fe{constructor(W,Q,te){this._documents=W,this._provider=Q,this._logService=te}provideSelectionRanges(W,Q,te){const re=this._documents.getDocument(W),fe=Q.map(S.Position.to);return(0,E.asPromise)(()=>this._provider.provideSelectionRanges(re,fe,te)).then(_e=>{if(!(0,n.isNonEmptyArray)(_e))return[];if(_e.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ue=[];for(let we=0;we<fe.length;we++){const Ae=[];ue.push(Ae);let xe=fe[we],ge=_e[we];for(;;){if(!ge.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(Ae.push(S.SelectionRange.from(ge)),!ge.parent)break;xe=ge.range,ge=ge.parent}}return ue})}}class We{constructor(W,Q){this._documents=W,this._provider=Q,this._idPool=new m.IdGenerator(""),this._cache=new Map}async prepareSession(W,Q,te){const re=this._documents.getDocument(W),fe=S.Position.to(Q),_e=await this._provider.prepareCallHierarchy(re,fe,te);if(!_e)return;const ue=this._idPool.nextId();return this._cache.set(ue,new Map),Array.isArray(_e)?_e.map(we=>this._cacheAndConvertItem(ue,we)):[this._cacheAndConvertItem(ue,_e)]}async provideCallsTo(W,Q,te){const re=this._itemFromCache(W,Q);if(!re)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(re,te);if(!!fe)return fe.map(_e=>({from:this._cacheAndConvertItem(W,_e.from),fromRanges:_e.fromRanges.map(ue=>S.Range.from(ue))}))}async provideCallsFrom(W,Q,te){const re=this._itemFromCache(W,Q);if(!re)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(re,te);if(!!fe)return fe.map(_e=>({to:this._cacheAndConvertItem(W,_e.to),fromRanges:_e.fromRanges.map(ue=>S.Range.from(ue))}))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,Q){var te;const re=this._cache.get(W),fe={_sessionId:W,_itemId:re.size.toString(36),name:Q.name,detail:Q.detail,kind:S.SymbolKind.from(Q.kind),uri:Q.uri,range:S.Range.from(Q.range),selectionRange:S.Range.from(Q.selectionRange),tags:(te=Q.tags)===null||te===void 0?void 0:te.map(S.SymbolTag.from)};return re.set(fe._itemId,Q),fe}_itemFromCache(W,Q){const te=this._cache.get(W);return te==null?void 0:te.get(Q)}}class Ne{constructor(W,Q){this.adapter=W,this.extension=Q}}class ze{constructor(W,Q,te,re,fe,_e,ue){this._adapter=new Map,this._uriTransformer=Q,this._proxy=W.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=re,this._diagnostics=fe,this._logService=_e,this._apiDeprecation=ue}_transformDocumentSelector(W){return(0,n.coalesce)((0,n.asArray)(W).map(Q=>this._doTransformDocumentSelector(Q)))}_doTransformDocumentSelector(W){if(typeof W=="string")return{$serialized:!0,language:W};if(W)return{$serialized:!0,language:W.language,scheme:this._transformScheme(W.scheme),pattern:typeof W.pattern=="undefined"?void 0:S.GlobPattern.from(W.pattern),exclusive:W.exclusive}}_transformScheme(W){return this._uriTransformer&&typeof W=="string"?this._uriTransformer.transformOutgoingScheme(W):W}_createDisposable(W){return new T.Disposable(()=>{this._adapter.delete(W),this._proxy.$unregister(W)})}_nextHandle(){return ze._handlePool++}_withAdapter(W,Q,te,re,fe=!1){const _e=this._adapter.get(W);if(!_e)return Promise.resolve(re);if(_e.adapter instanceof Q){let ue;_e.extension&&(ue=Date.now(),this._logService.trace(`[${_e.extension.identifier.value}] INVOKE provider '${Q.name}'`));const we=te(_e.adapter,_e.extension),Ae=_e.extension;return Ae&&Promise.resolve(we).then(()=>this._logService.trace(`[${Ae.identifier.value}] provider DONE after ${Date.now()-ue}ms`),xe=>{fe&&xe instanceof w.CancellationError||(this._logService.error(`[${Ae.identifier.value}] provider FAILED`),this._logService.error(xe))}),we}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(W,Q){const te=this._nextHandle();return this._adapter.set(te,new Ne(W,Q)),te}static _extLabel(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,Q,te,re){const fe=this._addNewAdapter(new a(this._documents,te),W),_e=re&&re.label||ze._extLabel(W);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(Q),_e),this._createDisposable(fe)}$provideDocumentSymbols(W,Q,te){return this._withAdapter(W,a,re=>re.provideDocumentSymbols(v.URI.revive(Q),te),void 0)}registerCodeLensProvider(W,Q,te){const re=this._nextHandle(),fe=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(re,new Ne(new h(this._documents,this._commands.converter,te),W)),this._proxy.$registerCodeLensSupport(re,this._transformDocumentSelector(Q),fe);let _e=this._createDisposable(re);if(fe!==void 0){const ue=te.onDidChangeCodeLenses(we=>this._proxy.$emitCodeLensEvent(fe));_e=T.Disposable.from(_e,ue)}return _e}$provideCodeLenses(W,Q,te){return this._withAdapter(W,h,re=>re.provideCodeLenses(v.URI.revive(Q),te),void 0)}$resolveCodeLens(W,Q,te){return this._withAdapter(W,h,re=>re.resolveCodeLens(Q,te),void 0)}$releaseCodeLenses(W,Q){this._withAdapter(W,h,te=>Promise.resolve(te.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider(W,Q,te){const re=this._addNewAdapter(new t(this._documents,te),W);return this._proxy.$registerDefinitionSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDefinition(W,Q,te,re){return this._withAdapter(W,t,fe=>fe.provideDefinition(v.URI.revive(Q),te,re),[])}registerDeclarationProvider(W,Q,te){const re=this._addNewAdapter(new i(this._documents,te),W);return this._proxy.$registerDeclarationSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDeclaration(W,Q,te,re){return this._withAdapter(W,i,fe=>fe.provideDeclaration(v.URI.revive(Q),te,re),[])}registerImplementationProvider(W,Q,te){const re=this._addNewAdapter(new s(this._documents,te),W);return this._proxy.$registerImplementationSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideImplementation(W,Q,te,re){return this._withAdapter(W,s,fe=>fe.provideImplementation(v.URI.revive(Q),te,re),[])}registerTypeDefinitionProvider(W,Q,te){const re=this._addNewAdapter(new o(this._documents,te),W);return this._proxy.$registerTypeDefinitionSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideTypeDefinition(W,Q,te,re){return this._withAdapter(W,o,fe=>fe.provideTypeDefinition(v.URI.revive(Q),te,re),[])}registerHoverProvider(W,Q,te,re){const fe=this._addNewAdapter(new u(this._documents,te),W);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(Q)),this._createDisposable(fe)}$provideHover(W,Q,te,re){return this._withAdapter(W,u,fe=>fe.provideHover(v.URI.revive(Q),te,re),void 0)}registerEvaluatableExpressionProvider(W,Q,te,re){const fe=this._addNewAdapter(new _(this._documents,te),W);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(Q)),this._createDisposable(fe)}$provideEvaluatableExpression(W,Q,te,re){return this._withAdapter(W,_,fe=>fe.provideEvaluatableExpression(v.URI.revive(Q),te,re),void 0)}registerInlineValuesProvider(W,Q,te,re){const fe=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,_e=this._addNewAdapter(new b(this._documents,te),W);this._proxy.$registerInlineValuesProvider(_e,this._transformDocumentSelector(Q),fe);let ue=this._createDisposable(_e);if(fe!==void 0){const we=te.onDidChangeInlineValues(Ae=>this._proxy.$emitInlineValuesEvent(fe));ue=T.Disposable.from(ue,we)}return ue}$provideInlineValues(W,Q,te,re,fe){return this._withAdapter(W,b,_e=>_e.provideInlineValues(v.URI.revive(Q),te,re,fe),void 0)}registerDocumentHighlightProvider(W,Q,te){const re=this._addNewAdapter(new A(this._documents,te),W);return this._proxy.$registerDocumentHighlightProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDocumentHighlights(W,Q,te,re){return this._withAdapter(W,A,fe=>fe.provideDocumentHighlights(v.URI.revive(Q),te,re),void 0)}registerLinkedEditingRangeProvider(W,Q,te){const re=this._addNewAdapter(new C(this._documents,te),W);return this._proxy.$registerLinkedEditingRangeProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideLinkedEditingRanges(W,Q,te,re){return this._withAdapter(W,C,async fe=>{const _e=await fe.provideLinkedEditingRanges(v.URI.revive(Q),te,re);if(_e)return{ranges:_e.ranges,wordPattern:_e.wordPattern?ze._serializeRegExp(_e.wordPattern):void 0}},void 0)}registerReferenceProvider(W,Q,te){const re=this._addNewAdapter(new l(this._documents,te),W);return this._proxy.$registerReferenceSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideReferences(W,Q,te,re,fe){return this._withAdapter(W,l,_e=>_e.provideReferences(v.URI.revive(Q),te,re,fe),void 0)}registerCodeActionProvider(W,Q,te,re){var fe,_e;const ue=new g.DisposableStore,we=this._addNewAdapter(new F(this._documents,this._commands.converter,this._diagnostics,te,this._logService,W,this._apiDeprecation),W);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector(Q),{providedKinds:(fe=re==null?void 0:re.providedCodeActionKinds)===null||fe===void 0?void 0:fe.map(Ae=>Ae.value),documentation:(_e=re==null?void 0:re.documentation)===null||_e===void 0?void 0:_e.map(Ae=>({kind:Ae.kind.value,command:this._commands.converter.toInternal(Ae.command,ue)}))},ze._extLabel(W),Boolean(te.resolveCodeAction)),ue.add(this._createDisposable(we)),ue}$provideCodeActions(W,Q,te,re,fe){return this._withAdapter(W,F,_e=>_e.provideCodeActions(v.URI.revive(Q),te,re,fe),void 0)}$resolveCodeAction(W,Q,te){return this._withAdapter(W,F,re=>re.resolveCodeAction(Q,te),void 0)}$releaseCodeActions(W,Q){this._withAdapter(W,F,te=>Promise.resolve(te.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider(W,Q,te){const re=this._addNewAdapter(new N(this._documents,te),W);return this._proxy.$registerDocumentFormattingSupport(re,this._transformDocumentSelector(Q),W.identifier,W.displayName||W.name),this._createDisposable(re)}$provideDocumentFormattingEdits(W,Q,te,re){return this._withAdapter(W,N,fe=>fe.provideDocumentFormattingEdits(v.URI.revive(Q),te,re),void 0)}registerDocumentRangeFormattingEditProvider(W,Q,te){const re=this._addNewAdapter(new z(this._documents,te),W);return this._proxy.$registerRangeFormattingSupport(re,this._transformDocumentSelector(Q),W.identifier,W.displayName||W.name),this._createDisposable(re)}$provideDocumentRangeFormattingEdits(W,Q,te,re,fe){return this._withAdapter(W,z,_e=>_e.provideDocumentRangeFormattingEdits(v.URI.revive(Q),te,re,fe),void 0)}registerOnTypeFormattingEditProvider(W,Q,te,re){const fe=this._addNewAdapter(new de(this._documents,te),W);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(Q),re,W.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(W,Q,te,re,fe,_e){return this._withAdapter(W,de,ue=>ue.provideOnTypeFormattingEdits(v.URI.revive(Q),te,re,fe,_e),void 0)}registerWorkspaceSymbolProvider(W,Q){const te=this._addNewAdapter(new he(Q,this._logService),W);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(W,Q,te){return this._withAdapter(W,he,re=>re.provideWorkspaceSymbols(Q,te),{symbols:[]})}$resolveWorkspaceSymbol(W,Q,te){return this._withAdapter(W,he,re=>re.resolveWorkspaceSymbol(Q,te),void 0)}$releaseWorkspaceSymbols(W,Q){this._withAdapter(W,he,te=>te.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider(W,Q,te){const re=this._addNewAdapter(new $(this._documents,te,this._logService),W);return this._proxy.$registerRenameSupport(re,this._transformDocumentSelector(Q),$.supportsResolving(te)),this._createDisposable(re)}$provideRenameEdits(W,Q,te,re,fe){return this._withAdapter(W,$,_e=>_e.provideRenameEdits(v.URI.revive(Q),te,re,fe),void 0)}$resolveRenameLocation(W,Q,te,re){return this._withAdapter(W,$,fe=>fe.resolveRenameLocation(v.URI.revive(Q),te,re),void 0)}registerDocumentSemanticTokensProvider(W,Q,te,re){const fe=this._nextHandle(),_e=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(fe,new Ne(new x(this._documents,te),W)),this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(Q),re,_e);let ue=this._createDisposable(fe);if(_e){const we=te.onDidChangeSemanticTokens(Ae=>this._proxy.$emitDocumentSemanticTokensEvent(_e));ue=T.Disposable.from(ue,we)}return ue}$provideDocumentSemanticTokens(W,Q,te,re){return this._withAdapter(W,x,fe=>fe.provideDocumentSemanticTokens(v.URI.revive(Q),te,re),null,!0)}$releaseDocumentSemanticTokens(W,Q){this._withAdapter(W,x,te=>te.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider(W,Q,te,re){const fe=this._addNewAdapter(new I(this._documents,te),W);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(Q),re),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(W,Q,te,re){return this._withAdapter(W,I,fe=>fe.provideDocumentRangeSemanticTokens(v.URI.revive(Q),te,re),null,!0)}registerCompletionItemProvider(W,Q,te,re){const fe=this._addNewAdapter(new H(this._documents,this._commands.converter,te,this._apiDeprecation,W),W);return this._proxy.$registerSuggestSupport(fe,this._transformDocumentSelector(Q),re,H.supportsResolving(te),`${W.identifier.value}(${re.join("")})`),this._createDisposable(fe)}$provideCompletionItems(W,Q,te,re,fe){return this._withAdapter(W,H,_e=>_e.provideCompletionItems(v.URI.revive(Q),te,re,fe),void 0)}$resolveCompletionItem(W,Q,te){return this._withAdapter(W,H,re=>re.resolveCompletionItem(Q,te),void 0)}$releaseCompletionItems(W,Q){this._withAdapter(W,H,te=>te.releaseCompletionItems(Q),void 0)}registerInlineCompletionsProvider(W,Q,te){const re=this._addNewAdapter(new M(this._documents,te),W);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideInlineCompletions(W,Q,te,re,fe){return this._withAdapter(W,M,_e=>_e.provideInlineCompletions(v.URI.revive(Q),te,re,fe),void 0)}registerSignatureHelpProvider(W,Q,te,re){const fe=Array.isArray(re)?{triggerCharacters:re,retriggerCharacters:[]}:re,_e=this._addNewAdapter(new B(this._documents,te),W);return this._proxy.$registerSignatureHelpProvider(_e,this._transformDocumentSelector(Q),fe),this._createDisposable(_e)}$provideSignatureHelp(W,Q,te,re,fe){return this._withAdapter(W,B,_e=>_e.provideSignatureHelp(v.URI.revive(Q),te,re,fe),void 0)}$releaseSignatureHelp(W,Q){this._withAdapter(W,B,te=>te.releaseSignatureHelp(Q),void 0)}registerInlayHintsProvider(W,Q,te){const re=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new G(this._documents,te),W);this._proxy.$registerInlayHintsProvider(fe,this._transformDocumentSelector(Q),re);let _e=this._createDisposable(fe);if(re!==void 0){const ue=te.onDidChangeInlayHints(we=>this._proxy.$emitInlayHintsEvent(re));_e=T.Disposable.from(_e,ue)}return _e}$provideInlayHints(W,Q,te,re){return this._withAdapter(W,G,fe=>fe.provideInlayHints(v.URI.revive(Q),te,re),void 0)}registerDocumentLinkProvider(W,Q,te){const re=this._addNewAdapter(new K(this._documents,te),W);return this._proxy.$registerDocumentLinkProvider(re,this._transformDocumentSelector(Q),typeof te.resolveDocumentLink=="function"),this._createDisposable(re)}$provideDocumentLinks(W,Q,te){return this._withAdapter(W,K,re=>re.provideLinks(v.URI.revive(Q),te),void 0)}$resolveDocumentLink(W,Q,te){return this._withAdapter(W,K,re=>re.resolveLink(Q,te),void 0)}$releaseDocumentLinks(W,Q){this._withAdapter(W,K,te=>te.releaseLinks(Q),void 0)}registerColorProvider(W,Q,te){const re=this._addNewAdapter(new se(this._documents,te),W);return this._proxy.$registerDocumentColorProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDocumentColors(W,Q,te){return this._withAdapter(W,se,re=>re.provideColors(v.URI.revive(Q),te),[])}$provideColorPresentations(W,Q,te,re){return this._withAdapter(W,se,fe=>fe.provideColorPresentations(v.URI.revive(Q),te,re),void 0)}registerFoldingRangeProvider(W,Q,te){const re=this._nextHandle(),fe=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(re,new Ne(new pe(this._documents,te),W)),this._proxy.$registerFoldingRangeProvider(re,this._transformDocumentSelector(Q),fe);let _e=this._createDisposable(re);if(fe!==void 0){const ue=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));_e=T.Disposable.from(_e,ue)}return _e}$provideFoldingRanges(W,Q,te,re){return this._withAdapter(W,pe,fe=>fe.provideFoldingRanges(v.URI.revive(Q),te,re),void 0)}registerSelectionRangeProvider(W,Q,te){const re=this._addNewAdapter(new Fe(this._documents,te,this._logService),W);return this._proxy.$registerSelectionRangeProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideSelectionRanges(W,Q,te,re){return this._withAdapter(W,Fe,fe=>fe.provideSelectionRanges(v.URI.revive(Q),te,re),[])}registerCallHierarchyProvider(W,Q,te){const re=this._addNewAdapter(new We(this._documents,te),W);return this._proxy.$registerCallHierarchyProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$prepareCallHierarchy(W,Q,te,re){return this._withAdapter(W,We,fe=>Promise.resolve(fe.prepareSession(v.URI.revive(Q),te,re)),void 0)}$provideCallHierarchyIncomingCalls(W,Q,te,re){return this._withAdapter(W,We,fe=>fe.provideCallsTo(Q,te,re),void 0)}$provideCallHierarchyOutgoingCalls(W,Q,te,re){return this._withAdapter(W,We,fe=>fe.provideCallsFrom(Q,te,re),void 0)}$releaseCallHierarchy(W,Q){this._withAdapter(W,We,te=>Promise.resolve(te.releaseSession(Q)),void 0)}static _serializeRegExp(W){return{pattern:W.source,flags:(0,y.regExpFlags)(W)}}static _serializeIndentationRule(W){return{decreaseIndentPattern:ze._serializeRegExp(W.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?ze._serializeRegExp(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?ze._serializeRegExp(W.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(W){return{beforeText:ze._serializeRegExp(W.beforeText),afterText:W.afterText?ze._serializeRegExp(W.afterText):void 0,previousLineText:W.previousLineText?ze._serializeRegExp(W.previousLineText):void 0,action:W.action}}static _serializeOnEnterRules(W){return W.map(ze._serializeOnEnterRule)}setLanguageConfiguration(W,Q,te){let{wordPattern:re}=te;if(re&&(0,y.regExpLeadsToEndlessLoop)(re))throw new Error(`Invalid language configuration: wordPattern '${re}' is not allowed to match the empty string.`);re?this._documents.setWordDefinitionFor(Q,re):this._documents.setWordDefinitionFor(Q,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const fe=this._nextHandle(),_e={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?ze._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?ze._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?ze._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(fe,Q,_e),this._createDisposable(fe)}$setWordDefinitions(W){for(const Q of W)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=ze,ze._handlePool=0}),define(ve[199],be([0,1,5,9,7]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(D,y){this._proxy=D.getProxy(v.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(D,y){await this._proxy.$changeLanguage(D,y);const k=this._documents.getDocumentData(D);if(!k)throw new Error(`document '${D.toString}' NOT found`);return k.document}async tokenAtPosition(D,y){var k;const n=D.version,P=R.Position.from(y),d=await this._proxy.$tokensAtPosition(D.uri,P),g={type:S.StandardTokenType.Other,range:(k=D.getWordRangeAtPosition(y))!==null&&k!==void 0?k:new S.Range(y.line,y.character,y.line,y.character)};if(!d)return g;const r={range:R.Range.to(d.range),type:R.TokenType.to(d.type)};return!r.range.contains(y)||n!==D.version?g:r}}e.ExtHostLanguages=T}),define(ve[200],be([0,1,5,17,32]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(D){return D&&D.title}let E=class{constructor(y,k){this._logService=k,this._proxy=y.getProxy(v.MainContext.MainThreadMessageService)}showMessage(y,k,n,P,d){const g={extension:y};let r;typeof P=="string"||T(P)?r=[P,...d]:(g.modal=P&&P.modal,g.useCustom=P&&P.useCustom,r=d),g.useCustom&&(0,S.checkProposedApiEnabled)(y);const m=[];for(let c=0;c<r.length;c++){const p=r[c];if(typeof p=="string")m.push({title:p,handle:c,isCloseAffordance:!1});else if(typeof p=="object"){let{title:w,isCloseAffordance:a}=p;m.push({title:w,isCloseAffordance:!!a,handle:c})}else this._logService.warn("Invalid message item:",p)}return this._proxy.$showMessage(k,n,g,m).then(c=>{if(typeof c=="number")return r[c]})}};E=je([qe(1,R.ILogService)],E),e.ExtHostMessageService=E}),define(ve[201],be([0,1,23,3,57,55,6,22,8,10,2,68,5,9,7,50,179,98]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r,m,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class w{constructor(f,t){const i=w._Keys.nextId();f.$registerNotebookEditorDecorationType(i,g.NotebookDecorationRenderOptions.from(t)),this.value={key:i,dispose(){f.$removeNotebookEditorDecorationType(i)}}}}e.NotebookEditorDecorationType=w,w._Keys=new T.IdGenerator("NotebookEditorDecorationType");class a{constructor(f,t,i,s,o,u){this._textDocumentsAndEditors=i,this._textDocuments=s,this.logService=o,this._extensionStoragePaths=u,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new D.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new R.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new R.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new R.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new R.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new P.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=f.getProxy(d.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=f.getProxy(d.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=f.getProxy(d.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:_=>{var b;if(_&&_.$mid===12){const A=(b=_.notebookEditor)===null||b===void 0?void 0:b.notebookUri,C=_.cell.handle,l=this._documents.get(A),F=l==null?void 0:l.getCell(C);if(F)return F.apiCell}return _}})}get activeNotebookEditor(){var f;return(f=this._activeNotebookEditor)===null||f===void 0?void 0:f.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(f=>f.apiEditor)}getEditorById(f){return this._editors.get(f)}getIdByEditor(f){for(const[t,i]of this._editors)if(i.apiEditor===f)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(f,t){const i=this._documents.get(f);if(!i&&!t)throw new Error(`NO notebook document for '${f}'`);return i}_getProviderData(f){const t=this._notebookContentProviders.get(f);if(!t)throw new Error(`NO provider for '${f}'`);return t}registerNotebookContentProvider(f,t,i,s,o){if((0,y.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:f,provider:i});let u;return i.onDidChangeNotebookContentOptions&&(u=i.onDidChangeNotebookContentOptions(()=>{const _=g.NotebookDocumentContentOptions.from(i.options);this._notebookProxy.$updateNotebookProviderOptions(t,_)})),this._notebookProxy.$registerNotebookProvider({id:f.identifier,location:f.extensionLocation},t,g.NotebookDocumentContentOptions.from(s),a._convertNotebookRegistrationData(f,o)),new r.Disposable(()=>{u==null||u.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(f,t){if(!t)return;const i=t.filenamePattern.map(s=>g.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(t.filenamePattern&&!i){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:t.displayName,filenamePattern:i,exclusive:t.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,t,i){const s=a._notebookStatusBarItemProviderHandlePool++,o=typeof i.onDidChangeCellStatusBarItems=="function"?a._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,i),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,o,t);let u;return o!==void 0&&(u=i.onDidChangeCellStatusBarItems(_=>this._notebookProxy.$emitCellStatusBarEvent(o))),new r.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,o),u&&u.dispose()})}createNotebookEditorDecorationType(f){return new w(this._notebookEditorsProxy,f).value}async createNotebookDocument(f){const t=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:f.viewType,content:f.content&&g.NotebookData.from(f.content)});return n.URI.revive(t)}async openNotebookDocument(f){const t=this._documents.get(f);if(t)return t.apiNotebook;const i=await this._notebookDocumentsProxy.$tryOpenNotebook(f),s=this._documents.get(n.URI.revive(i));return(0,k.assertIsDefined)(s==null?void 0:s.apiNotebook)}async showNotebookDocument(f,t){var i;n.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let s;typeof t=="object"?s={position:g.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(g.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:s={preserveFocus:!1};const o=await this._notebookEditorsProxy.$tryShowNotebookDocument(f.uri,f.viewType,s),u=o&&((i=this._editors.get(o))===null||i===void 0?void 0:i.apiEditor);if(u)return u;throw o?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,t,i,s){var o;const u=this._notebookStatusBarItemProviders.get(f),_=n.URI.revive(t),b=this._documents.get(_);if(!b||!u)return;const A=b.getCellFromIndex(i);if(!A)return;const C=await u.provideCellStatusBarItems(A.apiCell,s);if(!C)return;const l=new E.DisposableStore,F=this._statusBarCache.add([l]),N=(o=C&&C.map(z=>g.NotebookStatusBarItem.from(z,this._commandsConverter,l)))!==null&&o!==void 0?o:void 0;return{cacheId:F,items:N}}$releaseNotebookCellStatusBarItems(f){this._statusBarCache.delete(f)}registerNotebookSerializer(f,t,i,s,o){if((0,y.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");const u=this._handlePool++;return this._notebookSerializer.set(u,i),this._notebookProxy.$registerNotebookSerializer(u,{id:f.identifier,location:f.extensionLocation},t,g.NotebookDocumentContentOptions.from(s),a._convertNotebookRegistrationData(f,o)),(0,E.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(u)})}async $dataToNotebook(f,t,i){const s=this._notebookSerializer.get(f);if(!s)throw new Error("NO serializer found");const o=await s.deserializeNotebook(t.buffer,i);return g.NotebookData.from(o)}async $notebookToData(f,t,i){const s=this._notebookSerializer.get(f);if(!s)throw new Error("NO serializer found");const o=await s.serializeNotebook(g.NotebookData.to(t),i);return v.VSBuffer.wrap(o)}async $openNotebook(f,t,i,s,o){const{provider:u}=this._getProviderData(f),_=await u.openNotebook(n.URI.revive(t),{backupId:i,untitledDocumentData:s==null?void 0:s.buffer},o);return{metadata:g.NotebookDocumentMetadata.from(_.metadata),cells:_.cells.map(g.NotebookCellData.from)}}async $saveNotebook(f,t,i){const s=this.getNotebookDocument(n.URI.revive(t)),{provider:o}=this._getProviderData(f);return await o.saveNotebook(s.apiNotebook,i),!0}async $saveNotebookAs(f,t,i,s){const o=this.getNotebookDocument(n.URI.revive(t)),{provider:u}=this._getProviderData(f);return await u.saveNotebookAs(n.URI.revive(i),o.apiNotebook,s),!0}async $backupNotebook(f,t,i){var s;const o=this.getNotebookDocument(n.URI.revive(t)),u=this._getProviderData(f),_=(s=this._extensionStoragePaths.workspaceValue(u.extension))!==null&&s!==void 0?s:this._extensionStoragePaths.globalValue(u.extension),b=String((0,S.hash)([o.uri.toString(),this._backupIdPool++])),A=n.URI.joinPath(_,b),C=await u.provider.backupNotebook(o.apiNotebook,{destination:A},i);return o.updateBackup(C),C.id}$acceptModelChanged(f,t,i){this.getNotebookDocument(n.URI.revive(f)).acceptModelChanged(t,i)}$acceptDirtyStateChanged(f,t){const i=this.getNotebookDocument(n.URI.revive(f));i.acceptModelChanged({rawEvents:[],versionId:i.apiNotebook.version},t)}$acceptModelSaved(f){const t=this.getNotebookDocument(n.URI.revive(f));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",f,t);const i=this._editors.get(f);if(!i)throw new Error(`unknown text editor: ${f}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&i._acceptVisibleRanges(t.visibleRanges.ranges.map(g.NotebookRange.to)),t.selections&&i._acceptSelections(t.selections.selections.map(g.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:i.apiEditor,visibleRanges:i.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:i.apiEditor,selections:i.apiEditor.selections}))}$acceptEditorViewColumns(f){for(const t in f){const i=this._editors.get(t);if(!i)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);i._acceptViewColumn(g.ViewColumn.to(f[t]))}}$acceptDocumentPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",f.path,t);const i=this.getNotebookDocument(n.URI.revive(f));i.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:i.apiNotebook})}_createExtHostEditor(f,t,i){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const s=new p.ExtHostNotebookEditor(t,this._notebookEditorsProxy,f,i.visibleRanges.map(g.NotebookRange.to),i.selections.map(g.NotebookRange.to),typeof i.viewColumn=="number"?g.ViewColumn.to(i.viewColumn):void 0);this._editors.set(t,s)}$acceptDocumentAndEditorsDelta(f){var t,i,s;if(f.removedDocuments)for(const u of f.removedDocuments){const _=n.URI.revive(u),b=this._documents.get(_);b&&(b.dispose(),this._documents.delete(_),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(A=>A.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const A of this._editors.values())A.notebookData.uri.toString()===_.toString()&&this._editors.delete(A.id)}if(f.addedDocuments){const u=[];for(const _ of f.addedDocuments){const b=n.URI.revive(_.uri),A=_.viewType;if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const C=this,l=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(F){C._onDidChangeNotebookCells.fire(F)},emitCellOutputsChange(F){C._onDidChangeCellOutputs.fire(F)},emitCellMetadataChange(F){C._onDidChangeCellMetadata.fire(F)},emitCellExecutionStateChange(F){C._onDidChangeCellExecutionState.fire(F)}},A,_.metadata?g.NotebookDocumentMetadata.to(_.metadata):new r.NotebookDocumentMetadata,b);l.acceptModelChanged({versionId:_.versionId,rawEvents:[{kind:m.NotebookCellsChangeType.Initialize,changes:[[0,0,_.cells]]}]},!1),u.push(..._.cells.map(F=>c.ExtHostCell.asModelAddData(l.apiNotebook,F))),(t=this._documents.get(b))===null||t===void 0||t.dispose(),this._documents.set(b,l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:u}),this._onDidOpenNotebookDocument.fire(l.apiNotebook)}}if(f.addedEditors)for(const u of f.addedEditors){if(this._editors.has(u.id))return;const _=n.URI.revive(u.documentUri),b=this._documents.get(_);b&&this._createExtHostEditor(b,u.id,u)}const o=[];if(f.removedEditors)for(const u of f.removedEditors){const _=this._editors.get(u);_&&(this._editors.delete(u),((i=this._activeNotebookEditor)===null||i===void 0?void 0:i.id)===_.id&&(this._activeNotebookEditor=void 0),o.push(_))}if(f.visibleEditors){this._visibleNotebookEditors=f.visibleEditors.map(_=>this._editors.get(_)).filter(_=>!!_);const u=new Set;this._visibleNotebookEditors.forEach(_=>u.add(_.id));for(const _ of this._editors.values()){const b=u.has(_.id);_._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(_=>_).filter(_=>_.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}f.newActiveEditor===null?this._activeNotebookEditor=void 0:f.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(f.newActiveEditor)),f.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor)}}e.ExtHostNotebookController=a,a._notebookStatusBarItemProviderHandlePool=0}),define(ve[202],be([0,1,3,6,5,26,2,9,73,22,11,50,20,13,17]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let m=class{constructor(h,f,t,i){this._mainContext=h,this._initData=f,this._extHostNotebook=t,this._logService=i,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=h.getProxy(S.MainContext.MainThreadNotebookKernels)}createNotebookController(h,f,t,i,s,o){for(let I of this._kernelData.values())if(I.controller.id===f&&T.ExtensionIdentifier.equals(h.identifier,I.extensionId))throw new Error(`notebook controller with id '${f}' ALREADY exist`);const u=this._handlePool++,_=this;this._logService.trace(`NotebookController[${u}], CREATED by ${h.identifier.value}, ${f}`);const b=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${h.identifier}'`);let A=!1;const C=new R.DisposableStore,l=new v.Emitter,F=new v.Emitter,N={id:`${h.identifier.value}/${f}`,viewType:t,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:i||h.identifier.value,preloads:o?o.map(D.NotebookKernelPreload.from):[]};let z=s!=null?s:b,de;this._proxy.$addKernel(u,N).catch(I=>{console.log(I),A=!0});let he=0;const $=()=>{if(A)return;const I=++he;Promise.resolve().then(()=>{I===he&&this._proxy.$updateKernel(u,N)})},q=new k.ResourceMap,x={get id(){return f},get viewType(){return N.viewType},onDidChangeNotebookAssociation:l.event,get label(){return N.label},set label(I){var H;N.label=(H=I!=null?I:h.displayName)!==null&&H!==void 0?H:h.name,$()},get detail(){var I;return(I=N.detail)!==null&&I!==void 0?I:""},set detail(I){N.detail=I,$()},get description(){var I;return(I=N.description)!==null&&I!==void 0?I:""},set description(I){N.description=I,$()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(I){N.supportedLanguages=I,$()},get hasExecutionOrder(){var I;return(I=N.hasExecutionOrder)!==null&&I!==void 0?I:!1},set hasExecutionOrder(I){N.hasExecutionOrder=I,$()},get preloads(){return N.preloads?N.preloads.map(D.NotebookKernelPreload.to):[]},get executeHandler(){return z},set executeHandler(I){z=I!=null?I:b},get interruptHandler(){return de},set interruptHandler(I){de=I,N.supportsInterrupt=Boolean(I),$()},createNotebookCellExecutionTask(I){if(A)throw new Error("notebook controller is DISPOSED");if(!q.has(I.notebook.uri))throw _._logService.trace(`NotebookController[${u}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(q.keys()).map(H=>H.toString())),new Error(`notebook controller is NOT associated to notebook: ${I.notebook.uri.toString()}`);return _._createNotebookCellExecution(I)},dispose:()=>{A||(this._logService.trace(`NotebookController[${u}], DISPOSED`),A=!0,this._kernelData.delete(u),C.dispose(),l.dispose(),F.dispose(),this._proxy.$removeKernel(u))},onDidReceiveMessage:F.event,postMessage(I,H){return _._proxy.$postMessage(u,H&&_._extHostNotebook.getIdByEditor(H),I)},asWebviewUri(I){return(0,y.asWebviewUri)(I,_._initData.remote)},updateNotebookAffinity(I,H){_._proxy.$updateNotebookPriority(u,I.uri,H)}};return this._kernelData.set(u,{extensionId:h.identifier,controller:x,onDidReceiveMessage:F,onDidChangeSelection:l,associatedNotebooks:q}),x}$acceptNotebookAssociation(h,f,t){const i=this._kernelData.get(h);if(i){const s=this._extHostNotebook.getNotebookDocument(E.URI.revive(f));t?i.associatedNotebooks.set(s.uri,!0):i.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${h}] ASSOCIATE notebook`,s.uri.toString(),t),i.onDidChangeSelection.fire({selected:t,notebook:s.apiNotebook})}}async $executeCells(h,f,t){const i=this._kernelData.get(h);if(!i)return;const s=this._extHostNotebook.getNotebookDocument(E.URI.revive(f)),o=[];for(let u of t){const _=s.getCell(u);_&&o.push(_.apiCell)}try{this._logService.trace(`NotebookController[${h}] EXECUTE cells`,s.uri.toString(),o.length),await i.controller.executeHandler.call(i.controller,o,s.apiNotebook,i.controller)}catch(u){this._logService.error(`NotebookController[${h}] execute cells FAILED`,u),console.error(u)}}async $cancelCells(h,f,t){var i;const s=this._kernelData.get(h);if(!s)return;const o=this._extHostNotebook.getNotebookDocument(E.URI.revive(f));s.controller.interruptHandler&&await s.controller.interruptHandler.call(s.controller,o.apiNotebook);for(let u of t){const _=o.getCell(u);_&&((i=this._activeExecutions.get(_.uri))===null||i===void 0||i.cancel())}}$acceptKernelMessageFromRenderer(h,f,t){const i=this._kernelData.get(h);if(!i)return;const s=this._extHostNotebook.getEditorById(f);if(!s)throw new Error(`send message for UNKNOWN editor: ${f}`);i.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:t}))}_createNotebookCellExecution(h){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this._extHostNotebook.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!t)throw new Error("invalid cell");if(this._activeExecutions.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const i=new p(t.notebook,t,this._mainContext.getProxy(S.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(t.uri,i);const s=i.onDidChangeState(()=>{i.state===c.Resolved&&(i.dispose(),s.dispose(),this._activeExecutions.delete(t.uri))});return i.asApiObject()}};m=je([qe(3,r.ILogService)],m),e.ExtHostNotebookKernels=m;var c;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(c||(c={}));class p extends R.Disposable{constructor(h,f,t){super();this._document=h,this._cell=f,this._proxy=t,this._onDidChangeState=new v.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new d.CancellationTokenSource),this._collector=new w(10,i=>this.applyEdits(i)),this._executionOrder=f.internalMetadata.executionOrder,this.mixinMetadata({runState:P.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(h){await this._collector.addItem(h)}async applyEdits(h){return this._proxy.$applyEdits(this._document.uri,h,!1)}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(h){const f={editType:9,handle:this._cell.handle,internalMetadata:h};this.applyEdits([f])}cellIndexToHandle(h){if(typeof h!="number")return this._cell.handle;const f=this._document.getCellFromIndex(h);if(!f)throw new Error("INVALID cell index");return f.handle}asApiObject(){const h=this;return Object.freeze({get document(){return h._document.apiNotebook},get cell(){return h._cell.apiCell},get executionOrder(){return h._executionOrder},set executionOrder(f){h._executionOrder=f,h.mixinMetadata({executionOrder:f})},start(f){var t;if(h._state===c.Resolved||h._state===c.Started)throw new Error("Cannot call start again");h._state=c.Started,h._onDidChangeState.fire(),h.mixinMetadata({runState:P.NotebookCellExecutionState.Executing,runStartTime:(t=f==null?void 0:f.startTime)!==null&&t!==void 0?t:null})},end(f){var t,i;if(h._state===c.Resolved)throw new Error("Cannot call resolve twice");h._state=c.Resolved,h._onDidChangeState.fire(),h.mixinMetadata({runState:null,lastRunSuccess:(t=f==null?void 0:f.success)!==null&&t!==void 0?t:null,runEndTime:(i=f==null?void 0:f.endTime)!==null&&i!==void 0?i:null})},clearOutput(f){return h.verifyStateForOutput(),this.replaceOutput([],f)},async appendOutput(f,t){h.verifyStateForOutput();const i=h.cellIndexToHandle(t);return f=(0,g.asArray)(f),h.applyEditSoon({editType:2,handle:i,append:!0,outputs:f.map(D.NotebookCellOutput.from)})},async replaceOutput(f,t){h.verifyStateForOutput();const i=h.cellIndexToHandle(t);return f=(0,g.asArray)(f),h.applyEditSoon({editType:2,handle:i,outputs:f.map(D.NotebookCellOutput.from)})},async appendOutputItems(f,t){return h.verifyStateForOutput(),f=(0,g.asArray)(f),h.applyEditSoon({editType:7,append:!0,items:f.map(D.NotebookCellOutputItem.from),outputId:t})},async replaceOutputItems(f,t){return h.verifyStateForOutput(),f=(0,g.asArray)(f),h.applyEditSoon({editType:7,items:f.map(D.NotebookCellOutputItem.from),outputId:t})},token:h._tokenSource.token})}}class w{constructor(h,f){this.delay=h,this.callback=f,this.batch=[]}addItem(h){return this.batch.push(h),this.waitPromise||(this.waitPromise=(0,n.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const f=this.batch;return this.batch=[],this.callback(f)})),this.waitPromise}}}),define(ve[203],be([0,1,3,5,98]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(D,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,y,k){var n;const P=this._extHostNotebook.getEditorById(D);!P||(n=this._rendererMessageEmitters.get(y))===null||n===void 0||n.fire({editor:P.apiEditor,message:k})}createRendererMessaging(D){return{onDidReceiveMessage:(...k)=>this.getOrCreateEmitterFor(D).event(...k),postMessage:(k,n)=>{const P=S.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);if(!P)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(P.id,D,n)}}}getOrCreateEmitterFor(D){let y=this._rendererMessageEmitters.get(D);return y||(y=new v.Emitter({onLastListenerRemove:()=>{y==null||y.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,y),y)}}e.ExtHostNotebookRenderers=T}),define(ve[102],be([0,1,5,3,6,23,4,15]),function(J,e,v,R,S,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends S.Disposable{constructor(r,m,c,p){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=p,this._id=p.$register(this.name,m,c),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?T.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(m=>this._proxy.$clear(m,r))}show(r,m){this.validate(),this._id.then(c=>this._proxy.$reveal(c,!!(typeof r=="boolean"?r:m)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class k extends y{constructor(r,m){super(r,!1,void 0,m)}append(r){super.append(r),this._id.then(m=>this._proxy.$append(m,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class n extends y{constructor(r,m,c){super(r,!0,m,c)}append(r){throw new Error("Not supported")}}class P{constructor(r,m){this.name=r,this._channel=m}append(r){this._channel.then(m=>m.append(r))}appendLine(r){this._channel.then(m=>m.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,m){this._channel.then(c=>c.show(r,m))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=P;let d=class{constructor(r){this._proxy=r.getProxy(v.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new k(r,this._proxy)}createOutputChannelFromLogFile(r,m){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!m)throw new Error("illegal argument `file`. must not be falsy");return new n(r,m,this._proxy)}};d=je([qe(0,D.IExtHostRpcService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,E.createDecorator)("IExtHostOutputService")}),define(ve[204],be([0,1,11,20,3,6,5,2,7,12,13,47]),function(J,e,v,R,S,T,E,D,y,k,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(g,r,m){const c=g.getProxy(E.MainContext.MainThreadQuickOpen);class p{constructor(o,u){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=u}showQuickPick(o,u,_,b=R.CancellationToken.None){this._onDidSelectItem=void 0;const A=Promise.resolve(o),C=++this._instances,l=c.$show(C,{title:_==null?void 0:_.title,placeHolder:_==null?void 0:_.placeHolder,matchOnDescription:_==null?void 0:_.matchOnDescription,matchOnDetail:_==null?void 0:_.matchOnDetail,ignoreFocusLost:_==null?void 0:_.ignoreFocusOut,canPickMany:_==null?void 0:_.canPickMany},b),F={},N=l.then(()=>F);return Promise.race([N,A]).then(z=>{if(z!==F)return A.then(de=>{const he=[];for(let $=0;$<de.length;$++){const q=de[$];let x,I,H,M,B;typeof q=="string"?x=q:(x=q.label,I=q.description,H=q.detail,M=q.picked,B=q.alwaysShow),he.push({label:x,description:I,handle:$,detail:H,picked:M,alwaysShow:B})}return _&&typeof _.onDidSelectItem=="function"&&(this._onDidSelectItem=$=>{_.onDidSelectItem(de[$])}),c.$setItems(C,he),l.then($=>{if(typeof $=="number")return de[$];if(Array.isArray($))return $.map(q=>de[q])})})}).then(void 0,z=>{if(!(0,k.isPromiseCanceledError)(z))return c.$setError(C,z),Promise.reject(z)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,u=R.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,c.$input(o,typeof this._validateInput=="function",u).then(void 0,_=>{if(!(0,k.isPromiseCanceledError)(_))return Promise.reject(_)})}$validateInput(o){return this._validateInput?(0,v.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,u=R.CancellationToken.None){const _=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!_)return;const b=await this._workspace.getWorkspaceFolders2();if(!!b)return b.find(A=>A.uri.toString()===_.uri.toString())}createQuickPick(o,u){const _=new t(o,u,()=>this._sessions.delete(_._id));return this._sessions.set(_._id,_),_}createInputBox(o){const u=new i(o,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(o,u){const _=this._sessions.get(o);_&&_._fireDidChangeValue(u)}$onDidAccept(o){const u=this._sessions.get(o);u&&u._fireDidAccept()}$onDidChangeActive(o,u){const _=this._sessions.get(o);_ instanceof t&&_._fireDidChangeActive(u)}$onDidChangeSelection(o,u){const _=this._sessions.get(o);_ instanceof t&&_._fireDidChangeSelection(u)}$onDidTriggerButton(o,u){const _=this._sessions.get(o);_&&_._fireDidTriggerButton(u)}$onDidHide(o){const u=this._sessions.get(o);u&&u._fireDidHide()}}class w{constructor(o,u){this._extensionId=o,this._onDidDispose=u,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new S.Emitter,this._onDidChangeValueEmitter=new S.Emitter,this._onDidTriggerButtonEmitter=new S.Emitter,this._onDidHideEmitter=new S.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((u,_)=>{const b=u===y.QuickInputButtons.Back?-1:_;this._handlesToButtons.set(b,u)}),this.update({buttons:o.map((u,_)=>({iconPath:a(u.iconPath),tooltip:u.tooltip,handle:u===y.QuickInputButtons.Back?-1:_}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const u=this._handlesToButtons.get(o);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),c.$dispose(this._id))}update(o){if(!this._disposed){for(const u of Object.keys(o)){const _=o[u];this._pendingUpdate[u]=_===void 0?null:_}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){c.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}w._nextId=1;function a(s){if(s instanceof y.ThemeIcon)return{id:s.id};const o=f(s),u=h(s);return{dark:typeof o=="string"?D.URI.file(o):o,light:typeof u=="string"?D.URI.file(u):u}}function h(s){return typeof s=="object"&&"light"in s?s.light:s}function f(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends w{constructor(o,u,_){super(o,_);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new S.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new S.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((u,_)=>{this._handlesToItems.set(_,u),this._itemsToHandles.set(u,_)}),this.update({items:o.map((u,_)=>({label:u.label,description:u.description,handle:_,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(o){const u=(0,n.coalesce)(o.map(_=>this._handlesToItems.get(_)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(o){const u=(0,n.coalesce)(o.map(_=>this._handlesToItems.get(_)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}}class i extends w{constructor(o,u){super(o,u);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?P.default.Error:P.default.Ignore})}}return new p(r,m)}e.createExtHostQuickOpen=d}),define(ve[205],be([0,1,2,3,53,6,11,5,13,114,17,26,32]),function(J,e,v,R,S,T,E,D,y,k,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(o){if(o)return typeof o.iconPath=="string"?v.URI.file(o.iconPath):o.iconPath}function r(o,u){if(!o.iconPath&&!u.iconPath)return 0;if(o.iconPath){if(!u.iconPath)return 1}else return-1;const _=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath,b=typeof u.iconPath=="string"?u.iconPath:u.iconPath.fsPath;return(0,k.comparePaths)(_,b)}function m(o,u){let _=0;if(o.strikeThrough!==u.strikeThrough)return o.strikeThrough?1:-1;if(o.faded!==u.faded)return o.faded?1:-1;if(o.tooltip!==u.tooltip)return(o.tooltip||"").localeCompare(u.tooltip||"");if(_=r(o,u),_!==0)return _;if(o.light&&u.light)_=r(o.light,u.light);else{if(o.light)return 1;if(u.light)return-1}if(_!==0)return _;if(o.dark&&u.dark)_=r(o.dark,u.dark);else{if(o.dark)return 1;if(u.dark)return-1}return _}function c(o,u){if(o.command!==u.command)return o.command<u.command?-1:1;if(o.title!==u.title)return o.title<u.title?-1:1;if(o.tooltip!==u.tooltip){if(o.tooltip!==void 0&&u.tooltip!==void 0)return o.tooltip<u.tooltip?-1:1;if(o.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(o.arguments===u.arguments)return 0;if(o.arguments)if(u.arguments){if(o.arguments.length!==u.arguments.length)return o.arguments.length-u.arguments.length}else return 1;else return-1;for(let _=0;_<o.arguments.length;_++){const b=o.arguments[_],A=u.arguments[_];if(b!==A)return b<A?-1:1}return 0}function p(o,u){let _=(0,k.comparePaths)(o.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(_!==0)return _;if(o.command&&u.command)_=c(o.command,u.command);else{if(o.command)return 1;if(u.command)return-1}if(_!==0)return _;if(o.decorations&&u.decorations)_=m(o.decorations,u.decorations);else{if(o.decorations)return 1;if(u.decorations)return-1}return _}function w(o,u){for(let _=0;_<o.length;_++)if(o[_]!==u[_])return!1;return!0}function a(o,u){return o.command===u.command&&o.title===u.title&&o.tooltip===u.tooltip&&(o.arguments&&u.arguments?w(o.arguments,u.arguments):o.arguments===u.arguments)}function h(o,u){return(0,y.equals)(o,u,a)}class f{constructor(u,_,b){this._extension=u,this._proxy=_,this._sourceControlHandle=b,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(u){this._proxy.$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return(0,d.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(u){if((0,d.checkProposedApiEnabled)(this._extension),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,u))}focus(){(0,d.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(u,_){(0,d.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,u,_)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=f;class t{constructor(u,_,b,A,C){this._proxy=u,this._commands=_,this._sourceControlHandle=b,this._id=A,this._label=C,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,_){const b=this._resourceStatesCommandsMap.get(u);return b?(0,E.asPromise)(()=>this._commands.executeCommand(b.command,...b.arguments||[],_)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var u;const _=[...this._resourceStates].sort(p),A=(0,y.sortedDiff)(this._resourceSnapshot,_,p).map(F=>{const N=F.toInsert.map(z=>{const de=this._resourceHandlePool++;this._resourceStatesMap.set(de,z);const he=z.resourceUri,$=g(z.decorations),q=z.decorations&&g(z.decorations.light)||$,x=z.decorations&&g(z.decorations.dark)||$,I=[];let H;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const pe=new T.DisposableStore;H=this._commands.converter.toInternal(z.command,pe),this._resourceStatesDisposablesMap.set(de,pe)}else this._resourceStatesCommandsMap.set(de,z.command);q&&I.push(q),x&&x.toString()!==(q==null?void 0:q.toString())&&I.push(x);const M=z.decorations&&z.decorations.tooltip||"",B=z.decorations&&!!z.decorations.strikeThrough,G=z.decorations&&!!z.decorations.faded,K=z.contextValue||"";return{rawResource:[de,he,I,M,B,G,K,H],handle:de}});return{start:F.start,deleteCount:F.deleteCount,toInsert:N}}),C=A.map(({start:F,deleteCount:N,toInsert:z})=>[F,N,z.map(de=>de.rawResource)]),l=A.reverse();for(const{start:F,deleteCount:N,toInsert:z}of l){const de=z.map($=>$.handle),he=this._handlesSnapshot.splice(F,N,...de);for(const $ of he)this._resourceStatesMap.delete($),this._resourceStatesCommandsMap.delete($),(u=this._resourceStatesDisposablesMap.get($))===null||u===void 0||u.dispose(),this._resourceStatesDisposablesMap.delete($)}return this._resourceSnapshot=_,C}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(u,_,b,A,C,l){this._proxy=_,this._commands=b,this._id=A,this._label=C,this._rootUri=l,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new f(u,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,A,C,l)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,this._proxy.$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,this._proxy.$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=u;const _=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:_})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(this._statusBarCommands&&u&&h(this._statusBarCommands,u))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=u;const _=(u||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:_})}get selected(){return this._selected}createResourceGroup(u,_){const b=new t(this._proxy,this._commands,this.handle,u,_),A=R.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,A),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const u=[],_=[];for(const[b,A]of this.createdResourceGroups){A.dispose();const C=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});R.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),C.dispose(),this._groups.delete(b.handle),this._proxy.$unregisterGroup(this.handle,b.handle)}),u.push([b.handle,b.id,b.label,b.features]);const l=b._takeResourceStateSnapshot();l.length>0&&_.push([b.handle,l]),this._groups.set(b.handle,b)}this._proxy.$registerGroups(this.handle,u,_),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(_=>{const b=_._takeResourceStateSnapshot();b.length!==0&&u.push([_.handle,b])}),u.length>0&&this._proxy.$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,je([(0,S.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),je([(0,S.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let s=class Mn{constructor(u,_,b){this._commands=_,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=u.getProxy(D.MainContext.MainThreadSCM),this._telemetry=u.getProxy(D.MainContext.MainThreadTelemetry),_.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const C=this._sourceControls.get(A.sourceControlHandle);if(!C)return A;const l=C.getResourceGroup(A.groupHandle);return l?l.getResourceState(A.handle):A}else if(A&&A.$mid===4){const C=this._sourceControls.get(A.sourceControlHandle);return C?C.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const C=this._sourceControls.get(A.handle);return C||A}return A}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,_,b,A){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,_,b,A),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const C=Mn._handlePool++,l=new i(u,this._proxy,this._commands,_,b,A);this._sourceControls.set(C,l);const F=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(u.identifier))||[];return F.push(l),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(u.identifier),F),l}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const _=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(u.identifier)),b=_&&_[_.length-1];return b&&b.inputBox}$provideOriginalResource(u,_,b){const A=v.URI.revive(_);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,A.toString());const C=this._sourceControls.get(u);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,E.asPromise)(()=>C.quickDiffProvider.provideOriginalResource(A,b)).then(l=>l||null)}$onInputBoxValueChange(u,_){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const b=this._sourceControls.get(u);return b&&b.inputBox.$onInputBoxValueChange(_),Promise.resolve(void 0)}$executeResourceCommand(u,_,b,A){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,_,b);const C=this._sourceControls.get(u);if(!C)return Promise.resolve(void 0);const l=C.getResourceGroup(_);return l?l.$executeResourceCommand(b,A):Promise.resolve(void 0)}$validateInput(u,_,b){this.logService.trace("ExtHostSCM#$validateInput",u);const A=this._sourceControls.get(u);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):(0,E.asPromise)(()=>A.inputBox.validateInput(_,b)).then(C=>C?Promise.resolve([C.message,C.type]):Promise.resolve(void 0))}$setSelectedSourceControl(u){var _,b;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&((_=this._sourceControls.get(u))===null||_===void 0||_.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((b=this._sourceControls.get(this._selectedSourceControlHandle))===null||b===void 0||b.setSelectionState(!1)),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};s._handlePool=0,s=je([qe(2,n.ILogService)],s),e.ExtHostSCM=s});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!S:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(J,v):S?S.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(ve[206],be([0,1,7,5,135,6]),function(J,e,v,R,S,T){"use strict";var E,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(d,g,r,m,c=v.StatusBarAlignment.Left,p){E.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,nt(this,E,d,"f"),nt(this,D,g,"f"),this._entryId=y.ID_GEN++,this._extension=r,this._id=m,this._alignment=c,this._priority=p}get id(){var d;return(d=this._id)!==null&&d!==void 0?d:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var d;return(d=this._command)===null||d===void 0?void 0:d.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!y.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){var g;((g=this._command)===null||g===void 0?void 0:g.fromApi)!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Be(this,D,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Be(this,D,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var d;this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let r;this._name?r=this._name:r=(0,S.localize)(0,null,this._extension.displayName||this._extension.name);let m=this._color;this._backgroundColor&&(m=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Be(this,E,"f").$setEntry(this._entryId,g,r,this._text,this._tooltip,(d=this._command)===null||d===void 0?void 0:d.internal,m,this._backgroundColor,this._alignment===v.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,E=new WeakMap,D=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new v.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,S.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const g={message:d};return this._messages.unshift(g),this._update(),new v.Disposable(()=>{const r=this._messages.indexOf(g);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(d,g){this._proxy=d.getProxy(R.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new k(this)}createStatusBarEntry(d,g,r,m){return new y(this._proxy,this._commands,d,g,r,m)}setStatusBarMessage(d,g){const r=this._statusMessage.setMessage(d);let m;return typeof g=="number"?m=setTimeout(()=>r.dispose(),g):typeof g!="undefined"&&g.then(()=>r.dispose(),()=>r.dispose()),new v.Disposable(()=>{r.dispose(),clearTimeout(m)})}}e.ExtHostStatusBar=n}),define(ve[78],be([0,1,5,3,4]),function(J,e,v,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(D){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(v.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,y){this._proxy.$registerExtensionStorageKeysToSync(D,y)}getValue(D,y,k){return this._proxy.$getValue(D,y).then(n=>n||k)}setValue(D,y,k){return this._proxy.$setValue(D,y,k)}$acceptValue(D,y,k){this._onDidChangeStorage.fire({shared:D,key:y,value:k})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(ve[79],be([0,1,4,27,17,77,2]),function(J,e,v,R,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,v.createDecorator)("IExtensionStoragePaths");let D=class{constructor(k,n,P){var d;this._logService=n,this._extHostFileSystem=P,this._workspace=(d=k.workspace)!==null&&d!==void 0?d:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const n=this._workspace.id,P=E.URI.joinPath(this._environment.workspaceStorageHome,n);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch(d){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(E.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=E.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),P}catch(d){this._logService.error("[ExtHostStorage]",d);return}}workspaceValue(k){if(this._value)return E.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return E.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};D=je([qe(0,R.IExtHostInitDataService),qe(1,S.ILogService),qe(2,T.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(ve[40],be([0,1,3,5,4,2,15,6,7,136,12,173,20,37,157]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class m{constructor(t,i,s,o){this._proxy=t,this._id=i,this._creationOptions=s,this._name=o,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(_=>this._pidPromiseComplete=_);const u=this;this.value={get name(){return u._name||""},get processId(){return u._pidPromise},get creationOptions(){return u._creationOptions},get exitStatus(){return u._exitStatus},sendText(_,b=!0){u._checkDisposed(),u._proxy.$sendText(u._id,_,b)},show(_){u._checkDisposed(),u._proxy.$show(u._id,_)},hide(){u._checkDisposed(),u._proxy.$hide(u._id)},dispose(){u._disposed||(u._disposed=!0,u._proxy.$dispose(u._id))},get dimensions(){if(!(u._cols===void 0||u._rows===void 0))return{columns:u._cols,rows:u._rows}}}}async create(t,i,s,o,u,_,b,A,C,l,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:i,cwd:s,env:o,icon:u,initialText:_,waitOnExit:b,strictEnv:A,hideFromUser:C,isFeatureTerminal:l,isExtensionOwnedTerminal:F})}async createExtensionTerminal(t){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:t}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,i){return t===this._cols&&i===this._rows||t===0||i===0?!1:(this._cols=t,this._rows=i,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=m;class c{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new v.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new v.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new v.Emitter,this._onProcessTitleChanged=new v.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new v.Emitter,this._onProcessShellTypeChanged=new v.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,i){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:i})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(i=>this._onProcessTitleChanged.fire(i)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=c;let p=1,w=class extends D.Disposable{constructor(t,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new v.Emitter,this._onDidOpenTerminal=new v.Emitter,this._onDidChangeActiveTerminal=new v.Emitter,this._onDidChangeTerminalDimensions=new v.Emitter,this._proxy=i.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new v.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[s,o]of this._terminalProcesses)o.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(t){const i=t?this._defaultAutomationProfile:this._defaultProfile;return(i==null?void 0:i.path)||""}getDefaultShellArgs(t){const i=t?this._defaultAutomationProfile:this._defaultProfile;return(i==null?void 0:i.args)||[""]}createExtensionTerminal(t){const i=new m(this._proxy,(0,g.generateUuid)(),t,t.name),s=new c(t.pty);return i.createExtensionTerminal(t.iconPath).then(o=>{const u=this._setupExtHostProcessListeners(o,s);this._terminalProcessDisposables[o]=u}),this._terminals.push(i),i.value}attachPtyToTerminal(t,i){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const o=new c(i),u=this._setupExtHostProcessListeners(t,o);this._terminalProcessDisposables[t]=u}async $acceptActiveTerminalChanged(t){const i=this._activeTerminal;if(t===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(t);s&&(this._activeTerminal=s,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,i){const s=this._getTerminalById(t);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:i})}async $acceptTerminalDimensions(t,i,s){const o=this._getTerminalById(t);o&&o.setDimensions(i,s)&&this._onDidChangeTerminalDimensions.fire({terminal:o.value,dimensions:o.value.dimensions})}async $acceptTerminalMaximumDimensions(t,i,s){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(i,s)}async $acceptTerminalTitleChange(t,i){const s=this._getTerminalById(t);s&&(s.name=i)}async $acceptTerminalClosed(t,i){const s=this._getTerminalObjectIndexById(this._terminals,t);if(s!==null){const o=this._terminals.splice(s,1)[0];o.setExitCode(i),this._onDidCloseTerminal.fire(o.value)}}$acceptTerminalOpened(t,i,s,o){if(i){const b=this._getTerminalObjectIndexById(this._terminals,i);if(b!==null){this._terminals[b]._id=t,this._onDidOpenTerminal.fire(this.terminals[b]),this._terminals[b].isOpen=!0;return}}const u={name:o.name,shellPath:o.executable,shellArgs:o.args,cwd:typeof o.cwd=="string"?o.cwd:T.URI.revive(o.cwd),env:o.env,hideFromUser:o.hideFromUser},_=new m(this._proxy,t,u,s);this._terminals.push(_),this._onDidOpenTerminal.fire(_.value),_.isOpen=!0}async $acceptTerminalProcessId(t,i){const s=this._getTerminalById(t);s&&s._setProcessId(i)}async $startExtensionTerminal(t,i){const s=this._getTerminalById(t);if(!s)return{message:(0,k.localize)(0,null,t)};s.isOpen||await new Promise(u=>{const _=this.onDidOpenTerminal(async b=>{b===s.value&&(_.dispose(),u())})});const o=this._terminalProcesses.get(t);o?o.startSendingEvents(i):this._extensionTerminalAwaitingStart[t]={initialDimensions:i}}_setupExtHostProcessListeners(t,i){const s=new D.DisposableStore;s.add(i.onProcessReady(u=>this._proxy.$sendProcessReady(t,u.pid,u.cwd))),s.add(i.onProcessTitleChanged(u=>this._proxy.$sendProcessTitle(t,u))),this._bufferer.startBuffering(t,i.onProcessData),s.add(i.onProcessExit(u=>this._onProcessExit(t,u))),i.onProcessOverrideDimensions&&s.add(i.onProcessOverrideDimensions(u=>this._proxy.$sendOverrideDimensions(t,u))),this._terminalProcesses.set(t,i);const o=this._extensionTerminalAwaitingStart[t];return o&&i instanceof c&&(i.startSendingEvents(o.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),s}$acceptProcessAckDataEvent(t,i){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.acknowledgeDataEvent(i)}$acceptProcessInput(t,i){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.input(i)}$acceptProcessResize(t,i,s){var o;try{(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(i,s)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(t,i){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.shutdown(i)}$acceptProcessRequestInitialCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(t,s))}$acceptProcessRequestCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getCwd().then(s=>this._proxy.$sendProcessCwd(t,s))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,i){const s=this._getTerminalById(t);if(!s)return[];this._terminalLinkCache.delete(t);const o=this._terminalLinkCancellationSource.get(t);o&&o.dispose(!0);const u=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,u);const _=[],b={terminal:s.value,line:i},A=[];for(const F of this._linkProviders)A.push(new Promise(async N=>{u.token.onCancellationRequested(()=>N({provider:F,links:[]}));const z=await F.provideTerminalLinks(b,u.token)||[];u.token.isCancellationRequested||N({provider:F,links:z})}));const C=await Promise.all(A);if(u.token.isCancellationRequested)return[];const l=new Map;for(const F of C)F&&F.links.length>0&&_.push(...F.links.map(N=>{const z={id:p++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return l.set(z.id,{provider:F.provider,link:N}),z}));return this._terminalLinkCache.set(t,l),_}$activateLink(t,i){var s;const o=(s=this._terminalLinkCache.get(t))===null||s===void 0?void 0:s.get(i);!o||o.provider.handleTerminalLink(o.link)}_onProcessExit(t,i){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const s=this._terminalProcessDisposables[t];s&&(s.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,i)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,i){const s=this._getTerminalObjectIndexById(t,i);return s!==null?t[s]:null}_getTerminalObjectIndexById(t,i){let s=null;return t.some((o,u)=>o._id===i?(s=u,!0):!1),s}getEnvironmentVariableCollection(t){let i=this._environmentVariableCollections.get(t.identifier.value);return i||(i=new a,this._setEnvironmentVariableCollection(t.identifier.value,i)),i}_syncEnvironmentVariableCollection(t,i){const s=(0,P.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(t,i.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(t){t.forEach(i=>{const s=i[0],o=new a(i[1]);this._setEnvironmentVariableCollection(s,o)})}$acceptDefaultProfile(t,i){this._defaultProfile=t,this._defaultAutomationProfile=i}_setEnvironmentVariableCollection(t,i){this._environmentVariableCollections.set(t,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,i)})}};w=je([qe(1,E.IExtHostRpcService)],w),e.BaseExtHostTerminalService=w;class a{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new v.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Replace})}append(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,i){const s=this.map.get(t);(!s||s.value!==i.value||s.type!==i.type)&&(this.map.set(t,i),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,i){this.map.forEach((s,o)=>t.call(i,o,s,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let h=class extends w{constructor(t){super(!1,t)}createTerminal(t,i,s){throw new n.NotSupportedError}createTerminalFromOptions(t){throw new n.NotSupportedError}};h=je([qe(0,E.IExtHostRpcService)],h),e.WorkerExtHostTerminalService=h}),define(ve[207],be([0,1,3,13,5,99,9,7]),function(J,e,v,R,S,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(n,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new v.Emitter,this._onDidChangeTextEditorOptions=new v.Emitter,this._onDidChangeTextEditorVisibleRanges=new v.Emitter,this._onDidChangeTextEditorViewColumn=new v.Emitter,this._onDidChangeActiveTextEditor=new v.Emitter,this._onDidChangeVisibleTextEditors=new v.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const P=this._extHostDocumentsAndEditors.allEditors();return n?P:P.map(d=>d.value)}async showTextDocument(n,P,d){let g;typeof P=="number"?g={position:E.ViewColumn.from(P),preserveFocus:d}:typeof P=="object"?g={position:E.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?E.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:g={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(n.uri,g),m=r&&this._extHostDocumentsAndEditors.getEditor(r);if(m)return m.value;throw r?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n){return new T.TextEditorDecorationType(this._proxy,n).value}$acceptEditorPropertiesChanged(n,P){const d=this._extHostDocumentsAndEditors.getEditor(n);if(!d)throw new Error("unknown text editor");if(P.options&&d._acceptOptions(P.options),P.selections){const g=P.selections.selections.map(E.Selection.to);d._acceptSelections(g)}if(P.visibleRanges){const g=R.coalesce(P.visibleRanges.map(E.Range.to));d._acceptVisibleRanges(g)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:Object.assign(Object.assign({},P.options),{lineNumbers:E.TextEditorLineNumbersStyle.to(P.options.lineNumbers)})}),P.selections){const g=D.TextEditorSelectionChangeKind.fromValue(P.selections.source),r=P.selections.selections.map(E.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:r,kind:g})}if(P.visibleRanges){const g=R.coalesce(P.visibleRanges.map(E.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:g})}}$acceptEditorPositionData(n){for(const P in n){const d=this._extHostDocumentsAndEditors.getEditor(P);if(!d)throw new Error("Unknown text editor");const g=E.ViewColumn.to(n[P]);d.value.viewColumn!==g&&(d._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:g}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=y});var Kt=this&&this.__rest||function(J,e){var v={};for(var R in J)Object.prototype.hasOwnProperty.call(J,R)&&e.indexOf(R)<0&&(v[R]=J[R]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var S=0,R=Object.getOwnPropertySymbols(J);S<R.length;S++)e.indexOf(R[S])<0&&Object.prototype.propertyIsEnumerable.call(J,R[S])&&(v[R[S]]=J[R[S]]);return v};define(ve[208],be([0,1,2,4,5,6,7]),function(J,e,v,R,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class D{constructor(n,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(S.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:d=>{var g,r;if(d&&d.$mid===11){const m=d.uri===void 0?void 0:v.URI.revive(d.uri);return(r=(g=this._itemsBySourceAndUriMap.get(d.source))===null||g===void 0?void 0:g.get(y(m)))===null||r===void 0?void 0:r.get(d.handle)}return d}})}async $getTimeline(n,P,d,g,r){const m=this._providers.get(n);return m==null?void 0:m.provideTimeline(v.URI.revive(P),d,g,r)}registerTimelineProvider(n,P,d,g){const r=new T.DisposableStore,m=this.convertTimelineItem(P.id,g,r).bind(this);let c;P.onDidChange&&(c=P.onDidChange(w=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},w),{id:P.id})),this));const p=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},P),{scheme:n,onDidChange:void 0,async provideTimeline(w,a,h,f){var t;(f==null?void 0:f.resetCache)&&(r.clear(),(t=p.get(P.id))===null||t===void 0||t.clear());const i=await P.provideTimeline(w,a,h);if(i==null)return;const s=m(w,f);return Object.assign(Object.assign({},i),{source:P.id,items:i.items.map(s)})},dispose(){var w;for(const a of p.values())(w=a.get(P.id))===null||w===void 0||w.clear();c==null||c.dispose(),r.dispose()}}))}convertTimelineItem(n,P,d){return(g,r)=>{let m;if(r==null?void 0:r.cacheResults){let c=this._itemsBySourceAndUriMap.get(n);c===void 0&&(c=new Map,this._itemsBySourceAndUriMap.set(n,c));const p=y(g);m=c.get(p),m===void 0&&(m=new Map,c.set(p,m))}return c=>{var p,w;const{iconPath:a}=c,h=Kt(c,["iconPath"]),f=`${n}|${(p=c.id)!==null&&p!==void 0?p:c.timestamp}`;m==null||m.set(f,c);let t,i,s;return c.iconPath&&(a instanceof E.ThemeIcon?s={id:a.id}:v.URI.isUri(a)?(t=a,i=a):{light:t,dark:i}=a),Object.assign(Object.assign({},h),{id:(w=h.id)!==null&&w!==void 0?w:void 0,handle:f,source:n,command:c.command?P.toInternal(c.command,d):void 0,icon:t,iconDark:i,themeIcon:s,accessibilityInformation:c.accessibilityInformation})}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,T.toDisposable)(()=>{var d;for(const g of this._itemsBySourceAndUriMap.values())(d=g.get(n.id))===null||d===void 0||d.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=D;function y(k){return k==null?void 0:k.toString()}}),define(ve[209],be([0,1,6,16,2,5]),function(J,e,v,R,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class E{constructor(y){this._openers=new Map,this._proxy=y.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,k,n,P){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const d=P.schemes.find(g=>!E.supportedSchemes.has(g));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,n),this._proxy.$registerUriOpener(k,P.schemes,y,P.label),(0,v.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(y,k,n){const P=this._openers.get(y);if(!P)throw new Error(`Unknown opener with id: ${y}`);const d=S.URI.revive(k);return P.canOpenExternalUri(d,n)}async $openUri(y,k,n){const P=this._openers.get(y);if(!P)throw new Error(`Unknown opener id: '${y}'`);return P.openExternalUri(S.URI.revive(k.resolvedUri),{sourceUri:S.URI.revive(k.sourceUri)},n)}}e.ExtHostUriOpeners=E,E.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(ve[210],be([0,1,5,2,6,12,26]),function(J,e,v,R,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(v.MainContext.MainThreadUrls)}registerUriHandler(k,n){if(this.handles.has(E.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const P=D.HandlePool++;return this.handles.add(E.ExtensionIdentifier.toKey(k)),this.handlers.set(P,n),this._proxy.$registerUriHandler(P,k),(0,S.toDisposable)(()=>{this.handles.delete(E.ExtensionIdentifier.toKey(k)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(k,n){const P=this.handlers.get(k);if(!P)return Promise.resolve(void 0);try{P.handleUri(R.URI.revive(n))}catch(d){(0,T.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(k){return R.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=D,D.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!S:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(J,v):S?S.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(ve[51],be([0,1,3,2,145,166,73,5]),function(J,e,v,R,S,T,E,D){"use strict";var y,k,n,P,d,g,r,m,c,p,w,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(b,A,C,l,F,N,z){y.set(this,void 0),k.set(this,void 0),n.set(this,void 0),P.set(this,void 0),d.set(this,void 0),g.set(this,void 0),r.set(this,""),m.set(this,void 0),c.set(this,!1),p.set(this,!1),w.set(this,!1),this._onMessageEmitter=new v.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new v.Emitter),this._onDidDispose=Be(this,a,"f").event,nt(this,y,b,"f"),nt(this,k,A,"f"),nt(this,m,C,"f"),nt(this,P,l,"f"),nt(this,d,F,"f"),nt(this,g,N,"f"),nt(this,w,f(N),"f"),nt(this,n,z,"f")}dispose(){nt(this,c,!0,"f"),Be(this,a,"f").fire(),Be(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return nt(this,p,!0,"f"),(0,E.asWebviewUri)(b,Be(this,P,"f").remote)}get cspSource(){return E.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,r,"f")}set html(b){this.assertNotDisposed(),Be(this,r,"f")!==b&&(nt(this,r,b,"f"),!Be(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(nt(this,p,!0,"f"),Be(this,n,"f").report("Webview vscode-resource: uris",Be(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,k,"f").$setHtml(Be(this,y,"f"),b))}get options(){return this.assertNotDisposed(),Be(this,m,"f")}set options(b){this.assertNotDisposed(),Be(this,k,"f").$setOptions(Be(this,y,"f"),s(Be(this,g,"f"),Be(this,d,"f"),b)),nt(this,m,b,"f")}async postMessage(b){if(Be(this,c,"f"))return!1;const A=(0,T.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Be(this,w,"f")});return Be(this,k,"f").$postMessage(Be(this,y,"f"),A.message,...A.buffers)}assertNotDisposed(){if(Be(this,c,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,y=new WeakMap,k=new WeakMap,n=new WeakMap,P=new WeakMap,d=new WeakMap,g=new WeakMap,r=new WeakMap,m=new WeakMap,c=new WeakMap,p=new WeakMap,w=new WeakMap,a=new WeakMap;function f(_){try{const b=(0,S.normalizeVersion)((0,S.parseVersion)(_.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch(b){return!1}}e.shouldSerializeBuffersForPostMessage=f;class t{constructor(b,A,C,l,F){this.initData=A,this.workspace=C,this._logService=l,this._deprecationService=F,this._webviews=new Map,this._webviewProxy=b.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(b,A,...C){const l=this.getWebview(b);if(l){const{message:F}=(0,T.deserializeWebviewMessage)(A,C);l._onMessageEmitter.fire(F)}}$onMissingCsp(b,A){this._logService.warn(`${A} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,A,C){const l=new h(b,this._webviewProxy,o(A),this.initData,this.workspace,C,this._deprecationService);return this._webviews.set(b,l),l._onDidDispose(()=>{this._webviews.delete(b)}),l}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=t;function i(_){return{id:_.identifier,location:_.extensionLocation}}e.toExtensionData=i;function s(_,b,A){return{enableCommandUris:A.enableCommandUris,enableScripts:A.enableScripts,portMapping:A.portMapping,localResourceRoots:A.localResourceRoots||u(_,b)}}e.serializeWebviewOptions=s;function o(_){var b;return{enableCommandUris:_.enableCommandUris,enableScripts:_.enableScripts,portMapping:_.portMapping,localResourceRoots:(b=_.localResourceRoots)===null||b===void 0?void 0:b.map(A=>R.URI.from(A))}}e.reviveOptions=o;function u(_,b){return[...((b==null?void 0:b.getWorkspaceFolders())||[]).map(A=>A.uri),_.extensionLocation]}}),define(ve[211],be([0,1,20,57,6,16,25,2,9,51,68,5,7]),function(J,e,v,R,S,T,E,D,y,k,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=h(this.document.uri)+this._backupCounter++;return(0,E.joinPath)(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class r{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,s){const o=this.key(t,i.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const u=new g(i,s);return this._documents.set(o,u),u}delete(t,i){const s=this.key(t,i.uri);this._documents.delete(s)}key(t,i){return`${t}@@@${i}`}}var m;(function(f){f[f.Text=0]="Text",f[f.Custom=1]="Custom"})(m||(m={}));class c{constructor(){this._providers=new Map}addTextProvider(t,i,s){return this.add(0,t,i,s)}addCustomProvider(t,i,s){return this.add(1,t,i,s)}get(t){return this._providers.get(t)}add(t,i,s,o){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:s,provider:o}),new d.Disposable(()=>this._providers.delete(i))}}class p{constructor(t,i,s,o,u){this._extHostDocuments=i,this._extensionStoragePaths=s,this._extHostWebview=o,this._extHostWebviewPanels=u,this._editorProviders=new c,this._documents=new r,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,s,o){const u=new S.DisposableStore;return w(s)?(u.add(this._editorProviders.addTextProvider(i,t,s)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),i,o.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(u.add(this._editorProviders.addCustomProvider(i,t,s)),this.supportEditing(s)&&u.add(s.onDidChangeCustomDocument(_=>{const b=this.getCustomDocumentEntry(i,_.document.uri);if(a(_)){const A=b.addEdit(_);this._proxy.$onDidEdit(_.document.uri,i,A,_.label)}else this._proxy.$onContentChange(_.document.uri,i)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),i,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),d.Disposable.from(u,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,s,o,u){var _;const b=this._editorProviders.get(i);if(!b)throw new Error(`No provider found for '${i}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${i}'`);const A=D.URI.revive(t),C=await b.provider.openCustomDocument(A,{backupId:s,untitledDocumentData:o==null?void 0:o.buffer},u);let l;return this.supportEditing(b.provider)&&this._extensionStoragePaths&&(l=(_=this._extensionStoragePaths.workspaceValue(b.extension))!==null&&_!==void 0?_:this._extensionStoragePaths.globalValue(b.extension)),this._documents.add(i,C,l),{editable:this.supportEditing(b.provider)}}async $disposeCustomDocument(t,i){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${i}'`);const o=D.URI.revive(t),{document:u}=this.getCustomDocumentEntry(i,o);this._documents.delete(i,u),u.dispose()}async $resolveWebviewEditor(t,i,s,o,u,_){const b=this._editorProviders.get(s);if(!b)throw new Error(`No provider found for '${s}'`);const A=y.ViewColumn.to(u),C=this._extHostWebview.createNewWebview(i,o.webviewOptions,b.extension),l=this._extHostWebviewPanels.createNewWebviewPanel(i,s,o.title,A,o.panelOptions,C),F=D.URI.revive(t);switch(b.type){case 1:{const{document:N}=this.getCustomDocumentEntry(s,F);return b.provider.resolveCustomEditor(N,l,_)}case 0:{const N=this._extHostDocuments.getDocument(F);return b.provider.resolveCustomTextEditor(N,l,_)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,s){this.getCustomDocumentEntry(i,t).disposeEdits(s)}async $onMoveCustomEditor(t,i,s){const o=this._editorProviders.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const u=this._extHostWebviewPanels.getWebviewPanel(t);if(!u)throw new Error("No webview found");const _=D.URI.revive(i),b=this._extHostDocuments.getDocument(_);await o.provider.moveCustomTextEditor(b,u,v.CancellationToken.None)}async $undo(t,i,s,o){return this.getCustomDocumentEntry(i,t).undo(s,o)}async $redo(t,i,s,o){return this.getCustomDocumentEntry(i,t).redo(s,o)}async $revert(t,i,s){const o=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(o.document,s),o.disposeBackup()}async $onSave(t,i,s){const o=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(o.document,s),o.disposeBackup()}async $onSaveAs(t,i,s,o){const u=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(u.document,D.URI.revive(s),o)}async $backup(t,i,s){const o=this.getCustomDocumentEntry(i,t),_=await this.getCustomEditorProvider(i).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},s);return o.updateBackup(_),_.id}getCustomDocumentEntry(t,i){const s=this._documents.get(t,D.URI.revive(i));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const i=this._editorProviders.get(t),s=i==null?void 0:i.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=p;function w(f){return typeof f.resolveCustomTextEditor=="function"}function a(f){return typeof f.undo=="function"&&typeof f.redo=="function"}function h(f){const t=f.scheme===T.Schemas.file||f.scheme===T.Schemas.untitled?f.fsPath:f.toString();return(0,R.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!S:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(J,v):S?S.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(ve[212],be([0,1,3,6,2,37,9,51,5,7]),function(J,e,v,R,S,T,E,D,y,k){"use strict";var n,P,d,g,r,m,c,p,w,a,h,f,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends R.Disposable{constructor(_,b,A,C,l,F,N){super();n.set(this,void 0),P.set(this,void 0),d.set(this,void 0),g.set(this,void 0),r.set(this,void 0),m.set(this,void 0),c.set(this,void 0),p.set(this,void 0),w.set(this,!0),a.set(this,!0),h.set(this,!1),f.set(this,this._register(new v.Emitter)),this.onDidDispose=Be(this,f,"f").event,t.set(this,this._register(new v.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,nt(this,n,_,"f"),nt(this,P,b,"f"),nt(this,d,A,"f"),nt(this,r,F,"f"),nt(this,p,l,"f"),nt(this,m,C,"f"),nt(this,g,N,"f")}dispose(){Be(this,h,"f")||(nt(this,h,!0,"f"),Be(this,f,"f").fire(),Be(this,P,"f").$disposeWebview(Be(this,n,"f")),Be(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,g,"f")}get viewType(){return this.assertNotDisposed(),Be(this,d,"f")}get title(){return this.assertNotDisposed(),Be(this,m,"f")}set title(_){this.assertNotDisposed(),Be(this,m,"f")!==_&&(nt(this,m,_,"f"),Be(this,P,"f").$setTitle(Be(this,n,"f"),_))}get iconPath(){return this.assertNotDisposed(),Be(this,c,"f")}set iconPath(_){this.assertNotDisposed(),Be(this,c,"f")!==_&&(nt(this,c,_,"f"),Be(this,P,"f").$setIconPath(Be(this,n,"f"),S.URI.isUri(_)?{light:_,dark:_}:_))}get options(){return Be(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,p,"f")=="number"&&Be(this,p,"f")<0))return Be(this,p,"f")}get active(){return this.assertNotDisposed(),Be(this,a,"f")}get visible(){return this.assertNotDisposed(),Be(this,w,"f")}_updateViewState(_){Be(this,h,"f")||(this.active!==_.active||this.visible!==_.visible||this.viewColumn!==_.viewColumn)&&(nt(this,a,_.active,"f"),nt(this,w,_.visible,"f"),nt(this,p,_.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(_,b){this.assertNotDisposed(),Be(this,P,"f").$reveal(Be(this,n,"f"),{viewColumn:_?E.ViewColumn.from(_):void 0,preserveFocus:!!b})}assertNotDisposed(){if(Be(this,h,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,P=new WeakMap,d=new WeakMap,g=new WeakMap,r=new WeakMap,m=new WeakMap,c=new WeakMap,p=new WeakMap,w=new WeakMap,a=new WeakMap,h=new WeakMap,f=new WeakMap,t=new WeakMap;class s{constructor(_,b,A){this.webviews=b,this.workspace=A,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=_.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(_,b,A,C,l={}){const F=typeof C=="object"?C.viewColumn:C,N={viewColumn:E.ViewColumn.from(F),preserveFocus:typeof C=="object"&&!!C.preserveFocus},z=(0,D.shouldSerializeBuffersForPostMessage)(_),de=s.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(_),de,b,{title:A,panelOptions:o(l),webviewOptions:(0,D.serializeWebviewOptions)(_,this.workspace,l),serializeBuffersForPostMessage:z},N);const he=this.webviews.createNewWebview(de,l,_);return this.createNewWebviewPanel(de,b,A,F,l,he)}$onDidChangeWebviewPanelViewStates(_){const b=Object.keys(_);b.sort((A,C)=>{const l=_[A],F=_[C];return l.active?1:F.active?-1:+l.visible-+F.visible});for(const A of b){const C=this.getWebviewPanel(A);if(!C)continue;const l=_[A];C._updateViewState({active:l.active,visible:l.visible,viewColumn:E.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel(_){const b=this.getWebviewPanel(_);b==null||b.dispose(),this._webviewPanels.delete(_),this.webviews.deleteWebview(_)}registerWebviewPanelSerializer(_,b,A){if(this._serializers.has(b))throw new Error(`Serializer for '${b}' already registered`);return this._serializers.set(b,{serializer:A,extension:_}),this._proxy.$registerSerializer(b,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(_)}),new k.Disposable(()=>{this._serializers.delete(b),this._proxy.$unregisterSerializer(b)})}async $deserializeWebviewPanel(_,b,A,C){const l=this._serializers.get(b);if(!l)throw new Error(`No serializer found for '${b}'`);const{serializer:F,extension:N}=l,z=this.webviews.createNewWebview(_,A.webviewOptions,N),de=this.createNewWebviewPanel(_,b,A.title,C,A.panelOptions,z);await F.deserializeWebviewPanel(de,A.state)}createNewWebviewPanel(_,b,A,C,l,F){const N=new i(_,this._proxy,b,A,C,l,F);return this._webviewPanels.set(_,N),N}getWebviewPanel(_){return this._webviewPanels.get(_)}}e.ExtHostWebviewPanels=s;function o(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!S:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(J,v):S?S.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(ve[213],be([0,1,3,6,51,5,7]),function(J,e,v,R,S,T,E){"use strict";var D,y,k,n,P,d,g,r,m,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class p extends R.Disposable{constructor(h,f,t,i,s,o){super();D.set(this,void 0),y.set(this,void 0),k.set(this,void 0),n.set(this,void 0),P.set(this,!1),d.set(this,void 0),g.set(this,void 0),r.set(this,void 0),m.set(this,this._register(new v.Emitter)),this.onDidChangeVisibility=Be(this,m,"f").event,c.set(this,this._register(new v.Emitter)),this.onDidDispose=Be(this,c,"f").event,nt(this,k,t,"f"),nt(this,g,i,"f"),nt(this,D,h,"f"),nt(this,y,f,"f"),nt(this,n,s,"f"),nt(this,d,o,"f")}dispose(){Be(this,P,"f")||(nt(this,P,!0,"f"),Be(this,c,"f").fire(),Be(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,g,"f")}set title(h){this.assertNotDisposed(),Be(this,g,"f")!==h&&(nt(this,g,h,"f"),Be(this,y,"f").$setWebviewViewTitle(Be(this,D,"f"),h))}get description(){return this.assertNotDisposed(),Be(this,r,"f")}set description(h){this.assertNotDisposed(),Be(this,r,"f")!==h&&(nt(this,r,h,"f"),Be(this,y,"f").$setWebviewViewDescription(Be(this,D,"f"),h))}get visible(){return Be(this,d,"f")}get webview(){return Be(this,n,"f")}get viewType(){return Be(this,k,"f")}_setVisible(h){h===Be(this,d,"f")||Be(this,P,"f")||(nt(this,d,h,"f"),Be(this,m,"f").fire())}show(h){this.assertNotDisposed(),Be(this,y,"f").$show(Be(this,D,"f"),!!h)}assertNotDisposed(){if(Be(this,P,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,y=new WeakMap,k=new WeakMap,n=new WeakMap,P=new WeakMap,d=new WeakMap,g=new WeakMap,r=new WeakMap,m=new WeakMap,c=new WeakMap;class w{constructor(h,f){this._extHostWebview=f,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,f,t,i){if(this._viewProviders.has(f))throw new Error(`View provider for '${f}' already registered`);return this._viewProviders.set(f,{provider:t,extension:h}),this._proxy.$registerWebviewViewProvider((0,S.toExtensionData)(h),f,{retainContextWhenHidden:i==null?void 0:i.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new E.Disposable(()=>{this._viewProviders.delete(f),this._proxy.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(h,f,t,i,s){const o=this._viewProviders.get(f);if(!o)throw new Error(`No view provider found for '${f}'`);const{provider:u,extension:_}=o,b=this._extHostWebview.createNewWebview(h,{},_),A=new p(h,this._proxy,f,t,b,!0);this._webviewViews.set(h,A),await u.resolveWebviewView(A,{state:i},s)}async $onDidChangeWebviewViewVisibility(h,f){this.getWebviewView(h)._setVisible(f)}async $disposeWebviewView(h){const f=this.getWebviewView(h);this._webviewViews.delete(h),f.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const f=this._webviewViews.get(h);if(!f)throw new Error("No webview found");return f}}e.ExtHostWebviewViews=w}),define(ve[103],be([0,1,3,5,2,16,8,4,15]),function(J,e,v,R,S,T,E,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Nn{constructor(P){this._onDidChangeWindowState=new v.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Nn.InitialState,this._proxy=P.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(d=>this.$onDidChangeWindowFocus(d))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:P}),this._onDidChangeWindowState.fire(this._state))}openUri(P,d){let g;if(typeof P=="string"){g=P;try{P=S.URI.parse(P)}catch(r){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,E.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,g,d)}async asExternalUri(P,d){if((0,E.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this._proxy.$asExternalUri(P,d);return S.URI.from(g)}};k.InitialState={focused:!0},k=je([qe(0,y.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(ve[214],be([0,1,17,5,27,15]),function(J,e,v,R,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let E=class extends v.AbstractLogger{constructor(y,k){super();this._proxy=y.getProxy(R.MainContext.MainThreadLog),this._logFile=k.logFile.toJSON(),this.setLevel(k.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...k){this.getLevel()<=v.LogLevel.Trace&&this._proxy.$log(this._logFile,v.LogLevel.Trace,Array.from(arguments))}debug(y,...k){this.getLevel()<=v.LogLevel.Debug&&this._proxy.$log(this._logFile,v.LogLevel.Debug,Array.from(arguments))}info(y,...k){this.getLevel()<=v.LogLevel.Info&&this._proxy.$log(this._logFile,v.LogLevel.Info,Array.from(arguments))}warn(y,...k){this.getLevel()<=v.LogLevel.Warning&&this._proxy.$log(this._logFile,v.LogLevel.Warning,Array.from(arguments))}error(y,...k){this.getLevel()<=v.LogLevel.Error&&this._proxy.$log(this._logFile,v.LogLevel.Error,Array.from(arguments))}critical(y,...k){this.getLevel()<=v.LogLevel.Critical&&this._proxy.$log(this._logFile,v.LogLevel.Critical,Array.from(arguments))}flush(){}};E=je([qe(0,T.IExtHostRpcService),qe(1,S.IExtHostInitDataService)],E),e.ExtHostLogService=E}),define(ve[215],be([0,1,11,20,12,3,6,115,186,100,23]),function(J,e,v,R,S,T,E,D,y,k,n){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function d(o,u){try{return JSON.stringify(o,u)}catch(_){return"null"}}function g(o,u){return JSON.stringify(o,u)}function r(o){return o?(u,_)=>_&&_.$mid===1?o.transformOutgoing(_):_:null}var m;(function(o){o[o.LocalSide=0]="LocalSide",o[o.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));var c;(function(o){o[o.Responsive=0]="Responsive",o[o.Unresponsive=1]="Unresponsive"})(c=e.ResponsiveState||(e.ResponsiveState={}));const p=()=>{},w=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class h extends E.Disposable{constructor(u,_=null,b=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=u,this._logger=_,this._uriTransformer=b,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,C=k.ProxyIdentifier.count;A<C;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new v.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(u=>{this._pendingRPCReplies[u].resolveErr(S.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(u){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(u){this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(u){this._responsiveState!==u&&(this._responsiveState=u,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(u){return this._uriTransformer?(0,D.transformIncomingURIs)(u,this._uriTransformer):u}getProxy(u){const{nid:_,sid:b}=u;return this._proxies[_]||(this._proxies[_]=this._createProxy(_,b)),this._proxies[_]}_createProxy(u,_){let b={get:(A,C)=>(typeof C=="string"&&!A[C]&&C.charCodeAt(0)===36&&(A[C]=(...l)=>this._remoteCall(u,C,l)),C===a?_:A[C])};return new Proxy(Object.create(null),b)}set(u,_){return this._locals[u.nid]=_,_}assertRegistered(u){for(let _=0,b=u.length;_<b;_++){const A=u[_];if(!this._locals[A.nid])throw new Error(`Missing actor ${A.sid} (isMain: ${A.isMain})`)}}_receiveOneMessage(u){if(this._isDisposed)return;const _=u.byteLength,b=f.read(u,0),A=b.readUInt8(),C=b.readUInt32();switch(A){case 1:case 2:{let{rpcId:l,method:F,args:N}=t.deserializeRequestJSONArgs(b);this._uriTransformer&&(N=(0,D.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(_,C,l,F,N,A===2);break}case 3:case 4:{let{rpcId:l,method:F,args:N}=t.deserializeRequestMixedArgs(b);this._uriTransformer&&(N=(0,D.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(_,C,l,F,N,A===4);break}case 5:{this._logger&&this._logger.logIncoming(_,C,0,"ack"),this._onDidReceiveAcknowledge(C);break}case 6:{this._receiveCancel(_,C);break}case 7:{this._receiveReply(_,C,void 0);break}case 9:{let l=t.deserializeReplyOKJSON(b);this._uriTransformer&&(l=(0,D.transformIncomingURIs)(l,this._uriTransformer)),this._receiveReply(_,C,l);break}case 8:{let l=t.deserializeReplyOKVSBuffer(b);this._receiveReply(_,C,l);break}case 10:{let l=t.deserializeReplyErrError(b);this._uriTransformer&&(l=(0,D.transformIncomingURIs)(l,this._uriTransformer)),this._receiveReplyErr(_,C,l);break}case 11:{this._receiveReplyErr(_,C,void 0);break}default:console.error("received unexpected message"),console.error(u)}}_receiveRequest(u,_,b,A,C,l){this._logger&&this._logger.logIncoming(u,_,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(b)}.${A}(`,C);const F=String(_);let N,z;if(l){const he=new R.CancellationTokenSource;C.push(he.token),N=this._invokeHandler(b,A,C),z=()=>he.cancel()}else N=this._invokeHandler(b,A,C),z=p;this._cancelInvokedHandlers[F]=z;const de=t.serializeAcknowledged(_);this._logger&&this._logger.logOutgoing(de.byteLength,_,1,"ack"),this._protocol.send(de),N.then(he=>{delete this._cancelInvokedHandlers[F];const $=t.serializeReplyOK(_,he,this._uriReplacer);this._logger&&this._logger.logOutgoing($.byteLength,_,1,"reply:",he),this._protocol.send($)},he=>{delete this._cancelInvokedHandlers[F];const $=t.serializeReplyErr(_,he);this._logger&&this._logger.logOutgoing($.byteLength,_,1,"replyErr:",he),this._protocol.send($)})}_receiveCancel(u,_){this._logger&&this._logger.logIncoming(u,_,1,"receiveCancel");const b=String(_);this._cancelInvokedHandlers[b]&&this._cancelInvokedHandlers[b]()}_receiveReply(u,_,b){this._logger&&this._logger.logIncoming(u,_,0,"receiveReply:",b);const A=String(_);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const C=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],C.resolveOk(b)}_receiveReplyErr(u,_,b){this._logger&&this._logger.logIncoming(u,_,0,"receiveReplyErr:",b);const A=String(_);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const C=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let l;b&&(b.$isError?(l=new Error,l.name=b.name,l.message=b.message,l.stack=b.stack):l=b),C.resolveErr(l)}_invokeHandler(u,_,b){try{return Promise.resolve(this._doInvokeHandler(u,_,b))}catch(A){return Promise.reject(A)}}_doInvokeHandler(u,_,b){const A=this._locals[u];if(!A)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(u));let C=A[_];if(typeof C!="function")throw new Error("Unknown method "+_+" on actor "+(0,k.getStringIdentifierForProxy)(u));return C.apply(A,b)}_remoteCall(u,_,b){if(this._isDisposed)return Promise.reject(S.canceled());let A=null;if(b.length>0&&R.CancellationToken.isCancellationToken(b[b.length-1])&&(A=b.pop()),A&&A.isCancellationRequested)return Promise.reject(S.canceled());const C=t.serializeRequestArguments(b,this._uriReplacer),l=++this._lastMessageId,F=String(l),N=new y.LazyPromise;A&&A.onCancellationRequested(()=>{const de=t.serializeCancel(l);this._logger&&this._logger.logOutgoing(de.byteLength,l,0,"cancel"),this._protocol.send(t.serializeCancel(l))}),this._pendingRPCReplies[F]=N,this._onWillSendRequest(l);const z=t.serializeRequest(l,u,_,C,!!A);return this._logger&&this._logger.logOutgoing(z.byteLength,l,0,`request: ${(0,k.getStringIdentifierForProxy)(u)}.${_}(`,b),this._protocol.send(z),N}}e.RPCProtocol=h,P=w,h.UNRESPONSIVE_TIME=3*1e3;class f{constructor(u,_){this._buff=u,this._offset=_}static alloc(u,_,b){let A=new f(n.VSBuffer.alloc(b+1+4),0);return A.writeUInt8(u),A.writeUInt32(_),A}static read(u,_){return new f(u,_)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(u){this._buff.writeUInt8(u,this._offset),this._offset+=1}readUInt8(){const u=this._buff.readUInt8(this._offset);return this._offset+=1,u}writeUInt32(u){this._buff.writeUInt32BE(u,this._offset),this._offset+=4}readUInt32(){const u=this._buff.readUInt32BE(this._offset);return this._offset+=4,u}static sizeShortString(u){return 1+u.byteLength}writeShortString(u){this._buff.writeUInt8(u.byteLength,this._offset),this._offset+=1,this._buff.set(u,this._offset),this._offset+=u.byteLength}readShortString(){const u=this._buff.readUInt8(this._offset);this._offset+=1;const b=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,b}static sizeLongString(u){return 4+u.byteLength}writeLongString(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readLongString(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const b=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,b}writeBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}static sizeVSBuffer(u){return 4+u.byteLength}writeVSBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readVSBuffer(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const _=this._buff.slice(this._offset,this._offset+u);return this._offset+=u,_}static sizeMixedArray(u,_){let b=0;b+=1;for(let A=0,C=u.length;A<C;A++){const l=u[A],F=_[A];switch(b+=1,F){case 1:b+=this.sizeLongString(l);break;case 2:b+=this.sizeVSBuffer(l);break;case 3:break}}return b}writeMixedArray(u,_){this._buff.writeUInt8(u.length,this._offset),this._offset+=1;for(let b=0,A=u.length;b<A;b++){const C=u[b];switch(_[b]){case 1:this.writeUInt8(1),this.writeLongString(C);break;case 2:this.writeUInt8(2),this.writeVSBuffer(C);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const u=this._buff.readUInt8(this._offset);this._offset+=1;let _=new Array(u);for(let b=0;b<u;b++)switch(this.readUInt8()){case 1:_[b]=this.readLongString();break;case 2:_[b]=this.readVSBuffer();break;case 3:_[b]=void 0;break}return _}}class t{static _arrayContainsBufferOrUndefined(u){for(let _=0,b=u.length;_<b;_++)if(u[_]instanceof n.VSBuffer||typeof u[_]=="undefined")return!0;return!1}static serializeRequestArguments(u,_){if(this._arrayContainsBufferOrUndefined(u)){let b=[],A=[];for(let C=0,l=u.length;C<l;C++){const F=u[C];F instanceof n.VSBuffer?(b[C]=F,A[C]=2):typeof F=="undefined"?(b[C]=n.VSBuffer.alloc(0),A[C]=3):(b[C]=n.VSBuffer.fromString(g(F,_)),A[C]=1)}return{type:"mixed",args:b,argsType:A}}return{type:"simple",args:g(u,_)}}static serializeRequest(u,_,b,A,C){return A.type==="mixed"?this._requestMixedArgs(u,_,b,A.args,A.argsType,C):this._requestJSONArgs(u,_,b,A.args,C)}static _requestJSONArgs(u,_,b,A,C){const l=n.VSBuffer.fromString(b),F=n.VSBuffer.fromString(A);let N=0;N+=f.sizeUInt8(),N+=f.sizeShortString(l),N+=f.sizeLongString(F);let z=f.alloc(C?2:1,u,N);return z.writeUInt8(_),z.writeShortString(l),z.writeLongString(F),z.buffer}static deserializeRequestJSONArgs(u){const _=u.readUInt8(),b=u.readShortString(),A=u.readLongString();return{rpcId:_,method:b,args:JSON.parse(A)}}static _requestMixedArgs(u,_,b,A,C,l){const F=n.VSBuffer.fromString(b);let N=0;N+=f.sizeUInt8(),N+=f.sizeShortString(F),N+=f.sizeMixedArray(A,C);let z=f.alloc(l?4:3,u,N);return z.writeUInt8(_),z.writeShortString(F),z.writeMixedArray(A,C),z.buffer}static deserializeRequestMixedArgs(u){const _=u.readUInt8(),b=u.readShortString(),A=u.readMixedArray(),C=new Array(A.length);for(let l=0,F=A.length;l<F;l++){const N=A[l];typeof N=="string"?C[l]=JSON.parse(N):C[l]=N}return{rpcId:_,method:b,args:C}}static serializeAcknowledged(u){return f.alloc(5,u,0).buffer}static serializeCancel(u){return f.alloc(6,u,0).buffer}static serializeReplyOK(u,_,b){return typeof _=="undefined"?this._serializeReplyOKEmpty(u):_ instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(u,_):this._serializeReplyOKJSON(u,d(_,b))}static _serializeReplyOKEmpty(u){return f.alloc(7,u,0).buffer}static _serializeReplyOKVSBuffer(u,_){let b=0;b+=f.sizeVSBuffer(_);let A=f.alloc(8,u,b);return A.writeVSBuffer(_),A.buffer}static deserializeReplyOKVSBuffer(u){return u.readVSBuffer()}static _serializeReplyOKJSON(u,_){const b=n.VSBuffer.fromString(_);let A=0;A+=f.sizeLongString(b);let C=f.alloc(9,u,A);return C.writeLongString(b),C.buffer}static deserializeReplyOKJSON(u){const _=u.readLongString();return JSON.parse(_)}static serializeReplyErr(u,_){return _?this._serializeReplyErrEror(u,_):this._serializeReplyErrEmpty(u)}static _serializeReplyErrEror(u,_){const b=n.VSBuffer.fromString(d(S.transformErrorForSerialization(_),null));let A=0;A+=f.sizeLongString(b);let C=f.alloc(10,u,A);return C.writeLongString(b),C.buffer}static deserializeReplyErrError(u){const _=u.readLongString();return JSON.parse(_)}static _serializeReplyErrEmpty(u){return f.alloc(11,u,0).buffer}}var i;(function(o){o[o.RequestJSONArgs=1]="RequestJSONArgs",o[o.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",o[o.RequestMixedArgs=3]="RequestMixedArgs",o[o.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",o[o.Acknowledged=5]="Acknowledged",o[o.Cancel=6]="Cancel",o[o.ReplyOKEmpty=7]="ReplyOKEmpty",o[o.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",o[o.ReplyOKJSON=9]="ReplyOKJSON",o[o.ReplyErrError=10]="ReplyErrError",o[o.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var s;(function(o){o[o.String=1]="String",o[o.VSBuffer=2]="VSBuffer",o[o.Undefined=3]="Undefined"})(s||(s={}))}),define(ve[216],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const v=function(T){const E=D=>{self.removeEventListener("message",E);const y=D.data;Object.defineProperties(self,{postMessage:{value(k,n){y.postMessage(k,n)}},onmessage:{get(){return y.onmessage},set(k){y.onmessage=k}}}),y.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",E)}.toString();class R extends EventTarget{constructor(T,E,D){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${v})('${E}'))`,k=new Blob([y],{type:"application/javascript"}),n=URL.createObjectURL(k),P=new MessageChannel,d=n,g={type:"_newWorker",id:d,port:P.port2,url:n,options:D};T(g,[P.port2]),this.postMessage=P.port1.postMessage.bind(P.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:d};P.port1.postMessage(r),URL.revokeObjectURL(n),P.port1.close(),P.port2.close()},Object.defineProperties(this,{onmessage:{get(){return P.port1.onmessage},set(r){P.port1.onmessage=r}},onmessageerror:{get(){return P.port1.onmessageerror},set(r){P.port1.onmessageerror=r}}}),P.port1.addEventListener("messageerror",r=>{const m=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(m)}),P.port1.addEventListener("message",r=>{const m=new MessageEvent("message",{data:r.data});this.dispatchEvent(m)}),P.port1.start()}}e.NestedWorker=R}),define(ve[217],be([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,v.createDecorator)("remoteAgentService")}),define(ve[218],be([0,1,16,14,21,2,4,217]),function(J,e,v,R,S,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let y=class{constructor(n,P){this.localUserHome=n,this.remoteAgentService=P,this.resolveOS=(async()=>{const d=await this.remoteAgentService.getEnvironment();return(d==null?void 0:d.os)||S.OS})(),this.resolveUserHome=(async()=>{const d=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(d==null?void 0:d.userHome)||n})()}async userHome(n){return(n==null?void 0:n.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(n=>n===1?R.win32:R.posix)}async fileURI(n){let P="";if(await this.resolveOS===1&&(n=n.replace(/\\/g,"/")),n[0]==="/"&&n[1]==="/"){const g=n.indexOf("/",2);g===-1?(P=n.substring(2),n="/"):(P=n.substring(2,g),n=n.substring(g)||"/")}return T.URI.from({scheme:v.Schemas.file,authority:P,path:n,query:"",fragment:""})}};y=je([qe(1,D.IRemoteAgentService)],y),e.AbstractPathService=y}),define(ve[104],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class v{constructor(E,D){this.line=E,this.character=D}isBefore(E){return!1}isBeforeOrEqual(E){return!1}isAfter(E){return!1}isAfterOrEqual(E){return!1}isEqual(E){return!1}compareTo(E){return 0}translate(E,D){return new v(0,0)}with(E){return new v(0,0)}}e.Position=v;class R{constructor(E,D,y,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(E,D),this.end=new v(y,k)}contains(E){return!1}isEqual(E){return!1}intersection(E){}union(E){return new R(0,0,0,0)}with(E){return new R(0,0,0,0)}}e.Range=R;var S;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[41],be([0,1,13,28,24,36,8,4,14,12,104]),function(J,e,v,R,S,T,E,D,y,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",d=" characters skipped \u27EB",g=(P.length+d.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var r;(function(I){I[I.file=0]="file",I[I.text=1]="text"})(r=e.SearchProviderType||(e.SearchProviderType={}));var m;(function(I){I[I.File=1]="File",I[I.Text=2]="Text"})(m=e.QueryType||(e.QueryType={}));function c(I){return!!I.preview}e.resultIsMatch=c;function p(I){return!!I.resource}e.isFileMatch=p;function w(I){return!!I.message}e.isProgressMessage=w;var a;(function(I){I[I.Normal=0]="Normal",I[I.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class h{constructor(H){this.resource=H,this.results=[]}}e.FileMatch=h;class f{constructor(H,M,B){this.ranges=M;const G=Array.isArray(M)?M:[M];if(B&&B.matchLines===1&&t(G)){H=(0,E.getNLines)(H,B.matchLines);let K="",se=0,pe=0;const Fe=Math.floor(B.charsPerLine/5),We=[];for(const Ne of G){const ze=Math.max(Ne.startColumn-Fe,0),Ve=Ne.startColumn+B.charsPerLine;if(ze>pe+Fe+g){const W=P+(ze-pe)+d;K+=W+H.slice(ze,Ve),se+=ze-(pe+W.length)}else K+=H.slice(pe,Ve);We.push(new s(0,Ne.startColumn-se,Ne.endColumn-se)),pe=Ve}this.preview={text:K,matches:Array.isArray(this.ranges)?We:We[0]}}else{const K=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:H,matches:(0,v.mapArrayOrNot)(M,se=>new i(se.startLineNumber-K,se.startColumn,se.endLineNumber-K,se.endColumn))}}}}e.TextSearchMatch=f;function t(I){const H=I[0].startLineNumber;for(const M of I)if(M.startLineNumber!==H||M.endLineNumber!==H)return!1;return!0}class i{constructor(H,M,B,G){this.startLineNumber=H,this.startColumn=M,this.endLineNumber=B,this.endColumn=G}}e.SearchRange=i;class s extends i{constructor(H,M,B){super(H,M,H,B)}}e.OneLineRange=s;var o;(function(I){I.Default="default",I.FileNames="fileNames",I.Type="type",I.Modified="modified",I.CountDescending="countDescending",I.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function u(I,H=!0){const M=I&&I.files&&I.files.exclude,B=H&&I&&I.search&&I.search.exclude;if(!M&&!B)return;if(!M||!B)return M||B;let G=Object.create(null);return G=S.mixin(G,S.deepClone(M)),G=S.mixin(G,S.deepClone(B),!0),G}e.getExcludes=u;function _(I,H){return I.excludePattern&&R.match(I.excludePattern,H)?!1:I.includePattern||I.usingSearchPaths?I.includePattern&&R.match(I.includePattern,H)?!0:I.usingSearchPaths?!!I.folderQueries&&I.folderQueries.some(M=>{const B=M.folder.fsPath;if(T.isEqualOrParent(H,B)){const G=y.relative(B,H);return!M.includePattern||!!R.match(M.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=_;var b;(function(I){I[I.unknownEncoding=1]="unknownEncoding",I[I.regexParseError=2]="regexParseError",I[I.globParseError=3]="globParseError",I[I.invalidLiteral=4]="invalidLiteral",I[I.rgProcessError=5]="rgProcessError",I[I.other=6]="other",I[I.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class A extends Error{constructor(H,M){super(H);this.code=M}}e.SearchError=A;function C(I){const H=I.message;if((0,k.isPromiseCanceledError)(I))return new A(H,b.canceled);try{const M=JSON.parse(H);return new A(M.message,M.code)}catch(M){return new A(H,b.other)}}e.deserializeSearchError=C;function l(I){const H={message:I.message,code:I.code};return new Error(JSON.stringify(H))}e.serializeSearchError=l;function F(I){return I.type==="error"?!0:I.type==="success"}e.isSerializedSearchComplete=F;function N(I){return I.type==="success"}e.isSerializedSearchSuccess=N;function z(I){return!!I.path}e.isSerializedFileMatch=z;function de(I,H){const M=I.searchPath?I.searchPath:I.relativePath;return(0,E.fuzzyContains)(M,H)}e.isFilePatternMatch=de;class he{constructor(H){this.path=H,this.results=[]}addMatch(H){this.results.push(H)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=he;function $(I,H){const M=Object.assign(Object.assign({},I||{}),H||{});return Object.keys(M).filter(B=>{const G=M[B];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=$;class q{constructor(H,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},H.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=R.parse(this._excludeExpression);let B=H.includePattern;M.includePattern&&(B?B=Object.assign(Object.assign({},B),M.includePattern):B=M.includePattern),B&&(this._parsedIncludeExpression=R.parse(B))}includedInQuerySync(H,M,B){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(H,M,B)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(H,M,B))}includedInQuery(H,M,B){return Promise.resolve(this._parsedExcludeExpression(H,M,B)).then(K=>!!K).then(K=>K?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(H,M,B)).then(se=>!!se):Promise.resolve(!0)).then(K=>K)}hasSiblingExcludeClauses(){return x(this._excludeExpression)}}e.QueryGlobTester=q;function x(I){for(const H in I)if(typeof I[H]!="boolean")return!0;return!1}}),define(ve[30],be([0,1,13,11,20,3,22,16,81,25,8,10,2,138,4,17,153,48,49,27,15,7,41,5]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r,m,c,p,w,a,h,f,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(F,N,z){return new k.ExtUri(de=>b(de,z)).isEqual(F,N)}function o(F,N,z){return s(F.uri,N.uri,z)?0:(0,n.compare)(F.uri.toString(),N.uri.toString())}function u(F,N,z){return F.index!==N.index?F.index<N.index?-1:1:s(F.uri,N.uri,z)?(0,n.compare)(F.name,N.name):(0,n.compare)(F.uri.toString(),N.uri.toString())}function _(F,N,z,de){const he=F.slice(0).sort((q,x)=>z(q,x,de)),$=N.slice(0).sort((q,x)=>z(q,x,de));return(0,v.delta)(he,$,(q,x)=>z(q,x,de))}function b(F,N){const z=N.getCapabilities(F.scheme);return!(z&&z&1024)}class A extends p.Workspace{constructor(N,z,de,he,$,q){super(N,de.map(x=>new p.WorkspaceFolder(x)),he,q);this._name=z,this._isUntitled=$,this._workspaceFolders=[],this._structure=E.TernarySearchTree.forUris(q),de.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}static toExtHostWorkspace(N,z,de,he){if(!N)return{workspace:null,added:[],removed:[]};const{id:$,name:q,folders:x,configuration:I,isUntitled:H}=N,M=[],B=z;z?x.forEach((pe,Fe)=>{const We=d.URI.revive(pe.uri),Ne=A._findFolder(de||z,We,he);Ne?(Ne.name=pe.name,Ne.index=pe.index,M.push(Ne)):M.push({uri:We,name:pe.name,index:Fe})}):M.push(...x.map(({uri:pe,name:Fe,index:We})=>({uri:d.URI.revive(pe),name:Fe,index:We}))),M.sort((pe,Fe)=>pe.index<Fe.index?-1:1);const G=new A($,q,M,I?d.URI.revive(I):null,!!H,pe=>b(pe,he)),{added:K,removed:se}=_(B?B.workspaceFolders:[],G.workspaceFolders,o,he);return{workspace:G,added:K,removed:se}}static _findFolder(N,z,de){for(let he=0;he<N.folders.length;he++){const $=N.workspaceFolders[he];if(s($.uri,z,de))return $}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,z){return z&&this._structure.get(N)&&(N=(0,k.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let C=class{constructor(N,z,de,he){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=he,this._extHostFileSystemInfo=de,this._requestIdProvider=new y.Counter,this._barrier=new R.Barrier,this._proxy=N.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(i.MainContext.MainThreadMessageService);const $=z.workspace;this._confirmedWorkspace=$?new A($.id,$.name,[],$.configuration?d.URI.revive($.configuration):null,!!$.isUntitled,q=>b(q,de)):void 0}$initializeWorkspace(N,z){this._trusted=z,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:D.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,z,de,...he){const $=[];if(Array.isArray(he)&&he.forEach(M=>{d.URI.isUri(M.uri)&&!$.some(B=>s(B.uri,M.uri,this._extHostFileSystemInfo))&&$.push({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[z,de].some(M=>typeof M!="number"||M<0)||de===0&&$.length===0)return!1;const q=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(z+de>q.length)return!1;const x=q.slice(0);x.splice(z,de,...$.map(M=>({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<x.length;M++){const B=x[M];if(x.some((G,K)=>K!==M&&s(B.uri,G.uri,this._extHostFileSystemInfo)))return!1}x.forEach((M,B)=>M.index=B);const{added:I,removed:H}=_(q,x,u,this._extHostFileSystemInfo);if(I.length===0&&H.length===0)return!1;if(this._proxy){const M=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(M,z,de,$).then(void 0,B=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(c.Severity.Error,(0,g.localize)(0,null,M,B.toString()),{extension:N},[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(N,z){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,z)}async getWorkspaceFolder2(N,z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,z)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!this._actualWorkspace)return;const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,z){let de,he="";if(typeof N=="string"?(de=d.URI.file(N),he=N):typeof N!="undefined"&&(de=N,he=N.fsPath),!de)return he;const $=this.getWorkspaceFolder(de,!0);if(!$)return he;typeof z=="undefined"&&this._actualWorkspace&&(z=this._actualWorkspace.folders.length>1);let q=(0,k.relativePath)($.uri,de);return z&&$.name&&(q=`${$.name}/${q}`),q}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=A.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:z,added:de,removed:he}=A.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=z||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:de,removed:he}))}findFiles(N,z,de,he,$=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${he.value}, entryPoint: findFiles`);let q;if(z===null?q=!1:z&&(typeof z=="string"?q=z:q=z.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:I}=l(N);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)(x),(0,P.withUndefinedAsNull)(I),(0,P.withUndefinedAsNull)(q),(0,P.withUndefinedAsNull)(de),$).then(H=>Array.isArray(H)?H.map(M=>d.URI.revive(M)):[])}async findTextInFiles(N,z,de,he,$=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${he.value}, entryPoint: findTextInFiles`);const q=this._requestIdProvider.getNext(),x=typeof z.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:I,folder:H}=l(z.include),M=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,B={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:x,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:I,excludePattern:M},G=!1;if(this._activeSearchCallbacks[q]=K=>{if(G)return;const se=d.URI.revive(K.resource);K.results.forEach(pe=>{(0,t.resultIsMatch)(pe)?de({uri:se,preview:{text:pe.preview.text,matches:(0,v.mapArrayOrNot)(pe.preview.matches,Fe=>new f.Range(Fe.startLineNumber,Fe.startColumn,Fe.endLineNumber,Fe.endColumn))},ranges:(0,v.mapArrayOrNot)(pe.ranges,Fe=>new f.Range(Fe.startLineNumber,Fe.startColumn,Fe.endLineNumber,Fe.endColumn))}):de({uri:se,text:pe.text,lineNumber:pe.lineNumber})})},$.isCancellationRequested)return{};try{const K=await this._proxy.$startTextSearch(N,(0,P.withUndefinedAsNull)(H),B,q,$);return delete this._activeSearchCallbacks[q],K||{}}catch(K){throw delete this._activeSearchCallbacks[q],K}}$handleTextSearchResult(N,z){this._activeSearchCallbacks[z]&&this._activeSearchCallbacks[z](N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};C=je([qe(0,h.IExtHostRpcService),qe(1,a.IExtHostInitDataService),qe(2,w.IExtHostFileSystemInfo),qe(3,m.ILogService)],C),e.ExtHostWorkspace=C,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function l(F){let N,z;return F&&(typeof F=="string"?N=F:(N=F.pattern,z=F.baseFolder||d.URI.file(F.base))),{includePattern:N,folder:z}}}),define(ve[33],be([0,1,24,3,30,5,7,156,67,10,11,4,15,17,2]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(i,s){if(s){const o=s.split(".");let u=i;for(let _=0;u&&_<o.length;_++)u=u[o[_]];return u}}function c(i){return i instanceof r.URI}function p(i){return i&&i.uri instanceof r.URI&&i.languageId&&typeof i.languageId=="string"}function w(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function a(i){return i&&i.uri instanceof r.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function h(i){if(c(i))return{resource:i};if(p(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(w(i))return{overrideIdentifier:i.languageId};if(a(i))return{resource:i.uri};if(i===null)return{resource:null}}let f=class{constructor(s,o,u){this._proxy=s.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=u,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,o){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(s,o))}};f=je([qe(0,d.IExtHostRpcService),qe(1,S.IExtHostWorkspace),qe(2,g.ILogService)],f),e.ExtHostConfiguration=f;class t{constructor(s,o,u,_){this._onDidChangeConfiguration=new R.Emitter,this._proxy=s,this._logService=_,this._extHostWorkspace=o,this._configuration=D.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,o){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,u))}getConfiguration(s,o,u){const _=h(o)||{},b=this._toReadonlyValue(s?m(this._configuration.getValue(void 0,_,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,_,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,_,u==null?void 0:u.identifier);function A(l){if(l==null)return null;if(typeof l=="boolean")return l?1:4;switch(l){case E.ConfigurationTarget.Global:return 1;case E.ConfigurationTarget.Workspace:return 4;case E.ConfigurationTarget.WorkspaceFolder:return 5}}const C={has(l){return typeof m(b,l)!="undefined"},get:(l,F)=>{this._validateConfigurationAccess(s?`${s}.${l}`:l,_,u==null?void 0:u.identifier);let N=m(b,l);if(typeof N=="undefined")N=F;else{let z;const de=(he,$)=>{let q;const x=()=>{z=z||(0,v.deepClone)(b),q=q||m(z,$)};return(0,k.isObject)(he)?new Proxy(he,{get:(I,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return x(),()=>q;if(z)return q=q||m(z,$),q[H];const M=I[H];return typeof H=="string"?de(M,`${$}.${H}`):M},set:(I,H,M)=>(x(),q&&(q[H]=M),!0),deleteProperty:(I,H)=>(x(),q&&delete q[H],!0),defineProperty:(I,H,M)=>(x(),q&&Object.defineProperty(q,H,M),!0)}):he};N=de(N,l)}return N},update:(l,F,N,z)=>{l=s?`${s}.${l}`:l;const de=A(N);return F!==void 0?this._proxy.$updateConfigurationOption(de,l,F,_,z):this._proxy.$removeConfigurationOption(de,l,_,z)},inspect:l=>{var F,N,z,de,he,$,q,x;l=s?`${s}.${l}`:l;const I=(0,v.deepClone)(this._configuration.inspect(l,_,this._extHostWorkspace.workspace));if(I)return{key:l,defaultValue:(F=I.default)===null||F===void 0?void 0:F.value,globalValue:(N=I.user)===null||N===void 0?void 0:N.value,workspaceValue:(z=I.workspace)===null||z===void 0?void 0:z.value,workspaceFolderValue:(de=I.workspaceFolder)===null||de===void 0?void 0:de.value,defaultLanguageValue:(he=I.default)===null||he===void 0?void 0:he.override,globalLanguageValue:($=I.user)===null||$===void 0?void 0:$.override,workspaceLanguageValue:(q=I.workspace)===null||q===void 0?void 0:q.override,workspaceFolderLanguageValue:(x=I.workspaceFolder)===null||x===void 0?void 0:x.override,languageIds:I.overrideIdentifiers}}};return typeof b=="object"&&(0,v.mixin)(C,b,!1),Object.freeze(C)}_toReadonlyValue(s){const o=u=>(0,k.isObject)(u)?new Proxy(u,{get:(_,b)=>o(_[b]),set:(_,b,A)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(_,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(_,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:_=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return o(s)}_validateConfigurationAccess(s,o,u){const _=y.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),b=u?`[${u.value}] `:"";if(_===4){typeof(o==null?void 0:o.resource)=="undefined"&&this._logService.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(_===3){(o==null?void 0:o.resource)&&this._logService.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,o){const u=new D.ConfigurationChangeEvent(s,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(_,b)=>u.affectsConfiguration(_,h(b))})}_toMap(s){return s.reduce((o,u)=>(o.set(u[0],u[1]),o),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!S:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(J,v):S?S.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(ve[105],be([0,1,2,11,3,5,7,30,39,33,20,40,15,27,4,16,21,17,75,172,12]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r,m,c,p,w,a,h){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(he){function $(x){if(x!=null)return x}he.from=$;function q(x){if(x!=null)return x}he.to=q})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(he){function $(x){if(x!=null)return x}he.from=$;function q(x){if(x!=null)return x}he.to=q})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(he){function $(x){if(x!=null)return x}he.from=$;function q(x){if(x!=null)return x}he.to=q})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function(he){function $(I){if(I){const H=I;return H&&!!H.process}else return!1}he.is=$;function q(I){if(I==null)return;const H={process:I.process,args:I.args};return I.options&&(H.options=s.from(I.options)),H}he.from=q;function x(I){if(I!=null)return new E.ProcessExecution(I.process,I.args,I.options)}he.to=x})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(he){function $(x){if(x!=null)return x}he.from=$;function q(x){if(x!=null)return x}he.to=q})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var _;(function(he){function $(I){if(I){const H=I;return H&&(!!H.commandLine||!!H.command)}else return!1}he.is=$;function q(I){if(I==null)return;const H={};return I.commandLine!==void 0?H.commandLine=I.commandLine:(H.command=I.command,H.args=I.args),I.options&&(H.options=u.from(I.options)),H}he.from=q;function x(I){if(!(I==null||I.command===void 0&&I.commandLine===void 0))return I.commandLine?new E.ShellExecution(I.commandLine,I.options):new E.ShellExecution(I.command,I.args?I.args:[],I.options)}he.to=x})(_=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var b;(function(he){function $(I){if(I){let H=I;return H&&H.customExecution==="customExecution"}else return!1}he.is=$;function q(I){return{customExecution:"customExecution"}}he.from=q;function x(I,H){return H.get(I)}he.to=x})(b=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var A;(function(he){function $(q,x){let I;return q.scope!==void 0&&typeof q.scope!="number"?I=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===E.TaskScope.Workspace&&x&&x.workspaceFile?I=x.workspaceFile:I=a.USER_TASKS_GROUP_KEY),{id:q._id,workspaceFolder:I}}he.from=$})(A=e.TaskHandleDTO||(e.TaskHandleDTO={}));var C;(function(he){function $(I,H){if(I==null)return[];const M=[];for(let B of I){const G=q(B,H);G&&M.push(G)}return M}he.fromMany=$;function q(I,H){if(I==null)return;let M;I.execution instanceof E.ProcessExecution?M=o.from(I.execution):I.execution instanceof E.ShellExecution?M=_.from(I.execution):I.execution&&I.execution instanceof E.CustomExecution&&(M=b.from(I.execution));const B=t.from(I.definition);let G;if(I.scope?typeof I.scope=="number"?G=I.scope:G=I.scope.uri:G=E.TaskScope.Workspace,!B||!G)return;const K=I.group?I.group.id:void 0;return{_id:I._id,definition:B,name:I.name,source:{extensionId:H.identifier.value,label:I.source,scope:G},execution:M,isBackground:I.isBackground,group:K,presentationOptions:i.from(I.presentationOptions),problemMatchers:I.problemMatchers,hasDefinedMatchers:I.hasDefinedMatchers,runOptions:I.runOptions?I.runOptions:{reevaluateOnRerun:!0},detail:I.detail}}he.from=q;async function x(I,H,M){if(I==null)return;let B;o.is(I.execution)?B=o.to(I.execution):_.is(I.execution)?B=_.to(I.execution):b.is(I.execution)&&(B=b.to(I._id,M));const G=t.to(I.definition);let K;if(I.source&&(I.source.scope!==void 0?typeof I.source.scope=="number"?K=I.source.scope:K=await H.resolveWorkspaceFolder(v.URI.revive(I.source.scope)):K=E.TaskScope.Workspace),!G||!K)return;const se=new E.Task(G,K,I.name,I.source.label,B,I.problemMatchers);return I.isBackground!==void 0&&(se.isBackground=I.isBackground),I.group!==void 0&&(se.group=E.TaskGroup.from(I.group)),I.presentationOptions&&(se.presentationOptions=i.to(I.presentationOptions)),I._id&&(se._id=I._id),I.detail&&(se.detail=I.detail),se}he.to=x})(C=e.TaskDTO||(e.TaskDTO={}));var l;(function(he){function $(x){return x}he.from=$;function q(x){if(!!x)return Object.assign(Object.create(null),x)}he.to=q})(l=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor($,q,x){this._id=q,this._task=x,f.set(this,void 0),nt(this,f,$,"f")}get task(){return this._task}terminate(){Be(this,f,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}f=new WeakMap;var N;(function(he){function $(q){return{id:q._id,task:void 0}}he.from=$})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let z=class{constructor($,q,x,I,H,M,B,G){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=$.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=x,this._editorService=I,this._configurationService=H,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=B,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider($,q,x){if(!x)return new E.Disposable(()=>{});const I=this.nextHandle();return this._handlers.set(I,{type:q,provider:x,extension:$}),this._proxy.$registerTaskProvider(I,q),new E.Disposable(()=>{this._handlers.delete(I),this._proxy.$unregisterTaskProvider(I)})}registerTaskSystem($,q){this._proxy.$registerTaskSystem($,q)}fetchTasks($){return this._proxy.$fetchTasks(l.from($)).then(async q=>{const x=[];for(let I of q){const H=await C.to(I,this._workspaceProvider,this._providedCustomExecutions2);H&&x.push(H)}return x})}get taskExecutions(){const $=[];return this._taskExecutions.forEach(q=>$.push(q)),$}terminateTask($){if(!($ instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask($._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask($,q,x){const I=this._providedCustomExecutions2.get($.id);if(I){if(this._activeCustomExecutions2.get($.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set($.id,I),this._terminalService.attachPtyToTerminal(q,await I.callback(x))}this._lastStartedTask=$.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution($)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask($){const q=await this.getTaskExecution($);this._taskExecutionPromises.delete($.id),this._taskExecutions.delete($.id),this.customExecutionComplete($),this._onDidTerminateTask.fire({execution:q})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess($){const q=await this.getTaskExecution($.id);this._onDidTaskProcessStarted.fire({execution:q,processId:$.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess($){const q=await this.getTaskExecution($.id);this._onDidTaskProcessEnded.fire({execution:q,exitCode:$.exitCode})}$provideTasks($,q){const x=this._handlers.get($);if(!x)return Promise.reject(new Error("no handler found"));const I=[],H=(0,R.asPromise)(()=>x.provider.provideTasks(n.CancellationToken.None)).then(M=>this.provideTasksInternal(q,I,x,M));return new Promise(M=>{H.then(B=>{Promise.all(I).then(()=>{M(B)})})})}async $resolveTask($,q){const x=this._handlers.get($);if(!x)return Promise.reject(new Error("no handler found"));if(q.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${x.type}].`);const I=await C.to(q,this._workspaceProvider,this._providedCustomExecutions2);if(!I)throw new Error("Unexpected: Task cannot be resolved.");const H=await x.provider.resolveTask(I,n.CancellationToken.None);if(!H)return;this.checkDeprecation(H,x);const M=C.from(H,x.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==I.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(M.execution)&&await this.addCustomExecution(M,H,!0),await this.resolveTaskInternal(M)}nextHandle(){return this._handleCounter++}async addCustomExecution($,q,x){const I=await this._proxy.$createTaskId($);!x&&!this._providedCustomExecutions2.has(I)&&this._notProvidedCustomExecutions.add(I),this._providedCustomExecutions2.set(I,q.execution)}async getTaskExecution($,q){if(typeof $=="string"){const H=this._taskExecutionPromises.get($);if(!H)throw new Error("Unexpected: The specified task is missing an execution");return H}let x=this._taskExecutionPromises.get($.id);if(x)return x;const I=new Promise(async(H,M)=>{const B=q||await C.to($.task,this._workspaceProvider,this._providedCustomExecutions2);B?H(new F(this,$.id,B)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set($.id,I),I.then(H=>(this._taskExecutions.set($.id,H),H),H=>Promise.reject(H))}checkDeprecation($,q){$._deprecated&&this._deprecationService.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete($){this._activeCustomExecutions2.get($.id)&&this._activeCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.has($.id)&&this._lastStartedTask!==$.id&&(this._providedCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.delete($.id));let x=this._notProvidedCustomExecutions.values(),I=x.next();for(;!I.done;)!this._activeCustomExecutions2.has(I.value)&&this._lastStartedTask!==I.value&&(this._providedCustomExecutions2.delete(I.value),this._notProvidedCustomExecutions.delete(I.value)),I=x.next()}};z=je([qe(0,d.IExtHostRpcService),qe(1,g.IExtHostInitDataService),qe(2,D.IExtHostWorkspace),qe(3,y.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,P.IExtHostTerminalService),qe(6,p.ILogService),qe(7,w.IExtHostApiDeprecationService)],z),e.ExtHostTaskBase=z;let de=class extends z{constructor($,q,x,I,H,M,B,G){super($,q,x,I,H,M,B,G);this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:c.PlatformToString(0)})}async executeTask($,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const x=C.from(q,$);if(x===void 0)throw new Error("Task is not valid");if(b.is(x.execution))await this.addCustomExecution(x,q,!1);else throw new h.NotSupportedError;const I=await this.getTaskExecution(await this._proxy.$getTaskExecution(x),q);return this._proxy.$executeTask(x).catch(H=>{throw new Error(H)}),I}provideTasksInternal($,q,x,I){const H=[];if(I)for(let M of I){this.checkDeprecation(M,x),(!M.definition||!$[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const B=C.from(M,x.extension);B&&b.is(B.execution)?(H.push(B),q.push(this.addCustomExecution(B,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:H,extension:x.extension}}async resolveTaskInternal($){if(b.is($.execution))return $;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables($,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,q,x){}};de=je([qe(0,d.IExtHostRpcService),qe(1,g.IExtHostInitDataService),qe(2,D.IExtHostWorkspace),qe(3,y.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,P.IExtHostTerminalService),qe(6,p.ILogService),qe(7,w.IExtHostApiDeprecationService)],de),e.WorkerExtHostTask=de,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!S:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(J,v):S?S.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)},Kt=this&&this.__rest||function(J,e){var v={};for(var R in J)Object.prototype.hasOwnProperty.call(J,R)&&e.indexOf(R)<0&&(v[R]=J[R]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var S=0,R=Object.getOwnPropertySymbols(J);S<R.length;S++)e.indexOf(R[S])<0&&Object.prototype.propertyIsEnumerable.call(J,R[S])&&(v[R[S]]=J[R[S]]);return v};define(ve[219],be([0,1,13,11,23,20,3,54,43,6,24,10,2,37,5,39,15,70,9,7,30,182,97]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r,m,c,p,w,a,h,f,t){"use strict";var i,s,o,u;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const _=(x,I)=>`${x}:${I.toString()}`;let b=class{constructor(I,H,M){this.documents=H,this.workspace=M,this.resultsChangedEmitter=new E.Emitter,this.controllers=new Map,this.ownedTests=new f.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=I.getProxy(r.MainContext.MainThreadTesting),this.runQueue=new A(this.proxy),this.workspaceObservers=new $(this.proxy),this.textDocumentObservers=new q(this.proxy,H)}registerTestController(I,H){const M=(0,g.generateUuid)();this.controllers.set(M,{instance:H,extensionId:I}),this.proxy.$registerTestController(M);const B=[...this.testControllers.keys()];return setTimeout(()=>{var G;for(const K of B)(G=this.testControllers.get(K))===null||G===void 0||G.subscribeFn(M,H)},0),new a.Disposable(()=>{this.controllers.delete(M),this.proxy.$unregisterTestController(M)})}createTextDocumentTestObserver(I){return this.textDocumentObservers.checkout(I.uri)}createWorkspaceTestObserver(I){return this.workspaceObservers.checkout(I.uri)}async runTests(I,H=T.CancellationToken.None){const M=B=>B.map(this.getInternalTestForReference,this).filter(P.isDefined).map(G=>({src:G.src,testId:G.item.extId}));await this.proxy.$runTests({exclude:I.exclude?M(I.exclude).map(B=>B.testId):void 0,tests:M(I.tests),debug:I.debug},H)}createTestRun(I,H,M,B=!0){return this.runQueue.createTestRun(I,H,M,B)}$publishTestResults(I){this.results=Object.freeze(I.map(H=>(0,n.deepFreeze)(w.TestResults.to(H))).concat(this.results).sort((H,M)=>M.completedAt-H.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(I,H){const M=d.URI.revive(H),B=_(I,M);if(this.testControllers.has(B))return;const G=new T.CancellationTokenSource;let K;if(I===1){let Ne=this.documents.getDocument(M);if(!Ne){const ze=new k.DisposableStore;Ne=await new Promise(Ve=>{ze.add((0,R.disposableTimeout)(()=>Ve(void 0),5e3)),ze.add(this.documents.onDidAddDocuments(W=>{const Q=W.find(te=>te.document.uri.toString()===M.toString());Q&&Ve(Q)}))}).finally(()=>ze.dispose())}if(Ne){const ze=await this.workspace.getWorkspaceFolder2(M,!1);K=Ve=>Ve.createDocumentTestRoot?Ve.createDocumentTestRoot(Ne.document,G.token):(0,e.createDefaultDocumentTestRoot)(Ve,Ne.document,ze,G.token)}}else{const Ne=await this.workspace.getWorkspaceFolder2(M,!1);Ne&&(K=ze=>ze.createWorkspaceTestRoot(Ne,G.token))}if(!K)return;const se=async(Ne,ze)=>{try{const Ve=await K(ze);Ve&&Fe.addRoot(Ve,Ne)}catch(Ve){console.error(Ve)}},pe=new k.DisposableStore,Fe=pe.add(this.ownedTests.createForHierarchy(Ne=>this.proxy.$publishDiff(I,H,Ne)));pe.add((0,k.toDisposable)(()=>G.dispose(!0)));const We=[];for(const[Ne,ze]of this.controllers)We.push(se(Ne,ze.instance));Promise.all(We).then(()=>Fe.pushDiff([3,-1])),this.testControllers.set(B,{store:pe,collection:Fe,subscribeFn:se})}async $expandTest(I,H){const M=(0,v.mapFind)(this.testControllers.values(),B=>B.collection.treeId===I.src.tree?B:void 0);await(M==null?void 0:M.collection.expand(I.testId,H<0?Infinity:H)),this.flushCollectionDiffs()}$unsubscribeFromTests(I,H){var M;const B=d.URI.revive(H),G=_(I,B);(M=this.testControllers.get(G))===null||M===void 0||M.store.dispose(),this.testControllers.delete(G)}$acceptDiff(I,H,M){I===1?this.textDocumentObservers.acceptDiff(d.URI.revive(H),M):this.workspaceObservers.acceptDiff(d.URI.revive(H),M)}async $runTestsForProvider(I,H){const M=this.controllers.get(I.tests[0].src.controller);if(!M)return;const B=I.tests.map(({testId:se,src:pe})=>this.ownedTests.getTestById(se,pe==null?void 0:pe.tree)).filter(P.isDefined).map(([se,pe])=>pe),G=I.excludeExtIds.map(se=>this.ownedTests.getTestById(se)).filter(P.isDefined).filter(([se,pe])=>B.some(Fe=>se.comparePositions(Fe,pe)===1));if(!B.length)return;const K={tests:B.map(se=>N.unwrap(se.actual)),exclude:G.map(([,se])=>N.unwrap(se.actual)),debug:I.debug};await this.runQueue.enqueueRun({dto:C.fromInternal(I),token:H,extensionId:M.extensionId,req:K,doRun:()=>M.instance.runTests(K,H)})}$lookupTest(I){const H=this.ownedTests.getTestById(I.testId);if(!H)return Promise.resolve(void 0);const M=H[1],{actual:B,discoverCts:G,expandLevels:K}=M,se=Kt(M,["actual","discoverCts","expandLevels"]);return Promise.resolve(se)}flushCollectionDiffs(){for(const{collection:I}of this.testControllers.values())I.flushDiff()}getInternalTestForReference(I){var H,M;return(M=(H=this.workspaceObservers.getMirroredTestDataByReference(I))!==null&&H!==void 0?H:(0,v.mapFind)(this.testControllers.values(),B=>B.collection.getTestByReference(I)))!==null&&M!==void 0?M:this.textDocumentObservers.getMirroredTestDataByReference(I)}};b=je([qe(0,c.IExtHostRpcService),qe(1,m.IExtHostDocumentsAndEditors),qe(2,h.IExtHostWorkspace)],b),e.ExtHostTesting=b;class A{constructor(I){this.proxy=I,this.state=new Map}enqueueRun(I){let H=this.state.get(I.extensionId);H||(H={queue:[],current:void 0},this.state.set(I.extensionId,H));const M=new R.DeferredPromise,B=()=>{const G=[],K=new Set;H.current={publicReq:I.req,factory:se=>{const pe=new l(se,I.dto,K,this.proxy);return G.push(pe),I.token.onCancellationRequested(()=>pe.end()),pe}},this.invokeRunner(I.extensionId,I.dto.id,I.doRun,G).finally(()=>M.complete())};return H.queue.push(B),H.queue.length===1&&B(),M.p}createTestRun(I,H,M,B){var G,K;const se=this.state.get(I);if((se==null?void 0:se.current.publicReq)===H)return se.current.factory(M);const pe=C.fromPublic(H),Fe=new l(M,pe,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:H.debug,exclude:(K=(G=H.exclude)===null||G===void 0?void 0:G.map(We=>We.id))!==null&&K!==void 0?K:[],id:pe.id,tests:H.tests.map(We=>We.id),persist:B}),Fe.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(pe.id)),Fe}invokeRunner(I,H,M,B){try{const G=M();return(0,R.isThenable)(G)?G.then(()=>this.handleInvokeResult(I,H,B,void 0)).catch(K=>this.handleInvokeResult(I,H,B,K)):this.handleInvokeResult(I,H,B,void 0)}catch(G){return this.handleInvokeResult(I,H,B,G)}}async handleInvokeResult(I,H,M,B){const G=this.state.get(I);!G||(G.queue.shift(),G.queue.length>0?G.queue[0]():this.state.delete(I),await Promise.all(M.map(K=>K.onEnd.wait())))}}class C{constructor(I,H,M){this.id=I,this.include=H,this.exclude=M}static fromPublic(I){var H,M;return new C((0,g.generateUuid)(),new Set(I.tests.map(B=>B.id)),new Set((M=(H=I.exclude)===null||H===void 0?void 0:H.map(B=>B.id))!==null&&M!==void 0?M:y.Iterable.empty()))}static fromInternal(I){return new C(I.runId,new Set(I.tests.map(H=>H.testId)),new Set(I.excludeExtIds))}isIncluded(I){for(let H=I;H;H=H.parent){if(this.include.has(H.id))return!0;if(this.exclude.has(H.id))return!1}return!0}}class l{constructor(I,H,M,B){this.name=I,i.set(this,void 0),s.set(this,void 0),o.set(this,(0,g.generateUuid)()),u.set(this,void 0),this.onEnd=new R.Barrier,nt(this,i,B,"f"),nt(this,s,H,"f"),nt(this,u,M,"f"),B.$startedTestRunTask(H.id,{id:Be(this,o,"f"),name:I,running:!0})}setState(I,H,M){Be(this,s,"f").isIncluded(I)&&(this.ensureTestIsKnown(I),Be(this,i,"f").$updateTestStateInRun(Be(this,s,"f").id,Be(this,o,"f"),I.id,H,M))}appendMessage(I,H){Be(this,s,"f").isIncluded(I)&&(this.ensureTestIsKnown(I),Be(this,i,"f").$appendTestMessageInRun(Be(this,s,"f").id,Be(this,o,"f"),I.id,w.TestMessage.from(H)))}appendOutput(I){Be(this,i,"f").$appendOutputToRun(Be(this,s,"f").id,Be(this,o,"f"),S.VSBuffer.fromString(I))}end(){Be(this,i,"f").$finishedTestRunTask(Be(this,s,"f").id,Be(this,o,"f")),this.onEnd.open()}ensureTestIsKnown(I){const H=Be(this,u,"f");if(H.has(I.id))return;const M=[];for(;M.unshift(w.TestItem.from(I)),!(H.has(I.id)||(H.add(I.id),!I.parent));)I=I.parent;Be(this,i,"f").$addTestsToRun(Be(this,s,"f").id,M)}}i=new WeakMap,s=new WeakMap,o=new WeakMap,u=new WeakMap;const F=async(x,I,H,M)=>{if(!H)return;const B=await x.createWorkspaceTestRoot(H,M);if(!B)return;M.onCancellationRequested(()=>{N.removeFilter(I)});const G=N.getWrapperForTestItem(B,I);return G.refreshMatch(),G};e.createDefaultDocumentTestRoot=F;class N extends a.TestItemImpl{constructor(I,H,M){super(I.id,I.label,I.uri,void 0);if(this.actual=I,this.filterDocument=H,this.actualParent=M,!(I instanceof a.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${I.id} did not`);this.debuggable=I.debuggable,this.runnable=I.runnable,this.description=I.description,this.error=I.error,this.status=I.status,this.range=I.range,this.resolveHandler=I.resolveHandler;const B=(0,p.getPrivateApiFor)(this);(0,p.getPrivateApiFor)(I).bus.event(K=>{switch(K[0]){case 3:this[K[1]]=K[2];break;case 0:const se=N.getWrapperForTestItem(K[1],this.filterDocument,this);(0,p.getPrivateApiFor)(se).parent=I,se.refreshMatch();break;default:B.bus.fire(K)}})}static removeFilter(I){this.wrapperMap.delete(I)}static getWrapperForTestItem(I,H,M){let B=this.wrapperMap.get(H);if(B==null?void 0:B.has(I))return B.get(I);B||(B=new WeakMap,this.wrapperMap.set(H,B));const G=new N(I,H,M);return B.set(I,G),G}static unwrap(I){return I instanceof N?I.actual:I}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var I,H;const M=this._cachedMatchesFilter;for(const G of this.actual.children.values()){const K=N.getWrapperForTestItem(G,this.filterDocument,this);K.hasNodeMatchingFilter?this.children.has(K.id)||this.addChild(K):K.dispose()}const B=this.children.size>0||((I=this.actual.uri)===null||I===void 0?void 0:I.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=B,B!==M&&((H=this.actualParent)===null||H===void 0||H.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,p.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,p.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=N,N.wrapperMap=new WeakMap;class z extends t.IncrementalChangeCollector{constructor(I){super();this.emitter=I,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(I){this.added.add(I)}update(I){Object.assign(I.revived,w.TestItem.toPlain(I.item)),this.added.has(I)||this.updated.add(I)}remove(I){if(this.added.has(I)){this.added.delete(I);return}if(this.updated.delete(I),I.parent&&this.alreadyRemoved.has(I.parent)){this.alreadyRemoved.add(I.item.extId);return}this.removed.add(I)}getChangeEvent(){const{added:I,updated:H,removed:M}=this;return{get added(){return[...I].map(B=>B.revived)},get updated(){return[...H].map(B=>B.revived)},get removed(){return[...M].map(B=>B.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class de extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new E.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(I){let H=[];for(const M of I){const B=this.items.get(M);B&&H.push(B.revived)}return H}getMirroredTestDataById(I){return this.items.get(I)}getMirroredTestDataByReference(I){return this.items.get(I.id)}createItem(I,H){return Object.assign(Object.assign({},I),{revived:w.TestItem.toPlain(I.item),depth:H?H.depth+1:0,children:new Set})}createChangeCollector(){return new z(this.changeEmitter)}}e.MirroredTestCollection=de;class he{constructor(){this.resources=new Map}checkout(I){var H,M;const B=I.toString(),G=(H=this.resources.get(B))!==null&&H!==void 0?H:this.createObserverData(I);return(M=G.pendingDeletion)===null||M===void 0||M.dispose(),G.observers++,{onDidChangeTest:G.tests.onDidChangeTests,onDidDiscoverInitialTests:new E.Emitter().event,get tests(){return G.tests.rootTestItems},dispose:(0,D.once)(()=>{--G.observers||(G.pendingDeletion=this.eventuallyDispose(I))})}}getMirroredTestDataByReference(I){for(const{tests:H}of this.resources.values()){const M=H.getMirroredTestDataByReference(I);if(M)return M}}eventuallyDispose(I){return(0,R.disposableTimeout)(()=>this.unlisten(I),10*1e3)}createObserverData(I){const H=new de,M=this.listen(I,G=>H.apply(G)),B={observers:0,tests:H,listener:M};return this.resources.set(I.toString(),B),B}unlisten(I){var H;const M=I.toString(),B=this.resources.get(M);B&&(B.observers=-1,(H=B.pendingDeletion)===null||H===void 0||H.dispose(),B.listener.dispose(),this.resources.delete(M))}}class $ extends he{constructor(I){super();this.proxy=I,this.diffListeners=new Map}acceptDiff(I,H){var M;(M=this.diffListeners.get(I.toString()))===null||M===void 0||M(H)}listen(I,H){this.proxy.$subscribeToDiffs(0,I);const M=I.toString();return this.diffListeners.set(M,H),new a.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,I),this.diffListeners.delete(M)})}}class q extends he{constructor(I,H){super();this.proxy=I,this.documents=H,this.diffListeners=new Map}acceptDiff(I,H){var M;(M=this.diffListeners.get(I.toString()))===null||M===void 0||M(H)}listen(I,H){if(!this.documents.getDocument(I))return new a.Disposable(()=>{});const B=I.toString();return this.diffListeners.set(B,H),this.proxy.$subscribeToDiffs(1,I),new a.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,I),this.diffListeners.delete(B)})}}}),define(ve[220],be([0,1,13,52,28,59,22,16,14,25,8,10,2,118,141,92,48,175,218,41]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r,m,c,p,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(A,C,l,F){this.configurationService=A,this.workspaceContextService=C,this.editorGroupsService=l,this.pathService=F}text(A,C,l={}){A=this.getContentPattern(A,l);const F=this.configurationService.getValue(),N=C&&C.some(de=>!this.configurationService.getValue({resource:de}).search.useRipgrep),z=this.commonQuery(C==null?void 0:C.map(c.toWorkspaceFolder),l);return Object.assign(Object.assign({},z),{type:2,contentPattern:A,previewOptions:l.previewOptions,maxFileSize:l.maxFileSize,usePCRE2:F.search.usePCRE2||N||!1,beforeContext:l.beforeContext,afterContext:l.afterContext,userDisabledExcludesAndIgnoreFiles:l.disregardExcludeSettings&&l.disregardIgnoreFiles})}getContentPattern(A,C){const l=this.configurationService.getValue();A.isRegExp&&(A.pattern=A.pattern.replace(/\r?\n/g,"\\n"));const F=Object.assign(Object.assign({},A),{wordSeparators:l.editor.wordSeparators});return this.isCaseSensitive(A,C)&&(F.isCaseSensitive=!0),this.isMultiline(A)&&(F.isMultiline=!0),F}file(A,C={}){const l=this.commonQuery(A,C);return Object.assign(Object.assign({},l),{type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey})}handleIncludeExclude(A,C){return A?(A=Array.isArray(A)?A.map(o):o(A),C?this.parseSearchPaths(A):{pattern:t(...Array.isArray(A)?A:[A])}):{}}commonQuery(A=[],C={}){const l=this.handleIncludeExclude(C.includePattern,C.expandPatterns),F=this.handleIncludeExclude(C.excludePattern,C.expandPatterns),N=A.length>1,z=(l.searchPaths&&l.searchPaths.length?l.searchPaths.map($=>this.getFolderQueryForSearchPath($,C,F)):A.map($=>this.getFolderQueryForRoot($,C,F,N))).filter($=>!!$),de={_reason:C._reason,folderQueries:z,usingSearchPaths:!!(l.searchPaths&&l.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:F.pattern,includePattern:l.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const q=v.coalesce(v.flatten(this.editorGroupsService.groups.map(I=>I.editors.map(H=>H.resource)))).filter(I=>(0,a.pathIncludedInQuery)(de,I.fsPath)),x=this.commonQueryFromFileList(q);return Object.assign(Object.assign({},de),x)}const he=C.extraFileResources&&C.extraFileResources.filter($=>(0,a.pathIncludedInQuery)(de,$.fsPath));return de.extraFileResources=he&&he.length?he:void 0,de}commonQueryFromFileList(A){const C=[],l=new E.ResourceMap,F={};let N=!1;return A.forEach(z=>{var de,he;if(z.scheme===D.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(z)){const q=(he=(de=this.workspaceContextService.getWorkspaceFolder(z))===null||de===void 0?void 0:de.uri)!==null&&he!==void 0?he:z.with({path:y.dirname(z.fsPath)});let x=l.get(q);x||(N=!0,x={folder:q,includePattern:{}},C.push(x),l.set(q,x));const I=y.relative(q.fsPath,z.fsPath);(0,P.assertIsDefined)(x.includePattern)[I.replace(/\\/g,"/")]=!0}else z.fsPath&&(N=!0,F[z.fsPath]=!0)}),{folderQueries:C,includePattern:F,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(A,C){if(C.isSmartCase){if(A.isRegExp){if(n.containsUppercaseCharacter(A.pattern,!0))return!0}else if(n.containsUppercaseCharacter(A.pattern))return!0}return!!A.isCaseSensitive}isMultiline(A){return A.isMultiline||A.isRegExp&&(0,g.isMultilineRegexSource)(A.pattern)||A.pattern.indexOf(`
`)>=0?!0:!!A.isMultiline}parseSearchPaths(A){const C=x=>y.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),F=(Array.isArray(A)?A:i(A)).map(x=>{const I=this.pathService.resolvedUserHome;return I?(0,T.untildify)(x,I.scheme===D.Schemas.file?I.fsPath:I.path):x}),N=R.groupBy(F,x=>C(x)?"searchPaths":"exprSegments"),z=(N.exprSegments||[]).map(x=>n.rtrim(x,"/")).map(x=>n.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),s(x))),de={},he=this.expandSearchPathPatterns(N.searchPaths||[]);he&&he.length&&(de.searchPaths=he);const $=v.flatten(z),q=t(...$);return q&&(de.pattern=q),de}getExcludesForFolder(A,C){return C.disregardExcludeSettings?void 0:(0,a.getExcludes)(A,!C.disregardSearchExcludeSettings)}expandSearchPathPatterns(A){if(!A||!A.length)return[];const C=v.flatten(A.map(F=>{let{pathPortion:N,globPortion:z}=f(F);z&&(z=u(z));const de=this.expandOneSearchPath(N);return v.flatten(de.map(he=>this.resolveOneSearchPathPattern(he,z)))})),l=new Map;return C.forEach(F=>{const N=F.searchPath.toString(),z=l.get(N);z?F.pattern&&(z.pattern=z.pattern||{},z.pattern[F.pattern]=!0):l.set(N,{searchPath:F.searchPath,pattern:F.pattern?t(F.pattern):void 0})}),Array.from(l.values())}expandOneSearchPath(A){if(y.isAbsolute(A)){const C=this.workspaceContextService.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==D.Schemas.file?[{searchPath:C[0].uri.with({path:A})}]:[{searchPath:d.URI.file(y.normalize(A))}]}if(this.workspaceContextService.getWorkbenchState()===2){const C=this.workspaceContextService.getWorkspace().folders[0].uri;if(A=o(A),A.startsWith("../")||A===".."){const F=y.posix.resolve(C.path,A);return[{searchPath:C.with({path:F})}]}const l=u(A);return[{searchPath:C,pattern:l}]}else{if(A==="./"||A===".\\")return[];{const C=A.replace(/^\.[\/\\]/,""),F=this.workspaceContextService.getWorkspace().folders.map(N=>{const z=C.match(new RegExp(`^${N.name}(?:/(.*))?`));return z?{match:z,folder:N}:null}).filter(P.isDefined);if(F.length)return F.map(N=>{const z=N.match[1];return{searchPath:N.folder.uri,pattern:z&&u(z)}});{const N=A.match(/\.[\/\\](.+)[\/\\]?/),z=N?N[1]:A,de=r.localize(0,null,z);throw new Error(de)}}}}resolveOneSearchPathPattern(A,C){const l=A.pattern&&C?`${A.pattern}/${C}`:A.pattern||C,F=[{searchPath:A.searchPath,pattern:l}];return l&&!l.endsWith("**")&&F.push({searchPath:A.searchPath,pattern:l+"/**"}),F}getFolderQueryForSearchPath(A,C,l){const F=this.getFolderQueryForRoot((0,c.toWorkspaceFolder)(A.searchPath),C,l,!1);return F?Object.assign(Object.assign({},F),{includePattern:A.pattern}):null}getFolderQueryForRoot(A,C,l,F){let N;const z=d.URI.isUri(A)?A:A.uri;if(l.searchPaths){const x=l.searchPaths.filter(I=>(0,k.isEqual)(I.searchPath,z))[0];if(x&&!x.pattern)return null;x&&(N=x.pattern)}const de=this.configurationService.getValue({resource:z}),he=this.getExcludesForFolder(de,C),$=Object.assign(Object.assign({},he||{}),N||{}),q=d.URI.isUri(A)?(0,k.basename)(A):A.name;return{folder:z,folderName:F?q:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:de.files&&de.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!de.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!de.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!de.search.followSymlinks}}};h=je([qe(0,m.IConfigurationService),qe(1,c.IWorkspaceContextService),qe(2,p.IEditorGroupsService),qe(3,w.IPathService)],h),e.QueryBuilder=h;function f(b){const A=b.match(/[\*\{\}\(\)\[\]\?]/);if(A){const C=A.index,l=b.substr(0,C).match(/[/|\\][^/\\]*$/);if(l){let F=b.substr(0,l.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:b.substr((l.index||0)+1)}}}return{pathPortion:b}}function t(...b){return b.length?b.reduce((A,C)=>(A[C]=!0,A),Object.create(null)):void 0}function i(b){return S.splitGlobAware(b,",").map(A=>A.trim()).filter(A=>!!A.length)}function s(b){return[`**/${b}/**`,`**/${b}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function o(b){return b.replace(/\\/g,"/")}function u(b){return o(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function _(b,A){b=v.distinct(b,F=>F.toString());const C=[],l=A.getWorkspace();return b&&b.forEach(F=>{let N;if(A.getWorkbenchState()===2)N=(0,k.relativePath)(l.folders[0].uri,F),N&&N!=="."&&(N="./"+N);else{const z=A.getWorkspaceFolder(F);if(z){const de=z.name;if(l.folders.filter($=>$.name===de).length===1){const $=(0,k.relativePath)(z.uri,F);$===""?N=`./${z.name}`:N=`./${z.name}/${$}`}else N=F.fsPath}}N&&C.push(N)}),C}e.resolveResourcesForSearchIncludes=_}),define(ve[221],be([0,1,25,2,20,12,4,220,41,48]),function(J,e,v,R,S,T,E,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function P(m,c){const p=c.activationEvents;if(!p)return Promise.resolve(void 0);const w=[],a=[];for(const o of p)if(/^workspaceContains:/.test(o)){const u=o.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||m.forceUsingSearch?a.push(u):w.push(u)}if(w.length===0&&a.length===0)return Promise.resolve(void 0);let h;const f=new Promise((o,u)=>{h=o}),t=o=>h({activationEvent:o}),i=Promise.all(w.map(o=>d(m,o,t))).then(()=>{}),s=g(m,c.identifier,a,t);return Promise.all([i,s]).then(()=>{h(void 0)}),f}e.checkActivateWorkspaceContainsExtension=P;async function d(m,c,p){for(const w of m.folders)if(await m.exists(v.joinPath(R.URI.revive(w),c))){p(`workspaceContains:${c}`);return}}async function g(m,c,p,w){if(p.length===0)return Promise.resolve(void 0);const a=new S.CancellationTokenSource,h=m.checkExists(m.folders,p,a.token),f=setTimeout(async()=>{a.cancel(),w(`workspaceContainsTimeout:${p.join(",")}`)},n);let t=!1;try{t=await h}catch(i){T.isPromiseCanceledError(i)||T.onUnexpectedError(i)}a.dispose(),clearTimeout(f),t&&w(`workspaceContains:${p.join(",")}`)}function r(m,c,p,w){const a=m.get(E.IInstantiationService),h=m.get(y.ISearchService),t=a.createInstance(D.QueryBuilder).file(c.map(i=>(0,k.toWorkspaceFolder)(R.URI.revive(i))),{_reason:"checkExists",includePattern:p,exists:!0});return h.fileSearch(t,w).then(i=>!!i.limitHit,i=>T.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=r});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,S){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!S:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?S.call(J,v):S?S.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(ve[34],be([0,1,133,14,80,25,11,6,22,2,17,5,33,185,78,30,32,183,12,26,23,162,7,93,4,27,79,15,66,71,40,3,221,74,163]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r,m,c,p,w,a,h,f,t,i,s,o,u,_,b,A,C,l,F,N,z){"use strict";var de,he,$;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let q=class On extends D.Disposable{constructor(M,B,G,K,se,pe,Fe,We,Ne,ze){super();this._onDidChangeRemoteConnectionData=this._register(new l.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=B,this._extHostContext=G,this._initData=Fe,this._extHostWorkspace=K,this._extHostConfiguration=se,this._logService=pe,this._extHostTunnelService=Ne,this._extHostTerminalService=ze,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new E.Barrier,this._readyToStartExtensionHost=new E.Barrier,this._readyToRunExtensions=new E.Barrier,this._eagerExtensionsActivated=new E.Barrier,this._registry=new p.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=We,this._instaService=M.createChild(new b.ServiceCollection([r.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]));const Ve=new Set;this._initData.hostExtensions.forEach(W=>Ve.add(a.ExtensionIdentifier.toKey(W))),this._activator=new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(W,Q,te)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(W,w.transformErrorForSerialization(Q),te)},actualActivateExtension:async(W,Q)=>{if(Ve.has(a.ExtensionIdentifier.toKey(W)))return await this._mainThreadExtensionsProxy.$activateExtension(W,Q),new g.HostExtension;const te=this._registry.getExtensionDescription(W);return this._activateExtension(te,Q)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){w.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(se=>se.identifier).filter(se=>this.isActivated(se)).map(se=>this._deactivate(se))}catch(B){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,B){return this._activator.activateByEvent(M,B)}_activateById(M,B){return this._activator.activateById(M,B)}activateByIdWithErrors(M,B){return this._activateById(M,B).then(()=>{const G=this._activator.getActivatedExtension(M);if(G.activationFailed)return Promise.reject(G.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=y.TernarySearchTree.forPaths(),B=this._registry.getAllExtensionDescriptions().map(G=>{if(!!this._getEntryPoint(G))return this._hostUtils.realpath(G.extensionLocation.fsPath).then(K=>M.set(k.URI.file(K).fsPath,G))});this._extensionPathIndex=Promise.all(B).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let B=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return B;const G=this._activator.getActivatedExtension(M);if(!G)return B;try{typeof G.module.deactivate=="function"&&(B=Promise.resolve(G.module.deactivate()).then(void 0,K=>(this._logService.error(K),Promise.resolve(void 0))))}catch(K){this._logService.error(K)}try{(0,D.dispose)(G.subscriptions)}catch(K){this._logService.error(K)}return B}async _activateExtension(M,B){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,B).then(G=>{const K=G.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,K.codeLoadingTime,K.activateCallTime,K.activateResolvedTime,B),this._logExtensionActivationTimes(M,B,"success",K),G},G=>{throw this._logExtensionActivationTimes(M,B,"failure"),G})}_logExtensionActivationTimes(M,B,G,K){const se=x(M,B);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},se),K||{}),{outcome:G}))}_doActivateExtension(M,B){const G=x(M,B);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",G);const K=this._getEntryPoint(M);if(!K)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(B)}`),this._logService.flush();const se=new g.ExtensionActivationTimesBuilder(B.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,T.joinPath)(M.extensionLocation,K),se),this._loadExtensionContext(M)]).then(pe=>(S.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),On._callActivate(this._logService,M.identifier,pe[0],pe[1],se))).then(pe=>(S.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),pe))}_loadExtensionContext(M){const B=new f.ExtensionGlobalMemento(M,this._storage),G=new f.ExtensionMemento(M.identifier.value,!1,this._storage),K=new z.ExtensionSecrets(M,this._secretState),se=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,pe=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([B.whenReady,G.whenReady,this._storagePath.whenReady]).then(()=>{const Fe=this;let We;return Object.freeze({globalState:B,workspaceState:G,secrets:K,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Ne){return R.join(M.extensionLocation.fsPath,Ne)},get storagePath(){var Ne;return(Ne=Fe._storagePath.workspaceValue(M))===null||Ne===void 0?void 0:Ne.fsPath},get globalStoragePath(){return Fe._storagePath.globalValue(M).fsPath},get logPath(){return R.join(Fe._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return k.URI.joinPath(Fe._initData.logsLocation,M.identifier.value)},get storageUri(){return Fe._storagePath.workspaceValue(M)},get globalStorageUri(){return Fe._storagePath.globalValue(M)},get extensionMode(){return se},get extension(){return We===void 0&&(We=new I(Fe,M.identifier,M,pe)),We},get extensionRuntime(){return(0,c.checkProposedApiEnabled)(M),Fe.extensionRuntime},get environmentVariableCollection(){return Fe._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,B,G,K,se){return G=G||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,B,G,K,se).then(pe=>new g.ActivatedExtension(!1,null,se.build(),G,pe,K.subscriptions))}static _callActivateOptional(M,B,G,K,se){if(typeof G.activate=="function")try{se.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${B.value}`);const pe=typeof global=="object"?global:self,Fe=G.activate.apply(pe,[K]);return se.activateCallStop(),se.activateResolveStart(),Promise.resolve(Fe).then(We=>(se.activateResolveStop(),We))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(G)}_activateOneStartupFinished(M,B){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:B}).then(void 0,G=>{this._logService.error(G)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const B of M.activationEvents)B==="onStartupFinished"&&this._activateOneStartupFinished(M,B)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,se=>{this._logService.error(se)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(se=>this._handleWorkspaceContainsEagerExtensions(se.added)));const B=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],G=this._handleWorkspaceContainsEagerExtensions(B),K=Promise.all([M,G]).then(()=>{});return Promise.race([K,(0,E.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),K}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(B=>this._handleWorkspaceContainsEagerExtension(M,B))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,B){if(this.isActivated(B.identifier))return;const G=!this._initData.remote.isRemote&&!!this._initData.remote.authority,K={folders:M.map(pe=>pe.uri),forceUsingSearch:G,exists:pe=>this._hostUtils.exists(pe.fsPath),checkExists:(pe,Fe,We)=>this._mainThreadWorkspaceProxy.$checkExists(pe,Fe,We)},se=await(0,F.checkActivateWorkspaceContainsExtension)(K,B);if(!!se)return this._activateById(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:se.activationEvent}).then(void 0,pe=>this._logService.error(pe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:B}=this._initData.environment;if(!M||!B)throw new Error(v.localize(0,null));const G=await this._loadCommonJSModule(null,B,new g.ExtensionActivationTimesBuilder(!1));if(!G||typeof G.run!="function")throw new Error(v.localize(1,null,B.toString()));return new Promise((K,se)=>{const pe=(Ne,ze)=>{Ne?se(Ne):K(typeof ze=="number"&&ze>0?1:0)},Fe=(0,T.originalFSPath)(B),We=G.run(Fe,pe);We&&We.then&&We.then(()=>{K(0)}).catch(Ne=>{se(Ne.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,B){return this._resolvers[M]=B,(0,D.toDisposable)(()=>{delete this._resolvers[M]})}async _activateAndGetResolver(M){const B=M.indexOf("+");if(B===-1)throw new Error("Not an authority that can be resolved!");const G=M.substr(0,B);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${G}`,!1),{authorityPrefix:G,resolver:this._resolvers[G]}}async $resolveAuthority(M,B){const{authorityPrefix:G,resolver:K}=await this._activateAndGetResolver(M);if(!K)return{type:"error",error:{code:i.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${G}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(K)),S.mark(`code/extHost/willResolveAuthority/${G}`);const se=await K.resolve(M,{resolveAttempt:B});S.mark(`code/extHost/didResolveAuthorityOK/${G}`);const pe={authority:M,host:se.host,port:se.port,connectionToken:se.connectionToken},Fe={extensionHostEnv:se.extensionHostEnv,isTrusted:se.isTrusted};return{type:"ok",value:{authority:pe,options:Fe,tunnelInformation:{environmentTunnels:se.environmentTunnels}}}}catch(se){if(S.mark(`code/extHost/didResolveAuthorityError/${G}`),se instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:se._code,message:se._message,detail:se._detail}};throw se}}async $getCanonicalURI(M,B){const{authorityPrefix:G,resolver:K}=await this._activateAndGetResolver(M);if(!K)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${G}`);const se=k.URI.revive(B);if(typeof K.getCanonicalURI=="undefined")return se;const pe=await(0,E.asPromise)(()=>K.getCanonicalURI(se));return pe||se}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,B){return B===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(G=>this._activateByEvent(M,!1))}async $activate(M,B){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,B),!0):!1}async $deltaExtensions(M,B){M.forEach(K=>K.extensionLocation=k.URI.revive(K.extensionLocation));const G=await this.getExtensionPathIndex();return await Promise.all(B.map(async K=>{const se=this._registry.getExtensionDescription(K);if(!se)return;const pe=await this._hostUtils.realpath(se.extensionLocation.fsPath);G.delete(k.URI.file(pe).fsPath)})),await Promise.all(M.map(async K=>{const se=await this._hostUtils.realpath(K.extensionLocation.fsPath);G.set(k.URI.file(se).fsPath,K)})),this._registry.deltaExtensions(M,B),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let B=h.VSBuffer.alloc(M),G=Math.random()%256;for(let K=0;K<M;K++)B.writeUInt8(G,K);return B}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};q=je([qe(0,s.IInstantiationService),qe(1,e.IHostUtils),qe(2,_.IExtHostRpcService),qe(3,m.IExtHostWorkspace),qe(4,d.IExtHostConfiguration),qe(5,n.ILogService),qe(6,o.IExtHostInitDataService),qe(7,u.IExtensionStoragePaths),qe(8,A.IExtHostTunnelService),qe(9,C.IExtHostTerminalService)],q),e.AbstractExtHostExtensionService=q;function x(H,M){return{id:H.identifier.value,name:H.name,extensionVersion:H.version,publisherDisplayName:H.publisher,activationEvents:H.activationEvents?H.activationEvents.join(","):null,isBuiltin:H.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class I{constructor(M,B,G,K){de.set(this,void 0),he.set(this,void 0),$.set(this,void 0),nt(this,de,M,"f"),nt(this,he,B,"f"),nt(this,$,G.identifier,"f"),this.id=G.identifier.value,this.extensionUri=G.extensionLocation,this.extensionPath=R.normalize((0,T.originalFSPath)(G.extensionLocation)),this.packageJSON=G,this.extensionKind=K}get isActive(){return Be(this,de,"f").isActivated(Be(this,$,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,de,"f").getExtensionExports(Be(this,$,"f"))}activate(){return Be(this,de,"f").activateByIdWithErrors(Be(this,$,"f"),{startup:!1,extensionId:Be(this,he,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=I,de=new WeakMap,he=new WeakMap,$=new WeakMap}),define(ve[106],be([0,1,14,2,3,11,5,7,170,30,34,39,174,33,171,15,4,10,46,69]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r,m,c,p,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,c.createDecorator)("IExtHostDebugService");let h=class{constructor(b,A,C,l,F,N){this._workspaceService=A,this._extensionService=C,this._editorsService=l,this._configurationService=F,this._editorTabs=N,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new S.Emitter,this._onDidTerminateDebugSession=new S.Emitter,this._onDidChangeActiveDebugSession=new S.Emitter,this._onDidReceiveDebugSessionCustomEvent=new S.Emitter,this._debugServiceProxy=b.getProxy(E.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new S.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(z=>{z.onDidChange(de=>{this.registerAllDebugTypes(z)}),this.registerAllDebugTypes(z)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(b,A){const C=b;if(typeof C.sourceReference=="number"&&C.sourceReference>0){let l=`debug:${encodeURIComponent(C.path||"")}`,F="?";return A&&(l+=`${F}session=${encodeURIComponent(A.id)}`,F="&"),l+=`${F}ref=${C.sourceReference}`,R.URI.parse(l)}else{if(C.path)return R.URI.file(C.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(b){const A=[];for(const C of b.getAllExtensionDescriptions())if(C.contributes){const l=C.contributes.debuggers;if(l&&l.length>0)for(const F of l)(0,r.isDebuggerMainContribution)(F)&&A.push(F.type)}this._debugServiceProxy.$registerDebugTypes(A)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const b=[];return this._breakpoints.forEach(A=>b.push(A)),b}addBreakpoints(b){this.startBreakpoints();const A=b.filter(F=>{const N=F.id;return this._breakpoints.has(N)?!1:(this._breakpoints.set(N,F),!0)});this.fireBreakpointChanges(A,[],[]);const C=[],l=new Map;for(const F of A)if(F instanceof D.SourceBreakpoint){let N=l.get(F.location.uri.toString());N||(N={type:"sourceMulti",uri:F.location.uri,lines:[]},l.set(F.location.uri.toString(),N),C.push(N)),N.lines.push({id:F.id,enabled:F.enabled,condition:F.condition,hitCondition:F.hitCondition,logMessage:F.logMessage,line:F.location.range.start.line,character:F.location.range.start.character})}else F instanceof D.FunctionBreakpoint&&C.push({type:"function",id:F.id,enabled:F.enabled,hitCondition:F.hitCondition,logMessage:F.logMessage,condition:F.condition,functionName:F.functionName});return this._debugServiceProxy.$registerBreakpoints(C)}removeBreakpoints(b){this.startBreakpoints();const A=b.filter(N=>this._breakpoints.delete(N.id));this.fireBreakpointChanges([],A,[]);const C=A.filter(N=>N instanceof D.SourceBreakpoint).map(N=>N.id),l=A.filter(N=>N instanceof D.FunctionBreakpoint).map(N=>N.id),F=A.filter(N=>N instanceof D.DataBreakpoint).map(N=>N.id);return this._debugServiceProxy.$unregisterBreakpoints(C,l,F)}startDebugging(b,A,C){return this._debugServiceProxy.$startDebugging(b?b.uri:void 0,A,{parentSessionID:C.parentSession?C.parentSession.id:void 0,repl:C.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:C.noDebug,compact:C.compact})}stopDebugging(b){return this._debugServiceProxy.$stopDebugging(b?b.id:void 0)}registerDebugConfigurationProvider(b,A,C){if(!A)return new D.Disposable(()=>{});const l=this._configProviderHandleCounter++;return this._configProviders.push({type:b,handle:l,provider:A}),this._debugServiceProxy.$registerDebugConfigurationProvider(b,C,!!A.provideDebugConfigurations,!!A.resolveDebugConfiguration,!!A.resolveDebugConfigurationWithSubstitutedVariables,l),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(F=>F.provider!==A),this._debugServiceProxy.$unregisterDebugConfigurationProvider(l)})}registerDebugAdapterDescriptorFactory(b,A,C){if(!C)return new D.Disposable(()=>{});if(!this.definesDebugType(b,A))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${A}' debugger.`);if(this.getAdapterDescriptorFactoryByType(A))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const l=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:A,handle:l,factory:C}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(A,l),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(F=>F.factory!==C),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(l)})}registerDebugAdapterTrackerFactory(b,A){if(!A)return new D.Disposable(()=>{});const C=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:b,handle:C,factory:A}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(l=>l.factory!==A)})}async $runInTerminal(b,A){return Promise.resolve(void 0)}async $substituteVariables(b,A){if(!this._variableResolver){const[F,N]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(F||[],this._editorsService,N)}let C;const l=await this.getFolder(b);return l&&(C={uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(C,A)}createDebugAdapter(b,A){if(b.type==="implementation")return new o(b.implementation)}createSignService(){}async $startDASession(b,A){const C=this,l=await this.getSession(A);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(l.type),l).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}' (extension might have failed to activate)`);const N=this.convertToDto(F),z=this.createDebugAdapter(N,l);if(!z)throw new Error(`Couldn't create a debug adapter for type '${l.type}'.`);const de=z;return this._debugAdapters.set(b,de),this.getDebugAdapterTrackers(l).then(he=>(he&&this._debugAdaptersTrackers.set(b,he),de.onMessage(async $=>{if($.type==="request"&&$.command==="handshake"){const q=$,x={type:"response",seq:0,command:q.command,request_seq:q.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const I=await this._signService.sign(q.arguments.value);x.body={signature:I},de.sendResponse(x)}else throw new Error("no signer")}catch(I){x.success=!1,x.message=I.message,de.sendResponse(x)}}else he&&he.onDidSendMessage&&he.onDidSendMessage($),$=(0,r.convertToVSCPaths)($,!0),C._debugServiceProxy.$acceptDAMessage(b,$)}),de.onError($=>{he&&he.onError&&he.onError($),this._debugServiceProxy.$acceptDAError(b,$.name,$.message,$.stack)}),de.onExit($=>{he&&he.onExit&&he.onExit((0,p.withNullAsUndefined)($),void 0),this._debugServiceProxy.$acceptDAExit(b,(0,p.withNullAsUndefined)($),void 0)}),he&&he.onWillStartSession&&he.onWillStartSession(),de.startSession()))})}$sendDAMessage(b,A){A=(0,r.convertToDAPaths)(A,!1);const C=this._debugAdaptersTrackers.get(b);C&&C.onWillReceiveMessage&&C.onWillReceiveMessage(A);const l=this._debugAdapters.get(b);l&&l.sendMessage(A)}$stopDASession(b){const A=this._debugAdaptersTrackers.get(b);this._debugAdaptersTrackers.delete(b),A&&A.onWillStopSession&&A.onWillStopSession();const C=this._debugAdapters.get(b);return this._debugAdapters.delete(b),C?C.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(b){const A=[],C=[],l=[];if(b.added)for(const F of b.added){const N=F.id;if(N&&!this._breakpoints.has(N)){let z;if(F.type==="function")z=new D.FunctionBreakpoint(F.functionName,F.enabled,F.condition,F.hitCondition,F.logMessage);else if(F.type==="data")z=new D.DataBreakpoint(F.label,F.dataId,F.canPersist,F.enabled,F.hitCondition,F.condition,F.logMessage);else{const de=R.URI.revive(F.uri);z=new D.SourceBreakpoint(new D.Location(de,new D.Position(F.line,F.character)),F.enabled,F.condition,F.hitCondition,F.logMessage)}z._id=N,this._breakpoints.set(N,z),A.push(z)}}if(b.removed)for(const F of b.removed){const N=this._breakpoints.get(F);N&&(this._breakpoints.delete(F),C.push(N))}if(b.changed){for(const F of b.changed)if(F.id){const N=this._breakpoints.get(F.id);if(N){if(N instanceof D.FunctionBreakpoint&&F.type==="function"){const z=N;z.enabled=F.enabled,z.condition=F.condition,z.hitCondition=F.hitCondition,z.logMessage=F.logMessage,z.functionName=F.functionName}else if(N instanceof D.SourceBreakpoint&&F.type==="source"){const z=N;z.enabled=F.enabled,z.condition=F.condition,z.hitCondition=F.hitCondition,z.logMessage=F.logMessage,z.location=new D.Location(R.URI.revive(F.uri),new D.Position(F.line,F.character))}l.push(N)}}}this.fireBreakpointChanges(A,C,l)}$provideDebugConfigurations(b,A,C){return(0,T.asPromise)(async()=>{const l=this.getConfigProviderByHandle(b);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const F=await this.getFolder(A);return l.provideDebugConfigurations(F,C)}).then(l=>{if(!l)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return l})}$resolveDebugConfiguration(b,A,C,l){return(0,T.asPromise)(async()=>{const F=this.getConfigProviderByHandle(b);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const N=await this.getFolder(A);return F.resolveDebugConfiguration(N,C,l)})}$resolveDebugConfigurationWithSubstitutedVariables(b,A,C,l){return(0,T.asPromise)(async()=>{const F=this.getConfigProviderByHandle(b);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const N=await this.getFolder(A);return F.resolveDebugConfigurationWithSubstitutedVariables(N,C,l)})}async $provideDebugAdapter(b,A){const C=this.getAdapterDescriptorFactoryByHandle(b);if(!C)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const l=await this.getSession(A);return this.getAdapterDescriptor(C,l).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}'`);return this.convertToDto(F)})}async $acceptDebugSessionStarted(b){const A=await this.getSession(b);this._onDidStartDebugSession.fire(A)}async $acceptDebugSessionTerminated(b){const A=await this.getSession(b);A&&(this._onDidTerminateDebugSession.fire(A),this._debugSessions.delete(A.id))}async $acceptDebugSessionActiveChanged(b){this._activeDebugSession=b?await this.getSession(b):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(b,A){const C=await this.getSession(b);C&&C._acceptNameChanged(A)}async $acceptDebugSessionCustomEvent(b,A){const l={session:await this.getSession(b),event:A.event,body:A.body};this._onDidReceiveDebugSessionCustomEvent.fire(l)}convertToDto(b){if(b instanceof D.DebugAdapterExecutable)return{type:"executable",command:b.command,args:b.args,options:b.options};if(b instanceof D.DebugAdapterServer)return{type:"server",port:b.port,host:b.host};if(b instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:b.path};if(b instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:b.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(b){const A=this._adapterFactories.filter(C=>C.type===b);if(A.length>0)return A[0].factory}getAdapterDescriptorFactoryByHandle(b){const A=this._adapterFactories.filter(C=>C.handle===b);if(A.length>0)return A[0].factory}getConfigProviderByHandle(b){const A=this._configProviders.filter(C=>C.handle===b);if(A.length>0)return A[0].provider}definesDebugType(b,A){if(b.contributes){const C=b.contributes.debuggers;if(C&&C.length>0){for(const l of C)if(l.label&&l.type&&l.type===A)return!0}}return!1}getDebugAdapterTrackers(b){const C=b.configuration.type,l=this._trackerFactories.filter(F=>F.type===C||F.type==="*").map(F=>(0,T.asPromise)(()=>F.factory.createDebugAdapterTracker(b)).then(N=>N,N=>null));return Promise.race([Promise.all(l).then(F=>{const N=F.filter(z=>!!z);if(N.length>0)return new s(N)}),new Promise((F,N)=>{const z=setTimeout(()=>{clearTimeout(z),N(new Error("timeout"))},1e3)})]).catch(F=>{})}async getAdapterDescriptor(b,A){const C=A.configuration.debugServer;if(typeof C=="number")return Promise.resolve(new D.DebugAdapterServer(C));if(b){const F=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>b.createDebugAdapterDescriptor(A,this.daExecutableFromPackage(A,F))).then(N=>{if(N)return N})}const l=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(A,l))}daExecutableFromPackage(b,A){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(b,A,C){(b.length>0||A.length>0||C.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:b,removed:A,changed:C}))}async getSession(b){if(b)if(typeof b=="string"){const A=this._debugSessions.get(b);if(A)return A}else{let A=this._debugSessions.get(b.id);if(!A){const C=await this.getFolder(b.folderUri),l=b.parent?this._debugSessions.get(b.parent):void 0;A=new f(this._debugServiceProxy,b.id,b.type,b.name,C,b.configuration,l),this._debugSessions.set(A.id,A),this._debugServiceProxy.$sessionCached(A.id)}return A}throw new Error("cannot find session")}getFolder(b){if(b){const A=R.URI.revive(b);return this._workspaceService.resolveWorkspaceFolder(A)}return Promise.resolve(void 0)}};h=je([qe(0,m.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,n.IExtHostExtensionService),qe(3,P.IExtHostDocumentsAndEditors),qe(4,g.IExtHostConfiguration),qe(5,a.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class f{constructor(b,A,C,l,F,N,z){this._debugServiceProxy=b,this._id=A,this._type=C,this._name=l,this._workspaceFolder=F,this._configuration=N,this._parentSession=z}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(b){this._name=b,this._debugServiceProxy.$setDebugSessionName(this._id,b)}get parentSession(){return this._parentSession}_acceptNameChanged(b){this._name=b}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(b,A){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,b,A)}getDebugProtocolBreakpoint(b){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,b.id)}}e.ExtHostDebugSession=f;class t{constructor(b){this.value=Object.freeze({append(A){b.$appendDebugConsole(A)},appendLine(A){this.append(A+`
`)}})}}e.ExtHostDebugConsole=t;class i extends d.AbstractVariableResolverService{constructor(b,A,C,l,F){function N(){if(A){const z=A.activeEditor();if(z)return z.document.uri;const de=l.tabs.filter(he=>he.isActive);if(de.length>0)return de[0].resource}}super({getFolderUri:z=>{const de=b.filter(he=>he.name===z);if(de&&de.length>0)return de[0].uri},getWorkspaceFolderCount:()=>b.length,getConfigurationValue:(z,de)=>C.getConfiguration(void 0,z).get(de),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{const z=N();if(z)return v.normalize(z.fsPath)},getWorkspaceFolderPathForFile:()=>{if(F){const z=N();if(z){const de=F.getWorkspaceFolder(z);if(de)return v.normalize(de.uri.fsPath)}}},getSelectedText:()=>{if(A){const z=A.activeEditor();if(z&&!z.selection.isEmpty)return z.document.getText(z.selection)}},getLineNumber:()=>{if(A){const z=A.activeEditor();if(z)return String(z.selection.end.line+1)}}},void 0,Promise.resolve(w.env))}}e.ExtHostVariableResolverService=i;class s{constructor(b){this.trackers=b}onWillStartSession(){this.trackers.forEach(b=>b.onWillStartSession?b.onWillStartSession():void 0)}onWillReceiveMessage(b){this.trackers.forEach(A=>A.onWillReceiveMessage?A.onWillReceiveMessage(b):void 0)}onDidSendMessage(b){this.trackers.forEach(A=>A.onDidSendMessage?A.onDidSendMessage(b):void 0)}onWillStopSession(){this.trackers.forEach(b=>b.onWillStopSession?b.onWillStopSession():void 0)}onError(b){this.trackers.forEach(A=>A.onError?A.onError(b):void 0)}onExit(b,A){this.trackers.forEach(C=>C.onExit?C.onExit(b,A):void 0)}}class o extends y.AbstractDebugAdapter{constructor(b){super();this.implementation=b,b.onDidSendMessage(A=>{this.acceptMessage(A)})}startSession(){return Promise.resolve(void 0)}sendMessage(b){this.implementation.handleMessage(b)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends h{constructor(b,A,C,l,F,N){super(b,A,C,l,F,N)}createVariableResolver(b,A,C){return new i(b,A,C,this._editorTabs)}};u=je([qe(0,m.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,n.IExtHostExtensionService),qe(3,P.IExtHostDocumentsAndEditors),qe(4,g.IExtHostConfiguration),qe(5,a.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(ve[222],be([0,1,80,2,5,33,32,26,15,27,4,34,46,17]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(a,h,f,t,i,s,o){this._apiFactory=a,this._extensionRegistry=h,this._instaService=f,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=s,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),v.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new m(this._apiFactory,h,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(c)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(p,h,this._initData.environment.appUriScheme))}register(a){if(Array.isArray(a.nodeModuleName))for(let h of a.nodeModuleName)this._factories.set(h,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(h=>a.alternativeModuleName(h))}};r=je([qe(2,n.IInstantiationService),qe(3,T.IExtHostConfiguration),qe(4,P.IExtHostExtensionService),qe(5,k.IExtHostInitDataService),qe(6,g.ILogService)],r),e.RequireInterceptor=r;class m{constructor(a,h,f,t,i){this._apiFactory=a,this._extensionPaths=h,this._extensionRegistry=f,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(a,h){const f=this._extensionPaths.findSubstr(h.fsPath);if(f){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(f.identifier));return t||(t=this._apiFactory(f,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(f.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,s)=>t+=`	${s} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(E.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let c=class{constructor(a,h){this.nodeModuleName="keytar";const{environment:f}=h,t=a.getProxy(S.MainContext.MainThreadKeytar);if(f.appRoot){let i=f.appRoot.fsPath;d.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,s)=>t.$getPassword(i,s),setPassword:(i,s,o)=>t.$setPassword(i,s,o),deletePassword:(i,s)=>t.$deletePassword(i,s),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(a,h){return this._impl}alternativeModuleName(a){const h=a.length;if(h<=7||!this.alternativeNames)return;const f=h-7;if((a.charAt(f)==="/"||a.charAt(f)==="\\")&&a.endsWith("keytar")&&(a=a.replace(/\\/g,"/"),this.alternativeNames.has(a)))return"keytar"}};c=je([qe(0,y.IExtHostRpcService),qe(1,k.IExtHostInitDataService)],c);let p=class{constructor(a,h,f){this._extensionPaths=a,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=f.getProxy(S.MainContext.MainThreadTelemetry);const t=f.getProxy(S.MainContext.MainThreadWindow);this._impl=(i,s)=>{const o=R.URI.parse(i);return s?this.callOriginal(i,s):o.scheme==="http"||o.scheme==="https"?t.$openUri(o,i,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?t.$openUri(o,i,{}):this.callOriginal(i,s)}}load(a,h,f){const t=this._extensionPaths.findSubstr(h.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=f(a),this._impl}callOriginal(a,h){return this.sendNoForwardTelemetry(),this._original(a,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};p=je([qe(2,y.IExtHostRpcService)],p)}),define(ve[223],be([0,1,11,12,80,6,2,5,215,17,62,66,27,152,15,72,34,40]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r,m,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(h,f,t,i){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new y.RPCProtocol(h,null,i),f=w._transform(f,this._rpcProtocol);const s=new P.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());s.set(d.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},f)),s.set(r.IExtHostRpcService,new r.ExtHostRpcService(this._rpcProtocol)),s.set(m.IURITransformerService,new m.URITransformerService(i)),s.set(c.IHostUtils,t);const o=new g.InstantiationService(s,!0),u=o.invokeFunction(C=>C.get(p.IExtHostTerminalService));this._disposables.add(u),this._logService=o.invokeFunction(C=>C.get(k.ILogService)),S.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",f),this._extensionService=o.invokeFunction(C=>C.get(c.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const _=new WeakMap;this._extensionService.getExtensionPathIndex().then(C=>{Error.prepareStackTrace=(l,F)=>{let N="",z,de;for(const he of F)N+=`
	at ${he.toString()}`,de=he.getFileName(),!z&&de&&(z=C.findSubstr(de));return _.set(l,z),`${l.name||"Error"}: ${l.message||""}${N}`}});const b=this._rpcProtocol.getProxy(D.MainContext.MainThreadExtensionService),A=this._rpcProtocol.getProxy(D.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(C=>{const l=R.transformErrorForSerialization(C),F=_.get(C);F?b.$onExtensionRuntimeError(F.identifier,l):A.$onUnexpectedError(l)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const f=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,v.timeout)(4e3),f]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(h,f){h.extensions.forEach(i=>i.extensionLocation=E.URI.revive(f.transformIncomingURIs(i.extensionLocation))),h.environment.appRoot=E.URI.revive(f.transformIncomingURIs(h.environment.appRoot));const t=h.environment.extensionDevelopmentLocationURI;return t&&(h.environment.extensionDevelopmentLocationURI=t.map(i=>E.URI.revive(f.transformIncomingURIs(i)))),h.environment.extensionTestsLocationURI=E.URI.revive(f.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=E.URI.revive(f.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=E.URI.revive(f.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=E.URI.revive(f.transformIncomingURIs(h.logsLocation)),h.logFile=E.URI.revive(f.transformIncomingURIs(h.logFile)),h.workspace=f.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=w}),define(ve[224],be([0,1,14,20,61,28,25,56,41]),function(J,e,v,R,S,T,E,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(d,g,r){this.config=d,this.provider=g,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&T.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&T.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const g=this.config.folderQueries||[];return new Promise((r,m)=>{const c=p=>{this.resultCount++,d(p)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(p=>{const w=p.toString(),a=v.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,a)||this.matchFile(c,{base:p,basename:a})}),Promise.all(g.map(p=>this.searchInFolder(p,c))).then(p=>{r({limitHit:this.isLimitHit,stats:p[0]||void 0})},p=>{m(new Error((0,S.toErrorMessage)(p)))})})}async searchInFolder(d,g){const r=new R.CancellationTokenSource,m=this.getSearchOptionsForFolder(d),c=this.initDirectoryTree(),p=new y.QueryGlobTester(this.config,d),w=!p.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(r),a=D.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},m,r.token),f=a.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(i=>{const s=v.posix.relative(d.folder.path,i.path);if(w){const o=v.basename(i.path);this.matchFile(g,{base:d.folder,relativePath:s,basename:o});return}this.addDirectoryEntries(c,d.folder,s,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(c,p,g),{providerTime:f,postProcessTime:t.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(d){const g=(0,y.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),r=(0,y.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:r,includes:g,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},g,r,m){if(r===this.filePattern){const p=v.basename(this.filePattern);this.matchFile(m,{base:g,relativePath:this.filePattern,basename:p})}function c(p){const w=v.basename(p),a=v.dirname(p);let h=d[a];h||(h=d[a]=[],c(a)),h.push({base:g,relativePath:p,basename:w})}c(r)}matchDirectoryTree({rootEntries:d,pathToEntries:g},r,m){const c=this,p=this.filePattern;function w(a){const h=T.hasSiblingFn(()=>a.map(f=>f.basename));for(let f=0,t=a.length;f<t;f++){const i=a[f],{relativePath:s,basename:o}=i;if(!r.includedInQuerySync(s,o,p!==o?h:void 0))continue;const u=g[s];if(u)w(u);else{if(s===p)continue;c.matchFile(m,i)}if(c.isLimitHit)break}}w(d)}matchFile(d,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(g))}}class n{constructor(){this.sessions=new Map}fileSearch(d,g,r,m){const c=this.getSessionTokenSource(d.cacheKey),p=new k(d,g,c&&c.token);let w=0;const a=h=>{w+=h.length,r(h.map(f=>this.rawMatchToSearchItem(f)))};return this.doSearch(p,n.BATCH_SIZE,a,m).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:h.stats}}))}clearCache(d){const g=this.getSessionTokenSource(d);g&&g.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new R.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:E.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,g,r,m){m.onCancellationRequested(()=>{d.cancel()});const c=w=>{w&&(p.push(w),g>0&&p.length>=g&&(r(p),p=[]))};let p=[];return d.search(c).then(w=>(p.length&&r(p),w),w=>(p.length&&r(p),Promise.reject(w)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(ve[225],be([0,1,14,13,20,61,25,28,2,41,16,10]),function(J,e,v,R,S,T,E,D,y,k,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class d{constructor(a,h,f){this.query=a,this.provider=h,this.fileUtils=f,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,h){const f=this.query.folderQueries||[],t=new S.CancellationTokenSource;return h.onCancellationRequested(()=>t.cancel()),new Promise((i,s)=>{this.collector=new r(a);let o=!1;const u=(_,b)=>{if(!o&&!this.isLimitHit){const A=this.resultSize(_);c(_)&&typeof this.query.maxResults=="number"&&this.resultCount+A>this.query.maxResults&&(this.isLimitHit=!0,o=!0,t.cancel(),_=this.trimResultToSize(_,this.query.maxResults-this.resultCount));const C=this.resultSize(_);this.resultCount+=C,(C>0||!c(_))&&this.collector.add(_,b)}};Promise.all(f.map((_,b)=>this.searchInFolder(_,A=>u(A,b),t.token))).then(_=>{t.dispose(),this.collector.flush();const b=_.some(A=>!!A&&!!A.limitHit);i({limitHit:this.isLimitHit||b,messages:(0,R.flatten)(_.map(A=>(A==null?void 0:A.message)?(0,P.isArray)(A.message)?A.message:[A.message]:[])),stats:{type:"textSearchProvider"}})},_=>{t.dispose();const b=(0,T.toErrorMessage)(_);s(new Error(b))})})}resultSize(a){return c(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,h){const f=Array.isArray(a.ranges)?a.ranges:[a.ranges],t=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:f.slice(0,h),preview:{matches:t.slice(0,h),text:a.preview.text},uri:a.uri}}async searchInFolder(a,h,f){const t=new k.QueryGlobTester(this.query,a),i=[],s={report:_=>{if(!this.validateProviderResult(_))return;const b=a.folder.scheme===n.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(E.dirname(_.uri))):void 0,A=E.relativePath(a.folder,_.uri);A&&i.push(t.includedInQuery(A,v.basename(A),b).then(C=>{C&&h(_)}))}},o=this.getSearchOptionsForFolder(a),u=await this.provider.provideTextSearchResults(g(this.query.contentPattern),o,s,f);return await Promise.all(i),u}validateProviderResult(a){if(c(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const h=(0,k.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),f=(0,k.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),t={folder:y.URI.from(a.folder),excludes:f,includes:h,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=d;function g(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class r{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new p(512,h=>this.sendItems(h))}add(a,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!E.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(m(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=r;function m(w){return c(w)?{preview:{matches:(0,R.mapArrayOrNot)(w.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:w.preview.text},ranges:(0,R.mapArrayOrNot)(w.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function c(w){return!!w.preview}e.extensionResultIsMatch=c;class p{constructor(a,h){this.maxBatchSize=a,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,h){!a||this.addItemToBatch(a,h)}addItems(a,h){!a||this.addItemsToBatch(a,h)}addItemToBatch(a,h){this.batch.push(a),this.batchSize+=h,this.onUpdate()}addItemsToBatch(a,h){this.batch=this.batch.concat(a),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<p.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},p.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=p,p.TIMEOUT=4e3,p.START_BATCH_AFTER_COUNT=50}),define(ve[107],be([0,1,6,5,4,224,15,72,17,2,225]),function(J,e,v,R,S,T,E,D,y,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let P=class{constructor(m,c,p){this.extHostRpc=m,this._uriTransformer=c,this._logService=p,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}registerTextSearchProvider(m,c){if(this._textSearchUsedSchemes.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this._textSearchUsedSchemes.add(m);const p=this._handlePool++;return this._textSearchProvider.set(p,c),this._proxy.$registerTextSearchProvider(p,this._transformScheme(m)),(0,v.toDisposable)(()=>{this._textSearchUsedSchemes.delete(m),this._textSearchProvider.delete(p),this._proxy.$unregisterProvider(p)})}registerFileSearchProvider(m,c){if(this._fileSearchUsedSchemes.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this._fileSearchUsedSchemes.add(m);const p=this._handlePool++;return this._fileSearchProvider.set(p,c),this._proxy.$registerFileSearchProvider(p,this._transformScheme(m)),(0,v.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(m),this._fileSearchProvider.delete(p),this._proxy.$unregisterProvider(p)})}$provideFileSearchResults(m,c,p,w){const a=d(p),h=this._fileSearchProvider.get(m);if(h)return this._fileSearchManager.fileSearch(a,h,f=>{this._proxy.$handleFileMatch(m,c,f.map(t=>t.resource))},w);throw new Error("unknown provider: "+m)}$clearCache(m){return this._fileSearchManager.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,c,p,w){const a=this._textSearchProvider.get(m);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const h=d(p);return this.createTextSearchManager(h,a).search(t=>this._proxy.$handleTextMatch(m,c,t),w)}createTextSearchManager(m,c){return new n.TextSearchManager(m,c,{readdir:p=>Promise.resolve([]),toCanonicalName:p=>p})}};P=je([qe(0,E.IExtHostRpcService),qe(1,D.IURITransformerService),qe(2,y.ILogService)],P),e.ExtHostSearch=P;function d(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(g),extraFileResources:r.extraFileResources&&r.extraFileResources.map(m=>k.URI.revive(m))})}e.reviveQuery=d;function g(r){return Object.assign(Object.assign({},r),{folder:k.URI.revive(r.folder)})}}),define(ve[226],be([0,1,20,12,3,47,2,125,85,119,60,65,5,190,189,76,191,33,192,193,194,177,195,39,34,196,178,198,199,200,102,180,204,205,206,78,40,207,181,9,7,210,51,103,30,32,52,167,197,94,101,105,106,107,17,72,15,27,201,165,71,75,187,208,164,79,77,213,211,212,188,49,219,209,74,69,95,202,104,203,16,154]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r,m,c,p,w,a,h,f,t,i,s,o,u,_,b,A,C,l,F,N,z,de,he,$,q,x,I,H,M,B,G,K,se,pe,Fe,We,Ne,ze,Ve,W,Q,te,re,fe,_e,ue,we,Ae,xe,ge,Ke,j,Z,me,Oe,He,$e,Xe,ye,Se,Ce,ne,le,O,Y,oe,ke,Ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Le(Ue){const Qe=Ue.get(fe.IExtHostInitDataService),rt=Ue.get(Xe.IExtHostFileSystemInfo),et=Ue.get(Z.IExtHostConsumerFileSystem),Ye=Ue.get(s.IExtHostExtensionService),ot=Ue.get(G.IExtHostWorkspace),_t=Ue.get(le.IExtHostTelemetry),wt=Ue.get(p.IExtHostConfiguration),vt=Ue.get(te.IURITransformerService),ie=Ue.get(re.IExtHostRpcService),Ee=Ue.get(de.IExtHostStorage),ae=Ue.get(j.IExtensionStoragePaths),V=Ue.get(Q.ILogService),Me=Ue.get(we.IExtHostTunnelService),Te=Ue.get(Ae.IExtHostApiDeprecationService),Ze=Ue.get(B.IExtHostWindow),it=Ue.get(Ce.IExtHostSecretState),ut=Ue.get(ne.IExtHostEditorTabs);ie.set(d.ExtHostContext.ExtHostFileSystemInfo,rt),ie.set(d.ExtHostContext.ExtHostLogService,V),ie.set(d.ExtHostContext.ExtHostWorkspace,ot),ie.set(d.ExtHostContext.ExtHostConfiguration,wt),ie.set(d.ExtHostContext.ExtHostExtensionService,Ye),ie.set(d.ExtHostContext.ExtHostStorage,Ee),ie.set(d.ExtHostContext.ExtHostTunnelService,Me),ie.set(d.ExtHostContext.ExtHostWindow,Ze),ie.set(d.ExtHostContext.ExtHostSecretState,it),ie.set(d.ExtHostContext.ExtHostTelemetry,_t),ie.set(d.ExtHostContext.ExtHostEditorTabs,ut);const gt=ie.set(d.ExtHostContext.ExtHostDecorations,Ue.get(Ne.IExtHostDecorations)),Je=ie.set(d.ExtHostContext.ExtHostDocumentsAndEditors,Ue.get(i.IExtHostDocumentsAndEditors)),dt=ie.set(d.ExtHostContext.ExtHostCommands,Ue.get(m.IExtHostCommands)),at=ie.set(d.ExtHostContext.ExtHostTerminalService,Ue.get(he.IExtHostTerminalService)),lt=ie.set(d.ExtHostContext.ExtHostDebugService,Ue.get(Ve.IExtHostDebugService)),Pt=ie.set(d.ExtHostContext.ExtHostSearch,Ue.get(W.IExtHostSearch)),Ct=ie.set(d.ExtHostContext.ExtHostTask,Ue.get(ze.IExtHostTask)),At=ie.set(d.ExtHostContext.ExtHostOutputService,Ue.get(C.IExtHostOutputService)),Rt=ie.set(d.ExtHostContext.ExtHostUrls,new H.ExtHostUrls(ie)),yt=ie.set(d.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(ie,Je)),Gt=ie.set(d.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(ie,Je,V)),Qt=ie.set(d.ExtHostContext.ExtHostDocumentSaveParticipant,new f.ExtHostDocumentSaveParticipant(V,yt,ie.getProxy(d.MainContext.MainThreadBulkEdits))),mt=ie.set(d.ExtHostContext.ExtHostNotebook,new _e.ExtHostNotebookController(ie,dt,Je,yt,V,ae)),Yt=ie.set(d.ExtHostContext.ExtHostNotebookKernels,new O.ExtHostNotebookKernels(ie,Qe,mt,V)),Jt=ie.set(d.ExtHostContext.ExtHostNotebookRenderers,new oe.ExtHostNotebookRenderers(ie,mt)),Dt=ie.set(d.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(ie,Je)),un=ie.set(d.ExtHostContext.ExtHostTreeViews,new q.ExtHostTreeViews(ie.getProxy(d.MainContext.MainThreadTreeViews),dt,V)),Xt=ie.set(d.ExtHostContext.ExtHostEditorInsets,new pe.ExtHostEditorInsets(ie.getProxy(d.MainContext.MainThreadEditorInsets),Dt,Qe)),Bt=ie.set(d.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(ie,V)),ht=ie.set(d.ExtHostContext.ExtHostLanguageFeatures,new _.ExtHostLanguageFeatures(ie,vt,yt,dt,Bt,V,Te)),Zt=ie.set(d.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(ie,ht)),Lt=ie.set(d.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(ie,V,Je)),Mt=ie.set(d.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(ie,ot,dt)),Vt=ie.set(d.ExtHostContext.ExtHostSCM,new N.ExtHostSCM(ie,dt,V)),pn=ie.set(d.ExtHostContext.ExtHostComments,new c.ExtHostComments(ie,dt,yt)),cn=ie.set(d.ExtHostContext.ExtHostProgress,new l.ExtHostProgress(ie.getProxy(d.MainContext.MainThreadProgress))),vn=ie.set(d.ExtHostContext.ExtHosLabelService,new Fe.ExtHostLabelService(ie)),dn=ie.set(d.ExtHostContext.ExtHostTheming,new ue.ExtHostTheming(ie)),$t=ie.set(d.ExtHostContext.ExtHostAuthentication,new xe.ExtHostAuthentication(ie)),en=ie.set(d.ExtHostContext.ExtHostTimeline,new ge.ExtHostTimeline(ie,dt)),Ht=ie.set(d.ExtHostContext.ExtHostWebviews,new M.ExtHostWebviews(ie,{remote:Qe.remote},ot,V,Te)),tn=ie.set(d.ExtHostContext.ExtHostWebviewPanels,new He.ExtHostWebviewPanels(ie,Ht,ot)),bn=ie.set(d.ExtHostContext.ExtHostCustomEditors,new Oe.ExtHostCustomEditors(ie,yt,ae,Ht,tn)),wn=ie.set(d.ExtHostContext.ExtHostWebviewViews,new me.ExtHostWebviewViews(ie,Ht)),Nt=ie.set(d.ExtHostContext.ExtHostTesting,new ye.ExtHostTesting(ie,Je,ot)),jt=ie.set(d.ExtHostContext.ExtHostUriOpeners,new Se.ExtHostUriOpeners(ie)),_n=(0,se.values)(d.ExtHostContext);ie.assertRegistered(_n);const En=new $e.ExtHostBulkEdits(ie,Je),nn=new r.ExtHostClipboard(ie),rn=new A.ExtHostMessageService(ie,V),Wt=new a.ExtHostDialogs(ie),qt=new z.ExtHostStatusBar(ie,dt.converter),xt=new b.ExtHostLanguages(ie,yt);return g.ExtHostApiCommands.register(dt),function(Re,sn,It){const pt=function(){let X=!Re.isUnderDevelopment;function ce(Pe){X||(V.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function Pe(st){if(Array.isArray(st))st.forEach(Pe);else if(typeof st=="string")ce(st);else{const bt=st;typeof bt.scheme=="undefined"&&ce(st),!Re.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,K.throwProposedApiError)(Re)}return st}}(),yn={getSession(X,ce,Pe){return $t.getSession(Re,X,ce,Pe)},get onDidChangeSessions(){return $t.onDidChangeSessions},registerAuthenticationProvider(X,ce,Pe,st){return $t.registerAuthenticationProvider(X,ce,Pe,st)},get onDidChangeAuthenticationProviders(){return(0,K.checkProposedApiEnabled)(Re),$t.onDidChangeAuthenticationProviders},get providers(){return(0,K.checkProposedApiEnabled)(Re),$t.providers},logout(X,ce){return(0,K.checkProposedApiEnabled)(Re),$t.removeSession(X,ce)}},Sn={registerCommand(X,ce,Pe){return dt.registerCommand(!0,X,ce,Pe)},registerTextEditorCommand(X,ce,Pe){return dt.registerCommand(!0,X,(...st)=>{const bt=Dt.getActiveTextEditor();if(!bt){V.warn("Cannot execute "+X+" because there is no active text editor.");return}return bt.edit(Et=>{ce.apply(Pe,[bt,Et,...st])}).then(Et=>{Et||V.warn("Edits from command "+X+" were not applied.")},Et=>{V.warn("An error occurred while running command "+X,Et)})})},registerDiffInformationCommand:(X,ce,Pe)=>((0,K.checkProposedApiEnabled)(Re),dt.registerCommand(!0,X,async(...st)=>{const bt=Je.activeEditor(!0);if(!bt){V.warn("Cannot execute "+X+" because there is no active text editor.");return}const Et=await Dt.getDiffInformation(bt.id);ce.apply(Pe,[Et,...st])})),executeCommand(X,...ce){return dt.executeCommand(X,...ce)},getCommands(X=!1){return dt.getCommands(X)}},hn={get machineId(){return Qe.telemetryInfo.machineId},get sessionId(){return Qe.telemetryInfo.sessionId},get language(){return Qe.environment.appLanguage},get appName(){return Qe.environment.appName},get appRoot(){var X,ce;return(ce=(X=Qe.environment.appRoot)===null||X===void 0?void 0:X.fsPath)!==null&&ce!==void 0?ce:""},get uriScheme(){return Qe.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return at.getDefaultShell(!1)},get isTelemetryEnabled(){return _t.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return _t.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(Qe.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,ce){return Ze.openUri(X,{allowTunneling:!!Qe.remote.authority,allowContributedOpeners:ce==null?void 0:ce.allowContributedOpeners})},asExternalUri(X){return X.scheme===Qe.environment.appUriScheme?Rt.createAppUri(X):(!(0,Ie.matchesScheme)(X.scheme,ke.Schemas.http)&&!(0,Ie.matchesScheme)(X.scheme,ke.Schemas.https)&&(0,K.checkProposedApiEnabled)(Re),Ze.asExternalUri(X,{allowTunneling:!!Qe.remote.authority}))},get remoteName(){return(0,We.getRemoteName)(Qe.remote.authority)},get uiKind(){return Qe.uiKind}};Qe.environment.extensionTestsLocationURI||Object.freeze(hn);const fn=Qe.remote.isRemote?I.ExtensionKind.Workspace:I.ExtensionKind.UI,Dn={registerTestController(X){return Nt.registerTestController(Re.identifier.value,X)},createDocumentTestObserver(X){return(0,K.checkProposedApiEnabled)(Re),Nt.createTextDocumentTestObserver(X)},createWorkspaceTestObserver(X){return(0,K.checkProposedApiEnabled)(Re),Nt.createWorkspaceTestObserver(X)},runTests(X){return Nt.runTests(X)},createTestItem(X,ce){return new I.TestItemImpl(X.id,X.label,X.uri,ce)},createTestRun(X,ce,Pe){return Nt.createTestRun(Re.identifier.value,X,ce,Pe)},get onDidChangeTestResults(){return(0,K.checkProposedApiEnabled)(Re),Nt.onResultsChanged},get testResults(){return(0,K.checkProposedApiEnabled)(Re),Nt.results}},Cn={getExtension(X){const ce=sn.getExtensionDescription(X);if(ce)return new s.Extension(Ye,Re.identifier,ce,fn)},get all(){return sn.getAllExtensionDescriptions().map(X=>new s.Extension(Ye,Re.identifier,X,fn))},get onDidChange(){return sn.onDidChange}},kn={createDiagnosticCollection(X){return Bt.createDiagnosticCollection(Re.identifier,X)},get onDidChangeDiagnostics(){return Bt.onDidChangeDiagnostics},getDiagnostics:X=>Bt.getDiagnostics(X),getLanguages(){return xt.getLanguages()},setTextDocumentLanguage(X,ce){return xt.changeLanguage(X.uri,ce)},match(X,ce){return(0,n.score)(x.LanguageSelector.from(X),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(X,ce,Pe){return ht.registerCodeActionProvider(Re,pt(X),ce,Pe)},registerCodeLensProvider(X,ce){return ht.registerCodeLensProvider(Re,pt(X),ce)},registerDefinitionProvider(X,ce){return ht.registerDefinitionProvider(Re,pt(X),ce)},registerDeclarationProvider(X,ce){return ht.registerDeclarationProvider(Re,pt(X),ce)},registerImplementationProvider(X,ce){return ht.registerImplementationProvider(Re,pt(X),ce)},registerTypeDefinitionProvider(X,ce){return ht.registerTypeDefinitionProvider(Re,pt(X),ce)},registerHoverProvider(X,ce){return ht.registerHoverProvider(Re,pt(X),ce,Re.identifier)},registerEvaluatableExpressionProvider(X,ce){return ht.registerEvaluatableExpressionProvider(Re,pt(X),ce,Re.identifier)},registerInlineValuesProvider(X,ce){return ht.registerInlineValuesProvider(Re,pt(X),ce,Re.identifier)},registerDocumentHighlightProvider(X,ce){return ht.registerDocumentHighlightProvider(Re,pt(X),ce)},registerLinkedEditingRangeProvider(X,ce){return ht.registerLinkedEditingRangeProvider(Re,pt(X),ce)},registerReferenceProvider(X,ce){return ht.registerReferenceProvider(Re,pt(X),ce)},registerRenameProvider(X,ce){return ht.registerRenameProvider(Re,pt(X),ce)},registerDocumentSymbolProvider(X,ce,Pe){return ht.registerDocumentSymbolProvider(Re,pt(X),ce,Pe)},registerWorkspaceSymbolProvider(X){return ht.registerWorkspaceSymbolProvider(Re,X)},registerDocumentFormattingEditProvider(X,ce){return ht.registerDocumentFormattingEditProvider(Re,pt(X),ce)},registerDocumentRangeFormattingEditProvider(X,ce){return ht.registerDocumentRangeFormattingEditProvider(Re,pt(X),ce)},registerOnTypeFormattingEditProvider(X,ce,Pe,...st){return ht.registerOnTypeFormattingEditProvider(Re,pt(X),ce,[Pe].concat(st))},registerDocumentSemanticTokensProvider(X,ce,Pe){return ht.registerDocumentSemanticTokensProvider(Re,pt(X),ce,Pe)},registerDocumentRangeSemanticTokensProvider(X,ce,Pe){return ht.registerDocumentRangeSemanticTokensProvider(Re,pt(X),ce,Pe)},registerSignatureHelpProvider(X,ce,Pe,...st){return typeof Pe=="object"?ht.registerSignatureHelpProvider(Re,pt(X),ce,Pe):ht.registerSignatureHelpProvider(Re,pt(X),ce,typeof Pe=="undefined"?[]:[Pe,...st])},registerCompletionItemProvider(X,ce,...Pe){return ht.registerCompletionItemProvider(Re,pt(X),ce,Pe)},registerInlineCompletionItemProvider(X,ce){return(0,K.checkProposedApiEnabled)(Re),ht.registerInlineCompletionsProvider(Re,pt(X),ce)},registerDocumentLinkProvider(X,ce){return ht.registerDocumentLinkProvider(Re,pt(X),ce)},registerColorProvider(X,ce){return ht.registerColorProvider(Re,pt(X),ce)},registerFoldingRangeProvider(X,ce){return ht.registerFoldingRangeProvider(Re,pt(X),ce)},registerSelectionRangeProvider(X,ce){return ht.registerSelectionRangeProvider(Re,X,ce)},registerCallHierarchyProvider(X,ce){return ht.registerCallHierarchyProvider(Re,X,ce)},setLanguageConfiguration:(X,ce)=>ht.setLanguageConfiguration(Re,X,ce),getTokenInformationAtPosition(X,ce){return(0,K.checkProposedApiEnabled)(Re),xt.tokenAtPosition(X,ce)},registerInlayHintsProvider(X,ce){return(0,K.checkProposedApiEnabled)(Re),ht.registerInlayHintsProvider(Re,X,ce)}},on={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return at.activeTerminal},get terminals(){return at.terminals},async showTextDocument(X,ce,Pe){const st=await(E.URI.isUri(X)?Promise.resolve(mn.openTextDocument(X)):Promise.resolve(X));return Dt.showTextDocument(st,ce,Pe)},createTextEditorDecorationType(X){return Dt.createTextEditorDecorationType(X)},onDidChangeActiveTextEditor(X,ce,Pe){return Dt.onDidChangeActiveTextEditor(X,ce,Pe)},onDidChangeVisibleTextEditors(X,ce,Pe){return Dt.onDidChangeVisibleTextEditors(X,ce,Pe)},onDidChangeTextEditorSelection(X,ce,Pe){return Dt.onDidChangeTextEditorSelection(X,ce,Pe)},onDidChangeTextEditorOptions(X,ce,Pe){return Dt.onDidChangeTextEditorOptions(X,ce,Pe)},onDidChangeTextEditorVisibleRanges(X,ce,Pe){return Dt.onDidChangeTextEditorVisibleRanges(X,ce,Pe)},onDidChangeTextEditorViewColumn(X,ce,Pe){return Dt.onDidChangeTextEditorViewColumn(X,ce,Pe)},onDidCloseTerminal(X,ce,Pe){return at.onDidCloseTerminal(X,ce,Pe)},onDidOpenTerminal(X,ce,Pe){return at.onDidOpenTerminal(X,ce,Pe)},onDidChangeActiveTerminal(X,ce,Pe){return at.onDidChangeActiveTerminal(X,ce,Pe)},onDidChangeTerminalDimensions(X,ce,Pe){return(0,K.checkProposedApiEnabled)(Re),at.onDidChangeTerminalDimensions(X,ce,Pe)},onDidWriteTerminalData(X,ce,Pe){return(0,K.checkProposedApiEnabled)(Re),at.onDidWriteTerminalData(X,ce,Pe)},get state(){return Ze.state},onDidChangeWindowState(X,ce,Pe){return Ze.onDidChangeWindowState(X,ce,Pe)},showInformationMessage(X,...ce){return rn.showMessage(Re,T.default.Info,X,ce[0],ce.slice(1))},showWarningMessage(X,...ce){return rn.showMessage(Re,T.default.Warning,X,ce[0],ce.slice(1))},showErrorMessage(X,...ce){return rn.showMessage(Re,T.default.Error,X,ce[0],ce.slice(1))},showQuickPick(X,ce,Pe){return Mt.showQuickPick(X,!!Re.enableProposedApi,ce,Pe)},showWorkspaceFolderPick(X){return Mt.showWorkspaceFolderPick(X)},showInputBox(X,ce){return Mt.showInput(X,ce)},showOpenDialog(X){return Wt.showOpenDialog(X)},showSaveDialog(X){return Wt.showSaveDialog(X)},createStatusBarItem(X,ce,Pe){let st,bt,Et;return typeof X=="string"?(st=X,bt=ce,Et=Pe):(bt=X,Et=ce),qt.createStatusBarEntry(Re,st,bt,Et)},setStatusBarMessage(X,ce){return qt.setStatusBarMessage(X,ce)},withScmProgress(X){return Te.report("window.withScmProgress",Re,"Use 'withProgress' instead."),cn.withProgress(Re,{location:I.ProgressLocation.SourceControl},(ce,Pe)=>X({report(st){}}))},withProgress(X,ce){return cn.withProgress(Re,X,ce)},createOutputChannel(X){return At.createOutputChannel(X)},createWebviewPanel(X,ce,Pe,st){return tn.createWebviewPanel(Re,X,ce,Pe,st)},createWebviewTextEditorInset(X,ce,Pe,st){return(0,K.checkProposedApiEnabled)(Re),Xt.createWebviewEditorInset(X,ce,Pe,st,Re)},createTerminal(X,ce,Pe){return typeof X=="object"?"pty"in X?at.createExtensionTerminal(X):(X.iconPath&&(0,K.checkProposedApiEnabled)(Re),at.createTerminalFromOptions(X)):at.createTerminal(X,ce,Pe)},registerTerminalLinkProvider(X){return at.registerLinkProvider(X)},registerTreeDataProvider(X,ce){return un.registerTreeDataProvider(X,ce,Re)},createTreeView(X,ce){return un.createTreeView(X,ce,Re)},registerWebviewPanelSerializer:(X,ce)=>tn.registerWebviewPanelSerializer(Re,X,ce),registerCustomEditorProvider:(X,ce,Pe={})=>bn.registerCustomEditorProvider(Re,X,ce,Pe),registerFileDecorationProvider(X){return gt.registerFileDecorationProvider(X,Re.identifier)},registerUriHandler(X){return Rt.registerUriHandler(Re.identifier,X)},createQuickPick(){return Mt.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return Mt.createInputBox(Re.identifier)},get activeColorTheme(){return dn.activeColorTheme},onDidChangeActiveColorTheme(X,ce,Pe){return dn.onDidChangeActiveColorTheme(X,ce,Pe)},registerWebviewViewProvider(X,ce,Pe){return wn.registerWebviewViewProvider(Re,X,ce,Pe==null?void 0:Pe.webviewOptions)},get activeNotebookEditor(){return(0,K.checkProposedApiEnabled)(Re),mt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,ce,Pe){return(0,K.checkProposedApiEnabled)(Re),mt.onDidChangeActiveNotebookEditor(X,ce,Pe)},get visibleNotebookEditors(){return(0,K.checkProposedApiEnabled)(Re),mt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,K.checkProposedApiEnabled)(Re),mt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,ce,Pe){return(0,K.checkProposedApiEnabled)(Re),mt.onDidChangeNotebookEditorSelection(X,ce,Pe)},onDidChangeNotebookEditorVisibleRanges(X,ce,Pe){return(0,K.checkProposedApiEnabled)(Re),mt.onDidChangeNotebookEditorVisibleRanges(X,ce,Pe)},showNotebookDocument(X,ce){return(0,K.checkProposedApiEnabled)(Re),mt.showNotebookDocument(X,ce)},registerExternalUriOpener(X,ce,Pe){return(0,K.checkProposedApiEnabled)(Re),jt.registerExternalUriOpener(Re.identifier,X,ce,Pe)},get openEditors(){return(0,K.checkProposedApiEnabled)(Re),ut.tabs},get onDidChangeOpenEditors(){return(0,K.checkProposedApiEnabled)(Re),ut.onDidChangeTabs}},mn={get rootPath(){return Te.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(X){throw R.readonly()},getWorkspaceFolder(X){return ot.getWorkspaceFolder(X)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(X){throw R.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(X){throw R.readonly()},updateWorkspaceFolders:(X,ce,...Pe)=>ot.updateWorkspaceFolders(Re,X,ce||0,...Pe),onDidChangeWorkspaceFolders:function(X,ce,Pe){return ot.onDidChangeWorkspace(X,ce,Pe)},asRelativePath:(X,ce)=>ot.getRelativePath(X,ce),findFiles:(X,ce,Pe,st)=>ot.findFiles(x.GlobPattern.from(X),x.GlobPattern.from(ce),Pe,Re.identifier,st),findTextInFiles:(X,ce,Pe,st)=>{let bt,Et;return typeof ce=="object"?(bt=ce,Et=Pe):(bt={},Et=ce,st=Pe),ot.findTextInFiles(X,bt||{},Et,Re.identifier,st)},saveAll:X=>ot.saveAll(X),applyEdit(X){return En.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,ce,Pe,st)=>Lt.createFileSystemWatcher(x.GlobPattern.from(X),ce,Pe,st),get textDocuments(){return yt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw R.readonly()},openTextDocument(X){let ce;const Pe=X;if(typeof X=="string")ce=Promise.resolve(E.URI.file(X));else if(E.URI.isUri(X))ce=Promise.resolve(X);else if(!Pe||typeof Pe=="object")ce=yt.createDocumentData(Pe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(st=>yt.ensureDocumentData(st).then(bt=>bt.document))},onDidOpenTextDocument:(X,ce,Pe)=>yt.onDidAddDocument(X,ce,Pe),onDidCloseTextDocument:(X,ce,Pe)=>yt.onDidRemoveDocument(X,ce,Pe),onDidChangeTextDocument:(X,ce,Pe)=>yt.onDidChangeDocument(X,ce,Pe),onDidSaveTextDocument:(X,ce,Pe)=>yt.onDidSaveDocument(X,ce,Pe),onWillSaveTextDocument:(X,ce,Pe)=>Qt.getOnWillSaveTextDocumentEvent(Re)(X,ce,Pe),onDidChangeConfiguration:(X,ce,Pe)=>It.onDidChangeConfiguration(X,ce,Pe),getConfiguration(X,ce){return ce=arguments.length===1?void 0:ce,It.getConfiguration(X,ce,Re)},registerTextDocumentContentProvider(X,ce){return Gt.registerTextDocumentContentProvider(X,ce)},registerTaskProvider:(X,ce)=>(Te.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(Re,X,ce)),registerFileSystemProvider(X,ce,Pe){return Zt.registerFileSystemProvider(Re.identifier,X,ce,Pe,Re.enableProposedApi)},get fs(){return et.value},registerFileSearchProvider:(X,ce)=>((0,K.checkProposedApiEnabled)(Re),Pt.registerFileSearchProvider(X,ce)),registerTextSearchProvider:(X,ce)=>((0,K.checkProposedApiEnabled)(Re),Pt.registerTextSearchProvider(X,ce)),registerRemoteAuthorityResolver:(X,ce)=>((0,K.checkProposedApiEnabled)(Re),Ye.registerRemoteAuthorityResolver(X,ce)),registerResourceLabelFormatter:X=>((0,K.checkProposedApiEnabled)(Re),vn.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,ce,Pe)=>Lt.onDidCreateFile(X,ce,Pe),onDidDeleteFiles:(X,ce,Pe)=>Lt.onDidDeleteFile(X,ce,Pe),onDidRenameFiles:(X,ce,Pe)=>Lt.onDidRenameFile(X,ce,Pe),onWillCreateFiles:(X,ce,Pe)=>Lt.getOnWillCreateFileEvent(Re)(X,ce,Pe),onWillDeleteFiles:(X,ce,Pe)=>Lt.getOnWillDeleteFileEvent(Re)(X,ce,Pe),onWillRenameFiles:(X,ce,Pe)=>Lt.getOnWillRenameFileEvent(Re)(X,ce,Pe),openTunnel:X=>((0,K.checkProposedApiEnabled)(Re),Me.openTunnel(Re,X).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,K.checkProposedApiEnabled)(Re),Me.getTunnels()},onDidChangeTunnels:(X,ce,Pe)=>((0,K.checkProposedApiEnabled)(Re),Me.onDidChangeTunnels(X,ce,Pe)),registerPortAttributesProvider:(X,ce)=>((0,K.checkProposedApiEnabled)(Re),Me.registerPortsAttributesProvider(X,ce)),registerTimelineProvider:(X,ce)=>((0,K.checkProposedApiEnabled)(Re),en.registerTimelineProvider(X,ce,Re.identifier,dt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:X=>((0,K.checkProposedApiEnabled)(Re),ot.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,ce,Pe)=>ot.onDidGrantWorkspaceTrust(X,ce,Pe)},In={get inputBox(){return Te.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),Vt.getLastInputBox(Re)},createSourceControl(X,ce,Pe){return Vt.createSourceControl(Re,X,ce,Pe)}},Pn={createCommentController(X,ce){return pn.createCommentController(Re,X,ce)}},An={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(X,ce,Pe){return lt.onDidStartDebugSession(X,ce,Pe)},onDidTerminateDebugSession(X,ce,Pe){return lt.onDidTerminateDebugSession(X,ce,Pe)},onDidChangeActiveDebugSession(X,ce,Pe){return lt.onDidChangeActiveDebugSession(X,ce,Pe)},onDidReceiveDebugSessionCustomEvent(X,ce,Pe){return lt.onDidReceiveDebugSessionCustomEvent(X,ce,Pe)},onDidChangeBreakpoints(X,ce,Pe){return lt.onDidChangeBreakpoints(X,ce,Pe)},registerDebugConfigurationProvider(X,ce,Pe){return lt.registerDebugConfigurationProvider(X,ce,Pe||I.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,ce){return lt.registerDebugAdapterDescriptorFactory(Re,X,ce)},registerDebugAdapterTrackerFactory(X,ce){return lt.registerDebugAdapterTrackerFactory(X,ce)},startDebugging(X,ce,Pe){return!Pe||typeof Pe=="object"&&"configuration"in Pe?lt.startDebugging(X,ce,{parentSession:Pe}):lt.startDebugging(X,ce,Pe||{})},stopDebugging(X){return lt.stopDebugging(X)},addBreakpoints(X){return lt.addBreakpoints(X)},removeBreakpoints(X){return lt.removeBreakpoints(X)},asDebugSourceUri(X,ce){return lt.asDebugSourceUri(X,ce)}},Tn={registerTaskProvider:(X,ce)=>Ct.registerTaskProvider(Re,X,ce),fetchTasks:X=>Ct.fetchTasks(X),executeTask:X=>Ct.executeTask(Re,X),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(X,ce,Pe)=>Ct.onDidStartTask(X,ce,Pe),onDidEndTask:(X,ce,Pe)=>Ct.onDidEndTask(X,ce,Pe),onDidStartTaskProcess:(X,ce,Pe)=>Ct.onDidStartTaskProcess(X,ce,Pe),onDidEndTaskProcess:(X,ce,Pe)=>Ct.onDidEndTaskProcess(X,ce,Pe)},Rn={async openNotebookDocument(X,ce){(0,K.checkProposedApiEnabled)(Re);let Pe;if(E.URI.isUri(X))Pe=X,await mt.openNotebookDocument(X);else if(typeof X=="string")Pe=E.URI.revive(await mt.createNotebookDocument({viewType:X,content:ce}));else throw new Error("Invalid arguments");return mt.getNotebookDocument(Pe).apiNotebook},get onDidOpenNotebookDocument(){return(0,K.checkProposedApiEnabled)(Re),mt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,K.checkProposedApiEnabled)(Re),mt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,K.checkProposedApiEnabled)(Re),mt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,K.checkProposedApiEnabled)(Re),mt.notebookDocuments.map(X=>X.apiNotebook)},registerNotebookSerializer(X,ce,Pe,st){return(0,K.checkProposedApiEnabled)(Re),mt.registerNotebookSerializer(Re,X,ce,Pe,Re.enableProposedApi?st:void 0)},registerNotebookContentProvider:(X,ce,Pe,st)=>((0,K.checkProposedApiEnabled)(Re),mt.registerNotebookContentProvider(Re,X,ce,Pe,Re.enableProposedApi?st:void 0)),registerNotebookCellStatusBarItemProvider:(X,ce)=>((0,K.checkProposedApiEnabled)(Re),mt.registerNotebookCellStatusBarItemProvider(Re,X,ce)),createNotebookEditorDecorationType(X){return(0,K.checkProposedApiEnabled)(Re),mt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return(0,K.checkProposedApiEnabled)(Re),Jt.createRendererMessaging(X)},onDidChangeNotebookDocumentMetadata(X,ce,Pe){return(0,K.checkProposedApiEnabled)(Re),mt.onDidChangeNotebookDocumentMetadata(X,ce,Pe)},onDidChangeNotebookCells(X,ce,Pe){return(0,K.checkProposedApiEnabled)(Re),mt.onDidChangeNotebookCells(X,ce,Pe)},onDidChangeNotebookCellExecutionState(X,ce,Pe){return(0,K.checkProposedApiEnabled)(Re),mt.onDidChangeNotebookCellExecutionState(X,ce,Pe)},onDidChangeCellOutputs(X,ce,Pe){return(0,K.checkProposedApiEnabled)(Re),mt.onDidChangeCellOutputs(X,ce,Pe)},onDidChangeCellMetadata(X,ce,Pe){return(0,K.checkProposedApiEnabled)(Re),mt.onDidChangeCellMetadata(X,ce,Pe)},createConcatTextDocument(X,ce){return(0,K.checkProposedApiEnabled)(Re),new Ke.ExtHostNotebookConcatDocument(mt,yt,X,ce)},createNotebookController(X,ce,Pe,st,bt){return(0,K.checkProposedApiEnabled)(Re),Yt.createNotebookController(Re,X,ce,Pe,st,bt)}};return{version:Qe.version,authentication:yn,commands:Sn,comments:Pn,debug:An,env:hn,extensions:Cn,languages:kn,notebook:Rn,scm:In,tasks:Tn,test:Dn,window:on,workspace:mn,Breakpoint:I.Breakpoint,CallHierarchyIncomingCall:I.CallHierarchyIncomingCall,CallHierarchyItem:I.CallHierarchyItem,CallHierarchyOutgoingCall:I.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:v.CancellationTokenSource,CandidatePortSource:d.CandidatePortSource,CodeAction:I.CodeAction,CodeActionKind:I.CodeActionKind,CodeActionTriggerKind:I.CodeActionTriggerKind,CodeLens:I.CodeLens,Color:I.Color,ColorInformation:I.ColorInformation,ColorPresentation:I.ColorPresentation,ColorThemeKind:I.ColorThemeKind,CommentMode:I.CommentMode,CommentThreadCollapsibleState:I.CommentThreadCollapsibleState,CompletionItem:I.CompletionItem,CompletionItemKind:I.CompletionItemKind,CompletionItemTag:I.CompletionItemTag,CompletionList:I.CompletionList,CompletionTriggerKind:I.CompletionTriggerKind,ConfigurationTarget:I.ConfigurationTarget,CustomExecution:I.CustomExecution,DebugAdapterExecutable:I.DebugAdapterExecutable,DebugAdapterInlineImplementation:I.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:I.DebugAdapterNamedPipeServer,DebugAdapterServer:I.DebugAdapterServer,DebugConfigurationProviderTriggerKind:I.DebugConfigurationProviderTriggerKind,DebugConsoleMode:I.DebugConsoleMode,DecorationRangeBehavior:I.DecorationRangeBehavior,Diagnostic:I.Diagnostic,DiagnosticRelatedInformation:I.DiagnosticRelatedInformation,DiagnosticSeverity:I.DiagnosticSeverity,DiagnosticTag:I.DiagnosticTag,Disposable:I.Disposable,DocumentHighlight:I.DocumentHighlight,DocumentHighlightKind:I.DocumentHighlightKind,DocumentLink:I.DocumentLink,DocumentSymbol:I.DocumentSymbol,EndOfLine:I.EndOfLine,EnvironmentVariableMutatorType:I.EnvironmentVariableMutatorType,EvaluatableExpression:I.EvaluatableExpression,InlineValueText:I.InlineValueText,InlineValueVariableLookup:I.InlineValueVariableLookup,InlineValueEvaluatableExpression:I.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:I.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:I.ExtensionKind,ExtensionMode:I.ExtensionMode,ExternalUriOpenerPriority:I.ExternalUriOpenerPriority,FileChangeType:I.FileChangeType,FileDecoration:I.FileDecoration,FileSystemError:I.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:I.FoldingRange,FoldingRangeKind:I.FoldingRangeKind,FunctionBreakpoint:I.FunctionBreakpoint,InlineCompletionItem:I.InlineSuggestion,InlineCompletionList:I.InlineSuggestions,Hover:I.Hover,IndentAction:k.IndentAction,Location:I.Location,MarkdownString:I.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:I.ParameterInformation,PortAutoForwardAction:I.PortAutoForwardAction,Position:I.Position,ProcessExecution:I.ProcessExecution,ProgressLocation:I.ProgressLocation,QuickInputButtons:I.QuickInputButtons,Range:I.Range,RelativePattern:I.RelativePattern,Selection:I.Selection,SelectionRange:I.SelectionRange,SemanticTokens:I.SemanticTokens,SemanticTokensBuilder:I.SemanticTokensBuilder,SemanticTokensEdit:I.SemanticTokensEdit,SemanticTokensEdits:I.SemanticTokensEdits,SemanticTokensLegend:I.SemanticTokensLegend,ShellExecution:I.ShellExecution,ShellQuoting:I.ShellQuoting,SignatureHelp:I.SignatureHelp,SignatureHelpTriggerKind:I.SignatureHelpTriggerKind,SignatureInformation:I.SignatureInformation,SnippetString:I.SnippetString,SourceBreakpoint:I.SourceBreakpoint,StandardTokenType:I.StandardTokenType,StatusBarAlignment:I.StatusBarAlignment,SymbolInformation:I.SymbolInformation,SymbolKind:I.SymbolKind,SymbolTag:I.SymbolTag,Task:I.Task,TaskGroup:I.TaskGroup,TaskPanelKind:I.TaskPanelKind,TaskRevealKind:I.TaskRevealKind,TaskScope:I.TaskScope,TextDocumentSaveReason:I.TextDocumentSaveReason,TextEdit:I.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:I.TextEditorLineNumbersStyle,TextEditorRevealType:I.TextEditorRevealType,TextEditorSelectionChangeKind:I.TextEditorSelectionChangeKind,ThemeColor:I.ThemeColor,ThemeIcon:I.ThemeIcon,TreeItem:I.TreeItem,TreeItemCollapsibleState:I.TreeItemCollapsibleState,UIKind:d.UIKind,Uri:E.URI,ViewColumn:I.ViewColumn,WorkspaceEdit:I.WorkspaceEdit,InlayHint:I.InlayHint,InlayHintKind:I.InlayHintKind,RemoteAuthorityResolverError:I.RemoteAuthorityResolverError,ResolvedAuthority:I.ResolvedAuthority,SourceControlInputBoxValidationType:I.SourceControlInputBoxValidationType,ExtensionRuntime:I.ExtensionRuntime,TimelineItem:I.TimelineItem,NotebookRange:I.NotebookRange,NotebookCellKind:I.NotebookCellKind,NotebookCellExecutionState:I.NotebookCellExecutionState,NotebookDocumentMetadata:I.NotebookDocumentMetadata,NotebookCellMetadata:I.NotebookCellMetadata,NotebookCellData:I.NotebookCellData,NotebookData:I.NotebookData,NotebookKernelPreload:I.NotebookKernelPreload,NotebookCellStatusBarAlignment:I.NotebookCellStatusBarAlignment,NotebookEditorRevealType:I.NotebookEditorRevealType,NotebookCellOutput:I.NotebookCellOutput,NotebookCellOutputItem:I.NotebookCellOutputItem,NotebookCellStatusBarItem:I.NotebookCellStatusBarItem,NotebookControllerAffinity:I.NotebookControllerAffinity,PortAttributes:I.PortAttributes,LinkedEditingRanges:I.LinkedEditingRanges,TestItemStatus:I.TestItemStatus,TestResultState:I.TestResultState,TestMessage:I.TestMessage,TextSearchCompleteMessageType:Y.TextSearchCompleteMessageType,TestMessageSeverity:I.TestMessageSeverity,WorkspaceTrustState:I.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Le}),define(ve[227],be([0,1,62,102,30,101,33,76,39,40,105,106,107,79,78,71,75,103,77,49,74,95,69]),function(J,e,v,R,S,T,E,D,y,k,n,P,d,g,r,m,c,p,w,a,h,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths),(0,v.registerSingleton)(c.IExtHostApiDeprecationService,c.ExtHostApiDeprecationService),(0,v.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,v.registerSingleton)(E.IExtHostConfiguration,E.ExtHostConfiguration),(0,v.registerSingleton)(w.IExtHostConsumerFileSystem,w.ExtHostConsumerFileSystem),(0,v.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,v.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,v.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,v.registerSingleton)(a.IExtHostFileSystemInfo,a.ExtHostFileSystemInfo),(0,v.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,v.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch),(0,v.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,v.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,v.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,v.registerSingleton)(m.IExtHostTunnelService,m.ExtHostTunnelService),(0,v.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,v.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace),(0,v.registerSingleton)(h.IExtHostSecretState,h.ExtHostSecretState),(0,v.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry),(0,v.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(ve[228],be([0,1,226,34,222,7,11,5]),function(J,e,v,R,S,T,E,D){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(r){var m;const c=(m=self.trustedTypes)===null||m===void 0?void 0:m.createPolicy("TrustedFunctionWorkaround",{createScript:(w,...a)=>{a.forEach(i=>{var s;if(!((s=self.trustedTypes)===null||s===void 0?void 0:s.isScript(i)))throw new Error("TrustedScripts only, please")});const h=a.slice(0,-1).join(","),f=a.pop().toString();return`(function anonymous(${h}) {
${f}
})`}});function p(...w){return c?self.eval(c.createScript("",...w)):new Function(...w)}r.create=p})(k||(k={}));class n extends S.RequireInterceptor{_installInterceptor(){}getModule(m,c){for(let p of this._alternatives){let w=p(m);if(w){m=w;break}}if(this._factories.has(m))return this._factories.get(m).load(m,c,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends R.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const m=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);g(m,this._initData.environment.isExtensionDevelopmentDebug);const c=this._instaService.invokeFunction(v.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,c,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(m){return m.browser}async _loadCommonJSModule(m,c,p){var w,a,h,f,t,i,s,o;c=c.with({path:d(c.path,".js")}),m&&performance.mark(`code/extHost/willFetchExtensionCode/${m.value}`);const u=await fetch(c.toString(!0));if(m&&performance.mark(`code/extHost/didFetchExtensionCode/${m.value}`),u.status!==200)throw new Error(u.statusText);const _=await u.text(),b=`${c.toString(!0)}#vscode-extension`,A=`${_}
//# sourceURL=${b}`;let C;try{C=k.create((a=(w=P._ttpExtensionScripts)===null||w===void 0?void 0:w.createScript("module"))!==null&&a!==void 0?a:"module",(f=(h=P._ttpExtensionScripts)===null||h===void 0?void 0:h.createScript("exports"))!==null&&f!==void 0?f:"exports",(i=(t=P._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&i!==void 0?i:"require",(o=(s=P._ttpExtensionScripts)===null||s===void 0?void 0:s.createScript(A))!==null&&o!==void 0?o:A)}catch(z){throw console.error(m?`Loading code for extension ${m.value} failed: ${z.message}`:`Loading code failed: ${z.message}`),console.error(`${c.toString(!0)}${typeof z.line=="number"?` line ${z.line}`:""}${typeof z.column=="number"?` column ${z.column}`:""}`),console.error(z),z}const l={},F={exports:l},N=z=>{const de=this._fakeModules.getModule(z,c);if(de===void 0)throw new Error(`Cannot load module '${z}'`);return de};try{return p.codeLoadingStart(),m&&performance.mark(`code/extHost/willLoadExtensionCode/${m.value}`),C(F,l,N),F.exports!==l?F.exports:l}finally{m&&performance.mark(`code/extHost/didLoadExtensionCode/${m.value}`),p.codeLoadingStop()}}async $setRemoteEnvironment(m){throw new Error("Not supported")}async _waitForDebuggerAttachment(m=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const c=Date.now()+m;for(;Date.now()<c&&!("__jsDebugIsReady"in globalThis);)await(0,E.timeout)(10)}}e.ExtHostExtensionService=P,P._ttpExtensionScripts=(y=self.trustedTypes)===null||y===void 0?void 0:y.createPolicy("ExtensionScripts",{createScript:r=>r});function d(r,m){return r.endsWith(m)?r:r+m}function g(r,m){c("info","log"),c("log","log"),c("warn","warn"),c("error","error");function c(a,h){const f=console[a];console[a]=function(){r.$logExtensionHostMessage({type:"__$console",severity:h,arguments:w(arguments)}),m&&f.apply(console,arguments)}}const p=1e5;function w(a){const h=[],f=[];if(a.length)for(let t=0;t<a.length;t++){if(typeof a[t]=="undefined")a[t]="undefined";else if(a[t]instanceof Error){const i=a[t];i.stack?a[t]=i.stack:a[t]=i.toString()}f.push(a[t])}try{const t=JSON.stringify(f,function(i,s){if(s&&typeof s=="object"){if(h.indexOf(s)!==-1)return"[Circular]";h.push(s)}return s});return t.length>p?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(ve[229],be([0,1,62,17,34,228,214]),function(J,e,v,R,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.registerSingleton)(S.IExtHostExtensionService,T.ExtHostExtensionService),(0,v.registerSingleton)(R.ILogService,E.ExtHostLogService)}),define(ve[231],be([0,1,23,3,184,223,216,14,80,227,229]),function(J,e,v,R,S,T,E,D,y){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0});const n=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const P=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const c=(k=self.trustedTypes)===null||k===void 0?void 0:k.createPolicy("extensionHostWorker",{createScriptURL:w=>w}),p=self.Worker;Worker=function(w,a){const h=`importScripts('${w}');`;a=a||{},a.name=a.name||D.basename(w.toString());const f=new Blob([h],{type:"application/javascript"}),t=URL.createObjectURL(f);return new p(c?c.createScriptURL(t):t,a)}}else self.Worker=class extends E.NestedWorker{constructor(c,p){super(P,c,Object.assign({name:D.basename(c.toString())},p))}};const d=new class{exit(c){n()}async exists(c){return!0}async realpath(c){return c}};class g{constructor(){const p=new MessageChannel,w=new R.Emitter;let a=!1;P(p.port2,[p.port2]),p.port1.onmessage=h=>{const{data:f}=h;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const t=v.VSBuffer.wrap(new Uint8Array(f,0,f.byteLength));if((0,S.isMessageOfType)(t,2)){a=!0,m("received terminate message from renderer");return}w.fire(t)},this.protocol={onMessage:w.event,send:h=>{if(!a){const f=h.buffer.buffer.slice(h.buffer.byteOffset,h.buffer.byteOffset+h.buffer.byteLength);p.port1.postMessage(f,[f])}}}}}function r(c){return new Promise(p=>{const w=c.onMessage(a=>{w.dispose();const h=JSON.parse(a.toString());c.send((0,S.createMessageOfType)(0)),p({protocol:c,initData:h})});c.send((0,S.createMessageOfType)(1))})}let m=c=>n();(function(){const p=new g;y.mark("code/extHost/willConnectToRenderer"),r(p.protocol).then(w=>{y.mark("code/extHost/didWaitForInitData");const a=new T.ExtensionHostMain(w.protocol,w.initData,d,null);m=h=>a.terminate(h)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/286b643ecd231f66f3f2e67e1456f3c601838b46/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
